package net.eaglerforge.reflect;
import net.lax1dude.eaglercraft.v1_8.opengl.VertexFormat;
import net.lax1dude.eaglercraft.v1_8.vector.Vector4f;
import net.lax1dude.eaglercraft.v1_8.vector.Vector3f;
import net.lax1dude.eaglercraft.v1_8.vector.Matrix4f;
import net.lax1dude.eaglercraft.v1_8.opengl.HighPolyMesh;
import net.lax1dude.eaglercraft.v1_8.internal.ITextureGL;
import net.lax1dude.eaglercraft.v1_8.internal.buffer.ByteBuffer;
import net.lax1dude.eaglercraft.v1_8.internal.IProgramGL;
import net.lax1dude.eaglercraft.v1_8.internal.IBufferGL;
import net.lax1dude.eaglercraft.v1_8.internal.IBufferArrayGL;
import net.lax1dude.eaglercraft.v1_8.internal.buffer.FloatBuffer;
import net.minecraft.stats.StatFileWriter;
import net.lax1dude.eaglercraft.v1_8.profile.SkinModel;
import net.minecraft.util.ResourceLocation;
import net.minecraft.client.gui.FontRenderer;
import net.lax1dude.eaglercraft.v1_8.opengl.WorldRenderer;
import net.minecraft.client.renderer.Tessellator;
import net.minecraft.util.EnumWorldBlockLayer;
import net.minecraft.client.renderer.culling.ICamera;
import net.minecraft.client.gui.MapItemRenderer;
import net.minecraft.world.storage.ISaveFormat;
import net.minecraft.client.resources.model.ModelManager;
import net.minecraft.util.FrameTimer;
import net.minecraft.client.renderer.ItemRenderer;
import net.minecraft.client.renderer.entity.RenderItem;
import net.minecraft.client.renderer.entity.RenderManager;
import net.minecraft.client.renderer.BlockRendererDispatcher;
import net.minecraft.client.audio.SoundHandler;
import net.minecraft.client.renderer.texture.TextureMap;
import net.minecraft.client.resources.LanguageManager;
import net.minecraft.client.resources.ResourcePackRepository;
import net.minecraft.client.resources.IResourceManager;
import net.minecraft.client.renderer.texture.TextureManager;
import net.minecraft.util.Session;
import net.minecraft.client.multiplayer.ServerData;
import net.minecraft.client.Minecraft;
import net.minecraft.client.network.NetHandlerPlayClient;
import net.minecraft.client.multiplayer.WorldClient;
import net.minecraft.client.audio.MusicTicker;
import net.minecraft.client.gui.GuiScreen;
import net.minecraft.client.main.GameConfiguration;
import net.minecraft.entity.boss.EntityDragonPart;
import net.minecraft.entity.player.InventoryPlayer;
import net.minecraft.util.Rotations;
import net.minecraft.village.Village;
import net.minecraft.entity.passive.EntityWolf;
import net.minecraft.entity.passive.EntityVillager;
import net.minecraft.village.MerchantRecipeList;
import net.minecraft.village.MerchantRecipe;
import net.minecraft.entity.ai.EntityAISit;
import net.minecraft.entity.passive.EntitySheep;
import net.minecraft.item.EnumDyeColor;
import net.minecraft.entity.passive.EntityRabbit;
import net.minecraft.entity.ai.EntityAIControlledByPlayer;
import net.minecraft.entity.passive.EntityPig;
import net.minecraft.entity.passive.EntityOcelot;
import net.minecraft.entity.passive.EntityMooshroom;
import net.minecraft.inventory.InventoryBasic;
import net.minecraft.entity.passive.EntityCow;
import net.minecraft.entity.passive.EntityChicken;
import net.minecraft.entity.EntityAgeable;
import net.minecraft.entity.passive.EntityAnimal;
import net.minecraft.stats.StatisticsFile;
import net.minecraft.network.play.client.C15PacketClientSettings;
import net.minecraft.inventory.Container;
import net.minecraft.entity.player.EnumPlayerModelParts;
import net.minecraft.world.LockCode;
import net.minecraft.inventory.InventoryEnderChest;
import net.minecraft.util.FoodStats;
import net.minecraft.stats.StatBase;
import net.lax1dude.eaglercraft.v1_8.mojang.authlib.GameProfile;
import net.minecraft.world.IInteractionObject;
import net.minecraft.entity.passive.EntityHorse;
import net.minecraft.inventory.IInventory;
import net.minecraft.entity.IMerchant;
import net.minecraft.tileentity.TileEntitySign;
import net.minecraft.command.server.CommandBlockLogic;
import net.minecraft.scoreboard.Team;
import net.minecraft.entity.EnumCreatureAttribute;
import net.minecraft.entity.ai.attributes.BaseAttributeMap;
import net.minecraft.entity.ai.attributes.IAttributeInstance;
import net.minecraft.entity.ai.attributes.IAttribute;
import net.minecraft.util.CombatTracker;
import net.minecraft.potion.PotionEffect;
import net.minecraft.potion.Potion;
import net.minecraft.entity.IEntityLivingData;
import net.minecraft.entity.ai.EntitySenses;
import net.minecraft.pathfinding.PathNavigate;
import net.minecraft.entity.ai.EntityJumpHelper;
import net.minecraft.entity.ai.EntityMoveHelper;
import net.minecraft.entity.ai.EntityLookHelper;
import net.minecraft.command.CommandResultStats;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.entity.effect.EntityLightningBolt;
import net.minecraft.entity.item.EntityItem;
import net.minecraft.util.DamageSource;
import net.minecraft.entity.DataWatcher;
import net.minecraft.entity.item.EntityItemFrame;
import net.minecraft.nbt.NBTBase;
import net.minecraft.enchantment.Enchantment;
import net.minecraft.item.EnumRarity;
import net.minecraft.nbt.NBTTagList;
import net.minecraft.item.EnumAction;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.item.ItemStack;
import net.minecraft.item.Item;
import net.minecraft.server.management.ServerConfigurationManager;
import net.minecraft.command.ICommandManager;
import net.minecraft.util.IChatComponent;
import net.minecraft.world.WorldServer;
import net.minecraft.util.Vec3i;
import net.eaglerforge.api.ModData;
import net.eaglerforge.api.BaseData;
import net.minecraft.world.Teleporter;
import net.minecraft.server.management.PlayerManager;
import net.minecraft.entity.EntityTracker;
import net.minecraft.server.MinecraftServer;
import net.minecraft.util.IProgressUpdate;
import net.minecraft.village.VillageCollection;
import net.minecraft.world.EnumDifficulty;
import net.minecraft.world.DifficultyInstance;
import net.minecraft.scoreboard.Scoreboard;
import net.minecraft.crash.CrashReportCategory;
import net.minecraft.crash.CrashReport;
import net.minecraft.world.WorldSavedData;
import net.minecraft.world.storage.MapStorage;
import net.minecraft.world.GameRules;
import net.minecraft.world.storage.WorldInfo;
import net.minecraft.world.storage.ISaveHandler;
import net.minecraft.world.chunk.IChunkProvider;
import net.lax1dude.eaglercraft.v1_8.EaglercraftUUID;
import net.minecraft.world.WorldType;
import net.lax1dude.eaglercraft.v1_8.EaglercraftRandom;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.Explosion;
import net.minecraft.block.material.Material;
import net.minecraft.util.AxisAlignedBB;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.world.border.WorldBorder;
import net.minecraft.world.IWorldAccess;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.Entity;
import net.minecraft.util.MovingObjectPosition;
import net.minecraft.util.Vec3;
import net.minecraft.world.EnumSkyBlock;
import net.minecraft.util.EnumFacing;
import net.minecraft.block.state.IBlockState;
import net.minecraft.world.chunk.Chunk;
import net.minecraft.world.gen.structure.StructureBoundingBox;
import net.minecraft.block.Block;
import net.minecraft.world.WorldSettings;
import net.minecraft.world.biome.WorldChunkManager;
import net.minecraft.world.biome.BiomeGenBase;
import net.minecraft.util.BlockPos;
import net.minecraft.world.World;
import net.minecraft.world.WorldSettings.GameType;
import java.util.Calendar;
import java.lang.String;
import me.otterdev.UwUAPI;
import net.minecraft.init.Items;
import net.minecraft.init.Blocks;
import net.minecraft.client.entity.AbstractClientPlayer;
import net.minecraft.client.entity.EntityOtherPlayerMP;
import net.minecraft.client.entity.EntityPlayerSP;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.passive.EntityWolf;
import net.minecraft.entity.passive.EntityWaterMob;
import net.minecraft.entity.passive.EntityVillager;
import net.minecraft.entity.passive.EntityTameable;
import net.minecraft.entity.passive.EntitySquid;
import net.minecraft.entity.passive.EntitySheep;
import net.minecraft.entity.passive.EntityRabbit;
import net.minecraft.entity.passive.EntityPig;
import net.minecraft.entity.passive.EntityOcelot;
import net.minecraft.entity.passive.EntityMooshroom;
import net.minecraft.entity.passive.EntityHorse;
import net.minecraft.entity.passive.EntityCow;
import net.minecraft.entity.passive.EntityChicken;
import net.minecraft.entity.passive.EntityBat;
import net.minecraft.entity.passive.EntityAnimal;
import net.minecraft.entity.passive.EntityAmbientCreature;
import net.minecraft.entity.monster.EntityZombie;
import net.minecraft.entity.monster.EntityWitch;
import net.minecraft.entity.monster.EntitySpider;
import net.minecraft.entity.monster.EntitySnowman;
import net.minecraft.entity.monster.EntitySlime;
import net.minecraft.entity.monster.EntitySkeleton;
import net.minecraft.entity.monster.EntitySilverfish;
import net.minecraft.entity.monster.EntityPigZombie;
import net.minecraft.entity.monster.EntityMob;
import net.minecraft.entity.monster.EntityMagmaCube;
import net.minecraft.entity.monster.EntityIronGolem;
import net.minecraft.entity.monster.EntityGuardian;
import net.minecraft.entity.monster.EntityGolem;
import net.minecraft.entity.monster.EntityGiantZombie;
import net.minecraft.entity.monster.EntityGhast;
import net.minecraft.entity.monster.EntityEndermite;
import net.minecraft.entity.monster.EntityEnderman;
import net.minecraft.entity.monster.EntityCreeper;
import net.minecraft.entity.monster.EntityCaveSpider;
import net.minecraft.entity.monster.EntityBlaze;
import net.minecraft.entity.item.EntityXPOrb;
import net.minecraft.entity.item.EntityTNTPrimed;
import net.minecraft.entity.item.EntityPainting;
import net.minecraft.entity.item.EntityMinecartTNT;
import net.minecraft.entity.item.EntityMinecartHopper;
import net.minecraft.entity.item.EntityMinecartFurnace;
import net.minecraft.entity.item.EntityMinecartEmpty;
import net.minecraft.entity.item.EntityMinecartContainer;
import net.minecraft.entity.item.EntityMinecartChest;
import net.minecraft.entity.item.EntityMinecart;
import net.minecraft.entity.item.EntityItemFrame;
import net.minecraft.entity.item.EntityItem;
import net.minecraft.entity.item.EntityFireworkRocket;
import net.minecraft.entity.item.EntityFallingBlock;
import net.minecraft.entity.item.EntityExpBottle;
import net.minecraft.entity.item.EntityEnderPearl;
import net.minecraft.entity.item.EntityEnderEye;
import net.minecraft.entity.item.EntityEnderCrystal;
import net.minecraft.entity.item.EntityBoat;
import net.minecraft.entity.item.EntityArmorStand;
import net.minecraft.entity.effect.EntityLightningBolt;
import net.minecraft.entity.boss.EntityWither;
import net.minecraft.entity.boss.EntityDragon;
import net.minecraft.entity.EntityMinecartCommandBlock;
import net.minecraft.entity.EntityCreature;
import net.minecraft.entity.EntityLiving;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.Entity;
import net.minecraft.server.MinecraftServer;
import net.minecraft.world.WorldServer;
import net.minecraft.world.World;
import net.minecraft.client.multiplayer.WorldClient;
import net.minecraft.util.MathHelper;
import net.minecraft.util.Vec3;
import net.minecraft.util.AxisAlignedBB;
import net.lax1dude.eaglercraft.v1_8.opengl.WorldRenderer;
import net.lax1dude.eaglercraft.v1_8.opengl.VertexFormat;
import net.minecraft.client.renderer.EntityRenderer;
import net.minecraft.client.renderer.RenderGlobal;
import net.minecraft.client.renderer.Tessellator;
import net.minecraft.client.renderer.entity.RenderManager;
import net.lax1dude.eaglercraft.v1_8.opengl.GlStateManager;
import net.lax1dude.eaglercraft.v1_8.opengl.EaglercraftGPU;
import net.minecraft.client.Minecraft;
import net.minecraft.item.ItemStack;

import net.eaglerforge.api.*;
import java.util.ArrayList;
import java.lang.Exception;
import org.teavm.jso.JSBody;
import org.teavm.jso.JSObject;
import org.teavm.jso.JSFunctor;

//  _  _     ___      __ _        _   
//  | \| |___| _ \___ / _| |___ __| |_ 
//  | .` / _ \   / -_)  _| / -_) _|  _|
//  |_|\_\___/_|_\___|_| |_\___\__|\__|
//   _________________________________


//AutoGenerated by NoReflect
//Made by ZXMushroom63

public class PLReflect extends ModData {
    @JSBody(params = { "reflectInst" }, script = "reflectInst.getMethodMapFromClass = function(classObj) {var outMethodMap = {}; classObj.methods.forEach(method=>{outMethodMap[method.methodName]=method;}); return outMethodMap;}")
    public static native BaseData setMethodMapFn(BaseData reflectInst);

    
    //classdef for World
    public static void reflect_World_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_World = new ModData();

        ArrayList<BaseData> reflect_World_constructors = new ArrayList<BaseData>();
        
        BaseData[] reflect_World_constructors_arr = new BaseData[reflect_World_constructors.size()];
        for (int i = 0; i < reflect_World_constructors_arr.length; i++) {
            reflect_World_constructors_arr[i] = reflect_World_constructors.get(i);
        }

        ArrayList<BaseData> reflect_World_methods = new ArrayList<BaseData>();
        
        BaseData reflect_World_method_init_0 = new ModData();
        reflect_World_method_init_0.set("methodName", "init");
        reflect_World_method_init_0.set("returnType", "World");
        reflect_World_method_init_0.set("static", false);
        reflect_World_method_init_0.set("argnames", new String[]{});
        reflect_World_method_init_0.set("argtypes", new String[]{});
        reflect_World_method_init_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (World) ((World) params.getReflective("_self")).init();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_init_0);


        BaseData reflect_World_method_getBiomeGenForCoords_1 = new ModData();
        reflect_World_method_getBiomeGenForCoords_1.set("methodName", "getBiomeGenForCoords");
        reflect_World_method_getBiomeGenForCoords_1.set("returnType", "BiomeGenBase");
        reflect_World_method_getBiomeGenForCoords_1.set("static", false);
        reflect_World_method_getBiomeGenForCoords_1.set("argnames", new String[]{"pos"});
        reflect_World_method_getBiomeGenForCoords_1.set("argtypes", new String[]{"BlockPos"});
        reflect_World_method_getBiomeGenForCoords_1.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (BiomeGenBase) ((World) params.getReflective("_self")).getBiomeGenForCoords((BlockPos) params.getReflective("pos"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getBiomeGenForCoords_1);


        BaseData reflect_World_method_getWorldChunkManager_2 = new ModData();
        reflect_World_method_getWorldChunkManager_2.set("methodName", "getWorldChunkManager");
        reflect_World_method_getWorldChunkManager_2.set("returnType", "WorldChunkManager");
        reflect_World_method_getWorldChunkManager_2.set("static", false);
        reflect_World_method_getWorldChunkManager_2.set("argnames", new String[]{});
        reflect_World_method_getWorldChunkManager_2.set("argtypes", new String[]{});
        reflect_World_method_getWorldChunkManager_2.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (WorldChunkManager) ((World) params.getReflective("_self")).getWorldChunkManager();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getWorldChunkManager_2);


        BaseData reflect_World_method_initialize_3 = new ModData();
        reflect_World_method_initialize_3.set("methodName", "initialize");
        reflect_World_method_initialize_3.set("returnType", "void");
        reflect_World_method_initialize_3.set("static", false);
        reflect_World_method_initialize_3.set("argnames", new String[]{"settings"});
        reflect_World_method_initialize_3.set("argtypes", new String[]{"WorldSettings"});
        reflect_World_method_initialize_3.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((World) params.getReflective("_self")).initialize((WorldSettings) params.getReflective("settings"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_initialize_3);


        BaseData reflect_World_method_setInitialSpawnLocation_4 = new ModData();
        reflect_World_method_setInitialSpawnLocation_4.set("methodName", "setInitialSpawnLocation");
        reflect_World_method_setInitialSpawnLocation_4.set("returnType", "void");
        reflect_World_method_setInitialSpawnLocation_4.set("static", false);
        reflect_World_method_setInitialSpawnLocation_4.set("argnames", new String[]{});
        reflect_World_method_setInitialSpawnLocation_4.set("argtypes", new String[]{});
        reflect_World_method_setInitialSpawnLocation_4.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((World) params.getReflective("_self")).setInitialSpawnLocation();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_setInitialSpawnLocation_4);


        BaseData reflect_World_method_getGroundAboveSeaLevel_5 = new ModData();
        reflect_World_method_getGroundAboveSeaLevel_5.set("methodName", "getGroundAboveSeaLevel");
        reflect_World_method_getGroundAboveSeaLevel_5.set("returnType", "Block");
        reflect_World_method_getGroundAboveSeaLevel_5.set("static", false);
        reflect_World_method_getGroundAboveSeaLevel_5.set("argnames", new String[]{"pos"});
        reflect_World_method_getGroundAboveSeaLevel_5.set("argtypes", new String[]{"BlockPos"});
        reflect_World_method_getGroundAboveSeaLevel_5.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Block) ((World) params.getReflective("_self")).getGroundAboveSeaLevel((BlockPos) params.getReflective("pos"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getGroundAboveSeaLevel_5);


        BaseData reflect_World_method_isAirBlock_6 = new ModData();
        reflect_World_method_isAirBlock_6.set("methodName", "isAirBlock");
        reflect_World_method_isAirBlock_6.set("returnType", "boolean");
        reflect_World_method_isAirBlock_6.set("static", false);
        reflect_World_method_isAirBlock_6.set("argnames", new String[]{"pos"});
        reflect_World_method_isAirBlock_6.set("argtypes", new String[]{"BlockPos"});
        reflect_World_method_isAirBlock_6.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((World) params.getReflective("_self")).isAirBlock((BlockPos) params.getReflective("pos"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_isAirBlock_6);


        BaseData reflect_World_method_isBlockLoaded_7 = new ModData();
        reflect_World_method_isBlockLoaded_7.set("methodName", "isBlockLoaded");
        reflect_World_method_isBlockLoaded_7.set("returnType", "boolean");
        reflect_World_method_isBlockLoaded_7.set("static", false);
        reflect_World_method_isBlockLoaded_7.set("argnames", new String[]{"pos"});
        reflect_World_method_isBlockLoaded_7.set("argtypes", new String[]{"BlockPos"});
        reflect_World_method_isBlockLoaded_7.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((World) params.getReflective("_self")).isBlockLoaded((BlockPos) params.getReflective("pos"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_isBlockLoaded_7);


        BaseData reflect_World_method_isBlockLoaded_8 = new ModData();
        reflect_World_method_isBlockLoaded_8.set("methodName", "isBlockLoaded");
        reflect_World_method_isBlockLoaded_8.set("returnType", "boolean");
        reflect_World_method_isBlockLoaded_8.set("static", false);
        reflect_World_method_isBlockLoaded_8.set("argnames", new String[]{"pos", "allowEmpty"});
        reflect_World_method_isBlockLoaded_8.set("argtypes", new String[]{"BlockPos", "boolean"});
        reflect_World_method_isBlockLoaded_8.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((World) params.getReflective("_self")).isBlockLoaded((BlockPos) params.getReflective("pos"), (boolean) params.getBoolean("allowEmpty"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_isBlockLoaded_8);


        BaseData reflect_World_method_isAreaLoaded_9 = new ModData();
        reflect_World_method_isAreaLoaded_9.set("methodName", "isAreaLoaded");
        reflect_World_method_isAreaLoaded_9.set("returnType", "boolean");
        reflect_World_method_isAreaLoaded_9.set("static", false);
        reflect_World_method_isAreaLoaded_9.set("argnames", new String[]{"center", "radius"});
        reflect_World_method_isAreaLoaded_9.set("argtypes", new String[]{"BlockPos", "int"});
        reflect_World_method_isAreaLoaded_9.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((World) params.getReflective("_self")).isAreaLoaded((BlockPos) params.getReflective("center"), (int) params.getInt("radius"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_isAreaLoaded_9);


        BaseData reflect_World_method_isAreaLoaded_10 = new ModData();
        reflect_World_method_isAreaLoaded_10.set("methodName", "isAreaLoaded");
        reflect_World_method_isAreaLoaded_10.set("returnType", "boolean");
        reflect_World_method_isAreaLoaded_10.set("static", false);
        reflect_World_method_isAreaLoaded_10.set("argnames", new String[]{"center", "radius", "allowEmpty"});
        reflect_World_method_isAreaLoaded_10.set("argtypes", new String[]{"BlockPos", "int", "boolean"});
        reflect_World_method_isAreaLoaded_10.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((World) params.getReflective("_self")).isAreaLoaded((BlockPos) params.getReflective("center"), (int) params.getInt("radius"), (boolean) params.getBoolean("allowEmpty"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_isAreaLoaded_10);


        BaseData reflect_World_method_isAreaLoaded_11 = new ModData();
        reflect_World_method_isAreaLoaded_11.set("methodName", "isAreaLoaded");
        reflect_World_method_isAreaLoaded_11.set("returnType", "boolean");
        reflect_World_method_isAreaLoaded_11.set("static", false);
        reflect_World_method_isAreaLoaded_11.set("argnames", new String[]{"from", "to"});
        reflect_World_method_isAreaLoaded_11.set("argtypes", new String[]{"BlockPos", "BlockPos"});
        reflect_World_method_isAreaLoaded_11.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((World) params.getReflective("_self")).isAreaLoaded((BlockPos) params.getReflective("from"), (BlockPos) params.getReflective("to"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_isAreaLoaded_11);


        BaseData reflect_World_method_isAreaLoaded_12 = new ModData();
        reflect_World_method_isAreaLoaded_12.set("methodName", "isAreaLoaded");
        reflect_World_method_isAreaLoaded_12.set("returnType", "boolean");
        reflect_World_method_isAreaLoaded_12.set("static", false);
        reflect_World_method_isAreaLoaded_12.set("argnames", new String[]{"from", "to", "allowEmpty"});
        reflect_World_method_isAreaLoaded_12.set("argtypes", new String[]{"BlockPos", "BlockPos", "boolean"});
        reflect_World_method_isAreaLoaded_12.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((World) params.getReflective("_self")).isAreaLoaded((BlockPos) params.getReflective("from"), (BlockPos) params.getReflective("to"), (boolean) params.getBoolean("allowEmpty"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_isAreaLoaded_12);


        BaseData reflect_World_method_isAreaLoaded_13 = new ModData();
        reflect_World_method_isAreaLoaded_13.set("methodName", "isAreaLoaded");
        reflect_World_method_isAreaLoaded_13.set("returnType", "boolean");
        reflect_World_method_isAreaLoaded_13.set("static", false);
        reflect_World_method_isAreaLoaded_13.set("argnames", new String[]{"box"});
        reflect_World_method_isAreaLoaded_13.set("argtypes", new String[]{"StructureBoundingBox"});
        reflect_World_method_isAreaLoaded_13.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((World) params.getReflective("_self")).isAreaLoaded((StructureBoundingBox) params.getReflective("box"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_isAreaLoaded_13);


        BaseData reflect_World_method_isAreaLoaded_14 = new ModData();
        reflect_World_method_isAreaLoaded_14.set("methodName", "isAreaLoaded");
        reflect_World_method_isAreaLoaded_14.set("returnType", "boolean");
        reflect_World_method_isAreaLoaded_14.set("static", false);
        reflect_World_method_isAreaLoaded_14.set("argnames", new String[]{"box", "allowEmpty"});
        reflect_World_method_isAreaLoaded_14.set("argtypes", new String[]{"StructureBoundingBox", "boolean"});
        reflect_World_method_isAreaLoaded_14.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((World) params.getReflective("_self")).isAreaLoaded((StructureBoundingBox) params.getReflective("box"), (boolean) params.getBoolean("allowEmpty"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_isAreaLoaded_14);


        BaseData reflect_World_method_getChunkFromBlockCoords_15 = new ModData();
        reflect_World_method_getChunkFromBlockCoords_15.set("methodName", "getChunkFromBlockCoords");
        reflect_World_method_getChunkFromBlockCoords_15.set("returnType", "Chunk");
        reflect_World_method_getChunkFromBlockCoords_15.set("static", false);
        reflect_World_method_getChunkFromBlockCoords_15.set("argnames", new String[]{"pos"});
        reflect_World_method_getChunkFromBlockCoords_15.set("argtypes", new String[]{"BlockPos"});
        reflect_World_method_getChunkFromBlockCoords_15.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Chunk) ((World) params.getReflective("_self")).getChunkFromBlockCoords((BlockPos) params.getReflective("pos"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getChunkFromBlockCoords_15);


        BaseData reflect_World_method_getChunkFromChunkCoords_16 = new ModData();
        reflect_World_method_getChunkFromChunkCoords_16.set("methodName", "getChunkFromChunkCoords");
        reflect_World_method_getChunkFromChunkCoords_16.set("returnType", "Chunk");
        reflect_World_method_getChunkFromChunkCoords_16.set("static", false);
        reflect_World_method_getChunkFromChunkCoords_16.set("argnames", new String[]{"chunkX", "chunkZ"});
        reflect_World_method_getChunkFromChunkCoords_16.set("argtypes", new String[]{"int", "int"});
        reflect_World_method_getChunkFromChunkCoords_16.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Chunk) ((World) params.getReflective("_self")).getChunkFromChunkCoords((int) params.getInt("chunkX"), (int) params.getInt("chunkZ"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getChunkFromChunkCoords_16);


        BaseData reflect_World_method_setBlockState_17 = new ModData();
        reflect_World_method_setBlockState_17.set("methodName", "setBlockState");
        reflect_World_method_setBlockState_17.set("returnType", "boolean");
        reflect_World_method_setBlockState_17.set("static", false);
        reflect_World_method_setBlockState_17.set("argnames", new String[]{"pos", "newState", "flags"});
        reflect_World_method_setBlockState_17.set("argtypes", new String[]{"BlockPos", "IBlockState", "int"});
        reflect_World_method_setBlockState_17.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((World) params.getReflective("_self")).setBlockState((BlockPos) params.getReflective("pos"), (IBlockState) params.getReflective("newState"), (int) params.getInt("flags"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_setBlockState_17);


        BaseData reflect_World_method_setBlockToAir_18 = new ModData();
        reflect_World_method_setBlockToAir_18.set("methodName", "setBlockToAir");
        reflect_World_method_setBlockToAir_18.set("returnType", "boolean");
        reflect_World_method_setBlockToAir_18.set("static", false);
        reflect_World_method_setBlockToAir_18.set("argnames", new String[]{"pos"});
        reflect_World_method_setBlockToAir_18.set("argtypes", new String[]{"BlockPos"});
        reflect_World_method_setBlockToAir_18.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((World) params.getReflective("_self")).setBlockToAir((BlockPos) params.getReflective("pos"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_setBlockToAir_18);


        BaseData reflect_World_method_destroyBlock_19 = new ModData();
        reflect_World_method_destroyBlock_19.set("methodName", "destroyBlock");
        reflect_World_method_destroyBlock_19.set("returnType", "boolean");
        reflect_World_method_destroyBlock_19.set("static", false);
        reflect_World_method_destroyBlock_19.set("argnames", new String[]{"pos", "dropBlock"});
        reflect_World_method_destroyBlock_19.set("argtypes", new String[]{"BlockPos", "boolean"});
        reflect_World_method_destroyBlock_19.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((World) params.getReflective("_self")).destroyBlock((BlockPos) params.getReflective("pos"), (boolean) params.getBoolean("dropBlock"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_destroyBlock_19);


        BaseData reflect_World_method_setBlockState_20 = new ModData();
        reflect_World_method_setBlockState_20.set("methodName", "setBlockState");
        reflect_World_method_setBlockState_20.set("returnType", "boolean");
        reflect_World_method_setBlockState_20.set("static", false);
        reflect_World_method_setBlockState_20.set("argnames", new String[]{"pos", "state"});
        reflect_World_method_setBlockState_20.set("argtypes", new String[]{"BlockPos", "IBlockState"});
        reflect_World_method_setBlockState_20.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((World) params.getReflective("_self")).setBlockState((BlockPos) params.getReflective("pos"), (IBlockState) params.getReflective("state"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_setBlockState_20);


        BaseData reflect_World_method_markBlockForUpdate_21 = new ModData();
        reflect_World_method_markBlockForUpdate_21.set("methodName", "markBlockForUpdate");
        reflect_World_method_markBlockForUpdate_21.set("returnType", "void");
        reflect_World_method_markBlockForUpdate_21.set("static", false);
        reflect_World_method_markBlockForUpdate_21.set("argnames", new String[]{"pos"});
        reflect_World_method_markBlockForUpdate_21.set("argtypes", new String[]{"BlockPos"});
        reflect_World_method_markBlockForUpdate_21.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((World) params.getReflective("_self")).markBlockForUpdate((BlockPos) params.getReflective("pos"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_markBlockForUpdate_21);


        BaseData reflect_World_method_notifyNeighborsRespectDebug_22 = new ModData();
        reflect_World_method_notifyNeighborsRespectDebug_22.set("methodName", "notifyNeighborsRespectDebug");
        reflect_World_method_notifyNeighborsRespectDebug_22.set("returnType", "void");
        reflect_World_method_notifyNeighborsRespectDebug_22.set("static", false);
        reflect_World_method_notifyNeighborsRespectDebug_22.set("argnames", new String[]{"pos", "blockType"});
        reflect_World_method_notifyNeighborsRespectDebug_22.set("argtypes", new String[]{"BlockPos", "Block"});
        reflect_World_method_notifyNeighborsRespectDebug_22.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((World) params.getReflective("_self")).notifyNeighborsRespectDebug((BlockPos) params.getReflective("pos"), (Block) params.getReflective("blockType"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_notifyNeighborsRespectDebug_22);


        BaseData reflect_World_method_markBlocksDirtyVertical_23 = new ModData();
        reflect_World_method_markBlocksDirtyVertical_23.set("methodName", "markBlocksDirtyVertical");
        reflect_World_method_markBlocksDirtyVertical_23.set("returnType", "void");
        reflect_World_method_markBlocksDirtyVertical_23.set("static", false);
        reflect_World_method_markBlocksDirtyVertical_23.set("argnames", new String[]{"x1", "z1", "x2", "z2"});
        reflect_World_method_markBlocksDirtyVertical_23.set("argtypes", new String[]{"int", "int", "int", "int"});
        reflect_World_method_markBlocksDirtyVertical_23.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((World) params.getReflective("_self")).markBlocksDirtyVertical((int) params.getInt("x1"), (int) params.getInt("z1"), (int) params.getInt("x2"), (int) params.getInt("z2"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_markBlocksDirtyVertical_23);


        BaseData reflect_World_method_markBlockRangeForRenderUpdate_24 = new ModData();
        reflect_World_method_markBlockRangeForRenderUpdate_24.set("methodName", "markBlockRangeForRenderUpdate");
        reflect_World_method_markBlockRangeForRenderUpdate_24.set("returnType", "void");
        reflect_World_method_markBlockRangeForRenderUpdate_24.set("static", false);
        reflect_World_method_markBlockRangeForRenderUpdate_24.set("argnames", new String[]{"rangeMin", "rangeMax"});
        reflect_World_method_markBlockRangeForRenderUpdate_24.set("argtypes", new String[]{"BlockPos", "BlockPos"});
        reflect_World_method_markBlockRangeForRenderUpdate_24.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((World) params.getReflective("_self")).markBlockRangeForRenderUpdate((BlockPos) params.getReflective("rangeMin"), (BlockPos) params.getReflective("rangeMax"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_markBlockRangeForRenderUpdate_24);


        BaseData reflect_World_method_markBlockRangeForRenderUpdate_25 = new ModData();
        reflect_World_method_markBlockRangeForRenderUpdate_25.set("methodName", "markBlockRangeForRenderUpdate");
        reflect_World_method_markBlockRangeForRenderUpdate_25.set("returnType", "void");
        reflect_World_method_markBlockRangeForRenderUpdate_25.set("static", false);
        reflect_World_method_markBlockRangeForRenderUpdate_25.set("argnames", new String[]{"x1", "y1", "z1", "x2", "y2", "z2"});
        reflect_World_method_markBlockRangeForRenderUpdate_25.set("argtypes", new String[]{"int", "int", "int", "int", "int", "int"});
        reflect_World_method_markBlockRangeForRenderUpdate_25.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((World) params.getReflective("_self")).markBlockRangeForRenderUpdate((int) params.getInt("x1"), (int) params.getInt("y1"), (int) params.getInt("z1"), (int) params.getInt("x2"), (int) params.getInt("y2"), (int) params.getInt("z2"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_markBlockRangeForRenderUpdate_25);


        BaseData reflect_World_method_notifyNeighborsOfStateChange_26 = new ModData();
        reflect_World_method_notifyNeighborsOfStateChange_26.set("methodName", "notifyNeighborsOfStateChange");
        reflect_World_method_notifyNeighborsOfStateChange_26.set("returnType", "void");
        reflect_World_method_notifyNeighborsOfStateChange_26.set("static", false);
        reflect_World_method_notifyNeighborsOfStateChange_26.set("argnames", new String[]{"pos", "blockType"});
        reflect_World_method_notifyNeighborsOfStateChange_26.set("argtypes", new String[]{"BlockPos", "Block"});
        reflect_World_method_notifyNeighborsOfStateChange_26.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((World) params.getReflective("_self")).notifyNeighborsOfStateChange((BlockPos) params.getReflective("pos"), (Block) params.getReflective("blockType"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_notifyNeighborsOfStateChange_26);


        BaseData reflect_World_method_notifyNeighborsOfStateExcept_27 = new ModData();
        reflect_World_method_notifyNeighborsOfStateExcept_27.set("methodName", "notifyNeighborsOfStateExcept");
        reflect_World_method_notifyNeighborsOfStateExcept_27.set("returnType", "void");
        reflect_World_method_notifyNeighborsOfStateExcept_27.set("static", false);
        reflect_World_method_notifyNeighborsOfStateExcept_27.set("argnames", new String[]{"pos", "blockType", "skipSide"});
        reflect_World_method_notifyNeighborsOfStateExcept_27.set("argtypes", new String[]{"BlockPos", "Block", "EnumFacing"});
        reflect_World_method_notifyNeighborsOfStateExcept_27.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((World) params.getReflective("_self")).notifyNeighborsOfStateExcept((BlockPos) params.getReflective("pos"), (Block) params.getReflective("blockType"), (EnumFacing) params.getReflective("skipSide"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_notifyNeighborsOfStateExcept_27);


        BaseData reflect_World_method_notifyBlockOfStateChange_28 = new ModData();
        reflect_World_method_notifyBlockOfStateChange_28.set("methodName", "notifyBlockOfStateChange");
        reflect_World_method_notifyBlockOfStateChange_28.set("returnType", "void");
        reflect_World_method_notifyBlockOfStateChange_28.set("static", false);
        reflect_World_method_notifyBlockOfStateChange_28.set("argnames", new String[]{"pos", "blockIn"});
        reflect_World_method_notifyBlockOfStateChange_28.set("argtypes", new String[]{"BlockPos", "Block"});
        reflect_World_method_notifyBlockOfStateChange_28.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((World) params.getReflective("_self")).notifyBlockOfStateChange((BlockPos) params.getReflective("pos"), (Block) params.getReflective("blockIn"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_notifyBlockOfStateChange_28);


        BaseData reflect_World_method_isBlockTickPending_29 = new ModData();
        reflect_World_method_isBlockTickPending_29.set("methodName", "isBlockTickPending");
        reflect_World_method_isBlockTickPending_29.set("returnType", "boolean");
        reflect_World_method_isBlockTickPending_29.set("static", false);
        reflect_World_method_isBlockTickPending_29.set("argnames", new String[]{"pos", "blockType"});
        reflect_World_method_isBlockTickPending_29.set("argtypes", new String[]{"BlockPos", "Block"});
        reflect_World_method_isBlockTickPending_29.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((World) params.getReflective("_self")).isBlockTickPending((BlockPos) params.getReflective("pos"), (Block) params.getReflective("blockType"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_isBlockTickPending_29);


        BaseData reflect_World_method_canSeeSky_30 = new ModData();
        reflect_World_method_canSeeSky_30.set("methodName", "canSeeSky");
        reflect_World_method_canSeeSky_30.set("returnType", "boolean");
        reflect_World_method_canSeeSky_30.set("static", false);
        reflect_World_method_canSeeSky_30.set("argnames", new String[]{"pos"});
        reflect_World_method_canSeeSky_30.set("argtypes", new String[]{"BlockPos"});
        reflect_World_method_canSeeSky_30.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((World) params.getReflective("_self")).canSeeSky((BlockPos) params.getReflective("pos"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_canSeeSky_30);


        BaseData reflect_World_method_canBlockSeeSky_31 = new ModData();
        reflect_World_method_canBlockSeeSky_31.set("methodName", "canBlockSeeSky");
        reflect_World_method_canBlockSeeSky_31.set("returnType", "boolean");
        reflect_World_method_canBlockSeeSky_31.set("static", false);
        reflect_World_method_canBlockSeeSky_31.set("argnames", new String[]{"pos"});
        reflect_World_method_canBlockSeeSky_31.set("argtypes", new String[]{"BlockPos"});
        reflect_World_method_canBlockSeeSky_31.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((World) params.getReflective("_self")).canBlockSeeSky((BlockPos) params.getReflective("pos"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_canBlockSeeSky_31);


        BaseData reflect_World_method_getLight_32 = new ModData();
        reflect_World_method_getLight_32.set("methodName", "getLight");
        reflect_World_method_getLight_32.set("returnType", "int");
        reflect_World_method_getLight_32.set("static", false);
        reflect_World_method_getLight_32.set("argnames", new String[]{"pos"});
        reflect_World_method_getLight_32.set("argtypes", new String[]{"BlockPos"});
        reflect_World_method_getLight_32.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((World) params.getReflective("_self")).getLight((BlockPos) params.getReflective("pos"));
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getLight_32);


        BaseData reflect_World_method_getLightFromNeighbors_33 = new ModData();
        reflect_World_method_getLightFromNeighbors_33.set("methodName", "getLightFromNeighbors");
        reflect_World_method_getLightFromNeighbors_33.set("returnType", "int");
        reflect_World_method_getLightFromNeighbors_33.set("static", false);
        reflect_World_method_getLightFromNeighbors_33.set("argnames", new String[]{"pos"});
        reflect_World_method_getLightFromNeighbors_33.set("argtypes", new String[]{"BlockPos"});
        reflect_World_method_getLightFromNeighbors_33.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((World) params.getReflective("_self")).getLightFromNeighbors((BlockPos) params.getReflective("pos"));
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getLightFromNeighbors_33);


        BaseData reflect_World_method_getLight_34 = new ModData();
        reflect_World_method_getLight_34.set("methodName", "getLight");
        reflect_World_method_getLight_34.set("returnType", "int");
        reflect_World_method_getLight_34.set("static", false);
        reflect_World_method_getLight_34.set("argnames", new String[]{"pos", "checkNeighbors"});
        reflect_World_method_getLight_34.set("argtypes", new String[]{"BlockPos", "boolean"});
        reflect_World_method_getLight_34.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((World) params.getReflective("_self")).getLight((BlockPos) params.getReflective("pos"), (boolean) params.getBoolean("checkNeighbors"));
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getLight_34);


        BaseData reflect_World_method_getHeight_35 = new ModData();
        reflect_World_method_getHeight_35.set("methodName", "getHeight");
        reflect_World_method_getHeight_35.set("returnType", "BlockPos");
        reflect_World_method_getHeight_35.set("static", false);
        reflect_World_method_getHeight_35.set("argnames", new String[]{"pos"});
        reflect_World_method_getHeight_35.set("argtypes", new String[]{"BlockPos"});
        reflect_World_method_getHeight_35.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (BlockPos) ((World) params.getReflective("_self")).getHeight((BlockPos) params.getReflective("pos"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getHeight_35);


        BaseData reflect_World_method_getChunksLowestHorizon_36 = new ModData();
        reflect_World_method_getChunksLowestHorizon_36.set("methodName", "getChunksLowestHorizon");
        reflect_World_method_getChunksLowestHorizon_36.set("returnType", "int");
        reflect_World_method_getChunksLowestHorizon_36.set("static", false);
        reflect_World_method_getChunksLowestHorizon_36.set("argnames", new String[]{"x", "z"});
        reflect_World_method_getChunksLowestHorizon_36.set("argtypes", new String[]{"int", "int"});
        reflect_World_method_getChunksLowestHorizon_36.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((World) params.getReflective("_self")).getChunksLowestHorizon((int) params.getInt("x"), (int) params.getInt("z"));
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getChunksLowestHorizon_36);


        BaseData reflect_World_method_getLightFromNeighborsFor_37 = new ModData();
        reflect_World_method_getLightFromNeighborsFor_37.set("methodName", "getLightFromNeighborsFor");
        reflect_World_method_getLightFromNeighborsFor_37.set("returnType", "int");
        reflect_World_method_getLightFromNeighborsFor_37.set("static", false);
        reflect_World_method_getLightFromNeighborsFor_37.set("argnames", new String[]{"type", "pos"});
        reflect_World_method_getLightFromNeighborsFor_37.set("argtypes", new String[]{"EnumSkyBlock", "BlockPos"});
        reflect_World_method_getLightFromNeighborsFor_37.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((World) params.getReflective("_self")).getLightFromNeighborsFor((EnumSkyBlock) params.getReflective("type"), (BlockPos) params.getReflective("pos"));
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getLightFromNeighborsFor_37);


        BaseData reflect_World_method_getLightFor_38 = new ModData();
        reflect_World_method_getLightFor_38.set("methodName", "getLightFor");
        reflect_World_method_getLightFor_38.set("returnType", "int");
        reflect_World_method_getLightFor_38.set("static", false);
        reflect_World_method_getLightFor_38.set("argnames", new String[]{"type", "pos"});
        reflect_World_method_getLightFor_38.set("argtypes", new String[]{"EnumSkyBlock", "BlockPos"});
        reflect_World_method_getLightFor_38.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((World) params.getReflective("_self")).getLightFor((EnumSkyBlock) params.getReflective("type"), (BlockPos) params.getReflective("pos"));
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getLightFor_38);


        BaseData reflect_World_method_setLightFor_39 = new ModData();
        reflect_World_method_setLightFor_39.set("methodName", "setLightFor");
        reflect_World_method_setLightFor_39.set("returnType", "void");
        reflect_World_method_setLightFor_39.set("static", false);
        reflect_World_method_setLightFor_39.set("argnames", new String[]{"type", "pos", "lightValue"});
        reflect_World_method_setLightFor_39.set("argtypes", new String[]{"EnumSkyBlock", "BlockPos", "int"});
        reflect_World_method_setLightFor_39.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((World) params.getReflective("_self")).setLightFor((EnumSkyBlock) params.getReflective("type"), (BlockPos) params.getReflective("pos"), (int) params.getInt("lightValue"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_setLightFor_39);


        BaseData reflect_World_method_notifyLightSet_40 = new ModData();
        reflect_World_method_notifyLightSet_40.set("methodName", "notifyLightSet");
        reflect_World_method_notifyLightSet_40.set("returnType", "void");
        reflect_World_method_notifyLightSet_40.set("static", false);
        reflect_World_method_notifyLightSet_40.set("argnames", new String[]{"pos"});
        reflect_World_method_notifyLightSet_40.set("argtypes", new String[]{"BlockPos"});
        reflect_World_method_notifyLightSet_40.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((World) params.getReflective("_self")).notifyLightSet((BlockPos) params.getReflective("pos"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_notifyLightSet_40);


        BaseData reflect_World_method_getCombinedLight_41 = new ModData();
        reflect_World_method_getCombinedLight_41.set("methodName", "getCombinedLight");
        reflect_World_method_getCombinedLight_41.set("returnType", "int");
        reflect_World_method_getCombinedLight_41.set("static", false);
        reflect_World_method_getCombinedLight_41.set("argnames", new String[]{"pos", "lightValue"});
        reflect_World_method_getCombinedLight_41.set("argtypes", new String[]{"BlockPos", "int"});
        reflect_World_method_getCombinedLight_41.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((World) params.getReflective("_self")).getCombinedLight((BlockPos) params.getReflective("pos"), (int) params.getInt("lightValue"));
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getCombinedLight_41);


        BaseData reflect_World_method_getLightBrightness_42 = new ModData();
        reflect_World_method_getLightBrightness_42.set("methodName", "getLightBrightness");
        reflect_World_method_getLightBrightness_42.set("returnType", "float");
        reflect_World_method_getLightBrightness_42.set("static", false);
        reflect_World_method_getLightBrightness_42.set("argnames", new String[]{"pos"});
        reflect_World_method_getLightBrightness_42.set("argtypes", new String[]{"BlockPos"});
        reflect_World_method_getLightBrightness_42.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((World) params.getReflective("_self")).getLightBrightness((BlockPos) params.getReflective("pos"));
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getLightBrightness_42);


        BaseData reflect_World_method_getBlockState_43 = new ModData();
        reflect_World_method_getBlockState_43.set("methodName", "getBlockState");
        reflect_World_method_getBlockState_43.set("returnType", "IBlockState");
        reflect_World_method_getBlockState_43.set("static", false);
        reflect_World_method_getBlockState_43.set("argnames", new String[]{"pos"});
        reflect_World_method_getBlockState_43.set("argtypes", new String[]{"BlockPos"});
        reflect_World_method_getBlockState_43.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (IBlockState) ((World) params.getReflective("_self")).getBlockState((BlockPos) params.getReflective("pos"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getBlockState_43);


        BaseData reflect_World_method_getBlock_44 = new ModData();
        reflect_World_method_getBlock_44.set("methodName", "getBlock");
        reflect_World_method_getBlock_44.set("returnType", "Block");
        reflect_World_method_getBlock_44.set("static", false);
        reflect_World_method_getBlock_44.set("argnames", new String[]{"pos"});
        reflect_World_method_getBlock_44.set("argtypes", new String[]{"BlockPos"});
        reflect_World_method_getBlock_44.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Block) ((World) params.getReflective("_self")).getBlock((BlockPos) params.getReflective("pos"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getBlock_44);


        BaseData reflect_World_method_isDaytime_45 = new ModData();
        reflect_World_method_isDaytime_45.set("methodName", "isDaytime");
        reflect_World_method_isDaytime_45.set("returnType", "boolean");
        reflect_World_method_isDaytime_45.set("static", false);
        reflect_World_method_isDaytime_45.set("argnames", new String[]{});
        reflect_World_method_isDaytime_45.set("argtypes", new String[]{});
        reflect_World_method_isDaytime_45.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((World) params.getReflective("_self")).isDaytime();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_isDaytime_45);


        BaseData reflect_World_method_rayTraceBlocks_46 = new ModData();
        reflect_World_method_rayTraceBlocks_46.set("methodName", "rayTraceBlocks");
        reflect_World_method_rayTraceBlocks_46.set("returnType", "MovingObjectPosition");
        reflect_World_method_rayTraceBlocks_46.set("static", false);
        reflect_World_method_rayTraceBlocks_46.set("argnames", new String[]{"parVec3_1", "parVec3_2"});
        reflect_World_method_rayTraceBlocks_46.set("argtypes", new String[]{"Vec3", "Vec3"});
        reflect_World_method_rayTraceBlocks_46.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (MovingObjectPosition) ((World) params.getReflective("_self")).rayTraceBlocks((Vec3) params.getReflective("parVec3_1"), (Vec3) params.getReflective("parVec3_2"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_rayTraceBlocks_46);


        BaseData reflect_World_method_rayTraceBlocks_47 = new ModData();
        reflect_World_method_rayTraceBlocks_47.set("methodName", "rayTraceBlocks");
        reflect_World_method_rayTraceBlocks_47.set("returnType", "MovingObjectPosition");
        reflect_World_method_rayTraceBlocks_47.set("static", false);
        reflect_World_method_rayTraceBlocks_47.set("argnames", new String[]{"start", "end", "stopOnLiquid"});
        reflect_World_method_rayTraceBlocks_47.set("argtypes", new String[]{"Vec3", "Vec3", "boolean"});
        reflect_World_method_rayTraceBlocks_47.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (MovingObjectPosition) ((World) params.getReflective("_self")).rayTraceBlocks((Vec3) params.getReflective("start"), (Vec3) params.getReflective("end"), (boolean) params.getBoolean("stopOnLiquid"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_rayTraceBlocks_47);


        BaseData reflect_World_method_playSoundAtEntity_48 = new ModData();
        reflect_World_method_playSoundAtEntity_48.set("methodName", "playSoundAtEntity");
        reflect_World_method_playSoundAtEntity_48.set("returnType", "void");
        reflect_World_method_playSoundAtEntity_48.set("static", false);
        reflect_World_method_playSoundAtEntity_48.set("argnames", new String[]{"entityIn", "name", "volume", "pitch"});
        reflect_World_method_playSoundAtEntity_48.set("argtypes", new String[]{"Entity", "String", "float", "float"});
        reflect_World_method_playSoundAtEntity_48.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((World) params.getReflective("_self")).playSoundAtEntity((Entity) params.getReflective("entityIn"), (String) params.getString("name"), (float) params.getFloat("volume"), (float) params.getFloat("pitch"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_playSoundAtEntity_48);


        BaseData reflect_World_method_playSoundToNearExcept_49 = new ModData();
        reflect_World_method_playSoundToNearExcept_49.set("methodName", "playSoundToNearExcept");
        reflect_World_method_playSoundToNearExcept_49.set("returnType", "void");
        reflect_World_method_playSoundToNearExcept_49.set("static", false);
        reflect_World_method_playSoundToNearExcept_49.set("argnames", new String[]{"player", "name", "volume", "pitch"});
        reflect_World_method_playSoundToNearExcept_49.set("argtypes", new String[]{"EntityPlayer", "String", "float", "float"});
        reflect_World_method_playSoundToNearExcept_49.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((World) params.getReflective("_self")).playSoundToNearExcept((EntityPlayer) params.getReflective("player"), (String) params.getString("name"), (float) params.getFloat("volume"), (float) params.getFloat("pitch"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_playSoundToNearExcept_49);


        BaseData reflect_World_method_playSoundEffect_50 = new ModData();
        reflect_World_method_playSoundEffect_50.set("methodName", "playSoundEffect");
        reflect_World_method_playSoundEffect_50.set("returnType", "void");
        reflect_World_method_playSoundEffect_50.set("static", false);
        reflect_World_method_playSoundEffect_50.set("argnames", new String[]{"x", "y", "z", "soundName", "volume", "pitch"});
        reflect_World_method_playSoundEffect_50.set("argtypes", new String[]{"double", "double", "double", "String", "float", "float"});
        reflect_World_method_playSoundEffect_50.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((World) params.getReflective("_self")).playSoundEffect((double) params.getDouble("x"), (double) params.getDouble("y"), (double) params.getDouble("z"), (String) params.getString("soundName"), (float) params.getFloat("volume"), (float) params.getFloat("pitch"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_playSoundEffect_50);


        BaseData reflect_World_method_playRecord_51 = new ModData();
        reflect_World_method_playRecord_51.set("methodName", "playRecord");
        reflect_World_method_playRecord_51.set("returnType", "void");
        reflect_World_method_playRecord_51.set("static", false);
        reflect_World_method_playRecord_51.set("argnames", new String[]{"pos", "name"});
        reflect_World_method_playRecord_51.set("argtypes", new String[]{"BlockPos", "String"});
        reflect_World_method_playRecord_51.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((World) params.getReflective("_self")).playRecord((BlockPos) params.getReflective("pos"), (String) params.getString("name"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_playRecord_51);


        BaseData reflect_World_method_addWeatherEffect_52 = new ModData();
        reflect_World_method_addWeatherEffect_52.set("methodName", "addWeatherEffect");
        reflect_World_method_addWeatherEffect_52.set("returnType", "boolean");
        reflect_World_method_addWeatherEffect_52.set("static", false);
        reflect_World_method_addWeatherEffect_52.set("argnames", new String[]{"entityIn"});
        reflect_World_method_addWeatherEffect_52.set("argtypes", new String[]{"Entity"});
        reflect_World_method_addWeatherEffect_52.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((World) params.getReflective("_self")).addWeatherEffect((Entity) params.getReflective("entityIn"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_addWeatherEffect_52);


        BaseData reflect_World_method_spawnEntityInWorld_53 = new ModData();
        reflect_World_method_spawnEntityInWorld_53.set("methodName", "spawnEntityInWorld");
        reflect_World_method_spawnEntityInWorld_53.set("returnType", "boolean");
        reflect_World_method_spawnEntityInWorld_53.set("static", false);
        reflect_World_method_spawnEntityInWorld_53.set("argnames", new String[]{"entityIn"});
        reflect_World_method_spawnEntityInWorld_53.set("argtypes", new String[]{"Entity"});
        reflect_World_method_spawnEntityInWorld_53.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((World) params.getReflective("_self")).spawnEntityInWorld((Entity) params.getReflective("entityIn"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_spawnEntityInWorld_53);


        BaseData reflect_World_method_removeEntity_54 = new ModData();
        reflect_World_method_removeEntity_54.set("methodName", "removeEntity");
        reflect_World_method_removeEntity_54.set("returnType", "void");
        reflect_World_method_removeEntity_54.set("static", false);
        reflect_World_method_removeEntity_54.set("argnames", new String[]{"entityIn"});
        reflect_World_method_removeEntity_54.set("argtypes", new String[]{"Entity"});
        reflect_World_method_removeEntity_54.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((World) params.getReflective("_self")).removeEntity((Entity) params.getReflective("entityIn"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_removeEntity_54);


        BaseData reflect_World_method_removePlayerEntityDangerously_55 = new ModData();
        reflect_World_method_removePlayerEntityDangerously_55.set("methodName", "removePlayerEntityDangerously");
        reflect_World_method_removePlayerEntityDangerously_55.set("returnType", "void");
        reflect_World_method_removePlayerEntityDangerously_55.set("static", false);
        reflect_World_method_removePlayerEntityDangerously_55.set("argnames", new String[]{"entityIn"});
        reflect_World_method_removePlayerEntityDangerously_55.set("argtypes", new String[]{"Entity"});
        reflect_World_method_removePlayerEntityDangerously_55.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((World) params.getReflective("_self")).removePlayerEntityDangerously((Entity) params.getReflective("entityIn"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_removePlayerEntityDangerously_55);


        BaseData reflect_World_method_addWorldAccess_56 = new ModData();
        reflect_World_method_addWorldAccess_56.set("methodName", "addWorldAccess");
        reflect_World_method_addWorldAccess_56.set("returnType", "void");
        reflect_World_method_addWorldAccess_56.set("static", false);
        reflect_World_method_addWorldAccess_56.set("argnames", new String[]{"worldAccess"});
        reflect_World_method_addWorldAccess_56.set("argtypes", new String[]{"IWorldAccess"});
        reflect_World_method_addWorldAccess_56.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((World) params.getReflective("_self")).addWorldAccess((IWorldAccess) params.getReflective("worldAccess"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_addWorldAccess_56);


        BaseData reflect_World_method_removeWorldAccess_57 = new ModData();
        reflect_World_method_removeWorldAccess_57.set("methodName", "removeWorldAccess");
        reflect_World_method_removeWorldAccess_57.set("returnType", "void");
        reflect_World_method_removeWorldAccess_57.set("static", false);
        reflect_World_method_removeWorldAccess_57.set("argnames", new String[]{"worldAccess"});
        reflect_World_method_removeWorldAccess_57.set("argtypes", new String[]{"IWorldAccess"});
        reflect_World_method_removeWorldAccess_57.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((World) params.getReflective("_self")).removeWorldAccess((IWorldAccess) params.getReflective("worldAccess"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_removeWorldAccess_57);


        BaseData reflect_World_method_isInsideBorder_58 = new ModData();
        reflect_World_method_isInsideBorder_58.set("methodName", "isInsideBorder");
        reflect_World_method_isInsideBorder_58.set("returnType", "boolean");
        reflect_World_method_isInsideBorder_58.set("static", false);
        reflect_World_method_isInsideBorder_58.set("argnames", new String[]{"worldBorderIn", "entityIn"});
        reflect_World_method_isInsideBorder_58.set("argtypes", new String[]{"WorldBorder", "Entity"});
        reflect_World_method_isInsideBorder_58.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((World) params.getReflective("_self")).isInsideBorder((WorldBorder) params.getReflective("worldBorderIn"), (Entity) params.getReflective("entityIn"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_isInsideBorder_58);


        BaseData reflect_World_method_calculateSkylightSubtracted_59 = new ModData();
        reflect_World_method_calculateSkylightSubtracted_59.set("methodName", "calculateSkylightSubtracted");
        reflect_World_method_calculateSkylightSubtracted_59.set("returnType", "int");
        reflect_World_method_calculateSkylightSubtracted_59.set("static", false);
        reflect_World_method_calculateSkylightSubtracted_59.set("argnames", new String[]{"parFloat1"});
        reflect_World_method_calculateSkylightSubtracted_59.set("argtypes", new String[]{"float"});
        reflect_World_method_calculateSkylightSubtracted_59.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((World) params.getReflective("_self")).calculateSkylightSubtracted((float) params.getFloat("parFloat1"));
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_calculateSkylightSubtracted_59);


        BaseData reflect_World_method_getSunBrightness_60 = new ModData();
        reflect_World_method_getSunBrightness_60.set("methodName", "getSunBrightness");
        reflect_World_method_getSunBrightness_60.set("returnType", "float");
        reflect_World_method_getSunBrightness_60.set("static", false);
        reflect_World_method_getSunBrightness_60.set("argnames", new String[]{"parFloat1"});
        reflect_World_method_getSunBrightness_60.set("argtypes", new String[]{"float"});
        reflect_World_method_getSunBrightness_60.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((World) params.getReflective("_self")).getSunBrightness((float) params.getFloat("parFloat1"));
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getSunBrightness_60);


        BaseData reflect_World_method_getSkyColor_61 = new ModData();
        reflect_World_method_getSkyColor_61.set("methodName", "getSkyColor");
        reflect_World_method_getSkyColor_61.set("returnType", "Vec3");
        reflect_World_method_getSkyColor_61.set("static", false);
        reflect_World_method_getSkyColor_61.set("argnames", new String[]{"entityIn", "partialTicks"});
        reflect_World_method_getSkyColor_61.set("argtypes", new String[]{"Entity", "float"});
        reflect_World_method_getSkyColor_61.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Vec3) ((World) params.getReflective("_self")).getSkyColor((Entity) params.getReflective("entityIn"), (float) params.getFloat("partialTicks"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getSkyColor_61);


        BaseData reflect_World_method_getCelestialAngle_62 = new ModData();
        reflect_World_method_getCelestialAngle_62.set("methodName", "getCelestialAngle");
        reflect_World_method_getCelestialAngle_62.set("returnType", "float");
        reflect_World_method_getCelestialAngle_62.set("static", false);
        reflect_World_method_getCelestialAngle_62.set("argnames", new String[]{"partialTicks"});
        reflect_World_method_getCelestialAngle_62.set("argtypes", new String[]{"float"});
        reflect_World_method_getCelestialAngle_62.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((World) params.getReflective("_self")).getCelestialAngle((float) params.getFloat("partialTicks"));
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getCelestialAngle_62);


        BaseData reflect_World_method_getMoonPhase_63 = new ModData();
        reflect_World_method_getMoonPhase_63.set("methodName", "getMoonPhase");
        reflect_World_method_getMoonPhase_63.set("returnType", "int");
        reflect_World_method_getMoonPhase_63.set("static", false);
        reflect_World_method_getMoonPhase_63.set("argnames", new String[]{});
        reflect_World_method_getMoonPhase_63.set("argtypes", new String[]{});
        reflect_World_method_getMoonPhase_63.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((World) params.getReflective("_self")).getMoonPhase();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getMoonPhase_63);


        BaseData reflect_World_method_getCurrentMoonPhaseFactor_64 = new ModData();
        reflect_World_method_getCurrentMoonPhaseFactor_64.set("methodName", "getCurrentMoonPhaseFactor");
        reflect_World_method_getCurrentMoonPhaseFactor_64.set("returnType", "float");
        reflect_World_method_getCurrentMoonPhaseFactor_64.set("static", false);
        reflect_World_method_getCurrentMoonPhaseFactor_64.set("argnames", new String[]{});
        reflect_World_method_getCurrentMoonPhaseFactor_64.set("argtypes", new String[]{});
        reflect_World_method_getCurrentMoonPhaseFactor_64.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((World) params.getReflective("_self")).getCurrentMoonPhaseFactor();
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getCurrentMoonPhaseFactor_64);


        BaseData reflect_World_method_getCelestialAngleRadians_65 = new ModData();
        reflect_World_method_getCelestialAngleRadians_65.set("methodName", "getCelestialAngleRadians");
        reflect_World_method_getCelestialAngleRadians_65.set("returnType", "float");
        reflect_World_method_getCelestialAngleRadians_65.set("static", false);
        reflect_World_method_getCelestialAngleRadians_65.set("argnames", new String[]{"partialTicks"});
        reflect_World_method_getCelestialAngleRadians_65.set("argtypes", new String[]{"float"});
        reflect_World_method_getCelestialAngleRadians_65.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((World) params.getReflective("_self")).getCelestialAngleRadians((float) params.getFloat("partialTicks"));
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getCelestialAngleRadians_65);


        BaseData reflect_World_method_getCloudColour_66 = new ModData();
        reflect_World_method_getCloudColour_66.set("methodName", "getCloudColour");
        reflect_World_method_getCloudColour_66.set("returnType", "Vec3");
        reflect_World_method_getCloudColour_66.set("static", false);
        reflect_World_method_getCloudColour_66.set("argnames", new String[]{"partialTicks"});
        reflect_World_method_getCloudColour_66.set("argtypes", new String[]{"float"});
        reflect_World_method_getCloudColour_66.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Vec3) ((World) params.getReflective("_self")).getCloudColour((float) params.getFloat("partialTicks"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getCloudColour_66);


        BaseData reflect_World_method_getFogColor_67 = new ModData();
        reflect_World_method_getFogColor_67.set("methodName", "getFogColor");
        reflect_World_method_getFogColor_67.set("returnType", "Vec3");
        reflect_World_method_getFogColor_67.set("static", false);
        reflect_World_method_getFogColor_67.set("argnames", new String[]{"partialTicks"});
        reflect_World_method_getFogColor_67.set("argtypes", new String[]{"float"});
        reflect_World_method_getFogColor_67.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Vec3) ((World) params.getReflective("_self")).getFogColor((float) params.getFloat("partialTicks"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getFogColor_67);


        BaseData reflect_World_method_getPrecipitationHeight_68 = new ModData();
        reflect_World_method_getPrecipitationHeight_68.set("methodName", "getPrecipitationHeight");
        reflect_World_method_getPrecipitationHeight_68.set("returnType", "BlockPos");
        reflect_World_method_getPrecipitationHeight_68.set("static", false);
        reflect_World_method_getPrecipitationHeight_68.set("argnames", new String[]{"pos"});
        reflect_World_method_getPrecipitationHeight_68.set("argtypes", new String[]{"BlockPos"});
        reflect_World_method_getPrecipitationHeight_68.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (BlockPos) ((World) params.getReflective("_self")).getPrecipitationHeight((BlockPos) params.getReflective("pos"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getPrecipitationHeight_68);


        BaseData reflect_World_method_getTopSolidOrLiquidBlock_69 = new ModData();
        reflect_World_method_getTopSolidOrLiquidBlock_69.set("methodName", "getTopSolidOrLiquidBlock");
        reflect_World_method_getTopSolidOrLiquidBlock_69.set("returnType", "BlockPos");
        reflect_World_method_getTopSolidOrLiquidBlock_69.set("static", false);
        reflect_World_method_getTopSolidOrLiquidBlock_69.set("argnames", new String[]{"pos"});
        reflect_World_method_getTopSolidOrLiquidBlock_69.set("argtypes", new String[]{"BlockPos"});
        reflect_World_method_getTopSolidOrLiquidBlock_69.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (BlockPos) ((World) params.getReflective("_self")).getTopSolidOrLiquidBlock((BlockPos) params.getReflective("pos"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getTopSolidOrLiquidBlock_69);


        BaseData reflect_World_method_getStarBrightness_70 = new ModData();
        reflect_World_method_getStarBrightness_70.set("methodName", "getStarBrightness");
        reflect_World_method_getStarBrightness_70.set("returnType", "float");
        reflect_World_method_getStarBrightness_70.set("static", false);
        reflect_World_method_getStarBrightness_70.set("argnames", new String[]{"partialTicks"});
        reflect_World_method_getStarBrightness_70.set("argtypes", new String[]{"float"});
        reflect_World_method_getStarBrightness_70.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((World) params.getReflective("_self")).getStarBrightness((float) params.getFloat("partialTicks"));
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getStarBrightness_70);


        BaseData reflect_World_method_scheduleUpdate_71 = new ModData();
        reflect_World_method_scheduleUpdate_71.set("methodName", "scheduleUpdate");
        reflect_World_method_scheduleUpdate_71.set("returnType", "void");
        reflect_World_method_scheduleUpdate_71.set("static", false);
        reflect_World_method_scheduleUpdate_71.set("argnames", new String[]{"pos", "blockIn", "delay"});
        reflect_World_method_scheduleUpdate_71.set("argtypes", new String[]{"BlockPos", "Block", "int"});
        reflect_World_method_scheduleUpdate_71.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((World) params.getReflective("_self")).scheduleUpdate((BlockPos) params.getReflective("pos"), (Block) params.getReflective("blockIn"), (int) params.getInt("delay"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_scheduleUpdate_71);


        BaseData reflect_World_method_updateBlockTick_72 = new ModData();
        reflect_World_method_updateBlockTick_72.set("methodName", "updateBlockTick");
        reflect_World_method_updateBlockTick_72.set("returnType", "void");
        reflect_World_method_updateBlockTick_72.set("static", false);
        reflect_World_method_updateBlockTick_72.set("argnames", new String[]{"pos", "blockIn", "delay", "priority"});
        reflect_World_method_updateBlockTick_72.set("argtypes", new String[]{"BlockPos", "Block", "int", "int"});
        reflect_World_method_updateBlockTick_72.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((World) params.getReflective("_self")).updateBlockTick((BlockPos) params.getReflective("pos"), (Block) params.getReflective("blockIn"), (int) params.getInt("delay"), (int) params.getInt("priority"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_updateBlockTick_72);


        BaseData reflect_World_method_scheduleBlockUpdate_73 = new ModData();
        reflect_World_method_scheduleBlockUpdate_73.set("methodName", "scheduleBlockUpdate");
        reflect_World_method_scheduleBlockUpdate_73.set("returnType", "void");
        reflect_World_method_scheduleBlockUpdate_73.set("static", false);
        reflect_World_method_scheduleBlockUpdate_73.set("argnames", new String[]{"pos", "blockIn", "delay", "priority"});
        reflect_World_method_scheduleBlockUpdate_73.set("argtypes", new String[]{"BlockPos", "Block", "int", "int"});
        reflect_World_method_scheduleBlockUpdate_73.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((World) params.getReflective("_self")).scheduleBlockUpdate((BlockPos) params.getReflective("pos"), (Block) params.getReflective("blockIn"), (int) params.getInt("delay"), (int) params.getInt("priority"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_scheduleBlockUpdate_73);


        BaseData reflect_World_method_updateEntities_74 = new ModData();
        reflect_World_method_updateEntities_74.set("methodName", "updateEntities");
        reflect_World_method_updateEntities_74.set("returnType", "void");
        reflect_World_method_updateEntities_74.set("static", false);
        reflect_World_method_updateEntities_74.set("argnames", new String[]{});
        reflect_World_method_updateEntities_74.set("argtypes", new String[]{});
        reflect_World_method_updateEntities_74.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((World) params.getReflective("_self")).updateEntities();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_updateEntities_74);


        BaseData reflect_World_method_addTileEntity_75 = new ModData();
        reflect_World_method_addTileEntity_75.set("methodName", "addTileEntity");
        reflect_World_method_addTileEntity_75.set("returnType", "boolean");
        reflect_World_method_addTileEntity_75.set("static", false);
        reflect_World_method_addTileEntity_75.set("argnames", new String[]{"tile"});
        reflect_World_method_addTileEntity_75.set("argtypes", new String[]{"TileEntity"});
        reflect_World_method_addTileEntity_75.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((World) params.getReflective("_self")).addTileEntity((TileEntity) params.getReflective("tile"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_addTileEntity_75);


        BaseData reflect_World_method_updateEntity_76 = new ModData();
        reflect_World_method_updateEntity_76.set("methodName", "updateEntity");
        reflect_World_method_updateEntity_76.set("returnType", "void");
        reflect_World_method_updateEntity_76.set("static", false);
        reflect_World_method_updateEntity_76.set("argnames", new String[]{"ent"});
        reflect_World_method_updateEntity_76.set("argtypes", new String[]{"Entity"});
        reflect_World_method_updateEntity_76.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((World) params.getReflective("_self")).updateEntity((Entity) params.getReflective("ent"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_updateEntity_76);


        BaseData reflect_World_method_updateEntityWithOptionalForce_77 = new ModData();
        reflect_World_method_updateEntityWithOptionalForce_77.set("methodName", "updateEntityWithOptionalForce");
        reflect_World_method_updateEntityWithOptionalForce_77.set("returnType", "void");
        reflect_World_method_updateEntityWithOptionalForce_77.set("static", false);
        reflect_World_method_updateEntityWithOptionalForce_77.set("argnames", new String[]{"entityIn", "forceUpdate"});
        reflect_World_method_updateEntityWithOptionalForce_77.set("argtypes", new String[]{"Entity", "boolean"});
        reflect_World_method_updateEntityWithOptionalForce_77.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((World) params.getReflective("_self")).updateEntityWithOptionalForce((Entity) params.getReflective("entityIn"), (boolean) params.getBoolean("forceUpdate"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_updateEntityWithOptionalForce_77);


        BaseData reflect_World_method_checkNoEntityCollision_78 = new ModData();
        reflect_World_method_checkNoEntityCollision_78.set("methodName", "checkNoEntityCollision");
        reflect_World_method_checkNoEntityCollision_78.set("returnType", "boolean");
        reflect_World_method_checkNoEntityCollision_78.set("static", false);
        reflect_World_method_checkNoEntityCollision_78.set("argnames", new String[]{"bb"});
        reflect_World_method_checkNoEntityCollision_78.set("argtypes", new String[]{"AxisAlignedBB"});
        reflect_World_method_checkNoEntityCollision_78.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((World) params.getReflective("_self")).checkNoEntityCollision((AxisAlignedBB) params.getReflective("bb"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_checkNoEntityCollision_78);


        BaseData reflect_World_method_checkNoEntityCollision_79 = new ModData();
        reflect_World_method_checkNoEntityCollision_79.set("methodName", "checkNoEntityCollision");
        reflect_World_method_checkNoEntityCollision_79.set("returnType", "boolean");
        reflect_World_method_checkNoEntityCollision_79.set("static", false);
        reflect_World_method_checkNoEntityCollision_79.set("argnames", new String[]{"bb", "entityIn"});
        reflect_World_method_checkNoEntityCollision_79.set("argtypes", new String[]{"AxisAlignedBB", "Entity"});
        reflect_World_method_checkNoEntityCollision_79.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((World) params.getReflective("_self")).checkNoEntityCollision((AxisAlignedBB) params.getReflective("bb"), (Entity) params.getReflective("entityIn"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_checkNoEntityCollision_79);


        BaseData reflect_World_method_checkBlockCollision_80 = new ModData();
        reflect_World_method_checkBlockCollision_80.set("methodName", "checkBlockCollision");
        reflect_World_method_checkBlockCollision_80.set("returnType", "boolean");
        reflect_World_method_checkBlockCollision_80.set("static", false);
        reflect_World_method_checkBlockCollision_80.set("argnames", new String[]{"bb"});
        reflect_World_method_checkBlockCollision_80.set("argtypes", new String[]{"AxisAlignedBB"});
        reflect_World_method_checkBlockCollision_80.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((World) params.getReflective("_self")).checkBlockCollision((AxisAlignedBB) params.getReflective("bb"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_checkBlockCollision_80);


        BaseData reflect_World_method_isAnyLiquid_81 = new ModData();
        reflect_World_method_isAnyLiquid_81.set("methodName", "isAnyLiquid");
        reflect_World_method_isAnyLiquid_81.set("returnType", "boolean");
        reflect_World_method_isAnyLiquid_81.set("static", false);
        reflect_World_method_isAnyLiquid_81.set("argnames", new String[]{"bb"});
        reflect_World_method_isAnyLiquid_81.set("argtypes", new String[]{"AxisAlignedBB"});
        reflect_World_method_isAnyLiquid_81.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((World) params.getReflective("_self")).isAnyLiquid((AxisAlignedBB) params.getReflective("bb"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_isAnyLiquid_81);


        BaseData reflect_World_method_isFlammableWithin_82 = new ModData();
        reflect_World_method_isFlammableWithin_82.set("methodName", "isFlammableWithin");
        reflect_World_method_isFlammableWithin_82.set("returnType", "boolean");
        reflect_World_method_isFlammableWithin_82.set("static", false);
        reflect_World_method_isFlammableWithin_82.set("argnames", new String[]{"bb"});
        reflect_World_method_isFlammableWithin_82.set("argtypes", new String[]{"AxisAlignedBB"});
        reflect_World_method_isFlammableWithin_82.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((World) params.getReflective("_self")).isFlammableWithin((AxisAlignedBB) params.getReflective("bb"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_isFlammableWithin_82);


        BaseData reflect_World_method_handleMaterialAcceleration_83 = new ModData();
        reflect_World_method_handleMaterialAcceleration_83.set("methodName", "handleMaterialAcceleration");
        reflect_World_method_handleMaterialAcceleration_83.set("returnType", "boolean");
        reflect_World_method_handleMaterialAcceleration_83.set("static", false);
        reflect_World_method_handleMaterialAcceleration_83.set("argnames", new String[]{"bb", "materialIn", "entityIn"});
        reflect_World_method_handleMaterialAcceleration_83.set("argtypes", new String[]{"AxisAlignedBB", "Material", "Entity"});
        reflect_World_method_handleMaterialAcceleration_83.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((World) params.getReflective("_self")).handleMaterialAcceleration((AxisAlignedBB) params.getReflective("bb"), (Material) params.getReflective("materialIn"), (Entity) params.getReflective("entityIn"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_handleMaterialAcceleration_83);


        BaseData reflect_World_method_isMaterialInBB_84 = new ModData();
        reflect_World_method_isMaterialInBB_84.set("methodName", "isMaterialInBB");
        reflect_World_method_isMaterialInBB_84.set("returnType", "boolean");
        reflect_World_method_isMaterialInBB_84.set("static", false);
        reflect_World_method_isMaterialInBB_84.set("argnames", new String[]{"bb", "materialIn"});
        reflect_World_method_isMaterialInBB_84.set("argtypes", new String[]{"AxisAlignedBB", "Material"});
        reflect_World_method_isMaterialInBB_84.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((World) params.getReflective("_self")).isMaterialInBB((AxisAlignedBB) params.getReflective("bb"), (Material) params.getReflective("materialIn"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_isMaterialInBB_84);


        BaseData reflect_World_method_isAABBInMaterial_85 = new ModData();
        reflect_World_method_isAABBInMaterial_85.set("methodName", "isAABBInMaterial");
        reflect_World_method_isAABBInMaterial_85.set("returnType", "boolean");
        reflect_World_method_isAABBInMaterial_85.set("static", false);
        reflect_World_method_isAABBInMaterial_85.set("argnames", new String[]{"bb", "materialIn"});
        reflect_World_method_isAABBInMaterial_85.set("argtypes", new String[]{"AxisAlignedBB", "Material"});
        reflect_World_method_isAABBInMaterial_85.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((World) params.getReflective("_self")).isAABBInMaterial((AxisAlignedBB) params.getReflective("bb"), (Material) params.getReflective("materialIn"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_isAABBInMaterial_85);


        BaseData reflect_World_method_createExplosion_86 = new ModData();
        reflect_World_method_createExplosion_86.set("methodName", "createExplosion");
        reflect_World_method_createExplosion_86.set("returnType", "Explosion");
        reflect_World_method_createExplosion_86.set("static", false);
        reflect_World_method_createExplosion_86.set("argnames", new String[]{"entityIn", "x", "y", "z", "strength", "isSmoking"});
        reflect_World_method_createExplosion_86.set("argtypes", new String[]{"Entity", "double", "double", "double", "float", "boolean"});
        reflect_World_method_createExplosion_86.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Explosion) ((World) params.getReflective("_self")).createExplosion((Entity) params.getReflective("entityIn"), (double) params.getDouble("x"), (double) params.getDouble("y"), (double) params.getDouble("z"), (float) params.getFloat("strength"), (boolean) params.getBoolean("isSmoking"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_createExplosion_86);


        BaseData reflect_World_method_getBlockDensity_87 = new ModData();
        reflect_World_method_getBlockDensity_87.set("methodName", "getBlockDensity");
        reflect_World_method_getBlockDensity_87.set("returnType", "float");
        reflect_World_method_getBlockDensity_87.set("static", false);
        reflect_World_method_getBlockDensity_87.set("argnames", new String[]{"vec", "bb"});
        reflect_World_method_getBlockDensity_87.set("argtypes", new String[]{"Vec3", "AxisAlignedBB"});
        reflect_World_method_getBlockDensity_87.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((World) params.getReflective("_self")).getBlockDensity((Vec3) params.getReflective("vec"), (AxisAlignedBB) params.getReflective("bb"));
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getBlockDensity_87);


        BaseData reflect_World_method_extinguishFire_88 = new ModData();
        reflect_World_method_extinguishFire_88.set("methodName", "extinguishFire");
        reflect_World_method_extinguishFire_88.set("returnType", "boolean");
        reflect_World_method_extinguishFire_88.set("static", false);
        reflect_World_method_extinguishFire_88.set("argnames", new String[]{"player", "pos", "side"});
        reflect_World_method_extinguishFire_88.set("argtypes", new String[]{"EntityPlayer", "BlockPos", "EnumFacing"});
        reflect_World_method_extinguishFire_88.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((World) params.getReflective("_self")).extinguishFire((EntityPlayer) params.getReflective("player"), (BlockPos) params.getReflective("pos"), (EnumFacing) params.getReflective("side"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_extinguishFire_88);


        BaseData reflect_World_method_getDebugLoadedEntities_89 = new ModData();
        reflect_World_method_getDebugLoadedEntities_89.set("methodName", "getDebugLoadedEntities");
        reflect_World_method_getDebugLoadedEntities_89.set("returnType", "String");
        reflect_World_method_getDebugLoadedEntities_89.set("static", false);
        reflect_World_method_getDebugLoadedEntities_89.set("argnames", new String[]{});
        reflect_World_method_getDebugLoadedEntities_89.set("argtypes", new String[]{});
        reflect_World_method_getDebugLoadedEntities_89.setCallbackStringWithDataArg("exec", (BaseData params) -> {
                try {
                    return (String) ((World) params.getReflective("_self")).getDebugLoadedEntities();
                } catch (Exception _exception_reflect_) {
                    return "";
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getDebugLoadedEntities_89);


        BaseData reflect_World_method_getProviderName_90 = new ModData();
        reflect_World_method_getProviderName_90.set("methodName", "getProviderName");
        reflect_World_method_getProviderName_90.set("returnType", "String");
        reflect_World_method_getProviderName_90.set("static", false);
        reflect_World_method_getProviderName_90.set("argnames", new String[]{});
        reflect_World_method_getProviderName_90.set("argtypes", new String[]{});
        reflect_World_method_getProviderName_90.setCallbackStringWithDataArg("exec", (BaseData params) -> {
                try {
                    return (String) ((World) params.getReflective("_self")).getProviderName();
                } catch (Exception _exception_reflect_) {
                    return "";
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getProviderName_90);


        BaseData reflect_World_method_getTileEntity_91 = new ModData();
        reflect_World_method_getTileEntity_91.set("methodName", "getTileEntity");
        reflect_World_method_getTileEntity_91.set("returnType", "TileEntity");
        reflect_World_method_getTileEntity_91.set("static", false);
        reflect_World_method_getTileEntity_91.set("argnames", new String[]{"pos"});
        reflect_World_method_getTileEntity_91.set("argtypes", new String[]{"BlockPos"});
        reflect_World_method_getTileEntity_91.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (TileEntity) ((World) params.getReflective("_self")).getTileEntity((BlockPos) params.getReflective("pos"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getTileEntity_91);


        BaseData reflect_World_method_setTileEntity_92 = new ModData();
        reflect_World_method_setTileEntity_92.set("methodName", "setTileEntity");
        reflect_World_method_setTileEntity_92.set("returnType", "void");
        reflect_World_method_setTileEntity_92.set("static", false);
        reflect_World_method_setTileEntity_92.set("argnames", new String[]{"pos", "tileEntityIn"});
        reflect_World_method_setTileEntity_92.set("argtypes", new String[]{"BlockPos", "TileEntity"});
        reflect_World_method_setTileEntity_92.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((World) params.getReflective("_self")).setTileEntity((BlockPos) params.getReflective("pos"), (TileEntity) params.getReflective("tileEntityIn"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_setTileEntity_92);


        BaseData reflect_World_method_removeTileEntity_93 = new ModData();
        reflect_World_method_removeTileEntity_93.set("methodName", "removeTileEntity");
        reflect_World_method_removeTileEntity_93.set("returnType", "void");
        reflect_World_method_removeTileEntity_93.set("static", false);
        reflect_World_method_removeTileEntity_93.set("argnames", new String[]{"pos"});
        reflect_World_method_removeTileEntity_93.set("argtypes", new String[]{"BlockPos"});
        reflect_World_method_removeTileEntity_93.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((World) params.getReflective("_self")).removeTileEntity((BlockPos) params.getReflective("pos"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_removeTileEntity_93);


        BaseData reflect_World_method_markTileEntityForRemoval_94 = new ModData();
        reflect_World_method_markTileEntityForRemoval_94.set("methodName", "markTileEntityForRemoval");
        reflect_World_method_markTileEntityForRemoval_94.set("returnType", "void");
        reflect_World_method_markTileEntityForRemoval_94.set("static", false);
        reflect_World_method_markTileEntityForRemoval_94.set("argnames", new String[]{"tileEntityIn"});
        reflect_World_method_markTileEntityForRemoval_94.set("argtypes", new String[]{"TileEntity"});
        reflect_World_method_markTileEntityForRemoval_94.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((World) params.getReflective("_self")).markTileEntityForRemoval((TileEntity) params.getReflective("tileEntityIn"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_markTileEntityForRemoval_94);


        BaseData reflect_World_method_isBlockFullCube_95 = new ModData();
        reflect_World_method_isBlockFullCube_95.set("methodName", "isBlockFullCube");
        reflect_World_method_isBlockFullCube_95.set("returnType", "boolean");
        reflect_World_method_isBlockFullCube_95.set("static", false);
        reflect_World_method_isBlockFullCube_95.set("argnames", new String[]{"pos"});
        reflect_World_method_isBlockFullCube_95.set("argtypes", new String[]{"BlockPos"});
        reflect_World_method_isBlockFullCube_95.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((World) params.getReflective("_self")).isBlockFullCube((BlockPos) params.getReflective("pos"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_isBlockFullCube_95);


        BaseData reflect_World_method_doesBlockHaveSolidTopSurface_96 = new ModData();
        reflect_World_method_doesBlockHaveSolidTopSurface_96.set("methodName", "doesBlockHaveSolidTopSurface");
        reflect_World_method_doesBlockHaveSolidTopSurface_96.set("returnType", "boolean");
        reflect_World_method_doesBlockHaveSolidTopSurface_96.set("static", true);
        reflect_World_method_doesBlockHaveSolidTopSurface_96.set("argnames", new String[]{"blockAccess", "pos"});
        reflect_World_method_doesBlockHaveSolidTopSurface_96.set("argtypes", new String[]{"IBlockAccess", "BlockPos"});
        reflect_World_method_doesBlockHaveSolidTopSurface_96.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) World.doesBlockHaveSolidTopSurface((IBlockAccess) params.getReflective("blockAccess"), (BlockPos) params.getReflective("pos"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_doesBlockHaveSolidTopSurface_96);


        BaseData reflect_World_method_isBlockNormalCube_97 = new ModData();
        reflect_World_method_isBlockNormalCube_97.set("methodName", "isBlockNormalCube");
        reflect_World_method_isBlockNormalCube_97.set("returnType", "boolean");
        reflect_World_method_isBlockNormalCube_97.set("static", false);
        reflect_World_method_isBlockNormalCube_97.set("argnames", new String[]{"pos", "_default"});
        reflect_World_method_isBlockNormalCube_97.set("argtypes", new String[]{"BlockPos", "boolean"});
        reflect_World_method_isBlockNormalCube_97.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((World) params.getReflective("_self")).isBlockNormalCube((BlockPos) params.getReflective("pos"), (boolean) params.getBoolean("_default"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_isBlockNormalCube_97);


        BaseData reflect_World_method_calculateInitialSkylight_98 = new ModData();
        reflect_World_method_calculateInitialSkylight_98.set("methodName", "calculateInitialSkylight");
        reflect_World_method_calculateInitialSkylight_98.set("returnType", "void");
        reflect_World_method_calculateInitialSkylight_98.set("static", false);
        reflect_World_method_calculateInitialSkylight_98.set("argnames", new String[]{});
        reflect_World_method_calculateInitialSkylight_98.set("argtypes", new String[]{});
        reflect_World_method_calculateInitialSkylight_98.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((World) params.getReflective("_self")).calculateInitialSkylight();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_calculateInitialSkylight_98);


        BaseData reflect_World_method_setAllowedSpawnTypes_99 = new ModData();
        reflect_World_method_setAllowedSpawnTypes_99.set("methodName", "setAllowedSpawnTypes");
        reflect_World_method_setAllowedSpawnTypes_99.set("returnType", "void");
        reflect_World_method_setAllowedSpawnTypes_99.set("static", false);
        reflect_World_method_setAllowedSpawnTypes_99.set("argnames", new String[]{"hostile", "peaceful"});
        reflect_World_method_setAllowedSpawnTypes_99.set("argtypes", new String[]{"boolean", "boolean"});
        reflect_World_method_setAllowedSpawnTypes_99.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((World) params.getReflective("_self")).setAllowedSpawnTypes((boolean) params.getBoolean("hostile"), (boolean) params.getBoolean("peaceful"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_setAllowedSpawnTypes_99);


        BaseData reflect_World_method_tick_100 = new ModData();
        reflect_World_method_tick_100.set("methodName", "tick");
        reflect_World_method_tick_100.set("returnType", "void");
        reflect_World_method_tick_100.set("static", false);
        reflect_World_method_tick_100.set("argnames", new String[]{});
        reflect_World_method_tick_100.set("argtypes", new String[]{});
        reflect_World_method_tick_100.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((World) params.getReflective("_self")).tick();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_tick_100);


        BaseData reflect_World_method_forceBlockUpdateTick_101 = new ModData();
        reflect_World_method_forceBlockUpdateTick_101.set("methodName", "forceBlockUpdateTick");
        reflect_World_method_forceBlockUpdateTick_101.set("returnType", "void");
        reflect_World_method_forceBlockUpdateTick_101.set("static", false);
        reflect_World_method_forceBlockUpdateTick_101.set("argnames", new String[]{"blockType", "pos", "random"});
        reflect_World_method_forceBlockUpdateTick_101.set("argtypes", new String[]{"Block", "BlockPos", "EaglercraftRandom"});
        reflect_World_method_forceBlockUpdateTick_101.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((World) params.getReflective("_self")).forceBlockUpdateTick((Block) params.getReflective("blockType"), (BlockPos) params.getReflective("pos"), (EaglercraftRandom) params.getReflective("random"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_forceBlockUpdateTick_101);


        BaseData reflect_World_method_canBlockFreezeWater_102 = new ModData();
        reflect_World_method_canBlockFreezeWater_102.set("methodName", "canBlockFreezeWater");
        reflect_World_method_canBlockFreezeWater_102.set("returnType", "boolean");
        reflect_World_method_canBlockFreezeWater_102.set("static", false);
        reflect_World_method_canBlockFreezeWater_102.set("argnames", new String[]{"pos"});
        reflect_World_method_canBlockFreezeWater_102.set("argtypes", new String[]{"BlockPos"});
        reflect_World_method_canBlockFreezeWater_102.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((World) params.getReflective("_self")).canBlockFreezeWater((BlockPos) params.getReflective("pos"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_canBlockFreezeWater_102);


        BaseData reflect_World_method_canBlockFreezeNoWater_103 = new ModData();
        reflect_World_method_canBlockFreezeNoWater_103.set("methodName", "canBlockFreezeNoWater");
        reflect_World_method_canBlockFreezeNoWater_103.set("returnType", "boolean");
        reflect_World_method_canBlockFreezeNoWater_103.set("static", false);
        reflect_World_method_canBlockFreezeNoWater_103.set("argnames", new String[]{"pos"});
        reflect_World_method_canBlockFreezeNoWater_103.set("argtypes", new String[]{"BlockPos"});
        reflect_World_method_canBlockFreezeNoWater_103.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((World) params.getReflective("_self")).canBlockFreezeNoWater((BlockPos) params.getReflective("pos"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_canBlockFreezeNoWater_103);


        BaseData reflect_World_method_canBlockFreeze_104 = new ModData();
        reflect_World_method_canBlockFreeze_104.set("methodName", "canBlockFreeze");
        reflect_World_method_canBlockFreeze_104.set("returnType", "boolean");
        reflect_World_method_canBlockFreeze_104.set("static", false);
        reflect_World_method_canBlockFreeze_104.set("argnames", new String[]{"pos", "noWaterAdj"});
        reflect_World_method_canBlockFreeze_104.set("argtypes", new String[]{"BlockPos", "boolean"});
        reflect_World_method_canBlockFreeze_104.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((World) params.getReflective("_self")).canBlockFreeze((BlockPos) params.getReflective("pos"), (boolean) params.getBoolean("noWaterAdj"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_canBlockFreeze_104);


        BaseData reflect_World_method_canSnowAt_105 = new ModData();
        reflect_World_method_canSnowAt_105.set("methodName", "canSnowAt");
        reflect_World_method_canSnowAt_105.set("returnType", "boolean");
        reflect_World_method_canSnowAt_105.set("static", false);
        reflect_World_method_canSnowAt_105.set("argnames", new String[]{"pos", "checkLight"});
        reflect_World_method_canSnowAt_105.set("argtypes", new String[]{"BlockPos", "boolean"});
        reflect_World_method_canSnowAt_105.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((World) params.getReflective("_self")).canSnowAt((BlockPos) params.getReflective("pos"), (boolean) params.getBoolean("checkLight"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_canSnowAt_105);


        BaseData reflect_World_method_checkLight_106 = new ModData();
        reflect_World_method_checkLight_106.set("methodName", "checkLight");
        reflect_World_method_checkLight_106.set("returnType", "boolean");
        reflect_World_method_checkLight_106.set("static", false);
        reflect_World_method_checkLight_106.set("argnames", new String[]{"pos"});
        reflect_World_method_checkLight_106.set("argtypes", new String[]{"BlockPos"});
        reflect_World_method_checkLight_106.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((World) params.getReflective("_self")).checkLight((BlockPos) params.getReflective("pos"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_checkLight_106);


        BaseData reflect_World_method_checkLightFor_107 = new ModData();
        reflect_World_method_checkLightFor_107.set("methodName", "checkLightFor");
        reflect_World_method_checkLightFor_107.set("returnType", "boolean");
        reflect_World_method_checkLightFor_107.set("static", false);
        reflect_World_method_checkLightFor_107.set("argnames", new String[]{"lightType", "pos"});
        reflect_World_method_checkLightFor_107.set("argtypes", new String[]{"EnumSkyBlock", "BlockPos"});
        reflect_World_method_checkLightFor_107.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((World) params.getReflective("_self")).checkLightFor((EnumSkyBlock) params.getReflective("lightType"), (BlockPos) params.getReflective("pos"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_checkLightFor_107);


        BaseData reflect_World_method_tickUpdates_108 = new ModData();
        reflect_World_method_tickUpdates_108.set("methodName", "tickUpdates");
        reflect_World_method_tickUpdates_108.set("returnType", "boolean");
        reflect_World_method_tickUpdates_108.set("static", false);
        reflect_World_method_tickUpdates_108.set("argnames", new String[]{"parFlag"});
        reflect_World_method_tickUpdates_108.set("argtypes", new String[]{"boolean"});
        reflect_World_method_tickUpdates_108.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((World) params.getReflective("_self")).tickUpdates((boolean) params.getBoolean("parFlag"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_tickUpdates_108);


        BaseData reflect_World_method_getEntityByID_109 = new ModData();
        reflect_World_method_getEntityByID_109.set("methodName", "getEntityByID");
        reflect_World_method_getEntityByID_109.set("returnType", "Entity");
        reflect_World_method_getEntityByID_109.set("static", false);
        reflect_World_method_getEntityByID_109.set("argnames", new String[]{"id"});
        reflect_World_method_getEntityByID_109.set("argtypes", new String[]{"int"});
        reflect_World_method_getEntityByID_109.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Entity) ((World) params.getReflective("_self")).getEntityByID((int) params.getInt("id"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getEntityByID_109);


        BaseData reflect_World_method_markChunkDirty_110 = new ModData();
        reflect_World_method_markChunkDirty_110.set("methodName", "markChunkDirty");
        reflect_World_method_markChunkDirty_110.set("returnType", "void");
        reflect_World_method_markChunkDirty_110.set("static", false);
        reflect_World_method_markChunkDirty_110.set("argnames", new String[]{"pos", "unusedTileEntity"});
        reflect_World_method_markChunkDirty_110.set("argtypes", new String[]{"BlockPos", "TileEntity"});
        reflect_World_method_markChunkDirty_110.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((World) params.getReflective("_self")).markChunkDirty((BlockPos) params.getReflective("pos"), (TileEntity) params.getReflective("unusedTileEntity"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_markChunkDirty_110);


        BaseData reflect_World_method_func_181545_F_111 = new ModData();
        reflect_World_method_func_181545_F_111.set("methodName", "func_181545_F");
        reflect_World_method_func_181545_F_111.set("returnType", "int");
        reflect_World_method_func_181545_F_111.set("static", false);
        reflect_World_method_func_181545_F_111.set("argnames", new String[]{});
        reflect_World_method_func_181545_F_111.set("argtypes", new String[]{});
        reflect_World_method_func_181545_F_111.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((World) params.getReflective("_self")).func_181545_F();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_func_181545_F_111);


        BaseData reflect_World_method_func_181544_b_112 = new ModData();
        reflect_World_method_func_181544_b_112.set("methodName", "func_181544_b");
        reflect_World_method_func_181544_b_112.set("returnType", "void");
        reflect_World_method_func_181544_b_112.set("static", false);
        reflect_World_method_func_181544_b_112.set("argnames", new String[]{"parInt1"});
        reflect_World_method_func_181544_b_112.set("argtypes", new String[]{"int"});
        reflect_World_method_func_181544_b_112.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((World) params.getReflective("_self")).func_181544_b((int) params.getInt("parInt1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_func_181544_b_112);


        BaseData reflect_World_method_getStrongPower_113 = new ModData();
        reflect_World_method_getStrongPower_113.set("methodName", "getStrongPower");
        reflect_World_method_getStrongPower_113.set("returnType", "int");
        reflect_World_method_getStrongPower_113.set("static", false);
        reflect_World_method_getStrongPower_113.set("argnames", new String[]{"pos", "direction"});
        reflect_World_method_getStrongPower_113.set("argtypes", new String[]{"BlockPos", "EnumFacing"});
        reflect_World_method_getStrongPower_113.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((World) params.getReflective("_self")).getStrongPower((BlockPos) params.getReflective("pos"), (EnumFacing) params.getReflective("direction"));
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getStrongPower_113);


        BaseData reflect_World_method_getWorldType_114 = new ModData();
        reflect_World_method_getWorldType_114.set("methodName", "getWorldType");
        reflect_World_method_getWorldType_114.set("returnType", "WorldType");
        reflect_World_method_getWorldType_114.set("static", false);
        reflect_World_method_getWorldType_114.set("argnames", new String[]{});
        reflect_World_method_getWorldType_114.set("argtypes", new String[]{});
        reflect_World_method_getWorldType_114.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (WorldType) ((World) params.getReflective("_self")).getWorldType();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getWorldType_114);


        BaseData reflect_World_method_getStrongPower_115 = new ModData();
        reflect_World_method_getStrongPower_115.set("methodName", "getStrongPower");
        reflect_World_method_getStrongPower_115.set("returnType", "int");
        reflect_World_method_getStrongPower_115.set("static", false);
        reflect_World_method_getStrongPower_115.set("argnames", new String[]{"pos"});
        reflect_World_method_getStrongPower_115.set("argtypes", new String[]{"BlockPos"});
        reflect_World_method_getStrongPower_115.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((World) params.getReflective("_self")).getStrongPower((BlockPos) params.getReflective("pos"));
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getStrongPower_115);


        BaseData reflect_World_method_isSidePowered_116 = new ModData();
        reflect_World_method_isSidePowered_116.set("methodName", "isSidePowered");
        reflect_World_method_isSidePowered_116.set("returnType", "boolean");
        reflect_World_method_isSidePowered_116.set("static", false);
        reflect_World_method_isSidePowered_116.set("argnames", new String[]{"pos", "side"});
        reflect_World_method_isSidePowered_116.set("argtypes", new String[]{"BlockPos", "EnumFacing"});
        reflect_World_method_isSidePowered_116.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((World) params.getReflective("_self")).isSidePowered((BlockPos) params.getReflective("pos"), (EnumFacing) params.getReflective("side"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_isSidePowered_116);


        BaseData reflect_World_method_getRedstonePower_117 = new ModData();
        reflect_World_method_getRedstonePower_117.set("methodName", "getRedstonePower");
        reflect_World_method_getRedstonePower_117.set("returnType", "int");
        reflect_World_method_getRedstonePower_117.set("static", false);
        reflect_World_method_getRedstonePower_117.set("argnames", new String[]{"pos", "facing"});
        reflect_World_method_getRedstonePower_117.set("argtypes", new String[]{"BlockPos", "EnumFacing"});
        reflect_World_method_getRedstonePower_117.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((World) params.getReflective("_self")).getRedstonePower((BlockPos) params.getReflective("pos"), (EnumFacing) params.getReflective("facing"));
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getRedstonePower_117);


        BaseData reflect_World_method_isBlockPowered_118 = new ModData();
        reflect_World_method_isBlockPowered_118.set("methodName", "isBlockPowered");
        reflect_World_method_isBlockPowered_118.set("returnType", "boolean");
        reflect_World_method_isBlockPowered_118.set("static", false);
        reflect_World_method_isBlockPowered_118.set("argnames", new String[]{"pos"});
        reflect_World_method_isBlockPowered_118.set("argtypes", new String[]{"BlockPos"});
        reflect_World_method_isBlockPowered_118.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((World) params.getReflective("_self")).isBlockPowered((BlockPos) params.getReflective("pos"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_isBlockPowered_118);


        BaseData reflect_World_method_isBlockIndirectlyGettingPowered_119 = new ModData();
        reflect_World_method_isBlockIndirectlyGettingPowered_119.set("methodName", "isBlockIndirectlyGettingPowered");
        reflect_World_method_isBlockIndirectlyGettingPowered_119.set("returnType", "int");
        reflect_World_method_isBlockIndirectlyGettingPowered_119.set("static", false);
        reflect_World_method_isBlockIndirectlyGettingPowered_119.set("argnames", new String[]{"pos"});
        reflect_World_method_isBlockIndirectlyGettingPowered_119.set("argtypes", new String[]{"BlockPos"});
        reflect_World_method_isBlockIndirectlyGettingPowered_119.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((World) params.getReflective("_self")).isBlockIndirectlyGettingPowered((BlockPos) params.getReflective("pos"));
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_isBlockIndirectlyGettingPowered_119);


        BaseData reflect_World_method_getClosestPlayerToEntity_120 = new ModData();
        reflect_World_method_getClosestPlayerToEntity_120.set("methodName", "getClosestPlayerToEntity");
        reflect_World_method_getClosestPlayerToEntity_120.set("returnType", "EntityPlayer");
        reflect_World_method_getClosestPlayerToEntity_120.set("static", false);
        reflect_World_method_getClosestPlayerToEntity_120.set("argnames", new String[]{"entityIn", "distance"});
        reflect_World_method_getClosestPlayerToEntity_120.set("argtypes", new String[]{"Entity", "double"});
        reflect_World_method_getClosestPlayerToEntity_120.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EntityPlayer) ((World) params.getReflective("_self")).getClosestPlayerToEntity((Entity) params.getReflective("entityIn"), (double) params.getDouble("distance"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getClosestPlayerToEntity_120);


        BaseData reflect_World_method_getClosestPlayer_121 = new ModData();
        reflect_World_method_getClosestPlayer_121.set("methodName", "getClosestPlayer");
        reflect_World_method_getClosestPlayer_121.set("returnType", "EntityPlayer");
        reflect_World_method_getClosestPlayer_121.set("static", false);
        reflect_World_method_getClosestPlayer_121.set("argnames", new String[]{"x", "y", "z", "distance"});
        reflect_World_method_getClosestPlayer_121.set("argtypes", new String[]{"double", "double", "double", "double"});
        reflect_World_method_getClosestPlayer_121.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EntityPlayer) ((World) params.getReflective("_self")).getClosestPlayer((double) params.getDouble("x"), (double) params.getDouble("y"), (double) params.getDouble("z"), (double) params.getDouble("distance"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getClosestPlayer_121);


        BaseData reflect_World_method_isAnyPlayerWithinRangeAt_122 = new ModData();
        reflect_World_method_isAnyPlayerWithinRangeAt_122.set("methodName", "isAnyPlayerWithinRangeAt");
        reflect_World_method_isAnyPlayerWithinRangeAt_122.set("returnType", "boolean");
        reflect_World_method_isAnyPlayerWithinRangeAt_122.set("static", false);
        reflect_World_method_isAnyPlayerWithinRangeAt_122.set("argnames", new String[]{"x", "y", "z", "range"});
        reflect_World_method_isAnyPlayerWithinRangeAt_122.set("argtypes", new String[]{"double", "double", "double", "double"});
        reflect_World_method_isAnyPlayerWithinRangeAt_122.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((World) params.getReflective("_self")).isAnyPlayerWithinRangeAt((double) params.getDouble("x"), (double) params.getDouble("y"), (double) params.getDouble("z"), (double) params.getDouble("range"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_isAnyPlayerWithinRangeAt_122);


        BaseData reflect_World_method_getPlayerEntityByName_123 = new ModData();
        reflect_World_method_getPlayerEntityByName_123.set("methodName", "getPlayerEntityByName");
        reflect_World_method_getPlayerEntityByName_123.set("returnType", "EntityPlayer");
        reflect_World_method_getPlayerEntityByName_123.set("static", false);
        reflect_World_method_getPlayerEntityByName_123.set("argnames", new String[]{"name"});
        reflect_World_method_getPlayerEntityByName_123.set("argtypes", new String[]{"String"});
        reflect_World_method_getPlayerEntityByName_123.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EntityPlayer) ((World) params.getReflective("_self")).getPlayerEntityByName((String) params.getString("name"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getPlayerEntityByName_123);


        BaseData reflect_World_method_getPlayerEntityByUUID_124 = new ModData();
        reflect_World_method_getPlayerEntityByUUID_124.set("methodName", "getPlayerEntityByUUID");
        reflect_World_method_getPlayerEntityByUUID_124.set("returnType", "EntityPlayer");
        reflect_World_method_getPlayerEntityByUUID_124.set("static", false);
        reflect_World_method_getPlayerEntityByUUID_124.set("argnames", new String[]{"uuid"});
        reflect_World_method_getPlayerEntityByUUID_124.set("argtypes", new String[]{"EaglercraftUUID"});
        reflect_World_method_getPlayerEntityByUUID_124.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EntityPlayer) ((World) params.getReflective("_self")).getPlayerEntityByUUID((EaglercraftUUID) params.getReflective("uuid"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getPlayerEntityByUUID_124);


        BaseData reflect_World_method_sendQuittingDisconnectingPacket_125 = new ModData();
        reflect_World_method_sendQuittingDisconnectingPacket_125.set("methodName", "sendQuittingDisconnectingPacket");
        reflect_World_method_sendQuittingDisconnectingPacket_125.set("returnType", "void");
        reflect_World_method_sendQuittingDisconnectingPacket_125.set("static", false);
        reflect_World_method_sendQuittingDisconnectingPacket_125.set("argnames", new String[]{});
        reflect_World_method_sendQuittingDisconnectingPacket_125.set("argtypes", new String[]{});
        reflect_World_method_sendQuittingDisconnectingPacket_125.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((World) params.getReflective("_self")).sendQuittingDisconnectingPacket();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_sendQuittingDisconnectingPacket_125);


        BaseData reflect_World_method_checkSessionLock_126 = new ModData();
        reflect_World_method_checkSessionLock_126.set("methodName", "checkSessionLock");
        reflect_World_method_checkSessionLock_126.set("returnType", "void");
        reflect_World_method_checkSessionLock_126.set("static", false);
        reflect_World_method_checkSessionLock_126.set("argnames", new String[]{});
        reflect_World_method_checkSessionLock_126.set("argtypes", new String[]{});
        reflect_World_method_checkSessionLock_126.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((World) params.getReflective("_self")).checkSessionLock();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_checkSessionLock_126);


        BaseData reflect_World_method_setTotalWorldTime_127 = new ModData();
        reflect_World_method_setTotalWorldTime_127.set("methodName", "setTotalWorldTime");
        reflect_World_method_setTotalWorldTime_127.set("returnType", "void");
        reflect_World_method_setTotalWorldTime_127.set("static", false);
        reflect_World_method_setTotalWorldTime_127.set("argnames", new String[]{"worldTime"});
        reflect_World_method_setTotalWorldTime_127.set("argtypes", new String[]{"long"});
        reflect_World_method_setTotalWorldTime_127.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((World) params.getReflective("_self")).setTotalWorldTime((long) params.getReflective("worldTime"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_setTotalWorldTime_127);


        BaseData reflect_World_method_getSeed_128 = new ModData();
        reflect_World_method_getSeed_128.set("methodName", "getSeed");
        reflect_World_method_getSeed_128.set("returnType", "long");
        reflect_World_method_getSeed_128.set("static", false);
        reflect_World_method_getSeed_128.set("argnames", new String[]{});
        reflect_World_method_getSeed_128.set("argtypes", new String[]{});
        reflect_World_method_getSeed_128.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (long) ((World) params.getReflective("_self")).getSeed();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getSeed_128);


        BaseData reflect_World_method_getTotalWorldTime_129 = new ModData();
        reflect_World_method_getTotalWorldTime_129.set("methodName", "getTotalWorldTime");
        reflect_World_method_getTotalWorldTime_129.set("returnType", "long");
        reflect_World_method_getTotalWorldTime_129.set("static", false);
        reflect_World_method_getTotalWorldTime_129.set("argnames", new String[]{});
        reflect_World_method_getTotalWorldTime_129.set("argtypes", new String[]{});
        reflect_World_method_getTotalWorldTime_129.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (long) ((World) params.getReflective("_self")).getTotalWorldTime();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getTotalWorldTime_129);


        BaseData reflect_World_method_getWorldTime_130 = new ModData();
        reflect_World_method_getWorldTime_130.set("methodName", "getWorldTime");
        reflect_World_method_getWorldTime_130.set("returnType", "long");
        reflect_World_method_getWorldTime_130.set("static", false);
        reflect_World_method_getWorldTime_130.set("argnames", new String[]{});
        reflect_World_method_getWorldTime_130.set("argtypes", new String[]{});
        reflect_World_method_getWorldTime_130.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (long) ((World) params.getReflective("_self")).getWorldTime();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getWorldTime_130);


        BaseData reflect_World_method_setWorldTime_131 = new ModData();
        reflect_World_method_setWorldTime_131.set("methodName", "setWorldTime");
        reflect_World_method_setWorldTime_131.set("returnType", "void");
        reflect_World_method_setWorldTime_131.set("static", false);
        reflect_World_method_setWorldTime_131.set("argnames", new String[]{"time"});
        reflect_World_method_setWorldTime_131.set("argtypes", new String[]{"long"});
        reflect_World_method_setWorldTime_131.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((World) params.getReflective("_self")).setWorldTime((long) params.getReflective("time"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_setWorldTime_131);


        BaseData reflect_World_method_getSpawnPoint_132 = new ModData();
        reflect_World_method_getSpawnPoint_132.set("methodName", "getSpawnPoint");
        reflect_World_method_getSpawnPoint_132.set("returnType", "BlockPos");
        reflect_World_method_getSpawnPoint_132.set("static", false);
        reflect_World_method_getSpawnPoint_132.set("argnames", new String[]{});
        reflect_World_method_getSpawnPoint_132.set("argtypes", new String[]{});
        reflect_World_method_getSpawnPoint_132.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (BlockPos) ((World) params.getReflective("_self")).getSpawnPoint();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getSpawnPoint_132);


        BaseData reflect_World_method_setSpawnPoint_133 = new ModData();
        reflect_World_method_setSpawnPoint_133.set("methodName", "setSpawnPoint");
        reflect_World_method_setSpawnPoint_133.set("returnType", "void");
        reflect_World_method_setSpawnPoint_133.set("static", false);
        reflect_World_method_setSpawnPoint_133.set("argnames", new String[]{"pos"});
        reflect_World_method_setSpawnPoint_133.set("argtypes", new String[]{"BlockPos"});
        reflect_World_method_setSpawnPoint_133.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((World) params.getReflective("_self")).setSpawnPoint((BlockPos) params.getReflective("pos"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_setSpawnPoint_133);


        BaseData reflect_World_method_joinEntityInSurroundings_134 = new ModData();
        reflect_World_method_joinEntityInSurroundings_134.set("methodName", "joinEntityInSurroundings");
        reflect_World_method_joinEntityInSurroundings_134.set("returnType", "void");
        reflect_World_method_joinEntityInSurroundings_134.set("static", false);
        reflect_World_method_joinEntityInSurroundings_134.set("argnames", new String[]{"entityIn"});
        reflect_World_method_joinEntityInSurroundings_134.set("argtypes", new String[]{"Entity"});
        reflect_World_method_joinEntityInSurroundings_134.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((World) params.getReflective("_self")).joinEntityInSurroundings((Entity) params.getReflective("entityIn"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_joinEntityInSurroundings_134);


        BaseData reflect_World_method_isBlockModifiable_135 = new ModData();
        reflect_World_method_isBlockModifiable_135.set("methodName", "isBlockModifiable");
        reflect_World_method_isBlockModifiable_135.set("returnType", "boolean");
        reflect_World_method_isBlockModifiable_135.set("static", false);
        reflect_World_method_isBlockModifiable_135.set("argnames", new String[]{"player", "pos"});
        reflect_World_method_isBlockModifiable_135.set("argtypes", new String[]{"EntityPlayer", "BlockPos"});
        reflect_World_method_isBlockModifiable_135.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((World) params.getReflective("_self")).isBlockModifiable((EntityPlayer) params.getReflective("player"), (BlockPos) params.getReflective("pos"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_isBlockModifiable_135);


        BaseData reflect_World_method_setEntityState_136 = new ModData();
        reflect_World_method_setEntityState_136.set("methodName", "setEntityState");
        reflect_World_method_setEntityState_136.set("returnType", "void");
        reflect_World_method_setEntityState_136.set("static", false);
        reflect_World_method_setEntityState_136.set("argnames", new String[]{"entityIn", "state"});
        reflect_World_method_setEntityState_136.set("argtypes", new String[]{"Entity", "byte"});
        reflect_World_method_setEntityState_136.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((World) params.getReflective("_self")).setEntityState((Entity) params.getReflective("entityIn"), (byte) params.getByte("state"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_setEntityState_136);


        BaseData reflect_World_method_getChunkProvider_137 = new ModData();
        reflect_World_method_getChunkProvider_137.set("methodName", "getChunkProvider");
        reflect_World_method_getChunkProvider_137.set("returnType", "IChunkProvider");
        reflect_World_method_getChunkProvider_137.set("static", false);
        reflect_World_method_getChunkProvider_137.set("argnames", new String[]{});
        reflect_World_method_getChunkProvider_137.set("argtypes", new String[]{});
        reflect_World_method_getChunkProvider_137.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (IChunkProvider) ((World) params.getReflective("_self")).getChunkProvider();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getChunkProvider_137);


        BaseData reflect_World_method_addBlockEvent_138 = new ModData();
        reflect_World_method_addBlockEvent_138.set("methodName", "addBlockEvent");
        reflect_World_method_addBlockEvent_138.set("returnType", "void");
        reflect_World_method_addBlockEvent_138.set("static", false);
        reflect_World_method_addBlockEvent_138.set("argnames", new String[]{"pos", "blockIn", "eventID", "eventParam"});
        reflect_World_method_addBlockEvent_138.set("argtypes", new String[]{"BlockPos", "Block", "int", "int"});
        reflect_World_method_addBlockEvent_138.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((World) params.getReflective("_self")).addBlockEvent((BlockPos) params.getReflective("pos"), (Block) params.getReflective("blockIn"), (int) params.getInt("eventID"), (int) params.getInt("eventParam"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_addBlockEvent_138);


        BaseData reflect_World_method_getSaveHandler_139 = new ModData();
        reflect_World_method_getSaveHandler_139.set("methodName", "getSaveHandler");
        reflect_World_method_getSaveHandler_139.set("returnType", "ISaveHandler");
        reflect_World_method_getSaveHandler_139.set("static", false);
        reflect_World_method_getSaveHandler_139.set("argnames", new String[]{});
        reflect_World_method_getSaveHandler_139.set("argtypes", new String[]{});
        reflect_World_method_getSaveHandler_139.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (ISaveHandler) ((World) params.getReflective("_self")).getSaveHandler();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getSaveHandler_139);


        BaseData reflect_World_method_getWorldInfo_140 = new ModData();
        reflect_World_method_getWorldInfo_140.set("methodName", "getWorldInfo");
        reflect_World_method_getWorldInfo_140.set("returnType", "WorldInfo");
        reflect_World_method_getWorldInfo_140.set("static", false);
        reflect_World_method_getWorldInfo_140.set("argnames", new String[]{});
        reflect_World_method_getWorldInfo_140.set("argtypes", new String[]{});
        reflect_World_method_getWorldInfo_140.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (WorldInfo) ((World) params.getReflective("_self")).getWorldInfo();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getWorldInfo_140);


        BaseData reflect_World_method_getGameRules_141 = new ModData();
        reflect_World_method_getGameRules_141.set("methodName", "getGameRules");
        reflect_World_method_getGameRules_141.set("returnType", "GameRules");
        reflect_World_method_getGameRules_141.set("static", false);
        reflect_World_method_getGameRules_141.set("argnames", new String[]{});
        reflect_World_method_getGameRules_141.set("argtypes", new String[]{});
        reflect_World_method_getGameRules_141.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (GameRules) ((World) params.getReflective("_self")).getGameRules();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getGameRules_141);


        BaseData reflect_World_method_updateAllPlayersSleepingFlag_142 = new ModData();
        reflect_World_method_updateAllPlayersSleepingFlag_142.set("methodName", "updateAllPlayersSleepingFlag");
        reflect_World_method_updateAllPlayersSleepingFlag_142.set("returnType", "void");
        reflect_World_method_updateAllPlayersSleepingFlag_142.set("static", false);
        reflect_World_method_updateAllPlayersSleepingFlag_142.set("argnames", new String[]{});
        reflect_World_method_updateAllPlayersSleepingFlag_142.set("argtypes", new String[]{});
        reflect_World_method_updateAllPlayersSleepingFlag_142.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((World) params.getReflective("_self")).updateAllPlayersSleepingFlag();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_updateAllPlayersSleepingFlag_142);


        BaseData reflect_World_method_getThunderStrength_143 = new ModData();
        reflect_World_method_getThunderStrength_143.set("methodName", "getThunderStrength");
        reflect_World_method_getThunderStrength_143.set("returnType", "float");
        reflect_World_method_getThunderStrength_143.set("static", false);
        reflect_World_method_getThunderStrength_143.set("argnames", new String[]{"delta"});
        reflect_World_method_getThunderStrength_143.set("argtypes", new String[]{"float"});
        reflect_World_method_getThunderStrength_143.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((World) params.getReflective("_self")).getThunderStrength((float) params.getFloat("delta"));
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getThunderStrength_143);


        BaseData reflect_World_method_setThunderStrength_144 = new ModData();
        reflect_World_method_setThunderStrength_144.set("methodName", "setThunderStrength");
        reflect_World_method_setThunderStrength_144.set("returnType", "void");
        reflect_World_method_setThunderStrength_144.set("static", false);
        reflect_World_method_setThunderStrength_144.set("argnames", new String[]{"strength"});
        reflect_World_method_setThunderStrength_144.set("argtypes", new String[]{"float"});
        reflect_World_method_setThunderStrength_144.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((World) params.getReflective("_self")).setThunderStrength((float) params.getFloat("strength"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_setThunderStrength_144);


        BaseData reflect_World_method_getRainStrength_145 = new ModData();
        reflect_World_method_getRainStrength_145.set("methodName", "getRainStrength");
        reflect_World_method_getRainStrength_145.set("returnType", "float");
        reflect_World_method_getRainStrength_145.set("static", false);
        reflect_World_method_getRainStrength_145.set("argnames", new String[]{"delta"});
        reflect_World_method_getRainStrength_145.set("argtypes", new String[]{"float"});
        reflect_World_method_getRainStrength_145.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((World) params.getReflective("_self")).getRainStrength((float) params.getFloat("delta"));
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getRainStrength_145);


        BaseData reflect_World_method_setRainStrength_146 = new ModData();
        reflect_World_method_setRainStrength_146.set("methodName", "setRainStrength");
        reflect_World_method_setRainStrength_146.set("returnType", "void");
        reflect_World_method_setRainStrength_146.set("static", false);
        reflect_World_method_setRainStrength_146.set("argnames", new String[]{"strength"});
        reflect_World_method_setRainStrength_146.set("argtypes", new String[]{"float"});
        reflect_World_method_setRainStrength_146.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((World) params.getReflective("_self")).setRainStrength((float) params.getFloat("strength"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_setRainStrength_146);


        BaseData reflect_World_method_isThundering_147 = new ModData();
        reflect_World_method_isThundering_147.set("methodName", "isThundering");
        reflect_World_method_isThundering_147.set("returnType", "boolean");
        reflect_World_method_isThundering_147.set("static", false);
        reflect_World_method_isThundering_147.set("argnames", new String[]{});
        reflect_World_method_isThundering_147.set("argtypes", new String[]{});
        reflect_World_method_isThundering_147.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((World) params.getReflective("_self")).isThundering();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_isThundering_147);


        BaseData reflect_World_method_isRaining_148 = new ModData();
        reflect_World_method_isRaining_148.set("methodName", "isRaining");
        reflect_World_method_isRaining_148.set("returnType", "boolean");
        reflect_World_method_isRaining_148.set("static", false);
        reflect_World_method_isRaining_148.set("argnames", new String[]{});
        reflect_World_method_isRaining_148.set("argtypes", new String[]{});
        reflect_World_method_isRaining_148.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((World) params.getReflective("_self")).isRaining();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_isRaining_148);


        BaseData reflect_World_method_canLightningStrike_149 = new ModData();
        reflect_World_method_canLightningStrike_149.set("methodName", "canLightningStrike");
        reflect_World_method_canLightningStrike_149.set("returnType", "boolean");
        reflect_World_method_canLightningStrike_149.set("static", false);
        reflect_World_method_canLightningStrike_149.set("argnames", new String[]{"strikePosition"});
        reflect_World_method_canLightningStrike_149.set("argtypes", new String[]{"BlockPos"});
        reflect_World_method_canLightningStrike_149.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((World) params.getReflective("_self")).canLightningStrike((BlockPos) params.getReflective("strikePosition"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_canLightningStrike_149);


        BaseData reflect_World_method_isBlockinHighHumidity_150 = new ModData();
        reflect_World_method_isBlockinHighHumidity_150.set("methodName", "isBlockinHighHumidity");
        reflect_World_method_isBlockinHighHumidity_150.set("returnType", "boolean");
        reflect_World_method_isBlockinHighHumidity_150.set("static", false);
        reflect_World_method_isBlockinHighHumidity_150.set("argnames", new String[]{"pos"});
        reflect_World_method_isBlockinHighHumidity_150.set("argtypes", new String[]{"BlockPos"});
        reflect_World_method_isBlockinHighHumidity_150.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((World) params.getReflective("_self")).isBlockinHighHumidity((BlockPos) params.getReflective("pos"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_isBlockinHighHumidity_150);


        BaseData reflect_World_method_getMapStorage_151 = new ModData();
        reflect_World_method_getMapStorage_151.set("methodName", "getMapStorage");
        reflect_World_method_getMapStorage_151.set("returnType", "MapStorage");
        reflect_World_method_getMapStorage_151.set("static", false);
        reflect_World_method_getMapStorage_151.set("argnames", new String[]{});
        reflect_World_method_getMapStorage_151.set("argtypes", new String[]{});
        reflect_World_method_getMapStorage_151.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (MapStorage) ((World) params.getReflective("_self")).getMapStorage();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getMapStorage_151);


        BaseData reflect_World_method_setItemData_152 = new ModData();
        reflect_World_method_setItemData_152.set("methodName", "setItemData");
        reflect_World_method_setItemData_152.set("returnType", "void");
        reflect_World_method_setItemData_152.set("static", false);
        reflect_World_method_setItemData_152.set("argnames", new String[]{"dataID", "worldSavedDataIn"});
        reflect_World_method_setItemData_152.set("argtypes", new String[]{"String", "WorldSavedData"});
        reflect_World_method_setItemData_152.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((World) params.getReflective("_self")).setItemData((String) params.getString("dataID"), (WorldSavedData) params.getReflective("worldSavedDataIn"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_setItemData_152);


        BaseData reflect_World_method_getUniqueDataId_153 = new ModData();
        reflect_World_method_getUniqueDataId_153.set("methodName", "getUniqueDataId");
        reflect_World_method_getUniqueDataId_153.set("returnType", "int");
        reflect_World_method_getUniqueDataId_153.set("static", false);
        reflect_World_method_getUniqueDataId_153.set("argnames", new String[]{"key"});
        reflect_World_method_getUniqueDataId_153.set("argtypes", new String[]{"String"});
        reflect_World_method_getUniqueDataId_153.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((World) params.getReflective("_self")).getUniqueDataId((String) params.getString("key"));
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getUniqueDataId_153);


        BaseData reflect_World_method_playBroadcastSound_154 = new ModData();
        reflect_World_method_playBroadcastSound_154.set("methodName", "playBroadcastSound");
        reflect_World_method_playBroadcastSound_154.set("returnType", "void");
        reflect_World_method_playBroadcastSound_154.set("static", false);
        reflect_World_method_playBroadcastSound_154.set("argnames", new String[]{"pos", "parBlockPos", "parInt2"});
        reflect_World_method_playBroadcastSound_154.set("argtypes", new String[]{"int", "BlockPos", "int"});
        reflect_World_method_playBroadcastSound_154.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((World) params.getReflective("_self")).playBroadcastSound((int) params.getInt("pos"), (BlockPos) params.getReflective("parBlockPos"), (int) params.getInt("parInt2"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_playBroadcastSound_154);


        BaseData reflect_World_method_playAuxSFX_155 = new ModData();
        reflect_World_method_playAuxSFX_155.set("methodName", "playAuxSFX");
        reflect_World_method_playAuxSFX_155.set("returnType", "void");
        reflect_World_method_playAuxSFX_155.set("static", false);
        reflect_World_method_playAuxSFX_155.set("argnames", new String[]{"pos", "parBlockPos", "parInt2"});
        reflect_World_method_playAuxSFX_155.set("argtypes", new String[]{"int", "BlockPos", "int"});
        reflect_World_method_playAuxSFX_155.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((World) params.getReflective("_self")).playAuxSFX((int) params.getInt("pos"), (BlockPos) params.getReflective("parBlockPos"), (int) params.getInt("parInt2"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_playAuxSFX_155);


        BaseData reflect_World_method_playAuxSFXAtEntity_156 = new ModData();
        reflect_World_method_playAuxSFXAtEntity_156.set("methodName", "playAuxSFXAtEntity");
        reflect_World_method_playAuxSFXAtEntity_156.set("returnType", "void");
        reflect_World_method_playAuxSFXAtEntity_156.set("static", false);
        reflect_World_method_playAuxSFXAtEntity_156.set("argnames", new String[]{"player", "sfxType", "pos", "parInt2"});
        reflect_World_method_playAuxSFXAtEntity_156.set("argtypes", new String[]{"EntityPlayer", "int", "BlockPos", "int"});
        reflect_World_method_playAuxSFXAtEntity_156.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((World) params.getReflective("_self")).playAuxSFXAtEntity((EntityPlayer) params.getReflective("player"), (int) params.getInt("sfxType"), (BlockPos) params.getReflective("pos"), (int) params.getInt("parInt2"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_playAuxSFXAtEntity_156);


        BaseData reflect_World_method_getHeight_157 = new ModData();
        reflect_World_method_getHeight_157.set("methodName", "getHeight");
        reflect_World_method_getHeight_157.set("returnType", "int");
        reflect_World_method_getHeight_157.set("static", false);
        reflect_World_method_getHeight_157.set("argnames", new String[]{});
        reflect_World_method_getHeight_157.set("argtypes", new String[]{});
        reflect_World_method_getHeight_157.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((World) params.getReflective("_self")).getHeight();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getHeight_157);


        BaseData reflect_World_method_getActualHeight_158 = new ModData();
        reflect_World_method_getActualHeight_158.set("methodName", "getActualHeight");
        reflect_World_method_getActualHeight_158.set("returnType", "int");
        reflect_World_method_getActualHeight_158.set("static", false);
        reflect_World_method_getActualHeight_158.set("argnames", new String[]{});
        reflect_World_method_getActualHeight_158.set("argtypes", new String[]{});
        reflect_World_method_getActualHeight_158.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((World) params.getReflective("_self")).getActualHeight();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getActualHeight_158);


        BaseData reflect_World_method_setRandomSeed_159 = new ModData();
        reflect_World_method_setRandomSeed_159.set("methodName", "setRandomSeed");
        reflect_World_method_setRandomSeed_159.set("returnType", "EaglercraftRandom");
        reflect_World_method_setRandomSeed_159.set("static", false);
        reflect_World_method_setRandomSeed_159.set("argnames", new String[]{"parInt1", "parInt2", "parInt3"});
        reflect_World_method_setRandomSeed_159.set("argtypes", new String[]{"int", "int", "int"});
        reflect_World_method_setRandomSeed_159.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EaglercraftRandom) ((World) params.getReflective("_self")).setRandomSeed((int) params.getInt("parInt1"), (int) params.getInt("parInt2"), (int) params.getInt("parInt3"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_setRandomSeed_159);


        BaseData reflect_World_method_getStrongholdPos_160 = new ModData();
        reflect_World_method_getStrongholdPos_160.set("methodName", "getStrongholdPos");
        reflect_World_method_getStrongholdPos_160.set("returnType", "BlockPos");
        reflect_World_method_getStrongholdPos_160.set("static", false);
        reflect_World_method_getStrongholdPos_160.set("argnames", new String[]{"name", "pos"});
        reflect_World_method_getStrongholdPos_160.set("argtypes", new String[]{"String", "BlockPos"});
        reflect_World_method_getStrongholdPos_160.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (BlockPos) ((World) params.getReflective("_self")).getStrongholdPos((String) params.getString("name"), (BlockPos) params.getReflective("pos"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getStrongholdPos_160);


        BaseData reflect_World_method_extendedLevelsInChunkCache_161 = new ModData();
        reflect_World_method_extendedLevelsInChunkCache_161.set("methodName", "extendedLevelsInChunkCache");
        reflect_World_method_extendedLevelsInChunkCache_161.set("returnType", "boolean");
        reflect_World_method_extendedLevelsInChunkCache_161.set("static", false);
        reflect_World_method_extendedLevelsInChunkCache_161.set("argnames", new String[]{});
        reflect_World_method_extendedLevelsInChunkCache_161.set("argtypes", new String[]{});
        reflect_World_method_extendedLevelsInChunkCache_161.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((World) params.getReflective("_self")).extendedLevelsInChunkCache();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_extendedLevelsInChunkCache_161);


        BaseData reflect_World_method_getHorizon_162 = new ModData();
        reflect_World_method_getHorizon_162.set("methodName", "getHorizon");
        reflect_World_method_getHorizon_162.set("returnType", "double");
        reflect_World_method_getHorizon_162.set("static", false);
        reflect_World_method_getHorizon_162.set("argnames", new String[]{});
        reflect_World_method_getHorizon_162.set("argtypes", new String[]{});
        reflect_World_method_getHorizon_162.setCallbackDoubleWithDataArg("exec", (BaseData params) -> {
                try {
                    return (double) ((World) params.getReflective("_self")).getHorizon();
                } catch (Exception _exception_reflect_) {
                    return 0.0d;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getHorizon_162);


        BaseData reflect_World_method_addWorldInfoToCrashReport_163 = new ModData();
        reflect_World_method_addWorldInfoToCrashReport_163.set("methodName", "addWorldInfoToCrashReport");
        reflect_World_method_addWorldInfoToCrashReport_163.set("returnType", "CrashReportCategory");
        reflect_World_method_addWorldInfoToCrashReport_163.set("static", false);
        reflect_World_method_addWorldInfoToCrashReport_163.set("argnames", new String[]{"report"});
        reflect_World_method_addWorldInfoToCrashReport_163.set("argtypes", new String[]{"CrashReport"});
        reflect_World_method_addWorldInfoToCrashReport_163.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (CrashReportCategory) ((World) params.getReflective("_self")).addWorldInfoToCrashReport((CrashReport) params.getReflective("report"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_addWorldInfoToCrashReport_163);


        BaseData reflect_World_method_sendBlockBreakProgress_164 = new ModData();
        reflect_World_method_sendBlockBreakProgress_164.set("methodName", "sendBlockBreakProgress");
        reflect_World_method_sendBlockBreakProgress_164.set("returnType", "void");
        reflect_World_method_sendBlockBreakProgress_164.set("static", false);
        reflect_World_method_sendBlockBreakProgress_164.set("argnames", new String[]{"breakerId", "pos", "progress"});
        reflect_World_method_sendBlockBreakProgress_164.set("argtypes", new String[]{"int", "BlockPos", "int"});
        reflect_World_method_sendBlockBreakProgress_164.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((World) params.getReflective("_self")).sendBlockBreakProgress((int) params.getInt("breakerId"), (BlockPos) params.getReflective("pos"), (int) params.getInt("progress"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_sendBlockBreakProgress_164);


        BaseData reflect_World_method_getCurrentDate_165 = new ModData();
        reflect_World_method_getCurrentDate_165.set("methodName", "getCurrentDate");
        reflect_World_method_getCurrentDate_165.set("returnType", "Calendar");
        reflect_World_method_getCurrentDate_165.set("static", false);
        reflect_World_method_getCurrentDate_165.set("argnames", new String[]{});
        reflect_World_method_getCurrentDate_165.set("argtypes", new String[]{});
        reflect_World_method_getCurrentDate_165.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Calendar) ((World) params.getReflective("_self")).getCurrentDate();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getCurrentDate_165);


        BaseData reflect_World_method_getScoreboard_166 = new ModData();
        reflect_World_method_getScoreboard_166.set("methodName", "getScoreboard");
        reflect_World_method_getScoreboard_166.set("returnType", "Scoreboard");
        reflect_World_method_getScoreboard_166.set("static", false);
        reflect_World_method_getScoreboard_166.set("argnames", new String[]{});
        reflect_World_method_getScoreboard_166.set("argtypes", new String[]{});
        reflect_World_method_getScoreboard_166.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Scoreboard) ((World) params.getReflective("_self")).getScoreboard();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getScoreboard_166);


        BaseData reflect_World_method_updateComparatorOutputLevel_167 = new ModData();
        reflect_World_method_updateComparatorOutputLevel_167.set("methodName", "updateComparatorOutputLevel");
        reflect_World_method_updateComparatorOutputLevel_167.set("returnType", "void");
        reflect_World_method_updateComparatorOutputLevel_167.set("static", false);
        reflect_World_method_updateComparatorOutputLevel_167.set("argnames", new String[]{"pos", "blockIn"});
        reflect_World_method_updateComparatorOutputLevel_167.set("argtypes", new String[]{"BlockPos", "Block"});
        reflect_World_method_updateComparatorOutputLevel_167.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((World) params.getReflective("_self")).updateComparatorOutputLevel((BlockPos) params.getReflective("pos"), (Block) params.getReflective("blockIn"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_updateComparatorOutputLevel_167);


        BaseData reflect_World_method_getDifficultyForLocation_168 = new ModData();
        reflect_World_method_getDifficultyForLocation_168.set("methodName", "getDifficultyForLocation");
        reflect_World_method_getDifficultyForLocation_168.set("returnType", "DifficultyInstance");
        reflect_World_method_getDifficultyForLocation_168.set("static", false);
        reflect_World_method_getDifficultyForLocation_168.set("argnames", new String[]{"pos"});
        reflect_World_method_getDifficultyForLocation_168.set("argtypes", new String[]{"BlockPos"});
        reflect_World_method_getDifficultyForLocation_168.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (DifficultyInstance) ((World) params.getReflective("_self")).getDifficultyForLocation((BlockPos) params.getReflective("pos"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getDifficultyForLocation_168);


        BaseData reflect_World_method_getDifficulty_169 = new ModData();
        reflect_World_method_getDifficulty_169.set("methodName", "getDifficulty");
        reflect_World_method_getDifficulty_169.set("returnType", "EnumDifficulty");
        reflect_World_method_getDifficulty_169.set("static", false);
        reflect_World_method_getDifficulty_169.set("argnames", new String[]{});
        reflect_World_method_getDifficulty_169.set("argtypes", new String[]{});
        reflect_World_method_getDifficulty_169.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EnumDifficulty) ((World) params.getReflective("_self")).getDifficulty();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getDifficulty_169);


        BaseData reflect_World_method_getSkylightSubtracted_170 = new ModData();
        reflect_World_method_getSkylightSubtracted_170.set("methodName", "getSkylightSubtracted");
        reflect_World_method_getSkylightSubtracted_170.set("returnType", "int");
        reflect_World_method_getSkylightSubtracted_170.set("static", false);
        reflect_World_method_getSkylightSubtracted_170.set("argnames", new String[]{});
        reflect_World_method_getSkylightSubtracted_170.set("argtypes", new String[]{});
        reflect_World_method_getSkylightSubtracted_170.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((World) params.getReflective("_self")).getSkylightSubtracted();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getSkylightSubtracted_170);


        BaseData reflect_World_method_setSkylightSubtracted_171 = new ModData();
        reflect_World_method_setSkylightSubtracted_171.set("methodName", "setSkylightSubtracted");
        reflect_World_method_setSkylightSubtracted_171.set("returnType", "void");
        reflect_World_method_setSkylightSubtracted_171.set("static", false);
        reflect_World_method_setSkylightSubtracted_171.set("argnames", new String[]{"newSkylightSubtracted"});
        reflect_World_method_setSkylightSubtracted_171.set("argtypes", new String[]{"int"});
        reflect_World_method_setSkylightSubtracted_171.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((World) params.getReflective("_self")).setSkylightSubtracted((int) params.getInt("newSkylightSubtracted"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_setSkylightSubtracted_171);


        BaseData reflect_World_method_getLastLightningBolt_172 = new ModData();
        reflect_World_method_getLastLightningBolt_172.set("methodName", "getLastLightningBolt");
        reflect_World_method_getLastLightningBolt_172.set("returnType", "int");
        reflect_World_method_getLastLightningBolt_172.set("static", false);
        reflect_World_method_getLastLightningBolt_172.set("argnames", new String[]{});
        reflect_World_method_getLastLightningBolt_172.set("argtypes", new String[]{});
        reflect_World_method_getLastLightningBolt_172.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((World) params.getReflective("_self")).getLastLightningBolt();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getLastLightningBolt_172);


        BaseData reflect_World_method_setLastLightningBolt_173 = new ModData();
        reflect_World_method_setLastLightningBolt_173.set("methodName", "setLastLightningBolt");
        reflect_World_method_setLastLightningBolt_173.set("returnType", "void");
        reflect_World_method_setLastLightningBolt_173.set("static", false);
        reflect_World_method_setLastLightningBolt_173.set("argnames", new String[]{"lastLightningBoltIn"});
        reflect_World_method_setLastLightningBolt_173.set("argtypes", new String[]{"int"});
        reflect_World_method_setLastLightningBolt_173.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((World) params.getReflective("_self")).setLastLightningBolt((int) params.getInt("lastLightningBoltIn"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_setLastLightningBolt_173);


        BaseData reflect_World_method_isFindingSpawnPoint_174 = new ModData();
        reflect_World_method_isFindingSpawnPoint_174.set("methodName", "isFindingSpawnPoint");
        reflect_World_method_isFindingSpawnPoint_174.set("returnType", "boolean");
        reflect_World_method_isFindingSpawnPoint_174.set("static", false);
        reflect_World_method_isFindingSpawnPoint_174.set("argnames", new String[]{});
        reflect_World_method_isFindingSpawnPoint_174.set("argtypes", new String[]{});
        reflect_World_method_isFindingSpawnPoint_174.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((World) params.getReflective("_self")).isFindingSpawnPoint();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_isFindingSpawnPoint_174);


        BaseData reflect_World_method_getVillageCollection_175 = new ModData();
        reflect_World_method_getVillageCollection_175.set("methodName", "getVillageCollection");
        reflect_World_method_getVillageCollection_175.set("returnType", "VillageCollection");
        reflect_World_method_getVillageCollection_175.set("static", false);
        reflect_World_method_getVillageCollection_175.set("argnames", new String[]{});
        reflect_World_method_getVillageCollection_175.set("argtypes", new String[]{});
        reflect_World_method_getVillageCollection_175.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (VillageCollection) ((World) params.getReflective("_self")).getVillageCollection();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getVillageCollection_175);


        BaseData reflect_World_method_getWorldBorder_176 = new ModData();
        reflect_World_method_getWorldBorder_176.set("methodName", "getWorldBorder");
        reflect_World_method_getWorldBorder_176.set("returnType", "WorldBorder");
        reflect_World_method_getWorldBorder_176.set("static", false);
        reflect_World_method_getWorldBorder_176.set("argnames", new String[]{});
        reflect_World_method_getWorldBorder_176.set("argtypes", new String[]{});
        reflect_World_method_getWorldBorder_176.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (WorldBorder) ((World) params.getReflective("_self")).getWorldBorder();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_getWorldBorder_176);


        BaseData reflect_World_method_isSpawnChunk_177 = new ModData();
        reflect_World_method_isSpawnChunk_177.set("methodName", "isSpawnChunk");
        reflect_World_method_isSpawnChunk_177.set("returnType", "boolean");
        reflect_World_method_isSpawnChunk_177.set("static", false);
        reflect_World_method_isSpawnChunk_177.set("argnames", new String[]{"x", "z"});
        reflect_World_method_isSpawnChunk_177.set("argtypes", new String[]{"int", "int"});
        reflect_World_method_isSpawnChunk_177.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((World) params.getReflective("_self")).isSpawnChunk((int) params.getInt("x"), (int) params.getInt("z"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_World_methods.add(reflect_World_method_isSpawnChunk_177);


        BaseData[] reflect_World_methods_arr = new BaseData[reflect_World_methods.size()];
        for (int i = 0; i < reflect_World_methods_arr.length; i++) {
            reflect_World_methods_arr[i] = reflect_World_methods.get(i);
        }

        reflect_World.set("constructors", reflect_World_constructors_arr);
        reflect_World.set("methods", reflect_World_methods_arr);
        reflect_World.set("className", "World");
        reflect_World.set("classId", "net.minecraft.world.World");
        reflect_World.set("class", World.class);
        reflect_World.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof World;
        });
        reflectProfiles.add(reflect_World);
    }


    //classdef for WorldServer
    public static void reflect_WorldServer_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_WorldServer = new ModData();

        ArrayList<BaseData> reflect_WorldServer_constructors = new ArrayList<BaseData>();
        
        BaseData[] reflect_WorldServer_constructors_arr = new BaseData[reflect_WorldServer_constructors.size()];
        for (int i = 0; i < reflect_WorldServer_constructors_arr.length; i++) {
            reflect_WorldServer_constructors_arr[i] = reflect_WorldServer_constructors.get(i);
        }

        ArrayList<BaseData> reflect_WorldServer_methods = new ArrayList<BaseData>();
        
        BaseData reflect_WorldServer_method_init_0 = new ModData();
        reflect_WorldServer_method_init_0.set("methodName", "init");
        reflect_WorldServer_method_init_0.set("returnType", "World");
        reflect_WorldServer_method_init_0.set("static", false);
        reflect_WorldServer_method_init_0.set("argnames", new String[]{});
        reflect_WorldServer_method_init_0.set("argtypes", new String[]{});
        reflect_WorldServer_method_init_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (World) ((WorldServer) params.getReflective("_self")).init();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_WorldServer_methods.add(reflect_WorldServer_method_init_0);


        BaseData reflect_WorldServer_method_tick_1 = new ModData();
        reflect_WorldServer_method_tick_1.set("methodName", "tick");
        reflect_WorldServer_method_tick_1.set("returnType", "void");
        reflect_WorldServer_method_tick_1.set("static", false);
        reflect_WorldServer_method_tick_1.set("argnames", new String[]{});
        reflect_WorldServer_method_tick_1.set("argtypes", new String[]{});
        reflect_WorldServer_method_tick_1.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((WorldServer) params.getReflective("_self")).tick();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_WorldServer_methods.add(reflect_WorldServer_method_tick_1);


        BaseData reflect_WorldServer_method_updateAllPlayersSleepingFlag_2 = new ModData();
        reflect_WorldServer_method_updateAllPlayersSleepingFlag_2.set("methodName", "updateAllPlayersSleepingFlag");
        reflect_WorldServer_method_updateAllPlayersSleepingFlag_2.set("returnType", "void");
        reflect_WorldServer_method_updateAllPlayersSleepingFlag_2.set("static", false);
        reflect_WorldServer_method_updateAllPlayersSleepingFlag_2.set("argnames", new String[]{});
        reflect_WorldServer_method_updateAllPlayersSleepingFlag_2.set("argtypes", new String[]{});
        reflect_WorldServer_method_updateAllPlayersSleepingFlag_2.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((WorldServer) params.getReflective("_self")).updateAllPlayersSleepingFlag();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_WorldServer_methods.add(reflect_WorldServer_method_updateAllPlayersSleepingFlag_2);


        BaseData reflect_WorldServer_method_areAllPlayersAsleep_3 = new ModData();
        reflect_WorldServer_method_areAllPlayersAsleep_3.set("methodName", "areAllPlayersAsleep");
        reflect_WorldServer_method_areAllPlayersAsleep_3.set("returnType", "boolean");
        reflect_WorldServer_method_areAllPlayersAsleep_3.set("static", false);
        reflect_WorldServer_method_areAllPlayersAsleep_3.set("argnames", new String[]{});
        reflect_WorldServer_method_areAllPlayersAsleep_3.set("argtypes", new String[]{});
        reflect_WorldServer_method_areAllPlayersAsleep_3.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((WorldServer) params.getReflective("_self")).areAllPlayersAsleep();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_WorldServer_methods.add(reflect_WorldServer_method_areAllPlayersAsleep_3);


        BaseData reflect_WorldServer_method_setInitialSpawnLocation_4 = new ModData();
        reflect_WorldServer_method_setInitialSpawnLocation_4.set("methodName", "setInitialSpawnLocation");
        reflect_WorldServer_method_setInitialSpawnLocation_4.set("returnType", "void");
        reflect_WorldServer_method_setInitialSpawnLocation_4.set("static", false);
        reflect_WorldServer_method_setInitialSpawnLocation_4.set("argnames", new String[]{});
        reflect_WorldServer_method_setInitialSpawnLocation_4.set("argtypes", new String[]{});
        reflect_WorldServer_method_setInitialSpawnLocation_4.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((WorldServer) params.getReflective("_self")).setInitialSpawnLocation();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_WorldServer_methods.add(reflect_WorldServer_method_setInitialSpawnLocation_4);


        BaseData reflect_WorldServer_method_isBlockTickPending_5 = new ModData();
        reflect_WorldServer_method_isBlockTickPending_5.set("methodName", "isBlockTickPending");
        reflect_WorldServer_method_isBlockTickPending_5.set("returnType", "boolean");
        reflect_WorldServer_method_isBlockTickPending_5.set("static", false);
        reflect_WorldServer_method_isBlockTickPending_5.set("argnames", new String[]{"blockpos", "block"});
        reflect_WorldServer_method_isBlockTickPending_5.set("argtypes", new String[]{"BlockPos", "Block"});
        reflect_WorldServer_method_isBlockTickPending_5.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((WorldServer) params.getReflective("_self")).isBlockTickPending((BlockPos) params.getReflective("blockpos"), (Block) params.getReflective("block"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_WorldServer_methods.add(reflect_WorldServer_method_isBlockTickPending_5);


        BaseData reflect_WorldServer_method_scheduleUpdate_6 = new ModData();
        reflect_WorldServer_method_scheduleUpdate_6.set("methodName", "scheduleUpdate");
        reflect_WorldServer_method_scheduleUpdate_6.set("returnType", "void");
        reflect_WorldServer_method_scheduleUpdate_6.set("static", false);
        reflect_WorldServer_method_scheduleUpdate_6.set("argnames", new String[]{"blockpos", "block", "i"});
        reflect_WorldServer_method_scheduleUpdate_6.set("argtypes", new String[]{"BlockPos", "Block", "int"});
        reflect_WorldServer_method_scheduleUpdate_6.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((WorldServer) params.getReflective("_self")).scheduleUpdate((BlockPos) params.getReflective("blockpos"), (Block) params.getReflective("block"), (int) params.getInt("i"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_WorldServer_methods.add(reflect_WorldServer_method_scheduleUpdate_6);


        BaseData reflect_WorldServer_method_updateBlockTick_7 = new ModData();
        reflect_WorldServer_method_updateBlockTick_7.set("methodName", "updateBlockTick");
        reflect_WorldServer_method_updateBlockTick_7.set("returnType", "void");
        reflect_WorldServer_method_updateBlockTick_7.set("static", false);
        reflect_WorldServer_method_updateBlockTick_7.set("argnames", new String[]{"blockpos", "block", "i", "j"});
        reflect_WorldServer_method_updateBlockTick_7.set("argtypes", new String[]{"BlockPos", "Block", "int", "int"});
        reflect_WorldServer_method_updateBlockTick_7.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((WorldServer) params.getReflective("_self")).updateBlockTick((BlockPos) params.getReflective("blockpos"), (Block) params.getReflective("block"), (int) params.getInt("i"), (int) params.getInt("j"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_WorldServer_methods.add(reflect_WorldServer_method_updateBlockTick_7);


        BaseData reflect_WorldServer_method_scheduleBlockUpdate_8 = new ModData();
        reflect_WorldServer_method_scheduleBlockUpdate_8.set("methodName", "scheduleBlockUpdate");
        reflect_WorldServer_method_scheduleBlockUpdate_8.set("returnType", "void");
        reflect_WorldServer_method_scheduleBlockUpdate_8.set("static", false);
        reflect_WorldServer_method_scheduleBlockUpdate_8.set("argnames", new String[]{"blockpos", "block", "i", "j"});
        reflect_WorldServer_method_scheduleBlockUpdate_8.set("argtypes", new String[]{"BlockPos", "Block", "int", "int"});
        reflect_WorldServer_method_scheduleBlockUpdate_8.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((WorldServer) params.getReflective("_self")).scheduleBlockUpdate((BlockPos) params.getReflective("blockpos"), (Block) params.getReflective("block"), (int) params.getInt("i"), (int) params.getInt("j"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_WorldServer_methods.add(reflect_WorldServer_method_scheduleBlockUpdate_8);


        BaseData reflect_WorldServer_method_updateEntities_9 = new ModData();
        reflect_WorldServer_method_updateEntities_9.set("methodName", "updateEntities");
        reflect_WorldServer_method_updateEntities_9.set("returnType", "void");
        reflect_WorldServer_method_updateEntities_9.set("static", false);
        reflect_WorldServer_method_updateEntities_9.set("argnames", new String[]{});
        reflect_WorldServer_method_updateEntities_9.set("argtypes", new String[]{});
        reflect_WorldServer_method_updateEntities_9.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((WorldServer) params.getReflective("_self")).updateEntities();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_WorldServer_methods.add(reflect_WorldServer_method_updateEntities_9);


        BaseData reflect_WorldServer_method_resetUpdateEntityTick_10 = new ModData();
        reflect_WorldServer_method_resetUpdateEntityTick_10.set("methodName", "resetUpdateEntityTick");
        reflect_WorldServer_method_resetUpdateEntityTick_10.set("returnType", "void");
        reflect_WorldServer_method_resetUpdateEntityTick_10.set("static", false);
        reflect_WorldServer_method_resetUpdateEntityTick_10.set("argnames", new String[]{});
        reflect_WorldServer_method_resetUpdateEntityTick_10.set("argtypes", new String[]{});
        reflect_WorldServer_method_resetUpdateEntityTick_10.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((WorldServer) params.getReflective("_self")).resetUpdateEntityTick();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_WorldServer_methods.add(reflect_WorldServer_method_resetUpdateEntityTick_10);


        BaseData reflect_WorldServer_method_tickUpdates_11 = new ModData();
        reflect_WorldServer_method_tickUpdates_11.set("methodName", "tickUpdates");
        reflect_WorldServer_method_tickUpdates_11.set("returnType", "boolean");
        reflect_WorldServer_method_tickUpdates_11.set("static", false);
        reflect_WorldServer_method_tickUpdates_11.set("argnames", new String[]{"flag"});
        reflect_WorldServer_method_tickUpdates_11.set("argtypes", new String[]{"boolean"});
        reflect_WorldServer_method_tickUpdates_11.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((WorldServer) params.getReflective("_self")).tickUpdates((boolean) params.getBoolean("flag"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_WorldServer_methods.add(reflect_WorldServer_method_tickUpdates_11);


        BaseData reflect_WorldServer_method_updateEntityWithOptionalForce_12 = new ModData();
        reflect_WorldServer_method_updateEntityWithOptionalForce_12.set("methodName", "updateEntityWithOptionalForce");
        reflect_WorldServer_method_updateEntityWithOptionalForce_12.set("returnType", "void");
        reflect_WorldServer_method_updateEntityWithOptionalForce_12.set("static", false);
        reflect_WorldServer_method_updateEntityWithOptionalForce_12.set("argnames", new String[]{"entity", "flag"});
        reflect_WorldServer_method_updateEntityWithOptionalForce_12.set("argtypes", new String[]{"Entity", "boolean"});
        reflect_WorldServer_method_updateEntityWithOptionalForce_12.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((WorldServer) params.getReflective("_self")).updateEntityWithOptionalForce((Entity) params.getReflective("entity"), (boolean) params.getBoolean("flag"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_WorldServer_methods.add(reflect_WorldServer_method_updateEntityWithOptionalForce_12);


        BaseData reflect_WorldServer_method_isBlockModifiable_13 = new ModData();
        reflect_WorldServer_method_isBlockModifiable_13.set("methodName", "isBlockModifiable");
        reflect_WorldServer_method_isBlockModifiable_13.set("returnType", "boolean");
        reflect_WorldServer_method_isBlockModifiable_13.set("static", false);
        reflect_WorldServer_method_isBlockModifiable_13.set("argnames", new String[]{"entityplayer", "blockpos"});
        reflect_WorldServer_method_isBlockModifiable_13.set("argtypes", new String[]{"EntityPlayer", "BlockPos"});
        reflect_WorldServer_method_isBlockModifiable_13.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((WorldServer) params.getReflective("_self")).isBlockModifiable((EntityPlayer) params.getReflective("entityplayer"), (BlockPos) params.getReflective("blockpos"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_WorldServer_methods.add(reflect_WorldServer_method_isBlockModifiable_13);


        BaseData reflect_WorldServer_method_initialize_14 = new ModData();
        reflect_WorldServer_method_initialize_14.set("methodName", "initialize");
        reflect_WorldServer_method_initialize_14.set("returnType", "void");
        reflect_WorldServer_method_initialize_14.set("static", false);
        reflect_WorldServer_method_initialize_14.set("argnames", new String[]{"worldsettings"});
        reflect_WorldServer_method_initialize_14.set("argtypes", new String[]{"WorldSettings"});
        reflect_WorldServer_method_initialize_14.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((WorldServer) params.getReflective("_self")).initialize((WorldSettings) params.getReflective("worldsettings"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_WorldServer_methods.add(reflect_WorldServer_method_initialize_14);


        BaseData reflect_WorldServer_method_getSpawnCoordinate_15 = new ModData();
        reflect_WorldServer_method_getSpawnCoordinate_15.set("methodName", "getSpawnCoordinate");
        reflect_WorldServer_method_getSpawnCoordinate_15.set("returnType", "BlockPos");
        reflect_WorldServer_method_getSpawnCoordinate_15.set("static", false);
        reflect_WorldServer_method_getSpawnCoordinate_15.set("argnames", new String[]{});
        reflect_WorldServer_method_getSpawnCoordinate_15.set("argtypes", new String[]{});
        reflect_WorldServer_method_getSpawnCoordinate_15.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (BlockPos) ((WorldServer) params.getReflective("_self")).getSpawnCoordinate();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_WorldServer_methods.add(reflect_WorldServer_method_getSpawnCoordinate_15);


        BaseData reflect_WorldServer_method_saveAllChunks_16 = new ModData();
        reflect_WorldServer_method_saveAllChunks_16.set("methodName", "saveAllChunks");
        reflect_WorldServer_method_saveAllChunks_16.set("returnType", "void");
        reflect_WorldServer_method_saveAllChunks_16.set("static", false);
        reflect_WorldServer_method_saveAllChunks_16.set("argnames", new String[]{"progressCallback", "parIProgressUpdate"});
        reflect_WorldServer_method_saveAllChunks_16.set("argtypes", new String[]{"boolean", "IProgressUpdate"});
        reflect_WorldServer_method_saveAllChunks_16.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((WorldServer) params.getReflective("_self")).saveAllChunks((boolean) params.getBoolean("progressCallback"), (IProgressUpdate) params.getReflective("parIProgressUpdate"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_WorldServer_methods.add(reflect_WorldServer_method_saveAllChunks_16);


        BaseData reflect_WorldServer_method_saveChunkData_17 = new ModData();
        reflect_WorldServer_method_saveChunkData_17.set("methodName", "saveChunkData");
        reflect_WorldServer_method_saveChunkData_17.set("returnType", "void");
        reflect_WorldServer_method_saveChunkData_17.set("static", false);
        reflect_WorldServer_method_saveChunkData_17.set("argnames", new String[]{});
        reflect_WorldServer_method_saveChunkData_17.set("argtypes", new String[]{});
        reflect_WorldServer_method_saveChunkData_17.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((WorldServer) params.getReflective("_self")).saveChunkData();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_WorldServer_methods.add(reflect_WorldServer_method_saveChunkData_17);


        BaseData reflect_WorldServer_method_addWeatherEffect_18 = new ModData();
        reflect_WorldServer_method_addWeatherEffect_18.set("methodName", "addWeatherEffect");
        reflect_WorldServer_method_addWeatherEffect_18.set("returnType", "boolean");
        reflect_WorldServer_method_addWeatherEffect_18.set("static", false);
        reflect_WorldServer_method_addWeatherEffect_18.set("argnames", new String[]{"entity"});
        reflect_WorldServer_method_addWeatherEffect_18.set("argtypes", new String[]{"Entity"});
        reflect_WorldServer_method_addWeatherEffect_18.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((WorldServer) params.getReflective("_self")).addWeatherEffect((Entity) params.getReflective("entity"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_WorldServer_methods.add(reflect_WorldServer_method_addWeatherEffect_18);


        BaseData reflect_WorldServer_method_setEntityState_19 = new ModData();
        reflect_WorldServer_method_setEntityState_19.set("methodName", "setEntityState");
        reflect_WorldServer_method_setEntityState_19.set("returnType", "void");
        reflect_WorldServer_method_setEntityState_19.set("static", false);
        reflect_WorldServer_method_setEntityState_19.set("argnames", new String[]{"entity", "b0"});
        reflect_WorldServer_method_setEntityState_19.set("argtypes", new String[]{"Entity", "byte"});
        reflect_WorldServer_method_setEntityState_19.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((WorldServer) params.getReflective("_self")).setEntityState((Entity) params.getReflective("entity"), (byte) params.getByte("b0"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_WorldServer_methods.add(reflect_WorldServer_method_setEntityState_19);


        BaseData reflect_WorldServer_method_addBlockEvent_20 = new ModData();
        reflect_WorldServer_method_addBlockEvent_20.set("methodName", "addBlockEvent");
        reflect_WorldServer_method_addBlockEvent_20.set("returnType", "void");
        reflect_WorldServer_method_addBlockEvent_20.set("static", false);
        reflect_WorldServer_method_addBlockEvent_20.set("argnames", new String[]{"blockpos", "block", "i", "j"});
        reflect_WorldServer_method_addBlockEvent_20.set("argtypes", new String[]{"BlockPos", "Block", "int", "int"});
        reflect_WorldServer_method_addBlockEvent_20.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((WorldServer) params.getReflective("_self")).addBlockEvent((BlockPos) params.getReflective("blockpos"), (Block) params.getReflective("block"), (int) params.getInt("i"), (int) params.getInt("j"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_WorldServer_methods.add(reflect_WorldServer_method_addBlockEvent_20);


        BaseData reflect_WorldServer_method_flush_21 = new ModData();
        reflect_WorldServer_method_flush_21.set("methodName", "flush");
        reflect_WorldServer_method_flush_21.set("returnType", "void");
        reflect_WorldServer_method_flush_21.set("static", false);
        reflect_WorldServer_method_flush_21.set("argnames", new String[]{});
        reflect_WorldServer_method_flush_21.set("argtypes", new String[]{});
        reflect_WorldServer_method_flush_21.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((WorldServer) params.getReflective("_self")).flush();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_WorldServer_methods.add(reflect_WorldServer_method_flush_21);


        BaseData reflect_WorldServer_method_getMinecraftServer_22 = new ModData();
        reflect_WorldServer_method_getMinecraftServer_22.set("methodName", "getMinecraftServer");
        reflect_WorldServer_method_getMinecraftServer_22.set("returnType", "MinecraftServer");
        reflect_WorldServer_method_getMinecraftServer_22.set("static", false);
        reflect_WorldServer_method_getMinecraftServer_22.set("argnames", new String[]{});
        reflect_WorldServer_method_getMinecraftServer_22.set("argtypes", new String[]{});
        reflect_WorldServer_method_getMinecraftServer_22.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (MinecraftServer) ((WorldServer) params.getReflective("_self")).getMinecraftServer();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_WorldServer_methods.add(reflect_WorldServer_method_getMinecraftServer_22);


        BaseData reflect_WorldServer_method_getEntityTracker_23 = new ModData();
        reflect_WorldServer_method_getEntityTracker_23.set("methodName", "getEntityTracker");
        reflect_WorldServer_method_getEntityTracker_23.set("returnType", "EntityTracker");
        reflect_WorldServer_method_getEntityTracker_23.set("static", false);
        reflect_WorldServer_method_getEntityTracker_23.set("argnames", new String[]{});
        reflect_WorldServer_method_getEntityTracker_23.set("argtypes", new String[]{});
        reflect_WorldServer_method_getEntityTracker_23.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EntityTracker) ((WorldServer) params.getReflective("_self")).getEntityTracker();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_WorldServer_methods.add(reflect_WorldServer_method_getEntityTracker_23);


        BaseData reflect_WorldServer_method_getPlayerManager_24 = new ModData();
        reflect_WorldServer_method_getPlayerManager_24.set("methodName", "getPlayerManager");
        reflect_WorldServer_method_getPlayerManager_24.set("returnType", "PlayerManager");
        reflect_WorldServer_method_getPlayerManager_24.set("static", false);
        reflect_WorldServer_method_getPlayerManager_24.set("argnames", new String[]{});
        reflect_WorldServer_method_getPlayerManager_24.set("argtypes", new String[]{});
        reflect_WorldServer_method_getPlayerManager_24.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (PlayerManager) ((WorldServer) params.getReflective("_self")).getPlayerManager();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_WorldServer_methods.add(reflect_WorldServer_method_getPlayerManager_24);


        BaseData reflect_WorldServer_method_getDefaultTeleporter_25 = new ModData();
        reflect_WorldServer_method_getDefaultTeleporter_25.set("methodName", "getDefaultTeleporter");
        reflect_WorldServer_method_getDefaultTeleporter_25.set("returnType", "Teleporter");
        reflect_WorldServer_method_getDefaultTeleporter_25.set("static", false);
        reflect_WorldServer_method_getDefaultTeleporter_25.set("argnames", new String[]{});
        reflect_WorldServer_method_getDefaultTeleporter_25.set("argtypes", new String[]{});
        reflect_WorldServer_method_getDefaultTeleporter_25.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Teleporter) ((WorldServer) params.getReflective("_self")).getDefaultTeleporter();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_WorldServer_methods.add(reflect_WorldServer_method_getDefaultTeleporter_25);


        BaseData reflect_WorldServer_method_getEntityFromUuid_26 = new ModData();
        reflect_WorldServer_method_getEntityFromUuid_26.set("methodName", "getEntityFromUuid");
        reflect_WorldServer_method_getEntityFromUuid_26.set("returnType", "Entity");
        reflect_WorldServer_method_getEntityFromUuid_26.set("static", false);
        reflect_WorldServer_method_getEntityFromUuid_26.set("argnames", new String[]{"uuid"});
        reflect_WorldServer_method_getEntityFromUuid_26.set("argtypes", new String[]{"EaglercraftUUID"});
        reflect_WorldServer_method_getEntityFromUuid_26.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Entity) ((WorldServer) params.getReflective("_self")).getEntityFromUuid((EaglercraftUUID) params.getReflective("uuid"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_WorldServer_methods.add(reflect_WorldServer_method_getEntityFromUuid_26);


        BaseData reflect_WorldServer_method_addScheduledTask_27 = new ModData();
        reflect_WorldServer_method_addScheduledTask_27.set("methodName", "addScheduledTask");
        reflect_WorldServer_method_addScheduledTask_27.set("returnType", "void");
        reflect_WorldServer_method_addScheduledTask_27.set("static", false);
        reflect_WorldServer_method_addScheduledTask_27.set("argnames", new String[]{"runnable"});
        reflect_WorldServer_method_addScheduledTask_27.set("argtypes", new String[]{"Runnable"});
        reflect_WorldServer_method_addScheduledTask_27.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((WorldServer) params.getReflective("_self")).addScheduledTask((Runnable) params.getReflective("runnable"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_WorldServer_methods.add(reflect_WorldServer_method_addScheduledTask_27);


        BaseData[] reflect_WorldServer_methods_arr = new BaseData[reflect_WorldServer_methods.size()];
        for (int i = 0; i < reflect_WorldServer_methods_arr.length; i++) {
            reflect_WorldServer_methods_arr[i] = reflect_WorldServer_methods.get(i);
        }

        reflect_WorldServer.set("constructors", reflect_WorldServer_constructors_arr);
        reflect_WorldServer.set("methods", reflect_WorldServer_methods_arr);
        reflect_WorldServer.set("className", "WorldServer");
        reflect_WorldServer.set("classId", "net.minecraft.world.WorldServer");
        reflect_WorldServer.set("class", WorldServer.class);
        reflect_WorldServer.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof WorldServer;
        });
        reflectProfiles.add(reflect_WorldServer);
    }


    //classdef for AxisAlignedBB
    public static void reflect_AxisAlignedBB_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_AxisAlignedBB = new ModData();

        ArrayList<BaseData> reflect_AxisAlignedBB_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_AxisAlignedBB_constructor_AxisAlignedBB_0 = new ModData();
        reflect_AxisAlignedBB_constructor_AxisAlignedBB_0.set("returnType", "AxisAlignedBB");
        reflect_AxisAlignedBB_constructor_AxisAlignedBB_0.set("argnames", new String[]{"x1", "y1", "z1", "x2", "y2", "z2"});
        reflect_AxisAlignedBB_constructor_AxisAlignedBB_0.set("argtypes", new String[]{"double", "double", "double", "double", "double", "double"});
        reflect_AxisAlignedBB_constructor_AxisAlignedBB_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new AxisAlignedBB((double) params.getDouble("x1"), (double) params.getDouble("y1"), (double) params.getDouble("z1"), (double) params.getDouble("x2"), (double) params.getDouble("y2"), (double) params.getDouble("z2"));
        });
        
        reflect_AxisAlignedBB_constructors.add(reflect_AxisAlignedBB_constructor_AxisAlignedBB_0);


        BaseData reflect_AxisAlignedBB_constructor_AxisAlignedBB_1 = new ModData();
        reflect_AxisAlignedBB_constructor_AxisAlignedBB_1.set("returnType", "AxisAlignedBB");
        reflect_AxisAlignedBB_constructor_AxisAlignedBB_1.set("argnames", new String[]{"pos1", "pos2"});
        reflect_AxisAlignedBB_constructor_AxisAlignedBB_1.set("argtypes", new String[]{"BlockPos", "BlockPos"});
        reflect_AxisAlignedBB_constructor_AxisAlignedBB_1.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new AxisAlignedBB((BlockPos) params.getReflective("pos1"), (BlockPos) params.getReflective("pos2"));
        });
        
        reflect_AxisAlignedBB_constructors.add(reflect_AxisAlignedBB_constructor_AxisAlignedBB_1);


        BaseData[] reflect_AxisAlignedBB_constructors_arr = new BaseData[reflect_AxisAlignedBB_constructors.size()];
        for (int i = 0; i < reflect_AxisAlignedBB_constructors_arr.length; i++) {
            reflect_AxisAlignedBB_constructors_arr[i] = reflect_AxisAlignedBB_constructors.get(i);
        }

        ArrayList<BaseData> reflect_AxisAlignedBB_methods = new ArrayList<BaseData>();
        
        BaseData reflect_AxisAlignedBB_method_addCoord_0 = new ModData();
        reflect_AxisAlignedBB_method_addCoord_0.set("methodName", "addCoord");
        reflect_AxisAlignedBB_method_addCoord_0.set("returnType", "AxisAlignedBB");
        reflect_AxisAlignedBB_method_addCoord_0.set("static", false);
        reflect_AxisAlignedBB_method_addCoord_0.set("argnames", new String[]{"x", "y", "z"});
        reflect_AxisAlignedBB_method_addCoord_0.set("argtypes", new String[]{"double", "double", "double"});
        reflect_AxisAlignedBB_method_addCoord_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (AxisAlignedBB) ((AxisAlignedBB) params.getReflective("_self")).addCoord((double) params.getDouble("x"), (double) params.getDouble("y"), (double) params.getDouble("z"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_AxisAlignedBB_methods.add(reflect_AxisAlignedBB_method_addCoord_0);


        BaseData reflect_AxisAlignedBB_method_expand_1 = new ModData();
        reflect_AxisAlignedBB_method_expand_1.set("methodName", "expand");
        reflect_AxisAlignedBB_method_expand_1.set("returnType", "AxisAlignedBB");
        reflect_AxisAlignedBB_method_expand_1.set("static", false);
        reflect_AxisAlignedBB_method_expand_1.set("argnames", new String[]{"x", "y", "z"});
        reflect_AxisAlignedBB_method_expand_1.set("argtypes", new String[]{"double", "double", "double"});
        reflect_AxisAlignedBB_method_expand_1.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (AxisAlignedBB) ((AxisAlignedBB) params.getReflective("_self")).expand((double) params.getDouble("x"), (double) params.getDouble("y"), (double) params.getDouble("z"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_AxisAlignedBB_methods.add(reflect_AxisAlignedBB_method_expand_1);


        BaseData reflect_AxisAlignedBB_method_union_2 = new ModData();
        reflect_AxisAlignedBB_method_union_2.set("methodName", "union");
        reflect_AxisAlignedBB_method_union_2.set("returnType", "AxisAlignedBB");
        reflect_AxisAlignedBB_method_union_2.set("static", false);
        reflect_AxisAlignedBB_method_union_2.set("argnames", new String[]{"other"});
        reflect_AxisAlignedBB_method_union_2.set("argtypes", new String[]{"AxisAlignedBB"});
        reflect_AxisAlignedBB_method_union_2.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (AxisAlignedBB) ((AxisAlignedBB) params.getReflective("_self")).union((AxisAlignedBB) params.getReflective("other"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_AxisAlignedBB_methods.add(reflect_AxisAlignedBB_method_union_2);


        BaseData reflect_AxisAlignedBB_method_fromBounds_3 = new ModData();
        reflect_AxisAlignedBB_method_fromBounds_3.set("methodName", "fromBounds");
        reflect_AxisAlignedBB_method_fromBounds_3.set("returnType", "AxisAlignedBB");
        reflect_AxisAlignedBB_method_fromBounds_3.set("static", true);
        reflect_AxisAlignedBB_method_fromBounds_3.set("argnames", new String[]{"x1", "y1", "z1", "x2", "y2", "z2"});
        reflect_AxisAlignedBB_method_fromBounds_3.set("argtypes", new String[]{"double", "double", "double", "double", "double", "double"});
        reflect_AxisAlignedBB_method_fromBounds_3.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (AxisAlignedBB) AxisAlignedBB.fromBounds((double) params.getDouble("x1"), (double) params.getDouble("y1"), (double) params.getDouble("z1"), (double) params.getDouble("x2"), (double) params.getDouble("y2"), (double) params.getDouble("z2"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_AxisAlignedBB_methods.add(reflect_AxisAlignedBB_method_fromBounds_3);


        BaseData reflect_AxisAlignedBB_method_offset_4 = new ModData();
        reflect_AxisAlignedBB_method_offset_4.set("methodName", "offset");
        reflect_AxisAlignedBB_method_offset_4.set("returnType", "AxisAlignedBB");
        reflect_AxisAlignedBB_method_offset_4.set("static", false);
        reflect_AxisAlignedBB_method_offset_4.set("argnames", new String[]{"x", "y", "z"});
        reflect_AxisAlignedBB_method_offset_4.set("argtypes", new String[]{"double", "double", "double"});
        reflect_AxisAlignedBB_method_offset_4.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (AxisAlignedBB) ((AxisAlignedBB) params.getReflective("_self")).offset((double) params.getDouble("x"), (double) params.getDouble("y"), (double) params.getDouble("z"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_AxisAlignedBB_methods.add(reflect_AxisAlignedBB_method_offset_4);


        BaseData reflect_AxisAlignedBB_method_calculateXOffset_5 = new ModData();
        reflect_AxisAlignedBB_method_calculateXOffset_5.set("methodName", "calculateXOffset");
        reflect_AxisAlignedBB_method_calculateXOffset_5.set("returnType", "double");
        reflect_AxisAlignedBB_method_calculateXOffset_5.set("static", false);
        reflect_AxisAlignedBB_method_calculateXOffset_5.set("argnames", new String[]{"other", "offsetX"});
        reflect_AxisAlignedBB_method_calculateXOffset_5.set("argtypes", new String[]{"AxisAlignedBB", "double"});
        reflect_AxisAlignedBB_method_calculateXOffset_5.setCallbackDoubleWithDataArg("exec", (BaseData params) -> {
                try {
                    return (double) ((AxisAlignedBB) params.getReflective("_self")).calculateXOffset((AxisAlignedBB) params.getReflective("other"), (double) params.getDouble("offsetX"));
                } catch (Exception _exception_reflect_) {
                    return 0.0d;
                }
            });
            
        reflect_AxisAlignedBB_methods.add(reflect_AxisAlignedBB_method_calculateXOffset_5);


        BaseData reflect_AxisAlignedBB_method_calculateYOffset_6 = new ModData();
        reflect_AxisAlignedBB_method_calculateYOffset_6.set("methodName", "calculateYOffset");
        reflect_AxisAlignedBB_method_calculateYOffset_6.set("returnType", "double");
        reflect_AxisAlignedBB_method_calculateYOffset_6.set("static", false);
        reflect_AxisAlignedBB_method_calculateYOffset_6.set("argnames", new String[]{"other", "offsetY"});
        reflect_AxisAlignedBB_method_calculateYOffset_6.set("argtypes", new String[]{"AxisAlignedBB", "double"});
        reflect_AxisAlignedBB_method_calculateYOffset_6.setCallbackDoubleWithDataArg("exec", (BaseData params) -> {
                try {
                    return (double) ((AxisAlignedBB) params.getReflective("_self")).calculateYOffset((AxisAlignedBB) params.getReflective("other"), (double) params.getDouble("offsetY"));
                } catch (Exception _exception_reflect_) {
                    return 0.0d;
                }
            });
            
        reflect_AxisAlignedBB_methods.add(reflect_AxisAlignedBB_method_calculateYOffset_6);


        BaseData reflect_AxisAlignedBB_method_calculateZOffset_7 = new ModData();
        reflect_AxisAlignedBB_method_calculateZOffset_7.set("methodName", "calculateZOffset");
        reflect_AxisAlignedBB_method_calculateZOffset_7.set("returnType", "double");
        reflect_AxisAlignedBB_method_calculateZOffset_7.set("static", false);
        reflect_AxisAlignedBB_method_calculateZOffset_7.set("argnames", new String[]{"other", "offsetZ"});
        reflect_AxisAlignedBB_method_calculateZOffset_7.set("argtypes", new String[]{"AxisAlignedBB", "double"});
        reflect_AxisAlignedBB_method_calculateZOffset_7.setCallbackDoubleWithDataArg("exec", (BaseData params) -> {
                try {
                    return (double) ((AxisAlignedBB) params.getReflective("_self")).calculateZOffset((AxisAlignedBB) params.getReflective("other"), (double) params.getDouble("offsetZ"));
                } catch (Exception _exception_reflect_) {
                    return 0.0d;
                }
            });
            
        reflect_AxisAlignedBB_methods.add(reflect_AxisAlignedBB_method_calculateZOffset_7);


        BaseData reflect_AxisAlignedBB_method_intersectsWith_8 = new ModData();
        reflect_AxisAlignedBB_method_intersectsWith_8.set("methodName", "intersectsWith");
        reflect_AxisAlignedBB_method_intersectsWith_8.set("returnType", "boolean");
        reflect_AxisAlignedBB_method_intersectsWith_8.set("static", false);
        reflect_AxisAlignedBB_method_intersectsWith_8.set("argnames", new String[]{"other"});
        reflect_AxisAlignedBB_method_intersectsWith_8.set("argtypes", new String[]{"AxisAlignedBB"});
        reflect_AxisAlignedBB_method_intersectsWith_8.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((AxisAlignedBB) params.getReflective("_self")).intersectsWith((AxisAlignedBB) params.getReflective("other"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_AxisAlignedBB_methods.add(reflect_AxisAlignedBB_method_intersectsWith_8);


        BaseData reflect_AxisAlignedBB_method_isVecInside_9 = new ModData();
        reflect_AxisAlignedBB_method_isVecInside_9.set("methodName", "isVecInside");
        reflect_AxisAlignedBB_method_isVecInside_9.set("returnType", "boolean");
        reflect_AxisAlignedBB_method_isVecInside_9.set("static", false);
        reflect_AxisAlignedBB_method_isVecInside_9.set("argnames", new String[]{"vec"});
        reflect_AxisAlignedBB_method_isVecInside_9.set("argtypes", new String[]{"Vec3"});
        reflect_AxisAlignedBB_method_isVecInside_9.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((AxisAlignedBB) params.getReflective("_self")).isVecInside((Vec3) params.getReflective("vec"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_AxisAlignedBB_methods.add(reflect_AxisAlignedBB_method_isVecInside_9);


        BaseData reflect_AxisAlignedBB_method_getAverageEdgeLength_10 = new ModData();
        reflect_AxisAlignedBB_method_getAverageEdgeLength_10.set("methodName", "getAverageEdgeLength");
        reflect_AxisAlignedBB_method_getAverageEdgeLength_10.set("returnType", "double");
        reflect_AxisAlignedBB_method_getAverageEdgeLength_10.set("static", false);
        reflect_AxisAlignedBB_method_getAverageEdgeLength_10.set("argnames", new String[]{});
        reflect_AxisAlignedBB_method_getAverageEdgeLength_10.set("argtypes", new String[]{});
        reflect_AxisAlignedBB_method_getAverageEdgeLength_10.setCallbackDoubleWithDataArg("exec", (BaseData params) -> {
                try {
                    return (double) ((AxisAlignedBB) params.getReflective("_self")).getAverageEdgeLength();
                } catch (Exception _exception_reflect_) {
                    return 0.0d;
                }
            });
            
        reflect_AxisAlignedBB_methods.add(reflect_AxisAlignedBB_method_getAverageEdgeLength_10);


        BaseData reflect_AxisAlignedBB_method_contract_11 = new ModData();
        reflect_AxisAlignedBB_method_contract_11.set("methodName", "contract");
        reflect_AxisAlignedBB_method_contract_11.set("returnType", "AxisAlignedBB");
        reflect_AxisAlignedBB_method_contract_11.set("static", false);
        reflect_AxisAlignedBB_method_contract_11.set("argnames", new String[]{"x", "y", "z"});
        reflect_AxisAlignedBB_method_contract_11.set("argtypes", new String[]{"double", "double", "double"});
        reflect_AxisAlignedBB_method_contract_11.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (AxisAlignedBB) ((AxisAlignedBB) params.getReflective("_self")).contract((double) params.getDouble("x"), (double) params.getDouble("y"), (double) params.getDouble("z"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_AxisAlignedBB_methods.add(reflect_AxisAlignedBB_method_contract_11);


        BaseData reflect_AxisAlignedBB_method_calculateIntercept_12 = new ModData();
        reflect_AxisAlignedBB_method_calculateIntercept_12.set("methodName", "calculateIntercept");
        reflect_AxisAlignedBB_method_calculateIntercept_12.set("returnType", "MovingObjectPosition");
        reflect_AxisAlignedBB_method_calculateIntercept_12.set("static", false);
        reflect_AxisAlignedBB_method_calculateIntercept_12.set("argnames", new String[]{"vecA", "vecB"});
        reflect_AxisAlignedBB_method_calculateIntercept_12.set("argtypes", new String[]{"Vec3", "Vec3"});
        reflect_AxisAlignedBB_method_calculateIntercept_12.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (MovingObjectPosition) ((AxisAlignedBB) params.getReflective("_self")).calculateIntercept((Vec3) params.getReflective("vecA"), (Vec3) params.getReflective("vecB"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_AxisAlignedBB_methods.add(reflect_AxisAlignedBB_method_calculateIntercept_12);


        BaseData reflect_AxisAlignedBB_method_toString_13 = new ModData();
        reflect_AxisAlignedBB_method_toString_13.set("methodName", "toString");
        reflect_AxisAlignedBB_method_toString_13.set("returnType", "String");
        reflect_AxisAlignedBB_method_toString_13.set("static", false);
        reflect_AxisAlignedBB_method_toString_13.set("argnames", new String[]{});
        reflect_AxisAlignedBB_method_toString_13.set("argtypes", new String[]{});
        reflect_AxisAlignedBB_method_toString_13.setCallbackStringWithDataArg("exec", (BaseData params) -> {
                try {
                    return (String) ((AxisAlignedBB) params.getReflective("_self")).toString();
                } catch (Exception _exception_reflect_) {
                    return "";
                }
            });
            
        reflect_AxisAlignedBB_methods.add(reflect_AxisAlignedBB_method_toString_13);


        BaseData reflect_AxisAlignedBB_method_func_181656_b_14 = new ModData();
        reflect_AxisAlignedBB_method_func_181656_b_14.set("methodName", "func_181656_b");
        reflect_AxisAlignedBB_method_func_181656_b_14.set("returnType", "boolean");
        reflect_AxisAlignedBB_method_func_181656_b_14.set("static", false);
        reflect_AxisAlignedBB_method_func_181656_b_14.set("argnames", new String[]{});
        reflect_AxisAlignedBB_method_func_181656_b_14.set("argtypes", new String[]{});
        reflect_AxisAlignedBB_method_func_181656_b_14.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((AxisAlignedBB) params.getReflective("_self")).func_181656_b();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_AxisAlignedBB_methods.add(reflect_AxisAlignedBB_method_func_181656_b_14);


        BaseData reflect_AxisAlignedBB_method_loadModData_15 = new ModData();
        reflect_AxisAlignedBB_method_loadModData_15.set("methodName", "loadModData");
        reflect_AxisAlignedBB_method_loadModData_15.set("returnType", "void");
        reflect_AxisAlignedBB_method_loadModData_15.set("static", false);
        reflect_AxisAlignedBB_method_loadModData_15.set("argnames", new String[]{"data"});
        reflect_AxisAlignedBB_method_loadModData_15.set("argtypes", new String[]{"BaseData"});
        reflect_AxisAlignedBB_method_loadModData_15.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((AxisAlignedBB) params.getReflective("_self")).loadModData((BaseData) params.getReflective("data"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_AxisAlignedBB_methods.add(reflect_AxisAlignedBB_method_loadModData_15);


        BaseData reflect_AxisAlignedBB_method_fromModData_16 = new ModData();
        reflect_AxisAlignedBB_method_fromModData_16.set("methodName", "fromModData");
        reflect_AxisAlignedBB_method_fromModData_16.set("returnType", "AxisAlignedBB");
        reflect_AxisAlignedBB_method_fromModData_16.set("static", true);
        reflect_AxisAlignedBB_method_fromModData_16.set("argnames", new String[]{"data"});
        reflect_AxisAlignedBB_method_fromModData_16.set("argtypes", new String[]{"BaseData"});
        reflect_AxisAlignedBB_method_fromModData_16.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (AxisAlignedBB) AxisAlignedBB.fromModData((BaseData) params.getReflective("data"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_AxisAlignedBB_methods.add(reflect_AxisAlignedBB_method_fromModData_16);


        BaseData reflect_AxisAlignedBB_method_makeModData_17 = new ModData();
        reflect_AxisAlignedBB_method_makeModData_17.set("methodName", "makeModData");
        reflect_AxisAlignedBB_method_makeModData_17.set("returnType", "ModData");
        reflect_AxisAlignedBB_method_makeModData_17.set("static", false);
        reflect_AxisAlignedBB_method_makeModData_17.set("argnames", new String[]{});
        reflect_AxisAlignedBB_method_makeModData_17.set("argtypes", new String[]{});
        reflect_AxisAlignedBB_method_makeModData_17.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (ModData) ((AxisAlignedBB) params.getReflective("_self")).makeModData();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_AxisAlignedBB_methods.add(reflect_AxisAlignedBB_method_makeModData_17);


        BaseData[] reflect_AxisAlignedBB_methods_arr = new BaseData[reflect_AxisAlignedBB_methods.size()];
        for (int i = 0; i < reflect_AxisAlignedBB_methods_arr.length; i++) {
            reflect_AxisAlignedBB_methods_arr[i] = reflect_AxisAlignedBB_methods.get(i);
        }

        reflect_AxisAlignedBB.set("constructors", reflect_AxisAlignedBB_constructors_arr);
        reflect_AxisAlignedBB.set("methods", reflect_AxisAlignedBB_methods_arr);
        reflect_AxisAlignedBB.set("className", "AxisAlignedBB");
        reflect_AxisAlignedBB.set("classId", "net.minecraft.util.AxisAlignedBB");
        reflect_AxisAlignedBB.set("class", AxisAlignedBB.class);
        reflect_AxisAlignedBB.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof AxisAlignedBB;
        });
        reflectProfiles.add(reflect_AxisAlignedBB);
    }


    //classdef for MathHelper
    public static void reflect_MathHelper_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_MathHelper = new ModData();

        ArrayList<BaseData> reflect_MathHelper_constructors = new ArrayList<BaseData>();
        
        BaseData[] reflect_MathHelper_constructors_arr = new BaseData[reflect_MathHelper_constructors.size()];
        for (int i = 0; i < reflect_MathHelper_constructors_arr.length; i++) {
            reflect_MathHelper_constructors_arr[i] = reflect_MathHelper_constructors.get(i);
        }

        ArrayList<BaseData> reflect_MathHelper_methods = new ArrayList<BaseData>();
        
        BaseData reflect_MathHelper_method_sin_0 = new ModData();
        reflect_MathHelper_method_sin_0.set("methodName", "sin");
        reflect_MathHelper_method_sin_0.set("returnType", "float");
        reflect_MathHelper_method_sin_0.set("static", true);
        reflect_MathHelper_method_sin_0.set("argnames", new String[]{"parFloat1"});
        reflect_MathHelper_method_sin_0.set("argtypes", new String[]{"float"});
        reflect_MathHelper_method_sin_0.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) MathHelper.sin((float) params.getFloat("parFloat1"));
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_MathHelper_methods.add(reflect_MathHelper_method_sin_0);


        BaseData reflect_MathHelper_method_cos_1 = new ModData();
        reflect_MathHelper_method_cos_1.set("methodName", "cos");
        reflect_MathHelper_method_cos_1.set("returnType", "float");
        reflect_MathHelper_method_cos_1.set("static", true);
        reflect_MathHelper_method_cos_1.set("argnames", new String[]{"value"});
        reflect_MathHelper_method_cos_1.set("argtypes", new String[]{"float"});
        reflect_MathHelper_method_cos_1.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) MathHelper.cos((float) params.getFloat("value"));
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_MathHelper_methods.add(reflect_MathHelper_method_cos_1);


        BaseData reflect_MathHelper_method_sqrt_float_2 = new ModData();
        reflect_MathHelper_method_sqrt_float_2.set("methodName", "sqrt_float");
        reflect_MathHelper_method_sqrt_float_2.set("returnType", "float");
        reflect_MathHelper_method_sqrt_float_2.set("static", true);
        reflect_MathHelper_method_sqrt_float_2.set("argnames", new String[]{"value"});
        reflect_MathHelper_method_sqrt_float_2.set("argtypes", new String[]{"float"});
        reflect_MathHelper_method_sqrt_float_2.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) MathHelper.sqrt_float((float) params.getFloat("value"));
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_MathHelper_methods.add(reflect_MathHelper_method_sqrt_float_2);


        BaseData reflect_MathHelper_method_sqrt_double_3 = new ModData();
        reflect_MathHelper_method_sqrt_double_3.set("methodName", "sqrt_double");
        reflect_MathHelper_method_sqrt_double_3.set("returnType", "float");
        reflect_MathHelper_method_sqrt_double_3.set("static", true);
        reflect_MathHelper_method_sqrt_double_3.set("argnames", new String[]{"value"});
        reflect_MathHelper_method_sqrt_double_3.set("argtypes", new String[]{"double"});
        reflect_MathHelper_method_sqrt_double_3.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) MathHelper.sqrt_double((double) params.getDouble("value"));
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_MathHelper_methods.add(reflect_MathHelper_method_sqrt_double_3);


        BaseData reflect_MathHelper_method_floor_float_4 = new ModData();
        reflect_MathHelper_method_floor_float_4.set("methodName", "floor_float");
        reflect_MathHelper_method_floor_float_4.set("returnType", "int");
        reflect_MathHelper_method_floor_float_4.set("static", true);
        reflect_MathHelper_method_floor_float_4.set("argnames", new String[]{"value"});
        reflect_MathHelper_method_floor_float_4.set("argtypes", new String[]{"float"});
        reflect_MathHelper_method_floor_float_4.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) MathHelper.floor_float((float) params.getFloat("value"));
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_MathHelper_methods.add(reflect_MathHelper_method_floor_float_4);


        BaseData reflect_MathHelper_method_truncateDoubleToInt_5 = new ModData();
        reflect_MathHelper_method_truncateDoubleToInt_5.set("methodName", "truncateDoubleToInt");
        reflect_MathHelper_method_truncateDoubleToInt_5.set("returnType", "int");
        reflect_MathHelper_method_truncateDoubleToInt_5.set("static", true);
        reflect_MathHelper_method_truncateDoubleToInt_5.set("argnames", new String[]{"value"});
        reflect_MathHelper_method_truncateDoubleToInt_5.set("argtypes", new String[]{"double"});
        reflect_MathHelper_method_truncateDoubleToInt_5.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) MathHelper.truncateDoubleToInt((double) params.getDouble("value"));
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_MathHelper_methods.add(reflect_MathHelper_method_truncateDoubleToInt_5);


        BaseData reflect_MathHelper_method_floor_double_6 = new ModData();
        reflect_MathHelper_method_floor_double_6.set("methodName", "floor_double");
        reflect_MathHelper_method_floor_double_6.set("returnType", "int");
        reflect_MathHelper_method_floor_double_6.set("static", true);
        reflect_MathHelper_method_floor_double_6.set("argnames", new String[]{"value"});
        reflect_MathHelper_method_floor_double_6.set("argtypes", new String[]{"double"});
        reflect_MathHelper_method_floor_double_6.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) MathHelper.floor_double((double) params.getDouble("value"));
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_MathHelper_methods.add(reflect_MathHelper_method_floor_double_6);


        BaseData reflect_MathHelper_method_floor_double_long_7 = new ModData();
        reflect_MathHelper_method_floor_double_long_7.set("methodName", "floor_double_long");
        reflect_MathHelper_method_floor_double_long_7.set("returnType", "long");
        reflect_MathHelper_method_floor_double_long_7.set("static", true);
        reflect_MathHelper_method_floor_double_long_7.set("argnames", new String[]{"value"});
        reflect_MathHelper_method_floor_double_long_7.set("argtypes", new String[]{"double"});
        reflect_MathHelper_method_floor_double_long_7.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (long) MathHelper.floor_double_long((double) params.getDouble("value"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_MathHelper_methods.add(reflect_MathHelper_method_floor_double_long_7);


        BaseData reflect_MathHelper_method_func_154353_e_8 = new ModData();
        reflect_MathHelper_method_func_154353_e_8.set("methodName", "func_154353_e");
        reflect_MathHelper_method_func_154353_e_8.set("returnType", "int");
        reflect_MathHelper_method_func_154353_e_8.set("static", true);
        reflect_MathHelper_method_func_154353_e_8.set("argnames", new String[]{"value"});
        reflect_MathHelper_method_func_154353_e_8.set("argtypes", new String[]{"double"});
        reflect_MathHelper_method_func_154353_e_8.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) MathHelper.func_154353_e((double) params.getDouble("value"));
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_MathHelper_methods.add(reflect_MathHelper_method_func_154353_e_8);


        BaseData reflect_MathHelper_method_abs_9 = new ModData();
        reflect_MathHelper_method_abs_9.set("methodName", "abs");
        reflect_MathHelper_method_abs_9.set("returnType", "float");
        reflect_MathHelper_method_abs_9.set("static", true);
        reflect_MathHelper_method_abs_9.set("argnames", new String[]{"value"});
        reflect_MathHelper_method_abs_9.set("argtypes", new String[]{"float"});
        reflect_MathHelper_method_abs_9.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) MathHelper.abs((float) params.getFloat("value"));
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_MathHelper_methods.add(reflect_MathHelper_method_abs_9);


        BaseData reflect_MathHelper_method_abs_int_10 = new ModData();
        reflect_MathHelper_method_abs_int_10.set("methodName", "abs_int");
        reflect_MathHelper_method_abs_int_10.set("returnType", "int");
        reflect_MathHelper_method_abs_int_10.set("static", true);
        reflect_MathHelper_method_abs_int_10.set("argnames", new String[]{"value"});
        reflect_MathHelper_method_abs_int_10.set("argtypes", new String[]{"int"});
        reflect_MathHelper_method_abs_int_10.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) MathHelper.abs_int((int) params.getInt("value"));
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_MathHelper_methods.add(reflect_MathHelper_method_abs_int_10);


        BaseData reflect_MathHelper_method_ceiling_float_int_11 = new ModData();
        reflect_MathHelper_method_ceiling_float_int_11.set("methodName", "ceiling_float_int");
        reflect_MathHelper_method_ceiling_float_int_11.set("returnType", "int");
        reflect_MathHelper_method_ceiling_float_int_11.set("static", true);
        reflect_MathHelper_method_ceiling_float_int_11.set("argnames", new String[]{"value"});
        reflect_MathHelper_method_ceiling_float_int_11.set("argtypes", new String[]{"float"});
        reflect_MathHelper_method_ceiling_float_int_11.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) MathHelper.ceiling_float_int((float) params.getFloat("value"));
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_MathHelper_methods.add(reflect_MathHelper_method_ceiling_float_int_11);


        BaseData reflect_MathHelper_method_ceiling_double_int_12 = new ModData();
        reflect_MathHelper_method_ceiling_double_int_12.set("methodName", "ceiling_double_int");
        reflect_MathHelper_method_ceiling_double_int_12.set("returnType", "int");
        reflect_MathHelper_method_ceiling_double_int_12.set("static", true);
        reflect_MathHelper_method_ceiling_double_int_12.set("argnames", new String[]{"value"});
        reflect_MathHelper_method_ceiling_double_int_12.set("argtypes", new String[]{"double"});
        reflect_MathHelper_method_ceiling_double_int_12.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) MathHelper.ceiling_double_int((double) params.getDouble("value"));
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_MathHelper_methods.add(reflect_MathHelper_method_ceiling_double_int_12);


        BaseData reflect_MathHelper_method_clamp_int_13 = new ModData();
        reflect_MathHelper_method_clamp_int_13.set("methodName", "clamp_int");
        reflect_MathHelper_method_clamp_int_13.set("returnType", "int");
        reflect_MathHelper_method_clamp_int_13.set("static", true);
        reflect_MathHelper_method_clamp_int_13.set("argnames", new String[]{"num", "min", "max"});
        reflect_MathHelper_method_clamp_int_13.set("argtypes", new String[]{"int", "int", "int"});
        reflect_MathHelper_method_clamp_int_13.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) MathHelper.clamp_int((int) params.getInt("num"), (int) params.getInt("min"), (int) params.getInt("max"));
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_MathHelper_methods.add(reflect_MathHelper_method_clamp_int_13);


        BaseData reflect_MathHelper_method_clamp_float_14 = new ModData();
        reflect_MathHelper_method_clamp_float_14.set("methodName", "clamp_float");
        reflect_MathHelper_method_clamp_float_14.set("returnType", "float");
        reflect_MathHelper_method_clamp_float_14.set("static", true);
        reflect_MathHelper_method_clamp_float_14.set("argnames", new String[]{"num", "min", "max"});
        reflect_MathHelper_method_clamp_float_14.set("argtypes", new String[]{"float", "float", "float"});
        reflect_MathHelper_method_clamp_float_14.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) MathHelper.clamp_float((float) params.getFloat("num"), (float) params.getFloat("min"), (float) params.getFloat("max"));
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_MathHelper_methods.add(reflect_MathHelper_method_clamp_float_14);


        BaseData reflect_MathHelper_method_clamp_double_15 = new ModData();
        reflect_MathHelper_method_clamp_double_15.set("methodName", "clamp_double");
        reflect_MathHelper_method_clamp_double_15.set("returnType", "double");
        reflect_MathHelper_method_clamp_double_15.set("static", true);
        reflect_MathHelper_method_clamp_double_15.set("argnames", new String[]{"num", "min", "max"});
        reflect_MathHelper_method_clamp_double_15.set("argtypes", new String[]{"double", "double", "double"});
        reflect_MathHelper_method_clamp_double_15.setCallbackDoubleWithDataArg("exec", (BaseData params) -> {
                try {
                    return (double) MathHelper.clamp_double((double) params.getDouble("num"), (double) params.getDouble("min"), (double) params.getDouble("max"));
                } catch (Exception _exception_reflect_) {
                    return 0.0d;
                }
            });
            
        reflect_MathHelper_methods.add(reflect_MathHelper_method_clamp_double_15);


        BaseData reflect_MathHelper_method_denormalizeClamp_16 = new ModData();
        reflect_MathHelper_method_denormalizeClamp_16.set("methodName", "denormalizeClamp");
        reflect_MathHelper_method_denormalizeClamp_16.set("returnType", "double");
        reflect_MathHelper_method_denormalizeClamp_16.set("static", true);
        reflect_MathHelper_method_denormalizeClamp_16.set("argnames", new String[]{"parDouble1", "parDouble2", "parDouble3"});
        reflect_MathHelper_method_denormalizeClamp_16.set("argtypes", new String[]{"double", "double", "double"});
        reflect_MathHelper_method_denormalizeClamp_16.setCallbackDoubleWithDataArg("exec", (BaseData params) -> {
                try {
                    return (double) MathHelper.denormalizeClamp((double) params.getDouble("parDouble1"), (double) params.getDouble("parDouble2"), (double) params.getDouble("parDouble3"));
                } catch (Exception _exception_reflect_) {
                    return 0.0d;
                }
            });
            
        reflect_MathHelper_methods.add(reflect_MathHelper_method_denormalizeClamp_16);


        BaseData reflect_MathHelper_method_abs_max_17 = new ModData();
        reflect_MathHelper_method_abs_max_17.set("methodName", "abs_max");
        reflect_MathHelper_method_abs_max_17.set("returnType", "double");
        reflect_MathHelper_method_abs_max_17.set("static", true);
        reflect_MathHelper_method_abs_max_17.set("argnames", new String[]{"parDouble1", "parDouble2"});
        reflect_MathHelper_method_abs_max_17.set("argtypes", new String[]{"double", "double"});
        reflect_MathHelper_method_abs_max_17.setCallbackDoubleWithDataArg("exec", (BaseData params) -> {
                try {
                    return (double) MathHelper.abs_max((double) params.getDouble("parDouble1"), (double) params.getDouble("parDouble2"));
                } catch (Exception _exception_reflect_) {
                    return 0.0d;
                }
            });
            
        reflect_MathHelper_methods.add(reflect_MathHelper_method_abs_max_17);


        BaseData reflect_MathHelper_method_bucketInt_18 = new ModData();
        reflect_MathHelper_method_bucketInt_18.set("methodName", "bucketInt");
        reflect_MathHelper_method_bucketInt_18.set("returnType", "int");
        reflect_MathHelper_method_bucketInt_18.set("static", true);
        reflect_MathHelper_method_bucketInt_18.set("argnames", new String[]{"parInt1", "parInt2"});
        reflect_MathHelper_method_bucketInt_18.set("argtypes", new String[]{"int", "int"});
        reflect_MathHelper_method_bucketInt_18.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) MathHelper.bucketInt((int) params.getInt("parInt1"), (int) params.getInt("parInt2"));
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_MathHelper_methods.add(reflect_MathHelper_method_bucketInt_18);


        BaseData reflect_MathHelper_method_getRandomIntegerInRange_19 = new ModData();
        reflect_MathHelper_method_getRandomIntegerInRange_19.set("methodName", "getRandomIntegerInRange");
        reflect_MathHelper_method_getRandomIntegerInRange_19.set("returnType", "int");
        reflect_MathHelper_method_getRandomIntegerInRange_19.set("static", true);
        reflect_MathHelper_method_getRandomIntegerInRange_19.set("argnames", new String[]{"parRandom", "parInt1", "parInt2"});
        reflect_MathHelper_method_getRandomIntegerInRange_19.set("argtypes", new String[]{"EaglercraftRandom", "int", "int"});
        reflect_MathHelper_method_getRandomIntegerInRange_19.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) MathHelper.getRandomIntegerInRange((EaglercraftRandom) params.getReflective("parRandom"), (int) params.getInt("parInt1"), (int) params.getInt("parInt2"));
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_MathHelper_methods.add(reflect_MathHelper_method_getRandomIntegerInRange_19);


        BaseData reflect_MathHelper_method_randomFloatClamp_20 = new ModData();
        reflect_MathHelper_method_randomFloatClamp_20.set("methodName", "randomFloatClamp");
        reflect_MathHelper_method_randomFloatClamp_20.set("returnType", "float");
        reflect_MathHelper_method_randomFloatClamp_20.set("static", true);
        reflect_MathHelper_method_randomFloatClamp_20.set("argnames", new String[]{"parRandom", "parFloat1", "parFloat2"});
        reflect_MathHelper_method_randomFloatClamp_20.set("argtypes", new String[]{"EaglercraftRandom", "float", "float"});
        reflect_MathHelper_method_randomFloatClamp_20.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) MathHelper.randomFloatClamp((EaglercraftRandom) params.getReflective("parRandom"), (float) params.getFloat("parFloat1"), (float) params.getFloat("parFloat2"));
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_MathHelper_methods.add(reflect_MathHelper_method_randomFloatClamp_20);


        BaseData reflect_MathHelper_method_getRandomDoubleInRange_21 = new ModData();
        reflect_MathHelper_method_getRandomDoubleInRange_21.set("methodName", "getRandomDoubleInRange");
        reflect_MathHelper_method_getRandomDoubleInRange_21.set("returnType", "double");
        reflect_MathHelper_method_getRandomDoubleInRange_21.set("static", true);
        reflect_MathHelper_method_getRandomDoubleInRange_21.set("argnames", new String[]{"parRandom", "parDouble1", "parDouble2"});
        reflect_MathHelper_method_getRandomDoubleInRange_21.set("argtypes", new String[]{"EaglercraftRandom", "double", "double"});
        reflect_MathHelper_method_getRandomDoubleInRange_21.setCallbackDoubleWithDataArg("exec", (BaseData params) -> {
                try {
                    return (double) MathHelper.getRandomDoubleInRange((EaglercraftRandom) params.getReflective("parRandom"), (double) params.getDouble("parDouble1"), (double) params.getDouble("parDouble2"));
                } catch (Exception _exception_reflect_) {
                    return 0.0d;
                }
            });
            
        reflect_MathHelper_methods.add(reflect_MathHelper_method_getRandomDoubleInRange_21);


        BaseData reflect_MathHelper_method_average_22 = new ModData();
        reflect_MathHelper_method_average_22.set("methodName", "average");
        reflect_MathHelper_method_average_22.set("returnType", "double");
        reflect_MathHelper_method_average_22.set("static", true);
        reflect_MathHelper_method_average_22.set("argnames", new String[]{"values"});
        reflect_MathHelper_method_average_22.set("argtypes", new String[]{"long[]"});
        reflect_MathHelper_method_average_22.setCallbackDoubleWithDataArg("exec", (BaseData params) -> {
                try {
                    return (double) MathHelper.average((long[]) params.getReflective("values"));
                } catch (Exception _exception_reflect_) {
                    return 0.0d;
                }
            });
            
        reflect_MathHelper_methods.add(reflect_MathHelper_method_average_22);


        BaseData reflect_MathHelper_method_epsilonEquals_23 = new ModData();
        reflect_MathHelper_method_epsilonEquals_23.set("methodName", "epsilonEquals");
        reflect_MathHelper_method_epsilonEquals_23.set("returnType", "boolean");
        reflect_MathHelper_method_epsilonEquals_23.set("static", true);
        reflect_MathHelper_method_epsilonEquals_23.set("argnames", new String[]{"parFloat1", "parFloat2"});
        reflect_MathHelper_method_epsilonEquals_23.set("argtypes", new String[]{"float", "float"});
        reflect_MathHelper_method_epsilonEquals_23.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) MathHelper.epsilonEquals((float) params.getFloat("parFloat1"), (float) params.getFloat("parFloat2"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_MathHelper_methods.add(reflect_MathHelper_method_epsilonEquals_23);


        BaseData reflect_MathHelper_method_normalizeAngle_24 = new ModData();
        reflect_MathHelper_method_normalizeAngle_24.set("methodName", "normalizeAngle");
        reflect_MathHelper_method_normalizeAngle_24.set("returnType", "int");
        reflect_MathHelper_method_normalizeAngle_24.set("static", true);
        reflect_MathHelper_method_normalizeAngle_24.set("argnames", new String[]{"parInt1", "parInt2"});
        reflect_MathHelper_method_normalizeAngle_24.set("argtypes", new String[]{"int", "int"});
        reflect_MathHelper_method_normalizeAngle_24.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) MathHelper.normalizeAngle((int) params.getInt("parInt1"), (int) params.getInt("parInt2"));
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_MathHelper_methods.add(reflect_MathHelper_method_normalizeAngle_24);


        BaseData reflect_MathHelper_method_wrapAngleTo180_float_25 = new ModData();
        reflect_MathHelper_method_wrapAngleTo180_float_25.set("methodName", "wrapAngleTo180_float");
        reflect_MathHelper_method_wrapAngleTo180_float_25.set("returnType", "float");
        reflect_MathHelper_method_wrapAngleTo180_float_25.set("static", true);
        reflect_MathHelper_method_wrapAngleTo180_float_25.set("argnames", new String[]{"value"});
        reflect_MathHelper_method_wrapAngleTo180_float_25.set("argtypes", new String[]{"float"});
        reflect_MathHelper_method_wrapAngleTo180_float_25.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) MathHelper.wrapAngleTo180_float((float) params.getFloat("value"));
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_MathHelper_methods.add(reflect_MathHelper_method_wrapAngleTo180_float_25);


        BaseData reflect_MathHelper_method_wrapAngleTo180_double_26 = new ModData();
        reflect_MathHelper_method_wrapAngleTo180_double_26.set("methodName", "wrapAngleTo180_double");
        reflect_MathHelper_method_wrapAngleTo180_double_26.set("returnType", "double");
        reflect_MathHelper_method_wrapAngleTo180_double_26.set("static", true);
        reflect_MathHelper_method_wrapAngleTo180_double_26.set("argnames", new String[]{"value"});
        reflect_MathHelper_method_wrapAngleTo180_double_26.set("argtypes", new String[]{"double"});
        reflect_MathHelper_method_wrapAngleTo180_double_26.setCallbackDoubleWithDataArg("exec", (BaseData params) -> {
                try {
                    return (double) MathHelper.wrapAngleTo180_double((double) params.getDouble("value"));
                } catch (Exception _exception_reflect_) {
                    return 0.0d;
                }
            });
            
        reflect_MathHelper_methods.add(reflect_MathHelper_method_wrapAngleTo180_double_26);


        BaseData reflect_MathHelper_method_parseIntWithDefault_27 = new ModData();
        reflect_MathHelper_method_parseIntWithDefault_27.set("methodName", "parseIntWithDefault");
        reflect_MathHelper_method_parseIntWithDefault_27.set("returnType", "int");
        reflect_MathHelper_method_parseIntWithDefault_27.set("static", true);
        reflect_MathHelper_method_parseIntWithDefault_27.set("argnames", new String[]{"parString1", "parInt1"});
        reflect_MathHelper_method_parseIntWithDefault_27.set("argtypes", new String[]{"String", "int"});
        reflect_MathHelper_method_parseIntWithDefault_27.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) MathHelper.parseIntWithDefault((String) params.getString("parString1"), (int) params.getInt("parInt1"));
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_MathHelper_methods.add(reflect_MathHelper_method_parseIntWithDefault_27);


        BaseData reflect_MathHelper_method_parseIntWithDefaultAndMax_28 = new ModData();
        reflect_MathHelper_method_parseIntWithDefaultAndMax_28.set("methodName", "parseIntWithDefaultAndMax");
        reflect_MathHelper_method_parseIntWithDefaultAndMax_28.set("returnType", "int");
        reflect_MathHelper_method_parseIntWithDefaultAndMax_28.set("static", true);
        reflect_MathHelper_method_parseIntWithDefaultAndMax_28.set("argnames", new String[]{"parString1", "parInt1", "parInt2"});
        reflect_MathHelper_method_parseIntWithDefaultAndMax_28.set("argtypes", new String[]{"String", "int", "int"});
        reflect_MathHelper_method_parseIntWithDefaultAndMax_28.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) MathHelper.parseIntWithDefaultAndMax((String) params.getString("parString1"), (int) params.getInt("parInt1"), (int) params.getInt("parInt2"));
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_MathHelper_methods.add(reflect_MathHelper_method_parseIntWithDefaultAndMax_28);


        BaseData reflect_MathHelper_method_parseDoubleWithDefault_29 = new ModData();
        reflect_MathHelper_method_parseDoubleWithDefault_29.set("methodName", "parseDoubleWithDefault");
        reflect_MathHelper_method_parseDoubleWithDefault_29.set("returnType", "double");
        reflect_MathHelper_method_parseDoubleWithDefault_29.set("static", true);
        reflect_MathHelper_method_parseDoubleWithDefault_29.set("argnames", new String[]{"parString1", "parDouble1"});
        reflect_MathHelper_method_parseDoubleWithDefault_29.set("argtypes", new String[]{"String", "double"});
        reflect_MathHelper_method_parseDoubleWithDefault_29.setCallbackDoubleWithDataArg("exec", (BaseData params) -> {
                try {
                    return (double) MathHelper.parseDoubleWithDefault((String) params.getString("parString1"), (double) params.getDouble("parDouble1"));
                } catch (Exception _exception_reflect_) {
                    return 0.0d;
                }
            });
            
        reflect_MathHelper_methods.add(reflect_MathHelper_method_parseDoubleWithDefault_29);


        BaseData reflect_MathHelper_method_parseDoubleWithDefaultAndMax_30 = new ModData();
        reflect_MathHelper_method_parseDoubleWithDefaultAndMax_30.set("methodName", "parseDoubleWithDefaultAndMax");
        reflect_MathHelper_method_parseDoubleWithDefaultAndMax_30.set("returnType", "double");
        reflect_MathHelper_method_parseDoubleWithDefaultAndMax_30.set("static", true);
        reflect_MathHelper_method_parseDoubleWithDefaultAndMax_30.set("argnames", new String[]{"parString1", "parDouble1", "parDouble2"});
        reflect_MathHelper_method_parseDoubleWithDefaultAndMax_30.set("argtypes", new String[]{"String", "double", "double"});
        reflect_MathHelper_method_parseDoubleWithDefaultAndMax_30.setCallbackDoubleWithDataArg("exec", (BaseData params) -> {
                try {
                    return (double) MathHelper.parseDoubleWithDefaultAndMax((String) params.getString("parString1"), (double) params.getDouble("parDouble1"), (double) params.getDouble("parDouble2"));
                } catch (Exception _exception_reflect_) {
                    return 0.0d;
                }
            });
            
        reflect_MathHelper_methods.add(reflect_MathHelper_method_parseDoubleWithDefaultAndMax_30);


        BaseData reflect_MathHelper_method_roundUpToPowerOfTwo_31 = new ModData();
        reflect_MathHelper_method_roundUpToPowerOfTwo_31.set("methodName", "roundUpToPowerOfTwo");
        reflect_MathHelper_method_roundUpToPowerOfTwo_31.set("returnType", "int");
        reflect_MathHelper_method_roundUpToPowerOfTwo_31.set("static", true);
        reflect_MathHelper_method_roundUpToPowerOfTwo_31.set("argnames", new String[]{"value"});
        reflect_MathHelper_method_roundUpToPowerOfTwo_31.set("argtypes", new String[]{"int"});
        reflect_MathHelper_method_roundUpToPowerOfTwo_31.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) MathHelper.roundUpToPowerOfTwo((int) params.getInt("value"));
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_MathHelper_methods.add(reflect_MathHelper_method_roundUpToPowerOfTwo_31);


        BaseData reflect_MathHelper_method_calculateLogBaseTwo_32 = new ModData();
        reflect_MathHelper_method_calculateLogBaseTwo_32.set("methodName", "calculateLogBaseTwo");
        reflect_MathHelper_method_calculateLogBaseTwo_32.set("returnType", "int");
        reflect_MathHelper_method_calculateLogBaseTwo_32.set("static", true);
        reflect_MathHelper_method_calculateLogBaseTwo_32.set("argnames", new String[]{"value"});
        reflect_MathHelper_method_calculateLogBaseTwo_32.set("argtypes", new String[]{"int"});
        reflect_MathHelper_method_calculateLogBaseTwo_32.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) MathHelper.calculateLogBaseTwo((int) params.getInt("value"));
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_MathHelper_methods.add(reflect_MathHelper_method_calculateLogBaseTwo_32);


        BaseData reflect_MathHelper_method_func_154354_b_33 = new ModData();
        reflect_MathHelper_method_func_154354_b_33.set("methodName", "func_154354_b");
        reflect_MathHelper_method_func_154354_b_33.set("returnType", "int");
        reflect_MathHelper_method_func_154354_b_33.set("static", true);
        reflect_MathHelper_method_func_154354_b_33.set("argnames", new String[]{"parInt1", "parInt2"});
        reflect_MathHelper_method_func_154354_b_33.set("argtypes", new String[]{"int", "int"});
        reflect_MathHelper_method_func_154354_b_33.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) MathHelper.func_154354_b((int) params.getInt("parInt1"), (int) params.getInt("parInt2"));
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_MathHelper_methods.add(reflect_MathHelper_method_func_154354_b_33);


        BaseData reflect_MathHelper_method_func_180183_b_34 = new ModData();
        reflect_MathHelper_method_func_180183_b_34.set("methodName", "func_180183_b");
        reflect_MathHelper_method_func_180183_b_34.set("returnType", "int");
        reflect_MathHelper_method_func_180183_b_34.set("static", true);
        reflect_MathHelper_method_func_180183_b_34.set("argnames", new String[]{"parFloat1", "parFloat2", "parFloat3"});
        reflect_MathHelper_method_func_180183_b_34.set("argtypes", new String[]{"float", "float", "float"});
        reflect_MathHelper_method_func_180183_b_34.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) MathHelper.func_180183_b((float) params.getFloat("parFloat1"), (float) params.getFloat("parFloat2"), (float) params.getFloat("parFloat3"));
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_MathHelper_methods.add(reflect_MathHelper_method_func_180183_b_34);


        BaseData reflect_MathHelper_method_func_180181_b_35 = new ModData();
        reflect_MathHelper_method_func_180181_b_35.set("methodName", "func_180181_b");
        reflect_MathHelper_method_func_180181_b_35.set("returnType", "int");
        reflect_MathHelper_method_func_180181_b_35.set("static", true);
        reflect_MathHelper_method_func_180181_b_35.set("argnames", new String[]{"parInt1", "parInt2", "parInt3"});
        reflect_MathHelper_method_func_180181_b_35.set("argtypes", new String[]{"int", "int", "int"});
        reflect_MathHelper_method_func_180181_b_35.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) MathHelper.func_180181_b((int) params.getInt("parInt1"), (int) params.getInt("parInt2"), (int) params.getInt("parInt3"));
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_MathHelper_methods.add(reflect_MathHelper_method_func_180181_b_35);


        BaseData reflect_MathHelper_method_func_180188_d_36 = new ModData();
        reflect_MathHelper_method_func_180188_d_36.set("methodName", "func_180188_d");
        reflect_MathHelper_method_func_180188_d_36.set("returnType", "int");
        reflect_MathHelper_method_func_180188_d_36.set("static", true);
        reflect_MathHelper_method_func_180188_d_36.set("argnames", new String[]{"parInt1", "parInt2"});
        reflect_MathHelper_method_func_180188_d_36.set("argtypes", new String[]{"int", "int"});
        reflect_MathHelper_method_func_180188_d_36.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) MathHelper.func_180188_d((int) params.getInt("parInt1"), (int) params.getInt("parInt2"));
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_MathHelper_methods.add(reflect_MathHelper_method_func_180188_d_36);


        BaseData reflect_MathHelper_method_func_181162_h_37 = new ModData();
        reflect_MathHelper_method_func_181162_h_37.set("methodName", "func_181162_h");
        reflect_MathHelper_method_func_181162_h_37.set("returnType", "double");
        reflect_MathHelper_method_func_181162_h_37.set("static", true);
        reflect_MathHelper_method_func_181162_h_37.set("argnames", new String[]{"parDouble1"});
        reflect_MathHelper_method_func_181162_h_37.set("argtypes", new String[]{"double"});
        reflect_MathHelper_method_func_181162_h_37.setCallbackDoubleWithDataArg("exec", (BaseData params) -> {
                try {
                    return (double) MathHelper.func_181162_h((double) params.getDouble("parDouble1"));
                } catch (Exception _exception_reflect_) {
                    return 0.0d;
                }
            });
            
        reflect_MathHelper_methods.add(reflect_MathHelper_method_func_181162_h_37);


        BaseData reflect_MathHelper_method_getPositionRandom_38 = new ModData();
        reflect_MathHelper_method_getPositionRandom_38.set("methodName", "getPositionRandom");
        reflect_MathHelper_method_getPositionRandom_38.set("returnType", "long");
        reflect_MathHelper_method_getPositionRandom_38.set("static", true);
        reflect_MathHelper_method_getPositionRandom_38.set("argnames", new String[]{"pos"});
        reflect_MathHelper_method_getPositionRandom_38.set("argtypes", new String[]{"Vec3i"});
        reflect_MathHelper_method_getPositionRandom_38.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (long) MathHelper.getPositionRandom((Vec3i) params.getReflective("pos"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_MathHelper_methods.add(reflect_MathHelper_method_getPositionRandom_38);


        BaseData reflect_MathHelper_method_getCoordinateRandom_39 = new ModData();
        reflect_MathHelper_method_getCoordinateRandom_39.set("methodName", "getCoordinateRandom");
        reflect_MathHelper_method_getCoordinateRandom_39.set("returnType", "long");
        reflect_MathHelper_method_getCoordinateRandom_39.set("static", true);
        reflect_MathHelper_method_getCoordinateRandom_39.set("argnames", new String[]{"x", "y", "z"});
        reflect_MathHelper_method_getCoordinateRandom_39.set("argtypes", new String[]{"int", "int", "int"});
        reflect_MathHelper_method_getCoordinateRandom_39.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (long) MathHelper.getCoordinateRandom((int) params.getInt("x"), (int) params.getInt("y"), (int) params.getInt("z"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_MathHelper_methods.add(reflect_MathHelper_method_getCoordinateRandom_39);


        BaseData reflect_MathHelper_method_getRandomUuid_40 = new ModData();
        reflect_MathHelper_method_getRandomUuid_40.set("methodName", "getRandomUuid");
        reflect_MathHelper_method_getRandomUuid_40.set("returnType", "EaglercraftUUID");
        reflect_MathHelper_method_getRandomUuid_40.set("static", true);
        reflect_MathHelper_method_getRandomUuid_40.set("argnames", new String[]{"rand"});
        reflect_MathHelper_method_getRandomUuid_40.set("argtypes", new String[]{"EaglercraftRandom"});
        reflect_MathHelper_method_getRandomUuid_40.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EaglercraftUUID) MathHelper.getRandomUuid((EaglercraftRandom) params.getReflective("rand"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_MathHelper_methods.add(reflect_MathHelper_method_getRandomUuid_40);


        BaseData reflect_MathHelper_method_func_181160_c_41 = new ModData();
        reflect_MathHelper_method_func_181160_c_41.set("methodName", "func_181160_c");
        reflect_MathHelper_method_func_181160_c_41.set("returnType", "double");
        reflect_MathHelper_method_func_181160_c_41.set("static", true);
        reflect_MathHelper_method_func_181160_c_41.set("argnames", new String[]{"parDouble1", "parDouble2", "parDouble3"});
        reflect_MathHelper_method_func_181160_c_41.set("argtypes", new String[]{"double", "double", "double"});
        reflect_MathHelper_method_func_181160_c_41.setCallbackDoubleWithDataArg("exec", (BaseData params) -> {
                try {
                    return (double) MathHelper.func_181160_c((double) params.getDouble("parDouble1"), (double) params.getDouble("parDouble2"), (double) params.getDouble("parDouble3"));
                } catch (Exception _exception_reflect_) {
                    return 0.0d;
                }
            });
            
        reflect_MathHelper_methods.add(reflect_MathHelper_method_func_181160_c_41);


        BaseData reflect_MathHelper_method_func_181159_b_42 = new ModData();
        reflect_MathHelper_method_func_181159_b_42.set("methodName", "func_181159_b");
        reflect_MathHelper_method_func_181159_b_42.set("returnType", "double");
        reflect_MathHelper_method_func_181159_b_42.set("static", true);
        reflect_MathHelper_method_func_181159_b_42.set("argnames", new String[]{"parDouble1", "parDouble2"});
        reflect_MathHelper_method_func_181159_b_42.set("argtypes", new String[]{"double", "double"});
        reflect_MathHelper_method_func_181159_b_42.setCallbackDoubleWithDataArg("exec", (BaseData params) -> {
                try {
                    return (double) MathHelper.func_181159_b((double) params.getDouble("parDouble1"), (double) params.getDouble("parDouble2"));
                } catch (Exception _exception_reflect_) {
                    return 0.0d;
                }
            });
            
        reflect_MathHelper_methods.add(reflect_MathHelper_method_func_181159_b_42);


        BaseData reflect_MathHelper_method_func_181161_i_43 = new ModData();
        reflect_MathHelper_method_func_181161_i_43.set("methodName", "func_181161_i");
        reflect_MathHelper_method_func_181161_i_43.set("returnType", "double");
        reflect_MathHelper_method_func_181161_i_43.set("static", true);
        reflect_MathHelper_method_func_181161_i_43.set("argnames", new String[]{"parDouble1"});
        reflect_MathHelper_method_func_181161_i_43.set("argtypes", new String[]{"double"});
        reflect_MathHelper_method_func_181161_i_43.setCallbackDoubleWithDataArg("exec", (BaseData params) -> {
                try {
                    return (double) MathHelper.func_181161_i((double) params.getDouble("parDouble1"));
                } catch (Exception _exception_reflect_) {
                    return 0.0d;
                }
            });
            
        reflect_MathHelper_methods.add(reflect_MathHelper_method_func_181161_i_43);


        BaseData reflect_MathHelper_method_func_181758_c_44 = new ModData();
        reflect_MathHelper_method_func_181758_c_44.set("methodName", "func_181758_c");
        reflect_MathHelper_method_func_181758_c_44.set("returnType", "int");
        reflect_MathHelper_method_func_181758_c_44.set("static", true);
        reflect_MathHelper_method_func_181758_c_44.set("argnames", new String[]{"parFloat1", "parFloat2", "parFloat3"});
        reflect_MathHelper_method_func_181758_c_44.set("argtypes", new String[]{"float", "float", "float"});
        reflect_MathHelper_method_func_181758_c_44.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) MathHelper.func_181758_c((float) params.getFloat("parFloat1"), (float) params.getFloat("parFloat2"), (float) params.getFloat("parFloat3"));
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_MathHelper_methods.add(reflect_MathHelper_method_func_181758_c_44);


        BaseData[] reflect_MathHelper_methods_arr = new BaseData[reflect_MathHelper_methods.size()];
        for (int i = 0; i < reflect_MathHelper_methods_arr.length; i++) {
            reflect_MathHelper_methods_arr[i] = reflect_MathHelper_methods.get(i);
        }

        reflect_MathHelper.set("constructors", reflect_MathHelper_constructors_arr);
        reflect_MathHelper.set("methods", reflect_MathHelper_methods_arr);
        reflect_MathHelper.set("className", "MathHelper");
        reflect_MathHelper.set("classId", "net.minecraft.util.MathHelper");
        reflect_MathHelper.set("class", MathHelper.class);
        reflect_MathHelper.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof MathHelper;
        });
        reflectProfiles.add(reflect_MathHelper);
    }


    //classdef for Vec3
    public static void reflect_Vec3_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_Vec3 = new ModData();

        ArrayList<BaseData> reflect_Vec3_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_Vec3_constructor_Vec3_0 = new ModData();
        reflect_Vec3_constructor_Vec3_0.set("returnType", "Vec3");
        reflect_Vec3_constructor_Vec3_0.set("argnames", new String[]{"x", "y", "z"});
        reflect_Vec3_constructor_Vec3_0.set("argtypes", new String[]{"double", "double", "double"});
        reflect_Vec3_constructor_Vec3_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new Vec3((double) params.getDouble("x"), (double) params.getDouble("y"), (double) params.getDouble("z"));
        });
        
        reflect_Vec3_constructors.add(reflect_Vec3_constructor_Vec3_0);


        BaseData reflect_Vec3_constructor_Vec3_1 = new ModData();
        reflect_Vec3_constructor_Vec3_1.set("returnType", "Vec3");
        reflect_Vec3_constructor_Vec3_1.set("argnames", new String[]{"parVec3i"});
        reflect_Vec3_constructor_Vec3_1.set("argtypes", new String[]{"Vec3i"});
        reflect_Vec3_constructor_Vec3_1.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new Vec3((Vec3i) params.getReflective("parVec3i"));
        });
        
        reflect_Vec3_constructors.add(reflect_Vec3_constructor_Vec3_1);


        BaseData[] reflect_Vec3_constructors_arr = new BaseData[reflect_Vec3_constructors.size()];
        for (int i = 0; i < reflect_Vec3_constructors_arr.length; i++) {
            reflect_Vec3_constructors_arr[i] = reflect_Vec3_constructors.get(i);
        }

        ArrayList<BaseData> reflect_Vec3_methods = new ArrayList<BaseData>();
        
        BaseData reflect_Vec3_method_subtractReverse_0 = new ModData();
        reflect_Vec3_method_subtractReverse_0.set("methodName", "subtractReverse");
        reflect_Vec3_method_subtractReverse_0.set("returnType", "Vec3");
        reflect_Vec3_method_subtractReverse_0.set("static", false);
        reflect_Vec3_method_subtractReverse_0.set("argnames", new String[]{"vec"});
        reflect_Vec3_method_subtractReverse_0.set("argtypes", new String[]{"Vec3"});
        reflect_Vec3_method_subtractReverse_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Vec3) ((Vec3) params.getReflective("_self")).subtractReverse((Vec3) params.getReflective("vec"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Vec3_methods.add(reflect_Vec3_method_subtractReverse_0);


        BaseData reflect_Vec3_method_normalize_1 = new ModData();
        reflect_Vec3_method_normalize_1.set("methodName", "normalize");
        reflect_Vec3_method_normalize_1.set("returnType", "Vec3");
        reflect_Vec3_method_normalize_1.set("static", false);
        reflect_Vec3_method_normalize_1.set("argnames", new String[]{});
        reflect_Vec3_method_normalize_1.set("argtypes", new String[]{});
        reflect_Vec3_method_normalize_1.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Vec3) ((Vec3) params.getReflective("_self")).normalize();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Vec3_methods.add(reflect_Vec3_method_normalize_1);


        BaseData reflect_Vec3_method_dotProduct_2 = new ModData();
        reflect_Vec3_method_dotProduct_2.set("methodName", "dotProduct");
        reflect_Vec3_method_dotProduct_2.set("returnType", "double");
        reflect_Vec3_method_dotProduct_2.set("static", false);
        reflect_Vec3_method_dotProduct_2.set("argnames", new String[]{"vec"});
        reflect_Vec3_method_dotProduct_2.set("argtypes", new String[]{"Vec3"});
        reflect_Vec3_method_dotProduct_2.setCallbackDoubleWithDataArg("exec", (BaseData params) -> {
                try {
                    return (double) ((Vec3) params.getReflective("_self")).dotProduct((Vec3) params.getReflective("vec"));
                } catch (Exception _exception_reflect_) {
                    return 0.0d;
                }
            });
            
        reflect_Vec3_methods.add(reflect_Vec3_method_dotProduct_2);


        BaseData reflect_Vec3_method_crossProduct_3 = new ModData();
        reflect_Vec3_method_crossProduct_3.set("methodName", "crossProduct");
        reflect_Vec3_method_crossProduct_3.set("returnType", "Vec3");
        reflect_Vec3_method_crossProduct_3.set("static", false);
        reflect_Vec3_method_crossProduct_3.set("argnames", new String[]{"vec"});
        reflect_Vec3_method_crossProduct_3.set("argtypes", new String[]{"Vec3"});
        reflect_Vec3_method_crossProduct_3.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Vec3) ((Vec3) params.getReflective("_self")).crossProduct((Vec3) params.getReflective("vec"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Vec3_methods.add(reflect_Vec3_method_crossProduct_3);


        BaseData reflect_Vec3_method_subtract_4 = new ModData();
        reflect_Vec3_method_subtract_4.set("methodName", "subtract");
        reflect_Vec3_method_subtract_4.set("returnType", "Vec3");
        reflect_Vec3_method_subtract_4.set("static", false);
        reflect_Vec3_method_subtract_4.set("argnames", new String[]{"vec"});
        reflect_Vec3_method_subtract_4.set("argtypes", new String[]{"Vec3"});
        reflect_Vec3_method_subtract_4.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Vec3) ((Vec3) params.getReflective("_self")).subtract((Vec3) params.getReflective("vec"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Vec3_methods.add(reflect_Vec3_method_subtract_4);


        BaseData reflect_Vec3_method_subtract_5 = new ModData();
        reflect_Vec3_method_subtract_5.set("methodName", "subtract");
        reflect_Vec3_method_subtract_5.set("returnType", "Vec3");
        reflect_Vec3_method_subtract_5.set("static", false);
        reflect_Vec3_method_subtract_5.set("argnames", new String[]{"x", "y", "z"});
        reflect_Vec3_method_subtract_5.set("argtypes", new String[]{"double", "double", "double"});
        reflect_Vec3_method_subtract_5.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Vec3) ((Vec3) params.getReflective("_self")).subtract((double) params.getDouble("x"), (double) params.getDouble("y"), (double) params.getDouble("z"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Vec3_methods.add(reflect_Vec3_method_subtract_5);


        BaseData reflect_Vec3_method_add_6 = new ModData();
        reflect_Vec3_method_add_6.set("methodName", "add");
        reflect_Vec3_method_add_6.set("returnType", "Vec3");
        reflect_Vec3_method_add_6.set("static", false);
        reflect_Vec3_method_add_6.set("argnames", new String[]{"vec"});
        reflect_Vec3_method_add_6.set("argtypes", new String[]{"Vec3"});
        reflect_Vec3_method_add_6.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Vec3) ((Vec3) params.getReflective("_self")).add((Vec3) params.getReflective("vec"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Vec3_methods.add(reflect_Vec3_method_add_6);


        BaseData reflect_Vec3_method_addVector_7 = new ModData();
        reflect_Vec3_method_addVector_7.set("methodName", "addVector");
        reflect_Vec3_method_addVector_7.set("returnType", "Vec3");
        reflect_Vec3_method_addVector_7.set("static", false);
        reflect_Vec3_method_addVector_7.set("argnames", new String[]{"x", "y", "z"});
        reflect_Vec3_method_addVector_7.set("argtypes", new String[]{"double", "double", "double"});
        reflect_Vec3_method_addVector_7.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Vec3) ((Vec3) params.getReflective("_self")).addVector((double) params.getDouble("x"), (double) params.getDouble("y"), (double) params.getDouble("z"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Vec3_methods.add(reflect_Vec3_method_addVector_7);


        BaseData reflect_Vec3_method_distanceTo_8 = new ModData();
        reflect_Vec3_method_distanceTo_8.set("methodName", "distanceTo");
        reflect_Vec3_method_distanceTo_8.set("returnType", "double");
        reflect_Vec3_method_distanceTo_8.set("static", false);
        reflect_Vec3_method_distanceTo_8.set("argnames", new String[]{"vec"});
        reflect_Vec3_method_distanceTo_8.set("argtypes", new String[]{"Vec3"});
        reflect_Vec3_method_distanceTo_8.setCallbackDoubleWithDataArg("exec", (BaseData params) -> {
                try {
                    return (double) ((Vec3) params.getReflective("_self")).distanceTo((Vec3) params.getReflective("vec"));
                } catch (Exception _exception_reflect_) {
                    return 0.0d;
                }
            });
            
        reflect_Vec3_methods.add(reflect_Vec3_method_distanceTo_8);


        BaseData reflect_Vec3_method_squareDistanceTo_9 = new ModData();
        reflect_Vec3_method_squareDistanceTo_9.set("methodName", "squareDistanceTo");
        reflect_Vec3_method_squareDistanceTo_9.set("returnType", "double");
        reflect_Vec3_method_squareDistanceTo_9.set("static", false);
        reflect_Vec3_method_squareDistanceTo_9.set("argnames", new String[]{"vec"});
        reflect_Vec3_method_squareDistanceTo_9.set("argtypes", new String[]{"Vec3"});
        reflect_Vec3_method_squareDistanceTo_9.setCallbackDoubleWithDataArg("exec", (BaseData params) -> {
                try {
                    return (double) ((Vec3) params.getReflective("_self")).squareDistanceTo((Vec3) params.getReflective("vec"));
                } catch (Exception _exception_reflect_) {
                    return 0.0d;
                }
            });
            
        reflect_Vec3_methods.add(reflect_Vec3_method_squareDistanceTo_9);


        BaseData reflect_Vec3_method_lengthVector_10 = new ModData();
        reflect_Vec3_method_lengthVector_10.set("methodName", "lengthVector");
        reflect_Vec3_method_lengthVector_10.set("returnType", "double");
        reflect_Vec3_method_lengthVector_10.set("static", false);
        reflect_Vec3_method_lengthVector_10.set("argnames", new String[]{});
        reflect_Vec3_method_lengthVector_10.set("argtypes", new String[]{});
        reflect_Vec3_method_lengthVector_10.setCallbackDoubleWithDataArg("exec", (BaseData params) -> {
                try {
                    return (double) ((Vec3) params.getReflective("_self")).lengthVector();
                } catch (Exception _exception_reflect_) {
                    return 0.0d;
                }
            });
            
        reflect_Vec3_methods.add(reflect_Vec3_method_lengthVector_10);


        BaseData reflect_Vec3_method_getIntermediateWithXValue_11 = new ModData();
        reflect_Vec3_method_getIntermediateWithXValue_11.set("methodName", "getIntermediateWithXValue");
        reflect_Vec3_method_getIntermediateWithXValue_11.set("returnType", "Vec3");
        reflect_Vec3_method_getIntermediateWithXValue_11.set("static", false);
        reflect_Vec3_method_getIntermediateWithXValue_11.set("argnames", new String[]{"vec", "x"});
        reflect_Vec3_method_getIntermediateWithXValue_11.set("argtypes", new String[]{"Vec3", "double"});
        reflect_Vec3_method_getIntermediateWithXValue_11.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Vec3) ((Vec3) params.getReflective("_self")).getIntermediateWithXValue((Vec3) params.getReflective("vec"), (double) params.getDouble("x"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Vec3_methods.add(reflect_Vec3_method_getIntermediateWithXValue_11);


        BaseData reflect_Vec3_method_getIntermediateWithYValue_12 = new ModData();
        reflect_Vec3_method_getIntermediateWithYValue_12.set("methodName", "getIntermediateWithYValue");
        reflect_Vec3_method_getIntermediateWithYValue_12.set("returnType", "Vec3");
        reflect_Vec3_method_getIntermediateWithYValue_12.set("static", false);
        reflect_Vec3_method_getIntermediateWithYValue_12.set("argnames", new String[]{"vec", "y"});
        reflect_Vec3_method_getIntermediateWithYValue_12.set("argtypes", new String[]{"Vec3", "double"});
        reflect_Vec3_method_getIntermediateWithYValue_12.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Vec3) ((Vec3) params.getReflective("_self")).getIntermediateWithYValue((Vec3) params.getReflective("vec"), (double) params.getDouble("y"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Vec3_methods.add(reflect_Vec3_method_getIntermediateWithYValue_12);


        BaseData reflect_Vec3_method_getIntermediateWithZValue_13 = new ModData();
        reflect_Vec3_method_getIntermediateWithZValue_13.set("methodName", "getIntermediateWithZValue");
        reflect_Vec3_method_getIntermediateWithZValue_13.set("returnType", "Vec3");
        reflect_Vec3_method_getIntermediateWithZValue_13.set("static", false);
        reflect_Vec3_method_getIntermediateWithZValue_13.set("argnames", new String[]{"vec", "z"});
        reflect_Vec3_method_getIntermediateWithZValue_13.set("argtypes", new String[]{"Vec3", "double"});
        reflect_Vec3_method_getIntermediateWithZValue_13.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Vec3) ((Vec3) params.getReflective("_self")).getIntermediateWithZValue((Vec3) params.getReflective("vec"), (double) params.getDouble("z"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Vec3_methods.add(reflect_Vec3_method_getIntermediateWithZValue_13);


        BaseData reflect_Vec3_method_toString_14 = new ModData();
        reflect_Vec3_method_toString_14.set("methodName", "toString");
        reflect_Vec3_method_toString_14.set("returnType", "String");
        reflect_Vec3_method_toString_14.set("static", false);
        reflect_Vec3_method_toString_14.set("argnames", new String[]{});
        reflect_Vec3_method_toString_14.set("argtypes", new String[]{});
        reflect_Vec3_method_toString_14.setCallbackStringWithDataArg("exec", (BaseData params) -> {
                try {
                    return (String) ((Vec3) params.getReflective("_self")).toString();
                } catch (Exception _exception_reflect_) {
                    return "";
                }
            });
            
        reflect_Vec3_methods.add(reflect_Vec3_method_toString_14);


        BaseData reflect_Vec3_method_rotatePitch_15 = new ModData();
        reflect_Vec3_method_rotatePitch_15.set("methodName", "rotatePitch");
        reflect_Vec3_method_rotatePitch_15.set("returnType", "Vec3");
        reflect_Vec3_method_rotatePitch_15.set("static", false);
        reflect_Vec3_method_rotatePitch_15.set("argnames", new String[]{"pitch"});
        reflect_Vec3_method_rotatePitch_15.set("argtypes", new String[]{"float"});
        reflect_Vec3_method_rotatePitch_15.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Vec3) ((Vec3) params.getReflective("_self")).rotatePitch((float) params.getFloat("pitch"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Vec3_methods.add(reflect_Vec3_method_rotatePitch_15);


        BaseData reflect_Vec3_method_rotateYaw_16 = new ModData();
        reflect_Vec3_method_rotateYaw_16.set("methodName", "rotateYaw");
        reflect_Vec3_method_rotateYaw_16.set("returnType", "Vec3");
        reflect_Vec3_method_rotateYaw_16.set("static", false);
        reflect_Vec3_method_rotateYaw_16.set("argnames", new String[]{"yaw"});
        reflect_Vec3_method_rotateYaw_16.set("argtypes", new String[]{"float"});
        reflect_Vec3_method_rotateYaw_16.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Vec3) ((Vec3) params.getReflective("_self")).rotateYaw((float) params.getFloat("yaw"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Vec3_methods.add(reflect_Vec3_method_rotateYaw_16);


        BaseData reflect_Vec3_method_loadModData_17 = new ModData();
        reflect_Vec3_method_loadModData_17.set("methodName", "loadModData");
        reflect_Vec3_method_loadModData_17.set("returnType", "void");
        reflect_Vec3_method_loadModData_17.set("static", false);
        reflect_Vec3_method_loadModData_17.set("argnames", new String[]{"data"});
        reflect_Vec3_method_loadModData_17.set("argtypes", new String[]{"BaseData"});
        reflect_Vec3_method_loadModData_17.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Vec3) params.getReflective("_self")).loadModData((BaseData) params.getReflective("data"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Vec3_methods.add(reflect_Vec3_method_loadModData_17);


        BaseData reflect_Vec3_method_fromModData_18 = new ModData();
        reflect_Vec3_method_fromModData_18.set("methodName", "fromModData");
        reflect_Vec3_method_fromModData_18.set("returnType", "Vec3");
        reflect_Vec3_method_fromModData_18.set("static", true);
        reflect_Vec3_method_fromModData_18.set("argnames", new String[]{"data"});
        reflect_Vec3_method_fromModData_18.set("argtypes", new String[]{"BaseData"});
        reflect_Vec3_method_fromModData_18.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Vec3) Vec3.fromModData((BaseData) params.getReflective("data"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Vec3_methods.add(reflect_Vec3_method_fromModData_18);


        BaseData reflect_Vec3_method_makeModData_19 = new ModData();
        reflect_Vec3_method_makeModData_19.set("methodName", "makeModData");
        reflect_Vec3_method_makeModData_19.set("returnType", "ModData");
        reflect_Vec3_method_makeModData_19.set("static", false);
        reflect_Vec3_method_makeModData_19.set("argnames", new String[]{});
        reflect_Vec3_method_makeModData_19.set("argtypes", new String[]{});
        reflect_Vec3_method_makeModData_19.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (ModData) ((Vec3) params.getReflective("_self")).makeModData();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Vec3_methods.add(reflect_Vec3_method_makeModData_19);


        BaseData[] reflect_Vec3_methods_arr = new BaseData[reflect_Vec3_methods.size()];
        for (int i = 0; i < reflect_Vec3_methods_arr.length; i++) {
            reflect_Vec3_methods_arr[i] = reflect_Vec3_methods.get(i);
        }

        reflect_Vec3.set("constructors", reflect_Vec3_constructors_arr);
        reflect_Vec3.set("methods", reflect_Vec3_methods_arr);
        reflect_Vec3.set("className", "Vec3");
        reflect_Vec3.set("classId", "net.minecraft.util.Vec3");
        reflect_Vec3.set("class", Vec3.class);
        reflect_Vec3.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof Vec3;
        });
        reflectProfiles.add(reflect_Vec3);
    }


    //classdef for MinecraftServer
    public static void reflect_MinecraftServer_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_MinecraftServer = new ModData();

        ArrayList<BaseData> reflect_MinecraftServer_constructors = new ArrayList<BaseData>();
        
        BaseData[] reflect_MinecraftServer_constructors_arr = new BaseData[reflect_MinecraftServer_constructors.size()];
        for (int i = 0; i < reflect_MinecraftServer_constructors_arr.length; i++) {
            reflect_MinecraftServer_constructors_arr[i] = reflect_MinecraftServer_constructors.get(i);
        }

        ArrayList<BaseData> reflect_MinecraftServer_methods = new ArrayList<BaseData>();
        
        BaseData reflect_MinecraftServer_method_saveAllWorlds_0 = new ModData();
        reflect_MinecraftServer_method_saveAllWorlds_0.set("methodName", "saveAllWorlds");
        reflect_MinecraftServer_method_saveAllWorlds_0.set("returnType", "void");
        reflect_MinecraftServer_method_saveAllWorlds_0.set("static", false);
        reflect_MinecraftServer_method_saveAllWorlds_0.set("argnames", new String[]{"dontLog"});
        reflect_MinecraftServer_method_saveAllWorlds_0.set("argtypes", new String[]{"boolean"});
        reflect_MinecraftServer_method_saveAllWorlds_0.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((MinecraftServer) params.getReflective("_self")).saveAllWorlds((boolean) params.getBoolean("dontLog"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_saveAllWorlds_0);


        BaseData reflect_MinecraftServer_method_stopServer_1 = new ModData();
        reflect_MinecraftServer_method_stopServer_1.set("methodName", "stopServer");
        reflect_MinecraftServer_method_stopServer_1.set("returnType", "void");
        reflect_MinecraftServer_method_stopServer_1.set("static", false);
        reflect_MinecraftServer_method_stopServer_1.set("argnames", new String[]{});
        reflect_MinecraftServer_method_stopServer_1.set("argtypes", new String[]{});
        reflect_MinecraftServer_method_stopServer_1.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((MinecraftServer) params.getReflective("_self")).stopServer();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_stopServer_1);


        BaseData reflect_MinecraftServer_method_deleteWorldAndStopServer_2 = new ModData();
        reflect_MinecraftServer_method_deleteWorldAndStopServer_2.set("methodName", "deleteWorldAndStopServer");
        reflect_MinecraftServer_method_deleteWorldAndStopServer_2.set("returnType", "void");
        reflect_MinecraftServer_method_deleteWorldAndStopServer_2.set("static", false);
        reflect_MinecraftServer_method_deleteWorldAndStopServer_2.set("argnames", new String[]{});
        reflect_MinecraftServer_method_deleteWorldAndStopServer_2.set("argtypes", new String[]{});
        reflect_MinecraftServer_method_deleteWorldAndStopServer_2.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((MinecraftServer) params.getReflective("_self")).deleteWorldAndStopServer();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_deleteWorldAndStopServer_2);


        BaseData reflect_MinecraftServer_method_isServerRunning_3 = new ModData();
        reflect_MinecraftServer_method_isServerRunning_3.set("methodName", "isServerRunning");
        reflect_MinecraftServer_method_isServerRunning_3.set("returnType", "boolean");
        reflect_MinecraftServer_method_isServerRunning_3.set("static", false);
        reflect_MinecraftServer_method_isServerRunning_3.set("argnames", new String[]{});
        reflect_MinecraftServer_method_isServerRunning_3.set("argtypes", new String[]{});
        reflect_MinecraftServer_method_isServerRunning_3.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((MinecraftServer) params.getReflective("_self")).isServerRunning();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_isServerRunning_3);


        BaseData reflect_MinecraftServer_method_initiateShutdown_4 = new ModData();
        reflect_MinecraftServer_method_initiateShutdown_4.set("methodName", "initiateShutdown");
        reflect_MinecraftServer_method_initiateShutdown_4.set("returnType", "void");
        reflect_MinecraftServer_method_initiateShutdown_4.set("static", false);
        reflect_MinecraftServer_method_initiateShutdown_4.set("argnames", new String[]{});
        reflect_MinecraftServer_method_initiateShutdown_4.set("argtypes", new String[]{});
        reflect_MinecraftServer_method_initiateShutdown_4.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((MinecraftServer) params.getReflective("_self")).initiateShutdown();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_initiateShutdown_4);


        BaseData reflect_MinecraftServer_method_run_5 = new ModData();
        reflect_MinecraftServer_method_run_5.set("methodName", "run");
        reflect_MinecraftServer_method_run_5.set("returnType", "void");
        reflect_MinecraftServer_method_run_5.set("static", false);
        reflect_MinecraftServer_method_run_5.set("argnames", new String[]{});
        reflect_MinecraftServer_method_run_5.set("argtypes", new String[]{});
        reflect_MinecraftServer_method_run_5.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((MinecraftServer) params.getReflective("_self")).run();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_run_5);


        BaseData reflect_MinecraftServer_method_tick_6 = new ModData();
        reflect_MinecraftServer_method_tick_6.set("methodName", "tick");
        reflect_MinecraftServer_method_tick_6.set("returnType", "void");
        reflect_MinecraftServer_method_tick_6.set("static", false);
        reflect_MinecraftServer_method_tick_6.set("argnames", new String[]{});
        reflect_MinecraftServer_method_tick_6.set("argtypes", new String[]{});
        reflect_MinecraftServer_method_tick_6.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((MinecraftServer) params.getReflective("_self")).tick();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_tick_6);


        BaseData reflect_MinecraftServer_method_updateTimeLightAndEntities_7 = new ModData();
        reflect_MinecraftServer_method_updateTimeLightAndEntities_7.set("methodName", "updateTimeLightAndEntities");
        reflect_MinecraftServer_method_updateTimeLightAndEntities_7.set("returnType", "void");
        reflect_MinecraftServer_method_updateTimeLightAndEntities_7.set("static", false);
        reflect_MinecraftServer_method_updateTimeLightAndEntities_7.set("argnames", new String[]{});
        reflect_MinecraftServer_method_updateTimeLightAndEntities_7.set("argtypes", new String[]{});
        reflect_MinecraftServer_method_updateTimeLightAndEntities_7.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((MinecraftServer) params.getReflective("_self")).updateTimeLightAndEntities();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_updateTimeLightAndEntities_7);


        BaseData reflect_MinecraftServer_method_getAllowNether_8 = new ModData();
        reflect_MinecraftServer_method_getAllowNether_8.set("methodName", "getAllowNether");
        reflect_MinecraftServer_method_getAllowNether_8.set("returnType", "boolean");
        reflect_MinecraftServer_method_getAllowNether_8.set("static", false);
        reflect_MinecraftServer_method_getAllowNether_8.set("argnames", new String[]{});
        reflect_MinecraftServer_method_getAllowNether_8.set("argtypes", new String[]{});
        reflect_MinecraftServer_method_getAllowNether_8.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((MinecraftServer) params.getReflective("_self")).getAllowNether();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_getAllowNether_8);


        BaseData reflect_MinecraftServer_method_startServerThread_9 = new ModData();
        reflect_MinecraftServer_method_startServerThread_9.set("methodName", "startServerThread");
        reflect_MinecraftServer_method_startServerThread_9.set("returnType", "void");
        reflect_MinecraftServer_method_startServerThread_9.set("static", false);
        reflect_MinecraftServer_method_startServerThread_9.set("argnames", new String[]{});
        reflect_MinecraftServer_method_startServerThread_9.set("argtypes", new String[]{});
        reflect_MinecraftServer_method_startServerThread_9.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((MinecraftServer) params.getReflective("_self")).startServerThread();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_startServerThread_9);


        BaseData reflect_MinecraftServer_method_logWarning_10 = new ModData();
        reflect_MinecraftServer_method_logWarning_10.set("methodName", "logWarning");
        reflect_MinecraftServer_method_logWarning_10.set("returnType", "void");
        reflect_MinecraftServer_method_logWarning_10.set("static", false);
        reflect_MinecraftServer_method_logWarning_10.set("argnames", new String[]{"s"});
        reflect_MinecraftServer_method_logWarning_10.set("argtypes", new String[]{"String"});
        reflect_MinecraftServer_method_logWarning_10.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((MinecraftServer) params.getReflective("_self")).logWarning((String) params.getString("s"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_logWarning_10);


        BaseData reflect_MinecraftServer_method_worldServerForDimension_11 = new ModData();
        reflect_MinecraftServer_method_worldServerForDimension_11.set("methodName", "worldServerForDimension");
        reflect_MinecraftServer_method_worldServerForDimension_11.set("returnType", "WorldServer");
        reflect_MinecraftServer_method_worldServerForDimension_11.set("static", false);
        reflect_MinecraftServer_method_worldServerForDimension_11.set("argnames", new String[]{"dimension"});
        reflect_MinecraftServer_method_worldServerForDimension_11.set("argtypes", new String[]{"int"});
        reflect_MinecraftServer_method_worldServerForDimension_11.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (WorldServer) ((MinecraftServer) params.getReflective("_self")).worldServerForDimension((int) params.getInt("dimension"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_worldServerForDimension_11);


        BaseData reflect_MinecraftServer_method_getMinecraftVersion_12 = new ModData();
        reflect_MinecraftServer_method_getMinecraftVersion_12.set("methodName", "getMinecraftVersion");
        reflect_MinecraftServer_method_getMinecraftVersion_12.set("returnType", "String");
        reflect_MinecraftServer_method_getMinecraftVersion_12.set("static", false);
        reflect_MinecraftServer_method_getMinecraftVersion_12.set("argnames", new String[]{});
        reflect_MinecraftServer_method_getMinecraftVersion_12.set("argtypes", new String[]{});
        reflect_MinecraftServer_method_getMinecraftVersion_12.setCallbackStringWithDataArg("exec", (BaseData params) -> {
                try {
                    return (String) ((MinecraftServer) params.getReflective("_self")).getMinecraftVersion();
                } catch (Exception _exception_reflect_) {
                    return "";
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_getMinecraftVersion_12);


        BaseData reflect_MinecraftServer_method_getCurrentPlayerCount_13 = new ModData();
        reflect_MinecraftServer_method_getCurrentPlayerCount_13.set("methodName", "getCurrentPlayerCount");
        reflect_MinecraftServer_method_getCurrentPlayerCount_13.set("returnType", "int");
        reflect_MinecraftServer_method_getCurrentPlayerCount_13.set("static", false);
        reflect_MinecraftServer_method_getCurrentPlayerCount_13.set("argnames", new String[]{});
        reflect_MinecraftServer_method_getCurrentPlayerCount_13.set("argtypes", new String[]{});
        reflect_MinecraftServer_method_getCurrentPlayerCount_13.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((MinecraftServer) params.getReflective("_self")).getCurrentPlayerCount();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_getCurrentPlayerCount_13);


        BaseData reflect_MinecraftServer_method_getMaxPlayers_14 = new ModData();
        reflect_MinecraftServer_method_getMaxPlayers_14.set("methodName", "getMaxPlayers");
        reflect_MinecraftServer_method_getMaxPlayers_14.set("returnType", "int");
        reflect_MinecraftServer_method_getMaxPlayers_14.set("static", false);
        reflect_MinecraftServer_method_getMaxPlayers_14.set("argnames", new String[]{});
        reflect_MinecraftServer_method_getMaxPlayers_14.set("argtypes", new String[]{});
        reflect_MinecraftServer_method_getMaxPlayers_14.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((MinecraftServer) params.getReflective("_self")).getMaxPlayers();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_getMaxPlayers_14);


        BaseData reflect_MinecraftServer_method_getAllUsernames_15 = new ModData();
        reflect_MinecraftServer_method_getAllUsernames_15.set("methodName", "getAllUsernames");
        reflect_MinecraftServer_method_getAllUsernames_15.set("returnType", "String[]");
        reflect_MinecraftServer_method_getAllUsernames_15.set("static", false);
        reflect_MinecraftServer_method_getAllUsernames_15.set("argnames", new String[]{});
        reflect_MinecraftServer_method_getAllUsernames_15.set("argtypes", new String[]{});
        reflect_MinecraftServer_method_getAllUsernames_15.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (String[]) ((MinecraftServer) params.getReflective("_self")).getAllUsernames();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_getAllUsernames_15);


        BaseData reflect_MinecraftServer_method_getGameProfiles_16 = new ModData();
        reflect_MinecraftServer_method_getGameProfiles_16.set("methodName", "getGameProfiles");
        reflect_MinecraftServer_method_getGameProfiles_16.set("returnType", "GameProfile[]");
        reflect_MinecraftServer_method_getGameProfiles_16.set("static", false);
        reflect_MinecraftServer_method_getGameProfiles_16.set("argnames", new String[]{});
        reflect_MinecraftServer_method_getGameProfiles_16.set("argtypes", new String[]{});
        reflect_MinecraftServer_method_getGameProfiles_16.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (GameProfile[]) ((MinecraftServer) params.getReflective("_self")).getGameProfiles();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_getGameProfiles_16);


        BaseData reflect_MinecraftServer_method_getServerModName_17 = new ModData();
        reflect_MinecraftServer_method_getServerModName_17.set("methodName", "getServerModName");
        reflect_MinecraftServer_method_getServerModName_17.set("returnType", "String");
        reflect_MinecraftServer_method_getServerModName_17.set("static", false);
        reflect_MinecraftServer_method_getServerModName_17.set("argnames", new String[]{});
        reflect_MinecraftServer_method_getServerModName_17.set("argtypes", new String[]{});
        reflect_MinecraftServer_method_getServerModName_17.setCallbackStringWithDataArg("exec", (BaseData params) -> {
                try {
                    return (String) ((MinecraftServer) params.getReflective("_self")).getServerModName();
                } catch (Exception _exception_reflect_) {
                    return "";
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_getServerModName_17);


        BaseData reflect_MinecraftServer_method_addServerInfoToCrashReport_18 = new ModData();
        reflect_MinecraftServer_method_addServerInfoToCrashReport_18.set("methodName", "addServerInfoToCrashReport");
        reflect_MinecraftServer_method_addServerInfoToCrashReport_18.set("returnType", "CrashReport");
        reflect_MinecraftServer_method_addServerInfoToCrashReport_18.set("static", false);
        reflect_MinecraftServer_method_addServerInfoToCrashReport_18.set("argnames", new String[]{"crashreport"});
        reflect_MinecraftServer_method_addServerInfoToCrashReport_18.set("argtypes", new String[]{"CrashReport"});
        reflect_MinecraftServer_method_addServerInfoToCrashReport_18.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (CrashReport) ((MinecraftServer) params.getReflective("_self")).addServerInfoToCrashReport((CrashReport) params.getReflective("crashreport"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_addServerInfoToCrashReport_18);


        BaseData reflect_MinecraftServer_method_getServer_19 = new ModData();
        reflect_MinecraftServer_method_getServer_19.set("methodName", "getServer");
        reflect_MinecraftServer_method_getServer_19.set("returnType", "MinecraftServer");
        reflect_MinecraftServer_method_getServer_19.set("static", true);
        reflect_MinecraftServer_method_getServer_19.set("argnames", new String[]{});
        reflect_MinecraftServer_method_getServer_19.set("argtypes", new String[]{});
        reflect_MinecraftServer_method_getServer_19.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (MinecraftServer) MinecraftServer.getServer();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_getServer_19);


        BaseData reflect_MinecraftServer_method_getName_20 = new ModData();
        reflect_MinecraftServer_method_getName_20.set("methodName", "getName");
        reflect_MinecraftServer_method_getName_20.set("returnType", "String");
        reflect_MinecraftServer_method_getName_20.set("static", false);
        reflect_MinecraftServer_method_getName_20.set("argnames", new String[]{});
        reflect_MinecraftServer_method_getName_20.set("argtypes", new String[]{});
        reflect_MinecraftServer_method_getName_20.setCallbackStringWithDataArg("exec", (BaseData params) -> {
                try {
                    return (String) ((MinecraftServer) params.getReflective("_self")).getName();
                } catch (Exception _exception_reflect_) {
                    return "";
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_getName_20);


        BaseData reflect_MinecraftServer_method_addChatMessage_21 = new ModData();
        reflect_MinecraftServer_method_addChatMessage_21.set("methodName", "addChatMessage");
        reflect_MinecraftServer_method_addChatMessage_21.set("returnType", "void");
        reflect_MinecraftServer_method_addChatMessage_21.set("static", false);
        reflect_MinecraftServer_method_addChatMessage_21.set("argnames", new String[]{"ichatcomponent"});
        reflect_MinecraftServer_method_addChatMessage_21.set("argtypes", new String[]{"IChatComponent"});
        reflect_MinecraftServer_method_addChatMessage_21.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((MinecraftServer) params.getReflective("_self")).addChatMessage((IChatComponent) params.getReflective("ichatcomponent"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_addChatMessage_21);


        BaseData reflect_MinecraftServer_method_canCommandSenderUseCommand_22 = new ModData();
        reflect_MinecraftServer_method_canCommandSenderUseCommand_22.set("methodName", "canCommandSenderUseCommand");
        reflect_MinecraftServer_method_canCommandSenderUseCommand_22.set("returnType", "boolean");
        reflect_MinecraftServer_method_canCommandSenderUseCommand_22.set("static", false);
        reflect_MinecraftServer_method_canCommandSenderUseCommand_22.set("argnames", new String[]{"var1", "var2"});
        reflect_MinecraftServer_method_canCommandSenderUseCommand_22.set("argtypes", new String[]{"int", "String"});
        reflect_MinecraftServer_method_canCommandSenderUseCommand_22.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((MinecraftServer) params.getReflective("_self")).canCommandSenderUseCommand((int) params.getInt("var1"), (String) params.getString("var2"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_canCommandSenderUseCommand_22);


        BaseData reflect_MinecraftServer_method_getCommandManager_23 = new ModData();
        reflect_MinecraftServer_method_getCommandManager_23.set("methodName", "getCommandManager");
        reflect_MinecraftServer_method_getCommandManager_23.set("returnType", "ICommandManager");
        reflect_MinecraftServer_method_getCommandManager_23.set("static", false);
        reflect_MinecraftServer_method_getCommandManager_23.set("argnames", new String[]{});
        reflect_MinecraftServer_method_getCommandManager_23.set("argtypes", new String[]{});
        reflect_MinecraftServer_method_getCommandManager_23.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (ICommandManager) ((MinecraftServer) params.getReflective("_self")).getCommandManager();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_getCommandManager_23);


        BaseData reflect_MinecraftServer_method_getServerOwner_24 = new ModData();
        reflect_MinecraftServer_method_getServerOwner_24.set("methodName", "getServerOwner");
        reflect_MinecraftServer_method_getServerOwner_24.set("returnType", "String");
        reflect_MinecraftServer_method_getServerOwner_24.set("static", false);
        reflect_MinecraftServer_method_getServerOwner_24.set("argnames", new String[]{});
        reflect_MinecraftServer_method_getServerOwner_24.set("argtypes", new String[]{});
        reflect_MinecraftServer_method_getServerOwner_24.setCallbackStringWithDataArg("exec", (BaseData params) -> {
                try {
                    return (String) ((MinecraftServer) params.getReflective("_self")).getServerOwner();
                } catch (Exception _exception_reflect_) {
                    return "";
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_getServerOwner_24);


        BaseData reflect_MinecraftServer_method_setServerOwner_25 = new ModData();
        reflect_MinecraftServer_method_setServerOwner_25.set("methodName", "setServerOwner");
        reflect_MinecraftServer_method_setServerOwner_25.set("returnType", "void");
        reflect_MinecraftServer_method_setServerOwner_25.set("static", false);
        reflect_MinecraftServer_method_setServerOwner_25.set("argnames", new String[]{"owner"});
        reflect_MinecraftServer_method_setServerOwner_25.set("argtypes", new String[]{"String"});
        reflect_MinecraftServer_method_setServerOwner_25.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((MinecraftServer) params.getReflective("_self")).setServerOwner((String) params.getString("owner"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_setServerOwner_25);


        BaseData reflect_MinecraftServer_method_isSinglePlayer_26 = new ModData();
        reflect_MinecraftServer_method_isSinglePlayer_26.set("methodName", "isSinglePlayer");
        reflect_MinecraftServer_method_isSinglePlayer_26.set("returnType", "boolean");
        reflect_MinecraftServer_method_isSinglePlayer_26.set("static", false);
        reflect_MinecraftServer_method_isSinglePlayer_26.set("argnames", new String[]{});
        reflect_MinecraftServer_method_isSinglePlayer_26.set("argtypes", new String[]{});
        reflect_MinecraftServer_method_isSinglePlayer_26.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((MinecraftServer) params.getReflective("_self")).isSinglePlayer();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_isSinglePlayer_26);


        BaseData reflect_MinecraftServer_method_getFolderName_27 = new ModData();
        reflect_MinecraftServer_method_getFolderName_27.set("methodName", "getFolderName");
        reflect_MinecraftServer_method_getFolderName_27.set("returnType", "String");
        reflect_MinecraftServer_method_getFolderName_27.set("static", false);
        reflect_MinecraftServer_method_getFolderName_27.set("argnames", new String[]{});
        reflect_MinecraftServer_method_getFolderName_27.set("argtypes", new String[]{});
        reflect_MinecraftServer_method_getFolderName_27.setCallbackStringWithDataArg("exec", (BaseData params) -> {
                try {
                    return (String) ((MinecraftServer) params.getReflective("_self")).getFolderName();
                } catch (Exception _exception_reflect_) {
                    return "";
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_getFolderName_27);


        BaseData reflect_MinecraftServer_method_getWorldName_28 = new ModData();
        reflect_MinecraftServer_method_getWorldName_28.set("methodName", "getWorldName");
        reflect_MinecraftServer_method_getWorldName_28.set("returnType", "String");
        reflect_MinecraftServer_method_getWorldName_28.set("static", false);
        reflect_MinecraftServer_method_getWorldName_28.set("argnames", new String[]{});
        reflect_MinecraftServer_method_getWorldName_28.set("argtypes", new String[]{});
        reflect_MinecraftServer_method_getWorldName_28.setCallbackStringWithDataArg("exec", (BaseData params) -> {
                try {
                    return (String) ((MinecraftServer) params.getReflective("_self")).getWorldName();
                } catch (Exception _exception_reflect_) {
                    return "";
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_getWorldName_28);


        BaseData reflect_MinecraftServer_method_setDifficultyForAllWorlds_29 = new ModData();
        reflect_MinecraftServer_method_setDifficultyForAllWorlds_29.set("methodName", "setDifficultyForAllWorlds");
        reflect_MinecraftServer_method_setDifficultyForAllWorlds_29.set("returnType", "void");
        reflect_MinecraftServer_method_setDifficultyForAllWorlds_29.set("static", false);
        reflect_MinecraftServer_method_setDifficultyForAllWorlds_29.set("argnames", new String[]{"enumdifficulty"});
        reflect_MinecraftServer_method_setDifficultyForAllWorlds_29.set("argtypes", new String[]{"EnumDifficulty"});
        reflect_MinecraftServer_method_setDifficultyForAllWorlds_29.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((MinecraftServer) params.getReflective("_self")).setDifficultyForAllWorlds((EnumDifficulty) params.getReflective("enumdifficulty"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_setDifficultyForAllWorlds_29);


        BaseData reflect_MinecraftServer_method_setDifficultyLockedForAllWorlds_30 = new ModData();
        reflect_MinecraftServer_method_setDifficultyLockedForAllWorlds_30.set("methodName", "setDifficultyLockedForAllWorlds");
        reflect_MinecraftServer_method_setDifficultyLockedForAllWorlds_30.set("returnType", "void");
        reflect_MinecraftServer_method_setDifficultyLockedForAllWorlds_30.set("static", false);
        reflect_MinecraftServer_method_setDifficultyLockedForAllWorlds_30.set("argnames", new String[]{"locked"});
        reflect_MinecraftServer_method_setDifficultyLockedForAllWorlds_30.set("argtypes", new String[]{"boolean"});
        reflect_MinecraftServer_method_setDifficultyLockedForAllWorlds_30.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((MinecraftServer) params.getReflective("_self")).setDifficultyLockedForAllWorlds((boolean) params.getBoolean("locked"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_setDifficultyLockedForAllWorlds_30);


        BaseData reflect_MinecraftServer_method_isDemo_31 = new ModData();
        reflect_MinecraftServer_method_isDemo_31.set("methodName", "isDemo");
        reflect_MinecraftServer_method_isDemo_31.set("returnType", "boolean");
        reflect_MinecraftServer_method_isDemo_31.set("static", false);
        reflect_MinecraftServer_method_isDemo_31.set("argnames", new String[]{});
        reflect_MinecraftServer_method_isDemo_31.set("argtypes", new String[]{});
        reflect_MinecraftServer_method_isDemo_31.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((MinecraftServer) params.getReflective("_self")).isDemo();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_isDemo_31);


        BaseData reflect_MinecraftServer_method_setDemo_32 = new ModData();
        reflect_MinecraftServer_method_setDemo_32.set("methodName", "setDemo");
        reflect_MinecraftServer_method_setDemo_32.set("returnType", "void");
        reflect_MinecraftServer_method_setDemo_32.set("static", false);
        reflect_MinecraftServer_method_setDemo_32.set("argnames", new String[]{"demo"});
        reflect_MinecraftServer_method_setDemo_32.set("argtypes", new String[]{"boolean"});
        reflect_MinecraftServer_method_setDemo_32.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((MinecraftServer) params.getReflective("_self")).setDemo((boolean) params.getBoolean("demo"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_setDemo_32);


        BaseData reflect_MinecraftServer_method_canCreateBonusChest_33 = new ModData();
        reflect_MinecraftServer_method_canCreateBonusChest_33.set("methodName", "canCreateBonusChest");
        reflect_MinecraftServer_method_canCreateBonusChest_33.set("returnType", "void");
        reflect_MinecraftServer_method_canCreateBonusChest_33.set("static", false);
        reflect_MinecraftServer_method_canCreateBonusChest_33.set("argnames", new String[]{"enable"});
        reflect_MinecraftServer_method_canCreateBonusChest_33.set("argtypes", new String[]{"boolean"});
        reflect_MinecraftServer_method_canCreateBonusChest_33.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((MinecraftServer) params.getReflective("_self")).canCreateBonusChest((boolean) params.getBoolean("enable"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_canCreateBonusChest_33);


        BaseData reflect_MinecraftServer_method_getResourcePackUrl_34 = new ModData();
        reflect_MinecraftServer_method_getResourcePackUrl_34.set("methodName", "getResourcePackUrl");
        reflect_MinecraftServer_method_getResourcePackUrl_34.set("returnType", "String");
        reflect_MinecraftServer_method_getResourcePackUrl_34.set("static", false);
        reflect_MinecraftServer_method_getResourcePackUrl_34.set("argnames", new String[]{});
        reflect_MinecraftServer_method_getResourcePackUrl_34.set("argtypes", new String[]{});
        reflect_MinecraftServer_method_getResourcePackUrl_34.setCallbackStringWithDataArg("exec", (BaseData params) -> {
                try {
                    return (String) ((MinecraftServer) params.getReflective("_self")).getResourcePackUrl();
                } catch (Exception _exception_reflect_) {
                    return "";
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_getResourcePackUrl_34);


        BaseData reflect_MinecraftServer_method_getResourcePackHash_35 = new ModData();
        reflect_MinecraftServer_method_getResourcePackHash_35.set("methodName", "getResourcePackHash");
        reflect_MinecraftServer_method_getResourcePackHash_35.set("returnType", "String");
        reflect_MinecraftServer_method_getResourcePackHash_35.set("static", false);
        reflect_MinecraftServer_method_getResourcePackHash_35.set("argnames", new String[]{});
        reflect_MinecraftServer_method_getResourcePackHash_35.set("argtypes", new String[]{});
        reflect_MinecraftServer_method_getResourcePackHash_35.setCallbackStringWithDataArg("exec", (BaseData params) -> {
                try {
                    return (String) ((MinecraftServer) params.getReflective("_self")).getResourcePackHash();
                } catch (Exception _exception_reflect_) {
                    return "";
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_getResourcePackHash_35);


        BaseData reflect_MinecraftServer_method_setResourcePack_36 = new ModData();
        reflect_MinecraftServer_method_setResourcePack_36.set("methodName", "setResourcePack");
        reflect_MinecraftServer_method_setResourcePack_36.set("returnType", "void");
        reflect_MinecraftServer_method_setResourcePack_36.set("static", false);
        reflect_MinecraftServer_method_setResourcePack_36.set("argnames", new String[]{"parString1", "parString2"});
        reflect_MinecraftServer_method_setResourcePack_36.set("argtypes", new String[]{"String", "String"});
        reflect_MinecraftServer_method_setResourcePack_36.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((MinecraftServer) params.getReflective("_self")).setResourcePack((String) params.getString("parString1"), (String) params.getString("parString2"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_setResourcePack_36);


        BaseData reflect_MinecraftServer_method_isSnooperEnabled_37 = new ModData();
        reflect_MinecraftServer_method_isSnooperEnabled_37.set("methodName", "isSnooperEnabled");
        reflect_MinecraftServer_method_isSnooperEnabled_37.set("returnType", "boolean");
        reflect_MinecraftServer_method_isSnooperEnabled_37.set("static", false);
        reflect_MinecraftServer_method_isSnooperEnabled_37.set("argnames", new String[]{});
        reflect_MinecraftServer_method_isSnooperEnabled_37.set("argtypes", new String[]{});
        reflect_MinecraftServer_method_isSnooperEnabled_37.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((MinecraftServer) params.getReflective("_self")).isSnooperEnabled();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_isSnooperEnabled_37);


        BaseData reflect_MinecraftServer_method_isServerInOnlineMode_38 = new ModData();
        reflect_MinecraftServer_method_isServerInOnlineMode_38.set("methodName", "isServerInOnlineMode");
        reflect_MinecraftServer_method_isServerInOnlineMode_38.set("returnType", "boolean");
        reflect_MinecraftServer_method_isServerInOnlineMode_38.set("static", false);
        reflect_MinecraftServer_method_isServerInOnlineMode_38.set("argnames", new String[]{});
        reflect_MinecraftServer_method_isServerInOnlineMode_38.set("argtypes", new String[]{});
        reflect_MinecraftServer_method_isServerInOnlineMode_38.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((MinecraftServer) params.getReflective("_self")).isServerInOnlineMode();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_isServerInOnlineMode_38);


        BaseData reflect_MinecraftServer_method_setOnlineMode_39 = new ModData();
        reflect_MinecraftServer_method_setOnlineMode_39.set("methodName", "setOnlineMode");
        reflect_MinecraftServer_method_setOnlineMode_39.set("returnType", "void");
        reflect_MinecraftServer_method_setOnlineMode_39.set("static", false);
        reflect_MinecraftServer_method_setOnlineMode_39.set("argnames", new String[]{"online"});
        reflect_MinecraftServer_method_setOnlineMode_39.set("argtypes", new String[]{"boolean"});
        reflect_MinecraftServer_method_setOnlineMode_39.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((MinecraftServer) params.getReflective("_self")).setOnlineMode((boolean) params.getBoolean("online"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_setOnlineMode_39);


        BaseData reflect_MinecraftServer_method_getCanSpawnAnimals_40 = new ModData();
        reflect_MinecraftServer_method_getCanSpawnAnimals_40.set("methodName", "getCanSpawnAnimals");
        reflect_MinecraftServer_method_getCanSpawnAnimals_40.set("returnType", "boolean");
        reflect_MinecraftServer_method_getCanSpawnAnimals_40.set("static", false);
        reflect_MinecraftServer_method_getCanSpawnAnimals_40.set("argnames", new String[]{});
        reflect_MinecraftServer_method_getCanSpawnAnimals_40.set("argtypes", new String[]{});
        reflect_MinecraftServer_method_getCanSpawnAnimals_40.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((MinecraftServer) params.getReflective("_self")).getCanSpawnAnimals();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_getCanSpawnAnimals_40);


        BaseData reflect_MinecraftServer_method_setCanSpawnAnimals_41 = new ModData();
        reflect_MinecraftServer_method_setCanSpawnAnimals_41.set("methodName", "setCanSpawnAnimals");
        reflect_MinecraftServer_method_setCanSpawnAnimals_41.set("returnType", "void");
        reflect_MinecraftServer_method_setCanSpawnAnimals_41.set("static", false);
        reflect_MinecraftServer_method_setCanSpawnAnimals_41.set("argnames", new String[]{"spawnAnimals"});
        reflect_MinecraftServer_method_setCanSpawnAnimals_41.set("argtypes", new String[]{"boolean"});
        reflect_MinecraftServer_method_setCanSpawnAnimals_41.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((MinecraftServer) params.getReflective("_self")).setCanSpawnAnimals((boolean) params.getBoolean("spawnAnimals"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_setCanSpawnAnimals_41);


        BaseData reflect_MinecraftServer_method_getCanSpawnNPCs_42 = new ModData();
        reflect_MinecraftServer_method_getCanSpawnNPCs_42.set("methodName", "getCanSpawnNPCs");
        reflect_MinecraftServer_method_getCanSpawnNPCs_42.set("returnType", "boolean");
        reflect_MinecraftServer_method_getCanSpawnNPCs_42.set("static", false);
        reflect_MinecraftServer_method_getCanSpawnNPCs_42.set("argnames", new String[]{});
        reflect_MinecraftServer_method_getCanSpawnNPCs_42.set("argtypes", new String[]{});
        reflect_MinecraftServer_method_getCanSpawnNPCs_42.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((MinecraftServer) params.getReflective("_self")).getCanSpawnNPCs();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_getCanSpawnNPCs_42);


        BaseData reflect_MinecraftServer_method_setCanSpawnNPCs_43 = new ModData();
        reflect_MinecraftServer_method_setCanSpawnNPCs_43.set("methodName", "setCanSpawnNPCs");
        reflect_MinecraftServer_method_setCanSpawnNPCs_43.set("returnType", "void");
        reflect_MinecraftServer_method_setCanSpawnNPCs_43.set("static", false);
        reflect_MinecraftServer_method_setCanSpawnNPCs_43.set("argnames", new String[]{"spawnNpcs"});
        reflect_MinecraftServer_method_setCanSpawnNPCs_43.set("argtypes", new String[]{"boolean"});
        reflect_MinecraftServer_method_setCanSpawnNPCs_43.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((MinecraftServer) params.getReflective("_self")).setCanSpawnNPCs((boolean) params.getBoolean("spawnNpcs"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_setCanSpawnNPCs_43);


        BaseData reflect_MinecraftServer_method_isPVPEnabled_44 = new ModData();
        reflect_MinecraftServer_method_isPVPEnabled_44.set("methodName", "isPVPEnabled");
        reflect_MinecraftServer_method_isPVPEnabled_44.set("returnType", "boolean");
        reflect_MinecraftServer_method_isPVPEnabled_44.set("static", false);
        reflect_MinecraftServer_method_isPVPEnabled_44.set("argnames", new String[]{});
        reflect_MinecraftServer_method_isPVPEnabled_44.set("argtypes", new String[]{});
        reflect_MinecraftServer_method_isPVPEnabled_44.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((MinecraftServer) params.getReflective("_self")).isPVPEnabled();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_isPVPEnabled_44);


        BaseData reflect_MinecraftServer_method_setAllowPvp_45 = new ModData();
        reflect_MinecraftServer_method_setAllowPvp_45.set("methodName", "setAllowPvp");
        reflect_MinecraftServer_method_setAllowPvp_45.set("returnType", "void");
        reflect_MinecraftServer_method_setAllowPvp_45.set("static", false);
        reflect_MinecraftServer_method_setAllowPvp_45.set("argnames", new String[]{"allowPvp"});
        reflect_MinecraftServer_method_setAllowPvp_45.set("argtypes", new String[]{"boolean"});
        reflect_MinecraftServer_method_setAllowPvp_45.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((MinecraftServer) params.getReflective("_self")).setAllowPvp((boolean) params.getBoolean("allowPvp"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_setAllowPvp_45);


        BaseData reflect_MinecraftServer_method_isFlightAllowed_46 = new ModData();
        reflect_MinecraftServer_method_isFlightAllowed_46.set("methodName", "isFlightAllowed");
        reflect_MinecraftServer_method_isFlightAllowed_46.set("returnType", "boolean");
        reflect_MinecraftServer_method_isFlightAllowed_46.set("static", false);
        reflect_MinecraftServer_method_isFlightAllowed_46.set("argnames", new String[]{});
        reflect_MinecraftServer_method_isFlightAllowed_46.set("argtypes", new String[]{});
        reflect_MinecraftServer_method_isFlightAllowed_46.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((MinecraftServer) params.getReflective("_self")).isFlightAllowed();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_isFlightAllowed_46);


        BaseData reflect_MinecraftServer_method_setAllowFlight_47 = new ModData();
        reflect_MinecraftServer_method_setAllowFlight_47.set("methodName", "setAllowFlight");
        reflect_MinecraftServer_method_setAllowFlight_47.set("returnType", "void");
        reflect_MinecraftServer_method_setAllowFlight_47.set("static", false);
        reflect_MinecraftServer_method_setAllowFlight_47.set("argnames", new String[]{"allow"});
        reflect_MinecraftServer_method_setAllowFlight_47.set("argtypes", new String[]{"boolean"});
        reflect_MinecraftServer_method_setAllowFlight_47.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((MinecraftServer) params.getReflective("_self")).setAllowFlight((boolean) params.getBoolean("allow"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_setAllowFlight_47);


        BaseData reflect_MinecraftServer_method_getMOTD_48 = new ModData();
        reflect_MinecraftServer_method_getMOTD_48.set("methodName", "getMOTD");
        reflect_MinecraftServer_method_getMOTD_48.set("returnType", "String");
        reflect_MinecraftServer_method_getMOTD_48.set("static", false);
        reflect_MinecraftServer_method_getMOTD_48.set("argnames", new String[]{});
        reflect_MinecraftServer_method_getMOTD_48.set("argtypes", new String[]{});
        reflect_MinecraftServer_method_getMOTD_48.setCallbackStringWithDataArg("exec", (BaseData params) -> {
                try {
                    return (String) ((MinecraftServer) params.getReflective("_self")).getMOTD();
                } catch (Exception _exception_reflect_) {
                    return "";
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_getMOTD_48);


        BaseData reflect_MinecraftServer_method_setMOTD_49 = new ModData();
        reflect_MinecraftServer_method_setMOTD_49.set("methodName", "setMOTD");
        reflect_MinecraftServer_method_setMOTD_49.set("returnType", "void");
        reflect_MinecraftServer_method_setMOTD_49.set("static", false);
        reflect_MinecraftServer_method_setMOTD_49.set("argnames", new String[]{"motdIn"});
        reflect_MinecraftServer_method_setMOTD_49.set("argtypes", new String[]{"String"});
        reflect_MinecraftServer_method_setMOTD_49.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((MinecraftServer) params.getReflective("_self")).setMOTD((String) params.getString("motdIn"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_setMOTD_49);


        BaseData reflect_MinecraftServer_method_getBuildLimit_50 = new ModData();
        reflect_MinecraftServer_method_getBuildLimit_50.set("methodName", "getBuildLimit");
        reflect_MinecraftServer_method_getBuildLimit_50.set("returnType", "int");
        reflect_MinecraftServer_method_getBuildLimit_50.set("static", false);
        reflect_MinecraftServer_method_getBuildLimit_50.set("argnames", new String[]{});
        reflect_MinecraftServer_method_getBuildLimit_50.set("argtypes", new String[]{});
        reflect_MinecraftServer_method_getBuildLimit_50.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((MinecraftServer) params.getReflective("_self")).getBuildLimit();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_getBuildLimit_50);


        BaseData reflect_MinecraftServer_method_setBuildLimit_51 = new ModData();
        reflect_MinecraftServer_method_setBuildLimit_51.set("methodName", "setBuildLimit");
        reflect_MinecraftServer_method_setBuildLimit_51.set("returnType", "void");
        reflect_MinecraftServer_method_setBuildLimit_51.set("static", false);
        reflect_MinecraftServer_method_setBuildLimit_51.set("argnames", new String[]{"maxBuildHeight"});
        reflect_MinecraftServer_method_setBuildLimit_51.set("argtypes", new String[]{"int"});
        reflect_MinecraftServer_method_setBuildLimit_51.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((MinecraftServer) params.getReflective("_self")).setBuildLimit((int) params.getInt("maxBuildHeight"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_setBuildLimit_51);


        BaseData reflect_MinecraftServer_method_isServerStopped_52 = new ModData();
        reflect_MinecraftServer_method_isServerStopped_52.set("methodName", "isServerStopped");
        reflect_MinecraftServer_method_isServerStopped_52.set("returnType", "boolean");
        reflect_MinecraftServer_method_isServerStopped_52.set("static", false);
        reflect_MinecraftServer_method_isServerStopped_52.set("argnames", new String[]{});
        reflect_MinecraftServer_method_isServerStopped_52.set("argtypes", new String[]{});
        reflect_MinecraftServer_method_isServerStopped_52.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((MinecraftServer) params.getReflective("_self")).isServerStopped();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_isServerStopped_52);


        BaseData reflect_MinecraftServer_method_getConfigurationManager_53 = new ModData();
        reflect_MinecraftServer_method_getConfigurationManager_53.set("methodName", "getConfigurationManager");
        reflect_MinecraftServer_method_getConfigurationManager_53.set("returnType", "ServerConfigurationManager");
        reflect_MinecraftServer_method_getConfigurationManager_53.set("static", false);
        reflect_MinecraftServer_method_getConfigurationManager_53.set("argnames", new String[]{});
        reflect_MinecraftServer_method_getConfigurationManager_53.set("argtypes", new String[]{});
        reflect_MinecraftServer_method_getConfigurationManager_53.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (ServerConfigurationManager) ((MinecraftServer) params.getReflective("_self")).getConfigurationManager();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_getConfigurationManager_53);


        BaseData reflect_MinecraftServer_method_setConfigManager_54 = new ModData();
        reflect_MinecraftServer_method_setConfigManager_54.set("methodName", "setConfigManager");
        reflect_MinecraftServer_method_setConfigManager_54.set("returnType", "void");
        reflect_MinecraftServer_method_setConfigManager_54.set("static", false);
        reflect_MinecraftServer_method_setConfigManager_54.set("argnames", new String[]{"configManager"});
        reflect_MinecraftServer_method_setConfigManager_54.set("argtypes", new String[]{"ServerConfigurationManager"});
        reflect_MinecraftServer_method_setConfigManager_54.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((MinecraftServer) params.getReflective("_self")).setConfigManager((ServerConfigurationManager) params.getReflective("configManager"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_setConfigManager_54);


        BaseData reflect_MinecraftServer_method_serverIsInRunLoop_56 = new ModData();
        reflect_MinecraftServer_method_serverIsInRunLoop_56.set("methodName", "serverIsInRunLoop");
        reflect_MinecraftServer_method_serverIsInRunLoop_56.set("returnType", "boolean");
        reflect_MinecraftServer_method_serverIsInRunLoop_56.set("static", false);
        reflect_MinecraftServer_method_serverIsInRunLoop_56.set("argnames", new String[]{});
        reflect_MinecraftServer_method_serverIsInRunLoop_56.set("argtypes", new String[]{});
        reflect_MinecraftServer_method_serverIsInRunLoop_56.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((MinecraftServer) params.getReflective("_self")).serverIsInRunLoop();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_serverIsInRunLoop_56);


        BaseData reflect_MinecraftServer_method_getGuiEnabled_57 = new ModData();
        reflect_MinecraftServer_method_getGuiEnabled_57.set("methodName", "getGuiEnabled");
        reflect_MinecraftServer_method_getGuiEnabled_57.set("returnType", "boolean");
        reflect_MinecraftServer_method_getGuiEnabled_57.set("static", false);
        reflect_MinecraftServer_method_getGuiEnabled_57.set("argnames", new String[]{});
        reflect_MinecraftServer_method_getGuiEnabled_57.set("argtypes", new String[]{});
        reflect_MinecraftServer_method_getGuiEnabled_57.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((MinecraftServer) params.getReflective("_self")).getGuiEnabled();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_getGuiEnabled_57);


        BaseData reflect_MinecraftServer_method_getTickCounter_58 = new ModData();
        reflect_MinecraftServer_method_getTickCounter_58.set("methodName", "getTickCounter");
        reflect_MinecraftServer_method_getTickCounter_58.set("returnType", "int");
        reflect_MinecraftServer_method_getTickCounter_58.set("static", false);
        reflect_MinecraftServer_method_getTickCounter_58.set("argnames", new String[]{});
        reflect_MinecraftServer_method_getTickCounter_58.set("argtypes", new String[]{});
        reflect_MinecraftServer_method_getTickCounter_58.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((MinecraftServer) params.getReflective("_self")).getTickCounter();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_getTickCounter_58);


        BaseData reflect_MinecraftServer_method_enableProfiling_59 = new ModData();
        reflect_MinecraftServer_method_enableProfiling_59.set("methodName", "enableProfiling");
        reflect_MinecraftServer_method_enableProfiling_59.set("returnType", "void");
        reflect_MinecraftServer_method_enableProfiling_59.set("static", false);
        reflect_MinecraftServer_method_enableProfiling_59.set("argnames", new String[]{});
        reflect_MinecraftServer_method_enableProfiling_59.set("argtypes", new String[]{});
        reflect_MinecraftServer_method_enableProfiling_59.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((MinecraftServer) params.getReflective("_self")).enableProfiling();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_enableProfiling_59);


        BaseData reflect_MinecraftServer_method_getPosition_60 = new ModData();
        reflect_MinecraftServer_method_getPosition_60.set("methodName", "getPosition");
        reflect_MinecraftServer_method_getPosition_60.set("returnType", "BlockPos");
        reflect_MinecraftServer_method_getPosition_60.set("static", false);
        reflect_MinecraftServer_method_getPosition_60.set("argnames", new String[]{});
        reflect_MinecraftServer_method_getPosition_60.set("argtypes", new String[]{});
        reflect_MinecraftServer_method_getPosition_60.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (BlockPos) ((MinecraftServer) params.getReflective("_self")).getPosition();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_getPosition_60);


        BaseData reflect_MinecraftServer_method_getPositionVector_61 = new ModData();
        reflect_MinecraftServer_method_getPositionVector_61.set("methodName", "getPositionVector");
        reflect_MinecraftServer_method_getPositionVector_61.set("returnType", "Vec3");
        reflect_MinecraftServer_method_getPositionVector_61.set("static", false);
        reflect_MinecraftServer_method_getPositionVector_61.set("argnames", new String[]{});
        reflect_MinecraftServer_method_getPositionVector_61.set("argtypes", new String[]{});
        reflect_MinecraftServer_method_getPositionVector_61.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Vec3) ((MinecraftServer) params.getReflective("_self")).getPositionVector();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_getPositionVector_61);


        BaseData reflect_MinecraftServer_method_getEntityWorld_62 = new ModData();
        reflect_MinecraftServer_method_getEntityWorld_62.set("methodName", "getEntityWorld");
        reflect_MinecraftServer_method_getEntityWorld_62.set("returnType", "World");
        reflect_MinecraftServer_method_getEntityWorld_62.set("static", false);
        reflect_MinecraftServer_method_getEntityWorld_62.set("argnames", new String[]{});
        reflect_MinecraftServer_method_getEntityWorld_62.set("argtypes", new String[]{});
        reflect_MinecraftServer_method_getEntityWorld_62.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (World) ((MinecraftServer) params.getReflective("_self")).getEntityWorld();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_getEntityWorld_62);


        BaseData reflect_MinecraftServer_method_getCommandSenderEntity_63 = new ModData();
        reflect_MinecraftServer_method_getCommandSenderEntity_63.set("methodName", "getCommandSenderEntity");
        reflect_MinecraftServer_method_getCommandSenderEntity_63.set("returnType", "Entity");
        reflect_MinecraftServer_method_getCommandSenderEntity_63.set("static", false);
        reflect_MinecraftServer_method_getCommandSenderEntity_63.set("argnames", new String[]{});
        reflect_MinecraftServer_method_getCommandSenderEntity_63.set("argtypes", new String[]{});
        reflect_MinecraftServer_method_getCommandSenderEntity_63.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Entity) ((MinecraftServer) params.getReflective("_self")).getCommandSenderEntity();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_getCommandSenderEntity_63);


        BaseData reflect_MinecraftServer_method_getSpawnProtectionSize_64 = new ModData();
        reflect_MinecraftServer_method_getSpawnProtectionSize_64.set("methodName", "getSpawnProtectionSize");
        reflect_MinecraftServer_method_getSpawnProtectionSize_64.set("returnType", "int");
        reflect_MinecraftServer_method_getSpawnProtectionSize_64.set("static", false);
        reflect_MinecraftServer_method_getSpawnProtectionSize_64.set("argnames", new String[]{});
        reflect_MinecraftServer_method_getSpawnProtectionSize_64.set("argtypes", new String[]{});
        reflect_MinecraftServer_method_getSpawnProtectionSize_64.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((MinecraftServer) params.getReflective("_self")).getSpawnProtectionSize();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_getSpawnProtectionSize_64);


        BaseData reflect_MinecraftServer_method_isBlockProtected_65 = new ModData();
        reflect_MinecraftServer_method_isBlockProtected_65.set("methodName", "isBlockProtected");
        reflect_MinecraftServer_method_isBlockProtected_65.set("returnType", "boolean");
        reflect_MinecraftServer_method_isBlockProtected_65.set("static", false);
        reflect_MinecraftServer_method_isBlockProtected_65.set("argnames", new String[]{"var1", "var2", "var3"});
        reflect_MinecraftServer_method_isBlockProtected_65.set("argtypes", new String[]{"World", "BlockPos", "EntityPlayer"});
        reflect_MinecraftServer_method_isBlockProtected_65.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((MinecraftServer) params.getReflective("_self")).isBlockProtected((World) params.getReflective("var1"), (BlockPos) params.getReflective("var2"), (EntityPlayer) params.getReflective("var3"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_isBlockProtected_65);


        BaseData reflect_MinecraftServer_method_getForceGamemode_66 = new ModData();
        reflect_MinecraftServer_method_getForceGamemode_66.set("methodName", "getForceGamemode");
        reflect_MinecraftServer_method_getForceGamemode_66.set("returnType", "boolean");
        reflect_MinecraftServer_method_getForceGamemode_66.set("static", false);
        reflect_MinecraftServer_method_getForceGamemode_66.set("argnames", new String[]{});
        reflect_MinecraftServer_method_getForceGamemode_66.set("argtypes", new String[]{});
        reflect_MinecraftServer_method_getForceGamemode_66.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((MinecraftServer) params.getReflective("_self")).getForceGamemode();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_getForceGamemode_66);


        BaseData reflect_MinecraftServer_method_getCurrentTimeMillis_67 = new ModData();
        reflect_MinecraftServer_method_getCurrentTimeMillis_67.set("methodName", "getCurrentTimeMillis");
        reflect_MinecraftServer_method_getCurrentTimeMillis_67.set("returnType", "long");
        reflect_MinecraftServer_method_getCurrentTimeMillis_67.set("static", true);
        reflect_MinecraftServer_method_getCurrentTimeMillis_67.set("argnames", new String[]{});
        reflect_MinecraftServer_method_getCurrentTimeMillis_67.set("argtypes", new String[]{});
        reflect_MinecraftServer_method_getCurrentTimeMillis_67.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (long) MinecraftServer.getCurrentTimeMillis();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_getCurrentTimeMillis_67);


        BaseData reflect_MinecraftServer_method_getMaxPlayerIdleMinutes_68 = new ModData();
        reflect_MinecraftServer_method_getMaxPlayerIdleMinutes_68.set("methodName", "getMaxPlayerIdleMinutes");
        reflect_MinecraftServer_method_getMaxPlayerIdleMinutes_68.set("returnType", "int");
        reflect_MinecraftServer_method_getMaxPlayerIdleMinutes_68.set("static", false);
        reflect_MinecraftServer_method_getMaxPlayerIdleMinutes_68.set("argnames", new String[]{});
        reflect_MinecraftServer_method_getMaxPlayerIdleMinutes_68.set("argtypes", new String[]{});
        reflect_MinecraftServer_method_getMaxPlayerIdleMinutes_68.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((MinecraftServer) params.getReflective("_self")).getMaxPlayerIdleMinutes();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_getMaxPlayerIdleMinutes_68);


        BaseData reflect_MinecraftServer_method_setPlayerIdleTimeout_69 = new ModData();
        reflect_MinecraftServer_method_setPlayerIdleTimeout_69.set("methodName", "setPlayerIdleTimeout");
        reflect_MinecraftServer_method_setPlayerIdleTimeout_69.set("returnType", "void");
        reflect_MinecraftServer_method_setPlayerIdleTimeout_69.set("static", false);
        reflect_MinecraftServer_method_setPlayerIdleTimeout_69.set("argnames", new String[]{"i"});
        reflect_MinecraftServer_method_setPlayerIdleTimeout_69.set("argtypes", new String[]{"int"});
        reflect_MinecraftServer_method_setPlayerIdleTimeout_69.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((MinecraftServer) params.getReflective("_self")).setPlayerIdleTimeout((int) params.getInt("i"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_setPlayerIdleTimeout_69);


        BaseData reflect_MinecraftServer_method_getDisplayName_70 = new ModData();
        reflect_MinecraftServer_method_getDisplayName_70.set("methodName", "getDisplayName");
        reflect_MinecraftServer_method_getDisplayName_70.set("returnType", "IChatComponent");
        reflect_MinecraftServer_method_getDisplayName_70.set("static", false);
        reflect_MinecraftServer_method_getDisplayName_70.set("argnames", new String[]{});
        reflect_MinecraftServer_method_getDisplayName_70.set("argtypes", new String[]{});
        reflect_MinecraftServer_method_getDisplayName_70.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (IChatComponent) ((MinecraftServer) params.getReflective("_self")).getDisplayName();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_getDisplayName_70);


        BaseData reflect_MinecraftServer_method_isAnnouncingPlayerAchievements_71 = new ModData();
        reflect_MinecraftServer_method_isAnnouncingPlayerAchievements_71.set("methodName", "isAnnouncingPlayerAchievements");
        reflect_MinecraftServer_method_isAnnouncingPlayerAchievements_71.set("returnType", "boolean");
        reflect_MinecraftServer_method_isAnnouncingPlayerAchievements_71.set("static", false);
        reflect_MinecraftServer_method_isAnnouncingPlayerAchievements_71.set("argnames", new String[]{});
        reflect_MinecraftServer_method_isAnnouncingPlayerAchievements_71.set("argtypes", new String[]{});
        reflect_MinecraftServer_method_isAnnouncingPlayerAchievements_71.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((MinecraftServer) params.getReflective("_self")).isAnnouncingPlayerAchievements();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_isAnnouncingPlayerAchievements_71);


        BaseData reflect_MinecraftServer_method_refreshStatusNextTick_72 = new ModData();
        reflect_MinecraftServer_method_refreshStatusNextTick_72.set("methodName", "refreshStatusNextTick");
        reflect_MinecraftServer_method_refreshStatusNextTick_72.set("returnType", "void");
        reflect_MinecraftServer_method_refreshStatusNextTick_72.set("static", false);
        reflect_MinecraftServer_method_refreshStatusNextTick_72.set("argnames", new String[]{});
        reflect_MinecraftServer_method_refreshStatusNextTick_72.set("argtypes", new String[]{});
        reflect_MinecraftServer_method_refreshStatusNextTick_72.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((MinecraftServer) params.getReflective("_self")).refreshStatusNextTick();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_refreshStatusNextTick_72);


        BaseData reflect_MinecraftServer_method_getEntityFromUuid_73 = new ModData();
        reflect_MinecraftServer_method_getEntityFromUuid_73.set("methodName", "getEntityFromUuid");
        reflect_MinecraftServer_method_getEntityFromUuid_73.set("returnType", "Entity");
        reflect_MinecraftServer_method_getEntityFromUuid_73.set("static", false);
        reflect_MinecraftServer_method_getEntityFromUuid_73.set("argnames", new String[]{"uuid"});
        reflect_MinecraftServer_method_getEntityFromUuid_73.set("argtypes", new String[]{"EaglercraftUUID"});
        reflect_MinecraftServer_method_getEntityFromUuid_73.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Entity) ((MinecraftServer) params.getReflective("_self")).getEntityFromUuid((EaglercraftUUID) params.getReflective("uuid"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_getEntityFromUuid_73);


        BaseData reflect_MinecraftServer_method_sendCommandFeedback_74 = new ModData();
        reflect_MinecraftServer_method_sendCommandFeedback_74.set("methodName", "sendCommandFeedback");
        reflect_MinecraftServer_method_sendCommandFeedback_74.set("returnType", "boolean");
        reflect_MinecraftServer_method_sendCommandFeedback_74.set("static", false);
        reflect_MinecraftServer_method_sendCommandFeedback_74.set("argnames", new String[]{});
        reflect_MinecraftServer_method_sendCommandFeedback_74.set("argtypes", new String[]{});
        reflect_MinecraftServer_method_sendCommandFeedback_74.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((MinecraftServer) params.getReflective("_self")).sendCommandFeedback();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_sendCommandFeedback_74);


        BaseData reflect_MinecraftServer_method_getMaxWorldSize_76 = new ModData();
        reflect_MinecraftServer_method_getMaxWorldSize_76.set("methodName", "getMaxWorldSize");
        reflect_MinecraftServer_method_getMaxWorldSize_76.set("returnType", "int");
        reflect_MinecraftServer_method_getMaxWorldSize_76.set("static", false);
        reflect_MinecraftServer_method_getMaxWorldSize_76.set("argnames", new String[]{});
        reflect_MinecraftServer_method_getMaxWorldSize_76.set("argtypes", new String[]{});
        reflect_MinecraftServer_method_getMaxWorldSize_76.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((MinecraftServer) params.getReflective("_self")).getMaxWorldSize();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_getMaxWorldSize_76);


        BaseData reflect_MinecraftServer_method_isCallingFromMinecraftThread_77 = new ModData();
        reflect_MinecraftServer_method_isCallingFromMinecraftThread_77.set("methodName", "isCallingFromMinecraftThread");
        reflect_MinecraftServer_method_isCallingFromMinecraftThread_77.set("returnType", "boolean");
        reflect_MinecraftServer_method_isCallingFromMinecraftThread_77.set("static", false);
        reflect_MinecraftServer_method_isCallingFromMinecraftThread_77.set("argnames", new String[]{});
        reflect_MinecraftServer_method_isCallingFromMinecraftThread_77.set("argtypes", new String[]{});
        reflect_MinecraftServer_method_isCallingFromMinecraftThread_77.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((MinecraftServer) params.getReflective("_self")).isCallingFromMinecraftThread();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_isCallingFromMinecraftThread_77);


        BaseData reflect_MinecraftServer_method_getNetworkCompressionTreshold_78 = new ModData();
        reflect_MinecraftServer_method_getNetworkCompressionTreshold_78.set("methodName", "getNetworkCompressionTreshold");
        reflect_MinecraftServer_method_getNetworkCompressionTreshold_78.set("returnType", "int");
        reflect_MinecraftServer_method_getNetworkCompressionTreshold_78.set("static", false);
        reflect_MinecraftServer_method_getNetworkCompressionTreshold_78.set("argnames", new String[]{});
        reflect_MinecraftServer_method_getNetworkCompressionTreshold_78.set("argtypes", new String[]{});
        reflect_MinecraftServer_method_getNetworkCompressionTreshold_78.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((MinecraftServer) params.getReflective("_self")).getNetworkCompressionTreshold();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_getNetworkCompressionTreshold_78);


        BaseData reflect_MinecraftServer_method_setPaused_79 = new ModData();
        reflect_MinecraftServer_method_setPaused_79.set("methodName", "setPaused");
        reflect_MinecraftServer_method_setPaused_79.set("returnType", "void");
        reflect_MinecraftServer_method_setPaused_79.set("static", false);
        reflect_MinecraftServer_method_setPaused_79.set("argnames", new String[]{"pause"});
        reflect_MinecraftServer_method_setPaused_79.set("argtypes", new String[]{"boolean"});
        reflect_MinecraftServer_method_setPaused_79.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((MinecraftServer) params.getReflective("_self")).setPaused((boolean) params.getBoolean("pause"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_setPaused_79);


        BaseData reflect_MinecraftServer_method_getPaused_80 = new ModData();
        reflect_MinecraftServer_method_getPaused_80.set("methodName", "getPaused");
        reflect_MinecraftServer_method_getPaused_80.set("returnType", "boolean");
        reflect_MinecraftServer_method_getPaused_80.set("static", false);
        reflect_MinecraftServer_method_getPaused_80.set("argnames", new String[]{});
        reflect_MinecraftServer_method_getPaused_80.set("argtypes", new String[]{});
        reflect_MinecraftServer_method_getPaused_80.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((MinecraftServer) params.getReflective("_self")).getPaused();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_MinecraftServer_methods.add(reflect_MinecraftServer_method_getPaused_80);


        BaseData[] reflect_MinecraftServer_methods_arr = new BaseData[reflect_MinecraftServer_methods.size()];
        for (int i = 0; i < reflect_MinecraftServer_methods_arr.length; i++) {
            reflect_MinecraftServer_methods_arr[i] = reflect_MinecraftServer_methods.get(i);
        }

        reflect_MinecraftServer.set("constructors", reflect_MinecraftServer_constructors_arr);
        reflect_MinecraftServer.set("methods", reflect_MinecraftServer_methods_arr);
        reflect_MinecraftServer.set("className", "MinecraftServer");
        reflect_MinecraftServer.set("classId", "net.minecraft.server.MinecraftServer");
        reflect_MinecraftServer.set("class", MinecraftServer.class);
        reflect_MinecraftServer.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof MinecraftServer;
        });
        reflectProfiles.add(reflect_MinecraftServer);
    }


    //classdef for ItemStack
    public static void reflect_ItemStack_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_ItemStack = new ModData();

        ArrayList<BaseData> reflect_ItemStack_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_ItemStack_constructor_ItemStack_0 = new ModData();
        reflect_ItemStack_constructor_ItemStack_0.set("returnType", "ItemStack");
        reflect_ItemStack_constructor_ItemStack_0.set("argnames", new String[]{"blockIn"});
        reflect_ItemStack_constructor_ItemStack_0.set("argtypes", new String[]{"Block"});
        reflect_ItemStack_constructor_ItemStack_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new ItemStack((Block) params.getReflective("blockIn"));
        });
        
        reflect_ItemStack_constructors.add(reflect_ItemStack_constructor_ItemStack_0);


        BaseData reflect_ItemStack_constructor_ItemStack_1 = new ModData();
        reflect_ItemStack_constructor_ItemStack_1.set("returnType", "ItemStack");
        reflect_ItemStack_constructor_ItemStack_1.set("argnames", new String[]{"blockIn", "amount"});
        reflect_ItemStack_constructor_ItemStack_1.set("argtypes", new String[]{"Block", "int"});
        reflect_ItemStack_constructor_ItemStack_1.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new ItemStack((Block) params.getReflective("blockIn"), (int) params.getInt("amount"));
        });
        
        reflect_ItemStack_constructors.add(reflect_ItemStack_constructor_ItemStack_1);


        BaseData reflect_ItemStack_constructor_ItemStack_2 = new ModData();
        reflect_ItemStack_constructor_ItemStack_2.set("returnType", "ItemStack");
        reflect_ItemStack_constructor_ItemStack_2.set("argnames", new String[]{"blockIn", "amount", "meta"});
        reflect_ItemStack_constructor_ItemStack_2.set("argtypes", new String[]{"Block", "int", "int"});
        reflect_ItemStack_constructor_ItemStack_2.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new ItemStack((Block) params.getReflective("blockIn"), (int) params.getInt("amount"), (int) params.getInt("meta"));
        });
        
        reflect_ItemStack_constructors.add(reflect_ItemStack_constructor_ItemStack_2);


        BaseData reflect_ItemStack_constructor_ItemStack_3 = new ModData();
        reflect_ItemStack_constructor_ItemStack_3.set("returnType", "ItemStack");
        reflect_ItemStack_constructor_ItemStack_3.set("argnames", new String[]{"itemIn"});
        reflect_ItemStack_constructor_ItemStack_3.set("argtypes", new String[]{"Item"});
        reflect_ItemStack_constructor_ItemStack_3.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new ItemStack((Item) params.getReflective("itemIn"));
        });
        
        reflect_ItemStack_constructors.add(reflect_ItemStack_constructor_ItemStack_3);


        BaseData reflect_ItemStack_constructor_ItemStack_4 = new ModData();
        reflect_ItemStack_constructor_ItemStack_4.set("returnType", "ItemStack");
        reflect_ItemStack_constructor_ItemStack_4.set("argnames", new String[]{"itemIn", "amount"});
        reflect_ItemStack_constructor_ItemStack_4.set("argtypes", new String[]{"Item", "int"});
        reflect_ItemStack_constructor_ItemStack_4.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new ItemStack((Item) params.getReflective("itemIn"), (int) params.getInt("amount"));
        });
        
        reflect_ItemStack_constructors.add(reflect_ItemStack_constructor_ItemStack_4);


        BaseData reflect_ItemStack_constructor_ItemStack_5 = new ModData();
        reflect_ItemStack_constructor_ItemStack_5.set("returnType", "ItemStack");
        reflect_ItemStack_constructor_ItemStack_5.set("argnames", new String[]{"itemIn", "amount", "meta"});
        reflect_ItemStack_constructor_ItemStack_5.set("argtypes", new String[]{"Item", "int", "int"});
        reflect_ItemStack_constructor_ItemStack_5.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new ItemStack((Item) params.getReflective("itemIn"), (int) params.getInt("amount"), (int) params.getInt("meta"));
        });
        
        reflect_ItemStack_constructors.add(reflect_ItemStack_constructor_ItemStack_5);


        BaseData[] reflect_ItemStack_constructors_arr = new BaseData[reflect_ItemStack_constructors.size()];
        for (int i = 0; i < reflect_ItemStack_constructors_arr.length; i++) {
            reflect_ItemStack_constructors_arr[i] = reflect_ItemStack_constructors.get(i);
        }

        ArrayList<BaseData> reflect_ItemStack_methods = new ArrayList<BaseData>();
        
        BaseData reflect_ItemStack_method_loadModData_0 = new ModData();
        reflect_ItemStack_method_loadModData_0.set("methodName", "loadModData");
        reflect_ItemStack_method_loadModData_0.set("returnType", "void");
        reflect_ItemStack_method_loadModData_0.set("static", false);
        reflect_ItemStack_method_loadModData_0.set("argnames", new String[]{"data"});
        reflect_ItemStack_method_loadModData_0.set("argtypes", new String[]{"BaseData"});
        reflect_ItemStack_method_loadModData_0.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((ItemStack) params.getReflective("_self")).loadModData((BaseData) params.getReflective("data"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_loadModData_0);


        BaseData reflect_ItemStack_method_fromModData_1 = new ModData();
        reflect_ItemStack_method_fromModData_1.set("methodName", "fromModData");
        reflect_ItemStack_method_fromModData_1.set("returnType", "ItemStack");
        reflect_ItemStack_method_fromModData_1.set("static", true);
        reflect_ItemStack_method_fromModData_1.set("argnames", new String[]{"data"});
        reflect_ItemStack_method_fromModData_1.set("argtypes", new String[]{"BaseData"});
        reflect_ItemStack_method_fromModData_1.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (ItemStack) ItemStack.fromModData((BaseData) params.getReflective("data"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_fromModData_1);


        BaseData reflect_ItemStack_method_makeModData_2 = new ModData();
        reflect_ItemStack_method_makeModData_2.set("methodName", "makeModData");
        reflect_ItemStack_method_makeModData_2.set("returnType", "ModData");
        reflect_ItemStack_method_makeModData_2.set("static", false);
        reflect_ItemStack_method_makeModData_2.set("argnames", new String[]{});
        reflect_ItemStack_method_makeModData_2.set("argtypes", new String[]{});
        reflect_ItemStack_method_makeModData_2.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (ModData) ((ItemStack) params.getReflective("_self")).makeModData();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_makeModData_2);


        BaseData reflect_ItemStack_method_loadItemStackFromNBT_3 = new ModData();
        reflect_ItemStack_method_loadItemStackFromNBT_3.set("methodName", "loadItemStackFromNBT");
        reflect_ItemStack_method_loadItemStackFromNBT_3.set("returnType", "ItemStack");
        reflect_ItemStack_method_loadItemStackFromNBT_3.set("static", true);
        reflect_ItemStack_method_loadItemStackFromNBT_3.set("argnames", new String[]{"nbt"});
        reflect_ItemStack_method_loadItemStackFromNBT_3.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_ItemStack_method_loadItemStackFromNBT_3.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (ItemStack) ItemStack.loadItemStackFromNBT((NBTTagCompound) params.getReflective("nbt"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_loadItemStackFromNBT_3);


        BaseData reflect_ItemStack_method_splitStack_4 = new ModData();
        reflect_ItemStack_method_splitStack_4.set("methodName", "splitStack");
        reflect_ItemStack_method_splitStack_4.set("returnType", "ItemStack");
        reflect_ItemStack_method_splitStack_4.set("static", false);
        reflect_ItemStack_method_splitStack_4.set("argnames", new String[]{"amount"});
        reflect_ItemStack_method_splitStack_4.set("argtypes", new String[]{"int"});
        reflect_ItemStack_method_splitStack_4.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (ItemStack) ((ItemStack) params.getReflective("_self")).splitStack((int) params.getInt("amount"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_splitStack_4);


        BaseData reflect_ItemStack_method_getItem_5 = new ModData();
        reflect_ItemStack_method_getItem_5.set("methodName", "getItem");
        reflect_ItemStack_method_getItem_5.set("returnType", "Item");
        reflect_ItemStack_method_getItem_5.set("static", false);
        reflect_ItemStack_method_getItem_5.set("argnames", new String[]{});
        reflect_ItemStack_method_getItem_5.set("argtypes", new String[]{});
        reflect_ItemStack_method_getItem_5.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Item) ((ItemStack) params.getReflective("_self")).getItem();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_getItem_5);


        BaseData reflect_ItemStack_method_getStrVsBlock_6 = new ModData();
        reflect_ItemStack_method_getStrVsBlock_6.set("methodName", "getStrVsBlock");
        reflect_ItemStack_method_getStrVsBlock_6.set("returnType", "float");
        reflect_ItemStack_method_getStrVsBlock_6.set("static", false);
        reflect_ItemStack_method_getStrVsBlock_6.set("argnames", new String[]{"blockIn"});
        reflect_ItemStack_method_getStrVsBlock_6.set("argtypes", new String[]{"Block"});
        reflect_ItemStack_method_getStrVsBlock_6.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((ItemStack) params.getReflective("_self")).getStrVsBlock((Block) params.getReflective("blockIn"));
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_getStrVsBlock_6);


        BaseData reflect_ItemStack_method_useItemRightClick_7 = new ModData();
        reflect_ItemStack_method_useItemRightClick_7.set("methodName", "useItemRightClick");
        reflect_ItemStack_method_useItemRightClick_7.set("returnType", "ItemStack");
        reflect_ItemStack_method_useItemRightClick_7.set("static", false);
        reflect_ItemStack_method_useItemRightClick_7.set("argnames", new String[]{"worldIn", "playerIn"});
        reflect_ItemStack_method_useItemRightClick_7.set("argtypes", new String[]{"World", "EntityPlayer"});
        reflect_ItemStack_method_useItemRightClick_7.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (ItemStack) ((ItemStack) params.getReflective("_self")).useItemRightClick((World) params.getReflective("worldIn"), (EntityPlayer) params.getReflective("playerIn"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_useItemRightClick_7);


        BaseData reflect_ItemStack_method_onItemUseFinish_8 = new ModData();
        reflect_ItemStack_method_onItemUseFinish_8.set("methodName", "onItemUseFinish");
        reflect_ItemStack_method_onItemUseFinish_8.set("returnType", "ItemStack");
        reflect_ItemStack_method_onItemUseFinish_8.set("static", false);
        reflect_ItemStack_method_onItemUseFinish_8.set("argnames", new String[]{"worldIn", "playerIn"});
        reflect_ItemStack_method_onItemUseFinish_8.set("argtypes", new String[]{"World", "EntityPlayer"});
        reflect_ItemStack_method_onItemUseFinish_8.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (ItemStack) ((ItemStack) params.getReflective("_self")).onItemUseFinish((World) params.getReflective("worldIn"), (EntityPlayer) params.getReflective("playerIn"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_onItemUseFinish_8);


        BaseData reflect_ItemStack_method_writeToNBT_9 = new ModData();
        reflect_ItemStack_method_writeToNBT_9.set("methodName", "writeToNBT");
        reflect_ItemStack_method_writeToNBT_9.set("returnType", "NBTTagCompound");
        reflect_ItemStack_method_writeToNBT_9.set("static", false);
        reflect_ItemStack_method_writeToNBT_9.set("argnames", new String[]{"nbt"});
        reflect_ItemStack_method_writeToNBT_9.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_ItemStack_method_writeToNBT_9.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (NBTTagCompound) ((ItemStack) params.getReflective("_self")).writeToNBT((NBTTagCompound) params.getReflective("nbt"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_writeToNBT_9);


        BaseData reflect_ItemStack_method_toNBT_10 = new ModData();
        reflect_ItemStack_method_toNBT_10.set("methodName", "toNBT");
        reflect_ItemStack_method_toNBT_10.set("returnType", "String");
        reflect_ItemStack_method_toNBT_10.set("static", false);
        reflect_ItemStack_method_toNBT_10.set("argnames", new String[]{});
        reflect_ItemStack_method_toNBT_10.set("argtypes", new String[]{});
        reflect_ItemStack_method_toNBT_10.setCallbackStringWithDataArg("exec", (BaseData params) -> {
                try {
                    return (String) ((ItemStack) params.getReflective("_self")).toNBT();
                } catch (Exception _exception_reflect_) {
                    return "";
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_toNBT_10);


        BaseData reflect_ItemStack_method_fromNBT_11 = new ModData();
        reflect_ItemStack_method_fromNBT_11.set("methodName", "fromNBT");
        reflect_ItemStack_method_fromNBT_11.set("returnType", "void");
        reflect_ItemStack_method_fromNBT_11.set("static", false);
        reflect_ItemStack_method_fromNBT_11.set("argnames", new String[]{"nbt"});
        reflect_ItemStack_method_fromNBT_11.set("argtypes", new String[]{"String"});
        reflect_ItemStack_method_fromNBT_11.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((ItemStack) params.getReflective("_self")).fromNBT((String) params.getString("nbt"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_fromNBT_11);


        BaseData reflect_ItemStack_method_readFromNBT_12 = new ModData();
        reflect_ItemStack_method_readFromNBT_12.set("methodName", "readFromNBT");
        reflect_ItemStack_method_readFromNBT_12.set("returnType", "void");
        reflect_ItemStack_method_readFromNBT_12.set("static", false);
        reflect_ItemStack_method_readFromNBT_12.set("argnames", new String[]{"nbt"});
        reflect_ItemStack_method_readFromNBT_12.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_ItemStack_method_readFromNBT_12.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((ItemStack) params.getReflective("_self")).readFromNBT((NBTTagCompound) params.getReflective("nbt"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_readFromNBT_12);


        BaseData reflect_ItemStack_method_getMaxStackSize_13 = new ModData();
        reflect_ItemStack_method_getMaxStackSize_13.set("methodName", "getMaxStackSize");
        reflect_ItemStack_method_getMaxStackSize_13.set("returnType", "int");
        reflect_ItemStack_method_getMaxStackSize_13.set("static", false);
        reflect_ItemStack_method_getMaxStackSize_13.set("argnames", new String[]{});
        reflect_ItemStack_method_getMaxStackSize_13.set("argtypes", new String[]{});
        reflect_ItemStack_method_getMaxStackSize_13.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((ItemStack) params.getReflective("_self")).getMaxStackSize();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_getMaxStackSize_13);


        BaseData reflect_ItemStack_method_isStackable_14 = new ModData();
        reflect_ItemStack_method_isStackable_14.set("methodName", "isStackable");
        reflect_ItemStack_method_isStackable_14.set("returnType", "boolean");
        reflect_ItemStack_method_isStackable_14.set("static", false);
        reflect_ItemStack_method_isStackable_14.set("argnames", new String[]{});
        reflect_ItemStack_method_isStackable_14.set("argtypes", new String[]{});
        reflect_ItemStack_method_isStackable_14.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((ItemStack) params.getReflective("_self")).isStackable();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_isStackable_14);


        BaseData reflect_ItemStack_method_isItemStackDamageable_15 = new ModData();
        reflect_ItemStack_method_isItemStackDamageable_15.set("methodName", "isItemStackDamageable");
        reflect_ItemStack_method_isItemStackDamageable_15.set("returnType", "boolean");
        reflect_ItemStack_method_isItemStackDamageable_15.set("static", false);
        reflect_ItemStack_method_isItemStackDamageable_15.set("argnames", new String[]{});
        reflect_ItemStack_method_isItemStackDamageable_15.set("argtypes", new String[]{});
        reflect_ItemStack_method_isItemStackDamageable_15.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((ItemStack) params.getReflective("_self")).isItemStackDamageable();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_isItemStackDamageable_15);


        BaseData reflect_ItemStack_method_getHasSubtypes_16 = new ModData();
        reflect_ItemStack_method_getHasSubtypes_16.set("methodName", "getHasSubtypes");
        reflect_ItemStack_method_getHasSubtypes_16.set("returnType", "boolean");
        reflect_ItemStack_method_getHasSubtypes_16.set("static", false);
        reflect_ItemStack_method_getHasSubtypes_16.set("argnames", new String[]{});
        reflect_ItemStack_method_getHasSubtypes_16.set("argtypes", new String[]{});
        reflect_ItemStack_method_getHasSubtypes_16.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((ItemStack) params.getReflective("_self")).getHasSubtypes();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_getHasSubtypes_16);


        BaseData reflect_ItemStack_method_isItemDamaged_17 = new ModData();
        reflect_ItemStack_method_isItemDamaged_17.set("methodName", "isItemDamaged");
        reflect_ItemStack_method_isItemDamaged_17.set("returnType", "boolean");
        reflect_ItemStack_method_isItemDamaged_17.set("static", false);
        reflect_ItemStack_method_isItemDamaged_17.set("argnames", new String[]{});
        reflect_ItemStack_method_isItemDamaged_17.set("argtypes", new String[]{});
        reflect_ItemStack_method_isItemDamaged_17.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((ItemStack) params.getReflective("_self")).isItemDamaged();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_isItemDamaged_17);


        BaseData reflect_ItemStack_method_getItemDamage_18 = new ModData();
        reflect_ItemStack_method_getItemDamage_18.set("methodName", "getItemDamage");
        reflect_ItemStack_method_getItemDamage_18.set("returnType", "int");
        reflect_ItemStack_method_getItemDamage_18.set("static", false);
        reflect_ItemStack_method_getItemDamage_18.set("argnames", new String[]{});
        reflect_ItemStack_method_getItemDamage_18.set("argtypes", new String[]{});
        reflect_ItemStack_method_getItemDamage_18.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((ItemStack) params.getReflective("_self")).getItemDamage();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_getItemDamage_18);


        BaseData reflect_ItemStack_method_getMetadata_19 = new ModData();
        reflect_ItemStack_method_getMetadata_19.set("methodName", "getMetadata");
        reflect_ItemStack_method_getMetadata_19.set("returnType", "int");
        reflect_ItemStack_method_getMetadata_19.set("static", false);
        reflect_ItemStack_method_getMetadata_19.set("argnames", new String[]{});
        reflect_ItemStack_method_getMetadata_19.set("argtypes", new String[]{});
        reflect_ItemStack_method_getMetadata_19.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((ItemStack) params.getReflective("_self")).getMetadata();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_getMetadata_19);


        BaseData reflect_ItemStack_method_setItemDamage_20 = new ModData();
        reflect_ItemStack_method_setItemDamage_20.set("methodName", "setItemDamage");
        reflect_ItemStack_method_setItemDamage_20.set("returnType", "void");
        reflect_ItemStack_method_setItemDamage_20.set("static", false);
        reflect_ItemStack_method_setItemDamage_20.set("argnames", new String[]{"meta"});
        reflect_ItemStack_method_setItemDamage_20.set("argtypes", new String[]{"int"});
        reflect_ItemStack_method_setItemDamage_20.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((ItemStack) params.getReflective("_self")).setItemDamage((int) params.getInt("meta"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_setItemDamage_20);


        BaseData reflect_ItemStack_method_getMaxDamage_21 = new ModData();
        reflect_ItemStack_method_getMaxDamage_21.set("methodName", "getMaxDamage");
        reflect_ItemStack_method_getMaxDamage_21.set("returnType", "int");
        reflect_ItemStack_method_getMaxDamage_21.set("static", false);
        reflect_ItemStack_method_getMaxDamage_21.set("argnames", new String[]{});
        reflect_ItemStack_method_getMaxDamage_21.set("argtypes", new String[]{});
        reflect_ItemStack_method_getMaxDamage_21.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((ItemStack) params.getReflective("_self")).getMaxDamage();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_getMaxDamage_21);


        BaseData reflect_ItemStack_method_attemptDamageItem_22 = new ModData();
        reflect_ItemStack_method_attemptDamageItem_22.set("methodName", "attemptDamageItem");
        reflect_ItemStack_method_attemptDamageItem_22.set("returnType", "boolean");
        reflect_ItemStack_method_attemptDamageItem_22.set("static", false);
        reflect_ItemStack_method_attemptDamageItem_22.set("argnames", new String[]{"amount", "rand"});
        reflect_ItemStack_method_attemptDamageItem_22.set("argtypes", new String[]{"int", "EaglercraftRandom"});
        reflect_ItemStack_method_attemptDamageItem_22.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((ItemStack) params.getReflective("_self")).attemptDamageItem((int) params.getInt("amount"), (EaglercraftRandom) params.getReflective("rand"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_attemptDamageItem_22);


        BaseData reflect_ItemStack_method_damageItem_23 = new ModData();
        reflect_ItemStack_method_damageItem_23.set("methodName", "damageItem");
        reflect_ItemStack_method_damageItem_23.set("returnType", "void");
        reflect_ItemStack_method_damageItem_23.set("static", false);
        reflect_ItemStack_method_damageItem_23.set("argnames", new String[]{"amount", "entityIn"});
        reflect_ItemStack_method_damageItem_23.set("argtypes", new String[]{"int", "EntityLivingBase"});
        reflect_ItemStack_method_damageItem_23.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((ItemStack) params.getReflective("_self")).damageItem((int) params.getInt("amount"), (EntityLivingBase) params.getReflective("entityIn"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_damageItem_23);


        BaseData reflect_ItemStack_method_hitEntity_24 = new ModData();
        reflect_ItemStack_method_hitEntity_24.set("methodName", "hitEntity");
        reflect_ItemStack_method_hitEntity_24.set("returnType", "void");
        reflect_ItemStack_method_hitEntity_24.set("static", false);
        reflect_ItemStack_method_hitEntity_24.set("argnames", new String[]{"entityIn", "playerIn"});
        reflect_ItemStack_method_hitEntity_24.set("argtypes", new String[]{"EntityLivingBase", "EntityPlayer"});
        reflect_ItemStack_method_hitEntity_24.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((ItemStack) params.getReflective("_self")).hitEntity((EntityLivingBase) params.getReflective("entityIn"), (EntityPlayer) params.getReflective("playerIn"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_hitEntity_24);


        BaseData reflect_ItemStack_method_onBlockDestroyed_25 = new ModData();
        reflect_ItemStack_method_onBlockDestroyed_25.set("methodName", "onBlockDestroyed");
        reflect_ItemStack_method_onBlockDestroyed_25.set("returnType", "void");
        reflect_ItemStack_method_onBlockDestroyed_25.set("static", false);
        reflect_ItemStack_method_onBlockDestroyed_25.set("argnames", new String[]{"worldIn", "blockIn", "pos", "playerIn"});
        reflect_ItemStack_method_onBlockDestroyed_25.set("argtypes", new String[]{"World", "Block", "BlockPos", "EntityPlayer"});
        reflect_ItemStack_method_onBlockDestroyed_25.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((ItemStack) params.getReflective("_self")).onBlockDestroyed((World) params.getReflective("worldIn"), (Block) params.getReflective("blockIn"), (BlockPos) params.getReflective("pos"), (EntityPlayer) params.getReflective("playerIn"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_onBlockDestroyed_25);


        BaseData reflect_ItemStack_method_canHarvestBlock_26 = new ModData();
        reflect_ItemStack_method_canHarvestBlock_26.set("methodName", "canHarvestBlock");
        reflect_ItemStack_method_canHarvestBlock_26.set("returnType", "boolean");
        reflect_ItemStack_method_canHarvestBlock_26.set("static", false);
        reflect_ItemStack_method_canHarvestBlock_26.set("argnames", new String[]{"blockIn"});
        reflect_ItemStack_method_canHarvestBlock_26.set("argtypes", new String[]{"Block"});
        reflect_ItemStack_method_canHarvestBlock_26.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((ItemStack) params.getReflective("_self")).canHarvestBlock((Block) params.getReflective("blockIn"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_canHarvestBlock_26);


        BaseData reflect_ItemStack_method_interactWithEntity_27 = new ModData();
        reflect_ItemStack_method_interactWithEntity_27.set("methodName", "interactWithEntity");
        reflect_ItemStack_method_interactWithEntity_27.set("returnType", "boolean");
        reflect_ItemStack_method_interactWithEntity_27.set("static", false);
        reflect_ItemStack_method_interactWithEntity_27.set("argnames", new String[]{"playerIn", "entityIn"});
        reflect_ItemStack_method_interactWithEntity_27.set("argtypes", new String[]{"EntityPlayer", "EntityLivingBase"});
        reflect_ItemStack_method_interactWithEntity_27.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((ItemStack) params.getReflective("_self")).interactWithEntity((EntityPlayer) params.getReflective("playerIn"), (EntityLivingBase) params.getReflective("entityIn"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_interactWithEntity_27);


        BaseData reflect_ItemStack_method_copy_28 = new ModData();
        reflect_ItemStack_method_copy_28.set("methodName", "copy");
        reflect_ItemStack_method_copy_28.set("returnType", "ItemStack");
        reflect_ItemStack_method_copy_28.set("static", false);
        reflect_ItemStack_method_copy_28.set("argnames", new String[]{});
        reflect_ItemStack_method_copy_28.set("argtypes", new String[]{});
        reflect_ItemStack_method_copy_28.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (ItemStack) ((ItemStack) params.getReflective("_self")).copy();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_copy_28);


        BaseData reflect_ItemStack_method_areItemStackTagsEqual_29 = new ModData();
        reflect_ItemStack_method_areItemStackTagsEqual_29.set("methodName", "areItemStackTagsEqual");
        reflect_ItemStack_method_areItemStackTagsEqual_29.set("returnType", "boolean");
        reflect_ItemStack_method_areItemStackTagsEqual_29.set("static", true);
        reflect_ItemStack_method_areItemStackTagsEqual_29.set("argnames", new String[]{"stackA", "stackB"});
        reflect_ItemStack_method_areItemStackTagsEqual_29.set("argtypes", new String[]{"ItemStack", "ItemStack"});
        reflect_ItemStack_method_areItemStackTagsEqual_29.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ItemStack.areItemStackTagsEqual((ItemStack) params.getReflective("stackA"), (ItemStack) params.getReflective("stackB"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_areItemStackTagsEqual_29);


        BaseData reflect_ItemStack_method_areItemStacksEqual_30 = new ModData();
        reflect_ItemStack_method_areItemStacksEqual_30.set("methodName", "areItemStacksEqual");
        reflect_ItemStack_method_areItemStacksEqual_30.set("returnType", "boolean");
        reflect_ItemStack_method_areItemStacksEqual_30.set("static", true);
        reflect_ItemStack_method_areItemStacksEqual_30.set("argnames", new String[]{"stackA", "stackB"});
        reflect_ItemStack_method_areItemStacksEqual_30.set("argtypes", new String[]{"ItemStack", "ItemStack"});
        reflect_ItemStack_method_areItemStacksEqual_30.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ItemStack.areItemStacksEqual((ItemStack) params.getReflective("stackA"), (ItemStack) params.getReflective("stackB"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_areItemStacksEqual_30);


        BaseData reflect_ItemStack_method_areItemsEqual_31 = new ModData();
        reflect_ItemStack_method_areItemsEqual_31.set("methodName", "areItemsEqual");
        reflect_ItemStack_method_areItemsEqual_31.set("returnType", "boolean");
        reflect_ItemStack_method_areItemsEqual_31.set("static", true);
        reflect_ItemStack_method_areItemsEqual_31.set("argnames", new String[]{"stackA", "stackB"});
        reflect_ItemStack_method_areItemsEqual_31.set("argtypes", new String[]{"ItemStack", "ItemStack"});
        reflect_ItemStack_method_areItemsEqual_31.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ItemStack.areItemsEqual((ItemStack) params.getReflective("stackA"), (ItemStack) params.getReflective("stackB"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_areItemsEqual_31);


        BaseData reflect_ItemStack_method_isItemEqual_32 = new ModData();
        reflect_ItemStack_method_isItemEqual_32.set("methodName", "isItemEqual");
        reflect_ItemStack_method_isItemEqual_32.set("returnType", "boolean");
        reflect_ItemStack_method_isItemEqual_32.set("static", false);
        reflect_ItemStack_method_isItemEqual_32.set("argnames", new String[]{"other"});
        reflect_ItemStack_method_isItemEqual_32.set("argtypes", new String[]{"ItemStack"});
        reflect_ItemStack_method_isItemEqual_32.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((ItemStack) params.getReflective("_self")).isItemEqual((ItemStack) params.getReflective("other"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_isItemEqual_32);


        BaseData reflect_ItemStack_method_getUnlocalizedName_33 = new ModData();
        reflect_ItemStack_method_getUnlocalizedName_33.set("methodName", "getUnlocalizedName");
        reflect_ItemStack_method_getUnlocalizedName_33.set("returnType", "String");
        reflect_ItemStack_method_getUnlocalizedName_33.set("static", false);
        reflect_ItemStack_method_getUnlocalizedName_33.set("argnames", new String[]{});
        reflect_ItemStack_method_getUnlocalizedName_33.set("argtypes", new String[]{});
        reflect_ItemStack_method_getUnlocalizedName_33.setCallbackStringWithDataArg("exec", (BaseData params) -> {
                try {
                    return (String) ((ItemStack) params.getReflective("_self")).getUnlocalizedName();
                } catch (Exception _exception_reflect_) {
                    return "";
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_getUnlocalizedName_33);


        BaseData reflect_ItemStack_method_copyItemStack_34 = new ModData();
        reflect_ItemStack_method_copyItemStack_34.set("methodName", "copyItemStack");
        reflect_ItemStack_method_copyItemStack_34.set("returnType", "ItemStack");
        reflect_ItemStack_method_copyItemStack_34.set("static", true);
        reflect_ItemStack_method_copyItemStack_34.set("argnames", new String[]{"stack"});
        reflect_ItemStack_method_copyItemStack_34.set("argtypes", new String[]{"ItemStack"});
        reflect_ItemStack_method_copyItemStack_34.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (ItemStack) ItemStack.copyItemStack((ItemStack) params.getReflective("stack"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_copyItemStack_34);


        BaseData reflect_ItemStack_method_toString_35 = new ModData();
        reflect_ItemStack_method_toString_35.set("methodName", "toString");
        reflect_ItemStack_method_toString_35.set("returnType", "String");
        reflect_ItemStack_method_toString_35.set("static", false);
        reflect_ItemStack_method_toString_35.set("argnames", new String[]{});
        reflect_ItemStack_method_toString_35.set("argtypes", new String[]{});
        reflect_ItemStack_method_toString_35.setCallbackStringWithDataArg("exec", (BaseData params) -> {
                try {
                    return (String) ((ItemStack) params.getReflective("_self")).toString();
                } catch (Exception _exception_reflect_) {
                    return "";
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_toString_35);


        BaseData reflect_ItemStack_method_updateAnimation_36 = new ModData();
        reflect_ItemStack_method_updateAnimation_36.set("methodName", "updateAnimation");
        reflect_ItemStack_method_updateAnimation_36.set("returnType", "void");
        reflect_ItemStack_method_updateAnimation_36.set("static", false);
        reflect_ItemStack_method_updateAnimation_36.set("argnames", new String[]{"worldIn", "entityIn", "inventorySlot", "isCurrentItem"});
        reflect_ItemStack_method_updateAnimation_36.set("argtypes", new String[]{"World", "Entity", "int", "boolean"});
        reflect_ItemStack_method_updateAnimation_36.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((ItemStack) params.getReflective("_self")).updateAnimation((World) params.getReflective("worldIn"), (Entity) params.getReflective("entityIn"), (int) params.getInt("inventorySlot"), (boolean) params.getBoolean("isCurrentItem"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_updateAnimation_36);


        BaseData reflect_ItemStack_method_onCrafting_37 = new ModData();
        reflect_ItemStack_method_onCrafting_37.set("methodName", "onCrafting");
        reflect_ItemStack_method_onCrafting_37.set("returnType", "void");
        reflect_ItemStack_method_onCrafting_37.set("static", false);
        reflect_ItemStack_method_onCrafting_37.set("argnames", new String[]{"worldIn", "playerIn", "amount"});
        reflect_ItemStack_method_onCrafting_37.set("argtypes", new String[]{"World", "EntityPlayer", "int"});
        reflect_ItemStack_method_onCrafting_37.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((ItemStack) params.getReflective("_self")).onCrafting((World) params.getReflective("worldIn"), (EntityPlayer) params.getReflective("playerIn"), (int) params.getInt("amount"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_onCrafting_37);


        BaseData reflect_ItemStack_method_getIsItemStackEqual_38 = new ModData();
        reflect_ItemStack_method_getIsItemStackEqual_38.set("methodName", "getIsItemStackEqual");
        reflect_ItemStack_method_getIsItemStackEqual_38.set("returnType", "boolean");
        reflect_ItemStack_method_getIsItemStackEqual_38.set("static", false);
        reflect_ItemStack_method_getIsItemStackEqual_38.set("argnames", new String[]{"parItemStack"});
        reflect_ItemStack_method_getIsItemStackEqual_38.set("argtypes", new String[]{"ItemStack"});
        reflect_ItemStack_method_getIsItemStackEqual_38.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((ItemStack) params.getReflective("_self")).getIsItemStackEqual((ItemStack) params.getReflective("parItemStack"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_getIsItemStackEqual_38);


        BaseData reflect_ItemStack_method_getMaxItemUseDuration_39 = new ModData();
        reflect_ItemStack_method_getMaxItemUseDuration_39.set("methodName", "getMaxItemUseDuration");
        reflect_ItemStack_method_getMaxItemUseDuration_39.set("returnType", "int");
        reflect_ItemStack_method_getMaxItemUseDuration_39.set("static", false);
        reflect_ItemStack_method_getMaxItemUseDuration_39.set("argnames", new String[]{});
        reflect_ItemStack_method_getMaxItemUseDuration_39.set("argtypes", new String[]{});
        reflect_ItemStack_method_getMaxItemUseDuration_39.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((ItemStack) params.getReflective("_self")).getMaxItemUseDuration();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_getMaxItemUseDuration_39);


        BaseData reflect_ItemStack_method_getItemUseAction_40 = new ModData();
        reflect_ItemStack_method_getItemUseAction_40.set("methodName", "getItemUseAction");
        reflect_ItemStack_method_getItemUseAction_40.set("returnType", "EnumAction");
        reflect_ItemStack_method_getItemUseAction_40.set("static", false);
        reflect_ItemStack_method_getItemUseAction_40.set("argnames", new String[]{});
        reflect_ItemStack_method_getItemUseAction_40.set("argtypes", new String[]{});
        reflect_ItemStack_method_getItemUseAction_40.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EnumAction) ((ItemStack) params.getReflective("_self")).getItemUseAction();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_getItemUseAction_40);


        BaseData reflect_ItemStack_method_onPlayerStoppedUsing_41 = new ModData();
        reflect_ItemStack_method_onPlayerStoppedUsing_41.set("methodName", "onPlayerStoppedUsing");
        reflect_ItemStack_method_onPlayerStoppedUsing_41.set("returnType", "void");
        reflect_ItemStack_method_onPlayerStoppedUsing_41.set("static", false);
        reflect_ItemStack_method_onPlayerStoppedUsing_41.set("argnames", new String[]{"worldIn", "playerIn", "timeLeft"});
        reflect_ItemStack_method_onPlayerStoppedUsing_41.set("argtypes", new String[]{"World", "EntityPlayer", "int"});
        reflect_ItemStack_method_onPlayerStoppedUsing_41.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((ItemStack) params.getReflective("_self")).onPlayerStoppedUsing((World) params.getReflective("worldIn"), (EntityPlayer) params.getReflective("playerIn"), (int) params.getInt("timeLeft"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_onPlayerStoppedUsing_41);


        BaseData reflect_ItemStack_method_hasTagCompound_42 = new ModData();
        reflect_ItemStack_method_hasTagCompound_42.set("methodName", "hasTagCompound");
        reflect_ItemStack_method_hasTagCompound_42.set("returnType", "boolean");
        reflect_ItemStack_method_hasTagCompound_42.set("static", false);
        reflect_ItemStack_method_hasTagCompound_42.set("argnames", new String[]{});
        reflect_ItemStack_method_hasTagCompound_42.set("argtypes", new String[]{});
        reflect_ItemStack_method_hasTagCompound_42.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((ItemStack) params.getReflective("_self")).hasTagCompound();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_hasTagCompound_42);


        BaseData reflect_ItemStack_method_getTagCompound_43 = new ModData();
        reflect_ItemStack_method_getTagCompound_43.set("methodName", "getTagCompound");
        reflect_ItemStack_method_getTagCompound_43.set("returnType", "NBTTagCompound");
        reflect_ItemStack_method_getTagCompound_43.set("static", false);
        reflect_ItemStack_method_getTagCompound_43.set("argnames", new String[]{});
        reflect_ItemStack_method_getTagCompound_43.set("argtypes", new String[]{});
        reflect_ItemStack_method_getTagCompound_43.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (NBTTagCompound) ((ItemStack) params.getReflective("_self")).getTagCompound();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_getTagCompound_43);


        BaseData reflect_ItemStack_method_getSubCompound_44 = new ModData();
        reflect_ItemStack_method_getSubCompound_44.set("methodName", "getSubCompound");
        reflect_ItemStack_method_getSubCompound_44.set("returnType", "NBTTagCompound");
        reflect_ItemStack_method_getSubCompound_44.set("static", false);
        reflect_ItemStack_method_getSubCompound_44.set("argnames", new String[]{"key", "create"});
        reflect_ItemStack_method_getSubCompound_44.set("argtypes", new String[]{"String", "boolean"});
        reflect_ItemStack_method_getSubCompound_44.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (NBTTagCompound) ((ItemStack) params.getReflective("_self")).getSubCompound((String) params.getString("key"), (boolean) params.getBoolean("create"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_getSubCompound_44);


        BaseData reflect_ItemStack_method_getEnchantmentTagList_45 = new ModData();
        reflect_ItemStack_method_getEnchantmentTagList_45.set("methodName", "getEnchantmentTagList");
        reflect_ItemStack_method_getEnchantmentTagList_45.set("returnType", "NBTTagList");
        reflect_ItemStack_method_getEnchantmentTagList_45.set("static", false);
        reflect_ItemStack_method_getEnchantmentTagList_45.set("argnames", new String[]{});
        reflect_ItemStack_method_getEnchantmentTagList_45.set("argtypes", new String[]{});
        reflect_ItemStack_method_getEnchantmentTagList_45.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (NBTTagList) ((ItemStack) params.getReflective("_self")).getEnchantmentTagList();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_getEnchantmentTagList_45);


        BaseData reflect_ItemStack_method_setTagCompound_46 = new ModData();
        reflect_ItemStack_method_setTagCompound_46.set("methodName", "setTagCompound");
        reflect_ItemStack_method_setTagCompound_46.set("returnType", "void");
        reflect_ItemStack_method_setTagCompound_46.set("static", false);
        reflect_ItemStack_method_setTagCompound_46.set("argnames", new String[]{"nbt"});
        reflect_ItemStack_method_setTagCompound_46.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_ItemStack_method_setTagCompound_46.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((ItemStack) params.getReflective("_self")).setTagCompound((NBTTagCompound) params.getReflective("nbt"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_setTagCompound_46);


        BaseData reflect_ItemStack_method_getDisplayName_47 = new ModData();
        reflect_ItemStack_method_getDisplayName_47.set("methodName", "getDisplayName");
        reflect_ItemStack_method_getDisplayName_47.set("returnType", "String");
        reflect_ItemStack_method_getDisplayName_47.set("static", false);
        reflect_ItemStack_method_getDisplayName_47.set("argnames", new String[]{});
        reflect_ItemStack_method_getDisplayName_47.set("argtypes", new String[]{});
        reflect_ItemStack_method_getDisplayName_47.setCallbackStringWithDataArg("exec", (BaseData params) -> {
                try {
                    return (String) ((ItemStack) params.getReflective("_self")).getDisplayName();
                } catch (Exception _exception_reflect_) {
                    return "";
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_getDisplayName_47);


        BaseData reflect_ItemStack_method_setStackDisplayName_48 = new ModData();
        reflect_ItemStack_method_setStackDisplayName_48.set("methodName", "setStackDisplayName");
        reflect_ItemStack_method_setStackDisplayName_48.set("returnType", "ItemStack");
        reflect_ItemStack_method_setStackDisplayName_48.set("static", false);
        reflect_ItemStack_method_setStackDisplayName_48.set("argnames", new String[]{"displayName"});
        reflect_ItemStack_method_setStackDisplayName_48.set("argtypes", new String[]{"String"});
        reflect_ItemStack_method_setStackDisplayName_48.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (ItemStack) ((ItemStack) params.getReflective("_self")).setStackDisplayName((String) params.getString("displayName"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_setStackDisplayName_48);


        BaseData reflect_ItemStack_method_setLore_49 = new ModData();
        reflect_ItemStack_method_setLore_49.set("methodName", "setLore");
        reflect_ItemStack_method_setLore_49.set("returnType", "void");
        reflect_ItemStack_method_setLore_49.set("static", false);
        reflect_ItemStack_method_setLore_49.set("argnames", new String[]{"loreIn"});
        reflect_ItemStack_method_setLore_49.set("argtypes", new String[]{"String[]"});
        reflect_ItemStack_method_setLore_49.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((ItemStack) params.getReflective("_self")).setLore((String[]) params.getReflective("loreIn"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_setLore_49);


        BaseData reflect_ItemStack_method_getLore_50 = new ModData();
        reflect_ItemStack_method_getLore_50.set("methodName", "getLore");
        reflect_ItemStack_method_getLore_50.set("returnType", "String[]");
        reflect_ItemStack_method_getLore_50.set("static", false);
        reflect_ItemStack_method_getLore_50.set("argnames", new String[]{});
        reflect_ItemStack_method_getLore_50.set("argtypes", new String[]{});
        reflect_ItemStack_method_getLore_50.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (String[]) ((ItemStack) params.getReflective("_self")).getLore();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_getLore_50);


        BaseData reflect_ItemStack_method_clearCustomName_51 = new ModData();
        reflect_ItemStack_method_clearCustomName_51.set("methodName", "clearCustomName");
        reflect_ItemStack_method_clearCustomName_51.set("returnType", "void");
        reflect_ItemStack_method_clearCustomName_51.set("static", false);
        reflect_ItemStack_method_clearCustomName_51.set("argnames", new String[]{});
        reflect_ItemStack_method_clearCustomName_51.set("argtypes", new String[]{});
        reflect_ItemStack_method_clearCustomName_51.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((ItemStack) params.getReflective("_self")).clearCustomName();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_clearCustomName_51);


        BaseData reflect_ItemStack_method_hasDisplayName_52 = new ModData();
        reflect_ItemStack_method_hasDisplayName_52.set("methodName", "hasDisplayName");
        reflect_ItemStack_method_hasDisplayName_52.set("returnType", "boolean");
        reflect_ItemStack_method_hasDisplayName_52.set("static", false);
        reflect_ItemStack_method_hasDisplayName_52.set("argnames", new String[]{});
        reflect_ItemStack_method_hasDisplayName_52.set("argtypes", new String[]{});
        reflect_ItemStack_method_hasDisplayName_52.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((ItemStack) params.getReflective("_self")).hasDisplayName();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_hasDisplayName_52);


        BaseData reflect_ItemStack_method_hasEffect_53 = new ModData();
        reflect_ItemStack_method_hasEffect_53.set("methodName", "hasEffect");
        reflect_ItemStack_method_hasEffect_53.set("returnType", "boolean");
        reflect_ItemStack_method_hasEffect_53.set("static", false);
        reflect_ItemStack_method_hasEffect_53.set("argnames", new String[]{});
        reflect_ItemStack_method_hasEffect_53.set("argtypes", new String[]{});
        reflect_ItemStack_method_hasEffect_53.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((ItemStack) params.getReflective("_self")).hasEffect();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_hasEffect_53);


        BaseData reflect_ItemStack_method_getRarity_54 = new ModData();
        reflect_ItemStack_method_getRarity_54.set("methodName", "getRarity");
        reflect_ItemStack_method_getRarity_54.set("returnType", "EnumRarity");
        reflect_ItemStack_method_getRarity_54.set("static", false);
        reflect_ItemStack_method_getRarity_54.set("argnames", new String[]{});
        reflect_ItemStack_method_getRarity_54.set("argtypes", new String[]{});
        reflect_ItemStack_method_getRarity_54.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EnumRarity) ((ItemStack) params.getReflective("_self")).getRarity();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_getRarity_54);


        BaseData reflect_ItemStack_method_isItemEnchantable_55 = new ModData();
        reflect_ItemStack_method_isItemEnchantable_55.set("methodName", "isItemEnchantable");
        reflect_ItemStack_method_isItemEnchantable_55.set("returnType", "boolean");
        reflect_ItemStack_method_isItemEnchantable_55.set("static", false);
        reflect_ItemStack_method_isItemEnchantable_55.set("argnames", new String[]{});
        reflect_ItemStack_method_isItemEnchantable_55.set("argtypes", new String[]{});
        reflect_ItemStack_method_isItemEnchantable_55.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((ItemStack) params.getReflective("_self")).isItemEnchantable();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_isItemEnchantable_55);


        BaseData reflect_ItemStack_method_addEnchantment_56 = new ModData();
        reflect_ItemStack_method_addEnchantment_56.set("methodName", "addEnchantment");
        reflect_ItemStack_method_addEnchantment_56.set("returnType", "void");
        reflect_ItemStack_method_addEnchantment_56.set("static", false);
        reflect_ItemStack_method_addEnchantment_56.set("argnames", new String[]{"ench", "level"});
        reflect_ItemStack_method_addEnchantment_56.set("argtypes", new String[]{"Enchantment", "int"});
        reflect_ItemStack_method_addEnchantment_56.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((ItemStack) params.getReflective("_self")).addEnchantment((Enchantment) params.getReflective("ench"), (int) params.getInt("level"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_addEnchantment_56);


        BaseData reflect_ItemStack_method_isItemEnchanted_57 = new ModData();
        reflect_ItemStack_method_isItemEnchanted_57.set("methodName", "isItemEnchanted");
        reflect_ItemStack_method_isItemEnchanted_57.set("returnType", "boolean");
        reflect_ItemStack_method_isItemEnchanted_57.set("static", false);
        reflect_ItemStack_method_isItemEnchanted_57.set("argnames", new String[]{});
        reflect_ItemStack_method_isItemEnchanted_57.set("argtypes", new String[]{});
        reflect_ItemStack_method_isItemEnchanted_57.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((ItemStack) params.getReflective("_self")).isItemEnchanted();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_isItemEnchanted_57);


        BaseData reflect_ItemStack_method_setTagInfo_58 = new ModData();
        reflect_ItemStack_method_setTagInfo_58.set("methodName", "setTagInfo");
        reflect_ItemStack_method_setTagInfo_58.set("returnType", "void");
        reflect_ItemStack_method_setTagInfo_58.set("static", false);
        reflect_ItemStack_method_setTagInfo_58.set("argnames", new String[]{"key", "value"});
        reflect_ItemStack_method_setTagInfo_58.set("argtypes", new String[]{"String", "NBTBase"});
        reflect_ItemStack_method_setTagInfo_58.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((ItemStack) params.getReflective("_self")).setTagInfo((String) params.getString("key"), (NBTBase) params.getReflective("value"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_setTagInfo_58);


        BaseData reflect_ItemStack_method_canEditBlocks_59 = new ModData();
        reflect_ItemStack_method_canEditBlocks_59.set("methodName", "canEditBlocks");
        reflect_ItemStack_method_canEditBlocks_59.set("returnType", "boolean");
        reflect_ItemStack_method_canEditBlocks_59.set("static", false);
        reflect_ItemStack_method_canEditBlocks_59.set("argnames", new String[]{});
        reflect_ItemStack_method_canEditBlocks_59.set("argtypes", new String[]{});
        reflect_ItemStack_method_canEditBlocks_59.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((ItemStack) params.getReflective("_self")).canEditBlocks();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_canEditBlocks_59);


        BaseData reflect_ItemStack_method_isOnItemFrame_60 = new ModData();
        reflect_ItemStack_method_isOnItemFrame_60.set("methodName", "isOnItemFrame");
        reflect_ItemStack_method_isOnItemFrame_60.set("returnType", "boolean");
        reflect_ItemStack_method_isOnItemFrame_60.set("static", false);
        reflect_ItemStack_method_isOnItemFrame_60.set("argnames", new String[]{});
        reflect_ItemStack_method_isOnItemFrame_60.set("argtypes", new String[]{});
        reflect_ItemStack_method_isOnItemFrame_60.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((ItemStack) params.getReflective("_self")).isOnItemFrame();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_isOnItemFrame_60);


        BaseData reflect_ItemStack_method_setItemFrame_61 = new ModData();
        reflect_ItemStack_method_setItemFrame_61.set("methodName", "setItemFrame");
        reflect_ItemStack_method_setItemFrame_61.set("returnType", "void");
        reflect_ItemStack_method_setItemFrame_61.set("static", false);
        reflect_ItemStack_method_setItemFrame_61.set("argnames", new String[]{"frame"});
        reflect_ItemStack_method_setItemFrame_61.set("argtypes", new String[]{"EntityItemFrame"});
        reflect_ItemStack_method_setItemFrame_61.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((ItemStack) params.getReflective("_self")).setItemFrame((EntityItemFrame) params.getReflective("frame"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_setItemFrame_61);


        BaseData reflect_ItemStack_method_getItemFrame_62 = new ModData();
        reflect_ItemStack_method_getItemFrame_62.set("methodName", "getItemFrame");
        reflect_ItemStack_method_getItemFrame_62.set("returnType", "EntityItemFrame");
        reflect_ItemStack_method_getItemFrame_62.set("static", false);
        reflect_ItemStack_method_getItemFrame_62.set("argnames", new String[]{});
        reflect_ItemStack_method_getItemFrame_62.set("argtypes", new String[]{});
        reflect_ItemStack_method_getItemFrame_62.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EntityItemFrame) ((ItemStack) params.getReflective("_self")).getItemFrame();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_getItemFrame_62);


        BaseData reflect_ItemStack_method_getRepairCost_63 = new ModData();
        reflect_ItemStack_method_getRepairCost_63.set("methodName", "getRepairCost");
        reflect_ItemStack_method_getRepairCost_63.set("returnType", "int");
        reflect_ItemStack_method_getRepairCost_63.set("static", false);
        reflect_ItemStack_method_getRepairCost_63.set("argnames", new String[]{});
        reflect_ItemStack_method_getRepairCost_63.set("argtypes", new String[]{});
        reflect_ItemStack_method_getRepairCost_63.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((ItemStack) params.getReflective("_self")).getRepairCost();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_getRepairCost_63);


        BaseData reflect_ItemStack_method_setRepairCost_64 = new ModData();
        reflect_ItemStack_method_setRepairCost_64.set("methodName", "setRepairCost");
        reflect_ItemStack_method_setRepairCost_64.set("returnType", "void");
        reflect_ItemStack_method_setRepairCost_64.set("static", false);
        reflect_ItemStack_method_setRepairCost_64.set("argnames", new String[]{"cost"});
        reflect_ItemStack_method_setRepairCost_64.set("argtypes", new String[]{"int"});
        reflect_ItemStack_method_setRepairCost_64.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((ItemStack) params.getReflective("_self")).setRepairCost((int) params.getInt("cost"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_setRepairCost_64);


        BaseData reflect_ItemStack_method_setItem_65 = new ModData();
        reflect_ItemStack_method_setItem_65.set("methodName", "setItem");
        reflect_ItemStack_method_setItem_65.set("returnType", "void");
        reflect_ItemStack_method_setItem_65.set("static", false);
        reflect_ItemStack_method_setItem_65.set("argnames", new String[]{"newItem"});
        reflect_ItemStack_method_setItem_65.set("argtypes", new String[]{"Item"});
        reflect_ItemStack_method_setItem_65.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((ItemStack) params.getReflective("_self")).setItem((Item) params.getReflective("newItem"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_setItem_65);


        BaseData reflect_ItemStack_method_getChatComponent_66 = new ModData();
        reflect_ItemStack_method_getChatComponent_66.set("methodName", "getChatComponent");
        reflect_ItemStack_method_getChatComponent_66.set("returnType", "IChatComponent");
        reflect_ItemStack_method_getChatComponent_66.set("static", false);
        reflect_ItemStack_method_getChatComponent_66.set("argnames", new String[]{});
        reflect_ItemStack_method_getChatComponent_66.set("argtypes", new String[]{});
        reflect_ItemStack_method_getChatComponent_66.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (IChatComponent) ((ItemStack) params.getReflective("_self")).getChatComponent();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_getChatComponent_66);


        BaseData reflect_ItemStack_method_canDestroy_67 = new ModData();
        reflect_ItemStack_method_canDestroy_67.set("methodName", "canDestroy");
        reflect_ItemStack_method_canDestroy_67.set("returnType", "boolean");
        reflect_ItemStack_method_canDestroy_67.set("static", false);
        reflect_ItemStack_method_canDestroy_67.set("argnames", new String[]{"blockIn"});
        reflect_ItemStack_method_canDestroy_67.set("argtypes", new String[]{"Block"});
        reflect_ItemStack_method_canDestroy_67.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((ItemStack) params.getReflective("_self")).canDestroy((Block) params.getReflective("blockIn"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_canDestroy_67);


        BaseData reflect_ItemStack_method_canPlaceOn_68 = new ModData();
        reflect_ItemStack_method_canPlaceOn_68.set("methodName", "canPlaceOn");
        reflect_ItemStack_method_canPlaceOn_68.set("returnType", "boolean");
        reflect_ItemStack_method_canPlaceOn_68.set("static", false);
        reflect_ItemStack_method_canPlaceOn_68.set("argnames", new String[]{"blockIn"});
        reflect_ItemStack_method_canPlaceOn_68.set("argtypes", new String[]{"Block"});
        reflect_ItemStack_method_canPlaceOn_68.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((ItemStack) params.getReflective("_self")).canPlaceOn((Block) params.getReflective("blockIn"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_ItemStack_methods.add(reflect_ItemStack_method_canPlaceOn_68);


        BaseData[] reflect_ItemStack_methods_arr = new BaseData[reflect_ItemStack_methods.size()];
        for (int i = 0; i < reflect_ItemStack_methods_arr.length; i++) {
            reflect_ItemStack_methods_arr[i] = reflect_ItemStack_methods.get(i);
        }

        reflect_ItemStack.set("constructors", reflect_ItemStack_constructors_arr);
        reflect_ItemStack.set("methods", reflect_ItemStack_methods_arr);
        reflect_ItemStack.set("className", "ItemStack");
        reflect_ItemStack.set("classId", "net.minecraft.item.ItemStack");
        reflect_ItemStack.set("class", ItemStack.class);
        reflect_ItemStack.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof ItemStack;
        });
        reflectProfiles.add(reflect_ItemStack);
    }


    //classdef for Blocks
    public static void reflect_Blocks_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_Blocks = new ModData();

        ArrayList<BaseData> reflect_Blocks_constructors = new ArrayList<BaseData>();
        
        BaseData[] reflect_Blocks_constructors_arr = new BaseData[reflect_Blocks_constructors.size()];
        for (int i = 0; i < reflect_Blocks_constructors_arr.length; i++) {
            reflect_Blocks_constructors_arr[i] = reflect_Blocks_constructors.get(i);
        }

        ArrayList<BaseData> reflect_Blocks_methods = new ArrayList<BaseData>();
        
        BaseData reflect_Blocks_method_makeModData_0 = new ModData();
        reflect_Blocks_method_makeModData_0.set("methodName", "makeModData");
        reflect_Blocks_method_makeModData_0.set("returnType", "ModData");
        reflect_Blocks_method_makeModData_0.set("static", true);
        reflect_Blocks_method_makeModData_0.set("argnames", new String[]{});
        reflect_Blocks_method_makeModData_0.set("argtypes", new String[]{});
        reflect_Blocks_method_makeModData_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (ModData) Blocks.makeModData();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Blocks_methods.add(reflect_Blocks_method_makeModData_0);


        BaseData[] reflect_Blocks_methods_arr = new BaseData[reflect_Blocks_methods.size()];
        for (int i = 0; i < reflect_Blocks_methods_arr.length; i++) {
            reflect_Blocks_methods_arr[i] = reflect_Blocks_methods.get(i);
        }

        reflect_Blocks.set("constructors", reflect_Blocks_constructors_arr);
        reflect_Blocks.set("methods", reflect_Blocks_methods_arr);
        reflect_Blocks.set("className", "Blocks");
        reflect_Blocks.set("classId", "net.minecraft.init.Blocks");
        reflect_Blocks.set("class", Blocks.class);
        reflect_Blocks.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof Blocks;
        });
        reflectProfiles.add(reflect_Blocks);
    }


    //classdef for Items
    public static void reflect_Items_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_Items = new ModData();

        ArrayList<BaseData> reflect_Items_constructors = new ArrayList<BaseData>();
        
        BaseData[] reflect_Items_constructors_arr = new BaseData[reflect_Items_constructors.size()];
        for (int i = 0; i < reflect_Items_constructors_arr.length; i++) {
            reflect_Items_constructors_arr[i] = reflect_Items_constructors.get(i);
        }

        ArrayList<BaseData> reflect_Items_methods = new ArrayList<BaseData>();
        
        BaseData reflect_Items_method_makeModData_0 = new ModData();
        reflect_Items_method_makeModData_0.set("methodName", "makeModData");
        reflect_Items_method_makeModData_0.set("returnType", "ModData");
        reflect_Items_method_makeModData_0.set("static", true);
        reflect_Items_method_makeModData_0.set("argnames", new String[]{});
        reflect_Items_method_makeModData_0.set("argtypes", new String[]{});
        reflect_Items_method_makeModData_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (ModData) Items.makeModData();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Items_methods.add(reflect_Items_method_makeModData_0);


        BaseData[] reflect_Items_methods_arr = new BaseData[reflect_Items_methods.size()];
        for (int i = 0; i < reflect_Items_methods_arr.length; i++) {
            reflect_Items_methods_arr[i] = reflect_Items_methods.get(i);
        }

        reflect_Items.set("constructors", reflect_Items_constructors_arr);
        reflect_Items.set("methods", reflect_Items_methods_arr);
        reflect_Items.set("className", "Items");
        reflect_Items.set("classId", "net.minecraft.init.Items");
        reflect_Items.set("class", Items.class);
        reflect_Items.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof Items;
        });
        reflectProfiles.add(reflect_Items);
    }


    //classdef for Entity
    public static void reflect_Entity_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_Entity = new ModData();

        ArrayList<BaseData> reflect_Entity_constructors = new ArrayList<BaseData>();
        
        BaseData[] reflect_Entity_constructors_arr = new BaseData[reflect_Entity_constructors.size()];
        for (int i = 0; i < reflect_Entity_constructors_arr.length; i++) {
            reflect_Entity_constructors_arr[i] = reflect_Entity_constructors.get(i);
        }

        ArrayList<BaseData> reflect_Entity_methods = new ArrayList<BaseData>();
        
        BaseData reflect_Entity_method_getEntityId_0 = new ModData();
        reflect_Entity_method_getEntityId_0.set("methodName", "getEntityId");
        reflect_Entity_method_getEntityId_0.set("returnType", "int");
        reflect_Entity_method_getEntityId_0.set("static", false);
        reflect_Entity_method_getEntityId_0.set("argnames", new String[]{});
        reflect_Entity_method_getEntityId_0.set("argtypes", new String[]{});
        reflect_Entity_method_getEntityId_0.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((Entity) params.getReflective("_self")).getEntityId();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_getEntityId_0);


        BaseData reflect_Entity_method_setEntityId_1 = new ModData();
        reflect_Entity_method_setEntityId_1.set("methodName", "setEntityId");
        reflect_Entity_method_setEntityId_1.set("returnType", "void");
        reflect_Entity_method_setEntityId_1.set("static", false);
        reflect_Entity_method_setEntityId_1.set("argnames", new String[]{"id"});
        reflect_Entity_method_setEntityId_1.set("argtypes", new String[]{"int"});
        reflect_Entity_method_setEntityId_1.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).setEntityId((int) params.getInt("id"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_setEntityId_1);


        BaseData reflect_Entity_method_onKillCommand_2 = new ModData();
        reflect_Entity_method_onKillCommand_2.set("methodName", "onKillCommand");
        reflect_Entity_method_onKillCommand_2.set("returnType", "void");
        reflect_Entity_method_onKillCommand_2.set("static", false);
        reflect_Entity_method_onKillCommand_2.set("argnames", new String[]{});
        reflect_Entity_method_onKillCommand_2.set("argtypes", new String[]{});
        reflect_Entity_method_onKillCommand_2.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).onKillCommand();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_onKillCommand_2);


        BaseData reflect_Entity_method_getDataWatcher_3 = new ModData();
        reflect_Entity_method_getDataWatcher_3.set("methodName", "getDataWatcher");
        reflect_Entity_method_getDataWatcher_3.set("returnType", "DataWatcher");
        reflect_Entity_method_getDataWatcher_3.set("static", false);
        reflect_Entity_method_getDataWatcher_3.set("argnames", new String[]{});
        reflect_Entity_method_getDataWatcher_3.set("argtypes", new String[]{});
        reflect_Entity_method_getDataWatcher_3.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (DataWatcher) ((Entity) params.getReflective("_self")).getDataWatcher();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_getDataWatcher_3);


        BaseData reflect_Entity_method_equals_4 = new ModData();
        reflect_Entity_method_equals_4.set("methodName", "equals");
        reflect_Entity_method_equals_4.set("returnType", "boolean");
        reflect_Entity_method_equals_4.set("static", false);
        reflect_Entity_method_equals_4.set("argnames", new String[]{"object"});
        reflect_Entity_method_equals_4.set("argtypes", new String[]{"Object"});
        reflect_Entity_method_equals_4.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((Entity) params.getReflective("_self")).equals((Object) params.getReflective("object"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_equals_4);


        BaseData reflect_Entity_method_hashCode_5 = new ModData();
        reflect_Entity_method_hashCode_5.set("methodName", "hashCode");
        reflect_Entity_method_hashCode_5.set("returnType", "int");
        reflect_Entity_method_hashCode_5.set("static", false);
        reflect_Entity_method_hashCode_5.set("argnames", new String[]{});
        reflect_Entity_method_hashCode_5.set("argtypes", new String[]{});
        reflect_Entity_method_hashCode_5.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((Entity) params.getReflective("_self")).hashCode();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_hashCode_5);


        BaseData reflect_Entity_method_setDead_6 = new ModData();
        reflect_Entity_method_setDead_6.set("methodName", "setDead");
        reflect_Entity_method_setDead_6.set("returnType", "void");
        reflect_Entity_method_setDead_6.set("static", false);
        reflect_Entity_method_setDead_6.set("argnames", new String[]{});
        reflect_Entity_method_setDead_6.set("argtypes", new String[]{});
        reflect_Entity_method_setDead_6.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).setDead();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_setDead_6);


        BaseData reflect_Entity_method_setPosition_7 = new ModData();
        reflect_Entity_method_setPosition_7.set("methodName", "setPosition");
        reflect_Entity_method_setPosition_7.set("returnType", "void");
        reflect_Entity_method_setPosition_7.set("static", false);
        reflect_Entity_method_setPosition_7.set("argnames", new String[]{"x", "y", "z"});
        reflect_Entity_method_setPosition_7.set("argtypes", new String[]{"double", "double", "double"});
        reflect_Entity_method_setPosition_7.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).setPosition((double) params.getDouble("x"), (double) params.getDouble("y"), (double) params.getDouble("z"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_setPosition_7);


        BaseData reflect_Entity_method_setAngles_8 = new ModData();
        reflect_Entity_method_setAngles_8.set("methodName", "setAngles");
        reflect_Entity_method_setAngles_8.set("returnType", "void");
        reflect_Entity_method_setAngles_8.set("static", false);
        reflect_Entity_method_setAngles_8.set("argnames", new String[]{"yaw", "pitch"});
        reflect_Entity_method_setAngles_8.set("argtypes", new String[]{"float", "float"});
        reflect_Entity_method_setAngles_8.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).setAngles((float) params.getFloat("yaw"), (float) params.getFloat("pitch"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_setAngles_8);


        BaseData reflect_Entity_method_onUpdate_9 = new ModData();
        reflect_Entity_method_onUpdate_9.set("methodName", "onUpdate");
        reflect_Entity_method_onUpdate_9.set("returnType", "void");
        reflect_Entity_method_onUpdate_9.set("static", false);
        reflect_Entity_method_onUpdate_9.set("argnames", new String[]{});
        reflect_Entity_method_onUpdate_9.set("argtypes", new String[]{});
        reflect_Entity_method_onUpdate_9.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).onUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_onUpdate_9);


        BaseData reflect_Entity_method_onEntityUpdate_10 = new ModData();
        reflect_Entity_method_onEntityUpdate_10.set("methodName", "onEntityUpdate");
        reflect_Entity_method_onEntityUpdate_10.set("returnType", "void");
        reflect_Entity_method_onEntityUpdate_10.set("static", false);
        reflect_Entity_method_onEntityUpdate_10.set("argnames", new String[]{});
        reflect_Entity_method_onEntityUpdate_10.set("argtypes", new String[]{});
        reflect_Entity_method_onEntityUpdate_10.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).onEntityUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_onEntityUpdate_10);


        BaseData reflect_Entity_method_getMaxInPortalTime_11 = new ModData();
        reflect_Entity_method_getMaxInPortalTime_11.set("methodName", "getMaxInPortalTime");
        reflect_Entity_method_getMaxInPortalTime_11.set("returnType", "int");
        reflect_Entity_method_getMaxInPortalTime_11.set("static", false);
        reflect_Entity_method_getMaxInPortalTime_11.set("argnames", new String[]{});
        reflect_Entity_method_getMaxInPortalTime_11.set("argtypes", new String[]{});
        reflect_Entity_method_getMaxInPortalTime_11.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((Entity) params.getReflective("_self")).getMaxInPortalTime();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_getMaxInPortalTime_11);


        BaseData reflect_Entity_method_setFire_12 = new ModData();
        reflect_Entity_method_setFire_12.set("methodName", "setFire");
        reflect_Entity_method_setFire_12.set("returnType", "void");
        reflect_Entity_method_setFire_12.set("static", false);
        reflect_Entity_method_setFire_12.set("argnames", new String[]{"seconds"});
        reflect_Entity_method_setFire_12.set("argtypes", new String[]{"int"});
        reflect_Entity_method_setFire_12.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).setFire((int) params.getInt("seconds"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_setFire_12);


        BaseData reflect_Entity_method_extinguish_13 = new ModData();
        reflect_Entity_method_extinguish_13.set("methodName", "extinguish");
        reflect_Entity_method_extinguish_13.set("returnType", "void");
        reflect_Entity_method_extinguish_13.set("static", false);
        reflect_Entity_method_extinguish_13.set("argnames", new String[]{});
        reflect_Entity_method_extinguish_13.set("argtypes", new String[]{});
        reflect_Entity_method_extinguish_13.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).extinguish();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_extinguish_13);


        BaseData reflect_Entity_method_isOffsetPositionInLiquid_14 = new ModData();
        reflect_Entity_method_isOffsetPositionInLiquid_14.set("methodName", "isOffsetPositionInLiquid");
        reflect_Entity_method_isOffsetPositionInLiquid_14.set("returnType", "boolean");
        reflect_Entity_method_isOffsetPositionInLiquid_14.set("static", false);
        reflect_Entity_method_isOffsetPositionInLiquid_14.set("argnames", new String[]{"x", "y", "z"});
        reflect_Entity_method_isOffsetPositionInLiquid_14.set("argtypes", new String[]{"double", "double", "double"});
        reflect_Entity_method_isOffsetPositionInLiquid_14.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((Entity) params.getReflective("_self")).isOffsetPositionInLiquid((double) params.getDouble("x"), (double) params.getDouble("y"), (double) params.getDouble("z"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_isOffsetPositionInLiquid_14);


        BaseData reflect_Entity_method_moveEntity_15 = new ModData();
        reflect_Entity_method_moveEntity_15.set("methodName", "moveEntity");
        reflect_Entity_method_moveEntity_15.set("returnType", "void");
        reflect_Entity_method_moveEntity_15.set("static", false);
        reflect_Entity_method_moveEntity_15.set("argnames", new String[]{"x", "y", "z"});
        reflect_Entity_method_moveEntity_15.set("argtypes", new String[]{"double", "double", "double"});
        reflect_Entity_method_moveEntity_15.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).moveEntity((double) params.getDouble("x"), (double) params.getDouble("y"), (double) params.getDouble("z"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_moveEntity_15);


        BaseData reflect_Entity_method_playSound_16 = new ModData();
        reflect_Entity_method_playSound_16.set("methodName", "playSound");
        reflect_Entity_method_playSound_16.set("returnType", "void");
        reflect_Entity_method_playSound_16.set("static", false);
        reflect_Entity_method_playSound_16.set("argnames", new String[]{"s", "f", "f1"});
        reflect_Entity_method_playSound_16.set("argtypes", new String[]{"String", "float", "float"});
        reflect_Entity_method_playSound_16.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).playSound((String) params.getString("s"), (float) params.getFloat("f"), (float) params.getFloat("f1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_playSound_16);


        BaseData reflect_Entity_method_isSilent_17 = new ModData();
        reflect_Entity_method_isSilent_17.set("methodName", "isSilent");
        reflect_Entity_method_isSilent_17.set("returnType", "boolean");
        reflect_Entity_method_isSilent_17.set("static", false);
        reflect_Entity_method_isSilent_17.set("argnames", new String[]{});
        reflect_Entity_method_isSilent_17.set("argtypes", new String[]{});
        reflect_Entity_method_isSilent_17.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((Entity) params.getReflective("_self")).isSilent();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_isSilent_17);


        BaseData reflect_Entity_method_setSilent_18 = new ModData();
        reflect_Entity_method_setSilent_18.set("methodName", "setSilent");
        reflect_Entity_method_setSilent_18.set("returnType", "void");
        reflect_Entity_method_setSilent_18.set("static", false);
        reflect_Entity_method_setSilent_18.set("argnames", new String[]{"isSilent"});
        reflect_Entity_method_setSilent_18.set("argtypes", new String[]{"boolean"});
        reflect_Entity_method_setSilent_18.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).setSilent((boolean) params.getBoolean("isSilent"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_setSilent_18);


        BaseData reflect_Entity_method_getCollisionBoundingBox_19 = new ModData();
        reflect_Entity_method_getCollisionBoundingBox_19.set("methodName", "getCollisionBoundingBox");
        reflect_Entity_method_getCollisionBoundingBox_19.set("returnType", "AxisAlignedBB");
        reflect_Entity_method_getCollisionBoundingBox_19.set("static", false);
        reflect_Entity_method_getCollisionBoundingBox_19.set("argnames", new String[]{});
        reflect_Entity_method_getCollisionBoundingBox_19.set("argtypes", new String[]{});
        reflect_Entity_method_getCollisionBoundingBox_19.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (AxisAlignedBB) ((Entity) params.getReflective("_self")).getCollisionBoundingBox();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_getCollisionBoundingBox_19);


        BaseData reflect_Entity_method_isImmuneToFire_20 = new ModData();
        reflect_Entity_method_isImmuneToFire_20.set("methodName", "isImmuneToFire");
        reflect_Entity_method_isImmuneToFire_20.set("returnType", "boolean");
        reflect_Entity_method_isImmuneToFire_20.set("static", false);
        reflect_Entity_method_isImmuneToFire_20.set("argnames", new String[]{});
        reflect_Entity_method_isImmuneToFire_20.set("argtypes", new String[]{});
        reflect_Entity_method_isImmuneToFire_20.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((Entity) params.getReflective("_self")).isImmuneToFire();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_isImmuneToFire_20);


        BaseData reflect_Entity_method_fall_21 = new ModData();
        reflect_Entity_method_fall_21.set("methodName", "fall");
        reflect_Entity_method_fall_21.set("returnType", "void");
        reflect_Entity_method_fall_21.set("static", false);
        reflect_Entity_method_fall_21.set("argnames", new String[]{"distance", "damageMultiplier"});
        reflect_Entity_method_fall_21.set("argtypes", new String[]{"float", "float"});
        reflect_Entity_method_fall_21.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).fall((float) params.getFloat("distance"), (float) params.getFloat("damageMultiplier"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_fall_21);


        BaseData reflect_Entity_method_isWet_22 = new ModData();
        reflect_Entity_method_isWet_22.set("methodName", "isWet");
        reflect_Entity_method_isWet_22.set("returnType", "boolean");
        reflect_Entity_method_isWet_22.set("static", false);
        reflect_Entity_method_isWet_22.set("argnames", new String[]{});
        reflect_Entity_method_isWet_22.set("argtypes", new String[]{});
        reflect_Entity_method_isWet_22.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((Entity) params.getReflective("_self")).isWet();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_isWet_22);


        BaseData reflect_Entity_method_isInWater_23 = new ModData();
        reflect_Entity_method_isInWater_23.set("methodName", "isInWater");
        reflect_Entity_method_isInWater_23.set("returnType", "boolean");
        reflect_Entity_method_isInWater_23.set("static", false);
        reflect_Entity_method_isInWater_23.set("argnames", new String[]{});
        reflect_Entity_method_isInWater_23.set("argtypes", new String[]{});
        reflect_Entity_method_isInWater_23.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((Entity) params.getReflective("_self")).isInWater();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_isInWater_23);


        BaseData reflect_Entity_method_loadModData_24 = new ModData();
        reflect_Entity_method_loadModData_24.set("methodName", "loadModData");
        reflect_Entity_method_loadModData_24.set("returnType", "void");
        reflect_Entity_method_loadModData_24.set("static", false);
        reflect_Entity_method_loadModData_24.set("argnames", new String[]{"data"});
        reflect_Entity_method_loadModData_24.set("argtypes", new String[]{"BaseData"});
        reflect_Entity_method_loadModData_24.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).loadModData((BaseData) params.getReflective("data"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_loadModData_24);


        BaseData reflect_Entity_method_makeModData_25 = new ModData();
        reflect_Entity_method_makeModData_25.set("methodName", "makeModData");
        reflect_Entity_method_makeModData_25.set("returnType", "ModData");
        reflect_Entity_method_makeModData_25.set("static", false);
        reflect_Entity_method_makeModData_25.set("argnames", new String[]{});
        reflect_Entity_method_makeModData_25.set("argtypes", new String[]{});
        reflect_Entity_method_makeModData_25.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (ModData) ((Entity) params.getReflective("_self")).makeModData();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_makeModData_25);


        BaseData reflect_Entity_method_handleWaterMovement_26 = new ModData();
        reflect_Entity_method_handleWaterMovement_26.set("methodName", "handleWaterMovement");
        reflect_Entity_method_handleWaterMovement_26.set("returnType", "boolean");
        reflect_Entity_method_handleWaterMovement_26.set("static", false);
        reflect_Entity_method_handleWaterMovement_26.set("argnames", new String[]{});
        reflect_Entity_method_handleWaterMovement_26.set("argtypes", new String[]{});
        reflect_Entity_method_handleWaterMovement_26.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((Entity) params.getReflective("_self")).handleWaterMovement();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_handleWaterMovement_26);


        BaseData reflect_Entity_method_spawnRunningParticles_27 = new ModData();
        reflect_Entity_method_spawnRunningParticles_27.set("methodName", "spawnRunningParticles");
        reflect_Entity_method_spawnRunningParticles_27.set("returnType", "void");
        reflect_Entity_method_spawnRunningParticles_27.set("static", false);
        reflect_Entity_method_spawnRunningParticles_27.set("argnames", new String[]{});
        reflect_Entity_method_spawnRunningParticles_27.set("argtypes", new String[]{});
        reflect_Entity_method_spawnRunningParticles_27.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).spawnRunningParticles();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_spawnRunningParticles_27);


        BaseData reflect_Entity_method_isInsideOfMaterial_28 = new ModData();
        reflect_Entity_method_isInsideOfMaterial_28.set("methodName", "isInsideOfMaterial");
        reflect_Entity_method_isInsideOfMaterial_28.set("returnType", "boolean");
        reflect_Entity_method_isInsideOfMaterial_28.set("static", false);
        reflect_Entity_method_isInsideOfMaterial_28.set("argnames", new String[]{"materialIn"});
        reflect_Entity_method_isInsideOfMaterial_28.set("argtypes", new String[]{"Material"});
        reflect_Entity_method_isInsideOfMaterial_28.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((Entity) params.getReflective("_self")).isInsideOfMaterial((Material) params.getReflective("materialIn"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_isInsideOfMaterial_28);


        BaseData reflect_Entity_method_isInLava_29 = new ModData();
        reflect_Entity_method_isInLava_29.set("methodName", "isInLava");
        reflect_Entity_method_isInLava_29.set("returnType", "boolean");
        reflect_Entity_method_isInLava_29.set("static", false);
        reflect_Entity_method_isInLava_29.set("argnames", new String[]{});
        reflect_Entity_method_isInLava_29.set("argtypes", new String[]{});
        reflect_Entity_method_isInLava_29.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((Entity) params.getReflective("_self")).isInLava();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_isInLava_29);


        BaseData reflect_Entity_method_moveFlying_30 = new ModData();
        reflect_Entity_method_moveFlying_30.set("methodName", "moveFlying");
        reflect_Entity_method_moveFlying_30.set("returnType", "void");
        reflect_Entity_method_moveFlying_30.set("static", false);
        reflect_Entity_method_moveFlying_30.set("argnames", new String[]{"strafe", "forward", "friction"});
        reflect_Entity_method_moveFlying_30.set("argtypes", new String[]{"float", "float", "float"});
        reflect_Entity_method_moveFlying_30.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).moveFlying((float) params.getFloat("strafe"), (float) params.getFloat("forward"), (float) params.getFloat("friction"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_moveFlying_30);


        BaseData reflect_Entity_method_getBrightnessForRender_31 = new ModData();
        reflect_Entity_method_getBrightnessForRender_31.set("methodName", "getBrightnessForRender");
        reflect_Entity_method_getBrightnessForRender_31.set("returnType", "int");
        reflect_Entity_method_getBrightnessForRender_31.set("static", false);
        reflect_Entity_method_getBrightnessForRender_31.set("argnames", new String[]{"var1"});
        reflect_Entity_method_getBrightnessForRender_31.set("argtypes", new String[]{"float"});
        reflect_Entity_method_getBrightnessForRender_31.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((Entity) params.getReflective("_self")).getBrightnessForRender((float) params.getFloat("var1"));
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_getBrightnessForRender_31);


        BaseData reflect_Entity_method_getBrightness_32 = new ModData();
        reflect_Entity_method_getBrightness_32.set("methodName", "getBrightness");
        reflect_Entity_method_getBrightness_32.set("returnType", "float");
        reflect_Entity_method_getBrightness_32.set("static", false);
        reflect_Entity_method_getBrightness_32.set("argnames", new String[]{"var1"});
        reflect_Entity_method_getBrightness_32.set("argtypes", new String[]{"float"});
        reflect_Entity_method_getBrightness_32.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((Entity) params.getReflective("_self")).getBrightness((float) params.getFloat("var1"));
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_getBrightness_32);


        BaseData reflect_Entity_method_setWorld_33 = new ModData();
        reflect_Entity_method_setWorld_33.set("methodName", "setWorld");
        reflect_Entity_method_setWorld_33.set("returnType", "void");
        reflect_Entity_method_setWorld_33.set("static", false);
        reflect_Entity_method_setWorld_33.set("argnames", new String[]{"worldIn"});
        reflect_Entity_method_setWorld_33.set("argtypes", new String[]{"World"});
        reflect_Entity_method_setWorld_33.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).setWorld((World) params.getReflective("worldIn"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_setWorld_33);


        BaseData reflect_Entity_method_setPositionAndRotation_34 = new ModData();
        reflect_Entity_method_setPositionAndRotation_34.set("methodName", "setPositionAndRotation");
        reflect_Entity_method_setPositionAndRotation_34.set("returnType", "void");
        reflect_Entity_method_setPositionAndRotation_34.set("static", false);
        reflect_Entity_method_setPositionAndRotation_34.set("argnames", new String[]{"x", "y", "z", "yaw", "pitch"});
        reflect_Entity_method_setPositionAndRotation_34.set("argtypes", new String[]{"double", "double", "double", "float", "float"});
        reflect_Entity_method_setPositionAndRotation_34.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).setPositionAndRotation((double) params.getDouble("x"), (double) params.getDouble("y"), (double) params.getDouble("z"), (float) params.getFloat("yaw"), (float) params.getFloat("pitch"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_setPositionAndRotation_34);


        BaseData reflect_Entity_method_moveToBlockPosAndAngles_35 = new ModData();
        reflect_Entity_method_moveToBlockPosAndAngles_35.set("methodName", "moveToBlockPosAndAngles");
        reflect_Entity_method_moveToBlockPosAndAngles_35.set("returnType", "void");
        reflect_Entity_method_moveToBlockPosAndAngles_35.set("static", false);
        reflect_Entity_method_moveToBlockPosAndAngles_35.set("argnames", new String[]{"pos", "rotationYawIn", "rotationPitchIn"});
        reflect_Entity_method_moveToBlockPosAndAngles_35.set("argtypes", new String[]{"BlockPos", "float", "float"});
        reflect_Entity_method_moveToBlockPosAndAngles_35.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).moveToBlockPosAndAngles((BlockPos) params.getReflective("pos"), (float) params.getFloat("rotationYawIn"), (float) params.getFloat("rotationPitchIn"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_moveToBlockPosAndAngles_35);


        BaseData reflect_Entity_method_setLocationAndAngles_36 = new ModData();
        reflect_Entity_method_setLocationAndAngles_36.set("methodName", "setLocationAndAngles");
        reflect_Entity_method_setLocationAndAngles_36.set("returnType", "void");
        reflect_Entity_method_setLocationAndAngles_36.set("static", false);
        reflect_Entity_method_setLocationAndAngles_36.set("argnames", new String[]{"x", "y", "z", "yaw", "pitch"});
        reflect_Entity_method_setLocationAndAngles_36.set("argtypes", new String[]{"double", "double", "double", "float", "float"});
        reflect_Entity_method_setLocationAndAngles_36.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).setLocationAndAngles((double) params.getDouble("x"), (double) params.getDouble("y"), (double) params.getDouble("z"), (float) params.getFloat("yaw"), (float) params.getFloat("pitch"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_setLocationAndAngles_36);


        BaseData reflect_Entity_method_getDistanceToEntity_37 = new ModData();
        reflect_Entity_method_getDistanceToEntity_37.set("methodName", "getDistanceToEntity");
        reflect_Entity_method_getDistanceToEntity_37.set("returnType", "float");
        reflect_Entity_method_getDistanceToEntity_37.set("static", false);
        reflect_Entity_method_getDistanceToEntity_37.set("argnames", new String[]{"entityIn"});
        reflect_Entity_method_getDistanceToEntity_37.set("argtypes", new String[]{"Entity"});
        reflect_Entity_method_getDistanceToEntity_37.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((Entity) params.getReflective("_self")).getDistanceToEntity((Entity) params.getReflective("entityIn"));
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_getDistanceToEntity_37);


        BaseData reflect_Entity_method_getDistanceSq_38 = new ModData();
        reflect_Entity_method_getDistanceSq_38.set("methodName", "getDistanceSq");
        reflect_Entity_method_getDistanceSq_38.set("returnType", "double");
        reflect_Entity_method_getDistanceSq_38.set("static", false);
        reflect_Entity_method_getDistanceSq_38.set("argnames", new String[]{"x", "y", "z"});
        reflect_Entity_method_getDistanceSq_38.set("argtypes", new String[]{"double", "double", "double"});
        reflect_Entity_method_getDistanceSq_38.setCallbackDoubleWithDataArg("exec", (BaseData params) -> {
                try {
                    return (double) ((Entity) params.getReflective("_self")).getDistanceSq((double) params.getDouble("x"), (double) params.getDouble("y"), (double) params.getDouble("z"));
                } catch (Exception _exception_reflect_) {
                    return 0.0d;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_getDistanceSq_38);


        BaseData reflect_Entity_method_getDistanceSq_39 = new ModData();
        reflect_Entity_method_getDistanceSq_39.set("methodName", "getDistanceSq");
        reflect_Entity_method_getDistanceSq_39.set("returnType", "double");
        reflect_Entity_method_getDistanceSq_39.set("static", false);
        reflect_Entity_method_getDistanceSq_39.set("argnames", new String[]{"pos"});
        reflect_Entity_method_getDistanceSq_39.set("argtypes", new String[]{"BlockPos"});
        reflect_Entity_method_getDistanceSq_39.setCallbackDoubleWithDataArg("exec", (BaseData params) -> {
                try {
                    return (double) ((Entity) params.getReflective("_self")).getDistanceSq((BlockPos) params.getReflective("pos"));
                } catch (Exception _exception_reflect_) {
                    return 0.0d;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_getDistanceSq_39);


        BaseData reflect_Entity_method_getDistanceSqToCenter_40 = new ModData();
        reflect_Entity_method_getDistanceSqToCenter_40.set("methodName", "getDistanceSqToCenter");
        reflect_Entity_method_getDistanceSqToCenter_40.set("returnType", "double");
        reflect_Entity_method_getDistanceSqToCenter_40.set("static", false);
        reflect_Entity_method_getDistanceSqToCenter_40.set("argnames", new String[]{"pos"});
        reflect_Entity_method_getDistanceSqToCenter_40.set("argtypes", new String[]{"BlockPos"});
        reflect_Entity_method_getDistanceSqToCenter_40.setCallbackDoubleWithDataArg("exec", (BaseData params) -> {
                try {
                    return (double) ((Entity) params.getReflective("_self")).getDistanceSqToCenter((BlockPos) params.getReflective("pos"));
                } catch (Exception _exception_reflect_) {
                    return 0.0d;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_getDistanceSqToCenter_40);


        BaseData reflect_Entity_method_getDistance_41 = new ModData();
        reflect_Entity_method_getDistance_41.set("methodName", "getDistance");
        reflect_Entity_method_getDistance_41.set("returnType", "double");
        reflect_Entity_method_getDistance_41.set("static", false);
        reflect_Entity_method_getDistance_41.set("argnames", new String[]{"x", "y", "z"});
        reflect_Entity_method_getDistance_41.set("argtypes", new String[]{"double", "double", "double"});
        reflect_Entity_method_getDistance_41.setCallbackDoubleWithDataArg("exec", (BaseData params) -> {
                try {
                    return (double) ((Entity) params.getReflective("_self")).getDistance((double) params.getDouble("x"), (double) params.getDouble("y"), (double) params.getDouble("z"));
                } catch (Exception _exception_reflect_) {
                    return 0.0d;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_getDistance_41);


        BaseData reflect_Entity_method_getDistanceSqToEntity_42 = new ModData();
        reflect_Entity_method_getDistanceSqToEntity_42.set("methodName", "getDistanceSqToEntity");
        reflect_Entity_method_getDistanceSqToEntity_42.set("returnType", "double");
        reflect_Entity_method_getDistanceSqToEntity_42.set("static", false);
        reflect_Entity_method_getDistanceSqToEntity_42.set("argnames", new String[]{"entityIn"});
        reflect_Entity_method_getDistanceSqToEntity_42.set("argtypes", new String[]{"Entity"});
        reflect_Entity_method_getDistanceSqToEntity_42.setCallbackDoubleWithDataArg("exec", (BaseData params) -> {
                try {
                    return (double) ((Entity) params.getReflective("_self")).getDistanceSqToEntity((Entity) params.getReflective("entityIn"));
                } catch (Exception _exception_reflect_) {
                    return 0.0d;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_getDistanceSqToEntity_42);


        BaseData reflect_Entity_method_onCollideWithPlayer_43 = new ModData();
        reflect_Entity_method_onCollideWithPlayer_43.set("methodName", "onCollideWithPlayer");
        reflect_Entity_method_onCollideWithPlayer_43.set("returnType", "void");
        reflect_Entity_method_onCollideWithPlayer_43.set("static", false);
        reflect_Entity_method_onCollideWithPlayer_43.set("argnames", new String[]{"parEntityPlayer"});
        reflect_Entity_method_onCollideWithPlayer_43.set("argtypes", new String[]{"EntityPlayer"});
        reflect_Entity_method_onCollideWithPlayer_43.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).onCollideWithPlayer((EntityPlayer) params.getReflective("parEntityPlayer"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_onCollideWithPlayer_43);


        BaseData reflect_Entity_method_applyEntityCollision_44 = new ModData();
        reflect_Entity_method_applyEntityCollision_44.set("methodName", "applyEntityCollision");
        reflect_Entity_method_applyEntityCollision_44.set("returnType", "void");
        reflect_Entity_method_applyEntityCollision_44.set("static", false);
        reflect_Entity_method_applyEntityCollision_44.set("argnames", new String[]{"entityIn"});
        reflect_Entity_method_applyEntityCollision_44.set("argtypes", new String[]{"Entity"});
        reflect_Entity_method_applyEntityCollision_44.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).applyEntityCollision((Entity) params.getReflective("entityIn"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_applyEntityCollision_44);


        BaseData reflect_Entity_method_addVelocity_45 = new ModData();
        reflect_Entity_method_addVelocity_45.set("methodName", "addVelocity");
        reflect_Entity_method_addVelocity_45.set("returnType", "void");
        reflect_Entity_method_addVelocity_45.set("static", false);
        reflect_Entity_method_addVelocity_45.set("argnames", new String[]{"x", "y", "z"});
        reflect_Entity_method_addVelocity_45.set("argtypes", new String[]{"double", "double", "double"});
        reflect_Entity_method_addVelocity_45.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).addVelocity((double) params.getDouble("x"), (double) params.getDouble("y"), (double) params.getDouble("z"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_addVelocity_45);


        BaseData reflect_Entity_method_attackEntityFrom_46 = new ModData();
        reflect_Entity_method_attackEntityFrom_46.set("methodName", "attackEntityFrom");
        reflect_Entity_method_attackEntityFrom_46.set("returnType", "boolean");
        reflect_Entity_method_attackEntityFrom_46.set("static", false);
        reflect_Entity_method_attackEntityFrom_46.set("argnames", new String[]{"damagesource", "var2"});
        reflect_Entity_method_attackEntityFrom_46.set("argtypes", new String[]{"DamageSource", "float"});
        reflect_Entity_method_attackEntityFrom_46.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((Entity) params.getReflective("_self")).attackEntityFrom((DamageSource) params.getReflective("damagesource"), (float) params.getFloat("var2"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_attackEntityFrom_46);


        BaseData reflect_Entity_method_getLook_47 = new ModData();
        reflect_Entity_method_getLook_47.set("methodName", "getLook");
        reflect_Entity_method_getLook_47.set("returnType", "Vec3");
        reflect_Entity_method_getLook_47.set("static", false);
        reflect_Entity_method_getLook_47.set("argnames", new String[]{"partialTicks"});
        reflect_Entity_method_getLook_47.set("argtypes", new String[]{"float"});
        reflect_Entity_method_getLook_47.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Vec3) ((Entity) params.getReflective("_self")).getLook((float) params.getFloat("partialTicks"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_getLook_47);


        BaseData reflect_Entity_method_getPositionEyes_48 = new ModData();
        reflect_Entity_method_getPositionEyes_48.set("methodName", "getPositionEyes");
        reflect_Entity_method_getPositionEyes_48.set("returnType", "Vec3");
        reflect_Entity_method_getPositionEyes_48.set("static", false);
        reflect_Entity_method_getPositionEyes_48.set("argnames", new String[]{"partialTicks"});
        reflect_Entity_method_getPositionEyes_48.set("argtypes", new String[]{"float"});
        reflect_Entity_method_getPositionEyes_48.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Vec3) ((Entity) params.getReflective("_self")).getPositionEyes((float) params.getFloat("partialTicks"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_getPositionEyes_48);


        BaseData reflect_Entity_method_rayTrace_49 = new ModData();
        reflect_Entity_method_rayTrace_49.set("methodName", "rayTrace");
        reflect_Entity_method_rayTrace_49.set("returnType", "MovingObjectPosition");
        reflect_Entity_method_rayTrace_49.set("static", false);
        reflect_Entity_method_rayTrace_49.set("argnames", new String[]{"blockReachDistance", "partialTicks"});
        reflect_Entity_method_rayTrace_49.set("argtypes", new String[]{"double", "float"});
        reflect_Entity_method_rayTrace_49.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (MovingObjectPosition) ((Entity) params.getReflective("_self")).rayTrace((double) params.getDouble("blockReachDistance"), (float) params.getFloat("partialTicks"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_rayTrace_49);


        BaseData reflect_Entity_method_canBeCollidedWith_50 = new ModData();
        reflect_Entity_method_canBeCollidedWith_50.set("methodName", "canBeCollidedWith");
        reflect_Entity_method_canBeCollidedWith_50.set("returnType", "boolean");
        reflect_Entity_method_canBeCollidedWith_50.set("static", false);
        reflect_Entity_method_canBeCollidedWith_50.set("argnames", new String[]{});
        reflect_Entity_method_canBeCollidedWith_50.set("argtypes", new String[]{});
        reflect_Entity_method_canBeCollidedWith_50.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((Entity) params.getReflective("_self")).canBeCollidedWith();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_canBeCollidedWith_50);


        BaseData reflect_Entity_method_canBePushed_51 = new ModData();
        reflect_Entity_method_canBePushed_51.set("methodName", "canBePushed");
        reflect_Entity_method_canBePushed_51.set("returnType", "boolean");
        reflect_Entity_method_canBePushed_51.set("static", false);
        reflect_Entity_method_canBePushed_51.set("argnames", new String[]{});
        reflect_Entity_method_canBePushed_51.set("argtypes", new String[]{});
        reflect_Entity_method_canBePushed_51.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((Entity) params.getReflective("_self")).canBePushed();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_canBePushed_51);


        BaseData reflect_Entity_method_addToPlayerScore_52 = new ModData();
        reflect_Entity_method_addToPlayerScore_52.set("methodName", "addToPlayerScore");
        reflect_Entity_method_addToPlayerScore_52.set("returnType", "void");
        reflect_Entity_method_addToPlayerScore_52.set("static", false);
        reflect_Entity_method_addToPlayerScore_52.set("argnames", new String[]{"entityIn", "amount"});
        reflect_Entity_method_addToPlayerScore_52.set("argtypes", new String[]{"Entity", "int"});
        reflect_Entity_method_addToPlayerScore_52.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).addToPlayerScore((Entity) params.getReflective("entityIn"), (int) params.getInt("amount"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_addToPlayerScore_52);


        BaseData reflect_Entity_method_isInRangeToRender3d_53 = new ModData();
        reflect_Entity_method_isInRangeToRender3d_53.set("methodName", "isInRangeToRender3d");
        reflect_Entity_method_isInRangeToRender3d_53.set("returnType", "boolean");
        reflect_Entity_method_isInRangeToRender3d_53.set("static", false);
        reflect_Entity_method_isInRangeToRender3d_53.set("argnames", new String[]{"x", "y", "z"});
        reflect_Entity_method_isInRangeToRender3d_53.set("argtypes", new String[]{"double", "double", "double"});
        reflect_Entity_method_isInRangeToRender3d_53.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((Entity) params.getReflective("_self")).isInRangeToRender3d((double) params.getDouble("x"), (double) params.getDouble("y"), (double) params.getDouble("z"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_isInRangeToRender3d_53);


        BaseData reflect_Entity_method_isInRangeToRenderDist_54 = new ModData();
        reflect_Entity_method_isInRangeToRenderDist_54.set("methodName", "isInRangeToRenderDist");
        reflect_Entity_method_isInRangeToRenderDist_54.set("returnType", "boolean");
        reflect_Entity_method_isInRangeToRenderDist_54.set("static", false);
        reflect_Entity_method_isInRangeToRenderDist_54.set("argnames", new String[]{"distance"});
        reflect_Entity_method_isInRangeToRenderDist_54.set("argtypes", new String[]{"double"});
        reflect_Entity_method_isInRangeToRenderDist_54.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((Entity) params.getReflective("_self")).isInRangeToRenderDist((double) params.getDouble("distance"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_isInRangeToRenderDist_54);


        BaseData reflect_Entity_method_writeMountToNBT_55 = new ModData();
        reflect_Entity_method_writeMountToNBT_55.set("methodName", "writeMountToNBT");
        reflect_Entity_method_writeMountToNBT_55.set("returnType", "boolean");
        reflect_Entity_method_writeMountToNBT_55.set("static", false);
        reflect_Entity_method_writeMountToNBT_55.set("argnames", new String[]{"tagCompund"});
        reflect_Entity_method_writeMountToNBT_55.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_Entity_method_writeMountToNBT_55.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((Entity) params.getReflective("_self")).writeMountToNBT((NBTTagCompound) params.getReflective("tagCompund"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_writeMountToNBT_55);


        BaseData reflect_Entity_method_writeToNBTOptional_56 = new ModData();
        reflect_Entity_method_writeToNBTOptional_56.set("methodName", "writeToNBTOptional");
        reflect_Entity_method_writeToNBTOptional_56.set("returnType", "boolean");
        reflect_Entity_method_writeToNBTOptional_56.set("static", false);
        reflect_Entity_method_writeToNBTOptional_56.set("argnames", new String[]{"tagCompund"});
        reflect_Entity_method_writeToNBTOptional_56.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_Entity_method_writeToNBTOptional_56.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((Entity) params.getReflective("_self")).writeToNBTOptional((NBTTagCompound) params.getReflective("tagCompund"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_writeToNBTOptional_56);


        BaseData reflect_Entity_method_writeToNBT_57 = new ModData();
        reflect_Entity_method_writeToNBT_57.set("methodName", "writeToNBT");
        reflect_Entity_method_writeToNBT_57.set("returnType", "void");
        reflect_Entity_method_writeToNBT_57.set("static", false);
        reflect_Entity_method_writeToNBT_57.set("argnames", new String[]{"tagCompund"});
        reflect_Entity_method_writeToNBT_57.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_Entity_method_writeToNBT_57.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).writeToNBT((NBTTagCompound) params.getReflective("tagCompund"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_writeToNBT_57);


        BaseData reflect_Entity_method_readFromNBT_58 = new ModData();
        reflect_Entity_method_readFromNBT_58.set("methodName", "readFromNBT");
        reflect_Entity_method_readFromNBT_58.set("returnType", "void");
        reflect_Entity_method_readFromNBT_58.set("static", false);
        reflect_Entity_method_readFromNBT_58.set("argnames", new String[]{"tagCompund"});
        reflect_Entity_method_readFromNBT_58.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_Entity_method_readFromNBT_58.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).readFromNBT((NBTTagCompound) params.getReflective("tagCompund"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_readFromNBT_58);


        BaseData reflect_Entity_method_onChunkLoad_59 = new ModData();
        reflect_Entity_method_onChunkLoad_59.set("methodName", "onChunkLoad");
        reflect_Entity_method_onChunkLoad_59.set("returnType", "void");
        reflect_Entity_method_onChunkLoad_59.set("static", false);
        reflect_Entity_method_onChunkLoad_59.set("argnames", new String[]{});
        reflect_Entity_method_onChunkLoad_59.set("argtypes", new String[]{});
        reflect_Entity_method_onChunkLoad_59.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).onChunkLoad();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_onChunkLoad_59);


        BaseData reflect_Entity_method_dropItem_60 = new ModData();
        reflect_Entity_method_dropItem_60.set("methodName", "dropItem");
        reflect_Entity_method_dropItem_60.set("returnType", "EntityItem");
        reflect_Entity_method_dropItem_60.set("static", false);
        reflect_Entity_method_dropItem_60.set("argnames", new String[]{"itemIn", "size"});
        reflect_Entity_method_dropItem_60.set("argtypes", new String[]{"Item", "int"});
        reflect_Entity_method_dropItem_60.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EntityItem) ((Entity) params.getReflective("_self")).dropItem((Item) params.getReflective("itemIn"), (int) params.getInt("size"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_dropItem_60);


        BaseData reflect_Entity_method_dropItemWithOffset_61 = new ModData();
        reflect_Entity_method_dropItemWithOffset_61.set("methodName", "dropItemWithOffset");
        reflect_Entity_method_dropItemWithOffset_61.set("returnType", "EntityItem");
        reflect_Entity_method_dropItemWithOffset_61.set("static", false);
        reflect_Entity_method_dropItemWithOffset_61.set("argnames", new String[]{"itemIn", "size", "offsetY"});
        reflect_Entity_method_dropItemWithOffset_61.set("argtypes", new String[]{"Item", "int", "float"});
        reflect_Entity_method_dropItemWithOffset_61.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EntityItem) ((Entity) params.getReflective("_self")).dropItemWithOffset((Item) params.getReflective("itemIn"), (int) params.getInt("size"), (float) params.getFloat("offsetY"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_dropItemWithOffset_61);


        BaseData reflect_Entity_method_entityDropItem_62 = new ModData();
        reflect_Entity_method_entityDropItem_62.set("methodName", "entityDropItem");
        reflect_Entity_method_entityDropItem_62.set("returnType", "EntityItem");
        reflect_Entity_method_entityDropItem_62.set("static", false);
        reflect_Entity_method_entityDropItem_62.set("argnames", new String[]{"itemStackIn", "offsetY"});
        reflect_Entity_method_entityDropItem_62.set("argtypes", new String[]{"ItemStack", "float"});
        reflect_Entity_method_entityDropItem_62.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EntityItem) ((Entity) params.getReflective("_self")).entityDropItem((ItemStack) params.getReflective("itemStackIn"), (float) params.getFloat("offsetY"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_entityDropItem_62);


        BaseData reflect_Entity_method_isEntityAlive_63 = new ModData();
        reflect_Entity_method_isEntityAlive_63.set("methodName", "isEntityAlive");
        reflect_Entity_method_isEntityAlive_63.set("returnType", "boolean");
        reflect_Entity_method_isEntityAlive_63.set("static", false);
        reflect_Entity_method_isEntityAlive_63.set("argnames", new String[]{});
        reflect_Entity_method_isEntityAlive_63.set("argtypes", new String[]{});
        reflect_Entity_method_isEntityAlive_63.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((Entity) params.getReflective("_self")).isEntityAlive();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_isEntityAlive_63);


        BaseData reflect_Entity_method_isEntityInsideOpaqueBlock_64 = new ModData();
        reflect_Entity_method_isEntityInsideOpaqueBlock_64.set("methodName", "isEntityInsideOpaqueBlock");
        reflect_Entity_method_isEntityInsideOpaqueBlock_64.set("returnType", "boolean");
        reflect_Entity_method_isEntityInsideOpaqueBlock_64.set("static", false);
        reflect_Entity_method_isEntityInsideOpaqueBlock_64.set("argnames", new String[]{});
        reflect_Entity_method_isEntityInsideOpaqueBlock_64.set("argtypes", new String[]{});
        reflect_Entity_method_isEntityInsideOpaqueBlock_64.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((Entity) params.getReflective("_self")).isEntityInsideOpaqueBlock();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_isEntityInsideOpaqueBlock_64);


        BaseData reflect_Entity_method_interactFirst_65 = new ModData();
        reflect_Entity_method_interactFirst_65.set("methodName", "interactFirst");
        reflect_Entity_method_interactFirst_65.set("returnType", "boolean");
        reflect_Entity_method_interactFirst_65.set("static", false);
        reflect_Entity_method_interactFirst_65.set("argnames", new String[]{"playerIn"});
        reflect_Entity_method_interactFirst_65.set("argtypes", new String[]{"EntityPlayer"});
        reflect_Entity_method_interactFirst_65.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((Entity) params.getReflective("_self")).interactFirst((EntityPlayer) params.getReflective("playerIn"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_interactFirst_65);


        BaseData reflect_Entity_method_getCollisionBox_66 = new ModData();
        reflect_Entity_method_getCollisionBox_66.set("methodName", "getCollisionBox");
        reflect_Entity_method_getCollisionBox_66.set("returnType", "AxisAlignedBB");
        reflect_Entity_method_getCollisionBox_66.set("static", false);
        reflect_Entity_method_getCollisionBox_66.set("argnames", new String[]{"entityIn"});
        reflect_Entity_method_getCollisionBox_66.set("argtypes", new String[]{"Entity"});
        reflect_Entity_method_getCollisionBox_66.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (AxisAlignedBB) ((Entity) params.getReflective("_self")).getCollisionBox((Entity) params.getReflective("entityIn"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_getCollisionBox_66);


        BaseData reflect_Entity_method_updateRidden_67 = new ModData();
        reflect_Entity_method_updateRidden_67.set("methodName", "updateRidden");
        reflect_Entity_method_updateRidden_67.set("returnType", "void");
        reflect_Entity_method_updateRidden_67.set("static", false);
        reflect_Entity_method_updateRidden_67.set("argnames", new String[]{});
        reflect_Entity_method_updateRidden_67.set("argtypes", new String[]{});
        reflect_Entity_method_updateRidden_67.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).updateRidden();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_updateRidden_67);


        BaseData reflect_Entity_method_updateRiderPosition_68 = new ModData();
        reflect_Entity_method_updateRiderPosition_68.set("methodName", "updateRiderPosition");
        reflect_Entity_method_updateRiderPosition_68.set("returnType", "void");
        reflect_Entity_method_updateRiderPosition_68.set("static", false);
        reflect_Entity_method_updateRiderPosition_68.set("argnames", new String[]{});
        reflect_Entity_method_updateRiderPosition_68.set("argtypes", new String[]{});
        reflect_Entity_method_updateRiderPosition_68.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).updateRiderPosition();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_updateRiderPosition_68);


        BaseData reflect_Entity_method_getYOffset_69 = new ModData();
        reflect_Entity_method_getYOffset_69.set("methodName", "getYOffset");
        reflect_Entity_method_getYOffset_69.set("returnType", "double");
        reflect_Entity_method_getYOffset_69.set("static", false);
        reflect_Entity_method_getYOffset_69.set("argnames", new String[]{});
        reflect_Entity_method_getYOffset_69.set("argtypes", new String[]{});
        reflect_Entity_method_getYOffset_69.setCallbackDoubleWithDataArg("exec", (BaseData params) -> {
                try {
                    return (double) ((Entity) params.getReflective("_self")).getYOffset();
                } catch (Exception _exception_reflect_) {
                    return 0.0d;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_getYOffset_69);


        BaseData reflect_Entity_method_getMountedYOffset_70 = new ModData();
        reflect_Entity_method_getMountedYOffset_70.set("methodName", "getMountedYOffset");
        reflect_Entity_method_getMountedYOffset_70.set("returnType", "double");
        reflect_Entity_method_getMountedYOffset_70.set("static", false);
        reflect_Entity_method_getMountedYOffset_70.set("argnames", new String[]{});
        reflect_Entity_method_getMountedYOffset_70.set("argtypes", new String[]{});
        reflect_Entity_method_getMountedYOffset_70.setCallbackDoubleWithDataArg("exec", (BaseData params) -> {
                try {
                    return (double) ((Entity) params.getReflective("_self")).getMountedYOffset();
                } catch (Exception _exception_reflect_) {
                    return 0.0d;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_getMountedYOffset_70);


        BaseData reflect_Entity_method_mountEntity_71 = new ModData();
        reflect_Entity_method_mountEntity_71.set("methodName", "mountEntity");
        reflect_Entity_method_mountEntity_71.set("returnType", "void");
        reflect_Entity_method_mountEntity_71.set("static", false);
        reflect_Entity_method_mountEntity_71.set("argnames", new String[]{"entity"});
        reflect_Entity_method_mountEntity_71.set("argtypes", new String[]{"Entity"});
        reflect_Entity_method_mountEntity_71.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).mountEntity((Entity) params.getReflective("entity"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_mountEntity_71);


        BaseData reflect_Entity_method_setPositionAndRotation2_72 = new ModData();
        reflect_Entity_method_setPositionAndRotation2_72.set("methodName", "setPositionAndRotation2");
        reflect_Entity_method_setPositionAndRotation2_72.set("returnType", "void");
        reflect_Entity_method_setPositionAndRotation2_72.set("static", false);
        reflect_Entity_method_setPositionAndRotation2_72.set("argnames", new String[]{"d0", "d1", "d2", "f", "f1", "var9", "var10"});
        reflect_Entity_method_setPositionAndRotation2_72.set("argtypes", new String[]{"double", "double", "double", "float", "float", "int", "boolean"});
        reflect_Entity_method_setPositionAndRotation2_72.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).setPositionAndRotation2((double) params.getDouble("d0"), (double) params.getDouble("d1"), (double) params.getDouble("d2"), (float) params.getFloat("f"), (float) params.getFloat("f1"), (int) params.getInt("var9"), (boolean) params.getBoolean("var10"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_setPositionAndRotation2_72);


        BaseData reflect_Entity_method_getCollisionBorderSize_73 = new ModData();
        reflect_Entity_method_getCollisionBorderSize_73.set("methodName", "getCollisionBorderSize");
        reflect_Entity_method_getCollisionBorderSize_73.set("returnType", "float");
        reflect_Entity_method_getCollisionBorderSize_73.set("static", false);
        reflect_Entity_method_getCollisionBorderSize_73.set("argnames", new String[]{});
        reflect_Entity_method_getCollisionBorderSize_73.set("argtypes", new String[]{});
        reflect_Entity_method_getCollisionBorderSize_73.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((Entity) params.getReflective("_self")).getCollisionBorderSize();
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_getCollisionBorderSize_73);


        BaseData reflect_Entity_method_getLookVec_74 = new ModData();
        reflect_Entity_method_getLookVec_74.set("methodName", "getLookVec");
        reflect_Entity_method_getLookVec_74.set("returnType", "Vec3");
        reflect_Entity_method_getLookVec_74.set("static", false);
        reflect_Entity_method_getLookVec_74.set("argnames", new String[]{});
        reflect_Entity_method_getLookVec_74.set("argtypes", new String[]{});
        reflect_Entity_method_getLookVec_74.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Vec3) ((Entity) params.getReflective("_self")).getLookVec();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_getLookVec_74);


        BaseData reflect_Entity_method_func_181015_d_75 = new ModData();
        reflect_Entity_method_func_181015_d_75.set("methodName", "func_181015_d");
        reflect_Entity_method_func_181015_d_75.set("returnType", "void");
        reflect_Entity_method_func_181015_d_75.set("static", false);
        reflect_Entity_method_func_181015_d_75.set("argnames", new String[]{"parBlockPos"});
        reflect_Entity_method_func_181015_d_75.set("argtypes", new String[]{"BlockPos"});
        reflect_Entity_method_func_181015_d_75.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).func_181015_d((BlockPos) params.getReflective("parBlockPos"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_func_181015_d_75);


        BaseData reflect_Entity_method_getPortalCooldown_76 = new ModData();
        reflect_Entity_method_getPortalCooldown_76.set("methodName", "getPortalCooldown");
        reflect_Entity_method_getPortalCooldown_76.set("returnType", "int");
        reflect_Entity_method_getPortalCooldown_76.set("static", false);
        reflect_Entity_method_getPortalCooldown_76.set("argnames", new String[]{});
        reflect_Entity_method_getPortalCooldown_76.set("argtypes", new String[]{});
        reflect_Entity_method_getPortalCooldown_76.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((Entity) params.getReflective("_self")).getPortalCooldown();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_getPortalCooldown_76);


        BaseData reflect_Entity_method_setVelocity_77 = new ModData();
        reflect_Entity_method_setVelocity_77.set("methodName", "setVelocity");
        reflect_Entity_method_setVelocity_77.set("returnType", "void");
        reflect_Entity_method_setVelocity_77.set("static", false);
        reflect_Entity_method_setVelocity_77.set("argnames", new String[]{"x", "y", "z"});
        reflect_Entity_method_setVelocity_77.set("argtypes", new String[]{"double", "double", "double"});
        reflect_Entity_method_setVelocity_77.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).setVelocity((double) params.getDouble("x"), (double) params.getDouble("y"), (double) params.getDouble("z"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_setVelocity_77);


        BaseData reflect_Entity_method_handleStatusUpdate_78 = new ModData();
        reflect_Entity_method_handleStatusUpdate_78.set("methodName", "handleStatusUpdate");
        reflect_Entity_method_handleStatusUpdate_78.set("returnType", "void");
        reflect_Entity_method_handleStatusUpdate_78.set("static", false);
        reflect_Entity_method_handleStatusUpdate_78.set("argnames", new String[]{"id"});
        reflect_Entity_method_handleStatusUpdate_78.set("argtypes", new String[]{"byte"});
        reflect_Entity_method_handleStatusUpdate_78.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).handleStatusUpdate((byte) params.getByte("id"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_handleStatusUpdate_78);


        BaseData reflect_Entity_method_performHurtAnimation_79 = new ModData();
        reflect_Entity_method_performHurtAnimation_79.set("methodName", "performHurtAnimation");
        reflect_Entity_method_performHurtAnimation_79.set("returnType", "void");
        reflect_Entity_method_performHurtAnimation_79.set("static", false);
        reflect_Entity_method_performHurtAnimation_79.set("argnames", new String[]{});
        reflect_Entity_method_performHurtAnimation_79.set("argtypes", new String[]{});
        reflect_Entity_method_performHurtAnimation_79.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).performHurtAnimation();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_performHurtAnimation_79);


        BaseData reflect_Entity_method_getInventory_80 = new ModData();
        reflect_Entity_method_getInventory_80.set("methodName", "getInventory");
        reflect_Entity_method_getInventory_80.set("returnType", "ItemStack[]");
        reflect_Entity_method_getInventory_80.set("static", false);
        reflect_Entity_method_getInventory_80.set("argnames", new String[]{});
        reflect_Entity_method_getInventory_80.set("argtypes", new String[]{});
        reflect_Entity_method_getInventory_80.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (ItemStack[]) ((Entity) params.getReflective("_self")).getInventory();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_getInventory_80);


        BaseData reflect_Entity_method_setCurrentItemOrArmor_81 = new ModData();
        reflect_Entity_method_setCurrentItemOrArmor_81.set("methodName", "setCurrentItemOrArmor");
        reflect_Entity_method_setCurrentItemOrArmor_81.set("returnType", "void");
        reflect_Entity_method_setCurrentItemOrArmor_81.set("static", false);
        reflect_Entity_method_setCurrentItemOrArmor_81.set("argnames", new String[]{"var1", "var2"});
        reflect_Entity_method_setCurrentItemOrArmor_81.set("argtypes", new String[]{"int", "ItemStack"});
        reflect_Entity_method_setCurrentItemOrArmor_81.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).setCurrentItemOrArmor((int) params.getInt("var1"), (ItemStack) params.getReflective("var2"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_setCurrentItemOrArmor_81);


        BaseData reflect_Entity_method_isBurning_82 = new ModData();
        reflect_Entity_method_isBurning_82.set("methodName", "isBurning");
        reflect_Entity_method_isBurning_82.set("returnType", "boolean");
        reflect_Entity_method_isBurning_82.set("static", false);
        reflect_Entity_method_isBurning_82.set("argnames", new String[]{});
        reflect_Entity_method_isBurning_82.set("argtypes", new String[]{});
        reflect_Entity_method_isBurning_82.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((Entity) params.getReflective("_self")).isBurning();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_isBurning_82);


        BaseData reflect_Entity_method_isRiding_83 = new ModData();
        reflect_Entity_method_isRiding_83.set("methodName", "isRiding");
        reflect_Entity_method_isRiding_83.set("returnType", "boolean");
        reflect_Entity_method_isRiding_83.set("static", false);
        reflect_Entity_method_isRiding_83.set("argnames", new String[]{});
        reflect_Entity_method_isRiding_83.set("argtypes", new String[]{});
        reflect_Entity_method_isRiding_83.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((Entity) params.getReflective("_self")).isRiding();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_isRiding_83);


        BaseData reflect_Entity_method_isSneaking_84 = new ModData();
        reflect_Entity_method_isSneaking_84.set("methodName", "isSneaking");
        reflect_Entity_method_isSneaking_84.set("returnType", "boolean");
        reflect_Entity_method_isSneaking_84.set("static", false);
        reflect_Entity_method_isSneaking_84.set("argnames", new String[]{});
        reflect_Entity_method_isSneaking_84.set("argtypes", new String[]{});
        reflect_Entity_method_isSneaking_84.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((Entity) params.getReflective("_self")).isSneaking();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_isSneaking_84);


        BaseData reflect_Entity_method_setSneaking_85 = new ModData();
        reflect_Entity_method_setSneaking_85.set("methodName", "setSneaking");
        reflect_Entity_method_setSneaking_85.set("returnType", "void");
        reflect_Entity_method_setSneaking_85.set("static", false);
        reflect_Entity_method_setSneaking_85.set("argnames", new String[]{"sneaking"});
        reflect_Entity_method_setSneaking_85.set("argtypes", new String[]{"boolean"});
        reflect_Entity_method_setSneaking_85.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).setSneaking((boolean) params.getBoolean("sneaking"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_setSneaking_85);


        BaseData reflect_Entity_method_isSprinting_86 = new ModData();
        reflect_Entity_method_isSprinting_86.set("methodName", "isSprinting");
        reflect_Entity_method_isSprinting_86.set("returnType", "boolean");
        reflect_Entity_method_isSprinting_86.set("static", false);
        reflect_Entity_method_isSprinting_86.set("argnames", new String[]{});
        reflect_Entity_method_isSprinting_86.set("argtypes", new String[]{});
        reflect_Entity_method_isSprinting_86.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((Entity) params.getReflective("_self")).isSprinting();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_isSprinting_86);


        BaseData reflect_Entity_method_setSprinting_87 = new ModData();
        reflect_Entity_method_setSprinting_87.set("methodName", "setSprinting");
        reflect_Entity_method_setSprinting_87.set("returnType", "void");
        reflect_Entity_method_setSprinting_87.set("static", false);
        reflect_Entity_method_setSprinting_87.set("argnames", new String[]{"flag"});
        reflect_Entity_method_setSprinting_87.set("argtypes", new String[]{"boolean"});
        reflect_Entity_method_setSprinting_87.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).setSprinting((boolean) params.getBoolean("flag"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_setSprinting_87);


        BaseData reflect_Entity_method_isInvisible_88 = new ModData();
        reflect_Entity_method_isInvisible_88.set("methodName", "isInvisible");
        reflect_Entity_method_isInvisible_88.set("returnType", "boolean");
        reflect_Entity_method_isInvisible_88.set("static", false);
        reflect_Entity_method_isInvisible_88.set("argnames", new String[]{});
        reflect_Entity_method_isInvisible_88.set("argtypes", new String[]{});
        reflect_Entity_method_isInvisible_88.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((Entity) params.getReflective("_self")).isInvisible();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_isInvisible_88);


        BaseData reflect_Entity_method_isInvisibleToPlayer_89 = new ModData();
        reflect_Entity_method_isInvisibleToPlayer_89.set("methodName", "isInvisibleToPlayer");
        reflect_Entity_method_isInvisibleToPlayer_89.set("returnType", "boolean");
        reflect_Entity_method_isInvisibleToPlayer_89.set("static", false);
        reflect_Entity_method_isInvisibleToPlayer_89.set("argnames", new String[]{"player"});
        reflect_Entity_method_isInvisibleToPlayer_89.set("argtypes", new String[]{"EntityPlayer"});
        reflect_Entity_method_isInvisibleToPlayer_89.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((Entity) params.getReflective("_self")).isInvisibleToPlayer((EntityPlayer) params.getReflective("player"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_isInvisibleToPlayer_89);


        BaseData reflect_Entity_method_setInvisible_90 = new ModData();
        reflect_Entity_method_setInvisible_90.set("methodName", "setInvisible");
        reflect_Entity_method_setInvisible_90.set("returnType", "void");
        reflect_Entity_method_setInvisible_90.set("static", false);
        reflect_Entity_method_setInvisible_90.set("argnames", new String[]{"invisible"});
        reflect_Entity_method_setInvisible_90.set("argtypes", new String[]{"boolean"});
        reflect_Entity_method_setInvisible_90.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).setInvisible((boolean) params.getBoolean("invisible"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_setInvisible_90);


        BaseData reflect_Entity_method_isEating_91 = new ModData();
        reflect_Entity_method_isEating_91.set("methodName", "isEating");
        reflect_Entity_method_isEating_91.set("returnType", "boolean");
        reflect_Entity_method_isEating_91.set("static", false);
        reflect_Entity_method_isEating_91.set("argnames", new String[]{});
        reflect_Entity_method_isEating_91.set("argtypes", new String[]{});
        reflect_Entity_method_isEating_91.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((Entity) params.getReflective("_self")).isEating();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_isEating_91);


        BaseData reflect_Entity_method_setEating_92 = new ModData();
        reflect_Entity_method_setEating_92.set("methodName", "setEating");
        reflect_Entity_method_setEating_92.set("returnType", "void");
        reflect_Entity_method_setEating_92.set("static", false);
        reflect_Entity_method_setEating_92.set("argnames", new String[]{"eating"});
        reflect_Entity_method_setEating_92.set("argtypes", new String[]{"boolean"});
        reflect_Entity_method_setEating_92.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).setEating((boolean) params.getBoolean("eating"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_setEating_92);


        BaseData reflect_Entity_method_getAir_93 = new ModData();
        reflect_Entity_method_getAir_93.set("methodName", "getAir");
        reflect_Entity_method_getAir_93.set("returnType", "int");
        reflect_Entity_method_getAir_93.set("static", false);
        reflect_Entity_method_getAir_93.set("argnames", new String[]{});
        reflect_Entity_method_getAir_93.set("argtypes", new String[]{});
        reflect_Entity_method_getAir_93.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((Entity) params.getReflective("_self")).getAir();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_getAir_93);


        BaseData reflect_Entity_method_setAir_94 = new ModData();
        reflect_Entity_method_setAir_94.set("methodName", "setAir");
        reflect_Entity_method_setAir_94.set("returnType", "void");
        reflect_Entity_method_setAir_94.set("static", false);
        reflect_Entity_method_setAir_94.set("argnames", new String[]{"air"});
        reflect_Entity_method_setAir_94.set("argtypes", new String[]{"int"});
        reflect_Entity_method_setAir_94.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).setAir((int) params.getInt("air"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_setAir_94);


        BaseData reflect_Entity_method_onStruckByLightning_95 = new ModData();
        reflect_Entity_method_onStruckByLightning_95.set("methodName", "onStruckByLightning");
        reflect_Entity_method_onStruckByLightning_95.set("returnType", "void");
        reflect_Entity_method_onStruckByLightning_95.set("static", false);
        reflect_Entity_method_onStruckByLightning_95.set("argnames", new String[]{"lightningBolt"});
        reflect_Entity_method_onStruckByLightning_95.set("argtypes", new String[]{"EntityLightningBolt"});
        reflect_Entity_method_onStruckByLightning_95.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).onStruckByLightning((EntityLightningBolt) params.getReflective("lightningBolt"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_onStruckByLightning_95);


        BaseData reflect_Entity_method_onKillEntity_96 = new ModData();
        reflect_Entity_method_onKillEntity_96.set("methodName", "onKillEntity");
        reflect_Entity_method_onKillEntity_96.set("returnType", "void");
        reflect_Entity_method_onKillEntity_96.set("static", false);
        reflect_Entity_method_onKillEntity_96.set("argnames", new String[]{"entityLivingIn"});
        reflect_Entity_method_onKillEntity_96.set("argtypes", new String[]{"EntityLivingBase"});
        reflect_Entity_method_onKillEntity_96.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).onKillEntity((EntityLivingBase) params.getReflective("entityLivingIn"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_onKillEntity_96);


        BaseData reflect_Entity_method_setInWeb_97 = new ModData();
        reflect_Entity_method_setInWeb_97.set("methodName", "setInWeb");
        reflect_Entity_method_setInWeb_97.set("returnType", "void");
        reflect_Entity_method_setInWeb_97.set("static", false);
        reflect_Entity_method_setInWeb_97.set("argnames", new String[]{});
        reflect_Entity_method_setInWeb_97.set("argtypes", new String[]{});
        reflect_Entity_method_setInWeb_97.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).setInWeb();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_setInWeb_97);


        BaseData reflect_Entity_method_getName_98 = new ModData();
        reflect_Entity_method_getName_98.set("methodName", "getName");
        reflect_Entity_method_getName_98.set("returnType", "String");
        reflect_Entity_method_getName_98.set("static", false);
        reflect_Entity_method_getName_98.set("argnames", new String[]{});
        reflect_Entity_method_getName_98.set("argtypes", new String[]{});
        reflect_Entity_method_getName_98.setCallbackStringWithDataArg("exec", (BaseData params) -> {
                try {
                    return (String) ((Entity) params.getReflective("_self")).getName();
                } catch (Exception _exception_reflect_) {
                    return "";
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_getName_98);


        BaseData reflect_Entity_method_getParts_99 = new ModData();
        reflect_Entity_method_getParts_99.set("methodName", "getParts");
        reflect_Entity_method_getParts_99.set("returnType", "Entity[]");
        reflect_Entity_method_getParts_99.set("static", false);
        reflect_Entity_method_getParts_99.set("argnames", new String[]{});
        reflect_Entity_method_getParts_99.set("argtypes", new String[]{});
        reflect_Entity_method_getParts_99.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Entity[]) ((Entity) params.getReflective("_self")).getParts();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_getParts_99);


        BaseData reflect_Entity_method_isEntityEqual_100 = new ModData();
        reflect_Entity_method_isEntityEqual_100.set("methodName", "isEntityEqual");
        reflect_Entity_method_isEntityEqual_100.set("returnType", "boolean");
        reflect_Entity_method_isEntityEqual_100.set("static", false);
        reflect_Entity_method_isEntityEqual_100.set("argnames", new String[]{"entityIn"});
        reflect_Entity_method_isEntityEqual_100.set("argtypes", new String[]{"Entity"});
        reflect_Entity_method_isEntityEqual_100.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((Entity) params.getReflective("_self")).isEntityEqual((Entity) params.getReflective("entityIn"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_isEntityEqual_100);


        BaseData reflect_Entity_method_getRotationYawHead_101 = new ModData();
        reflect_Entity_method_getRotationYawHead_101.set("methodName", "getRotationYawHead");
        reflect_Entity_method_getRotationYawHead_101.set("returnType", "float");
        reflect_Entity_method_getRotationYawHead_101.set("static", false);
        reflect_Entity_method_getRotationYawHead_101.set("argnames", new String[]{});
        reflect_Entity_method_getRotationYawHead_101.set("argtypes", new String[]{});
        reflect_Entity_method_getRotationYawHead_101.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((Entity) params.getReflective("_self")).getRotationYawHead();
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_getRotationYawHead_101);


        BaseData reflect_Entity_method_setRotationYawHead_102 = new ModData();
        reflect_Entity_method_setRotationYawHead_102.set("methodName", "setRotationYawHead");
        reflect_Entity_method_setRotationYawHead_102.set("returnType", "void");
        reflect_Entity_method_setRotationYawHead_102.set("static", false);
        reflect_Entity_method_setRotationYawHead_102.set("argnames", new String[]{"rotation"});
        reflect_Entity_method_setRotationYawHead_102.set("argtypes", new String[]{"float"});
        reflect_Entity_method_setRotationYawHead_102.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).setRotationYawHead((float) params.getFloat("rotation"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_setRotationYawHead_102);


        BaseData reflect_Entity_method_func_181013_g_103 = new ModData();
        reflect_Entity_method_func_181013_g_103.set("methodName", "func_181013_g");
        reflect_Entity_method_func_181013_g_103.set("returnType", "void");
        reflect_Entity_method_func_181013_g_103.set("static", false);
        reflect_Entity_method_func_181013_g_103.set("argnames", new String[]{"parFloat1"});
        reflect_Entity_method_func_181013_g_103.set("argtypes", new String[]{"float"});
        reflect_Entity_method_func_181013_g_103.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).func_181013_g((float) params.getFloat("parFloat1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_func_181013_g_103);


        BaseData reflect_Entity_method_canAttackWithItem_104 = new ModData();
        reflect_Entity_method_canAttackWithItem_104.set("methodName", "canAttackWithItem");
        reflect_Entity_method_canAttackWithItem_104.set("returnType", "boolean");
        reflect_Entity_method_canAttackWithItem_104.set("static", false);
        reflect_Entity_method_canAttackWithItem_104.set("argnames", new String[]{});
        reflect_Entity_method_canAttackWithItem_104.set("argtypes", new String[]{});
        reflect_Entity_method_canAttackWithItem_104.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((Entity) params.getReflective("_self")).canAttackWithItem();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_canAttackWithItem_104);


        BaseData reflect_Entity_method_hitByEntity_105 = new ModData();
        reflect_Entity_method_hitByEntity_105.set("methodName", "hitByEntity");
        reflect_Entity_method_hitByEntity_105.set("returnType", "boolean");
        reflect_Entity_method_hitByEntity_105.set("static", false);
        reflect_Entity_method_hitByEntity_105.set("argnames", new String[]{"entityIn"});
        reflect_Entity_method_hitByEntity_105.set("argtypes", new String[]{"Entity"});
        reflect_Entity_method_hitByEntity_105.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((Entity) params.getReflective("_self")).hitByEntity((Entity) params.getReflective("entityIn"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_hitByEntity_105);


        BaseData reflect_Entity_method_toString_106 = new ModData();
        reflect_Entity_method_toString_106.set("methodName", "toString");
        reflect_Entity_method_toString_106.set("returnType", "String");
        reflect_Entity_method_toString_106.set("static", false);
        reflect_Entity_method_toString_106.set("argnames", new String[]{});
        reflect_Entity_method_toString_106.set("argtypes", new String[]{});
        reflect_Entity_method_toString_106.setCallbackStringWithDataArg("exec", (BaseData params) -> {
                try {
                    return (String) ((Entity) params.getReflective("_self")).toString();
                } catch (Exception _exception_reflect_) {
                    return "";
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_toString_106);


        BaseData reflect_Entity_method_isEntityInvulnerable_107 = new ModData();
        reflect_Entity_method_isEntityInvulnerable_107.set("methodName", "isEntityInvulnerable");
        reflect_Entity_method_isEntityInvulnerable_107.set("returnType", "boolean");
        reflect_Entity_method_isEntityInvulnerable_107.set("static", false);
        reflect_Entity_method_isEntityInvulnerable_107.set("argnames", new String[]{"source"});
        reflect_Entity_method_isEntityInvulnerable_107.set("argtypes", new String[]{"DamageSource"});
        reflect_Entity_method_isEntityInvulnerable_107.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((Entity) params.getReflective("_self")).isEntityInvulnerable((DamageSource) params.getReflective("source"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_isEntityInvulnerable_107);


        BaseData reflect_Entity_method_copyLocationAndAnglesFrom_108 = new ModData();
        reflect_Entity_method_copyLocationAndAnglesFrom_108.set("methodName", "copyLocationAndAnglesFrom");
        reflect_Entity_method_copyLocationAndAnglesFrom_108.set("returnType", "void");
        reflect_Entity_method_copyLocationAndAnglesFrom_108.set("static", false);
        reflect_Entity_method_copyLocationAndAnglesFrom_108.set("argnames", new String[]{"entityIn"});
        reflect_Entity_method_copyLocationAndAnglesFrom_108.set("argtypes", new String[]{"Entity"});
        reflect_Entity_method_copyLocationAndAnglesFrom_108.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).copyLocationAndAnglesFrom((Entity) params.getReflective("entityIn"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_copyLocationAndAnglesFrom_108);


        BaseData reflect_Entity_method_copyDataFromOld_109 = new ModData();
        reflect_Entity_method_copyDataFromOld_109.set("methodName", "copyDataFromOld");
        reflect_Entity_method_copyDataFromOld_109.set("returnType", "void");
        reflect_Entity_method_copyDataFromOld_109.set("static", false);
        reflect_Entity_method_copyDataFromOld_109.set("argnames", new String[]{"entityIn"});
        reflect_Entity_method_copyDataFromOld_109.set("argtypes", new String[]{"Entity"});
        reflect_Entity_method_copyDataFromOld_109.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).copyDataFromOld((Entity) params.getReflective("entityIn"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_copyDataFromOld_109);


        BaseData reflect_Entity_method_toNBT_110 = new ModData();
        reflect_Entity_method_toNBT_110.set("methodName", "toNBT");
        reflect_Entity_method_toNBT_110.set("returnType", "String");
        reflect_Entity_method_toNBT_110.set("static", false);
        reflect_Entity_method_toNBT_110.set("argnames", new String[]{});
        reflect_Entity_method_toNBT_110.set("argtypes", new String[]{});
        reflect_Entity_method_toNBT_110.setCallbackStringWithDataArg("exec", (BaseData params) -> {
                try {
                    return (String) ((Entity) params.getReflective("_self")).toNBT();
                } catch (Exception _exception_reflect_) {
                    return "";
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_toNBT_110);


        BaseData reflect_Entity_method_fromNBT_111 = new ModData();
        reflect_Entity_method_fromNBT_111.set("methodName", "fromNBT");
        reflect_Entity_method_fromNBT_111.set("returnType", "void");
        reflect_Entity_method_fromNBT_111.set("static", false);
        reflect_Entity_method_fromNBT_111.set("argnames", new String[]{"nbt"});
        reflect_Entity_method_fromNBT_111.set("argtypes", new String[]{"String"});
        reflect_Entity_method_fromNBT_111.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).fromNBT((String) params.getString("nbt"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_fromNBT_111);


        BaseData reflect_Entity_method_travelToDimension_112 = new ModData();
        reflect_Entity_method_travelToDimension_112.set("methodName", "travelToDimension");
        reflect_Entity_method_travelToDimension_112.set("returnType", "void");
        reflect_Entity_method_travelToDimension_112.set("static", false);
        reflect_Entity_method_travelToDimension_112.set("argnames", new String[]{"i"});
        reflect_Entity_method_travelToDimension_112.set("argtypes", new String[]{"int"});
        reflect_Entity_method_travelToDimension_112.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).travelToDimension((int) params.getInt("i"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_travelToDimension_112);


        BaseData reflect_Entity_method_getExplosionResistance_113 = new ModData();
        reflect_Entity_method_getExplosionResistance_113.set("methodName", "getExplosionResistance");
        reflect_Entity_method_getExplosionResistance_113.set("returnType", "float");
        reflect_Entity_method_getExplosionResistance_113.set("static", false);
        reflect_Entity_method_getExplosionResistance_113.set("argnames", new String[]{"explosionIn", "worldIn", "pos", "blockStateIn"});
        reflect_Entity_method_getExplosionResistance_113.set("argtypes", new String[]{"Explosion", "World", "BlockPos", "IBlockState"});
        reflect_Entity_method_getExplosionResistance_113.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((Entity) params.getReflective("_self")).getExplosionResistance((Explosion) params.getReflective("explosionIn"), (World) params.getReflective("worldIn"), (BlockPos) params.getReflective("pos"), (IBlockState) params.getReflective("blockStateIn"));
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_getExplosionResistance_113);


        BaseData reflect_Entity_method_getMaxFallHeight_114 = new ModData();
        reflect_Entity_method_getMaxFallHeight_114.set("methodName", "getMaxFallHeight");
        reflect_Entity_method_getMaxFallHeight_114.set("returnType", "int");
        reflect_Entity_method_getMaxFallHeight_114.set("static", false);
        reflect_Entity_method_getMaxFallHeight_114.set("argnames", new String[]{});
        reflect_Entity_method_getMaxFallHeight_114.set("argtypes", new String[]{});
        reflect_Entity_method_getMaxFallHeight_114.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((Entity) params.getReflective("_self")).getMaxFallHeight();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_getMaxFallHeight_114);


        BaseData reflect_Entity_method_func_181014_aG_115 = new ModData();
        reflect_Entity_method_func_181014_aG_115.set("methodName", "func_181014_aG");
        reflect_Entity_method_func_181014_aG_115.set("returnType", "Vec3");
        reflect_Entity_method_func_181014_aG_115.set("static", false);
        reflect_Entity_method_func_181014_aG_115.set("argnames", new String[]{});
        reflect_Entity_method_func_181014_aG_115.set("argtypes", new String[]{});
        reflect_Entity_method_func_181014_aG_115.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Vec3) ((Entity) params.getReflective("_self")).func_181014_aG();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_func_181014_aG_115);


        BaseData reflect_Entity_method_func_181012_aH_116 = new ModData();
        reflect_Entity_method_func_181012_aH_116.set("methodName", "func_181012_aH");
        reflect_Entity_method_func_181012_aH_116.set("returnType", "EnumFacing");
        reflect_Entity_method_func_181012_aH_116.set("static", false);
        reflect_Entity_method_func_181012_aH_116.set("argnames", new String[]{});
        reflect_Entity_method_func_181012_aH_116.set("argtypes", new String[]{});
        reflect_Entity_method_func_181012_aH_116.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EnumFacing) ((Entity) params.getReflective("_self")).func_181012_aH();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_func_181012_aH_116);


        BaseData reflect_Entity_method_doesEntityNotTriggerPressurePlate_117 = new ModData();
        reflect_Entity_method_doesEntityNotTriggerPressurePlate_117.set("methodName", "doesEntityNotTriggerPressurePlate");
        reflect_Entity_method_doesEntityNotTriggerPressurePlate_117.set("returnType", "boolean");
        reflect_Entity_method_doesEntityNotTriggerPressurePlate_117.set("static", false);
        reflect_Entity_method_doesEntityNotTriggerPressurePlate_117.set("argnames", new String[]{});
        reflect_Entity_method_doesEntityNotTriggerPressurePlate_117.set("argtypes", new String[]{});
        reflect_Entity_method_doesEntityNotTriggerPressurePlate_117.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((Entity) params.getReflective("_self")).doesEntityNotTriggerPressurePlate();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_doesEntityNotTriggerPressurePlate_117);


        BaseData reflect_Entity_method_addEntityCrashInfo_118 = new ModData();
        reflect_Entity_method_addEntityCrashInfo_118.set("methodName", "addEntityCrashInfo");
        reflect_Entity_method_addEntityCrashInfo_118.set("returnType", "void");
        reflect_Entity_method_addEntityCrashInfo_118.set("static", false);
        reflect_Entity_method_addEntityCrashInfo_118.set("argnames", new String[]{"category"});
        reflect_Entity_method_addEntityCrashInfo_118.set("argtypes", new String[]{"CrashReportCategory"});
        reflect_Entity_method_addEntityCrashInfo_118.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).addEntityCrashInfo((CrashReportCategory) params.getReflective("category"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_addEntityCrashInfo_118);


        BaseData reflect_Entity_method_canRenderOnFire_119 = new ModData();
        reflect_Entity_method_canRenderOnFire_119.set("methodName", "canRenderOnFire");
        reflect_Entity_method_canRenderOnFire_119.set("returnType", "boolean");
        reflect_Entity_method_canRenderOnFire_119.set("static", false);
        reflect_Entity_method_canRenderOnFire_119.set("argnames", new String[]{});
        reflect_Entity_method_canRenderOnFire_119.set("argtypes", new String[]{});
        reflect_Entity_method_canRenderOnFire_119.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((Entity) params.getReflective("_self")).canRenderOnFire();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_canRenderOnFire_119);


        BaseData reflect_Entity_method_getUniqueID_120 = new ModData();
        reflect_Entity_method_getUniqueID_120.set("methodName", "getUniqueID");
        reflect_Entity_method_getUniqueID_120.set("returnType", "EaglercraftUUID");
        reflect_Entity_method_getUniqueID_120.set("static", false);
        reflect_Entity_method_getUniqueID_120.set("argnames", new String[]{});
        reflect_Entity_method_getUniqueID_120.set("argtypes", new String[]{});
        reflect_Entity_method_getUniqueID_120.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EaglercraftUUID) ((Entity) params.getReflective("_self")).getUniqueID();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_getUniqueID_120);


        BaseData reflect_Entity_method_isPushedByWater_121 = new ModData();
        reflect_Entity_method_isPushedByWater_121.set("methodName", "isPushedByWater");
        reflect_Entity_method_isPushedByWater_121.set("returnType", "boolean");
        reflect_Entity_method_isPushedByWater_121.set("static", false);
        reflect_Entity_method_isPushedByWater_121.set("argnames", new String[]{});
        reflect_Entity_method_isPushedByWater_121.set("argtypes", new String[]{});
        reflect_Entity_method_isPushedByWater_121.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((Entity) params.getReflective("_self")).isPushedByWater();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_isPushedByWater_121);


        BaseData reflect_Entity_method_getDisplayName_122 = new ModData();
        reflect_Entity_method_getDisplayName_122.set("methodName", "getDisplayName");
        reflect_Entity_method_getDisplayName_122.set("returnType", "IChatComponent");
        reflect_Entity_method_getDisplayName_122.set("static", false);
        reflect_Entity_method_getDisplayName_122.set("argnames", new String[]{});
        reflect_Entity_method_getDisplayName_122.set("argtypes", new String[]{});
        reflect_Entity_method_getDisplayName_122.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (IChatComponent) ((Entity) params.getReflective("_self")).getDisplayName();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_getDisplayName_122);


        BaseData reflect_Entity_method_setCustomNameTag_123 = new ModData();
        reflect_Entity_method_setCustomNameTag_123.set("methodName", "setCustomNameTag");
        reflect_Entity_method_setCustomNameTag_123.set("returnType", "void");
        reflect_Entity_method_setCustomNameTag_123.set("static", false);
        reflect_Entity_method_setCustomNameTag_123.set("argnames", new String[]{"name"});
        reflect_Entity_method_setCustomNameTag_123.set("argtypes", new String[]{"String"});
        reflect_Entity_method_setCustomNameTag_123.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).setCustomNameTag((String) params.getString("name"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_setCustomNameTag_123);


        BaseData reflect_Entity_method_getCustomNameTag_124 = new ModData();
        reflect_Entity_method_getCustomNameTag_124.set("methodName", "getCustomNameTag");
        reflect_Entity_method_getCustomNameTag_124.set("returnType", "String");
        reflect_Entity_method_getCustomNameTag_124.set("static", false);
        reflect_Entity_method_getCustomNameTag_124.set("argnames", new String[]{});
        reflect_Entity_method_getCustomNameTag_124.set("argtypes", new String[]{});
        reflect_Entity_method_getCustomNameTag_124.setCallbackStringWithDataArg("exec", (BaseData params) -> {
                try {
                    return (String) ((Entity) params.getReflective("_self")).getCustomNameTag();
                } catch (Exception _exception_reflect_) {
                    return "";
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_getCustomNameTag_124);


        BaseData reflect_Entity_method_hasCustomName_125 = new ModData();
        reflect_Entity_method_hasCustomName_125.set("methodName", "hasCustomName");
        reflect_Entity_method_hasCustomName_125.set("returnType", "boolean");
        reflect_Entity_method_hasCustomName_125.set("static", false);
        reflect_Entity_method_hasCustomName_125.set("argnames", new String[]{});
        reflect_Entity_method_hasCustomName_125.set("argtypes", new String[]{});
        reflect_Entity_method_hasCustomName_125.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((Entity) params.getReflective("_self")).hasCustomName();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_hasCustomName_125);


        BaseData reflect_Entity_method_setAlwaysRenderNameTag_126 = new ModData();
        reflect_Entity_method_setAlwaysRenderNameTag_126.set("methodName", "setAlwaysRenderNameTag");
        reflect_Entity_method_setAlwaysRenderNameTag_126.set("returnType", "void");
        reflect_Entity_method_setAlwaysRenderNameTag_126.set("static", false);
        reflect_Entity_method_setAlwaysRenderNameTag_126.set("argnames", new String[]{"alwaysRenderNameTag"});
        reflect_Entity_method_setAlwaysRenderNameTag_126.set("argtypes", new String[]{"boolean"});
        reflect_Entity_method_setAlwaysRenderNameTag_126.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).setAlwaysRenderNameTag((boolean) params.getBoolean("alwaysRenderNameTag"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_setAlwaysRenderNameTag_126);


        BaseData reflect_Entity_method_getAlwaysRenderNameTag_127 = new ModData();
        reflect_Entity_method_getAlwaysRenderNameTag_127.set("methodName", "getAlwaysRenderNameTag");
        reflect_Entity_method_getAlwaysRenderNameTag_127.set("returnType", "boolean");
        reflect_Entity_method_getAlwaysRenderNameTag_127.set("static", false);
        reflect_Entity_method_getAlwaysRenderNameTag_127.set("argnames", new String[]{});
        reflect_Entity_method_getAlwaysRenderNameTag_127.set("argtypes", new String[]{});
        reflect_Entity_method_getAlwaysRenderNameTag_127.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((Entity) params.getReflective("_self")).getAlwaysRenderNameTag();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_getAlwaysRenderNameTag_127);


        BaseData reflect_Entity_method_setPositionAndUpdate_128 = new ModData();
        reflect_Entity_method_setPositionAndUpdate_128.set("methodName", "setPositionAndUpdate");
        reflect_Entity_method_setPositionAndUpdate_128.set("returnType", "void");
        reflect_Entity_method_setPositionAndUpdate_128.set("static", false);
        reflect_Entity_method_setPositionAndUpdate_128.set("argnames", new String[]{"d0", "d1", "d2"});
        reflect_Entity_method_setPositionAndUpdate_128.set("argtypes", new String[]{"double", "double", "double"});
        reflect_Entity_method_setPositionAndUpdate_128.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).setPositionAndUpdate((double) params.getDouble("d0"), (double) params.getDouble("d1"), (double) params.getDouble("d2"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_setPositionAndUpdate_128);


        BaseData reflect_Entity_method_getAlwaysRenderNameTagForRender_129 = new ModData();
        reflect_Entity_method_getAlwaysRenderNameTagForRender_129.set("methodName", "getAlwaysRenderNameTagForRender");
        reflect_Entity_method_getAlwaysRenderNameTagForRender_129.set("returnType", "boolean");
        reflect_Entity_method_getAlwaysRenderNameTagForRender_129.set("static", false);
        reflect_Entity_method_getAlwaysRenderNameTagForRender_129.set("argnames", new String[]{});
        reflect_Entity_method_getAlwaysRenderNameTagForRender_129.set("argtypes", new String[]{});
        reflect_Entity_method_getAlwaysRenderNameTagForRender_129.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((Entity) params.getReflective("_self")).getAlwaysRenderNameTagForRender();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_getAlwaysRenderNameTagForRender_129);


        BaseData reflect_Entity_method_onDataWatcherUpdate_130 = new ModData();
        reflect_Entity_method_onDataWatcherUpdate_130.set("methodName", "onDataWatcherUpdate");
        reflect_Entity_method_onDataWatcherUpdate_130.set("returnType", "void");
        reflect_Entity_method_onDataWatcherUpdate_130.set("static", false);
        reflect_Entity_method_onDataWatcherUpdate_130.set("argnames", new String[]{"dataID"});
        reflect_Entity_method_onDataWatcherUpdate_130.set("argtypes", new String[]{"int"});
        reflect_Entity_method_onDataWatcherUpdate_130.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).onDataWatcherUpdate((int) params.getInt("dataID"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_onDataWatcherUpdate_130);


        BaseData reflect_Entity_method_getHorizontalFacing_131 = new ModData();
        reflect_Entity_method_getHorizontalFacing_131.set("methodName", "getHorizontalFacing");
        reflect_Entity_method_getHorizontalFacing_131.set("returnType", "EnumFacing");
        reflect_Entity_method_getHorizontalFacing_131.set("static", false);
        reflect_Entity_method_getHorizontalFacing_131.set("argnames", new String[]{});
        reflect_Entity_method_getHorizontalFacing_131.set("argtypes", new String[]{});
        reflect_Entity_method_getHorizontalFacing_131.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EnumFacing) ((Entity) params.getReflective("_self")).getHorizontalFacing();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_getHorizontalFacing_131);


        BaseData reflect_Entity_method_isSpectatedByPlayer_132 = new ModData();
        reflect_Entity_method_isSpectatedByPlayer_132.set("methodName", "isSpectatedByPlayer");
        reflect_Entity_method_isSpectatedByPlayer_132.set("returnType", "boolean");
        reflect_Entity_method_isSpectatedByPlayer_132.set("static", false);
        reflect_Entity_method_isSpectatedByPlayer_132.set("argnames", new String[]{"var1"});
        reflect_Entity_method_isSpectatedByPlayer_132.set("argtypes", new String[]{"EntityPlayerMP"});
        reflect_Entity_method_isSpectatedByPlayer_132.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((Entity) params.getReflective("_self")).isSpectatedByPlayer((EntityPlayerMP) params.getReflective("var1"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_isSpectatedByPlayer_132);


        BaseData reflect_Entity_method_getEntityBoundingBox_133 = new ModData();
        reflect_Entity_method_getEntityBoundingBox_133.set("methodName", "getEntityBoundingBox");
        reflect_Entity_method_getEntityBoundingBox_133.set("returnType", "AxisAlignedBB");
        reflect_Entity_method_getEntityBoundingBox_133.set("static", false);
        reflect_Entity_method_getEntityBoundingBox_133.set("argnames", new String[]{});
        reflect_Entity_method_getEntityBoundingBox_133.set("argtypes", new String[]{});
        reflect_Entity_method_getEntityBoundingBox_133.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (AxisAlignedBB) ((Entity) params.getReflective("_self")).getEntityBoundingBox();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_getEntityBoundingBox_133);


        BaseData reflect_Entity_method_setEntityBoundingBox_134 = new ModData();
        reflect_Entity_method_setEntityBoundingBox_134.set("methodName", "setEntityBoundingBox");
        reflect_Entity_method_setEntityBoundingBox_134.set("returnType", "void");
        reflect_Entity_method_setEntityBoundingBox_134.set("static", false);
        reflect_Entity_method_setEntityBoundingBox_134.set("argnames", new String[]{"bb"});
        reflect_Entity_method_setEntityBoundingBox_134.set("argtypes", new String[]{"AxisAlignedBB"});
        reflect_Entity_method_setEntityBoundingBox_134.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).setEntityBoundingBox((AxisAlignedBB) params.getReflective("bb"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_setEntityBoundingBox_134);


        BaseData reflect_Entity_method_getEyeHeight_135 = new ModData();
        reflect_Entity_method_getEyeHeight_135.set("methodName", "getEyeHeight");
        reflect_Entity_method_getEyeHeight_135.set("returnType", "float");
        reflect_Entity_method_getEyeHeight_135.set("static", false);
        reflect_Entity_method_getEyeHeight_135.set("argnames", new String[]{});
        reflect_Entity_method_getEyeHeight_135.set("argtypes", new String[]{});
        reflect_Entity_method_getEyeHeight_135.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((Entity) params.getReflective("_self")).getEyeHeight();
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_getEyeHeight_135);


        BaseData reflect_Entity_method_isOutsideBorder_136 = new ModData();
        reflect_Entity_method_isOutsideBorder_136.set("methodName", "isOutsideBorder");
        reflect_Entity_method_isOutsideBorder_136.set("returnType", "boolean");
        reflect_Entity_method_isOutsideBorder_136.set("static", false);
        reflect_Entity_method_isOutsideBorder_136.set("argnames", new String[]{});
        reflect_Entity_method_isOutsideBorder_136.set("argtypes", new String[]{});
        reflect_Entity_method_isOutsideBorder_136.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((Entity) params.getReflective("_self")).isOutsideBorder();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_isOutsideBorder_136);


        BaseData reflect_Entity_method_setOutsideBorder_137 = new ModData();
        reflect_Entity_method_setOutsideBorder_137.set("methodName", "setOutsideBorder");
        reflect_Entity_method_setOutsideBorder_137.set("returnType", "void");
        reflect_Entity_method_setOutsideBorder_137.set("static", false);
        reflect_Entity_method_setOutsideBorder_137.set("argnames", new String[]{"outsideBorder"});
        reflect_Entity_method_setOutsideBorder_137.set("argtypes", new String[]{"boolean"});
        reflect_Entity_method_setOutsideBorder_137.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).setOutsideBorder((boolean) params.getBoolean("outsideBorder"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_setOutsideBorder_137);


        BaseData reflect_Entity_method_replaceItemInInventory_138 = new ModData();
        reflect_Entity_method_replaceItemInInventory_138.set("methodName", "replaceItemInInventory");
        reflect_Entity_method_replaceItemInInventory_138.set("returnType", "boolean");
        reflect_Entity_method_replaceItemInInventory_138.set("static", false);
        reflect_Entity_method_replaceItemInInventory_138.set("argnames", new String[]{"inventorySlot", "itemStackIn"});
        reflect_Entity_method_replaceItemInInventory_138.set("argtypes", new String[]{"int", "ItemStack"});
        reflect_Entity_method_replaceItemInInventory_138.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((Entity) params.getReflective("_self")).replaceItemInInventory((int) params.getInt("inventorySlot"), (ItemStack) params.getReflective("itemStackIn"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_replaceItemInInventory_138);


        BaseData reflect_Entity_method_addChatMessage_139 = new ModData();
        reflect_Entity_method_addChatMessage_139.set("methodName", "addChatMessage");
        reflect_Entity_method_addChatMessage_139.set("returnType", "void");
        reflect_Entity_method_addChatMessage_139.set("static", false);
        reflect_Entity_method_addChatMessage_139.set("argnames", new String[]{"var1"});
        reflect_Entity_method_addChatMessage_139.set("argtypes", new String[]{"IChatComponent"});
        reflect_Entity_method_addChatMessage_139.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).addChatMessage((IChatComponent) params.getReflective("var1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_addChatMessage_139);


        BaseData reflect_Entity_method_canCommandSenderUseCommand_140 = new ModData();
        reflect_Entity_method_canCommandSenderUseCommand_140.set("methodName", "canCommandSenderUseCommand");
        reflect_Entity_method_canCommandSenderUseCommand_140.set("returnType", "boolean");
        reflect_Entity_method_canCommandSenderUseCommand_140.set("static", false);
        reflect_Entity_method_canCommandSenderUseCommand_140.set("argnames", new String[]{"var1", "var2"});
        reflect_Entity_method_canCommandSenderUseCommand_140.set("argtypes", new String[]{"int", "String"});
        reflect_Entity_method_canCommandSenderUseCommand_140.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((Entity) params.getReflective("_self")).canCommandSenderUseCommand((int) params.getInt("var1"), (String) params.getString("var2"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_canCommandSenderUseCommand_140);


        BaseData reflect_Entity_method_getPosition_141 = new ModData();
        reflect_Entity_method_getPosition_141.set("methodName", "getPosition");
        reflect_Entity_method_getPosition_141.set("returnType", "BlockPos");
        reflect_Entity_method_getPosition_141.set("static", false);
        reflect_Entity_method_getPosition_141.set("argnames", new String[]{});
        reflect_Entity_method_getPosition_141.set("argtypes", new String[]{});
        reflect_Entity_method_getPosition_141.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (BlockPos) ((Entity) params.getReflective("_self")).getPosition();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_getPosition_141);


        BaseData reflect_Entity_method_getPositionVector_142 = new ModData();
        reflect_Entity_method_getPositionVector_142.set("methodName", "getPositionVector");
        reflect_Entity_method_getPositionVector_142.set("returnType", "Vec3");
        reflect_Entity_method_getPositionVector_142.set("static", false);
        reflect_Entity_method_getPositionVector_142.set("argnames", new String[]{});
        reflect_Entity_method_getPositionVector_142.set("argtypes", new String[]{});
        reflect_Entity_method_getPositionVector_142.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Vec3) ((Entity) params.getReflective("_self")).getPositionVector();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_getPositionVector_142);


        BaseData reflect_Entity_method_getEntityWorld_143 = new ModData();
        reflect_Entity_method_getEntityWorld_143.set("methodName", "getEntityWorld");
        reflect_Entity_method_getEntityWorld_143.set("returnType", "World");
        reflect_Entity_method_getEntityWorld_143.set("static", false);
        reflect_Entity_method_getEntityWorld_143.set("argnames", new String[]{});
        reflect_Entity_method_getEntityWorld_143.set("argtypes", new String[]{});
        reflect_Entity_method_getEntityWorld_143.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (World) ((Entity) params.getReflective("_self")).getEntityWorld();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_getEntityWorld_143);


        BaseData reflect_Entity_method_getCommandSenderEntity_144 = new ModData();
        reflect_Entity_method_getCommandSenderEntity_144.set("methodName", "getCommandSenderEntity");
        reflect_Entity_method_getCommandSenderEntity_144.set("returnType", "Entity");
        reflect_Entity_method_getCommandSenderEntity_144.set("static", false);
        reflect_Entity_method_getCommandSenderEntity_144.set("argnames", new String[]{});
        reflect_Entity_method_getCommandSenderEntity_144.set("argtypes", new String[]{});
        reflect_Entity_method_getCommandSenderEntity_144.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Entity) ((Entity) params.getReflective("_self")).getCommandSenderEntity();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_getCommandSenderEntity_144);


        BaseData reflect_Entity_method_sendCommandFeedback_145 = new ModData();
        reflect_Entity_method_sendCommandFeedback_145.set("methodName", "sendCommandFeedback");
        reflect_Entity_method_sendCommandFeedback_145.set("returnType", "boolean");
        reflect_Entity_method_sendCommandFeedback_145.set("static", false);
        reflect_Entity_method_sendCommandFeedback_145.set("argnames", new String[]{});
        reflect_Entity_method_sendCommandFeedback_145.set("argtypes", new String[]{});
        reflect_Entity_method_sendCommandFeedback_145.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((Entity) params.getReflective("_self")).sendCommandFeedback();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_sendCommandFeedback_145);


        BaseData reflect_Entity_method_getCommandStats_147 = new ModData();
        reflect_Entity_method_getCommandStats_147.set("methodName", "getCommandStats");
        reflect_Entity_method_getCommandStats_147.set("returnType", "CommandResultStats");
        reflect_Entity_method_getCommandStats_147.set("static", false);
        reflect_Entity_method_getCommandStats_147.set("argnames", new String[]{});
        reflect_Entity_method_getCommandStats_147.set("argtypes", new String[]{});
        reflect_Entity_method_getCommandStats_147.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (CommandResultStats) ((Entity) params.getReflective("_self")).getCommandStats();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_getCommandStats_147);


        BaseData reflect_Entity_method_func_174817_o_148 = new ModData();
        reflect_Entity_method_func_174817_o_148.set("methodName", "func_174817_o");
        reflect_Entity_method_func_174817_o_148.set("returnType", "void");
        reflect_Entity_method_func_174817_o_148.set("static", false);
        reflect_Entity_method_func_174817_o_148.set("argnames", new String[]{"entityIn"});
        reflect_Entity_method_func_174817_o_148.set("argtypes", new String[]{"Entity"});
        reflect_Entity_method_func_174817_o_148.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).func_174817_o((Entity) params.getReflective("entityIn"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_func_174817_o_148);


        BaseData reflect_Entity_method_getNBTTagCompound_149 = new ModData();
        reflect_Entity_method_getNBTTagCompound_149.set("methodName", "getNBTTagCompound");
        reflect_Entity_method_getNBTTagCompound_149.set("returnType", "NBTTagCompound");
        reflect_Entity_method_getNBTTagCompound_149.set("static", false);
        reflect_Entity_method_getNBTTagCompound_149.set("argnames", new String[]{});
        reflect_Entity_method_getNBTTagCompound_149.set("argtypes", new String[]{});
        reflect_Entity_method_getNBTTagCompound_149.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (NBTTagCompound) ((Entity) params.getReflective("_self")).getNBTTagCompound();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_getNBTTagCompound_149);


        BaseData reflect_Entity_method_clientUpdateEntityNBT_150 = new ModData();
        reflect_Entity_method_clientUpdateEntityNBT_150.set("methodName", "clientUpdateEntityNBT");
        reflect_Entity_method_clientUpdateEntityNBT_150.set("returnType", "void");
        reflect_Entity_method_clientUpdateEntityNBT_150.set("static", false);
        reflect_Entity_method_clientUpdateEntityNBT_150.set("argnames", new String[]{"compound"});
        reflect_Entity_method_clientUpdateEntityNBT_150.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_Entity_method_clientUpdateEntityNBT_150.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).clientUpdateEntityNBT((NBTTagCompound) params.getReflective("compound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_clientUpdateEntityNBT_150);


        BaseData reflect_Entity_method_interactAt_151 = new ModData();
        reflect_Entity_method_interactAt_151.set("methodName", "interactAt");
        reflect_Entity_method_interactAt_151.set("returnType", "boolean");
        reflect_Entity_method_interactAt_151.set("static", false);
        reflect_Entity_method_interactAt_151.set("argnames", new String[]{"player", "targetVec3"});
        reflect_Entity_method_interactAt_151.set("argtypes", new String[]{"EntityPlayer", "Vec3"});
        reflect_Entity_method_interactAt_151.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((Entity) params.getReflective("_self")).interactAt((EntityPlayer) params.getReflective("player"), (Vec3) params.getReflective("targetVec3"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_interactAt_151);


        BaseData reflect_Entity_method_isImmuneToExplosions_152 = new ModData();
        reflect_Entity_method_isImmuneToExplosions_152.set("methodName", "isImmuneToExplosions");
        reflect_Entity_method_isImmuneToExplosions_152.set("returnType", "boolean");
        reflect_Entity_method_isImmuneToExplosions_152.set("static", false);
        reflect_Entity_method_isImmuneToExplosions_152.set("argnames", new String[]{});
        reflect_Entity_method_isImmuneToExplosions_152.set("argtypes", new String[]{});
        reflect_Entity_method_isImmuneToExplosions_152.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((Entity) params.getReflective("_self")).isImmuneToExplosions();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_isImmuneToExplosions_152);


        BaseData reflect_Entity_method_renderDynamicLightsEagler_153 = new ModData();
        reflect_Entity_method_renderDynamicLightsEagler_153.set("methodName", "renderDynamicLightsEagler");
        reflect_Entity_method_renderDynamicLightsEagler_153.set("returnType", "void");
        reflect_Entity_method_renderDynamicLightsEagler_153.set("static", false);
        reflect_Entity_method_renderDynamicLightsEagler_153.set("argnames", new String[]{"partialTicks", "isInFrustum"});
        reflect_Entity_method_renderDynamicLightsEagler_153.set("argtypes", new String[]{"float", "boolean"});
        reflect_Entity_method_renderDynamicLightsEagler_153.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Entity) params.getReflective("_self")).renderDynamicLightsEagler((float) params.getFloat("partialTicks"), (boolean) params.getBoolean("isInFrustum"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Entity_methods.add(reflect_Entity_method_renderDynamicLightsEagler_153);


        BaseData[] reflect_Entity_methods_arr = new BaseData[reflect_Entity_methods.size()];
        for (int i = 0; i < reflect_Entity_methods_arr.length; i++) {
            reflect_Entity_methods_arr[i] = reflect_Entity_methods.get(i);
        }

        reflect_Entity.set("constructors", reflect_Entity_constructors_arr);
        reflect_Entity.set("methods", reflect_Entity_methods_arr);
        reflect_Entity.set("className", "Entity");
        reflect_Entity.set("classId", "net.minecraft.entity.Entity");
        reflect_Entity.set("class", Entity.class);
        reflect_Entity.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof Entity;
        });
        reflectProfiles.add(reflect_Entity);
    }


    //classdef for EntityCreature
    public static void reflect_EntityCreature_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityCreature = new ModData();

        ArrayList<BaseData> reflect_EntityCreature_constructors = new ArrayList<BaseData>();
        
        BaseData[] reflect_EntityCreature_constructors_arr = new BaseData[reflect_EntityCreature_constructors.size()];
        for (int i = 0; i < reflect_EntityCreature_constructors_arr.length; i++) {
            reflect_EntityCreature_constructors_arr[i] = reflect_EntityCreature_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityCreature_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityCreature_method_getBlockPathWeight_0 = new ModData();
        reflect_EntityCreature_method_getBlockPathWeight_0.set("methodName", "getBlockPathWeight");
        reflect_EntityCreature_method_getBlockPathWeight_0.set("returnType", "float");
        reflect_EntityCreature_method_getBlockPathWeight_0.set("static", false);
        reflect_EntityCreature_method_getBlockPathWeight_0.set("argnames", new String[]{"pos"});
        reflect_EntityCreature_method_getBlockPathWeight_0.set("argtypes", new String[]{"BlockPos"});
        reflect_EntityCreature_method_getBlockPathWeight_0.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityCreature) params.getReflective("_self")).getBlockPathWeight((BlockPos) params.getReflective("pos"));
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityCreature_methods.add(reflect_EntityCreature_method_getBlockPathWeight_0);


        BaseData reflect_EntityCreature_method_getCanSpawnHere_1 = new ModData();
        reflect_EntityCreature_method_getCanSpawnHere_1.set("methodName", "getCanSpawnHere");
        reflect_EntityCreature_method_getCanSpawnHere_1.set("returnType", "boolean");
        reflect_EntityCreature_method_getCanSpawnHere_1.set("static", false);
        reflect_EntityCreature_method_getCanSpawnHere_1.set("argnames", new String[]{});
        reflect_EntityCreature_method_getCanSpawnHere_1.set("argtypes", new String[]{});
        reflect_EntityCreature_method_getCanSpawnHere_1.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityCreature) params.getReflective("_self")).getCanSpawnHere();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityCreature_methods.add(reflect_EntityCreature_method_getCanSpawnHere_1);


        BaseData reflect_EntityCreature_method_hasPath_2 = new ModData();
        reflect_EntityCreature_method_hasPath_2.set("methodName", "hasPath");
        reflect_EntityCreature_method_hasPath_2.set("returnType", "boolean");
        reflect_EntityCreature_method_hasPath_2.set("static", false);
        reflect_EntityCreature_method_hasPath_2.set("argnames", new String[]{});
        reflect_EntityCreature_method_hasPath_2.set("argtypes", new String[]{});
        reflect_EntityCreature_method_hasPath_2.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityCreature) params.getReflective("_self")).hasPath();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityCreature_methods.add(reflect_EntityCreature_method_hasPath_2);


        BaseData reflect_EntityCreature_method_isWithinHomeDistanceCurrentPosition_3 = new ModData();
        reflect_EntityCreature_method_isWithinHomeDistanceCurrentPosition_3.set("methodName", "isWithinHomeDistanceCurrentPosition");
        reflect_EntityCreature_method_isWithinHomeDistanceCurrentPosition_3.set("returnType", "boolean");
        reflect_EntityCreature_method_isWithinHomeDistanceCurrentPosition_3.set("static", false);
        reflect_EntityCreature_method_isWithinHomeDistanceCurrentPosition_3.set("argnames", new String[]{});
        reflect_EntityCreature_method_isWithinHomeDistanceCurrentPosition_3.set("argtypes", new String[]{});
        reflect_EntityCreature_method_isWithinHomeDistanceCurrentPosition_3.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityCreature) params.getReflective("_self")).isWithinHomeDistanceCurrentPosition();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityCreature_methods.add(reflect_EntityCreature_method_isWithinHomeDistanceCurrentPosition_3);


        BaseData reflect_EntityCreature_method_isWithinHomeDistanceFromPosition_4 = new ModData();
        reflect_EntityCreature_method_isWithinHomeDistanceFromPosition_4.set("methodName", "isWithinHomeDistanceFromPosition");
        reflect_EntityCreature_method_isWithinHomeDistanceFromPosition_4.set("returnType", "boolean");
        reflect_EntityCreature_method_isWithinHomeDistanceFromPosition_4.set("static", false);
        reflect_EntityCreature_method_isWithinHomeDistanceFromPosition_4.set("argnames", new String[]{"pos"});
        reflect_EntityCreature_method_isWithinHomeDistanceFromPosition_4.set("argtypes", new String[]{"BlockPos"});
        reflect_EntityCreature_method_isWithinHomeDistanceFromPosition_4.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityCreature) params.getReflective("_self")).isWithinHomeDistanceFromPosition((BlockPos) params.getReflective("pos"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityCreature_methods.add(reflect_EntityCreature_method_isWithinHomeDistanceFromPosition_4);


        BaseData reflect_EntityCreature_method_setHomePosAndDistance_5 = new ModData();
        reflect_EntityCreature_method_setHomePosAndDistance_5.set("methodName", "setHomePosAndDistance");
        reflect_EntityCreature_method_setHomePosAndDistance_5.set("returnType", "void");
        reflect_EntityCreature_method_setHomePosAndDistance_5.set("static", false);
        reflect_EntityCreature_method_setHomePosAndDistance_5.set("argnames", new String[]{"pos", "distance"});
        reflect_EntityCreature_method_setHomePosAndDistance_5.set("argtypes", new String[]{"BlockPos", "int"});
        reflect_EntityCreature_method_setHomePosAndDistance_5.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityCreature) params.getReflective("_self")).setHomePosAndDistance((BlockPos) params.getReflective("pos"), (int) params.getInt("distance"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityCreature_methods.add(reflect_EntityCreature_method_setHomePosAndDistance_5);


        BaseData reflect_EntityCreature_method_getHomePosition_6 = new ModData();
        reflect_EntityCreature_method_getHomePosition_6.set("methodName", "getHomePosition");
        reflect_EntityCreature_method_getHomePosition_6.set("returnType", "BlockPos");
        reflect_EntityCreature_method_getHomePosition_6.set("static", false);
        reflect_EntityCreature_method_getHomePosition_6.set("argnames", new String[]{});
        reflect_EntityCreature_method_getHomePosition_6.set("argtypes", new String[]{});
        reflect_EntityCreature_method_getHomePosition_6.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (BlockPos) ((EntityCreature) params.getReflective("_self")).getHomePosition();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityCreature_methods.add(reflect_EntityCreature_method_getHomePosition_6);


        BaseData reflect_EntityCreature_method_getMaximumHomeDistance_7 = new ModData();
        reflect_EntityCreature_method_getMaximumHomeDistance_7.set("methodName", "getMaximumHomeDistance");
        reflect_EntityCreature_method_getMaximumHomeDistance_7.set("returnType", "float");
        reflect_EntityCreature_method_getMaximumHomeDistance_7.set("static", false);
        reflect_EntityCreature_method_getMaximumHomeDistance_7.set("argnames", new String[]{});
        reflect_EntityCreature_method_getMaximumHomeDistance_7.set("argtypes", new String[]{});
        reflect_EntityCreature_method_getMaximumHomeDistance_7.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityCreature) params.getReflective("_self")).getMaximumHomeDistance();
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityCreature_methods.add(reflect_EntityCreature_method_getMaximumHomeDistance_7);


        BaseData reflect_EntityCreature_method_detachHome_8 = new ModData();
        reflect_EntityCreature_method_detachHome_8.set("methodName", "detachHome");
        reflect_EntityCreature_method_detachHome_8.set("returnType", "void");
        reflect_EntityCreature_method_detachHome_8.set("static", false);
        reflect_EntityCreature_method_detachHome_8.set("argnames", new String[]{});
        reflect_EntityCreature_method_detachHome_8.set("argtypes", new String[]{});
        reflect_EntityCreature_method_detachHome_8.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityCreature) params.getReflective("_self")).detachHome();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityCreature_methods.add(reflect_EntityCreature_method_detachHome_8);


        BaseData reflect_EntityCreature_method_hasHome_9 = new ModData();
        reflect_EntityCreature_method_hasHome_9.set("methodName", "hasHome");
        reflect_EntityCreature_method_hasHome_9.set("returnType", "boolean");
        reflect_EntityCreature_method_hasHome_9.set("static", false);
        reflect_EntityCreature_method_hasHome_9.set("argnames", new String[]{});
        reflect_EntityCreature_method_hasHome_9.set("argtypes", new String[]{});
        reflect_EntityCreature_method_hasHome_9.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityCreature) params.getReflective("_self")).hasHome();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityCreature_methods.add(reflect_EntityCreature_method_hasHome_9);


        BaseData[] reflect_EntityCreature_methods_arr = new BaseData[reflect_EntityCreature_methods.size()];
        for (int i = 0; i < reflect_EntityCreature_methods_arr.length; i++) {
            reflect_EntityCreature_methods_arr[i] = reflect_EntityCreature_methods.get(i);
        }

        reflect_EntityCreature.set("constructors", reflect_EntityCreature_constructors_arr);
        reflect_EntityCreature.set("methods", reflect_EntityCreature_methods_arr);
        reflect_EntityCreature.set("className", "EntityCreature");
        reflect_EntityCreature.set("classId", "net.minecraft.entity.EntityCreature");
        reflect_EntityCreature.set("class", EntityCreature.class);
        reflect_EntityCreature.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityCreature;
        });
        reflectProfiles.add(reflect_EntityCreature);
    }


    //classdef for EntityLiving
    public static void reflect_EntityLiving_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityLiving = new ModData();

        ArrayList<BaseData> reflect_EntityLiving_constructors = new ArrayList<BaseData>();
        
        BaseData[] reflect_EntityLiving_constructors_arr = new BaseData[reflect_EntityLiving_constructors.size()];
        for (int i = 0; i < reflect_EntityLiving_constructors_arr.length; i++) {
            reflect_EntityLiving_constructors_arr[i] = reflect_EntityLiving_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityLiving_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityLiving_method_getLookHelper_0 = new ModData();
        reflect_EntityLiving_method_getLookHelper_0.set("methodName", "getLookHelper");
        reflect_EntityLiving_method_getLookHelper_0.set("returnType", "EntityLookHelper");
        reflect_EntityLiving_method_getLookHelper_0.set("static", false);
        reflect_EntityLiving_method_getLookHelper_0.set("argnames", new String[]{});
        reflect_EntityLiving_method_getLookHelper_0.set("argtypes", new String[]{});
        reflect_EntityLiving_method_getLookHelper_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EntityLookHelper) ((EntityLiving) params.getReflective("_self")).getLookHelper();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityLiving_methods.add(reflect_EntityLiving_method_getLookHelper_0);


        BaseData reflect_EntityLiving_method_getMoveHelper_1 = new ModData();
        reflect_EntityLiving_method_getMoveHelper_1.set("methodName", "getMoveHelper");
        reflect_EntityLiving_method_getMoveHelper_1.set("returnType", "EntityMoveHelper");
        reflect_EntityLiving_method_getMoveHelper_1.set("static", false);
        reflect_EntityLiving_method_getMoveHelper_1.set("argnames", new String[]{});
        reflect_EntityLiving_method_getMoveHelper_1.set("argtypes", new String[]{});
        reflect_EntityLiving_method_getMoveHelper_1.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EntityMoveHelper) ((EntityLiving) params.getReflective("_self")).getMoveHelper();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityLiving_methods.add(reflect_EntityLiving_method_getMoveHelper_1);


        BaseData reflect_EntityLiving_method_getJumpHelper_2 = new ModData();
        reflect_EntityLiving_method_getJumpHelper_2.set("methodName", "getJumpHelper");
        reflect_EntityLiving_method_getJumpHelper_2.set("returnType", "EntityJumpHelper");
        reflect_EntityLiving_method_getJumpHelper_2.set("static", false);
        reflect_EntityLiving_method_getJumpHelper_2.set("argnames", new String[]{});
        reflect_EntityLiving_method_getJumpHelper_2.set("argtypes", new String[]{});
        reflect_EntityLiving_method_getJumpHelper_2.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EntityJumpHelper) ((EntityLiving) params.getReflective("_self")).getJumpHelper();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityLiving_methods.add(reflect_EntityLiving_method_getJumpHelper_2);


        BaseData reflect_EntityLiving_method_getNavigator_3 = new ModData();
        reflect_EntityLiving_method_getNavigator_3.set("methodName", "getNavigator");
        reflect_EntityLiving_method_getNavigator_3.set("returnType", "PathNavigate");
        reflect_EntityLiving_method_getNavigator_3.set("static", false);
        reflect_EntityLiving_method_getNavigator_3.set("argnames", new String[]{});
        reflect_EntityLiving_method_getNavigator_3.set("argtypes", new String[]{});
        reflect_EntityLiving_method_getNavigator_3.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (PathNavigate) ((EntityLiving) params.getReflective("_self")).getNavigator();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityLiving_methods.add(reflect_EntityLiving_method_getNavigator_3);


        BaseData reflect_EntityLiving_method_getEntitySenses_4 = new ModData();
        reflect_EntityLiving_method_getEntitySenses_4.set("methodName", "getEntitySenses");
        reflect_EntityLiving_method_getEntitySenses_4.set("returnType", "EntitySenses");
        reflect_EntityLiving_method_getEntitySenses_4.set("static", false);
        reflect_EntityLiving_method_getEntitySenses_4.set("argnames", new String[]{});
        reflect_EntityLiving_method_getEntitySenses_4.set("argtypes", new String[]{});
        reflect_EntityLiving_method_getEntitySenses_4.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EntitySenses) ((EntityLiving) params.getReflective("_self")).getEntitySenses();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityLiving_methods.add(reflect_EntityLiving_method_getEntitySenses_4);


        BaseData reflect_EntityLiving_method_getAttackTarget_5 = new ModData();
        reflect_EntityLiving_method_getAttackTarget_5.set("methodName", "getAttackTarget");
        reflect_EntityLiving_method_getAttackTarget_5.set("returnType", "EntityLivingBase");
        reflect_EntityLiving_method_getAttackTarget_5.set("static", false);
        reflect_EntityLiving_method_getAttackTarget_5.set("argnames", new String[]{});
        reflect_EntityLiving_method_getAttackTarget_5.set("argtypes", new String[]{});
        reflect_EntityLiving_method_getAttackTarget_5.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EntityLivingBase) ((EntityLiving) params.getReflective("_self")).getAttackTarget();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityLiving_methods.add(reflect_EntityLiving_method_getAttackTarget_5);


        BaseData reflect_EntityLiving_method_setAttackTarget_6 = new ModData();
        reflect_EntityLiving_method_setAttackTarget_6.set("methodName", "setAttackTarget");
        reflect_EntityLiving_method_setAttackTarget_6.set("returnType", "void");
        reflect_EntityLiving_method_setAttackTarget_6.set("static", false);
        reflect_EntityLiving_method_setAttackTarget_6.set("argnames", new String[]{"entitylivingbaseIn"});
        reflect_EntityLiving_method_setAttackTarget_6.set("argtypes", new String[]{"EntityLivingBase"});
        reflect_EntityLiving_method_setAttackTarget_6.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLiving) params.getReflective("_self")).setAttackTarget((EntityLivingBase) params.getReflective("entitylivingbaseIn"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLiving_methods.add(reflect_EntityLiving_method_setAttackTarget_6);


        BaseData reflect_EntityLiving_method_eatGrassBonus_7 = new ModData();
        reflect_EntityLiving_method_eatGrassBonus_7.set("methodName", "eatGrassBonus");
        reflect_EntityLiving_method_eatGrassBonus_7.set("returnType", "void");
        reflect_EntityLiving_method_eatGrassBonus_7.set("static", false);
        reflect_EntityLiving_method_eatGrassBonus_7.set("argnames", new String[]{});
        reflect_EntityLiving_method_eatGrassBonus_7.set("argtypes", new String[]{});
        reflect_EntityLiving_method_eatGrassBonus_7.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLiving) params.getReflective("_self")).eatGrassBonus();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLiving_methods.add(reflect_EntityLiving_method_eatGrassBonus_7);


        BaseData reflect_EntityLiving_method_getTalkInterval_8 = new ModData();
        reflect_EntityLiving_method_getTalkInterval_8.set("methodName", "getTalkInterval");
        reflect_EntityLiving_method_getTalkInterval_8.set("returnType", "int");
        reflect_EntityLiving_method_getTalkInterval_8.set("static", false);
        reflect_EntityLiving_method_getTalkInterval_8.set("argnames", new String[]{});
        reflect_EntityLiving_method_getTalkInterval_8.set("argtypes", new String[]{});
        reflect_EntityLiving_method_getTalkInterval_8.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityLiving) params.getReflective("_self")).getTalkInterval();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityLiving_methods.add(reflect_EntityLiving_method_getTalkInterval_8);


        BaseData reflect_EntityLiving_method_playLivingSound_9 = new ModData();
        reflect_EntityLiving_method_playLivingSound_9.set("methodName", "playLivingSound");
        reflect_EntityLiving_method_playLivingSound_9.set("returnType", "void");
        reflect_EntityLiving_method_playLivingSound_9.set("static", false);
        reflect_EntityLiving_method_playLivingSound_9.set("argnames", new String[]{});
        reflect_EntityLiving_method_playLivingSound_9.set("argtypes", new String[]{});
        reflect_EntityLiving_method_playLivingSound_9.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLiving) params.getReflective("_self")).playLivingSound();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLiving_methods.add(reflect_EntityLiving_method_playLivingSound_9);


        BaseData reflect_EntityLiving_method_onEntityUpdate_10 = new ModData();
        reflect_EntityLiving_method_onEntityUpdate_10.set("methodName", "onEntityUpdate");
        reflect_EntityLiving_method_onEntityUpdate_10.set("returnType", "void");
        reflect_EntityLiving_method_onEntityUpdate_10.set("static", false);
        reflect_EntityLiving_method_onEntityUpdate_10.set("argnames", new String[]{});
        reflect_EntityLiving_method_onEntityUpdate_10.set("argtypes", new String[]{});
        reflect_EntityLiving_method_onEntityUpdate_10.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLiving) params.getReflective("_self")).onEntityUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLiving_methods.add(reflect_EntityLiving_method_onEntityUpdate_10);


        BaseData reflect_EntityLiving_method_spawnExplosionParticle_11 = new ModData();
        reflect_EntityLiving_method_spawnExplosionParticle_11.set("methodName", "spawnExplosionParticle");
        reflect_EntityLiving_method_spawnExplosionParticle_11.set("returnType", "void");
        reflect_EntityLiving_method_spawnExplosionParticle_11.set("static", false);
        reflect_EntityLiving_method_spawnExplosionParticle_11.set("argnames", new String[]{});
        reflect_EntityLiving_method_spawnExplosionParticle_11.set("argtypes", new String[]{});
        reflect_EntityLiving_method_spawnExplosionParticle_11.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLiving) params.getReflective("_self")).spawnExplosionParticle();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLiving_methods.add(reflect_EntityLiving_method_spawnExplosionParticle_11);


        BaseData reflect_EntityLiving_method_handleStatusUpdate_12 = new ModData();
        reflect_EntityLiving_method_handleStatusUpdate_12.set("methodName", "handleStatusUpdate");
        reflect_EntityLiving_method_handleStatusUpdate_12.set("returnType", "void");
        reflect_EntityLiving_method_handleStatusUpdate_12.set("static", false);
        reflect_EntityLiving_method_handleStatusUpdate_12.set("argnames", new String[]{"b0"});
        reflect_EntityLiving_method_handleStatusUpdate_12.set("argtypes", new String[]{"byte"});
        reflect_EntityLiving_method_handleStatusUpdate_12.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLiving) params.getReflective("_self")).handleStatusUpdate((byte) params.getByte("b0"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLiving_methods.add(reflect_EntityLiving_method_handleStatusUpdate_12);


        BaseData reflect_EntityLiving_method_onUpdate_13 = new ModData();
        reflect_EntityLiving_method_onUpdate_13.set("methodName", "onUpdate");
        reflect_EntityLiving_method_onUpdate_13.set("returnType", "void");
        reflect_EntityLiving_method_onUpdate_13.set("static", false);
        reflect_EntityLiving_method_onUpdate_13.set("argnames", new String[]{});
        reflect_EntityLiving_method_onUpdate_13.set("argtypes", new String[]{});
        reflect_EntityLiving_method_onUpdate_13.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLiving) params.getReflective("_self")).onUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLiving_methods.add(reflect_EntityLiving_method_onUpdate_13);


        BaseData reflect_EntityLiving_method_writeEntityToNBT_14 = new ModData();
        reflect_EntityLiving_method_writeEntityToNBT_14.set("methodName", "writeEntityToNBT");
        reflect_EntityLiving_method_writeEntityToNBT_14.set("returnType", "void");
        reflect_EntityLiving_method_writeEntityToNBT_14.set("static", false);
        reflect_EntityLiving_method_writeEntityToNBT_14.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityLiving_method_writeEntityToNBT_14.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityLiving_method_writeEntityToNBT_14.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLiving) params.getReflective("_self")).writeEntityToNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLiving_methods.add(reflect_EntityLiving_method_writeEntityToNBT_14);


        BaseData reflect_EntityLiving_method_readEntityFromNBT_15 = new ModData();
        reflect_EntityLiving_method_readEntityFromNBT_15.set("methodName", "readEntityFromNBT");
        reflect_EntityLiving_method_readEntityFromNBT_15.set("returnType", "void");
        reflect_EntityLiving_method_readEntityFromNBT_15.set("static", false);
        reflect_EntityLiving_method_readEntityFromNBT_15.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityLiving_method_readEntityFromNBT_15.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityLiving_method_readEntityFromNBT_15.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLiving) params.getReflective("_self")).readEntityFromNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLiving_methods.add(reflect_EntityLiving_method_readEntityFromNBT_15);


        BaseData reflect_EntityLiving_method_setMoveForward_16 = new ModData();
        reflect_EntityLiving_method_setMoveForward_16.set("methodName", "setMoveForward");
        reflect_EntityLiving_method_setMoveForward_16.set("returnType", "void");
        reflect_EntityLiving_method_setMoveForward_16.set("static", false);
        reflect_EntityLiving_method_setMoveForward_16.set("argnames", new String[]{"parFloat1"});
        reflect_EntityLiving_method_setMoveForward_16.set("argtypes", new String[]{"float"});
        reflect_EntityLiving_method_setMoveForward_16.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLiving) params.getReflective("_self")).setMoveForward((float) params.getFloat("parFloat1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLiving_methods.add(reflect_EntityLiving_method_setMoveForward_16);


        BaseData reflect_EntityLiving_method_setAIMoveSpeed_17 = new ModData();
        reflect_EntityLiving_method_setAIMoveSpeed_17.set("methodName", "setAIMoveSpeed");
        reflect_EntityLiving_method_setAIMoveSpeed_17.set("returnType", "void");
        reflect_EntityLiving_method_setAIMoveSpeed_17.set("static", false);
        reflect_EntityLiving_method_setAIMoveSpeed_17.set("argnames", new String[]{"f"});
        reflect_EntityLiving_method_setAIMoveSpeed_17.set("argtypes", new String[]{"float"});
        reflect_EntityLiving_method_setAIMoveSpeed_17.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLiving) params.getReflective("_self")).setAIMoveSpeed((float) params.getFloat("f"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLiving_methods.add(reflect_EntityLiving_method_setAIMoveSpeed_17);


        BaseData reflect_EntityLiving_method_onLivingUpdate_18 = new ModData();
        reflect_EntityLiving_method_onLivingUpdate_18.set("methodName", "onLivingUpdate");
        reflect_EntityLiving_method_onLivingUpdate_18.set("returnType", "void");
        reflect_EntityLiving_method_onLivingUpdate_18.set("static", false);
        reflect_EntityLiving_method_onLivingUpdate_18.set("argnames", new String[]{});
        reflect_EntityLiving_method_onLivingUpdate_18.set("argtypes", new String[]{});
        reflect_EntityLiving_method_onLivingUpdate_18.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLiving) params.getReflective("_self")).onLivingUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLiving_methods.add(reflect_EntityLiving_method_onLivingUpdate_18);


        BaseData reflect_EntityLiving_method_getVerticalFaceSpeed_19 = new ModData();
        reflect_EntityLiving_method_getVerticalFaceSpeed_19.set("methodName", "getVerticalFaceSpeed");
        reflect_EntityLiving_method_getVerticalFaceSpeed_19.set("returnType", "int");
        reflect_EntityLiving_method_getVerticalFaceSpeed_19.set("static", false);
        reflect_EntityLiving_method_getVerticalFaceSpeed_19.set("argnames", new String[]{});
        reflect_EntityLiving_method_getVerticalFaceSpeed_19.set("argtypes", new String[]{});
        reflect_EntityLiving_method_getVerticalFaceSpeed_19.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityLiving) params.getReflective("_self")).getVerticalFaceSpeed();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityLiving_methods.add(reflect_EntityLiving_method_getVerticalFaceSpeed_19);


        BaseData reflect_EntityLiving_method_faceEntity_20 = new ModData();
        reflect_EntityLiving_method_faceEntity_20.set("methodName", "faceEntity");
        reflect_EntityLiving_method_faceEntity_20.set("returnType", "void");
        reflect_EntityLiving_method_faceEntity_20.set("static", false);
        reflect_EntityLiving_method_faceEntity_20.set("argnames", new String[]{"entityIn", "parFloat1", "parFloat2"});
        reflect_EntityLiving_method_faceEntity_20.set("argtypes", new String[]{"Entity", "float", "float"});
        reflect_EntityLiving_method_faceEntity_20.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLiving) params.getReflective("_self")).faceEntity((Entity) params.getReflective("entityIn"), (float) params.getFloat("parFloat1"), (float) params.getFloat("parFloat2"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLiving_methods.add(reflect_EntityLiving_method_faceEntity_20);


        BaseData reflect_EntityLiving_method_getCanSpawnHere_21 = new ModData();
        reflect_EntityLiving_method_getCanSpawnHere_21.set("methodName", "getCanSpawnHere");
        reflect_EntityLiving_method_getCanSpawnHere_21.set("returnType", "boolean");
        reflect_EntityLiving_method_getCanSpawnHere_21.set("static", false);
        reflect_EntityLiving_method_getCanSpawnHere_21.set("argnames", new String[]{});
        reflect_EntityLiving_method_getCanSpawnHere_21.set("argtypes", new String[]{});
        reflect_EntityLiving_method_getCanSpawnHere_21.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityLiving) params.getReflective("_self")).getCanSpawnHere();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityLiving_methods.add(reflect_EntityLiving_method_getCanSpawnHere_21);


        BaseData reflect_EntityLiving_method_isNotColliding_22 = new ModData();
        reflect_EntityLiving_method_isNotColliding_22.set("methodName", "isNotColliding");
        reflect_EntityLiving_method_isNotColliding_22.set("returnType", "boolean");
        reflect_EntityLiving_method_isNotColliding_22.set("static", false);
        reflect_EntityLiving_method_isNotColliding_22.set("argnames", new String[]{});
        reflect_EntityLiving_method_isNotColliding_22.set("argtypes", new String[]{});
        reflect_EntityLiving_method_isNotColliding_22.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityLiving) params.getReflective("_self")).isNotColliding();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityLiving_methods.add(reflect_EntityLiving_method_isNotColliding_22);


        BaseData reflect_EntityLiving_method_getRenderSizeModifier_23 = new ModData();
        reflect_EntityLiving_method_getRenderSizeModifier_23.set("methodName", "getRenderSizeModifier");
        reflect_EntityLiving_method_getRenderSizeModifier_23.set("returnType", "float");
        reflect_EntityLiving_method_getRenderSizeModifier_23.set("static", false);
        reflect_EntityLiving_method_getRenderSizeModifier_23.set("argnames", new String[]{});
        reflect_EntityLiving_method_getRenderSizeModifier_23.set("argtypes", new String[]{});
        reflect_EntityLiving_method_getRenderSizeModifier_23.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityLiving) params.getReflective("_self")).getRenderSizeModifier();
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityLiving_methods.add(reflect_EntityLiving_method_getRenderSizeModifier_23);


        BaseData reflect_EntityLiving_method_getMaxSpawnedInChunk_24 = new ModData();
        reflect_EntityLiving_method_getMaxSpawnedInChunk_24.set("methodName", "getMaxSpawnedInChunk");
        reflect_EntityLiving_method_getMaxSpawnedInChunk_24.set("returnType", "int");
        reflect_EntityLiving_method_getMaxSpawnedInChunk_24.set("static", false);
        reflect_EntityLiving_method_getMaxSpawnedInChunk_24.set("argnames", new String[]{});
        reflect_EntityLiving_method_getMaxSpawnedInChunk_24.set("argtypes", new String[]{});
        reflect_EntityLiving_method_getMaxSpawnedInChunk_24.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityLiving) params.getReflective("_self")).getMaxSpawnedInChunk();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityLiving_methods.add(reflect_EntityLiving_method_getMaxSpawnedInChunk_24);


        BaseData reflect_EntityLiving_method_getMaxFallHeight_25 = new ModData();
        reflect_EntityLiving_method_getMaxFallHeight_25.set("methodName", "getMaxFallHeight");
        reflect_EntityLiving_method_getMaxFallHeight_25.set("returnType", "int");
        reflect_EntityLiving_method_getMaxFallHeight_25.set("static", false);
        reflect_EntityLiving_method_getMaxFallHeight_25.set("argnames", new String[]{});
        reflect_EntityLiving_method_getMaxFallHeight_25.set("argtypes", new String[]{});
        reflect_EntityLiving_method_getMaxFallHeight_25.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityLiving) params.getReflective("_self")).getMaxFallHeight();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityLiving_methods.add(reflect_EntityLiving_method_getMaxFallHeight_25);


        BaseData reflect_EntityLiving_method_getHeldItem_26 = new ModData();
        reflect_EntityLiving_method_getHeldItem_26.set("methodName", "getHeldItem");
        reflect_EntityLiving_method_getHeldItem_26.set("returnType", "ItemStack");
        reflect_EntityLiving_method_getHeldItem_26.set("static", false);
        reflect_EntityLiving_method_getHeldItem_26.set("argnames", new String[]{});
        reflect_EntityLiving_method_getHeldItem_26.set("argtypes", new String[]{});
        reflect_EntityLiving_method_getHeldItem_26.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (ItemStack) ((EntityLiving) params.getReflective("_self")).getHeldItem();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityLiving_methods.add(reflect_EntityLiving_method_getHeldItem_26);


        BaseData reflect_EntityLiving_method_getEquipmentInSlot_27 = new ModData();
        reflect_EntityLiving_method_getEquipmentInSlot_27.set("methodName", "getEquipmentInSlot");
        reflect_EntityLiving_method_getEquipmentInSlot_27.set("returnType", "ItemStack");
        reflect_EntityLiving_method_getEquipmentInSlot_27.set("static", false);
        reflect_EntityLiving_method_getEquipmentInSlot_27.set("argnames", new String[]{"i"});
        reflect_EntityLiving_method_getEquipmentInSlot_27.set("argtypes", new String[]{"int"});
        reflect_EntityLiving_method_getEquipmentInSlot_27.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (ItemStack) ((EntityLiving) params.getReflective("_self")).getEquipmentInSlot((int) params.getInt("i"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityLiving_methods.add(reflect_EntityLiving_method_getEquipmentInSlot_27);


        BaseData reflect_EntityLiving_method_getCurrentArmor_28 = new ModData();
        reflect_EntityLiving_method_getCurrentArmor_28.set("methodName", "getCurrentArmor");
        reflect_EntityLiving_method_getCurrentArmor_28.set("returnType", "ItemStack");
        reflect_EntityLiving_method_getCurrentArmor_28.set("static", false);
        reflect_EntityLiving_method_getCurrentArmor_28.set("argnames", new String[]{"i"});
        reflect_EntityLiving_method_getCurrentArmor_28.set("argtypes", new String[]{"int"});
        reflect_EntityLiving_method_getCurrentArmor_28.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (ItemStack) ((EntityLiving) params.getReflective("_self")).getCurrentArmor((int) params.getInt("i"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityLiving_methods.add(reflect_EntityLiving_method_getCurrentArmor_28);


        BaseData reflect_EntityLiving_method_setCurrentItemOrArmor_29 = new ModData();
        reflect_EntityLiving_method_setCurrentItemOrArmor_29.set("methodName", "setCurrentItemOrArmor");
        reflect_EntityLiving_method_setCurrentItemOrArmor_29.set("returnType", "void");
        reflect_EntityLiving_method_setCurrentItemOrArmor_29.set("static", false);
        reflect_EntityLiving_method_setCurrentItemOrArmor_29.set("argnames", new String[]{"i", "itemstack"});
        reflect_EntityLiving_method_setCurrentItemOrArmor_29.set("argtypes", new String[]{"int", "ItemStack"});
        reflect_EntityLiving_method_setCurrentItemOrArmor_29.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLiving) params.getReflective("_self")).setCurrentItemOrArmor((int) params.getInt("i"), (ItemStack) params.getReflective("itemstack"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLiving_methods.add(reflect_EntityLiving_method_setCurrentItemOrArmor_29);


        BaseData reflect_EntityLiving_method_getInventory_30 = new ModData();
        reflect_EntityLiving_method_getInventory_30.set("methodName", "getInventory");
        reflect_EntityLiving_method_getInventory_30.set("returnType", "ItemStack[]");
        reflect_EntityLiving_method_getInventory_30.set("static", false);
        reflect_EntityLiving_method_getInventory_30.set("argnames", new String[]{});
        reflect_EntityLiving_method_getInventory_30.set("argtypes", new String[]{});
        reflect_EntityLiving_method_getInventory_30.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (ItemStack[]) ((EntityLiving) params.getReflective("_self")).getInventory();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityLiving_methods.add(reflect_EntityLiving_method_getInventory_30);


        BaseData reflect_EntityLiving_method_getArmorPosition_31 = new ModData();
        reflect_EntityLiving_method_getArmorPosition_31.set("methodName", "getArmorPosition");
        reflect_EntityLiving_method_getArmorPosition_31.set("returnType", "int");
        reflect_EntityLiving_method_getArmorPosition_31.set("static", true);
        reflect_EntityLiving_method_getArmorPosition_31.set("argnames", new String[]{"stack"});
        reflect_EntityLiving_method_getArmorPosition_31.set("argtypes", new String[]{"ItemStack"});
        reflect_EntityLiving_method_getArmorPosition_31.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) EntityLiving.getArmorPosition((ItemStack) params.getReflective("stack"));
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityLiving_methods.add(reflect_EntityLiving_method_getArmorPosition_31);


        BaseData reflect_EntityLiving_method_getArmorItemForSlot_32 = new ModData();
        reflect_EntityLiving_method_getArmorItemForSlot_32.set("methodName", "getArmorItemForSlot");
        reflect_EntityLiving_method_getArmorItemForSlot_32.set("returnType", "Item");
        reflect_EntityLiving_method_getArmorItemForSlot_32.set("static", true);
        reflect_EntityLiving_method_getArmorItemForSlot_32.set("argnames", new String[]{"armorSlot", "itemTier"});
        reflect_EntityLiving_method_getArmorItemForSlot_32.set("argtypes", new String[]{"int", "int"});
        reflect_EntityLiving_method_getArmorItemForSlot_32.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Item) EntityLiving.getArmorItemForSlot((int) params.getInt("armorSlot"), (int) params.getInt("itemTier"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityLiving_methods.add(reflect_EntityLiving_method_getArmorItemForSlot_32);


        BaseData reflect_EntityLiving_method_onInitialSpawn_33 = new ModData();
        reflect_EntityLiving_method_onInitialSpawn_33.set("methodName", "onInitialSpawn");
        reflect_EntityLiving_method_onInitialSpawn_33.set("returnType", "IEntityLivingData");
        reflect_EntityLiving_method_onInitialSpawn_33.set("static", false);
        reflect_EntityLiving_method_onInitialSpawn_33.set("argnames", new String[]{"difficulty", "livingdata"});
        reflect_EntityLiving_method_onInitialSpawn_33.set("argtypes", new String[]{"DifficultyInstance", "IEntityLivingData"});
        reflect_EntityLiving_method_onInitialSpawn_33.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (IEntityLivingData) ((EntityLiving) params.getReflective("_self")).onInitialSpawn((DifficultyInstance) params.getReflective("difficulty"), (IEntityLivingData) params.getReflective("livingdata"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityLiving_methods.add(reflect_EntityLiving_method_onInitialSpawn_33);


        BaseData reflect_EntityLiving_method_canBeSteered_34 = new ModData();
        reflect_EntityLiving_method_canBeSteered_34.set("methodName", "canBeSteered");
        reflect_EntityLiving_method_canBeSteered_34.set("returnType", "boolean");
        reflect_EntityLiving_method_canBeSteered_34.set("static", false);
        reflect_EntityLiving_method_canBeSteered_34.set("argnames", new String[]{});
        reflect_EntityLiving_method_canBeSteered_34.set("argtypes", new String[]{});
        reflect_EntityLiving_method_canBeSteered_34.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityLiving) params.getReflective("_self")).canBeSteered();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityLiving_methods.add(reflect_EntityLiving_method_canBeSteered_34);


        BaseData reflect_EntityLiving_method_enablePersistence_35 = new ModData();
        reflect_EntityLiving_method_enablePersistence_35.set("methodName", "enablePersistence");
        reflect_EntityLiving_method_enablePersistence_35.set("returnType", "void");
        reflect_EntityLiving_method_enablePersistence_35.set("static", false);
        reflect_EntityLiving_method_enablePersistence_35.set("argnames", new String[]{});
        reflect_EntityLiving_method_enablePersistence_35.set("argtypes", new String[]{});
        reflect_EntityLiving_method_enablePersistence_35.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLiving) params.getReflective("_self")).enablePersistence();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLiving_methods.add(reflect_EntityLiving_method_enablePersistence_35);


        BaseData reflect_EntityLiving_method_setEquipmentDropChance_36 = new ModData();
        reflect_EntityLiving_method_setEquipmentDropChance_36.set("methodName", "setEquipmentDropChance");
        reflect_EntityLiving_method_setEquipmentDropChance_36.set("returnType", "void");
        reflect_EntityLiving_method_setEquipmentDropChance_36.set("static", false);
        reflect_EntityLiving_method_setEquipmentDropChance_36.set("argnames", new String[]{"slotIn", "chance"});
        reflect_EntityLiving_method_setEquipmentDropChance_36.set("argtypes", new String[]{"int", "float"});
        reflect_EntityLiving_method_setEquipmentDropChance_36.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLiving) params.getReflective("_self")).setEquipmentDropChance((int) params.getInt("slotIn"), (float) params.getFloat("chance"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLiving_methods.add(reflect_EntityLiving_method_setEquipmentDropChance_36);


        BaseData reflect_EntityLiving_method_canPickUpLoot_37 = new ModData();
        reflect_EntityLiving_method_canPickUpLoot_37.set("methodName", "canPickUpLoot");
        reflect_EntityLiving_method_canPickUpLoot_37.set("returnType", "boolean");
        reflect_EntityLiving_method_canPickUpLoot_37.set("static", false);
        reflect_EntityLiving_method_canPickUpLoot_37.set("argnames", new String[]{});
        reflect_EntityLiving_method_canPickUpLoot_37.set("argtypes", new String[]{});
        reflect_EntityLiving_method_canPickUpLoot_37.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityLiving) params.getReflective("_self")).canPickUpLoot();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityLiving_methods.add(reflect_EntityLiving_method_canPickUpLoot_37);


        BaseData reflect_EntityLiving_method_setCanPickUpLoot_38 = new ModData();
        reflect_EntityLiving_method_setCanPickUpLoot_38.set("methodName", "setCanPickUpLoot");
        reflect_EntityLiving_method_setCanPickUpLoot_38.set("returnType", "void");
        reflect_EntityLiving_method_setCanPickUpLoot_38.set("static", false);
        reflect_EntityLiving_method_setCanPickUpLoot_38.set("argnames", new String[]{"canPickup"});
        reflect_EntityLiving_method_setCanPickUpLoot_38.set("argtypes", new String[]{"boolean"});
        reflect_EntityLiving_method_setCanPickUpLoot_38.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLiving) params.getReflective("_self")).setCanPickUpLoot((boolean) params.getBoolean("canPickup"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLiving_methods.add(reflect_EntityLiving_method_setCanPickUpLoot_38);


        BaseData reflect_EntityLiving_method_isNoDespawnRequired_39 = new ModData();
        reflect_EntityLiving_method_isNoDespawnRequired_39.set("methodName", "isNoDespawnRequired");
        reflect_EntityLiving_method_isNoDespawnRequired_39.set("returnType", "boolean");
        reflect_EntityLiving_method_isNoDespawnRequired_39.set("static", false);
        reflect_EntityLiving_method_isNoDespawnRequired_39.set("argnames", new String[]{});
        reflect_EntityLiving_method_isNoDespawnRequired_39.set("argtypes", new String[]{});
        reflect_EntityLiving_method_isNoDespawnRequired_39.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityLiving) params.getReflective("_self")).isNoDespawnRequired();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityLiving_methods.add(reflect_EntityLiving_method_isNoDespawnRequired_39);


        BaseData reflect_EntityLiving_method_interactFirst_40 = new ModData();
        reflect_EntityLiving_method_interactFirst_40.set("methodName", "interactFirst");
        reflect_EntityLiving_method_interactFirst_40.set("returnType", "boolean");
        reflect_EntityLiving_method_interactFirst_40.set("static", false);
        reflect_EntityLiving_method_interactFirst_40.set("argnames", new String[]{"entityplayer"});
        reflect_EntityLiving_method_interactFirst_40.set("argtypes", new String[]{"EntityPlayer"});
        reflect_EntityLiving_method_interactFirst_40.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityLiving) params.getReflective("_self")).interactFirst((EntityPlayer) params.getReflective("entityplayer"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityLiving_methods.add(reflect_EntityLiving_method_interactFirst_40);


        BaseData reflect_EntityLiving_method_clearLeashed_41 = new ModData();
        reflect_EntityLiving_method_clearLeashed_41.set("methodName", "clearLeashed");
        reflect_EntityLiving_method_clearLeashed_41.set("returnType", "void");
        reflect_EntityLiving_method_clearLeashed_41.set("static", false);
        reflect_EntityLiving_method_clearLeashed_41.set("argnames", new String[]{"sendPacket", "dropLead"});
        reflect_EntityLiving_method_clearLeashed_41.set("argtypes", new String[]{"boolean", "boolean"});
        reflect_EntityLiving_method_clearLeashed_41.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLiving) params.getReflective("_self")).clearLeashed((boolean) params.getBoolean("sendPacket"), (boolean) params.getBoolean("dropLead"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLiving_methods.add(reflect_EntityLiving_method_clearLeashed_41);


        BaseData reflect_EntityLiving_method_allowLeashing_42 = new ModData();
        reflect_EntityLiving_method_allowLeashing_42.set("methodName", "allowLeashing");
        reflect_EntityLiving_method_allowLeashing_42.set("returnType", "boolean");
        reflect_EntityLiving_method_allowLeashing_42.set("static", false);
        reflect_EntityLiving_method_allowLeashing_42.set("argnames", new String[]{});
        reflect_EntityLiving_method_allowLeashing_42.set("argtypes", new String[]{});
        reflect_EntityLiving_method_allowLeashing_42.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityLiving) params.getReflective("_self")).allowLeashing();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityLiving_methods.add(reflect_EntityLiving_method_allowLeashing_42);


        BaseData reflect_EntityLiving_method_getLeashed_43 = new ModData();
        reflect_EntityLiving_method_getLeashed_43.set("methodName", "getLeashed");
        reflect_EntityLiving_method_getLeashed_43.set("returnType", "boolean");
        reflect_EntityLiving_method_getLeashed_43.set("static", false);
        reflect_EntityLiving_method_getLeashed_43.set("argnames", new String[]{});
        reflect_EntityLiving_method_getLeashed_43.set("argtypes", new String[]{});
        reflect_EntityLiving_method_getLeashed_43.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityLiving) params.getReflective("_self")).getLeashed();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityLiving_methods.add(reflect_EntityLiving_method_getLeashed_43);


        BaseData reflect_EntityLiving_method_getLeashedToEntity_44 = new ModData();
        reflect_EntityLiving_method_getLeashedToEntity_44.set("methodName", "getLeashedToEntity");
        reflect_EntityLiving_method_getLeashedToEntity_44.set("returnType", "Entity");
        reflect_EntityLiving_method_getLeashedToEntity_44.set("static", false);
        reflect_EntityLiving_method_getLeashedToEntity_44.set("argnames", new String[]{});
        reflect_EntityLiving_method_getLeashedToEntity_44.set("argtypes", new String[]{});
        reflect_EntityLiving_method_getLeashedToEntity_44.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Entity) ((EntityLiving) params.getReflective("_self")).getLeashedToEntity();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityLiving_methods.add(reflect_EntityLiving_method_getLeashedToEntity_44);


        BaseData reflect_EntityLiving_method_setLeashedToEntity_45 = new ModData();
        reflect_EntityLiving_method_setLeashedToEntity_45.set("methodName", "setLeashedToEntity");
        reflect_EntityLiving_method_setLeashedToEntity_45.set("returnType", "void");
        reflect_EntityLiving_method_setLeashedToEntity_45.set("static", false);
        reflect_EntityLiving_method_setLeashedToEntity_45.set("argnames", new String[]{"entityIn", "sendAttachNotification"});
        reflect_EntityLiving_method_setLeashedToEntity_45.set("argtypes", new String[]{"Entity", "boolean"});
        reflect_EntityLiving_method_setLeashedToEntity_45.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLiving) params.getReflective("_self")).setLeashedToEntity((Entity) params.getReflective("entityIn"), (boolean) params.getBoolean("sendAttachNotification"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLiving_methods.add(reflect_EntityLiving_method_setLeashedToEntity_45);


        BaseData reflect_EntityLiving_method_replaceItemInInventory_46 = new ModData();
        reflect_EntityLiving_method_replaceItemInInventory_46.set("methodName", "replaceItemInInventory");
        reflect_EntityLiving_method_replaceItemInInventory_46.set("returnType", "boolean");
        reflect_EntityLiving_method_replaceItemInInventory_46.set("static", false);
        reflect_EntityLiving_method_replaceItemInInventory_46.set("argnames", new String[]{"i", "itemstack"});
        reflect_EntityLiving_method_replaceItemInInventory_46.set("argtypes", new String[]{"int", "ItemStack"});
        reflect_EntityLiving_method_replaceItemInInventory_46.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityLiving) params.getReflective("_self")).replaceItemInInventory((int) params.getInt("i"), (ItemStack) params.getReflective("itemstack"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityLiving_methods.add(reflect_EntityLiving_method_replaceItemInInventory_46);


        BaseData reflect_EntityLiving_method_isServerWorld_47 = new ModData();
        reflect_EntityLiving_method_isServerWorld_47.set("methodName", "isServerWorld");
        reflect_EntityLiving_method_isServerWorld_47.set("returnType", "boolean");
        reflect_EntityLiving_method_isServerWorld_47.set("static", false);
        reflect_EntityLiving_method_isServerWorld_47.set("argnames", new String[]{});
        reflect_EntityLiving_method_isServerWorld_47.set("argtypes", new String[]{});
        reflect_EntityLiving_method_isServerWorld_47.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityLiving) params.getReflective("_self")).isServerWorld();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityLiving_methods.add(reflect_EntityLiving_method_isServerWorld_47);


        BaseData reflect_EntityLiving_method_setNoAI_48 = new ModData();
        reflect_EntityLiving_method_setNoAI_48.set("methodName", "setNoAI");
        reflect_EntityLiving_method_setNoAI_48.set("returnType", "void");
        reflect_EntityLiving_method_setNoAI_48.set("static", false);
        reflect_EntityLiving_method_setNoAI_48.set("argnames", new String[]{"disable"});
        reflect_EntityLiving_method_setNoAI_48.set("argtypes", new String[]{"boolean"});
        reflect_EntityLiving_method_setNoAI_48.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLiving) params.getReflective("_self")).setNoAI((boolean) params.getBoolean("disable"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLiving_methods.add(reflect_EntityLiving_method_setNoAI_48);


        BaseData reflect_EntityLiving_method_isAIDisabled_49 = new ModData();
        reflect_EntityLiving_method_isAIDisabled_49.set("methodName", "isAIDisabled");
        reflect_EntityLiving_method_isAIDisabled_49.set("returnType", "boolean");
        reflect_EntityLiving_method_isAIDisabled_49.set("static", false);
        reflect_EntityLiving_method_isAIDisabled_49.set("argnames", new String[]{});
        reflect_EntityLiving_method_isAIDisabled_49.set("argtypes", new String[]{});
        reflect_EntityLiving_method_isAIDisabled_49.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityLiving) params.getReflective("_self")).isAIDisabled();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityLiving_methods.add(reflect_EntityLiving_method_isAIDisabled_49);


        BaseData[] reflect_EntityLiving_methods_arr = new BaseData[reflect_EntityLiving_methods.size()];
        for (int i = 0; i < reflect_EntityLiving_methods_arr.length; i++) {
            reflect_EntityLiving_methods_arr[i] = reflect_EntityLiving_methods.get(i);
        }

        reflect_EntityLiving.set("constructors", reflect_EntityLiving_constructors_arr);
        reflect_EntityLiving.set("methods", reflect_EntityLiving_methods_arr);
        reflect_EntityLiving.set("className", "EntityLiving");
        reflect_EntityLiving.set("classId", "net.minecraft.entity.EntityLiving");
        reflect_EntityLiving.set("class", EntityLiving.class);
        reflect_EntityLiving.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityLiving;
        });
        reflectProfiles.add(reflect_EntityLiving);
    }


    //classdef for EntityLivingBase
    public static void reflect_EntityLivingBase_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityLivingBase = new ModData();

        ArrayList<BaseData> reflect_EntityLivingBase_constructors = new ArrayList<BaseData>();
        
        BaseData[] reflect_EntityLivingBase_constructors_arr = new BaseData[reflect_EntityLivingBase_constructors.size()];
        for (int i = 0; i < reflect_EntityLivingBase_constructors_arr.length; i++) {
            reflect_EntityLivingBase_constructors_arr[i] = reflect_EntityLivingBase_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityLivingBase_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityLivingBase_method_onKillCommand_0 = new ModData();
        reflect_EntityLivingBase_method_onKillCommand_0.set("methodName", "onKillCommand");
        reflect_EntityLivingBase_method_onKillCommand_0.set("returnType", "void");
        reflect_EntityLivingBase_method_onKillCommand_0.set("static", false);
        reflect_EntityLivingBase_method_onKillCommand_0.set("argnames", new String[]{});
        reflect_EntityLivingBase_method_onKillCommand_0.set("argtypes", new String[]{});
        reflect_EntityLivingBase_method_onKillCommand_0.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLivingBase) params.getReflective("_self")).onKillCommand();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_onKillCommand_0);


        BaseData reflect_EntityLivingBase_method_canBreatheUnderwater_1 = new ModData();
        reflect_EntityLivingBase_method_canBreatheUnderwater_1.set("methodName", "canBreatheUnderwater");
        reflect_EntityLivingBase_method_canBreatheUnderwater_1.set("returnType", "boolean");
        reflect_EntityLivingBase_method_canBreatheUnderwater_1.set("static", false);
        reflect_EntityLivingBase_method_canBreatheUnderwater_1.set("argnames", new String[]{});
        reflect_EntityLivingBase_method_canBreatheUnderwater_1.set("argtypes", new String[]{});
        reflect_EntityLivingBase_method_canBreatheUnderwater_1.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityLivingBase) params.getReflective("_self")).canBreatheUnderwater();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_canBreatheUnderwater_1);


        BaseData reflect_EntityLivingBase_method_onEntityUpdate_2 = new ModData();
        reflect_EntityLivingBase_method_onEntityUpdate_2.set("methodName", "onEntityUpdate");
        reflect_EntityLivingBase_method_onEntityUpdate_2.set("returnType", "void");
        reflect_EntityLivingBase_method_onEntityUpdate_2.set("static", false);
        reflect_EntityLivingBase_method_onEntityUpdate_2.set("argnames", new String[]{});
        reflect_EntityLivingBase_method_onEntityUpdate_2.set("argtypes", new String[]{});
        reflect_EntityLivingBase_method_onEntityUpdate_2.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLivingBase) params.getReflective("_self")).onEntityUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_onEntityUpdate_2);


        BaseData reflect_EntityLivingBase_method_isChild_3 = new ModData();
        reflect_EntityLivingBase_method_isChild_3.set("methodName", "isChild");
        reflect_EntityLivingBase_method_isChild_3.set("returnType", "boolean");
        reflect_EntityLivingBase_method_isChild_3.set("static", false);
        reflect_EntityLivingBase_method_isChild_3.set("argnames", new String[]{});
        reflect_EntityLivingBase_method_isChild_3.set("argtypes", new String[]{});
        reflect_EntityLivingBase_method_isChild_3.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityLivingBase) params.getReflective("_self")).isChild();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_isChild_3);


        BaseData reflect_EntityLivingBase_method_getRNG_4 = new ModData();
        reflect_EntityLivingBase_method_getRNG_4.set("methodName", "getRNG");
        reflect_EntityLivingBase_method_getRNG_4.set("returnType", "EaglercraftRandom");
        reflect_EntityLivingBase_method_getRNG_4.set("static", false);
        reflect_EntityLivingBase_method_getRNG_4.set("argnames", new String[]{});
        reflect_EntityLivingBase_method_getRNG_4.set("argtypes", new String[]{});
        reflect_EntityLivingBase_method_getRNG_4.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EaglercraftRandom) ((EntityLivingBase) params.getReflective("_self")).getRNG();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_getRNG_4);


        BaseData reflect_EntityLivingBase_method_getAITarget_5 = new ModData();
        reflect_EntityLivingBase_method_getAITarget_5.set("methodName", "getAITarget");
        reflect_EntityLivingBase_method_getAITarget_5.set("returnType", "EntityLivingBase");
        reflect_EntityLivingBase_method_getAITarget_5.set("static", false);
        reflect_EntityLivingBase_method_getAITarget_5.set("argnames", new String[]{});
        reflect_EntityLivingBase_method_getAITarget_5.set("argtypes", new String[]{});
        reflect_EntityLivingBase_method_getAITarget_5.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EntityLivingBase) ((EntityLivingBase) params.getReflective("_self")).getAITarget();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_getAITarget_5);


        BaseData reflect_EntityLivingBase_method_getRevengeTimer_6 = new ModData();
        reflect_EntityLivingBase_method_getRevengeTimer_6.set("methodName", "getRevengeTimer");
        reflect_EntityLivingBase_method_getRevengeTimer_6.set("returnType", "int");
        reflect_EntityLivingBase_method_getRevengeTimer_6.set("static", false);
        reflect_EntityLivingBase_method_getRevengeTimer_6.set("argnames", new String[]{});
        reflect_EntityLivingBase_method_getRevengeTimer_6.set("argtypes", new String[]{});
        reflect_EntityLivingBase_method_getRevengeTimer_6.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityLivingBase) params.getReflective("_self")).getRevengeTimer();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_getRevengeTimer_6);


        BaseData reflect_EntityLivingBase_method_setRevengeTarget_7 = new ModData();
        reflect_EntityLivingBase_method_setRevengeTarget_7.set("methodName", "setRevengeTarget");
        reflect_EntityLivingBase_method_setRevengeTarget_7.set("returnType", "void");
        reflect_EntityLivingBase_method_setRevengeTarget_7.set("static", false);
        reflect_EntityLivingBase_method_setRevengeTarget_7.set("argnames", new String[]{"livingBase"});
        reflect_EntityLivingBase_method_setRevengeTarget_7.set("argtypes", new String[]{"EntityLivingBase"});
        reflect_EntityLivingBase_method_setRevengeTarget_7.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLivingBase) params.getReflective("_self")).setRevengeTarget((EntityLivingBase) params.getReflective("livingBase"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_setRevengeTarget_7);


        BaseData reflect_EntityLivingBase_method_getLastAttacker_8 = new ModData();
        reflect_EntityLivingBase_method_getLastAttacker_8.set("methodName", "getLastAttacker");
        reflect_EntityLivingBase_method_getLastAttacker_8.set("returnType", "EntityLivingBase");
        reflect_EntityLivingBase_method_getLastAttacker_8.set("static", false);
        reflect_EntityLivingBase_method_getLastAttacker_8.set("argnames", new String[]{});
        reflect_EntityLivingBase_method_getLastAttacker_8.set("argtypes", new String[]{});
        reflect_EntityLivingBase_method_getLastAttacker_8.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EntityLivingBase) ((EntityLivingBase) params.getReflective("_self")).getLastAttacker();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_getLastAttacker_8);


        BaseData reflect_EntityLivingBase_method_getLastAttackerTime_9 = new ModData();
        reflect_EntityLivingBase_method_getLastAttackerTime_9.set("methodName", "getLastAttackerTime");
        reflect_EntityLivingBase_method_getLastAttackerTime_9.set("returnType", "int");
        reflect_EntityLivingBase_method_getLastAttackerTime_9.set("static", false);
        reflect_EntityLivingBase_method_getLastAttackerTime_9.set("argnames", new String[]{});
        reflect_EntityLivingBase_method_getLastAttackerTime_9.set("argtypes", new String[]{});
        reflect_EntityLivingBase_method_getLastAttackerTime_9.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityLivingBase) params.getReflective("_self")).getLastAttackerTime();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_getLastAttackerTime_9);


        BaseData reflect_EntityLivingBase_method_setLastAttacker_10 = new ModData();
        reflect_EntityLivingBase_method_setLastAttacker_10.set("methodName", "setLastAttacker");
        reflect_EntityLivingBase_method_setLastAttacker_10.set("returnType", "void");
        reflect_EntityLivingBase_method_setLastAttacker_10.set("static", false);
        reflect_EntityLivingBase_method_setLastAttacker_10.set("argnames", new String[]{"entityIn"});
        reflect_EntityLivingBase_method_setLastAttacker_10.set("argtypes", new String[]{"Entity"});
        reflect_EntityLivingBase_method_setLastAttacker_10.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLivingBase) params.getReflective("_self")).setLastAttacker((Entity) params.getReflective("entityIn"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_setLastAttacker_10);


        BaseData reflect_EntityLivingBase_method_getAge_11 = new ModData();
        reflect_EntityLivingBase_method_getAge_11.set("methodName", "getAge");
        reflect_EntityLivingBase_method_getAge_11.set("returnType", "int");
        reflect_EntityLivingBase_method_getAge_11.set("static", false);
        reflect_EntityLivingBase_method_getAge_11.set("argnames", new String[]{});
        reflect_EntityLivingBase_method_getAge_11.set("argtypes", new String[]{});
        reflect_EntityLivingBase_method_getAge_11.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityLivingBase) params.getReflective("_self")).getAge();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_getAge_11);


        BaseData reflect_EntityLivingBase_method_writeEntityToNBT_12 = new ModData();
        reflect_EntityLivingBase_method_writeEntityToNBT_12.set("methodName", "writeEntityToNBT");
        reflect_EntityLivingBase_method_writeEntityToNBT_12.set("returnType", "void");
        reflect_EntityLivingBase_method_writeEntityToNBT_12.set("static", false);
        reflect_EntityLivingBase_method_writeEntityToNBT_12.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityLivingBase_method_writeEntityToNBT_12.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityLivingBase_method_writeEntityToNBT_12.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLivingBase) params.getReflective("_self")).writeEntityToNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_writeEntityToNBT_12);


        BaseData reflect_EntityLivingBase_method_readEntityFromNBT_13 = new ModData();
        reflect_EntityLivingBase_method_readEntityFromNBT_13.set("methodName", "readEntityFromNBT");
        reflect_EntityLivingBase_method_readEntityFromNBT_13.set("returnType", "void");
        reflect_EntityLivingBase_method_readEntityFromNBT_13.set("static", false);
        reflect_EntityLivingBase_method_readEntityFromNBT_13.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityLivingBase_method_readEntityFromNBT_13.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityLivingBase_method_readEntityFromNBT_13.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLivingBase) params.getReflective("_self")).readEntityFromNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_readEntityFromNBT_13);


        BaseData reflect_EntityLivingBase_method_clearActivePotions_14 = new ModData();
        reflect_EntityLivingBase_method_clearActivePotions_14.set("methodName", "clearActivePotions");
        reflect_EntityLivingBase_method_clearActivePotions_14.set("returnType", "void");
        reflect_EntityLivingBase_method_clearActivePotions_14.set("static", false);
        reflect_EntityLivingBase_method_clearActivePotions_14.set("argnames", new String[]{});
        reflect_EntityLivingBase_method_clearActivePotions_14.set("argtypes", new String[]{});
        reflect_EntityLivingBase_method_clearActivePotions_14.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLivingBase) params.getReflective("_self")).clearActivePotions();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_clearActivePotions_14);


        BaseData reflect_EntityLivingBase_method_isPotionActive_15 = new ModData();
        reflect_EntityLivingBase_method_isPotionActive_15.set("methodName", "isPotionActive");
        reflect_EntityLivingBase_method_isPotionActive_15.set("returnType", "boolean");
        reflect_EntityLivingBase_method_isPotionActive_15.set("static", false);
        reflect_EntityLivingBase_method_isPotionActive_15.set("argnames", new String[]{"potionId"});
        reflect_EntityLivingBase_method_isPotionActive_15.set("argtypes", new String[]{"int"});
        reflect_EntityLivingBase_method_isPotionActive_15.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityLivingBase) params.getReflective("_self")).isPotionActive((int) params.getInt("potionId"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_isPotionActive_15);


        BaseData reflect_EntityLivingBase_method_isPotionActive_16 = new ModData();
        reflect_EntityLivingBase_method_isPotionActive_16.set("methodName", "isPotionActive");
        reflect_EntityLivingBase_method_isPotionActive_16.set("returnType", "boolean");
        reflect_EntityLivingBase_method_isPotionActive_16.set("static", false);
        reflect_EntityLivingBase_method_isPotionActive_16.set("argnames", new String[]{"potionIn"});
        reflect_EntityLivingBase_method_isPotionActive_16.set("argtypes", new String[]{"Potion"});
        reflect_EntityLivingBase_method_isPotionActive_16.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityLivingBase) params.getReflective("_self")).isPotionActive((Potion) params.getReflective("potionIn"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_isPotionActive_16);


        BaseData reflect_EntityLivingBase_method_getActivePotionEffect_17 = new ModData();
        reflect_EntityLivingBase_method_getActivePotionEffect_17.set("methodName", "getActivePotionEffect");
        reflect_EntityLivingBase_method_getActivePotionEffect_17.set("returnType", "PotionEffect");
        reflect_EntityLivingBase_method_getActivePotionEffect_17.set("static", false);
        reflect_EntityLivingBase_method_getActivePotionEffect_17.set("argnames", new String[]{"potionIn"});
        reflect_EntityLivingBase_method_getActivePotionEffect_17.set("argtypes", new String[]{"Potion"});
        reflect_EntityLivingBase_method_getActivePotionEffect_17.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (PotionEffect) ((EntityLivingBase) params.getReflective("_self")).getActivePotionEffect((Potion) params.getReflective("potionIn"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_getActivePotionEffect_17);


        BaseData reflect_EntityLivingBase_method_addPotionEffect_18 = new ModData();
        reflect_EntityLivingBase_method_addPotionEffect_18.set("methodName", "addPotionEffect");
        reflect_EntityLivingBase_method_addPotionEffect_18.set("returnType", "void");
        reflect_EntityLivingBase_method_addPotionEffect_18.set("static", false);
        reflect_EntityLivingBase_method_addPotionEffect_18.set("argnames", new String[]{"potioneffectIn"});
        reflect_EntityLivingBase_method_addPotionEffect_18.set("argtypes", new String[]{"PotionEffect"});
        reflect_EntityLivingBase_method_addPotionEffect_18.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLivingBase) params.getReflective("_self")).addPotionEffect((PotionEffect) params.getReflective("potioneffectIn"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_addPotionEffect_18);


        BaseData reflect_EntityLivingBase_method_isPotionApplicable_19 = new ModData();
        reflect_EntityLivingBase_method_isPotionApplicable_19.set("methodName", "isPotionApplicable");
        reflect_EntityLivingBase_method_isPotionApplicable_19.set("returnType", "boolean");
        reflect_EntityLivingBase_method_isPotionApplicable_19.set("static", false);
        reflect_EntityLivingBase_method_isPotionApplicable_19.set("argnames", new String[]{"potioneffectIn"});
        reflect_EntityLivingBase_method_isPotionApplicable_19.set("argtypes", new String[]{"PotionEffect"});
        reflect_EntityLivingBase_method_isPotionApplicable_19.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityLivingBase) params.getReflective("_self")).isPotionApplicable((PotionEffect) params.getReflective("potioneffectIn"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_isPotionApplicable_19);


        BaseData reflect_EntityLivingBase_method_isEntityUndead_20 = new ModData();
        reflect_EntityLivingBase_method_isEntityUndead_20.set("methodName", "isEntityUndead");
        reflect_EntityLivingBase_method_isEntityUndead_20.set("returnType", "boolean");
        reflect_EntityLivingBase_method_isEntityUndead_20.set("static", false);
        reflect_EntityLivingBase_method_isEntityUndead_20.set("argnames", new String[]{});
        reflect_EntityLivingBase_method_isEntityUndead_20.set("argtypes", new String[]{});
        reflect_EntityLivingBase_method_isEntityUndead_20.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityLivingBase) params.getReflective("_self")).isEntityUndead();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_isEntityUndead_20);


        BaseData reflect_EntityLivingBase_method_removePotionEffectClient_21 = new ModData();
        reflect_EntityLivingBase_method_removePotionEffectClient_21.set("methodName", "removePotionEffectClient");
        reflect_EntityLivingBase_method_removePotionEffectClient_21.set("returnType", "void");
        reflect_EntityLivingBase_method_removePotionEffectClient_21.set("static", false);
        reflect_EntityLivingBase_method_removePotionEffectClient_21.set("argnames", new String[]{"potionId"});
        reflect_EntityLivingBase_method_removePotionEffectClient_21.set("argtypes", new String[]{"int"});
        reflect_EntityLivingBase_method_removePotionEffectClient_21.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLivingBase) params.getReflective("_self")).removePotionEffectClient((int) params.getInt("potionId"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_removePotionEffectClient_21);


        BaseData reflect_EntityLivingBase_method_removePotionEffect_22 = new ModData();
        reflect_EntityLivingBase_method_removePotionEffect_22.set("methodName", "removePotionEffect");
        reflect_EntityLivingBase_method_removePotionEffect_22.set("returnType", "void");
        reflect_EntityLivingBase_method_removePotionEffect_22.set("static", false);
        reflect_EntityLivingBase_method_removePotionEffect_22.set("argnames", new String[]{"potionId"});
        reflect_EntityLivingBase_method_removePotionEffect_22.set("argtypes", new String[]{"int"});
        reflect_EntityLivingBase_method_removePotionEffect_22.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLivingBase) params.getReflective("_self")).removePotionEffect((int) params.getInt("potionId"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_removePotionEffect_22);


        BaseData reflect_EntityLivingBase_method_heal_23 = new ModData();
        reflect_EntityLivingBase_method_heal_23.set("methodName", "heal");
        reflect_EntityLivingBase_method_heal_23.set("returnType", "void");
        reflect_EntityLivingBase_method_heal_23.set("static", false);
        reflect_EntityLivingBase_method_heal_23.set("argnames", new String[]{"f"});
        reflect_EntityLivingBase_method_heal_23.set("argtypes", new String[]{"float"});
        reflect_EntityLivingBase_method_heal_23.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLivingBase) params.getReflective("_self")).heal((float) params.getFloat("f"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_heal_23);


        BaseData reflect_EntityLivingBase_method_getHealth_24 = new ModData();
        reflect_EntityLivingBase_method_getHealth_24.set("methodName", "getHealth");
        reflect_EntityLivingBase_method_getHealth_24.set("returnType", "float");
        reflect_EntityLivingBase_method_getHealth_24.set("static", false);
        reflect_EntityLivingBase_method_getHealth_24.set("argnames", new String[]{});
        reflect_EntityLivingBase_method_getHealth_24.set("argtypes", new String[]{});
        reflect_EntityLivingBase_method_getHealth_24.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityLivingBase) params.getReflective("_self")).getHealth();
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_getHealth_24);


        BaseData reflect_EntityLivingBase_method_setHealth_25 = new ModData();
        reflect_EntityLivingBase_method_setHealth_25.set("methodName", "setHealth");
        reflect_EntityLivingBase_method_setHealth_25.set("returnType", "void");
        reflect_EntityLivingBase_method_setHealth_25.set("static", false);
        reflect_EntityLivingBase_method_setHealth_25.set("argnames", new String[]{"health"});
        reflect_EntityLivingBase_method_setHealth_25.set("argtypes", new String[]{"float"});
        reflect_EntityLivingBase_method_setHealth_25.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLivingBase) params.getReflective("_self")).setHealth((float) params.getFloat("health"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_setHealth_25);


        BaseData reflect_EntityLivingBase_method_attackEntityFrom_26 = new ModData();
        reflect_EntityLivingBase_method_attackEntityFrom_26.set("methodName", "attackEntityFrom");
        reflect_EntityLivingBase_method_attackEntityFrom_26.set("returnType", "boolean");
        reflect_EntityLivingBase_method_attackEntityFrom_26.set("static", false);
        reflect_EntityLivingBase_method_attackEntityFrom_26.set("argnames", new String[]{"damagesource", "f"});
        reflect_EntityLivingBase_method_attackEntityFrom_26.set("argtypes", new String[]{"DamageSource", "float"});
        reflect_EntityLivingBase_method_attackEntityFrom_26.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityLivingBase) params.getReflective("_self")).attackEntityFrom((DamageSource) params.getReflective("damagesource"), (float) params.getFloat("f"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_attackEntityFrom_26);


        BaseData reflect_EntityLivingBase_method_renderBrokenItemStack_27 = new ModData();
        reflect_EntityLivingBase_method_renderBrokenItemStack_27.set("methodName", "renderBrokenItemStack");
        reflect_EntityLivingBase_method_renderBrokenItemStack_27.set("returnType", "void");
        reflect_EntityLivingBase_method_renderBrokenItemStack_27.set("static", false);
        reflect_EntityLivingBase_method_renderBrokenItemStack_27.set("argnames", new String[]{"stack"});
        reflect_EntityLivingBase_method_renderBrokenItemStack_27.set("argtypes", new String[]{"ItemStack"});
        reflect_EntityLivingBase_method_renderBrokenItemStack_27.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLivingBase) params.getReflective("_self")).renderBrokenItemStack((ItemStack) params.getReflective("stack"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_renderBrokenItemStack_27);


        BaseData reflect_EntityLivingBase_method_onDeath_28 = new ModData();
        reflect_EntityLivingBase_method_onDeath_28.set("methodName", "onDeath");
        reflect_EntityLivingBase_method_onDeath_28.set("returnType", "void");
        reflect_EntityLivingBase_method_onDeath_28.set("static", false);
        reflect_EntityLivingBase_method_onDeath_28.set("argnames", new String[]{"damagesource"});
        reflect_EntityLivingBase_method_onDeath_28.set("argtypes", new String[]{"DamageSource"});
        reflect_EntityLivingBase_method_onDeath_28.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLivingBase) params.getReflective("_self")).onDeath((DamageSource) params.getReflective("damagesource"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_onDeath_28);


        BaseData reflect_EntityLivingBase_method_knockBack_29 = new ModData();
        reflect_EntityLivingBase_method_knockBack_29.set("methodName", "knockBack");
        reflect_EntityLivingBase_method_knockBack_29.set("returnType", "void");
        reflect_EntityLivingBase_method_knockBack_29.set("static", false);
        reflect_EntityLivingBase_method_knockBack_29.set("argnames", new String[]{"entityIn", "parFloat1", "parDouble1", "parDouble2"});
        reflect_EntityLivingBase_method_knockBack_29.set("argtypes", new String[]{"Entity", "float", "double", "double"});
        reflect_EntityLivingBase_method_knockBack_29.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLivingBase) params.getReflective("_self")).knockBack((Entity) params.getReflective("entityIn"), (float) params.getFloat("parFloat1"), (double) params.getDouble("parDouble1"), (double) params.getDouble("parDouble2"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_knockBack_29);


        BaseData reflect_EntityLivingBase_method_isOnLadder_30 = new ModData();
        reflect_EntityLivingBase_method_isOnLadder_30.set("methodName", "isOnLadder");
        reflect_EntityLivingBase_method_isOnLadder_30.set("returnType", "boolean");
        reflect_EntityLivingBase_method_isOnLadder_30.set("static", false);
        reflect_EntityLivingBase_method_isOnLadder_30.set("argnames", new String[]{});
        reflect_EntityLivingBase_method_isOnLadder_30.set("argtypes", new String[]{});
        reflect_EntityLivingBase_method_isOnLadder_30.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityLivingBase) params.getReflective("_self")).isOnLadder();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_isOnLadder_30);


        BaseData reflect_EntityLivingBase_method_isEntityAlive_31 = new ModData();
        reflect_EntityLivingBase_method_isEntityAlive_31.set("methodName", "isEntityAlive");
        reflect_EntityLivingBase_method_isEntityAlive_31.set("returnType", "boolean");
        reflect_EntityLivingBase_method_isEntityAlive_31.set("static", false);
        reflect_EntityLivingBase_method_isEntityAlive_31.set("argnames", new String[]{});
        reflect_EntityLivingBase_method_isEntityAlive_31.set("argtypes", new String[]{});
        reflect_EntityLivingBase_method_isEntityAlive_31.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityLivingBase) params.getReflective("_self")).isEntityAlive();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_isEntityAlive_31);


        BaseData reflect_EntityLivingBase_method_fall_32 = new ModData();
        reflect_EntityLivingBase_method_fall_32.set("methodName", "fall");
        reflect_EntityLivingBase_method_fall_32.set("returnType", "void");
        reflect_EntityLivingBase_method_fall_32.set("static", false);
        reflect_EntityLivingBase_method_fall_32.set("argnames", new String[]{"f", "f1"});
        reflect_EntityLivingBase_method_fall_32.set("argtypes", new String[]{"float", "float"});
        reflect_EntityLivingBase_method_fall_32.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLivingBase) params.getReflective("_self")).fall((float) params.getFloat("f"), (float) params.getFloat("f1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_fall_32);


        BaseData reflect_EntityLivingBase_method_performHurtAnimation_33 = new ModData();
        reflect_EntityLivingBase_method_performHurtAnimation_33.set("methodName", "performHurtAnimation");
        reflect_EntityLivingBase_method_performHurtAnimation_33.set("returnType", "void");
        reflect_EntityLivingBase_method_performHurtAnimation_33.set("static", false);
        reflect_EntityLivingBase_method_performHurtAnimation_33.set("argnames", new String[]{});
        reflect_EntityLivingBase_method_performHurtAnimation_33.set("argtypes", new String[]{});
        reflect_EntityLivingBase_method_performHurtAnimation_33.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLivingBase) params.getReflective("_self")).performHurtAnimation();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_performHurtAnimation_33);


        BaseData reflect_EntityLivingBase_method_getTotalArmorValue_34 = new ModData();
        reflect_EntityLivingBase_method_getTotalArmorValue_34.set("methodName", "getTotalArmorValue");
        reflect_EntityLivingBase_method_getTotalArmorValue_34.set("returnType", "int");
        reflect_EntityLivingBase_method_getTotalArmorValue_34.set("static", false);
        reflect_EntityLivingBase_method_getTotalArmorValue_34.set("argnames", new String[]{});
        reflect_EntityLivingBase_method_getTotalArmorValue_34.set("argtypes", new String[]{});
        reflect_EntityLivingBase_method_getTotalArmorValue_34.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityLivingBase) params.getReflective("_self")).getTotalArmorValue();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_getTotalArmorValue_34);


        BaseData reflect_EntityLivingBase_method_getCombatTracker_35 = new ModData();
        reflect_EntityLivingBase_method_getCombatTracker_35.set("methodName", "getCombatTracker");
        reflect_EntityLivingBase_method_getCombatTracker_35.set("returnType", "CombatTracker");
        reflect_EntityLivingBase_method_getCombatTracker_35.set("static", false);
        reflect_EntityLivingBase_method_getCombatTracker_35.set("argnames", new String[]{});
        reflect_EntityLivingBase_method_getCombatTracker_35.set("argtypes", new String[]{});
        reflect_EntityLivingBase_method_getCombatTracker_35.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (CombatTracker) ((EntityLivingBase) params.getReflective("_self")).getCombatTracker();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_getCombatTracker_35);


        BaseData reflect_EntityLivingBase_method_func_94060_bK_36 = new ModData();
        reflect_EntityLivingBase_method_func_94060_bK_36.set("methodName", "func_94060_bK");
        reflect_EntityLivingBase_method_func_94060_bK_36.set("returnType", "EntityLivingBase");
        reflect_EntityLivingBase_method_func_94060_bK_36.set("static", false);
        reflect_EntityLivingBase_method_func_94060_bK_36.set("argnames", new String[]{});
        reflect_EntityLivingBase_method_func_94060_bK_36.set("argtypes", new String[]{});
        reflect_EntityLivingBase_method_func_94060_bK_36.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EntityLivingBase) ((EntityLivingBase) params.getReflective("_self")).func_94060_bK();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_func_94060_bK_36);


        BaseData reflect_EntityLivingBase_method_getMaxHealth_37 = new ModData();
        reflect_EntityLivingBase_method_getMaxHealth_37.set("methodName", "getMaxHealth");
        reflect_EntityLivingBase_method_getMaxHealth_37.set("returnType", "float");
        reflect_EntityLivingBase_method_getMaxHealth_37.set("static", false);
        reflect_EntityLivingBase_method_getMaxHealth_37.set("argnames", new String[]{});
        reflect_EntityLivingBase_method_getMaxHealth_37.set("argtypes", new String[]{});
        reflect_EntityLivingBase_method_getMaxHealth_37.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityLivingBase) params.getReflective("_self")).getMaxHealth();
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_getMaxHealth_37);


        BaseData reflect_EntityLivingBase_method_getArrowCountInEntity_38 = new ModData();
        reflect_EntityLivingBase_method_getArrowCountInEntity_38.set("methodName", "getArrowCountInEntity");
        reflect_EntityLivingBase_method_getArrowCountInEntity_38.set("returnType", "int");
        reflect_EntityLivingBase_method_getArrowCountInEntity_38.set("static", false);
        reflect_EntityLivingBase_method_getArrowCountInEntity_38.set("argnames", new String[]{});
        reflect_EntityLivingBase_method_getArrowCountInEntity_38.set("argtypes", new String[]{});
        reflect_EntityLivingBase_method_getArrowCountInEntity_38.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityLivingBase) params.getReflective("_self")).getArrowCountInEntity();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_getArrowCountInEntity_38);


        BaseData reflect_EntityLivingBase_method_setArrowCountInEntity_39 = new ModData();
        reflect_EntityLivingBase_method_setArrowCountInEntity_39.set("methodName", "setArrowCountInEntity");
        reflect_EntityLivingBase_method_setArrowCountInEntity_39.set("returnType", "void");
        reflect_EntityLivingBase_method_setArrowCountInEntity_39.set("static", false);
        reflect_EntityLivingBase_method_setArrowCountInEntity_39.set("argnames", new String[]{"count"});
        reflect_EntityLivingBase_method_setArrowCountInEntity_39.set("argtypes", new String[]{"int"});
        reflect_EntityLivingBase_method_setArrowCountInEntity_39.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLivingBase) params.getReflective("_self")).setArrowCountInEntity((int) params.getInt("count"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_setArrowCountInEntity_39);


        BaseData reflect_EntityLivingBase_method_swingItem_40 = new ModData();
        reflect_EntityLivingBase_method_swingItem_40.set("methodName", "swingItem");
        reflect_EntityLivingBase_method_swingItem_40.set("returnType", "void");
        reflect_EntityLivingBase_method_swingItem_40.set("static", false);
        reflect_EntityLivingBase_method_swingItem_40.set("argnames", new String[]{});
        reflect_EntityLivingBase_method_swingItem_40.set("argtypes", new String[]{});
        reflect_EntityLivingBase_method_swingItem_40.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLivingBase) params.getReflective("_self")).swingItem();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_swingItem_40);


        BaseData reflect_EntityLivingBase_method_handleStatusUpdate_41 = new ModData();
        reflect_EntityLivingBase_method_handleStatusUpdate_41.set("methodName", "handleStatusUpdate");
        reflect_EntityLivingBase_method_handleStatusUpdate_41.set("returnType", "void");
        reflect_EntityLivingBase_method_handleStatusUpdate_41.set("static", false);
        reflect_EntityLivingBase_method_handleStatusUpdate_41.set("argnames", new String[]{"b0"});
        reflect_EntityLivingBase_method_handleStatusUpdate_41.set("argtypes", new String[]{"byte"});
        reflect_EntityLivingBase_method_handleStatusUpdate_41.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLivingBase) params.getReflective("_self")).handleStatusUpdate((byte) params.getByte("b0"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_handleStatusUpdate_41);


        BaseData reflect_EntityLivingBase_method_getEntityAttribute_42 = new ModData();
        reflect_EntityLivingBase_method_getEntityAttribute_42.set("methodName", "getEntityAttribute");
        reflect_EntityLivingBase_method_getEntityAttribute_42.set("returnType", "IAttributeInstance");
        reflect_EntityLivingBase_method_getEntityAttribute_42.set("static", false);
        reflect_EntityLivingBase_method_getEntityAttribute_42.set("argnames", new String[]{"attribute"});
        reflect_EntityLivingBase_method_getEntityAttribute_42.set("argtypes", new String[]{"IAttribute"});
        reflect_EntityLivingBase_method_getEntityAttribute_42.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (IAttributeInstance) ((EntityLivingBase) params.getReflective("_self")).getEntityAttribute((IAttribute) params.getReflective("attribute"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_getEntityAttribute_42);


        BaseData reflect_EntityLivingBase_method_getAttributeMap_43 = new ModData();
        reflect_EntityLivingBase_method_getAttributeMap_43.set("methodName", "getAttributeMap");
        reflect_EntityLivingBase_method_getAttributeMap_43.set("returnType", "BaseAttributeMap");
        reflect_EntityLivingBase_method_getAttributeMap_43.set("static", false);
        reflect_EntityLivingBase_method_getAttributeMap_43.set("argnames", new String[]{});
        reflect_EntityLivingBase_method_getAttributeMap_43.set("argtypes", new String[]{});
        reflect_EntityLivingBase_method_getAttributeMap_43.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (BaseAttributeMap) ((EntityLivingBase) params.getReflective("_self")).getAttributeMap();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_getAttributeMap_43);


        BaseData reflect_EntityLivingBase_method_getCreatureAttribute_44 = new ModData();
        reflect_EntityLivingBase_method_getCreatureAttribute_44.set("methodName", "getCreatureAttribute");
        reflect_EntityLivingBase_method_getCreatureAttribute_44.set("returnType", "EnumCreatureAttribute");
        reflect_EntityLivingBase_method_getCreatureAttribute_44.set("static", false);
        reflect_EntityLivingBase_method_getCreatureAttribute_44.set("argnames", new String[]{});
        reflect_EntityLivingBase_method_getCreatureAttribute_44.set("argtypes", new String[]{});
        reflect_EntityLivingBase_method_getCreatureAttribute_44.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EnumCreatureAttribute) ((EntityLivingBase) params.getReflective("_self")).getCreatureAttribute();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_getCreatureAttribute_44);


        BaseData reflect_EntityLivingBase_method_setSprinting_45 = new ModData();
        reflect_EntityLivingBase_method_setSprinting_45.set("methodName", "setSprinting");
        reflect_EntityLivingBase_method_setSprinting_45.set("returnType", "void");
        reflect_EntityLivingBase_method_setSprinting_45.set("static", false);
        reflect_EntityLivingBase_method_setSprinting_45.set("argnames", new String[]{"flag"});
        reflect_EntityLivingBase_method_setSprinting_45.set("argtypes", new String[]{"boolean"});
        reflect_EntityLivingBase_method_setSprinting_45.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLivingBase) params.getReflective("_self")).setSprinting((boolean) params.getBoolean("flag"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_setSprinting_45);


        BaseData reflect_EntityLivingBase_method_dismountEntity_46 = new ModData();
        reflect_EntityLivingBase_method_dismountEntity_46.set("methodName", "dismountEntity");
        reflect_EntityLivingBase_method_dismountEntity_46.set("returnType", "void");
        reflect_EntityLivingBase_method_dismountEntity_46.set("static", false);
        reflect_EntityLivingBase_method_dismountEntity_46.set("argnames", new String[]{"parEntity"});
        reflect_EntityLivingBase_method_dismountEntity_46.set("argtypes", new String[]{"Entity"});
        reflect_EntityLivingBase_method_dismountEntity_46.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLivingBase) params.getReflective("_self")).dismountEntity((Entity) params.getReflective("parEntity"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_dismountEntity_46);


        BaseData reflect_EntityLivingBase_method_getAlwaysRenderNameTagForRender_47 = new ModData();
        reflect_EntityLivingBase_method_getAlwaysRenderNameTagForRender_47.set("methodName", "getAlwaysRenderNameTagForRender");
        reflect_EntityLivingBase_method_getAlwaysRenderNameTagForRender_47.set("returnType", "boolean");
        reflect_EntityLivingBase_method_getAlwaysRenderNameTagForRender_47.set("static", false);
        reflect_EntityLivingBase_method_getAlwaysRenderNameTagForRender_47.set("argnames", new String[]{});
        reflect_EntityLivingBase_method_getAlwaysRenderNameTagForRender_47.set("argtypes", new String[]{});
        reflect_EntityLivingBase_method_getAlwaysRenderNameTagForRender_47.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityLivingBase) params.getReflective("_self")).getAlwaysRenderNameTagForRender();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_getAlwaysRenderNameTagForRender_47);


        BaseData reflect_EntityLivingBase_method_moveEntityWithHeading_48 = new ModData();
        reflect_EntityLivingBase_method_moveEntityWithHeading_48.set("methodName", "moveEntityWithHeading");
        reflect_EntityLivingBase_method_moveEntityWithHeading_48.set("returnType", "void");
        reflect_EntityLivingBase_method_moveEntityWithHeading_48.set("static", false);
        reflect_EntityLivingBase_method_moveEntityWithHeading_48.set("argnames", new String[]{"f", "f1"});
        reflect_EntityLivingBase_method_moveEntityWithHeading_48.set("argtypes", new String[]{"float", "float"});
        reflect_EntityLivingBase_method_moveEntityWithHeading_48.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLivingBase) params.getReflective("_self")).moveEntityWithHeading((float) params.getFloat("f"), (float) params.getFloat("f1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_moveEntityWithHeading_48);


        BaseData reflect_EntityLivingBase_method_getAIMoveSpeed_49 = new ModData();
        reflect_EntityLivingBase_method_getAIMoveSpeed_49.set("methodName", "getAIMoveSpeed");
        reflect_EntityLivingBase_method_getAIMoveSpeed_49.set("returnType", "float");
        reflect_EntityLivingBase_method_getAIMoveSpeed_49.set("static", false);
        reflect_EntityLivingBase_method_getAIMoveSpeed_49.set("argnames", new String[]{});
        reflect_EntityLivingBase_method_getAIMoveSpeed_49.set("argtypes", new String[]{});
        reflect_EntityLivingBase_method_getAIMoveSpeed_49.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityLivingBase) params.getReflective("_self")).getAIMoveSpeed();
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_getAIMoveSpeed_49);


        BaseData reflect_EntityLivingBase_method_setAIMoveSpeed_50 = new ModData();
        reflect_EntityLivingBase_method_setAIMoveSpeed_50.set("methodName", "setAIMoveSpeed");
        reflect_EntityLivingBase_method_setAIMoveSpeed_50.set("returnType", "void");
        reflect_EntityLivingBase_method_setAIMoveSpeed_50.set("static", false);
        reflect_EntityLivingBase_method_setAIMoveSpeed_50.set("argnames", new String[]{"speedIn"});
        reflect_EntityLivingBase_method_setAIMoveSpeed_50.set("argtypes", new String[]{"float"});
        reflect_EntityLivingBase_method_setAIMoveSpeed_50.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLivingBase) params.getReflective("_self")).setAIMoveSpeed((float) params.getFloat("speedIn"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_setAIMoveSpeed_50);


        BaseData reflect_EntityLivingBase_method_attackEntityAsMob_51 = new ModData();
        reflect_EntityLivingBase_method_attackEntityAsMob_51.set("methodName", "attackEntityAsMob");
        reflect_EntityLivingBase_method_attackEntityAsMob_51.set("returnType", "boolean");
        reflect_EntityLivingBase_method_attackEntityAsMob_51.set("static", false);
        reflect_EntityLivingBase_method_attackEntityAsMob_51.set("argnames", new String[]{"entityIn"});
        reflect_EntityLivingBase_method_attackEntityAsMob_51.set("argtypes", new String[]{"Entity"});
        reflect_EntityLivingBase_method_attackEntityAsMob_51.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityLivingBase) params.getReflective("_self")).attackEntityAsMob((Entity) params.getReflective("entityIn"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_attackEntityAsMob_51);


        BaseData reflect_EntityLivingBase_method_isPlayerSleeping_52 = new ModData();
        reflect_EntityLivingBase_method_isPlayerSleeping_52.set("methodName", "isPlayerSleeping");
        reflect_EntityLivingBase_method_isPlayerSleeping_52.set("returnType", "boolean");
        reflect_EntityLivingBase_method_isPlayerSleeping_52.set("static", false);
        reflect_EntityLivingBase_method_isPlayerSleeping_52.set("argnames", new String[]{});
        reflect_EntityLivingBase_method_isPlayerSleeping_52.set("argtypes", new String[]{});
        reflect_EntityLivingBase_method_isPlayerSleeping_52.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityLivingBase) params.getReflective("_self")).isPlayerSleeping();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_isPlayerSleeping_52);


        BaseData reflect_EntityLivingBase_method_onUpdate_53 = new ModData();
        reflect_EntityLivingBase_method_onUpdate_53.set("methodName", "onUpdate");
        reflect_EntityLivingBase_method_onUpdate_53.set("returnType", "void");
        reflect_EntityLivingBase_method_onUpdate_53.set("static", false);
        reflect_EntityLivingBase_method_onUpdate_53.set("argnames", new String[]{});
        reflect_EntityLivingBase_method_onUpdate_53.set("argtypes", new String[]{});
        reflect_EntityLivingBase_method_onUpdate_53.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLivingBase) params.getReflective("_self")).onUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_onUpdate_53);


        BaseData reflect_EntityLivingBase_method_onLivingUpdate_54 = new ModData();
        reflect_EntityLivingBase_method_onLivingUpdate_54.set("methodName", "onLivingUpdate");
        reflect_EntityLivingBase_method_onLivingUpdate_54.set("returnType", "void");
        reflect_EntityLivingBase_method_onLivingUpdate_54.set("static", false);
        reflect_EntityLivingBase_method_onLivingUpdate_54.set("argnames", new String[]{});
        reflect_EntityLivingBase_method_onLivingUpdate_54.set("argtypes", new String[]{});
        reflect_EntityLivingBase_method_onLivingUpdate_54.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLivingBase) params.getReflective("_self")).onLivingUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_onLivingUpdate_54);


        BaseData reflect_EntityLivingBase_method_mountEntity_55 = new ModData();
        reflect_EntityLivingBase_method_mountEntity_55.set("methodName", "mountEntity");
        reflect_EntityLivingBase_method_mountEntity_55.set("returnType", "void");
        reflect_EntityLivingBase_method_mountEntity_55.set("static", false);
        reflect_EntityLivingBase_method_mountEntity_55.set("argnames", new String[]{"entity"});
        reflect_EntityLivingBase_method_mountEntity_55.set("argtypes", new String[]{"Entity"});
        reflect_EntityLivingBase_method_mountEntity_55.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLivingBase) params.getReflective("_self")).mountEntity((Entity) params.getReflective("entity"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_mountEntity_55);


        BaseData reflect_EntityLivingBase_method_updateRidden_56 = new ModData();
        reflect_EntityLivingBase_method_updateRidden_56.set("methodName", "updateRidden");
        reflect_EntityLivingBase_method_updateRidden_56.set("returnType", "void");
        reflect_EntityLivingBase_method_updateRidden_56.set("static", false);
        reflect_EntityLivingBase_method_updateRidden_56.set("argnames", new String[]{});
        reflect_EntityLivingBase_method_updateRidden_56.set("argtypes", new String[]{});
        reflect_EntityLivingBase_method_updateRidden_56.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLivingBase) params.getReflective("_self")).updateRidden();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_updateRidden_56);


        BaseData reflect_EntityLivingBase_method_setPositionAndRotation2_57 = new ModData();
        reflect_EntityLivingBase_method_setPositionAndRotation2_57.set("methodName", "setPositionAndRotation2");
        reflect_EntityLivingBase_method_setPositionAndRotation2_57.set("returnType", "void");
        reflect_EntityLivingBase_method_setPositionAndRotation2_57.set("static", false);
        reflect_EntityLivingBase_method_setPositionAndRotation2_57.set("argnames", new String[]{"d0", "d1", "d2", "f", "f1", "i", "var10"});
        reflect_EntityLivingBase_method_setPositionAndRotation2_57.set("argtypes", new String[]{"double", "double", "double", "float", "float", "int", "boolean"});
        reflect_EntityLivingBase_method_setPositionAndRotation2_57.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLivingBase) params.getReflective("_self")).setPositionAndRotation2((double) params.getDouble("d0"), (double) params.getDouble("d1"), (double) params.getDouble("d2"), (float) params.getFloat("f"), (float) params.getFloat("f1"), (int) params.getInt("i"), (boolean) params.getBoolean("var10"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_setPositionAndRotation2_57);


        BaseData reflect_EntityLivingBase_method_setJumping_58 = new ModData();
        reflect_EntityLivingBase_method_setJumping_58.set("methodName", "setJumping");
        reflect_EntityLivingBase_method_setJumping_58.set("returnType", "void");
        reflect_EntityLivingBase_method_setJumping_58.set("static", false);
        reflect_EntityLivingBase_method_setJumping_58.set("argnames", new String[]{"parFlag"});
        reflect_EntityLivingBase_method_setJumping_58.set("argtypes", new String[]{"boolean"});
        reflect_EntityLivingBase_method_setJumping_58.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLivingBase) params.getReflective("_self")).setJumping((boolean) params.getBoolean("parFlag"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_setJumping_58);


        BaseData reflect_EntityLivingBase_method_onItemPickup_59 = new ModData();
        reflect_EntityLivingBase_method_onItemPickup_59.set("methodName", "onItemPickup");
        reflect_EntityLivingBase_method_onItemPickup_59.set("returnType", "void");
        reflect_EntityLivingBase_method_onItemPickup_59.set("static", false);
        reflect_EntityLivingBase_method_onItemPickup_59.set("argnames", new String[]{"entity", "var2"});
        reflect_EntityLivingBase_method_onItemPickup_59.set("argtypes", new String[]{"Entity", "int"});
        reflect_EntityLivingBase_method_onItemPickup_59.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLivingBase) params.getReflective("_self")).onItemPickup((Entity) params.getReflective("entity"), (int) params.getInt("var2"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_onItemPickup_59);


        BaseData reflect_EntityLivingBase_method_canEntityBeSeen_60 = new ModData();
        reflect_EntityLivingBase_method_canEntityBeSeen_60.set("methodName", "canEntityBeSeen");
        reflect_EntityLivingBase_method_canEntityBeSeen_60.set("returnType", "boolean");
        reflect_EntityLivingBase_method_canEntityBeSeen_60.set("static", false);
        reflect_EntityLivingBase_method_canEntityBeSeen_60.set("argnames", new String[]{"entityIn"});
        reflect_EntityLivingBase_method_canEntityBeSeen_60.set("argtypes", new String[]{"Entity"});
        reflect_EntityLivingBase_method_canEntityBeSeen_60.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityLivingBase) params.getReflective("_self")).canEntityBeSeen((Entity) params.getReflective("entityIn"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_canEntityBeSeen_60);


        BaseData reflect_EntityLivingBase_method_getLookVec_61 = new ModData();
        reflect_EntityLivingBase_method_getLookVec_61.set("methodName", "getLookVec");
        reflect_EntityLivingBase_method_getLookVec_61.set("returnType", "Vec3");
        reflect_EntityLivingBase_method_getLookVec_61.set("static", false);
        reflect_EntityLivingBase_method_getLookVec_61.set("argnames", new String[]{});
        reflect_EntityLivingBase_method_getLookVec_61.set("argtypes", new String[]{});
        reflect_EntityLivingBase_method_getLookVec_61.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Vec3) ((EntityLivingBase) params.getReflective("_self")).getLookVec();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_getLookVec_61);


        BaseData reflect_EntityLivingBase_method_getLook_62 = new ModData();
        reflect_EntityLivingBase_method_getLook_62.set("methodName", "getLook");
        reflect_EntityLivingBase_method_getLook_62.set("returnType", "Vec3");
        reflect_EntityLivingBase_method_getLook_62.set("static", false);
        reflect_EntityLivingBase_method_getLook_62.set("argnames", new String[]{"f"});
        reflect_EntityLivingBase_method_getLook_62.set("argtypes", new String[]{"float"});
        reflect_EntityLivingBase_method_getLook_62.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Vec3) ((EntityLivingBase) params.getReflective("_self")).getLook((float) params.getFloat("f"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_getLook_62);


        BaseData reflect_EntityLivingBase_method_getSwingProgress_63 = new ModData();
        reflect_EntityLivingBase_method_getSwingProgress_63.set("methodName", "getSwingProgress");
        reflect_EntityLivingBase_method_getSwingProgress_63.set("returnType", "float");
        reflect_EntityLivingBase_method_getSwingProgress_63.set("static", false);
        reflect_EntityLivingBase_method_getSwingProgress_63.set("argnames", new String[]{"partialTickTime"});
        reflect_EntityLivingBase_method_getSwingProgress_63.set("argtypes", new String[]{"float"});
        reflect_EntityLivingBase_method_getSwingProgress_63.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityLivingBase) params.getReflective("_self")).getSwingProgress((float) params.getFloat("partialTickTime"));
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_getSwingProgress_63);


        BaseData reflect_EntityLivingBase_method_isServerWorld_64 = new ModData();
        reflect_EntityLivingBase_method_isServerWorld_64.set("methodName", "isServerWorld");
        reflect_EntityLivingBase_method_isServerWorld_64.set("returnType", "boolean");
        reflect_EntityLivingBase_method_isServerWorld_64.set("static", false);
        reflect_EntityLivingBase_method_isServerWorld_64.set("argnames", new String[]{});
        reflect_EntityLivingBase_method_isServerWorld_64.set("argtypes", new String[]{});
        reflect_EntityLivingBase_method_isServerWorld_64.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityLivingBase) params.getReflective("_self")).isServerWorld();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_isServerWorld_64);


        BaseData reflect_EntityLivingBase_method_canBeCollidedWith_65 = new ModData();
        reflect_EntityLivingBase_method_canBeCollidedWith_65.set("methodName", "canBeCollidedWith");
        reflect_EntityLivingBase_method_canBeCollidedWith_65.set("returnType", "boolean");
        reflect_EntityLivingBase_method_canBeCollidedWith_65.set("static", false);
        reflect_EntityLivingBase_method_canBeCollidedWith_65.set("argnames", new String[]{});
        reflect_EntityLivingBase_method_canBeCollidedWith_65.set("argtypes", new String[]{});
        reflect_EntityLivingBase_method_canBeCollidedWith_65.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityLivingBase) params.getReflective("_self")).canBeCollidedWith();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_canBeCollidedWith_65);


        BaseData reflect_EntityLivingBase_method_canBePushed_66 = new ModData();
        reflect_EntityLivingBase_method_canBePushed_66.set("methodName", "canBePushed");
        reflect_EntityLivingBase_method_canBePushed_66.set("returnType", "boolean");
        reflect_EntityLivingBase_method_canBePushed_66.set("static", false);
        reflect_EntityLivingBase_method_canBePushed_66.set("argnames", new String[]{});
        reflect_EntityLivingBase_method_canBePushed_66.set("argtypes", new String[]{});
        reflect_EntityLivingBase_method_canBePushed_66.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityLivingBase) params.getReflective("_self")).canBePushed();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_canBePushed_66);


        BaseData reflect_EntityLivingBase_method_getRotationYawHead_67 = new ModData();
        reflect_EntityLivingBase_method_getRotationYawHead_67.set("methodName", "getRotationYawHead");
        reflect_EntityLivingBase_method_getRotationYawHead_67.set("returnType", "float");
        reflect_EntityLivingBase_method_getRotationYawHead_67.set("static", false);
        reflect_EntityLivingBase_method_getRotationYawHead_67.set("argnames", new String[]{});
        reflect_EntityLivingBase_method_getRotationYawHead_67.set("argtypes", new String[]{});
        reflect_EntityLivingBase_method_getRotationYawHead_67.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityLivingBase) params.getReflective("_self")).getRotationYawHead();
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_getRotationYawHead_67);


        BaseData reflect_EntityLivingBase_method_setRotationYawHead_68 = new ModData();
        reflect_EntityLivingBase_method_setRotationYawHead_68.set("methodName", "setRotationYawHead");
        reflect_EntityLivingBase_method_setRotationYawHead_68.set("returnType", "void");
        reflect_EntityLivingBase_method_setRotationYawHead_68.set("static", false);
        reflect_EntityLivingBase_method_setRotationYawHead_68.set("argnames", new String[]{"f"});
        reflect_EntityLivingBase_method_setRotationYawHead_68.set("argtypes", new String[]{"float"});
        reflect_EntityLivingBase_method_setRotationYawHead_68.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLivingBase) params.getReflective("_self")).setRotationYawHead((float) params.getFloat("f"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_setRotationYawHead_68);


        BaseData reflect_EntityLivingBase_method_func_181013_g_69 = new ModData();
        reflect_EntityLivingBase_method_func_181013_g_69.set("methodName", "func_181013_g");
        reflect_EntityLivingBase_method_func_181013_g_69.set("returnType", "void");
        reflect_EntityLivingBase_method_func_181013_g_69.set("static", false);
        reflect_EntityLivingBase_method_func_181013_g_69.set("argnames", new String[]{"f"});
        reflect_EntityLivingBase_method_func_181013_g_69.set("argtypes", new String[]{"float"});
        reflect_EntityLivingBase_method_func_181013_g_69.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLivingBase) params.getReflective("_self")).func_181013_g((float) params.getFloat("f"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_func_181013_g_69);


        BaseData reflect_EntityLivingBase_method_getAbsorptionAmount_70 = new ModData();
        reflect_EntityLivingBase_method_getAbsorptionAmount_70.set("methodName", "getAbsorptionAmount");
        reflect_EntityLivingBase_method_getAbsorptionAmount_70.set("returnType", "float");
        reflect_EntityLivingBase_method_getAbsorptionAmount_70.set("static", false);
        reflect_EntityLivingBase_method_getAbsorptionAmount_70.set("argnames", new String[]{});
        reflect_EntityLivingBase_method_getAbsorptionAmount_70.set("argtypes", new String[]{});
        reflect_EntityLivingBase_method_getAbsorptionAmount_70.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityLivingBase) params.getReflective("_self")).getAbsorptionAmount();
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_getAbsorptionAmount_70);


        BaseData reflect_EntityLivingBase_method_setAbsorptionAmount_71 = new ModData();
        reflect_EntityLivingBase_method_setAbsorptionAmount_71.set("methodName", "setAbsorptionAmount");
        reflect_EntityLivingBase_method_setAbsorptionAmount_71.set("returnType", "void");
        reflect_EntityLivingBase_method_setAbsorptionAmount_71.set("static", false);
        reflect_EntityLivingBase_method_setAbsorptionAmount_71.set("argnames", new String[]{"amount"});
        reflect_EntityLivingBase_method_setAbsorptionAmount_71.set("argtypes", new String[]{"float"});
        reflect_EntityLivingBase_method_setAbsorptionAmount_71.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLivingBase) params.getReflective("_self")).setAbsorptionAmount((float) params.getFloat("amount"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_setAbsorptionAmount_71);


        BaseData reflect_EntityLivingBase_method_getTeam_72 = new ModData();
        reflect_EntityLivingBase_method_getTeam_72.set("methodName", "getTeam");
        reflect_EntityLivingBase_method_getTeam_72.set("returnType", "Team");
        reflect_EntityLivingBase_method_getTeam_72.set("static", false);
        reflect_EntityLivingBase_method_getTeam_72.set("argnames", new String[]{});
        reflect_EntityLivingBase_method_getTeam_72.set("argtypes", new String[]{});
        reflect_EntityLivingBase_method_getTeam_72.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Team) ((EntityLivingBase) params.getReflective("_self")).getTeam();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_getTeam_72);


        BaseData reflect_EntityLivingBase_method_isOnSameTeam_73 = new ModData();
        reflect_EntityLivingBase_method_isOnSameTeam_73.set("methodName", "isOnSameTeam");
        reflect_EntityLivingBase_method_isOnSameTeam_73.set("returnType", "boolean");
        reflect_EntityLivingBase_method_isOnSameTeam_73.set("static", false);
        reflect_EntityLivingBase_method_isOnSameTeam_73.set("argnames", new String[]{"otherEntity"});
        reflect_EntityLivingBase_method_isOnSameTeam_73.set("argtypes", new String[]{"EntityLivingBase"});
        reflect_EntityLivingBase_method_isOnSameTeam_73.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityLivingBase) params.getReflective("_self")).isOnSameTeam((EntityLivingBase) params.getReflective("otherEntity"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_isOnSameTeam_73);


        BaseData reflect_EntityLivingBase_method_isOnTeam_74 = new ModData();
        reflect_EntityLivingBase_method_isOnTeam_74.set("methodName", "isOnTeam");
        reflect_EntityLivingBase_method_isOnTeam_74.set("returnType", "boolean");
        reflect_EntityLivingBase_method_isOnTeam_74.set("static", false);
        reflect_EntityLivingBase_method_isOnTeam_74.set("argnames", new String[]{"parTeam"});
        reflect_EntityLivingBase_method_isOnTeam_74.set("argtypes", new String[]{"Team"});
        reflect_EntityLivingBase_method_isOnTeam_74.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityLivingBase) params.getReflective("_self")).isOnTeam((Team) params.getReflective("parTeam"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_isOnTeam_74);


        BaseData reflect_EntityLivingBase_method_sendEnterCombat_75 = new ModData();
        reflect_EntityLivingBase_method_sendEnterCombat_75.set("methodName", "sendEnterCombat");
        reflect_EntityLivingBase_method_sendEnterCombat_75.set("returnType", "void");
        reflect_EntityLivingBase_method_sendEnterCombat_75.set("static", false);
        reflect_EntityLivingBase_method_sendEnterCombat_75.set("argnames", new String[]{});
        reflect_EntityLivingBase_method_sendEnterCombat_75.set("argtypes", new String[]{});
        reflect_EntityLivingBase_method_sendEnterCombat_75.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLivingBase) params.getReflective("_self")).sendEnterCombat();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_sendEnterCombat_75);


        BaseData reflect_EntityLivingBase_method_sendEndCombat_76 = new ModData();
        reflect_EntityLivingBase_method_sendEndCombat_76.set("methodName", "sendEndCombat");
        reflect_EntityLivingBase_method_sendEndCombat_76.set("returnType", "void");
        reflect_EntityLivingBase_method_sendEndCombat_76.set("static", false);
        reflect_EntityLivingBase_method_sendEndCombat_76.set("argnames", new String[]{});
        reflect_EntityLivingBase_method_sendEndCombat_76.set("argtypes", new String[]{});
        reflect_EntityLivingBase_method_sendEndCombat_76.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLivingBase) params.getReflective("_self")).sendEndCombat();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLivingBase_methods.add(reflect_EntityLivingBase_method_sendEndCombat_76);


        BaseData[] reflect_EntityLivingBase_methods_arr = new BaseData[reflect_EntityLivingBase_methods.size()];
        for (int i = 0; i < reflect_EntityLivingBase_methods_arr.length; i++) {
            reflect_EntityLivingBase_methods_arr[i] = reflect_EntityLivingBase_methods.get(i);
        }

        reflect_EntityLivingBase.set("constructors", reflect_EntityLivingBase_constructors_arr);
        reflect_EntityLivingBase.set("methods", reflect_EntityLivingBase_methods_arr);
        reflect_EntityLivingBase.set("className", "EntityLivingBase");
        reflect_EntityLivingBase.set("classId", "net.minecraft.entity.EntityLivingBase");
        reflect_EntityLivingBase.set("class", EntityLivingBase.class);
        reflect_EntityLivingBase.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityLivingBase;
        });
        reflectProfiles.add(reflect_EntityLivingBase);
    }


    //classdef for EntityMinecartCommandBlock
    public static void reflect_EntityMinecartCommandBlock_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityMinecartCommandBlock = new ModData();

        ArrayList<BaseData> reflect_EntityMinecartCommandBlock_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_EntityMinecartCommandBlock_constructor_EntityMinecartCommandBlock_0 = new ModData();
        reflect_EntityMinecartCommandBlock_constructor_EntityMinecartCommandBlock_0.set("returnType", "EntityMinecartCommandBlock");
        reflect_EntityMinecartCommandBlock_constructor_EntityMinecartCommandBlock_0.set("argnames", new String[]{"worldIn"});
        reflect_EntityMinecartCommandBlock_constructor_EntityMinecartCommandBlock_0.set("argtypes", new String[]{"World"});
        reflect_EntityMinecartCommandBlock_constructor_EntityMinecartCommandBlock_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityMinecartCommandBlock((World) params.getReflective("worldIn"));
        });
        
        reflect_EntityMinecartCommandBlock_constructors.add(reflect_EntityMinecartCommandBlock_constructor_EntityMinecartCommandBlock_0);


        BaseData reflect_EntityMinecartCommandBlock_constructor_EntityMinecartCommandBlock_1 = new ModData();
        reflect_EntityMinecartCommandBlock_constructor_EntityMinecartCommandBlock_1.set("returnType", "EntityMinecartCommandBlock");
        reflect_EntityMinecartCommandBlock_constructor_EntityMinecartCommandBlock_1.set("argnames", new String[]{"worldIn", "x", "y", "z"});
        reflect_EntityMinecartCommandBlock_constructor_EntityMinecartCommandBlock_1.set("argtypes", new String[]{"World", "double", "double", "double"});
        reflect_EntityMinecartCommandBlock_constructor_EntityMinecartCommandBlock_1.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityMinecartCommandBlock((World) params.getReflective("worldIn"), (double) params.getDouble("x"), (double) params.getDouble("y"), (double) params.getDouble("z"));
        });
        
        reflect_EntityMinecartCommandBlock_constructors.add(reflect_EntityMinecartCommandBlock_constructor_EntityMinecartCommandBlock_1);


        BaseData[] reflect_EntityMinecartCommandBlock_constructors_arr = new BaseData[reflect_EntityMinecartCommandBlock_constructors.size()];
        for (int i = 0; i < reflect_EntityMinecartCommandBlock_constructors_arr.length; i++) {
            reflect_EntityMinecartCommandBlock_constructors_arr[i] = reflect_EntityMinecartCommandBlock_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityMinecartCommandBlock_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityMinecartCommandBlock_method_getDefaultDisplayTile_0 = new ModData();
        reflect_EntityMinecartCommandBlock_method_getDefaultDisplayTile_0.set("methodName", "getDefaultDisplayTile");
        reflect_EntityMinecartCommandBlock_method_getDefaultDisplayTile_0.set("returnType", "IBlockState");
        reflect_EntityMinecartCommandBlock_method_getDefaultDisplayTile_0.set("static", false);
        reflect_EntityMinecartCommandBlock_method_getDefaultDisplayTile_0.set("argnames", new String[]{});
        reflect_EntityMinecartCommandBlock_method_getDefaultDisplayTile_0.set("argtypes", new String[]{});
        reflect_EntityMinecartCommandBlock_method_getDefaultDisplayTile_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (IBlockState) ((EntityMinecartCommandBlock) params.getReflective("_self")).getDefaultDisplayTile();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityMinecartCommandBlock_methods.add(reflect_EntityMinecartCommandBlock_method_getDefaultDisplayTile_0);


        BaseData reflect_EntityMinecartCommandBlock_method_getCommandBlockLogic_1 = new ModData();
        reflect_EntityMinecartCommandBlock_method_getCommandBlockLogic_1.set("methodName", "getCommandBlockLogic");
        reflect_EntityMinecartCommandBlock_method_getCommandBlockLogic_1.set("returnType", "CommandBlockLogic");
        reflect_EntityMinecartCommandBlock_method_getCommandBlockLogic_1.set("static", false);
        reflect_EntityMinecartCommandBlock_method_getCommandBlockLogic_1.set("argnames", new String[]{});
        reflect_EntityMinecartCommandBlock_method_getCommandBlockLogic_1.set("argtypes", new String[]{});
        reflect_EntityMinecartCommandBlock_method_getCommandBlockLogic_1.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (CommandBlockLogic) ((EntityMinecartCommandBlock) params.getReflective("_self")).getCommandBlockLogic();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityMinecartCommandBlock_methods.add(reflect_EntityMinecartCommandBlock_method_getCommandBlockLogic_1);


        BaseData reflect_EntityMinecartCommandBlock_method_onActivatorRailPass_2 = new ModData();
        reflect_EntityMinecartCommandBlock_method_onActivatorRailPass_2.set("methodName", "onActivatorRailPass");
        reflect_EntityMinecartCommandBlock_method_onActivatorRailPass_2.set("returnType", "void");
        reflect_EntityMinecartCommandBlock_method_onActivatorRailPass_2.set("static", false);
        reflect_EntityMinecartCommandBlock_method_onActivatorRailPass_2.set("argnames", new String[]{"var1", "var2", "var3", "flag"});
        reflect_EntityMinecartCommandBlock_method_onActivatorRailPass_2.set("argtypes", new String[]{"int", "int", "int", "boolean"});
        reflect_EntityMinecartCommandBlock_method_onActivatorRailPass_2.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityMinecartCommandBlock) params.getReflective("_self")).onActivatorRailPass((int) params.getInt("var1"), (int) params.getInt("var2"), (int) params.getInt("var3"), (boolean) params.getBoolean("flag"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityMinecartCommandBlock_methods.add(reflect_EntityMinecartCommandBlock_method_onActivatorRailPass_2);


        BaseData reflect_EntityMinecartCommandBlock_method_interactFirst_3 = new ModData();
        reflect_EntityMinecartCommandBlock_method_interactFirst_3.set("methodName", "interactFirst");
        reflect_EntityMinecartCommandBlock_method_interactFirst_3.set("returnType", "boolean");
        reflect_EntityMinecartCommandBlock_method_interactFirst_3.set("static", false);
        reflect_EntityMinecartCommandBlock_method_interactFirst_3.set("argnames", new String[]{"entityplayer"});
        reflect_EntityMinecartCommandBlock_method_interactFirst_3.set("argtypes", new String[]{"EntityPlayer"});
        reflect_EntityMinecartCommandBlock_method_interactFirst_3.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityMinecartCommandBlock) params.getReflective("_self")).interactFirst((EntityPlayer) params.getReflective("entityplayer"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityMinecartCommandBlock_methods.add(reflect_EntityMinecartCommandBlock_method_interactFirst_3);


        BaseData reflect_EntityMinecartCommandBlock_method_onDataWatcherUpdate_4 = new ModData();
        reflect_EntityMinecartCommandBlock_method_onDataWatcherUpdate_4.set("methodName", "onDataWatcherUpdate");
        reflect_EntityMinecartCommandBlock_method_onDataWatcherUpdate_4.set("returnType", "void");
        reflect_EntityMinecartCommandBlock_method_onDataWatcherUpdate_4.set("static", false);
        reflect_EntityMinecartCommandBlock_method_onDataWatcherUpdate_4.set("argnames", new String[]{"i"});
        reflect_EntityMinecartCommandBlock_method_onDataWatcherUpdate_4.set("argtypes", new String[]{"int"});
        reflect_EntityMinecartCommandBlock_method_onDataWatcherUpdate_4.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityMinecartCommandBlock) params.getReflective("_self")).onDataWatcherUpdate((int) params.getInt("i"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityMinecartCommandBlock_methods.add(reflect_EntityMinecartCommandBlock_method_onDataWatcherUpdate_4);


        BaseData[] reflect_EntityMinecartCommandBlock_methods_arr = new BaseData[reflect_EntityMinecartCommandBlock_methods.size()];
        for (int i = 0; i < reflect_EntityMinecartCommandBlock_methods_arr.length; i++) {
            reflect_EntityMinecartCommandBlock_methods_arr[i] = reflect_EntityMinecartCommandBlock_methods.get(i);
        }

        reflect_EntityMinecartCommandBlock.set("constructors", reflect_EntityMinecartCommandBlock_constructors_arr);
        reflect_EntityMinecartCommandBlock.set("methods", reflect_EntityMinecartCommandBlock_methods_arr);
        reflect_EntityMinecartCommandBlock.set("className", "EntityMinecartCommandBlock");
        reflect_EntityMinecartCommandBlock.set("classId", "net.minecraft.entity.EntityMinecartCommandBlock");
        reflect_EntityMinecartCommandBlock.set("class", EntityMinecartCommandBlock.class);
        reflect_EntityMinecartCommandBlock.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityMinecartCommandBlock;
        });
        reflectProfiles.add(reflect_EntityMinecartCommandBlock);
    }


    //classdef for EntityPlayer
    public static void reflect_EntityPlayer_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityPlayer = new ModData();

        ArrayList<BaseData> reflect_EntityPlayer_constructors = new ArrayList<BaseData>();
        
        BaseData[] reflect_EntityPlayer_constructors_arr = new BaseData[reflect_EntityPlayer_constructors.size()];
        for (int i = 0; i < reflect_EntityPlayer_constructors_arr.length; i++) {
            reflect_EntityPlayer_constructors_arr[i] = reflect_EntityPlayer_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityPlayer_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityPlayer_method_loadModData_0 = new ModData();
        reflect_EntityPlayer_method_loadModData_0.set("methodName", "loadModData");
        reflect_EntityPlayer_method_loadModData_0.set("returnType", "void");
        reflect_EntityPlayer_method_loadModData_0.set("static", false);
        reflect_EntityPlayer_method_loadModData_0.set("argnames", new String[]{"data"});
        reflect_EntityPlayer_method_loadModData_0.set("argtypes", new String[]{"BaseData"});
        reflect_EntityPlayer_method_loadModData_0.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayer) params.getReflective("_self")).loadModData((BaseData) params.getReflective("data"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_loadModData_0);


        BaseData reflect_EntityPlayer_method_makeModData_1 = new ModData();
        reflect_EntityPlayer_method_makeModData_1.set("methodName", "makeModData");
        reflect_EntityPlayer_method_makeModData_1.set("returnType", "ModData");
        reflect_EntityPlayer_method_makeModData_1.set("static", false);
        reflect_EntityPlayer_method_makeModData_1.set("argnames", new String[]{});
        reflect_EntityPlayer_method_makeModData_1.set("argtypes", new String[]{});
        reflect_EntityPlayer_method_makeModData_1.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (ModData) ((EntityPlayer) params.getReflective("_self")).makeModData();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_makeModData_1);


        BaseData reflect_EntityPlayer_method_getItemInUse_2 = new ModData();
        reflect_EntityPlayer_method_getItemInUse_2.set("methodName", "getItemInUse");
        reflect_EntityPlayer_method_getItemInUse_2.set("returnType", "ItemStack");
        reflect_EntityPlayer_method_getItemInUse_2.set("static", false);
        reflect_EntityPlayer_method_getItemInUse_2.set("argnames", new String[]{});
        reflect_EntityPlayer_method_getItemInUse_2.set("argtypes", new String[]{});
        reflect_EntityPlayer_method_getItemInUse_2.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (ItemStack) ((EntityPlayer) params.getReflective("_self")).getItemInUse();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_getItemInUse_2);


        BaseData reflect_EntityPlayer_method_getItemInUseCount_3 = new ModData();
        reflect_EntityPlayer_method_getItemInUseCount_3.set("methodName", "getItemInUseCount");
        reflect_EntityPlayer_method_getItemInUseCount_3.set("returnType", "int");
        reflect_EntityPlayer_method_getItemInUseCount_3.set("static", false);
        reflect_EntityPlayer_method_getItemInUseCount_3.set("argnames", new String[]{});
        reflect_EntityPlayer_method_getItemInUseCount_3.set("argtypes", new String[]{});
        reflect_EntityPlayer_method_getItemInUseCount_3.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityPlayer) params.getReflective("_self")).getItemInUseCount();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_getItemInUseCount_3);


        BaseData reflect_EntityPlayer_method_isUsingItem_4 = new ModData();
        reflect_EntityPlayer_method_isUsingItem_4.set("methodName", "isUsingItem");
        reflect_EntityPlayer_method_isUsingItem_4.set("returnType", "boolean");
        reflect_EntityPlayer_method_isUsingItem_4.set("static", false);
        reflect_EntityPlayer_method_isUsingItem_4.set("argnames", new String[]{});
        reflect_EntityPlayer_method_isUsingItem_4.set("argtypes", new String[]{});
        reflect_EntityPlayer_method_isUsingItem_4.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityPlayer) params.getReflective("_self")).isUsingItem();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_isUsingItem_4);


        BaseData reflect_EntityPlayer_method_getItemInUseDuration_5 = new ModData();
        reflect_EntityPlayer_method_getItemInUseDuration_5.set("methodName", "getItemInUseDuration");
        reflect_EntityPlayer_method_getItemInUseDuration_5.set("returnType", "int");
        reflect_EntityPlayer_method_getItemInUseDuration_5.set("static", false);
        reflect_EntityPlayer_method_getItemInUseDuration_5.set("argnames", new String[]{});
        reflect_EntityPlayer_method_getItemInUseDuration_5.set("argtypes", new String[]{});
        reflect_EntityPlayer_method_getItemInUseDuration_5.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityPlayer) params.getReflective("_self")).getItemInUseDuration();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_getItemInUseDuration_5);


        BaseData reflect_EntityPlayer_method_stopUsingItem_6 = new ModData();
        reflect_EntityPlayer_method_stopUsingItem_6.set("methodName", "stopUsingItem");
        reflect_EntityPlayer_method_stopUsingItem_6.set("returnType", "void");
        reflect_EntityPlayer_method_stopUsingItem_6.set("static", false);
        reflect_EntityPlayer_method_stopUsingItem_6.set("argnames", new String[]{});
        reflect_EntityPlayer_method_stopUsingItem_6.set("argtypes", new String[]{});
        reflect_EntityPlayer_method_stopUsingItem_6.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayer) params.getReflective("_self")).stopUsingItem();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_stopUsingItem_6);


        BaseData reflect_EntityPlayer_method_clearItemInUse_7 = new ModData();
        reflect_EntityPlayer_method_clearItemInUse_7.set("methodName", "clearItemInUse");
        reflect_EntityPlayer_method_clearItemInUse_7.set("returnType", "void");
        reflect_EntityPlayer_method_clearItemInUse_7.set("static", false);
        reflect_EntityPlayer_method_clearItemInUse_7.set("argnames", new String[]{});
        reflect_EntityPlayer_method_clearItemInUse_7.set("argtypes", new String[]{});
        reflect_EntityPlayer_method_clearItemInUse_7.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayer) params.getReflective("_self")).clearItemInUse();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_clearItemInUse_7);


        BaseData reflect_EntityPlayer_method_isBlocking_8 = new ModData();
        reflect_EntityPlayer_method_isBlocking_8.set("methodName", "isBlocking");
        reflect_EntityPlayer_method_isBlocking_8.set("returnType", "boolean");
        reflect_EntityPlayer_method_isBlocking_8.set("static", false);
        reflect_EntityPlayer_method_isBlocking_8.set("argnames", new String[]{});
        reflect_EntityPlayer_method_isBlocking_8.set("argtypes", new String[]{});
        reflect_EntityPlayer_method_isBlocking_8.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityPlayer) params.getReflective("_self")).isBlocking();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_isBlocking_8);


        BaseData reflect_EntityPlayer_method_onUpdate_9 = new ModData();
        reflect_EntityPlayer_method_onUpdate_9.set("methodName", "onUpdate");
        reflect_EntityPlayer_method_onUpdate_9.set("returnType", "void");
        reflect_EntityPlayer_method_onUpdate_9.set("static", false);
        reflect_EntityPlayer_method_onUpdate_9.set("argnames", new String[]{});
        reflect_EntityPlayer_method_onUpdate_9.set("argtypes", new String[]{});
        reflect_EntityPlayer_method_onUpdate_9.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayer) params.getReflective("_self")).onUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_onUpdate_9);


        BaseData reflect_EntityPlayer_method_getMaxInPortalTime_10 = new ModData();
        reflect_EntityPlayer_method_getMaxInPortalTime_10.set("methodName", "getMaxInPortalTime");
        reflect_EntityPlayer_method_getMaxInPortalTime_10.set("returnType", "int");
        reflect_EntityPlayer_method_getMaxInPortalTime_10.set("static", false);
        reflect_EntityPlayer_method_getMaxInPortalTime_10.set("argnames", new String[]{});
        reflect_EntityPlayer_method_getMaxInPortalTime_10.set("argtypes", new String[]{});
        reflect_EntityPlayer_method_getMaxInPortalTime_10.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityPlayer) params.getReflective("_self")).getMaxInPortalTime();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_getMaxInPortalTime_10);


        BaseData reflect_EntityPlayer_method_getPortalCooldown_11 = new ModData();
        reflect_EntityPlayer_method_getPortalCooldown_11.set("methodName", "getPortalCooldown");
        reflect_EntityPlayer_method_getPortalCooldown_11.set("returnType", "int");
        reflect_EntityPlayer_method_getPortalCooldown_11.set("static", false);
        reflect_EntityPlayer_method_getPortalCooldown_11.set("argnames", new String[]{});
        reflect_EntityPlayer_method_getPortalCooldown_11.set("argtypes", new String[]{});
        reflect_EntityPlayer_method_getPortalCooldown_11.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityPlayer) params.getReflective("_self")).getPortalCooldown();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_getPortalCooldown_11);


        BaseData reflect_EntityPlayer_method_playSound_12 = new ModData();
        reflect_EntityPlayer_method_playSound_12.set("methodName", "playSound");
        reflect_EntityPlayer_method_playSound_12.set("returnType", "void");
        reflect_EntityPlayer_method_playSound_12.set("static", false);
        reflect_EntityPlayer_method_playSound_12.set("argnames", new String[]{"s", "f", "f1"});
        reflect_EntityPlayer_method_playSound_12.set("argtypes", new String[]{"String", "float", "float"});
        reflect_EntityPlayer_method_playSound_12.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayer) params.getReflective("_self")).playSound((String) params.getString("s"), (float) params.getFloat("f"), (float) params.getFloat("f1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_playSound_12);


        BaseData reflect_EntityPlayer_method_handleStatusUpdate_13 = new ModData();
        reflect_EntityPlayer_method_handleStatusUpdate_13.set("methodName", "handleStatusUpdate");
        reflect_EntityPlayer_method_handleStatusUpdate_13.set("returnType", "void");
        reflect_EntityPlayer_method_handleStatusUpdate_13.set("static", false);
        reflect_EntityPlayer_method_handleStatusUpdate_13.set("argnames", new String[]{"b0"});
        reflect_EntityPlayer_method_handleStatusUpdate_13.set("argtypes", new String[]{"byte"});
        reflect_EntityPlayer_method_handleStatusUpdate_13.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayer) params.getReflective("_self")).handleStatusUpdate((byte) params.getByte("b0"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_handleStatusUpdate_13);


        BaseData reflect_EntityPlayer_method_updateRidden_14 = new ModData();
        reflect_EntityPlayer_method_updateRidden_14.set("methodName", "updateRidden");
        reflect_EntityPlayer_method_updateRidden_14.set("returnType", "void");
        reflect_EntityPlayer_method_updateRidden_14.set("static", false);
        reflect_EntityPlayer_method_updateRidden_14.set("argnames", new String[]{});
        reflect_EntityPlayer_method_updateRidden_14.set("argtypes", new String[]{});
        reflect_EntityPlayer_method_updateRidden_14.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayer) params.getReflective("_self")).updateRidden();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_updateRidden_14);


        BaseData reflect_EntityPlayer_method_preparePlayerToSpawn_15 = new ModData();
        reflect_EntityPlayer_method_preparePlayerToSpawn_15.set("methodName", "preparePlayerToSpawn");
        reflect_EntityPlayer_method_preparePlayerToSpawn_15.set("returnType", "void");
        reflect_EntityPlayer_method_preparePlayerToSpawn_15.set("static", false);
        reflect_EntityPlayer_method_preparePlayerToSpawn_15.set("argnames", new String[]{});
        reflect_EntityPlayer_method_preparePlayerToSpawn_15.set("argtypes", new String[]{});
        reflect_EntityPlayer_method_preparePlayerToSpawn_15.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayer) params.getReflective("_self")).preparePlayerToSpawn();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_preparePlayerToSpawn_15);


        BaseData reflect_EntityPlayer_method_onLivingUpdate_16 = new ModData();
        reflect_EntityPlayer_method_onLivingUpdate_16.set("methodName", "onLivingUpdate");
        reflect_EntityPlayer_method_onLivingUpdate_16.set("returnType", "void");
        reflect_EntityPlayer_method_onLivingUpdate_16.set("static", false);
        reflect_EntityPlayer_method_onLivingUpdate_16.set("argnames", new String[]{});
        reflect_EntityPlayer_method_onLivingUpdate_16.set("argtypes", new String[]{});
        reflect_EntityPlayer_method_onLivingUpdate_16.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayer) params.getReflective("_self")).onLivingUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_onLivingUpdate_16);


        BaseData reflect_EntityPlayer_method_getScore_17 = new ModData();
        reflect_EntityPlayer_method_getScore_17.set("methodName", "getScore");
        reflect_EntityPlayer_method_getScore_17.set("returnType", "int");
        reflect_EntityPlayer_method_getScore_17.set("static", false);
        reflect_EntityPlayer_method_getScore_17.set("argnames", new String[]{});
        reflect_EntityPlayer_method_getScore_17.set("argtypes", new String[]{});
        reflect_EntityPlayer_method_getScore_17.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityPlayer) params.getReflective("_self")).getScore();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_getScore_17);


        BaseData reflect_EntityPlayer_method_setScore_18 = new ModData();
        reflect_EntityPlayer_method_setScore_18.set("methodName", "setScore");
        reflect_EntityPlayer_method_setScore_18.set("returnType", "void");
        reflect_EntityPlayer_method_setScore_18.set("static", false);
        reflect_EntityPlayer_method_setScore_18.set("argnames", new String[]{"parInt1"});
        reflect_EntityPlayer_method_setScore_18.set("argtypes", new String[]{"int"});
        reflect_EntityPlayer_method_setScore_18.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayer) params.getReflective("_self")).setScore((int) params.getInt("parInt1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_setScore_18);


        BaseData reflect_EntityPlayer_method_addScore_19 = new ModData();
        reflect_EntityPlayer_method_addScore_19.set("methodName", "addScore");
        reflect_EntityPlayer_method_addScore_19.set("returnType", "void");
        reflect_EntityPlayer_method_addScore_19.set("static", false);
        reflect_EntityPlayer_method_addScore_19.set("argnames", new String[]{"parInt1"});
        reflect_EntityPlayer_method_addScore_19.set("argtypes", new String[]{"int"});
        reflect_EntityPlayer_method_addScore_19.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayer) params.getReflective("_self")).addScore((int) params.getInt("parInt1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_addScore_19);


        BaseData reflect_EntityPlayer_method_onDeath_20 = new ModData();
        reflect_EntityPlayer_method_onDeath_20.set("methodName", "onDeath");
        reflect_EntityPlayer_method_onDeath_20.set("returnType", "void");
        reflect_EntityPlayer_method_onDeath_20.set("static", false);
        reflect_EntityPlayer_method_onDeath_20.set("argnames", new String[]{"damagesource"});
        reflect_EntityPlayer_method_onDeath_20.set("argtypes", new String[]{"DamageSource"});
        reflect_EntityPlayer_method_onDeath_20.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayer) params.getReflective("_self")).onDeath((DamageSource) params.getReflective("damagesource"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_onDeath_20);


        BaseData reflect_EntityPlayer_method_addToPlayerScore_21 = new ModData();
        reflect_EntityPlayer_method_addToPlayerScore_21.set("methodName", "addToPlayerScore");
        reflect_EntityPlayer_method_addToPlayerScore_21.set("returnType", "void");
        reflect_EntityPlayer_method_addToPlayerScore_21.set("static", false);
        reflect_EntityPlayer_method_addToPlayerScore_21.set("argnames", new String[]{"entity", "i"});
        reflect_EntityPlayer_method_addToPlayerScore_21.set("argtypes", new String[]{"Entity", "int"});
        reflect_EntityPlayer_method_addToPlayerScore_21.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayer) params.getReflective("_self")).addToPlayerScore((Entity) params.getReflective("entity"), (int) params.getInt("i"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_addToPlayerScore_21);


        BaseData reflect_EntityPlayer_method_dropOneItem_22 = new ModData();
        reflect_EntityPlayer_method_dropOneItem_22.set("methodName", "dropOneItem");
        reflect_EntityPlayer_method_dropOneItem_22.set("returnType", "EntityItem");
        reflect_EntityPlayer_method_dropOneItem_22.set("static", false);
        reflect_EntityPlayer_method_dropOneItem_22.set("argnames", new String[]{"flag"});
        reflect_EntityPlayer_method_dropOneItem_22.set("argtypes", new String[]{"boolean"});
        reflect_EntityPlayer_method_dropOneItem_22.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EntityItem) ((EntityPlayer) params.getReflective("_self")).dropOneItem((boolean) params.getBoolean("flag"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_dropOneItem_22);


        BaseData reflect_EntityPlayer_method_dropPlayerItemWithRandomChoice_23 = new ModData();
        reflect_EntityPlayer_method_dropPlayerItemWithRandomChoice_23.set("methodName", "dropPlayerItemWithRandomChoice");
        reflect_EntityPlayer_method_dropPlayerItemWithRandomChoice_23.set("returnType", "EntityItem");
        reflect_EntityPlayer_method_dropPlayerItemWithRandomChoice_23.set("static", false);
        reflect_EntityPlayer_method_dropPlayerItemWithRandomChoice_23.set("argnames", new String[]{"itemStackIn", "unused"});
        reflect_EntityPlayer_method_dropPlayerItemWithRandomChoice_23.set("argtypes", new String[]{"ItemStack", "boolean"});
        reflect_EntityPlayer_method_dropPlayerItemWithRandomChoice_23.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EntityItem) ((EntityPlayer) params.getReflective("_self")).dropPlayerItemWithRandomChoice((ItemStack) params.getReflective("itemStackIn"), (boolean) params.getBoolean("unused"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_dropPlayerItemWithRandomChoice_23);


        BaseData reflect_EntityPlayer_method_dropItem_24 = new ModData();
        reflect_EntityPlayer_method_dropItem_24.set("methodName", "dropItem");
        reflect_EntityPlayer_method_dropItem_24.set("returnType", "EntityItem");
        reflect_EntityPlayer_method_dropItem_24.set("static", false);
        reflect_EntityPlayer_method_dropItem_24.set("argnames", new String[]{"droppedItem", "dropAround", "traceItem"});
        reflect_EntityPlayer_method_dropItem_24.set("argtypes", new String[]{"ItemStack", "boolean", "boolean"});
        reflect_EntityPlayer_method_dropItem_24.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EntityItem) ((EntityPlayer) params.getReflective("_self")).dropItem((ItemStack) params.getReflective("droppedItem"), (boolean) params.getBoolean("dropAround"), (boolean) params.getBoolean("traceItem"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_dropItem_24);


        BaseData reflect_EntityPlayer_method_getToolDigEfficiency_25 = new ModData();
        reflect_EntityPlayer_method_getToolDigEfficiency_25.set("methodName", "getToolDigEfficiency");
        reflect_EntityPlayer_method_getToolDigEfficiency_25.set("returnType", "float");
        reflect_EntityPlayer_method_getToolDigEfficiency_25.set("static", false);
        reflect_EntityPlayer_method_getToolDigEfficiency_25.set("argnames", new String[]{"parBlock"});
        reflect_EntityPlayer_method_getToolDigEfficiency_25.set("argtypes", new String[]{"Block"});
        reflect_EntityPlayer_method_getToolDigEfficiency_25.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityPlayer) params.getReflective("_self")).getToolDigEfficiency((Block) params.getReflective("parBlock"));
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_getToolDigEfficiency_25);


        BaseData reflect_EntityPlayer_method_canHarvestBlock_26 = new ModData();
        reflect_EntityPlayer_method_canHarvestBlock_26.set("methodName", "canHarvestBlock");
        reflect_EntityPlayer_method_canHarvestBlock_26.set("returnType", "boolean");
        reflect_EntityPlayer_method_canHarvestBlock_26.set("static", false);
        reflect_EntityPlayer_method_canHarvestBlock_26.set("argnames", new String[]{"blockToHarvest"});
        reflect_EntityPlayer_method_canHarvestBlock_26.set("argtypes", new String[]{"Block"});
        reflect_EntityPlayer_method_canHarvestBlock_26.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityPlayer) params.getReflective("_self")).canHarvestBlock((Block) params.getReflective("blockToHarvest"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_canHarvestBlock_26);


        BaseData reflect_EntityPlayer_method_readEntityFromNBT_27 = new ModData();
        reflect_EntityPlayer_method_readEntityFromNBT_27.set("methodName", "readEntityFromNBT");
        reflect_EntityPlayer_method_readEntityFromNBT_27.set("returnType", "void");
        reflect_EntityPlayer_method_readEntityFromNBT_27.set("static", false);
        reflect_EntityPlayer_method_readEntityFromNBT_27.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityPlayer_method_readEntityFromNBT_27.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityPlayer_method_readEntityFromNBT_27.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayer) params.getReflective("_self")).readEntityFromNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_readEntityFromNBT_27);


        BaseData reflect_EntityPlayer_method_writeEntityToNBT_28 = new ModData();
        reflect_EntityPlayer_method_writeEntityToNBT_28.set("methodName", "writeEntityToNBT");
        reflect_EntityPlayer_method_writeEntityToNBT_28.set("returnType", "void");
        reflect_EntityPlayer_method_writeEntityToNBT_28.set("static", false);
        reflect_EntityPlayer_method_writeEntityToNBT_28.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityPlayer_method_writeEntityToNBT_28.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityPlayer_method_writeEntityToNBT_28.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayer) params.getReflective("_self")).writeEntityToNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_writeEntityToNBT_28);


        BaseData reflect_EntityPlayer_method_attackEntityFrom_29 = new ModData();
        reflect_EntityPlayer_method_attackEntityFrom_29.set("methodName", "attackEntityFrom");
        reflect_EntityPlayer_method_attackEntityFrom_29.set("returnType", "boolean");
        reflect_EntityPlayer_method_attackEntityFrom_29.set("static", false);
        reflect_EntityPlayer_method_attackEntityFrom_29.set("argnames", new String[]{"damagesource", "f"});
        reflect_EntityPlayer_method_attackEntityFrom_29.set("argtypes", new String[]{"DamageSource", "float"});
        reflect_EntityPlayer_method_attackEntityFrom_29.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityPlayer) params.getReflective("_self")).attackEntityFrom((DamageSource) params.getReflective("damagesource"), (float) params.getFloat("f"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_attackEntityFrom_29);


        BaseData reflect_EntityPlayer_method_canAttackPlayer_30 = new ModData();
        reflect_EntityPlayer_method_canAttackPlayer_30.set("methodName", "canAttackPlayer");
        reflect_EntityPlayer_method_canAttackPlayer_30.set("returnType", "boolean");
        reflect_EntityPlayer_method_canAttackPlayer_30.set("static", false);
        reflect_EntityPlayer_method_canAttackPlayer_30.set("argnames", new String[]{"entityplayer"});
        reflect_EntityPlayer_method_canAttackPlayer_30.set("argtypes", new String[]{"EntityPlayer"});
        reflect_EntityPlayer_method_canAttackPlayer_30.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityPlayer) params.getReflective("_self")).canAttackPlayer((EntityPlayer) params.getReflective("entityplayer"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_canAttackPlayer_30);


        BaseData reflect_EntityPlayer_method_getTotalArmorValue_31 = new ModData();
        reflect_EntityPlayer_method_getTotalArmorValue_31.set("methodName", "getTotalArmorValue");
        reflect_EntityPlayer_method_getTotalArmorValue_31.set("returnType", "int");
        reflect_EntityPlayer_method_getTotalArmorValue_31.set("static", false);
        reflect_EntityPlayer_method_getTotalArmorValue_31.set("argnames", new String[]{});
        reflect_EntityPlayer_method_getTotalArmorValue_31.set("argtypes", new String[]{});
        reflect_EntityPlayer_method_getTotalArmorValue_31.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityPlayer) params.getReflective("_self")).getTotalArmorValue();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_getTotalArmorValue_31);


        BaseData reflect_EntityPlayer_method_getArmorVisibility_32 = new ModData();
        reflect_EntityPlayer_method_getArmorVisibility_32.set("methodName", "getArmorVisibility");
        reflect_EntityPlayer_method_getArmorVisibility_32.set("returnType", "float");
        reflect_EntityPlayer_method_getArmorVisibility_32.set("static", false);
        reflect_EntityPlayer_method_getArmorVisibility_32.set("argnames", new String[]{});
        reflect_EntityPlayer_method_getArmorVisibility_32.set("argtypes", new String[]{});
        reflect_EntityPlayer_method_getArmorVisibility_32.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityPlayer) params.getReflective("_self")).getArmorVisibility();
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_getArmorVisibility_32);


        BaseData reflect_EntityPlayer_method_openEditSign_33 = new ModData();
        reflect_EntityPlayer_method_openEditSign_33.set("methodName", "openEditSign");
        reflect_EntityPlayer_method_openEditSign_33.set("returnType", "void");
        reflect_EntityPlayer_method_openEditSign_33.set("static", false);
        reflect_EntityPlayer_method_openEditSign_33.set("argnames", new String[]{"var1"});
        reflect_EntityPlayer_method_openEditSign_33.set("argtypes", new String[]{"TileEntitySign"});
        reflect_EntityPlayer_method_openEditSign_33.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayer) params.getReflective("_self")).openEditSign((TileEntitySign) params.getReflective("var1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_openEditSign_33);


        BaseData reflect_EntityPlayer_method_openEditCommandBlock_34 = new ModData();
        reflect_EntityPlayer_method_openEditCommandBlock_34.set("methodName", "openEditCommandBlock");
        reflect_EntityPlayer_method_openEditCommandBlock_34.set("returnType", "void");
        reflect_EntityPlayer_method_openEditCommandBlock_34.set("static", false);
        reflect_EntityPlayer_method_openEditCommandBlock_34.set("argnames", new String[]{"var1"});
        reflect_EntityPlayer_method_openEditCommandBlock_34.set("argtypes", new String[]{"CommandBlockLogic"});
        reflect_EntityPlayer_method_openEditCommandBlock_34.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayer) params.getReflective("_self")).openEditCommandBlock((CommandBlockLogic) params.getReflective("var1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_openEditCommandBlock_34);


        BaseData reflect_EntityPlayer_method_displayVillagerTradeGui_35 = new ModData();
        reflect_EntityPlayer_method_displayVillagerTradeGui_35.set("methodName", "displayVillagerTradeGui");
        reflect_EntityPlayer_method_displayVillagerTradeGui_35.set("returnType", "void");
        reflect_EntityPlayer_method_displayVillagerTradeGui_35.set("static", false);
        reflect_EntityPlayer_method_displayVillagerTradeGui_35.set("argnames", new String[]{"var1"});
        reflect_EntityPlayer_method_displayVillagerTradeGui_35.set("argtypes", new String[]{"IMerchant"});
        reflect_EntityPlayer_method_displayVillagerTradeGui_35.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayer) params.getReflective("_self")).displayVillagerTradeGui((IMerchant) params.getReflective("var1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_displayVillagerTradeGui_35);


        BaseData reflect_EntityPlayer_method_displayGUIChest_36 = new ModData();
        reflect_EntityPlayer_method_displayGUIChest_36.set("methodName", "displayGUIChest");
        reflect_EntityPlayer_method_displayGUIChest_36.set("returnType", "void");
        reflect_EntityPlayer_method_displayGUIChest_36.set("static", false);
        reflect_EntityPlayer_method_displayGUIChest_36.set("argnames", new String[]{"var1"});
        reflect_EntityPlayer_method_displayGUIChest_36.set("argtypes", new String[]{"IInventory"});
        reflect_EntityPlayer_method_displayGUIChest_36.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayer) params.getReflective("_self")).displayGUIChest((IInventory) params.getReflective("var1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_displayGUIChest_36);


        BaseData reflect_EntityPlayer_method_displayGUIHorse_37 = new ModData();
        reflect_EntityPlayer_method_displayGUIHorse_37.set("methodName", "displayGUIHorse");
        reflect_EntityPlayer_method_displayGUIHorse_37.set("returnType", "void");
        reflect_EntityPlayer_method_displayGUIHorse_37.set("static", false);
        reflect_EntityPlayer_method_displayGUIHorse_37.set("argnames", new String[]{"var1", "var2"});
        reflect_EntityPlayer_method_displayGUIHorse_37.set("argtypes", new String[]{"EntityHorse", "IInventory"});
        reflect_EntityPlayer_method_displayGUIHorse_37.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayer) params.getReflective("_self")).displayGUIHorse((EntityHorse) params.getReflective("var1"), (IInventory) params.getReflective("var2"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_displayGUIHorse_37);


        BaseData reflect_EntityPlayer_method_displayGui_38 = new ModData();
        reflect_EntityPlayer_method_displayGui_38.set("methodName", "displayGui");
        reflect_EntityPlayer_method_displayGui_38.set("returnType", "void");
        reflect_EntityPlayer_method_displayGui_38.set("static", false);
        reflect_EntityPlayer_method_displayGui_38.set("argnames", new String[]{"var1"});
        reflect_EntityPlayer_method_displayGui_38.set("argtypes", new String[]{"IInteractionObject"});
        reflect_EntityPlayer_method_displayGui_38.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayer) params.getReflective("_self")).displayGui((IInteractionObject) params.getReflective("var1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_displayGui_38);


        BaseData reflect_EntityPlayer_method_displayGUIBook_39 = new ModData();
        reflect_EntityPlayer_method_displayGUIBook_39.set("methodName", "displayGUIBook");
        reflect_EntityPlayer_method_displayGUIBook_39.set("returnType", "void");
        reflect_EntityPlayer_method_displayGUIBook_39.set("static", false);
        reflect_EntityPlayer_method_displayGUIBook_39.set("argnames", new String[]{"var1"});
        reflect_EntityPlayer_method_displayGUIBook_39.set("argtypes", new String[]{"ItemStack"});
        reflect_EntityPlayer_method_displayGUIBook_39.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayer) params.getReflective("_self")).displayGUIBook((ItemStack) params.getReflective("var1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_displayGUIBook_39);


        BaseData reflect_EntityPlayer_method_interactWith_40 = new ModData();
        reflect_EntityPlayer_method_interactWith_40.set("methodName", "interactWith");
        reflect_EntityPlayer_method_interactWith_40.set("returnType", "boolean");
        reflect_EntityPlayer_method_interactWith_40.set("static", false);
        reflect_EntityPlayer_method_interactWith_40.set("argnames", new String[]{"parEntity"});
        reflect_EntityPlayer_method_interactWith_40.set("argtypes", new String[]{"Entity"});
        reflect_EntityPlayer_method_interactWith_40.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityPlayer) params.getReflective("_self")).interactWith((Entity) params.getReflective("parEntity"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_interactWith_40);


        BaseData reflect_EntityPlayer_method_getCurrentEquippedItem_41 = new ModData();
        reflect_EntityPlayer_method_getCurrentEquippedItem_41.set("methodName", "getCurrentEquippedItem");
        reflect_EntityPlayer_method_getCurrentEquippedItem_41.set("returnType", "ItemStack");
        reflect_EntityPlayer_method_getCurrentEquippedItem_41.set("static", false);
        reflect_EntityPlayer_method_getCurrentEquippedItem_41.set("argnames", new String[]{});
        reflect_EntityPlayer_method_getCurrentEquippedItem_41.set("argtypes", new String[]{});
        reflect_EntityPlayer_method_getCurrentEquippedItem_41.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (ItemStack) ((EntityPlayer) params.getReflective("_self")).getCurrentEquippedItem();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_getCurrentEquippedItem_41);


        BaseData reflect_EntityPlayer_method_destroyCurrentEquippedItem_42 = new ModData();
        reflect_EntityPlayer_method_destroyCurrentEquippedItem_42.set("methodName", "destroyCurrentEquippedItem");
        reflect_EntityPlayer_method_destroyCurrentEquippedItem_42.set("returnType", "void");
        reflect_EntityPlayer_method_destroyCurrentEquippedItem_42.set("static", false);
        reflect_EntityPlayer_method_destroyCurrentEquippedItem_42.set("argnames", new String[]{});
        reflect_EntityPlayer_method_destroyCurrentEquippedItem_42.set("argtypes", new String[]{});
        reflect_EntityPlayer_method_destroyCurrentEquippedItem_42.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayer) params.getReflective("_self")).destroyCurrentEquippedItem();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_destroyCurrentEquippedItem_42);


        BaseData reflect_EntityPlayer_method_getYOffset_43 = new ModData();
        reflect_EntityPlayer_method_getYOffset_43.set("methodName", "getYOffset");
        reflect_EntityPlayer_method_getYOffset_43.set("returnType", "double");
        reflect_EntityPlayer_method_getYOffset_43.set("static", false);
        reflect_EntityPlayer_method_getYOffset_43.set("argnames", new String[]{});
        reflect_EntityPlayer_method_getYOffset_43.set("argtypes", new String[]{});
        reflect_EntityPlayer_method_getYOffset_43.setCallbackDoubleWithDataArg("exec", (BaseData params) -> {
                try {
                    return (double) ((EntityPlayer) params.getReflective("_self")).getYOffset();
                } catch (Exception _exception_reflect_) {
                    return 0.0d;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_getYOffset_43);


        BaseData reflect_EntityPlayer_method_attackTargetEntityWithCurrentItem_44 = new ModData();
        reflect_EntityPlayer_method_attackTargetEntityWithCurrentItem_44.set("methodName", "attackTargetEntityWithCurrentItem");
        reflect_EntityPlayer_method_attackTargetEntityWithCurrentItem_44.set("returnType", "void");
        reflect_EntityPlayer_method_attackTargetEntityWithCurrentItem_44.set("static", false);
        reflect_EntityPlayer_method_attackTargetEntityWithCurrentItem_44.set("argnames", new String[]{"entity"});
        reflect_EntityPlayer_method_attackTargetEntityWithCurrentItem_44.set("argtypes", new String[]{"Entity"});
        reflect_EntityPlayer_method_attackTargetEntityWithCurrentItem_44.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayer) params.getReflective("_self")).attackTargetEntityWithCurrentItem((Entity) params.getReflective("entity"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_attackTargetEntityWithCurrentItem_44);


        BaseData reflect_EntityPlayer_method_onCriticalHit_45 = new ModData();
        reflect_EntityPlayer_method_onCriticalHit_45.set("methodName", "onCriticalHit");
        reflect_EntityPlayer_method_onCriticalHit_45.set("returnType", "void");
        reflect_EntityPlayer_method_onCriticalHit_45.set("static", false);
        reflect_EntityPlayer_method_onCriticalHit_45.set("argnames", new String[]{"var1"});
        reflect_EntityPlayer_method_onCriticalHit_45.set("argtypes", new String[]{"Entity"});
        reflect_EntityPlayer_method_onCriticalHit_45.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayer) params.getReflective("_self")).onCriticalHit((Entity) params.getReflective("var1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_onCriticalHit_45);


        BaseData reflect_EntityPlayer_method_onEnchantmentCritical_46 = new ModData();
        reflect_EntityPlayer_method_onEnchantmentCritical_46.set("methodName", "onEnchantmentCritical");
        reflect_EntityPlayer_method_onEnchantmentCritical_46.set("returnType", "void");
        reflect_EntityPlayer_method_onEnchantmentCritical_46.set("static", false);
        reflect_EntityPlayer_method_onEnchantmentCritical_46.set("argnames", new String[]{"var1"});
        reflect_EntityPlayer_method_onEnchantmentCritical_46.set("argtypes", new String[]{"Entity"});
        reflect_EntityPlayer_method_onEnchantmentCritical_46.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayer) params.getReflective("_self")).onEnchantmentCritical((Entity) params.getReflective("var1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_onEnchantmentCritical_46);


        BaseData reflect_EntityPlayer_method_respawnPlayer_47 = new ModData();
        reflect_EntityPlayer_method_respawnPlayer_47.set("methodName", "respawnPlayer");
        reflect_EntityPlayer_method_respawnPlayer_47.set("returnType", "void");
        reflect_EntityPlayer_method_respawnPlayer_47.set("static", false);
        reflect_EntityPlayer_method_respawnPlayer_47.set("argnames", new String[]{});
        reflect_EntityPlayer_method_respawnPlayer_47.set("argtypes", new String[]{});
        reflect_EntityPlayer_method_respawnPlayer_47.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayer) params.getReflective("_self")).respawnPlayer();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_respawnPlayer_47);


        BaseData reflect_EntityPlayer_method_setDead_48 = new ModData();
        reflect_EntityPlayer_method_setDead_48.set("methodName", "setDead");
        reflect_EntityPlayer_method_setDead_48.set("returnType", "void");
        reflect_EntityPlayer_method_setDead_48.set("static", false);
        reflect_EntityPlayer_method_setDead_48.set("argnames", new String[]{});
        reflect_EntityPlayer_method_setDead_48.set("argtypes", new String[]{});
        reflect_EntityPlayer_method_setDead_48.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayer) params.getReflective("_self")).setDead();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_setDead_48);


        BaseData reflect_EntityPlayer_method_isEntityInsideOpaqueBlock_49 = new ModData();
        reflect_EntityPlayer_method_isEntityInsideOpaqueBlock_49.set("methodName", "isEntityInsideOpaqueBlock");
        reflect_EntityPlayer_method_isEntityInsideOpaqueBlock_49.set("returnType", "boolean");
        reflect_EntityPlayer_method_isEntityInsideOpaqueBlock_49.set("static", false);
        reflect_EntityPlayer_method_isEntityInsideOpaqueBlock_49.set("argnames", new String[]{});
        reflect_EntityPlayer_method_isEntityInsideOpaqueBlock_49.set("argtypes", new String[]{});
        reflect_EntityPlayer_method_isEntityInsideOpaqueBlock_49.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityPlayer) params.getReflective("_self")).isEntityInsideOpaqueBlock();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_isEntityInsideOpaqueBlock_49);


        BaseData reflect_EntityPlayer_method_isUser_50 = new ModData();
        reflect_EntityPlayer_method_isUser_50.set("methodName", "isUser");
        reflect_EntityPlayer_method_isUser_50.set("returnType", "boolean");
        reflect_EntityPlayer_method_isUser_50.set("static", false);
        reflect_EntityPlayer_method_isUser_50.set("argnames", new String[]{});
        reflect_EntityPlayer_method_isUser_50.set("argtypes", new String[]{});
        reflect_EntityPlayer_method_isUser_50.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityPlayer) params.getReflective("_self")).isUser();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_isUser_50);


        BaseData reflect_EntityPlayer_method_getGameProfile_51 = new ModData();
        reflect_EntityPlayer_method_getGameProfile_51.set("methodName", "getGameProfile");
        reflect_EntityPlayer_method_getGameProfile_51.set("returnType", "GameProfile");
        reflect_EntityPlayer_method_getGameProfile_51.set("static", false);
        reflect_EntityPlayer_method_getGameProfile_51.set("argnames", new String[]{});
        reflect_EntityPlayer_method_getGameProfile_51.set("argtypes", new String[]{});
        reflect_EntityPlayer_method_getGameProfile_51.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (GameProfile) ((EntityPlayer) params.getReflective("_self")).getGameProfile();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_getGameProfile_51);


        BaseData reflect_EntityPlayer_method_wakeUpPlayer_52 = new ModData();
        reflect_EntityPlayer_method_wakeUpPlayer_52.set("methodName", "wakeUpPlayer");
        reflect_EntityPlayer_method_wakeUpPlayer_52.set("returnType", "void");
        reflect_EntityPlayer_method_wakeUpPlayer_52.set("static", false);
        reflect_EntityPlayer_method_wakeUpPlayer_52.set("argnames", new String[]{"flag", "flag1", "flag2"});
        reflect_EntityPlayer_method_wakeUpPlayer_52.set("argtypes", new String[]{"boolean", "boolean", "boolean"});
        reflect_EntityPlayer_method_wakeUpPlayer_52.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayer) params.getReflective("_self")).wakeUpPlayer((boolean) params.getBoolean("flag"), (boolean) params.getBoolean("flag1"), (boolean) params.getBoolean("flag2"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_wakeUpPlayer_52);


        BaseData reflect_EntityPlayer_method_getBedSpawnLocation_53 = new ModData();
        reflect_EntityPlayer_method_getBedSpawnLocation_53.set("methodName", "getBedSpawnLocation");
        reflect_EntityPlayer_method_getBedSpawnLocation_53.set("returnType", "BlockPos");
        reflect_EntityPlayer_method_getBedSpawnLocation_53.set("static", true);
        reflect_EntityPlayer_method_getBedSpawnLocation_53.set("argnames", new String[]{"worldIn", "bedLocation", "forceSpawn"});
        reflect_EntityPlayer_method_getBedSpawnLocation_53.set("argtypes", new String[]{"World", "BlockPos", "boolean"});
        reflect_EntityPlayer_method_getBedSpawnLocation_53.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (BlockPos) EntityPlayer.getBedSpawnLocation((World) params.getReflective("worldIn"), (BlockPos) params.getReflective("bedLocation"), (boolean) params.getBoolean("forceSpawn"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_getBedSpawnLocation_53);


        BaseData reflect_EntityPlayer_method_getBedOrientationInDegrees_54 = new ModData();
        reflect_EntityPlayer_method_getBedOrientationInDegrees_54.set("methodName", "getBedOrientationInDegrees");
        reflect_EntityPlayer_method_getBedOrientationInDegrees_54.set("returnType", "float");
        reflect_EntityPlayer_method_getBedOrientationInDegrees_54.set("static", false);
        reflect_EntityPlayer_method_getBedOrientationInDegrees_54.set("argnames", new String[]{});
        reflect_EntityPlayer_method_getBedOrientationInDegrees_54.set("argtypes", new String[]{});
        reflect_EntityPlayer_method_getBedOrientationInDegrees_54.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityPlayer) params.getReflective("_self")).getBedOrientationInDegrees();
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_getBedOrientationInDegrees_54);


        BaseData reflect_EntityPlayer_method_isPlayerSleeping_55 = new ModData();
        reflect_EntityPlayer_method_isPlayerSleeping_55.set("methodName", "isPlayerSleeping");
        reflect_EntityPlayer_method_isPlayerSleeping_55.set("returnType", "boolean");
        reflect_EntityPlayer_method_isPlayerSleeping_55.set("static", false);
        reflect_EntityPlayer_method_isPlayerSleeping_55.set("argnames", new String[]{});
        reflect_EntityPlayer_method_isPlayerSleeping_55.set("argtypes", new String[]{});
        reflect_EntityPlayer_method_isPlayerSleeping_55.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityPlayer) params.getReflective("_self")).isPlayerSleeping();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_isPlayerSleeping_55);


        BaseData reflect_EntityPlayer_method_isPlayerFullyAsleep_56 = new ModData();
        reflect_EntityPlayer_method_isPlayerFullyAsleep_56.set("methodName", "isPlayerFullyAsleep");
        reflect_EntityPlayer_method_isPlayerFullyAsleep_56.set("returnType", "boolean");
        reflect_EntityPlayer_method_isPlayerFullyAsleep_56.set("static", false);
        reflect_EntityPlayer_method_isPlayerFullyAsleep_56.set("argnames", new String[]{});
        reflect_EntityPlayer_method_isPlayerFullyAsleep_56.set("argtypes", new String[]{});
        reflect_EntityPlayer_method_isPlayerFullyAsleep_56.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityPlayer) params.getReflective("_self")).isPlayerFullyAsleep();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_isPlayerFullyAsleep_56);


        BaseData reflect_EntityPlayer_method_getSleepTimer_57 = new ModData();
        reflect_EntityPlayer_method_getSleepTimer_57.set("methodName", "getSleepTimer");
        reflect_EntityPlayer_method_getSleepTimer_57.set("returnType", "int");
        reflect_EntityPlayer_method_getSleepTimer_57.set("static", false);
        reflect_EntityPlayer_method_getSleepTimer_57.set("argnames", new String[]{});
        reflect_EntityPlayer_method_getSleepTimer_57.set("argtypes", new String[]{});
        reflect_EntityPlayer_method_getSleepTimer_57.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityPlayer) params.getReflective("_self")).getSleepTimer();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_getSleepTimer_57);


        BaseData reflect_EntityPlayer_method_addChatComponentMessage_58 = new ModData();
        reflect_EntityPlayer_method_addChatComponentMessage_58.set("methodName", "addChatComponentMessage");
        reflect_EntityPlayer_method_addChatComponentMessage_58.set("returnType", "void");
        reflect_EntityPlayer_method_addChatComponentMessage_58.set("static", false);
        reflect_EntityPlayer_method_addChatComponentMessage_58.set("argnames", new String[]{"var1"});
        reflect_EntityPlayer_method_addChatComponentMessage_58.set("argtypes", new String[]{"IChatComponent"});
        reflect_EntityPlayer_method_addChatComponentMessage_58.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayer) params.getReflective("_self")).addChatComponentMessage((IChatComponent) params.getReflective("var1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_addChatComponentMessage_58);


        BaseData reflect_EntityPlayer_method_getBedLocation_59 = new ModData();
        reflect_EntityPlayer_method_getBedLocation_59.set("methodName", "getBedLocation");
        reflect_EntityPlayer_method_getBedLocation_59.set("returnType", "BlockPos");
        reflect_EntityPlayer_method_getBedLocation_59.set("static", false);
        reflect_EntityPlayer_method_getBedLocation_59.set("argnames", new String[]{});
        reflect_EntityPlayer_method_getBedLocation_59.set("argtypes", new String[]{});
        reflect_EntityPlayer_method_getBedLocation_59.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (BlockPos) ((EntityPlayer) params.getReflective("_self")).getBedLocation();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_getBedLocation_59);


        BaseData reflect_EntityPlayer_method_isSpawnForced_60 = new ModData();
        reflect_EntityPlayer_method_isSpawnForced_60.set("methodName", "isSpawnForced");
        reflect_EntityPlayer_method_isSpawnForced_60.set("returnType", "boolean");
        reflect_EntityPlayer_method_isSpawnForced_60.set("static", false);
        reflect_EntityPlayer_method_isSpawnForced_60.set("argnames", new String[]{});
        reflect_EntityPlayer_method_isSpawnForced_60.set("argtypes", new String[]{});
        reflect_EntityPlayer_method_isSpawnForced_60.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityPlayer) params.getReflective("_self")).isSpawnForced();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_isSpawnForced_60);


        BaseData reflect_EntityPlayer_method_setSpawnPoint_61 = new ModData();
        reflect_EntityPlayer_method_setSpawnPoint_61.set("methodName", "setSpawnPoint");
        reflect_EntityPlayer_method_setSpawnPoint_61.set("returnType", "void");
        reflect_EntityPlayer_method_setSpawnPoint_61.set("static", false);
        reflect_EntityPlayer_method_setSpawnPoint_61.set("argnames", new String[]{"pos", "forced"});
        reflect_EntityPlayer_method_setSpawnPoint_61.set("argtypes", new String[]{"BlockPos", "boolean"});
        reflect_EntityPlayer_method_setSpawnPoint_61.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayer) params.getReflective("_self")).setSpawnPoint((BlockPos) params.getReflective("pos"), (boolean) params.getBoolean("forced"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_setSpawnPoint_61);


        BaseData reflect_EntityPlayer_method_triggerAchievement_62 = new ModData();
        reflect_EntityPlayer_method_triggerAchievement_62.set("methodName", "triggerAchievement");
        reflect_EntityPlayer_method_triggerAchievement_62.set("returnType", "void");
        reflect_EntityPlayer_method_triggerAchievement_62.set("static", false);
        reflect_EntityPlayer_method_triggerAchievement_62.set("argnames", new String[]{"achievementIn"});
        reflect_EntityPlayer_method_triggerAchievement_62.set("argtypes", new String[]{"StatBase"});
        reflect_EntityPlayer_method_triggerAchievement_62.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayer) params.getReflective("_self")).triggerAchievement((StatBase) params.getReflective("achievementIn"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_triggerAchievement_62);


        BaseData reflect_EntityPlayer_method_addStat_63 = new ModData();
        reflect_EntityPlayer_method_addStat_63.set("methodName", "addStat");
        reflect_EntityPlayer_method_addStat_63.set("returnType", "void");
        reflect_EntityPlayer_method_addStat_63.set("static", false);
        reflect_EntityPlayer_method_addStat_63.set("argnames", new String[]{"var1", "var2"});
        reflect_EntityPlayer_method_addStat_63.set("argtypes", new String[]{"StatBase", "int"});
        reflect_EntityPlayer_method_addStat_63.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayer) params.getReflective("_self")).addStat((StatBase) params.getReflective("var1"), (int) params.getInt("var2"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_addStat_63);


        BaseData reflect_EntityPlayer_method_func_175145_a_64 = new ModData();
        reflect_EntityPlayer_method_func_175145_a_64.set("methodName", "func_175145_a");
        reflect_EntityPlayer_method_func_175145_a_64.set("returnType", "void");
        reflect_EntityPlayer_method_func_175145_a_64.set("static", false);
        reflect_EntityPlayer_method_func_175145_a_64.set("argnames", new String[]{"var1"});
        reflect_EntityPlayer_method_func_175145_a_64.set("argtypes", new String[]{"StatBase"});
        reflect_EntityPlayer_method_func_175145_a_64.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayer) params.getReflective("_self")).func_175145_a((StatBase) params.getReflective("var1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_func_175145_a_64);


        BaseData reflect_EntityPlayer_method_jump_65 = new ModData();
        reflect_EntityPlayer_method_jump_65.set("methodName", "jump");
        reflect_EntityPlayer_method_jump_65.set("returnType", "void");
        reflect_EntityPlayer_method_jump_65.set("static", false);
        reflect_EntityPlayer_method_jump_65.set("argnames", new String[]{});
        reflect_EntityPlayer_method_jump_65.set("argtypes", new String[]{});
        reflect_EntityPlayer_method_jump_65.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayer) params.getReflective("_self")).jump();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_jump_65);


        BaseData reflect_EntityPlayer_method_moveEntityWithHeading_66 = new ModData();
        reflect_EntityPlayer_method_moveEntityWithHeading_66.set("methodName", "moveEntityWithHeading");
        reflect_EntityPlayer_method_moveEntityWithHeading_66.set("returnType", "void");
        reflect_EntityPlayer_method_moveEntityWithHeading_66.set("static", false);
        reflect_EntityPlayer_method_moveEntityWithHeading_66.set("argnames", new String[]{"f", "f1"});
        reflect_EntityPlayer_method_moveEntityWithHeading_66.set("argtypes", new String[]{"float", "float"});
        reflect_EntityPlayer_method_moveEntityWithHeading_66.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayer) params.getReflective("_self")).moveEntityWithHeading((float) params.getFloat("f"), (float) params.getFloat("f1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_moveEntityWithHeading_66);


        BaseData reflect_EntityPlayer_method_getAIMoveSpeed_67 = new ModData();
        reflect_EntityPlayer_method_getAIMoveSpeed_67.set("methodName", "getAIMoveSpeed");
        reflect_EntityPlayer_method_getAIMoveSpeed_67.set("returnType", "float");
        reflect_EntityPlayer_method_getAIMoveSpeed_67.set("static", false);
        reflect_EntityPlayer_method_getAIMoveSpeed_67.set("argnames", new String[]{});
        reflect_EntityPlayer_method_getAIMoveSpeed_67.set("argtypes", new String[]{});
        reflect_EntityPlayer_method_getAIMoveSpeed_67.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityPlayer) params.getReflective("_self")).getAIMoveSpeed();
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_getAIMoveSpeed_67);


        BaseData reflect_EntityPlayer_method_addMovementStat_68 = new ModData();
        reflect_EntityPlayer_method_addMovementStat_68.set("methodName", "addMovementStat");
        reflect_EntityPlayer_method_addMovementStat_68.set("returnType", "void");
        reflect_EntityPlayer_method_addMovementStat_68.set("static", false);
        reflect_EntityPlayer_method_addMovementStat_68.set("argnames", new String[]{"parDouble1", "parDouble2", "parDouble3"});
        reflect_EntityPlayer_method_addMovementStat_68.set("argtypes", new String[]{"double", "double", "double"});
        reflect_EntityPlayer_method_addMovementStat_68.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayer) params.getReflective("_self")).addMovementStat((double) params.getDouble("parDouble1"), (double) params.getDouble("parDouble2"), (double) params.getDouble("parDouble3"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_addMovementStat_68);


        BaseData reflect_EntityPlayer_method_fall_69 = new ModData();
        reflect_EntityPlayer_method_fall_69.set("methodName", "fall");
        reflect_EntityPlayer_method_fall_69.set("returnType", "void");
        reflect_EntityPlayer_method_fall_69.set("static", false);
        reflect_EntityPlayer_method_fall_69.set("argnames", new String[]{"f", "f1"});
        reflect_EntityPlayer_method_fall_69.set("argtypes", new String[]{"float", "float"});
        reflect_EntityPlayer_method_fall_69.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayer) params.getReflective("_self")).fall((float) params.getFloat("f"), (float) params.getFloat("f1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_fall_69);


        BaseData reflect_EntityPlayer_method_onKillEntity_70 = new ModData();
        reflect_EntityPlayer_method_onKillEntity_70.set("methodName", "onKillEntity");
        reflect_EntityPlayer_method_onKillEntity_70.set("returnType", "void");
        reflect_EntityPlayer_method_onKillEntity_70.set("static", false);
        reflect_EntityPlayer_method_onKillEntity_70.set("argnames", new String[]{"entitylivingbase"});
        reflect_EntityPlayer_method_onKillEntity_70.set("argtypes", new String[]{"EntityLivingBase"});
        reflect_EntityPlayer_method_onKillEntity_70.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayer) params.getReflective("_self")).onKillEntity((EntityLivingBase) params.getReflective("entitylivingbase"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_onKillEntity_70);


        BaseData reflect_EntityPlayer_method_setInWeb_71 = new ModData();
        reflect_EntityPlayer_method_setInWeb_71.set("methodName", "setInWeb");
        reflect_EntityPlayer_method_setInWeb_71.set("returnType", "void");
        reflect_EntityPlayer_method_setInWeb_71.set("static", false);
        reflect_EntityPlayer_method_setInWeb_71.set("argnames", new String[]{});
        reflect_EntityPlayer_method_setInWeb_71.set("argtypes", new String[]{});
        reflect_EntityPlayer_method_setInWeb_71.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayer) params.getReflective("_self")).setInWeb();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_setInWeb_71);


        BaseData reflect_EntityPlayer_method_getCurrentArmor_72 = new ModData();
        reflect_EntityPlayer_method_getCurrentArmor_72.set("methodName", "getCurrentArmor");
        reflect_EntityPlayer_method_getCurrentArmor_72.set("returnType", "ItemStack");
        reflect_EntityPlayer_method_getCurrentArmor_72.set("static", false);
        reflect_EntityPlayer_method_getCurrentArmor_72.set("argnames", new String[]{"i"});
        reflect_EntityPlayer_method_getCurrentArmor_72.set("argtypes", new String[]{"int"});
        reflect_EntityPlayer_method_getCurrentArmor_72.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (ItemStack) ((EntityPlayer) params.getReflective("_self")).getCurrentArmor((int) params.getInt("i"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_getCurrentArmor_72);


        BaseData reflect_EntityPlayer_method_addExperience_73 = new ModData();
        reflect_EntityPlayer_method_addExperience_73.set("methodName", "addExperience");
        reflect_EntityPlayer_method_addExperience_73.set("returnType", "void");
        reflect_EntityPlayer_method_addExperience_73.set("static", false);
        reflect_EntityPlayer_method_addExperience_73.set("argnames", new String[]{"amount"});
        reflect_EntityPlayer_method_addExperience_73.set("argtypes", new String[]{"int"});
        reflect_EntityPlayer_method_addExperience_73.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayer) params.getReflective("_self")).addExperience((int) params.getInt("amount"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_addExperience_73);


        BaseData reflect_EntityPlayer_method_getXPSeed_74 = new ModData();
        reflect_EntityPlayer_method_getXPSeed_74.set("methodName", "getXPSeed");
        reflect_EntityPlayer_method_getXPSeed_74.set("returnType", "int");
        reflect_EntityPlayer_method_getXPSeed_74.set("static", false);
        reflect_EntityPlayer_method_getXPSeed_74.set("argnames", new String[]{});
        reflect_EntityPlayer_method_getXPSeed_74.set("argtypes", new String[]{});
        reflect_EntityPlayer_method_getXPSeed_74.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityPlayer) params.getReflective("_self")).getXPSeed();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_getXPSeed_74);


        BaseData reflect_EntityPlayer_method_removeExperienceLevel_75 = new ModData();
        reflect_EntityPlayer_method_removeExperienceLevel_75.set("methodName", "removeExperienceLevel");
        reflect_EntityPlayer_method_removeExperienceLevel_75.set("returnType", "void");
        reflect_EntityPlayer_method_removeExperienceLevel_75.set("static", false);
        reflect_EntityPlayer_method_removeExperienceLevel_75.set("argnames", new String[]{"i"});
        reflect_EntityPlayer_method_removeExperienceLevel_75.set("argtypes", new String[]{"int"});
        reflect_EntityPlayer_method_removeExperienceLevel_75.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayer) params.getReflective("_self")).removeExperienceLevel((int) params.getInt("i"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_removeExperienceLevel_75);


        BaseData reflect_EntityPlayer_method_addExperienceLevel_76 = new ModData();
        reflect_EntityPlayer_method_addExperienceLevel_76.set("methodName", "addExperienceLevel");
        reflect_EntityPlayer_method_addExperienceLevel_76.set("returnType", "void");
        reflect_EntityPlayer_method_addExperienceLevel_76.set("static", false);
        reflect_EntityPlayer_method_addExperienceLevel_76.set("argnames", new String[]{"i"});
        reflect_EntityPlayer_method_addExperienceLevel_76.set("argtypes", new String[]{"int"});
        reflect_EntityPlayer_method_addExperienceLevel_76.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayer) params.getReflective("_self")).addExperienceLevel((int) params.getInt("i"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_addExperienceLevel_76);


        BaseData reflect_EntityPlayer_method_xpBarCap_77 = new ModData();
        reflect_EntityPlayer_method_xpBarCap_77.set("methodName", "xpBarCap");
        reflect_EntityPlayer_method_xpBarCap_77.set("returnType", "int");
        reflect_EntityPlayer_method_xpBarCap_77.set("static", false);
        reflect_EntityPlayer_method_xpBarCap_77.set("argnames", new String[]{});
        reflect_EntityPlayer_method_xpBarCap_77.set("argtypes", new String[]{});
        reflect_EntityPlayer_method_xpBarCap_77.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityPlayer) params.getReflective("_self")).xpBarCap();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_xpBarCap_77);


        BaseData reflect_EntityPlayer_method_addExhaustion_78 = new ModData();
        reflect_EntityPlayer_method_addExhaustion_78.set("methodName", "addExhaustion");
        reflect_EntityPlayer_method_addExhaustion_78.set("returnType", "void");
        reflect_EntityPlayer_method_addExhaustion_78.set("static", false);
        reflect_EntityPlayer_method_addExhaustion_78.set("argnames", new String[]{"parFloat1"});
        reflect_EntityPlayer_method_addExhaustion_78.set("argtypes", new String[]{"float"});
        reflect_EntityPlayer_method_addExhaustion_78.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayer) params.getReflective("_self")).addExhaustion((float) params.getFloat("parFloat1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_addExhaustion_78);


        BaseData reflect_EntityPlayer_method_getFoodStats_79 = new ModData();
        reflect_EntityPlayer_method_getFoodStats_79.set("methodName", "getFoodStats");
        reflect_EntityPlayer_method_getFoodStats_79.set("returnType", "FoodStats");
        reflect_EntityPlayer_method_getFoodStats_79.set("static", false);
        reflect_EntityPlayer_method_getFoodStats_79.set("argnames", new String[]{});
        reflect_EntityPlayer_method_getFoodStats_79.set("argtypes", new String[]{});
        reflect_EntityPlayer_method_getFoodStats_79.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (FoodStats) ((EntityPlayer) params.getReflective("_self")).getFoodStats();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_getFoodStats_79);


        BaseData reflect_EntityPlayer_method_canEat_80 = new ModData();
        reflect_EntityPlayer_method_canEat_80.set("methodName", "canEat");
        reflect_EntityPlayer_method_canEat_80.set("returnType", "boolean");
        reflect_EntityPlayer_method_canEat_80.set("static", false);
        reflect_EntityPlayer_method_canEat_80.set("argnames", new String[]{"ignoreHunger"});
        reflect_EntityPlayer_method_canEat_80.set("argtypes", new String[]{"boolean"});
        reflect_EntityPlayer_method_canEat_80.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityPlayer) params.getReflective("_self")).canEat((boolean) params.getBoolean("ignoreHunger"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_canEat_80);


        BaseData reflect_EntityPlayer_method_shouldHeal_81 = new ModData();
        reflect_EntityPlayer_method_shouldHeal_81.set("methodName", "shouldHeal");
        reflect_EntityPlayer_method_shouldHeal_81.set("returnType", "boolean");
        reflect_EntityPlayer_method_shouldHeal_81.set("static", false);
        reflect_EntityPlayer_method_shouldHeal_81.set("argnames", new String[]{});
        reflect_EntityPlayer_method_shouldHeal_81.set("argtypes", new String[]{});
        reflect_EntityPlayer_method_shouldHeal_81.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityPlayer) params.getReflective("_self")).shouldHeal();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_shouldHeal_81);


        BaseData reflect_EntityPlayer_method_setItemInUse_82 = new ModData();
        reflect_EntityPlayer_method_setItemInUse_82.set("methodName", "setItemInUse");
        reflect_EntityPlayer_method_setItemInUse_82.set("returnType", "void");
        reflect_EntityPlayer_method_setItemInUse_82.set("static", false);
        reflect_EntityPlayer_method_setItemInUse_82.set("argnames", new String[]{"itemstack", "i"});
        reflect_EntityPlayer_method_setItemInUse_82.set("argtypes", new String[]{"ItemStack", "int"});
        reflect_EntityPlayer_method_setItemInUse_82.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayer) params.getReflective("_self")).setItemInUse((ItemStack) params.getReflective("itemstack"), (int) params.getInt("i"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_setItemInUse_82);


        BaseData reflect_EntityPlayer_method_isAllowEdit_83 = new ModData();
        reflect_EntityPlayer_method_isAllowEdit_83.set("methodName", "isAllowEdit");
        reflect_EntityPlayer_method_isAllowEdit_83.set("returnType", "boolean");
        reflect_EntityPlayer_method_isAllowEdit_83.set("static", false);
        reflect_EntityPlayer_method_isAllowEdit_83.set("argnames", new String[]{});
        reflect_EntityPlayer_method_isAllowEdit_83.set("argtypes", new String[]{});
        reflect_EntityPlayer_method_isAllowEdit_83.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityPlayer) params.getReflective("_self")).isAllowEdit();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_isAllowEdit_83);


        BaseData reflect_EntityPlayer_method_canPlayerEdit_84 = new ModData();
        reflect_EntityPlayer_method_canPlayerEdit_84.set("methodName", "canPlayerEdit");
        reflect_EntityPlayer_method_canPlayerEdit_84.set("returnType", "boolean");
        reflect_EntityPlayer_method_canPlayerEdit_84.set("static", false);
        reflect_EntityPlayer_method_canPlayerEdit_84.set("argnames", new String[]{"parBlockPos", "parEnumFacing", "parItemStack"});
        reflect_EntityPlayer_method_canPlayerEdit_84.set("argtypes", new String[]{"BlockPos", "EnumFacing", "ItemStack"});
        reflect_EntityPlayer_method_canPlayerEdit_84.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityPlayer) params.getReflective("_self")).canPlayerEdit((BlockPos) params.getReflective("parBlockPos"), (EnumFacing) params.getReflective("parEnumFacing"), (ItemStack) params.getReflective("parItemStack"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_canPlayerEdit_84);


        BaseData reflect_EntityPlayer_method_getAlwaysRenderNameTagForRender_85 = new ModData();
        reflect_EntityPlayer_method_getAlwaysRenderNameTagForRender_85.set("methodName", "getAlwaysRenderNameTagForRender");
        reflect_EntityPlayer_method_getAlwaysRenderNameTagForRender_85.set("returnType", "boolean");
        reflect_EntityPlayer_method_getAlwaysRenderNameTagForRender_85.set("static", false);
        reflect_EntityPlayer_method_getAlwaysRenderNameTagForRender_85.set("argnames", new String[]{});
        reflect_EntityPlayer_method_getAlwaysRenderNameTagForRender_85.set("argtypes", new String[]{});
        reflect_EntityPlayer_method_getAlwaysRenderNameTagForRender_85.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityPlayer) params.getReflective("_self")).getAlwaysRenderNameTagForRender();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_getAlwaysRenderNameTagForRender_85);


        BaseData reflect_EntityPlayer_method_clonePlayer_86 = new ModData();
        reflect_EntityPlayer_method_clonePlayer_86.set("methodName", "clonePlayer");
        reflect_EntityPlayer_method_clonePlayer_86.set("returnType", "void");
        reflect_EntityPlayer_method_clonePlayer_86.set("static", false);
        reflect_EntityPlayer_method_clonePlayer_86.set("argnames", new String[]{"entityplayer", "flag"});
        reflect_EntityPlayer_method_clonePlayer_86.set("argtypes", new String[]{"EntityPlayer", "boolean"});
        reflect_EntityPlayer_method_clonePlayer_86.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayer) params.getReflective("_self")).clonePlayer((EntityPlayer) params.getReflective("entityplayer"), (boolean) params.getBoolean("flag"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_clonePlayer_86);


        BaseData reflect_EntityPlayer_method_sendPlayerAbilities_87 = new ModData();
        reflect_EntityPlayer_method_sendPlayerAbilities_87.set("methodName", "sendPlayerAbilities");
        reflect_EntityPlayer_method_sendPlayerAbilities_87.set("returnType", "void");
        reflect_EntityPlayer_method_sendPlayerAbilities_87.set("static", false);
        reflect_EntityPlayer_method_sendPlayerAbilities_87.set("argnames", new String[]{});
        reflect_EntityPlayer_method_sendPlayerAbilities_87.set("argtypes", new String[]{});
        reflect_EntityPlayer_method_sendPlayerAbilities_87.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayer) params.getReflective("_self")).sendPlayerAbilities();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_sendPlayerAbilities_87);


        BaseData reflect_EntityPlayer_method_getName_89 = new ModData();
        reflect_EntityPlayer_method_getName_89.set("methodName", "getName");
        reflect_EntityPlayer_method_getName_89.set("returnType", "String");
        reflect_EntityPlayer_method_getName_89.set("static", false);
        reflect_EntityPlayer_method_getName_89.set("argnames", new String[]{});
        reflect_EntityPlayer_method_getName_89.set("argtypes", new String[]{});
        reflect_EntityPlayer_method_getName_89.setCallbackStringWithDataArg("exec", (BaseData params) -> {
                try {
                    return (String) ((EntityPlayer) params.getReflective("_self")).getName();
                } catch (Exception _exception_reflect_) {
                    return "";
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_getName_89);


        BaseData reflect_EntityPlayer_method_getInventoryEnderChest_90 = new ModData();
        reflect_EntityPlayer_method_getInventoryEnderChest_90.set("methodName", "getInventoryEnderChest");
        reflect_EntityPlayer_method_getInventoryEnderChest_90.set("returnType", "InventoryEnderChest");
        reflect_EntityPlayer_method_getInventoryEnderChest_90.set("static", false);
        reflect_EntityPlayer_method_getInventoryEnderChest_90.set("argnames", new String[]{});
        reflect_EntityPlayer_method_getInventoryEnderChest_90.set("argtypes", new String[]{});
        reflect_EntityPlayer_method_getInventoryEnderChest_90.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (InventoryEnderChest) ((EntityPlayer) params.getReflective("_self")).getInventoryEnderChest();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_getInventoryEnderChest_90);


        BaseData reflect_EntityPlayer_method_getEquipmentInSlot_91 = new ModData();
        reflect_EntityPlayer_method_getEquipmentInSlot_91.set("methodName", "getEquipmentInSlot");
        reflect_EntityPlayer_method_getEquipmentInSlot_91.set("returnType", "ItemStack");
        reflect_EntityPlayer_method_getEquipmentInSlot_91.set("static", false);
        reflect_EntityPlayer_method_getEquipmentInSlot_91.set("argnames", new String[]{"i"});
        reflect_EntityPlayer_method_getEquipmentInSlot_91.set("argtypes", new String[]{"int"});
        reflect_EntityPlayer_method_getEquipmentInSlot_91.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (ItemStack) ((EntityPlayer) params.getReflective("_self")).getEquipmentInSlot((int) params.getInt("i"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_getEquipmentInSlot_91);


        BaseData reflect_EntityPlayer_method_getHeldItem_92 = new ModData();
        reflect_EntityPlayer_method_getHeldItem_92.set("methodName", "getHeldItem");
        reflect_EntityPlayer_method_getHeldItem_92.set("returnType", "ItemStack");
        reflect_EntityPlayer_method_getHeldItem_92.set("static", false);
        reflect_EntityPlayer_method_getHeldItem_92.set("argnames", new String[]{});
        reflect_EntityPlayer_method_getHeldItem_92.set("argtypes", new String[]{});
        reflect_EntityPlayer_method_getHeldItem_92.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (ItemStack) ((EntityPlayer) params.getReflective("_self")).getHeldItem();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_getHeldItem_92);


        BaseData reflect_EntityPlayer_method_setCurrentItemOrArmor_93 = new ModData();
        reflect_EntityPlayer_method_setCurrentItemOrArmor_93.set("methodName", "setCurrentItemOrArmor");
        reflect_EntityPlayer_method_setCurrentItemOrArmor_93.set("returnType", "void");
        reflect_EntityPlayer_method_setCurrentItemOrArmor_93.set("static", false);
        reflect_EntityPlayer_method_setCurrentItemOrArmor_93.set("argnames", new String[]{"i", "itemstack"});
        reflect_EntityPlayer_method_setCurrentItemOrArmor_93.set("argtypes", new String[]{"int", "ItemStack"});
        reflect_EntityPlayer_method_setCurrentItemOrArmor_93.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayer) params.getReflective("_self")).setCurrentItemOrArmor((int) params.getInt("i"), (ItemStack) params.getReflective("itemstack"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_setCurrentItemOrArmor_93);


        BaseData reflect_EntityPlayer_method_isInvisibleToPlayer_94 = new ModData();
        reflect_EntityPlayer_method_isInvisibleToPlayer_94.set("methodName", "isInvisibleToPlayer");
        reflect_EntityPlayer_method_isInvisibleToPlayer_94.set("returnType", "boolean");
        reflect_EntityPlayer_method_isInvisibleToPlayer_94.set("static", false);
        reflect_EntityPlayer_method_isInvisibleToPlayer_94.set("argnames", new String[]{"entityplayer"});
        reflect_EntityPlayer_method_isInvisibleToPlayer_94.set("argtypes", new String[]{"EntityPlayer"});
        reflect_EntityPlayer_method_isInvisibleToPlayer_94.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityPlayer) params.getReflective("_self")).isInvisibleToPlayer((EntityPlayer) params.getReflective("entityplayer"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_isInvisibleToPlayer_94);


        BaseData reflect_EntityPlayer_method_getInventory_95 = new ModData();
        reflect_EntityPlayer_method_getInventory_95.set("methodName", "getInventory");
        reflect_EntityPlayer_method_getInventory_95.set("returnType", "ItemStack[]");
        reflect_EntityPlayer_method_getInventory_95.set("static", false);
        reflect_EntityPlayer_method_getInventory_95.set("argnames", new String[]{});
        reflect_EntityPlayer_method_getInventory_95.set("argtypes", new String[]{});
        reflect_EntityPlayer_method_getInventory_95.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (ItemStack[]) ((EntityPlayer) params.getReflective("_self")).getInventory();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_getInventory_95);


        BaseData reflect_EntityPlayer_method_isPushedByWater_96 = new ModData();
        reflect_EntityPlayer_method_isPushedByWater_96.set("methodName", "isPushedByWater");
        reflect_EntityPlayer_method_isPushedByWater_96.set("returnType", "boolean");
        reflect_EntityPlayer_method_isPushedByWater_96.set("static", false);
        reflect_EntityPlayer_method_isPushedByWater_96.set("argnames", new String[]{});
        reflect_EntityPlayer_method_isPushedByWater_96.set("argtypes", new String[]{});
        reflect_EntityPlayer_method_isPushedByWater_96.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityPlayer) params.getReflective("_self")).isPushedByWater();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_isPushedByWater_96);


        BaseData reflect_EntityPlayer_method_getWorldScoreboard_97 = new ModData();
        reflect_EntityPlayer_method_getWorldScoreboard_97.set("methodName", "getWorldScoreboard");
        reflect_EntityPlayer_method_getWorldScoreboard_97.set("returnType", "Scoreboard");
        reflect_EntityPlayer_method_getWorldScoreboard_97.set("static", false);
        reflect_EntityPlayer_method_getWorldScoreboard_97.set("argnames", new String[]{});
        reflect_EntityPlayer_method_getWorldScoreboard_97.set("argtypes", new String[]{});
        reflect_EntityPlayer_method_getWorldScoreboard_97.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Scoreboard) ((EntityPlayer) params.getReflective("_self")).getWorldScoreboard();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_getWorldScoreboard_97);


        BaseData reflect_EntityPlayer_method_getTeam_98 = new ModData();
        reflect_EntityPlayer_method_getTeam_98.set("methodName", "getTeam");
        reflect_EntityPlayer_method_getTeam_98.set("returnType", "Team");
        reflect_EntityPlayer_method_getTeam_98.set("static", false);
        reflect_EntityPlayer_method_getTeam_98.set("argnames", new String[]{});
        reflect_EntityPlayer_method_getTeam_98.set("argtypes", new String[]{});
        reflect_EntityPlayer_method_getTeam_98.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Team) ((EntityPlayer) params.getReflective("_self")).getTeam();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_getTeam_98);


        BaseData reflect_EntityPlayer_method_getDisplayName_99 = new ModData();
        reflect_EntityPlayer_method_getDisplayName_99.set("methodName", "getDisplayName");
        reflect_EntityPlayer_method_getDisplayName_99.set("returnType", "IChatComponent");
        reflect_EntityPlayer_method_getDisplayName_99.set("static", false);
        reflect_EntityPlayer_method_getDisplayName_99.set("argnames", new String[]{});
        reflect_EntityPlayer_method_getDisplayName_99.set("argtypes", new String[]{});
        reflect_EntityPlayer_method_getDisplayName_99.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (IChatComponent) ((EntityPlayer) params.getReflective("_self")).getDisplayName();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_getDisplayName_99);


        BaseData reflect_EntityPlayer_method_getEyeHeight_100 = new ModData();
        reflect_EntityPlayer_method_getEyeHeight_100.set("methodName", "getEyeHeight");
        reflect_EntityPlayer_method_getEyeHeight_100.set("returnType", "float");
        reflect_EntityPlayer_method_getEyeHeight_100.set("static", false);
        reflect_EntityPlayer_method_getEyeHeight_100.set("argnames", new String[]{});
        reflect_EntityPlayer_method_getEyeHeight_100.set("argtypes", new String[]{});
        reflect_EntityPlayer_method_getEyeHeight_100.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityPlayer) params.getReflective("_self")).getEyeHeight();
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_getEyeHeight_100);


        BaseData reflect_EntityPlayer_method_setAbsorptionAmount_101 = new ModData();
        reflect_EntityPlayer_method_setAbsorptionAmount_101.set("methodName", "setAbsorptionAmount");
        reflect_EntityPlayer_method_setAbsorptionAmount_101.set("returnType", "void");
        reflect_EntityPlayer_method_setAbsorptionAmount_101.set("static", false);
        reflect_EntityPlayer_method_setAbsorptionAmount_101.set("argnames", new String[]{"f"});
        reflect_EntityPlayer_method_setAbsorptionAmount_101.set("argtypes", new String[]{"float"});
        reflect_EntityPlayer_method_setAbsorptionAmount_101.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayer) params.getReflective("_self")).setAbsorptionAmount((float) params.getFloat("f"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_setAbsorptionAmount_101);


        BaseData reflect_EntityPlayer_method_getAbsorptionAmount_102 = new ModData();
        reflect_EntityPlayer_method_getAbsorptionAmount_102.set("methodName", "getAbsorptionAmount");
        reflect_EntityPlayer_method_getAbsorptionAmount_102.set("returnType", "float");
        reflect_EntityPlayer_method_getAbsorptionAmount_102.set("static", false);
        reflect_EntityPlayer_method_getAbsorptionAmount_102.set("argnames", new String[]{});
        reflect_EntityPlayer_method_getAbsorptionAmount_102.set("argtypes", new String[]{});
        reflect_EntityPlayer_method_getAbsorptionAmount_102.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityPlayer) params.getReflective("_self")).getAbsorptionAmount();
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_getAbsorptionAmount_102);


        BaseData reflect_EntityPlayer_method_getUUID_103 = new ModData();
        reflect_EntityPlayer_method_getUUID_103.set("methodName", "getUUID");
        reflect_EntityPlayer_method_getUUID_103.set("returnType", "EaglercraftUUID");
        reflect_EntityPlayer_method_getUUID_103.set("static", true);
        reflect_EntityPlayer_method_getUUID_103.set("argnames", new String[]{"profile"});
        reflect_EntityPlayer_method_getUUID_103.set("argtypes", new String[]{"GameProfile"});
        reflect_EntityPlayer_method_getUUID_103.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EaglercraftUUID) EntityPlayer.getUUID((GameProfile) params.getReflective("profile"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_getUUID_103);


        BaseData reflect_EntityPlayer_method_getOfflineUUID_104 = new ModData();
        reflect_EntityPlayer_method_getOfflineUUID_104.set("methodName", "getOfflineUUID");
        reflect_EntityPlayer_method_getOfflineUUID_104.set("returnType", "EaglercraftUUID");
        reflect_EntityPlayer_method_getOfflineUUID_104.set("static", true);
        reflect_EntityPlayer_method_getOfflineUUID_104.set("argnames", new String[]{"username"});
        reflect_EntityPlayer_method_getOfflineUUID_104.set("argtypes", new String[]{"String"});
        reflect_EntityPlayer_method_getOfflineUUID_104.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EaglercraftUUID) EntityPlayer.getOfflineUUID((String) params.getString("username"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_getOfflineUUID_104);


        BaseData reflect_EntityPlayer_method_canOpen_105 = new ModData();
        reflect_EntityPlayer_method_canOpen_105.set("methodName", "canOpen");
        reflect_EntityPlayer_method_canOpen_105.set("returnType", "boolean");
        reflect_EntityPlayer_method_canOpen_105.set("static", false);
        reflect_EntityPlayer_method_canOpen_105.set("argnames", new String[]{"code"});
        reflect_EntityPlayer_method_canOpen_105.set("argtypes", new String[]{"LockCode"});
        reflect_EntityPlayer_method_canOpen_105.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityPlayer) params.getReflective("_self")).canOpen((LockCode) params.getReflective("code"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_canOpen_105);


        BaseData reflect_EntityPlayer_method_isWearing_106 = new ModData();
        reflect_EntityPlayer_method_isWearing_106.set("methodName", "isWearing");
        reflect_EntityPlayer_method_isWearing_106.set("returnType", "boolean");
        reflect_EntityPlayer_method_isWearing_106.set("static", false);
        reflect_EntityPlayer_method_isWearing_106.set("argnames", new String[]{"parEnumPlayerModelParts"});
        reflect_EntityPlayer_method_isWearing_106.set("argtypes", new String[]{"EnumPlayerModelParts"});
        reflect_EntityPlayer_method_isWearing_106.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityPlayer) params.getReflective("_self")).isWearing((EnumPlayerModelParts) params.getReflective("parEnumPlayerModelParts"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_isWearing_106);


        BaseData reflect_EntityPlayer_method_sendCommandFeedback_107 = new ModData();
        reflect_EntityPlayer_method_sendCommandFeedback_107.set("methodName", "sendCommandFeedback");
        reflect_EntityPlayer_method_sendCommandFeedback_107.set("returnType", "boolean");
        reflect_EntityPlayer_method_sendCommandFeedback_107.set("static", false);
        reflect_EntityPlayer_method_sendCommandFeedback_107.set("argnames", new String[]{});
        reflect_EntityPlayer_method_sendCommandFeedback_107.set("argtypes", new String[]{});
        reflect_EntityPlayer_method_sendCommandFeedback_107.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityPlayer) params.getReflective("_self")).sendCommandFeedback();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_sendCommandFeedback_107);


        BaseData reflect_EntityPlayer_method_replaceItemInInventory_108 = new ModData();
        reflect_EntityPlayer_method_replaceItemInInventory_108.set("methodName", "replaceItemInInventory");
        reflect_EntityPlayer_method_replaceItemInInventory_108.set("returnType", "boolean");
        reflect_EntityPlayer_method_replaceItemInInventory_108.set("static", false);
        reflect_EntityPlayer_method_replaceItemInInventory_108.set("argnames", new String[]{"i", "itemstack"});
        reflect_EntityPlayer_method_replaceItemInInventory_108.set("argtypes", new String[]{"int", "ItemStack"});
        reflect_EntityPlayer_method_replaceItemInInventory_108.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityPlayer) params.getReflective("_self")).replaceItemInInventory((int) params.getInt("i"), (ItemStack) params.getReflective("itemstack"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_replaceItemInInventory_108);


        BaseData reflect_EntityPlayer_method_hasReducedDebug_109 = new ModData();
        reflect_EntityPlayer_method_hasReducedDebug_109.set("methodName", "hasReducedDebug");
        reflect_EntityPlayer_method_hasReducedDebug_109.set("returnType", "boolean");
        reflect_EntityPlayer_method_hasReducedDebug_109.set("static", false);
        reflect_EntityPlayer_method_hasReducedDebug_109.set("argnames", new String[]{});
        reflect_EntityPlayer_method_hasReducedDebug_109.set("argtypes", new String[]{});
        reflect_EntityPlayer_method_hasReducedDebug_109.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityPlayer) params.getReflective("_self")).hasReducedDebug();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_hasReducedDebug_109);


        BaseData reflect_EntityPlayer_method_setReducedDebug_110 = new ModData();
        reflect_EntityPlayer_method_setReducedDebug_110.set("methodName", "setReducedDebug");
        reflect_EntityPlayer_method_setReducedDebug_110.set("returnType", "void");
        reflect_EntityPlayer_method_setReducedDebug_110.set("static", false);
        reflect_EntityPlayer_method_setReducedDebug_110.set("argnames", new String[]{"reducedDebug"});
        reflect_EntityPlayer_method_setReducedDebug_110.set("argtypes", new String[]{"boolean"});
        reflect_EntityPlayer_method_setReducedDebug_110.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayer) params.getReflective("_self")).setReducedDebug((boolean) params.getBoolean("reducedDebug"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayer_methods.add(reflect_EntityPlayer_method_setReducedDebug_110);


        BaseData[] reflect_EntityPlayer_methods_arr = new BaseData[reflect_EntityPlayer_methods.size()];
        for (int i = 0; i < reflect_EntityPlayer_methods_arr.length; i++) {
            reflect_EntityPlayer_methods_arr[i] = reflect_EntityPlayer_methods.get(i);
        }

        reflect_EntityPlayer.set("constructors", reflect_EntityPlayer_constructors_arr);
        reflect_EntityPlayer.set("methods", reflect_EntityPlayer_methods_arr);
        reflect_EntityPlayer.set("className", "EntityPlayer");
        reflect_EntityPlayer.set("classId", "net.minecraft.entity.player.EntityPlayer");
        reflect_EntityPlayer.set("class", EntityPlayer.class);
        reflect_EntityPlayer.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityPlayer;
        });
        reflectProfiles.add(reflect_EntityPlayer);
    }


    //classdef for EntityPlayerMP
    public static void reflect_EntityPlayerMP_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityPlayerMP = new ModData();

        ArrayList<BaseData> reflect_EntityPlayerMP_constructors = new ArrayList<BaseData>();
        
        BaseData[] reflect_EntityPlayerMP_constructors_arr = new BaseData[reflect_EntityPlayerMP_constructors.size()];
        for (int i = 0; i < reflect_EntityPlayerMP_constructors_arr.length; i++) {
            reflect_EntityPlayerMP_constructors_arr[i] = reflect_EntityPlayerMP_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityPlayerMP_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityPlayerMP_method_readEntityFromNBT_0 = new ModData();
        reflect_EntityPlayerMP_method_readEntityFromNBT_0.set("methodName", "readEntityFromNBT");
        reflect_EntityPlayerMP_method_readEntityFromNBT_0.set("returnType", "void");
        reflect_EntityPlayerMP_method_readEntityFromNBT_0.set("static", false);
        reflect_EntityPlayerMP_method_readEntityFromNBT_0.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityPlayerMP_method_readEntityFromNBT_0.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityPlayerMP_method_readEntityFromNBT_0.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerMP) params.getReflective("_self")).readEntityFromNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_readEntityFromNBT_0);


        BaseData reflect_EntityPlayerMP_method_writeEntityToNBT_1 = new ModData();
        reflect_EntityPlayerMP_method_writeEntityToNBT_1.set("methodName", "writeEntityToNBT");
        reflect_EntityPlayerMP_method_writeEntityToNBT_1.set("returnType", "void");
        reflect_EntityPlayerMP_method_writeEntityToNBT_1.set("static", false);
        reflect_EntityPlayerMP_method_writeEntityToNBT_1.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityPlayerMP_method_writeEntityToNBT_1.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityPlayerMP_method_writeEntityToNBT_1.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerMP) params.getReflective("_self")).writeEntityToNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_writeEntityToNBT_1);


        BaseData reflect_EntityPlayerMP_method_addExperienceLevel_2 = new ModData();
        reflect_EntityPlayerMP_method_addExperienceLevel_2.set("methodName", "addExperienceLevel");
        reflect_EntityPlayerMP_method_addExperienceLevel_2.set("returnType", "void");
        reflect_EntityPlayerMP_method_addExperienceLevel_2.set("static", false);
        reflect_EntityPlayerMP_method_addExperienceLevel_2.set("argnames", new String[]{"levels"});
        reflect_EntityPlayerMP_method_addExperienceLevel_2.set("argtypes", new String[]{"int"});
        reflect_EntityPlayerMP_method_addExperienceLevel_2.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerMP) params.getReflective("_self")).addExperienceLevel((int) params.getInt("levels"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_addExperienceLevel_2);


        BaseData reflect_EntityPlayerMP_method_removeExperienceLevel_3 = new ModData();
        reflect_EntityPlayerMP_method_removeExperienceLevel_3.set("methodName", "removeExperienceLevel");
        reflect_EntityPlayerMP_method_removeExperienceLevel_3.set("returnType", "void");
        reflect_EntityPlayerMP_method_removeExperienceLevel_3.set("static", false);
        reflect_EntityPlayerMP_method_removeExperienceLevel_3.set("argnames", new String[]{"levels"});
        reflect_EntityPlayerMP_method_removeExperienceLevel_3.set("argtypes", new String[]{"int"});
        reflect_EntityPlayerMP_method_removeExperienceLevel_3.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerMP) params.getReflective("_self")).removeExperienceLevel((int) params.getInt("levels"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_removeExperienceLevel_3);


        BaseData reflect_EntityPlayerMP_method_addSelfToInternalCraftingInventory_4 = new ModData();
        reflect_EntityPlayerMP_method_addSelfToInternalCraftingInventory_4.set("methodName", "addSelfToInternalCraftingInventory");
        reflect_EntityPlayerMP_method_addSelfToInternalCraftingInventory_4.set("returnType", "void");
        reflect_EntityPlayerMP_method_addSelfToInternalCraftingInventory_4.set("static", false);
        reflect_EntityPlayerMP_method_addSelfToInternalCraftingInventory_4.set("argnames", new String[]{});
        reflect_EntityPlayerMP_method_addSelfToInternalCraftingInventory_4.set("argtypes", new String[]{});
        reflect_EntityPlayerMP_method_addSelfToInternalCraftingInventory_4.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerMP) params.getReflective("_self")).addSelfToInternalCraftingInventory();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_addSelfToInternalCraftingInventory_4);


        BaseData reflect_EntityPlayerMP_method_sendEnterCombat_5 = new ModData();
        reflect_EntityPlayerMP_method_sendEnterCombat_5.set("methodName", "sendEnterCombat");
        reflect_EntityPlayerMP_method_sendEnterCombat_5.set("returnType", "void");
        reflect_EntityPlayerMP_method_sendEnterCombat_5.set("static", false);
        reflect_EntityPlayerMP_method_sendEnterCombat_5.set("argnames", new String[]{});
        reflect_EntityPlayerMP_method_sendEnterCombat_5.set("argtypes", new String[]{});
        reflect_EntityPlayerMP_method_sendEnterCombat_5.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerMP) params.getReflective("_self")).sendEnterCombat();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_sendEnterCombat_5);


        BaseData reflect_EntityPlayerMP_method_sendEndCombat_6 = new ModData();
        reflect_EntityPlayerMP_method_sendEndCombat_6.set("methodName", "sendEndCombat");
        reflect_EntityPlayerMP_method_sendEndCombat_6.set("returnType", "void");
        reflect_EntityPlayerMP_method_sendEndCombat_6.set("static", false);
        reflect_EntityPlayerMP_method_sendEndCombat_6.set("argnames", new String[]{});
        reflect_EntityPlayerMP_method_sendEndCombat_6.set("argtypes", new String[]{});
        reflect_EntityPlayerMP_method_sendEndCombat_6.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerMP) params.getReflective("_self")).sendEndCombat();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_sendEndCombat_6);


        BaseData reflect_EntityPlayerMP_method_onUpdate_7 = new ModData();
        reflect_EntityPlayerMP_method_onUpdate_7.set("methodName", "onUpdate");
        reflect_EntityPlayerMP_method_onUpdate_7.set("returnType", "void");
        reflect_EntityPlayerMP_method_onUpdate_7.set("static", false);
        reflect_EntityPlayerMP_method_onUpdate_7.set("argnames", new String[]{});
        reflect_EntityPlayerMP_method_onUpdate_7.set("argtypes", new String[]{});
        reflect_EntityPlayerMP_method_onUpdate_7.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerMP) params.getReflective("_self")).onUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_onUpdate_7);


        BaseData reflect_EntityPlayerMP_method_onUpdateEntity_8 = new ModData();
        reflect_EntityPlayerMP_method_onUpdateEntity_8.set("methodName", "onUpdateEntity");
        reflect_EntityPlayerMP_method_onUpdateEntity_8.set("returnType", "void");
        reflect_EntityPlayerMP_method_onUpdateEntity_8.set("static", false);
        reflect_EntityPlayerMP_method_onUpdateEntity_8.set("argnames", new String[]{});
        reflect_EntityPlayerMP_method_onUpdateEntity_8.set("argtypes", new String[]{});
        reflect_EntityPlayerMP_method_onUpdateEntity_8.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerMP) params.getReflective("_self")).onUpdateEntity();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_onUpdateEntity_8);


        BaseData reflect_EntityPlayerMP_method_onDeath_9 = new ModData();
        reflect_EntityPlayerMP_method_onDeath_9.set("methodName", "onDeath");
        reflect_EntityPlayerMP_method_onDeath_9.set("returnType", "void");
        reflect_EntityPlayerMP_method_onDeath_9.set("static", false);
        reflect_EntityPlayerMP_method_onDeath_9.set("argnames", new String[]{"cause"});
        reflect_EntityPlayerMP_method_onDeath_9.set("argtypes", new String[]{"DamageSource"});
        reflect_EntityPlayerMP_method_onDeath_9.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerMP) params.getReflective("_self")).onDeath((DamageSource) params.getReflective("cause"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_onDeath_9);


        BaseData reflect_EntityPlayerMP_method_attackEntityFrom_10 = new ModData();
        reflect_EntityPlayerMP_method_attackEntityFrom_10.set("methodName", "attackEntityFrom");
        reflect_EntityPlayerMP_method_attackEntityFrom_10.set("returnType", "boolean");
        reflect_EntityPlayerMP_method_attackEntityFrom_10.set("static", false);
        reflect_EntityPlayerMP_method_attackEntityFrom_10.set("argnames", new String[]{"damagesource", "f"});
        reflect_EntityPlayerMP_method_attackEntityFrom_10.set("argtypes", new String[]{"DamageSource", "float"});
        reflect_EntityPlayerMP_method_attackEntityFrom_10.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityPlayerMP) params.getReflective("_self")).attackEntityFrom((DamageSource) params.getReflective("damagesource"), (float) params.getFloat("f"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_attackEntityFrom_10);


        BaseData reflect_EntityPlayerMP_method_canAttackPlayer_11 = new ModData();
        reflect_EntityPlayerMP_method_canAttackPlayer_11.set("methodName", "canAttackPlayer");
        reflect_EntityPlayerMP_method_canAttackPlayer_11.set("returnType", "boolean");
        reflect_EntityPlayerMP_method_canAttackPlayer_11.set("static", false);
        reflect_EntityPlayerMP_method_canAttackPlayer_11.set("argnames", new String[]{"other"});
        reflect_EntityPlayerMP_method_canAttackPlayer_11.set("argtypes", new String[]{"EntityPlayer"});
        reflect_EntityPlayerMP_method_canAttackPlayer_11.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityPlayerMP) params.getReflective("_self")).canAttackPlayer((EntityPlayer) params.getReflective("other"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_canAttackPlayer_11);


        BaseData reflect_EntityPlayerMP_method_travelToDimension_12 = new ModData();
        reflect_EntityPlayerMP_method_travelToDimension_12.set("methodName", "travelToDimension");
        reflect_EntityPlayerMP_method_travelToDimension_12.set("returnType", "void");
        reflect_EntityPlayerMP_method_travelToDimension_12.set("static", false);
        reflect_EntityPlayerMP_method_travelToDimension_12.set("argnames", new String[]{"dimensionId"});
        reflect_EntityPlayerMP_method_travelToDimension_12.set("argtypes", new String[]{"int"});
        reflect_EntityPlayerMP_method_travelToDimension_12.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerMP) params.getReflective("_self")).travelToDimension((int) params.getInt("dimensionId"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_travelToDimension_12);


        BaseData reflect_EntityPlayerMP_method_isSpectatedByPlayer_13 = new ModData();
        reflect_EntityPlayerMP_method_isSpectatedByPlayer_13.set("methodName", "isSpectatedByPlayer");
        reflect_EntityPlayerMP_method_isSpectatedByPlayer_13.set("returnType", "boolean");
        reflect_EntityPlayerMP_method_isSpectatedByPlayer_13.set("static", false);
        reflect_EntityPlayerMP_method_isSpectatedByPlayer_13.set("argnames", new String[]{"player"});
        reflect_EntityPlayerMP_method_isSpectatedByPlayer_13.set("argtypes", new String[]{"EntityPlayerMP"});
        reflect_EntityPlayerMP_method_isSpectatedByPlayer_13.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityPlayerMP) params.getReflective("_self")).isSpectatedByPlayer((EntityPlayerMP) params.getReflective("player"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_isSpectatedByPlayer_13);


        BaseData reflect_EntityPlayerMP_method_onItemPickup_14 = new ModData();
        reflect_EntityPlayerMP_method_onItemPickup_14.set("methodName", "onItemPickup");
        reflect_EntityPlayerMP_method_onItemPickup_14.set("returnType", "void");
        reflect_EntityPlayerMP_method_onItemPickup_14.set("static", false);
        reflect_EntityPlayerMP_method_onItemPickup_14.set("argnames", new String[]{"parEntity", "parInt1"});
        reflect_EntityPlayerMP_method_onItemPickup_14.set("argtypes", new String[]{"Entity", "int"});
        reflect_EntityPlayerMP_method_onItemPickup_14.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerMP) params.getReflective("_self")).onItemPickup((Entity) params.getReflective("parEntity"), (int) params.getInt("parInt1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_onItemPickup_14);


        BaseData reflect_EntityPlayerMP_method_wakeUpPlayer_15 = new ModData();
        reflect_EntityPlayerMP_method_wakeUpPlayer_15.set("methodName", "wakeUpPlayer");
        reflect_EntityPlayerMP_method_wakeUpPlayer_15.set("returnType", "void");
        reflect_EntityPlayerMP_method_wakeUpPlayer_15.set("static", false);
        reflect_EntityPlayerMP_method_wakeUpPlayer_15.set("argnames", new String[]{"updateWorldFlag", "setSpawn", "parFlag3"});
        reflect_EntityPlayerMP_method_wakeUpPlayer_15.set("argtypes", new String[]{"boolean", "boolean", "boolean"});
        reflect_EntityPlayerMP_method_wakeUpPlayer_15.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerMP) params.getReflective("_self")).wakeUpPlayer((boolean) params.getBoolean("updateWorldFlag"), (boolean) params.getBoolean("setSpawn"), (boolean) params.getBoolean("parFlag3"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_wakeUpPlayer_15);


        BaseData reflect_EntityPlayerMP_method_mountEntity_16 = new ModData();
        reflect_EntityPlayerMP_method_mountEntity_16.set("methodName", "mountEntity");
        reflect_EntityPlayerMP_method_mountEntity_16.set("returnType", "void");
        reflect_EntityPlayerMP_method_mountEntity_16.set("static", false);
        reflect_EntityPlayerMP_method_mountEntity_16.set("argnames", new String[]{"entity"});
        reflect_EntityPlayerMP_method_mountEntity_16.set("argtypes", new String[]{"Entity"});
        reflect_EntityPlayerMP_method_mountEntity_16.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerMP) params.getReflective("_self")).mountEntity((Entity) params.getReflective("entity"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_mountEntity_16);


        BaseData reflect_EntityPlayerMP_method_handleFalling_17 = new ModData();
        reflect_EntityPlayerMP_method_handleFalling_17.set("methodName", "handleFalling");
        reflect_EntityPlayerMP_method_handleFalling_17.set("returnType", "void");
        reflect_EntityPlayerMP_method_handleFalling_17.set("static", false);
        reflect_EntityPlayerMP_method_handleFalling_17.set("argnames", new String[]{"parDouble1", "parFlag"});
        reflect_EntityPlayerMP_method_handleFalling_17.set("argtypes", new String[]{"double", "boolean"});
        reflect_EntityPlayerMP_method_handleFalling_17.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerMP) params.getReflective("_self")).handleFalling((double) params.getDouble("parDouble1"), (boolean) params.getBoolean("parFlag"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_handleFalling_17);


        BaseData reflect_EntityPlayerMP_method_openEditSign_18 = new ModData();
        reflect_EntityPlayerMP_method_openEditSign_18.set("methodName", "openEditSign");
        reflect_EntityPlayerMP_method_openEditSign_18.set("returnType", "void");
        reflect_EntityPlayerMP_method_openEditSign_18.set("static", false);
        reflect_EntityPlayerMP_method_openEditSign_18.set("argnames", new String[]{"tileentitysign"});
        reflect_EntityPlayerMP_method_openEditSign_18.set("argtypes", new String[]{"TileEntitySign"});
        reflect_EntityPlayerMP_method_openEditSign_18.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerMP) params.getReflective("_self")).openEditSign((TileEntitySign) params.getReflective("tileentitysign"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_openEditSign_18);


        BaseData reflect_EntityPlayerMP_method_displayGui_19 = new ModData();
        reflect_EntityPlayerMP_method_displayGui_19.set("methodName", "displayGui");
        reflect_EntityPlayerMP_method_displayGui_19.set("returnType", "void");
        reflect_EntityPlayerMP_method_displayGui_19.set("static", false);
        reflect_EntityPlayerMP_method_displayGui_19.set("argnames", new String[]{"iinteractionobject"});
        reflect_EntityPlayerMP_method_displayGui_19.set("argtypes", new String[]{"IInteractionObject"});
        reflect_EntityPlayerMP_method_displayGui_19.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerMP) params.getReflective("_self")).displayGui((IInteractionObject) params.getReflective("iinteractionobject"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_displayGui_19);


        BaseData reflect_EntityPlayerMP_method_displayGUIChest_20 = new ModData();
        reflect_EntityPlayerMP_method_displayGUIChest_20.set("methodName", "displayGUIChest");
        reflect_EntityPlayerMP_method_displayGUIChest_20.set("returnType", "void");
        reflect_EntityPlayerMP_method_displayGUIChest_20.set("static", false);
        reflect_EntityPlayerMP_method_displayGUIChest_20.set("argnames", new String[]{"iinventory"});
        reflect_EntityPlayerMP_method_displayGUIChest_20.set("argtypes", new String[]{"IInventory"});
        reflect_EntityPlayerMP_method_displayGUIChest_20.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerMP) params.getReflective("_self")).displayGUIChest((IInventory) params.getReflective("iinventory"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_displayGUIChest_20);


        BaseData reflect_EntityPlayerMP_method_displayVillagerTradeGui_21 = new ModData();
        reflect_EntityPlayerMP_method_displayVillagerTradeGui_21.set("methodName", "displayVillagerTradeGui");
        reflect_EntityPlayerMP_method_displayVillagerTradeGui_21.set("returnType", "void");
        reflect_EntityPlayerMP_method_displayVillagerTradeGui_21.set("static", false);
        reflect_EntityPlayerMP_method_displayVillagerTradeGui_21.set("argnames", new String[]{"imerchant"});
        reflect_EntityPlayerMP_method_displayVillagerTradeGui_21.set("argtypes", new String[]{"IMerchant"});
        reflect_EntityPlayerMP_method_displayVillagerTradeGui_21.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerMP) params.getReflective("_self")).displayVillagerTradeGui((IMerchant) params.getReflective("imerchant"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_displayVillagerTradeGui_21);


        BaseData reflect_EntityPlayerMP_method_displayGUIHorse_22 = new ModData();
        reflect_EntityPlayerMP_method_displayGUIHorse_22.set("methodName", "displayGUIHorse");
        reflect_EntityPlayerMP_method_displayGUIHorse_22.set("returnType", "void");
        reflect_EntityPlayerMP_method_displayGUIHorse_22.set("static", false);
        reflect_EntityPlayerMP_method_displayGUIHorse_22.set("argnames", new String[]{"entityhorse", "iinventory"});
        reflect_EntityPlayerMP_method_displayGUIHorse_22.set("argtypes", new String[]{"EntityHorse", "IInventory"});
        reflect_EntityPlayerMP_method_displayGUIHorse_22.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerMP) params.getReflective("_self")).displayGUIHorse((EntityHorse) params.getReflective("entityhorse"), (IInventory) params.getReflective("iinventory"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_displayGUIHorse_22);


        BaseData reflect_EntityPlayerMP_method_displayGUIBook_23 = new ModData();
        reflect_EntityPlayerMP_method_displayGUIBook_23.set("methodName", "displayGUIBook");
        reflect_EntityPlayerMP_method_displayGUIBook_23.set("returnType", "void");
        reflect_EntityPlayerMP_method_displayGUIBook_23.set("static", false);
        reflect_EntityPlayerMP_method_displayGUIBook_23.set("argnames", new String[]{"itemstack"});
        reflect_EntityPlayerMP_method_displayGUIBook_23.set("argtypes", new String[]{"ItemStack"});
        reflect_EntityPlayerMP_method_displayGUIBook_23.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerMP) params.getReflective("_self")).displayGUIBook((ItemStack) params.getReflective("itemstack"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_displayGUIBook_23);


        BaseData reflect_EntityPlayerMP_method_sendSlotContents_24 = new ModData();
        reflect_EntityPlayerMP_method_sendSlotContents_24.set("methodName", "sendSlotContents");
        reflect_EntityPlayerMP_method_sendSlotContents_24.set("returnType", "void");
        reflect_EntityPlayerMP_method_sendSlotContents_24.set("static", false);
        reflect_EntityPlayerMP_method_sendSlotContents_24.set("argnames", new String[]{"container", "i", "itemstack"});
        reflect_EntityPlayerMP_method_sendSlotContents_24.set("argtypes", new String[]{"Container", "int", "ItemStack"});
        reflect_EntityPlayerMP_method_sendSlotContents_24.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerMP) params.getReflective("_self")).sendSlotContents((Container) params.getReflective("container"), (int) params.getInt("i"), (ItemStack) params.getReflective("itemstack"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_sendSlotContents_24);


        BaseData reflect_EntityPlayerMP_method_sendContainerToPlayer_25 = new ModData();
        reflect_EntityPlayerMP_method_sendContainerToPlayer_25.set("methodName", "sendContainerToPlayer");
        reflect_EntityPlayerMP_method_sendContainerToPlayer_25.set("returnType", "void");
        reflect_EntityPlayerMP_method_sendContainerToPlayer_25.set("static", false);
        reflect_EntityPlayerMP_method_sendContainerToPlayer_25.set("argnames", new String[]{"parContainer"});
        reflect_EntityPlayerMP_method_sendContainerToPlayer_25.set("argtypes", new String[]{"Container"});
        reflect_EntityPlayerMP_method_sendContainerToPlayer_25.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerMP) params.getReflective("_self")).sendContainerToPlayer((Container) params.getReflective("parContainer"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_sendContainerToPlayer_25);


        BaseData reflect_EntityPlayerMP_method_sendProgressBarUpdate_26 = new ModData();
        reflect_EntityPlayerMP_method_sendProgressBarUpdate_26.set("methodName", "sendProgressBarUpdate");
        reflect_EntityPlayerMP_method_sendProgressBarUpdate_26.set("returnType", "void");
        reflect_EntityPlayerMP_method_sendProgressBarUpdate_26.set("static", false);
        reflect_EntityPlayerMP_method_sendProgressBarUpdate_26.set("argnames", new String[]{"container", "i", "j"});
        reflect_EntityPlayerMP_method_sendProgressBarUpdate_26.set("argtypes", new String[]{"Container", "int", "int"});
        reflect_EntityPlayerMP_method_sendProgressBarUpdate_26.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerMP) params.getReflective("_self")).sendProgressBarUpdate((Container) params.getReflective("container"), (int) params.getInt("i"), (int) params.getInt("j"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_sendProgressBarUpdate_26);


        BaseData reflect_EntityPlayerMP_method_func_175173_a_27 = new ModData();
        reflect_EntityPlayerMP_method_func_175173_a_27.set("methodName", "func_175173_a");
        reflect_EntityPlayerMP_method_func_175173_a_27.set("returnType", "void");
        reflect_EntityPlayerMP_method_func_175173_a_27.set("static", false);
        reflect_EntityPlayerMP_method_func_175173_a_27.set("argnames", new String[]{"container", "iinventory"});
        reflect_EntityPlayerMP_method_func_175173_a_27.set("argtypes", new String[]{"Container", "IInventory"});
        reflect_EntityPlayerMP_method_func_175173_a_27.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerMP) params.getReflective("_self")).func_175173_a((Container) params.getReflective("container"), (IInventory) params.getReflective("iinventory"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_func_175173_a_27);


        BaseData reflect_EntityPlayerMP_method_closeScreen_28 = new ModData();
        reflect_EntityPlayerMP_method_closeScreen_28.set("methodName", "closeScreen");
        reflect_EntityPlayerMP_method_closeScreen_28.set("returnType", "void");
        reflect_EntityPlayerMP_method_closeScreen_28.set("static", false);
        reflect_EntityPlayerMP_method_closeScreen_28.set("argnames", new String[]{});
        reflect_EntityPlayerMP_method_closeScreen_28.set("argtypes", new String[]{});
        reflect_EntityPlayerMP_method_closeScreen_28.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerMP) params.getReflective("_self")).closeScreen();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_closeScreen_28);


        BaseData reflect_EntityPlayerMP_method_updateHeldItem_29 = new ModData();
        reflect_EntityPlayerMP_method_updateHeldItem_29.set("methodName", "updateHeldItem");
        reflect_EntityPlayerMP_method_updateHeldItem_29.set("returnType", "void");
        reflect_EntityPlayerMP_method_updateHeldItem_29.set("static", false);
        reflect_EntityPlayerMP_method_updateHeldItem_29.set("argnames", new String[]{});
        reflect_EntityPlayerMP_method_updateHeldItem_29.set("argtypes", new String[]{});
        reflect_EntityPlayerMP_method_updateHeldItem_29.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerMP) params.getReflective("_self")).updateHeldItem();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_updateHeldItem_29);


        BaseData reflect_EntityPlayerMP_method_closeContainer_30 = new ModData();
        reflect_EntityPlayerMP_method_closeContainer_30.set("methodName", "closeContainer");
        reflect_EntityPlayerMP_method_closeContainer_30.set("returnType", "void");
        reflect_EntityPlayerMP_method_closeContainer_30.set("static", false);
        reflect_EntityPlayerMP_method_closeContainer_30.set("argnames", new String[]{});
        reflect_EntityPlayerMP_method_closeContainer_30.set("argtypes", new String[]{});
        reflect_EntityPlayerMP_method_closeContainer_30.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerMP) params.getReflective("_self")).closeContainer();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_closeContainer_30);


        BaseData reflect_EntityPlayerMP_method_setEntityActionState_31 = new ModData();
        reflect_EntityPlayerMP_method_setEntityActionState_31.set("methodName", "setEntityActionState");
        reflect_EntityPlayerMP_method_setEntityActionState_31.set("returnType", "void");
        reflect_EntityPlayerMP_method_setEntityActionState_31.set("static", false);
        reflect_EntityPlayerMP_method_setEntityActionState_31.set("argnames", new String[]{"sneaking", "parFloat2", "parFlag", "parFlag2"});
        reflect_EntityPlayerMP_method_setEntityActionState_31.set("argtypes", new String[]{"float", "float", "boolean", "boolean"});
        reflect_EntityPlayerMP_method_setEntityActionState_31.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerMP) params.getReflective("_self")).setEntityActionState((float) params.getFloat("sneaking"), (float) params.getFloat("parFloat2"), (boolean) params.getBoolean("parFlag"), (boolean) params.getBoolean("parFlag2"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_setEntityActionState_31);


        BaseData reflect_EntityPlayerMP_method_addStat_32 = new ModData();
        reflect_EntityPlayerMP_method_addStat_32.set("methodName", "addStat");
        reflect_EntityPlayerMP_method_addStat_32.set("returnType", "void");
        reflect_EntityPlayerMP_method_addStat_32.set("static", false);
        reflect_EntityPlayerMP_method_addStat_32.set("argnames", new String[]{"statbase", "i"});
        reflect_EntityPlayerMP_method_addStat_32.set("argtypes", new String[]{"StatBase", "int"});
        reflect_EntityPlayerMP_method_addStat_32.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerMP) params.getReflective("_self")).addStat((StatBase) params.getReflective("statbase"), (int) params.getInt("i"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_addStat_32);


        BaseData reflect_EntityPlayerMP_method_func_175145_a_33 = new ModData();
        reflect_EntityPlayerMP_method_func_175145_a_33.set("methodName", "func_175145_a");
        reflect_EntityPlayerMP_method_func_175145_a_33.set("returnType", "void");
        reflect_EntityPlayerMP_method_func_175145_a_33.set("static", false);
        reflect_EntityPlayerMP_method_func_175145_a_33.set("argnames", new String[]{"parStatBase"});
        reflect_EntityPlayerMP_method_func_175145_a_33.set("argtypes", new String[]{"StatBase"});
        reflect_EntityPlayerMP_method_func_175145_a_33.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerMP) params.getReflective("_self")).func_175145_a((StatBase) params.getReflective("parStatBase"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_func_175145_a_33);


        BaseData reflect_EntityPlayerMP_method_mountEntityAndWakeUp_34 = new ModData();
        reflect_EntityPlayerMP_method_mountEntityAndWakeUp_34.set("methodName", "mountEntityAndWakeUp");
        reflect_EntityPlayerMP_method_mountEntityAndWakeUp_34.set("returnType", "void");
        reflect_EntityPlayerMP_method_mountEntityAndWakeUp_34.set("static", false);
        reflect_EntityPlayerMP_method_mountEntityAndWakeUp_34.set("argnames", new String[]{});
        reflect_EntityPlayerMP_method_mountEntityAndWakeUp_34.set("argtypes", new String[]{});
        reflect_EntityPlayerMP_method_mountEntityAndWakeUp_34.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerMP) params.getReflective("_self")).mountEntityAndWakeUp();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_mountEntityAndWakeUp_34);


        BaseData reflect_EntityPlayerMP_method_setPlayerHealthUpdated_35 = new ModData();
        reflect_EntityPlayerMP_method_setPlayerHealthUpdated_35.set("methodName", "setPlayerHealthUpdated");
        reflect_EntityPlayerMP_method_setPlayerHealthUpdated_35.set("returnType", "void");
        reflect_EntityPlayerMP_method_setPlayerHealthUpdated_35.set("static", false);
        reflect_EntityPlayerMP_method_setPlayerHealthUpdated_35.set("argnames", new String[]{});
        reflect_EntityPlayerMP_method_setPlayerHealthUpdated_35.set("argtypes", new String[]{});
        reflect_EntityPlayerMP_method_setPlayerHealthUpdated_35.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerMP) params.getReflective("_self")).setPlayerHealthUpdated();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_setPlayerHealthUpdated_35);


        BaseData reflect_EntityPlayerMP_method_addChatComponentMessage_36 = new ModData();
        reflect_EntityPlayerMP_method_addChatComponentMessage_36.set("methodName", "addChatComponentMessage");
        reflect_EntityPlayerMP_method_addChatComponentMessage_36.set("returnType", "void");
        reflect_EntityPlayerMP_method_addChatComponentMessage_36.set("static", false);
        reflect_EntityPlayerMP_method_addChatComponentMessage_36.set("argnames", new String[]{"ichatcomponent"});
        reflect_EntityPlayerMP_method_addChatComponentMessage_36.set("argtypes", new String[]{"IChatComponent"});
        reflect_EntityPlayerMP_method_addChatComponentMessage_36.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerMP) params.getReflective("_self")).addChatComponentMessage((IChatComponent) params.getReflective("ichatcomponent"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_addChatComponentMessage_36);


        BaseData reflect_EntityPlayerMP_method_setItemInUse_37 = new ModData();
        reflect_EntityPlayerMP_method_setItemInUse_37.set("methodName", "setItemInUse");
        reflect_EntityPlayerMP_method_setItemInUse_37.set("returnType", "void");
        reflect_EntityPlayerMP_method_setItemInUse_37.set("static", false);
        reflect_EntityPlayerMP_method_setItemInUse_37.set("argnames", new String[]{"stack", "duration"});
        reflect_EntityPlayerMP_method_setItemInUse_37.set("argtypes", new String[]{"ItemStack", "int"});
        reflect_EntityPlayerMP_method_setItemInUse_37.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerMP) params.getReflective("_self")).setItemInUse((ItemStack) params.getReflective("stack"), (int) params.getInt("duration"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_setItemInUse_37);


        BaseData reflect_EntityPlayerMP_method_clonePlayer_38 = new ModData();
        reflect_EntityPlayerMP_method_clonePlayer_38.set("methodName", "clonePlayer");
        reflect_EntityPlayerMP_method_clonePlayer_38.set("returnType", "void");
        reflect_EntityPlayerMP_method_clonePlayer_38.set("static", false);
        reflect_EntityPlayerMP_method_clonePlayer_38.set("argnames", new String[]{"oldPlayer", "respawnFromEnd"});
        reflect_EntityPlayerMP_method_clonePlayer_38.set("argtypes", new String[]{"EntityPlayer", "boolean"});
        reflect_EntityPlayerMP_method_clonePlayer_38.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerMP) params.getReflective("_self")).clonePlayer((EntityPlayer) params.getReflective("oldPlayer"), (boolean) params.getBoolean("respawnFromEnd"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_clonePlayer_38);


        BaseData reflect_EntityPlayerMP_method_setPositionAndUpdate_39 = new ModData();
        reflect_EntityPlayerMP_method_setPositionAndUpdate_39.set("methodName", "setPositionAndUpdate");
        reflect_EntityPlayerMP_method_setPositionAndUpdate_39.set("returnType", "void");
        reflect_EntityPlayerMP_method_setPositionAndUpdate_39.set("static", false);
        reflect_EntityPlayerMP_method_setPositionAndUpdate_39.set("argnames", new String[]{"x", "y", "z"});
        reflect_EntityPlayerMP_method_setPositionAndUpdate_39.set("argtypes", new String[]{"double", "double", "double"});
        reflect_EntityPlayerMP_method_setPositionAndUpdate_39.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerMP) params.getReflective("_self")).setPositionAndUpdate((double) params.getDouble("x"), (double) params.getDouble("y"), (double) params.getDouble("z"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_setPositionAndUpdate_39);


        BaseData reflect_EntityPlayerMP_method_onCriticalHit_40 = new ModData();
        reflect_EntityPlayerMP_method_onCriticalHit_40.set("methodName", "onCriticalHit");
        reflect_EntityPlayerMP_method_onCriticalHit_40.set("returnType", "void");
        reflect_EntityPlayerMP_method_onCriticalHit_40.set("static", false);
        reflect_EntityPlayerMP_method_onCriticalHit_40.set("argnames", new String[]{"entity"});
        reflect_EntityPlayerMP_method_onCriticalHit_40.set("argtypes", new String[]{"Entity"});
        reflect_EntityPlayerMP_method_onCriticalHit_40.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerMP) params.getReflective("_self")).onCriticalHit((Entity) params.getReflective("entity"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_onCriticalHit_40);


        BaseData reflect_EntityPlayerMP_method_onEnchantmentCritical_41 = new ModData();
        reflect_EntityPlayerMP_method_onEnchantmentCritical_41.set("methodName", "onEnchantmentCritical");
        reflect_EntityPlayerMP_method_onEnchantmentCritical_41.set("returnType", "void");
        reflect_EntityPlayerMP_method_onEnchantmentCritical_41.set("static", false);
        reflect_EntityPlayerMP_method_onEnchantmentCritical_41.set("argnames", new String[]{"entity"});
        reflect_EntityPlayerMP_method_onEnchantmentCritical_41.set("argtypes", new String[]{"Entity"});
        reflect_EntityPlayerMP_method_onEnchantmentCritical_41.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerMP) params.getReflective("_self")).onEnchantmentCritical((Entity) params.getReflective("entity"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_onEnchantmentCritical_41);


        BaseData reflect_EntityPlayerMP_method_sendPlayerAbilities_42 = new ModData();
        reflect_EntityPlayerMP_method_sendPlayerAbilities_42.set("methodName", "sendPlayerAbilities");
        reflect_EntityPlayerMP_method_sendPlayerAbilities_42.set("returnType", "void");
        reflect_EntityPlayerMP_method_sendPlayerAbilities_42.set("static", false);
        reflect_EntityPlayerMP_method_sendPlayerAbilities_42.set("argnames", new String[]{});
        reflect_EntityPlayerMP_method_sendPlayerAbilities_42.set("argtypes", new String[]{});
        reflect_EntityPlayerMP_method_sendPlayerAbilities_42.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerMP) params.getReflective("_self")).sendPlayerAbilities();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_sendPlayerAbilities_42);


        BaseData reflect_EntityPlayerMP_method_getServerForPlayer_43 = new ModData();
        reflect_EntityPlayerMP_method_getServerForPlayer_43.set("methodName", "getServerForPlayer");
        reflect_EntityPlayerMP_method_getServerForPlayer_43.set("returnType", "WorldServer");
        reflect_EntityPlayerMP_method_getServerForPlayer_43.set("static", false);
        reflect_EntityPlayerMP_method_getServerForPlayer_43.set("argnames", new String[]{});
        reflect_EntityPlayerMP_method_getServerForPlayer_43.set("argtypes", new String[]{});
        reflect_EntityPlayerMP_method_getServerForPlayer_43.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (WorldServer) ((EntityPlayerMP) params.getReflective("_self")).getServerForPlayer();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_getServerForPlayer_43);


        BaseData reflect_EntityPlayerMP_method_isSpectator_45 = new ModData();
        reflect_EntityPlayerMP_method_isSpectator_45.set("methodName", "isSpectator");
        reflect_EntityPlayerMP_method_isSpectator_45.set("returnType", "boolean");
        reflect_EntityPlayerMP_method_isSpectator_45.set("static", false);
        reflect_EntityPlayerMP_method_isSpectator_45.set("argnames", new String[]{});
        reflect_EntityPlayerMP_method_isSpectator_45.set("argtypes", new String[]{});
        reflect_EntityPlayerMP_method_isSpectator_45.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityPlayerMP) params.getReflective("_self")).isSpectator();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_isSpectator_45);


        BaseData reflect_EntityPlayerMP_method_addChatMessage_46 = new ModData();
        reflect_EntityPlayerMP_method_addChatMessage_46.set("methodName", "addChatMessage");
        reflect_EntityPlayerMP_method_addChatMessage_46.set("returnType", "void");
        reflect_EntityPlayerMP_method_addChatMessage_46.set("static", false);
        reflect_EntityPlayerMP_method_addChatMessage_46.set("argnames", new String[]{"ichatcomponent"});
        reflect_EntityPlayerMP_method_addChatMessage_46.set("argtypes", new String[]{"IChatComponent"});
        reflect_EntityPlayerMP_method_addChatMessage_46.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerMP) params.getReflective("_self")).addChatMessage((IChatComponent) params.getReflective("ichatcomponent"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_addChatMessage_46);


        BaseData reflect_EntityPlayerMP_method_canCommandSenderUseCommand_47 = new ModData();
        reflect_EntityPlayerMP_method_canCommandSenderUseCommand_47.set("methodName", "canCommandSenderUseCommand");
        reflect_EntityPlayerMP_method_canCommandSenderUseCommand_47.set("returnType", "boolean");
        reflect_EntityPlayerMP_method_canCommandSenderUseCommand_47.set("static", false);
        reflect_EntityPlayerMP_method_canCommandSenderUseCommand_47.set("argnames", new String[]{"i", "s"});
        reflect_EntityPlayerMP_method_canCommandSenderUseCommand_47.set("argtypes", new String[]{"int", "String"});
        reflect_EntityPlayerMP_method_canCommandSenderUseCommand_47.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityPlayerMP) params.getReflective("_self")).canCommandSenderUseCommand((int) params.getInt("i"), (String) params.getString("s"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_canCommandSenderUseCommand_47);


        BaseData reflect_EntityPlayerMP_method_getPlayerIP_48 = new ModData();
        reflect_EntityPlayerMP_method_getPlayerIP_48.set("methodName", "getPlayerIP");
        reflect_EntityPlayerMP_method_getPlayerIP_48.set("returnType", "String");
        reflect_EntityPlayerMP_method_getPlayerIP_48.set("static", false);
        reflect_EntityPlayerMP_method_getPlayerIP_48.set("argnames", new String[]{});
        reflect_EntityPlayerMP_method_getPlayerIP_48.set("argtypes", new String[]{});
        reflect_EntityPlayerMP_method_getPlayerIP_48.setCallbackStringWithDataArg("exec", (BaseData params) -> {
                try {
                    return (String) ((EntityPlayerMP) params.getReflective("_self")).getPlayerIP();
                } catch (Exception _exception_reflect_) {
                    return "";
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_getPlayerIP_48);


        BaseData reflect_EntityPlayerMP_method_handleClientSettings_49 = new ModData();
        reflect_EntityPlayerMP_method_handleClientSettings_49.set("methodName", "handleClientSettings");
        reflect_EntityPlayerMP_method_handleClientSettings_49.set("returnType", "void");
        reflect_EntityPlayerMP_method_handleClientSettings_49.set("static", false);
        reflect_EntityPlayerMP_method_handleClientSettings_49.set("argnames", new String[]{"packetIn"});
        reflect_EntityPlayerMP_method_handleClientSettings_49.set("argtypes", new String[]{"C15PacketClientSettings"});
        reflect_EntityPlayerMP_method_handleClientSettings_49.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerMP) params.getReflective("_self")).handleClientSettings((C15PacketClientSettings) params.getReflective("packetIn"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_handleClientSettings_49);


        BaseData reflect_EntityPlayerMP_method_loadResourcePack_50 = new ModData();
        reflect_EntityPlayerMP_method_loadResourcePack_50.set("methodName", "loadResourcePack");
        reflect_EntityPlayerMP_method_loadResourcePack_50.set("returnType", "void");
        reflect_EntityPlayerMP_method_loadResourcePack_50.set("static", false);
        reflect_EntityPlayerMP_method_loadResourcePack_50.set("argnames", new String[]{"url", "hash"});
        reflect_EntityPlayerMP_method_loadResourcePack_50.set("argtypes", new String[]{"String", "String"});
        reflect_EntityPlayerMP_method_loadResourcePack_50.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerMP) params.getReflective("_self")).loadResourcePack((String) params.getString("url"), (String) params.getString("hash"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_loadResourcePack_50);


        BaseData reflect_EntityPlayerMP_method_getPosition_51 = new ModData();
        reflect_EntityPlayerMP_method_getPosition_51.set("methodName", "getPosition");
        reflect_EntityPlayerMP_method_getPosition_51.set("returnType", "BlockPos");
        reflect_EntityPlayerMP_method_getPosition_51.set("static", false);
        reflect_EntityPlayerMP_method_getPosition_51.set("argnames", new String[]{});
        reflect_EntityPlayerMP_method_getPosition_51.set("argtypes", new String[]{});
        reflect_EntityPlayerMP_method_getPosition_51.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (BlockPos) ((EntityPlayerMP) params.getReflective("_self")).getPosition();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_getPosition_51);


        BaseData reflect_EntityPlayerMP_method_markPlayerActive_52 = new ModData();
        reflect_EntityPlayerMP_method_markPlayerActive_52.set("methodName", "markPlayerActive");
        reflect_EntityPlayerMP_method_markPlayerActive_52.set("returnType", "void");
        reflect_EntityPlayerMP_method_markPlayerActive_52.set("static", false);
        reflect_EntityPlayerMP_method_markPlayerActive_52.set("argnames", new String[]{});
        reflect_EntityPlayerMP_method_markPlayerActive_52.set("argtypes", new String[]{});
        reflect_EntityPlayerMP_method_markPlayerActive_52.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerMP) params.getReflective("_self")).markPlayerActive();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_markPlayerActive_52);


        BaseData reflect_EntityPlayerMP_method_getStatFile_53 = new ModData();
        reflect_EntityPlayerMP_method_getStatFile_53.set("methodName", "getStatFile");
        reflect_EntityPlayerMP_method_getStatFile_53.set("returnType", "StatisticsFile");
        reflect_EntityPlayerMP_method_getStatFile_53.set("static", false);
        reflect_EntityPlayerMP_method_getStatFile_53.set("argnames", new String[]{});
        reflect_EntityPlayerMP_method_getStatFile_53.set("argtypes", new String[]{});
        reflect_EntityPlayerMP_method_getStatFile_53.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (StatisticsFile) ((EntityPlayerMP) params.getReflective("_self")).getStatFile();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_getStatFile_53);


        BaseData reflect_EntityPlayerMP_method_removeEntity_54 = new ModData();
        reflect_EntityPlayerMP_method_removeEntity_54.set("methodName", "removeEntity");
        reflect_EntityPlayerMP_method_removeEntity_54.set("returnType", "void");
        reflect_EntityPlayerMP_method_removeEntity_54.set("static", false);
        reflect_EntityPlayerMP_method_removeEntity_54.set("argnames", new String[]{"parEntity"});
        reflect_EntityPlayerMP_method_removeEntity_54.set("argtypes", new String[]{"Entity"});
        reflect_EntityPlayerMP_method_removeEntity_54.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerMP) params.getReflective("_self")).removeEntity((Entity) params.getReflective("parEntity"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_removeEntity_54);


        BaseData reflect_EntityPlayerMP_method_getSpectatingEntity_55 = new ModData();
        reflect_EntityPlayerMP_method_getSpectatingEntity_55.set("methodName", "getSpectatingEntity");
        reflect_EntityPlayerMP_method_getSpectatingEntity_55.set("returnType", "Entity");
        reflect_EntityPlayerMP_method_getSpectatingEntity_55.set("static", false);
        reflect_EntityPlayerMP_method_getSpectatingEntity_55.set("argnames", new String[]{});
        reflect_EntityPlayerMP_method_getSpectatingEntity_55.set("argtypes", new String[]{});
        reflect_EntityPlayerMP_method_getSpectatingEntity_55.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Entity) ((EntityPlayerMP) params.getReflective("_self")).getSpectatingEntity();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_getSpectatingEntity_55);


        BaseData reflect_EntityPlayerMP_method_setSpectatingEntity_56 = new ModData();
        reflect_EntityPlayerMP_method_setSpectatingEntity_56.set("methodName", "setSpectatingEntity");
        reflect_EntityPlayerMP_method_setSpectatingEntity_56.set("returnType", "void");
        reflect_EntityPlayerMP_method_setSpectatingEntity_56.set("static", false);
        reflect_EntityPlayerMP_method_setSpectatingEntity_56.set("argnames", new String[]{"entityToSpectate"});
        reflect_EntityPlayerMP_method_setSpectatingEntity_56.set("argtypes", new String[]{"Entity"});
        reflect_EntityPlayerMP_method_setSpectatingEntity_56.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerMP) params.getReflective("_self")).setSpectatingEntity((Entity) params.getReflective("entityToSpectate"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_setSpectatingEntity_56);


        BaseData reflect_EntityPlayerMP_method_attackTargetEntityWithCurrentItem_57 = new ModData();
        reflect_EntityPlayerMP_method_attackTargetEntityWithCurrentItem_57.set("methodName", "attackTargetEntityWithCurrentItem");
        reflect_EntityPlayerMP_method_attackTargetEntityWithCurrentItem_57.set("returnType", "void");
        reflect_EntityPlayerMP_method_attackTargetEntityWithCurrentItem_57.set("static", false);
        reflect_EntityPlayerMP_method_attackTargetEntityWithCurrentItem_57.set("argnames", new String[]{"targetEntity"});
        reflect_EntityPlayerMP_method_attackTargetEntityWithCurrentItem_57.set("argtypes", new String[]{"Entity"});
        reflect_EntityPlayerMP_method_attackTargetEntityWithCurrentItem_57.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerMP) params.getReflective("_self")).attackTargetEntityWithCurrentItem((Entity) params.getReflective("targetEntity"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_attackTargetEntityWithCurrentItem_57);


        BaseData reflect_EntityPlayerMP_method_getLastActiveTime_58 = new ModData();
        reflect_EntityPlayerMP_method_getLastActiveTime_58.set("methodName", "getLastActiveTime");
        reflect_EntityPlayerMP_method_getLastActiveTime_58.set("returnType", "long");
        reflect_EntityPlayerMP_method_getLastActiveTime_58.set("static", false);
        reflect_EntityPlayerMP_method_getLastActiveTime_58.set("argnames", new String[]{});
        reflect_EntityPlayerMP_method_getLastActiveTime_58.set("argtypes", new String[]{});
        reflect_EntityPlayerMP_method_getLastActiveTime_58.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (long) ((EntityPlayerMP) params.getReflective("_self")).getLastActiveTime();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_getLastActiveTime_58);


        BaseData reflect_EntityPlayerMP_method_getTabListDisplayName_59 = new ModData();
        reflect_EntityPlayerMP_method_getTabListDisplayName_59.set("methodName", "getTabListDisplayName");
        reflect_EntityPlayerMP_method_getTabListDisplayName_59.set("returnType", "IChatComponent");
        reflect_EntityPlayerMP_method_getTabListDisplayName_59.set("static", false);
        reflect_EntityPlayerMP_method_getTabListDisplayName_59.set("argnames", new String[]{});
        reflect_EntityPlayerMP_method_getTabListDisplayName_59.set("argtypes", new String[]{});
        reflect_EntityPlayerMP_method_getTabListDisplayName_59.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (IChatComponent) ((EntityPlayerMP) params.getReflective("_self")).getTabListDisplayName();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityPlayerMP_methods.add(reflect_EntityPlayerMP_method_getTabListDisplayName_59);


        BaseData[] reflect_EntityPlayerMP_methods_arr = new BaseData[reflect_EntityPlayerMP_methods.size()];
        for (int i = 0; i < reflect_EntityPlayerMP_methods_arr.length; i++) {
            reflect_EntityPlayerMP_methods_arr[i] = reflect_EntityPlayerMP_methods.get(i);
        }

        reflect_EntityPlayerMP.set("constructors", reflect_EntityPlayerMP_constructors_arr);
        reflect_EntityPlayerMP.set("methods", reflect_EntityPlayerMP_methods_arr);
        reflect_EntityPlayerMP.set("className", "EntityPlayerMP");
        reflect_EntityPlayerMP.set("classId", "net.minecraft.entity.player.EntityPlayerMP");
        reflect_EntityPlayerMP.set("class", EntityPlayerMP.class);
        reflect_EntityPlayerMP.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityPlayerMP;
        });
        reflectProfiles.add(reflect_EntityPlayerMP);
    }


    //classdef for EntityAmbientCreature
    public static void reflect_EntityAmbientCreature_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityAmbientCreature = new ModData();

        ArrayList<BaseData> reflect_EntityAmbientCreature_constructors = new ArrayList<BaseData>();
        
        BaseData[] reflect_EntityAmbientCreature_constructors_arr = new BaseData[reflect_EntityAmbientCreature_constructors.size()];
        for (int i = 0; i < reflect_EntityAmbientCreature_constructors_arr.length; i++) {
            reflect_EntityAmbientCreature_constructors_arr[i] = reflect_EntityAmbientCreature_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityAmbientCreature_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityAmbientCreature_method_allowLeashing_0 = new ModData();
        reflect_EntityAmbientCreature_method_allowLeashing_0.set("methodName", "allowLeashing");
        reflect_EntityAmbientCreature_method_allowLeashing_0.set("returnType", "boolean");
        reflect_EntityAmbientCreature_method_allowLeashing_0.set("static", false);
        reflect_EntityAmbientCreature_method_allowLeashing_0.set("argnames", new String[]{});
        reflect_EntityAmbientCreature_method_allowLeashing_0.set("argtypes", new String[]{});
        reflect_EntityAmbientCreature_method_allowLeashing_0.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityAmbientCreature) params.getReflective("_self")).allowLeashing();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityAmbientCreature_methods.add(reflect_EntityAmbientCreature_method_allowLeashing_0);


        BaseData[] reflect_EntityAmbientCreature_methods_arr = new BaseData[reflect_EntityAmbientCreature_methods.size()];
        for (int i = 0; i < reflect_EntityAmbientCreature_methods_arr.length; i++) {
            reflect_EntityAmbientCreature_methods_arr[i] = reflect_EntityAmbientCreature_methods.get(i);
        }

        reflect_EntityAmbientCreature.set("constructors", reflect_EntityAmbientCreature_constructors_arr);
        reflect_EntityAmbientCreature.set("methods", reflect_EntityAmbientCreature_methods_arr);
        reflect_EntityAmbientCreature.set("className", "EntityAmbientCreature");
        reflect_EntityAmbientCreature.set("classId", "net.minecraft.entity.passive.EntityAmbientCreature");
        reflect_EntityAmbientCreature.set("class", EntityAmbientCreature.class);
        reflect_EntityAmbientCreature.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityAmbientCreature;
        });
        reflectProfiles.add(reflect_EntityAmbientCreature);
    }


    //classdef for EntityAnimal
    public static void reflect_EntityAnimal_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityAnimal = new ModData();

        ArrayList<BaseData> reflect_EntityAnimal_constructors = new ArrayList<BaseData>();
        
        BaseData[] reflect_EntityAnimal_constructors_arr = new BaseData[reflect_EntityAnimal_constructors.size()];
        for (int i = 0; i < reflect_EntityAnimal_constructors_arr.length; i++) {
            reflect_EntityAnimal_constructors_arr[i] = reflect_EntityAnimal_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityAnimal_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityAnimal_method_onLivingUpdate_0 = new ModData();
        reflect_EntityAnimal_method_onLivingUpdate_0.set("methodName", "onLivingUpdate");
        reflect_EntityAnimal_method_onLivingUpdate_0.set("returnType", "void");
        reflect_EntityAnimal_method_onLivingUpdate_0.set("static", false);
        reflect_EntityAnimal_method_onLivingUpdate_0.set("argnames", new String[]{});
        reflect_EntityAnimal_method_onLivingUpdate_0.set("argtypes", new String[]{});
        reflect_EntityAnimal_method_onLivingUpdate_0.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityAnimal) params.getReflective("_self")).onLivingUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityAnimal_methods.add(reflect_EntityAnimal_method_onLivingUpdate_0);


        BaseData reflect_EntityAnimal_method_attackEntityFrom_1 = new ModData();
        reflect_EntityAnimal_method_attackEntityFrom_1.set("methodName", "attackEntityFrom");
        reflect_EntityAnimal_method_attackEntityFrom_1.set("returnType", "boolean");
        reflect_EntityAnimal_method_attackEntityFrom_1.set("static", false);
        reflect_EntityAnimal_method_attackEntityFrom_1.set("argnames", new String[]{"damagesource", "f"});
        reflect_EntityAnimal_method_attackEntityFrom_1.set("argtypes", new String[]{"DamageSource", "float"});
        reflect_EntityAnimal_method_attackEntityFrom_1.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityAnimal) params.getReflective("_self")).attackEntityFrom((DamageSource) params.getReflective("damagesource"), (float) params.getFloat("f"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityAnimal_methods.add(reflect_EntityAnimal_method_attackEntityFrom_1);


        BaseData reflect_EntityAnimal_method_getBlockPathWeight_2 = new ModData();
        reflect_EntityAnimal_method_getBlockPathWeight_2.set("methodName", "getBlockPathWeight");
        reflect_EntityAnimal_method_getBlockPathWeight_2.set("returnType", "float");
        reflect_EntityAnimal_method_getBlockPathWeight_2.set("static", false);
        reflect_EntityAnimal_method_getBlockPathWeight_2.set("argnames", new String[]{"blockpos"});
        reflect_EntityAnimal_method_getBlockPathWeight_2.set("argtypes", new String[]{"BlockPos"});
        reflect_EntityAnimal_method_getBlockPathWeight_2.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityAnimal) params.getReflective("_self")).getBlockPathWeight((BlockPos) params.getReflective("blockpos"));
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityAnimal_methods.add(reflect_EntityAnimal_method_getBlockPathWeight_2);


        BaseData reflect_EntityAnimal_method_writeEntityToNBT_3 = new ModData();
        reflect_EntityAnimal_method_writeEntityToNBT_3.set("methodName", "writeEntityToNBT");
        reflect_EntityAnimal_method_writeEntityToNBT_3.set("returnType", "void");
        reflect_EntityAnimal_method_writeEntityToNBT_3.set("static", false);
        reflect_EntityAnimal_method_writeEntityToNBT_3.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityAnimal_method_writeEntityToNBT_3.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityAnimal_method_writeEntityToNBT_3.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityAnimal) params.getReflective("_self")).writeEntityToNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityAnimal_methods.add(reflect_EntityAnimal_method_writeEntityToNBT_3);


        BaseData reflect_EntityAnimal_method_readEntityFromNBT_4 = new ModData();
        reflect_EntityAnimal_method_readEntityFromNBT_4.set("methodName", "readEntityFromNBT");
        reflect_EntityAnimal_method_readEntityFromNBT_4.set("returnType", "void");
        reflect_EntityAnimal_method_readEntityFromNBT_4.set("static", false);
        reflect_EntityAnimal_method_readEntityFromNBT_4.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityAnimal_method_readEntityFromNBT_4.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityAnimal_method_readEntityFromNBT_4.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityAnimal) params.getReflective("_self")).readEntityFromNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityAnimal_methods.add(reflect_EntityAnimal_method_readEntityFromNBT_4);


        BaseData reflect_EntityAnimal_method_getCanSpawnHere_5 = new ModData();
        reflect_EntityAnimal_method_getCanSpawnHere_5.set("methodName", "getCanSpawnHere");
        reflect_EntityAnimal_method_getCanSpawnHere_5.set("returnType", "boolean");
        reflect_EntityAnimal_method_getCanSpawnHere_5.set("static", false);
        reflect_EntityAnimal_method_getCanSpawnHere_5.set("argnames", new String[]{});
        reflect_EntityAnimal_method_getCanSpawnHere_5.set("argtypes", new String[]{});
        reflect_EntityAnimal_method_getCanSpawnHere_5.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityAnimal) params.getReflective("_self")).getCanSpawnHere();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityAnimal_methods.add(reflect_EntityAnimal_method_getCanSpawnHere_5);


        BaseData reflect_EntityAnimal_method_getTalkInterval_6 = new ModData();
        reflect_EntityAnimal_method_getTalkInterval_6.set("methodName", "getTalkInterval");
        reflect_EntityAnimal_method_getTalkInterval_6.set("returnType", "int");
        reflect_EntityAnimal_method_getTalkInterval_6.set("static", false);
        reflect_EntityAnimal_method_getTalkInterval_6.set("argnames", new String[]{});
        reflect_EntityAnimal_method_getTalkInterval_6.set("argtypes", new String[]{});
        reflect_EntityAnimal_method_getTalkInterval_6.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityAnimal) params.getReflective("_self")).getTalkInterval();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityAnimal_methods.add(reflect_EntityAnimal_method_getTalkInterval_6);


        BaseData reflect_EntityAnimal_method_isBreedingItem_7 = new ModData();
        reflect_EntityAnimal_method_isBreedingItem_7.set("methodName", "isBreedingItem");
        reflect_EntityAnimal_method_isBreedingItem_7.set("returnType", "boolean");
        reflect_EntityAnimal_method_isBreedingItem_7.set("static", false);
        reflect_EntityAnimal_method_isBreedingItem_7.set("argnames", new String[]{"stack"});
        reflect_EntityAnimal_method_isBreedingItem_7.set("argtypes", new String[]{"ItemStack"});
        reflect_EntityAnimal_method_isBreedingItem_7.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityAnimal) params.getReflective("_self")).isBreedingItem((ItemStack) params.getReflective("stack"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityAnimal_methods.add(reflect_EntityAnimal_method_isBreedingItem_7);


        BaseData reflect_EntityAnimal_method_interact_8 = new ModData();
        reflect_EntityAnimal_method_interact_8.set("methodName", "interact");
        reflect_EntityAnimal_method_interact_8.set("returnType", "boolean");
        reflect_EntityAnimal_method_interact_8.set("static", false);
        reflect_EntityAnimal_method_interact_8.set("argnames", new String[]{"entityplayer"});
        reflect_EntityAnimal_method_interact_8.set("argtypes", new String[]{"EntityPlayer"});
        reflect_EntityAnimal_method_interact_8.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityAnimal) params.getReflective("_self")).interact((EntityPlayer) params.getReflective("entityplayer"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityAnimal_methods.add(reflect_EntityAnimal_method_interact_8);


        BaseData reflect_EntityAnimal_method_setInLove_9 = new ModData();
        reflect_EntityAnimal_method_setInLove_9.set("methodName", "setInLove");
        reflect_EntityAnimal_method_setInLove_9.set("returnType", "void");
        reflect_EntityAnimal_method_setInLove_9.set("static", false);
        reflect_EntityAnimal_method_setInLove_9.set("argnames", new String[]{"player"});
        reflect_EntityAnimal_method_setInLove_9.set("argtypes", new String[]{"EntityPlayer"});
        reflect_EntityAnimal_method_setInLove_9.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityAnimal) params.getReflective("_self")).setInLove((EntityPlayer) params.getReflective("player"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityAnimal_methods.add(reflect_EntityAnimal_method_setInLove_9);


        BaseData reflect_EntityAnimal_method_getPlayerInLove_10 = new ModData();
        reflect_EntityAnimal_method_getPlayerInLove_10.set("methodName", "getPlayerInLove");
        reflect_EntityAnimal_method_getPlayerInLove_10.set("returnType", "EntityPlayer");
        reflect_EntityAnimal_method_getPlayerInLove_10.set("static", false);
        reflect_EntityAnimal_method_getPlayerInLove_10.set("argnames", new String[]{});
        reflect_EntityAnimal_method_getPlayerInLove_10.set("argtypes", new String[]{});
        reflect_EntityAnimal_method_getPlayerInLove_10.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EntityPlayer) ((EntityAnimal) params.getReflective("_self")).getPlayerInLove();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityAnimal_methods.add(reflect_EntityAnimal_method_getPlayerInLove_10);


        BaseData reflect_EntityAnimal_method_isInLove_11 = new ModData();
        reflect_EntityAnimal_method_isInLove_11.set("methodName", "isInLove");
        reflect_EntityAnimal_method_isInLove_11.set("returnType", "boolean");
        reflect_EntityAnimal_method_isInLove_11.set("static", false);
        reflect_EntityAnimal_method_isInLove_11.set("argnames", new String[]{});
        reflect_EntityAnimal_method_isInLove_11.set("argtypes", new String[]{});
        reflect_EntityAnimal_method_isInLove_11.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityAnimal) params.getReflective("_self")).isInLove();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityAnimal_methods.add(reflect_EntityAnimal_method_isInLove_11);


        BaseData reflect_EntityAnimal_method_resetInLove_12 = new ModData();
        reflect_EntityAnimal_method_resetInLove_12.set("methodName", "resetInLove");
        reflect_EntityAnimal_method_resetInLove_12.set("returnType", "void");
        reflect_EntityAnimal_method_resetInLove_12.set("static", false);
        reflect_EntityAnimal_method_resetInLove_12.set("argnames", new String[]{});
        reflect_EntityAnimal_method_resetInLove_12.set("argtypes", new String[]{});
        reflect_EntityAnimal_method_resetInLove_12.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityAnimal) params.getReflective("_self")).resetInLove();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityAnimal_methods.add(reflect_EntityAnimal_method_resetInLove_12);


        BaseData reflect_EntityAnimal_method_canMateWith_13 = new ModData();
        reflect_EntityAnimal_method_canMateWith_13.set("methodName", "canMateWith");
        reflect_EntityAnimal_method_canMateWith_13.set("returnType", "boolean");
        reflect_EntityAnimal_method_canMateWith_13.set("static", false);
        reflect_EntityAnimal_method_canMateWith_13.set("argnames", new String[]{"otherAnimal"});
        reflect_EntityAnimal_method_canMateWith_13.set("argtypes", new String[]{"EntityAnimal"});
        reflect_EntityAnimal_method_canMateWith_13.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityAnimal) params.getReflective("_self")).canMateWith((EntityAnimal) params.getReflective("otherAnimal"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityAnimal_methods.add(reflect_EntityAnimal_method_canMateWith_13);


        BaseData reflect_EntityAnimal_method_handleStatusUpdate_14 = new ModData();
        reflect_EntityAnimal_method_handleStatusUpdate_14.set("methodName", "handleStatusUpdate");
        reflect_EntityAnimal_method_handleStatusUpdate_14.set("returnType", "void");
        reflect_EntityAnimal_method_handleStatusUpdate_14.set("static", false);
        reflect_EntityAnimal_method_handleStatusUpdate_14.set("argnames", new String[]{"b0"});
        reflect_EntityAnimal_method_handleStatusUpdate_14.set("argtypes", new String[]{"byte"});
        reflect_EntityAnimal_method_handleStatusUpdate_14.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityAnimal) params.getReflective("_self")).handleStatusUpdate((byte) params.getByte("b0"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityAnimal_methods.add(reflect_EntityAnimal_method_handleStatusUpdate_14);


        BaseData[] reflect_EntityAnimal_methods_arr = new BaseData[reflect_EntityAnimal_methods.size()];
        for (int i = 0; i < reflect_EntityAnimal_methods_arr.length; i++) {
            reflect_EntityAnimal_methods_arr[i] = reflect_EntityAnimal_methods.get(i);
        }

        reflect_EntityAnimal.set("constructors", reflect_EntityAnimal_constructors_arr);
        reflect_EntityAnimal.set("methods", reflect_EntityAnimal_methods_arr);
        reflect_EntityAnimal.set("className", "EntityAnimal");
        reflect_EntityAnimal.set("classId", "net.minecraft.entity.passive.EntityAnimal");
        reflect_EntityAnimal.set("class", EntityAnimal.class);
        reflect_EntityAnimal.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityAnimal;
        });
        reflectProfiles.add(reflect_EntityAnimal);
    }


    //classdef for EntityBat
    public static void reflect_EntityBat_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityBat = new ModData();

        ArrayList<BaseData> reflect_EntityBat_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_EntityBat_constructor_EntityBat_0 = new ModData();
        reflect_EntityBat_constructor_EntityBat_0.set("returnType", "EntityBat");
        reflect_EntityBat_constructor_EntityBat_0.set("argnames", new String[]{"worldIn"});
        reflect_EntityBat_constructor_EntityBat_0.set("argtypes", new String[]{"World"});
        reflect_EntityBat_constructor_EntityBat_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityBat((World) params.getReflective("worldIn"));
        });
        
        reflect_EntityBat_constructors.add(reflect_EntityBat_constructor_EntityBat_0);


        BaseData[] reflect_EntityBat_constructors_arr = new BaseData[reflect_EntityBat_constructors.size()];
        for (int i = 0; i < reflect_EntityBat_constructors_arr.length; i++) {
            reflect_EntityBat_constructors_arr[i] = reflect_EntityBat_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityBat_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityBat_method_canBePushed_0 = new ModData();
        reflect_EntityBat_method_canBePushed_0.set("methodName", "canBePushed");
        reflect_EntityBat_method_canBePushed_0.set("returnType", "boolean");
        reflect_EntityBat_method_canBePushed_0.set("static", false);
        reflect_EntityBat_method_canBePushed_0.set("argnames", new String[]{});
        reflect_EntityBat_method_canBePushed_0.set("argtypes", new String[]{});
        reflect_EntityBat_method_canBePushed_0.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityBat) params.getReflective("_self")).canBePushed();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityBat_methods.add(reflect_EntityBat_method_canBePushed_0);


        BaseData reflect_EntityBat_method_getIsBatHanging_1 = new ModData();
        reflect_EntityBat_method_getIsBatHanging_1.set("methodName", "getIsBatHanging");
        reflect_EntityBat_method_getIsBatHanging_1.set("returnType", "boolean");
        reflect_EntityBat_method_getIsBatHanging_1.set("static", false);
        reflect_EntityBat_method_getIsBatHanging_1.set("argnames", new String[]{});
        reflect_EntityBat_method_getIsBatHanging_1.set("argtypes", new String[]{});
        reflect_EntityBat_method_getIsBatHanging_1.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityBat) params.getReflective("_self")).getIsBatHanging();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityBat_methods.add(reflect_EntityBat_method_getIsBatHanging_1);


        BaseData reflect_EntityBat_method_setIsBatHanging_2 = new ModData();
        reflect_EntityBat_method_setIsBatHanging_2.set("methodName", "setIsBatHanging");
        reflect_EntityBat_method_setIsBatHanging_2.set("returnType", "void");
        reflect_EntityBat_method_setIsBatHanging_2.set("static", false);
        reflect_EntityBat_method_setIsBatHanging_2.set("argnames", new String[]{"isHanging"});
        reflect_EntityBat_method_setIsBatHanging_2.set("argtypes", new String[]{"boolean"});
        reflect_EntityBat_method_setIsBatHanging_2.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityBat) params.getReflective("_self")).setIsBatHanging((boolean) params.getBoolean("isHanging"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityBat_methods.add(reflect_EntityBat_method_setIsBatHanging_2);


        BaseData reflect_EntityBat_method_onUpdate_3 = new ModData();
        reflect_EntityBat_method_onUpdate_3.set("methodName", "onUpdate");
        reflect_EntityBat_method_onUpdate_3.set("returnType", "void");
        reflect_EntityBat_method_onUpdate_3.set("static", false);
        reflect_EntityBat_method_onUpdate_3.set("argnames", new String[]{});
        reflect_EntityBat_method_onUpdate_3.set("argtypes", new String[]{});
        reflect_EntityBat_method_onUpdate_3.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityBat) params.getReflective("_self")).onUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityBat_methods.add(reflect_EntityBat_method_onUpdate_3);


        BaseData reflect_EntityBat_method_fall_4 = new ModData();
        reflect_EntityBat_method_fall_4.set("methodName", "fall");
        reflect_EntityBat_method_fall_4.set("returnType", "void");
        reflect_EntityBat_method_fall_4.set("static", false);
        reflect_EntityBat_method_fall_4.set("argnames", new String[]{"var1", "var2"});
        reflect_EntityBat_method_fall_4.set("argtypes", new String[]{"float", "float"});
        reflect_EntityBat_method_fall_4.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityBat) params.getReflective("_self")).fall((float) params.getFloat("var1"), (float) params.getFloat("var2"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityBat_methods.add(reflect_EntityBat_method_fall_4);


        BaseData reflect_EntityBat_method_doesEntityNotTriggerPressurePlate_5 = new ModData();
        reflect_EntityBat_method_doesEntityNotTriggerPressurePlate_5.set("methodName", "doesEntityNotTriggerPressurePlate");
        reflect_EntityBat_method_doesEntityNotTriggerPressurePlate_5.set("returnType", "boolean");
        reflect_EntityBat_method_doesEntityNotTriggerPressurePlate_5.set("static", false);
        reflect_EntityBat_method_doesEntityNotTriggerPressurePlate_5.set("argnames", new String[]{});
        reflect_EntityBat_method_doesEntityNotTriggerPressurePlate_5.set("argtypes", new String[]{});
        reflect_EntityBat_method_doesEntityNotTriggerPressurePlate_5.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityBat) params.getReflective("_self")).doesEntityNotTriggerPressurePlate();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityBat_methods.add(reflect_EntityBat_method_doesEntityNotTriggerPressurePlate_5);


        BaseData reflect_EntityBat_method_attackEntityFrom_6 = new ModData();
        reflect_EntityBat_method_attackEntityFrom_6.set("methodName", "attackEntityFrom");
        reflect_EntityBat_method_attackEntityFrom_6.set("returnType", "boolean");
        reflect_EntityBat_method_attackEntityFrom_6.set("static", false);
        reflect_EntityBat_method_attackEntityFrom_6.set("argnames", new String[]{"damagesource", "f"});
        reflect_EntityBat_method_attackEntityFrom_6.set("argtypes", new String[]{"DamageSource", "float"});
        reflect_EntityBat_method_attackEntityFrom_6.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityBat) params.getReflective("_self")).attackEntityFrom((DamageSource) params.getReflective("damagesource"), (float) params.getFloat("f"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityBat_methods.add(reflect_EntityBat_method_attackEntityFrom_6);


        BaseData reflect_EntityBat_method_readEntityFromNBT_7 = new ModData();
        reflect_EntityBat_method_readEntityFromNBT_7.set("methodName", "readEntityFromNBT");
        reflect_EntityBat_method_readEntityFromNBT_7.set("returnType", "void");
        reflect_EntityBat_method_readEntityFromNBT_7.set("static", false);
        reflect_EntityBat_method_readEntityFromNBT_7.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityBat_method_readEntityFromNBT_7.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityBat_method_readEntityFromNBT_7.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityBat) params.getReflective("_self")).readEntityFromNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityBat_methods.add(reflect_EntityBat_method_readEntityFromNBT_7);


        BaseData reflect_EntityBat_method_writeEntityToNBT_8 = new ModData();
        reflect_EntityBat_method_writeEntityToNBT_8.set("methodName", "writeEntityToNBT");
        reflect_EntityBat_method_writeEntityToNBT_8.set("returnType", "void");
        reflect_EntityBat_method_writeEntityToNBT_8.set("static", false);
        reflect_EntityBat_method_writeEntityToNBT_8.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityBat_method_writeEntityToNBT_8.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityBat_method_writeEntityToNBT_8.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityBat) params.getReflective("_self")).writeEntityToNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityBat_methods.add(reflect_EntityBat_method_writeEntityToNBT_8);


        BaseData reflect_EntityBat_method_getCanSpawnHere_9 = new ModData();
        reflect_EntityBat_method_getCanSpawnHere_9.set("methodName", "getCanSpawnHere");
        reflect_EntityBat_method_getCanSpawnHere_9.set("returnType", "boolean");
        reflect_EntityBat_method_getCanSpawnHere_9.set("static", false);
        reflect_EntityBat_method_getCanSpawnHere_9.set("argnames", new String[]{});
        reflect_EntityBat_method_getCanSpawnHere_9.set("argtypes", new String[]{});
        reflect_EntityBat_method_getCanSpawnHere_9.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityBat) params.getReflective("_self")).getCanSpawnHere();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityBat_methods.add(reflect_EntityBat_method_getCanSpawnHere_9);


        BaseData reflect_EntityBat_method_getEyeHeight_10 = new ModData();
        reflect_EntityBat_method_getEyeHeight_10.set("methodName", "getEyeHeight");
        reflect_EntityBat_method_getEyeHeight_10.set("returnType", "float");
        reflect_EntityBat_method_getEyeHeight_10.set("static", false);
        reflect_EntityBat_method_getEyeHeight_10.set("argnames", new String[]{});
        reflect_EntityBat_method_getEyeHeight_10.set("argtypes", new String[]{});
        reflect_EntityBat_method_getEyeHeight_10.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityBat) params.getReflective("_self")).getEyeHeight();
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityBat_methods.add(reflect_EntityBat_method_getEyeHeight_10);


        BaseData[] reflect_EntityBat_methods_arr = new BaseData[reflect_EntityBat_methods.size()];
        for (int i = 0; i < reflect_EntityBat_methods_arr.length; i++) {
            reflect_EntityBat_methods_arr[i] = reflect_EntityBat_methods.get(i);
        }

        reflect_EntityBat.set("constructors", reflect_EntityBat_constructors_arr);
        reflect_EntityBat.set("methods", reflect_EntityBat_methods_arr);
        reflect_EntityBat.set("className", "EntityBat");
        reflect_EntityBat.set("classId", "net.minecraft.entity.passive.EntityBat");
        reflect_EntityBat.set("class", EntityBat.class);
        reflect_EntityBat.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityBat;
        });
        reflectProfiles.add(reflect_EntityBat);
    }


    //classdef for EntityChicken
    public static void reflect_EntityChicken_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityChicken = new ModData();

        ArrayList<BaseData> reflect_EntityChicken_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_EntityChicken_constructor_EntityChicken_0 = new ModData();
        reflect_EntityChicken_constructor_EntityChicken_0.set("returnType", "EntityChicken");
        reflect_EntityChicken_constructor_EntityChicken_0.set("argnames", new String[]{"worldIn"});
        reflect_EntityChicken_constructor_EntityChicken_0.set("argtypes", new String[]{"World"});
        reflect_EntityChicken_constructor_EntityChicken_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityChicken((World) params.getReflective("worldIn"));
        });
        
        reflect_EntityChicken_constructors.add(reflect_EntityChicken_constructor_EntityChicken_0);


        BaseData[] reflect_EntityChicken_constructors_arr = new BaseData[reflect_EntityChicken_constructors.size()];
        for (int i = 0; i < reflect_EntityChicken_constructors_arr.length; i++) {
            reflect_EntityChicken_constructors_arr[i] = reflect_EntityChicken_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityChicken_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityChicken_method_getEyeHeight_0 = new ModData();
        reflect_EntityChicken_method_getEyeHeight_0.set("methodName", "getEyeHeight");
        reflect_EntityChicken_method_getEyeHeight_0.set("returnType", "float");
        reflect_EntityChicken_method_getEyeHeight_0.set("static", false);
        reflect_EntityChicken_method_getEyeHeight_0.set("argnames", new String[]{});
        reflect_EntityChicken_method_getEyeHeight_0.set("argtypes", new String[]{});
        reflect_EntityChicken_method_getEyeHeight_0.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityChicken) params.getReflective("_self")).getEyeHeight();
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityChicken_methods.add(reflect_EntityChicken_method_getEyeHeight_0);


        BaseData reflect_EntityChicken_method_onLivingUpdate_1 = new ModData();
        reflect_EntityChicken_method_onLivingUpdate_1.set("methodName", "onLivingUpdate");
        reflect_EntityChicken_method_onLivingUpdate_1.set("returnType", "void");
        reflect_EntityChicken_method_onLivingUpdate_1.set("static", false);
        reflect_EntityChicken_method_onLivingUpdate_1.set("argnames", new String[]{});
        reflect_EntityChicken_method_onLivingUpdate_1.set("argtypes", new String[]{});
        reflect_EntityChicken_method_onLivingUpdate_1.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityChicken) params.getReflective("_self")).onLivingUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityChicken_methods.add(reflect_EntityChicken_method_onLivingUpdate_1);


        BaseData reflect_EntityChicken_method_fall_2 = new ModData();
        reflect_EntityChicken_method_fall_2.set("methodName", "fall");
        reflect_EntityChicken_method_fall_2.set("returnType", "void");
        reflect_EntityChicken_method_fall_2.set("static", false);
        reflect_EntityChicken_method_fall_2.set("argnames", new String[]{"var1", "var2"});
        reflect_EntityChicken_method_fall_2.set("argtypes", new String[]{"float", "float"});
        reflect_EntityChicken_method_fall_2.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityChicken) params.getReflective("_self")).fall((float) params.getFloat("var1"), (float) params.getFloat("var2"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityChicken_methods.add(reflect_EntityChicken_method_fall_2);


        BaseData reflect_EntityChicken_method_createChild_3 = new ModData();
        reflect_EntityChicken_method_createChild_3.set("methodName", "createChild");
        reflect_EntityChicken_method_createChild_3.set("returnType", "EntityChicken");
        reflect_EntityChicken_method_createChild_3.set("static", false);
        reflect_EntityChicken_method_createChild_3.set("argnames", new String[]{"var1"});
        reflect_EntityChicken_method_createChild_3.set("argtypes", new String[]{"EntityAgeable"});
        reflect_EntityChicken_method_createChild_3.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EntityChicken) ((EntityChicken) params.getReflective("_self")).createChild((EntityAgeable) params.getReflective("var1"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityChicken_methods.add(reflect_EntityChicken_method_createChild_3);


        BaseData reflect_EntityChicken_method_isBreedingItem_4 = new ModData();
        reflect_EntityChicken_method_isBreedingItem_4.set("methodName", "isBreedingItem");
        reflect_EntityChicken_method_isBreedingItem_4.set("returnType", "boolean");
        reflect_EntityChicken_method_isBreedingItem_4.set("static", false);
        reflect_EntityChicken_method_isBreedingItem_4.set("argnames", new String[]{"itemstack"});
        reflect_EntityChicken_method_isBreedingItem_4.set("argtypes", new String[]{"ItemStack"});
        reflect_EntityChicken_method_isBreedingItem_4.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityChicken) params.getReflective("_self")).isBreedingItem((ItemStack) params.getReflective("itemstack"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityChicken_methods.add(reflect_EntityChicken_method_isBreedingItem_4);


        BaseData reflect_EntityChicken_method_readEntityFromNBT_5 = new ModData();
        reflect_EntityChicken_method_readEntityFromNBT_5.set("methodName", "readEntityFromNBT");
        reflect_EntityChicken_method_readEntityFromNBT_5.set("returnType", "void");
        reflect_EntityChicken_method_readEntityFromNBT_5.set("static", false);
        reflect_EntityChicken_method_readEntityFromNBT_5.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityChicken_method_readEntityFromNBT_5.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityChicken_method_readEntityFromNBT_5.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityChicken) params.getReflective("_self")).readEntityFromNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityChicken_methods.add(reflect_EntityChicken_method_readEntityFromNBT_5);


        BaseData reflect_EntityChicken_method_writeEntityToNBT_6 = new ModData();
        reflect_EntityChicken_method_writeEntityToNBT_6.set("methodName", "writeEntityToNBT");
        reflect_EntityChicken_method_writeEntityToNBT_6.set("returnType", "void");
        reflect_EntityChicken_method_writeEntityToNBT_6.set("static", false);
        reflect_EntityChicken_method_writeEntityToNBT_6.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityChicken_method_writeEntityToNBT_6.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityChicken_method_writeEntityToNBT_6.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityChicken) params.getReflective("_self")).writeEntityToNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityChicken_methods.add(reflect_EntityChicken_method_writeEntityToNBT_6);


        BaseData reflect_EntityChicken_method_updateRiderPosition_7 = new ModData();
        reflect_EntityChicken_method_updateRiderPosition_7.set("methodName", "updateRiderPosition");
        reflect_EntityChicken_method_updateRiderPosition_7.set("returnType", "void");
        reflect_EntityChicken_method_updateRiderPosition_7.set("static", false);
        reflect_EntityChicken_method_updateRiderPosition_7.set("argnames", new String[]{});
        reflect_EntityChicken_method_updateRiderPosition_7.set("argtypes", new String[]{});
        reflect_EntityChicken_method_updateRiderPosition_7.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityChicken) params.getReflective("_self")).updateRiderPosition();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityChicken_methods.add(reflect_EntityChicken_method_updateRiderPosition_7);


        BaseData reflect_EntityChicken_method_isChickenJockey_8 = new ModData();
        reflect_EntityChicken_method_isChickenJockey_8.set("methodName", "isChickenJockey");
        reflect_EntityChicken_method_isChickenJockey_8.set("returnType", "boolean");
        reflect_EntityChicken_method_isChickenJockey_8.set("static", false);
        reflect_EntityChicken_method_isChickenJockey_8.set("argnames", new String[]{});
        reflect_EntityChicken_method_isChickenJockey_8.set("argtypes", new String[]{});
        reflect_EntityChicken_method_isChickenJockey_8.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityChicken) params.getReflective("_self")).isChickenJockey();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityChicken_methods.add(reflect_EntityChicken_method_isChickenJockey_8);


        BaseData reflect_EntityChicken_method_setChickenJockey_9 = new ModData();
        reflect_EntityChicken_method_setChickenJockey_9.set("methodName", "setChickenJockey");
        reflect_EntityChicken_method_setChickenJockey_9.set("returnType", "void");
        reflect_EntityChicken_method_setChickenJockey_9.set("static", false);
        reflect_EntityChicken_method_setChickenJockey_9.set("argnames", new String[]{"jockey"});
        reflect_EntityChicken_method_setChickenJockey_9.set("argtypes", new String[]{"boolean"});
        reflect_EntityChicken_method_setChickenJockey_9.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityChicken) params.getReflective("_self")).setChickenJockey((boolean) params.getBoolean("jockey"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityChicken_methods.add(reflect_EntityChicken_method_setChickenJockey_9);


        BaseData[] reflect_EntityChicken_methods_arr = new BaseData[reflect_EntityChicken_methods.size()];
        for (int i = 0; i < reflect_EntityChicken_methods_arr.length; i++) {
            reflect_EntityChicken_methods_arr[i] = reflect_EntityChicken_methods.get(i);
        }

        reflect_EntityChicken.set("constructors", reflect_EntityChicken_constructors_arr);
        reflect_EntityChicken.set("methods", reflect_EntityChicken_methods_arr);
        reflect_EntityChicken.set("className", "EntityChicken");
        reflect_EntityChicken.set("classId", "net.minecraft.entity.passive.EntityChicken");
        reflect_EntityChicken.set("class", EntityChicken.class);
        reflect_EntityChicken.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityChicken;
        });
        reflectProfiles.add(reflect_EntityChicken);
    }


    //classdef for EntityCow
    public static void reflect_EntityCow_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityCow = new ModData();

        ArrayList<BaseData> reflect_EntityCow_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_EntityCow_constructor_EntityCow_0 = new ModData();
        reflect_EntityCow_constructor_EntityCow_0.set("returnType", "EntityCow");
        reflect_EntityCow_constructor_EntityCow_0.set("argnames", new String[]{"worldIn"});
        reflect_EntityCow_constructor_EntityCow_0.set("argtypes", new String[]{"World"});
        reflect_EntityCow_constructor_EntityCow_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityCow((World) params.getReflective("worldIn"));
        });
        
        reflect_EntityCow_constructors.add(reflect_EntityCow_constructor_EntityCow_0);


        BaseData[] reflect_EntityCow_constructors_arr = new BaseData[reflect_EntityCow_constructors.size()];
        for (int i = 0; i < reflect_EntityCow_constructors_arr.length; i++) {
            reflect_EntityCow_constructors_arr[i] = reflect_EntityCow_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityCow_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityCow_method_interact_0 = new ModData();
        reflect_EntityCow_method_interact_0.set("methodName", "interact");
        reflect_EntityCow_method_interact_0.set("returnType", "boolean");
        reflect_EntityCow_method_interact_0.set("static", false);
        reflect_EntityCow_method_interact_0.set("argnames", new String[]{"entityplayer"});
        reflect_EntityCow_method_interact_0.set("argtypes", new String[]{"EntityPlayer"});
        reflect_EntityCow_method_interact_0.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityCow) params.getReflective("_self")).interact((EntityPlayer) params.getReflective("entityplayer"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityCow_methods.add(reflect_EntityCow_method_interact_0);


        BaseData reflect_EntityCow_method_createChild_1 = new ModData();
        reflect_EntityCow_method_createChild_1.set("methodName", "createChild");
        reflect_EntityCow_method_createChild_1.set("returnType", "EntityCow");
        reflect_EntityCow_method_createChild_1.set("static", false);
        reflect_EntityCow_method_createChild_1.set("argnames", new String[]{"var1"});
        reflect_EntityCow_method_createChild_1.set("argtypes", new String[]{"EntityAgeable"});
        reflect_EntityCow_method_createChild_1.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EntityCow) ((EntityCow) params.getReflective("_self")).createChild((EntityAgeable) params.getReflective("var1"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityCow_methods.add(reflect_EntityCow_method_createChild_1);


        BaseData reflect_EntityCow_method_getEyeHeight_2 = new ModData();
        reflect_EntityCow_method_getEyeHeight_2.set("methodName", "getEyeHeight");
        reflect_EntityCow_method_getEyeHeight_2.set("returnType", "float");
        reflect_EntityCow_method_getEyeHeight_2.set("static", false);
        reflect_EntityCow_method_getEyeHeight_2.set("argnames", new String[]{});
        reflect_EntityCow_method_getEyeHeight_2.set("argtypes", new String[]{});
        reflect_EntityCow_method_getEyeHeight_2.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityCow) params.getReflective("_self")).getEyeHeight();
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityCow_methods.add(reflect_EntityCow_method_getEyeHeight_2);


        BaseData[] reflect_EntityCow_methods_arr = new BaseData[reflect_EntityCow_methods.size()];
        for (int i = 0; i < reflect_EntityCow_methods_arr.length; i++) {
            reflect_EntityCow_methods_arr[i] = reflect_EntityCow_methods.get(i);
        }

        reflect_EntityCow.set("constructors", reflect_EntityCow_constructors_arr);
        reflect_EntityCow.set("methods", reflect_EntityCow_methods_arr);
        reflect_EntityCow.set("className", "EntityCow");
        reflect_EntityCow.set("classId", "net.minecraft.entity.passive.EntityCow");
        reflect_EntityCow.set("class", EntityCow.class);
        reflect_EntityCow.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityCow;
        });
        reflectProfiles.add(reflect_EntityCow);
    }


    //classdef for EntityHorse
    public static void reflect_EntityHorse_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityHorse = new ModData();

        ArrayList<BaseData> reflect_EntityHorse_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_EntityHorse_constructor_EntityHorse_0 = new ModData();
        reflect_EntityHorse_constructor_EntityHorse_0.set("returnType", "EntityHorse");
        reflect_EntityHorse_constructor_EntityHorse_0.set("argnames", new String[]{"worldIn"});
        reflect_EntityHorse_constructor_EntityHorse_0.set("argtypes", new String[]{"World"});
        reflect_EntityHorse_constructor_EntityHorse_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityHorse((World) params.getReflective("worldIn"));
        });
        
        reflect_EntityHorse_constructors.add(reflect_EntityHorse_constructor_EntityHorse_0);


        BaseData[] reflect_EntityHorse_constructors_arr = new BaseData[reflect_EntityHorse_constructors.size()];
        for (int i = 0; i < reflect_EntityHorse_constructors_arr.length; i++) {
            reflect_EntityHorse_constructors_arr[i] = reflect_EntityHorse_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityHorse_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityHorse_method_setHorseType_0 = new ModData();
        reflect_EntityHorse_method_setHorseType_0.set("methodName", "setHorseType");
        reflect_EntityHorse_method_setHorseType_0.set("returnType", "void");
        reflect_EntityHorse_method_setHorseType_0.set("static", false);
        reflect_EntityHorse_method_setHorseType_0.set("argnames", new String[]{"type"});
        reflect_EntityHorse_method_setHorseType_0.set("argtypes", new String[]{"int"});
        reflect_EntityHorse_method_setHorseType_0.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityHorse) params.getReflective("_self")).setHorseType((int) params.getInt("type"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_setHorseType_0);


        BaseData reflect_EntityHorse_method_getHorseType_1 = new ModData();
        reflect_EntityHorse_method_getHorseType_1.set("methodName", "getHorseType");
        reflect_EntityHorse_method_getHorseType_1.set("returnType", "int");
        reflect_EntityHorse_method_getHorseType_1.set("static", false);
        reflect_EntityHorse_method_getHorseType_1.set("argnames", new String[]{});
        reflect_EntityHorse_method_getHorseType_1.set("argtypes", new String[]{});
        reflect_EntityHorse_method_getHorseType_1.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityHorse) params.getReflective("_self")).getHorseType();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_getHorseType_1);


        BaseData reflect_EntityHorse_method_setHorseVariant_2 = new ModData();
        reflect_EntityHorse_method_setHorseVariant_2.set("methodName", "setHorseVariant");
        reflect_EntityHorse_method_setHorseVariant_2.set("returnType", "void");
        reflect_EntityHorse_method_setHorseVariant_2.set("static", false);
        reflect_EntityHorse_method_setHorseVariant_2.set("argnames", new String[]{"variant"});
        reflect_EntityHorse_method_setHorseVariant_2.set("argtypes", new String[]{"int"});
        reflect_EntityHorse_method_setHorseVariant_2.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityHorse) params.getReflective("_self")).setHorseVariant((int) params.getInt("variant"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_setHorseVariant_2);


        BaseData reflect_EntityHorse_method_getHorseVariant_3 = new ModData();
        reflect_EntityHorse_method_getHorseVariant_3.set("methodName", "getHorseVariant");
        reflect_EntityHorse_method_getHorseVariant_3.set("returnType", "int");
        reflect_EntityHorse_method_getHorseVariant_3.set("static", false);
        reflect_EntityHorse_method_getHorseVariant_3.set("argnames", new String[]{});
        reflect_EntityHorse_method_getHorseVariant_3.set("argtypes", new String[]{});
        reflect_EntityHorse_method_getHorseVariant_3.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityHorse) params.getReflective("_self")).getHorseVariant();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_getHorseVariant_3);


        BaseData reflect_EntityHorse_method_getName_4 = new ModData();
        reflect_EntityHorse_method_getName_4.set("methodName", "getName");
        reflect_EntityHorse_method_getName_4.set("returnType", "String");
        reflect_EntityHorse_method_getName_4.set("static", false);
        reflect_EntityHorse_method_getName_4.set("argnames", new String[]{});
        reflect_EntityHorse_method_getName_4.set("argtypes", new String[]{});
        reflect_EntityHorse_method_getName_4.setCallbackStringWithDataArg("exec", (BaseData params) -> {
                try {
                    return (String) ((EntityHorse) params.getReflective("_self")).getName();
                } catch (Exception _exception_reflect_) {
                    return "";
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_getName_4);


        BaseData reflect_EntityHorse_method_isAdultHorse_5 = new ModData();
        reflect_EntityHorse_method_isAdultHorse_5.set("methodName", "isAdultHorse");
        reflect_EntityHorse_method_isAdultHorse_5.set("returnType", "boolean");
        reflect_EntityHorse_method_isAdultHorse_5.set("static", false);
        reflect_EntityHorse_method_isAdultHorse_5.set("argnames", new String[]{});
        reflect_EntityHorse_method_isAdultHorse_5.set("argtypes", new String[]{});
        reflect_EntityHorse_method_isAdultHorse_5.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityHorse) params.getReflective("_self")).isAdultHorse();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_isAdultHorse_5);


        BaseData reflect_EntityHorse_method_isTame_6 = new ModData();
        reflect_EntityHorse_method_isTame_6.set("methodName", "isTame");
        reflect_EntityHorse_method_isTame_6.set("returnType", "boolean");
        reflect_EntityHorse_method_isTame_6.set("static", false);
        reflect_EntityHorse_method_isTame_6.set("argnames", new String[]{});
        reflect_EntityHorse_method_isTame_6.set("argtypes", new String[]{});
        reflect_EntityHorse_method_isTame_6.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityHorse) params.getReflective("_self")).isTame();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_isTame_6);


        BaseData reflect_EntityHorse_method_func_110253_bW_7 = new ModData();
        reflect_EntityHorse_method_func_110253_bW_7.set("methodName", "func_110253_bW");
        reflect_EntityHorse_method_func_110253_bW_7.set("returnType", "boolean");
        reflect_EntityHorse_method_func_110253_bW_7.set("static", false);
        reflect_EntityHorse_method_func_110253_bW_7.set("argnames", new String[]{});
        reflect_EntityHorse_method_func_110253_bW_7.set("argtypes", new String[]{});
        reflect_EntityHorse_method_func_110253_bW_7.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityHorse) params.getReflective("_self")).func_110253_bW();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_func_110253_bW_7);


        BaseData reflect_EntityHorse_method_getOwnerId_8 = new ModData();
        reflect_EntityHorse_method_getOwnerId_8.set("methodName", "getOwnerId");
        reflect_EntityHorse_method_getOwnerId_8.set("returnType", "String");
        reflect_EntityHorse_method_getOwnerId_8.set("static", false);
        reflect_EntityHorse_method_getOwnerId_8.set("argnames", new String[]{});
        reflect_EntityHorse_method_getOwnerId_8.set("argtypes", new String[]{});
        reflect_EntityHorse_method_getOwnerId_8.setCallbackStringWithDataArg("exec", (BaseData params) -> {
                try {
                    return (String) ((EntityHorse) params.getReflective("_self")).getOwnerId();
                } catch (Exception _exception_reflect_) {
                    return "";
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_getOwnerId_8);


        BaseData reflect_EntityHorse_method_setOwnerId_9 = new ModData();
        reflect_EntityHorse_method_setOwnerId_9.set("methodName", "setOwnerId");
        reflect_EntityHorse_method_setOwnerId_9.set("returnType", "void");
        reflect_EntityHorse_method_setOwnerId_9.set("static", false);
        reflect_EntityHorse_method_setOwnerId_9.set("argnames", new String[]{"id"});
        reflect_EntityHorse_method_setOwnerId_9.set("argtypes", new String[]{"String"});
        reflect_EntityHorse_method_setOwnerId_9.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityHorse) params.getReflective("_self")).setOwnerId((String) params.getString("id"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_setOwnerId_9);


        BaseData reflect_EntityHorse_method_getHorseSize_10 = new ModData();
        reflect_EntityHorse_method_getHorseSize_10.set("methodName", "getHorseSize");
        reflect_EntityHorse_method_getHorseSize_10.set("returnType", "float");
        reflect_EntityHorse_method_getHorseSize_10.set("static", false);
        reflect_EntityHorse_method_getHorseSize_10.set("argnames", new String[]{});
        reflect_EntityHorse_method_getHorseSize_10.set("argtypes", new String[]{});
        reflect_EntityHorse_method_getHorseSize_10.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityHorse) params.getReflective("_self")).getHorseSize();
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_getHorseSize_10);


        BaseData reflect_EntityHorse_method_setScaleForAge_11 = new ModData();
        reflect_EntityHorse_method_setScaleForAge_11.set("methodName", "setScaleForAge");
        reflect_EntityHorse_method_setScaleForAge_11.set("returnType", "void");
        reflect_EntityHorse_method_setScaleForAge_11.set("static", false);
        reflect_EntityHorse_method_setScaleForAge_11.set("argnames", new String[]{"flag"});
        reflect_EntityHorse_method_setScaleForAge_11.set("argtypes", new String[]{"boolean"});
        reflect_EntityHorse_method_setScaleForAge_11.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityHorse) params.getReflective("_self")).setScaleForAge((boolean) params.getBoolean("flag"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_setScaleForAge_11);


        BaseData reflect_EntityHorse_method_isHorseJumping_12 = new ModData();
        reflect_EntityHorse_method_isHorseJumping_12.set("methodName", "isHorseJumping");
        reflect_EntityHorse_method_isHorseJumping_12.set("returnType", "boolean");
        reflect_EntityHorse_method_isHorseJumping_12.set("static", false);
        reflect_EntityHorse_method_isHorseJumping_12.set("argnames", new String[]{});
        reflect_EntityHorse_method_isHorseJumping_12.set("argtypes", new String[]{});
        reflect_EntityHorse_method_isHorseJumping_12.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityHorse) params.getReflective("_self")).isHorseJumping();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_isHorseJumping_12);


        BaseData reflect_EntityHorse_method_setHorseTamed_13 = new ModData();
        reflect_EntityHorse_method_setHorseTamed_13.set("methodName", "setHorseTamed");
        reflect_EntityHorse_method_setHorseTamed_13.set("returnType", "void");
        reflect_EntityHorse_method_setHorseTamed_13.set("static", false);
        reflect_EntityHorse_method_setHorseTamed_13.set("argnames", new String[]{"tamed"});
        reflect_EntityHorse_method_setHorseTamed_13.set("argtypes", new String[]{"boolean"});
        reflect_EntityHorse_method_setHorseTamed_13.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityHorse) params.getReflective("_self")).setHorseTamed((boolean) params.getBoolean("tamed"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_setHorseTamed_13);


        BaseData reflect_EntityHorse_method_setHorseJumping_14 = new ModData();
        reflect_EntityHorse_method_setHorseJumping_14.set("methodName", "setHorseJumping");
        reflect_EntityHorse_method_setHorseJumping_14.set("returnType", "void");
        reflect_EntityHorse_method_setHorseJumping_14.set("static", false);
        reflect_EntityHorse_method_setHorseJumping_14.set("argnames", new String[]{"jumping"});
        reflect_EntityHorse_method_setHorseJumping_14.set("argtypes", new String[]{"boolean"});
        reflect_EntityHorse_method_setHorseJumping_14.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityHorse) params.getReflective("_self")).setHorseJumping((boolean) params.getBoolean("jumping"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_setHorseJumping_14);


        BaseData reflect_EntityHorse_method_allowLeashing_15 = new ModData();
        reflect_EntityHorse_method_allowLeashing_15.set("methodName", "allowLeashing");
        reflect_EntityHorse_method_allowLeashing_15.set("returnType", "boolean");
        reflect_EntityHorse_method_allowLeashing_15.set("static", false);
        reflect_EntityHorse_method_allowLeashing_15.set("argnames", new String[]{});
        reflect_EntityHorse_method_allowLeashing_15.set("argtypes", new String[]{});
        reflect_EntityHorse_method_allowLeashing_15.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityHorse) params.getReflective("_self")).allowLeashing();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_allowLeashing_15);


        BaseData reflect_EntityHorse_method_isChested_16 = new ModData();
        reflect_EntityHorse_method_isChested_16.set("methodName", "isChested");
        reflect_EntityHorse_method_isChested_16.set("returnType", "boolean");
        reflect_EntityHorse_method_isChested_16.set("static", false);
        reflect_EntityHorse_method_isChested_16.set("argnames", new String[]{});
        reflect_EntityHorse_method_isChested_16.set("argtypes", new String[]{});
        reflect_EntityHorse_method_isChested_16.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityHorse) params.getReflective("_self")).isChested();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_isChested_16);


        BaseData reflect_EntityHorse_method_getHorseArmorIndexSynced_17 = new ModData();
        reflect_EntityHorse_method_getHorseArmorIndexSynced_17.set("methodName", "getHorseArmorIndexSynced");
        reflect_EntityHorse_method_getHorseArmorIndexSynced_17.set("returnType", "int");
        reflect_EntityHorse_method_getHorseArmorIndexSynced_17.set("static", false);
        reflect_EntityHorse_method_getHorseArmorIndexSynced_17.set("argnames", new String[]{});
        reflect_EntityHorse_method_getHorseArmorIndexSynced_17.set("argtypes", new String[]{});
        reflect_EntityHorse_method_getHorseArmorIndexSynced_17.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityHorse) params.getReflective("_self")).getHorseArmorIndexSynced();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_getHorseArmorIndexSynced_17);


        BaseData reflect_EntityHorse_method_isEatingHaystack_18 = new ModData();
        reflect_EntityHorse_method_isEatingHaystack_18.set("methodName", "isEatingHaystack");
        reflect_EntityHorse_method_isEatingHaystack_18.set("returnType", "boolean");
        reflect_EntityHorse_method_isEatingHaystack_18.set("static", false);
        reflect_EntityHorse_method_isEatingHaystack_18.set("argnames", new String[]{});
        reflect_EntityHorse_method_isEatingHaystack_18.set("argtypes", new String[]{});
        reflect_EntityHorse_method_isEatingHaystack_18.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityHorse) params.getReflective("_self")).isEatingHaystack();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_isEatingHaystack_18);


        BaseData reflect_EntityHorse_method_isRearing_19 = new ModData();
        reflect_EntityHorse_method_isRearing_19.set("methodName", "isRearing");
        reflect_EntityHorse_method_isRearing_19.set("returnType", "boolean");
        reflect_EntityHorse_method_isRearing_19.set("static", false);
        reflect_EntityHorse_method_isRearing_19.set("argnames", new String[]{});
        reflect_EntityHorse_method_isRearing_19.set("argtypes", new String[]{});
        reflect_EntityHorse_method_isRearing_19.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityHorse) params.getReflective("_self")).isRearing();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_isRearing_19);


        BaseData reflect_EntityHorse_method_isBreeding_20 = new ModData();
        reflect_EntityHorse_method_isBreeding_20.set("methodName", "isBreeding");
        reflect_EntityHorse_method_isBreeding_20.set("returnType", "boolean");
        reflect_EntityHorse_method_isBreeding_20.set("static", false);
        reflect_EntityHorse_method_isBreeding_20.set("argnames", new String[]{});
        reflect_EntityHorse_method_isBreeding_20.set("argtypes", new String[]{});
        reflect_EntityHorse_method_isBreeding_20.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityHorse) params.getReflective("_self")).isBreeding();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_isBreeding_20);


        BaseData reflect_EntityHorse_method_getHasReproduced_21 = new ModData();
        reflect_EntityHorse_method_getHasReproduced_21.set("methodName", "getHasReproduced");
        reflect_EntityHorse_method_getHasReproduced_21.set("returnType", "boolean");
        reflect_EntityHorse_method_getHasReproduced_21.set("static", false);
        reflect_EntityHorse_method_getHasReproduced_21.set("argnames", new String[]{});
        reflect_EntityHorse_method_getHasReproduced_21.set("argtypes", new String[]{});
        reflect_EntityHorse_method_getHasReproduced_21.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityHorse) params.getReflective("_self")).getHasReproduced();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_getHasReproduced_21);


        BaseData reflect_EntityHorse_method_setHorseArmorStack_22 = new ModData();
        reflect_EntityHorse_method_setHorseArmorStack_22.set("methodName", "setHorseArmorStack");
        reflect_EntityHorse_method_setHorseArmorStack_22.set("returnType", "void");
        reflect_EntityHorse_method_setHorseArmorStack_22.set("static", false);
        reflect_EntityHorse_method_setHorseArmorStack_22.set("argnames", new String[]{"itemStackIn"});
        reflect_EntityHorse_method_setHorseArmorStack_22.set("argtypes", new String[]{"ItemStack"});
        reflect_EntityHorse_method_setHorseArmorStack_22.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityHorse) params.getReflective("_self")).setHorseArmorStack((ItemStack) params.getReflective("itemStackIn"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_setHorseArmorStack_22);


        BaseData reflect_EntityHorse_method_setBreeding_23 = new ModData();
        reflect_EntityHorse_method_setBreeding_23.set("methodName", "setBreeding");
        reflect_EntityHorse_method_setBreeding_23.set("returnType", "void");
        reflect_EntityHorse_method_setBreeding_23.set("static", false);
        reflect_EntityHorse_method_setBreeding_23.set("argnames", new String[]{"breeding"});
        reflect_EntityHorse_method_setBreeding_23.set("argtypes", new String[]{"boolean"});
        reflect_EntityHorse_method_setBreeding_23.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityHorse) params.getReflective("_self")).setBreeding((boolean) params.getBoolean("breeding"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_setBreeding_23);


        BaseData reflect_EntityHorse_method_setChested_24 = new ModData();
        reflect_EntityHorse_method_setChested_24.set("methodName", "setChested");
        reflect_EntityHorse_method_setChested_24.set("returnType", "void");
        reflect_EntityHorse_method_setChested_24.set("static", false);
        reflect_EntityHorse_method_setChested_24.set("argnames", new String[]{"chested"});
        reflect_EntityHorse_method_setChested_24.set("argtypes", new String[]{"boolean"});
        reflect_EntityHorse_method_setChested_24.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityHorse) params.getReflective("_self")).setChested((boolean) params.getBoolean("chested"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_setChested_24);


        BaseData reflect_EntityHorse_method_setHasReproduced_25 = new ModData();
        reflect_EntityHorse_method_setHasReproduced_25.set("methodName", "setHasReproduced");
        reflect_EntityHorse_method_setHasReproduced_25.set("returnType", "void");
        reflect_EntityHorse_method_setHasReproduced_25.set("static", false);
        reflect_EntityHorse_method_setHasReproduced_25.set("argnames", new String[]{"hasReproducedIn"});
        reflect_EntityHorse_method_setHasReproduced_25.set("argtypes", new String[]{"boolean"});
        reflect_EntityHorse_method_setHasReproduced_25.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityHorse) params.getReflective("_self")).setHasReproduced((boolean) params.getBoolean("hasReproducedIn"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_setHasReproduced_25);


        BaseData reflect_EntityHorse_method_setHorseSaddled_26 = new ModData();
        reflect_EntityHorse_method_setHorseSaddled_26.set("methodName", "setHorseSaddled");
        reflect_EntityHorse_method_setHorseSaddled_26.set("returnType", "void");
        reflect_EntityHorse_method_setHorseSaddled_26.set("static", false);
        reflect_EntityHorse_method_setHorseSaddled_26.set("argnames", new String[]{"saddled"});
        reflect_EntityHorse_method_setHorseSaddled_26.set("argtypes", new String[]{"boolean"});
        reflect_EntityHorse_method_setHorseSaddled_26.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityHorse) params.getReflective("_self")).setHorseSaddled((boolean) params.getBoolean("saddled"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_setHorseSaddled_26);


        BaseData reflect_EntityHorse_method_getTemper_27 = new ModData();
        reflect_EntityHorse_method_getTemper_27.set("methodName", "getTemper");
        reflect_EntityHorse_method_getTemper_27.set("returnType", "int");
        reflect_EntityHorse_method_getTemper_27.set("static", false);
        reflect_EntityHorse_method_getTemper_27.set("argnames", new String[]{});
        reflect_EntityHorse_method_getTemper_27.set("argtypes", new String[]{});
        reflect_EntityHorse_method_getTemper_27.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityHorse) params.getReflective("_self")).getTemper();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_getTemper_27);


        BaseData reflect_EntityHorse_method_setTemper_28 = new ModData();
        reflect_EntityHorse_method_setTemper_28.set("methodName", "setTemper");
        reflect_EntityHorse_method_setTemper_28.set("returnType", "void");
        reflect_EntityHorse_method_setTemper_28.set("static", false);
        reflect_EntityHorse_method_setTemper_28.set("argnames", new String[]{"temperIn"});
        reflect_EntityHorse_method_setTemper_28.set("argtypes", new String[]{"int"});
        reflect_EntityHorse_method_setTemper_28.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityHorse) params.getReflective("_self")).setTemper((int) params.getInt("temperIn"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_setTemper_28);


        BaseData reflect_EntityHorse_method_increaseTemper_29 = new ModData();
        reflect_EntityHorse_method_increaseTemper_29.set("methodName", "increaseTemper");
        reflect_EntityHorse_method_increaseTemper_29.set("returnType", "int");
        reflect_EntityHorse_method_increaseTemper_29.set("static", false);
        reflect_EntityHorse_method_increaseTemper_29.set("argnames", new String[]{"parInt1"});
        reflect_EntityHorse_method_increaseTemper_29.set("argtypes", new String[]{"int"});
        reflect_EntityHorse_method_increaseTemper_29.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityHorse) params.getReflective("_self")).increaseTemper((int) params.getInt("parInt1"));
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_increaseTemper_29);


        BaseData reflect_EntityHorse_method_attackEntityFrom_30 = new ModData();
        reflect_EntityHorse_method_attackEntityFrom_30.set("methodName", "attackEntityFrom");
        reflect_EntityHorse_method_attackEntityFrom_30.set("returnType", "boolean");
        reflect_EntityHorse_method_attackEntityFrom_30.set("static", false);
        reflect_EntityHorse_method_attackEntityFrom_30.set("argnames", new String[]{"damagesource", "f"});
        reflect_EntityHorse_method_attackEntityFrom_30.set("argtypes", new String[]{"DamageSource", "float"});
        reflect_EntityHorse_method_attackEntityFrom_30.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityHorse) params.getReflective("_self")).attackEntityFrom((DamageSource) params.getReflective("damagesource"), (float) params.getFloat("f"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_attackEntityFrom_30);


        BaseData reflect_EntityHorse_method_getTotalArmorValue_31 = new ModData();
        reflect_EntityHorse_method_getTotalArmorValue_31.set("methodName", "getTotalArmorValue");
        reflect_EntityHorse_method_getTotalArmorValue_31.set("returnType", "int");
        reflect_EntityHorse_method_getTotalArmorValue_31.set("static", false);
        reflect_EntityHorse_method_getTotalArmorValue_31.set("argnames", new String[]{});
        reflect_EntityHorse_method_getTotalArmorValue_31.set("argtypes", new String[]{});
        reflect_EntityHorse_method_getTotalArmorValue_31.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityHorse) params.getReflective("_self")).getTotalArmorValue();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_getTotalArmorValue_31);


        BaseData reflect_EntityHorse_method_canBePushed_32 = new ModData();
        reflect_EntityHorse_method_canBePushed_32.set("methodName", "canBePushed");
        reflect_EntityHorse_method_canBePushed_32.set("returnType", "boolean");
        reflect_EntityHorse_method_canBePushed_32.set("static", false);
        reflect_EntityHorse_method_canBePushed_32.set("argnames", new String[]{});
        reflect_EntityHorse_method_canBePushed_32.set("argtypes", new String[]{});
        reflect_EntityHorse_method_canBePushed_32.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityHorse) params.getReflective("_self")).canBePushed();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_canBePushed_32);


        BaseData reflect_EntityHorse_method_prepareChunkForSpawn_33 = new ModData();
        reflect_EntityHorse_method_prepareChunkForSpawn_33.set("methodName", "prepareChunkForSpawn");
        reflect_EntityHorse_method_prepareChunkForSpawn_33.set("returnType", "boolean");
        reflect_EntityHorse_method_prepareChunkForSpawn_33.set("static", false);
        reflect_EntityHorse_method_prepareChunkForSpawn_33.set("argnames", new String[]{});
        reflect_EntityHorse_method_prepareChunkForSpawn_33.set("argtypes", new String[]{});
        reflect_EntityHorse_method_prepareChunkForSpawn_33.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityHorse) params.getReflective("_self")).prepareChunkForSpawn();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_prepareChunkForSpawn_33);


        BaseData reflect_EntityHorse_method_dropChests_34 = new ModData();
        reflect_EntityHorse_method_dropChests_34.set("methodName", "dropChests");
        reflect_EntityHorse_method_dropChests_34.set("returnType", "void");
        reflect_EntityHorse_method_dropChests_34.set("static", false);
        reflect_EntityHorse_method_dropChests_34.set("argnames", new String[]{});
        reflect_EntityHorse_method_dropChests_34.set("argtypes", new String[]{});
        reflect_EntityHorse_method_dropChests_34.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityHorse) params.getReflective("_self")).dropChests();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_dropChests_34);


        BaseData reflect_EntityHorse_method_fall_35 = new ModData();
        reflect_EntityHorse_method_fall_35.set("methodName", "fall");
        reflect_EntityHorse_method_fall_35.set("returnType", "void");
        reflect_EntityHorse_method_fall_35.set("static", false);
        reflect_EntityHorse_method_fall_35.set("argnames", new String[]{"f", "f1"});
        reflect_EntityHorse_method_fall_35.set("argtypes", new String[]{"float", "float"});
        reflect_EntityHorse_method_fall_35.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityHorse) params.getReflective("_self")).fall((float) params.getFloat("f"), (float) params.getFloat("f1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_fall_35);


        BaseData reflect_EntityHorse_method_onInventoryChanged_36 = new ModData();
        reflect_EntityHorse_method_onInventoryChanged_36.set("methodName", "onInventoryChanged");
        reflect_EntityHorse_method_onInventoryChanged_36.set("returnType", "void");
        reflect_EntityHorse_method_onInventoryChanged_36.set("static", false);
        reflect_EntityHorse_method_onInventoryChanged_36.set("argnames", new String[]{"var1"});
        reflect_EntityHorse_method_onInventoryChanged_36.set("argtypes", new String[]{"InventoryBasic"});
        reflect_EntityHorse_method_onInventoryChanged_36.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityHorse) params.getReflective("_self")).onInventoryChanged((InventoryBasic) params.getReflective("var1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_onInventoryChanged_36);


        BaseData reflect_EntityHorse_method_getCanSpawnHere_37 = new ModData();
        reflect_EntityHorse_method_getCanSpawnHere_37.set("methodName", "getCanSpawnHere");
        reflect_EntityHorse_method_getCanSpawnHere_37.set("returnType", "boolean");
        reflect_EntityHorse_method_getCanSpawnHere_37.set("static", false);
        reflect_EntityHorse_method_getCanSpawnHere_37.set("argnames", new String[]{});
        reflect_EntityHorse_method_getCanSpawnHere_37.set("argtypes", new String[]{});
        reflect_EntityHorse_method_getCanSpawnHere_37.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityHorse) params.getReflective("_self")).getCanSpawnHere();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_getCanSpawnHere_37);


        BaseData reflect_EntityHorse_method_getHorseJumpStrength_38 = new ModData();
        reflect_EntityHorse_method_getHorseJumpStrength_38.set("methodName", "getHorseJumpStrength");
        reflect_EntityHorse_method_getHorseJumpStrength_38.set("returnType", "double");
        reflect_EntityHorse_method_getHorseJumpStrength_38.set("static", false);
        reflect_EntityHorse_method_getHorseJumpStrength_38.set("argnames", new String[]{});
        reflect_EntityHorse_method_getHorseJumpStrength_38.set("argtypes", new String[]{});
        reflect_EntityHorse_method_getHorseJumpStrength_38.setCallbackDoubleWithDataArg("exec", (BaseData params) -> {
                try {
                    return (double) ((EntityHorse) params.getReflective("_self")).getHorseJumpStrength();
                } catch (Exception _exception_reflect_) {
                    return 0.0d;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_getHorseJumpStrength_38);


        BaseData reflect_EntityHorse_method_isHorseSaddled_39 = new ModData();
        reflect_EntityHorse_method_isHorseSaddled_39.set("methodName", "isHorseSaddled");
        reflect_EntityHorse_method_isHorseSaddled_39.set("returnType", "boolean");
        reflect_EntityHorse_method_isHorseSaddled_39.set("static", false);
        reflect_EntityHorse_method_isHorseSaddled_39.set("argnames", new String[]{});
        reflect_EntityHorse_method_isHorseSaddled_39.set("argtypes", new String[]{});
        reflect_EntityHorse_method_isHorseSaddled_39.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityHorse) params.getReflective("_self")).isHorseSaddled();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_isHorseSaddled_39);


        BaseData reflect_EntityHorse_method_getMaxSpawnedInChunk_40 = new ModData();
        reflect_EntityHorse_method_getMaxSpawnedInChunk_40.set("methodName", "getMaxSpawnedInChunk");
        reflect_EntityHorse_method_getMaxSpawnedInChunk_40.set("returnType", "int");
        reflect_EntityHorse_method_getMaxSpawnedInChunk_40.set("static", false);
        reflect_EntityHorse_method_getMaxSpawnedInChunk_40.set("argnames", new String[]{});
        reflect_EntityHorse_method_getMaxSpawnedInChunk_40.set("argtypes", new String[]{});
        reflect_EntityHorse_method_getMaxSpawnedInChunk_40.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityHorse) params.getReflective("_self")).getMaxSpawnedInChunk();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_getMaxSpawnedInChunk_40);


        BaseData reflect_EntityHorse_method_getMaxTemper_41 = new ModData();
        reflect_EntityHorse_method_getMaxTemper_41.set("methodName", "getMaxTemper");
        reflect_EntityHorse_method_getMaxTemper_41.set("returnType", "int");
        reflect_EntityHorse_method_getMaxTemper_41.set("static", false);
        reflect_EntityHorse_method_getMaxTemper_41.set("argnames", new String[]{});
        reflect_EntityHorse_method_getMaxTemper_41.set("argtypes", new String[]{});
        reflect_EntityHorse_method_getMaxTemper_41.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityHorse) params.getReflective("_self")).getMaxTemper();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_getMaxTemper_41);


        BaseData reflect_EntityHorse_method_getTalkInterval_42 = new ModData();
        reflect_EntityHorse_method_getTalkInterval_42.set("methodName", "getTalkInterval");
        reflect_EntityHorse_method_getTalkInterval_42.set("returnType", "int");
        reflect_EntityHorse_method_getTalkInterval_42.set("static", false);
        reflect_EntityHorse_method_getTalkInterval_42.set("argnames", new String[]{});
        reflect_EntityHorse_method_getTalkInterval_42.set("argtypes", new String[]{});
        reflect_EntityHorse_method_getTalkInterval_42.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityHorse) params.getReflective("_self")).getTalkInterval();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_getTalkInterval_42);


        BaseData reflect_EntityHorse_method_func_110239_cn_43 = new ModData();
        reflect_EntityHorse_method_func_110239_cn_43.set("methodName", "func_110239_cn");
        reflect_EntityHorse_method_func_110239_cn_43.set("returnType", "boolean");
        reflect_EntityHorse_method_func_110239_cn_43.set("static", false);
        reflect_EntityHorse_method_func_110239_cn_43.set("argnames", new String[]{});
        reflect_EntityHorse_method_func_110239_cn_43.set("argtypes", new String[]{});
        reflect_EntityHorse_method_func_110239_cn_43.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityHorse) params.getReflective("_self")).func_110239_cn();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_func_110239_cn_43);


        BaseData reflect_EntityHorse_method_func_175507_cI_44 = new ModData();
        reflect_EntityHorse_method_func_175507_cI_44.set("methodName", "func_175507_cI");
        reflect_EntityHorse_method_func_175507_cI_44.set("returnType", "boolean");
        reflect_EntityHorse_method_func_175507_cI_44.set("static", false);
        reflect_EntityHorse_method_func_175507_cI_44.set("argnames", new String[]{});
        reflect_EntityHorse_method_func_175507_cI_44.set("argtypes", new String[]{});
        reflect_EntityHorse_method_func_175507_cI_44.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityHorse) params.getReflective("_self")).func_175507_cI();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_func_175507_cI_44);


        BaseData reflect_EntityHorse_method_getHorseTexture_45 = new ModData();
        reflect_EntityHorse_method_getHorseTexture_45.set("methodName", "getHorseTexture");
        reflect_EntityHorse_method_getHorseTexture_45.set("returnType", "String");
        reflect_EntityHorse_method_getHorseTexture_45.set("static", false);
        reflect_EntityHorse_method_getHorseTexture_45.set("argnames", new String[]{});
        reflect_EntityHorse_method_getHorseTexture_45.set("argtypes", new String[]{});
        reflect_EntityHorse_method_getHorseTexture_45.setCallbackStringWithDataArg("exec", (BaseData params) -> {
                try {
                    return (String) ((EntityHorse) params.getReflective("_self")).getHorseTexture();
                } catch (Exception _exception_reflect_) {
                    return "";
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_getHorseTexture_45);


        BaseData reflect_EntityHorse_method_getVariantTexturePaths_46 = new ModData();
        reflect_EntityHorse_method_getVariantTexturePaths_46.set("methodName", "getVariantTexturePaths");
        reflect_EntityHorse_method_getVariantTexturePaths_46.set("returnType", "String[]");
        reflect_EntityHorse_method_getVariantTexturePaths_46.set("static", false);
        reflect_EntityHorse_method_getVariantTexturePaths_46.set("argnames", new String[]{});
        reflect_EntityHorse_method_getVariantTexturePaths_46.set("argtypes", new String[]{});
        reflect_EntityHorse_method_getVariantTexturePaths_46.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (String[]) ((EntityHorse) params.getReflective("_self")).getVariantTexturePaths();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_getVariantTexturePaths_46);


        BaseData reflect_EntityHorse_method_openGUI_47 = new ModData();
        reflect_EntityHorse_method_openGUI_47.set("methodName", "openGUI");
        reflect_EntityHorse_method_openGUI_47.set("returnType", "void");
        reflect_EntityHorse_method_openGUI_47.set("static", false);
        reflect_EntityHorse_method_openGUI_47.set("argnames", new String[]{"playerEntity"});
        reflect_EntityHorse_method_openGUI_47.set("argtypes", new String[]{"EntityPlayer"});
        reflect_EntityHorse_method_openGUI_47.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityHorse) params.getReflective("_self")).openGUI((EntityPlayer) params.getReflective("playerEntity"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_openGUI_47);


        BaseData reflect_EntityHorse_method_interact_48 = new ModData();
        reflect_EntityHorse_method_interact_48.set("methodName", "interact");
        reflect_EntityHorse_method_interact_48.set("returnType", "boolean");
        reflect_EntityHorse_method_interact_48.set("static", false);
        reflect_EntityHorse_method_interact_48.set("argnames", new String[]{"entityplayer"});
        reflect_EntityHorse_method_interact_48.set("argtypes", new String[]{"EntityPlayer"});
        reflect_EntityHorse_method_interact_48.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityHorse) params.getReflective("_self")).interact((EntityPlayer) params.getReflective("entityplayer"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_interact_48);


        BaseData reflect_EntityHorse_method_canWearArmor_49 = new ModData();
        reflect_EntityHorse_method_canWearArmor_49.set("methodName", "canWearArmor");
        reflect_EntityHorse_method_canWearArmor_49.set("returnType", "boolean");
        reflect_EntityHorse_method_canWearArmor_49.set("static", false);
        reflect_EntityHorse_method_canWearArmor_49.set("argnames", new String[]{});
        reflect_EntityHorse_method_canWearArmor_49.set("argtypes", new String[]{});
        reflect_EntityHorse_method_canWearArmor_49.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityHorse) params.getReflective("_self")).canWearArmor();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_canWearArmor_49);


        BaseData reflect_EntityHorse_method_canCarryChest_50 = new ModData();
        reflect_EntityHorse_method_canCarryChest_50.set("methodName", "canCarryChest");
        reflect_EntityHorse_method_canCarryChest_50.set("returnType", "boolean");
        reflect_EntityHorse_method_canCarryChest_50.set("static", false);
        reflect_EntityHorse_method_canCarryChest_50.set("argnames", new String[]{});
        reflect_EntityHorse_method_canCarryChest_50.set("argtypes", new String[]{});
        reflect_EntityHorse_method_canCarryChest_50.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityHorse) params.getReflective("_self")).canCarryChest();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_canCarryChest_50);


        BaseData reflect_EntityHorse_method_isUndead_51 = new ModData();
        reflect_EntityHorse_method_isUndead_51.set("methodName", "isUndead");
        reflect_EntityHorse_method_isUndead_51.set("returnType", "boolean");
        reflect_EntityHorse_method_isUndead_51.set("static", false);
        reflect_EntityHorse_method_isUndead_51.set("argnames", new String[]{});
        reflect_EntityHorse_method_isUndead_51.set("argtypes", new String[]{});
        reflect_EntityHorse_method_isUndead_51.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityHorse) params.getReflective("_self")).isUndead();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_isUndead_51);


        BaseData reflect_EntityHorse_method_isSterile_52 = new ModData();
        reflect_EntityHorse_method_isSterile_52.set("methodName", "isSterile");
        reflect_EntityHorse_method_isSterile_52.set("returnType", "boolean");
        reflect_EntityHorse_method_isSterile_52.set("static", false);
        reflect_EntityHorse_method_isSterile_52.set("argnames", new String[]{});
        reflect_EntityHorse_method_isSterile_52.set("argtypes", new String[]{});
        reflect_EntityHorse_method_isSterile_52.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityHorse) params.getReflective("_self")).isSterile();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_isSterile_52);


        BaseData reflect_EntityHorse_method_isBreedingItem_53 = new ModData();
        reflect_EntityHorse_method_isBreedingItem_53.set("methodName", "isBreedingItem");
        reflect_EntityHorse_method_isBreedingItem_53.set("returnType", "boolean");
        reflect_EntityHorse_method_isBreedingItem_53.set("static", false);
        reflect_EntityHorse_method_isBreedingItem_53.set("argnames", new String[]{"var1"});
        reflect_EntityHorse_method_isBreedingItem_53.set("argtypes", new String[]{"ItemStack"});
        reflect_EntityHorse_method_isBreedingItem_53.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityHorse) params.getReflective("_self")).isBreedingItem((ItemStack) params.getReflective("var1"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_isBreedingItem_53);


        BaseData reflect_EntityHorse_method_onDeath_54 = new ModData();
        reflect_EntityHorse_method_onDeath_54.set("methodName", "onDeath");
        reflect_EntityHorse_method_onDeath_54.set("returnType", "void");
        reflect_EntityHorse_method_onDeath_54.set("static", false);
        reflect_EntityHorse_method_onDeath_54.set("argnames", new String[]{"damagesource"});
        reflect_EntityHorse_method_onDeath_54.set("argtypes", new String[]{"DamageSource"});
        reflect_EntityHorse_method_onDeath_54.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityHorse) params.getReflective("_self")).onDeath((DamageSource) params.getReflective("damagesource"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_onDeath_54);


        BaseData reflect_EntityHorse_method_onLivingUpdate_55 = new ModData();
        reflect_EntityHorse_method_onLivingUpdate_55.set("methodName", "onLivingUpdate");
        reflect_EntityHorse_method_onLivingUpdate_55.set("returnType", "void");
        reflect_EntityHorse_method_onLivingUpdate_55.set("static", false);
        reflect_EntityHorse_method_onLivingUpdate_55.set("argnames", new String[]{});
        reflect_EntityHorse_method_onLivingUpdate_55.set("argtypes", new String[]{});
        reflect_EntityHorse_method_onLivingUpdate_55.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityHorse) params.getReflective("_self")).onLivingUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_onLivingUpdate_55);


        BaseData reflect_EntityHorse_method_onUpdate_56 = new ModData();
        reflect_EntityHorse_method_onUpdate_56.set("methodName", "onUpdate");
        reflect_EntityHorse_method_onUpdate_56.set("returnType", "void");
        reflect_EntityHorse_method_onUpdate_56.set("static", false);
        reflect_EntityHorse_method_onUpdate_56.set("argnames", new String[]{});
        reflect_EntityHorse_method_onUpdate_56.set("argtypes", new String[]{});
        reflect_EntityHorse_method_onUpdate_56.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityHorse) params.getReflective("_self")).onUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_onUpdate_56);


        BaseData reflect_EntityHorse_method_setEating_57 = new ModData();
        reflect_EntityHorse_method_setEating_57.set("methodName", "setEating");
        reflect_EntityHorse_method_setEating_57.set("returnType", "void");
        reflect_EntityHorse_method_setEating_57.set("static", false);
        reflect_EntityHorse_method_setEating_57.set("argnames", new String[]{"flag"});
        reflect_EntityHorse_method_setEating_57.set("argtypes", new String[]{"boolean"});
        reflect_EntityHorse_method_setEating_57.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityHorse) params.getReflective("_self")).setEating((boolean) params.getBoolean("flag"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_setEating_57);


        BaseData reflect_EntityHorse_method_setEatingHaystack_58 = new ModData();
        reflect_EntityHorse_method_setEatingHaystack_58.set("methodName", "setEatingHaystack");
        reflect_EntityHorse_method_setEatingHaystack_58.set("returnType", "void");
        reflect_EntityHorse_method_setEatingHaystack_58.set("static", false);
        reflect_EntityHorse_method_setEatingHaystack_58.set("argnames", new String[]{"parFlag"});
        reflect_EntityHorse_method_setEatingHaystack_58.set("argtypes", new String[]{"boolean"});
        reflect_EntityHorse_method_setEatingHaystack_58.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityHorse) params.getReflective("_self")).setEatingHaystack((boolean) params.getBoolean("parFlag"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_setEatingHaystack_58);


        BaseData reflect_EntityHorse_method_setRearing_59 = new ModData();
        reflect_EntityHorse_method_setRearing_59.set("methodName", "setRearing");
        reflect_EntityHorse_method_setRearing_59.set("returnType", "void");
        reflect_EntityHorse_method_setRearing_59.set("static", false);
        reflect_EntityHorse_method_setRearing_59.set("argnames", new String[]{"rearing"});
        reflect_EntityHorse_method_setRearing_59.set("argtypes", new String[]{"boolean"});
        reflect_EntityHorse_method_setRearing_59.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityHorse) params.getReflective("_self")).setRearing((boolean) params.getBoolean("rearing"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_setRearing_59);


        BaseData reflect_EntityHorse_method_makeHorseRearWithSound_60 = new ModData();
        reflect_EntityHorse_method_makeHorseRearWithSound_60.set("methodName", "makeHorseRearWithSound");
        reflect_EntityHorse_method_makeHorseRearWithSound_60.set("returnType", "void");
        reflect_EntityHorse_method_makeHorseRearWithSound_60.set("static", false);
        reflect_EntityHorse_method_makeHorseRearWithSound_60.set("argnames", new String[]{});
        reflect_EntityHorse_method_makeHorseRearWithSound_60.set("argtypes", new String[]{});
        reflect_EntityHorse_method_makeHorseRearWithSound_60.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityHorse) params.getReflective("_self")).makeHorseRearWithSound();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_makeHorseRearWithSound_60);


        BaseData reflect_EntityHorse_method_dropChestItems_61 = new ModData();
        reflect_EntityHorse_method_dropChestItems_61.set("methodName", "dropChestItems");
        reflect_EntityHorse_method_dropChestItems_61.set("returnType", "void");
        reflect_EntityHorse_method_dropChestItems_61.set("static", false);
        reflect_EntityHorse_method_dropChestItems_61.set("argnames", new String[]{});
        reflect_EntityHorse_method_dropChestItems_61.set("argtypes", new String[]{});
        reflect_EntityHorse_method_dropChestItems_61.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityHorse) params.getReflective("_self")).dropChestItems();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_dropChestItems_61);


        BaseData reflect_EntityHorse_method_setTamedBy_62 = new ModData();
        reflect_EntityHorse_method_setTamedBy_62.set("methodName", "setTamedBy");
        reflect_EntityHorse_method_setTamedBy_62.set("returnType", "boolean");
        reflect_EntityHorse_method_setTamedBy_62.set("static", false);
        reflect_EntityHorse_method_setTamedBy_62.set("argnames", new String[]{"player"});
        reflect_EntityHorse_method_setTamedBy_62.set("argtypes", new String[]{"EntityPlayer"});
        reflect_EntityHorse_method_setTamedBy_62.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityHorse) params.getReflective("_self")).setTamedBy((EntityPlayer) params.getReflective("player"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_setTamedBy_62);


        BaseData reflect_EntityHorse_method_moveEntityWithHeading_63 = new ModData();
        reflect_EntityHorse_method_moveEntityWithHeading_63.set("methodName", "moveEntityWithHeading");
        reflect_EntityHorse_method_moveEntityWithHeading_63.set("returnType", "void");
        reflect_EntityHorse_method_moveEntityWithHeading_63.set("static", false);
        reflect_EntityHorse_method_moveEntityWithHeading_63.set("argnames", new String[]{"f", "f1"});
        reflect_EntityHorse_method_moveEntityWithHeading_63.set("argtypes", new String[]{"float", "float"});
        reflect_EntityHorse_method_moveEntityWithHeading_63.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityHorse) params.getReflective("_self")).moveEntityWithHeading((float) params.getFloat("f"), (float) params.getFloat("f1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_moveEntityWithHeading_63);


        BaseData reflect_EntityHorse_method_writeEntityToNBT_64 = new ModData();
        reflect_EntityHorse_method_writeEntityToNBT_64.set("methodName", "writeEntityToNBT");
        reflect_EntityHorse_method_writeEntityToNBT_64.set("returnType", "void");
        reflect_EntityHorse_method_writeEntityToNBT_64.set("static", false);
        reflect_EntityHorse_method_writeEntityToNBT_64.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityHorse_method_writeEntityToNBT_64.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityHorse_method_writeEntityToNBT_64.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityHorse) params.getReflective("_self")).writeEntityToNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_writeEntityToNBT_64);


        BaseData reflect_EntityHorse_method_readEntityFromNBT_65 = new ModData();
        reflect_EntityHorse_method_readEntityFromNBT_65.set("methodName", "readEntityFromNBT");
        reflect_EntityHorse_method_readEntityFromNBT_65.set("returnType", "void");
        reflect_EntityHorse_method_readEntityFromNBT_65.set("static", false);
        reflect_EntityHorse_method_readEntityFromNBT_65.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityHorse_method_readEntityFromNBT_65.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityHorse_method_readEntityFromNBT_65.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityHorse) params.getReflective("_self")).readEntityFromNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_readEntityFromNBT_65);


        BaseData reflect_EntityHorse_method_canMateWith_66 = new ModData();
        reflect_EntityHorse_method_canMateWith_66.set("methodName", "canMateWith");
        reflect_EntityHorse_method_canMateWith_66.set("returnType", "boolean");
        reflect_EntityHorse_method_canMateWith_66.set("static", false);
        reflect_EntityHorse_method_canMateWith_66.set("argnames", new String[]{"entityanimal"});
        reflect_EntityHorse_method_canMateWith_66.set("argtypes", new String[]{"EntityAnimal"});
        reflect_EntityHorse_method_canMateWith_66.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityHorse) params.getReflective("_self")).canMateWith((EntityAnimal) params.getReflective("entityanimal"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_canMateWith_66);


        BaseData reflect_EntityHorse_method_createChild_67 = new ModData();
        reflect_EntityHorse_method_createChild_67.set("methodName", "createChild");
        reflect_EntityHorse_method_createChild_67.set("returnType", "EntityAgeable");
        reflect_EntityHorse_method_createChild_67.set("static", false);
        reflect_EntityHorse_method_createChild_67.set("argnames", new String[]{"entityageable"});
        reflect_EntityHorse_method_createChild_67.set("argtypes", new String[]{"EntityAgeable"});
        reflect_EntityHorse_method_createChild_67.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EntityAgeable) ((EntityHorse) params.getReflective("_self")).createChild((EntityAgeable) params.getReflective("entityageable"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_createChild_67);


        BaseData reflect_EntityHorse_method_getGrassEatingAmount_68 = new ModData();
        reflect_EntityHorse_method_getGrassEatingAmount_68.set("methodName", "getGrassEatingAmount");
        reflect_EntityHorse_method_getGrassEatingAmount_68.set("returnType", "float");
        reflect_EntityHorse_method_getGrassEatingAmount_68.set("static", false);
        reflect_EntityHorse_method_getGrassEatingAmount_68.set("argnames", new String[]{"parFloat1"});
        reflect_EntityHorse_method_getGrassEatingAmount_68.set("argtypes", new String[]{"float"});
        reflect_EntityHorse_method_getGrassEatingAmount_68.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityHorse) params.getReflective("_self")).getGrassEatingAmount((float) params.getFloat("parFloat1"));
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_getGrassEatingAmount_68);


        BaseData reflect_EntityHorse_method_getRearingAmount_69 = new ModData();
        reflect_EntityHorse_method_getRearingAmount_69.set("methodName", "getRearingAmount");
        reflect_EntityHorse_method_getRearingAmount_69.set("returnType", "float");
        reflect_EntityHorse_method_getRearingAmount_69.set("static", false);
        reflect_EntityHorse_method_getRearingAmount_69.set("argnames", new String[]{"parFloat1"});
        reflect_EntityHorse_method_getRearingAmount_69.set("argtypes", new String[]{"float"});
        reflect_EntityHorse_method_getRearingAmount_69.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityHorse) params.getReflective("_self")).getRearingAmount((float) params.getFloat("parFloat1"));
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_getRearingAmount_69);


        BaseData reflect_EntityHorse_method_getMouthOpennessAngle_70 = new ModData();
        reflect_EntityHorse_method_getMouthOpennessAngle_70.set("methodName", "getMouthOpennessAngle");
        reflect_EntityHorse_method_getMouthOpennessAngle_70.set("returnType", "float");
        reflect_EntityHorse_method_getMouthOpennessAngle_70.set("static", false);
        reflect_EntityHorse_method_getMouthOpennessAngle_70.set("argnames", new String[]{"parFloat1"});
        reflect_EntityHorse_method_getMouthOpennessAngle_70.set("argtypes", new String[]{"float"});
        reflect_EntityHorse_method_getMouthOpennessAngle_70.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityHorse) params.getReflective("_self")).getMouthOpennessAngle((float) params.getFloat("parFloat1"));
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_getMouthOpennessAngle_70);


        BaseData reflect_EntityHorse_method_setJumpPower_71 = new ModData();
        reflect_EntityHorse_method_setJumpPower_71.set("methodName", "setJumpPower");
        reflect_EntityHorse_method_setJumpPower_71.set("returnType", "void");
        reflect_EntityHorse_method_setJumpPower_71.set("static", false);
        reflect_EntityHorse_method_setJumpPower_71.set("argnames", new String[]{"jumpPowerIn"});
        reflect_EntityHorse_method_setJumpPower_71.set("argtypes", new String[]{"int"});
        reflect_EntityHorse_method_setJumpPower_71.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityHorse) params.getReflective("_self")).setJumpPower((int) params.getInt("jumpPowerIn"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_setJumpPower_71);


        BaseData reflect_EntityHorse_method_handleStatusUpdate_72 = new ModData();
        reflect_EntityHorse_method_handleStatusUpdate_72.set("methodName", "handleStatusUpdate");
        reflect_EntityHorse_method_handleStatusUpdate_72.set("returnType", "void");
        reflect_EntityHorse_method_handleStatusUpdate_72.set("static", false);
        reflect_EntityHorse_method_handleStatusUpdate_72.set("argnames", new String[]{"b0"});
        reflect_EntityHorse_method_handleStatusUpdate_72.set("argtypes", new String[]{"byte"});
        reflect_EntityHorse_method_handleStatusUpdate_72.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityHorse) params.getReflective("_self")).handleStatusUpdate((byte) params.getByte("b0"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_handleStatusUpdate_72);


        BaseData reflect_EntityHorse_method_updateRiderPosition_73 = new ModData();
        reflect_EntityHorse_method_updateRiderPosition_73.set("methodName", "updateRiderPosition");
        reflect_EntityHorse_method_updateRiderPosition_73.set("returnType", "void");
        reflect_EntityHorse_method_updateRiderPosition_73.set("static", false);
        reflect_EntityHorse_method_updateRiderPosition_73.set("argnames", new String[]{});
        reflect_EntityHorse_method_updateRiderPosition_73.set("argtypes", new String[]{});
        reflect_EntityHorse_method_updateRiderPosition_73.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityHorse) params.getReflective("_self")).updateRiderPosition();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_updateRiderPosition_73);


        BaseData reflect_EntityHorse_method_isArmorItem_74 = new ModData();
        reflect_EntityHorse_method_isArmorItem_74.set("methodName", "isArmorItem");
        reflect_EntityHorse_method_isArmorItem_74.set("returnType", "boolean");
        reflect_EntityHorse_method_isArmorItem_74.set("static", true);
        reflect_EntityHorse_method_isArmorItem_74.set("argnames", new String[]{"parItem"});
        reflect_EntityHorse_method_isArmorItem_74.set("argtypes", new String[]{"Item"});
        reflect_EntityHorse_method_isArmorItem_74.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) EntityHorse.isArmorItem((Item) params.getReflective("parItem"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_isArmorItem_74);


        BaseData reflect_EntityHorse_method_isOnLadder_75 = new ModData();
        reflect_EntityHorse_method_isOnLadder_75.set("methodName", "isOnLadder");
        reflect_EntityHorse_method_isOnLadder_75.set("returnType", "boolean");
        reflect_EntityHorse_method_isOnLadder_75.set("static", false);
        reflect_EntityHorse_method_isOnLadder_75.set("argnames", new String[]{});
        reflect_EntityHorse_method_isOnLadder_75.set("argtypes", new String[]{});
        reflect_EntityHorse_method_isOnLadder_75.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityHorse) params.getReflective("_self")).isOnLadder();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_isOnLadder_75);


        BaseData reflect_EntityHorse_method_getEyeHeight_76 = new ModData();
        reflect_EntityHorse_method_getEyeHeight_76.set("methodName", "getEyeHeight");
        reflect_EntityHorse_method_getEyeHeight_76.set("returnType", "float");
        reflect_EntityHorse_method_getEyeHeight_76.set("static", false);
        reflect_EntityHorse_method_getEyeHeight_76.set("argnames", new String[]{});
        reflect_EntityHorse_method_getEyeHeight_76.set("argtypes", new String[]{});
        reflect_EntityHorse_method_getEyeHeight_76.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityHorse) params.getReflective("_self")).getEyeHeight();
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_getEyeHeight_76);


        BaseData reflect_EntityHorse_method_replaceItemInInventory_77 = new ModData();
        reflect_EntityHorse_method_replaceItemInInventory_77.set("methodName", "replaceItemInInventory");
        reflect_EntityHorse_method_replaceItemInInventory_77.set("returnType", "boolean");
        reflect_EntityHorse_method_replaceItemInInventory_77.set("static", false);
        reflect_EntityHorse_method_replaceItemInInventory_77.set("argnames", new String[]{"i", "itemstack"});
        reflect_EntityHorse_method_replaceItemInInventory_77.set("argtypes", new String[]{"int", "ItemStack"});
        reflect_EntityHorse_method_replaceItemInInventory_77.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityHorse) params.getReflective("_self")).replaceItemInInventory((int) params.getInt("i"), (ItemStack) params.getReflective("itemstack"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityHorse_methods.add(reflect_EntityHorse_method_replaceItemInInventory_77);


        BaseData[] reflect_EntityHorse_methods_arr = new BaseData[reflect_EntityHorse_methods.size()];
        for (int i = 0; i < reflect_EntityHorse_methods_arr.length; i++) {
            reflect_EntityHorse_methods_arr[i] = reflect_EntityHorse_methods.get(i);
        }

        reflect_EntityHorse.set("constructors", reflect_EntityHorse_constructors_arr);
        reflect_EntityHorse.set("methods", reflect_EntityHorse_methods_arr);
        reflect_EntityHorse.set("className", "EntityHorse");
        reflect_EntityHorse.set("classId", "net.minecraft.entity.passive.EntityHorse");
        reflect_EntityHorse.set("class", EntityHorse.class);
        reflect_EntityHorse.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityHorse;
        });
        reflectProfiles.add(reflect_EntityHorse);
    }


    //classdef for EntityMooshroom
    public static void reflect_EntityMooshroom_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityMooshroom = new ModData();

        ArrayList<BaseData> reflect_EntityMooshroom_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_EntityMooshroom_constructor_EntityMooshroom_0 = new ModData();
        reflect_EntityMooshroom_constructor_EntityMooshroom_0.set("returnType", "EntityMooshroom");
        reflect_EntityMooshroom_constructor_EntityMooshroom_0.set("argnames", new String[]{"worldIn"});
        reflect_EntityMooshroom_constructor_EntityMooshroom_0.set("argtypes", new String[]{"World"});
        reflect_EntityMooshroom_constructor_EntityMooshroom_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityMooshroom((World) params.getReflective("worldIn"));
        });
        
        reflect_EntityMooshroom_constructors.add(reflect_EntityMooshroom_constructor_EntityMooshroom_0);


        BaseData[] reflect_EntityMooshroom_constructors_arr = new BaseData[reflect_EntityMooshroom_constructors.size()];
        for (int i = 0; i < reflect_EntityMooshroom_constructors_arr.length; i++) {
            reflect_EntityMooshroom_constructors_arr[i] = reflect_EntityMooshroom_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityMooshroom_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityMooshroom_method_interact_0 = new ModData();
        reflect_EntityMooshroom_method_interact_0.set("methodName", "interact");
        reflect_EntityMooshroom_method_interact_0.set("returnType", "boolean");
        reflect_EntityMooshroom_method_interact_0.set("static", false);
        reflect_EntityMooshroom_method_interact_0.set("argnames", new String[]{"entityplayer"});
        reflect_EntityMooshroom_method_interact_0.set("argtypes", new String[]{"EntityPlayer"});
        reflect_EntityMooshroom_method_interact_0.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityMooshroom) params.getReflective("_self")).interact((EntityPlayer) params.getReflective("entityplayer"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityMooshroom_methods.add(reflect_EntityMooshroom_method_interact_0);


        BaseData reflect_EntityMooshroom_method_createChild_1 = new ModData();
        reflect_EntityMooshroom_method_createChild_1.set("methodName", "createChild");
        reflect_EntityMooshroom_method_createChild_1.set("returnType", "EntityMooshroom");
        reflect_EntityMooshroom_method_createChild_1.set("static", false);
        reflect_EntityMooshroom_method_createChild_1.set("argnames", new String[]{"var1"});
        reflect_EntityMooshroom_method_createChild_1.set("argtypes", new String[]{"EntityAgeable"});
        reflect_EntityMooshroom_method_createChild_1.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EntityMooshroom) ((EntityMooshroom) params.getReflective("_self")).createChild((EntityAgeable) params.getReflective("var1"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityMooshroom_methods.add(reflect_EntityMooshroom_method_createChild_1);


        BaseData[] reflect_EntityMooshroom_methods_arr = new BaseData[reflect_EntityMooshroom_methods.size()];
        for (int i = 0; i < reflect_EntityMooshroom_methods_arr.length; i++) {
            reflect_EntityMooshroom_methods_arr[i] = reflect_EntityMooshroom_methods.get(i);
        }

        reflect_EntityMooshroom.set("constructors", reflect_EntityMooshroom_constructors_arr);
        reflect_EntityMooshroom.set("methods", reflect_EntityMooshroom_methods_arr);
        reflect_EntityMooshroom.set("className", "EntityMooshroom");
        reflect_EntityMooshroom.set("classId", "net.minecraft.entity.passive.EntityMooshroom");
        reflect_EntityMooshroom.set("class", EntityMooshroom.class);
        reflect_EntityMooshroom.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityMooshroom;
        });
        reflectProfiles.add(reflect_EntityMooshroom);
    }


    //classdef for EntityOcelot
    public static void reflect_EntityOcelot_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityOcelot = new ModData();

        ArrayList<BaseData> reflect_EntityOcelot_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_EntityOcelot_constructor_EntityOcelot_0 = new ModData();
        reflect_EntityOcelot_constructor_EntityOcelot_0.set("returnType", "EntityOcelot");
        reflect_EntityOcelot_constructor_EntityOcelot_0.set("argnames", new String[]{"worldIn"});
        reflect_EntityOcelot_constructor_EntityOcelot_0.set("argtypes", new String[]{"World"});
        reflect_EntityOcelot_constructor_EntityOcelot_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityOcelot((World) params.getReflective("worldIn"));
        });
        
        reflect_EntityOcelot_constructors.add(reflect_EntityOcelot_constructor_EntityOcelot_0);


        BaseData[] reflect_EntityOcelot_constructors_arr = new BaseData[reflect_EntityOcelot_constructors.size()];
        for (int i = 0; i < reflect_EntityOcelot_constructors_arr.length; i++) {
            reflect_EntityOcelot_constructors_arr[i] = reflect_EntityOcelot_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityOcelot_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityOcelot_method_updateAITasks_0 = new ModData();
        reflect_EntityOcelot_method_updateAITasks_0.set("methodName", "updateAITasks");
        reflect_EntityOcelot_method_updateAITasks_0.set("returnType", "void");
        reflect_EntityOcelot_method_updateAITasks_0.set("static", false);
        reflect_EntityOcelot_method_updateAITasks_0.set("argnames", new String[]{});
        reflect_EntityOcelot_method_updateAITasks_0.set("argtypes", new String[]{});
        reflect_EntityOcelot_method_updateAITasks_0.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityOcelot) params.getReflective("_self")).updateAITasks();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityOcelot_methods.add(reflect_EntityOcelot_method_updateAITasks_0);


        BaseData reflect_EntityOcelot_method_fall_1 = new ModData();
        reflect_EntityOcelot_method_fall_1.set("methodName", "fall");
        reflect_EntityOcelot_method_fall_1.set("returnType", "void");
        reflect_EntityOcelot_method_fall_1.set("static", false);
        reflect_EntityOcelot_method_fall_1.set("argnames", new String[]{"var1", "var2"});
        reflect_EntityOcelot_method_fall_1.set("argtypes", new String[]{"float", "float"});
        reflect_EntityOcelot_method_fall_1.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityOcelot) params.getReflective("_self")).fall((float) params.getFloat("var1"), (float) params.getFloat("var2"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityOcelot_methods.add(reflect_EntityOcelot_method_fall_1);


        BaseData reflect_EntityOcelot_method_writeEntityToNBT_2 = new ModData();
        reflect_EntityOcelot_method_writeEntityToNBT_2.set("methodName", "writeEntityToNBT");
        reflect_EntityOcelot_method_writeEntityToNBT_2.set("returnType", "void");
        reflect_EntityOcelot_method_writeEntityToNBT_2.set("static", false);
        reflect_EntityOcelot_method_writeEntityToNBT_2.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityOcelot_method_writeEntityToNBT_2.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityOcelot_method_writeEntityToNBT_2.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityOcelot) params.getReflective("_self")).writeEntityToNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityOcelot_methods.add(reflect_EntityOcelot_method_writeEntityToNBT_2);


        BaseData reflect_EntityOcelot_method_readEntityFromNBT_3 = new ModData();
        reflect_EntityOcelot_method_readEntityFromNBT_3.set("methodName", "readEntityFromNBT");
        reflect_EntityOcelot_method_readEntityFromNBT_3.set("returnType", "void");
        reflect_EntityOcelot_method_readEntityFromNBT_3.set("static", false);
        reflect_EntityOcelot_method_readEntityFromNBT_3.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityOcelot_method_readEntityFromNBT_3.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityOcelot_method_readEntityFromNBT_3.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityOcelot) params.getReflective("_self")).readEntityFromNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityOcelot_methods.add(reflect_EntityOcelot_method_readEntityFromNBT_3);


        BaseData reflect_EntityOcelot_method_attackEntityAsMob_4 = new ModData();
        reflect_EntityOcelot_method_attackEntityAsMob_4.set("methodName", "attackEntityAsMob");
        reflect_EntityOcelot_method_attackEntityAsMob_4.set("returnType", "boolean");
        reflect_EntityOcelot_method_attackEntityAsMob_4.set("static", false);
        reflect_EntityOcelot_method_attackEntityAsMob_4.set("argnames", new String[]{"entity"});
        reflect_EntityOcelot_method_attackEntityAsMob_4.set("argtypes", new String[]{"Entity"});
        reflect_EntityOcelot_method_attackEntityAsMob_4.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityOcelot) params.getReflective("_self")).attackEntityAsMob((Entity) params.getReflective("entity"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityOcelot_methods.add(reflect_EntityOcelot_method_attackEntityAsMob_4);


        BaseData reflect_EntityOcelot_method_attackEntityFrom_5 = new ModData();
        reflect_EntityOcelot_method_attackEntityFrom_5.set("methodName", "attackEntityFrom");
        reflect_EntityOcelot_method_attackEntityFrom_5.set("returnType", "boolean");
        reflect_EntityOcelot_method_attackEntityFrom_5.set("static", false);
        reflect_EntityOcelot_method_attackEntityFrom_5.set("argnames", new String[]{"damagesource", "f"});
        reflect_EntityOcelot_method_attackEntityFrom_5.set("argtypes", new String[]{"DamageSource", "float"});
        reflect_EntityOcelot_method_attackEntityFrom_5.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityOcelot) params.getReflective("_self")).attackEntityFrom((DamageSource) params.getReflective("damagesource"), (float) params.getFloat("f"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityOcelot_methods.add(reflect_EntityOcelot_method_attackEntityFrom_5);


        BaseData reflect_EntityOcelot_method_interact_6 = new ModData();
        reflect_EntityOcelot_method_interact_6.set("methodName", "interact");
        reflect_EntityOcelot_method_interact_6.set("returnType", "boolean");
        reflect_EntityOcelot_method_interact_6.set("static", false);
        reflect_EntityOcelot_method_interact_6.set("argnames", new String[]{"entityplayer"});
        reflect_EntityOcelot_method_interact_6.set("argtypes", new String[]{"EntityPlayer"});
        reflect_EntityOcelot_method_interact_6.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityOcelot) params.getReflective("_self")).interact((EntityPlayer) params.getReflective("entityplayer"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityOcelot_methods.add(reflect_EntityOcelot_method_interact_6);


        BaseData reflect_EntityOcelot_method_createChild_7 = new ModData();
        reflect_EntityOcelot_method_createChild_7.set("methodName", "createChild");
        reflect_EntityOcelot_method_createChild_7.set("returnType", "EntityOcelot");
        reflect_EntityOcelot_method_createChild_7.set("static", false);
        reflect_EntityOcelot_method_createChild_7.set("argnames", new String[]{"var1"});
        reflect_EntityOcelot_method_createChild_7.set("argtypes", new String[]{"EntityAgeable"});
        reflect_EntityOcelot_method_createChild_7.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EntityOcelot) ((EntityOcelot) params.getReflective("_self")).createChild((EntityAgeable) params.getReflective("var1"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityOcelot_methods.add(reflect_EntityOcelot_method_createChild_7);


        BaseData reflect_EntityOcelot_method_isBreedingItem_8 = new ModData();
        reflect_EntityOcelot_method_isBreedingItem_8.set("methodName", "isBreedingItem");
        reflect_EntityOcelot_method_isBreedingItem_8.set("returnType", "boolean");
        reflect_EntityOcelot_method_isBreedingItem_8.set("static", false);
        reflect_EntityOcelot_method_isBreedingItem_8.set("argnames", new String[]{"itemstack"});
        reflect_EntityOcelot_method_isBreedingItem_8.set("argtypes", new String[]{"ItemStack"});
        reflect_EntityOcelot_method_isBreedingItem_8.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityOcelot) params.getReflective("_self")).isBreedingItem((ItemStack) params.getReflective("itemstack"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityOcelot_methods.add(reflect_EntityOcelot_method_isBreedingItem_8);


        BaseData reflect_EntityOcelot_method_canMateWith_9 = new ModData();
        reflect_EntityOcelot_method_canMateWith_9.set("methodName", "canMateWith");
        reflect_EntityOcelot_method_canMateWith_9.set("returnType", "boolean");
        reflect_EntityOcelot_method_canMateWith_9.set("static", false);
        reflect_EntityOcelot_method_canMateWith_9.set("argnames", new String[]{"entityanimal"});
        reflect_EntityOcelot_method_canMateWith_9.set("argtypes", new String[]{"EntityAnimal"});
        reflect_EntityOcelot_method_canMateWith_9.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityOcelot) params.getReflective("_self")).canMateWith((EntityAnimal) params.getReflective("entityanimal"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityOcelot_methods.add(reflect_EntityOcelot_method_canMateWith_9);


        BaseData reflect_EntityOcelot_method_getTameSkin_10 = new ModData();
        reflect_EntityOcelot_method_getTameSkin_10.set("methodName", "getTameSkin");
        reflect_EntityOcelot_method_getTameSkin_10.set("returnType", "int");
        reflect_EntityOcelot_method_getTameSkin_10.set("static", false);
        reflect_EntityOcelot_method_getTameSkin_10.set("argnames", new String[]{});
        reflect_EntityOcelot_method_getTameSkin_10.set("argtypes", new String[]{});
        reflect_EntityOcelot_method_getTameSkin_10.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityOcelot) params.getReflective("_self")).getTameSkin();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityOcelot_methods.add(reflect_EntityOcelot_method_getTameSkin_10);


        BaseData reflect_EntityOcelot_method_setTameSkin_11 = new ModData();
        reflect_EntityOcelot_method_setTameSkin_11.set("methodName", "setTameSkin");
        reflect_EntityOcelot_method_setTameSkin_11.set("returnType", "void");
        reflect_EntityOcelot_method_setTameSkin_11.set("static", false);
        reflect_EntityOcelot_method_setTameSkin_11.set("argnames", new String[]{"skinId"});
        reflect_EntityOcelot_method_setTameSkin_11.set("argtypes", new String[]{"int"});
        reflect_EntityOcelot_method_setTameSkin_11.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityOcelot) params.getReflective("_self")).setTameSkin((int) params.getInt("skinId"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityOcelot_methods.add(reflect_EntityOcelot_method_setTameSkin_11);


        BaseData reflect_EntityOcelot_method_getCanSpawnHere_12 = new ModData();
        reflect_EntityOcelot_method_getCanSpawnHere_12.set("methodName", "getCanSpawnHere");
        reflect_EntityOcelot_method_getCanSpawnHere_12.set("returnType", "boolean");
        reflect_EntityOcelot_method_getCanSpawnHere_12.set("static", false);
        reflect_EntityOcelot_method_getCanSpawnHere_12.set("argnames", new String[]{});
        reflect_EntityOcelot_method_getCanSpawnHere_12.set("argtypes", new String[]{});
        reflect_EntityOcelot_method_getCanSpawnHere_12.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityOcelot) params.getReflective("_self")).getCanSpawnHere();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityOcelot_methods.add(reflect_EntityOcelot_method_getCanSpawnHere_12);


        BaseData reflect_EntityOcelot_method_isNotColliding_13 = new ModData();
        reflect_EntityOcelot_method_isNotColliding_13.set("methodName", "isNotColliding");
        reflect_EntityOcelot_method_isNotColliding_13.set("returnType", "boolean");
        reflect_EntityOcelot_method_isNotColliding_13.set("static", false);
        reflect_EntityOcelot_method_isNotColliding_13.set("argnames", new String[]{});
        reflect_EntityOcelot_method_isNotColliding_13.set("argtypes", new String[]{});
        reflect_EntityOcelot_method_isNotColliding_13.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityOcelot) params.getReflective("_self")).isNotColliding();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityOcelot_methods.add(reflect_EntityOcelot_method_isNotColliding_13);


        BaseData reflect_EntityOcelot_method_getName_14 = new ModData();
        reflect_EntityOcelot_method_getName_14.set("methodName", "getName");
        reflect_EntityOcelot_method_getName_14.set("returnType", "String");
        reflect_EntityOcelot_method_getName_14.set("static", false);
        reflect_EntityOcelot_method_getName_14.set("argnames", new String[]{});
        reflect_EntityOcelot_method_getName_14.set("argtypes", new String[]{});
        reflect_EntityOcelot_method_getName_14.setCallbackStringWithDataArg("exec", (BaseData params) -> {
                try {
                    return (String) ((EntityOcelot) params.getReflective("_self")).getName();
                } catch (Exception _exception_reflect_) {
                    return "";
                }
            });
            
        reflect_EntityOcelot_methods.add(reflect_EntityOcelot_method_getName_14);


        BaseData reflect_EntityOcelot_method_setTamed_15 = new ModData();
        reflect_EntityOcelot_method_setTamed_15.set("methodName", "setTamed");
        reflect_EntityOcelot_method_setTamed_15.set("returnType", "void");
        reflect_EntityOcelot_method_setTamed_15.set("static", false);
        reflect_EntityOcelot_method_setTamed_15.set("argnames", new String[]{"flag"});
        reflect_EntityOcelot_method_setTamed_15.set("argtypes", new String[]{"boolean"});
        reflect_EntityOcelot_method_setTamed_15.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityOcelot) params.getReflective("_self")).setTamed((boolean) params.getBoolean("flag"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityOcelot_methods.add(reflect_EntityOcelot_method_setTamed_15);


        BaseData[] reflect_EntityOcelot_methods_arr = new BaseData[reflect_EntityOcelot_methods.size()];
        for (int i = 0; i < reflect_EntityOcelot_methods_arr.length; i++) {
            reflect_EntityOcelot_methods_arr[i] = reflect_EntityOcelot_methods.get(i);
        }

        reflect_EntityOcelot.set("constructors", reflect_EntityOcelot_constructors_arr);
        reflect_EntityOcelot.set("methods", reflect_EntityOcelot_methods_arr);
        reflect_EntityOcelot.set("className", "EntityOcelot");
        reflect_EntityOcelot.set("classId", "net.minecraft.entity.passive.EntityOcelot");
        reflect_EntityOcelot.set("class", EntityOcelot.class);
        reflect_EntityOcelot.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityOcelot;
        });
        reflectProfiles.add(reflect_EntityOcelot);
    }


    //classdef for EntityPig
    public static void reflect_EntityPig_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityPig = new ModData();

        ArrayList<BaseData> reflect_EntityPig_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_EntityPig_constructor_EntityPig_0 = new ModData();
        reflect_EntityPig_constructor_EntityPig_0.set("returnType", "EntityPig");
        reflect_EntityPig_constructor_EntityPig_0.set("argnames", new String[]{"worldIn"});
        reflect_EntityPig_constructor_EntityPig_0.set("argtypes", new String[]{"World"});
        reflect_EntityPig_constructor_EntityPig_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityPig((World) params.getReflective("worldIn"));
        });
        
        reflect_EntityPig_constructors.add(reflect_EntityPig_constructor_EntityPig_0);


        BaseData[] reflect_EntityPig_constructors_arr = new BaseData[reflect_EntityPig_constructors.size()];
        for (int i = 0; i < reflect_EntityPig_constructors_arr.length; i++) {
            reflect_EntityPig_constructors_arr[i] = reflect_EntityPig_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityPig_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityPig_method_canBeSteered_0 = new ModData();
        reflect_EntityPig_method_canBeSteered_0.set("methodName", "canBeSteered");
        reflect_EntityPig_method_canBeSteered_0.set("returnType", "boolean");
        reflect_EntityPig_method_canBeSteered_0.set("static", false);
        reflect_EntityPig_method_canBeSteered_0.set("argnames", new String[]{});
        reflect_EntityPig_method_canBeSteered_0.set("argtypes", new String[]{});
        reflect_EntityPig_method_canBeSteered_0.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityPig) params.getReflective("_self")).canBeSteered();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityPig_methods.add(reflect_EntityPig_method_canBeSteered_0);


        BaseData reflect_EntityPig_method_writeEntityToNBT_1 = new ModData();
        reflect_EntityPig_method_writeEntityToNBT_1.set("methodName", "writeEntityToNBT");
        reflect_EntityPig_method_writeEntityToNBT_1.set("returnType", "void");
        reflect_EntityPig_method_writeEntityToNBT_1.set("static", false);
        reflect_EntityPig_method_writeEntityToNBT_1.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityPig_method_writeEntityToNBT_1.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityPig_method_writeEntityToNBT_1.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPig) params.getReflective("_self")).writeEntityToNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPig_methods.add(reflect_EntityPig_method_writeEntityToNBT_1);


        BaseData reflect_EntityPig_method_readEntityFromNBT_2 = new ModData();
        reflect_EntityPig_method_readEntityFromNBT_2.set("methodName", "readEntityFromNBT");
        reflect_EntityPig_method_readEntityFromNBT_2.set("returnType", "void");
        reflect_EntityPig_method_readEntityFromNBT_2.set("static", false);
        reflect_EntityPig_method_readEntityFromNBT_2.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityPig_method_readEntityFromNBT_2.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityPig_method_readEntityFromNBT_2.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPig) params.getReflective("_self")).readEntityFromNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPig_methods.add(reflect_EntityPig_method_readEntityFromNBT_2);


        BaseData reflect_EntityPig_method_interact_3 = new ModData();
        reflect_EntityPig_method_interact_3.set("methodName", "interact");
        reflect_EntityPig_method_interact_3.set("returnType", "boolean");
        reflect_EntityPig_method_interact_3.set("static", false);
        reflect_EntityPig_method_interact_3.set("argnames", new String[]{"entityplayer"});
        reflect_EntityPig_method_interact_3.set("argtypes", new String[]{"EntityPlayer"});
        reflect_EntityPig_method_interact_3.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityPig) params.getReflective("_self")).interact((EntityPlayer) params.getReflective("entityplayer"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityPig_methods.add(reflect_EntityPig_method_interact_3);


        BaseData reflect_EntityPig_method_getSaddled_4 = new ModData();
        reflect_EntityPig_method_getSaddled_4.set("methodName", "getSaddled");
        reflect_EntityPig_method_getSaddled_4.set("returnType", "boolean");
        reflect_EntityPig_method_getSaddled_4.set("static", false);
        reflect_EntityPig_method_getSaddled_4.set("argnames", new String[]{});
        reflect_EntityPig_method_getSaddled_4.set("argtypes", new String[]{});
        reflect_EntityPig_method_getSaddled_4.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityPig) params.getReflective("_self")).getSaddled();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityPig_methods.add(reflect_EntityPig_method_getSaddled_4);


        BaseData reflect_EntityPig_method_setSaddled_5 = new ModData();
        reflect_EntityPig_method_setSaddled_5.set("methodName", "setSaddled");
        reflect_EntityPig_method_setSaddled_5.set("returnType", "void");
        reflect_EntityPig_method_setSaddled_5.set("static", false);
        reflect_EntityPig_method_setSaddled_5.set("argnames", new String[]{"saddled"});
        reflect_EntityPig_method_setSaddled_5.set("argtypes", new String[]{"boolean"});
        reflect_EntityPig_method_setSaddled_5.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPig) params.getReflective("_self")).setSaddled((boolean) params.getBoolean("saddled"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPig_methods.add(reflect_EntityPig_method_setSaddled_5);


        BaseData reflect_EntityPig_method_onStruckByLightning_6 = new ModData();
        reflect_EntityPig_method_onStruckByLightning_6.set("methodName", "onStruckByLightning");
        reflect_EntityPig_method_onStruckByLightning_6.set("returnType", "void");
        reflect_EntityPig_method_onStruckByLightning_6.set("static", false);
        reflect_EntityPig_method_onStruckByLightning_6.set("argnames", new String[]{"var1"});
        reflect_EntityPig_method_onStruckByLightning_6.set("argtypes", new String[]{"EntityLightningBolt"});
        reflect_EntityPig_method_onStruckByLightning_6.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPig) params.getReflective("_self")).onStruckByLightning((EntityLightningBolt) params.getReflective("var1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPig_methods.add(reflect_EntityPig_method_onStruckByLightning_6);


        BaseData reflect_EntityPig_method_fall_7 = new ModData();
        reflect_EntityPig_method_fall_7.set("methodName", "fall");
        reflect_EntityPig_method_fall_7.set("returnType", "void");
        reflect_EntityPig_method_fall_7.set("static", false);
        reflect_EntityPig_method_fall_7.set("argnames", new String[]{"f", "f1"});
        reflect_EntityPig_method_fall_7.set("argtypes", new String[]{"float", "float"});
        reflect_EntityPig_method_fall_7.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPig) params.getReflective("_self")).fall((float) params.getFloat("f"), (float) params.getFloat("f1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPig_methods.add(reflect_EntityPig_method_fall_7);


        BaseData reflect_EntityPig_method_createChild_8 = new ModData();
        reflect_EntityPig_method_createChild_8.set("methodName", "createChild");
        reflect_EntityPig_method_createChild_8.set("returnType", "EntityPig");
        reflect_EntityPig_method_createChild_8.set("static", false);
        reflect_EntityPig_method_createChild_8.set("argnames", new String[]{"var1"});
        reflect_EntityPig_method_createChild_8.set("argtypes", new String[]{"EntityAgeable"});
        reflect_EntityPig_method_createChild_8.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EntityPig) ((EntityPig) params.getReflective("_self")).createChild((EntityAgeable) params.getReflective("var1"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityPig_methods.add(reflect_EntityPig_method_createChild_8);


        BaseData reflect_EntityPig_method_isBreedingItem_9 = new ModData();
        reflect_EntityPig_method_isBreedingItem_9.set("methodName", "isBreedingItem");
        reflect_EntityPig_method_isBreedingItem_9.set("returnType", "boolean");
        reflect_EntityPig_method_isBreedingItem_9.set("static", false);
        reflect_EntityPig_method_isBreedingItem_9.set("argnames", new String[]{"itemstack"});
        reflect_EntityPig_method_isBreedingItem_9.set("argtypes", new String[]{"ItemStack"});
        reflect_EntityPig_method_isBreedingItem_9.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityPig) params.getReflective("_self")).isBreedingItem((ItemStack) params.getReflective("itemstack"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityPig_methods.add(reflect_EntityPig_method_isBreedingItem_9);


        BaseData reflect_EntityPig_method_getAIControlledByPlayer_10 = new ModData();
        reflect_EntityPig_method_getAIControlledByPlayer_10.set("methodName", "getAIControlledByPlayer");
        reflect_EntityPig_method_getAIControlledByPlayer_10.set("returnType", "EntityAIControlledByPlayer");
        reflect_EntityPig_method_getAIControlledByPlayer_10.set("static", false);
        reflect_EntityPig_method_getAIControlledByPlayer_10.set("argnames", new String[]{});
        reflect_EntityPig_method_getAIControlledByPlayer_10.set("argtypes", new String[]{});
        reflect_EntityPig_method_getAIControlledByPlayer_10.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EntityAIControlledByPlayer) ((EntityPig) params.getReflective("_self")).getAIControlledByPlayer();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityPig_methods.add(reflect_EntityPig_method_getAIControlledByPlayer_10);


        BaseData[] reflect_EntityPig_methods_arr = new BaseData[reflect_EntityPig_methods.size()];
        for (int i = 0; i < reflect_EntityPig_methods_arr.length; i++) {
            reflect_EntityPig_methods_arr[i] = reflect_EntityPig_methods.get(i);
        }

        reflect_EntityPig.set("constructors", reflect_EntityPig_constructors_arr);
        reflect_EntityPig.set("methods", reflect_EntityPig_methods_arr);
        reflect_EntityPig.set("className", "EntityPig");
        reflect_EntityPig.set("classId", "net.minecraft.entity.passive.EntityPig");
        reflect_EntityPig.set("class", EntityPig.class);
        reflect_EntityPig.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityPig;
        });
        reflectProfiles.add(reflect_EntityPig);
    }


    //classdef for EntityRabbit
    public static void reflect_EntityRabbit_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityRabbit = new ModData();

        ArrayList<BaseData> reflect_EntityRabbit_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_EntityRabbit_constructor_EntityRabbit_0 = new ModData();
        reflect_EntityRabbit_constructor_EntityRabbit_0.set("returnType", "EntityRabbit");
        reflect_EntityRabbit_constructor_EntityRabbit_0.set("argnames", new String[]{"worldIn"});
        reflect_EntityRabbit_constructor_EntityRabbit_0.set("argtypes", new String[]{"World"});
        reflect_EntityRabbit_constructor_EntityRabbit_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityRabbit((World) params.getReflective("worldIn"));
        });
        
        reflect_EntityRabbit_constructors.add(reflect_EntityRabbit_constructor_EntityRabbit_0);


        BaseData[] reflect_EntityRabbit_constructors_arr = new BaseData[reflect_EntityRabbit_constructors.size()];
        for (int i = 0; i < reflect_EntityRabbit_constructors_arr.length; i++) {
            reflect_EntityRabbit_constructors_arr[i] = reflect_EntityRabbit_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityRabbit_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityRabbit_method_func_175521_o_1 = new ModData();
        reflect_EntityRabbit_method_func_175521_o_1.set("methodName", "func_175521_o");
        reflect_EntityRabbit_method_func_175521_o_1.set("returnType", "float");
        reflect_EntityRabbit_method_func_175521_o_1.set("static", false);
        reflect_EntityRabbit_method_func_175521_o_1.set("argnames", new String[]{"parFloat1"});
        reflect_EntityRabbit_method_func_175521_o_1.set("argtypes", new String[]{"float"});
        reflect_EntityRabbit_method_func_175521_o_1.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityRabbit) params.getReflective("_self")).func_175521_o((float) params.getFloat("parFloat1"));
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityRabbit_methods.add(reflect_EntityRabbit_method_func_175521_o_1);


        BaseData reflect_EntityRabbit_method_setMovementSpeed_2 = new ModData();
        reflect_EntityRabbit_method_setMovementSpeed_2.set("methodName", "setMovementSpeed");
        reflect_EntityRabbit_method_setMovementSpeed_2.set("returnType", "void");
        reflect_EntityRabbit_method_setMovementSpeed_2.set("static", false);
        reflect_EntityRabbit_method_setMovementSpeed_2.set("argnames", new String[]{"newSpeed"});
        reflect_EntityRabbit_method_setMovementSpeed_2.set("argtypes", new String[]{"double"});
        reflect_EntityRabbit_method_setMovementSpeed_2.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityRabbit) params.getReflective("_self")).setMovementSpeed((double) params.getDouble("newSpeed"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityRabbit_methods.add(reflect_EntityRabbit_method_setMovementSpeed_2);


        BaseData reflect_EntityRabbit_method_func_175523_cj_5 = new ModData();
        reflect_EntityRabbit_method_func_175523_cj_5.set("methodName", "func_175523_cj");
        reflect_EntityRabbit_method_func_175523_cj_5.set("returnType", "boolean");
        reflect_EntityRabbit_method_func_175523_cj_5.set("static", false);
        reflect_EntityRabbit_method_func_175523_cj_5.set("argnames", new String[]{});
        reflect_EntityRabbit_method_func_175523_cj_5.set("argtypes", new String[]{});
        reflect_EntityRabbit_method_func_175523_cj_5.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityRabbit) params.getReflective("_self")).func_175523_cj();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityRabbit_methods.add(reflect_EntityRabbit_method_func_175523_cj_5);


        BaseData reflect_EntityRabbit_method_updateAITasks_6 = new ModData();
        reflect_EntityRabbit_method_updateAITasks_6.set("methodName", "updateAITasks");
        reflect_EntityRabbit_method_updateAITasks_6.set("returnType", "void");
        reflect_EntityRabbit_method_updateAITasks_6.set("static", false);
        reflect_EntityRabbit_method_updateAITasks_6.set("argnames", new String[]{});
        reflect_EntityRabbit_method_updateAITasks_6.set("argtypes", new String[]{});
        reflect_EntityRabbit_method_updateAITasks_6.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityRabbit) params.getReflective("_self")).updateAITasks();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityRabbit_methods.add(reflect_EntityRabbit_method_updateAITasks_6);


        BaseData reflect_EntityRabbit_method_spawnRunningParticles_7 = new ModData();
        reflect_EntityRabbit_method_spawnRunningParticles_7.set("methodName", "spawnRunningParticles");
        reflect_EntityRabbit_method_spawnRunningParticles_7.set("returnType", "void");
        reflect_EntityRabbit_method_spawnRunningParticles_7.set("static", false);
        reflect_EntityRabbit_method_spawnRunningParticles_7.set("argnames", new String[]{});
        reflect_EntityRabbit_method_spawnRunningParticles_7.set("argtypes", new String[]{});
        reflect_EntityRabbit_method_spawnRunningParticles_7.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityRabbit) params.getReflective("_self")).spawnRunningParticles();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityRabbit_methods.add(reflect_EntityRabbit_method_spawnRunningParticles_7);


        BaseData reflect_EntityRabbit_method_onLivingUpdate_8 = new ModData();
        reflect_EntityRabbit_method_onLivingUpdate_8.set("methodName", "onLivingUpdate");
        reflect_EntityRabbit_method_onLivingUpdate_8.set("returnType", "void");
        reflect_EntityRabbit_method_onLivingUpdate_8.set("static", false);
        reflect_EntityRabbit_method_onLivingUpdate_8.set("argnames", new String[]{});
        reflect_EntityRabbit_method_onLivingUpdate_8.set("argtypes", new String[]{});
        reflect_EntityRabbit_method_onLivingUpdate_8.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityRabbit) params.getReflective("_self")).onLivingUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityRabbit_methods.add(reflect_EntityRabbit_method_onLivingUpdate_8);


        BaseData reflect_EntityRabbit_method_writeEntityToNBT_9 = new ModData();
        reflect_EntityRabbit_method_writeEntityToNBT_9.set("methodName", "writeEntityToNBT");
        reflect_EntityRabbit_method_writeEntityToNBT_9.set("returnType", "void");
        reflect_EntityRabbit_method_writeEntityToNBT_9.set("static", false);
        reflect_EntityRabbit_method_writeEntityToNBT_9.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityRabbit_method_writeEntityToNBT_9.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityRabbit_method_writeEntityToNBT_9.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityRabbit) params.getReflective("_self")).writeEntityToNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityRabbit_methods.add(reflect_EntityRabbit_method_writeEntityToNBT_9);


        BaseData reflect_EntityRabbit_method_readEntityFromNBT_10 = new ModData();
        reflect_EntityRabbit_method_readEntityFromNBT_10.set("methodName", "readEntityFromNBT");
        reflect_EntityRabbit_method_readEntityFromNBT_10.set("returnType", "void");
        reflect_EntityRabbit_method_readEntityFromNBT_10.set("static", false);
        reflect_EntityRabbit_method_readEntityFromNBT_10.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityRabbit_method_readEntityFromNBT_10.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityRabbit_method_readEntityFromNBT_10.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityRabbit) params.getReflective("_self")).readEntityFromNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityRabbit_methods.add(reflect_EntityRabbit_method_readEntityFromNBT_10);


        BaseData reflect_EntityRabbit_method_attackEntityAsMob_11 = new ModData();
        reflect_EntityRabbit_method_attackEntityAsMob_11.set("methodName", "attackEntityAsMob");
        reflect_EntityRabbit_method_attackEntityAsMob_11.set("returnType", "boolean");
        reflect_EntityRabbit_method_attackEntityAsMob_11.set("static", false);
        reflect_EntityRabbit_method_attackEntityAsMob_11.set("argnames", new String[]{"entity"});
        reflect_EntityRabbit_method_attackEntityAsMob_11.set("argtypes", new String[]{"Entity"});
        reflect_EntityRabbit_method_attackEntityAsMob_11.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityRabbit) params.getReflective("_self")).attackEntityAsMob((Entity) params.getReflective("entity"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityRabbit_methods.add(reflect_EntityRabbit_method_attackEntityAsMob_11);


        BaseData reflect_EntityRabbit_method_getTotalArmorValue_12 = new ModData();
        reflect_EntityRabbit_method_getTotalArmorValue_12.set("methodName", "getTotalArmorValue");
        reflect_EntityRabbit_method_getTotalArmorValue_12.set("returnType", "int");
        reflect_EntityRabbit_method_getTotalArmorValue_12.set("static", false);
        reflect_EntityRabbit_method_getTotalArmorValue_12.set("argnames", new String[]{});
        reflect_EntityRabbit_method_getTotalArmorValue_12.set("argtypes", new String[]{});
        reflect_EntityRabbit_method_getTotalArmorValue_12.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityRabbit) params.getReflective("_self")).getTotalArmorValue();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityRabbit_methods.add(reflect_EntityRabbit_method_getTotalArmorValue_12);


        BaseData reflect_EntityRabbit_method_attackEntityFrom_13 = new ModData();
        reflect_EntityRabbit_method_attackEntityFrom_13.set("methodName", "attackEntityFrom");
        reflect_EntityRabbit_method_attackEntityFrom_13.set("returnType", "boolean");
        reflect_EntityRabbit_method_attackEntityFrom_13.set("static", false);
        reflect_EntityRabbit_method_attackEntityFrom_13.set("argnames", new String[]{"damagesource", "f"});
        reflect_EntityRabbit_method_attackEntityFrom_13.set("argtypes", new String[]{"DamageSource", "float"});
        reflect_EntityRabbit_method_attackEntityFrom_13.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityRabbit) params.getReflective("_self")).attackEntityFrom((DamageSource) params.getReflective("damagesource"), (float) params.getFloat("f"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityRabbit_methods.add(reflect_EntityRabbit_method_attackEntityFrom_13);


        BaseData reflect_EntityRabbit_method_createChild_14 = new ModData();
        reflect_EntityRabbit_method_createChild_14.set("methodName", "createChild");
        reflect_EntityRabbit_method_createChild_14.set("returnType", "EntityRabbit");
        reflect_EntityRabbit_method_createChild_14.set("static", false);
        reflect_EntityRabbit_method_createChild_14.set("argnames", new String[]{"entityageable"});
        reflect_EntityRabbit_method_createChild_14.set("argtypes", new String[]{"EntityAgeable"});
        reflect_EntityRabbit_method_createChild_14.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EntityRabbit) ((EntityRabbit) params.getReflective("_self")).createChild((EntityAgeable) params.getReflective("entityageable"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityRabbit_methods.add(reflect_EntityRabbit_method_createChild_14);


        BaseData reflect_EntityRabbit_method_isBreedingItem_15 = new ModData();
        reflect_EntityRabbit_method_isBreedingItem_15.set("methodName", "isBreedingItem");
        reflect_EntityRabbit_method_isBreedingItem_15.set("returnType", "boolean");
        reflect_EntityRabbit_method_isBreedingItem_15.set("static", false);
        reflect_EntityRabbit_method_isBreedingItem_15.set("argnames", new String[]{"itemstack"});
        reflect_EntityRabbit_method_isBreedingItem_15.set("argtypes", new String[]{"ItemStack"});
        reflect_EntityRabbit_method_isBreedingItem_15.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityRabbit) params.getReflective("_self")).isBreedingItem((ItemStack) params.getReflective("itemstack"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityRabbit_methods.add(reflect_EntityRabbit_method_isBreedingItem_15);


        BaseData reflect_EntityRabbit_method_getRabbitType_16 = new ModData();
        reflect_EntityRabbit_method_getRabbitType_16.set("methodName", "getRabbitType");
        reflect_EntityRabbit_method_getRabbitType_16.set("returnType", "int");
        reflect_EntityRabbit_method_getRabbitType_16.set("static", false);
        reflect_EntityRabbit_method_getRabbitType_16.set("argnames", new String[]{});
        reflect_EntityRabbit_method_getRabbitType_16.set("argtypes", new String[]{});
        reflect_EntityRabbit_method_getRabbitType_16.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityRabbit) params.getReflective("_self")).getRabbitType();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityRabbit_methods.add(reflect_EntityRabbit_method_getRabbitType_16);


        BaseData reflect_EntityRabbit_method_setRabbitType_17 = new ModData();
        reflect_EntityRabbit_method_setRabbitType_17.set("methodName", "setRabbitType");
        reflect_EntityRabbit_method_setRabbitType_17.set("returnType", "void");
        reflect_EntityRabbit_method_setRabbitType_17.set("static", false);
        reflect_EntityRabbit_method_setRabbitType_17.set("argnames", new String[]{"rabbitTypeId"});
        reflect_EntityRabbit_method_setRabbitType_17.set("argtypes", new String[]{"int"});
        reflect_EntityRabbit_method_setRabbitType_17.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityRabbit) params.getReflective("_self")).setRabbitType((int) params.getInt("rabbitTypeId"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityRabbit_methods.add(reflect_EntityRabbit_method_setRabbitType_17);


        BaseData reflect_EntityRabbit_method_handleStatusUpdate_18 = new ModData();
        reflect_EntityRabbit_method_handleStatusUpdate_18.set("methodName", "handleStatusUpdate");
        reflect_EntityRabbit_method_handleStatusUpdate_18.set("returnType", "void");
        reflect_EntityRabbit_method_handleStatusUpdate_18.set("static", false);
        reflect_EntityRabbit_method_handleStatusUpdate_18.set("argnames", new String[]{"b0"});
        reflect_EntityRabbit_method_handleStatusUpdate_18.set("argtypes", new String[]{"byte"});
        reflect_EntityRabbit_method_handleStatusUpdate_18.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityRabbit) params.getReflective("_self")).handleStatusUpdate((byte) params.getByte("b0"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityRabbit_methods.add(reflect_EntityRabbit_method_handleStatusUpdate_18);


        BaseData[] reflect_EntityRabbit_methods_arr = new BaseData[reflect_EntityRabbit_methods.size()];
        for (int i = 0; i < reflect_EntityRabbit_methods_arr.length; i++) {
            reflect_EntityRabbit_methods_arr[i] = reflect_EntityRabbit_methods.get(i);
        }

        reflect_EntityRabbit.set("constructors", reflect_EntityRabbit_constructors_arr);
        reflect_EntityRabbit.set("methods", reflect_EntityRabbit_methods_arr);
        reflect_EntityRabbit.set("className", "EntityRabbit");
        reflect_EntityRabbit.set("classId", "net.minecraft.entity.passive.EntityRabbit");
        reflect_EntityRabbit.set("class", EntityRabbit.class);
        reflect_EntityRabbit.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityRabbit;
        });
        reflectProfiles.add(reflect_EntityRabbit);
    }


    //classdef for EntitySheep
    public static void reflect_EntitySheep_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntitySheep = new ModData();

        ArrayList<BaseData> reflect_EntitySheep_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_EntitySheep_constructor_EntitySheep_0 = new ModData();
        reflect_EntitySheep_constructor_EntitySheep_0.set("returnType", "EntitySheep");
        reflect_EntitySheep_constructor_EntitySheep_0.set("argnames", new String[]{"worldIn"});
        reflect_EntitySheep_constructor_EntitySheep_0.set("argtypes", new String[]{"World"});
        reflect_EntitySheep_constructor_EntitySheep_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntitySheep((World) params.getReflective("worldIn"));
        });
        
        reflect_EntitySheep_constructors.add(reflect_EntitySheep_constructor_EntitySheep_0);


        BaseData[] reflect_EntitySheep_constructors_arr = new BaseData[reflect_EntitySheep_constructors.size()];
        for (int i = 0; i < reflect_EntitySheep_constructors_arr.length; i++) {
            reflect_EntitySheep_constructors_arr[i] = reflect_EntitySheep_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntitySheep_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntitySheep_method_func_175513_a_0 = new ModData();
        reflect_EntitySheep_method_func_175513_a_0.set("methodName", "func_175513_a");
        reflect_EntitySheep_method_func_175513_a_0.set("returnType", "float[]");
        reflect_EntitySheep_method_func_175513_a_0.set("static", true);
        reflect_EntitySheep_method_func_175513_a_0.set("argnames", new String[]{"dyeColor"});
        reflect_EntitySheep_method_func_175513_a_0.set("argtypes", new String[]{"EnumDyeColor"});
        reflect_EntitySheep_method_func_175513_a_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float[]) EntitySheep.func_175513_a((EnumDyeColor) params.getReflective("dyeColor"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntitySheep_methods.add(reflect_EntitySheep_method_func_175513_a_0);


        BaseData reflect_EntitySheep_method_onLivingUpdate_1 = new ModData();
        reflect_EntitySheep_method_onLivingUpdate_1.set("methodName", "onLivingUpdate");
        reflect_EntitySheep_method_onLivingUpdate_1.set("returnType", "void");
        reflect_EntitySheep_method_onLivingUpdate_1.set("static", false);
        reflect_EntitySheep_method_onLivingUpdate_1.set("argnames", new String[]{});
        reflect_EntitySheep_method_onLivingUpdate_1.set("argtypes", new String[]{});
        reflect_EntitySheep_method_onLivingUpdate_1.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntitySheep) params.getReflective("_self")).onLivingUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntitySheep_methods.add(reflect_EntitySheep_method_onLivingUpdate_1);


        BaseData reflect_EntitySheep_method_handleStatusUpdate_2 = new ModData();
        reflect_EntitySheep_method_handleStatusUpdate_2.set("methodName", "handleStatusUpdate");
        reflect_EntitySheep_method_handleStatusUpdate_2.set("returnType", "void");
        reflect_EntitySheep_method_handleStatusUpdate_2.set("static", false);
        reflect_EntitySheep_method_handleStatusUpdate_2.set("argnames", new String[]{"b0"});
        reflect_EntitySheep_method_handleStatusUpdate_2.set("argtypes", new String[]{"byte"});
        reflect_EntitySheep_method_handleStatusUpdate_2.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntitySheep) params.getReflective("_self")).handleStatusUpdate((byte) params.getByte("b0"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntitySheep_methods.add(reflect_EntitySheep_method_handleStatusUpdate_2);


        BaseData reflect_EntitySheep_method_getHeadRotationPointY_3 = new ModData();
        reflect_EntitySheep_method_getHeadRotationPointY_3.set("methodName", "getHeadRotationPointY");
        reflect_EntitySheep_method_getHeadRotationPointY_3.set("returnType", "float");
        reflect_EntitySheep_method_getHeadRotationPointY_3.set("static", false);
        reflect_EntitySheep_method_getHeadRotationPointY_3.set("argnames", new String[]{"parFloat1"});
        reflect_EntitySheep_method_getHeadRotationPointY_3.set("argtypes", new String[]{"float"});
        reflect_EntitySheep_method_getHeadRotationPointY_3.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntitySheep) params.getReflective("_self")).getHeadRotationPointY((float) params.getFloat("parFloat1"));
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntitySheep_methods.add(reflect_EntitySheep_method_getHeadRotationPointY_3);


        BaseData reflect_EntitySheep_method_getHeadRotationAngleX_4 = new ModData();
        reflect_EntitySheep_method_getHeadRotationAngleX_4.set("methodName", "getHeadRotationAngleX");
        reflect_EntitySheep_method_getHeadRotationAngleX_4.set("returnType", "float");
        reflect_EntitySheep_method_getHeadRotationAngleX_4.set("static", false);
        reflect_EntitySheep_method_getHeadRotationAngleX_4.set("argnames", new String[]{"parFloat1"});
        reflect_EntitySheep_method_getHeadRotationAngleX_4.set("argtypes", new String[]{"float"});
        reflect_EntitySheep_method_getHeadRotationAngleX_4.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntitySheep) params.getReflective("_self")).getHeadRotationAngleX((float) params.getFloat("parFloat1"));
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntitySheep_methods.add(reflect_EntitySheep_method_getHeadRotationAngleX_4);


        BaseData reflect_EntitySheep_method_interact_5 = new ModData();
        reflect_EntitySheep_method_interact_5.set("methodName", "interact");
        reflect_EntitySheep_method_interact_5.set("returnType", "boolean");
        reflect_EntitySheep_method_interact_5.set("static", false);
        reflect_EntitySheep_method_interact_5.set("argnames", new String[]{"entityplayer"});
        reflect_EntitySheep_method_interact_5.set("argtypes", new String[]{"EntityPlayer"});
        reflect_EntitySheep_method_interact_5.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntitySheep) params.getReflective("_self")).interact((EntityPlayer) params.getReflective("entityplayer"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntitySheep_methods.add(reflect_EntitySheep_method_interact_5);


        BaseData reflect_EntitySheep_method_writeEntityToNBT_6 = new ModData();
        reflect_EntitySheep_method_writeEntityToNBT_6.set("methodName", "writeEntityToNBT");
        reflect_EntitySheep_method_writeEntityToNBT_6.set("returnType", "void");
        reflect_EntitySheep_method_writeEntityToNBT_6.set("static", false);
        reflect_EntitySheep_method_writeEntityToNBT_6.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntitySheep_method_writeEntityToNBT_6.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntitySheep_method_writeEntityToNBT_6.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntitySheep) params.getReflective("_self")).writeEntityToNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntitySheep_methods.add(reflect_EntitySheep_method_writeEntityToNBT_6);


        BaseData reflect_EntitySheep_method_readEntityFromNBT_7 = new ModData();
        reflect_EntitySheep_method_readEntityFromNBT_7.set("methodName", "readEntityFromNBT");
        reflect_EntitySheep_method_readEntityFromNBT_7.set("returnType", "void");
        reflect_EntitySheep_method_readEntityFromNBT_7.set("static", false);
        reflect_EntitySheep_method_readEntityFromNBT_7.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntitySheep_method_readEntityFromNBT_7.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntitySheep_method_readEntityFromNBT_7.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntitySheep) params.getReflective("_self")).readEntityFromNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntitySheep_methods.add(reflect_EntitySheep_method_readEntityFromNBT_7);


        BaseData reflect_EntitySheep_method_getFleeceColor_8 = new ModData();
        reflect_EntitySheep_method_getFleeceColor_8.set("methodName", "getFleeceColor");
        reflect_EntitySheep_method_getFleeceColor_8.set("returnType", "EnumDyeColor");
        reflect_EntitySheep_method_getFleeceColor_8.set("static", false);
        reflect_EntitySheep_method_getFleeceColor_8.set("argnames", new String[]{});
        reflect_EntitySheep_method_getFleeceColor_8.set("argtypes", new String[]{});
        reflect_EntitySheep_method_getFleeceColor_8.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EnumDyeColor) ((EntitySheep) params.getReflective("_self")).getFleeceColor();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntitySheep_methods.add(reflect_EntitySheep_method_getFleeceColor_8);


        BaseData reflect_EntitySheep_method_setFleeceColor_9 = new ModData();
        reflect_EntitySheep_method_setFleeceColor_9.set("methodName", "setFleeceColor");
        reflect_EntitySheep_method_setFleeceColor_9.set("returnType", "void");
        reflect_EntitySheep_method_setFleeceColor_9.set("static", false);
        reflect_EntitySheep_method_setFleeceColor_9.set("argnames", new String[]{"color"});
        reflect_EntitySheep_method_setFleeceColor_9.set("argtypes", new String[]{"EnumDyeColor"});
        reflect_EntitySheep_method_setFleeceColor_9.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntitySheep) params.getReflective("_self")).setFleeceColor((EnumDyeColor) params.getReflective("color"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntitySheep_methods.add(reflect_EntitySheep_method_setFleeceColor_9);


        BaseData reflect_EntitySheep_method_getSheared_10 = new ModData();
        reflect_EntitySheep_method_getSheared_10.set("methodName", "getSheared");
        reflect_EntitySheep_method_getSheared_10.set("returnType", "boolean");
        reflect_EntitySheep_method_getSheared_10.set("static", false);
        reflect_EntitySheep_method_getSheared_10.set("argnames", new String[]{});
        reflect_EntitySheep_method_getSheared_10.set("argtypes", new String[]{});
        reflect_EntitySheep_method_getSheared_10.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntitySheep) params.getReflective("_self")).getSheared();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntitySheep_methods.add(reflect_EntitySheep_method_getSheared_10);


        BaseData reflect_EntitySheep_method_setSheared_11 = new ModData();
        reflect_EntitySheep_method_setSheared_11.set("methodName", "setSheared");
        reflect_EntitySheep_method_setSheared_11.set("returnType", "void");
        reflect_EntitySheep_method_setSheared_11.set("static", false);
        reflect_EntitySheep_method_setSheared_11.set("argnames", new String[]{"sheared"});
        reflect_EntitySheep_method_setSheared_11.set("argtypes", new String[]{"boolean"});
        reflect_EntitySheep_method_setSheared_11.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntitySheep) params.getReflective("_self")).setSheared((boolean) params.getBoolean("sheared"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntitySheep_methods.add(reflect_EntitySheep_method_setSheared_11);


        BaseData reflect_EntitySheep_method_getRandomSheepColor_12 = new ModData();
        reflect_EntitySheep_method_getRandomSheepColor_12.set("methodName", "getRandomSheepColor");
        reflect_EntitySheep_method_getRandomSheepColor_12.set("returnType", "EnumDyeColor");
        reflect_EntitySheep_method_getRandomSheepColor_12.set("static", true);
        reflect_EntitySheep_method_getRandomSheepColor_12.set("argnames", new String[]{"random"});
        reflect_EntitySheep_method_getRandomSheepColor_12.set("argtypes", new String[]{"EaglercraftRandom"});
        reflect_EntitySheep_method_getRandomSheepColor_12.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EnumDyeColor) EntitySheep.getRandomSheepColor((EaglercraftRandom) params.getReflective("random"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntitySheep_methods.add(reflect_EntitySheep_method_getRandomSheepColor_12);


        BaseData reflect_EntitySheep_method_createChild_13 = new ModData();
        reflect_EntitySheep_method_createChild_13.set("methodName", "createChild");
        reflect_EntitySheep_method_createChild_13.set("returnType", "EntitySheep");
        reflect_EntitySheep_method_createChild_13.set("static", false);
        reflect_EntitySheep_method_createChild_13.set("argnames", new String[]{"entityageable"});
        reflect_EntitySheep_method_createChild_13.set("argtypes", new String[]{"EntityAgeable"});
        reflect_EntitySheep_method_createChild_13.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EntitySheep) ((EntitySheep) params.getReflective("_self")).createChild((EntityAgeable) params.getReflective("entityageable"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntitySheep_methods.add(reflect_EntitySheep_method_createChild_13);


        BaseData reflect_EntitySheep_method_eatGrassBonus_14 = new ModData();
        reflect_EntitySheep_method_eatGrassBonus_14.set("methodName", "eatGrassBonus");
        reflect_EntitySheep_method_eatGrassBonus_14.set("returnType", "void");
        reflect_EntitySheep_method_eatGrassBonus_14.set("static", false);
        reflect_EntitySheep_method_eatGrassBonus_14.set("argnames", new String[]{});
        reflect_EntitySheep_method_eatGrassBonus_14.set("argtypes", new String[]{});
        reflect_EntitySheep_method_eatGrassBonus_14.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntitySheep) params.getReflective("_self")).eatGrassBonus();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntitySheep_methods.add(reflect_EntitySheep_method_eatGrassBonus_14);


        BaseData reflect_EntitySheep_method_getEyeHeight_15 = new ModData();
        reflect_EntitySheep_method_getEyeHeight_15.set("methodName", "getEyeHeight");
        reflect_EntitySheep_method_getEyeHeight_15.set("returnType", "float");
        reflect_EntitySheep_method_getEyeHeight_15.set("static", false);
        reflect_EntitySheep_method_getEyeHeight_15.set("argnames", new String[]{});
        reflect_EntitySheep_method_getEyeHeight_15.set("argtypes", new String[]{});
        reflect_EntitySheep_method_getEyeHeight_15.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntitySheep) params.getReflective("_self")).getEyeHeight();
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntitySheep_methods.add(reflect_EntitySheep_method_getEyeHeight_15);


        BaseData[] reflect_EntitySheep_methods_arr = new BaseData[reflect_EntitySheep_methods.size()];
        for (int i = 0; i < reflect_EntitySheep_methods_arr.length; i++) {
            reflect_EntitySheep_methods_arr[i] = reflect_EntitySheep_methods.get(i);
        }

        reflect_EntitySheep.set("constructors", reflect_EntitySheep_constructors_arr);
        reflect_EntitySheep.set("methods", reflect_EntitySheep_methods_arr);
        reflect_EntitySheep.set("className", "EntitySheep");
        reflect_EntitySheep.set("classId", "net.minecraft.entity.passive.EntitySheep");
        reflect_EntitySheep.set("class", EntitySheep.class);
        reflect_EntitySheep.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntitySheep;
        });
        reflectProfiles.add(reflect_EntitySheep);
    }


    //classdef for EntitySquid
    public static void reflect_EntitySquid_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntitySquid = new ModData();

        ArrayList<BaseData> reflect_EntitySquid_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_EntitySquid_constructor_EntitySquid_0 = new ModData();
        reflect_EntitySquid_constructor_EntitySquid_0.set("returnType", "EntitySquid");
        reflect_EntitySquid_constructor_EntitySquid_0.set("argnames", new String[]{"worldIn"});
        reflect_EntitySquid_constructor_EntitySquid_0.set("argtypes", new String[]{"World"});
        reflect_EntitySquid_constructor_EntitySquid_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntitySquid((World) params.getReflective("worldIn"));
        });
        
        reflect_EntitySquid_constructors.add(reflect_EntitySquid_constructor_EntitySquid_0);


        BaseData[] reflect_EntitySquid_constructors_arr = new BaseData[reflect_EntitySquid_constructors.size()];
        for (int i = 0; i < reflect_EntitySquid_constructors_arr.length; i++) {
            reflect_EntitySquid_constructors_arr[i] = reflect_EntitySquid_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntitySquid_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntitySquid_method_getEyeHeight_0 = new ModData();
        reflect_EntitySquid_method_getEyeHeight_0.set("methodName", "getEyeHeight");
        reflect_EntitySquid_method_getEyeHeight_0.set("returnType", "float");
        reflect_EntitySquid_method_getEyeHeight_0.set("static", false);
        reflect_EntitySquid_method_getEyeHeight_0.set("argnames", new String[]{});
        reflect_EntitySquid_method_getEyeHeight_0.set("argtypes", new String[]{});
        reflect_EntitySquid_method_getEyeHeight_0.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntitySquid) params.getReflective("_self")).getEyeHeight();
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntitySquid_methods.add(reflect_EntitySquid_method_getEyeHeight_0);


        BaseData reflect_EntitySquid_method_isInWater_1 = new ModData();
        reflect_EntitySquid_method_isInWater_1.set("methodName", "isInWater");
        reflect_EntitySquid_method_isInWater_1.set("returnType", "boolean");
        reflect_EntitySquid_method_isInWater_1.set("static", false);
        reflect_EntitySquid_method_isInWater_1.set("argnames", new String[]{});
        reflect_EntitySquid_method_isInWater_1.set("argtypes", new String[]{});
        reflect_EntitySquid_method_isInWater_1.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntitySquid) params.getReflective("_self")).isInWater();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntitySquid_methods.add(reflect_EntitySquid_method_isInWater_1);


        BaseData reflect_EntitySquid_method_onLivingUpdate_2 = new ModData();
        reflect_EntitySquid_method_onLivingUpdate_2.set("methodName", "onLivingUpdate");
        reflect_EntitySquid_method_onLivingUpdate_2.set("returnType", "void");
        reflect_EntitySquid_method_onLivingUpdate_2.set("static", false);
        reflect_EntitySquid_method_onLivingUpdate_2.set("argnames", new String[]{});
        reflect_EntitySquid_method_onLivingUpdate_2.set("argtypes", new String[]{});
        reflect_EntitySquid_method_onLivingUpdate_2.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntitySquid) params.getReflective("_self")).onLivingUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntitySquid_methods.add(reflect_EntitySquid_method_onLivingUpdate_2);


        BaseData reflect_EntitySquid_method_moveEntityWithHeading_3 = new ModData();
        reflect_EntitySquid_method_moveEntityWithHeading_3.set("methodName", "moveEntityWithHeading");
        reflect_EntitySquid_method_moveEntityWithHeading_3.set("returnType", "void");
        reflect_EntitySquid_method_moveEntityWithHeading_3.set("static", false);
        reflect_EntitySquid_method_moveEntityWithHeading_3.set("argnames", new String[]{"var1", "var2"});
        reflect_EntitySquid_method_moveEntityWithHeading_3.set("argtypes", new String[]{"float", "float"});
        reflect_EntitySquid_method_moveEntityWithHeading_3.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntitySquid) params.getReflective("_self")).moveEntityWithHeading((float) params.getFloat("var1"), (float) params.getFloat("var2"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntitySquid_methods.add(reflect_EntitySquid_method_moveEntityWithHeading_3);


        BaseData reflect_EntitySquid_method_getCanSpawnHere_4 = new ModData();
        reflect_EntitySquid_method_getCanSpawnHere_4.set("methodName", "getCanSpawnHere");
        reflect_EntitySquid_method_getCanSpawnHere_4.set("returnType", "boolean");
        reflect_EntitySquid_method_getCanSpawnHere_4.set("static", false);
        reflect_EntitySquid_method_getCanSpawnHere_4.set("argnames", new String[]{});
        reflect_EntitySquid_method_getCanSpawnHere_4.set("argtypes", new String[]{});
        reflect_EntitySquid_method_getCanSpawnHere_4.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntitySquid) params.getReflective("_self")).getCanSpawnHere();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntitySquid_methods.add(reflect_EntitySquid_method_getCanSpawnHere_4);


        BaseData reflect_EntitySquid_method_handleStatusUpdate_5 = new ModData();
        reflect_EntitySquid_method_handleStatusUpdate_5.set("methodName", "handleStatusUpdate");
        reflect_EntitySquid_method_handleStatusUpdate_5.set("returnType", "void");
        reflect_EntitySquid_method_handleStatusUpdate_5.set("static", false);
        reflect_EntitySquid_method_handleStatusUpdate_5.set("argnames", new String[]{"b0"});
        reflect_EntitySquid_method_handleStatusUpdate_5.set("argtypes", new String[]{"byte"});
        reflect_EntitySquid_method_handleStatusUpdate_5.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntitySquid) params.getReflective("_self")).handleStatusUpdate((byte) params.getByte("b0"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntitySquid_methods.add(reflect_EntitySquid_method_handleStatusUpdate_5);


        BaseData reflect_EntitySquid_method_func_175568_b_6 = new ModData();
        reflect_EntitySquid_method_func_175568_b_6.set("methodName", "func_175568_b");
        reflect_EntitySquid_method_func_175568_b_6.set("returnType", "void");
        reflect_EntitySquid_method_func_175568_b_6.set("static", false);
        reflect_EntitySquid_method_func_175568_b_6.set("argnames", new String[]{"randomMotionVecXIn", "randomMotionVecYIn", "randomMotionVecZIn"});
        reflect_EntitySquid_method_func_175568_b_6.set("argtypes", new String[]{"float", "float", "float"});
        reflect_EntitySquid_method_func_175568_b_6.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntitySquid) params.getReflective("_self")).func_175568_b((float) params.getFloat("randomMotionVecXIn"), (float) params.getFloat("randomMotionVecYIn"), (float) params.getFloat("randomMotionVecZIn"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntitySquid_methods.add(reflect_EntitySquid_method_func_175568_b_6);


        BaseData reflect_EntitySquid_method_func_175567_n_7 = new ModData();
        reflect_EntitySquid_method_func_175567_n_7.set("methodName", "func_175567_n");
        reflect_EntitySquid_method_func_175567_n_7.set("returnType", "boolean");
        reflect_EntitySquid_method_func_175567_n_7.set("static", false);
        reflect_EntitySquid_method_func_175567_n_7.set("argnames", new String[]{});
        reflect_EntitySquid_method_func_175567_n_7.set("argtypes", new String[]{});
        reflect_EntitySquid_method_func_175567_n_7.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntitySquid) params.getReflective("_self")).func_175567_n();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntitySquid_methods.add(reflect_EntitySquid_method_func_175567_n_7);


        BaseData[] reflect_EntitySquid_methods_arr = new BaseData[reflect_EntitySquid_methods.size()];
        for (int i = 0; i < reflect_EntitySquid_methods_arr.length; i++) {
            reflect_EntitySquid_methods_arr[i] = reflect_EntitySquid_methods.get(i);
        }

        reflect_EntitySquid.set("constructors", reflect_EntitySquid_constructors_arr);
        reflect_EntitySquid.set("methods", reflect_EntitySquid_methods_arr);
        reflect_EntitySquid.set("className", "EntitySquid");
        reflect_EntitySquid.set("classId", "net.minecraft.entity.passive.EntitySquid");
        reflect_EntitySquid.set("class", EntitySquid.class);
        reflect_EntitySquid.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntitySquid;
        });
        reflectProfiles.add(reflect_EntitySquid);
    }


    //classdef for EntityTameable
    public static void reflect_EntityTameable_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityTameable = new ModData();

        ArrayList<BaseData> reflect_EntityTameable_constructors = new ArrayList<BaseData>();
        
        BaseData[] reflect_EntityTameable_constructors_arr = new BaseData[reflect_EntityTameable_constructors.size()];
        for (int i = 0; i < reflect_EntityTameable_constructors_arr.length; i++) {
            reflect_EntityTameable_constructors_arr[i] = reflect_EntityTameable_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityTameable_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityTameable_method_writeEntityToNBT_0 = new ModData();
        reflect_EntityTameable_method_writeEntityToNBT_0.set("methodName", "writeEntityToNBT");
        reflect_EntityTameable_method_writeEntityToNBT_0.set("returnType", "void");
        reflect_EntityTameable_method_writeEntityToNBT_0.set("static", false);
        reflect_EntityTameable_method_writeEntityToNBT_0.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityTameable_method_writeEntityToNBT_0.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityTameable_method_writeEntityToNBT_0.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityTameable) params.getReflective("_self")).writeEntityToNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityTameable_methods.add(reflect_EntityTameable_method_writeEntityToNBT_0);


        BaseData reflect_EntityTameable_method_readEntityFromNBT_1 = new ModData();
        reflect_EntityTameable_method_readEntityFromNBT_1.set("methodName", "readEntityFromNBT");
        reflect_EntityTameable_method_readEntityFromNBT_1.set("returnType", "void");
        reflect_EntityTameable_method_readEntityFromNBT_1.set("static", false);
        reflect_EntityTameable_method_readEntityFromNBT_1.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityTameable_method_readEntityFromNBT_1.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityTameable_method_readEntityFromNBT_1.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityTameable) params.getReflective("_self")).readEntityFromNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityTameable_methods.add(reflect_EntityTameable_method_readEntityFromNBT_1);


        BaseData reflect_EntityTameable_method_handleStatusUpdate_2 = new ModData();
        reflect_EntityTameable_method_handleStatusUpdate_2.set("methodName", "handleStatusUpdate");
        reflect_EntityTameable_method_handleStatusUpdate_2.set("returnType", "void");
        reflect_EntityTameable_method_handleStatusUpdate_2.set("static", false);
        reflect_EntityTameable_method_handleStatusUpdate_2.set("argnames", new String[]{"b0"});
        reflect_EntityTameable_method_handleStatusUpdate_2.set("argtypes", new String[]{"byte"});
        reflect_EntityTameable_method_handleStatusUpdate_2.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityTameable) params.getReflective("_self")).handleStatusUpdate((byte) params.getByte("b0"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityTameable_methods.add(reflect_EntityTameable_method_handleStatusUpdate_2);


        BaseData reflect_EntityTameable_method_isTamed_3 = new ModData();
        reflect_EntityTameable_method_isTamed_3.set("methodName", "isTamed");
        reflect_EntityTameable_method_isTamed_3.set("returnType", "boolean");
        reflect_EntityTameable_method_isTamed_3.set("static", false);
        reflect_EntityTameable_method_isTamed_3.set("argnames", new String[]{});
        reflect_EntityTameable_method_isTamed_3.set("argtypes", new String[]{});
        reflect_EntityTameable_method_isTamed_3.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityTameable) params.getReflective("_self")).isTamed();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityTameable_methods.add(reflect_EntityTameable_method_isTamed_3);


        BaseData reflect_EntityTameable_method_setTamed_4 = new ModData();
        reflect_EntityTameable_method_setTamed_4.set("methodName", "setTamed");
        reflect_EntityTameable_method_setTamed_4.set("returnType", "void");
        reflect_EntityTameable_method_setTamed_4.set("static", false);
        reflect_EntityTameable_method_setTamed_4.set("argnames", new String[]{"tamed"});
        reflect_EntityTameable_method_setTamed_4.set("argtypes", new String[]{"boolean"});
        reflect_EntityTameable_method_setTamed_4.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityTameable) params.getReflective("_self")).setTamed((boolean) params.getBoolean("tamed"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityTameable_methods.add(reflect_EntityTameable_method_setTamed_4);


        BaseData reflect_EntityTameable_method_isSitting_5 = new ModData();
        reflect_EntityTameable_method_isSitting_5.set("methodName", "isSitting");
        reflect_EntityTameable_method_isSitting_5.set("returnType", "boolean");
        reflect_EntityTameable_method_isSitting_5.set("static", false);
        reflect_EntityTameable_method_isSitting_5.set("argnames", new String[]{});
        reflect_EntityTameable_method_isSitting_5.set("argtypes", new String[]{});
        reflect_EntityTameable_method_isSitting_5.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityTameable) params.getReflective("_self")).isSitting();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityTameable_methods.add(reflect_EntityTameable_method_isSitting_5);


        BaseData reflect_EntityTameable_method_setSitting_6 = new ModData();
        reflect_EntityTameable_method_setSitting_6.set("methodName", "setSitting");
        reflect_EntityTameable_method_setSitting_6.set("returnType", "void");
        reflect_EntityTameable_method_setSitting_6.set("static", false);
        reflect_EntityTameable_method_setSitting_6.set("argnames", new String[]{"sitting"});
        reflect_EntityTameable_method_setSitting_6.set("argtypes", new String[]{"boolean"});
        reflect_EntityTameable_method_setSitting_6.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityTameable) params.getReflective("_self")).setSitting((boolean) params.getBoolean("sitting"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityTameable_methods.add(reflect_EntityTameable_method_setSitting_6);


        BaseData reflect_EntityTameable_method_getOwnerId_7 = new ModData();
        reflect_EntityTameable_method_getOwnerId_7.set("methodName", "getOwnerId");
        reflect_EntityTameable_method_getOwnerId_7.set("returnType", "String");
        reflect_EntityTameable_method_getOwnerId_7.set("static", false);
        reflect_EntityTameable_method_getOwnerId_7.set("argnames", new String[]{});
        reflect_EntityTameable_method_getOwnerId_7.set("argtypes", new String[]{});
        reflect_EntityTameable_method_getOwnerId_7.setCallbackStringWithDataArg("exec", (BaseData params) -> {
                try {
                    return (String) ((EntityTameable) params.getReflective("_self")).getOwnerId();
                } catch (Exception _exception_reflect_) {
                    return "";
                }
            });
            
        reflect_EntityTameable_methods.add(reflect_EntityTameable_method_getOwnerId_7);


        BaseData reflect_EntityTameable_method_setOwnerId_8 = new ModData();
        reflect_EntityTameable_method_setOwnerId_8.set("methodName", "setOwnerId");
        reflect_EntityTameable_method_setOwnerId_8.set("returnType", "void");
        reflect_EntityTameable_method_setOwnerId_8.set("static", false);
        reflect_EntityTameable_method_setOwnerId_8.set("argnames", new String[]{"ownerUuid"});
        reflect_EntityTameable_method_setOwnerId_8.set("argtypes", new String[]{"String"});
        reflect_EntityTameable_method_setOwnerId_8.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityTameable) params.getReflective("_self")).setOwnerId((String) params.getString("ownerUuid"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityTameable_methods.add(reflect_EntityTameable_method_setOwnerId_8);


        BaseData reflect_EntityTameable_method_getOwner_9 = new ModData();
        reflect_EntityTameable_method_getOwner_9.set("methodName", "getOwner");
        reflect_EntityTameable_method_getOwner_9.set("returnType", "EntityLivingBase");
        reflect_EntityTameable_method_getOwner_9.set("static", false);
        reflect_EntityTameable_method_getOwner_9.set("argnames", new String[]{});
        reflect_EntityTameable_method_getOwner_9.set("argtypes", new String[]{});
        reflect_EntityTameable_method_getOwner_9.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EntityLivingBase) ((EntityTameable) params.getReflective("_self")).getOwner();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityTameable_methods.add(reflect_EntityTameable_method_getOwner_9);


        BaseData reflect_EntityTameable_method_isOwner_10 = new ModData();
        reflect_EntityTameable_method_isOwner_10.set("methodName", "isOwner");
        reflect_EntityTameable_method_isOwner_10.set("returnType", "boolean");
        reflect_EntityTameable_method_isOwner_10.set("static", false);
        reflect_EntityTameable_method_isOwner_10.set("argnames", new String[]{"entityIn"});
        reflect_EntityTameable_method_isOwner_10.set("argtypes", new String[]{"EntityLivingBase"});
        reflect_EntityTameable_method_isOwner_10.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityTameable) params.getReflective("_self")).isOwner((EntityLivingBase) params.getReflective("entityIn"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityTameable_methods.add(reflect_EntityTameable_method_isOwner_10);


        BaseData reflect_EntityTameable_method_getAISit_11 = new ModData();
        reflect_EntityTameable_method_getAISit_11.set("methodName", "getAISit");
        reflect_EntityTameable_method_getAISit_11.set("returnType", "EntityAISit");
        reflect_EntityTameable_method_getAISit_11.set("static", false);
        reflect_EntityTameable_method_getAISit_11.set("argnames", new String[]{});
        reflect_EntityTameable_method_getAISit_11.set("argtypes", new String[]{});
        reflect_EntityTameable_method_getAISit_11.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EntityAISit) ((EntityTameable) params.getReflective("_self")).getAISit();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityTameable_methods.add(reflect_EntityTameable_method_getAISit_11);


        BaseData reflect_EntityTameable_method_shouldAttackEntity_12 = new ModData();
        reflect_EntityTameable_method_shouldAttackEntity_12.set("methodName", "shouldAttackEntity");
        reflect_EntityTameable_method_shouldAttackEntity_12.set("returnType", "boolean");
        reflect_EntityTameable_method_shouldAttackEntity_12.set("static", false);
        reflect_EntityTameable_method_shouldAttackEntity_12.set("argnames", new String[]{"parEntityLivingBase", "parEntityLivingBase2"});
        reflect_EntityTameable_method_shouldAttackEntity_12.set("argtypes", new String[]{"EntityLivingBase", "EntityLivingBase"});
        reflect_EntityTameable_method_shouldAttackEntity_12.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityTameable) params.getReflective("_self")).shouldAttackEntity((EntityLivingBase) params.getReflective("parEntityLivingBase"), (EntityLivingBase) params.getReflective("parEntityLivingBase2"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityTameable_methods.add(reflect_EntityTameable_method_shouldAttackEntity_12);


        BaseData reflect_EntityTameable_method_getTeam_13 = new ModData();
        reflect_EntityTameable_method_getTeam_13.set("methodName", "getTeam");
        reflect_EntityTameable_method_getTeam_13.set("returnType", "Team");
        reflect_EntityTameable_method_getTeam_13.set("static", false);
        reflect_EntityTameable_method_getTeam_13.set("argnames", new String[]{});
        reflect_EntityTameable_method_getTeam_13.set("argtypes", new String[]{});
        reflect_EntityTameable_method_getTeam_13.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Team) ((EntityTameable) params.getReflective("_self")).getTeam();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityTameable_methods.add(reflect_EntityTameable_method_getTeam_13);


        BaseData reflect_EntityTameable_method_isOnSameTeam_14 = new ModData();
        reflect_EntityTameable_method_isOnSameTeam_14.set("methodName", "isOnSameTeam");
        reflect_EntityTameable_method_isOnSameTeam_14.set("returnType", "boolean");
        reflect_EntityTameable_method_isOnSameTeam_14.set("static", false);
        reflect_EntityTameable_method_isOnSameTeam_14.set("argnames", new String[]{"entitylivingbase"});
        reflect_EntityTameable_method_isOnSameTeam_14.set("argtypes", new String[]{"EntityLivingBase"});
        reflect_EntityTameable_method_isOnSameTeam_14.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityTameable) params.getReflective("_self")).isOnSameTeam((EntityLivingBase) params.getReflective("entitylivingbase"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityTameable_methods.add(reflect_EntityTameable_method_isOnSameTeam_14);


        BaseData reflect_EntityTameable_method_onDeath_15 = new ModData();
        reflect_EntityTameable_method_onDeath_15.set("methodName", "onDeath");
        reflect_EntityTameable_method_onDeath_15.set("returnType", "void");
        reflect_EntityTameable_method_onDeath_15.set("static", false);
        reflect_EntityTameable_method_onDeath_15.set("argnames", new String[]{"damagesource"});
        reflect_EntityTameable_method_onDeath_15.set("argtypes", new String[]{"DamageSource"});
        reflect_EntityTameable_method_onDeath_15.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityTameable) params.getReflective("_self")).onDeath((DamageSource) params.getReflective("damagesource"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityTameable_methods.add(reflect_EntityTameable_method_onDeath_15);


        BaseData[] reflect_EntityTameable_methods_arr = new BaseData[reflect_EntityTameable_methods.size()];
        for (int i = 0; i < reflect_EntityTameable_methods_arr.length; i++) {
            reflect_EntityTameable_methods_arr[i] = reflect_EntityTameable_methods.get(i);
        }

        reflect_EntityTameable.set("constructors", reflect_EntityTameable_constructors_arr);
        reflect_EntityTameable.set("methods", reflect_EntityTameable_methods_arr);
        reflect_EntityTameable.set("className", "EntityTameable");
        reflect_EntityTameable.set("classId", "net.minecraft.entity.passive.EntityTameable");
        reflect_EntityTameable.set("class", EntityTameable.class);
        reflect_EntityTameable.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityTameable;
        });
        reflectProfiles.add(reflect_EntityTameable);
    }


    //classdef for EntityVillager
    public static void reflect_EntityVillager_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityVillager = new ModData();

        ArrayList<BaseData> reflect_EntityVillager_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_EntityVillager_constructor_EntityVillager_0 = new ModData();
        reflect_EntityVillager_constructor_EntityVillager_0.set("returnType", "EntityVillager");
        reflect_EntityVillager_constructor_EntityVillager_0.set("argnames", new String[]{"worldIn"});
        reflect_EntityVillager_constructor_EntityVillager_0.set("argtypes", new String[]{"World"});
        reflect_EntityVillager_constructor_EntityVillager_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityVillager((World) params.getReflective("worldIn"));
        });
        
        reflect_EntityVillager_constructors.add(reflect_EntityVillager_constructor_EntityVillager_0);


        BaseData reflect_EntityVillager_constructor_EntityVillager_1 = new ModData();
        reflect_EntityVillager_constructor_EntityVillager_1.set("returnType", "EntityVillager");
        reflect_EntityVillager_constructor_EntityVillager_1.set("argnames", new String[]{"worldIn", "professionId"});
        reflect_EntityVillager_constructor_EntityVillager_1.set("argtypes", new String[]{"World", "int"});
        reflect_EntityVillager_constructor_EntityVillager_1.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityVillager((World) params.getReflective("worldIn"), (int) params.getInt("professionId"));
        });
        
        reflect_EntityVillager_constructors.add(reflect_EntityVillager_constructor_EntityVillager_1);


        BaseData[] reflect_EntityVillager_constructors_arr = new BaseData[reflect_EntityVillager_constructors.size()];
        for (int i = 0; i < reflect_EntityVillager_constructors_arr.length; i++) {
            reflect_EntityVillager_constructors_arr[i] = reflect_EntityVillager_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityVillager_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityVillager_method_bootstrap_0 = new ModData();
        reflect_EntityVillager_method_bootstrap_0.set("methodName", "bootstrap");
        reflect_EntityVillager_method_bootstrap_0.set("returnType", "void");
        reflect_EntityVillager_method_bootstrap_0.set("static", true);
        reflect_EntityVillager_method_bootstrap_0.set("argnames", new String[]{});
        reflect_EntityVillager_method_bootstrap_0.set("argtypes", new String[]{});
        reflect_EntityVillager_method_bootstrap_0.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    EntityVillager.bootstrap();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityVillager_methods.add(reflect_EntityVillager_method_bootstrap_0);


        BaseData reflect_EntityVillager_method_interact_1 = new ModData();
        reflect_EntityVillager_method_interact_1.set("methodName", "interact");
        reflect_EntityVillager_method_interact_1.set("returnType", "boolean");
        reflect_EntityVillager_method_interact_1.set("static", false);
        reflect_EntityVillager_method_interact_1.set("argnames", new String[]{"entityplayer"});
        reflect_EntityVillager_method_interact_1.set("argtypes", new String[]{"EntityPlayer"});
        reflect_EntityVillager_method_interact_1.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityVillager) params.getReflective("_self")).interact((EntityPlayer) params.getReflective("entityplayer"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityVillager_methods.add(reflect_EntityVillager_method_interact_1);


        BaseData reflect_EntityVillager_method_writeEntityToNBT_2 = new ModData();
        reflect_EntityVillager_method_writeEntityToNBT_2.set("methodName", "writeEntityToNBT");
        reflect_EntityVillager_method_writeEntityToNBT_2.set("returnType", "void");
        reflect_EntityVillager_method_writeEntityToNBT_2.set("static", false);
        reflect_EntityVillager_method_writeEntityToNBT_2.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityVillager_method_writeEntityToNBT_2.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityVillager_method_writeEntityToNBT_2.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityVillager) params.getReflective("_self")).writeEntityToNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityVillager_methods.add(reflect_EntityVillager_method_writeEntityToNBT_2);


        BaseData reflect_EntityVillager_method_readEntityFromNBT_3 = new ModData();
        reflect_EntityVillager_method_readEntityFromNBT_3.set("methodName", "readEntityFromNBT");
        reflect_EntityVillager_method_readEntityFromNBT_3.set("returnType", "void");
        reflect_EntityVillager_method_readEntityFromNBT_3.set("static", false);
        reflect_EntityVillager_method_readEntityFromNBT_3.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityVillager_method_readEntityFromNBT_3.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityVillager_method_readEntityFromNBT_3.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityVillager) params.getReflective("_self")).readEntityFromNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityVillager_methods.add(reflect_EntityVillager_method_readEntityFromNBT_3);


        BaseData reflect_EntityVillager_method_setProfession_4 = new ModData();
        reflect_EntityVillager_method_setProfession_4.set("methodName", "setProfession");
        reflect_EntityVillager_method_setProfession_4.set("returnType", "void");
        reflect_EntityVillager_method_setProfession_4.set("static", false);
        reflect_EntityVillager_method_setProfession_4.set("argnames", new String[]{"professionId"});
        reflect_EntityVillager_method_setProfession_4.set("argtypes", new String[]{"int"});
        reflect_EntityVillager_method_setProfession_4.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityVillager) params.getReflective("_self")).setProfession((int) params.getInt("professionId"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityVillager_methods.add(reflect_EntityVillager_method_setProfession_4);


        BaseData reflect_EntityVillager_method_getProfession_5 = new ModData();
        reflect_EntityVillager_method_getProfession_5.set("methodName", "getProfession");
        reflect_EntityVillager_method_getProfession_5.set("returnType", "int");
        reflect_EntityVillager_method_getProfession_5.set("static", false);
        reflect_EntityVillager_method_getProfession_5.set("argnames", new String[]{});
        reflect_EntityVillager_method_getProfession_5.set("argtypes", new String[]{});
        reflect_EntityVillager_method_getProfession_5.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityVillager) params.getReflective("_self")).getProfession();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityVillager_methods.add(reflect_EntityVillager_method_getProfession_5);


        BaseData reflect_EntityVillager_method_isMating_6 = new ModData();
        reflect_EntityVillager_method_isMating_6.set("methodName", "isMating");
        reflect_EntityVillager_method_isMating_6.set("returnType", "boolean");
        reflect_EntityVillager_method_isMating_6.set("static", false);
        reflect_EntityVillager_method_isMating_6.set("argnames", new String[]{});
        reflect_EntityVillager_method_isMating_6.set("argtypes", new String[]{});
        reflect_EntityVillager_method_isMating_6.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityVillager) params.getReflective("_self")).isMating();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityVillager_methods.add(reflect_EntityVillager_method_isMating_6);


        BaseData reflect_EntityVillager_method_setMating_7 = new ModData();
        reflect_EntityVillager_method_setMating_7.set("methodName", "setMating");
        reflect_EntityVillager_method_setMating_7.set("returnType", "void");
        reflect_EntityVillager_method_setMating_7.set("static", false);
        reflect_EntityVillager_method_setMating_7.set("argnames", new String[]{"mating"});
        reflect_EntityVillager_method_setMating_7.set("argtypes", new String[]{"boolean"});
        reflect_EntityVillager_method_setMating_7.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityVillager) params.getReflective("_self")).setMating((boolean) params.getBoolean("mating"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityVillager_methods.add(reflect_EntityVillager_method_setMating_7);


        BaseData reflect_EntityVillager_method_setPlaying_8 = new ModData();
        reflect_EntityVillager_method_setPlaying_8.set("methodName", "setPlaying");
        reflect_EntityVillager_method_setPlaying_8.set("returnType", "void");
        reflect_EntityVillager_method_setPlaying_8.set("static", false);
        reflect_EntityVillager_method_setPlaying_8.set("argnames", new String[]{"playing"});
        reflect_EntityVillager_method_setPlaying_8.set("argtypes", new String[]{"boolean"});
        reflect_EntityVillager_method_setPlaying_8.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityVillager) params.getReflective("_self")).setPlaying((boolean) params.getBoolean("playing"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityVillager_methods.add(reflect_EntityVillager_method_setPlaying_8);


        BaseData reflect_EntityVillager_method_isPlaying_9 = new ModData();
        reflect_EntityVillager_method_isPlaying_9.set("methodName", "isPlaying");
        reflect_EntityVillager_method_isPlaying_9.set("returnType", "boolean");
        reflect_EntityVillager_method_isPlaying_9.set("static", false);
        reflect_EntityVillager_method_isPlaying_9.set("argnames", new String[]{});
        reflect_EntityVillager_method_isPlaying_9.set("argtypes", new String[]{});
        reflect_EntityVillager_method_isPlaying_9.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityVillager) params.getReflective("_self")).isPlaying();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityVillager_methods.add(reflect_EntityVillager_method_isPlaying_9);


        BaseData reflect_EntityVillager_method_setRevengeTarget_10 = new ModData();
        reflect_EntityVillager_method_setRevengeTarget_10.set("methodName", "setRevengeTarget");
        reflect_EntityVillager_method_setRevengeTarget_10.set("returnType", "void");
        reflect_EntityVillager_method_setRevengeTarget_10.set("static", false);
        reflect_EntityVillager_method_setRevengeTarget_10.set("argnames", new String[]{"entitylivingbase"});
        reflect_EntityVillager_method_setRevengeTarget_10.set("argtypes", new String[]{"EntityLivingBase"});
        reflect_EntityVillager_method_setRevengeTarget_10.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityVillager) params.getReflective("_self")).setRevengeTarget((EntityLivingBase) params.getReflective("entitylivingbase"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityVillager_methods.add(reflect_EntityVillager_method_setRevengeTarget_10);


        BaseData reflect_EntityVillager_method_onDeath_11 = new ModData();
        reflect_EntityVillager_method_onDeath_11.set("methodName", "onDeath");
        reflect_EntityVillager_method_onDeath_11.set("returnType", "void");
        reflect_EntityVillager_method_onDeath_11.set("static", false);
        reflect_EntityVillager_method_onDeath_11.set("argnames", new String[]{"damagesource"});
        reflect_EntityVillager_method_onDeath_11.set("argtypes", new String[]{"DamageSource"});
        reflect_EntityVillager_method_onDeath_11.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityVillager) params.getReflective("_self")).onDeath((DamageSource) params.getReflective("damagesource"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityVillager_methods.add(reflect_EntityVillager_method_onDeath_11);


        BaseData reflect_EntityVillager_method_setCustomer_12 = new ModData();
        reflect_EntityVillager_method_setCustomer_12.set("methodName", "setCustomer");
        reflect_EntityVillager_method_setCustomer_12.set("returnType", "void");
        reflect_EntityVillager_method_setCustomer_12.set("static", false);
        reflect_EntityVillager_method_setCustomer_12.set("argnames", new String[]{"entityplayer"});
        reflect_EntityVillager_method_setCustomer_12.set("argtypes", new String[]{"EntityPlayer"});
        reflect_EntityVillager_method_setCustomer_12.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityVillager) params.getReflective("_self")).setCustomer((EntityPlayer) params.getReflective("entityplayer"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityVillager_methods.add(reflect_EntityVillager_method_setCustomer_12);


        BaseData reflect_EntityVillager_method_getCustomer_13 = new ModData();
        reflect_EntityVillager_method_getCustomer_13.set("methodName", "getCustomer");
        reflect_EntityVillager_method_getCustomer_13.set("returnType", "EntityPlayer");
        reflect_EntityVillager_method_getCustomer_13.set("static", false);
        reflect_EntityVillager_method_getCustomer_13.set("argnames", new String[]{});
        reflect_EntityVillager_method_getCustomer_13.set("argtypes", new String[]{});
        reflect_EntityVillager_method_getCustomer_13.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EntityPlayer) ((EntityVillager) params.getReflective("_self")).getCustomer();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityVillager_methods.add(reflect_EntityVillager_method_getCustomer_13);


        BaseData reflect_EntityVillager_method_isTrading_14 = new ModData();
        reflect_EntityVillager_method_isTrading_14.set("methodName", "isTrading");
        reflect_EntityVillager_method_isTrading_14.set("returnType", "boolean");
        reflect_EntityVillager_method_isTrading_14.set("static", false);
        reflect_EntityVillager_method_isTrading_14.set("argnames", new String[]{});
        reflect_EntityVillager_method_isTrading_14.set("argtypes", new String[]{});
        reflect_EntityVillager_method_isTrading_14.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityVillager) params.getReflective("_self")).isTrading();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityVillager_methods.add(reflect_EntityVillager_method_isTrading_14);


        BaseData reflect_EntityVillager_method_getIsWillingToMate_15 = new ModData();
        reflect_EntityVillager_method_getIsWillingToMate_15.set("methodName", "getIsWillingToMate");
        reflect_EntityVillager_method_getIsWillingToMate_15.set("returnType", "boolean");
        reflect_EntityVillager_method_getIsWillingToMate_15.set("static", false);
        reflect_EntityVillager_method_getIsWillingToMate_15.set("argnames", new String[]{"updateFirst"});
        reflect_EntityVillager_method_getIsWillingToMate_15.set("argtypes", new String[]{"boolean"});
        reflect_EntityVillager_method_getIsWillingToMate_15.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityVillager) params.getReflective("_self")).getIsWillingToMate((boolean) params.getBoolean("updateFirst"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityVillager_methods.add(reflect_EntityVillager_method_getIsWillingToMate_15);


        BaseData reflect_EntityVillager_method_setIsWillingToMate_16 = new ModData();
        reflect_EntityVillager_method_setIsWillingToMate_16.set("methodName", "setIsWillingToMate");
        reflect_EntityVillager_method_setIsWillingToMate_16.set("returnType", "void");
        reflect_EntityVillager_method_setIsWillingToMate_16.set("static", false);
        reflect_EntityVillager_method_setIsWillingToMate_16.set("argnames", new String[]{"willingToTrade"});
        reflect_EntityVillager_method_setIsWillingToMate_16.set("argtypes", new String[]{"boolean"});
        reflect_EntityVillager_method_setIsWillingToMate_16.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityVillager) params.getReflective("_self")).setIsWillingToMate((boolean) params.getBoolean("willingToTrade"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityVillager_methods.add(reflect_EntityVillager_method_setIsWillingToMate_16);


        BaseData reflect_EntityVillager_method_useRecipe_17 = new ModData();
        reflect_EntityVillager_method_useRecipe_17.set("methodName", "useRecipe");
        reflect_EntityVillager_method_useRecipe_17.set("returnType", "void");
        reflect_EntityVillager_method_useRecipe_17.set("static", false);
        reflect_EntityVillager_method_useRecipe_17.set("argnames", new String[]{"merchantrecipe"});
        reflect_EntityVillager_method_useRecipe_17.set("argtypes", new String[]{"MerchantRecipe"});
        reflect_EntityVillager_method_useRecipe_17.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityVillager) params.getReflective("_self")).useRecipe((MerchantRecipe) params.getReflective("merchantrecipe"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityVillager_methods.add(reflect_EntityVillager_method_useRecipe_17);


        BaseData reflect_EntityVillager_method_verifySellingItem_18 = new ModData();
        reflect_EntityVillager_method_verifySellingItem_18.set("methodName", "verifySellingItem");
        reflect_EntityVillager_method_verifySellingItem_18.set("returnType", "void");
        reflect_EntityVillager_method_verifySellingItem_18.set("static", false);
        reflect_EntityVillager_method_verifySellingItem_18.set("argnames", new String[]{"itemstack"});
        reflect_EntityVillager_method_verifySellingItem_18.set("argtypes", new String[]{"ItemStack"});
        reflect_EntityVillager_method_verifySellingItem_18.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityVillager) params.getReflective("_self")).verifySellingItem((ItemStack) params.getReflective("itemstack"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityVillager_methods.add(reflect_EntityVillager_method_verifySellingItem_18);


        BaseData reflect_EntityVillager_method_getRecipes_19 = new ModData();
        reflect_EntityVillager_method_getRecipes_19.set("methodName", "getRecipes");
        reflect_EntityVillager_method_getRecipes_19.set("returnType", "MerchantRecipeList");
        reflect_EntityVillager_method_getRecipes_19.set("static", false);
        reflect_EntityVillager_method_getRecipes_19.set("argnames", new String[]{"var1"});
        reflect_EntityVillager_method_getRecipes_19.set("argtypes", new String[]{"EntityPlayer"});
        reflect_EntityVillager_method_getRecipes_19.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (MerchantRecipeList) ((EntityVillager) params.getReflective("_self")).getRecipes((EntityPlayer) params.getReflective("var1"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityVillager_methods.add(reflect_EntityVillager_method_getRecipes_19);


        BaseData reflect_EntityVillager_method_setRecipes_20 = new ModData();
        reflect_EntityVillager_method_setRecipes_20.set("methodName", "setRecipes");
        reflect_EntityVillager_method_setRecipes_20.set("returnType", "void");
        reflect_EntityVillager_method_setRecipes_20.set("static", false);
        reflect_EntityVillager_method_setRecipes_20.set("argnames", new String[]{"var1"});
        reflect_EntityVillager_method_setRecipes_20.set("argtypes", new String[]{"MerchantRecipeList"});
        reflect_EntityVillager_method_setRecipes_20.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityVillager) params.getReflective("_self")).setRecipes((MerchantRecipeList) params.getReflective("var1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityVillager_methods.add(reflect_EntityVillager_method_setRecipes_20);


        BaseData reflect_EntityVillager_method_getDisplayName_21 = new ModData();
        reflect_EntityVillager_method_getDisplayName_21.set("methodName", "getDisplayName");
        reflect_EntityVillager_method_getDisplayName_21.set("returnType", "IChatComponent");
        reflect_EntityVillager_method_getDisplayName_21.set("static", false);
        reflect_EntityVillager_method_getDisplayName_21.set("argnames", new String[]{});
        reflect_EntityVillager_method_getDisplayName_21.set("argtypes", new String[]{});
        reflect_EntityVillager_method_getDisplayName_21.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (IChatComponent) ((EntityVillager) params.getReflective("_self")).getDisplayName();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityVillager_methods.add(reflect_EntityVillager_method_getDisplayName_21);


        BaseData reflect_EntityVillager_method_getEyeHeight_22 = new ModData();
        reflect_EntityVillager_method_getEyeHeight_22.set("methodName", "getEyeHeight");
        reflect_EntityVillager_method_getEyeHeight_22.set("returnType", "float");
        reflect_EntityVillager_method_getEyeHeight_22.set("static", false);
        reflect_EntityVillager_method_getEyeHeight_22.set("argnames", new String[]{});
        reflect_EntityVillager_method_getEyeHeight_22.set("argtypes", new String[]{});
        reflect_EntityVillager_method_getEyeHeight_22.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityVillager) params.getReflective("_self")).getEyeHeight();
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityVillager_methods.add(reflect_EntityVillager_method_getEyeHeight_22);


        BaseData reflect_EntityVillager_method_handleStatusUpdate_23 = new ModData();
        reflect_EntityVillager_method_handleStatusUpdate_23.set("methodName", "handleStatusUpdate");
        reflect_EntityVillager_method_handleStatusUpdate_23.set("returnType", "void");
        reflect_EntityVillager_method_handleStatusUpdate_23.set("static", false);
        reflect_EntityVillager_method_handleStatusUpdate_23.set("argnames", new String[]{"b0"});
        reflect_EntityVillager_method_handleStatusUpdate_23.set("argtypes", new String[]{"byte"});
        reflect_EntityVillager_method_handleStatusUpdate_23.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityVillager) params.getReflective("_self")).handleStatusUpdate((byte) params.getByte("b0"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityVillager_methods.add(reflect_EntityVillager_method_handleStatusUpdate_23);


        BaseData reflect_EntityVillager_method_setLookingForHome_24 = new ModData();
        reflect_EntityVillager_method_setLookingForHome_24.set("methodName", "setLookingForHome");
        reflect_EntityVillager_method_setLookingForHome_24.set("returnType", "void");
        reflect_EntityVillager_method_setLookingForHome_24.set("static", false);
        reflect_EntityVillager_method_setLookingForHome_24.set("argnames", new String[]{});
        reflect_EntityVillager_method_setLookingForHome_24.set("argtypes", new String[]{});
        reflect_EntityVillager_method_setLookingForHome_24.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityVillager) params.getReflective("_self")).setLookingForHome();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityVillager_methods.add(reflect_EntityVillager_method_setLookingForHome_24);


        BaseData reflect_EntityVillager_method_createChild_25 = new ModData();
        reflect_EntityVillager_method_createChild_25.set("methodName", "createChild");
        reflect_EntityVillager_method_createChild_25.set("returnType", "EntityVillager");
        reflect_EntityVillager_method_createChild_25.set("static", false);
        reflect_EntityVillager_method_createChild_25.set("argnames", new String[]{"var1"});
        reflect_EntityVillager_method_createChild_25.set("argtypes", new String[]{"EntityAgeable"});
        reflect_EntityVillager_method_createChild_25.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EntityVillager) ((EntityVillager) params.getReflective("_self")).createChild((EntityAgeable) params.getReflective("var1"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityVillager_methods.add(reflect_EntityVillager_method_createChild_25);


        BaseData reflect_EntityVillager_method_allowLeashing_26 = new ModData();
        reflect_EntityVillager_method_allowLeashing_26.set("methodName", "allowLeashing");
        reflect_EntityVillager_method_allowLeashing_26.set("returnType", "boolean");
        reflect_EntityVillager_method_allowLeashing_26.set("static", false);
        reflect_EntityVillager_method_allowLeashing_26.set("argnames", new String[]{});
        reflect_EntityVillager_method_allowLeashing_26.set("argtypes", new String[]{});
        reflect_EntityVillager_method_allowLeashing_26.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityVillager) params.getReflective("_self")).allowLeashing();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityVillager_methods.add(reflect_EntityVillager_method_allowLeashing_26);


        BaseData reflect_EntityVillager_method_onStruckByLightning_27 = new ModData();
        reflect_EntityVillager_method_onStruckByLightning_27.set("methodName", "onStruckByLightning");
        reflect_EntityVillager_method_onStruckByLightning_27.set("returnType", "void");
        reflect_EntityVillager_method_onStruckByLightning_27.set("static", false);
        reflect_EntityVillager_method_onStruckByLightning_27.set("argnames", new String[]{"var1"});
        reflect_EntityVillager_method_onStruckByLightning_27.set("argtypes", new String[]{"EntityLightningBolt"});
        reflect_EntityVillager_method_onStruckByLightning_27.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityVillager) params.getReflective("_self")).onStruckByLightning((EntityLightningBolt) params.getReflective("var1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityVillager_methods.add(reflect_EntityVillager_method_onStruckByLightning_27);


        BaseData reflect_EntityVillager_method_getVillagerInventory_28 = new ModData();
        reflect_EntityVillager_method_getVillagerInventory_28.set("methodName", "getVillagerInventory");
        reflect_EntityVillager_method_getVillagerInventory_28.set("returnType", "InventoryBasic");
        reflect_EntityVillager_method_getVillagerInventory_28.set("static", false);
        reflect_EntityVillager_method_getVillagerInventory_28.set("argnames", new String[]{});
        reflect_EntityVillager_method_getVillagerInventory_28.set("argtypes", new String[]{});
        reflect_EntityVillager_method_getVillagerInventory_28.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (InventoryBasic) ((EntityVillager) params.getReflective("_self")).getVillagerInventory();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityVillager_methods.add(reflect_EntityVillager_method_getVillagerInventory_28);


        BaseData reflect_EntityVillager_method_func_175553_cp_29 = new ModData();
        reflect_EntityVillager_method_func_175553_cp_29.set("methodName", "func_175553_cp");
        reflect_EntityVillager_method_func_175553_cp_29.set("returnType", "boolean");
        reflect_EntityVillager_method_func_175553_cp_29.set("static", false);
        reflect_EntityVillager_method_func_175553_cp_29.set("argnames", new String[]{});
        reflect_EntityVillager_method_func_175553_cp_29.set("argtypes", new String[]{});
        reflect_EntityVillager_method_func_175553_cp_29.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityVillager) params.getReflective("_self")).func_175553_cp();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityVillager_methods.add(reflect_EntityVillager_method_func_175553_cp_29);


        BaseData reflect_EntityVillager_method_canAbondonItems_30 = new ModData();
        reflect_EntityVillager_method_canAbondonItems_30.set("methodName", "canAbondonItems");
        reflect_EntityVillager_method_canAbondonItems_30.set("returnType", "boolean");
        reflect_EntityVillager_method_canAbondonItems_30.set("static", false);
        reflect_EntityVillager_method_canAbondonItems_30.set("argnames", new String[]{});
        reflect_EntityVillager_method_canAbondonItems_30.set("argtypes", new String[]{});
        reflect_EntityVillager_method_canAbondonItems_30.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityVillager) params.getReflective("_self")).canAbondonItems();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityVillager_methods.add(reflect_EntityVillager_method_canAbondonItems_30);


        BaseData reflect_EntityVillager_method_func_175557_cr_31 = new ModData();
        reflect_EntityVillager_method_func_175557_cr_31.set("methodName", "func_175557_cr");
        reflect_EntityVillager_method_func_175557_cr_31.set("returnType", "boolean");
        reflect_EntityVillager_method_func_175557_cr_31.set("static", false);
        reflect_EntityVillager_method_func_175557_cr_31.set("argnames", new String[]{});
        reflect_EntityVillager_method_func_175557_cr_31.set("argtypes", new String[]{});
        reflect_EntityVillager_method_func_175557_cr_31.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityVillager) params.getReflective("_self")).func_175557_cr();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityVillager_methods.add(reflect_EntityVillager_method_func_175557_cr_31);


        BaseData reflect_EntityVillager_method_isFarmItemInInventory_32 = new ModData();
        reflect_EntityVillager_method_isFarmItemInInventory_32.set("methodName", "isFarmItemInInventory");
        reflect_EntityVillager_method_isFarmItemInInventory_32.set("returnType", "boolean");
        reflect_EntityVillager_method_isFarmItemInInventory_32.set("static", false);
        reflect_EntityVillager_method_isFarmItemInInventory_32.set("argnames", new String[]{});
        reflect_EntityVillager_method_isFarmItemInInventory_32.set("argtypes", new String[]{});
        reflect_EntityVillager_method_isFarmItemInInventory_32.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityVillager) params.getReflective("_self")).isFarmItemInInventory();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityVillager_methods.add(reflect_EntityVillager_method_isFarmItemInInventory_32);


        BaseData reflect_EntityVillager_method_replaceItemInInventory_33 = new ModData();
        reflect_EntityVillager_method_replaceItemInInventory_33.set("methodName", "replaceItemInInventory");
        reflect_EntityVillager_method_replaceItemInInventory_33.set("returnType", "boolean");
        reflect_EntityVillager_method_replaceItemInInventory_33.set("static", false);
        reflect_EntityVillager_method_replaceItemInInventory_33.set("argnames", new String[]{"i", "itemstack"});
        reflect_EntityVillager_method_replaceItemInInventory_33.set("argtypes", new String[]{"int", "ItemStack"});
        reflect_EntityVillager_method_replaceItemInInventory_33.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityVillager) params.getReflective("_self")).replaceItemInInventory((int) params.getInt("i"), (ItemStack) params.getReflective("itemstack"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityVillager_methods.add(reflect_EntityVillager_method_replaceItemInInventory_33);


        BaseData[] reflect_EntityVillager_methods_arr = new BaseData[reflect_EntityVillager_methods.size()];
        for (int i = 0; i < reflect_EntityVillager_methods_arr.length; i++) {
            reflect_EntityVillager_methods_arr[i] = reflect_EntityVillager_methods.get(i);
        }

        reflect_EntityVillager.set("constructors", reflect_EntityVillager_constructors_arr);
        reflect_EntityVillager.set("methods", reflect_EntityVillager_methods_arr);
        reflect_EntityVillager.set("className", "EntityVillager");
        reflect_EntityVillager.set("classId", "net.minecraft.entity.passive.EntityVillager");
        reflect_EntityVillager.set("class", EntityVillager.class);
        reflect_EntityVillager.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityVillager;
        });
        reflectProfiles.add(reflect_EntityVillager);
    }


    //classdef for EntityWaterMob
    public static void reflect_EntityWaterMob_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityWaterMob = new ModData();

        ArrayList<BaseData> reflect_EntityWaterMob_constructors = new ArrayList<BaseData>();
        
        BaseData[] reflect_EntityWaterMob_constructors_arr = new BaseData[reflect_EntityWaterMob_constructors.size()];
        for (int i = 0; i < reflect_EntityWaterMob_constructors_arr.length; i++) {
            reflect_EntityWaterMob_constructors_arr[i] = reflect_EntityWaterMob_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityWaterMob_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityWaterMob_method_canBreatheUnderwater_0 = new ModData();
        reflect_EntityWaterMob_method_canBreatheUnderwater_0.set("methodName", "canBreatheUnderwater");
        reflect_EntityWaterMob_method_canBreatheUnderwater_0.set("returnType", "boolean");
        reflect_EntityWaterMob_method_canBreatheUnderwater_0.set("static", false);
        reflect_EntityWaterMob_method_canBreatheUnderwater_0.set("argnames", new String[]{});
        reflect_EntityWaterMob_method_canBreatheUnderwater_0.set("argtypes", new String[]{});
        reflect_EntityWaterMob_method_canBreatheUnderwater_0.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityWaterMob) params.getReflective("_self")).canBreatheUnderwater();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityWaterMob_methods.add(reflect_EntityWaterMob_method_canBreatheUnderwater_0);


        BaseData reflect_EntityWaterMob_method_getCanSpawnHere_1 = new ModData();
        reflect_EntityWaterMob_method_getCanSpawnHere_1.set("methodName", "getCanSpawnHere");
        reflect_EntityWaterMob_method_getCanSpawnHere_1.set("returnType", "boolean");
        reflect_EntityWaterMob_method_getCanSpawnHere_1.set("static", false);
        reflect_EntityWaterMob_method_getCanSpawnHere_1.set("argnames", new String[]{});
        reflect_EntityWaterMob_method_getCanSpawnHere_1.set("argtypes", new String[]{});
        reflect_EntityWaterMob_method_getCanSpawnHere_1.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityWaterMob) params.getReflective("_self")).getCanSpawnHere();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityWaterMob_methods.add(reflect_EntityWaterMob_method_getCanSpawnHere_1);


        BaseData reflect_EntityWaterMob_method_isNotColliding_2 = new ModData();
        reflect_EntityWaterMob_method_isNotColliding_2.set("methodName", "isNotColliding");
        reflect_EntityWaterMob_method_isNotColliding_2.set("returnType", "boolean");
        reflect_EntityWaterMob_method_isNotColliding_2.set("static", false);
        reflect_EntityWaterMob_method_isNotColliding_2.set("argnames", new String[]{});
        reflect_EntityWaterMob_method_isNotColliding_2.set("argtypes", new String[]{});
        reflect_EntityWaterMob_method_isNotColliding_2.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityWaterMob) params.getReflective("_self")).isNotColliding();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityWaterMob_methods.add(reflect_EntityWaterMob_method_isNotColliding_2);


        BaseData reflect_EntityWaterMob_method_getTalkInterval_3 = new ModData();
        reflect_EntityWaterMob_method_getTalkInterval_3.set("methodName", "getTalkInterval");
        reflect_EntityWaterMob_method_getTalkInterval_3.set("returnType", "int");
        reflect_EntityWaterMob_method_getTalkInterval_3.set("static", false);
        reflect_EntityWaterMob_method_getTalkInterval_3.set("argnames", new String[]{});
        reflect_EntityWaterMob_method_getTalkInterval_3.set("argtypes", new String[]{});
        reflect_EntityWaterMob_method_getTalkInterval_3.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityWaterMob) params.getReflective("_self")).getTalkInterval();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityWaterMob_methods.add(reflect_EntityWaterMob_method_getTalkInterval_3);


        BaseData reflect_EntityWaterMob_method_onEntityUpdate_4 = new ModData();
        reflect_EntityWaterMob_method_onEntityUpdate_4.set("methodName", "onEntityUpdate");
        reflect_EntityWaterMob_method_onEntityUpdate_4.set("returnType", "void");
        reflect_EntityWaterMob_method_onEntityUpdate_4.set("static", false);
        reflect_EntityWaterMob_method_onEntityUpdate_4.set("argnames", new String[]{});
        reflect_EntityWaterMob_method_onEntityUpdate_4.set("argtypes", new String[]{});
        reflect_EntityWaterMob_method_onEntityUpdate_4.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityWaterMob) params.getReflective("_self")).onEntityUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityWaterMob_methods.add(reflect_EntityWaterMob_method_onEntityUpdate_4);


        BaseData reflect_EntityWaterMob_method_isPushedByWater_5 = new ModData();
        reflect_EntityWaterMob_method_isPushedByWater_5.set("methodName", "isPushedByWater");
        reflect_EntityWaterMob_method_isPushedByWater_5.set("returnType", "boolean");
        reflect_EntityWaterMob_method_isPushedByWater_5.set("static", false);
        reflect_EntityWaterMob_method_isPushedByWater_5.set("argnames", new String[]{});
        reflect_EntityWaterMob_method_isPushedByWater_5.set("argtypes", new String[]{});
        reflect_EntityWaterMob_method_isPushedByWater_5.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityWaterMob) params.getReflective("_self")).isPushedByWater();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityWaterMob_methods.add(reflect_EntityWaterMob_method_isPushedByWater_5);


        BaseData[] reflect_EntityWaterMob_methods_arr = new BaseData[reflect_EntityWaterMob_methods.size()];
        for (int i = 0; i < reflect_EntityWaterMob_methods_arr.length; i++) {
            reflect_EntityWaterMob_methods_arr[i] = reflect_EntityWaterMob_methods.get(i);
        }

        reflect_EntityWaterMob.set("constructors", reflect_EntityWaterMob_constructors_arr);
        reflect_EntityWaterMob.set("methods", reflect_EntityWaterMob_methods_arr);
        reflect_EntityWaterMob.set("className", "EntityWaterMob");
        reflect_EntityWaterMob.set("classId", "net.minecraft.entity.passive.EntityWaterMob");
        reflect_EntityWaterMob.set("class", EntityWaterMob.class);
        reflect_EntityWaterMob.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityWaterMob;
        });
        reflectProfiles.add(reflect_EntityWaterMob);
    }


    //classdef for EntityWolf
    public static void reflect_EntityWolf_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityWolf = new ModData();

        ArrayList<BaseData> reflect_EntityWolf_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_EntityWolf_constructor_EntityWolf_0 = new ModData();
        reflect_EntityWolf_constructor_EntityWolf_0.set("returnType", "EntityWolf");
        reflect_EntityWolf_constructor_EntityWolf_0.set("argnames", new String[]{"worldIn"});
        reflect_EntityWolf_constructor_EntityWolf_0.set("argtypes", new String[]{"World"});
        reflect_EntityWolf_constructor_EntityWolf_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityWolf((World) params.getReflective("worldIn"));
        });
        
        reflect_EntityWolf_constructors.add(reflect_EntityWolf_constructor_EntityWolf_0);


        BaseData[] reflect_EntityWolf_constructors_arr = new BaseData[reflect_EntityWolf_constructors.size()];
        for (int i = 0; i < reflect_EntityWolf_constructors_arr.length; i++) {
            reflect_EntityWolf_constructors_arr[i] = reflect_EntityWolf_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityWolf_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityWolf_method_setAttackTarget_0 = new ModData();
        reflect_EntityWolf_method_setAttackTarget_0.set("methodName", "setAttackTarget");
        reflect_EntityWolf_method_setAttackTarget_0.set("returnType", "void");
        reflect_EntityWolf_method_setAttackTarget_0.set("static", false);
        reflect_EntityWolf_method_setAttackTarget_0.set("argnames", new String[]{"entitylivingbase"});
        reflect_EntityWolf_method_setAttackTarget_0.set("argtypes", new String[]{"EntityLivingBase"});
        reflect_EntityWolf_method_setAttackTarget_0.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityWolf) params.getReflective("_self")).setAttackTarget((EntityLivingBase) params.getReflective("entitylivingbase"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityWolf_methods.add(reflect_EntityWolf_method_setAttackTarget_0);


        BaseData reflect_EntityWolf_method_writeEntityToNBT_1 = new ModData();
        reflect_EntityWolf_method_writeEntityToNBT_1.set("methodName", "writeEntityToNBT");
        reflect_EntityWolf_method_writeEntityToNBT_1.set("returnType", "void");
        reflect_EntityWolf_method_writeEntityToNBT_1.set("static", false);
        reflect_EntityWolf_method_writeEntityToNBT_1.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityWolf_method_writeEntityToNBT_1.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityWolf_method_writeEntityToNBT_1.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityWolf) params.getReflective("_self")).writeEntityToNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityWolf_methods.add(reflect_EntityWolf_method_writeEntityToNBT_1);


        BaseData reflect_EntityWolf_method_readEntityFromNBT_2 = new ModData();
        reflect_EntityWolf_method_readEntityFromNBT_2.set("methodName", "readEntityFromNBT");
        reflect_EntityWolf_method_readEntityFromNBT_2.set("returnType", "void");
        reflect_EntityWolf_method_readEntityFromNBT_2.set("static", false);
        reflect_EntityWolf_method_readEntityFromNBT_2.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityWolf_method_readEntityFromNBT_2.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityWolf_method_readEntityFromNBT_2.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityWolf) params.getReflective("_self")).readEntityFromNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityWolf_methods.add(reflect_EntityWolf_method_readEntityFromNBT_2);


        BaseData reflect_EntityWolf_method_onLivingUpdate_3 = new ModData();
        reflect_EntityWolf_method_onLivingUpdate_3.set("methodName", "onLivingUpdate");
        reflect_EntityWolf_method_onLivingUpdate_3.set("returnType", "void");
        reflect_EntityWolf_method_onLivingUpdate_3.set("static", false);
        reflect_EntityWolf_method_onLivingUpdate_3.set("argnames", new String[]{});
        reflect_EntityWolf_method_onLivingUpdate_3.set("argtypes", new String[]{});
        reflect_EntityWolf_method_onLivingUpdate_3.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityWolf) params.getReflective("_self")).onLivingUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityWolf_methods.add(reflect_EntityWolf_method_onLivingUpdate_3);


        BaseData reflect_EntityWolf_method_onUpdate_4 = new ModData();
        reflect_EntityWolf_method_onUpdate_4.set("methodName", "onUpdate");
        reflect_EntityWolf_method_onUpdate_4.set("returnType", "void");
        reflect_EntityWolf_method_onUpdate_4.set("static", false);
        reflect_EntityWolf_method_onUpdate_4.set("argnames", new String[]{});
        reflect_EntityWolf_method_onUpdate_4.set("argtypes", new String[]{});
        reflect_EntityWolf_method_onUpdate_4.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityWolf) params.getReflective("_self")).onUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityWolf_methods.add(reflect_EntityWolf_method_onUpdate_4);


        BaseData reflect_EntityWolf_method_isWolfWet_5 = new ModData();
        reflect_EntityWolf_method_isWolfWet_5.set("methodName", "isWolfWet");
        reflect_EntityWolf_method_isWolfWet_5.set("returnType", "boolean");
        reflect_EntityWolf_method_isWolfWet_5.set("static", false);
        reflect_EntityWolf_method_isWolfWet_5.set("argnames", new String[]{});
        reflect_EntityWolf_method_isWolfWet_5.set("argtypes", new String[]{});
        reflect_EntityWolf_method_isWolfWet_5.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityWolf) params.getReflective("_self")).isWolfWet();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityWolf_methods.add(reflect_EntityWolf_method_isWolfWet_5);


        BaseData reflect_EntityWolf_method_getShadingWhileWet_6 = new ModData();
        reflect_EntityWolf_method_getShadingWhileWet_6.set("methodName", "getShadingWhileWet");
        reflect_EntityWolf_method_getShadingWhileWet_6.set("returnType", "float");
        reflect_EntityWolf_method_getShadingWhileWet_6.set("static", false);
        reflect_EntityWolf_method_getShadingWhileWet_6.set("argnames", new String[]{"parFloat1"});
        reflect_EntityWolf_method_getShadingWhileWet_6.set("argtypes", new String[]{"float"});
        reflect_EntityWolf_method_getShadingWhileWet_6.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityWolf) params.getReflective("_self")).getShadingWhileWet((float) params.getFloat("parFloat1"));
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityWolf_methods.add(reflect_EntityWolf_method_getShadingWhileWet_6);


        BaseData reflect_EntityWolf_method_getShakeAngle_7 = new ModData();
        reflect_EntityWolf_method_getShakeAngle_7.set("methodName", "getShakeAngle");
        reflect_EntityWolf_method_getShakeAngle_7.set("returnType", "float");
        reflect_EntityWolf_method_getShakeAngle_7.set("static", false);
        reflect_EntityWolf_method_getShakeAngle_7.set("argnames", new String[]{"parFloat1", "parFloat2"});
        reflect_EntityWolf_method_getShakeAngle_7.set("argtypes", new String[]{"float", "float"});
        reflect_EntityWolf_method_getShakeAngle_7.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityWolf) params.getReflective("_self")).getShakeAngle((float) params.getFloat("parFloat1"), (float) params.getFloat("parFloat2"));
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityWolf_methods.add(reflect_EntityWolf_method_getShakeAngle_7);


        BaseData reflect_EntityWolf_method_getInterestedAngle_8 = new ModData();
        reflect_EntityWolf_method_getInterestedAngle_8.set("methodName", "getInterestedAngle");
        reflect_EntityWolf_method_getInterestedAngle_8.set("returnType", "float");
        reflect_EntityWolf_method_getInterestedAngle_8.set("static", false);
        reflect_EntityWolf_method_getInterestedAngle_8.set("argnames", new String[]{"parFloat1"});
        reflect_EntityWolf_method_getInterestedAngle_8.set("argtypes", new String[]{"float"});
        reflect_EntityWolf_method_getInterestedAngle_8.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityWolf) params.getReflective("_self")).getInterestedAngle((float) params.getFloat("parFloat1"));
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityWolf_methods.add(reflect_EntityWolf_method_getInterestedAngle_8);


        BaseData reflect_EntityWolf_method_getEyeHeight_9 = new ModData();
        reflect_EntityWolf_method_getEyeHeight_9.set("methodName", "getEyeHeight");
        reflect_EntityWolf_method_getEyeHeight_9.set("returnType", "float");
        reflect_EntityWolf_method_getEyeHeight_9.set("static", false);
        reflect_EntityWolf_method_getEyeHeight_9.set("argnames", new String[]{});
        reflect_EntityWolf_method_getEyeHeight_9.set("argtypes", new String[]{});
        reflect_EntityWolf_method_getEyeHeight_9.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityWolf) params.getReflective("_self")).getEyeHeight();
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityWolf_methods.add(reflect_EntityWolf_method_getEyeHeight_9);


        BaseData reflect_EntityWolf_method_getVerticalFaceSpeed_10 = new ModData();
        reflect_EntityWolf_method_getVerticalFaceSpeed_10.set("methodName", "getVerticalFaceSpeed");
        reflect_EntityWolf_method_getVerticalFaceSpeed_10.set("returnType", "int");
        reflect_EntityWolf_method_getVerticalFaceSpeed_10.set("static", false);
        reflect_EntityWolf_method_getVerticalFaceSpeed_10.set("argnames", new String[]{});
        reflect_EntityWolf_method_getVerticalFaceSpeed_10.set("argtypes", new String[]{});
        reflect_EntityWolf_method_getVerticalFaceSpeed_10.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityWolf) params.getReflective("_self")).getVerticalFaceSpeed();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityWolf_methods.add(reflect_EntityWolf_method_getVerticalFaceSpeed_10);


        BaseData reflect_EntityWolf_method_attackEntityFrom_11 = new ModData();
        reflect_EntityWolf_method_attackEntityFrom_11.set("methodName", "attackEntityFrom");
        reflect_EntityWolf_method_attackEntityFrom_11.set("returnType", "boolean");
        reflect_EntityWolf_method_attackEntityFrom_11.set("static", false);
        reflect_EntityWolf_method_attackEntityFrom_11.set("argnames", new String[]{"damagesource", "f"});
        reflect_EntityWolf_method_attackEntityFrom_11.set("argtypes", new String[]{"DamageSource", "float"});
        reflect_EntityWolf_method_attackEntityFrom_11.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityWolf) params.getReflective("_self")).attackEntityFrom((DamageSource) params.getReflective("damagesource"), (float) params.getFloat("f"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityWolf_methods.add(reflect_EntityWolf_method_attackEntityFrom_11);


        BaseData reflect_EntityWolf_method_attackEntityAsMob_12 = new ModData();
        reflect_EntityWolf_method_attackEntityAsMob_12.set("methodName", "attackEntityAsMob");
        reflect_EntityWolf_method_attackEntityAsMob_12.set("returnType", "boolean");
        reflect_EntityWolf_method_attackEntityAsMob_12.set("static", false);
        reflect_EntityWolf_method_attackEntityAsMob_12.set("argnames", new String[]{"entity"});
        reflect_EntityWolf_method_attackEntityAsMob_12.set("argtypes", new String[]{"Entity"});
        reflect_EntityWolf_method_attackEntityAsMob_12.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityWolf) params.getReflective("_self")).attackEntityAsMob((Entity) params.getReflective("entity"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityWolf_methods.add(reflect_EntityWolf_method_attackEntityAsMob_12);


        BaseData reflect_EntityWolf_method_setTamed_13 = new ModData();
        reflect_EntityWolf_method_setTamed_13.set("methodName", "setTamed");
        reflect_EntityWolf_method_setTamed_13.set("returnType", "void");
        reflect_EntityWolf_method_setTamed_13.set("static", false);
        reflect_EntityWolf_method_setTamed_13.set("argnames", new String[]{"flag"});
        reflect_EntityWolf_method_setTamed_13.set("argtypes", new String[]{"boolean"});
        reflect_EntityWolf_method_setTamed_13.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityWolf) params.getReflective("_self")).setTamed((boolean) params.getBoolean("flag"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityWolf_methods.add(reflect_EntityWolf_method_setTamed_13);


        BaseData reflect_EntityWolf_method_interact_14 = new ModData();
        reflect_EntityWolf_method_interact_14.set("methodName", "interact");
        reflect_EntityWolf_method_interact_14.set("returnType", "boolean");
        reflect_EntityWolf_method_interact_14.set("static", false);
        reflect_EntityWolf_method_interact_14.set("argnames", new String[]{"entityplayer"});
        reflect_EntityWolf_method_interact_14.set("argtypes", new String[]{"EntityPlayer"});
        reflect_EntityWolf_method_interact_14.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityWolf) params.getReflective("_self")).interact((EntityPlayer) params.getReflective("entityplayer"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityWolf_methods.add(reflect_EntityWolf_method_interact_14);


        BaseData reflect_EntityWolf_method_handleStatusUpdate_15 = new ModData();
        reflect_EntityWolf_method_handleStatusUpdate_15.set("methodName", "handleStatusUpdate");
        reflect_EntityWolf_method_handleStatusUpdate_15.set("returnType", "void");
        reflect_EntityWolf_method_handleStatusUpdate_15.set("static", false);
        reflect_EntityWolf_method_handleStatusUpdate_15.set("argnames", new String[]{"b0"});
        reflect_EntityWolf_method_handleStatusUpdate_15.set("argtypes", new String[]{"byte"});
        reflect_EntityWolf_method_handleStatusUpdate_15.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityWolf) params.getReflective("_self")).handleStatusUpdate((byte) params.getByte("b0"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityWolf_methods.add(reflect_EntityWolf_method_handleStatusUpdate_15);


        BaseData reflect_EntityWolf_method_getTailRotation_16 = new ModData();
        reflect_EntityWolf_method_getTailRotation_16.set("methodName", "getTailRotation");
        reflect_EntityWolf_method_getTailRotation_16.set("returnType", "float");
        reflect_EntityWolf_method_getTailRotation_16.set("static", false);
        reflect_EntityWolf_method_getTailRotation_16.set("argnames", new String[]{});
        reflect_EntityWolf_method_getTailRotation_16.set("argtypes", new String[]{});
        reflect_EntityWolf_method_getTailRotation_16.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityWolf) params.getReflective("_self")).getTailRotation();
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityWolf_methods.add(reflect_EntityWolf_method_getTailRotation_16);


        BaseData reflect_EntityWolf_method_isBreedingItem_17 = new ModData();
        reflect_EntityWolf_method_isBreedingItem_17.set("methodName", "isBreedingItem");
        reflect_EntityWolf_method_isBreedingItem_17.set("returnType", "boolean");
        reflect_EntityWolf_method_isBreedingItem_17.set("static", false);
        reflect_EntityWolf_method_isBreedingItem_17.set("argnames", new String[]{"itemstack"});
        reflect_EntityWolf_method_isBreedingItem_17.set("argtypes", new String[]{"ItemStack"});
        reflect_EntityWolf_method_isBreedingItem_17.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityWolf) params.getReflective("_self")).isBreedingItem((ItemStack) params.getReflective("itemstack"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityWolf_methods.add(reflect_EntityWolf_method_isBreedingItem_17);


        BaseData reflect_EntityWolf_method_getMaxSpawnedInChunk_18 = new ModData();
        reflect_EntityWolf_method_getMaxSpawnedInChunk_18.set("methodName", "getMaxSpawnedInChunk");
        reflect_EntityWolf_method_getMaxSpawnedInChunk_18.set("returnType", "int");
        reflect_EntityWolf_method_getMaxSpawnedInChunk_18.set("static", false);
        reflect_EntityWolf_method_getMaxSpawnedInChunk_18.set("argnames", new String[]{});
        reflect_EntityWolf_method_getMaxSpawnedInChunk_18.set("argtypes", new String[]{});
        reflect_EntityWolf_method_getMaxSpawnedInChunk_18.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityWolf) params.getReflective("_self")).getMaxSpawnedInChunk();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityWolf_methods.add(reflect_EntityWolf_method_getMaxSpawnedInChunk_18);


        BaseData reflect_EntityWolf_method_isAngry_19 = new ModData();
        reflect_EntityWolf_method_isAngry_19.set("methodName", "isAngry");
        reflect_EntityWolf_method_isAngry_19.set("returnType", "boolean");
        reflect_EntityWolf_method_isAngry_19.set("static", false);
        reflect_EntityWolf_method_isAngry_19.set("argnames", new String[]{});
        reflect_EntityWolf_method_isAngry_19.set("argtypes", new String[]{});
        reflect_EntityWolf_method_isAngry_19.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityWolf) params.getReflective("_self")).isAngry();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityWolf_methods.add(reflect_EntityWolf_method_isAngry_19);


        BaseData reflect_EntityWolf_method_setAngry_20 = new ModData();
        reflect_EntityWolf_method_setAngry_20.set("methodName", "setAngry");
        reflect_EntityWolf_method_setAngry_20.set("returnType", "void");
        reflect_EntityWolf_method_setAngry_20.set("static", false);
        reflect_EntityWolf_method_setAngry_20.set("argnames", new String[]{"angry"});
        reflect_EntityWolf_method_setAngry_20.set("argtypes", new String[]{"boolean"});
        reflect_EntityWolf_method_setAngry_20.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityWolf) params.getReflective("_self")).setAngry((boolean) params.getBoolean("angry"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityWolf_methods.add(reflect_EntityWolf_method_setAngry_20);


        BaseData reflect_EntityWolf_method_getCollarColor_21 = new ModData();
        reflect_EntityWolf_method_getCollarColor_21.set("methodName", "getCollarColor");
        reflect_EntityWolf_method_getCollarColor_21.set("returnType", "EnumDyeColor");
        reflect_EntityWolf_method_getCollarColor_21.set("static", false);
        reflect_EntityWolf_method_getCollarColor_21.set("argnames", new String[]{});
        reflect_EntityWolf_method_getCollarColor_21.set("argtypes", new String[]{});
        reflect_EntityWolf_method_getCollarColor_21.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EnumDyeColor) ((EntityWolf) params.getReflective("_self")).getCollarColor();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityWolf_methods.add(reflect_EntityWolf_method_getCollarColor_21);


        BaseData reflect_EntityWolf_method_setCollarColor_22 = new ModData();
        reflect_EntityWolf_method_setCollarColor_22.set("methodName", "setCollarColor");
        reflect_EntityWolf_method_setCollarColor_22.set("returnType", "void");
        reflect_EntityWolf_method_setCollarColor_22.set("static", false);
        reflect_EntityWolf_method_setCollarColor_22.set("argnames", new String[]{"collarcolor"});
        reflect_EntityWolf_method_setCollarColor_22.set("argtypes", new String[]{"EnumDyeColor"});
        reflect_EntityWolf_method_setCollarColor_22.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityWolf) params.getReflective("_self")).setCollarColor((EnumDyeColor) params.getReflective("collarcolor"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityWolf_methods.add(reflect_EntityWolf_method_setCollarColor_22);


        BaseData reflect_EntityWolf_method_createChild_23 = new ModData();
        reflect_EntityWolf_method_createChild_23.set("methodName", "createChild");
        reflect_EntityWolf_method_createChild_23.set("returnType", "EntityWolf");
        reflect_EntityWolf_method_createChild_23.set("static", false);
        reflect_EntityWolf_method_createChild_23.set("argnames", new String[]{"var1"});
        reflect_EntityWolf_method_createChild_23.set("argtypes", new String[]{"EntityAgeable"});
        reflect_EntityWolf_method_createChild_23.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EntityWolf) ((EntityWolf) params.getReflective("_self")).createChild((EntityAgeable) params.getReflective("var1"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityWolf_methods.add(reflect_EntityWolf_method_createChild_23);


        BaseData reflect_EntityWolf_method_setBegging_24 = new ModData();
        reflect_EntityWolf_method_setBegging_24.set("methodName", "setBegging");
        reflect_EntityWolf_method_setBegging_24.set("returnType", "void");
        reflect_EntityWolf_method_setBegging_24.set("static", false);
        reflect_EntityWolf_method_setBegging_24.set("argnames", new String[]{"beg"});
        reflect_EntityWolf_method_setBegging_24.set("argtypes", new String[]{"boolean"});
        reflect_EntityWolf_method_setBegging_24.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityWolf) params.getReflective("_self")).setBegging((boolean) params.getBoolean("beg"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityWolf_methods.add(reflect_EntityWolf_method_setBegging_24);


        BaseData reflect_EntityWolf_method_canMateWith_25 = new ModData();
        reflect_EntityWolf_method_canMateWith_25.set("methodName", "canMateWith");
        reflect_EntityWolf_method_canMateWith_25.set("returnType", "boolean");
        reflect_EntityWolf_method_canMateWith_25.set("static", false);
        reflect_EntityWolf_method_canMateWith_25.set("argnames", new String[]{"entityanimal"});
        reflect_EntityWolf_method_canMateWith_25.set("argtypes", new String[]{"EntityAnimal"});
        reflect_EntityWolf_method_canMateWith_25.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityWolf) params.getReflective("_self")).canMateWith((EntityAnimal) params.getReflective("entityanimal"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityWolf_methods.add(reflect_EntityWolf_method_canMateWith_25);


        BaseData reflect_EntityWolf_method_isBegging_26 = new ModData();
        reflect_EntityWolf_method_isBegging_26.set("methodName", "isBegging");
        reflect_EntityWolf_method_isBegging_26.set("returnType", "boolean");
        reflect_EntityWolf_method_isBegging_26.set("static", false);
        reflect_EntityWolf_method_isBegging_26.set("argnames", new String[]{});
        reflect_EntityWolf_method_isBegging_26.set("argtypes", new String[]{});
        reflect_EntityWolf_method_isBegging_26.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityWolf) params.getReflective("_self")).isBegging();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityWolf_methods.add(reflect_EntityWolf_method_isBegging_26);


        BaseData reflect_EntityWolf_method_shouldAttackEntity_27 = new ModData();
        reflect_EntityWolf_method_shouldAttackEntity_27.set("methodName", "shouldAttackEntity");
        reflect_EntityWolf_method_shouldAttackEntity_27.set("returnType", "boolean");
        reflect_EntityWolf_method_shouldAttackEntity_27.set("static", false);
        reflect_EntityWolf_method_shouldAttackEntity_27.set("argnames", new String[]{"entitylivingbase", "entitylivingbase1"});
        reflect_EntityWolf_method_shouldAttackEntity_27.set("argtypes", new String[]{"EntityLivingBase", "EntityLivingBase"});
        reflect_EntityWolf_method_shouldAttackEntity_27.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityWolf) params.getReflective("_self")).shouldAttackEntity((EntityLivingBase) params.getReflective("entitylivingbase"), (EntityLivingBase) params.getReflective("entitylivingbase1"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityWolf_methods.add(reflect_EntityWolf_method_shouldAttackEntity_27);


        BaseData reflect_EntityWolf_method_allowLeashing_28 = new ModData();
        reflect_EntityWolf_method_allowLeashing_28.set("methodName", "allowLeashing");
        reflect_EntityWolf_method_allowLeashing_28.set("returnType", "boolean");
        reflect_EntityWolf_method_allowLeashing_28.set("static", false);
        reflect_EntityWolf_method_allowLeashing_28.set("argnames", new String[]{});
        reflect_EntityWolf_method_allowLeashing_28.set("argtypes", new String[]{});
        reflect_EntityWolf_method_allowLeashing_28.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityWolf) params.getReflective("_self")).allowLeashing();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityWolf_methods.add(reflect_EntityWolf_method_allowLeashing_28);


        BaseData[] reflect_EntityWolf_methods_arr = new BaseData[reflect_EntityWolf_methods.size()];
        for (int i = 0; i < reflect_EntityWolf_methods_arr.length; i++) {
            reflect_EntityWolf_methods_arr[i] = reflect_EntityWolf_methods.get(i);
        }

        reflect_EntityWolf.set("constructors", reflect_EntityWolf_constructors_arr);
        reflect_EntityWolf.set("methods", reflect_EntityWolf_methods_arr);
        reflect_EntityWolf.set("className", "EntityWolf");
        reflect_EntityWolf.set("classId", "net.minecraft.entity.passive.EntityWolf");
        reflect_EntityWolf.set("class", EntityWolf.class);
        reflect_EntityWolf.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityWolf;
        });
        reflectProfiles.add(reflect_EntityWolf);
    }


    //classdef for EntityBlaze
    public static void reflect_EntityBlaze_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityBlaze = new ModData();

        ArrayList<BaseData> reflect_EntityBlaze_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_EntityBlaze_constructor_EntityBlaze_0 = new ModData();
        reflect_EntityBlaze_constructor_EntityBlaze_0.set("returnType", "EntityBlaze");
        reflect_EntityBlaze_constructor_EntityBlaze_0.set("argnames", new String[]{"worldIn"});
        reflect_EntityBlaze_constructor_EntityBlaze_0.set("argtypes", new String[]{"World"});
        reflect_EntityBlaze_constructor_EntityBlaze_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityBlaze((World) params.getReflective("worldIn"));
        });
        
        reflect_EntityBlaze_constructors.add(reflect_EntityBlaze_constructor_EntityBlaze_0);


        BaseData[] reflect_EntityBlaze_constructors_arr = new BaseData[reflect_EntityBlaze_constructors.size()];
        for (int i = 0; i < reflect_EntityBlaze_constructors_arr.length; i++) {
            reflect_EntityBlaze_constructors_arr[i] = reflect_EntityBlaze_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityBlaze_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityBlaze_method_getBrightnessForRender_0 = new ModData();
        reflect_EntityBlaze_method_getBrightnessForRender_0.set("methodName", "getBrightnessForRender");
        reflect_EntityBlaze_method_getBrightnessForRender_0.set("returnType", "int");
        reflect_EntityBlaze_method_getBrightnessForRender_0.set("static", false);
        reflect_EntityBlaze_method_getBrightnessForRender_0.set("argnames", new String[]{"var1"});
        reflect_EntityBlaze_method_getBrightnessForRender_0.set("argtypes", new String[]{"float"});
        reflect_EntityBlaze_method_getBrightnessForRender_0.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityBlaze) params.getReflective("_self")).getBrightnessForRender((float) params.getFloat("var1"));
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityBlaze_methods.add(reflect_EntityBlaze_method_getBrightnessForRender_0);


        BaseData reflect_EntityBlaze_method_getBrightness_1 = new ModData();
        reflect_EntityBlaze_method_getBrightness_1.set("methodName", "getBrightness");
        reflect_EntityBlaze_method_getBrightness_1.set("returnType", "float");
        reflect_EntityBlaze_method_getBrightness_1.set("static", false);
        reflect_EntityBlaze_method_getBrightness_1.set("argnames", new String[]{"var1"});
        reflect_EntityBlaze_method_getBrightness_1.set("argtypes", new String[]{"float"});
        reflect_EntityBlaze_method_getBrightness_1.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityBlaze) params.getReflective("_self")).getBrightness((float) params.getFloat("var1"));
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityBlaze_methods.add(reflect_EntityBlaze_method_getBrightness_1);


        BaseData reflect_EntityBlaze_method_onLivingUpdate_2 = new ModData();
        reflect_EntityBlaze_method_onLivingUpdate_2.set("methodName", "onLivingUpdate");
        reflect_EntityBlaze_method_onLivingUpdate_2.set("returnType", "void");
        reflect_EntityBlaze_method_onLivingUpdate_2.set("static", false);
        reflect_EntityBlaze_method_onLivingUpdate_2.set("argnames", new String[]{});
        reflect_EntityBlaze_method_onLivingUpdate_2.set("argtypes", new String[]{});
        reflect_EntityBlaze_method_onLivingUpdate_2.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityBlaze) params.getReflective("_self")).onLivingUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityBlaze_methods.add(reflect_EntityBlaze_method_onLivingUpdate_2);


        BaseData reflect_EntityBlaze_method_fall_3 = new ModData();
        reflect_EntityBlaze_method_fall_3.set("methodName", "fall");
        reflect_EntityBlaze_method_fall_3.set("returnType", "void");
        reflect_EntityBlaze_method_fall_3.set("static", false);
        reflect_EntityBlaze_method_fall_3.set("argnames", new String[]{"var1", "var2"});
        reflect_EntityBlaze_method_fall_3.set("argtypes", new String[]{"float", "float"});
        reflect_EntityBlaze_method_fall_3.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityBlaze) params.getReflective("_self")).fall((float) params.getFloat("var1"), (float) params.getFloat("var2"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityBlaze_methods.add(reflect_EntityBlaze_method_fall_3);


        BaseData reflect_EntityBlaze_method_isBurning_4 = new ModData();
        reflect_EntityBlaze_method_isBurning_4.set("methodName", "isBurning");
        reflect_EntityBlaze_method_isBurning_4.set("returnType", "boolean");
        reflect_EntityBlaze_method_isBurning_4.set("static", false);
        reflect_EntityBlaze_method_isBurning_4.set("argnames", new String[]{});
        reflect_EntityBlaze_method_isBurning_4.set("argtypes", new String[]{});
        reflect_EntityBlaze_method_isBurning_4.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityBlaze) params.getReflective("_self")).isBurning();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityBlaze_methods.add(reflect_EntityBlaze_method_isBurning_4);


        BaseData reflect_EntityBlaze_method_func_70845_n_5 = new ModData();
        reflect_EntityBlaze_method_func_70845_n_5.set("methodName", "func_70845_n");
        reflect_EntityBlaze_method_func_70845_n_5.set("returnType", "boolean");
        reflect_EntityBlaze_method_func_70845_n_5.set("static", false);
        reflect_EntityBlaze_method_func_70845_n_5.set("argnames", new String[]{});
        reflect_EntityBlaze_method_func_70845_n_5.set("argtypes", new String[]{});
        reflect_EntityBlaze_method_func_70845_n_5.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityBlaze) params.getReflective("_self")).func_70845_n();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityBlaze_methods.add(reflect_EntityBlaze_method_func_70845_n_5);


        BaseData reflect_EntityBlaze_method_setOnFire_6 = new ModData();
        reflect_EntityBlaze_method_setOnFire_6.set("methodName", "setOnFire");
        reflect_EntityBlaze_method_setOnFire_6.set("returnType", "void");
        reflect_EntityBlaze_method_setOnFire_6.set("static", false);
        reflect_EntityBlaze_method_setOnFire_6.set("argnames", new String[]{"onFire"});
        reflect_EntityBlaze_method_setOnFire_6.set("argtypes", new String[]{"boolean"});
        reflect_EntityBlaze_method_setOnFire_6.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityBlaze) params.getReflective("_self")).setOnFire((boolean) params.getBoolean("onFire"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityBlaze_methods.add(reflect_EntityBlaze_method_setOnFire_6);


        BaseData[] reflect_EntityBlaze_methods_arr = new BaseData[reflect_EntityBlaze_methods.size()];
        for (int i = 0; i < reflect_EntityBlaze_methods_arr.length; i++) {
            reflect_EntityBlaze_methods_arr[i] = reflect_EntityBlaze_methods.get(i);
        }

        reflect_EntityBlaze.set("constructors", reflect_EntityBlaze_constructors_arr);
        reflect_EntityBlaze.set("methods", reflect_EntityBlaze_methods_arr);
        reflect_EntityBlaze.set("className", "EntityBlaze");
        reflect_EntityBlaze.set("classId", "net.minecraft.entity.monster.EntityBlaze");
        reflect_EntityBlaze.set("class", EntityBlaze.class);
        reflect_EntityBlaze.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityBlaze;
        });
        reflectProfiles.add(reflect_EntityBlaze);
    }


    //classdef for EntityCaveSpider
    public static void reflect_EntityCaveSpider_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityCaveSpider = new ModData();

        ArrayList<BaseData> reflect_EntityCaveSpider_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_EntityCaveSpider_constructor_EntityCaveSpider_0 = new ModData();
        reflect_EntityCaveSpider_constructor_EntityCaveSpider_0.set("returnType", "EntityCaveSpider");
        reflect_EntityCaveSpider_constructor_EntityCaveSpider_0.set("argnames", new String[]{"worldIn"});
        reflect_EntityCaveSpider_constructor_EntityCaveSpider_0.set("argtypes", new String[]{"World"});
        reflect_EntityCaveSpider_constructor_EntityCaveSpider_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityCaveSpider((World) params.getReflective("worldIn"));
        });
        
        reflect_EntityCaveSpider_constructors.add(reflect_EntityCaveSpider_constructor_EntityCaveSpider_0);


        BaseData[] reflect_EntityCaveSpider_constructors_arr = new BaseData[reflect_EntityCaveSpider_constructors.size()];
        for (int i = 0; i < reflect_EntityCaveSpider_constructors_arr.length; i++) {
            reflect_EntityCaveSpider_constructors_arr[i] = reflect_EntityCaveSpider_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityCaveSpider_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityCaveSpider_method_attackEntityAsMob_0 = new ModData();
        reflect_EntityCaveSpider_method_attackEntityAsMob_0.set("methodName", "attackEntityAsMob");
        reflect_EntityCaveSpider_method_attackEntityAsMob_0.set("returnType", "boolean");
        reflect_EntityCaveSpider_method_attackEntityAsMob_0.set("static", false);
        reflect_EntityCaveSpider_method_attackEntityAsMob_0.set("argnames", new String[]{"entity"});
        reflect_EntityCaveSpider_method_attackEntityAsMob_0.set("argtypes", new String[]{"Entity"});
        reflect_EntityCaveSpider_method_attackEntityAsMob_0.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityCaveSpider) params.getReflective("_self")).attackEntityAsMob((Entity) params.getReflective("entity"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityCaveSpider_methods.add(reflect_EntityCaveSpider_method_attackEntityAsMob_0);


        BaseData reflect_EntityCaveSpider_method_onInitialSpawn_1 = new ModData();
        reflect_EntityCaveSpider_method_onInitialSpawn_1.set("methodName", "onInitialSpawn");
        reflect_EntityCaveSpider_method_onInitialSpawn_1.set("returnType", "IEntityLivingData");
        reflect_EntityCaveSpider_method_onInitialSpawn_1.set("static", false);
        reflect_EntityCaveSpider_method_onInitialSpawn_1.set("argnames", new String[]{"var1", "ientitylivingdata"});
        reflect_EntityCaveSpider_method_onInitialSpawn_1.set("argtypes", new String[]{"DifficultyInstance", "IEntityLivingData"});
        reflect_EntityCaveSpider_method_onInitialSpawn_1.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (IEntityLivingData) ((EntityCaveSpider) params.getReflective("_self")).onInitialSpawn((DifficultyInstance) params.getReflective("var1"), (IEntityLivingData) params.getReflective("ientitylivingdata"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityCaveSpider_methods.add(reflect_EntityCaveSpider_method_onInitialSpawn_1);


        BaseData reflect_EntityCaveSpider_method_getEyeHeight_2 = new ModData();
        reflect_EntityCaveSpider_method_getEyeHeight_2.set("methodName", "getEyeHeight");
        reflect_EntityCaveSpider_method_getEyeHeight_2.set("returnType", "float");
        reflect_EntityCaveSpider_method_getEyeHeight_2.set("static", false);
        reflect_EntityCaveSpider_method_getEyeHeight_2.set("argnames", new String[]{});
        reflect_EntityCaveSpider_method_getEyeHeight_2.set("argtypes", new String[]{});
        reflect_EntityCaveSpider_method_getEyeHeight_2.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityCaveSpider) params.getReflective("_self")).getEyeHeight();
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityCaveSpider_methods.add(reflect_EntityCaveSpider_method_getEyeHeight_2);


        BaseData[] reflect_EntityCaveSpider_methods_arr = new BaseData[reflect_EntityCaveSpider_methods.size()];
        for (int i = 0; i < reflect_EntityCaveSpider_methods_arr.length; i++) {
            reflect_EntityCaveSpider_methods_arr[i] = reflect_EntityCaveSpider_methods.get(i);
        }

        reflect_EntityCaveSpider.set("constructors", reflect_EntityCaveSpider_constructors_arr);
        reflect_EntityCaveSpider.set("methods", reflect_EntityCaveSpider_methods_arr);
        reflect_EntityCaveSpider.set("className", "EntityCaveSpider");
        reflect_EntityCaveSpider.set("classId", "net.minecraft.entity.monster.EntityCaveSpider");
        reflect_EntityCaveSpider.set("class", EntityCaveSpider.class);
        reflect_EntityCaveSpider.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityCaveSpider;
        });
        reflectProfiles.add(reflect_EntityCaveSpider);
    }


    //classdef for EntityCreeper
    public static void reflect_EntityCreeper_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityCreeper = new ModData();

        ArrayList<BaseData> reflect_EntityCreeper_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_EntityCreeper_constructor_EntityCreeper_0 = new ModData();
        reflect_EntityCreeper_constructor_EntityCreeper_0.set("returnType", "EntityCreeper");
        reflect_EntityCreeper_constructor_EntityCreeper_0.set("argnames", new String[]{"worldIn"});
        reflect_EntityCreeper_constructor_EntityCreeper_0.set("argtypes", new String[]{"World"});
        reflect_EntityCreeper_constructor_EntityCreeper_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityCreeper((World) params.getReflective("worldIn"));
        });
        
        reflect_EntityCreeper_constructors.add(reflect_EntityCreeper_constructor_EntityCreeper_0);


        BaseData[] reflect_EntityCreeper_constructors_arr = new BaseData[reflect_EntityCreeper_constructors.size()];
        for (int i = 0; i < reflect_EntityCreeper_constructors_arr.length; i++) {
            reflect_EntityCreeper_constructors_arr[i] = reflect_EntityCreeper_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityCreeper_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityCreeper_method_getMaxFallHeight_0 = new ModData();
        reflect_EntityCreeper_method_getMaxFallHeight_0.set("methodName", "getMaxFallHeight");
        reflect_EntityCreeper_method_getMaxFallHeight_0.set("returnType", "int");
        reflect_EntityCreeper_method_getMaxFallHeight_0.set("static", false);
        reflect_EntityCreeper_method_getMaxFallHeight_0.set("argnames", new String[]{});
        reflect_EntityCreeper_method_getMaxFallHeight_0.set("argtypes", new String[]{});
        reflect_EntityCreeper_method_getMaxFallHeight_0.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityCreeper) params.getReflective("_self")).getMaxFallHeight();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityCreeper_methods.add(reflect_EntityCreeper_method_getMaxFallHeight_0);


        BaseData reflect_EntityCreeper_method_fall_1 = new ModData();
        reflect_EntityCreeper_method_fall_1.set("methodName", "fall");
        reflect_EntityCreeper_method_fall_1.set("returnType", "void");
        reflect_EntityCreeper_method_fall_1.set("static", false);
        reflect_EntityCreeper_method_fall_1.set("argnames", new String[]{"f", "f1"});
        reflect_EntityCreeper_method_fall_1.set("argtypes", new String[]{"float", "float"});
        reflect_EntityCreeper_method_fall_1.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityCreeper) params.getReflective("_self")).fall((float) params.getFloat("f"), (float) params.getFloat("f1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityCreeper_methods.add(reflect_EntityCreeper_method_fall_1);


        BaseData reflect_EntityCreeper_method_writeEntityToNBT_2 = new ModData();
        reflect_EntityCreeper_method_writeEntityToNBT_2.set("methodName", "writeEntityToNBT");
        reflect_EntityCreeper_method_writeEntityToNBT_2.set("returnType", "void");
        reflect_EntityCreeper_method_writeEntityToNBT_2.set("static", false);
        reflect_EntityCreeper_method_writeEntityToNBT_2.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityCreeper_method_writeEntityToNBT_2.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityCreeper_method_writeEntityToNBT_2.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityCreeper) params.getReflective("_self")).writeEntityToNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityCreeper_methods.add(reflect_EntityCreeper_method_writeEntityToNBT_2);


        BaseData reflect_EntityCreeper_method_readEntityFromNBT_3 = new ModData();
        reflect_EntityCreeper_method_readEntityFromNBT_3.set("methodName", "readEntityFromNBT");
        reflect_EntityCreeper_method_readEntityFromNBT_3.set("returnType", "void");
        reflect_EntityCreeper_method_readEntityFromNBT_3.set("static", false);
        reflect_EntityCreeper_method_readEntityFromNBT_3.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityCreeper_method_readEntityFromNBT_3.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityCreeper_method_readEntityFromNBT_3.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityCreeper) params.getReflective("_self")).readEntityFromNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityCreeper_methods.add(reflect_EntityCreeper_method_readEntityFromNBT_3);


        BaseData reflect_EntityCreeper_method_onUpdate_4 = new ModData();
        reflect_EntityCreeper_method_onUpdate_4.set("methodName", "onUpdate");
        reflect_EntityCreeper_method_onUpdate_4.set("returnType", "void");
        reflect_EntityCreeper_method_onUpdate_4.set("static", false);
        reflect_EntityCreeper_method_onUpdate_4.set("argnames", new String[]{});
        reflect_EntityCreeper_method_onUpdate_4.set("argtypes", new String[]{});
        reflect_EntityCreeper_method_onUpdate_4.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityCreeper) params.getReflective("_self")).onUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityCreeper_methods.add(reflect_EntityCreeper_method_onUpdate_4);


        BaseData reflect_EntityCreeper_method_onDeath_5 = new ModData();
        reflect_EntityCreeper_method_onDeath_5.set("methodName", "onDeath");
        reflect_EntityCreeper_method_onDeath_5.set("returnType", "void");
        reflect_EntityCreeper_method_onDeath_5.set("static", false);
        reflect_EntityCreeper_method_onDeath_5.set("argnames", new String[]{"damagesource"});
        reflect_EntityCreeper_method_onDeath_5.set("argtypes", new String[]{"DamageSource"});
        reflect_EntityCreeper_method_onDeath_5.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityCreeper) params.getReflective("_self")).onDeath((DamageSource) params.getReflective("damagesource"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityCreeper_methods.add(reflect_EntityCreeper_method_onDeath_5);


        BaseData reflect_EntityCreeper_method_attackEntityAsMob_6 = new ModData();
        reflect_EntityCreeper_method_attackEntityAsMob_6.set("methodName", "attackEntityAsMob");
        reflect_EntityCreeper_method_attackEntityAsMob_6.set("returnType", "boolean");
        reflect_EntityCreeper_method_attackEntityAsMob_6.set("static", false);
        reflect_EntityCreeper_method_attackEntityAsMob_6.set("argnames", new String[]{"var1"});
        reflect_EntityCreeper_method_attackEntityAsMob_6.set("argtypes", new String[]{"Entity"});
        reflect_EntityCreeper_method_attackEntityAsMob_6.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityCreeper) params.getReflective("_self")).attackEntityAsMob((Entity) params.getReflective("var1"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityCreeper_methods.add(reflect_EntityCreeper_method_attackEntityAsMob_6);


        BaseData reflect_EntityCreeper_method_getPowered_7 = new ModData();
        reflect_EntityCreeper_method_getPowered_7.set("methodName", "getPowered");
        reflect_EntityCreeper_method_getPowered_7.set("returnType", "boolean");
        reflect_EntityCreeper_method_getPowered_7.set("static", false);
        reflect_EntityCreeper_method_getPowered_7.set("argnames", new String[]{});
        reflect_EntityCreeper_method_getPowered_7.set("argtypes", new String[]{});
        reflect_EntityCreeper_method_getPowered_7.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityCreeper) params.getReflective("_self")).getPowered();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityCreeper_methods.add(reflect_EntityCreeper_method_getPowered_7);


        BaseData reflect_EntityCreeper_method_getCreeperFlashIntensity_8 = new ModData();
        reflect_EntityCreeper_method_getCreeperFlashIntensity_8.set("methodName", "getCreeperFlashIntensity");
        reflect_EntityCreeper_method_getCreeperFlashIntensity_8.set("returnType", "float");
        reflect_EntityCreeper_method_getCreeperFlashIntensity_8.set("static", false);
        reflect_EntityCreeper_method_getCreeperFlashIntensity_8.set("argnames", new String[]{"parFloat1"});
        reflect_EntityCreeper_method_getCreeperFlashIntensity_8.set("argtypes", new String[]{"float"});
        reflect_EntityCreeper_method_getCreeperFlashIntensity_8.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityCreeper) params.getReflective("_self")).getCreeperFlashIntensity((float) params.getFloat("parFloat1"));
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityCreeper_methods.add(reflect_EntityCreeper_method_getCreeperFlashIntensity_8);


        BaseData reflect_EntityCreeper_method_getCreeperState_9 = new ModData();
        reflect_EntityCreeper_method_getCreeperState_9.set("methodName", "getCreeperState");
        reflect_EntityCreeper_method_getCreeperState_9.set("returnType", "int");
        reflect_EntityCreeper_method_getCreeperState_9.set("static", false);
        reflect_EntityCreeper_method_getCreeperState_9.set("argnames", new String[]{});
        reflect_EntityCreeper_method_getCreeperState_9.set("argtypes", new String[]{});
        reflect_EntityCreeper_method_getCreeperState_9.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityCreeper) params.getReflective("_self")).getCreeperState();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityCreeper_methods.add(reflect_EntityCreeper_method_getCreeperState_9);


        BaseData reflect_EntityCreeper_method_setCreeperState_10 = new ModData();
        reflect_EntityCreeper_method_setCreeperState_10.set("methodName", "setCreeperState");
        reflect_EntityCreeper_method_setCreeperState_10.set("returnType", "void");
        reflect_EntityCreeper_method_setCreeperState_10.set("static", false);
        reflect_EntityCreeper_method_setCreeperState_10.set("argnames", new String[]{"state"});
        reflect_EntityCreeper_method_setCreeperState_10.set("argtypes", new String[]{"int"});
        reflect_EntityCreeper_method_setCreeperState_10.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityCreeper) params.getReflective("_self")).setCreeperState((int) params.getInt("state"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityCreeper_methods.add(reflect_EntityCreeper_method_setCreeperState_10);


        BaseData reflect_EntityCreeper_method_onStruckByLightning_11 = new ModData();
        reflect_EntityCreeper_method_onStruckByLightning_11.set("methodName", "onStruckByLightning");
        reflect_EntityCreeper_method_onStruckByLightning_11.set("returnType", "void");
        reflect_EntityCreeper_method_onStruckByLightning_11.set("static", false);
        reflect_EntityCreeper_method_onStruckByLightning_11.set("argnames", new String[]{"entitylightningbolt"});
        reflect_EntityCreeper_method_onStruckByLightning_11.set("argtypes", new String[]{"EntityLightningBolt"});
        reflect_EntityCreeper_method_onStruckByLightning_11.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityCreeper) params.getReflective("_self")).onStruckByLightning((EntityLightningBolt) params.getReflective("entitylightningbolt"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityCreeper_methods.add(reflect_EntityCreeper_method_onStruckByLightning_11);


        BaseData reflect_EntityCreeper_method_hasIgnited_12 = new ModData();
        reflect_EntityCreeper_method_hasIgnited_12.set("methodName", "hasIgnited");
        reflect_EntityCreeper_method_hasIgnited_12.set("returnType", "boolean");
        reflect_EntityCreeper_method_hasIgnited_12.set("static", false);
        reflect_EntityCreeper_method_hasIgnited_12.set("argnames", new String[]{});
        reflect_EntityCreeper_method_hasIgnited_12.set("argtypes", new String[]{});
        reflect_EntityCreeper_method_hasIgnited_12.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityCreeper) params.getReflective("_self")).hasIgnited();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityCreeper_methods.add(reflect_EntityCreeper_method_hasIgnited_12);


        BaseData reflect_EntityCreeper_method_ignite_13 = new ModData();
        reflect_EntityCreeper_method_ignite_13.set("methodName", "ignite");
        reflect_EntityCreeper_method_ignite_13.set("returnType", "void");
        reflect_EntityCreeper_method_ignite_13.set("static", false);
        reflect_EntityCreeper_method_ignite_13.set("argnames", new String[]{});
        reflect_EntityCreeper_method_ignite_13.set("argtypes", new String[]{});
        reflect_EntityCreeper_method_ignite_13.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityCreeper) params.getReflective("_self")).ignite();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityCreeper_methods.add(reflect_EntityCreeper_method_ignite_13);


        BaseData reflect_EntityCreeper_method_isAIEnabled_14 = new ModData();
        reflect_EntityCreeper_method_isAIEnabled_14.set("methodName", "isAIEnabled");
        reflect_EntityCreeper_method_isAIEnabled_14.set("returnType", "boolean");
        reflect_EntityCreeper_method_isAIEnabled_14.set("static", false);
        reflect_EntityCreeper_method_isAIEnabled_14.set("argnames", new String[]{});
        reflect_EntityCreeper_method_isAIEnabled_14.set("argtypes", new String[]{});
        reflect_EntityCreeper_method_isAIEnabled_14.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityCreeper) params.getReflective("_self")).isAIEnabled();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityCreeper_methods.add(reflect_EntityCreeper_method_isAIEnabled_14);


        BaseData reflect_EntityCreeper_method_func_175493_co_15 = new ModData();
        reflect_EntityCreeper_method_func_175493_co_15.set("methodName", "func_175493_co");
        reflect_EntityCreeper_method_func_175493_co_15.set("returnType", "void");
        reflect_EntityCreeper_method_func_175493_co_15.set("static", false);
        reflect_EntityCreeper_method_func_175493_co_15.set("argnames", new String[]{});
        reflect_EntityCreeper_method_func_175493_co_15.set("argtypes", new String[]{});
        reflect_EntityCreeper_method_func_175493_co_15.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityCreeper) params.getReflective("_self")).func_175493_co();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityCreeper_methods.add(reflect_EntityCreeper_method_func_175493_co_15);


        BaseData[] reflect_EntityCreeper_methods_arr = new BaseData[reflect_EntityCreeper_methods.size()];
        for (int i = 0; i < reflect_EntityCreeper_methods_arr.length; i++) {
            reflect_EntityCreeper_methods_arr[i] = reflect_EntityCreeper_methods.get(i);
        }

        reflect_EntityCreeper.set("constructors", reflect_EntityCreeper_constructors_arr);
        reflect_EntityCreeper.set("methods", reflect_EntityCreeper_methods_arr);
        reflect_EntityCreeper.set("className", "EntityCreeper");
        reflect_EntityCreeper.set("classId", "net.minecraft.entity.monster.EntityCreeper");
        reflect_EntityCreeper.set("class", EntityCreeper.class);
        reflect_EntityCreeper.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityCreeper;
        });
        reflectProfiles.add(reflect_EntityCreeper);
    }


    //classdef for EntityEnderman
    public static void reflect_EntityEnderman_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityEnderman = new ModData();

        ArrayList<BaseData> reflect_EntityEnderman_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_EntityEnderman_constructor_EntityEnderman_0 = new ModData();
        reflect_EntityEnderman_constructor_EntityEnderman_0.set("returnType", "EntityEnderman");
        reflect_EntityEnderman_constructor_EntityEnderman_0.set("argnames", new String[]{"worldIn"});
        reflect_EntityEnderman_constructor_EntityEnderman_0.set("argtypes", new String[]{"World"});
        reflect_EntityEnderman_constructor_EntityEnderman_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityEnderman((World) params.getReflective("worldIn"));
        });
        
        reflect_EntityEnderman_constructors.add(reflect_EntityEnderman_constructor_EntityEnderman_0);


        BaseData[] reflect_EntityEnderman_constructors_arr = new BaseData[reflect_EntityEnderman_constructors.size()];
        for (int i = 0; i < reflect_EntityEnderman_constructors_arr.length; i++) {
            reflect_EntityEnderman_constructors_arr[i] = reflect_EntityEnderman_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityEnderman_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityEnderman_method_writeEntityToNBT_0 = new ModData();
        reflect_EntityEnderman_method_writeEntityToNBT_0.set("methodName", "writeEntityToNBT");
        reflect_EntityEnderman_method_writeEntityToNBT_0.set("returnType", "void");
        reflect_EntityEnderman_method_writeEntityToNBT_0.set("static", false);
        reflect_EntityEnderman_method_writeEntityToNBT_0.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityEnderman_method_writeEntityToNBT_0.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityEnderman_method_writeEntityToNBT_0.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityEnderman) params.getReflective("_self")).writeEntityToNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityEnderman_methods.add(reflect_EntityEnderman_method_writeEntityToNBT_0);


        BaseData reflect_EntityEnderman_method_readEntityFromNBT_1 = new ModData();
        reflect_EntityEnderman_method_readEntityFromNBT_1.set("methodName", "readEntityFromNBT");
        reflect_EntityEnderman_method_readEntityFromNBT_1.set("returnType", "void");
        reflect_EntityEnderman_method_readEntityFromNBT_1.set("static", false);
        reflect_EntityEnderman_method_readEntityFromNBT_1.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityEnderman_method_readEntityFromNBT_1.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityEnderman_method_readEntityFromNBT_1.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityEnderman) params.getReflective("_self")).readEntityFromNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityEnderman_methods.add(reflect_EntityEnderman_method_readEntityFromNBT_1);


        BaseData reflect_EntityEnderman_method_getEyeHeight_2 = new ModData();
        reflect_EntityEnderman_method_getEyeHeight_2.set("methodName", "getEyeHeight");
        reflect_EntityEnderman_method_getEyeHeight_2.set("returnType", "float");
        reflect_EntityEnderman_method_getEyeHeight_2.set("static", false);
        reflect_EntityEnderman_method_getEyeHeight_2.set("argnames", new String[]{});
        reflect_EntityEnderman_method_getEyeHeight_2.set("argtypes", new String[]{});
        reflect_EntityEnderman_method_getEyeHeight_2.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityEnderman) params.getReflective("_self")).getEyeHeight();
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityEnderman_methods.add(reflect_EntityEnderman_method_getEyeHeight_2);


        BaseData reflect_EntityEnderman_method_onLivingUpdate_3 = new ModData();
        reflect_EntityEnderman_method_onLivingUpdate_3.set("methodName", "onLivingUpdate");
        reflect_EntityEnderman_method_onLivingUpdate_3.set("returnType", "void");
        reflect_EntityEnderman_method_onLivingUpdate_3.set("static", false);
        reflect_EntityEnderman_method_onLivingUpdate_3.set("argnames", new String[]{});
        reflect_EntityEnderman_method_onLivingUpdate_3.set("argtypes", new String[]{});
        reflect_EntityEnderman_method_onLivingUpdate_3.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityEnderman) params.getReflective("_self")).onLivingUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityEnderman_methods.add(reflect_EntityEnderman_method_onLivingUpdate_3);


        BaseData reflect_EntityEnderman_method_setHeldBlockState_4 = new ModData();
        reflect_EntityEnderman_method_setHeldBlockState_4.set("methodName", "setHeldBlockState");
        reflect_EntityEnderman_method_setHeldBlockState_4.set("returnType", "void");
        reflect_EntityEnderman_method_setHeldBlockState_4.set("static", false);
        reflect_EntityEnderman_method_setHeldBlockState_4.set("argnames", new String[]{"state"});
        reflect_EntityEnderman_method_setHeldBlockState_4.set("argtypes", new String[]{"IBlockState"});
        reflect_EntityEnderman_method_setHeldBlockState_4.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityEnderman) params.getReflective("_self")).setHeldBlockState((IBlockState) params.getReflective("state"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityEnderman_methods.add(reflect_EntityEnderman_method_setHeldBlockState_4);


        BaseData reflect_EntityEnderman_method_getHeldBlockState_5 = new ModData();
        reflect_EntityEnderman_method_getHeldBlockState_5.set("methodName", "getHeldBlockState");
        reflect_EntityEnderman_method_getHeldBlockState_5.set("returnType", "IBlockState");
        reflect_EntityEnderman_method_getHeldBlockState_5.set("static", false);
        reflect_EntityEnderman_method_getHeldBlockState_5.set("argnames", new String[]{});
        reflect_EntityEnderman_method_getHeldBlockState_5.set("argtypes", new String[]{});
        reflect_EntityEnderman_method_getHeldBlockState_5.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (IBlockState) ((EntityEnderman) params.getReflective("_self")).getHeldBlockState();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityEnderman_methods.add(reflect_EntityEnderman_method_getHeldBlockState_5);


        BaseData reflect_EntityEnderman_method_attackEntityFrom_6 = new ModData();
        reflect_EntityEnderman_method_attackEntityFrom_6.set("methodName", "attackEntityFrom");
        reflect_EntityEnderman_method_attackEntityFrom_6.set("returnType", "boolean");
        reflect_EntityEnderman_method_attackEntityFrom_6.set("static", false);
        reflect_EntityEnderman_method_attackEntityFrom_6.set("argnames", new String[]{"damagesource", "f"});
        reflect_EntityEnderman_method_attackEntityFrom_6.set("argtypes", new String[]{"DamageSource", "float"});
        reflect_EntityEnderman_method_attackEntityFrom_6.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityEnderman) params.getReflective("_self")).attackEntityFrom((DamageSource) params.getReflective("damagesource"), (float) params.getFloat("f"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityEnderman_methods.add(reflect_EntityEnderman_method_attackEntityFrom_6);


        BaseData reflect_EntityEnderman_method_isScreaming_7 = new ModData();
        reflect_EntityEnderman_method_isScreaming_7.set("methodName", "isScreaming");
        reflect_EntityEnderman_method_isScreaming_7.set("returnType", "boolean");
        reflect_EntityEnderman_method_isScreaming_7.set("static", false);
        reflect_EntityEnderman_method_isScreaming_7.set("argnames", new String[]{});
        reflect_EntityEnderman_method_isScreaming_7.set("argtypes", new String[]{});
        reflect_EntityEnderman_method_isScreaming_7.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityEnderman) params.getReflective("_self")).isScreaming();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityEnderman_methods.add(reflect_EntityEnderman_method_isScreaming_7);


        BaseData reflect_EntityEnderman_method_setScreaming_8 = new ModData();
        reflect_EntityEnderman_method_setScreaming_8.set("methodName", "setScreaming");
        reflect_EntityEnderman_method_setScreaming_8.set("returnType", "void");
        reflect_EntityEnderman_method_setScreaming_8.set("static", false);
        reflect_EntityEnderman_method_setScreaming_8.set("argnames", new String[]{"screaming"});
        reflect_EntityEnderman_method_setScreaming_8.set("argtypes", new String[]{"boolean"});
        reflect_EntityEnderman_method_setScreaming_8.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityEnderman) params.getReflective("_self")).setScreaming((boolean) params.getBoolean("screaming"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityEnderman_methods.add(reflect_EntityEnderman_method_setScreaming_8);


        BaseData reflect_EntityEnderman_method_bootstrap_9 = new ModData();
        reflect_EntityEnderman_method_bootstrap_9.set("methodName", "bootstrap");
        reflect_EntityEnderman_method_bootstrap_9.set("returnType", "void");
        reflect_EntityEnderman_method_bootstrap_9.set("static", true);
        reflect_EntityEnderman_method_bootstrap_9.set("argnames", new String[]{});
        reflect_EntityEnderman_method_bootstrap_9.set("argtypes", new String[]{});
        reflect_EntityEnderman_method_bootstrap_9.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    EntityEnderman.bootstrap();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityEnderman_methods.add(reflect_EntityEnderman_method_bootstrap_9);


        BaseData[] reflect_EntityEnderman_methods_arr = new BaseData[reflect_EntityEnderman_methods.size()];
        for (int i = 0; i < reflect_EntityEnderman_methods_arr.length; i++) {
            reflect_EntityEnderman_methods_arr[i] = reflect_EntityEnderman_methods.get(i);
        }

        reflect_EntityEnderman.set("constructors", reflect_EntityEnderman_constructors_arr);
        reflect_EntityEnderman.set("methods", reflect_EntityEnderman_methods_arr);
        reflect_EntityEnderman.set("className", "EntityEnderman");
        reflect_EntityEnderman.set("classId", "net.minecraft.entity.monster.EntityEnderman");
        reflect_EntityEnderman.set("class", EntityEnderman.class);
        reflect_EntityEnderman.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityEnderman;
        });
        reflectProfiles.add(reflect_EntityEnderman);
    }


    //classdef for EntityEndermite
    public static void reflect_EntityEndermite_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityEndermite = new ModData();

        ArrayList<BaseData> reflect_EntityEndermite_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_EntityEndermite_constructor_EntityEndermite_0 = new ModData();
        reflect_EntityEndermite_constructor_EntityEndermite_0.set("returnType", "EntityEndermite");
        reflect_EntityEndermite_constructor_EntityEndermite_0.set("argnames", new String[]{"worldIn"});
        reflect_EntityEndermite_constructor_EntityEndermite_0.set("argtypes", new String[]{"World"});
        reflect_EntityEndermite_constructor_EntityEndermite_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityEndermite((World) params.getReflective("worldIn"));
        });
        
        reflect_EntityEndermite_constructors.add(reflect_EntityEndermite_constructor_EntityEndermite_0);


        BaseData[] reflect_EntityEndermite_constructors_arr = new BaseData[reflect_EntityEndermite_constructors.size()];
        for (int i = 0; i < reflect_EntityEndermite_constructors_arr.length; i++) {
            reflect_EntityEndermite_constructors_arr[i] = reflect_EntityEndermite_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityEndermite_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityEndermite_method_getEyeHeight_0 = new ModData();
        reflect_EntityEndermite_method_getEyeHeight_0.set("methodName", "getEyeHeight");
        reflect_EntityEndermite_method_getEyeHeight_0.set("returnType", "float");
        reflect_EntityEndermite_method_getEyeHeight_0.set("static", false);
        reflect_EntityEndermite_method_getEyeHeight_0.set("argnames", new String[]{});
        reflect_EntityEndermite_method_getEyeHeight_0.set("argtypes", new String[]{});
        reflect_EntityEndermite_method_getEyeHeight_0.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityEndermite) params.getReflective("_self")).getEyeHeight();
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityEndermite_methods.add(reflect_EntityEndermite_method_getEyeHeight_0);


        BaseData reflect_EntityEndermite_method_readEntityFromNBT_1 = new ModData();
        reflect_EntityEndermite_method_readEntityFromNBT_1.set("methodName", "readEntityFromNBT");
        reflect_EntityEndermite_method_readEntityFromNBT_1.set("returnType", "void");
        reflect_EntityEndermite_method_readEntityFromNBT_1.set("static", false);
        reflect_EntityEndermite_method_readEntityFromNBT_1.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityEndermite_method_readEntityFromNBT_1.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityEndermite_method_readEntityFromNBT_1.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityEndermite) params.getReflective("_self")).readEntityFromNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityEndermite_methods.add(reflect_EntityEndermite_method_readEntityFromNBT_1);


        BaseData reflect_EntityEndermite_method_writeEntityToNBT_2 = new ModData();
        reflect_EntityEndermite_method_writeEntityToNBT_2.set("methodName", "writeEntityToNBT");
        reflect_EntityEndermite_method_writeEntityToNBT_2.set("returnType", "void");
        reflect_EntityEndermite_method_writeEntityToNBT_2.set("static", false);
        reflect_EntityEndermite_method_writeEntityToNBT_2.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityEndermite_method_writeEntityToNBT_2.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityEndermite_method_writeEntityToNBT_2.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityEndermite) params.getReflective("_self")).writeEntityToNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityEndermite_methods.add(reflect_EntityEndermite_method_writeEntityToNBT_2);


        BaseData reflect_EntityEndermite_method_onUpdate_3 = new ModData();
        reflect_EntityEndermite_method_onUpdate_3.set("methodName", "onUpdate");
        reflect_EntityEndermite_method_onUpdate_3.set("returnType", "void");
        reflect_EntityEndermite_method_onUpdate_3.set("static", false);
        reflect_EntityEndermite_method_onUpdate_3.set("argnames", new String[]{});
        reflect_EntityEndermite_method_onUpdate_3.set("argtypes", new String[]{});
        reflect_EntityEndermite_method_onUpdate_3.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityEndermite) params.getReflective("_self")).onUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityEndermite_methods.add(reflect_EntityEndermite_method_onUpdate_3);


        BaseData reflect_EntityEndermite_method_isSpawnedByPlayer_4 = new ModData();
        reflect_EntityEndermite_method_isSpawnedByPlayer_4.set("methodName", "isSpawnedByPlayer");
        reflect_EntityEndermite_method_isSpawnedByPlayer_4.set("returnType", "boolean");
        reflect_EntityEndermite_method_isSpawnedByPlayer_4.set("static", false);
        reflect_EntityEndermite_method_isSpawnedByPlayer_4.set("argnames", new String[]{});
        reflect_EntityEndermite_method_isSpawnedByPlayer_4.set("argtypes", new String[]{});
        reflect_EntityEndermite_method_isSpawnedByPlayer_4.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityEndermite) params.getReflective("_self")).isSpawnedByPlayer();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityEndermite_methods.add(reflect_EntityEndermite_method_isSpawnedByPlayer_4);


        BaseData reflect_EntityEndermite_method_setSpawnedByPlayer_5 = new ModData();
        reflect_EntityEndermite_method_setSpawnedByPlayer_5.set("methodName", "setSpawnedByPlayer");
        reflect_EntityEndermite_method_setSpawnedByPlayer_5.set("returnType", "void");
        reflect_EntityEndermite_method_setSpawnedByPlayer_5.set("static", false);
        reflect_EntityEndermite_method_setSpawnedByPlayer_5.set("argnames", new String[]{"spawnedByPlayer"});
        reflect_EntityEndermite_method_setSpawnedByPlayer_5.set("argtypes", new String[]{"boolean"});
        reflect_EntityEndermite_method_setSpawnedByPlayer_5.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityEndermite) params.getReflective("_self")).setSpawnedByPlayer((boolean) params.getBoolean("spawnedByPlayer"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityEndermite_methods.add(reflect_EntityEndermite_method_setSpawnedByPlayer_5);


        BaseData reflect_EntityEndermite_method_onLivingUpdate_6 = new ModData();
        reflect_EntityEndermite_method_onLivingUpdate_6.set("methodName", "onLivingUpdate");
        reflect_EntityEndermite_method_onLivingUpdate_6.set("returnType", "void");
        reflect_EntityEndermite_method_onLivingUpdate_6.set("static", false);
        reflect_EntityEndermite_method_onLivingUpdate_6.set("argnames", new String[]{});
        reflect_EntityEndermite_method_onLivingUpdate_6.set("argtypes", new String[]{});
        reflect_EntityEndermite_method_onLivingUpdate_6.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityEndermite) params.getReflective("_self")).onLivingUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityEndermite_methods.add(reflect_EntityEndermite_method_onLivingUpdate_6);


        BaseData reflect_EntityEndermite_method_getCanSpawnHere_7 = new ModData();
        reflect_EntityEndermite_method_getCanSpawnHere_7.set("methodName", "getCanSpawnHere");
        reflect_EntityEndermite_method_getCanSpawnHere_7.set("returnType", "boolean");
        reflect_EntityEndermite_method_getCanSpawnHere_7.set("static", false);
        reflect_EntityEndermite_method_getCanSpawnHere_7.set("argnames", new String[]{});
        reflect_EntityEndermite_method_getCanSpawnHere_7.set("argtypes", new String[]{});
        reflect_EntityEndermite_method_getCanSpawnHere_7.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityEndermite) params.getReflective("_self")).getCanSpawnHere();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityEndermite_methods.add(reflect_EntityEndermite_method_getCanSpawnHere_7);


        BaseData reflect_EntityEndermite_method_getCreatureAttribute_8 = new ModData();
        reflect_EntityEndermite_method_getCreatureAttribute_8.set("methodName", "getCreatureAttribute");
        reflect_EntityEndermite_method_getCreatureAttribute_8.set("returnType", "EnumCreatureAttribute");
        reflect_EntityEndermite_method_getCreatureAttribute_8.set("static", false);
        reflect_EntityEndermite_method_getCreatureAttribute_8.set("argnames", new String[]{});
        reflect_EntityEndermite_method_getCreatureAttribute_8.set("argtypes", new String[]{});
        reflect_EntityEndermite_method_getCreatureAttribute_8.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EnumCreatureAttribute) ((EntityEndermite) params.getReflective("_self")).getCreatureAttribute();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityEndermite_methods.add(reflect_EntityEndermite_method_getCreatureAttribute_8);


        BaseData[] reflect_EntityEndermite_methods_arr = new BaseData[reflect_EntityEndermite_methods.size()];
        for (int i = 0; i < reflect_EntityEndermite_methods_arr.length; i++) {
            reflect_EntityEndermite_methods_arr[i] = reflect_EntityEndermite_methods.get(i);
        }

        reflect_EntityEndermite.set("constructors", reflect_EntityEndermite_constructors_arr);
        reflect_EntityEndermite.set("methods", reflect_EntityEndermite_methods_arr);
        reflect_EntityEndermite.set("className", "EntityEndermite");
        reflect_EntityEndermite.set("classId", "net.minecraft.entity.monster.EntityEndermite");
        reflect_EntityEndermite.set("class", EntityEndermite.class);
        reflect_EntityEndermite.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityEndermite;
        });
        reflectProfiles.add(reflect_EntityEndermite);
    }


    //classdef for EntityGhast
    public static void reflect_EntityGhast_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityGhast = new ModData();

        ArrayList<BaseData> reflect_EntityGhast_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_EntityGhast_constructor_EntityGhast_0 = new ModData();
        reflect_EntityGhast_constructor_EntityGhast_0.set("returnType", "EntityGhast");
        reflect_EntityGhast_constructor_EntityGhast_0.set("argnames", new String[]{"worldIn"});
        reflect_EntityGhast_constructor_EntityGhast_0.set("argtypes", new String[]{"World"});
        reflect_EntityGhast_constructor_EntityGhast_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityGhast((World) params.getReflective("worldIn"));
        });
        
        reflect_EntityGhast_constructors.add(reflect_EntityGhast_constructor_EntityGhast_0);


        BaseData[] reflect_EntityGhast_constructors_arr = new BaseData[reflect_EntityGhast_constructors.size()];
        for (int i = 0; i < reflect_EntityGhast_constructors_arr.length; i++) {
            reflect_EntityGhast_constructors_arr[i] = reflect_EntityGhast_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityGhast_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityGhast_method_isAttacking_0 = new ModData();
        reflect_EntityGhast_method_isAttacking_0.set("methodName", "isAttacking");
        reflect_EntityGhast_method_isAttacking_0.set("returnType", "boolean");
        reflect_EntityGhast_method_isAttacking_0.set("static", false);
        reflect_EntityGhast_method_isAttacking_0.set("argnames", new String[]{});
        reflect_EntityGhast_method_isAttacking_0.set("argtypes", new String[]{});
        reflect_EntityGhast_method_isAttacking_0.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityGhast) params.getReflective("_self")).isAttacking();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityGhast_methods.add(reflect_EntityGhast_method_isAttacking_0);


        BaseData reflect_EntityGhast_method_setAttacking_1 = new ModData();
        reflect_EntityGhast_method_setAttacking_1.set("methodName", "setAttacking");
        reflect_EntityGhast_method_setAttacking_1.set("returnType", "void");
        reflect_EntityGhast_method_setAttacking_1.set("static", false);
        reflect_EntityGhast_method_setAttacking_1.set("argnames", new String[]{"parFlag"});
        reflect_EntityGhast_method_setAttacking_1.set("argtypes", new String[]{"boolean"});
        reflect_EntityGhast_method_setAttacking_1.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityGhast) params.getReflective("_self")).setAttacking((boolean) params.getBoolean("parFlag"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityGhast_methods.add(reflect_EntityGhast_method_setAttacking_1);


        BaseData reflect_EntityGhast_method_getFireballStrength_2 = new ModData();
        reflect_EntityGhast_method_getFireballStrength_2.set("methodName", "getFireballStrength");
        reflect_EntityGhast_method_getFireballStrength_2.set("returnType", "int");
        reflect_EntityGhast_method_getFireballStrength_2.set("static", false);
        reflect_EntityGhast_method_getFireballStrength_2.set("argnames", new String[]{});
        reflect_EntityGhast_method_getFireballStrength_2.set("argtypes", new String[]{});
        reflect_EntityGhast_method_getFireballStrength_2.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityGhast) params.getReflective("_self")).getFireballStrength();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityGhast_methods.add(reflect_EntityGhast_method_getFireballStrength_2);


        BaseData reflect_EntityGhast_method_onUpdate_3 = new ModData();
        reflect_EntityGhast_method_onUpdate_3.set("methodName", "onUpdate");
        reflect_EntityGhast_method_onUpdate_3.set("returnType", "void");
        reflect_EntityGhast_method_onUpdate_3.set("static", false);
        reflect_EntityGhast_method_onUpdate_3.set("argnames", new String[]{});
        reflect_EntityGhast_method_onUpdate_3.set("argtypes", new String[]{});
        reflect_EntityGhast_method_onUpdate_3.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityGhast) params.getReflective("_self")).onUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityGhast_methods.add(reflect_EntityGhast_method_onUpdate_3);


        BaseData reflect_EntityGhast_method_attackEntityFrom_4 = new ModData();
        reflect_EntityGhast_method_attackEntityFrom_4.set("methodName", "attackEntityFrom");
        reflect_EntityGhast_method_attackEntityFrom_4.set("returnType", "boolean");
        reflect_EntityGhast_method_attackEntityFrom_4.set("static", false);
        reflect_EntityGhast_method_attackEntityFrom_4.set("argnames", new String[]{"damagesource", "f"});
        reflect_EntityGhast_method_attackEntityFrom_4.set("argtypes", new String[]{"DamageSource", "float"});
        reflect_EntityGhast_method_attackEntityFrom_4.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityGhast) params.getReflective("_self")).attackEntityFrom((DamageSource) params.getReflective("damagesource"), (float) params.getFloat("f"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityGhast_methods.add(reflect_EntityGhast_method_attackEntityFrom_4);


        BaseData reflect_EntityGhast_method_getCanSpawnHere_5 = new ModData();
        reflect_EntityGhast_method_getCanSpawnHere_5.set("methodName", "getCanSpawnHere");
        reflect_EntityGhast_method_getCanSpawnHere_5.set("returnType", "boolean");
        reflect_EntityGhast_method_getCanSpawnHere_5.set("static", false);
        reflect_EntityGhast_method_getCanSpawnHere_5.set("argnames", new String[]{});
        reflect_EntityGhast_method_getCanSpawnHere_5.set("argtypes", new String[]{});
        reflect_EntityGhast_method_getCanSpawnHere_5.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityGhast) params.getReflective("_self")).getCanSpawnHere();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityGhast_methods.add(reflect_EntityGhast_method_getCanSpawnHere_5);


        BaseData reflect_EntityGhast_method_getMaxSpawnedInChunk_6 = new ModData();
        reflect_EntityGhast_method_getMaxSpawnedInChunk_6.set("methodName", "getMaxSpawnedInChunk");
        reflect_EntityGhast_method_getMaxSpawnedInChunk_6.set("returnType", "int");
        reflect_EntityGhast_method_getMaxSpawnedInChunk_6.set("static", false);
        reflect_EntityGhast_method_getMaxSpawnedInChunk_6.set("argnames", new String[]{});
        reflect_EntityGhast_method_getMaxSpawnedInChunk_6.set("argtypes", new String[]{});
        reflect_EntityGhast_method_getMaxSpawnedInChunk_6.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityGhast) params.getReflective("_self")).getMaxSpawnedInChunk();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityGhast_methods.add(reflect_EntityGhast_method_getMaxSpawnedInChunk_6);


        BaseData reflect_EntityGhast_method_writeEntityToNBT_7 = new ModData();
        reflect_EntityGhast_method_writeEntityToNBT_7.set("methodName", "writeEntityToNBT");
        reflect_EntityGhast_method_writeEntityToNBT_7.set("returnType", "void");
        reflect_EntityGhast_method_writeEntityToNBT_7.set("static", false);
        reflect_EntityGhast_method_writeEntityToNBT_7.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityGhast_method_writeEntityToNBT_7.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityGhast_method_writeEntityToNBT_7.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityGhast) params.getReflective("_self")).writeEntityToNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityGhast_methods.add(reflect_EntityGhast_method_writeEntityToNBT_7);


        BaseData reflect_EntityGhast_method_readEntityFromNBT_8 = new ModData();
        reflect_EntityGhast_method_readEntityFromNBT_8.set("methodName", "readEntityFromNBT");
        reflect_EntityGhast_method_readEntityFromNBT_8.set("returnType", "void");
        reflect_EntityGhast_method_readEntityFromNBT_8.set("static", false);
        reflect_EntityGhast_method_readEntityFromNBT_8.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityGhast_method_readEntityFromNBT_8.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityGhast_method_readEntityFromNBT_8.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityGhast) params.getReflective("_self")).readEntityFromNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityGhast_methods.add(reflect_EntityGhast_method_readEntityFromNBT_8);


        BaseData reflect_EntityGhast_method_getEyeHeight_9 = new ModData();
        reflect_EntityGhast_method_getEyeHeight_9.set("methodName", "getEyeHeight");
        reflect_EntityGhast_method_getEyeHeight_9.set("returnType", "float");
        reflect_EntityGhast_method_getEyeHeight_9.set("static", false);
        reflect_EntityGhast_method_getEyeHeight_9.set("argnames", new String[]{});
        reflect_EntityGhast_method_getEyeHeight_9.set("argtypes", new String[]{});
        reflect_EntityGhast_method_getEyeHeight_9.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityGhast) params.getReflective("_self")).getEyeHeight();
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityGhast_methods.add(reflect_EntityGhast_method_getEyeHeight_9);


        BaseData[] reflect_EntityGhast_methods_arr = new BaseData[reflect_EntityGhast_methods.size()];
        for (int i = 0; i < reflect_EntityGhast_methods_arr.length; i++) {
            reflect_EntityGhast_methods_arr[i] = reflect_EntityGhast_methods.get(i);
        }

        reflect_EntityGhast.set("constructors", reflect_EntityGhast_constructors_arr);
        reflect_EntityGhast.set("methods", reflect_EntityGhast_methods_arr);
        reflect_EntityGhast.set("className", "EntityGhast");
        reflect_EntityGhast.set("classId", "net.minecraft.entity.monster.EntityGhast");
        reflect_EntityGhast.set("class", EntityGhast.class);
        reflect_EntityGhast.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityGhast;
        });
        reflectProfiles.add(reflect_EntityGhast);
    }


    //classdef for EntityGiantZombie
    public static void reflect_EntityGiantZombie_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityGiantZombie = new ModData();

        ArrayList<BaseData> reflect_EntityGiantZombie_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_EntityGiantZombie_constructor_EntityGiantZombie_0 = new ModData();
        reflect_EntityGiantZombie_constructor_EntityGiantZombie_0.set("returnType", "EntityGiantZombie");
        reflect_EntityGiantZombie_constructor_EntityGiantZombie_0.set("argnames", new String[]{"worldIn"});
        reflect_EntityGiantZombie_constructor_EntityGiantZombie_0.set("argtypes", new String[]{"World"});
        reflect_EntityGiantZombie_constructor_EntityGiantZombie_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityGiantZombie((World) params.getReflective("worldIn"));
        });
        
        reflect_EntityGiantZombie_constructors.add(reflect_EntityGiantZombie_constructor_EntityGiantZombie_0);


        BaseData[] reflect_EntityGiantZombie_constructors_arr = new BaseData[reflect_EntityGiantZombie_constructors.size()];
        for (int i = 0; i < reflect_EntityGiantZombie_constructors_arr.length; i++) {
            reflect_EntityGiantZombie_constructors_arr[i] = reflect_EntityGiantZombie_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityGiantZombie_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityGiantZombie_method_getEyeHeight_0 = new ModData();
        reflect_EntityGiantZombie_method_getEyeHeight_0.set("methodName", "getEyeHeight");
        reflect_EntityGiantZombie_method_getEyeHeight_0.set("returnType", "float");
        reflect_EntityGiantZombie_method_getEyeHeight_0.set("static", false);
        reflect_EntityGiantZombie_method_getEyeHeight_0.set("argnames", new String[]{});
        reflect_EntityGiantZombie_method_getEyeHeight_0.set("argtypes", new String[]{});
        reflect_EntityGiantZombie_method_getEyeHeight_0.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityGiantZombie) params.getReflective("_self")).getEyeHeight();
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityGiantZombie_methods.add(reflect_EntityGiantZombie_method_getEyeHeight_0);


        BaseData reflect_EntityGiantZombie_method_getBlockPathWeight_1 = new ModData();
        reflect_EntityGiantZombie_method_getBlockPathWeight_1.set("methodName", "getBlockPathWeight");
        reflect_EntityGiantZombie_method_getBlockPathWeight_1.set("returnType", "float");
        reflect_EntityGiantZombie_method_getBlockPathWeight_1.set("static", false);
        reflect_EntityGiantZombie_method_getBlockPathWeight_1.set("argnames", new String[]{"blockpos"});
        reflect_EntityGiantZombie_method_getBlockPathWeight_1.set("argtypes", new String[]{"BlockPos"});
        reflect_EntityGiantZombie_method_getBlockPathWeight_1.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityGiantZombie) params.getReflective("_self")).getBlockPathWeight((BlockPos) params.getReflective("blockpos"));
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityGiantZombie_methods.add(reflect_EntityGiantZombie_method_getBlockPathWeight_1);


        BaseData[] reflect_EntityGiantZombie_methods_arr = new BaseData[reflect_EntityGiantZombie_methods.size()];
        for (int i = 0; i < reflect_EntityGiantZombie_methods_arr.length; i++) {
            reflect_EntityGiantZombie_methods_arr[i] = reflect_EntityGiantZombie_methods.get(i);
        }

        reflect_EntityGiantZombie.set("constructors", reflect_EntityGiantZombie_constructors_arr);
        reflect_EntityGiantZombie.set("methods", reflect_EntityGiantZombie_methods_arr);
        reflect_EntityGiantZombie.set("className", "EntityGiantZombie");
        reflect_EntityGiantZombie.set("classId", "net.minecraft.entity.monster.EntityGiantZombie");
        reflect_EntityGiantZombie.set("class", EntityGiantZombie.class);
        reflect_EntityGiantZombie.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityGiantZombie;
        });
        reflectProfiles.add(reflect_EntityGiantZombie);
    }


    //classdef for EntityGolem
    public static void reflect_EntityGolem_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityGolem = new ModData();

        ArrayList<BaseData> reflect_EntityGolem_constructors = new ArrayList<BaseData>();
        
        BaseData[] reflect_EntityGolem_constructors_arr = new BaseData[reflect_EntityGolem_constructors.size()];
        for (int i = 0; i < reflect_EntityGolem_constructors_arr.length; i++) {
            reflect_EntityGolem_constructors_arr[i] = reflect_EntityGolem_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityGolem_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityGolem_method_fall_0 = new ModData();
        reflect_EntityGolem_method_fall_0.set("methodName", "fall");
        reflect_EntityGolem_method_fall_0.set("returnType", "void");
        reflect_EntityGolem_method_fall_0.set("static", false);
        reflect_EntityGolem_method_fall_0.set("argnames", new String[]{"var1", "var2"});
        reflect_EntityGolem_method_fall_0.set("argtypes", new String[]{"float", "float"});
        reflect_EntityGolem_method_fall_0.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityGolem) params.getReflective("_self")).fall((float) params.getFloat("var1"), (float) params.getFloat("var2"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityGolem_methods.add(reflect_EntityGolem_method_fall_0);


        BaseData reflect_EntityGolem_method_getTalkInterval_1 = new ModData();
        reflect_EntityGolem_method_getTalkInterval_1.set("methodName", "getTalkInterval");
        reflect_EntityGolem_method_getTalkInterval_1.set("returnType", "int");
        reflect_EntityGolem_method_getTalkInterval_1.set("static", false);
        reflect_EntityGolem_method_getTalkInterval_1.set("argnames", new String[]{});
        reflect_EntityGolem_method_getTalkInterval_1.set("argtypes", new String[]{});
        reflect_EntityGolem_method_getTalkInterval_1.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityGolem) params.getReflective("_self")).getTalkInterval();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityGolem_methods.add(reflect_EntityGolem_method_getTalkInterval_1);


        BaseData[] reflect_EntityGolem_methods_arr = new BaseData[reflect_EntityGolem_methods.size()];
        for (int i = 0; i < reflect_EntityGolem_methods_arr.length; i++) {
            reflect_EntityGolem_methods_arr[i] = reflect_EntityGolem_methods.get(i);
        }

        reflect_EntityGolem.set("constructors", reflect_EntityGolem_constructors_arr);
        reflect_EntityGolem.set("methods", reflect_EntityGolem_methods_arr);
        reflect_EntityGolem.set("className", "EntityGolem");
        reflect_EntityGolem.set("classId", "net.minecraft.entity.monster.EntityGolem");
        reflect_EntityGolem.set("class", EntityGolem.class);
        reflect_EntityGolem.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityGolem;
        });
        reflectProfiles.add(reflect_EntityGolem);
    }


    //classdef for EntityGuardian
    public static void reflect_EntityGuardian_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityGuardian = new ModData();

        ArrayList<BaseData> reflect_EntityGuardian_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_EntityGuardian_constructor_EntityGuardian_0 = new ModData();
        reflect_EntityGuardian_constructor_EntityGuardian_0.set("returnType", "EntityGuardian");
        reflect_EntityGuardian_constructor_EntityGuardian_0.set("argnames", new String[]{"worldIn"});
        reflect_EntityGuardian_constructor_EntityGuardian_0.set("argtypes", new String[]{"World"});
        reflect_EntityGuardian_constructor_EntityGuardian_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityGuardian((World) params.getReflective("worldIn"));
        });
        
        reflect_EntityGuardian_constructors.add(reflect_EntityGuardian_constructor_EntityGuardian_0);


        BaseData[] reflect_EntityGuardian_constructors_arr = new BaseData[reflect_EntityGuardian_constructors.size()];
        for (int i = 0; i < reflect_EntityGuardian_constructors_arr.length; i++) {
            reflect_EntityGuardian_constructors_arr[i] = reflect_EntityGuardian_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityGuardian_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityGuardian_method_readEntityFromNBT_0 = new ModData();
        reflect_EntityGuardian_method_readEntityFromNBT_0.set("methodName", "readEntityFromNBT");
        reflect_EntityGuardian_method_readEntityFromNBT_0.set("returnType", "void");
        reflect_EntityGuardian_method_readEntityFromNBT_0.set("static", false);
        reflect_EntityGuardian_method_readEntityFromNBT_0.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityGuardian_method_readEntityFromNBT_0.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityGuardian_method_readEntityFromNBT_0.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityGuardian) params.getReflective("_self")).readEntityFromNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityGuardian_methods.add(reflect_EntityGuardian_method_readEntityFromNBT_0);


        BaseData reflect_EntityGuardian_method_writeEntityToNBT_1 = new ModData();
        reflect_EntityGuardian_method_writeEntityToNBT_1.set("methodName", "writeEntityToNBT");
        reflect_EntityGuardian_method_writeEntityToNBT_1.set("returnType", "void");
        reflect_EntityGuardian_method_writeEntityToNBT_1.set("static", false);
        reflect_EntityGuardian_method_writeEntityToNBT_1.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityGuardian_method_writeEntityToNBT_1.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityGuardian_method_writeEntityToNBT_1.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityGuardian) params.getReflective("_self")).writeEntityToNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityGuardian_methods.add(reflect_EntityGuardian_method_writeEntityToNBT_1);


        BaseData reflect_EntityGuardian_method_func_175472_n_2 = new ModData();
        reflect_EntityGuardian_method_func_175472_n_2.set("methodName", "func_175472_n");
        reflect_EntityGuardian_method_func_175472_n_2.set("returnType", "boolean");
        reflect_EntityGuardian_method_func_175472_n_2.set("static", false);
        reflect_EntityGuardian_method_func_175472_n_2.set("argnames", new String[]{});
        reflect_EntityGuardian_method_func_175472_n_2.set("argtypes", new String[]{});
        reflect_EntityGuardian_method_func_175472_n_2.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityGuardian) params.getReflective("_self")).func_175472_n();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityGuardian_methods.add(reflect_EntityGuardian_method_func_175472_n_2);


        BaseData reflect_EntityGuardian_method_func_175464_ck_3 = new ModData();
        reflect_EntityGuardian_method_func_175464_ck_3.set("methodName", "func_175464_ck");
        reflect_EntityGuardian_method_func_175464_ck_3.set("returnType", "int");
        reflect_EntityGuardian_method_func_175464_ck_3.set("static", false);
        reflect_EntityGuardian_method_func_175464_ck_3.set("argnames", new String[]{});
        reflect_EntityGuardian_method_func_175464_ck_3.set("argtypes", new String[]{});
        reflect_EntityGuardian_method_func_175464_ck_3.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityGuardian) params.getReflective("_self")).func_175464_ck();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityGuardian_methods.add(reflect_EntityGuardian_method_func_175464_ck_3);


        BaseData reflect_EntityGuardian_method_isElder_4 = new ModData();
        reflect_EntityGuardian_method_isElder_4.set("methodName", "isElder");
        reflect_EntityGuardian_method_isElder_4.set("returnType", "boolean");
        reflect_EntityGuardian_method_isElder_4.set("static", false);
        reflect_EntityGuardian_method_isElder_4.set("argnames", new String[]{});
        reflect_EntityGuardian_method_isElder_4.set("argtypes", new String[]{});
        reflect_EntityGuardian_method_isElder_4.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityGuardian) params.getReflective("_self")).isElder();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityGuardian_methods.add(reflect_EntityGuardian_method_isElder_4);


        BaseData reflect_EntityGuardian_method_setElder_5 = new ModData();
        reflect_EntityGuardian_method_setElder_5.set("methodName", "setElder");
        reflect_EntityGuardian_method_setElder_5.set("returnType", "void");
        reflect_EntityGuardian_method_setElder_5.set("static", false);
        reflect_EntityGuardian_method_setElder_5.set("argnames", new String[]{"elder"});
        reflect_EntityGuardian_method_setElder_5.set("argtypes", new String[]{"boolean"});
        reflect_EntityGuardian_method_setElder_5.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityGuardian) params.getReflective("_self")).setElder((boolean) params.getBoolean("elder"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityGuardian_methods.add(reflect_EntityGuardian_method_setElder_5);


        BaseData reflect_EntityGuardian_method_setElder_6 = new ModData();
        reflect_EntityGuardian_method_setElder_6.set("methodName", "setElder");
        reflect_EntityGuardian_method_setElder_6.set("returnType", "void");
        reflect_EntityGuardian_method_setElder_6.set("static", false);
        reflect_EntityGuardian_method_setElder_6.set("argnames", new String[]{});
        reflect_EntityGuardian_method_setElder_6.set("argtypes", new String[]{});
        reflect_EntityGuardian_method_setElder_6.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityGuardian) params.getReflective("_self")).setElder();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityGuardian_methods.add(reflect_EntityGuardian_method_setElder_6);


        BaseData reflect_EntityGuardian_method_hasTargetedEntity_7 = new ModData();
        reflect_EntityGuardian_method_hasTargetedEntity_7.set("methodName", "hasTargetedEntity");
        reflect_EntityGuardian_method_hasTargetedEntity_7.set("returnType", "boolean");
        reflect_EntityGuardian_method_hasTargetedEntity_7.set("static", false);
        reflect_EntityGuardian_method_hasTargetedEntity_7.set("argnames", new String[]{});
        reflect_EntityGuardian_method_hasTargetedEntity_7.set("argtypes", new String[]{});
        reflect_EntityGuardian_method_hasTargetedEntity_7.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityGuardian) params.getReflective("_self")).hasTargetedEntity();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityGuardian_methods.add(reflect_EntityGuardian_method_hasTargetedEntity_7);


        BaseData reflect_EntityGuardian_method_getTargetedEntity_8 = new ModData();
        reflect_EntityGuardian_method_getTargetedEntity_8.set("methodName", "getTargetedEntity");
        reflect_EntityGuardian_method_getTargetedEntity_8.set("returnType", "EntityLivingBase");
        reflect_EntityGuardian_method_getTargetedEntity_8.set("static", false);
        reflect_EntityGuardian_method_getTargetedEntity_8.set("argnames", new String[]{});
        reflect_EntityGuardian_method_getTargetedEntity_8.set("argtypes", new String[]{});
        reflect_EntityGuardian_method_getTargetedEntity_8.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EntityLivingBase) ((EntityGuardian) params.getReflective("_self")).getTargetedEntity();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityGuardian_methods.add(reflect_EntityGuardian_method_getTargetedEntity_8);


        BaseData reflect_EntityGuardian_method_onDataWatcherUpdate_9 = new ModData();
        reflect_EntityGuardian_method_onDataWatcherUpdate_9.set("methodName", "onDataWatcherUpdate");
        reflect_EntityGuardian_method_onDataWatcherUpdate_9.set("returnType", "void");
        reflect_EntityGuardian_method_onDataWatcherUpdate_9.set("static", false);
        reflect_EntityGuardian_method_onDataWatcherUpdate_9.set("argnames", new String[]{"i"});
        reflect_EntityGuardian_method_onDataWatcherUpdate_9.set("argtypes", new String[]{"int"});
        reflect_EntityGuardian_method_onDataWatcherUpdate_9.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityGuardian) params.getReflective("_self")).onDataWatcherUpdate((int) params.getInt("i"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityGuardian_methods.add(reflect_EntityGuardian_method_onDataWatcherUpdate_9);


        BaseData reflect_EntityGuardian_method_getTalkInterval_10 = new ModData();
        reflect_EntityGuardian_method_getTalkInterval_10.set("methodName", "getTalkInterval");
        reflect_EntityGuardian_method_getTalkInterval_10.set("returnType", "int");
        reflect_EntityGuardian_method_getTalkInterval_10.set("static", false);
        reflect_EntityGuardian_method_getTalkInterval_10.set("argnames", new String[]{});
        reflect_EntityGuardian_method_getTalkInterval_10.set("argtypes", new String[]{});
        reflect_EntityGuardian_method_getTalkInterval_10.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityGuardian) params.getReflective("_self")).getTalkInterval();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityGuardian_methods.add(reflect_EntityGuardian_method_getTalkInterval_10);


        BaseData reflect_EntityGuardian_method_getEyeHeight_11 = new ModData();
        reflect_EntityGuardian_method_getEyeHeight_11.set("methodName", "getEyeHeight");
        reflect_EntityGuardian_method_getEyeHeight_11.set("returnType", "float");
        reflect_EntityGuardian_method_getEyeHeight_11.set("static", false);
        reflect_EntityGuardian_method_getEyeHeight_11.set("argnames", new String[]{});
        reflect_EntityGuardian_method_getEyeHeight_11.set("argtypes", new String[]{});
        reflect_EntityGuardian_method_getEyeHeight_11.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityGuardian) params.getReflective("_self")).getEyeHeight();
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityGuardian_methods.add(reflect_EntityGuardian_method_getEyeHeight_11);


        BaseData reflect_EntityGuardian_method_getBlockPathWeight_12 = new ModData();
        reflect_EntityGuardian_method_getBlockPathWeight_12.set("methodName", "getBlockPathWeight");
        reflect_EntityGuardian_method_getBlockPathWeight_12.set("returnType", "float");
        reflect_EntityGuardian_method_getBlockPathWeight_12.set("static", false);
        reflect_EntityGuardian_method_getBlockPathWeight_12.set("argnames", new String[]{"blockpos"});
        reflect_EntityGuardian_method_getBlockPathWeight_12.set("argtypes", new String[]{"BlockPos"});
        reflect_EntityGuardian_method_getBlockPathWeight_12.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityGuardian) params.getReflective("_self")).getBlockPathWeight((BlockPos) params.getReflective("blockpos"));
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityGuardian_methods.add(reflect_EntityGuardian_method_getBlockPathWeight_12);


        BaseData reflect_EntityGuardian_method_onLivingUpdate_13 = new ModData();
        reflect_EntityGuardian_method_onLivingUpdate_13.set("methodName", "onLivingUpdate");
        reflect_EntityGuardian_method_onLivingUpdate_13.set("returnType", "void");
        reflect_EntityGuardian_method_onLivingUpdate_13.set("static", false);
        reflect_EntityGuardian_method_onLivingUpdate_13.set("argnames", new String[]{});
        reflect_EntityGuardian_method_onLivingUpdate_13.set("argtypes", new String[]{});
        reflect_EntityGuardian_method_onLivingUpdate_13.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityGuardian) params.getReflective("_self")).onLivingUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityGuardian_methods.add(reflect_EntityGuardian_method_onLivingUpdate_13);


        BaseData reflect_EntityGuardian_method_func_175471_a_14 = new ModData();
        reflect_EntityGuardian_method_func_175471_a_14.set("methodName", "func_175471_a");
        reflect_EntityGuardian_method_func_175471_a_14.set("returnType", "float");
        reflect_EntityGuardian_method_func_175471_a_14.set("static", false);
        reflect_EntityGuardian_method_func_175471_a_14.set("argnames", new String[]{"parFloat1"});
        reflect_EntityGuardian_method_func_175471_a_14.set("argtypes", new String[]{"float"});
        reflect_EntityGuardian_method_func_175471_a_14.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityGuardian) params.getReflective("_self")).func_175471_a((float) params.getFloat("parFloat1"));
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityGuardian_methods.add(reflect_EntityGuardian_method_func_175471_a_14);


        BaseData reflect_EntityGuardian_method_func_175469_o_15 = new ModData();
        reflect_EntityGuardian_method_func_175469_o_15.set("methodName", "func_175469_o");
        reflect_EntityGuardian_method_func_175469_o_15.set("returnType", "float");
        reflect_EntityGuardian_method_func_175469_o_15.set("static", false);
        reflect_EntityGuardian_method_func_175469_o_15.set("argnames", new String[]{"parFloat1"});
        reflect_EntityGuardian_method_func_175469_o_15.set("argtypes", new String[]{"float"});
        reflect_EntityGuardian_method_func_175469_o_15.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityGuardian) params.getReflective("_self")).func_175469_o((float) params.getFloat("parFloat1"));
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityGuardian_methods.add(reflect_EntityGuardian_method_func_175469_o_15);


        BaseData reflect_EntityGuardian_method_func_175477_p_16 = new ModData();
        reflect_EntityGuardian_method_func_175477_p_16.set("methodName", "func_175477_p");
        reflect_EntityGuardian_method_func_175477_p_16.set("returnType", "float");
        reflect_EntityGuardian_method_func_175477_p_16.set("static", false);
        reflect_EntityGuardian_method_func_175477_p_16.set("argnames", new String[]{"parFloat1"});
        reflect_EntityGuardian_method_func_175477_p_16.set("argtypes", new String[]{"float"});
        reflect_EntityGuardian_method_func_175477_p_16.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityGuardian) params.getReflective("_self")).func_175477_p((float) params.getFloat("parFloat1"));
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityGuardian_methods.add(reflect_EntityGuardian_method_func_175477_p_16);


        BaseData reflect_EntityGuardian_method_isNotColliding_17 = new ModData();
        reflect_EntityGuardian_method_isNotColliding_17.set("methodName", "isNotColliding");
        reflect_EntityGuardian_method_isNotColliding_17.set("returnType", "boolean");
        reflect_EntityGuardian_method_isNotColliding_17.set("static", false);
        reflect_EntityGuardian_method_isNotColliding_17.set("argnames", new String[]{});
        reflect_EntityGuardian_method_isNotColliding_17.set("argtypes", new String[]{});
        reflect_EntityGuardian_method_isNotColliding_17.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityGuardian) params.getReflective("_self")).isNotColliding();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityGuardian_methods.add(reflect_EntityGuardian_method_isNotColliding_17);


        BaseData reflect_EntityGuardian_method_getCanSpawnHere_18 = new ModData();
        reflect_EntityGuardian_method_getCanSpawnHere_18.set("methodName", "getCanSpawnHere");
        reflect_EntityGuardian_method_getCanSpawnHere_18.set("returnType", "boolean");
        reflect_EntityGuardian_method_getCanSpawnHere_18.set("static", false);
        reflect_EntityGuardian_method_getCanSpawnHere_18.set("argnames", new String[]{});
        reflect_EntityGuardian_method_getCanSpawnHere_18.set("argtypes", new String[]{});
        reflect_EntityGuardian_method_getCanSpawnHere_18.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityGuardian) params.getReflective("_self")).getCanSpawnHere();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityGuardian_methods.add(reflect_EntityGuardian_method_getCanSpawnHere_18);


        BaseData reflect_EntityGuardian_method_attackEntityFrom_19 = new ModData();
        reflect_EntityGuardian_method_attackEntityFrom_19.set("methodName", "attackEntityFrom");
        reflect_EntityGuardian_method_attackEntityFrom_19.set("returnType", "boolean");
        reflect_EntityGuardian_method_attackEntityFrom_19.set("static", false);
        reflect_EntityGuardian_method_attackEntityFrom_19.set("argnames", new String[]{"damagesource", "f"});
        reflect_EntityGuardian_method_attackEntityFrom_19.set("argtypes", new String[]{"DamageSource", "float"});
        reflect_EntityGuardian_method_attackEntityFrom_19.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityGuardian) params.getReflective("_self")).attackEntityFrom((DamageSource) params.getReflective("damagesource"), (float) params.getFloat("f"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityGuardian_methods.add(reflect_EntityGuardian_method_attackEntityFrom_19);


        BaseData reflect_EntityGuardian_method_getVerticalFaceSpeed_20 = new ModData();
        reflect_EntityGuardian_method_getVerticalFaceSpeed_20.set("methodName", "getVerticalFaceSpeed");
        reflect_EntityGuardian_method_getVerticalFaceSpeed_20.set("returnType", "int");
        reflect_EntityGuardian_method_getVerticalFaceSpeed_20.set("static", false);
        reflect_EntityGuardian_method_getVerticalFaceSpeed_20.set("argnames", new String[]{});
        reflect_EntityGuardian_method_getVerticalFaceSpeed_20.set("argtypes", new String[]{});
        reflect_EntityGuardian_method_getVerticalFaceSpeed_20.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityGuardian) params.getReflective("_self")).getVerticalFaceSpeed();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityGuardian_methods.add(reflect_EntityGuardian_method_getVerticalFaceSpeed_20);


        BaseData reflect_EntityGuardian_method_moveEntityWithHeading_21 = new ModData();
        reflect_EntityGuardian_method_moveEntityWithHeading_21.set("methodName", "moveEntityWithHeading");
        reflect_EntityGuardian_method_moveEntityWithHeading_21.set("returnType", "void");
        reflect_EntityGuardian_method_moveEntityWithHeading_21.set("static", false);
        reflect_EntityGuardian_method_moveEntityWithHeading_21.set("argnames", new String[]{"f", "f1"});
        reflect_EntityGuardian_method_moveEntityWithHeading_21.set("argtypes", new String[]{"float", "float"});
        reflect_EntityGuardian_method_moveEntityWithHeading_21.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityGuardian) params.getReflective("_self")).moveEntityWithHeading((float) params.getFloat("f"), (float) params.getFloat("f1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityGuardian_methods.add(reflect_EntityGuardian_method_moveEntityWithHeading_21);


        BaseData[] reflect_EntityGuardian_methods_arr = new BaseData[reflect_EntityGuardian_methods.size()];
        for (int i = 0; i < reflect_EntityGuardian_methods_arr.length; i++) {
            reflect_EntityGuardian_methods_arr[i] = reflect_EntityGuardian_methods.get(i);
        }

        reflect_EntityGuardian.set("constructors", reflect_EntityGuardian_constructors_arr);
        reflect_EntityGuardian.set("methods", reflect_EntityGuardian_methods_arr);
        reflect_EntityGuardian.set("className", "EntityGuardian");
        reflect_EntityGuardian.set("classId", "net.minecraft.entity.monster.EntityGuardian");
        reflect_EntityGuardian.set("class", EntityGuardian.class);
        reflect_EntityGuardian.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityGuardian;
        });
        reflectProfiles.add(reflect_EntityGuardian);
    }


    //classdef for EntityIronGolem
    public static void reflect_EntityIronGolem_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityIronGolem = new ModData();

        ArrayList<BaseData> reflect_EntityIronGolem_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_EntityIronGolem_constructor_EntityIronGolem_0 = new ModData();
        reflect_EntityIronGolem_constructor_EntityIronGolem_0.set("returnType", "EntityIronGolem");
        reflect_EntityIronGolem_constructor_EntityIronGolem_0.set("argnames", new String[]{"worldIn"});
        reflect_EntityIronGolem_constructor_EntityIronGolem_0.set("argtypes", new String[]{"World"});
        reflect_EntityIronGolem_constructor_EntityIronGolem_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityIronGolem((World) params.getReflective("worldIn"));
        });
        
        reflect_EntityIronGolem_constructors.add(reflect_EntityIronGolem_constructor_EntityIronGolem_0);


        BaseData[] reflect_EntityIronGolem_constructors_arr = new BaseData[reflect_EntityIronGolem_constructors.size()];
        for (int i = 0; i < reflect_EntityIronGolem_constructors_arr.length; i++) {
            reflect_EntityIronGolem_constructors_arr[i] = reflect_EntityIronGolem_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityIronGolem_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityIronGolem_method_onLivingUpdate_0 = new ModData();
        reflect_EntityIronGolem_method_onLivingUpdate_0.set("methodName", "onLivingUpdate");
        reflect_EntityIronGolem_method_onLivingUpdate_0.set("returnType", "void");
        reflect_EntityIronGolem_method_onLivingUpdate_0.set("static", false);
        reflect_EntityIronGolem_method_onLivingUpdate_0.set("argnames", new String[]{});
        reflect_EntityIronGolem_method_onLivingUpdate_0.set("argtypes", new String[]{});
        reflect_EntityIronGolem_method_onLivingUpdate_0.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityIronGolem) params.getReflective("_self")).onLivingUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityIronGolem_methods.add(reflect_EntityIronGolem_method_onLivingUpdate_0);


        BaseData reflect_EntityIronGolem_method_writeEntityToNBT_1 = new ModData();
        reflect_EntityIronGolem_method_writeEntityToNBT_1.set("methodName", "writeEntityToNBT");
        reflect_EntityIronGolem_method_writeEntityToNBT_1.set("returnType", "void");
        reflect_EntityIronGolem_method_writeEntityToNBT_1.set("static", false);
        reflect_EntityIronGolem_method_writeEntityToNBT_1.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityIronGolem_method_writeEntityToNBT_1.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityIronGolem_method_writeEntityToNBT_1.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityIronGolem) params.getReflective("_self")).writeEntityToNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityIronGolem_methods.add(reflect_EntityIronGolem_method_writeEntityToNBT_1);


        BaseData reflect_EntityIronGolem_method_readEntityFromNBT_2 = new ModData();
        reflect_EntityIronGolem_method_readEntityFromNBT_2.set("methodName", "readEntityFromNBT");
        reflect_EntityIronGolem_method_readEntityFromNBT_2.set("returnType", "void");
        reflect_EntityIronGolem_method_readEntityFromNBT_2.set("static", false);
        reflect_EntityIronGolem_method_readEntityFromNBT_2.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityIronGolem_method_readEntityFromNBT_2.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityIronGolem_method_readEntityFromNBT_2.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityIronGolem) params.getReflective("_self")).readEntityFromNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityIronGolem_methods.add(reflect_EntityIronGolem_method_readEntityFromNBT_2);


        BaseData reflect_EntityIronGolem_method_attackEntityAsMob_3 = new ModData();
        reflect_EntityIronGolem_method_attackEntityAsMob_3.set("methodName", "attackEntityAsMob");
        reflect_EntityIronGolem_method_attackEntityAsMob_3.set("returnType", "boolean");
        reflect_EntityIronGolem_method_attackEntityAsMob_3.set("static", false);
        reflect_EntityIronGolem_method_attackEntityAsMob_3.set("argnames", new String[]{"entity"});
        reflect_EntityIronGolem_method_attackEntityAsMob_3.set("argtypes", new String[]{"Entity"});
        reflect_EntityIronGolem_method_attackEntityAsMob_3.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityIronGolem) params.getReflective("_self")).attackEntityAsMob((Entity) params.getReflective("entity"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityIronGolem_methods.add(reflect_EntityIronGolem_method_attackEntityAsMob_3);


        BaseData reflect_EntityIronGolem_method_handleStatusUpdate_4 = new ModData();
        reflect_EntityIronGolem_method_handleStatusUpdate_4.set("methodName", "handleStatusUpdate");
        reflect_EntityIronGolem_method_handleStatusUpdate_4.set("returnType", "void");
        reflect_EntityIronGolem_method_handleStatusUpdate_4.set("static", false);
        reflect_EntityIronGolem_method_handleStatusUpdate_4.set("argnames", new String[]{"b0"});
        reflect_EntityIronGolem_method_handleStatusUpdate_4.set("argtypes", new String[]{"byte"});
        reflect_EntityIronGolem_method_handleStatusUpdate_4.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityIronGolem) params.getReflective("_self")).handleStatusUpdate((byte) params.getByte("b0"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityIronGolem_methods.add(reflect_EntityIronGolem_method_handleStatusUpdate_4);


        BaseData reflect_EntityIronGolem_method_getVillage_5 = new ModData();
        reflect_EntityIronGolem_method_getVillage_5.set("methodName", "getVillage");
        reflect_EntityIronGolem_method_getVillage_5.set("returnType", "Village");
        reflect_EntityIronGolem_method_getVillage_5.set("static", false);
        reflect_EntityIronGolem_method_getVillage_5.set("argnames", new String[]{});
        reflect_EntityIronGolem_method_getVillage_5.set("argtypes", new String[]{});
        reflect_EntityIronGolem_method_getVillage_5.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Village) ((EntityIronGolem) params.getReflective("_self")).getVillage();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityIronGolem_methods.add(reflect_EntityIronGolem_method_getVillage_5);


        BaseData reflect_EntityIronGolem_method_getAttackTimer_6 = new ModData();
        reflect_EntityIronGolem_method_getAttackTimer_6.set("methodName", "getAttackTimer");
        reflect_EntityIronGolem_method_getAttackTimer_6.set("returnType", "int");
        reflect_EntityIronGolem_method_getAttackTimer_6.set("static", false);
        reflect_EntityIronGolem_method_getAttackTimer_6.set("argnames", new String[]{});
        reflect_EntityIronGolem_method_getAttackTimer_6.set("argtypes", new String[]{});
        reflect_EntityIronGolem_method_getAttackTimer_6.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityIronGolem) params.getReflective("_self")).getAttackTimer();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityIronGolem_methods.add(reflect_EntityIronGolem_method_getAttackTimer_6);


        BaseData reflect_EntityIronGolem_method_setHoldingRose_7 = new ModData();
        reflect_EntityIronGolem_method_setHoldingRose_7.set("methodName", "setHoldingRose");
        reflect_EntityIronGolem_method_setHoldingRose_7.set("returnType", "void");
        reflect_EntityIronGolem_method_setHoldingRose_7.set("static", false);
        reflect_EntityIronGolem_method_setHoldingRose_7.set("argnames", new String[]{"parFlag"});
        reflect_EntityIronGolem_method_setHoldingRose_7.set("argtypes", new String[]{"boolean"});
        reflect_EntityIronGolem_method_setHoldingRose_7.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityIronGolem) params.getReflective("_self")).setHoldingRose((boolean) params.getBoolean("parFlag"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityIronGolem_methods.add(reflect_EntityIronGolem_method_setHoldingRose_7);


        BaseData reflect_EntityIronGolem_method_getHoldRoseTick_8 = new ModData();
        reflect_EntityIronGolem_method_getHoldRoseTick_8.set("methodName", "getHoldRoseTick");
        reflect_EntityIronGolem_method_getHoldRoseTick_8.set("returnType", "int");
        reflect_EntityIronGolem_method_getHoldRoseTick_8.set("static", false);
        reflect_EntityIronGolem_method_getHoldRoseTick_8.set("argnames", new String[]{});
        reflect_EntityIronGolem_method_getHoldRoseTick_8.set("argtypes", new String[]{});
        reflect_EntityIronGolem_method_getHoldRoseTick_8.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityIronGolem) params.getReflective("_self")).getHoldRoseTick();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityIronGolem_methods.add(reflect_EntityIronGolem_method_getHoldRoseTick_8);


        BaseData reflect_EntityIronGolem_method_isPlayerCreated_9 = new ModData();
        reflect_EntityIronGolem_method_isPlayerCreated_9.set("methodName", "isPlayerCreated");
        reflect_EntityIronGolem_method_isPlayerCreated_9.set("returnType", "boolean");
        reflect_EntityIronGolem_method_isPlayerCreated_9.set("static", false);
        reflect_EntityIronGolem_method_isPlayerCreated_9.set("argnames", new String[]{});
        reflect_EntityIronGolem_method_isPlayerCreated_9.set("argtypes", new String[]{});
        reflect_EntityIronGolem_method_isPlayerCreated_9.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityIronGolem) params.getReflective("_self")).isPlayerCreated();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityIronGolem_methods.add(reflect_EntityIronGolem_method_isPlayerCreated_9);


        BaseData reflect_EntityIronGolem_method_setPlayerCreated_10 = new ModData();
        reflect_EntityIronGolem_method_setPlayerCreated_10.set("methodName", "setPlayerCreated");
        reflect_EntityIronGolem_method_setPlayerCreated_10.set("returnType", "void");
        reflect_EntityIronGolem_method_setPlayerCreated_10.set("static", false);
        reflect_EntityIronGolem_method_setPlayerCreated_10.set("argnames", new String[]{"parFlag"});
        reflect_EntityIronGolem_method_setPlayerCreated_10.set("argtypes", new String[]{"boolean"});
        reflect_EntityIronGolem_method_setPlayerCreated_10.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityIronGolem) params.getReflective("_self")).setPlayerCreated((boolean) params.getBoolean("parFlag"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityIronGolem_methods.add(reflect_EntityIronGolem_method_setPlayerCreated_10);


        BaseData reflect_EntityIronGolem_method_onDeath_11 = new ModData();
        reflect_EntityIronGolem_method_onDeath_11.set("methodName", "onDeath");
        reflect_EntityIronGolem_method_onDeath_11.set("returnType", "void");
        reflect_EntityIronGolem_method_onDeath_11.set("static", false);
        reflect_EntityIronGolem_method_onDeath_11.set("argnames", new String[]{"damagesource"});
        reflect_EntityIronGolem_method_onDeath_11.set("argtypes", new String[]{"DamageSource"});
        reflect_EntityIronGolem_method_onDeath_11.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityIronGolem) params.getReflective("_self")).onDeath((DamageSource) params.getReflective("damagesource"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityIronGolem_methods.add(reflect_EntityIronGolem_method_onDeath_11);


        BaseData[] reflect_EntityIronGolem_methods_arr = new BaseData[reflect_EntityIronGolem_methods.size()];
        for (int i = 0; i < reflect_EntityIronGolem_methods_arr.length; i++) {
            reflect_EntityIronGolem_methods_arr[i] = reflect_EntityIronGolem_methods.get(i);
        }

        reflect_EntityIronGolem.set("constructors", reflect_EntityIronGolem_constructors_arr);
        reflect_EntityIronGolem.set("methods", reflect_EntityIronGolem_methods_arr);
        reflect_EntityIronGolem.set("className", "EntityIronGolem");
        reflect_EntityIronGolem.set("classId", "net.minecraft.entity.monster.EntityIronGolem");
        reflect_EntityIronGolem.set("class", EntityIronGolem.class);
        reflect_EntityIronGolem.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityIronGolem;
        });
        reflectProfiles.add(reflect_EntityIronGolem);
    }


    //classdef for EntityMagmaCube
    public static void reflect_EntityMagmaCube_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityMagmaCube = new ModData();

        ArrayList<BaseData> reflect_EntityMagmaCube_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_EntityMagmaCube_constructor_EntityMagmaCube_0 = new ModData();
        reflect_EntityMagmaCube_constructor_EntityMagmaCube_0.set("returnType", "EntityMagmaCube");
        reflect_EntityMagmaCube_constructor_EntityMagmaCube_0.set("argnames", new String[]{"worldIn"});
        reflect_EntityMagmaCube_constructor_EntityMagmaCube_0.set("argtypes", new String[]{"World"});
        reflect_EntityMagmaCube_constructor_EntityMagmaCube_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityMagmaCube((World) params.getReflective("worldIn"));
        });
        
        reflect_EntityMagmaCube_constructors.add(reflect_EntityMagmaCube_constructor_EntityMagmaCube_0);


        BaseData[] reflect_EntityMagmaCube_constructors_arr = new BaseData[reflect_EntityMagmaCube_constructors.size()];
        for (int i = 0; i < reflect_EntityMagmaCube_constructors_arr.length; i++) {
            reflect_EntityMagmaCube_constructors_arr[i] = reflect_EntityMagmaCube_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityMagmaCube_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityMagmaCube_method_getCanSpawnHere_0 = new ModData();
        reflect_EntityMagmaCube_method_getCanSpawnHere_0.set("methodName", "getCanSpawnHere");
        reflect_EntityMagmaCube_method_getCanSpawnHere_0.set("returnType", "boolean");
        reflect_EntityMagmaCube_method_getCanSpawnHere_0.set("static", false);
        reflect_EntityMagmaCube_method_getCanSpawnHere_0.set("argnames", new String[]{});
        reflect_EntityMagmaCube_method_getCanSpawnHere_0.set("argtypes", new String[]{});
        reflect_EntityMagmaCube_method_getCanSpawnHere_0.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityMagmaCube) params.getReflective("_self")).getCanSpawnHere();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityMagmaCube_methods.add(reflect_EntityMagmaCube_method_getCanSpawnHere_0);


        BaseData reflect_EntityMagmaCube_method_isNotColliding_1 = new ModData();
        reflect_EntityMagmaCube_method_isNotColliding_1.set("methodName", "isNotColliding");
        reflect_EntityMagmaCube_method_isNotColliding_1.set("returnType", "boolean");
        reflect_EntityMagmaCube_method_isNotColliding_1.set("static", false);
        reflect_EntityMagmaCube_method_isNotColliding_1.set("argnames", new String[]{});
        reflect_EntityMagmaCube_method_isNotColliding_1.set("argtypes", new String[]{});
        reflect_EntityMagmaCube_method_isNotColliding_1.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityMagmaCube) params.getReflective("_self")).isNotColliding();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityMagmaCube_methods.add(reflect_EntityMagmaCube_method_isNotColliding_1);


        BaseData reflect_EntityMagmaCube_method_getTotalArmorValue_2 = new ModData();
        reflect_EntityMagmaCube_method_getTotalArmorValue_2.set("methodName", "getTotalArmorValue");
        reflect_EntityMagmaCube_method_getTotalArmorValue_2.set("returnType", "int");
        reflect_EntityMagmaCube_method_getTotalArmorValue_2.set("static", false);
        reflect_EntityMagmaCube_method_getTotalArmorValue_2.set("argnames", new String[]{});
        reflect_EntityMagmaCube_method_getTotalArmorValue_2.set("argtypes", new String[]{});
        reflect_EntityMagmaCube_method_getTotalArmorValue_2.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityMagmaCube) params.getReflective("_self")).getTotalArmorValue();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityMagmaCube_methods.add(reflect_EntityMagmaCube_method_getTotalArmorValue_2);


        BaseData reflect_EntityMagmaCube_method_getBrightnessForRender_3 = new ModData();
        reflect_EntityMagmaCube_method_getBrightnessForRender_3.set("methodName", "getBrightnessForRender");
        reflect_EntityMagmaCube_method_getBrightnessForRender_3.set("returnType", "int");
        reflect_EntityMagmaCube_method_getBrightnessForRender_3.set("static", false);
        reflect_EntityMagmaCube_method_getBrightnessForRender_3.set("argnames", new String[]{"var1"});
        reflect_EntityMagmaCube_method_getBrightnessForRender_3.set("argtypes", new String[]{"float"});
        reflect_EntityMagmaCube_method_getBrightnessForRender_3.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityMagmaCube) params.getReflective("_self")).getBrightnessForRender((float) params.getFloat("var1"));
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityMagmaCube_methods.add(reflect_EntityMagmaCube_method_getBrightnessForRender_3);


        BaseData reflect_EntityMagmaCube_method_getBrightness_4 = new ModData();
        reflect_EntityMagmaCube_method_getBrightness_4.set("methodName", "getBrightness");
        reflect_EntityMagmaCube_method_getBrightness_4.set("returnType", "float");
        reflect_EntityMagmaCube_method_getBrightness_4.set("static", false);
        reflect_EntityMagmaCube_method_getBrightness_4.set("argnames", new String[]{"var1"});
        reflect_EntityMagmaCube_method_getBrightness_4.set("argtypes", new String[]{"float"});
        reflect_EntityMagmaCube_method_getBrightness_4.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityMagmaCube) params.getReflective("_self")).getBrightness((float) params.getFloat("var1"));
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityMagmaCube_methods.add(reflect_EntityMagmaCube_method_getBrightness_4);


        BaseData reflect_EntityMagmaCube_method_isBurning_5 = new ModData();
        reflect_EntityMagmaCube_method_isBurning_5.set("methodName", "isBurning");
        reflect_EntityMagmaCube_method_isBurning_5.set("returnType", "boolean");
        reflect_EntityMagmaCube_method_isBurning_5.set("static", false);
        reflect_EntityMagmaCube_method_isBurning_5.set("argnames", new String[]{});
        reflect_EntityMagmaCube_method_isBurning_5.set("argtypes", new String[]{});
        reflect_EntityMagmaCube_method_isBurning_5.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityMagmaCube) params.getReflective("_self")).isBurning();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityMagmaCube_methods.add(reflect_EntityMagmaCube_method_isBurning_5);


        BaseData reflect_EntityMagmaCube_method_fall_6 = new ModData();
        reflect_EntityMagmaCube_method_fall_6.set("methodName", "fall");
        reflect_EntityMagmaCube_method_fall_6.set("returnType", "void");
        reflect_EntityMagmaCube_method_fall_6.set("static", false);
        reflect_EntityMagmaCube_method_fall_6.set("argnames", new String[]{"var1", "var2"});
        reflect_EntityMagmaCube_method_fall_6.set("argtypes", new String[]{"float", "float"});
        reflect_EntityMagmaCube_method_fall_6.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityMagmaCube) params.getReflective("_self")).fall((float) params.getFloat("var1"), (float) params.getFloat("var2"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityMagmaCube_methods.add(reflect_EntityMagmaCube_method_fall_6);


        BaseData[] reflect_EntityMagmaCube_methods_arr = new BaseData[reflect_EntityMagmaCube_methods.size()];
        for (int i = 0; i < reflect_EntityMagmaCube_methods_arr.length; i++) {
            reflect_EntityMagmaCube_methods_arr[i] = reflect_EntityMagmaCube_methods.get(i);
        }

        reflect_EntityMagmaCube.set("constructors", reflect_EntityMagmaCube_constructors_arr);
        reflect_EntityMagmaCube.set("methods", reflect_EntityMagmaCube_methods_arr);
        reflect_EntityMagmaCube.set("className", "EntityMagmaCube");
        reflect_EntityMagmaCube.set("classId", "net.minecraft.entity.monster.EntityMagmaCube");
        reflect_EntityMagmaCube.set("class", EntityMagmaCube.class);
        reflect_EntityMagmaCube.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityMagmaCube;
        });
        reflectProfiles.add(reflect_EntityMagmaCube);
    }


    //classdef for EntityMob
    public static void reflect_EntityMob_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityMob = new ModData();

        ArrayList<BaseData> reflect_EntityMob_constructors = new ArrayList<BaseData>();
        
        BaseData[] reflect_EntityMob_constructors_arr = new BaseData[reflect_EntityMob_constructors.size()];
        for (int i = 0; i < reflect_EntityMob_constructors_arr.length; i++) {
            reflect_EntityMob_constructors_arr[i] = reflect_EntityMob_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityMob_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityMob_method_onLivingUpdate_0 = new ModData();
        reflect_EntityMob_method_onLivingUpdate_0.set("methodName", "onLivingUpdate");
        reflect_EntityMob_method_onLivingUpdate_0.set("returnType", "void");
        reflect_EntityMob_method_onLivingUpdate_0.set("static", false);
        reflect_EntityMob_method_onLivingUpdate_0.set("argnames", new String[]{});
        reflect_EntityMob_method_onLivingUpdate_0.set("argtypes", new String[]{});
        reflect_EntityMob_method_onLivingUpdate_0.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityMob) params.getReflective("_self")).onLivingUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityMob_methods.add(reflect_EntityMob_method_onLivingUpdate_0);


        BaseData reflect_EntityMob_method_onUpdate_1 = new ModData();
        reflect_EntityMob_method_onUpdate_1.set("methodName", "onUpdate");
        reflect_EntityMob_method_onUpdate_1.set("returnType", "void");
        reflect_EntityMob_method_onUpdate_1.set("static", false);
        reflect_EntityMob_method_onUpdate_1.set("argnames", new String[]{});
        reflect_EntityMob_method_onUpdate_1.set("argtypes", new String[]{});
        reflect_EntityMob_method_onUpdate_1.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityMob) params.getReflective("_self")).onUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityMob_methods.add(reflect_EntityMob_method_onUpdate_1);


        BaseData reflect_EntityMob_method_attackEntityFrom_2 = new ModData();
        reflect_EntityMob_method_attackEntityFrom_2.set("methodName", "attackEntityFrom");
        reflect_EntityMob_method_attackEntityFrom_2.set("returnType", "boolean");
        reflect_EntityMob_method_attackEntityFrom_2.set("static", false);
        reflect_EntityMob_method_attackEntityFrom_2.set("argnames", new String[]{"damagesource", "f"});
        reflect_EntityMob_method_attackEntityFrom_2.set("argtypes", new String[]{"DamageSource", "float"});
        reflect_EntityMob_method_attackEntityFrom_2.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityMob) params.getReflective("_self")).attackEntityFrom((DamageSource) params.getReflective("damagesource"), (float) params.getFloat("f"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityMob_methods.add(reflect_EntityMob_method_attackEntityFrom_2);


        BaseData reflect_EntityMob_method_attackEntityAsMob_3 = new ModData();
        reflect_EntityMob_method_attackEntityAsMob_3.set("methodName", "attackEntityAsMob");
        reflect_EntityMob_method_attackEntityAsMob_3.set("returnType", "boolean");
        reflect_EntityMob_method_attackEntityAsMob_3.set("static", false);
        reflect_EntityMob_method_attackEntityAsMob_3.set("argnames", new String[]{"entity"});
        reflect_EntityMob_method_attackEntityAsMob_3.set("argtypes", new String[]{"Entity"});
        reflect_EntityMob_method_attackEntityAsMob_3.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityMob) params.getReflective("_self")).attackEntityAsMob((Entity) params.getReflective("entity"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityMob_methods.add(reflect_EntityMob_method_attackEntityAsMob_3);


        BaseData reflect_EntityMob_method_getBlockPathWeight_4 = new ModData();
        reflect_EntityMob_method_getBlockPathWeight_4.set("methodName", "getBlockPathWeight");
        reflect_EntityMob_method_getBlockPathWeight_4.set("returnType", "float");
        reflect_EntityMob_method_getBlockPathWeight_4.set("static", false);
        reflect_EntityMob_method_getBlockPathWeight_4.set("argnames", new String[]{"blockpos"});
        reflect_EntityMob_method_getBlockPathWeight_4.set("argtypes", new String[]{"BlockPos"});
        reflect_EntityMob_method_getBlockPathWeight_4.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityMob) params.getReflective("_self")).getBlockPathWeight((BlockPos) params.getReflective("blockpos"));
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityMob_methods.add(reflect_EntityMob_method_getBlockPathWeight_4);


        BaseData reflect_EntityMob_method_getCanSpawnHere_5 = new ModData();
        reflect_EntityMob_method_getCanSpawnHere_5.set("methodName", "getCanSpawnHere");
        reflect_EntityMob_method_getCanSpawnHere_5.set("returnType", "boolean");
        reflect_EntityMob_method_getCanSpawnHere_5.set("static", false);
        reflect_EntityMob_method_getCanSpawnHere_5.set("argnames", new String[]{});
        reflect_EntityMob_method_getCanSpawnHere_5.set("argtypes", new String[]{});
        reflect_EntityMob_method_getCanSpawnHere_5.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityMob) params.getReflective("_self")).getCanSpawnHere();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityMob_methods.add(reflect_EntityMob_method_getCanSpawnHere_5);


        BaseData[] reflect_EntityMob_methods_arr = new BaseData[reflect_EntityMob_methods.size()];
        for (int i = 0; i < reflect_EntityMob_methods_arr.length; i++) {
            reflect_EntityMob_methods_arr[i] = reflect_EntityMob_methods.get(i);
        }

        reflect_EntityMob.set("constructors", reflect_EntityMob_constructors_arr);
        reflect_EntityMob.set("methods", reflect_EntityMob_methods_arr);
        reflect_EntityMob.set("className", "EntityMob");
        reflect_EntityMob.set("classId", "net.minecraft.entity.monster.EntityMob");
        reflect_EntityMob.set("class", EntityMob.class);
        reflect_EntityMob.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityMob;
        });
        reflectProfiles.add(reflect_EntityMob);
    }


    //classdef for EntityPigZombie
    public static void reflect_EntityPigZombie_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityPigZombie = new ModData();

        ArrayList<BaseData> reflect_EntityPigZombie_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_EntityPigZombie_constructor_EntityPigZombie_0 = new ModData();
        reflect_EntityPigZombie_constructor_EntityPigZombie_0.set("returnType", "EntityPigZombie");
        reflect_EntityPigZombie_constructor_EntityPigZombie_0.set("argnames", new String[]{"worldIn"});
        reflect_EntityPigZombie_constructor_EntityPigZombie_0.set("argtypes", new String[]{"World"});
        reflect_EntityPigZombie_constructor_EntityPigZombie_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityPigZombie((World) params.getReflective("worldIn"));
        });
        
        reflect_EntityPigZombie_constructors.add(reflect_EntityPigZombie_constructor_EntityPigZombie_0);


        BaseData[] reflect_EntityPigZombie_constructors_arr = new BaseData[reflect_EntityPigZombie_constructors.size()];
        for (int i = 0; i < reflect_EntityPigZombie_constructors_arr.length; i++) {
            reflect_EntityPigZombie_constructors_arr[i] = reflect_EntityPigZombie_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityPigZombie_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityPigZombie_method_setRevengeTarget_0 = new ModData();
        reflect_EntityPigZombie_method_setRevengeTarget_0.set("methodName", "setRevengeTarget");
        reflect_EntityPigZombie_method_setRevengeTarget_0.set("returnType", "void");
        reflect_EntityPigZombie_method_setRevengeTarget_0.set("static", false);
        reflect_EntityPigZombie_method_setRevengeTarget_0.set("argnames", new String[]{"entitylivingbase"});
        reflect_EntityPigZombie_method_setRevengeTarget_0.set("argtypes", new String[]{"EntityLivingBase"});
        reflect_EntityPigZombie_method_setRevengeTarget_0.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPigZombie) params.getReflective("_self")).setRevengeTarget((EntityLivingBase) params.getReflective("entitylivingbase"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPigZombie_methods.add(reflect_EntityPigZombie_method_setRevengeTarget_0);


        BaseData reflect_EntityPigZombie_method_onUpdate_1 = new ModData();
        reflect_EntityPigZombie_method_onUpdate_1.set("methodName", "onUpdate");
        reflect_EntityPigZombie_method_onUpdate_1.set("returnType", "void");
        reflect_EntityPigZombie_method_onUpdate_1.set("static", false);
        reflect_EntityPigZombie_method_onUpdate_1.set("argnames", new String[]{});
        reflect_EntityPigZombie_method_onUpdate_1.set("argtypes", new String[]{});
        reflect_EntityPigZombie_method_onUpdate_1.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPigZombie) params.getReflective("_self")).onUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPigZombie_methods.add(reflect_EntityPigZombie_method_onUpdate_1);


        BaseData reflect_EntityPigZombie_method_getCanSpawnHere_2 = new ModData();
        reflect_EntityPigZombie_method_getCanSpawnHere_2.set("methodName", "getCanSpawnHere");
        reflect_EntityPigZombie_method_getCanSpawnHere_2.set("returnType", "boolean");
        reflect_EntityPigZombie_method_getCanSpawnHere_2.set("static", false);
        reflect_EntityPigZombie_method_getCanSpawnHere_2.set("argnames", new String[]{});
        reflect_EntityPigZombie_method_getCanSpawnHere_2.set("argtypes", new String[]{});
        reflect_EntityPigZombie_method_getCanSpawnHere_2.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityPigZombie) params.getReflective("_self")).getCanSpawnHere();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityPigZombie_methods.add(reflect_EntityPigZombie_method_getCanSpawnHere_2);


        BaseData reflect_EntityPigZombie_method_isNotColliding_3 = new ModData();
        reflect_EntityPigZombie_method_isNotColliding_3.set("methodName", "isNotColliding");
        reflect_EntityPigZombie_method_isNotColliding_3.set("returnType", "boolean");
        reflect_EntityPigZombie_method_isNotColliding_3.set("static", false);
        reflect_EntityPigZombie_method_isNotColliding_3.set("argnames", new String[]{});
        reflect_EntityPigZombie_method_isNotColliding_3.set("argtypes", new String[]{});
        reflect_EntityPigZombie_method_isNotColliding_3.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityPigZombie) params.getReflective("_self")).isNotColliding();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityPigZombie_methods.add(reflect_EntityPigZombie_method_isNotColliding_3);


        BaseData reflect_EntityPigZombie_method_writeEntityToNBT_4 = new ModData();
        reflect_EntityPigZombie_method_writeEntityToNBT_4.set("methodName", "writeEntityToNBT");
        reflect_EntityPigZombie_method_writeEntityToNBT_4.set("returnType", "void");
        reflect_EntityPigZombie_method_writeEntityToNBT_4.set("static", false);
        reflect_EntityPigZombie_method_writeEntityToNBT_4.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityPigZombie_method_writeEntityToNBT_4.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityPigZombie_method_writeEntityToNBT_4.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPigZombie) params.getReflective("_self")).writeEntityToNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPigZombie_methods.add(reflect_EntityPigZombie_method_writeEntityToNBT_4);


        BaseData reflect_EntityPigZombie_method_readEntityFromNBT_5 = new ModData();
        reflect_EntityPigZombie_method_readEntityFromNBT_5.set("methodName", "readEntityFromNBT");
        reflect_EntityPigZombie_method_readEntityFromNBT_5.set("returnType", "void");
        reflect_EntityPigZombie_method_readEntityFromNBT_5.set("static", false);
        reflect_EntityPigZombie_method_readEntityFromNBT_5.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityPigZombie_method_readEntityFromNBT_5.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityPigZombie_method_readEntityFromNBT_5.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPigZombie) params.getReflective("_self")).readEntityFromNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPigZombie_methods.add(reflect_EntityPigZombie_method_readEntityFromNBT_5);


        BaseData reflect_EntityPigZombie_method_attackEntityFrom_6 = new ModData();
        reflect_EntityPigZombie_method_attackEntityFrom_6.set("methodName", "attackEntityFrom");
        reflect_EntityPigZombie_method_attackEntityFrom_6.set("returnType", "boolean");
        reflect_EntityPigZombie_method_attackEntityFrom_6.set("static", false);
        reflect_EntityPigZombie_method_attackEntityFrom_6.set("argnames", new String[]{"damagesource", "f"});
        reflect_EntityPigZombie_method_attackEntityFrom_6.set("argtypes", new String[]{"DamageSource", "float"});
        reflect_EntityPigZombie_method_attackEntityFrom_6.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityPigZombie) params.getReflective("_self")).attackEntityFrom((DamageSource) params.getReflective("damagesource"), (float) params.getFloat("f"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityPigZombie_methods.add(reflect_EntityPigZombie_method_attackEntityFrom_6);


        BaseData reflect_EntityPigZombie_method_isAngry_7 = new ModData();
        reflect_EntityPigZombie_method_isAngry_7.set("methodName", "isAngry");
        reflect_EntityPigZombie_method_isAngry_7.set("returnType", "boolean");
        reflect_EntityPigZombie_method_isAngry_7.set("static", false);
        reflect_EntityPigZombie_method_isAngry_7.set("argnames", new String[]{});
        reflect_EntityPigZombie_method_isAngry_7.set("argtypes", new String[]{});
        reflect_EntityPigZombie_method_isAngry_7.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityPigZombie) params.getReflective("_self")).isAngry();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityPigZombie_methods.add(reflect_EntityPigZombie_method_isAngry_7);


        BaseData reflect_EntityPigZombie_method_interact_8 = new ModData();
        reflect_EntityPigZombie_method_interact_8.set("methodName", "interact");
        reflect_EntityPigZombie_method_interact_8.set("returnType", "boolean");
        reflect_EntityPigZombie_method_interact_8.set("static", false);
        reflect_EntityPigZombie_method_interact_8.set("argnames", new String[]{"var1"});
        reflect_EntityPigZombie_method_interact_8.set("argtypes", new String[]{"EntityPlayer"});
        reflect_EntityPigZombie_method_interact_8.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityPigZombie) params.getReflective("_self")).interact((EntityPlayer) params.getReflective("var1"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityPigZombie_methods.add(reflect_EntityPigZombie_method_interact_8);


        BaseData[] reflect_EntityPigZombie_methods_arr = new BaseData[reflect_EntityPigZombie_methods.size()];
        for (int i = 0; i < reflect_EntityPigZombie_methods_arr.length; i++) {
            reflect_EntityPigZombie_methods_arr[i] = reflect_EntityPigZombie_methods.get(i);
        }

        reflect_EntityPigZombie.set("constructors", reflect_EntityPigZombie_constructors_arr);
        reflect_EntityPigZombie.set("methods", reflect_EntityPigZombie_methods_arr);
        reflect_EntityPigZombie.set("className", "EntityPigZombie");
        reflect_EntityPigZombie.set("classId", "net.minecraft.entity.monster.EntityPigZombie");
        reflect_EntityPigZombie.set("class", EntityPigZombie.class);
        reflect_EntityPigZombie.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityPigZombie;
        });
        reflectProfiles.add(reflect_EntityPigZombie);
    }


    //classdef for EntitySilverfish
    public static void reflect_EntitySilverfish_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntitySilverfish = new ModData();

        ArrayList<BaseData> reflect_EntitySilverfish_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_EntitySilverfish_constructor_EntitySilverfish_0 = new ModData();
        reflect_EntitySilverfish_constructor_EntitySilverfish_0.set("returnType", "EntitySilverfish");
        reflect_EntitySilverfish_constructor_EntitySilverfish_0.set("argnames", new String[]{"worldIn"});
        reflect_EntitySilverfish_constructor_EntitySilverfish_0.set("argtypes", new String[]{"World"});
        reflect_EntitySilverfish_constructor_EntitySilverfish_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntitySilverfish((World) params.getReflective("worldIn"));
        });
        
        reflect_EntitySilverfish_constructors.add(reflect_EntitySilverfish_constructor_EntitySilverfish_0);


        BaseData[] reflect_EntitySilverfish_constructors_arr = new BaseData[reflect_EntitySilverfish_constructors.size()];
        for (int i = 0; i < reflect_EntitySilverfish_constructors_arr.length; i++) {
            reflect_EntitySilverfish_constructors_arr[i] = reflect_EntitySilverfish_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntitySilverfish_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntitySilverfish_method_getYOffset_0 = new ModData();
        reflect_EntitySilverfish_method_getYOffset_0.set("methodName", "getYOffset");
        reflect_EntitySilverfish_method_getYOffset_0.set("returnType", "double");
        reflect_EntitySilverfish_method_getYOffset_0.set("static", false);
        reflect_EntitySilverfish_method_getYOffset_0.set("argnames", new String[]{});
        reflect_EntitySilverfish_method_getYOffset_0.set("argtypes", new String[]{});
        reflect_EntitySilverfish_method_getYOffset_0.setCallbackDoubleWithDataArg("exec", (BaseData params) -> {
                try {
                    return (double) ((EntitySilverfish) params.getReflective("_self")).getYOffset();
                } catch (Exception _exception_reflect_) {
                    return 0.0d;
                }
            });
            
        reflect_EntitySilverfish_methods.add(reflect_EntitySilverfish_method_getYOffset_0);


        BaseData reflect_EntitySilverfish_method_getEyeHeight_1 = new ModData();
        reflect_EntitySilverfish_method_getEyeHeight_1.set("methodName", "getEyeHeight");
        reflect_EntitySilverfish_method_getEyeHeight_1.set("returnType", "float");
        reflect_EntitySilverfish_method_getEyeHeight_1.set("static", false);
        reflect_EntitySilverfish_method_getEyeHeight_1.set("argnames", new String[]{});
        reflect_EntitySilverfish_method_getEyeHeight_1.set("argtypes", new String[]{});
        reflect_EntitySilverfish_method_getEyeHeight_1.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntitySilverfish) params.getReflective("_self")).getEyeHeight();
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntitySilverfish_methods.add(reflect_EntitySilverfish_method_getEyeHeight_1);


        BaseData reflect_EntitySilverfish_method_attackEntityFrom_2 = new ModData();
        reflect_EntitySilverfish_method_attackEntityFrom_2.set("methodName", "attackEntityFrom");
        reflect_EntitySilverfish_method_attackEntityFrom_2.set("returnType", "boolean");
        reflect_EntitySilverfish_method_attackEntityFrom_2.set("static", false);
        reflect_EntitySilverfish_method_attackEntityFrom_2.set("argnames", new String[]{"damagesource", "f"});
        reflect_EntitySilverfish_method_attackEntityFrom_2.set("argtypes", new String[]{"DamageSource", "float"});
        reflect_EntitySilverfish_method_attackEntityFrom_2.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntitySilverfish) params.getReflective("_self")).attackEntityFrom((DamageSource) params.getReflective("damagesource"), (float) params.getFloat("f"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntitySilverfish_methods.add(reflect_EntitySilverfish_method_attackEntityFrom_2);


        BaseData reflect_EntitySilverfish_method_onUpdate_3 = new ModData();
        reflect_EntitySilverfish_method_onUpdate_3.set("methodName", "onUpdate");
        reflect_EntitySilverfish_method_onUpdate_3.set("returnType", "void");
        reflect_EntitySilverfish_method_onUpdate_3.set("static", false);
        reflect_EntitySilverfish_method_onUpdate_3.set("argnames", new String[]{});
        reflect_EntitySilverfish_method_onUpdate_3.set("argtypes", new String[]{});
        reflect_EntitySilverfish_method_onUpdate_3.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntitySilverfish) params.getReflective("_self")).onUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntitySilverfish_methods.add(reflect_EntitySilverfish_method_onUpdate_3);


        BaseData reflect_EntitySilverfish_method_getBlockPathWeight_4 = new ModData();
        reflect_EntitySilverfish_method_getBlockPathWeight_4.set("methodName", "getBlockPathWeight");
        reflect_EntitySilverfish_method_getBlockPathWeight_4.set("returnType", "float");
        reflect_EntitySilverfish_method_getBlockPathWeight_4.set("static", false);
        reflect_EntitySilverfish_method_getBlockPathWeight_4.set("argnames", new String[]{"blockpos"});
        reflect_EntitySilverfish_method_getBlockPathWeight_4.set("argtypes", new String[]{"BlockPos"});
        reflect_EntitySilverfish_method_getBlockPathWeight_4.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntitySilverfish) params.getReflective("_self")).getBlockPathWeight((BlockPos) params.getReflective("blockpos"));
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntitySilverfish_methods.add(reflect_EntitySilverfish_method_getBlockPathWeight_4);


        BaseData reflect_EntitySilverfish_method_getCanSpawnHere_5 = new ModData();
        reflect_EntitySilverfish_method_getCanSpawnHere_5.set("methodName", "getCanSpawnHere");
        reflect_EntitySilverfish_method_getCanSpawnHere_5.set("returnType", "boolean");
        reflect_EntitySilverfish_method_getCanSpawnHere_5.set("static", false);
        reflect_EntitySilverfish_method_getCanSpawnHere_5.set("argnames", new String[]{});
        reflect_EntitySilverfish_method_getCanSpawnHere_5.set("argtypes", new String[]{});
        reflect_EntitySilverfish_method_getCanSpawnHere_5.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntitySilverfish) params.getReflective("_self")).getCanSpawnHere();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntitySilverfish_methods.add(reflect_EntitySilverfish_method_getCanSpawnHere_5);


        BaseData reflect_EntitySilverfish_method_getCreatureAttribute_6 = new ModData();
        reflect_EntitySilverfish_method_getCreatureAttribute_6.set("methodName", "getCreatureAttribute");
        reflect_EntitySilverfish_method_getCreatureAttribute_6.set("returnType", "EnumCreatureAttribute");
        reflect_EntitySilverfish_method_getCreatureAttribute_6.set("static", false);
        reflect_EntitySilverfish_method_getCreatureAttribute_6.set("argnames", new String[]{});
        reflect_EntitySilverfish_method_getCreatureAttribute_6.set("argtypes", new String[]{});
        reflect_EntitySilverfish_method_getCreatureAttribute_6.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EnumCreatureAttribute) ((EntitySilverfish) params.getReflective("_self")).getCreatureAttribute();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntitySilverfish_methods.add(reflect_EntitySilverfish_method_getCreatureAttribute_6);


        BaseData[] reflect_EntitySilverfish_methods_arr = new BaseData[reflect_EntitySilverfish_methods.size()];
        for (int i = 0; i < reflect_EntitySilverfish_methods_arr.length; i++) {
            reflect_EntitySilverfish_methods_arr[i] = reflect_EntitySilverfish_methods.get(i);
        }

        reflect_EntitySilverfish.set("constructors", reflect_EntitySilverfish_constructors_arr);
        reflect_EntitySilverfish.set("methods", reflect_EntitySilverfish_methods_arr);
        reflect_EntitySilverfish.set("className", "EntitySilverfish");
        reflect_EntitySilverfish.set("classId", "net.minecraft.entity.monster.EntitySilverfish");
        reflect_EntitySilverfish.set("class", EntitySilverfish.class);
        reflect_EntitySilverfish.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntitySilverfish;
        });
        reflectProfiles.add(reflect_EntitySilverfish);
    }


    //classdef for EntitySkeleton
    public static void reflect_EntitySkeleton_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntitySkeleton = new ModData();

        ArrayList<BaseData> reflect_EntitySkeleton_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_EntitySkeleton_constructor_EntitySkeleton_0 = new ModData();
        reflect_EntitySkeleton_constructor_EntitySkeleton_0.set("returnType", "EntitySkeleton");
        reflect_EntitySkeleton_constructor_EntitySkeleton_0.set("argnames", new String[]{"worldIn"});
        reflect_EntitySkeleton_constructor_EntitySkeleton_0.set("argtypes", new String[]{"World"});
        reflect_EntitySkeleton_constructor_EntitySkeleton_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntitySkeleton((World) params.getReflective("worldIn"));
        });
        
        reflect_EntitySkeleton_constructors.add(reflect_EntitySkeleton_constructor_EntitySkeleton_0);


        BaseData[] reflect_EntitySkeleton_constructors_arr = new BaseData[reflect_EntitySkeleton_constructors.size()];
        for (int i = 0; i < reflect_EntitySkeleton_constructors_arr.length; i++) {
            reflect_EntitySkeleton_constructors_arr[i] = reflect_EntitySkeleton_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntitySkeleton_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntitySkeleton_method_attackEntityAsMob_0 = new ModData();
        reflect_EntitySkeleton_method_attackEntityAsMob_0.set("methodName", "attackEntityAsMob");
        reflect_EntitySkeleton_method_attackEntityAsMob_0.set("returnType", "boolean");
        reflect_EntitySkeleton_method_attackEntityAsMob_0.set("static", false);
        reflect_EntitySkeleton_method_attackEntityAsMob_0.set("argnames", new String[]{"entity"});
        reflect_EntitySkeleton_method_attackEntityAsMob_0.set("argtypes", new String[]{"Entity"});
        reflect_EntitySkeleton_method_attackEntityAsMob_0.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntitySkeleton) params.getReflective("_self")).attackEntityAsMob((Entity) params.getReflective("entity"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntitySkeleton_methods.add(reflect_EntitySkeleton_method_attackEntityAsMob_0);


        BaseData reflect_EntitySkeleton_method_getCreatureAttribute_1 = new ModData();
        reflect_EntitySkeleton_method_getCreatureAttribute_1.set("methodName", "getCreatureAttribute");
        reflect_EntitySkeleton_method_getCreatureAttribute_1.set("returnType", "EnumCreatureAttribute");
        reflect_EntitySkeleton_method_getCreatureAttribute_1.set("static", false);
        reflect_EntitySkeleton_method_getCreatureAttribute_1.set("argnames", new String[]{});
        reflect_EntitySkeleton_method_getCreatureAttribute_1.set("argtypes", new String[]{});
        reflect_EntitySkeleton_method_getCreatureAttribute_1.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EnumCreatureAttribute) ((EntitySkeleton) params.getReflective("_self")).getCreatureAttribute();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntitySkeleton_methods.add(reflect_EntitySkeleton_method_getCreatureAttribute_1);


        BaseData reflect_EntitySkeleton_method_onLivingUpdate_2 = new ModData();
        reflect_EntitySkeleton_method_onLivingUpdate_2.set("methodName", "onLivingUpdate");
        reflect_EntitySkeleton_method_onLivingUpdate_2.set("returnType", "void");
        reflect_EntitySkeleton_method_onLivingUpdate_2.set("static", false);
        reflect_EntitySkeleton_method_onLivingUpdate_2.set("argnames", new String[]{});
        reflect_EntitySkeleton_method_onLivingUpdate_2.set("argtypes", new String[]{});
        reflect_EntitySkeleton_method_onLivingUpdate_2.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntitySkeleton) params.getReflective("_self")).onLivingUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntitySkeleton_methods.add(reflect_EntitySkeleton_method_onLivingUpdate_2);


        BaseData reflect_EntitySkeleton_method_updateRidden_3 = new ModData();
        reflect_EntitySkeleton_method_updateRidden_3.set("methodName", "updateRidden");
        reflect_EntitySkeleton_method_updateRidden_3.set("returnType", "void");
        reflect_EntitySkeleton_method_updateRidden_3.set("static", false);
        reflect_EntitySkeleton_method_updateRidden_3.set("argnames", new String[]{});
        reflect_EntitySkeleton_method_updateRidden_3.set("argtypes", new String[]{});
        reflect_EntitySkeleton_method_updateRidden_3.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntitySkeleton) params.getReflective("_self")).updateRidden();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntitySkeleton_methods.add(reflect_EntitySkeleton_method_updateRidden_3);


        BaseData reflect_EntitySkeleton_method_onDeath_4 = new ModData();
        reflect_EntitySkeleton_method_onDeath_4.set("methodName", "onDeath");
        reflect_EntitySkeleton_method_onDeath_4.set("returnType", "void");
        reflect_EntitySkeleton_method_onDeath_4.set("static", false);
        reflect_EntitySkeleton_method_onDeath_4.set("argnames", new String[]{"damagesource"});
        reflect_EntitySkeleton_method_onDeath_4.set("argtypes", new String[]{"DamageSource"});
        reflect_EntitySkeleton_method_onDeath_4.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntitySkeleton) params.getReflective("_self")).onDeath((DamageSource) params.getReflective("damagesource"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntitySkeleton_methods.add(reflect_EntitySkeleton_method_onDeath_4);


        BaseData reflect_EntitySkeleton_method_setCombatTask_5 = new ModData();
        reflect_EntitySkeleton_method_setCombatTask_5.set("methodName", "setCombatTask");
        reflect_EntitySkeleton_method_setCombatTask_5.set("returnType", "void");
        reflect_EntitySkeleton_method_setCombatTask_5.set("static", false);
        reflect_EntitySkeleton_method_setCombatTask_5.set("argnames", new String[]{});
        reflect_EntitySkeleton_method_setCombatTask_5.set("argtypes", new String[]{});
        reflect_EntitySkeleton_method_setCombatTask_5.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntitySkeleton) params.getReflective("_self")).setCombatTask();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntitySkeleton_methods.add(reflect_EntitySkeleton_method_setCombatTask_5);


        BaseData reflect_EntitySkeleton_method_attackEntityWithRangedAttack_6 = new ModData();
        reflect_EntitySkeleton_method_attackEntityWithRangedAttack_6.set("methodName", "attackEntityWithRangedAttack");
        reflect_EntitySkeleton_method_attackEntityWithRangedAttack_6.set("returnType", "void");
        reflect_EntitySkeleton_method_attackEntityWithRangedAttack_6.set("static", false);
        reflect_EntitySkeleton_method_attackEntityWithRangedAttack_6.set("argnames", new String[]{"entitylivingbase", "f"});
        reflect_EntitySkeleton_method_attackEntityWithRangedAttack_6.set("argtypes", new String[]{"EntityLivingBase", "float"});
        reflect_EntitySkeleton_method_attackEntityWithRangedAttack_6.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntitySkeleton) params.getReflective("_self")).attackEntityWithRangedAttack((EntityLivingBase) params.getReflective("entitylivingbase"), (float) params.getFloat("f"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntitySkeleton_methods.add(reflect_EntitySkeleton_method_attackEntityWithRangedAttack_6);


        BaseData reflect_EntitySkeleton_method_getSkeletonType_7 = new ModData();
        reflect_EntitySkeleton_method_getSkeletonType_7.set("methodName", "getSkeletonType");
        reflect_EntitySkeleton_method_getSkeletonType_7.set("returnType", "int");
        reflect_EntitySkeleton_method_getSkeletonType_7.set("static", false);
        reflect_EntitySkeleton_method_getSkeletonType_7.set("argnames", new String[]{});
        reflect_EntitySkeleton_method_getSkeletonType_7.set("argtypes", new String[]{});
        reflect_EntitySkeleton_method_getSkeletonType_7.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntitySkeleton) params.getReflective("_self")).getSkeletonType();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntitySkeleton_methods.add(reflect_EntitySkeleton_method_getSkeletonType_7);


        BaseData reflect_EntitySkeleton_method_setSkeletonType_8 = new ModData();
        reflect_EntitySkeleton_method_setSkeletonType_8.set("methodName", "setSkeletonType");
        reflect_EntitySkeleton_method_setSkeletonType_8.set("returnType", "void");
        reflect_EntitySkeleton_method_setSkeletonType_8.set("static", false);
        reflect_EntitySkeleton_method_setSkeletonType_8.set("argnames", new String[]{"parInt1"});
        reflect_EntitySkeleton_method_setSkeletonType_8.set("argtypes", new String[]{"int"});
        reflect_EntitySkeleton_method_setSkeletonType_8.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntitySkeleton) params.getReflective("_self")).setSkeletonType((int) params.getInt("parInt1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntitySkeleton_methods.add(reflect_EntitySkeleton_method_setSkeletonType_8);


        BaseData reflect_EntitySkeleton_method_readEntityFromNBT_9 = new ModData();
        reflect_EntitySkeleton_method_readEntityFromNBT_9.set("methodName", "readEntityFromNBT");
        reflect_EntitySkeleton_method_readEntityFromNBT_9.set("returnType", "void");
        reflect_EntitySkeleton_method_readEntityFromNBT_9.set("static", false);
        reflect_EntitySkeleton_method_readEntityFromNBT_9.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntitySkeleton_method_readEntityFromNBT_9.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntitySkeleton_method_readEntityFromNBT_9.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntitySkeleton) params.getReflective("_self")).readEntityFromNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntitySkeleton_methods.add(reflect_EntitySkeleton_method_readEntityFromNBT_9);


        BaseData reflect_EntitySkeleton_method_writeEntityToNBT_10 = new ModData();
        reflect_EntitySkeleton_method_writeEntityToNBT_10.set("methodName", "writeEntityToNBT");
        reflect_EntitySkeleton_method_writeEntityToNBT_10.set("returnType", "void");
        reflect_EntitySkeleton_method_writeEntityToNBT_10.set("static", false);
        reflect_EntitySkeleton_method_writeEntityToNBT_10.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntitySkeleton_method_writeEntityToNBT_10.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntitySkeleton_method_writeEntityToNBT_10.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntitySkeleton) params.getReflective("_self")).writeEntityToNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntitySkeleton_methods.add(reflect_EntitySkeleton_method_writeEntityToNBT_10);


        BaseData reflect_EntitySkeleton_method_setCurrentItemOrArmor_11 = new ModData();
        reflect_EntitySkeleton_method_setCurrentItemOrArmor_11.set("methodName", "setCurrentItemOrArmor");
        reflect_EntitySkeleton_method_setCurrentItemOrArmor_11.set("returnType", "void");
        reflect_EntitySkeleton_method_setCurrentItemOrArmor_11.set("static", false);
        reflect_EntitySkeleton_method_setCurrentItemOrArmor_11.set("argnames", new String[]{"i", "itemstack"});
        reflect_EntitySkeleton_method_setCurrentItemOrArmor_11.set("argtypes", new String[]{"int", "ItemStack"});
        reflect_EntitySkeleton_method_setCurrentItemOrArmor_11.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntitySkeleton) params.getReflective("_self")).setCurrentItemOrArmor((int) params.getInt("i"), (ItemStack) params.getReflective("itemstack"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntitySkeleton_methods.add(reflect_EntitySkeleton_method_setCurrentItemOrArmor_11);


        BaseData reflect_EntitySkeleton_method_getEyeHeight_12 = new ModData();
        reflect_EntitySkeleton_method_getEyeHeight_12.set("methodName", "getEyeHeight");
        reflect_EntitySkeleton_method_getEyeHeight_12.set("returnType", "float");
        reflect_EntitySkeleton_method_getEyeHeight_12.set("static", false);
        reflect_EntitySkeleton_method_getEyeHeight_12.set("argnames", new String[]{});
        reflect_EntitySkeleton_method_getEyeHeight_12.set("argtypes", new String[]{});
        reflect_EntitySkeleton_method_getEyeHeight_12.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntitySkeleton) params.getReflective("_self")).getEyeHeight();
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntitySkeleton_methods.add(reflect_EntitySkeleton_method_getEyeHeight_12);


        BaseData reflect_EntitySkeleton_method_getYOffset_13 = new ModData();
        reflect_EntitySkeleton_method_getYOffset_13.set("methodName", "getYOffset");
        reflect_EntitySkeleton_method_getYOffset_13.set("returnType", "double");
        reflect_EntitySkeleton_method_getYOffset_13.set("static", false);
        reflect_EntitySkeleton_method_getYOffset_13.set("argnames", new String[]{});
        reflect_EntitySkeleton_method_getYOffset_13.set("argtypes", new String[]{});
        reflect_EntitySkeleton_method_getYOffset_13.setCallbackDoubleWithDataArg("exec", (BaseData params) -> {
                try {
                    return (double) ((EntitySkeleton) params.getReflective("_self")).getYOffset();
                } catch (Exception _exception_reflect_) {
                    return 0.0d;
                }
            });
            
        reflect_EntitySkeleton_methods.add(reflect_EntitySkeleton_method_getYOffset_13);


        BaseData[] reflect_EntitySkeleton_methods_arr = new BaseData[reflect_EntitySkeleton_methods.size()];
        for (int i = 0; i < reflect_EntitySkeleton_methods_arr.length; i++) {
            reflect_EntitySkeleton_methods_arr[i] = reflect_EntitySkeleton_methods.get(i);
        }

        reflect_EntitySkeleton.set("constructors", reflect_EntitySkeleton_constructors_arr);
        reflect_EntitySkeleton.set("methods", reflect_EntitySkeleton_methods_arr);
        reflect_EntitySkeleton.set("className", "EntitySkeleton");
        reflect_EntitySkeleton.set("classId", "net.minecraft.entity.monster.EntitySkeleton");
        reflect_EntitySkeleton.set("class", EntitySkeleton.class);
        reflect_EntitySkeleton.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntitySkeleton;
        });
        reflectProfiles.add(reflect_EntitySkeleton);
    }


    //classdef for EntitySlime
    public static void reflect_EntitySlime_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntitySlime = new ModData();

        ArrayList<BaseData> reflect_EntitySlime_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_EntitySlime_constructor_EntitySlime_0 = new ModData();
        reflect_EntitySlime_constructor_EntitySlime_0.set("returnType", "EntitySlime");
        reflect_EntitySlime_constructor_EntitySlime_0.set("argnames", new String[]{"worldIn"});
        reflect_EntitySlime_constructor_EntitySlime_0.set("argtypes", new String[]{"World"});
        reflect_EntitySlime_constructor_EntitySlime_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntitySlime((World) params.getReflective("worldIn"));
        });
        
        reflect_EntitySlime_constructors.add(reflect_EntitySlime_constructor_EntitySlime_0);


        BaseData[] reflect_EntitySlime_constructors_arr = new BaseData[reflect_EntitySlime_constructors.size()];
        for (int i = 0; i < reflect_EntitySlime_constructors_arr.length; i++) {
            reflect_EntitySlime_constructors_arr[i] = reflect_EntitySlime_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntitySlime_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntitySlime_method_getSlimeSize_0 = new ModData();
        reflect_EntitySlime_method_getSlimeSize_0.set("methodName", "getSlimeSize");
        reflect_EntitySlime_method_getSlimeSize_0.set("returnType", "int");
        reflect_EntitySlime_method_getSlimeSize_0.set("static", false);
        reflect_EntitySlime_method_getSlimeSize_0.set("argnames", new String[]{});
        reflect_EntitySlime_method_getSlimeSize_0.set("argtypes", new String[]{});
        reflect_EntitySlime_method_getSlimeSize_0.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntitySlime) params.getReflective("_self")).getSlimeSize();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntitySlime_methods.add(reflect_EntitySlime_method_getSlimeSize_0);


        BaseData reflect_EntitySlime_method_writeEntityToNBT_1 = new ModData();
        reflect_EntitySlime_method_writeEntityToNBT_1.set("methodName", "writeEntityToNBT");
        reflect_EntitySlime_method_writeEntityToNBT_1.set("returnType", "void");
        reflect_EntitySlime_method_writeEntityToNBT_1.set("static", false);
        reflect_EntitySlime_method_writeEntityToNBT_1.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntitySlime_method_writeEntityToNBT_1.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntitySlime_method_writeEntityToNBT_1.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntitySlime) params.getReflective("_self")).writeEntityToNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntitySlime_methods.add(reflect_EntitySlime_method_writeEntityToNBT_1);


        BaseData reflect_EntitySlime_method_readEntityFromNBT_2 = new ModData();
        reflect_EntitySlime_method_readEntityFromNBT_2.set("methodName", "readEntityFromNBT");
        reflect_EntitySlime_method_readEntityFromNBT_2.set("returnType", "void");
        reflect_EntitySlime_method_readEntityFromNBT_2.set("static", false);
        reflect_EntitySlime_method_readEntityFromNBT_2.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntitySlime_method_readEntityFromNBT_2.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntitySlime_method_readEntityFromNBT_2.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntitySlime) params.getReflective("_self")).readEntityFromNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntitySlime_methods.add(reflect_EntitySlime_method_readEntityFromNBT_2);


        BaseData reflect_EntitySlime_method_onUpdate_3 = new ModData();
        reflect_EntitySlime_method_onUpdate_3.set("methodName", "onUpdate");
        reflect_EntitySlime_method_onUpdate_3.set("returnType", "void");
        reflect_EntitySlime_method_onUpdate_3.set("static", false);
        reflect_EntitySlime_method_onUpdate_3.set("argnames", new String[]{});
        reflect_EntitySlime_method_onUpdate_3.set("argtypes", new String[]{});
        reflect_EntitySlime_method_onUpdate_3.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntitySlime) params.getReflective("_self")).onUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntitySlime_methods.add(reflect_EntitySlime_method_onUpdate_3);


        BaseData reflect_EntitySlime_method_onDataWatcherUpdate_4 = new ModData();
        reflect_EntitySlime_method_onDataWatcherUpdate_4.set("methodName", "onDataWatcherUpdate");
        reflect_EntitySlime_method_onDataWatcherUpdate_4.set("returnType", "void");
        reflect_EntitySlime_method_onDataWatcherUpdate_4.set("static", false);
        reflect_EntitySlime_method_onDataWatcherUpdate_4.set("argnames", new String[]{"i"});
        reflect_EntitySlime_method_onDataWatcherUpdate_4.set("argtypes", new String[]{"int"});
        reflect_EntitySlime_method_onDataWatcherUpdate_4.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntitySlime) params.getReflective("_self")).onDataWatcherUpdate((int) params.getInt("i"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntitySlime_methods.add(reflect_EntitySlime_method_onDataWatcherUpdate_4);


        BaseData reflect_EntitySlime_method_setDead_5 = new ModData();
        reflect_EntitySlime_method_setDead_5.set("methodName", "setDead");
        reflect_EntitySlime_method_setDead_5.set("returnType", "void");
        reflect_EntitySlime_method_setDead_5.set("static", false);
        reflect_EntitySlime_method_setDead_5.set("argnames", new String[]{});
        reflect_EntitySlime_method_setDead_5.set("argtypes", new String[]{});
        reflect_EntitySlime_method_setDead_5.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntitySlime) params.getReflective("_self")).setDead();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntitySlime_methods.add(reflect_EntitySlime_method_setDead_5);


        BaseData reflect_EntitySlime_method_applyEntityCollision_6 = new ModData();
        reflect_EntitySlime_method_applyEntityCollision_6.set("methodName", "applyEntityCollision");
        reflect_EntitySlime_method_applyEntityCollision_6.set("returnType", "void");
        reflect_EntitySlime_method_applyEntityCollision_6.set("static", false);
        reflect_EntitySlime_method_applyEntityCollision_6.set("argnames", new String[]{"entity"});
        reflect_EntitySlime_method_applyEntityCollision_6.set("argtypes", new String[]{"Entity"});
        reflect_EntitySlime_method_applyEntityCollision_6.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntitySlime) params.getReflective("_self")).applyEntityCollision((Entity) params.getReflective("entity"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntitySlime_methods.add(reflect_EntitySlime_method_applyEntityCollision_6);


        BaseData reflect_EntitySlime_method_onCollideWithPlayer_7 = new ModData();
        reflect_EntitySlime_method_onCollideWithPlayer_7.set("methodName", "onCollideWithPlayer");
        reflect_EntitySlime_method_onCollideWithPlayer_7.set("returnType", "void");
        reflect_EntitySlime_method_onCollideWithPlayer_7.set("static", false);
        reflect_EntitySlime_method_onCollideWithPlayer_7.set("argnames", new String[]{"entityplayer"});
        reflect_EntitySlime_method_onCollideWithPlayer_7.set("argtypes", new String[]{"EntityPlayer"});
        reflect_EntitySlime_method_onCollideWithPlayer_7.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntitySlime) params.getReflective("_self")).onCollideWithPlayer((EntityPlayer) params.getReflective("entityplayer"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntitySlime_methods.add(reflect_EntitySlime_method_onCollideWithPlayer_7);


        BaseData reflect_EntitySlime_method_getEyeHeight_8 = new ModData();
        reflect_EntitySlime_method_getEyeHeight_8.set("methodName", "getEyeHeight");
        reflect_EntitySlime_method_getEyeHeight_8.set("returnType", "float");
        reflect_EntitySlime_method_getEyeHeight_8.set("static", false);
        reflect_EntitySlime_method_getEyeHeight_8.set("argnames", new String[]{});
        reflect_EntitySlime_method_getEyeHeight_8.set("argtypes", new String[]{});
        reflect_EntitySlime_method_getEyeHeight_8.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntitySlime) params.getReflective("_self")).getEyeHeight();
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntitySlime_methods.add(reflect_EntitySlime_method_getEyeHeight_8);


        BaseData reflect_EntitySlime_method_getCanSpawnHere_9 = new ModData();
        reflect_EntitySlime_method_getCanSpawnHere_9.set("methodName", "getCanSpawnHere");
        reflect_EntitySlime_method_getCanSpawnHere_9.set("returnType", "boolean");
        reflect_EntitySlime_method_getCanSpawnHere_9.set("static", false);
        reflect_EntitySlime_method_getCanSpawnHere_9.set("argnames", new String[]{});
        reflect_EntitySlime_method_getCanSpawnHere_9.set("argtypes", new String[]{});
        reflect_EntitySlime_method_getCanSpawnHere_9.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntitySlime) params.getReflective("_self")).getCanSpawnHere();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntitySlime_methods.add(reflect_EntitySlime_method_getCanSpawnHere_9);


        BaseData reflect_EntitySlime_method_getVerticalFaceSpeed_10 = new ModData();
        reflect_EntitySlime_method_getVerticalFaceSpeed_10.set("methodName", "getVerticalFaceSpeed");
        reflect_EntitySlime_method_getVerticalFaceSpeed_10.set("returnType", "int");
        reflect_EntitySlime_method_getVerticalFaceSpeed_10.set("static", false);
        reflect_EntitySlime_method_getVerticalFaceSpeed_10.set("argnames", new String[]{});
        reflect_EntitySlime_method_getVerticalFaceSpeed_10.set("argtypes", new String[]{});
        reflect_EntitySlime_method_getVerticalFaceSpeed_10.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntitySlime) params.getReflective("_self")).getVerticalFaceSpeed();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntitySlime_methods.add(reflect_EntitySlime_method_getVerticalFaceSpeed_10);


        BaseData[] reflect_EntitySlime_methods_arr = new BaseData[reflect_EntitySlime_methods.size()];
        for (int i = 0; i < reflect_EntitySlime_methods_arr.length; i++) {
            reflect_EntitySlime_methods_arr[i] = reflect_EntitySlime_methods.get(i);
        }

        reflect_EntitySlime.set("constructors", reflect_EntitySlime_constructors_arr);
        reflect_EntitySlime.set("methods", reflect_EntitySlime_methods_arr);
        reflect_EntitySlime.set("className", "EntitySlime");
        reflect_EntitySlime.set("classId", "net.minecraft.entity.monster.EntitySlime");
        reflect_EntitySlime.set("class", EntitySlime.class);
        reflect_EntitySlime.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntitySlime;
        });
        reflectProfiles.add(reflect_EntitySlime);
    }


    //classdef for EntitySnowman
    public static void reflect_EntitySnowman_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntitySnowman = new ModData();

        ArrayList<BaseData> reflect_EntitySnowman_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_EntitySnowman_constructor_EntitySnowman_0 = new ModData();
        reflect_EntitySnowman_constructor_EntitySnowman_0.set("returnType", "EntitySnowman");
        reflect_EntitySnowman_constructor_EntitySnowman_0.set("argnames", new String[]{"worldIn"});
        reflect_EntitySnowman_constructor_EntitySnowman_0.set("argtypes", new String[]{"World"});
        reflect_EntitySnowman_constructor_EntitySnowman_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntitySnowman((World) params.getReflective("worldIn"));
        });
        
        reflect_EntitySnowman_constructors.add(reflect_EntitySnowman_constructor_EntitySnowman_0);


        BaseData[] reflect_EntitySnowman_constructors_arr = new BaseData[reflect_EntitySnowman_constructors.size()];
        for (int i = 0; i < reflect_EntitySnowman_constructors_arr.length; i++) {
            reflect_EntitySnowman_constructors_arr[i] = reflect_EntitySnowman_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntitySnowman_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntitySnowman_method_onLivingUpdate_0 = new ModData();
        reflect_EntitySnowman_method_onLivingUpdate_0.set("methodName", "onLivingUpdate");
        reflect_EntitySnowman_method_onLivingUpdate_0.set("returnType", "void");
        reflect_EntitySnowman_method_onLivingUpdate_0.set("static", false);
        reflect_EntitySnowman_method_onLivingUpdate_0.set("argnames", new String[]{});
        reflect_EntitySnowman_method_onLivingUpdate_0.set("argtypes", new String[]{});
        reflect_EntitySnowman_method_onLivingUpdate_0.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntitySnowman) params.getReflective("_self")).onLivingUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntitySnowman_methods.add(reflect_EntitySnowman_method_onLivingUpdate_0);


        BaseData reflect_EntitySnowman_method_attackEntityWithRangedAttack_1 = new ModData();
        reflect_EntitySnowman_method_attackEntityWithRangedAttack_1.set("methodName", "attackEntityWithRangedAttack");
        reflect_EntitySnowman_method_attackEntityWithRangedAttack_1.set("returnType", "void");
        reflect_EntitySnowman_method_attackEntityWithRangedAttack_1.set("static", false);
        reflect_EntitySnowman_method_attackEntityWithRangedAttack_1.set("argnames", new String[]{"parEntityLivingBase", "parFloat1"});
        reflect_EntitySnowman_method_attackEntityWithRangedAttack_1.set("argtypes", new String[]{"EntityLivingBase", "float"});
        reflect_EntitySnowman_method_attackEntityWithRangedAttack_1.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntitySnowman) params.getReflective("_self")).attackEntityWithRangedAttack((EntityLivingBase) params.getReflective("parEntityLivingBase"), (float) params.getFloat("parFloat1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntitySnowman_methods.add(reflect_EntitySnowman_method_attackEntityWithRangedAttack_1);


        BaseData reflect_EntitySnowman_method_getEyeHeight_2 = new ModData();
        reflect_EntitySnowman_method_getEyeHeight_2.set("methodName", "getEyeHeight");
        reflect_EntitySnowman_method_getEyeHeight_2.set("returnType", "float");
        reflect_EntitySnowman_method_getEyeHeight_2.set("static", false);
        reflect_EntitySnowman_method_getEyeHeight_2.set("argnames", new String[]{});
        reflect_EntitySnowman_method_getEyeHeight_2.set("argtypes", new String[]{});
        reflect_EntitySnowman_method_getEyeHeight_2.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntitySnowman) params.getReflective("_self")).getEyeHeight();
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntitySnowman_methods.add(reflect_EntitySnowman_method_getEyeHeight_2);


        BaseData[] reflect_EntitySnowman_methods_arr = new BaseData[reflect_EntitySnowman_methods.size()];
        for (int i = 0; i < reflect_EntitySnowman_methods_arr.length; i++) {
            reflect_EntitySnowman_methods_arr[i] = reflect_EntitySnowman_methods.get(i);
        }

        reflect_EntitySnowman.set("constructors", reflect_EntitySnowman_constructors_arr);
        reflect_EntitySnowman.set("methods", reflect_EntitySnowman_methods_arr);
        reflect_EntitySnowman.set("className", "EntitySnowman");
        reflect_EntitySnowman.set("classId", "net.minecraft.entity.monster.EntitySnowman");
        reflect_EntitySnowman.set("class", EntitySnowman.class);
        reflect_EntitySnowman.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntitySnowman;
        });
        reflectProfiles.add(reflect_EntitySnowman);
    }


    //classdef for EntitySpider
    public static void reflect_EntitySpider_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntitySpider = new ModData();

        ArrayList<BaseData> reflect_EntitySpider_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_EntitySpider_constructor_EntitySpider_0 = new ModData();
        reflect_EntitySpider_constructor_EntitySpider_0.set("returnType", "EntitySpider");
        reflect_EntitySpider_constructor_EntitySpider_0.set("argnames", new String[]{"worldIn"});
        reflect_EntitySpider_constructor_EntitySpider_0.set("argtypes", new String[]{"World"});
        reflect_EntitySpider_constructor_EntitySpider_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntitySpider((World) params.getReflective("worldIn"));
        });
        
        reflect_EntitySpider_constructors.add(reflect_EntitySpider_constructor_EntitySpider_0);


        BaseData[] reflect_EntitySpider_constructors_arr = new BaseData[reflect_EntitySpider_constructors.size()];
        for (int i = 0; i < reflect_EntitySpider_constructors_arr.length; i++) {
            reflect_EntitySpider_constructors_arr[i] = reflect_EntitySpider_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntitySpider_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntitySpider_method_getMountedYOffset_0 = new ModData();
        reflect_EntitySpider_method_getMountedYOffset_0.set("methodName", "getMountedYOffset");
        reflect_EntitySpider_method_getMountedYOffset_0.set("returnType", "double");
        reflect_EntitySpider_method_getMountedYOffset_0.set("static", false);
        reflect_EntitySpider_method_getMountedYOffset_0.set("argnames", new String[]{});
        reflect_EntitySpider_method_getMountedYOffset_0.set("argtypes", new String[]{});
        reflect_EntitySpider_method_getMountedYOffset_0.setCallbackDoubleWithDataArg("exec", (BaseData params) -> {
                try {
                    return (double) ((EntitySpider) params.getReflective("_self")).getMountedYOffset();
                } catch (Exception _exception_reflect_) {
                    return 0.0d;
                }
            });
            
        reflect_EntitySpider_methods.add(reflect_EntitySpider_method_getMountedYOffset_0);


        BaseData reflect_EntitySpider_method_onUpdate_1 = new ModData();
        reflect_EntitySpider_method_onUpdate_1.set("methodName", "onUpdate");
        reflect_EntitySpider_method_onUpdate_1.set("returnType", "void");
        reflect_EntitySpider_method_onUpdate_1.set("static", false);
        reflect_EntitySpider_method_onUpdate_1.set("argnames", new String[]{});
        reflect_EntitySpider_method_onUpdate_1.set("argtypes", new String[]{});
        reflect_EntitySpider_method_onUpdate_1.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntitySpider) params.getReflective("_self")).onUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntitySpider_methods.add(reflect_EntitySpider_method_onUpdate_1);


        BaseData reflect_EntitySpider_method_isOnLadder_2 = new ModData();
        reflect_EntitySpider_method_isOnLadder_2.set("methodName", "isOnLadder");
        reflect_EntitySpider_method_isOnLadder_2.set("returnType", "boolean");
        reflect_EntitySpider_method_isOnLadder_2.set("static", false);
        reflect_EntitySpider_method_isOnLadder_2.set("argnames", new String[]{});
        reflect_EntitySpider_method_isOnLadder_2.set("argtypes", new String[]{});
        reflect_EntitySpider_method_isOnLadder_2.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntitySpider) params.getReflective("_self")).isOnLadder();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntitySpider_methods.add(reflect_EntitySpider_method_isOnLadder_2);


        BaseData reflect_EntitySpider_method_setInWeb_3 = new ModData();
        reflect_EntitySpider_method_setInWeb_3.set("methodName", "setInWeb");
        reflect_EntitySpider_method_setInWeb_3.set("returnType", "void");
        reflect_EntitySpider_method_setInWeb_3.set("static", false);
        reflect_EntitySpider_method_setInWeb_3.set("argnames", new String[]{});
        reflect_EntitySpider_method_setInWeb_3.set("argtypes", new String[]{});
        reflect_EntitySpider_method_setInWeb_3.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntitySpider) params.getReflective("_self")).setInWeb();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntitySpider_methods.add(reflect_EntitySpider_method_setInWeb_3);


        BaseData reflect_EntitySpider_method_getCreatureAttribute_4 = new ModData();
        reflect_EntitySpider_method_getCreatureAttribute_4.set("methodName", "getCreatureAttribute");
        reflect_EntitySpider_method_getCreatureAttribute_4.set("returnType", "EnumCreatureAttribute");
        reflect_EntitySpider_method_getCreatureAttribute_4.set("static", false);
        reflect_EntitySpider_method_getCreatureAttribute_4.set("argnames", new String[]{});
        reflect_EntitySpider_method_getCreatureAttribute_4.set("argtypes", new String[]{});
        reflect_EntitySpider_method_getCreatureAttribute_4.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EnumCreatureAttribute) ((EntitySpider) params.getReflective("_self")).getCreatureAttribute();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntitySpider_methods.add(reflect_EntitySpider_method_getCreatureAttribute_4);


        BaseData reflect_EntitySpider_method_isPotionApplicable_5 = new ModData();
        reflect_EntitySpider_method_isPotionApplicable_5.set("methodName", "isPotionApplicable");
        reflect_EntitySpider_method_isPotionApplicable_5.set("returnType", "boolean");
        reflect_EntitySpider_method_isPotionApplicable_5.set("static", false);
        reflect_EntitySpider_method_isPotionApplicable_5.set("argnames", new String[]{"potioneffect"});
        reflect_EntitySpider_method_isPotionApplicable_5.set("argtypes", new String[]{"PotionEffect"});
        reflect_EntitySpider_method_isPotionApplicable_5.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntitySpider) params.getReflective("_self")).isPotionApplicable((PotionEffect) params.getReflective("potioneffect"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntitySpider_methods.add(reflect_EntitySpider_method_isPotionApplicable_5);


        BaseData reflect_EntitySpider_method_isBesideClimbableBlock_6 = new ModData();
        reflect_EntitySpider_method_isBesideClimbableBlock_6.set("methodName", "isBesideClimbableBlock");
        reflect_EntitySpider_method_isBesideClimbableBlock_6.set("returnType", "boolean");
        reflect_EntitySpider_method_isBesideClimbableBlock_6.set("static", false);
        reflect_EntitySpider_method_isBesideClimbableBlock_6.set("argnames", new String[]{});
        reflect_EntitySpider_method_isBesideClimbableBlock_6.set("argtypes", new String[]{});
        reflect_EntitySpider_method_isBesideClimbableBlock_6.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntitySpider) params.getReflective("_self")).isBesideClimbableBlock();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntitySpider_methods.add(reflect_EntitySpider_method_isBesideClimbableBlock_6);


        BaseData reflect_EntitySpider_method_setBesideClimbableBlock_7 = new ModData();
        reflect_EntitySpider_method_setBesideClimbableBlock_7.set("methodName", "setBesideClimbableBlock");
        reflect_EntitySpider_method_setBesideClimbableBlock_7.set("returnType", "void");
        reflect_EntitySpider_method_setBesideClimbableBlock_7.set("static", false);
        reflect_EntitySpider_method_setBesideClimbableBlock_7.set("argnames", new String[]{"parFlag"});
        reflect_EntitySpider_method_setBesideClimbableBlock_7.set("argtypes", new String[]{"boolean"});
        reflect_EntitySpider_method_setBesideClimbableBlock_7.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntitySpider) params.getReflective("_self")).setBesideClimbableBlock((boolean) params.getBoolean("parFlag"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntitySpider_methods.add(reflect_EntitySpider_method_setBesideClimbableBlock_7);


        BaseData reflect_EntitySpider_method_getEyeHeight_8 = new ModData();
        reflect_EntitySpider_method_getEyeHeight_8.set("methodName", "getEyeHeight");
        reflect_EntitySpider_method_getEyeHeight_8.set("returnType", "float");
        reflect_EntitySpider_method_getEyeHeight_8.set("static", false);
        reflect_EntitySpider_method_getEyeHeight_8.set("argnames", new String[]{});
        reflect_EntitySpider_method_getEyeHeight_8.set("argtypes", new String[]{});
        reflect_EntitySpider_method_getEyeHeight_8.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntitySpider) params.getReflective("_self")).getEyeHeight();
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntitySpider_methods.add(reflect_EntitySpider_method_getEyeHeight_8);


        BaseData[] reflect_EntitySpider_methods_arr = new BaseData[reflect_EntitySpider_methods.size()];
        for (int i = 0; i < reflect_EntitySpider_methods_arr.length; i++) {
            reflect_EntitySpider_methods_arr[i] = reflect_EntitySpider_methods.get(i);
        }

        reflect_EntitySpider.set("constructors", reflect_EntitySpider_constructors_arr);
        reflect_EntitySpider.set("methods", reflect_EntitySpider_methods_arr);
        reflect_EntitySpider.set("className", "EntitySpider");
        reflect_EntitySpider.set("classId", "net.minecraft.entity.monster.EntitySpider");
        reflect_EntitySpider.set("class", EntitySpider.class);
        reflect_EntitySpider.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntitySpider;
        });
        reflectProfiles.add(reflect_EntitySpider);
    }


    //classdef for EntityWitch
    public static void reflect_EntityWitch_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityWitch = new ModData();

        ArrayList<BaseData> reflect_EntityWitch_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_EntityWitch_constructor_EntityWitch_0 = new ModData();
        reflect_EntityWitch_constructor_EntityWitch_0.set("returnType", "EntityWitch");
        reflect_EntityWitch_constructor_EntityWitch_0.set("argnames", new String[]{"worldIn"});
        reflect_EntityWitch_constructor_EntityWitch_0.set("argtypes", new String[]{"World"});
        reflect_EntityWitch_constructor_EntityWitch_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityWitch((World) params.getReflective("worldIn"));
        });
        
        reflect_EntityWitch_constructors.add(reflect_EntityWitch_constructor_EntityWitch_0);


        BaseData[] reflect_EntityWitch_constructors_arr = new BaseData[reflect_EntityWitch_constructors.size()];
        for (int i = 0; i < reflect_EntityWitch_constructors_arr.length; i++) {
            reflect_EntityWitch_constructors_arr[i] = reflect_EntityWitch_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityWitch_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityWitch_method_setAggressive_0 = new ModData();
        reflect_EntityWitch_method_setAggressive_0.set("methodName", "setAggressive");
        reflect_EntityWitch_method_setAggressive_0.set("returnType", "void");
        reflect_EntityWitch_method_setAggressive_0.set("static", false);
        reflect_EntityWitch_method_setAggressive_0.set("argnames", new String[]{"aggressive"});
        reflect_EntityWitch_method_setAggressive_0.set("argtypes", new String[]{"boolean"});
        reflect_EntityWitch_method_setAggressive_0.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityWitch) params.getReflective("_self")).setAggressive((boolean) params.getBoolean("aggressive"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityWitch_methods.add(reflect_EntityWitch_method_setAggressive_0);


        BaseData reflect_EntityWitch_method_getAggressive_1 = new ModData();
        reflect_EntityWitch_method_getAggressive_1.set("methodName", "getAggressive");
        reflect_EntityWitch_method_getAggressive_1.set("returnType", "boolean");
        reflect_EntityWitch_method_getAggressive_1.set("static", false);
        reflect_EntityWitch_method_getAggressive_1.set("argnames", new String[]{});
        reflect_EntityWitch_method_getAggressive_1.set("argtypes", new String[]{});
        reflect_EntityWitch_method_getAggressive_1.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityWitch) params.getReflective("_self")).getAggressive();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityWitch_methods.add(reflect_EntityWitch_method_getAggressive_1);


        BaseData reflect_EntityWitch_method_onLivingUpdate_2 = new ModData();
        reflect_EntityWitch_method_onLivingUpdate_2.set("methodName", "onLivingUpdate");
        reflect_EntityWitch_method_onLivingUpdate_2.set("returnType", "void");
        reflect_EntityWitch_method_onLivingUpdate_2.set("static", false);
        reflect_EntityWitch_method_onLivingUpdate_2.set("argnames", new String[]{});
        reflect_EntityWitch_method_onLivingUpdate_2.set("argtypes", new String[]{});
        reflect_EntityWitch_method_onLivingUpdate_2.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityWitch) params.getReflective("_self")).onLivingUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityWitch_methods.add(reflect_EntityWitch_method_onLivingUpdate_2);


        BaseData reflect_EntityWitch_method_handleStatusUpdate_3 = new ModData();
        reflect_EntityWitch_method_handleStatusUpdate_3.set("methodName", "handleStatusUpdate");
        reflect_EntityWitch_method_handleStatusUpdate_3.set("returnType", "void");
        reflect_EntityWitch_method_handleStatusUpdate_3.set("static", false);
        reflect_EntityWitch_method_handleStatusUpdate_3.set("argnames", new String[]{"b0"});
        reflect_EntityWitch_method_handleStatusUpdate_3.set("argtypes", new String[]{"byte"});
        reflect_EntityWitch_method_handleStatusUpdate_3.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityWitch) params.getReflective("_self")).handleStatusUpdate((byte) params.getByte("b0"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityWitch_methods.add(reflect_EntityWitch_method_handleStatusUpdate_3);


        BaseData reflect_EntityWitch_method_attackEntityWithRangedAttack_4 = new ModData();
        reflect_EntityWitch_method_attackEntityWithRangedAttack_4.set("methodName", "attackEntityWithRangedAttack");
        reflect_EntityWitch_method_attackEntityWithRangedAttack_4.set("returnType", "void");
        reflect_EntityWitch_method_attackEntityWithRangedAttack_4.set("static", false);
        reflect_EntityWitch_method_attackEntityWithRangedAttack_4.set("argnames", new String[]{"entitylivingbase", "var2"});
        reflect_EntityWitch_method_attackEntityWithRangedAttack_4.set("argtypes", new String[]{"EntityLivingBase", "float"});
        reflect_EntityWitch_method_attackEntityWithRangedAttack_4.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityWitch) params.getReflective("_self")).attackEntityWithRangedAttack((EntityLivingBase) params.getReflective("entitylivingbase"), (float) params.getFloat("var2"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityWitch_methods.add(reflect_EntityWitch_method_attackEntityWithRangedAttack_4);


        BaseData reflect_EntityWitch_method_getEyeHeight_5 = new ModData();
        reflect_EntityWitch_method_getEyeHeight_5.set("methodName", "getEyeHeight");
        reflect_EntityWitch_method_getEyeHeight_5.set("returnType", "float");
        reflect_EntityWitch_method_getEyeHeight_5.set("static", false);
        reflect_EntityWitch_method_getEyeHeight_5.set("argnames", new String[]{});
        reflect_EntityWitch_method_getEyeHeight_5.set("argtypes", new String[]{});
        reflect_EntityWitch_method_getEyeHeight_5.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityWitch) params.getReflective("_self")).getEyeHeight();
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityWitch_methods.add(reflect_EntityWitch_method_getEyeHeight_5);


        BaseData[] reflect_EntityWitch_methods_arr = new BaseData[reflect_EntityWitch_methods.size()];
        for (int i = 0; i < reflect_EntityWitch_methods_arr.length; i++) {
            reflect_EntityWitch_methods_arr[i] = reflect_EntityWitch_methods.get(i);
        }

        reflect_EntityWitch.set("constructors", reflect_EntityWitch_constructors_arr);
        reflect_EntityWitch.set("methods", reflect_EntityWitch_methods_arr);
        reflect_EntityWitch.set("className", "EntityWitch");
        reflect_EntityWitch.set("classId", "net.minecraft.entity.monster.EntityWitch");
        reflect_EntityWitch.set("class", EntityWitch.class);
        reflect_EntityWitch.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityWitch;
        });
        reflectProfiles.add(reflect_EntityWitch);
    }


    //classdef for EntityZombie
    public static void reflect_EntityZombie_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityZombie = new ModData();

        ArrayList<BaseData> reflect_EntityZombie_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_EntityZombie_constructor_EntityZombie_0 = new ModData();
        reflect_EntityZombie_constructor_EntityZombie_0.set("returnType", "EntityZombie");
        reflect_EntityZombie_constructor_EntityZombie_0.set("argnames", new String[]{"worldIn"});
        reflect_EntityZombie_constructor_EntityZombie_0.set("argtypes", new String[]{"World"});
        reflect_EntityZombie_constructor_EntityZombie_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityZombie((World) params.getReflective("worldIn"));
        });
        
        reflect_EntityZombie_constructors.add(reflect_EntityZombie_constructor_EntityZombie_0);


        BaseData[] reflect_EntityZombie_constructors_arr = new BaseData[reflect_EntityZombie_constructors.size()];
        for (int i = 0; i < reflect_EntityZombie_constructors_arr.length; i++) {
            reflect_EntityZombie_constructors_arr[i] = reflect_EntityZombie_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityZombie_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityZombie_method_getTotalArmorValue_0 = new ModData();
        reflect_EntityZombie_method_getTotalArmorValue_0.set("methodName", "getTotalArmorValue");
        reflect_EntityZombie_method_getTotalArmorValue_0.set("returnType", "int");
        reflect_EntityZombie_method_getTotalArmorValue_0.set("static", false);
        reflect_EntityZombie_method_getTotalArmorValue_0.set("argnames", new String[]{});
        reflect_EntityZombie_method_getTotalArmorValue_0.set("argtypes", new String[]{});
        reflect_EntityZombie_method_getTotalArmorValue_0.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityZombie) params.getReflective("_self")).getTotalArmorValue();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityZombie_methods.add(reflect_EntityZombie_method_getTotalArmorValue_0);


        BaseData reflect_EntityZombie_method_isBreakDoorsTaskSet_1 = new ModData();
        reflect_EntityZombie_method_isBreakDoorsTaskSet_1.set("methodName", "isBreakDoorsTaskSet");
        reflect_EntityZombie_method_isBreakDoorsTaskSet_1.set("returnType", "boolean");
        reflect_EntityZombie_method_isBreakDoorsTaskSet_1.set("static", false);
        reflect_EntityZombie_method_isBreakDoorsTaskSet_1.set("argnames", new String[]{});
        reflect_EntityZombie_method_isBreakDoorsTaskSet_1.set("argtypes", new String[]{});
        reflect_EntityZombie_method_isBreakDoorsTaskSet_1.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityZombie) params.getReflective("_self")).isBreakDoorsTaskSet();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityZombie_methods.add(reflect_EntityZombie_method_isBreakDoorsTaskSet_1);


        BaseData reflect_EntityZombie_method_setBreakDoorsAItask_2 = new ModData();
        reflect_EntityZombie_method_setBreakDoorsAItask_2.set("methodName", "setBreakDoorsAItask");
        reflect_EntityZombie_method_setBreakDoorsAItask_2.set("returnType", "void");
        reflect_EntityZombie_method_setBreakDoorsAItask_2.set("static", false);
        reflect_EntityZombie_method_setBreakDoorsAItask_2.set("argnames", new String[]{"par1"});
        reflect_EntityZombie_method_setBreakDoorsAItask_2.set("argtypes", new String[]{"boolean"});
        reflect_EntityZombie_method_setBreakDoorsAItask_2.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityZombie) params.getReflective("_self")).setBreakDoorsAItask((boolean) params.getBoolean("par1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityZombie_methods.add(reflect_EntityZombie_method_setBreakDoorsAItask_2);


        BaseData reflect_EntityZombie_method_isChild_3 = new ModData();
        reflect_EntityZombie_method_isChild_3.set("methodName", "isChild");
        reflect_EntityZombie_method_isChild_3.set("returnType", "boolean");
        reflect_EntityZombie_method_isChild_3.set("static", false);
        reflect_EntityZombie_method_isChild_3.set("argnames", new String[]{});
        reflect_EntityZombie_method_isChild_3.set("argtypes", new String[]{});
        reflect_EntityZombie_method_isChild_3.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityZombie) params.getReflective("_self")).isChild();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityZombie_methods.add(reflect_EntityZombie_method_isChild_3);


        BaseData reflect_EntityZombie_method_setChild_4 = new ModData();
        reflect_EntityZombie_method_setChild_4.set("methodName", "setChild");
        reflect_EntityZombie_method_setChild_4.set("returnType", "void");
        reflect_EntityZombie_method_setChild_4.set("static", false);
        reflect_EntityZombie_method_setChild_4.set("argnames", new String[]{"childZombie"});
        reflect_EntityZombie_method_setChild_4.set("argtypes", new String[]{"boolean"});
        reflect_EntityZombie_method_setChild_4.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityZombie) params.getReflective("_self")).setChild((boolean) params.getBoolean("childZombie"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityZombie_methods.add(reflect_EntityZombie_method_setChild_4);


        BaseData reflect_EntityZombie_method_isVillager_5 = new ModData();
        reflect_EntityZombie_method_isVillager_5.set("methodName", "isVillager");
        reflect_EntityZombie_method_isVillager_5.set("returnType", "boolean");
        reflect_EntityZombie_method_isVillager_5.set("static", false);
        reflect_EntityZombie_method_isVillager_5.set("argnames", new String[]{});
        reflect_EntityZombie_method_isVillager_5.set("argtypes", new String[]{});
        reflect_EntityZombie_method_isVillager_5.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityZombie) params.getReflective("_self")).isVillager();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityZombie_methods.add(reflect_EntityZombie_method_isVillager_5);


        BaseData reflect_EntityZombie_method_setVillager_6 = new ModData();
        reflect_EntityZombie_method_setVillager_6.set("methodName", "setVillager");
        reflect_EntityZombie_method_setVillager_6.set("returnType", "void");
        reflect_EntityZombie_method_setVillager_6.set("static", false);
        reflect_EntityZombie_method_setVillager_6.set("argnames", new String[]{"villager"});
        reflect_EntityZombie_method_setVillager_6.set("argtypes", new String[]{"boolean"});
        reflect_EntityZombie_method_setVillager_6.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityZombie) params.getReflective("_self")).setVillager((boolean) params.getBoolean("villager"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityZombie_methods.add(reflect_EntityZombie_method_setVillager_6);


        BaseData reflect_EntityZombie_method_onLivingUpdate_7 = new ModData();
        reflect_EntityZombie_method_onLivingUpdate_7.set("methodName", "onLivingUpdate");
        reflect_EntityZombie_method_onLivingUpdate_7.set("returnType", "void");
        reflect_EntityZombie_method_onLivingUpdate_7.set("static", false);
        reflect_EntityZombie_method_onLivingUpdate_7.set("argnames", new String[]{});
        reflect_EntityZombie_method_onLivingUpdate_7.set("argtypes", new String[]{});
        reflect_EntityZombie_method_onLivingUpdate_7.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityZombie) params.getReflective("_self")).onLivingUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityZombie_methods.add(reflect_EntityZombie_method_onLivingUpdate_7);


        BaseData reflect_EntityZombie_method_attackEntityFrom_8 = new ModData();
        reflect_EntityZombie_method_attackEntityFrom_8.set("methodName", "attackEntityFrom");
        reflect_EntityZombie_method_attackEntityFrom_8.set("returnType", "boolean");
        reflect_EntityZombie_method_attackEntityFrom_8.set("static", false);
        reflect_EntityZombie_method_attackEntityFrom_8.set("argnames", new String[]{"damagesource", "f"});
        reflect_EntityZombie_method_attackEntityFrom_8.set("argtypes", new String[]{"DamageSource", "float"});
        reflect_EntityZombie_method_attackEntityFrom_8.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityZombie) params.getReflective("_self")).attackEntityFrom((DamageSource) params.getReflective("damagesource"), (float) params.getFloat("f"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityZombie_methods.add(reflect_EntityZombie_method_attackEntityFrom_8);


        BaseData reflect_EntityZombie_method_onUpdate_9 = new ModData();
        reflect_EntityZombie_method_onUpdate_9.set("methodName", "onUpdate");
        reflect_EntityZombie_method_onUpdate_9.set("returnType", "void");
        reflect_EntityZombie_method_onUpdate_9.set("static", false);
        reflect_EntityZombie_method_onUpdate_9.set("argnames", new String[]{});
        reflect_EntityZombie_method_onUpdate_9.set("argtypes", new String[]{});
        reflect_EntityZombie_method_onUpdate_9.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityZombie) params.getReflective("_self")).onUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityZombie_methods.add(reflect_EntityZombie_method_onUpdate_9);


        BaseData reflect_EntityZombie_method_attackEntityAsMob_10 = new ModData();
        reflect_EntityZombie_method_attackEntityAsMob_10.set("methodName", "attackEntityAsMob");
        reflect_EntityZombie_method_attackEntityAsMob_10.set("returnType", "boolean");
        reflect_EntityZombie_method_attackEntityAsMob_10.set("static", false);
        reflect_EntityZombie_method_attackEntityAsMob_10.set("argnames", new String[]{"entity"});
        reflect_EntityZombie_method_attackEntityAsMob_10.set("argtypes", new String[]{"Entity"});
        reflect_EntityZombie_method_attackEntityAsMob_10.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityZombie) params.getReflective("_self")).attackEntityAsMob((Entity) params.getReflective("entity"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityZombie_methods.add(reflect_EntityZombie_method_attackEntityAsMob_10);


        BaseData reflect_EntityZombie_method_getCreatureAttribute_11 = new ModData();
        reflect_EntityZombie_method_getCreatureAttribute_11.set("methodName", "getCreatureAttribute");
        reflect_EntityZombie_method_getCreatureAttribute_11.set("returnType", "EnumCreatureAttribute");
        reflect_EntityZombie_method_getCreatureAttribute_11.set("static", false);
        reflect_EntityZombie_method_getCreatureAttribute_11.set("argnames", new String[]{});
        reflect_EntityZombie_method_getCreatureAttribute_11.set("argtypes", new String[]{});
        reflect_EntityZombie_method_getCreatureAttribute_11.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EnumCreatureAttribute) ((EntityZombie) params.getReflective("_self")).getCreatureAttribute();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityZombie_methods.add(reflect_EntityZombie_method_getCreatureAttribute_11);


        BaseData reflect_EntityZombie_method_writeEntityToNBT_12 = new ModData();
        reflect_EntityZombie_method_writeEntityToNBT_12.set("methodName", "writeEntityToNBT");
        reflect_EntityZombie_method_writeEntityToNBT_12.set("returnType", "void");
        reflect_EntityZombie_method_writeEntityToNBT_12.set("static", false);
        reflect_EntityZombie_method_writeEntityToNBT_12.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityZombie_method_writeEntityToNBT_12.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityZombie_method_writeEntityToNBT_12.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityZombie) params.getReflective("_self")).writeEntityToNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityZombie_methods.add(reflect_EntityZombie_method_writeEntityToNBT_12);


        BaseData reflect_EntityZombie_method_readEntityFromNBT_13 = new ModData();
        reflect_EntityZombie_method_readEntityFromNBT_13.set("methodName", "readEntityFromNBT");
        reflect_EntityZombie_method_readEntityFromNBT_13.set("returnType", "void");
        reflect_EntityZombie_method_readEntityFromNBT_13.set("static", false);
        reflect_EntityZombie_method_readEntityFromNBT_13.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityZombie_method_readEntityFromNBT_13.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityZombie_method_readEntityFromNBT_13.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityZombie) params.getReflective("_self")).readEntityFromNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityZombie_methods.add(reflect_EntityZombie_method_readEntityFromNBT_13);


        BaseData reflect_EntityZombie_method_onKillEntity_14 = new ModData();
        reflect_EntityZombie_method_onKillEntity_14.set("methodName", "onKillEntity");
        reflect_EntityZombie_method_onKillEntity_14.set("returnType", "void");
        reflect_EntityZombie_method_onKillEntity_14.set("static", false);
        reflect_EntityZombie_method_onKillEntity_14.set("argnames", new String[]{"entitylivingbase"});
        reflect_EntityZombie_method_onKillEntity_14.set("argtypes", new String[]{"EntityLivingBase"});
        reflect_EntityZombie_method_onKillEntity_14.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityZombie) params.getReflective("_self")).onKillEntity((EntityLivingBase) params.getReflective("entitylivingbase"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityZombie_methods.add(reflect_EntityZombie_method_onKillEntity_14);


        BaseData reflect_EntityZombie_method_getEyeHeight_15 = new ModData();
        reflect_EntityZombie_method_getEyeHeight_15.set("methodName", "getEyeHeight");
        reflect_EntityZombie_method_getEyeHeight_15.set("returnType", "float");
        reflect_EntityZombie_method_getEyeHeight_15.set("static", false);
        reflect_EntityZombie_method_getEyeHeight_15.set("argnames", new String[]{});
        reflect_EntityZombie_method_getEyeHeight_15.set("argtypes", new String[]{});
        reflect_EntityZombie_method_getEyeHeight_15.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityZombie) params.getReflective("_self")).getEyeHeight();
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityZombie_methods.add(reflect_EntityZombie_method_getEyeHeight_15);


        BaseData reflect_EntityZombie_method_interact_16 = new ModData();
        reflect_EntityZombie_method_interact_16.set("methodName", "interact");
        reflect_EntityZombie_method_interact_16.set("returnType", "boolean");
        reflect_EntityZombie_method_interact_16.set("static", false);
        reflect_EntityZombie_method_interact_16.set("argnames", new String[]{"entityplayer"});
        reflect_EntityZombie_method_interact_16.set("argtypes", new String[]{"EntityPlayer"});
        reflect_EntityZombie_method_interact_16.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityZombie) params.getReflective("_self")).interact((EntityPlayer) params.getReflective("entityplayer"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityZombie_methods.add(reflect_EntityZombie_method_interact_16);


        BaseData reflect_EntityZombie_method_handleStatusUpdate_17 = new ModData();
        reflect_EntityZombie_method_handleStatusUpdate_17.set("methodName", "handleStatusUpdate");
        reflect_EntityZombie_method_handleStatusUpdate_17.set("returnType", "void");
        reflect_EntityZombie_method_handleStatusUpdate_17.set("static", false);
        reflect_EntityZombie_method_handleStatusUpdate_17.set("argnames", new String[]{"b0"});
        reflect_EntityZombie_method_handleStatusUpdate_17.set("argtypes", new String[]{"byte"});
        reflect_EntityZombie_method_handleStatusUpdate_17.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityZombie) params.getReflective("_self")).handleStatusUpdate((byte) params.getByte("b0"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityZombie_methods.add(reflect_EntityZombie_method_handleStatusUpdate_17);


        BaseData reflect_EntityZombie_method_isConverting_18 = new ModData();
        reflect_EntityZombie_method_isConverting_18.set("methodName", "isConverting");
        reflect_EntityZombie_method_isConverting_18.set("returnType", "boolean");
        reflect_EntityZombie_method_isConverting_18.set("static", false);
        reflect_EntityZombie_method_isConverting_18.set("argnames", new String[]{});
        reflect_EntityZombie_method_isConverting_18.set("argtypes", new String[]{});
        reflect_EntityZombie_method_isConverting_18.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityZombie) params.getReflective("_self")).isConverting();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityZombie_methods.add(reflect_EntityZombie_method_isConverting_18);


        BaseData reflect_EntityZombie_method_setChildSize_19 = new ModData();
        reflect_EntityZombie_method_setChildSize_19.set("methodName", "setChildSize");
        reflect_EntityZombie_method_setChildSize_19.set("returnType", "void");
        reflect_EntityZombie_method_setChildSize_19.set("static", false);
        reflect_EntityZombie_method_setChildSize_19.set("argnames", new String[]{"isChild"});
        reflect_EntityZombie_method_setChildSize_19.set("argtypes", new String[]{"boolean"});
        reflect_EntityZombie_method_setChildSize_19.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityZombie) params.getReflective("_self")).setChildSize((boolean) params.getBoolean("isChild"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityZombie_methods.add(reflect_EntityZombie_method_setChildSize_19);


        BaseData reflect_EntityZombie_method_getYOffset_20 = new ModData();
        reflect_EntityZombie_method_getYOffset_20.set("methodName", "getYOffset");
        reflect_EntityZombie_method_getYOffset_20.set("returnType", "double");
        reflect_EntityZombie_method_getYOffset_20.set("static", false);
        reflect_EntityZombie_method_getYOffset_20.set("argnames", new String[]{});
        reflect_EntityZombie_method_getYOffset_20.set("argtypes", new String[]{});
        reflect_EntityZombie_method_getYOffset_20.setCallbackDoubleWithDataArg("exec", (BaseData params) -> {
                try {
                    return (double) ((EntityZombie) params.getReflective("_self")).getYOffset();
                } catch (Exception _exception_reflect_) {
                    return 0.0d;
                }
            });
            
        reflect_EntityZombie_methods.add(reflect_EntityZombie_method_getYOffset_20);


        BaseData reflect_EntityZombie_method_onDeath_21 = new ModData();
        reflect_EntityZombie_method_onDeath_21.set("methodName", "onDeath");
        reflect_EntityZombie_method_onDeath_21.set("returnType", "void");
        reflect_EntityZombie_method_onDeath_21.set("static", false);
        reflect_EntityZombie_method_onDeath_21.set("argnames", new String[]{"damagesource"});
        reflect_EntityZombie_method_onDeath_21.set("argtypes", new String[]{"DamageSource"});
        reflect_EntityZombie_method_onDeath_21.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityZombie) params.getReflective("_self")).onDeath((DamageSource) params.getReflective("damagesource"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityZombie_methods.add(reflect_EntityZombie_method_onDeath_21);


        BaseData[] reflect_EntityZombie_methods_arr = new BaseData[reflect_EntityZombie_methods.size()];
        for (int i = 0; i < reflect_EntityZombie_methods_arr.length; i++) {
            reflect_EntityZombie_methods_arr[i] = reflect_EntityZombie_methods.get(i);
        }

        reflect_EntityZombie.set("constructors", reflect_EntityZombie_constructors_arr);
        reflect_EntityZombie.set("methods", reflect_EntityZombie_methods_arr);
        reflect_EntityZombie.set("className", "EntityZombie");
        reflect_EntityZombie.set("classId", "net.minecraft.entity.monster.EntityZombie");
        reflect_EntityZombie.set("class", EntityZombie.class);
        reflect_EntityZombie.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityZombie;
        });
        reflectProfiles.add(reflect_EntityZombie);
    }


    //classdef for EntityArmorStand
    public static void reflect_EntityArmorStand_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityArmorStand = new ModData();

        ArrayList<BaseData> reflect_EntityArmorStand_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_EntityArmorStand_constructor_EntityArmorStand_0 = new ModData();
        reflect_EntityArmorStand_constructor_EntityArmorStand_0.set("returnType", "EntityArmorStand");
        reflect_EntityArmorStand_constructor_EntityArmorStand_0.set("argnames", new String[]{"worldIn"});
        reflect_EntityArmorStand_constructor_EntityArmorStand_0.set("argtypes", new String[]{"World"});
        reflect_EntityArmorStand_constructor_EntityArmorStand_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityArmorStand((World) params.getReflective("worldIn"));
        });
        
        reflect_EntityArmorStand_constructors.add(reflect_EntityArmorStand_constructor_EntityArmorStand_0);


        BaseData reflect_EntityArmorStand_constructor_EntityArmorStand_1 = new ModData();
        reflect_EntityArmorStand_constructor_EntityArmorStand_1.set("returnType", "EntityArmorStand");
        reflect_EntityArmorStand_constructor_EntityArmorStand_1.set("argnames", new String[]{"worldIn", "posX", "posY", "posZ"});
        reflect_EntityArmorStand_constructor_EntityArmorStand_1.set("argtypes", new String[]{"World", "double", "double", "double"});
        reflect_EntityArmorStand_constructor_EntityArmorStand_1.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityArmorStand((World) params.getReflective("worldIn"), (double) params.getDouble("posX"), (double) params.getDouble("posY"), (double) params.getDouble("posZ"));
        });
        
        reflect_EntityArmorStand_constructors.add(reflect_EntityArmorStand_constructor_EntityArmorStand_1);


        BaseData[] reflect_EntityArmorStand_constructors_arr = new BaseData[reflect_EntityArmorStand_constructors.size()];
        for (int i = 0; i < reflect_EntityArmorStand_constructors_arr.length; i++) {
            reflect_EntityArmorStand_constructors_arr[i] = reflect_EntityArmorStand_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityArmorStand_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityArmorStand_method_isServerWorld_0 = new ModData();
        reflect_EntityArmorStand_method_isServerWorld_0.set("methodName", "isServerWorld");
        reflect_EntityArmorStand_method_isServerWorld_0.set("returnType", "boolean");
        reflect_EntityArmorStand_method_isServerWorld_0.set("static", false);
        reflect_EntityArmorStand_method_isServerWorld_0.set("argnames", new String[]{});
        reflect_EntityArmorStand_method_isServerWorld_0.set("argtypes", new String[]{});
        reflect_EntityArmorStand_method_isServerWorld_0.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityArmorStand) params.getReflective("_self")).isServerWorld();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityArmorStand_methods.add(reflect_EntityArmorStand_method_isServerWorld_0);


        BaseData reflect_EntityArmorStand_method_getHeldItem_1 = new ModData();
        reflect_EntityArmorStand_method_getHeldItem_1.set("methodName", "getHeldItem");
        reflect_EntityArmorStand_method_getHeldItem_1.set("returnType", "ItemStack");
        reflect_EntityArmorStand_method_getHeldItem_1.set("static", false);
        reflect_EntityArmorStand_method_getHeldItem_1.set("argnames", new String[]{});
        reflect_EntityArmorStand_method_getHeldItem_1.set("argtypes", new String[]{});
        reflect_EntityArmorStand_method_getHeldItem_1.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (ItemStack) ((EntityArmorStand) params.getReflective("_self")).getHeldItem();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityArmorStand_methods.add(reflect_EntityArmorStand_method_getHeldItem_1);


        BaseData reflect_EntityArmorStand_method_getEquipmentInSlot_2 = new ModData();
        reflect_EntityArmorStand_method_getEquipmentInSlot_2.set("methodName", "getEquipmentInSlot");
        reflect_EntityArmorStand_method_getEquipmentInSlot_2.set("returnType", "ItemStack");
        reflect_EntityArmorStand_method_getEquipmentInSlot_2.set("static", false);
        reflect_EntityArmorStand_method_getEquipmentInSlot_2.set("argnames", new String[]{"i"});
        reflect_EntityArmorStand_method_getEquipmentInSlot_2.set("argtypes", new String[]{"int"});
        reflect_EntityArmorStand_method_getEquipmentInSlot_2.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (ItemStack) ((EntityArmorStand) params.getReflective("_self")).getEquipmentInSlot((int) params.getInt("i"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityArmorStand_methods.add(reflect_EntityArmorStand_method_getEquipmentInSlot_2);


        BaseData reflect_EntityArmorStand_method_getCurrentArmor_3 = new ModData();
        reflect_EntityArmorStand_method_getCurrentArmor_3.set("methodName", "getCurrentArmor");
        reflect_EntityArmorStand_method_getCurrentArmor_3.set("returnType", "ItemStack");
        reflect_EntityArmorStand_method_getCurrentArmor_3.set("static", false);
        reflect_EntityArmorStand_method_getCurrentArmor_3.set("argnames", new String[]{"i"});
        reflect_EntityArmorStand_method_getCurrentArmor_3.set("argtypes", new String[]{"int"});
        reflect_EntityArmorStand_method_getCurrentArmor_3.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (ItemStack) ((EntityArmorStand) params.getReflective("_self")).getCurrentArmor((int) params.getInt("i"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityArmorStand_methods.add(reflect_EntityArmorStand_method_getCurrentArmor_3);


        BaseData reflect_EntityArmorStand_method_setCurrentItemOrArmor_4 = new ModData();
        reflect_EntityArmorStand_method_setCurrentItemOrArmor_4.set("methodName", "setCurrentItemOrArmor");
        reflect_EntityArmorStand_method_setCurrentItemOrArmor_4.set("returnType", "void");
        reflect_EntityArmorStand_method_setCurrentItemOrArmor_4.set("static", false);
        reflect_EntityArmorStand_method_setCurrentItemOrArmor_4.set("argnames", new String[]{"i", "itemstack"});
        reflect_EntityArmorStand_method_setCurrentItemOrArmor_4.set("argtypes", new String[]{"int", "ItemStack"});
        reflect_EntityArmorStand_method_setCurrentItemOrArmor_4.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityArmorStand) params.getReflective("_self")).setCurrentItemOrArmor((int) params.getInt("i"), (ItemStack) params.getReflective("itemstack"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityArmorStand_methods.add(reflect_EntityArmorStand_method_setCurrentItemOrArmor_4);


        BaseData reflect_EntityArmorStand_method_getInventory_5 = new ModData();
        reflect_EntityArmorStand_method_getInventory_5.set("methodName", "getInventory");
        reflect_EntityArmorStand_method_getInventory_5.set("returnType", "ItemStack[]");
        reflect_EntityArmorStand_method_getInventory_5.set("static", false);
        reflect_EntityArmorStand_method_getInventory_5.set("argnames", new String[]{});
        reflect_EntityArmorStand_method_getInventory_5.set("argtypes", new String[]{});
        reflect_EntityArmorStand_method_getInventory_5.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (ItemStack[]) ((EntityArmorStand) params.getReflective("_self")).getInventory();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityArmorStand_methods.add(reflect_EntityArmorStand_method_getInventory_5);


        BaseData reflect_EntityArmorStand_method_replaceItemInInventory_6 = new ModData();
        reflect_EntityArmorStand_method_replaceItemInInventory_6.set("methodName", "replaceItemInInventory");
        reflect_EntityArmorStand_method_replaceItemInInventory_6.set("returnType", "boolean");
        reflect_EntityArmorStand_method_replaceItemInInventory_6.set("static", false);
        reflect_EntityArmorStand_method_replaceItemInInventory_6.set("argnames", new String[]{"i", "itemstack"});
        reflect_EntityArmorStand_method_replaceItemInInventory_6.set("argtypes", new String[]{"int", "ItemStack"});
        reflect_EntityArmorStand_method_replaceItemInInventory_6.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityArmorStand) params.getReflective("_self")).replaceItemInInventory((int) params.getInt("i"), (ItemStack) params.getReflective("itemstack"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityArmorStand_methods.add(reflect_EntityArmorStand_method_replaceItemInInventory_6);


        BaseData reflect_EntityArmorStand_method_writeEntityToNBT_7 = new ModData();
        reflect_EntityArmorStand_method_writeEntityToNBT_7.set("methodName", "writeEntityToNBT");
        reflect_EntityArmorStand_method_writeEntityToNBT_7.set("returnType", "void");
        reflect_EntityArmorStand_method_writeEntityToNBT_7.set("static", false);
        reflect_EntityArmorStand_method_writeEntityToNBT_7.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityArmorStand_method_writeEntityToNBT_7.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityArmorStand_method_writeEntityToNBT_7.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityArmorStand) params.getReflective("_self")).writeEntityToNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityArmorStand_methods.add(reflect_EntityArmorStand_method_writeEntityToNBT_7);


        BaseData reflect_EntityArmorStand_method_readEntityFromNBT_8 = new ModData();
        reflect_EntityArmorStand_method_readEntityFromNBT_8.set("methodName", "readEntityFromNBT");
        reflect_EntityArmorStand_method_readEntityFromNBT_8.set("returnType", "void");
        reflect_EntityArmorStand_method_readEntityFromNBT_8.set("static", false);
        reflect_EntityArmorStand_method_readEntityFromNBT_8.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityArmorStand_method_readEntityFromNBT_8.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityArmorStand_method_readEntityFromNBT_8.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityArmorStand) params.getReflective("_self")).readEntityFromNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityArmorStand_methods.add(reflect_EntityArmorStand_method_readEntityFromNBT_8);


        BaseData reflect_EntityArmorStand_method_canBePushed_9 = new ModData();
        reflect_EntityArmorStand_method_canBePushed_9.set("methodName", "canBePushed");
        reflect_EntityArmorStand_method_canBePushed_9.set("returnType", "boolean");
        reflect_EntityArmorStand_method_canBePushed_9.set("static", false);
        reflect_EntityArmorStand_method_canBePushed_9.set("argnames", new String[]{});
        reflect_EntityArmorStand_method_canBePushed_9.set("argtypes", new String[]{});
        reflect_EntityArmorStand_method_canBePushed_9.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityArmorStand) params.getReflective("_self")).canBePushed();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityArmorStand_methods.add(reflect_EntityArmorStand_method_canBePushed_9);


        BaseData reflect_EntityArmorStand_method_interactAt_10 = new ModData();
        reflect_EntityArmorStand_method_interactAt_10.set("methodName", "interactAt");
        reflect_EntityArmorStand_method_interactAt_10.set("returnType", "boolean");
        reflect_EntityArmorStand_method_interactAt_10.set("static", false);
        reflect_EntityArmorStand_method_interactAt_10.set("argnames", new String[]{"entityplayer", "vec3"});
        reflect_EntityArmorStand_method_interactAt_10.set("argtypes", new String[]{"EntityPlayer", "Vec3"});
        reflect_EntityArmorStand_method_interactAt_10.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityArmorStand) params.getReflective("_self")).interactAt((EntityPlayer) params.getReflective("entityplayer"), (Vec3) params.getReflective("vec3"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityArmorStand_methods.add(reflect_EntityArmorStand_method_interactAt_10);


        BaseData reflect_EntityArmorStand_method_attackEntityFrom_11 = new ModData();
        reflect_EntityArmorStand_method_attackEntityFrom_11.set("methodName", "attackEntityFrom");
        reflect_EntityArmorStand_method_attackEntityFrom_11.set("returnType", "boolean");
        reflect_EntityArmorStand_method_attackEntityFrom_11.set("static", false);
        reflect_EntityArmorStand_method_attackEntityFrom_11.set("argnames", new String[]{"damagesource", "var2"});
        reflect_EntityArmorStand_method_attackEntityFrom_11.set("argtypes", new String[]{"DamageSource", "float"});
        reflect_EntityArmorStand_method_attackEntityFrom_11.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityArmorStand) params.getReflective("_self")).attackEntityFrom((DamageSource) params.getReflective("damagesource"), (float) params.getFloat("var2"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityArmorStand_methods.add(reflect_EntityArmorStand_method_attackEntityFrom_11);


        BaseData reflect_EntityArmorStand_method_isInRangeToRenderDist_12 = new ModData();
        reflect_EntityArmorStand_method_isInRangeToRenderDist_12.set("methodName", "isInRangeToRenderDist");
        reflect_EntityArmorStand_method_isInRangeToRenderDist_12.set("returnType", "boolean");
        reflect_EntityArmorStand_method_isInRangeToRenderDist_12.set("static", false);
        reflect_EntityArmorStand_method_isInRangeToRenderDist_12.set("argnames", new String[]{"d0"});
        reflect_EntityArmorStand_method_isInRangeToRenderDist_12.set("argtypes", new String[]{"double"});
        reflect_EntityArmorStand_method_isInRangeToRenderDist_12.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityArmorStand) params.getReflective("_self")).isInRangeToRenderDist((double) params.getDouble("d0"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityArmorStand_methods.add(reflect_EntityArmorStand_method_isInRangeToRenderDist_12);


        BaseData reflect_EntityArmorStand_method_getEyeHeight_13 = new ModData();
        reflect_EntityArmorStand_method_getEyeHeight_13.set("methodName", "getEyeHeight");
        reflect_EntityArmorStand_method_getEyeHeight_13.set("returnType", "float");
        reflect_EntityArmorStand_method_getEyeHeight_13.set("static", false);
        reflect_EntityArmorStand_method_getEyeHeight_13.set("argnames", new String[]{});
        reflect_EntityArmorStand_method_getEyeHeight_13.set("argtypes", new String[]{});
        reflect_EntityArmorStand_method_getEyeHeight_13.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityArmorStand) params.getReflective("_self")).getEyeHeight();
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityArmorStand_methods.add(reflect_EntityArmorStand_method_getEyeHeight_13);


        BaseData reflect_EntityArmorStand_method_moveEntityWithHeading_14 = new ModData();
        reflect_EntityArmorStand_method_moveEntityWithHeading_14.set("methodName", "moveEntityWithHeading");
        reflect_EntityArmorStand_method_moveEntityWithHeading_14.set("returnType", "void");
        reflect_EntityArmorStand_method_moveEntityWithHeading_14.set("static", false);
        reflect_EntityArmorStand_method_moveEntityWithHeading_14.set("argnames", new String[]{"f", "f1"});
        reflect_EntityArmorStand_method_moveEntityWithHeading_14.set("argtypes", new String[]{"float", "float"});
        reflect_EntityArmorStand_method_moveEntityWithHeading_14.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityArmorStand) params.getReflective("_self")).moveEntityWithHeading((float) params.getFloat("f"), (float) params.getFloat("f1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityArmorStand_methods.add(reflect_EntityArmorStand_method_moveEntityWithHeading_14);


        BaseData reflect_EntityArmorStand_method_onUpdate_15 = new ModData();
        reflect_EntityArmorStand_method_onUpdate_15.set("methodName", "onUpdate");
        reflect_EntityArmorStand_method_onUpdate_15.set("returnType", "void");
        reflect_EntityArmorStand_method_onUpdate_15.set("static", false);
        reflect_EntityArmorStand_method_onUpdate_15.set("argnames", new String[]{});
        reflect_EntityArmorStand_method_onUpdate_15.set("argtypes", new String[]{});
        reflect_EntityArmorStand_method_onUpdate_15.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityArmorStand) params.getReflective("_self")).onUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityArmorStand_methods.add(reflect_EntityArmorStand_method_onUpdate_15);


        BaseData reflect_EntityArmorStand_method_setInvisible_16 = new ModData();
        reflect_EntityArmorStand_method_setInvisible_16.set("methodName", "setInvisible");
        reflect_EntityArmorStand_method_setInvisible_16.set("returnType", "void");
        reflect_EntityArmorStand_method_setInvisible_16.set("static", false);
        reflect_EntityArmorStand_method_setInvisible_16.set("argnames", new String[]{"flag"});
        reflect_EntityArmorStand_method_setInvisible_16.set("argtypes", new String[]{"boolean"});
        reflect_EntityArmorStand_method_setInvisible_16.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityArmorStand) params.getReflective("_self")).setInvisible((boolean) params.getBoolean("flag"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityArmorStand_methods.add(reflect_EntityArmorStand_method_setInvisible_16);


        BaseData reflect_EntityArmorStand_method_isChild_17 = new ModData();
        reflect_EntityArmorStand_method_isChild_17.set("methodName", "isChild");
        reflect_EntityArmorStand_method_isChild_17.set("returnType", "boolean");
        reflect_EntityArmorStand_method_isChild_17.set("static", false);
        reflect_EntityArmorStand_method_isChild_17.set("argnames", new String[]{});
        reflect_EntityArmorStand_method_isChild_17.set("argtypes", new String[]{});
        reflect_EntityArmorStand_method_isChild_17.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityArmorStand) params.getReflective("_self")).isChild();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityArmorStand_methods.add(reflect_EntityArmorStand_method_isChild_17);


        BaseData reflect_EntityArmorStand_method_onKillCommand_18 = new ModData();
        reflect_EntityArmorStand_method_onKillCommand_18.set("methodName", "onKillCommand");
        reflect_EntityArmorStand_method_onKillCommand_18.set("returnType", "void");
        reflect_EntityArmorStand_method_onKillCommand_18.set("static", false);
        reflect_EntityArmorStand_method_onKillCommand_18.set("argnames", new String[]{});
        reflect_EntityArmorStand_method_onKillCommand_18.set("argtypes", new String[]{});
        reflect_EntityArmorStand_method_onKillCommand_18.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityArmorStand) params.getReflective("_self")).onKillCommand();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityArmorStand_methods.add(reflect_EntityArmorStand_method_onKillCommand_18);


        BaseData reflect_EntityArmorStand_method_isImmuneToExplosions_19 = new ModData();
        reflect_EntityArmorStand_method_isImmuneToExplosions_19.set("methodName", "isImmuneToExplosions");
        reflect_EntityArmorStand_method_isImmuneToExplosions_19.set("returnType", "boolean");
        reflect_EntityArmorStand_method_isImmuneToExplosions_19.set("static", false);
        reflect_EntityArmorStand_method_isImmuneToExplosions_19.set("argnames", new String[]{});
        reflect_EntityArmorStand_method_isImmuneToExplosions_19.set("argtypes", new String[]{});
        reflect_EntityArmorStand_method_isImmuneToExplosions_19.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityArmorStand) params.getReflective("_self")).isImmuneToExplosions();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityArmorStand_methods.add(reflect_EntityArmorStand_method_isImmuneToExplosions_19);


        BaseData reflect_EntityArmorStand_method_isSmall_20 = new ModData();
        reflect_EntityArmorStand_method_isSmall_20.set("methodName", "isSmall");
        reflect_EntityArmorStand_method_isSmall_20.set("returnType", "boolean");
        reflect_EntityArmorStand_method_isSmall_20.set("static", false);
        reflect_EntityArmorStand_method_isSmall_20.set("argnames", new String[]{});
        reflect_EntityArmorStand_method_isSmall_20.set("argtypes", new String[]{});
        reflect_EntityArmorStand_method_isSmall_20.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityArmorStand) params.getReflective("_self")).isSmall();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityArmorStand_methods.add(reflect_EntityArmorStand_method_isSmall_20);


        BaseData reflect_EntityArmorStand_method_hasNoGravity_21 = new ModData();
        reflect_EntityArmorStand_method_hasNoGravity_21.set("methodName", "hasNoGravity");
        reflect_EntityArmorStand_method_hasNoGravity_21.set("returnType", "boolean");
        reflect_EntityArmorStand_method_hasNoGravity_21.set("static", false);
        reflect_EntityArmorStand_method_hasNoGravity_21.set("argnames", new String[]{});
        reflect_EntityArmorStand_method_hasNoGravity_21.set("argtypes", new String[]{});
        reflect_EntityArmorStand_method_hasNoGravity_21.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityArmorStand) params.getReflective("_self")).hasNoGravity();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityArmorStand_methods.add(reflect_EntityArmorStand_method_hasNoGravity_21);


        BaseData reflect_EntityArmorStand_method_getShowArms_22 = new ModData();
        reflect_EntityArmorStand_method_getShowArms_22.set("methodName", "getShowArms");
        reflect_EntityArmorStand_method_getShowArms_22.set("returnType", "boolean");
        reflect_EntityArmorStand_method_getShowArms_22.set("static", false);
        reflect_EntityArmorStand_method_getShowArms_22.set("argnames", new String[]{});
        reflect_EntityArmorStand_method_getShowArms_22.set("argtypes", new String[]{});
        reflect_EntityArmorStand_method_getShowArms_22.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityArmorStand) params.getReflective("_self")).getShowArms();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityArmorStand_methods.add(reflect_EntityArmorStand_method_getShowArms_22);


        BaseData reflect_EntityArmorStand_method_hasNoBasePlate_23 = new ModData();
        reflect_EntityArmorStand_method_hasNoBasePlate_23.set("methodName", "hasNoBasePlate");
        reflect_EntityArmorStand_method_hasNoBasePlate_23.set("returnType", "boolean");
        reflect_EntityArmorStand_method_hasNoBasePlate_23.set("static", false);
        reflect_EntityArmorStand_method_hasNoBasePlate_23.set("argnames", new String[]{});
        reflect_EntityArmorStand_method_hasNoBasePlate_23.set("argtypes", new String[]{});
        reflect_EntityArmorStand_method_hasNoBasePlate_23.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityArmorStand) params.getReflective("_self")).hasNoBasePlate();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityArmorStand_methods.add(reflect_EntityArmorStand_method_hasNoBasePlate_23);


        BaseData reflect_EntityArmorStand_method_func_181026_s_24 = new ModData();
        reflect_EntityArmorStand_method_func_181026_s_24.set("methodName", "func_181026_s");
        reflect_EntityArmorStand_method_func_181026_s_24.set("returnType", "boolean");
        reflect_EntityArmorStand_method_func_181026_s_24.set("static", false);
        reflect_EntityArmorStand_method_func_181026_s_24.set("argnames", new String[]{});
        reflect_EntityArmorStand_method_func_181026_s_24.set("argtypes", new String[]{});
        reflect_EntityArmorStand_method_func_181026_s_24.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityArmorStand) params.getReflective("_self")).func_181026_s();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityArmorStand_methods.add(reflect_EntityArmorStand_method_func_181026_s_24);


        BaseData reflect_EntityArmorStand_method_setHeadRotation_25 = new ModData();
        reflect_EntityArmorStand_method_setHeadRotation_25.set("methodName", "setHeadRotation");
        reflect_EntityArmorStand_method_setHeadRotation_25.set("returnType", "void");
        reflect_EntityArmorStand_method_setHeadRotation_25.set("static", false);
        reflect_EntityArmorStand_method_setHeadRotation_25.set("argnames", new String[]{"parRotations"});
        reflect_EntityArmorStand_method_setHeadRotation_25.set("argtypes", new String[]{"Rotations"});
        reflect_EntityArmorStand_method_setHeadRotation_25.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityArmorStand) params.getReflective("_self")).setHeadRotation((Rotations) params.getReflective("parRotations"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityArmorStand_methods.add(reflect_EntityArmorStand_method_setHeadRotation_25);


        BaseData reflect_EntityArmorStand_method_setBodyRotation_26 = new ModData();
        reflect_EntityArmorStand_method_setBodyRotation_26.set("methodName", "setBodyRotation");
        reflect_EntityArmorStand_method_setBodyRotation_26.set("returnType", "void");
        reflect_EntityArmorStand_method_setBodyRotation_26.set("static", false);
        reflect_EntityArmorStand_method_setBodyRotation_26.set("argnames", new String[]{"parRotations"});
        reflect_EntityArmorStand_method_setBodyRotation_26.set("argtypes", new String[]{"Rotations"});
        reflect_EntityArmorStand_method_setBodyRotation_26.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityArmorStand) params.getReflective("_self")).setBodyRotation((Rotations) params.getReflective("parRotations"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityArmorStand_methods.add(reflect_EntityArmorStand_method_setBodyRotation_26);


        BaseData reflect_EntityArmorStand_method_setLeftArmRotation_27 = new ModData();
        reflect_EntityArmorStand_method_setLeftArmRotation_27.set("methodName", "setLeftArmRotation");
        reflect_EntityArmorStand_method_setLeftArmRotation_27.set("returnType", "void");
        reflect_EntityArmorStand_method_setLeftArmRotation_27.set("static", false);
        reflect_EntityArmorStand_method_setLeftArmRotation_27.set("argnames", new String[]{"parRotations"});
        reflect_EntityArmorStand_method_setLeftArmRotation_27.set("argtypes", new String[]{"Rotations"});
        reflect_EntityArmorStand_method_setLeftArmRotation_27.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityArmorStand) params.getReflective("_self")).setLeftArmRotation((Rotations) params.getReflective("parRotations"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityArmorStand_methods.add(reflect_EntityArmorStand_method_setLeftArmRotation_27);


        BaseData reflect_EntityArmorStand_method_setRightArmRotation_28 = new ModData();
        reflect_EntityArmorStand_method_setRightArmRotation_28.set("methodName", "setRightArmRotation");
        reflect_EntityArmorStand_method_setRightArmRotation_28.set("returnType", "void");
        reflect_EntityArmorStand_method_setRightArmRotation_28.set("static", false);
        reflect_EntityArmorStand_method_setRightArmRotation_28.set("argnames", new String[]{"parRotations"});
        reflect_EntityArmorStand_method_setRightArmRotation_28.set("argtypes", new String[]{"Rotations"});
        reflect_EntityArmorStand_method_setRightArmRotation_28.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityArmorStand) params.getReflective("_self")).setRightArmRotation((Rotations) params.getReflective("parRotations"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityArmorStand_methods.add(reflect_EntityArmorStand_method_setRightArmRotation_28);


        BaseData reflect_EntityArmorStand_method_setLeftLegRotation_29 = new ModData();
        reflect_EntityArmorStand_method_setLeftLegRotation_29.set("methodName", "setLeftLegRotation");
        reflect_EntityArmorStand_method_setLeftLegRotation_29.set("returnType", "void");
        reflect_EntityArmorStand_method_setLeftLegRotation_29.set("static", false);
        reflect_EntityArmorStand_method_setLeftLegRotation_29.set("argnames", new String[]{"parRotations"});
        reflect_EntityArmorStand_method_setLeftLegRotation_29.set("argtypes", new String[]{"Rotations"});
        reflect_EntityArmorStand_method_setLeftLegRotation_29.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityArmorStand) params.getReflective("_self")).setLeftLegRotation((Rotations) params.getReflective("parRotations"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityArmorStand_methods.add(reflect_EntityArmorStand_method_setLeftLegRotation_29);


        BaseData reflect_EntityArmorStand_method_setRightLegRotation_30 = new ModData();
        reflect_EntityArmorStand_method_setRightLegRotation_30.set("methodName", "setRightLegRotation");
        reflect_EntityArmorStand_method_setRightLegRotation_30.set("returnType", "void");
        reflect_EntityArmorStand_method_setRightLegRotation_30.set("static", false);
        reflect_EntityArmorStand_method_setRightLegRotation_30.set("argnames", new String[]{"parRotations"});
        reflect_EntityArmorStand_method_setRightLegRotation_30.set("argtypes", new String[]{"Rotations"});
        reflect_EntityArmorStand_method_setRightLegRotation_30.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityArmorStand) params.getReflective("_self")).setRightLegRotation((Rotations) params.getReflective("parRotations"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityArmorStand_methods.add(reflect_EntityArmorStand_method_setRightLegRotation_30);


        BaseData reflect_EntityArmorStand_method_getHeadRotation_31 = new ModData();
        reflect_EntityArmorStand_method_getHeadRotation_31.set("methodName", "getHeadRotation");
        reflect_EntityArmorStand_method_getHeadRotation_31.set("returnType", "Rotations");
        reflect_EntityArmorStand_method_getHeadRotation_31.set("static", false);
        reflect_EntityArmorStand_method_getHeadRotation_31.set("argnames", new String[]{});
        reflect_EntityArmorStand_method_getHeadRotation_31.set("argtypes", new String[]{});
        reflect_EntityArmorStand_method_getHeadRotation_31.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Rotations) ((EntityArmorStand) params.getReflective("_self")).getHeadRotation();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityArmorStand_methods.add(reflect_EntityArmorStand_method_getHeadRotation_31);


        BaseData reflect_EntityArmorStand_method_getBodyRotation_32 = new ModData();
        reflect_EntityArmorStand_method_getBodyRotation_32.set("methodName", "getBodyRotation");
        reflect_EntityArmorStand_method_getBodyRotation_32.set("returnType", "Rotations");
        reflect_EntityArmorStand_method_getBodyRotation_32.set("static", false);
        reflect_EntityArmorStand_method_getBodyRotation_32.set("argnames", new String[]{});
        reflect_EntityArmorStand_method_getBodyRotation_32.set("argtypes", new String[]{});
        reflect_EntityArmorStand_method_getBodyRotation_32.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Rotations) ((EntityArmorStand) params.getReflective("_self")).getBodyRotation();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityArmorStand_methods.add(reflect_EntityArmorStand_method_getBodyRotation_32);


        BaseData reflect_EntityArmorStand_method_getLeftArmRotation_33 = new ModData();
        reflect_EntityArmorStand_method_getLeftArmRotation_33.set("methodName", "getLeftArmRotation");
        reflect_EntityArmorStand_method_getLeftArmRotation_33.set("returnType", "Rotations");
        reflect_EntityArmorStand_method_getLeftArmRotation_33.set("static", false);
        reflect_EntityArmorStand_method_getLeftArmRotation_33.set("argnames", new String[]{});
        reflect_EntityArmorStand_method_getLeftArmRotation_33.set("argtypes", new String[]{});
        reflect_EntityArmorStand_method_getLeftArmRotation_33.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Rotations) ((EntityArmorStand) params.getReflective("_self")).getLeftArmRotation();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityArmorStand_methods.add(reflect_EntityArmorStand_method_getLeftArmRotation_33);


        BaseData reflect_EntityArmorStand_method_getRightArmRotation_34 = new ModData();
        reflect_EntityArmorStand_method_getRightArmRotation_34.set("methodName", "getRightArmRotation");
        reflect_EntityArmorStand_method_getRightArmRotation_34.set("returnType", "Rotations");
        reflect_EntityArmorStand_method_getRightArmRotation_34.set("static", false);
        reflect_EntityArmorStand_method_getRightArmRotation_34.set("argnames", new String[]{});
        reflect_EntityArmorStand_method_getRightArmRotation_34.set("argtypes", new String[]{});
        reflect_EntityArmorStand_method_getRightArmRotation_34.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Rotations) ((EntityArmorStand) params.getReflective("_self")).getRightArmRotation();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityArmorStand_methods.add(reflect_EntityArmorStand_method_getRightArmRotation_34);


        BaseData reflect_EntityArmorStand_method_getLeftLegRotation_35 = new ModData();
        reflect_EntityArmorStand_method_getLeftLegRotation_35.set("methodName", "getLeftLegRotation");
        reflect_EntityArmorStand_method_getLeftLegRotation_35.set("returnType", "Rotations");
        reflect_EntityArmorStand_method_getLeftLegRotation_35.set("static", false);
        reflect_EntityArmorStand_method_getLeftLegRotation_35.set("argnames", new String[]{});
        reflect_EntityArmorStand_method_getLeftLegRotation_35.set("argtypes", new String[]{});
        reflect_EntityArmorStand_method_getLeftLegRotation_35.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Rotations) ((EntityArmorStand) params.getReflective("_self")).getLeftLegRotation();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityArmorStand_methods.add(reflect_EntityArmorStand_method_getLeftLegRotation_35);


        BaseData reflect_EntityArmorStand_method_getRightLegRotation_36 = new ModData();
        reflect_EntityArmorStand_method_getRightLegRotation_36.set("methodName", "getRightLegRotation");
        reflect_EntityArmorStand_method_getRightLegRotation_36.set("returnType", "Rotations");
        reflect_EntityArmorStand_method_getRightLegRotation_36.set("static", false);
        reflect_EntityArmorStand_method_getRightLegRotation_36.set("argnames", new String[]{});
        reflect_EntityArmorStand_method_getRightLegRotation_36.set("argtypes", new String[]{});
        reflect_EntityArmorStand_method_getRightLegRotation_36.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Rotations) ((EntityArmorStand) params.getReflective("_self")).getRightLegRotation();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityArmorStand_methods.add(reflect_EntityArmorStand_method_getRightLegRotation_36);


        BaseData reflect_EntityArmorStand_method_canBeCollidedWith_37 = new ModData();
        reflect_EntityArmorStand_method_canBeCollidedWith_37.set("methodName", "canBeCollidedWith");
        reflect_EntityArmorStand_method_canBeCollidedWith_37.set("returnType", "boolean");
        reflect_EntityArmorStand_method_canBeCollidedWith_37.set("static", false);
        reflect_EntityArmorStand_method_canBeCollidedWith_37.set("argnames", new String[]{});
        reflect_EntityArmorStand_method_canBeCollidedWith_37.set("argtypes", new String[]{});
        reflect_EntityArmorStand_method_canBeCollidedWith_37.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityArmorStand) params.getReflective("_self")).canBeCollidedWith();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityArmorStand_methods.add(reflect_EntityArmorStand_method_canBeCollidedWith_37);


        BaseData[] reflect_EntityArmorStand_methods_arr = new BaseData[reflect_EntityArmorStand_methods.size()];
        for (int i = 0; i < reflect_EntityArmorStand_methods_arr.length; i++) {
            reflect_EntityArmorStand_methods_arr[i] = reflect_EntityArmorStand_methods.get(i);
        }

        reflect_EntityArmorStand.set("constructors", reflect_EntityArmorStand_constructors_arr);
        reflect_EntityArmorStand.set("methods", reflect_EntityArmorStand_methods_arr);
        reflect_EntityArmorStand.set("className", "EntityArmorStand");
        reflect_EntityArmorStand.set("classId", "net.minecraft.entity.item.EntityArmorStand");
        reflect_EntityArmorStand.set("class", EntityArmorStand.class);
        reflect_EntityArmorStand.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityArmorStand;
        });
        reflectProfiles.add(reflect_EntityArmorStand);
    }


    //classdef for EntityBoat
    public static void reflect_EntityBoat_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityBoat = new ModData();

        ArrayList<BaseData> reflect_EntityBoat_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_EntityBoat_constructor_EntityBoat_0 = new ModData();
        reflect_EntityBoat_constructor_EntityBoat_0.set("returnType", "EntityBoat");
        reflect_EntityBoat_constructor_EntityBoat_0.set("argnames", new String[]{"worldIn"});
        reflect_EntityBoat_constructor_EntityBoat_0.set("argtypes", new String[]{"World"});
        reflect_EntityBoat_constructor_EntityBoat_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityBoat((World) params.getReflective("worldIn"));
        });
        
        reflect_EntityBoat_constructors.add(reflect_EntityBoat_constructor_EntityBoat_0);


        BaseData reflect_EntityBoat_constructor_EntityBoat_1 = new ModData();
        reflect_EntityBoat_constructor_EntityBoat_1.set("returnType", "EntityBoat");
        reflect_EntityBoat_constructor_EntityBoat_1.set("argnames", new String[]{"worldIn", "parDouble1", "parDouble2", "parDouble3"});
        reflect_EntityBoat_constructor_EntityBoat_1.set("argtypes", new String[]{"World", "double", "double", "double"});
        reflect_EntityBoat_constructor_EntityBoat_1.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityBoat((World) params.getReflective("worldIn"), (double) params.getDouble("parDouble1"), (double) params.getDouble("parDouble2"), (double) params.getDouble("parDouble3"));
        });
        
        reflect_EntityBoat_constructors.add(reflect_EntityBoat_constructor_EntityBoat_1);


        BaseData[] reflect_EntityBoat_constructors_arr = new BaseData[reflect_EntityBoat_constructors.size()];
        for (int i = 0; i < reflect_EntityBoat_constructors_arr.length; i++) {
            reflect_EntityBoat_constructors_arr[i] = reflect_EntityBoat_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityBoat_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityBoat_method_getCollisionBox_0 = new ModData();
        reflect_EntityBoat_method_getCollisionBox_0.set("methodName", "getCollisionBox");
        reflect_EntityBoat_method_getCollisionBox_0.set("returnType", "AxisAlignedBB");
        reflect_EntityBoat_method_getCollisionBox_0.set("static", false);
        reflect_EntityBoat_method_getCollisionBox_0.set("argnames", new String[]{"entity"});
        reflect_EntityBoat_method_getCollisionBox_0.set("argtypes", new String[]{"Entity"});
        reflect_EntityBoat_method_getCollisionBox_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (AxisAlignedBB) ((EntityBoat) params.getReflective("_self")).getCollisionBox((Entity) params.getReflective("entity"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityBoat_methods.add(reflect_EntityBoat_method_getCollisionBox_0);


        BaseData reflect_EntityBoat_method_getCollisionBoundingBox_1 = new ModData();
        reflect_EntityBoat_method_getCollisionBoundingBox_1.set("methodName", "getCollisionBoundingBox");
        reflect_EntityBoat_method_getCollisionBoundingBox_1.set("returnType", "AxisAlignedBB");
        reflect_EntityBoat_method_getCollisionBoundingBox_1.set("static", false);
        reflect_EntityBoat_method_getCollisionBoundingBox_1.set("argnames", new String[]{});
        reflect_EntityBoat_method_getCollisionBoundingBox_1.set("argtypes", new String[]{});
        reflect_EntityBoat_method_getCollisionBoundingBox_1.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (AxisAlignedBB) ((EntityBoat) params.getReflective("_self")).getCollisionBoundingBox();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityBoat_methods.add(reflect_EntityBoat_method_getCollisionBoundingBox_1);


        BaseData reflect_EntityBoat_method_canBePushed_2 = new ModData();
        reflect_EntityBoat_method_canBePushed_2.set("methodName", "canBePushed");
        reflect_EntityBoat_method_canBePushed_2.set("returnType", "boolean");
        reflect_EntityBoat_method_canBePushed_2.set("static", false);
        reflect_EntityBoat_method_canBePushed_2.set("argnames", new String[]{});
        reflect_EntityBoat_method_canBePushed_2.set("argtypes", new String[]{});
        reflect_EntityBoat_method_canBePushed_2.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityBoat) params.getReflective("_self")).canBePushed();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityBoat_methods.add(reflect_EntityBoat_method_canBePushed_2);


        BaseData reflect_EntityBoat_method_getMountedYOffset_3 = new ModData();
        reflect_EntityBoat_method_getMountedYOffset_3.set("methodName", "getMountedYOffset");
        reflect_EntityBoat_method_getMountedYOffset_3.set("returnType", "double");
        reflect_EntityBoat_method_getMountedYOffset_3.set("static", false);
        reflect_EntityBoat_method_getMountedYOffset_3.set("argnames", new String[]{});
        reflect_EntityBoat_method_getMountedYOffset_3.set("argtypes", new String[]{});
        reflect_EntityBoat_method_getMountedYOffset_3.setCallbackDoubleWithDataArg("exec", (BaseData params) -> {
                try {
                    return (double) ((EntityBoat) params.getReflective("_self")).getMountedYOffset();
                } catch (Exception _exception_reflect_) {
                    return 0.0d;
                }
            });
            
        reflect_EntityBoat_methods.add(reflect_EntityBoat_method_getMountedYOffset_3);


        BaseData reflect_EntityBoat_method_attackEntityFrom_4 = new ModData();
        reflect_EntityBoat_method_attackEntityFrom_4.set("methodName", "attackEntityFrom");
        reflect_EntityBoat_method_attackEntityFrom_4.set("returnType", "boolean");
        reflect_EntityBoat_method_attackEntityFrom_4.set("static", false);
        reflect_EntityBoat_method_attackEntityFrom_4.set("argnames", new String[]{"damagesource", "f"});
        reflect_EntityBoat_method_attackEntityFrom_4.set("argtypes", new String[]{"DamageSource", "float"});
        reflect_EntityBoat_method_attackEntityFrom_4.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityBoat) params.getReflective("_self")).attackEntityFrom((DamageSource) params.getReflective("damagesource"), (float) params.getFloat("f"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityBoat_methods.add(reflect_EntityBoat_method_attackEntityFrom_4);


        BaseData reflect_EntityBoat_method_performHurtAnimation_5 = new ModData();
        reflect_EntityBoat_method_performHurtAnimation_5.set("methodName", "performHurtAnimation");
        reflect_EntityBoat_method_performHurtAnimation_5.set("returnType", "void");
        reflect_EntityBoat_method_performHurtAnimation_5.set("static", false);
        reflect_EntityBoat_method_performHurtAnimation_5.set("argnames", new String[]{});
        reflect_EntityBoat_method_performHurtAnimation_5.set("argtypes", new String[]{});
        reflect_EntityBoat_method_performHurtAnimation_5.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityBoat) params.getReflective("_self")).performHurtAnimation();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityBoat_methods.add(reflect_EntityBoat_method_performHurtAnimation_5);


        BaseData reflect_EntityBoat_method_canBeCollidedWith_6 = new ModData();
        reflect_EntityBoat_method_canBeCollidedWith_6.set("methodName", "canBeCollidedWith");
        reflect_EntityBoat_method_canBeCollidedWith_6.set("returnType", "boolean");
        reflect_EntityBoat_method_canBeCollidedWith_6.set("static", false);
        reflect_EntityBoat_method_canBeCollidedWith_6.set("argnames", new String[]{});
        reflect_EntityBoat_method_canBeCollidedWith_6.set("argtypes", new String[]{});
        reflect_EntityBoat_method_canBeCollidedWith_6.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityBoat) params.getReflective("_self")).canBeCollidedWith();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityBoat_methods.add(reflect_EntityBoat_method_canBeCollidedWith_6);


        BaseData reflect_EntityBoat_method_setPositionAndRotation2_7 = new ModData();
        reflect_EntityBoat_method_setPositionAndRotation2_7.set("methodName", "setPositionAndRotation2");
        reflect_EntityBoat_method_setPositionAndRotation2_7.set("returnType", "void");
        reflect_EntityBoat_method_setPositionAndRotation2_7.set("static", false);
        reflect_EntityBoat_method_setPositionAndRotation2_7.set("argnames", new String[]{"d0", "d1", "d2", "f", "f1", "i", "flag"});
        reflect_EntityBoat_method_setPositionAndRotation2_7.set("argtypes", new String[]{"double", "double", "double", "float", "float", "int", "boolean"});
        reflect_EntityBoat_method_setPositionAndRotation2_7.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityBoat) params.getReflective("_self")).setPositionAndRotation2((double) params.getDouble("d0"), (double) params.getDouble("d1"), (double) params.getDouble("d2"), (float) params.getFloat("f"), (float) params.getFloat("f1"), (int) params.getInt("i"), (boolean) params.getBoolean("flag"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityBoat_methods.add(reflect_EntityBoat_method_setPositionAndRotation2_7);


        BaseData reflect_EntityBoat_method_setVelocity_8 = new ModData();
        reflect_EntityBoat_method_setVelocity_8.set("methodName", "setVelocity");
        reflect_EntityBoat_method_setVelocity_8.set("returnType", "void");
        reflect_EntityBoat_method_setVelocity_8.set("static", false);
        reflect_EntityBoat_method_setVelocity_8.set("argnames", new String[]{"d0", "d1", "d2"});
        reflect_EntityBoat_method_setVelocity_8.set("argtypes", new String[]{"double", "double", "double"});
        reflect_EntityBoat_method_setVelocity_8.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityBoat) params.getReflective("_self")).setVelocity((double) params.getDouble("d0"), (double) params.getDouble("d1"), (double) params.getDouble("d2"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityBoat_methods.add(reflect_EntityBoat_method_setVelocity_8);


        BaseData reflect_EntityBoat_method_onUpdate_9 = new ModData();
        reflect_EntityBoat_method_onUpdate_9.set("methodName", "onUpdate");
        reflect_EntityBoat_method_onUpdate_9.set("returnType", "void");
        reflect_EntityBoat_method_onUpdate_9.set("static", false);
        reflect_EntityBoat_method_onUpdate_9.set("argnames", new String[]{});
        reflect_EntityBoat_method_onUpdate_9.set("argtypes", new String[]{});
        reflect_EntityBoat_method_onUpdate_9.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityBoat) params.getReflective("_self")).onUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityBoat_methods.add(reflect_EntityBoat_method_onUpdate_9);


        BaseData reflect_EntityBoat_method_updateRiderPosition_10 = new ModData();
        reflect_EntityBoat_method_updateRiderPosition_10.set("methodName", "updateRiderPosition");
        reflect_EntityBoat_method_updateRiderPosition_10.set("returnType", "void");
        reflect_EntityBoat_method_updateRiderPosition_10.set("static", false);
        reflect_EntityBoat_method_updateRiderPosition_10.set("argnames", new String[]{});
        reflect_EntityBoat_method_updateRiderPosition_10.set("argtypes", new String[]{});
        reflect_EntityBoat_method_updateRiderPosition_10.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityBoat) params.getReflective("_self")).updateRiderPosition();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityBoat_methods.add(reflect_EntityBoat_method_updateRiderPosition_10);


        BaseData reflect_EntityBoat_method_interactFirst_11 = new ModData();
        reflect_EntityBoat_method_interactFirst_11.set("methodName", "interactFirst");
        reflect_EntityBoat_method_interactFirst_11.set("returnType", "boolean");
        reflect_EntityBoat_method_interactFirst_11.set("static", false);
        reflect_EntityBoat_method_interactFirst_11.set("argnames", new String[]{"entityplayer"});
        reflect_EntityBoat_method_interactFirst_11.set("argtypes", new String[]{"EntityPlayer"});
        reflect_EntityBoat_method_interactFirst_11.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityBoat) params.getReflective("_self")).interactFirst((EntityPlayer) params.getReflective("entityplayer"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityBoat_methods.add(reflect_EntityBoat_method_interactFirst_11);


        BaseData reflect_EntityBoat_method_setDamageTaken_12 = new ModData();
        reflect_EntityBoat_method_setDamageTaken_12.set("methodName", "setDamageTaken");
        reflect_EntityBoat_method_setDamageTaken_12.set("returnType", "void");
        reflect_EntityBoat_method_setDamageTaken_12.set("static", false);
        reflect_EntityBoat_method_setDamageTaken_12.set("argnames", new String[]{"parFloat1"});
        reflect_EntityBoat_method_setDamageTaken_12.set("argtypes", new String[]{"float"});
        reflect_EntityBoat_method_setDamageTaken_12.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityBoat) params.getReflective("_self")).setDamageTaken((float) params.getFloat("parFloat1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityBoat_methods.add(reflect_EntityBoat_method_setDamageTaken_12);


        BaseData reflect_EntityBoat_method_getDamageTaken_13 = new ModData();
        reflect_EntityBoat_method_getDamageTaken_13.set("methodName", "getDamageTaken");
        reflect_EntityBoat_method_getDamageTaken_13.set("returnType", "float");
        reflect_EntityBoat_method_getDamageTaken_13.set("static", false);
        reflect_EntityBoat_method_getDamageTaken_13.set("argnames", new String[]{});
        reflect_EntityBoat_method_getDamageTaken_13.set("argtypes", new String[]{});
        reflect_EntityBoat_method_getDamageTaken_13.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityBoat) params.getReflective("_self")).getDamageTaken();
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityBoat_methods.add(reflect_EntityBoat_method_getDamageTaken_13);


        BaseData reflect_EntityBoat_method_setTimeSinceHit_14 = new ModData();
        reflect_EntityBoat_method_setTimeSinceHit_14.set("methodName", "setTimeSinceHit");
        reflect_EntityBoat_method_setTimeSinceHit_14.set("returnType", "void");
        reflect_EntityBoat_method_setTimeSinceHit_14.set("static", false);
        reflect_EntityBoat_method_setTimeSinceHit_14.set("argnames", new String[]{"parInt1"});
        reflect_EntityBoat_method_setTimeSinceHit_14.set("argtypes", new String[]{"int"});
        reflect_EntityBoat_method_setTimeSinceHit_14.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityBoat) params.getReflective("_self")).setTimeSinceHit((int) params.getInt("parInt1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityBoat_methods.add(reflect_EntityBoat_method_setTimeSinceHit_14);


        BaseData reflect_EntityBoat_method_getTimeSinceHit_15 = new ModData();
        reflect_EntityBoat_method_getTimeSinceHit_15.set("methodName", "getTimeSinceHit");
        reflect_EntityBoat_method_getTimeSinceHit_15.set("returnType", "int");
        reflect_EntityBoat_method_getTimeSinceHit_15.set("static", false);
        reflect_EntityBoat_method_getTimeSinceHit_15.set("argnames", new String[]{});
        reflect_EntityBoat_method_getTimeSinceHit_15.set("argtypes", new String[]{});
        reflect_EntityBoat_method_getTimeSinceHit_15.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityBoat) params.getReflective("_self")).getTimeSinceHit();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityBoat_methods.add(reflect_EntityBoat_method_getTimeSinceHit_15);


        BaseData reflect_EntityBoat_method_setForwardDirection_16 = new ModData();
        reflect_EntityBoat_method_setForwardDirection_16.set("methodName", "setForwardDirection");
        reflect_EntityBoat_method_setForwardDirection_16.set("returnType", "void");
        reflect_EntityBoat_method_setForwardDirection_16.set("static", false);
        reflect_EntityBoat_method_setForwardDirection_16.set("argnames", new String[]{"parInt1"});
        reflect_EntityBoat_method_setForwardDirection_16.set("argtypes", new String[]{"int"});
        reflect_EntityBoat_method_setForwardDirection_16.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityBoat) params.getReflective("_self")).setForwardDirection((int) params.getInt("parInt1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityBoat_methods.add(reflect_EntityBoat_method_setForwardDirection_16);


        BaseData reflect_EntityBoat_method_getForwardDirection_17 = new ModData();
        reflect_EntityBoat_method_getForwardDirection_17.set("methodName", "getForwardDirection");
        reflect_EntityBoat_method_getForwardDirection_17.set("returnType", "int");
        reflect_EntityBoat_method_getForwardDirection_17.set("static", false);
        reflect_EntityBoat_method_getForwardDirection_17.set("argnames", new String[]{});
        reflect_EntityBoat_method_getForwardDirection_17.set("argtypes", new String[]{});
        reflect_EntityBoat_method_getForwardDirection_17.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityBoat) params.getReflective("_self")).getForwardDirection();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityBoat_methods.add(reflect_EntityBoat_method_getForwardDirection_17);


        BaseData reflect_EntityBoat_method_setIsBoatEmpty_18 = new ModData();
        reflect_EntityBoat_method_setIsBoatEmpty_18.set("methodName", "setIsBoatEmpty");
        reflect_EntityBoat_method_setIsBoatEmpty_18.set("returnType", "void");
        reflect_EntityBoat_method_setIsBoatEmpty_18.set("static", false);
        reflect_EntityBoat_method_setIsBoatEmpty_18.set("argnames", new String[]{"parFlag"});
        reflect_EntityBoat_method_setIsBoatEmpty_18.set("argtypes", new String[]{"boolean"});
        reflect_EntityBoat_method_setIsBoatEmpty_18.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityBoat) params.getReflective("_self")).setIsBoatEmpty((boolean) params.getBoolean("parFlag"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityBoat_methods.add(reflect_EntityBoat_method_setIsBoatEmpty_18);


        BaseData[] reflect_EntityBoat_methods_arr = new BaseData[reflect_EntityBoat_methods.size()];
        for (int i = 0; i < reflect_EntityBoat_methods_arr.length; i++) {
            reflect_EntityBoat_methods_arr[i] = reflect_EntityBoat_methods.get(i);
        }

        reflect_EntityBoat.set("constructors", reflect_EntityBoat_constructors_arr);
        reflect_EntityBoat.set("methods", reflect_EntityBoat_methods_arr);
        reflect_EntityBoat.set("className", "EntityBoat");
        reflect_EntityBoat.set("classId", "net.minecraft.entity.item.EntityBoat");
        reflect_EntityBoat.set("class", EntityBoat.class);
        reflect_EntityBoat.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityBoat;
        });
        reflectProfiles.add(reflect_EntityBoat);
    }


    //classdef for EntityEnderCrystal
    public static void reflect_EntityEnderCrystal_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityEnderCrystal = new ModData();

        ArrayList<BaseData> reflect_EntityEnderCrystal_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_EntityEnderCrystal_constructor_EntityEnderCrystal_0 = new ModData();
        reflect_EntityEnderCrystal_constructor_EntityEnderCrystal_0.set("returnType", "EntityEnderCrystal");
        reflect_EntityEnderCrystal_constructor_EntityEnderCrystal_0.set("argnames", new String[]{"worldIn"});
        reflect_EntityEnderCrystal_constructor_EntityEnderCrystal_0.set("argtypes", new String[]{"World"});
        reflect_EntityEnderCrystal_constructor_EntityEnderCrystal_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityEnderCrystal((World) params.getReflective("worldIn"));
        });
        
        reflect_EntityEnderCrystal_constructors.add(reflect_EntityEnderCrystal_constructor_EntityEnderCrystal_0);


        BaseData reflect_EntityEnderCrystal_constructor_EntityEnderCrystal_1 = new ModData();
        reflect_EntityEnderCrystal_constructor_EntityEnderCrystal_1.set("returnType", "EntityEnderCrystal");
        reflect_EntityEnderCrystal_constructor_EntityEnderCrystal_1.set("argnames", new String[]{"worldIn", "parDouble1", "parDouble2", "parDouble3"});
        reflect_EntityEnderCrystal_constructor_EntityEnderCrystal_1.set("argtypes", new String[]{"World", "double", "double", "double"});
        reflect_EntityEnderCrystal_constructor_EntityEnderCrystal_1.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityEnderCrystal((World) params.getReflective("worldIn"), (double) params.getDouble("parDouble1"), (double) params.getDouble("parDouble2"), (double) params.getDouble("parDouble3"));
        });
        
        reflect_EntityEnderCrystal_constructors.add(reflect_EntityEnderCrystal_constructor_EntityEnderCrystal_1);


        BaseData[] reflect_EntityEnderCrystal_constructors_arr = new BaseData[reflect_EntityEnderCrystal_constructors.size()];
        for (int i = 0; i < reflect_EntityEnderCrystal_constructors_arr.length; i++) {
            reflect_EntityEnderCrystal_constructors_arr[i] = reflect_EntityEnderCrystal_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityEnderCrystal_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityEnderCrystal_method_onUpdate_0 = new ModData();
        reflect_EntityEnderCrystal_method_onUpdate_0.set("methodName", "onUpdate");
        reflect_EntityEnderCrystal_method_onUpdate_0.set("returnType", "void");
        reflect_EntityEnderCrystal_method_onUpdate_0.set("static", false);
        reflect_EntityEnderCrystal_method_onUpdate_0.set("argnames", new String[]{});
        reflect_EntityEnderCrystal_method_onUpdate_0.set("argtypes", new String[]{});
        reflect_EntityEnderCrystal_method_onUpdate_0.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityEnderCrystal) params.getReflective("_self")).onUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityEnderCrystal_methods.add(reflect_EntityEnderCrystal_method_onUpdate_0);


        BaseData reflect_EntityEnderCrystal_method_canBeCollidedWith_1 = new ModData();
        reflect_EntityEnderCrystal_method_canBeCollidedWith_1.set("methodName", "canBeCollidedWith");
        reflect_EntityEnderCrystal_method_canBeCollidedWith_1.set("returnType", "boolean");
        reflect_EntityEnderCrystal_method_canBeCollidedWith_1.set("static", false);
        reflect_EntityEnderCrystal_method_canBeCollidedWith_1.set("argnames", new String[]{});
        reflect_EntityEnderCrystal_method_canBeCollidedWith_1.set("argtypes", new String[]{});
        reflect_EntityEnderCrystal_method_canBeCollidedWith_1.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityEnderCrystal) params.getReflective("_self")).canBeCollidedWith();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityEnderCrystal_methods.add(reflect_EntityEnderCrystal_method_canBeCollidedWith_1);


        BaseData reflect_EntityEnderCrystal_method_attackEntityFrom_2 = new ModData();
        reflect_EntityEnderCrystal_method_attackEntityFrom_2.set("methodName", "attackEntityFrom");
        reflect_EntityEnderCrystal_method_attackEntityFrom_2.set("returnType", "boolean");
        reflect_EntityEnderCrystal_method_attackEntityFrom_2.set("static", false);
        reflect_EntityEnderCrystal_method_attackEntityFrom_2.set("argnames", new String[]{"damagesource", "var2"});
        reflect_EntityEnderCrystal_method_attackEntityFrom_2.set("argtypes", new String[]{"DamageSource", "float"});
        reflect_EntityEnderCrystal_method_attackEntityFrom_2.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityEnderCrystal) params.getReflective("_self")).attackEntityFrom((DamageSource) params.getReflective("damagesource"), (float) params.getFloat("var2"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityEnderCrystal_methods.add(reflect_EntityEnderCrystal_method_attackEntityFrom_2);


        BaseData[] reflect_EntityEnderCrystal_methods_arr = new BaseData[reflect_EntityEnderCrystal_methods.size()];
        for (int i = 0; i < reflect_EntityEnderCrystal_methods_arr.length; i++) {
            reflect_EntityEnderCrystal_methods_arr[i] = reflect_EntityEnderCrystal_methods.get(i);
        }

        reflect_EntityEnderCrystal.set("constructors", reflect_EntityEnderCrystal_constructors_arr);
        reflect_EntityEnderCrystal.set("methods", reflect_EntityEnderCrystal_methods_arr);
        reflect_EntityEnderCrystal.set("className", "EntityEnderCrystal");
        reflect_EntityEnderCrystal.set("classId", "net.minecraft.entity.item.EntityEnderCrystal");
        reflect_EntityEnderCrystal.set("class", EntityEnderCrystal.class);
        reflect_EntityEnderCrystal.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityEnderCrystal;
        });
        reflectProfiles.add(reflect_EntityEnderCrystal);
    }


    //classdef for EntityEnderEye
    public static void reflect_EntityEnderEye_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityEnderEye = new ModData();

        ArrayList<BaseData> reflect_EntityEnderEye_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_EntityEnderEye_constructor_EntityEnderEye_0 = new ModData();
        reflect_EntityEnderEye_constructor_EntityEnderEye_0.set("returnType", "EntityEnderEye");
        reflect_EntityEnderEye_constructor_EntityEnderEye_0.set("argnames", new String[]{"worldIn"});
        reflect_EntityEnderEye_constructor_EntityEnderEye_0.set("argtypes", new String[]{"World"});
        reflect_EntityEnderEye_constructor_EntityEnderEye_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityEnderEye((World) params.getReflective("worldIn"));
        });
        
        reflect_EntityEnderEye_constructors.add(reflect_EntityEnderEye_constructor_EntityEnderEye_0);


        BaseData reflect_EntityEnderEye_constructor_EntityEnderEye_1 = new ModData();
        reflect_EntityEnderEye_constructor_EntityEnderEye_1.set("returnType", "EntityEnderEye");
        reflect_EntityEnderEye_constructor_EntityEnderEye_1.set("argnames", new String[]{"worldIn", "x", "y", "z"});
        reflect_EntityEnderEye_constructor_EntityEnderEye_1.set("argtypes", new String[]{"World", "double", "double", "double"});
        reflect_EntityEnderEye_constructor_EntityEnderEye_1.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityEnderEye((World) params.getReflective("worldIn"), (double) params.getDouble("x"), (double) params.getDouble("y"), (double) params.getDouble("z"));
        });
        
        reflect_EntityEnderEye_constructors.add(reflect_EntityEnderEye_constructor_EntityEnderEye_1);


        BaseData[] reflect_EntityEnderEye_constructors_arr = new BaseData[reflect_EntityEnderEye_constructors.size()];
        for (int i = 0; i < reflect_EntityEnderEye_constructors_arr.length; i++) {
            reflect_EntityEnderEye_constructors_arr[i] = reflect_EntityEnderEye_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityEnderEye_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityEnderEye_method_isInRangeToRenderDist_0 = new ModData();
        reflect_EntityEnderEye_method_isInRangeToRenderDist_0.set("methodName", "isInRangeToRenderDist");
        reflect_EntityEnderEye_method_isInRangeToRenderDist_0.set("returnType", "boolean");
        reflect_EntityEnderEye_method_isInRangeToRenderDist_0.set("static", false);
        reflect_EntityEnderEye_method_isInRangeToRenderDist_0.set("argnames", new String[]{"d0"});
        reflect_EntityEnderEye_method_isInRangeToRenderDist_0.set("argtypes", new String[]{"double"});
        reflect_EntityEnderEye_method_isInRangeToRenderDist_0.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityEnderEye) params.getReflective("_self")).isInRangeToRenderDist((double) params.getDouble("d0"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityEnderEye_methods.add(reflect_EntityEnderEye_method_isInRangeToRenderDist_0);


        BaseData reflect_EntityEnderEye_method_moveTowards_1 = new ModData();
        reflect_EntityEnderEye_method_moveTowards_1.set("methodName", "moveTowards");
        reflect_EntityEnderEye_method_moveTowards_1.set("returnType", "void");
        reflect_EntityEnderEye_method_moveTowards_1.set("static", false);
        reflect_EntityEnderEye_method_moveTowards_1.set("argnames", new String[]{"parBlockPos"});
        reflect_EntityEnderEye_method_moveTowards_1.set("argtypes", new String[]{"BlockPos"});
        reflect_EntityEnderEye_method_moveTowards_1.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityEnderEye) params.getReflective("_self")).moveTowards((BlockPos) params.getReflective("parBlockPos"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityEnderEye_methods.add(reflect_EntityEnderEye_method_moveTowards_1);


        BaseData reflect_EntityEnderEye_method_setVelocity_2 = new ModData();
        reflect_EntityEnderEye_method_setVelocity_2.set("methodName", "setVelocity");
        reflect_EntityEnderEye_method_setVelocity_2.set("returnType", "void");
        reflect_EntityEnderEye_method_setVelocity_2.set("static", false);
        reflect_EntityEnderEye_method_setVelocity_2.set("argnames", new String[]{"d0", "d1", "d2"});
        reflect_EntityEnderEye_method_setVelocity_2.set("argtypes", new String[]{"double", "double", "double"});
        reflect_EntityEnderEye_method_setVelocity_2.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityEnderEye) params.getReflective("_self")).setVelocity((double) params.getDouble("d0"), (double) params.getDouble("d1"), (double) params.getDouble("d2"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityEnderEye_methods.add(reflect_EntityEnderEye_method_setVelocity_2);


        BaseData reflect_EntityEnderEye_method_onUpdate_3 = new ModData();
        reflect_EntityEnderEye_method_onUpdate_3.set("methodName", "onUpdate");
        reflect_EntityEnderEye_method_onUpdate_3.set("returnType", "void");
        reflect_EntityEnderEye_method_onUpdate_3.set("static", false);
        reflect_EntityEnderEye_method_onUpdate_3.set("argnames", new String[]{});
        reflect_EntityEnderEye_method_onUpdate_3.set("argtypes", new String[]{});
        reflect_EntityEnderEye_method_onUpdate_3.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityEnderEye) params.getReflective("_self")).onUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityEnderEye_methods.add(reflect_EntityEnderEye_method_onUpdate_3);


        BaseData reflect_EntityEnderEye_method_writeEntityToNBT_4 = new ModData();
        reflect_EntityEnderEye_method_writeEntityToNBT_4.set("methodName", "writeEntityToNBT");
        reflect_EntityEnderEye_method_writeEntityToNBT_4.set("returnType", "void");
        reflect_EntityEnderEye_method_writeEntityToNBT_4.set("static", false);
        reflect_EntityEnderEye_method_writeEntityToNBT_4.set("argnames", new String[]{"var1"});
        reflect_EntityEnderEye_method_writeEntityToNBT_4.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityEnderEye_method_writeEntityToNBT_4.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityEnderEye) params.getReflective("_self")).writeEntityToNBT((NBTTagCompound) params.getReflective("var1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityEnderEye_methods.add(reflect_EntityEnderEye_method_writeEntityToNBT_4);


        BaseData reflect_EntityEnderEye_method_readEntityFromNBT_5 = new ModData();
        reflect_EntityEnderEye_method_readEntityFromNBT_5.set("methodName", "readEntityFromNBT");
        reflect_EntityEnderEye_method_readEntityFromNBT_5.set("returnType", "void");
        reflect_EntityEnderEye_method_readEntityFromNBT_5.set("static", false);
        reflect_EntityEnderEye_method_readEntityFromNBT_5.set("argnames", new String[]{"var1"});
        reflect_EntityEnderEye_method_readEntityFromNBT_5.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityEnderEye_method_readEntityFromNBT_5.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityEnderEye) params.getReflective("_self")).readEntityFromNBT((NBTTagCompound) params.getReflective("var1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityEnderEye_methods.add(reflect_EntityEnderEye_method_readEntityFromNBT_5);


        BaseData reflect_EntityEnderEye_method_getBrightness_6 = new ModData();
        reflect_EntityEnderEye_method_getBrightness_6.set("methodName", "getBrightness");
        reflect_EntityEnderEye_method_getBrightness_6.set("returnType", "float");
        reflect_EntityEnderEye_method_getBrightness_6.set("static", false);
        reflect_EntityEnderEye_method_getBrightness_6.set("argnames", new String[]{"var1"});
        reflect_EntityEnderEye_method_getBrightness_6.set("argtypes", new String[]{"float"});
        reflect_EntityEnderEye_method_getBrightness_6.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityEnderEye) params.getReflective("_self")).getBrightness((float) params.getFloat("var1"));
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityEnderEye_methods.add(reflect_EntityEnderEye_method_getBrightness_6);


        BaseData reflect_EntityEnderEye_method_getBrightnessForRender_7 = new ModData();
        reflect_EntityEnderEye_method_getBrightnessForRender_7.set("methodName", "getBrightnessForRender");
        reflect_EntityEnderEye_method_getBrightnessForRender_7.set("returnType", "int");
        reflect_EntityEnderEye_method_getBrightnessForRender_7.set("static", false);
        reflect_EntityEnderEye_method_getBrightnessForRender_7.set("argnames", new String[]{"var1"});
        reflect_EntityEnderEye_method_getBrightnessForRender_7.set("argtypes", new String[]{"float"});
        reflect_EntityEnderEye_method_getBrightnessForRender_7.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityEnderEye) params.getReflective("_self")).getBrightnessForRender((float) params.getFloat("var1"));
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityEnderEye_methods.add(reflect_EntityEnderEye_method_getBrightnessForRender_7);


        BaseData reflect_EntityEnderEye_method_canAttackWithItem_8 = new ModData();
        reflect_EntityEnderEye_method_canAttackWithItem_8.set("methodName", "canAttackWithItem");
        reflect_EntityEnderEye_method_canAttackWithItem_8.set("returnType", "boolean");
        reflect_EntityEnderEye_method_canAttackWithItem_8.set("static", false);
        reflect_EntityEnderEye_method_canAttackWithItem_8.set("argnames", new String[]{});
        reflect_EntityEnderEye_method_canAttackWithItem_8.set("argtypes", new String[]{});
        reflect_EntityEnderEye_method_canAttackWithItem_8.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityEnderEye) params.getReflective("_self")).canAttackWithItem();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityEnderEye_methods.add(reflect_EntityEnderEye_method_canAttackWithItem_8);


        BaseData[] reflect_EntityEnderEye_methods_arr = new BaseData[reflect_EntityEnderEye_methods.size()];
        for (int i = 0; i < reflect_EntityEnderEye_methods_arr.length; i++) {
            reflect_EntityEnderEye_methods_arr[i] = reflect_EntityEnderEye_methods.get(i);
        }

        reflect_EntityEnderEye.set("constructors", reflect_EntityEnderEye_constructors_arr);
        reflect_EntityEnderEye.set("methods", reflect_EntityEnderEye_methods_arr);
        reflect_EntityEnderEye.set("className", "EntityEnderEye");
        reflect_EntityEnderEye.set("classId", "net.minecraft.entity.item.EntityEnderEye");
        reflect_EntityEnderEye.set("class", EntityEnderEye.class);
        reflect_EntityEnderEye.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityEnderEye;
        });
        reflectProfiles.add(reflect_EntityEnderEye);
    }


    //classdef for EntityEnderPearl
    public static void reflect_EntityEnderPearl_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityEnderPearl = new ModData();

        ArrayList<BaseData> reflect_EntityEnderPearl_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_EntityEnderPearl_constructor_EntityEnderPearl_0 = new ModData();
        reflect_EntityEnderPearl_constructor_EntityEnderPearl_0.set("returnType", "EntityEnderPearl");
        reflect_EntityEnderPearl_constructor_EntityEnderPearl_0.set("argnames", new String[]{"parWorld"});
        reflect_EntityEnderPearl_constructor_EntityEnderPearl_0.set("argtypes", new String[]{"World"});
        reflect_EntityEnderPearl_constructor_EntityEnderPearl_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityEnderPearl((World) params.getReflective("parWorld"));
        });
        
        reflect_EntityEnderPearl_constructors.add(reflect_EntityEnderPearl_constructor_EntityEnderPearl_0);


        BaseData reflect_EntityEnderPearl_constructor_EntityEnderPearl_1 = new ModData();
        reflect_EntityEnderPearl_constructor_EntityEnderPearl_1.set("returnType", "EntityEnderPearl");
        reflect_EntityEnderPearl_constructor_EntityEnderPearl_1.set("argnames", new String[]{"worldIn", "parEntityLivingBase"});
        reflect_EntityEnderPearl_constructor_EntityEnderPearl_1.set("argtypes", new String[]{"World", "EntityLivingBase"});
        reflect_EntityEnderPearl_constructor_EntityEnderPearl_1.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityEnderPearl((World) params.getReflective("worldIn"), (EntityLivingBase) params.getReflective("parEntityLivingBase"));
        });
        
        reflect_EntityEnderPearl_constructors.add(reflect_EntityEnderPearl_constructor_EntityEnderPearl_1);


        BaseData reflect_EntityEnderPearl_constructor_EntityEnderPearl_2 = new ModData();
        reflect_EntityEnderPearl_constructor_EntityEnderPearl_2.set("returnType", "EntityEnderPearl");
        reflect_EntityEnderPearl_constructor_EntityEnderPearl_2.set("argnames", new String[]{"worldIn", "parDouble1", "parDouble2", "parDouble3"});
        reflect_EntityEnderPearl_constructor_EntityEnderPearl_2.set("argtypes", new String[]{"World", "double", "double", "double"});
        reflect_EntityEnderPearl_constructor_EntityEnderPearl_2.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityEnderPearl((World) params.getReflective("worldIn"), (double) params.getDouble("parDouble1"), (double) params.getDouble("parDouble2"), (double) params.getDouble("parDouble3"));
        });
        
        reflect_EntityEnderPearl_constructors.add(reflect_EntityEnderPearl_constructor_EntityEnderPearl_2);


        BaseData[] reflect_EntityEnderPearl_constructors_arr = new BaseData[reflect_EntityEnderPearl_constructors.size()];
        for (int i = 0; i < reflect_EntityEnderPearl_constructors_arr.length; i++) {
            reflect_EntityEnderPearl_constructors_arr[i] = reflect_EntityEnderPearl_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityEnderPearl_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityEnderPearl_method_onUpdate_0 = new ModData();
        reflect_EntityEnderPearl_method_onUpdate_0.set("methodName", "onUpdate");
        reflect_EntityEnderPearl_method_onUpdate_0.set("returnType", "void");
        reflect_EntityEnderPearl_method_onUpdate_0.set("static", false);
        reflect_EntityEnderPearl_method_onUpdate_0.set("argnames", new String[]{});
        reflect_EntityEnderPearl_method_onUpdate_0.set("argtypes", new String[]{});
        reflect_EntityEnderPearl_method_onUpdate_0.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityEnderPearl) params.getReflective("_self")).onUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityEnderPearl_methods.add(reflect_EntityEnderPearl_method_onUpdate_0);


        BaseData[] reflect_EntityEnderPearl_methods_arr = new BaseData[reflect_EntityEnderPearl_methods.size()];
        for (int i = 0; i < reflect_EntityEnderPearl_methods_arr.length; i++) {
            reflect_EntityEnderPearl_methods_arr[i] = reflect_EntityEnderPearl_methods.get(i);
        }

        reflect_EntityEnderPearl.set("constructors", reflect_EntityEnderPearl_constructors_arr);
        reflect_EntityEnderPearl.set("methods", reflect_EntityEnderPearl_methods_arr);
        reflect_EntityEnderPearl.set("className", "EntityEnderPearl");
        reflect_EntityEnderPearl.set("classId", "net.minecraft.entity.item.EntityEnderPearl");
        reflect_EntityEnderPearl.set("class", EntityEnderPearl.class);
        reflect_EntityEnderPearl.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityEnderPearl;
        });
        reflectProfiles.add(reflect_EntityEnderPearl);
    }


    //classdef for EntityExpBottle
    public static void reflect_EntityExpBottle_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityExpBottle = new ModData();

        ArrayList<BaseData> reflect_EntityExpBottle_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_EntityExpBottle_constructor_EntityExpBottle_0 = new ModData();
        reflect_EntityExpBottle_constructor_EntityExpBottle_0.set("returnType", "EntityExpBottle");
        reflect_EntityExpBottle_constructor_EntityExpBottle_0.set("argnames", new String[]{"worldIn"});
        reflect_EntityExpBottle_constructor_EntityExpBottle_0.set("argtypes", new String[]{"World"});
        reflect_EntityExpBottle_constructor_EntityExpBottle_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityExpBottle((World) params.getReflective("worldIn"));
        });
        
        reflect_EntityExpBottle_constructors.add(reflect_EntityExpBottle_constructor_EntityExpBottle_0);


        BaseData reflect_EntityExpBottle_constructor_EntityExpBottle_1 = new ModData();
        reflect_EntityExpBottle_constructor_EntityExpBottle_1.set("returnType", "EntityExpBottle");
        reflect_EntityExpBottle_constructor_EntityExpBottle_1.set("argnames", new String[]{"worldIn", "parEntityLivingBase"});
        reflect_EntityExpBottle_constructor_EntityExpBottle_1.set("argtypes", new String[]{"World", "EntityLivingBase"});
        reflect_EntityExpBottle_constructor_EntityExpBottle_1.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityExpBottle((World) params.getReflective("worldIn"), (EntityLivingBase) params.getReflective("parEntityLivingBase"));
        });
        
        reflect_EntityExpBottle_constructors.add(reflect_EntityExpBottle_constructor_EntityExpBottle_1);


        BaseData reflect_EntityExpBottle_constructor_EntityExpBottle_2 = new ModData();
        reflect_EntityExpBottle_constructor_EntityExpBottle_2.set("returnType", "EntityExpBottle");
        reflect_EntityExpBottle_constructor_EntityExpBottle_2.set("argnames", new String[]{"worldIn", "parDouble1", "parDouble2", "parDouble3"});
        reflect_EntityExpBottle_constructor_EntityExpBottle_2.set("argtypes", new String[]{"World", "double", "double", "double"});
        reflect_EntityExpBottle_constructor_EntityExpBottle_2.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityExpBottle((World) params.getReflective("worldIn"), (double) params.getDouble("parDouble1"), (double) params.getDouble("parDouble2"), (double) params.getDouble("parDouble3"));
        });
        
        reflect_EntityExpBottle_constructors.add(reflect_EntityExpBottle_constructor_EntityExpBottle_2);


        BaseData[] reflect_EntityExpBottle_constructors_arr = new BaseData[reflect_EntityExpBottle_constructors.size()];
        for (int i = 0; i < reflect_EntityExpBottle_constructors_arr.length; i++) {
            reflect_EntityExpBottle_constructors_arr[i] = reflect_EntityExpBottle_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityExpBottle_methods = new ArrayList<BaseData>();
        
        BaseData[] reflect_EntityExpBottle_methods_arr = new BaseData[reflect_EntityExpBottle_methods.size()];
        for (int i = 0; i < reflect_EntityExpBottle_methods_arr.length; i++) {
            reflect_EntityExpBottle_methods_arr[i] = reflect_EntityExpBottle_methods.get(i);
        }

        reflect_EntityExpBottle.set("constructors", reflect_EntityExpBottle_constructors_arr);
        reflect_EntityExpBottle.set("methods", reflect_EntityExpBottle_methods_arr);
        reflect_EntityExpBottle.set("className", "EntityExpBottle");
        reflect_EntityExpBottle.set("classId", "net.minecraft.entity.item.EntityExpBottle");
        reflect_EntityExpBottle.set("class", EntityExpBottle.class);
        reflect_EntityExpBottle.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityExpBottle;
        });
        reflectProfiles.add(reflect_EntityExpBottle);
    }


    //classdef for EntityFallingBlock
    public static void reflect_EntityFallingBlock_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityFallingBlock = new ModData();

        ArrayList<BaseData> reflect_EntityFallingBlock_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_EntityFallingBlock_constructor_EntityFallingBlock_0 = new ModData();
        reflect_EntityFallingBlock_constructor_EntityFallingBlock_0.set("returnType", "EntityFallingBlock");
        reflect_EntityFallingBlock_constructor_EntityFallingBlock_0.set("argnames", new String[]{"worldIn"});
        reflect_EntityFallingBlock_constructor_EntityFallingBlock_0.set("argtypes", new String[]{"World"});
        reflect_EntityFallingBlock_constructor_EntityFallingBlock_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityFallingBlock((World) params.getReflective("worldIn"));
        });
        
        reflect_EntityFallingBlock_constructors.add(reflect_EntityFallingBlock_constructor_EntityFallingBlock_0);


        BaseData reflect_EntityFallingBlock_constructor_EntityFallingBlock_1 = new ModData();
        reflect_EntityFallingBlock_constructor_EntityFallingBlock_1.set("returnType", "EntityFallingBlock");
        reflect_EntityFallingBlock_constructor_EntityFallingBlock_1.set("argnames", new String[]{"worldIn", "x", "y", "z", "fallingBlockState"});
        reflect_EntityFallingBlock_constructor_EntityFallingBlock_1.set("argtypes", new String[]{"World", "double", "double", "double", "IBlockState"});
        reflect_EntityFallingBlock_constructor_EntityFallingBlock_1.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityFallingBlock((World) params.getReflective("worldIn"), (double) params.getDouble("x"), (double) params.getDouble("y"), (double) params.getDouble("z"), (IBlockState) params.getReflective("fallingBlockState"));
        });
        
        reflect_EntityFallingBlock_constructors.add(reflect_EntityFallingBlock_constructor_EntityFallingBlock_1);


        BaseData[] reflect_EntityFallingBlock_constructors_arr = new BaseData[reflect_EntityFallingBlock_constructors.size()];
        for (int i = 0; i < reflect_EntityFallingBlock_constructors_arr.length; i++) {
            reflect_EntityFallingBlock_constructors_arr[i] = reflect_EntityFallingBlock_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityFallingBlock_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityFallingBlock_method_canBeCollidedWith_0 = new ModData();
        reflect_EntityFallingBlock_method_canBeCollidedWith_0.set("methodName", "canBeCollidedWith");
        reflect_EntityFallingBlock_method_canBeCollidedWith_0.set("returnType", "boolean");
        reflect_EntityFallingBlock_method_canBeCollidedWith_0.set("static", false);
        reflect_EntityFallingBlock_method_canBeCollidedWith_0.set("argnames", new String[]{});
        reflect_EntityFallingBlock_method_canBeCollidedWith_0.set("argtypes", new String[]{});
        reflect_EntityFallingBlock_method_canBeCollidedWith_0.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityFallingBlock) params.getReflective("_self")).canBeCollidedWith();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityFallingBlock_methods.add(reflect_EntityFallingBlock_method_canBeCollidedWith_0);


        BaseData reflect_EntityFallingBlock_method_onUpdate_1 = new ModData();
        reflect_EntityFallingBlock_method_onUpdate_1.set("methodName", "onUpdate");
        reflect_EntityFallingBlock_method_onUpdate_1.set("returnType", "void");
        reflect_EntityFallingBlock_method_onUpdate_1.set("static", false);
        reflect_EntityFallingBlock_method_onUpdate_1.set("argnames", new String[]{});
        reflect_EntityFallingBlock_method_onUpdate_1.set("argtypes", new String[]{});
        reflect_EntityFallingBlock_method_onUpdate_1.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityFallingBlock) params.getReflective("_self")).onUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityFallingBlock_methods.add(reflect_EntityFallingBlock_method_onUpdate_1);


        BaseData reflect_EntityFallingBlock_method_fall_2 = new ModData();
        reflect_EntityFallingBlock_method_fall_2.set("methodName", "fall");
        reflect_EntityFallingBlock_method_fall_2.set("returnType", "void");
        reflect_EntityFallingBlock_method_fall_2.set("static", false);
        reflect_EntityFallingBlock_method_fall_2.set("argnames", new String[]{"f", "var2"});
        reflect_EntityFallingBlock_method_fall_2.set("argtypes", new String[]{"float", "float"});
        reflect_EntityFallingBlock_method_fall_2.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityFallingBlock) params.getReflective("_self")).fall((float) params.getFloat("f"), (float) params.getFloat("var2"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityFallingBlock_methods.add(reflect_EntityFallingBlock_method_fall_2);


        BaseData reflect_EntityFallingBlock_method_getWorldObj_3 = new ModData();
        reflect_EntityFallingBlock_method_getWorldObj_3.set("methodName", "getWorldObj");
        reflect_EntityFallingBlock_method_getWorldObj_3.set("returnType", "World");
        reflect_EntityFallingBlock_method_getWorldObj_3.set("static", false);
        reflect_EntityFallingBlock_method_getWorldObj_3.set("argnames", new String[]{});
        reflect_EntityFallingBlock_method_getWorldObj_3.set("argtypes", new String[]{});
        reflect_EntityFallingBlock_method_getWorldObj_3.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (World) ((EntityFallingBlock) params.getReflective("_self")).getWorldObj();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityFallingBlock_methods.add(reflect_EntityFallingBlock_method_getWorldObj_3);


        BaseData reflect_EntityFallingBlock_method_setHurtEntities_4 = new ModData();
        reflect_EntityFallingBlock_method_setHurtEntities_4.set("methodName", "setHurtEntities");
        reflect_EntityFallingBlock_method_setHurtEntities_4.set("returnType", "void");
        reflect_EntityFallingBlock_method_setHurtEntities_4.set("static", false);
        reflect_EntityFallingBlock_method_setHurtEntities_4.set("argnames", new String[]{"parFlag"});
        reflect_EntityFallingBlock_method_setHurtEntities_4.set("argtypes", new String[]{"boolean"});
        reflect_EntityFallingBlock_method_setHurtEntities_4.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityFallingBlock) params.getReflective("_self")).setHurtEntities((boolean) params.getBoolean("parFlag"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityFallingBlock_methods.add(reflect_EntityFallingBlock_method_setHurtEntities_4);


        BaseData reflect_EntityFallingBlock_method_canRenderOnFire_5 = new ModData();
        reflect_EntityFallingBlock_method_canRenderOnFire_5.set("methodName", "canRenderOnFire");
        reflect_EntityFallingBlock_method_canRenderOnFire_5.set("returnType", "boolean");
        reflect_EntityFallingBlock_method_canRenderOnFire_5.set("static", false);
        reflect_EntityFallingBlock_method_canRenderOnFire_5.set("argnames", new String[]{});
        reflect_EntityFallingBlock_method_canRenderOnFire_5.set("argtypes", new String[]{});
        reflect_EntityFallingBlock_method_canRenderOnFire_5.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityFallingBlock) params.getReflective("_self")).canRenderOnFire();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityFallingBlock_methods.add(reflect_EntityFallingBlock_method_canRenderOnFire_5);


        BaseData reflect_EntityFallingBlock_method_addEntityCrashInfo_6 = new ModData();
        reflect_EntityFallingBlock_method_addEntityCrashInfo_6.set("methodName", "addEntityCrashInfo");
        reflect_EntityFallingBlock_method_addEntityCrashInfo_6.set("returnType", "void");
        reflect_EntityFallingBlock_method_addEntityCrashInfo_6.set("static", false);
        reflect_EntityFallingBlock_method_addEntityCrashInfo_6.set("argnames", new String[]{"crashreportcategory"});
        reflect_EntityFallingBlock_method_addEntityCrashInfo_6.set("argtypes", new String[]{"CrashReportCategory"});
        reflect_EntityFallingBlock_method_addEntityCrashInfo_6.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityFallingBlock) params.getReflective("_self")).addEntityCrashInfo((CrashReportCategory) params.getReflective("crashreportcategory"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityFallingBlock_methods.add(reflect_EntityFallingBlock_method_addEntityCrashInfo_6);


        BaseData reflect_EntityFallingBlock_method_getBlock_7 = new ModData();
        reflect_EntityFallingBlock_method_getBlock_7.set("methodName", "getBlock");
        reflect_EntityFallingBlock_method_getBlock_7.set("returnType", "IBlockState");
        reflect_EntityFallingBlock_method_getBlock_7.set("static", false);
        reflect_EntityFallingBlock_method_getBlock_7.set("argnames", new String[]{});
        reflect_EntityFallingBlock_method_getBlock_7.set("argtypes", new String[]{});
        reflect_EntityFallingBlock_method_getBlock_7.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (IBlockState) ((EntityFallingBlock) params.getReflective("_self")).getBlock();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityFallingBlock_methods.add(reflect_EntityFallingBlock_method_getBlock_7);


        BaseData[] reflect_EntityFallingBlock_methods_arr = new BaseData[reflect_EntityFallingBlock_methods.size()];
        for (int i = 0; i < reflect_EntityFallingBlock_methods_arr.length; i++) {
            reflect_EntityFallingBlock_methods_arr[i] = reflect_EntityFallingBlock_methods.get(i);
        }

        reflect_EntityFallingBlock.set("constructors", reflect_EntityFallingBlock_constructors_arr);
        reflect_EntityFallingBlock.set("methods", reflect_EntityFallingBlock_methods_arr);
        reflect_EntityFallingBlock.set("className", "EntityFallingBlock");
        reflect_EntityFallingBlock.set("classId", "net.minecraft.entity.item.EntityFallingBlock");
        reflect_EntityFallingBlock.set("class", EntityFallingBlock.class);
        reflect_EntityFallingBlock.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityFallingBlock;
        });
        reflectProfiles.add(reflect_EntityFallingBlock);
    }


    //classdef for EntityFireworkRocket
    public static void reflect_EntityFireworkRocket_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityFireworkRocket = new ModData();

        ArrayList<BaseData> reflect_EntityFireworkRocket_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_EntityFireworkRocket_constructor_EntityFireworkRocket_0 = new ModData();
        reflect_EntityFireworkRocket_constructor_EntityFireworkRocket_0.set("returnType", "EntityFireworkRocket");
        reflect_EntityFireworkRocket_constructor_EntityFireworkRocket_0.set("argnames", new String[]{"worldIn"});
        reflect_EntityFireworkRocket_constructor_EntityFireworkRocket_0.set("argtypes", new String[]{"World"});
        reflect_EntityFireworkRocket_constructor_EntityFireworkRocket_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityFireworkRocket((World) params.getReflective("worldIn"));
        });
        
        reflect_EntityFireworkRocket_constructors.add(reflect_EntityFireworkRocket_constructor_EntityFireworkRocket_0);


        BaseData reflect_EntityFireworkRocket_constructor_EntityFireworkRocket_1 = new ModData();
        reflect_EntityFireworkRocket_constructor_EntityFireworkRocket_1.set("returnType", "EntityFireworkRocket");
        reflect_EntityFireworkRocket_constructor_EntityFireworkRocket_1.set("argnames", new String[]{"worldIn", "x", "y", "z", "givenItem"});
        reflect_EntityFireworkRocket_constructor_EntityFireworkRocket_1.set("argtypes", new String[]{"World", "double", "double", "double", "ItemStack"});
        reflect_EntityFireworkRocket_constructor_EntityFireworkRocket_1.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityFireworkRocket((World) params.getReflective("worldIn"), (double) params.getDouble("x"), (double) params.getDouble("y"), (double) params.getDouble("z"), (ItemStack) params.getReflective("givenItem"));
        });
        
        reflect_EntityFireworkRocket_constructors.add(reflect_EntityFireworkRocket_constructor_EntityFireworkRocket_1);


        BaseData[] reflect_EntityFireworkRocket_constructors_arr = new BaseData[reflect_EntityFireworkRocket_constructors.size()];
        for (int i = 0; i < reflect_EntityFireworkRocket_constructors_arr.length; i++) {
            reflect_EntityFireworkRocket_constructors_arr[i] = reflect_EntityFireworkRocket_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityFireworkRocket_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityFireworkRocket_method_isInRangeToRenderDist_0 = new ModData();
        reflect_EntityFireworkRocket_method_isInRangeToRenderDist_0.set("methodName", "isInRangeToRenderDist");
        reflect_EntityFireworkRocket_method_isInRangeToRenderDist_0.set("returnType", "boolean");
        reflect_EntityFireworkRocket_method_isInRangeToRenderDist_0.set("static", false);
        reflect_EntityFireworkRocket_method_isInRangeToRenderDist_0.set("argnames", new String[]{"d0"});
        reflect_EntityFireworkRocket_method_isInRangeToRenderDist_0.set("argtypes", new String[]{"double"});
        reflect_EntityFireworkRocket_method_isInRangeToRenderDist_0.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityFireworkRocket) params.getReflective("_self")).isInRangeToRenderDist((double) params.getDouble("d0"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityFireworkRocket_methods.add(reflect_EntityFireworkRocket_method_isInRangeToRenderDist_0);


        BaseData reflect_EntityFireworkRocket_method_setVelocity_1 = new ModData();
        reflect_EntityFireworkRocket_method_setVelocity_1.set("methodName", "setVelocity");
        reflect_EntityFireworkRocket_method_setVelocity_1.set("returnType", "void");
        reflect_EntityFireworkRocket_method_setVelocity_1.set("static", false);
        reflect_EntityFireworkRocket_method_setVelocity_1.set("argnames", new String[]{"d0", "d1", "d2"});
        reflect_EntityFireworkRocket_method_setVelocity_1.set("argtypes", new String[]{"double", "double", "double"});
        reflect_EntityFireworkRocket_method_setVelocity_1.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityFireworkRocket) params.getReflective("_self")).setVelocity((double) params.getDouble("d0"), (double) params.getDouble("d1"), (double) params.getDouble("d2"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityFireworkRocket_methods.add(reflect_EntityFireworkRocket_method_setVelocity_1);


        BaseData reflect_EntityFireworkRocket_method_onUpdate_2 = new ModData();
        reflect_EntityFireworkRocket_method_onUpdate_2.set("methodName", "onUpdate");
        reflect_EntityFireworkRocket_method_onUpdate_2.set("returnType", "void");
        reflect_EntityFireworkRocket_method_onUpdate_2.set("static", false);
        reflect_EntityFireworkRocket_method_onUpdate_2.set("argnames", new String[]{});
        reflect_EntityFireworkRocket_method_onUpdate_2.set("argtypes", new String[]{});
        reflect_EntityFireworkRocket_method_onUpdate_2.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityFireworkRocket) params.getReflective("_self")).onUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityFireworkRocket_methods.add(reflect_EntityFireworkRocket_method_onUpdate_2);


        BaseData reflect_EntityFireworkRocket_method_handleStatusUpdate_3 = new ModData();
        reflect_EntityFireworkRocket_method_handleStatusUpdate_3.set("methodName", "handleStatusUpdate");
        reflect_EntityFireworkRocket_method_handleStatusUpdate_3.set("returnType", "void");
        reflect_EntityFireworkRocket_method_handleStatusUpdate_3.set("static", false);
        reflect_EntityFireworkRocket_method_handleStatusUpdate_3.set("argnames", new String[]{"b0"});
        reflect_EntityFireworkRocket_method_handleStatusUpdate_3.set("argtypes", new String[]{"byte"});
        reflect_EntityFireworkRocket_method_handleStatusUpdate_3.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityFireworkRocket) params.getReflective("_self")).handleStatusUpdate((byte) params.getByte("b0"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityFireworkRocket_methods.add(reflect_EntityFireworkRocket_method_handleStatusUpdate_3);


        BaseData reflect_EntityFireworkRocket_method_writeEntityToNBT_4 = new ModData();
        reflect_EntityFireworkRocket_method_writeEntityToNBT_4.set("methodName", "writeEntityToNBT");
        reflect_EntityFireworkRocket_method_writeEntityToNBT_4.set("returnType", "void");
        reflect_EntityFireworkRocket_method_writeEntityToNBT_4.set("static", false);
        reflect_EntityFireworkRocket_method_writeEntityToNBT_4.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityFireworkRocket_method_writeEntityToNBT_4.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityFireworkRocket_method_writeEntityToNBT_4.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityFireworkRocket) params.getReflective("_self")).writeEntityToNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityFireworkRocket_methods.add(reflect_EntityFireworkRocket_method_writeEntityToNBT_4);


        BaseData reflect_EntityFireworkRocket_method_readEntityFromNBT_5 = new ModData();
        reflect_EntityFireworkRocket_method_readEntityFromNBT_5.set("methodName", "readEntityFromNBT");
        reflect_EntityFireworkRocket_method_readEntityFromNBT_5.set("returnType", "void");
        reflect_EntityFireworkRocket_method_readEntityFromNBT_5.set("static", false);
        reflect_EntityFireworkRocket_method_readEntityFromNBT_5.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityFireworkRocket_method_readEntityFromNBT_5.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityFireworkRocket_method_readEntityFromNBT_5.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityFireworkRocket) params.getReflective("_self")).readEntityFromNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityFireworkRocket_methods.add(reflect_EntityFireworkRocket_method_readEntityFromNBT_5);


        BaseData reflect_EntityFireworkRocket_method_getBrightness_6 = new ModData();
        reflect_EntityFireworkRocket_method_getBrightness_6.set("methodName", "getBrightness");
        reflect_EntityFireworkRocket_method_getBrightness_6.set("returnType", "float");
        reflect_EntityFireworkRocket_method_getBrightness_6.set("static", false);
        reflect_EntityFireworkRocket_method_getBrightness_6.set("argnames", new String[]{"f"});
        reflect_EntityFireworkRocket_method_getBrightness_6.set("argtypes", new String[]{"float"});
        reflect_EntityFireworkRocket_method_getBrightness_6.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityFireworkRocket) params.getReflective("_self")).getBrightness((float) params.getFloat("f"));
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityFireworkRocket_methods.add(reflect_EntityFireworkRocket_method_getBrightness_6);


        BaseData reflect_EntityFireworkRocket_method_getBrightnessForRender_7 = new ModData();
        reflect_EntityFireworkRocket_method_getBrightnessForRender_7.set("methodName", "getBrightnessForRender");
        reflect_EntityFireworkRocket_method_getBrightnessForRender_7.set("returnType", "int");
        reflect_EntityFireworkRocket_method_getBrightnessForRender_7.set("static", false);
        reflect_EntityFireworkRocket_method_getBrightnessForRender_7.set("argnames", new String[]{"f"});
        reflect_EntityFireworkRocket_method_getBrightnessForRender_7.set("argtypes", new String[]{"float"});
        reflect_EntityFireworkRocket_method_getBrightnessForRender_7.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityFireworkRocket) params.getReflective("_self")).getBrightnessForRender((float) params.getFloat("f"));
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityFireworkRocket_methods.add(reflect_EntityFireworkRocket_method_getBrightnessForRender_7);


        BaseData reflect_EntityFireworkRocket_method_canAttackWithItem_8 = new ModData();
        reflect_EntityFireworkRocket_method_canAttackWithItem_8.set("methodName", "canAttackWithItem");
        reflect_EntityFireworkRocket_method_canAttackWithItem_8.set("returnType", "boolean");
        reflect_EntityFireworkRocket_method_canAttackWithItem_8.set("static", false);
        reflect_EntityFireworkRocket_method_canAttackWithItem_8.set("argnames", new String[]{});
        reflect_EntityFireworkRocket_method_canAttackWithItem_8.set("argtypes", new String[]{});
        reflect_EntityFireworkRocket_method_canAttackWithItem_8.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityFireworkRocket) params.getReflective("_self")).canAttackWithItem();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityFireworkRocket_methods.add(reflect_EntityFireworkRocket_method_canAttackWithItem_8);


        BaseData[] reflect_EntityFireworkRocket_methods_arr = new BaseData[reflect_EntityFireworkRocket_methods.size()];
        for (int i = 0; i < reflect_EntityFireworkRocket_methods_arr.length; i++) {
            reflect_EntityFireworkRocket_methods_arr[i] = reflect_EntityFireworkRocket_methods.get(i);
        }

        reflect_EntityFireworkRocket.set("constructors", reflect_EntityFireworkRocket_constructors_arr);
        reflect_EntityFireworkRocket.set("methods", reflect_EntityFireworkRocket_methods_arr);
        reflect_EntityFireworkRocket.set("className", "EntityFireworkRocket");
        reflect_EntityFireworkRocket.set("classId", "net.minecraft.entity.item.EntityFireworkRocket");
        reflect_EntityFireworkRocket.set("class", EntityFireworkRocket.class);
        reflect_EntityFireworkRocket.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityFireworkRocket;
        });
        reflectProfiles.add(reflect_EntityFireworkRocket);
    }


    //classdef for EntityItem
    public static void reflect_EntityItem_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityItem = new ModData();

        ArrayList<BaseData> reflect_EntityItem_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_EntityItem_constructor_EntityItem_0 = new ModData();
        reflect_EntityItem_constructor_EntityItem_0.set("returnType", "EntityItem");
        reflect_EntityItem_constructor_EntityItem_0.set("argnames", new String[]{"worldIn", "x", "y", "z"});
        reflect_EntityItem_constructor_EntityItem_0.set("argtypes", new String[]{"World", "double", "double", "double"});
        reflect_EntityItem_constructor_EntityItem_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityItem((World) params.getReflective("worldIn"), (double) params.getDouble("x"), (double) params.getDouble("y"), (double) params.getDouble("z"));
        });
        
        reflect_EntityItem_constructors.add(reflect_EntityItem_constructor_EntityItem_0);


        BaseData reflect_EntityItem_constructor_EntityItem_1 = new ModData();
        reflect_EntityItem_constructor_EntityItem_1.set("returnType", "EntityItem");
        reflect_EntityItem_constructor_EntityItem_1.set("argnames", new String[]{"worldIn", "x", "y", "z", "stack"});
        reflect_EntityItem_constructor_EntityItem_1.set("argtypes", new String[]{"World", "double", "double", "double", "ItemStack"});
        reflect_EntityItem_constructor_EntityItem_1.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityItem((World) params.getReflective("worldIn"), (double) params.getDouble("x"), (double) params.getDouble("y"), (double) params.getDouble("z"), (ItemStack) params.getReflective("stack"));
        });
        
        reflect_EntityItem_constructors.add(reflect_EntityItem_constructor_EntityItem_1);


        BaseData reflect_EntityItem_constructor_EntityItem_2 = new ModData();
        reflect_EntityItem_constructor_EntityItem_2.set("returnType", "EntityItem");
        reflect_EntityItem_constructor_EntityItem_2.set("argnames", new String[]{"worldIn"});
        reflect_EntityItem_constructor_EntityItem_2.set("argtypes", new String[]{"World"});
        reflect_EntityItem_constructor_EntityItem_2.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityItem((World) params.getReflective("worldIn"));
        });
        
        reflect_EntityItem_constructors.add(reflect_EntityItem_constructor_EntityItem_2);


        BaseData[] reflect_EntityItem_constructors_arr = new BaseData[reflect_EntityItem_constructors.size()];
        for (int i = 0; i < reflect_EntityItem_constructors_arr.length; i++) {
            reflect_EntityItem_constructors_arr[i] = reflect_EntityItem_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityItem_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityItem_method_onUpdate_0 = new ModData();
        reflect_EntityItem_method_onUpdate_0.set("methodName", "onUpdate");
        reflect_EntityItem_method_onUpdate_0.set("returnType", "void");
        reflect_EntityItem_method_onUpdate_0.set("static", false);
        reflect_EntityItem_method_onUpdate_0.set("argnames", new String[]{});
        reflect_EntityItem_method_onUpdate_0.set("argtypes", new String[]{});
        reflect_EntityItem_method_onUpdate_0.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityItem) params.getReflective("_self")).onUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityItem_methods.add(reflect_EntityItem_method_onUpdate_0);


        BaseData reflect_EntityItem_method_setAgeToCreativeDespawnTime_1 = new ModData();
        reflect_EntityItem_method_setAgeToCreativeDespawnTime_1.set("methodName", "setAgeToCreativeDespawnTime");
        reflect_EntityItem_method_setAgeToCreativeDespawnTime_1.set("returnType", "void");
        reflect_EntityItem_method_setAgeToCreativeDespawnTime_1.set("static", false);
        reflect_EntityItem_method_setAgeToCreativeDespawnTime_1.set("argnames", new String[]{});
        reflect_EntityItem_method_setAgeToCreativeDespawnTime_1.set("argtypes", new String[]{});
        reflect_EntityItem_method_setAgeToCreativeDespawnTime_1.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityItem) params.getReflective("_self")).setAgeToCreativeDespawnTime();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityItem_methods.add(reflect_EntityItem_method_setAgeToCreativeDespawnTime_1);


        BaseData reflect_EntityItem_method_handleWaterMovement_2 = new ModData();
        reflect_EntityItem_method_handleWaterMovement_2.set("methodName", "handleWaterMovement");
        reflect_EntityItem_method_handleWaterMovement_2.set("returnType", "boolean");
        reflect_EntityItem_method_handleWaterMovement_2.set("static", false);
        reflect_EntityItem_method_handleWaterMovement_2.set("argnames", new String[]{});
        reflect_EntityItem_method_handleWaterMovement_2.set("argtypes", new String[]{});
        reflect_EntityItem_method_handleWaterMovement_2.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityItem) params.getReflective("_self")).handleWaterMovement();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityItem_methods.add(reflect_EntityItem_method_handleWaterMovement_2);


        BaseData reflect_EntityItem_method_attackEntityFrom_3 = new ModData();
        reflect_EntityItem_method_attackEntityFrom_3.set("methodName", "attackEntityFrom");
        reflect_EntityItem_method_attackEntityFrom_3.set("returnType", "boolean");
        reflect_EntityItem_method_attackEntityFrom_3.set("static", false);
        reflect_EntityItem_method_attackEntityFrom_3.set("argnames", new String[]{"damagesource", "f"});
        reflect_EntityItem_method_attackEntityFrom_3.set("argtypes", new String[]{"DamageSource", "float"});
        reflect_EntityItem_method_attackEntityFrom_3.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityItem) params.getReflective("_self")).attackEntityFrom((DamageSource) params.getReflective("damagesource"), (float) params.getFloat("f"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityItem_methods.add(reflect_EntityItem_method_attackEntityFrom_3);


        BaseData reflect_EntityItem_method_writeEntityToNBT_4 = new ModData();
        reflect_EntityItem_method_writeEntityToNBT_4.set("methodName", "writeEntityToNBT");
        reflect_EntityItem_method_writeEntityToNBT_4.set("returnType", "void");
        reflect_EntityItem_method_writeEntityToNBT_4.set("static", false);
        reflect_EntityItem_method_writeEntityToNBT_4.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityItem_method_writeEntityToNBT_4.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityItem_method_writeEntityToNBT_4.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityItem) params.getReflective("_self")).writeEntityToNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityItem_methods.add(reflect_EntityItem_method_writeEntityToNBT_4);


        BaseData reflect_EntityItem_method_readEntityFromNBT_5 = new ModData();
        reflect_EntityItem_method_readEntityFromNBT_5.set("methodName", "readEntityFromNBT");
        reflect_EntityItem_method_readEntityFromNBT_5.set("returnType", "void");
        reflect_EntityItem_method_readEntityFromNBT_5.set("static", false);
        reflect_EntityItem_method_readEntityFromNBT_5.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityItem_method_readEntityFromNBT_5.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityItem_method_readEntityFromNBT_5.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityItem) params.getReflective("_self")).readEntityFromNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityItem_methods.add(reflect_EntityItem_method_readEntityFromNBT_5);


        BaseData reflect_EntityItem_method_onCollideWithPlayer_6 = new ModData();
        reflect_EntityItem_method_onCollideWithPlayer_6.set("methodName", "onCollideWithPlayer");
        reflect_EntityItem_method_onCollideWithPlayer_6.set("returnType", "void");
        reflect_EntityItem_method_onCollideWithPlayer_6.set("static", false);
        reflect_EntityItem_method_onCollideWithPlayer_6.set("argnames", new String[]{"entityplayer"});
        reflect_EntityItem_method_onCollideWithPlayer_6.set("argtypes", new String[]{"EntityPlayer"});
        reflect_EntityItem_method_onCollideWithPlayer_6.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityItem) params.getReflective("_self")).onCollideWithPlayer((EntityPlayer) params.getReflective("entityplayer"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityItem_methods.add(reflect_EntityItem_method_onCollideWithPlayer_6);


        BaseData reflect_EntityItem_method_getName_7 = new ModData();
        reflect_EntityItem_method_getName_7.set("methodName", "getName");
        reflect_EntityItem_method_getName_7.set("returnType", "String");
        reflect_EntityItem_method_getName_7.set("static", false);
        reflect_EntityItem_method_getName_7.set("argnames", new String[]{});
        reflect_EntityItem_method_getName_7.set("argtypes", new String[]{});
        reflect_EntityItem_method_getName_7.setCallbackStringWithDataArg("exec", (BaseData params) -> {
                try {
                    return (String) ((EntityItem) params.getReflective("_self")).getName();
                } catch (Exception _exception_reflect_) {
                    return "";
                }
            });
            
        reflect_EntityItem_methods.add(reflect_EntityItem_method_getName_7);


        BaseData reflect_EntityItem_method_canAttackWithItem_8 = new ModData();
        reflect_EntityItem_method_canAttackWithItem_8.set("methodName", "canAttackWithItem");
        reflect_EntityItem_method_canAttackWithItem_8.set("returnType", "boolean");
        reflect_EntityItem_method_canAttackWithItem_8.set("static", false);
        reflect_EntityItem_method_canAttackWithItem_8.set("argnames", new String[]{});
        reflect_EntityItem_method_canAttackWithItem_8.set("argtypes", new String[]{});
        reflect_EntityItem_method_canAttackWithItem_8.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityItem) params.getReflective("_self")).canAttackWithItem();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityItem_methods.add(reflect_EntityItem_method_canAttackWithItem_8);


        BaseData reflect_EntityItem_method_travelToDimension_9 = new ModData();
        reflect_EntityItem_method_travelToDimension_9.set("methodName", "travelToDimension");
        reflect_EntityItem_method_travelToDimension_9.set("returnType", "void");
        reflect_EntityItem_method_travelToDimension_9.set("static", false);
        reflect_EntityItem_method_travelToDimension_9.set("argnames", new String[]{"i"});
        reflect_EntityItem_method_travelToDimension_9.set("argtypes", new String[]{"int"});
        reflect_EntityItem_method_travelToDimension_9.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityItem) params.getReflective("_self")).travelToDimension((int) params.getInt("i"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityItem_methods.add(reflect_EntityItem_method_travelToDimension_9);


        BaseData reflect_EntityItem_method_getEntityItem_10 = new ModData();
        reflect_EntityItem_method_getEntityItem_10.set("methodName", "getEntityItem");
        reflect_EntityItem_method_getEntityItem_10.set("returnType", "ItemStack");
        reflect_EntityItem_method_getEntityItem_10.set("static", false);
        reflect_EntityItem_method_getEntityItem_10.set("argnames", new String[]{});
        reflect_EntityItem_method_getEntityItem_10.set("argtypes", new String[]{});
        reflect_EntityItem_method_getEntityItem_10.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (ItemStack) ((EntityItem) params.getReflective("_self")).getEntityItem();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityItem_methods.add(reflect_EntityItem_method_getEntityItem_10);


        BaseData reflect_EntityItem_method_setEntityItemStack_11 = new ModData();
        reflect_EntityItem_method_setEntityItemStack_11.set("methodName", "setEntityItemStack");
        reflect_EntityItem_method_setEntityItemStack_11.set("returnType", "void");
        reflect_EntityItem_method_setEntityItemStack_11.set("static", false);
        reflect_EntityItem_method_setEntityItemStack_11.set("argnames", new String[]{"stack"});
        reflect_EntityItem_method_setEntityItemStack_11.set("argtypes", new String[]{"ItemStack"});
        reflect_EntityItem_method_setEntityItemStack_11.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityItem) params.getReflective("_self")).setEntityItemStack((ItemStack) params.getReflective("stack"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityItem_methods.add(reflect_EntityItem_method_setEntityItemStack_11);


        BaseData reflect_EntityItem_method_getOwner_12 = new ModData();
        reflect_EntityItem_method_getOwner_12.set("methodName", "getOwner");
        reflect_EntityItem_method_getOwner_12.set("returnType", "String");
        reflect_EntityItem_method_getOwner_12.set("static", false);
        reflect_EntityItem_method_getOwner_12.set("argnames", new String[]{});
        reflect_EntityItem_method_getOwner_12.set("argtypes", new String[]{});
        reflect_EntityItem_method_getOwner_12.setCallbackStringWithDataArg("exec", (BaseData params) -> {
                try {
                    return (String) ((EntityItem) params.getReflective("_self")).getOwner();
                } catch (Exception _exception_reflect_) {
                    return "";
                }
            });
            
        reflect_EntityItem_methods.add(reflect_EntityItem_method_getOwner_12);


        BaseData reflect_EntityItem_method_setOwner_13 = new ModData();
        reflect_EntityItem_method_setOwner_13.set("methodName", "setOwner");
        reflect_EntityItem_method_setOwner_13.set("returnType", "void");
        reflect_EntityItem_method_setOwner_13.set("static", false);
        reflect_EntityItem_method_setOwner_13.set("argnames", new String[]{"owner"});
        reflect_EntityItem_method_setOwner_13.set("argtypes", new String[]{"String"});
        reflect_EntityItem_method_setOwner_13.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityItem) params.getReflective("_self")).setOwner((String) params.getString("owner"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityItem_methods.add(reflect_EntityItem_method_setOwner_13);


        BaseData reflect_EntityItem_method_getThrower_14 = new ModData();
        reflect_EntityItem_method_getThrower_14.set("methodName", "getThrower");
        reflect_EntityItem_method_getThrower_14.set("returnType", "String");
        reflect_EntityItem_method_getThrower_14.set("static", false);
        reflect_EntityItem_method_getThrower_14.set("argnames", new String[]{});
        reflect_EntityItem_method_getThrower_14.set("argtypes", new String[]{});
        reflect_EntityItem_method_getThrower_14.setCallbackStringWithDataArg("exec", (BaseData params) -> {
                try {
                    return (String) ((EntityItem) params.getReflective("_self")).getThrower();
                } catch (Exception _exception_reflect_) {
                    return "";
                }
            });
            
        reflect_EntityItem_methods.add(reflect_EntityItem_method_getThrower_14);


        BaseData reflect_EntityItem_method_setThrower_15 = new ModData();
        reflect_EntityItem_method_setThrower_15.set("methodName", "setThrower");
        reflect_EntityItem_method_setThrower_15.set("returnType", "void");
        reflect_EntityItem_method_setThrower_15.set("static", false);
        reflect_EntityItem_method_setThrower_15.set("argnames", new String[]{"thrower"});
        reflect_EntityItem_method_setThrower_15.set("argtypes", new String[]{"String"});
        reflect_EntityItem_method_setThrower_15.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityItem) params.getReflective("_self")).setThrower((String) params.getString("thrower"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityItem_methods.add(reflect_EntityItem_method_setThrower_15);


        BaseData reflect_EntityItem_method_getAge_16 = new ModData();
        reflect_EntityItem_method_getAge_16.set("methodName", "getAge");
        reflect_EntityItem_method_getAge_16.set("returnType", "int");
        reflect_EntityItem_method_getAge_16.set("static", false);
        reflect_EntityItem_method_getAge_16.set("argnames", new String[]{});
        reflect_EntityItem_method_getAge_16.set("argtypes", new String[]{});
        reflect_EntityItem_method_getAge_16.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityItem) params.getReflective("_self")).getAge();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityItem_methods.add(reflect_EntityItem_method_getAge_16);


        BaseData reflect_EntityItem_method_setDefaultPickupDelay_17 = new ModData();
        reflect_EntityItem_method_setDefaultPickupDelay_17.set("methodName", "setDefaultPickupDelay");
        reflect_EntityItem_method_setDefaultPickupDelay_17.set("returnType", "void");
        reflect_EntityItem_method_setDefaultPickupDelay_17.set("static", false);
        reflect_EntityItem_method_setDefaultPickupDelay_17.set("argnames", new String[]{});
        reflect_EntityItem_method_setDefaultPickupDelay_17.set("argtypes", new String[]{});
        reflect_EntityItem_method_setDefaultPickupDelay_17.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityItem) params.getReflective("_self")).setDefaultPickupDelay();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityItem_methods.add(reflect_EntityItem_method_setDefaultPickupDelay_17);


        BaseData reflect_EntityItem_method_setNoPickupDelay_18 = new ModData();
        reflect_EntityItem_method_setNoPickupDelay_18.set("methodName", "setNoPickupDelay");
        reflect_EntityItem_method_setNoPickupDelay_18.set("returnType", "void");
        reflect_EntityItem_method_setNoPickupDelay_18.set("static", false);
        reflect_EntityItem_method_setNoPickupDelay_18.set("argnames", new String[]{});
        reflect_EntityItem_method_setNoPickupDelay_18.set("argtypes", new String[]{});
        reflect_EntityItem_method_setNoPickupDelay_18.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityItem) params.getReflective("_self")).setNoPickupDelay();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityItem_methods.add(reflect_EntityItem_method_setNoPickupDelay_18);


        BaseData reflect_EntityItem_method_setInfinitePickupDelay_19 = new ModData();
        reflect_EntityItem_method_setInfinitePickupDelay_19.set("methodName", "setInfinitePickupDelay");
        reflect_EntityItem_method_setInfinitePickupDelay_19.set("returnType", "void");
        reflect_EntityItem_method_setInfinitePickupDelay_19.set("static", false);
        reflect_EntityItem_method_setInfinitePickupDelay_19.set("argnames", new String[]{});
        reflect_EntityItem_method_setInfinitePickupDelay_19.set("argtypes", new String[]{});
        reflect_EntityItem_method_setInfinitePickupDelay_19.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityItem) params.getReflective("_self")).setInfinitePickupDelay();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityItem_methods.add(reflect_EntityItem_method_setInfinitePickupDelay_19);


        BaseData reflect_EntityItem_method_setPickupDelay_20 = new ModData();
        reflect_EntityItem_method_setPickupDelay_20.set("methodName", "setPickupDelay");
        reflect_EntityItem_method_setPickupDelay_20.set("returnType", "void");
        reflect_EntityItem_method_setPickupDelay_20.set("static", false);
        reflect_EntityItem_method_setPickupDelay_20.set("argnames", new String[]{"ticks"});
        reflect_EntityItem_method_setPickupDelay_20.set("argtypes", new String[]{"int"});
        reflect_EntityItem_method_setPickupDelay_20.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityItem) params.getReflective("_self")).setPickupDelay((int) params.getInt("ticks"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityItem_methods.add(reflect_EntityItem_method_setPickupDelay_20);


        BaseData reflect_EntityItem_method_cannotPickup_21 = new ModData();
        reflect_EntityItem_method_cannotPickup_21.set("methodName", "cannotPickup");
        reflect_EntityItem_method_cannotPickup_21.set("returnType", "boolean");
        reflect_EntityItem_method_cannotPickup_21.set("static", false);
        reflect_EntityItem_method_cannotPickup_21.set("argnames", new String[]{});
        reflect_EntityItem_method_cannotPickup_21.set("argtypes", new String[]{});
        reflect_EntityItem_method_cannotPickup_21.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityItem) params.getReflective("_self")).cannotPickup();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityItem_methods.add(reflect_EntityItem_method_cannotPickup_21);


        BaseData reflect_EntityItem_method_setNoDespawn_22 = new ModData();
        reflect_EntityItem_method_setNoDespawn_22.set("methodName", "setNoDespawn");
        reflect_EntityItem_method_setNoDespawn_22.set("returnType", "void");
        reflect_EntityItem_method_setNoDespawn_22.set("static", false);
        reflect_EntityItem_method_setNoDespawn_22.set("argnames", new String[]{});
        reflect_EntityItem_method_setNoDespawn_22.set("argtypes", new String[]{});
        reflect_EntityItem_method_setNoDespawn_22.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityItem) params.getReflective("_self")).setNoDespawn();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityItem_methods.add(reflect_EntityItem_method_setNoDespawn_22);


        BaseData reflect_EntityItem_method_func_174870_v_23 = new ModData();
        reflect_EntityItem_method_func_174870_v_23.set("methodName", "func_174870_v");
        reflect_EntityItem_method_func_174870_v_23.set("returnType", "void");
        reflect_EntityItem_method_func_174870_v_23.set("static", false);
        reflect_EntityItem_method_func_174870_v_23.set("argnames", new String[]{});
        reflect_EntityItem_method_func_174870_v_23.set("argtypes", new String[]{});
        reflect_EntityItem_method_func_174870_v_23.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityItem) params.getReflective("_self")).func_174870_v();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityItem_methods.add(reflect_EntityItem_method_func_174870_v_23);


        BaseData[] reflect_EntityItem_methods_arr = new BaseData[reflect_EntityItem_methods.size()];
        for (int i = 0; i < reflect_EntityItem_methods_arr.length; i++) {
            reflect_EntityItem_methods_arr[i] = reflect_EntityItem_methods.get(i);
        }

        reflect_EntityItem.set("constructors", reflect_EntityItem_constructors_arr);
        reflect_EntityItem.set("methods", reflect_EntityItem_methods_arr);
        reflect_EntityItem.set("className", "EntityItem");
        reflect_EntityItem.set("classId", "net.minecraft.entity.item.EntityItem");
        reflect_EntityItem.set("class", EntityItem.class);
        reflect_EntityItem.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityItem;
        });
        reflectProfiles.add(reflect_EntityItem);
    }


    //classdef for EntityItemFrame
    public static void reflect_EntityItemFrame_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityItemFrame = new ModData();

        ArrayList<BaseData> reflect_EntityItemFrame_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_EntityItemFrame_constructor_EntityItemFrame_0 = new ModData();
        reflect_EntityItemFrame_constructor_EntityItemFrame_0.set("returnType", "EntityItemFrame");
        reflect_EntityItemFrame_constructor_EntityItemFrame_0.set("argnames", new String[]{"worldIn"});
        reflect_EntityItemFrame_constructor_EntityItemFrame_0.set("argtypes", new String[]{"World"});
        reflect_EntityItemFrame_constructor_EntityItemFrame_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityItemFrame((World) params.getReflective("worldIn"));
        });
        
        reflect_EntityItemFrame_constructors.add(reflect_EntityItemFrame_constructor_EntityItemFrame_0);


        BaseData reflect_EntityItemFrame_constructor_EntityItemFrame_1 = new ModData();
        reflect_EntityItemFrame_constructor_EntityItemFrame_1.set("returnType", "EntityItemFrame");
        reflect_EntityItemFrame_constructor_EntityItemFrame_1.set("argnames", new String[]{"worldIn", "parBlockPos", "parEnumFacing"});
        reflect_EntityItemFrame_constructor_EntityItemFrame_1.set("argtypes", new String[]{"World", "BlockPos", "EnumFacing"});
        reflect_EntityItemFrame_constructor_EntityItemFrame_1.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityItemFrame((World) params.getReflective("worldIn"), (BlockPos) params.getReflective("parBlockPos"), (EnumFacing) params.getReflective("parEnumFacing"));
        });
        
        reflect_EntityItemFrame_constructors.add(reflect_EntityItemFrame_constructor_EntityItemFrame_1);


        BaseData[] reflect_EntityItemFrame_constructors_arr = new BaseData[reflect_EntityItemFrame_constructors.size()];
        for (int i = 0; i < reflect_EntityItemFrame_constructors_arr.length; i++) {
            reflect_EntityItemFrame_constructors_arr[i] = reflect_EntityItemFrame_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityItemFrame_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityItemFrame_method_getCollisionBorderSize_0 = new ModData();
        reflect_EntityItemFrame_method_getCollisionBorderSize_0.set("methodName", "getCollisionBorderSize");
        reflect_EntityItemFrame_method_getCollisionBorderSize_0.set("returnType", "float");
        reflect_EntityItemFrame_method_getCollisionBorderSize_0.set("static", false);
        reflect_EntityItemFrame_method_getCollisionBorderSize_0.set("argnames", new String[]{});
        reflect_EntityItemFrame_method_getCollisionBorderSize_0.set("argtypes", new String[]{});
        reflect_EntityItemFrame_method_getCollisionBorderSize_0.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityItemFrame) params.getReflective("_self")).getCollisionBorderSize();
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityItemFrame_methods.add(reflect_EntityItemFrame_method_getCollisionBorderSize_0);


        BaseData reflect_EntityItemFrame_method_attackEntityFrom_1 = new ModData();
        reflect_EntityItemFrame_method_attackEntityFrom_1.set("methodName", "attackEntityFrom");
        reflect_EntityItemFrame_method_attackEntityFrom_1.set("returnType", "boolean");
        reflect_EntityItemFrame_method_attackEntityFrom_1.set("static", false);
        reflect_EntityItemFrame_method_attackEntityFrom_1.set("argnames", new String[]{"damagesource", "f"});
        reflect_EntityItemFrame_method_attackEntityFrom_1.set("argtypes", new String[]{"DamageSource", "float"});
        reflect_EntityItemFrame_method_attackEntityFrom_1.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityItemFrame) params.getReflective("_self")).attackEntityFrom((DamageSource) params.getReflective("damagesource"), (float) params.getFloat("f"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityItemFrame_methods.add(reflect_EntityItemFrame_method_attackEntityFrom_1);


        BaseData reflect_EntityItemFrame_method_getWidthPixels_2 = new ModData();
        reflect_EntityItemFrame_method_getWidthPixels_2.set("methodName", "getWidthPixels");
        reflect_EntityItemFrame_method_getWidthPixels_2.set("returnType", "int");
        reflect_EntityItemFrame_method_getWidthPixels_2.set("static", false);
        reflect_EntityItemFrame_method_getWidthPixels_2.set("argnames", new String[]{});
        reflect_EntityItemFrame_method_getWidthPixels_2.set("argtypes", new String[]{});
        reflect_EntityItemFrame_method_getWidthPixels_2.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityItemFrame) params.getReflective("_self")).getWidthPixels();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityItemFrame_methods.add(reflect_EntityItemFrame_method_getWidthPixels_2);


        BaseData reflect_EntityItemFrame_method_getHeightPixels_3 = new ModData();
        reflect_EntityItemFrame_method_getHeightPixels_3.set("methodName", "getHeightPixels");
        reflect_EntityItemFrame_method_getHeightPixels_3.set("returnType", "int");
        reflect_EntityItemFrame_method_getHeightPixels_3.set("static", false);
        reflect_EntityItemFrame_method_getHeightPixels_3.set("argnames", new String[]{});
        reflect_EntityItemFrame_method_getHeightPixels_3.set("argtypes", new String[]{});
        reflect_EntityItemFrame_method_getHeightPixels_3.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityItemFrame) params.getReflective("_self")).getHeightPixels();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityItemFrame_methods.add(reflect_EntityItemFrame_method_getHeightPixels_3);


        BaseData reflect_EntityItemFrame_method_isInRangeToRenderDist_4 = new ModData();
        reflect_EntityItemFrame_method_isInRangeToRenderDist_4.set("methodName", "isInRangeToRenderDist");
        reflect_EntityItemFrame_method_isInRangeToRenderDist_4.set("returnType", "boolean");
        reflect_EntityItemFrame_method_isInRangeToRenderDist_4.set("static", false);
        reflect_EntityItemFrame_method_isInRangeToRenderDist_4.set("argnames", new String[]{"d0"});
        reflect_EntityItemFrame_method_isInRangeToRenderDist_4.set("argtypes", new String[]{"double"});
        reflect_EntityItemFrame_method_isInRangeToRenderDist_4.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityItemFrame) params.getReflective("_self")).isInRangeToRenderDist((double) params.getDouble("d0"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityItemFrame_methods.add(reflect_EntityItemFrame_method_isInRangeToRenderDist_4);


        BaseData reflect_EntityItemFrame_method_onBroken_5 = new ModData();
        reflect_EntityItemFrame_method_onBroken_5.set("methodName", "onBroken");
        reflect_EntityItemFrame_method_onBroken_5.set("returnType", "void");
        reflect_EntityItemFrame_method_onBroken_5.set("static", false);
        reflect_EntityItemFrame_method_onBroken_5.set("argnames", new String[]{"entity"});
        reflect_EntityItemFrame_method_onBroken_5.set("argtypes", new String[]{"Entity"});
        reflect_EntityItemFrame_method_onBroken_5.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityItemFrame) params.getReflective("_self")).onBroken((Entity) params.getReflective("entity"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityItemFrame_methods.add(reflect_EntityItemFrame_method_onBroken_5);


        BaseData reflect_EntityItemFrame_method_dropItemOrSelf_6 = new ModData();
        reflect_EntityItemFrame_method_dropItemOrSelf_6.set("methodName", "dropItemOrSelf");
        reflect_EntityItemFrame_method_dropItemOrSelf_6.set("returnType", "void");
        reflect_EntityItemFrame_method_dropItemOrSelf_6.set("static", false);
        reflect_EntityItemFrame_method_dropItemOrSelf_6.set("argnames", new String[]{"parEntity", "parFlag"});
        reflect_EntityItemFrame_method_dropItemOrSelf_6.set("argtypes", new String[]{"Entity", "boolean"});
        reflect_EntityItemFrame_method_dropItemOrSelf_6.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityItemFrame) params.getReflective("_self")).dropItemOrSelf((Entity) params.getReflective("parEntity"), (boolean) params.getBoolean("parFlag"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityItemFrame_methods.add(reflect_EntityItemFrame_method_dropItemOrSelf_6);


        BaseData reflect_EntityItemFrame_method_getDisplayedItem_7 = new ModData();
        reflect_EntityItemFrame_method_getDisplayedItem_7.set("methodName", "getDisplayedItem");
        reflect_EntityItemFrame_method_getDisplayedItem_7.set("returnType", "ItemStack");
        reflect_EntityItemFrame_method_getDisplayedItem_7.set("static", false);
        reflect_EntityItemFrame_method_getDisplayedItem_7.set("argnames", new String[]{});
        reflect_EntityItemFrame_method_getDisplayedItem_7.set("argtypes", new String[]{});
        reflect_EntityItemFrame_method_getDisplayedItem_7.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (ItemStack) ((EntityItemFrame) params.getReflective("_self")).getDisplayedItem();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityItemFrame_methods.add(reflect_EntityItemFrame_method_getDisplayedItem_7);


        BaseData reflect_EntityItemFrame_method_setDisplayedItem_8 = new ModData();
        reflect_EntityItemFrame_method_setDisplayedItem_8.set("methodName", "setDisplayedItem");
        reflect_EntityItemFrame_method_setDisplayedItem_8.set("returnType", "void");
        reflect_EntityItemFrame_method_setDisplayedItem_8.set("static", false);
        reflect_EntityItemFrame_method_setDisplayedItem_8.set("argnames", new String[]{"parItemStack"});
        reflect_EntityItemFrame_method_setDisplayedItem_8.set("argtypes", new String[]{"ItemStack"});
        reflect_EntityItemFrame_method_setDisplayedItem_8.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityItemFrame) params.getReflective("_self")).setDisplayedItem((ItemStack) params.getReflective("parItemStack"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityItemFrame_methods.add(reflect_EntityItemFrame_method_setDisplayedItem_8);


        BaseData reflect_EntityItemFrame_method_getRotation_9 = new ModData();
        reflect_EntityItemFrame_method_getRotation_9.set("methodName", "getRotation");
        reflect_EntityItemFrame_method_getRotation_9.set("returnType", "int");
        reflect_EntityItemFrame_method_getRotation_9.set("static", false);
        reflect_EntityItemFrame_method_getRotation_9.set("argnames", new String[]{});
        reflect_EntityItemFrame_method_getRotation_9.set("argtypes", new String[]{});
        reflect_EntityItemFrame_method_getRotation_9.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityItemFrame) params.getReflective("_self")).getRotation();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityItemFrame_methods.add(reflect_EntityItemFrame_method_getRotation_9);


        BaseData reflect_EntityItemFrame_method_setItemRotation_10 = new ModData();
        reflect_EntityItemFrame_method_setItemRotation_10.set("methodName", "setItemRotation");
        reflect_EntityItemFrame_method_setItemRotation_10.set("returnType", "void");
        reflect_EntityItemFrame_method_setItemRotation_10.set("static", false);
        reflect_EntityItemFrame_method_setItemRotation_10.set("argnames", new String[]{"parInt1"});
        reflect_EntityItemFrame_method_setItemRotation_10.set("argtypes", new String[]{"int"});
        reflect_EntityItemFrame_method_setItemRotation_10.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityItemFrame) params.getReflective("_self")).setItemRotation((int) params.getInt("parInt1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityItemFrame_methods.add(reflect_EntityItemFrame_method_setItemRotation_10);


        BaseData reflect_EntityItemFrame_method_writeEntityToNBT_11 = new ModData();
        reflect_EntityItemFrame_method_writeEntityToNBT_11.set("methodName", "writeEntityToNBT");
        reflect_EntityItemFrame_method_writeEntityToNBT_11.set("returnType", "void");
        reflect_EntityItemFrame_method_writeEntityToNBT_11.set("static", false);
        reflect_EntityItemFrame_method_writeEntityToNBT_11.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityItemFrame_method_writeEntityToNBT_11.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityItemFrame_method_writeEntityToNBT_11.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityItemFrame) params.getReflective("_self")).writeEntityToNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityItemFrame_methods.add(reflect_EntityItemFrame_method_writeEntityToNBT_11);


        BaseData reflect_EntityItemFrame_method_readEntityFromNBT_12 = new ModData();
        reflect_EntityItemFrame_method_readEntityFromNBT_12.set("methodName", "readEntityFromNBT");
        reflect_EntityItemFrame_method_readEntityFromNBT_12.set("returnType", "void");
        reflect_EntityItemFrame_method_readEntityFromNBT_12.set("static", false);
        reflect_EntityItemFrame_method_readEntityFromNBT_12.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityItemFrame_method_readEntityFromNBT_12.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityItemFrame_method_readEntityFromNBT_12.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityItemFrame) params.getReflective("_self")).readEntityFromNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityItemFrame_methods.add(reflect_EntityItemFrame_method_readEntityFromNBT_12);


        BaseData reflect_EntityItemFrame_method_interactFirst_13 = new ModData();
        reflect_EntityItemFrame_method_interactFirst_13.set("methodName", "interactFirst");
        reflect_EntityItemFrame_method_interactFirst_13.set("returnType", "boolean");
        reflect_EntityItemFrame_method_interactFirst_13.set("static", false);
        reflect_EntityItemFrame_method_interactFirst_13.set("argnames", new String[]{"entityplayer"});
        reflect_EntityItemFrame_method_interactFirst_13.set("argtypes", new String[]{"EntityPlayer"});
        reflect_EntityItemFrame_method_interactFirst_13.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityItemFrame) params.getReflective("_self")).interactFirst((EntityPlayer) params.getReflective("entityplayer"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityItemFrame_methods.add(reflect_EntityItemFrame_method_interactFirst_13);


        BaseData reflect_EntityItemFrame_method_func_174866_q_14 = new ModData();
        reflect_EntityItemFrame_method_func_174866_q_14.set("methodName", "func_174866_q");
        reflect_EntityItemFrame_method_func_174866_q_14.set("returnType", "int");
        reflect_EntityItemFrame_method_func_174866_q_14.set("static", false);
        reflect_EntityItemFrame_method_func_174866_q_14.set("argnames", new String[]{});
        reflect_EntityItemFrame_method_func_174866_q_14.set("argtypes", new String[]{});
        reflect_EntityItemFrame_method_func_174866_q_14.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityItemFrame) params.getReflective("_self")).func_174866_q();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityItemFrame_methods.add(reflect_EntityItemFrame_method_func_174866_q_14);


        BaseData[] reflect_EntityItemFrame_methods_arr = new BaseData[reflect_EntityItemFrame_methods.size()];
        for (int i = 0; i < reflect_EntityItemFrame_methods_arr.length; i++) {
            reflect_EntityItemFrame_methods_arr[i] = reflect_EntityItemFrame_methods.get(i);
        }

        reflect_EntityItemFrame.set("constructors", reflect_EntityItemFrame_constructors_arr);
        reflect_EntityItemFrame.set("methods", reflect_EntityItemFrame_methods_arr);
        reflect_EntityItemFrame.set("className", "EntityItemFrame");
        reflect_EntityItemFrame.set("classId", "net.minecraft.entity.item.EntityItemFrame");
        reflect_EntityItemFrame.set("class", EntityItemFrame.class);
        reflect_EntityItemFrame.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityItemFrame;
        });
        reflectProfiles.add(reflect_EntityItemFrame);
    }


    //classdef for EntityMinecart
    public static void reflect_EntityMinecart_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityMinecart = new ModData();

        ArrayList<BaseData> reflect_EntityMinecart_constructors = new ArrayList<BaseData>();
        
        BaseData[] reflect_EntityMinecart_constructors_arr = new BaseData[reflect_EntityMinecart_constructors.size()];
        for (int i = 0; i < reflect_EntityMinecart_constructors_arr.length; i++) {
            reflect_EntityMinecart_constructors_arr[i] = reflect_EntityMinecart_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityMinecart_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityMinecart_method_getCollisionBox_0 = new ModData();
        reflect_EntityMinecart_method_getCollisionBox_0.set("methodName", "getCollisionBox");
        reflect_EntityMinecart_method_getCollisionBox_0.set("returnType", "AxisAlignedBB");
        reflect_EntityMinecart_method_getCollisionBox_0.set("static", false);
        reflect_EntityMinecart_method_getCollisionBox_0.set("argnames", new String[]{"entity"});
        reflect_EntityMinecart_method_getCollisionBox_0.set("argtypes", new String[]{"Entity"});
        reflect_EntityMinecart_method_getCollisionBox_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (AxisAlignedBB) ((EntityMinecart) params.getReflective("_self")).getCollisionBox((Entity) params.getReflective("entity"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityMinecart_methods.add(reflect_EntityMinecart_method_getCollisionBox_0);


        BaseData reflect_EntityMinecart_method_getCollisionBoundingBox_1 = new ModData();
        reflect_EntityMinecart_method_getCollisionBoundingBox_1.set("methodName", "getCollisionBoundingBox");
        reflect_EntityMinecart_method_getCollisionBoundingBox_1.set("returnType", "AxisAlignedBB");
        reflect_EntityMinecart_method_getCollisionBoundingBox_1.set("static", false);
        reflect_EntityMinecart_method_getCollisionBoundingBox_1.set("argnames", new String[]{});
        reflect_EntityMinecart_method_getCollisionBoundingBox_1.set("argtypes", new String[]{});
        reflect_EntityMinecart_method_getCollisionBoundingBox_1.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (AxisAlignedBB) ((EntityMinecart) params.getReflective("_self")).getCollisionBoundingBox();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityMinecart_methods.add(reflect_EntityMinecart_method_getCollisionBoundingBox_1);


        BaseData reflect_EntityMinecart_method_canBePushed_2 = new ModData();
        reflect_EntityMinecart_method_canBePushed_2.set("methodName", "canBePushed");
        reflect_EntityMinecart_method_canBePushed_2.set("returnType", "boolean");
        reflect_EntityMinecart_method_canBePushed_2.set("static", false);
        reflect_EntityMinecart_method_canBePushed_2.set("argnames", new String[]{});
        reflect_EntityMinecart_method_canBePushed_2.set("argtypes", new String[]{});
        reflect_EntityMinecart_method_canBePushed_2.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityMinecart) params.getReflective("_self")).canBePushed();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityMinecart_methods.add(reflect_EntityMinecart_method_canBePushed_2);


        BaseData reflect_EntityMinecart_method_getMountedYOffset_3 = new ModData();
        reflect_EntityMinecart_method_getMountedYOffset_3.set("methodName", "getMountedYOffset");
        reflect_EntityMinecart_method_getMountedYOffset_3.set("returnType", "double");
        reflect_EntityMinecart_method_getMountedYOffset_3.set("static", false);
        reflect_EntityMinecart_method_getMountedYOffset_3.set("argnames", new String[]{});
        reflect_EntityMinecart_method_getMountedYOffset_3.set("argtypes", new String[]{});
        reflect_EntityMinecart_method_getMountedYOffset_3.setCallbackDoubleWithDataArg("exec", (BaseData params) -> {
                try {
                    return (double) ((EntityMinecart) params.getReflective("_self")).getMountedYOffset();
                } catch (Exception _exception_reflect_) {
                    return 0.0d;
                }
            });
            
        reflect_EntityMinecart_methods.add(reflect_EntityMinecart_method_getMountedYOffset_3);


        BaseData reflect_EntityMinecart_method_attackEntityFrom_4 = new ModData();
        reflect_EntityMinecart_method_attackEntityFrom_4.set("methodName", "attackEntityFrom");
        reflect_EntityMinecart_method_attackEntityFrom_4.set("returnType", "boolean");
        reflect_EntityMinecart_method_attackEntityFrom_4.set("static", false);
        reflect_EntityMinecart_method_attackEntityFrom_4.set("argnames", new String[]{"damagesource", "f"});
        reflect_EntityMinecart_method_attackEntityFrom_4.set("argtypes", new String[]{"DamageSource", "float"});
        reflect_EntityMinecart_method_attackEntityFrom_4.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityMinecart) params.getReflective("_self")).attackEntityFrom((DamageSource) params.getReflective("damagesource"), (float) params.getFloat("f"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityMinecart_methods.add(reflect_EntityMinecart_method_attackEntityFrom_4);


        BaseData reflect_EntityMinecart_method_killMinecart_5 = new ModData();
        reflect_EntityMinecart_method_killMinecart_5.set("methodName", "killMinecart");
        reflect_EntityMinecart_method_killMinecart_5.set("returnType", "void");
        reflect_EntityMinecart_method_killMinecart_5.set("static", false);
        reflect_EntityMinecart_method_killMinecart_5.set("argnames", new String[]{"parDamageSource"});
        reflect_EntityMinecart_method_killMinecart_5.set("argtypes", new String[]{"DamageSource"});
        reflect_EntityMinecart_method_killMinecart_5.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityMinecart) params.getReflective("_self")).killMinecart((DamageSource) params.getReflective("parDamageSource"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityMinecart_methods.add(reflect_EntityMinecart_method_killMinecart_5);


        BaseData reflect_EntityMinecart_method_performHurtAnimation_6 = new ModData();
        reflect_EntityMinecart_method_performHurtAnimation_6.set("methodName", "performHurtAnimation");
        reflect_EntityMinecart_method_performHurtAnimation_6.set("returnType", "void");
        reflect_EntityMinecart_method_performHurtAnimation_6.set("static", false);
        reflect_EntityMinecart_method_performHurtAnimation_6.set("argnames", new String[]{});
        reflect_EntityMinecart_method_performHurtAnimation_6.set("argtypes", new String[]{});
        reflect_EntityMinecart_method_performHurtAnimation_6.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityMinecart) params.getReflective("_self")).performHurtAnimation();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityMinecart_methods.add(reflect_EntityMinecart_method_performHurtAnimation_6);


        BaseData reflect_EntityMinecart_method_canBeCollidedWith_7 = new ModData();
        reflect_EntityMinecart_method_canBeCollidedWith_7.set("methodName", "canBeCollidedWith");
        reflect_EntityMinecart_method_canBeCollidedWith_7.set("returnType", "boolean");
        reflect_EntityMinecart_method_canBeCollidedWith_7.set("static", false);
        reflect_EntityMinecart_method_canBeCollidedWith_7.set("argnames", new String[]{});
        reflect_EntityMinecart_method_canBeCollidedWith_7.set("argtypes", new String[]{});
        reflect_EntityMinecart_method_canBeCollidedWith_7.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityMinecart) params.getReflective("_self")).canBeCollidedWith();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityMinecart_methods.add(reflect_EntityMinecart_method_canBeCollidedWith_7);


        BaseData reflect_EntityMinecart_method_setDead_8 = new ModData();
        reflect_EntityMinecart_method_setDead_8.set("methodName", "setDead");
        reflect_EntityMinecart_method_setDead_8.set("returnType", "void");
        reflect_EntityMinecart_method_setDead_8.set("static", false);
        reflect_EntityMinecart_method_setDead_8.set("argnames", new String[]{});
        reflect_EntityMinecart_method_setDead_8.set("argtypes", new String[]{});
        reflect_EntityMinecart_method_setDead_8.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityMinecart) params.getReflective("_self")).setDead();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityMinecart_methods.add(reflect_EntityMinecart_method_setDead_8);


        BaseData reflect_EntityMinecart_method_onUpdate_9 = new ModData();
        reflect_EntityMinecart_method_onUpdate_9.set("methodName", "onUpdate");
        reflect_EntityMinecart_method_onUpdate_9.set("returnType", "void");
        reflect_EntityMinecart_method_onUpdate_9.set("static", false);
        reflect_EntityMinecart_method_onUpdate_9.set("argnames", new String[]{});
        reflect_EntityMinecart_method_onUpdate_9.set("argtypes", new String[]{});
        reflect_EntityMinecart_method_onUpdate_9.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityMinecart) params.getReflective("_self")).onUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityMinecart_methods.add(reflect_EntityMinecart_method_onUpdate_9);


        BaseData reflect_EntityMinecart_method_onActivatorRailPass_10 = new ModData();
        reflect_EntityMinecart_method_onActivatorRailPass_10.set("methodName", "onActivatorRailPass");
        reflect_EntityMinecart_method_onActivatorRailPass_10.set("returnType", "void");
        reflect_EntityMinecart_method_onActivatorRailPass_10.set("static", false);
        reflect_EntityMinecart_method_onActivatorRailPass_10.set("argnames", new String[]{"x", "y", "z", "receivingPower"});
        reflect_EntityMinecart_method_onActivatorRailPass_10.set("argtypes", new String[]{"int", "int", "int", "boolean"});
        reflect_EntityMinecart_method_onActivatorRailPass_10.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityMinecart) params.getReflective("_self")).onActivatorRailPass((int) params.getInt("x"), (int) params.getInt("y"), (int) params.getInt("z"), (boolean) params.getBoolean("receivingPower"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityMinecart_methods.add(reflect_EntityMinecart_method_onActivatorRailPass_10);


        BaseData reflect_EntityMinecart_method_setPosition_11 = new ModData();
        reflect_EntityMinecart_method_setPosition_11.set("methodName", "setPosition");
        reflect_EntityMinecart_method_setPosition_11.set("returnType", "void");
        reflect_EntityMinecart_method_setPosition_11.set("static", false);
        reflect_EntityMinecart_method_setPosition_11.set("argnames", new String[]{"d0", "d1", "d2"});
        reflect_EntityMinecart_method_setPosition_11.set("argtypes", new String[]{"double", "double", "double"});
        reflect_EntityMinecart_method_setPosition_11.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityMinecart) params.getReflective("_self")).setPosition((double) params.getDouble("d0"), (double) params.getDouble("d1"), (double) params.getDouble("d2"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityMinecart_methods.add(reflect_EntityMinecart_method_setPosition_11);


        BaseData reflect_EntityMinecart_method_func_70495_a_12 = new ModData();
        reflect_EntityMinecart_method_func_70495_a_12.set("methodName", "func_70495_a");
        reflect_EntityMinecart_method_func_70495_a_12.set("returnType", "Vec3");
        reflect_EntityMinecart_method_func_70495_a_12.set("static", false);
        reflect_EntityMinecart_method_func_70495_a_12.set("argnames", new String[]{"parDouble1", "parDouble2", "parDouble3", "parDouble4"});
        reflect_EntityMinecart_method_func_70495_a_12.set("argtypes", new String[]{"double", "double", "double", "double"});
        reflect_EntityMinecart_method_func_70495_a_12.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Vec3) ((EntityMinecart) params.getReflective("_self")).func_70495_a((double) params.getDouble("parDouble1"), (double) params.getDouble("parDouble2"), (double) params.getDouble("parDouble3"), (double) params.getDouble("parDouble4"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityMinecart_methods.add(reflect_EntityMinecart_method_func_70495_a_12);


        BaseData reflect_EntityMinecart_method_func_70489_a_13 = new ModData();
        reflect_EntityMinecart_method_func_70489_a_13.set("methodName", "func_70489_a");
        reflect_EntityMinecart_method_func_70489_a_13.set("returnType", "Vec3");
        reflect_EntityMinecart_method_func_70489_a_13.set("static", false);
        reflect_EntityMinecart_method_func_70489_a_13.set("argnames", new String[]{"parDouble1", "parDouble2", "parDouble3"});
        reflect_EntityMinecart_method_func_70489_a_13.set("argtypes", new String[]{"double", "double", "double"});
        reflect_EntityMinecart_method_func_70489_a_13.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Vec3) ((EntityMinecart) params.getReflective("_self")).func_70489_a((double) params.getDouble("parDouble1"), (double) params.getDouble("parDouble2"), (double) params.getDouble("parDouble3"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityMinecart_methods.add(reflect_EntityMinecart_method_func_70489_a_13);


        BaseData reflect_EntityMinecart_method_applyEntityCollision_14 = new ModData();
        reflect_EntityMinecart_method_applyEntityCollision_14.set("methodName", "applyEntityCollision");
        reflect_EntityMinecart_method_applyEntityCollision_14.set("returnType", "void");
        reflect_EntityMinecart_method_applyEntityCollision_14.set("static", false);
        reflect_EntityMinecart_method_applyEntityCollision_14.set("argnames", new String[]{"entity"});
        reflect_EntityMinecart_method_applyEntityCollision_14.set("argtypes", new String[]{"Entity"});
        reflect_EntityMinecart_method_applyEntityCollision_14.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityMinecart) params.getReflective("_self")).applyEntityCollision((Entity) params.getReflective("entity"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityMinecart_methods.add(reflect_EntityMinecart_method_applyEntityCollision_14);


        BaseData reflect_EntityMinecart_method_setPositionAndRotation2_15 = new ModData();
        reflect_EntityMinecart_method_setPositionAndRotation2_15.set("methodName", "setPositionAndRotation2");
        reflect_EntityMinecart_method_setPositionAndRotation2_15.set("returnType", "void");
        reflect_EntityMinecart_method_setPositionAndRotation2_15.set("static", false);
        reflect_EntityMinecart_method_setPositionAndRotation2_15.set("argnames", new String[]{"d0", "d1", "d2", "f", "f1", "i", "var10"});
        reflect_EntityMinecart_method_setPositionAndRotation2_15.set("argtypes", new String[]{"double", "double", "double", "float", "float", "int", "boolean"});
        reflect_EntityMinecart_method_setPositionAndRotation2_15.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityMinecart) params.getReflective("_self")).setPositionAndRotation2((double) params.getDouble("d0"), (double) params.getDouble("d1"), (double) params.getDouble("d2"), (float) params.getFloat("f"), (float) params.getFloat("f1"), (int) params.getInt("i"), (boolean) params.getBoolean("var10"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityMinecart_methods.add(reflect_EntityMinecart_method_setPositionAndRotation2_15);


        BaseData reflect_EntityMinecart_method_setVelocity_16 = new ModData();
        reflect_EntityMinecart_method_setVelocity_16.set("methodName", "setVelocity");
        reflect_EntityMinecart_method_setVelocity_16.set("returnType", "void");
        reflect_EntityMinecart_method_setVelocity_16.set("static", false);
        reflect_EntityMinecart_method_setVelocity_16.set("argnames", new String[]{"d0", "d1", "d2"});
        reflect_EntityMinecart_method_setVelocity_16.set("argtypes", new String[]{"double", "double", "double"});
        reflect_EntityMinecart_method_setVelocity_16.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityMinecart) params.getReflective("_self")).setVelocity((double) params.getDouble("d0"), (double) params.getDouble("d1"), (double) params.getDouble("d2"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityMinecart_methods.add(reflect_EntityMinecart_method_setVelocity_16);


        BaseData reflect_EntityMinecart_method_setDamage_17 = new ModData();
        reflect_EntityMinecart_method_setDamage_17.set("methodName", "setDamage");
        reflect_EntityMinecart_method_setDamage_17.set("returnType", "void");
        reflect_EntityMinecart_method_setDamage_17.set("static", false);
        reflect_EntityMinecart_method_setDamage_17.set("argnames", new String[]{"parFloat1"});
        reflect_EntityMinecart_method_setDamage_17.set("argtypes", new String[]{"float"});
        reflect_EntityMinecart_method_setDamage_17.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityMinecart) params.getReflective("_self")).setDamage((float) params.getFloat("parFloat1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityMinecart_methods.add(reflect_EntityMinecart_method_setDamage_17);


        BaseData reflect_EntityMinecart_method_getDamage_18 = new ModData();
        reflect_EntityMinecart_method_getDamage_18.set("methodName", "getDamage");
        reflect_EntityMinecart_method_getDamage_18.set("returnType", "float");
        reflect_EntityMinecart_method_getDamage_18.set("static", false);
        reflect_EntityMinecart_method_getDamage_18.set("argnames", new String[]{});
        reflect_EntityMinecart_method_getDamage_18.set("argtypes", new String[]{});
        reflect_EntityMinecart_method_getDamage_18.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityMinecart) params.getReflective("_self")).getDamage();
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityMinecart_methods.add(reflect_EntityMinecart_method_getDamage_18);


        BaseData reflect_EntityMinecart_method_setRollingAmplitude_19 = new ModData();
        reflect_EntityMinecart_method_setRollingAmplitude_19.set("methodName", "setRollingAmplitude");
        reflect_EntityMinecart_method_setRollingAmplitude_19.set("returnType", "void");
        reflect_EntityMinecart_method_setRollingAmplitude_19.set("static", false);
        reflect_EntityMinecart_method_setRollingAmplitude_19.set("argnames", new String[]{"parInt1"});
        reflect_EntityMinecart_method_setRollingAmplitude_19.set("argtypes", new String[]{"int"});
        reflect_EntityMinecart_method_setRollingAmplitude_19.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityMinecart) params.getReflective("_self")).setRollingAmplitude((int) params.getInt("parInt1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityMinecart_methods.add(reflect_EntityMinecart_method_setRollingAmplitude_19);


        BaseData reflect_EntityMinecart_method_getRollingAmplitude_20 = new ModData();
        reflect_EntityMinecart_method_getRollingAmplitude_20.set("methodName", "getRollingAmplitude");
        reflect_EntityMinecart_method_getRollingAmplitude_20.set("returnType", "int");
        reflect_EntityMinecart_method_getRollingAmplitude_20.set("static", false);
        reflect_EntityMinecart_method_getRollingAmplitude_20.set("argnames", new String[]{});
        reflect_EntityMinecart_method_getRollingAmplitude_20.set("argtypes", new String[]{});
        reflect_EntityMinecart_method_getRollingAmplitude_20.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityMinecart) params.getReflective("_self")).getRollingAmplitude();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityMinecart_methods.add(reflect_EntityMinecart_method_getRollingAmplitude_20);


        BaseData reflect_EntityMinecart_method_setRollingDirection_21 = new ModData();
        reflect_EntityMinecart_method_setRollingDirection_21.set("methodName", "setRollingDirection");
        reflect_EntityMinecart_method_setRollingDirection_21.set("returnType", "void");
        reflect_EntityMinecart_method_setRollingDirection_21.set("static", false);
        reflect_EntityMinecart_method_setRollingDirection_21.set("argnames", new String[]{"parInt1"});
        reflect_EntityMinecart_method_setRollingDirection_21.set("argtypes", new String[]{"int"});
        reflect_EntityMinecart_method_setRollingDirection_21.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityMinecart) params.getReflective("_self")).setRollingDirection((int) params.getInt("parInt1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityMinecart_methods.add(reflect_EntityMinecart_method_setRollingDirection_21);


        BaseData reflect_EntityMinecart_method_getRollingDirection_22 = new ModData();
        reflect_EntityMinecart_method_getRollingDirection_22.set("methodName", "getRollingDirection");
        reflect_EntityMinecart_method_getRollingDirection_22.set("returnType", "int");
        reflect_EntityMinecart_method_getRollingDirection_22.set("static", false);
        reflect_EntityMinecart_method_getRollingDirection_22.set("argnames", new String[]{});
        reflect_EntityMinecart_method_getRollingDirection_22.set("argtypes", new String[]{});
        reflect_EntityMinecart_method_getRollingDirection_22.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityMinecart) params.getReflective("_self")).getRollingDirection();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityMinecart_methods.add(reflect_EntityMinecart_method_getRollingDirection_22);


        BaseData reflect_EntityMinecart_method_getDisplayTile_23 = new ModData();
        reflect_EntityMinecart_method_getDisplayTile_23.set("methodName", "getDisplayTile");
        reflect_EntityMinecart_method_getDisplayTile_23.set("returnType", "IBlockState");
        reflect_EntityMinecart_method_getDisplayTile_23.set("static", false);
        reflect_EntityMinecart_method_getDisplayTile_23.set("argnames", new String[]{});
        reflect_EntityMinecart_method_getDisplayTile_23.set("argtypes", new String[]{});
        reflect_EntityMinecart_method_getDisplayTile_23.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (IBlockState) ((EntityMinecart) params.getReflective("_self")).getDisplayTile();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityMinecart_methods.add(reflect_EntityMinecart_method_getDisplayTile_23);


        BaseData reflect_EntityMinecart_method_getDefaultDisplayTile_24 = new ModData();
        reflect_EntityMinecart_method_getDefaultDisplayTile_24.set("methodName", "getDefaultDisplayTile");
        reflect_EntityMinecart_method_getDefaultDisplayTile_24.set("returnType", "IBlockState");
        reflect_EntityMinecart_method_getDefaultDisplayTile_24.set("static", false);
        reflect_EntityMinecart_method_getDefaultDisplayTile_24.set("argnames", new String[]{});
        reflect_EntityMinecart_method_getDefaultDisplayTile_24.set("argtypes", new String[]{});
        reflect_EntityMinecart_method_getDefaultDisplayTile_24.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (IBlockState) ((EntityMinecart) params.getReflective("_self")).getDefaultDisplayTile();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityMinecart_methods.add(reflect_EntityMinecart_method_getDefaultDisplayTile_24);


        BaseData reflect_EntityMinecart_method_getDisplayTileOffset_25 = new ModData();
        reflect_EntityMinecart_method_getDisplayTileOffset_25.set("methodName", "getDisplayTileOffset");
        reflect_EntityMinecart_method_getDisplayTileOffset_25.set("returnType", "int");
        reflect_EntityMinecart_method_getDisplayTileOffset_25.set("static", false);
        reflect_EntityMinecart_method_getDisplayTileOffset_25.set("argnames", new String[]{});
        reflect_EntityMinecart_method_getDisplayTileOffset_25.set("argtypes", new String[]{});
        reflect_EntityMinecart_method_getDisplayTileOffset_25.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityMinecart) params.getReflective("_self")).getDisplayTileOffset();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityMinecart_methods.add(reflect_EntityMinecart_method_getDisplayTileOffset_25);


        BaseData reflect_EntityMinecart_method_getDefaultDisplayTileOffset_26 = new ModData();
        reflect_EntityMinecart_method_getDefaultDisplayTileOffset_26.set("methodName", "getDefaultDisplayTileOffset");
        reflect_EntityMinecart_method_getDefaultDisplayTileOffset_26.set("returnType", "int");
        reflect_EntityMinecart_method_getDefaultDisplayTileOffset_26.set("static", false);
        reflect_EntityMinecart_method_getDefaultDisplayTileOffset_26.set("argnames", new String[]{});
        reflect_EntityMinecart_method_getDefaultDisplayTileOffset_26.set("argtypes", new String[]{});
        reflect_EntityMinecart_method_getDefaultDisplayTileOffset_26.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityMinecart) params.getReflective("_self")).getDefaultDisplayTileOffset();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityMinecart_methods.add(reflect_EntityMinecart_method_getDefaultDisplayTileOffset_26);


        BaseData reflect_EntityMinecart_method_func_174899_a_27 = new ModData();
        reflect_EntityMinecart_method_func_174899_a_27.set("methodName", "func_174899_a");
        reflect_EntityMinecart_method_func_174899_a_27.set("returnType", "void");
        reflect_EntityMinecart_method_func_174899_a_27.set("static", false);
        reflect_EntityMinecart_method_func_174899_a_27.set("argnames", new String[]{"parIBlockState"});
        reflect_EntityMinecart_method_func_174899_a_27.set("argtypes", new String[]{"IBlockState"});
        reflect_EntityMinecart_method_func_174899_a_27.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityMinecart) params.getReflective("_self")).func_174899_a((IBlockState) params.getReflective("parIBlockState"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityMinecart_methods.add(reflect_EntityMinecart_method_func_174899_a_27);


        BaseData reflect_EntityMinecart_method_setDisplayTileOffset_28 = new ModData();
        reflect_EntityMinecart_method_setDisplayTileOffset_28.set("methodName", "setDisplayTileOffset");
        reflect_EntityMinecart_method_setDisplayTileOffset_28.set("returnType", "void");
        reflect_EntityMinecart_method_setDisplayTileOffset_28.set("static", false);
        reflect_EntityMinecart_method_setDisplayTileOffset_28.set("argnames", new String[]{"parInt1"});
        reflect_EntityMinecart_method_setDisplayTileOffset_28.set("argtypes", new String[]{"int"});
        reflect_EntityMinecart_method_setDisplayTileOffset_28.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityMinecart) params.getReflective("_self")).setDisplayTileOffset((int) params.getInt("parInt1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityMinecart_methods.add(reflect_EntityMinecart_method_setDisplayTileOffset_28);


        BaseData reflect_EntityMinecart_method_hasDisplayTile_29 = new ModData();
        reflect_EntityMinecart_method_hasDisplayTile_29.set("methodName", "hasDisplayTile");
        reflect_EntityMinecart_method_hasDisplayTile_29.set("returnType", "boolean");
        reflect_EntityMinecart_method_hasDisplayTile_29.set("static", false);
        reflect_EntityMinecart_method_hasDisplayTile_29.set("argnames", new String[]{});
        reflect_EntityMinecart_method_hasDisplayTile_29.set("argtypes", new String[]{});
        reflect_EntityMinecart_method_hasDisplayTile_29.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityMinecart) params.getReflective("_self")).hasDisplayTile();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityMinecart_methods.add(reflect_EntityMinecart_method_hasDisplayTile_29);


        BaseData reflect_EntityMinecart_method_setHasDisplayTile_30 = new ModData();
        reflect_EntityMinecart_method_setHasDisplayTile_30.set("methodName", "setHasDisplayTile");
        reflect_EntityMinecart_method_setHasDisplayTile_30.set("returnType", "void");
        reflect_EntityMinecart_method_setHasDisplayTile_30.set("static", false);
        reflect_EntityMinecart_method_setHasDisplayTile_30.set("argnames", new String[]{"parFlag"});
        reflect_EntityMinecart_method_setHasDisplayTile_30.set("argtypes", new String[]{"boolean"});
        reflect_EntityMinecart_method_setHasDisplayTile_30.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityMinecart) params.getReflective("_self")).setHasDisplayTile((boolean) params.getBoolean("parFlag"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityMinecart_methods.add(reflect_EntityMinecart_method_setHasDisplayTile_30);


        BaseData reflect_EntityMinecart_method_setCustomNameTag_31 = new ModData();
        reflect_EntityMinecart_method_setCustomNameTag_31.set("methodName", "setCustomNameTag");
        reflect_EntityMinecart_method_setCustomNameTag_31.set("returnType", "void");
        reflect_EntityMinecart_method_setCustomNameTag_31.set("static", false);
        reflect_EntityMinecart_method_setCustomNameTag_31.set("argnames", new String[]{"s"});
        reflect_EntityMinecart_method_setCustomNameTag_31.set("argtypes", new String[]{"String"});
        reflect_EntityMinecart_method_setCustomNameTag_31.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityMinecart) params.getReflective("_self")).setCustomNameTag((String) params.getString("s"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityMinecart_methods.add(reflect_EntityMinecart_method_setCustomNameTag_31);


        BaseData reflect_EntityMinecart_method_getName_32 = new ModData();
        reflect_EntityMinecart_method_getName_32.set("methodName", "getName");
        reflect_EntityMinecart_method_getName_32.set("returnType", "String");
        reflect_EntityMinecart_method_getName_32.set("static", false);
        reflect_EntityMinecart_method_getName_32.set("argnames", new String[]{});
        reflect_EntityMinecart_method_getName_32.set("argtypes", new String[]{});
        reflect_EntityMinecart_method_getName_32.setCallbackStringWithDataArg("exec", (BaseData params) -> {
                try {
                    return (String) ((EntityMinecart) params.getReflective("_self")).getName();
                } catch (Exception _exception_reflect_) {
                    return "";
                }
            });
            
        reflect_EntityMinecart_methods.add(reflect_EntityMinecart_method_getName_32);


        BaseData reflect_EntityMinecart_method_hasCustomName_33 = new ModData();
        reflect_EntityMinecart_method_hasCustomName_33.set("methodName", "hasCustomName");
        reflect_EntityMinecart_method_hasCustomName_33.set("returnType", "boolean");
        reflect_EntityMinecart_method_hasCustomName_33.set("static", false);
        reflect_EntityMinecart_method_hasCustomName_33.set("argnames", new String[]{});
        reflect_EntityMinecart_method_hasCustomName_33.set("argtypes", new String[]{});
        reflect_EntityMinecart_method_hasCustomName_33.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityMinecart) params.getReflective("_self")).hasCustomName();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityMinecart_methods.add(reflect_EntityMinecart_method_hasCustomName_33);


        BaseData reflect_EntityMinecart_method_getCustomNameTag_34 = new ModData();
        reflect_EntityMinecart_method_getCustomNameTag_34.set("methodName", "getCustomNameTag");
        reflect_EntityMinecart_method_getCustomNameTag_34.set("returnType", "String");
        reflect_EntityMinecart_method_getCustomNameTag_34.set("static", false);
        reflect_EntityMinecart_method_getCustomNameTag_34.set("argnames", new String[]{});
        reflect_EntityMinecart_method_getCustomNameTag_34.set("argtypes", new String[]{});
        reflect_EntityMinecart_method_getCustomNameTag_34.setCallbackStringWithDataArg("exec", (BaseData params) -> {
                try {
                    return (String) ((EntityMinecart) params.getReflective("_self")).getCustomNameTag();
                } catch (Exception _exception_reflect_) {
                    return "";
                }
            });
            
        reflect_EntityMinecart_methods.add(reflect_EntityMinecart_method_getCustomNameTag_34);


        BaseData reflect_EntityMinecart_method_getDisplayName_35 = new ModData();
        reflect_EntityMinecart_method_getDisplayName_35.set("methodName", "getDisplayName");
        reflect_EntityMinecart_method_getDisplayName_35.set("returnType", "IChatComponent");
        reflect_EntityMinecart_method_getDisplayName_35.set("static", false);
        reflect_EntityMinecart_method_getDisplayName_35.set("argnames", new String[]{});
        reflect_EntityMinecart_method_getDisplayName_35.set("argtypes", new String[]{});
        reflect_EntityMinecart_method_getDisplayName_35.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (IChatComponent) ((EntityMinecart) params.getReflective("_self")).getDisplayName();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityMinecart_methods.add(reflect_EntityMinecart_method_getDisplayName_35);


        BaseData[] reflect_EntityMinecart_methods_arr = new BaseData[reflect_EntityMinecart_methods.size()];
        for (int i = 0; i < reflect_EntityMinecart_methods_arr.length; i++) {
            reflect_EntityMinecart_methods_arr[i] = reflect_EntityMinecart_methods.get(i);
        }

        reflect_EntityMinecart.set("constructors", reflect_EntityMinecart_constructors_arr);
        reflect_EntityMinecart.set("methods", reflect_EntityMinecart_methods_arr);
        reflect_EntityMinecart.set("className", "EntityMinecart");
        reflect_EntityMinecart.set("classId", "net.minecraft.entity.item.EntityMinecart");
        reflect_EntityMinecart.set("class", EntityMinecart.class);
        reflect_EntityMinecart.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityMinecart;
        });
        reflectProfiles.add(reflect_EntityMinecart);
    }


    //classdef for EntityMinecartChest
    public static void reflect_EntityMinecartChest_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityMinecartChest = new ModData();

        ArrayList<BaseData> reflect_EntityMinecartChest_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_EntityMinecartChest_constructor_EntityMinecartChest_0 = new ModData();
        reflect_EntityMinecartChest_constructor_EntityMinecartChest_0.set("returnType", "EntityMinecartChest");
        reflect_EntityMinecartChest_constructor_EntityMinecartChest_0.set("argnames", new String[]{"worldIn"});
        reflect_EntityMinecartChest_constructor_EntityMinecartChest_0.set("argtypes", new String[]{"World"});
        reflect_EntityMinecartChest_constructor_EntityMinecartChest_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityMinecartChest((World) params.getReflective("worldIn"));
        });
        
        reflect_EntityMinecartChest_constructors.add(reflect_EntityMinecartChest_constructor_EntityMinecartChest_0);


        BaseData reflect_EntityMinecartChest_constructor_EntityMinecartChest_1 = new ModData();
        reflect_EntityMinecartChest_constructor_EntityMinecartChest_1.set("returnType", "EntityMinecartChest");
        reflect_EntityMinecartChest_constructor_EntityMinecartChest_1.set("argnames", new String[]{"worldIn", "parDouble1", "parDouble2", "parDouble3"});
        reflect_EntityMinecartChest_constructor_EntityMinecartChest_1.set("argtypes", new String[]{"World", "double", "double", "double"});
        reflect_EntityMinecartChest_constructor_EntityMinecartChest_1.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityMinecartChest((World) params.getReflective("worldIn"), (double) params.getDouble("parDouble1"), (double) params.getDouble("parDouble2"), (double) params.getDouble("parDouble3"));
        });
        
        reflect_EntityMinecartChest_constructors.add(reflect_EntityMinecartChest_constructor_EntityMinecartChest_1);


        BaseData[] reflect_EntityMinecartChest_constructors_arr = new BaseData[reflect_EntityMinecartChest_constructors.size()];
        for (int i = 0; i < reflect_EntityMinecartChest_constructors_arr.length; i++) {
            reflect_EntityMinecartChest_constructors_arr[i] = reflect_EntityMinecartChest_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityMinecartChest_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityMinecartChest_method_killMinecart_0 = new ModData();
        reflect_EntityMinecartChest_method_killMinecart_0.set("methodName", "killMinecart");
        reflect_EntityMinecartChest_method_killMinecart_0.set("returnType", "void");
        reflect_EntityMinecartChest_method_killMinecart_0.set("static", false);
        reflect_EntityMinecartChest_method_killMinecart_0.set("argnames", new String[]{"damagesource"});
        reflect_EntityMinecartChest_method_killMinecart_0.set("argtypes", new String[]{"DamageSource"});
        reflect_EntityMinecartChest_method_killMinecart_0.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityMinecartChest) params.getReflective("_self")).killMinecart((DamageSource) params.getReflective("damagesource"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityMinecartChest_methods.add(reflect_EntityMinecartChest_method_killMinecart_0);


        BaseData reflect_EntityMinecartChest_method_getSizeInventory_1 = new ModData();
        reflect_EntityMinecartChest_method_getSizeInventory_1.set("methodName", "getSizeInventory");
        reflect_EntityMinecartChest_method_getSizeInventory_1.set("returnType", "int");
        reflect_EntityMinecartChest_method_getSizeInventory_1.set("static", false);
        reflect_EntityMinecartChest_method_getSizeInventory_1.set("argnames", new String[]{});
        reflect_EntityMinecartChest_method_getSizeInventory_1.set("argtypes", new String[]{});
        reflect_EntityMinecartChest_method_getSizeInventory_1.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityMinecartChest) params.getReflective("_self")).getSizeInventory();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityMinecartChest_methods.add(reflect_EntityMinecartChest_method_getSizeInventory_1);


        BaseData reflect_EntityMinecartChest_method_getDefaultDisplayTile_2 = new ModData();
        reflect_EntityMinecartChest_method_getDefaultDisplayTile_2.set("methodName", "getDefaultDisplayTile");
        reflect_EntityMinecartChest_method_getDefaultDisplayTile_2.set("returnType", "IBlockState");
        reflect_EntityMinecartChest_method_getDefaultDisplayTile_2.set("static", false);
        reflect_EntityMinecartChest_method_getDefaultDisplayTile_2.set("argnames", new String[]{});
        reflect_EntityMinecartChest_method_getDefaultDisplayTile_2.set("argtypes", new String[]{});
        reflect_EntityMinecartChest_method_getDefaultDisplayTile_2.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (IBlockState) ((EntityMinecartChest) params.getReflective("_self")).getDefaultDisplayTile();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityMinecartChest_methods.add(reflect_EntityMinecartChest_method_getDefaultDisplayTile_2);


        BaseData reflect_EntityMinecartChest_method_getDefaultDisplayTileOffset_3 = new ModData();
        reflect_EntityMinecartChest_method_getDefaultDisplayTileOffset_3.set("methodName", "getDefaultDisplayTileOffset");
        reflect_EntityMinecartChest_method_getDefaultDisplayTileOffset_3.set("returnType", "int");
        reflect_EntityMinecartChest_method_getDefaultDisplayTileOffset_3.set("static", false);
        reflect_EntityMinecartChest_method_getDefaultDisplayTileOffset_3.set("argnames", new String[]{});
        reflect_EntityMinecartChest_method_getDefaultDisplayTileOffset_3.set("argtypes", new String[]{});
        reflect_EntityMinecartChest_method_getDefaultDisplayTileOffset_3.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityMinecartChest) params.getReflective("_self")).getDefaultDisplayTileOffset();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityMinecartChest_methods.add(reflect_EntityMinecartChest_method_getDefaultDisplayTileOffset_3);


        BaseData reflect_EntityMinecartChest_method_getGuiID_4 = new ModData();
        reflect_EntityMinecartChest_method_getGuiID_4.set("methodName", "getGuiID");
        reflect_EntityMinecartChest_method_getGuiID_4.set("returnType", "String");
        reflect_EntityMinecartChest_method_getGuiID_4.set("static", false);
        reflect_EntityMinecartChest_method_getGuiID_4.set("argnames", new String[]{});
        reflect_EntityMinecartChest_method_getGuiID_4.set("argtypes", new String[]{});
        reflect_EntityMinecartChest_method_getGuiID_4.setCallbackStringWithDataArg("exec", (BaseData params) -> {
                try {
                    return (String) ((EntityMinecartChest) params.getReflective("_self")).getGuiID();
                } catch (Exception _exception_reflect_) {
                    return "";
                }
            });
            
        reflect_EntityMinecartChest_methods.add(reflect_EntityMinecartChest_method_getGuiID_4);


        BaseData reflect_EntityMinecartChest_method_createContainer_5 = new ModData();
        reflect_EntityMinecartChest_method_createContainer_5.set("methodName", "createContainer");
        reflect_EntityMinecartChest_method_createContainer_5.set("returnType", "Container");
        reflect_EntityMinecartChest_method_createContainer_5.set("static", false);
        reflect_EntityMinecartChest_method_createContainer_5.set("argnames", new String[]{"inventoryplayer", "entityplayer"});
        reflect_EntityMinecartChest_method_createContainer_5.set("argtypes", new String[]{"InventoryPlayer", "EntityPlayer"});
        reflect_EntityMinecartChest_method_createContainer_5.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Container) ((EntityMinecartChest) params.getReflective("_self")).createContainer((InventoryPlayer) params.getReflective("inventoryplayer"), (EntityPlayer) params.getReflective("entityplayer"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityMinecartChest_methods.add(reflect_EntityMinecartChest_method_createContainer_5);


        BaseData[] reflect_EntityMinecartChest_methods_arr = new BaseData[reflect_EntityMinecartChest_methods.size()];
        for (int i = 0; i < reflect_EntityMinecartChest_methods_arr.length; i++) {
            reflect_EntityMinecartChest_methods_arr[i] = reflect_EntityMinecartChest_methods.get(i);
        }

        reflect_EntityMinecartChest.set("constructors", reflect_EntityMinecartChest_constructors_arr);
        reflect_EntityMinecartChest.set("methods", reflect_EntityMinecartChest_methods_arr);
        reflect_EntityMinecartChest.set("className", "EntityMinecartChest");
        reflect_EntityMinecartChest.set("classId", "net.minecraft.entity.item.EntityMinecartChest");
        reflect_EntityMinecartChest.set("class", EntityMinecartChest.class);
        reflect_EntityMinecartChest.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityMinecartChest;
        });
        reflectProfiles.add(reflect_EntityMinecartChest);
    }


    //classdef for EntityMinecartContainer
    public static void reflect_EntityMinecartContainer_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityMinecartContainer = new ModData();

        ArrayList<BaseData> reflect_EntityMinecartContainer_constructors = new ArrayList<BaseData>();
        
        BaseData[] reflect_EntityMinecartContainer_constructors_arr = new BaseData[reflect_EntityMinecartContainer_constructors.size()];
        for (int i = 0; i < reflect_EntityMinecartContainer_constructors_arr.length; i++) {
            reflect_EntityMinecartContainer_constructors_arr[i] = reflect_EntityMinecartContainer_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityMinecartContainer_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityMinecartContainer_method_killMinecart_0 = new ModData();
        reflect_EntityMinecartContainer_method_killMinecart_0.set("methodName", "killMinecart");
        reflect_EntityMinecartContainer_method_killMinecart_0.set("returnType", "void");
        reflect_EntityMinecartContainer_method_killMinecart_0.set("static", false);
        reflect_EntityMinecartContainer_method_killMinecart_0.set("argnames", new String[]{"damagesource"});
        reflect_EntityMinecartContainer_method_killMinecart_0.set("argtypes", new String[]{"DamageSource"});
        reflect_EntityMinecartContainer_method_killMinecart_0.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityMinecartContainer) params.getReflective("_self")).killMinecart((DamageSource) params.getReflective("damagesource"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityMinecartContainer_methods.add(reflect_EntityMinecartContainer_method_killMinecart_0);


        BaseData reflect_EntityMinecartContainer_method_getStackInSlot_1 = new ModData();
        reflect_EntityMinecartContainer_method_getStackInSlot_1.set("methodName", "getStackInSlot");
        reflect_EntityMinecartContainer_method_getStackInSlot_1.set("returnType", "ItemStack");
        reflect_EntityMinecartContainer_method_getStackInSlot_1.set("static", false);
        reflect_EntityMinecartContainer_method_getStackInSlot_1.set("argnames", new String[]{"i"});
        reflect_EntityMinecartContainer_method_getStackInSlot_1.set("argtypes", new String[]{"int"});
        reflect_EntityMinecartContainer_method_getStackInSlot_1.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (ItemStack) ((EntityMinecartContainer) params.getReflective("_self")).getStackInSlot((int) params.getInt("i"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityMinecartContainer_methods.add(reflect_EntityMinecartContainer_method_getStackInSlot_1);


        BaseData reflect_EntityMinecartContainer_method_decrStackSize_2 = new ModData();
        reflect_EntityMinecartContainer_method_decrStackSize_2.set("methodName", "decrStackSize");
        reflect_EntityMinecartContainer_method_decrStackSize_2.set("returnType", "ItemStack");
        reflect_EntityMinecartContainer_method_decrStackSize_2.set("static", false);
        reflect_EntityMinecartContainer_method_decrStackSize_2.set("argnames", new String[]{"i", "j"});
        reflect_EntityMinecartContainer_method_decrStackSize_2.set("argtypes", new String[]{"int", "int"});
        reflect_EntityMinecartContainer_method_decrStackSize_2.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (ItemStack) ((EntityMinecartContainer) params.getReflective("_self")).decrStackSize((int) params.getInt("i"), (int) params.getInt("j"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityMinecartContainer_methods.add(reflect_EntityMinecartContainer_method_decrStackSize_2);


        BaseData reflect_EntityMinecartContainer_method_removeStackFromSlot_3 = new ModData();
        reflect_EntityMinecartContainer_method_removeStackFromSlot_3.set("methodName", "removeStackFromSlot");
        reflect_EntityMinecartContainer_method_removeStackFromSlot_3.set("returnType", "ItemStack");
        reflect_EntityMinecartContainer_method_removeStackFromSlot_3.set("static", false);
        reflect_EntityMinecartContainer_method_removeStackFromSlot_3.set("argnames", new String[]{"i"});
        reflect_EntityMinecartContainer_method_removeStackFromSlot_3.set("argtypes", new String[]{"int"});
        reflect_EntityMinecartContainer_method_removeStackFromSlot_3.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (ItemStack) ((EntityMinecartContainer) params.getReflective("_self")).removeStackFromSlot((int) params.getInt("i"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityMinecartContainer_methods.add(reflect_EntityMinecartContainer_method_removeStackFromSlot_3);


        BaseData reflect_EntityMinecartContainer_method_setInventorySlotContents_4 = new ModData();
        reflect_EntityMinecartContainer_method_setInventorySlotContents_4.set("methodName", "setInventorySlotContents");
        reflect_EntityMinecartContainer_method_setInventorySlotContents_4.set("returnType", "void");
        reflect_EntityMinecartContainer_method_setInventorySlotContents_4.set("static", false);
        reflect_EntityMinecartContainer_method_setInventorySlotContents_4.set("argnames", new String[]{"i", "itemstack"});
        reflect_EntityMinecartContainer_method_setInventorySlotContents_4.set("argtypes", new String[]{"int", "ItemStack"});
        reflect_EntityMinecartContainer_method_setInventorySlotContents_4.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityMinecartContainer) params.getReflective("_self")).setInventorySlotContents((int) params.getInt("i"), (ItemStack) params.getReflective("itemstack"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityMinecartContainer_methods.add(reflect_EntityMinecartContainer_method_setInventorySlotContents_4);


        BaseData reflect_EntityMinecartContainer_method_markDirty_5 = new ModData();
        reflect_EntityMinecartContainer_method_markDirty_5.set("methodName", "markDirty");
        reflect_EntityMinecartContainer_method_markDirty_5.set("returnType", "void");
        reflect_EntityMinecartContainer_method_markDirty_5.set("static", false);
        reflect_EntityMinecartContainer_method_markDirty_5.set("argnames", new String[]{});
        reflect_EntityMinecartContainer_method_markDirty_5.set("argtypes", new String[]{});
        reflect_EntityMinecartContainer_method_markDirty_5.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityMinecartContainer) params.getReflective("_self")).markDirty();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityMinecartContainer_methods.add(reflect_EntityMinecartContainer_method_markDirty_5);


        BaseData reflect_EntityMinecartContainer_method_isUseableByPlayer_6 = new ModData();
        reflect_EntityMinecartContainer_method_isUseableByPlayer_6.set("methodName", "isUseableByPlayer");
        reflect_EntityMinecartContainer_method_isUseableByPlayer_6.set("returnType", "boolean");
        reflect_EntityMinecartContainer_method_isUseableByPlayer_6.set("static", false);
        reflect_EntityMinecartContainer_method_isUseableByPlayer_6.set("argnames", new String[]{"entityplayer"});
        reflect_EntityMinecartContainer_method_isUseableByPlayer_6.set("argtypes", new String[]{"EntityPlayer"});
        reflect_EntityMinecartContainer_method_isUseableByPlayer_6.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityMinecartContainer) params.getReflective("_self")).isUseableByPlayer((EntityPlayer) params.getReflective("entityplayer"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityMinecartContainer_methods.add(reflect_EntityMinecartContainer_method_isUseableByPlayer_6);


        BaseData reflect_EntityMinecartContainer_method_openInventory_7 = new ModData();
        reflect_EntityMinecartContainer_method_openInventory_7.set("methodName", "openInventory");
        reflect_EntityMinecartContainer_method_openInventory_7.set("returnType", "void");
        reflect_EntityMinecartContainer_method_openInventory_7.set("static", false);
        reflect_EntityMinecartContainer_method_openInventory_7.set("argnames", new String[]{"var1"});
        reflect_EntityMinecartContainer_method_openInventory_7.set("argtypes", new String[]{"EntityPlayer"});
        reflect_EntityMinecartContainer_method_openInventory_7.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityMinecartContainer) params.getReflective("_self")).openInventory((EntityPlayer) params.getReflective("var1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityMinecartContainer_methods.add(reflect_EntityMinecartContainer_method_openInventory_7);


        BaseData reflect_EntityMinecartContainer_method_closeInventory_8 = new ModData();
        reflect_EntityMinecartContainer_method_closeInventory_8.set("methodName", "closeInventory");
        reflect_EntityMinecartContainer_method_closeInventory_8.set("returnType", "void");
        reflect_EntityMinecartContainer_method_closeInventory_8.set("static", false);
        reflect_EntityMinecartContainer_method_closeInventory_8.set("argnames", new String[]{"var1"});
        reflect_EntityMinecartContainer_method_closeInventory_8.set("argtypes", new String[]{"EntityPlayer"});
        reflect_EntityMinecartContainer_method_closeInventory_8.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityMinecartContainer) params.getReflective("_self")).closeInventory((EntityPlayer) params.getReflective("var1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityMinecartContainer_methods.add(reflect_EntityMinecartContainer_method_closeInventory_8);


        BaseData reflect_EntityMinecartContainer_method_isItemValidForSlot_9 = new ModData();
        reflect_EntityMinecartContainer_method_isItemValidForSlot_9.set("methodName", "isItemValidForSlot");
        reflect_EntityMinecartContainer_method_isItemValidForSlot_9.set("returnType", "boolean");
        reflect_EntityMinecartContainer_method_isItemValidForSlot_9.set("static", false);
        reflect_EntityMinecartContainer_method_isItemValidForSlot_9.set("argnames", new String[]{"var1", "var2"});
        reflect_EntityMinecartContainer_method_isItemValidForSlot_9.set("argtypes", new String[]{"int", "ItemStack"});
        reflect_EntityMinecartContainer_method_isItemValidForSlot_9.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityMinecartContainer) params.getReflective("_self")).isItemValidForSlot((int) params.getInt("var1"), (ItemStack) params.getReflective("var2"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityMinecartContainer_methods.add(reflect_EntityMinecartContainer_method_isItemValidForSlot_9);


        BaseData reflect_EntityMinecartContainer_method_getName_10 = new ModData();
        reflect_EntityMinecartContainer_method_getName_10.set("methodName", "getName");
        reflect_EntityMinecartContainer_method_getName_10.set("returnType", "String");
        reflect_EntityMinecartContainer_method_getName_10.set("static", false);
        reflect_EntityMinecartContainer_method_getName_10.set("argnames", new String[]{});
        reflect_EntityMinecartContainer_method_getName_10.set("argtypes", new String[]{});
        reflect_EntityMinecartContainer_method_getName_10.setCallbackStringWithDataArg("exec", (BaseData params) -> {
                try {
                    return (String) ((EntityMinecartContainer) params.getReflective("_self")).getName();
                } catch (Exception _exception_reflect_) {
                    return "";
                }
            });
            
        reflect_EntityMinecartContainer_methods.add(reflect_EntityMinecartContainer_method_getName_10);


        BaseData reflect_EntityMinecartContainer_method_getInventoryStackLimit_11 = new ModData();
        reflect_EntityMinecartContainer_method_getInventoryStackLimit_11.set("methodName", "getInventoryStackLimit");
        reflect_EntityMinecartContainer_method_getInventoryStackLimit_11.set("returnType", "int");
        reflect_EntityMinecartContainer_method_getInventoryStackLimit_11.set("static", false);
        reflect_EntityMinecartContainer_method_getInventoryStackLimit_11.set("argnames", new String[]{});
        reflect_EntityMinecartContainer_method_getInventoryStackLimit_11.set("argtypes", new String[]{});
        reflect_EntityMinecartContainer_method_getInventoryStackLimit_11.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityMinecartContainer) params.getReflective("_self")).getInventoryStackLimit();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityMinecartContainer_methods.add(reflect_EntityMinecartContainer_method_getInventoryStackLimit_11);


        BaseData reflect_EntityMinecartContainer_method_travelToDimension_12 = new ModData();
        reflect_EntityMinecartContainer_method_travelToDimension_12.set("methodName", "travelToDimension");
        reflect_EntityMinecartContainer_method_travelToDimension_12.set("returnType", "void");
        reflect_EntityMinecartContainer_method_travelToDimension_12.set("static", false);
        reflect_EntityMinecartContainer_method_travelToDimension_12.set("argnames", new String[]{"i"});
        reflect_EntityMinecartContainer_method_travelToDimension_12.set("argtypes", new String[]{"int"});
        reflect_EntityMinecartContainer_method_travelToDimension_12.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityMinecartContainer) params.getReflective("_self")).travelToDimension((int) params.getInt("i"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityMinecartContainer_methods.add(reflect_EntityMinecartContainer_method_travelToDimension_12);


        BaseData reflect_EntityMinecartContainer_method_setDead_13 = new ModData();
        reflect_EntityMinecartContainer_method_setDead_13.set("methodName", "setDead");
        reflect_EntityMinecartContainer_method_setDead_13.set("returnType", "void");
        reflect_EntityMinecartContainer_method_setDead_13.set("static", false);
        reflect_EntityMinecartContainer_method_setDead_13.set("argnames", new String[]{});
        reflect_EntityMinecartContainer_method_setDead_13.set("argtypes", new String[]{});
        reflect_EntityMinecartContainer_method_setDead_13.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityMinecartContainer) params.getReflective("_self")).setDead();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityMinecartContainer_methods.add(reflect_EntityMinecartContainer_method_setDead_13);


        BaseData reflect_EntityMinecartContainer_method_interactFirst_14 = new ModData();
        reflect_EntityMinecartContainer_method_interactFirst_14.set("methodName", "interactFirst");
        reflect_EntityMinecartContainer_method_interactFirst_14.set("returnType", "boolean");
        reflect_EntityMinecartContainer_method_interactFirst_14.set("static", false);
        reflect_EntityMinecartContainer_method_interactFirst_14.set("argnames", new String[]{"entityplayer"});
        reflect_EntityMinecartContainer_method_interactFirst_14.set("argtypes", new String[]{"EntityPlayer"});
        reflect_EntityMinecartContainer_method_interactFirst_14.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityMinecartContainer) params.getReflective("_self")).interactFirst((EntityPlayer) params.getReflective("entityplayer"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityMinecartContainer_methods.add(reflect_EntityMinecartContainer_method_interactFirst_14);


        BaseData reflect_EntityMinecartContainer_method_getField_15 = new ModData();
        reflect_EntityMinecartContainer_method_getField_15.set("methodName", "getField");
        reflect_EntityMinecartContainer_method_getField_15.set("returnType", "int");
        reflect_EntityMinecartContainer_method_getField_15.set("static", false);
        reflect_EntityMinecartContainer_method_getField_15.set("argnames", new String[]{"var1"});
        reflect_EntityMinecartContainer_method_getField_15.set("argtypes", new String[]{"int"});
        reflect_EntityMinecartContainer_method_getField_15.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityMinecartContainer) params.getReflective("_self")).getField((int) params.getInt("var1"));
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityMinecartContainer_methods.add(reflect_EntityMinecartContainer_method_getField_15);


        BaseData reflect_EntityMinecartContainer_method_setField_16 = new ModData();
        reflect_EntityMinecartContainer_method_setField_16.set("methodName", "setField");
        reflect_EntityMinecartContainer_method_setField_16.set("returnType", "void");
        reflect_EntityMinecartContainer_method_setField_16.set("static", false);
        reflect_EntityMinecartContainer_method_setField_16.set("argnames", new String[]{"var1", "var2"});
        reflect_EntityMinecartContainer_method_setField_16.set("argtypes", new String[]{"int", "int"});
        reflect_EntityMinecartContainer_method_setField_16.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityMinecartContainer) params.getReflective("_self")).setField((int) params.getInt("var1"), (int) params.getInt("var2"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityMinecartContainer_methods.add(reflect_EntityMinecartContainer_method_setField_16);


        BaseData reflect_EntityMinecartContainer_method_getFieldCount_17 = new ModData();
        reflect_EntityMinecartContainer_method_getFieldCount_17.set("methodName", "getFieldCount");
        reflect_EntityMinecartContainer_method_getFieldCount_17.set("returnType", "int");
        reflect_EntityMinecartContainer_method_getFieldCount_17.set("static", false);
        reflect_EntityMinecartContainer_method_getFieldCount_17.set("argnames", new String[]{});
        reflect_EntityMinecartContainer_method_getFieldCount_17.set("argtypes", new String[]{});
        reflect_EntityMinecartContainer_method_getFieldCount_17.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityMinecartContainer) params.getReflective("_self")).getFieldCount();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityMinecartContainer_methods.add(reflect_EntityMinecartContainer_method_getFieldCount_17);


        BaseData reflect_EntityMinecartContainer_method_isLocked_18 = new ModData();
        reflect_EntityMinecartContainer_method_isLocked_18.set("methodName", "isLocked");
        reflect_EntityMinecartContainer_method_isLocked_18.set("returnType", "boolean");
        reflect_EntityMinecartContainer_method_isLocked_18.set("static", false);
        reflect_EntityMinecartContainer_method_isLocked_18.set("argnames", new String[]{});
        reflect_EntityMinecartContainer_method_isLocked_18.set("argtypes", new String[]{});
        reflect_EntityMinecartContainer_method_isLocked_18.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityMinecartContainer) params.getReflective("_self")).isLocked();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityMinecartContainer_methods.add(reflect_EntityMinecartContainer_method_isLocked_18);


        BaseData reflect_EntityMinecartContainer_method_setLockCode_19 = new ModData();
        reflect_EntityMinecartContainer_method_setLockCode_19.set("methodName", "setLockCode");
        reflect_EntityMinecartContainer_method_setLockCode_19.set("returnType", "void");
        reflect_EntityMinecartContainer_method_setLockCode_19.set("static", false);
        reflect_EntityMinecartContainer_method_setLockCode_19.set("argnames", new String[]{"var1"});
        reflect_EntityMinecartContainer_method_setLockCode_19.set("argtypes", new String[]{"LockCode"});
        reflect_EntityMinecartContainer_method_setLockCode_19.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityMinecartContainer) params.getReflective("_self")).setLockCode((LockCode) params.getReflective("var1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityMinecartContainer_methods.add(reflect_EntityMinecartContainer_method_setLockCode_19);


        BaseData reflect_EntityMinecartContainer_method_getLockCode_20 = new ModData();
        reflect_EntityMinecartContainer_method_getLockCode_20.set("methodName", "getLockCode");
        reflect_EntityMinecartContainer_method_getLockCode_20.set("returnType", "LockCode");
        reflect_EntityMinecartContainer_method_getLockCode_20.set("static", false);
        reflect_EntityMinecartContainer_method_getLockCode_20.set("argnames", new String[]{});
        reflect_EntityMinecartContainer_method_getLockCode_20.set("argtypes", new String[]{});
        reflect_EntityMinecartContainer_method_getLockCode_20.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (LockCode) ((EntityMinecartContainer) params.getReflective("_self")).getLockCode();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityMinecartContainer_methods.add(reflect_EntityMinecartContainer_method_getLockCode_20);


        BaseData reflect_EntityMinecartContainer_method_clear_21 = new ModData();
        reflect_EntityMinecartContainer_method_clear_21.set("methodName", "clear");
        reflect_EntityMinecartContainer_method_clear_21.set("returnType", "void");
        reflect_EntityMinecartContainer_method_clear_21.set("static", false);
        reflect_EntityMinecartContainer_method_clear_21.set("argnames", new String[]{});
        reflect_EntityMinecartContainer_method_clear_21.set("argtypes", new String[]{});
        reflect_EntityMinecartContainer_method_clear_21.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityMinecartContainer) params.getReflective("_self")).clear();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityMinecartContainer_methods.add(reflect_EntityMinecartContainer_method_clear_21);


        BaseData[] reflect_EntityMinecartContainer_methods_arr = new BaseData[reflect_EntityMinecartContainer_methods.size()];
        for (int i = 0; i < reflect_EntityMinecartContainer_methods_arr.length; i++) {
            reflect_EntityMinecartContainer_methods_arr[i] = reflect_EntityMinecartContainer_methods.get(i);
        }

        reflect_EntityMinecartContainer.set("constructors", reflect_EntityMinecartContainer_constructors_arr);
        reflect_EntityMinecartContainer.set("methods", reflect_EntityMinecartContainer_methods_arr);
        reflect_EntityMinecartContainer.set("className", "EntityMinecartContainer");
        reflect_EntityMinecartContainer.set("classId", "net.minecraft.entity.item.EntityMinecartContainer");
        reflect_EntityMinecartContainer.set("class", EntityMinecartContainer.class);
        reflect_EntityMinecartContainer.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityMinecartContainer;
        });
        reflectProfiles.add(reflect_EntityMinecartContainer);
    }


    //classdef for EntityMinecartEmpty
    public static void reflect_EntityMinecartEmpty_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityMinecartEmpty = new ModData();

        ArrayList<BaseData> reflect_EntityMinecartEmpty_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_EntityMinecartEmpty_constructor_EntityMinecartEmpty_0 = new ModData();
        reflect_EntityMinecartEmpty_constructor_EntityMinecartEmpty_0.set("returnType", "EntityMinecartEmpty");
        reflect_EntityMinecartEmpty_constructor_EntityMinecartEmpty_0.set("argnames", new String[]{"worldIn"});
        reflect_EntityMinecartEmpty_constructor_EntityMinecartEmpty_0.set("argtypes", new String[]{"World"});
        reflect_EntityMinecartEmpty_constructor_EntityMinecartEmpty_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityMinecartEmpty((World) params.getReflective("worldIn"));
        });
        
        reflect_EntityMinecartEmpty_constructors.add(reflect_EntityMinecartEmpty_constructor_EntityMinecartEmpty_0);


        BaseData reflect_EntityMinecartEmpty_constructor_EntityMinecartEmpty_1 = new ModData();
        reflect_EntityMinecartEmpty_constructor_EntityMinecartEmpty_1.set("returnType", "EntityMinecartEmpty");
        reflect_EntityMinecartEmpty_constructor_EntityMinecartEmpty_1.set("argnames", new String[]{"worldIn", "parDouble1", "parDouble2", "parDouble3"});
        reflect_EntityMinecartEmpty_constructor_EntityMinecartEmpty_1.set("argtypes", new String[]{"World", "double", "double", "double"});
        reflect_EntityMinecartEmpty_constructor_EntityMinecartEmpty_1.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityMinecartEmpty((World) params.getReflective("worldIn"), (double) params.getDouble("parDouble1"), (double) params.getDouble("parDouble2"), (double) params.getDouble("parDouble3"));
        });
        
        reflect_EntityMinecartEmpty_constructors.add(reflect_EntityMinecartEmpty_constructor_EntityMinecartEmpty_1);


        BaseData[] reflect_EntityMinecartEmpty_constructors_arr = new BaseData[reflect_EntityMinecartEmpty_constructors.size()];
        for (int i = 0; i < reflect_EntityMinecartEmpty_constructors_arr.length; i++) {
            reflect_EntityMinecartEmpty_constructors_arr[i] = reflect_EntityMinecartEmpty_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityMinecartEmpty_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityMinecartEmpty_method_interactFirst_0 = new ModData();
        reflect_EntityMinecartEmpty_method_interactFirst_0.set("methodName", "interactFirst");
        reflect_EntityMinecartEmpty_method_interactFirst_0.set("returnType", "boolean");
        reflect_EntityMinecartEmpty_method_interactFirst_0.set("static", false);
        reflect_EntityMinecartEmpty_method_interactFirst_0.set("argnames", new String[]{"entityplayer"});
        reflect_EntityMinecartEmpty_method_interactFirst_0.set("argtypes", new String[]{"EntityPlayer"});
        reflect_EntityMinecartEmpty_method_interactFirst_0.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityMinecartEmpty) params.getReflective("_self")).interactFirst((EntityPlayer) params.getReflective("entityplayer"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityMinecartEmpty_methods.add(reflect_EntityMinecartEmpty_method_interactFirst_0);


        BaseData reflect_EntityMinecartEmpty_method_onActivatorRailPass_1 = new ModData();
        reflect_EntityMinecartEmpty_method_onActivatorRailPass_1.set("methodName", "onActivatorRailPass");
        reflect_EntityMinecartEmpty_method_onActivatorRailPass_1.set("returnType", "void");
        reflect_EntityMinecartEmpty_method_onActivatorRailPass_1.set("static", false);
        reflect_EntityMinecartEmpty_method_onActivatorRailPass_1.set("argnames", new String[]{"var1", "var2", "var3", "flag"});
        reflect_EntityMinecartEmpty_method_onActivatorRailPass_1.set("argtypes", new String[]{"int", "int", "int", "boolean"});
        reflect_EntityMinecartEmpty_method_onActivatorRailPass_1.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityMinecartEmpty) params.getReflective("_self")).onActivatorRailPass((int) params.getInt("var1"), (int) params.getInt("var2"), (int) params.getInt("var3"), (boolean) params.getBoolean("flag"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityMinecartEmpty_methods.add(reflect_EntityMinecartEmpty_method_onActivatorRailPass_1);


        BaseData[] reflect_EntityMinecartEmpty_methods_arr = new BaseData[reflect_EntityMinecartEmpty_methods.size()];
        for (int i = 0; i < reflect_EntityMinecartEmpty_methods_arr.length; i++) {
            reflect_EntityMinecartEmpty_methods_arr[i] = reflect_EntityMinecartEmpty_methods.get(i);
        }

        reflect_EntityMinecartEmpty.set("constructors", reflect_EntityMinecartEmpty_constructors_arr);
        reflect_EntityMinecartEmpty.set("methods", reflect_EntityMinecartEmpty_methods_arr);
        reflect_EntityMinecartEmpty.set("className", "EntityMinecartEmpty");
        reflect_EntityMinecartEmpty.set("classId", "net.minecraft.entity.item.EntityMinecartEmpty");
        reflect_EntityMinecartEmpty.set("class", EntityMinecartEmpty.class);
        reflect_EntityMinecartEmpty.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityMinecartEmpty;
        });
        reflectProfiles.add(reflect_EntityMinecartEmpty);
    }


    //classdef for EntityMinecartFurnace
    public static void reflect_EntityMinecartFurnace_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityMinecartFurnace = new ModData();

        ArrayList<BaseData> reflect_EntityMinecartFurnace_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_EntityMinecartFurnace_constructor_EntityMinecartFurnace_0 = new ModData();
        reflect_EntityMinecartFurnace_constructor_EntityMinecartFurnace_0.set("returnType", "EntityMinecartFurnace");
        reflect_EntityMinecartFurnace_constructor_EntityMinecartFurnace_0.set("argnames", new String[]{"worldIn"});
        reflect_EntityMinecartFurnace_constructor_EntityMinecartFurnace_0.set("argtypes", new String[]{"World"});
        reflect_EntityMinecartFurnace_constructor_EntityMinecartFurnace_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityMinecartFurnace((World) params.getReflective("worldIn"));
        });
        
        reflect_EntityMinecartFurnace_constructors.add(reflect_EntityMinecartFurnace_constructor_EntityMinecartFurnace_0);


        BaseData reflect_EntityMinecartFurnace_constructor_EntityMinecartFurnace_1 = new ModData();
        reflect_EntityMinecartFurnace_constructor_EntityMinecartFurnace_1.set("returnType", "EntityMinecartFurnace");
        reflect_EntityMinecartFurnace_constructor_EntityMinecartFurnace_1.set("argnames", new String[]{"worldIn", "parDouble1", "parDouble2", "parDouble3"});
        reflect_EntityMinecartFurnace_constructor_EntityMinecartFurnace_1.set("argtypes", new String[]{"World", "double", "double", "double"});
        reflect_EntityMinecartFurnace_constructor_EntityMinecartFurnace_1.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityMinecartFurnace((World) params.getReflective("worldIn"), (double) params.getDouble("parDouble1"), (double) params.getDouble("parDouble2"), (double) params.getDouble("parDouble3"));
        });
        
        reflect_EntityMinecartFurnace_constructors.add(reflect_EntityMinecartFurnace_constructor_EntityMinecartFurnace_1);


        BaseData[] reflect_EntityMinecartFurnace_constructors_arr = new BaseData[reflect_EntityMinecartFurnace_constructors.size()];
        for (int i = 0; i < reflect_EntityMinecartFurnace_constructors_arr.length; i++) {
            reflect_EntityMinecartFurnace_constructors_arr[i] = reflect_EntityMinecartFurnace_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityMinecartFurnace_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityMinecartFurnace_method_onUpdate_0 = new ModData();
        reflect_EntityMinecartFurnace_method_onUpdate_0.set("methodName", "onUpdate");
        reflect_EntityMinecartFurnace_method_onUpdate_0.set("returnType", "void");
        reflect_EntityMinecartFurnace_method_onUpdate_0.set("static", false);
        reflect_EntityMinecartFurnace_method_onUpdate_0.set("argnames", new String[]{});
        reflect_EntityMinecartFurnace_method_onUpdate_0.set("argtypes", new String[]{});
        reflect_EntityMinecartFurnace_method_onUpdate_0.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityMinecartFurnace) params.getReflective("_self")).onUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityMinecartFurnace_methods.add(reflect_EntityMinecartFurnace_method_onUpdate_0);


        BaseData reflect_EntityMinecartFurnace_method_killMinecart_1 = new ModData();
        reflect_EntityMinecartFurnace_method_killMinecart_1.set("methodName", "killMinecart");
        reflect_EntityMinecartFurnace_method_killMinecart_1.set("returnType", "void");
        reflect_EntityMinecartFurnace_method_killMinecart_1.set("static", false);
        reflect_EntityMinecartFurnace_method_killMinecart_1.set("argnames", new String[]{"damagesource"});
        reflect_EntityMinecartFurnace_method_killMinecart_1.set("argtypes", new String[]{"DamageSource"});
        reflect_EntityMinecartFurnace_method_killMinecart_1.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityMinecartFurnace) params.getReflective("_self")).killMinecart((DamageSource) params.getReflective("damagesource"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityMinecartFurnace_methods.add(reflect_EntityMinecartFurnace_method_killMinecart_1);


        BaseData reflect_EntityMinecartFurnace_method_interactFirst_2 = new ModData();
        reflect_EntityMinecartFurnace_method_interactFirst_2.set("methodName", "interactFirst");
        reflect_EntityMinecartFurnace_method_interactFirst_2.set("returnType", "boolean");
        reflect_EntityMinecartFurnace_method_interactFirst_2.set("static", false);
        reflect_EntityMinecartFurnace_method_interactFirst_2.set("argnames", new String[]{"entityplayer"});
        reflect_EntityMinecartFurnace_method_interactFirst_2.set("argtypes", new String[]{"EntityPlayer"});
        reflect_EntityMinecartFurnace_method_interactFirst_2.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityMinecartFurnace) params.getReflective("_self")).interactFirst((EntityPlayer) params.getReflective("entityplayer"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityMinecartFurnace_methods.add(reflect_EntityMinecartFurnace_method_interactFirst_2);


        BaseData reflect_EntityMinecartFurnace_method_getDefaultDisplayTile_3 = new ModData();
        reflect_EntityMinecartFurnace_method_getDefaultDisplayTile_3.set("methodName", "getDefaultDisplayTile");
        reflect_EntityMinecartFurnace_method_getDefaultDisplayTile_3.set("returnType", "IBlockState");
        reflect_EntityMinecartFurnace_method_getDefaultDisplayTile_3.set("static", false);
        reflect_EntityMinecartFurnace_method_getDefaultDisplayTile_3.set("argnames", new String[]{});
        reflect_EntityMinecartFurnace_method_getDefaultDisplayTile_3.set("argtypes", new String[]{});
        reflect_EntityMinecartFurnace_method_getDefaultDisplayTile_3.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (IBlockState) ((EntityMinecartFurnace) params.getReflective("_self")).getDefaultDisplayTile();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityMinecartFurnace_methods.add(reflect_EntityMinecartFurnace_method_getDefaultDisplayTile_3);


        BaseData[] reflect_EntityMinecartFurnace_methods_arr = new BaseData[reflect_EntityMinecartFurnace_methods.size()];
        for (int i = 0; i < reflect_EntityMinecartFurnace_methods_arr.length; i++) {
            reflect_EntityMinecartFurnace_methods_arr[i] = reflect_EntityMinecartFurnace_methods.get(i);
        }

        reflect_EntityMinecartFurnace.set("constructors", reflect_EntityMinecartFurnace_constructors_arr);
        reflect_EntityMinecartFurnace.set("methods", reflect_EntityMinecartFurnace_methods_arr);
        reflect_EntityMinecartFurnace.set("className", "EntityMinecartFurnace");
        reflect_EntityMinecartFurnace.set("classId", "net.minecraft.entity.item.EntityMinecartFurnace");
        reflect_EntityMinecartFurnace.set("class", EntityMinecartFurnace.class);
        reflect_EntityMinecartFurnace.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityMinecartFurnace;
        });
        reflectProfiles.add(reflect_EntityMinecartFurnace);
    }


    //classdef for EntityMinecartHopper
    public static void reflect_EntityMinecartHopper_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityMinecartHopper = new ModData();

        ArrayList<BaseData> reflect_EntityMinecartHopper_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_EntityMinecartHopper_constructor_EntityMinecartHopper_0 = new ModData();
        reflect_EntityMinecartHopper_constructor_EntityMinecartHopper_0.set("returnType", "EntityMinecartHopper");
        reflect_EntityMinecartHopper_constructor_EntityMinecartHopper_0.set("argnames", new String[]{"worldIn"});
        reflect_EntityMinecartHopper_constructor_EntityMinecartHopper_0.set("argtypes", new String[]{"World"});
        reflect_EntityMinecartHopper_constructor_EntityMinecartHopper_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityMinecartHopper((World) params.getReflective("worldIn"));
        });
        
        reflect_EntityMinecartHopper_constructors.add(reflect_EntityMinecartHopper_constructor_EntityMinecartHopper_0);


        BaseData reflect_EntityMinecartHopper_constructor_EntityMinecartHopper_1 = new ModData();
        reflect_EntityMinecartHopper_constructor_EntityMinecartHopper_1.set("returnType", "EntityMinecartHopper");
        reflect_EntityMinecartHopper_constructor_EntityMinecartHopper_1.set("argnames", new String[]{"worldIn", "parDouble1", "parDouble2", "parDouble3"});
        reflect_EntityMinecartHopper_constructor_EntityMinecartHopper_1.set("argtypes", new String[]{"World", "double", "double", "double"});
        reflect_EntityMinecartHopper_constructor_EntityMinecartHopper_1.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityMinecartHopper((World) params.getReflective("worldIn"), (double) params.getDouble("parDouble1"), (double) params.getDouble("parDouble2"), (double) params.getDouble("parDouble3"));
        });
        
        reflect_EntityMinecartHopper_constructors.add(reflect_EntityMinecartHopper_constructor_EntityMinecartHopper_1);


        BaseData[] reflect_EntityMinecartHopper_constructors_arr = new BaseData[reflect_EntityMinecartHopper_constructors.size()];
        for (int i = 0; i < reflect_EntityMinecartHopper_constructors_arr.length; i++) {
            reflect_EntityMinecartHopper_constructors_arr[i] = reflect_EntityMinecartHopper_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityMinecartHopper_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityMinecartHopper_method_getDefaultDisplayTile_0 = new ModData();
        reflect_EntityMinecartHopper_method_getDefaultDisplayTile_0.set("methodName", "getDefaultDisplayTile");
        reflect_EntityMinecartHopper_method_getDefaultDisplayTile_0.set("returnType", "IBlockState");
        reflect_EntityMinecartHopper_method_getDefaultDisplayTile_0.set("static", false);
        reflect_EntityMinecartHopper_method_getDefaultDisplayTile_0.set("argnames", new String[]{});
        reflect_EntityMinecartHopper_method_getDefaultDisplayTile_0.set("argtypes", new String[]{});
        reflect_EntityMinecartHopper_method_getDefaultDisplayTile_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (IBlockState) ((EntityMinecartHopper) params.getReflective("_self")).getDefaultDisplayTile();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityMinecartHopper_methods.add(reflect_EntityMinecartHopper_method_getDefaultDisplayTile_0);


        BaseData reflect_EntityMinecartHopper_method_getDefaultDisplayTileOffset_1 = new ModData();
        reflect_EntityMinecartHopper_method_getDefaultDisplayTileOffset_1.set("methodName", "getDefaultDisplayTileOffset");
        reflect_EntityMinecartHopper_method_getDefaultDisplayTileOffset_1.set("returnType", "int");
        reflect_EntityMinecartHopper_method_getDefaultDisplayTileOffset_1.set("static", false);
        reflect_EntityMinecartHopper_method_getDefaultDisplayTileOffset_1.set("argnames", new String[]{});
        reflect_EntityMinecartHopper_method_getDefaultDisplayTileOffset_1.set("argtypes", new String[]{});
        reflect_EntityMinecartHopper_method_getDefaultDisplayTileOffset_1.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityMinecartHopper) params.getReflective("_self")).getDefaultDisplayTileOffset();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityMinecartHopper_methods.add(reflect_EntityMinecartHopper_method_getDefaultDisplayTileOffset_1);


        BaseData reflect_EntityMinecartHopper_method_getSizeInventory_2 = new ModData();
        reflect_EntityMinecartHopper_method_getSizeInventory_2.set("methodName", "getSizeInventory");
        reflect_EntityMinecartHopper_method_getSizeInventory_2.set("returnType", "int");
        reflect_EntityMinecartHopper_method_getSizeInventory_2.set("static", false);
        reflect_EntityMinecartHopper_method_getSizeInventory_2.set("argnames", new String[]{});
        reflect_EntityMinecartHopper_method_getSizeInventory_2.set("argtypes", new String[]{});
        reflect_EntityMinecartHopper_method_getSizeInventory_2.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityMinecartHopper) params.getReflective("_self")).getSizeInventory();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityMinecartHopper_methods.add(reflect_EntityMinecartHopper_method_getSizeInventory_2);


        BaseData reflect_EntityMinecartHopper_method_interactFirst_3 = new ModData();
        reflect_EntityMinecartHopper_method_interactFirst_3.set("methodName", "interactFirst");
        reflect_EntityMinecartHopper_method_interactFirst_3.set("returnType", "boolean");
        reflect_EntityMinecartHopper_method_interactFirst_3.set("static", false);
        reflect_EntityMinecartHopper_method_interactFirst_3.set("argnames", new String[]{"entityplayer"});
        reflect_EntityMinecartHopper_method_interactFirst_3.set("argtypes", new String[]{"EntityPlayer"});
        reflect_EntityMinecartHopper_method_interactFirst_3.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityMinecartHopper) params.getReflective("_self")).interactFirst((EntityPlayer) params.getReflective("entityplayer"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityMinecartHopper_methods.add(reflect_EntityMinecartHopper_method_interactFirst_3);


        BaseData reflect_EntityMinecartHopper_method_onActivatorRailPass_4 = new ModData();
        reflect_EntityMinecartHopper_method_onActivatorRailPass_4.set("methodName", "onActivatorRailPass");
        reflect_EntityMinecartHopper_method_onActivatorRailPass_4.set("returnType", "void");
        reflect_EntityMinecartHopper_method_onActivatorRailPass_4.set("static", false);
        reflect_EntityMinecartHopper_method_onActivatorRailPass_4.set("argnames", new String[]{"var1", "var2", "var3", "flag"});
        reflect_EntityMinecartHopper_method_onActivatorRailPass_4.set("argtypes", new String[]{"int", "int", "int", "boolean"});
        reflect_EntityMinecartHopper_method_onActivatorRailPass_4.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityMinecartHopper) params.getReflective("_self")).onActivatorRailPass((int) params.getInt("var1"), (int) params.getInt("var2"), (int) params.getInt("var3"), (boolean) params.getBoolean("flag"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityMinecartHopper_methods.add(reflect_EntityMinecartHopper_method_onActivatorRailPass_4);


        BaseData reflect_EntityMinecartHopper_method_getBlocked_5 = new ModData();
        reflect_EntityMinecartHopper_method_getBlocked_5.set("methodName", "getBlocked");
        reflect_EntityMinecartHopper_method_getBlocked_5.set("returnType", "boolean");
        reflect_EntityMinecartHopper_method_getBlocked_5.set("static", false);
        reflect_EntityMinecartHopper_method_getBlocked_5.set("argnames", new String[]{});
        reflect_EntityMinecartHopper_method_getBlocked_5.set("argtypes", new String[]{});
        reflect_EntityMinecartHopper_method_getBlocked_5.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityMinecartHopper) params.getReflective("_self")).getBlocked();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityMinecartHopper_methods.add(reflect_EntityMinecartHopper_method_getBlocked_5);


        BaseData reflect_EntityMinecartHopper_method_setBlocked_6 = new ModData();
        reflect_EntityMinecartHopper_method_setBlocked_6.set("methodName", "setBlocked");
        reflect_EntityMinecartHopper_method_setBlocked_6.set("returnType", "void");
        reflect_EntityMinecartHopper_method_setBlocked_6.set("static", false);
        reflect_EntityMinecartHopper_method_setBlocked_6.set("argnames", new String[]{"parFlag"});
        reflect_EntityMinecartHopper_method_setBlocked_6.set("argtypes", new String[]{"boolean"});
        reflect_EntityMinecartHopper_method_setBlocked_6.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityMinecartHopper) params.getReflective("_self")).setBlocked((boolean) params.getBoolean("parFlag"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityMinecartHopper_methods.add(reflect_EntityMinecartHopper_method_setBlocked_6);


        BaseData reflect_EntityMinecartHopper_method_getWorld_7 = new ModData();
        reflect_EntityMinecartHopper_method_getWorld_7.set("methodName", "getWorld");
        reflect_EntityMinecartHopper_method_getWorld_7.set("returnType", "World");
        reflect_EntityMinecartHopper_method_getWorld_7.set("static", false);
        reflect_EntityMinecartHopper_method_getWorld_7.set("argnames", new String[]{});
        reflect_EntityMinecartHopper_method_getWorld_7.set("argtypes", new String[]{});
        reflect_EntityMinecartHopper_method_getWorld_7.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (World) ((EntityMinecartHopper) params.getReflective("_self")).getWorld();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityMinecartHopper_methods.add(reflect_EntityMinecartHopper_method_getWorld_7);


        BaseData reflect_EntityMinecartHopper_method_getXPos_8 = new ModData();
        reflect_EntityMinecartHopper_method_getXPos_8.set("methodName", "getXPos");
        reflect_EntityMinecartHopper_method_getXPos_8.set("returnType", "double");
        reflect_EntityMinecartHopper_method_getXPos_8.set("static", false);
        reflect_EntityMinecartHopper_method_getXPos_8.set("argnames", new String[]{});
        reflect_EntityMinecartHopper_method_getXPos_8.set("argtypes", new String[]{});
        reflect_EntityMinecartHopper_method_getXPos_8.setCallbackDoubleWithDataArg("exec", (BaseData params) -> {
                try {
                    return (double) ((EntityMinecartHopper) params.getReflective("_self")).getXPos();
                } catch (Exception _exception_reflect_) {
                    return 0.0d;
                }
            });
            
        reflect_EntityMinecartHopper_methods.add(reflect_EntityMinecartHopper_method_getXPos_8);


        BaseData reflect_EntityMinecartHopper_method_getYPos_9 = new ModData();
        reflect_EntityMinecartHopper_method_getYPos_9.set("methodName", "getYPos");
        reflect_EntityMinecartHopper_method_getYPos_9.set("returnType", "double");
        reflect_EntityMinecartHopper_method_getYPos_9.set("static", false);
        reflect_EntityMinecartHopper_method_getYPos_9.set("argnames", new String[]{});
        reflect_EntityMinecartHopper_method_getYPos_9.set("argtypes", new String[]{});
        reflect_EntityMinecartHopper_method_getYPos_9.setCallbackDoubleWithDataArg("exec", (BaseData params) -> {
                try {
                    return (double) ((EntityMinecartHopper) params.getReflective("_self")).getYPos();
                } catch (Exception _exception_reflect_) {
                    return 0.0d;
                }
            });
            
        reflect_EntityMinecartHopper_methods.add(reflect_EntityMinecartHopper_method_getYPos_9);


        BaseData reflect_EntityMinecartHopper_method_getZPos_10 = new ModData();
        reflect_EntityMinecartHopper_method_getZPos_10.set("methodName", "getZPos");
        reflect_EntityMinecartHopper_method_getZPos_10.set("returnType", "double");
        reflect_EntityMinecartHopper_method_getZPos_10.set("static", false);
        reflect_EntityMinecartHopper_method_getZPos_10.set("argnames", new String[]{});
        reflect_EntityMinecartHopper_method_getZPos_10.set("argtypes", new String[]{});
        reflect_EntityMinecartHopper_method_getZPos_10.setCallbackDoubleWithDataArg("exec", (BaseData params) -> {
                try {
                    return (double) ((EntityMinecartHopper) params.getReflective("_self")).getZPos();
                } catch (Exception _exception_reflect_) {
                    return 0.0d;
                }
            });
            
        reflect_EntityMinecartHopper_methods.add(reflect_EntityMinecartHopper_method_getZPos_10);


        BaseData reflect_EntityMinecartHopper_method_onUpdate_11 = new ModData();
        reflect_EntityMinecartHopper_method_onUpdate_11.set("methodName", "onUpdate");
        reflect_EntityMinecartHopper_method_onUpdate_11.set("returnType", "void");
        reflect_EntityMinecartHopper_method_onUpdate_11.set("static", false);
        reflect_EntityMinecartHopper_method_onUpdate_11.set("argnames", new String[]{});
        reflect_EntityMinecartHopper_method_onUpdate_11.set("argtypes", new String[]{});
        reflect_EntityMinecartHopper_method_onUpdate_11.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityMinecartHopper) params.getReflective("_self")).onUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityMinecartHopper_methods.add(reflect_EntityMinecartHopper_method_onUpdate_11);


        BaseData reflect_EntityMinecartHopper_method_func_96112_aD_12 = new ModData();
        reflect_EntityMinecartHopper_method_func_96112_aD_12.set("methodName", "func_96112_aD");
        reflect_EntityMinecartHopper_method_func_96112_aD_12.set("returnType", "boolean");
        reflect_EntityMinecartHopper_method_func_96112_aD_12.set("static", false);
        reflect_EntityMinecartHopper_method_func_96112_aD_12.set("argnames", new String[]{});
        reflect_EntityMinecartHopper_method_func_96112_aD_12.set("argtypes", new String[]{});
        reflect_EntityMinecartHopper_method_func_96112_aD_12.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityMinecartHopper) params.getReflective("_self")).func_96112_aD();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityMinecartHopper_methods.add(reflect_EntityMinecartHopper_method_func_96112_aD_12);


        BaseData reflect_EntityMinecartHopper_method_killMinecart_13 = new ModData();
        reflect_EntityMinecartHopper_method_killMinecart_13.set("methodName", "killMinecart");
        reflect_EntityMinecartHopper_method_killMinecart_13.set("returnType", "void");
        reflect_EntityMinecartHopper_method_killMinecart_13.set("static", false);
        reflect_EntityMinecartHopper_method_killMinecart_13.set("argnames", new String[]{"damagesource"});
        reflect_EntityMinecartHopper_method_killMinecart_13.set("argtypes", new String[]{"DamageSource"});
        reflect_EntityMinecartHopper_method_killMinecart_13.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityMinecartHopper) params.getReflective("_self")).killMinecart((DamageSource) params.getReflective("damagesource"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityMinecartHopper_methods.add(reflect_EntityMinecartHopper_method_killMinecart_13);


        BaseData reflect_EntityMinecartHopper_method_setTransferTicker_14 = new ModData();
        reflect_EntityMinecartHopper_method_setTransferTicker_14.set("methodName", "setTransferTicker");
        reflect_EntityMinecartHopper_method_setTransferTicker_14.set("returnType", "void");
        reflect_EntityMinecartHopper_method_setTransferTicker_14.set("static", false);
        reflect_EntityMinecartHopper_method_setTransferTicker_14.set("argnames", new String[]{"parInt1"});
        reflect_EntityMinecartHopper_method_setTransferTicker_14.set("argtypes", new String[]{"int"});
        reflect_EntityMinecartHopper_method_setTransferTicker_14.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityMinecartHopper) params.getReflective("_self")).setTransferTicker((int) params.getInt("parInt1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityMinecartHopper_methods.add(reflect_EntityMinecartHopper_method_setTransferTicker_14);


        BaseData reflect_EntityMinecartHopper_method_canTransfer_15 = new ModData();
        reflect_EntityMinecartHopper_method_canTransfer_15.set("methodName", "canTransfer");
        reflect_EntityMinecartHopper_method_canTransfer_15.set("returnType", "boolean");
        reflect_EntityMinecartHopper_method_canTransfer_15.set("static", false);
        reflect_EntityMinecartHopper_method_canTransfer_15.set("argnames", new String[]{});
        reflect_EntityMinecartHopper_method_canTransfer_15.set("argtypes", new String[]{});
        reflect_EntityMinecartHopper_method_canTransfer_15.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityMinecartHopper) params.getReflective("_self")).canTransfer();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityMinecartHopper_methods.add(reflect_EntityMinecartHopper_method_canTransfer_15);


        BaseData reflect_EntityMinecartHopper_method_getGuiID_16 = new ModData();
        reflect_EntityMinecartHopper_method_getGuiID_16.set("methodName", "getGuiID");
        reflect_EntityMinecartHopper_method_getGuiID_16.set("returnType", "String");
        reflect_EntityMinecartHopper_method_getGuiID_16.set("static", false);
        reflect_EntityMinecartHopper_method_getGuiID_16.set("argnames", new String[]{});
        reflect_EntityMinecartHopper_method_getGuiID_16.set("argtypes", new String[]{});
        reflect_EntityMinecartHopper_method_getGuiID_16.setCallbackStringWithDataArg("exec", (BaseData params) -> {
                try {
                    return (String) ((EntityMinecartHopper) params.getReflective("_self")).getGuiID();
                } catch (Exception _exception_reflect_) {
                    return "";
                }
            });
            
        reflect_EntityMinecartHopper_methods.add(reflect_EntityMinecartHopper_method_getGuiID_16);


        BaseData reflect_EntityMinecartHopper_method_createContainer_17 = new ModData();
        reflect_EntityMinecartHopper_method_createContainer_17.set("methodName", "createContainer");
        reflect_EntityMinecartHopper_method_createContainer_17.set("returnType", "Container");
        reflect_EntityMinecartHopper_method_createContainer_17.set("static", false);
        reflect_EntityMinecartHopper_method_createContainer_17.set("argnames", new String[]{"inventoryplayer", "entityplayer"});
        reflect_EntityMinecartHopper_method_createContainer_17.set("argtypes", new String[]{"InventoryPlayer", "EntityPlayer"});
        reflect_EntityMinecartHopper_method_createContainer_17.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Container) ((EntityMinecartHopper) params.getReflective("_self")).createContainer((InventoryPlayer) params.getReflective("inventoryplayer"), (EntityPlayer) params.getReflective("entityplayer"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityMinecartHopper_methods.add(reflect_EntityMinecartHopper_method_createContainer_17);


        BaseData[] reflect_EntityMinecartHopper_methods_arr = new BaseData[reflect_EntityMinecartHopper_methods.size()];
        for (int i = 0; i < reflect_EntityMinecartHopper_methods_arr.length; i++) {
            reflect_EntityMinecartHopper_methods_arr[i] = reflect_EntityMinecartHopper_methods.get(i);
        }

        reflect_EntityMinecartHopper.set("constructors", reflect_EntityMinecartHopper_constructors_arr);
        reflect_EntityMinecartHopper.set("methods", reflect_EntityMinecartHopper_methods_arr);
        reflect_EntityMinecartHopper.set("className", "EntityMinecartHopper");
        reflect_EntityMinecartHopper.set("classId", "net.minecraft.entity.item.EntityMinecartHopper");
        reflect_EntityMinecartHopper.set("class", EntityMinecartHopper.class);
        reflect_EntityMinecartHopper.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityMinecartHopper;
        });
        reflectProfiles.add(reflect_EntityMinecartHopper);
    }


    //classdef for EntityMinecartTNT
    public static void reflect_EntityMinecartTNT_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityMinecartTNT = new ModData();

        ArrayList<BaseData> reflect_EntityMinecartTNT_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_EntityMinecartTNT_constructor_EntityMinecartTNT_0 = new ModData();
        reflect_EntityMinecartTNT_constructor_EntityMinecartTNT_0.set("returnType", "EntityMinecartTNT");
        reflect_EntityMinecartTNT_constructor_EntityMinecartTNT_0.set("argnames", new String[]{"worldIn"});
        reflect_EntityMinecartTNT_constructor_EntityMinecartTNT_0.set("argtypes", new String[]{"World"});
        reflect_EntityMinecartTNT_constructor_EntityMinecartTNT_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityMinecartTNT((World) params.getReflective("worldIn"));
        });
        
        reflect_EntityMinecartTNT_constructors.add(reflect_EntityMinecartTNT_constructor_EntityMinecartTNT_0);


        BaseData reflect_EntityMinecartTNT_constructor_EntityMinecartTNT_1 = new ModData();
        reflect_EntityMinecartTNT_constructor_EntityMinecartTNT_1.set("returnType", "EntityMinecartTNT");
        reflect_EntityMinecartTNT_constructor_EntityMinecartTNT_1.set("argnames", new String[]{"worldIn", "parDouble1", "parDouble2", "parDouble3"});
        reflect_EntityMinecartTNT_constructor_EntityMinecartTNT_1.set("argtypes", new String[]{"World", "double", "double", "double"});
        reflect_EntityMinecartTNT_constructor_EntityMinecartTNT_1.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityMinecartTNT((World) params.getReflective("worldIn"), (double) params.getDouble("parDouble1"), (double) params.getDouble("parDouble2"), (double) params.getDouble("parDouble3"));
        });
        
        reflect_EntityMinecartTNT_constructors.add(reflect_EntityMinecartTNT_constructor_EntityMinecartTNT_1);


        BaseData[] reflect_EntityMinecartTNT_constructors_arr = new BaseData[reflect_EntityMinecartTNT_constructors.size()];
        for (int i = 0; i < reflect_EntityMinecartTNT_constructors_arr.length; i++) {
            reflect_EntityMinecartTNT_constructors_arr[i] = reflect_EntityMinecartTNT_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityMinecartTNT_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityMinecartTNT_method_getDefaultDisplayTile_0 = new ModData();
        reflect_EntityMinecartTNT_method_getDefaultDisplayTile_0.set("methodName", "getDefaultDisplayTile");
        reflect_EntityMinecartTNT_method_getDefaultDisplayTile_0.set("returnType", "IBlockState");
        reflect_EntityMinecartTNT_method_getDefaultDisplayTile_0.set("static", false);
        reflect_EntityMinecartTNT_method_getDefaultDisplayTile_0.set("argnames", new String[]{});
        reflect_EntityMinecartTNT_method_getDefaultDisplayTile_0.set("argtypes", new String[]{});
        reflect_EntityMinecartTNT_method_getDefaultDisplayTile_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (IBlockState) ((EntityMinecartTNT) params.getReflective("_self")).getDefaultDisplayTile();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityMinecartTNT_methods.add(reflect_EntityMinecartTNT_method_getDefaultDisplayTile_0);


        BaseData reflect_EntityMinecartTNT_method_onUpdate_1 = new ModData();
        reflect_EntityMinecartTNT_method_onUpdate_1.set("methodName", "onUpdate");
        reflect_EntityMinecartTNT_method_onUpdate_1.set("returnType", "void");
        reflect_EntityMinecartTNT_method_onUpdate_1.set("static", false);
        reflect_EntityMinecartTNT_method_onUpdate_1.set("argnames", new String[]{});
        reflect_EntityMinecartTNT_method_onUpdate_1.set("argtypes", new String[]{});
        reflect_EntityMinecartTNT_method_onUpdate_1.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityMinecartTNT) params.getReflective("_self")).onUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityMinecartTNT_methods.add(reflect_EntityMinecartTNT_method_onUpdate_1);


        BaseData reflect_EntityMinecartTNT_method_attackEntityFrom_2 = new ModData();
        reflect_EntityMinecartTNT_method_attackEntityFrom_2.set("methodName", "attackEntityFrom");
        reflect_EntityMinecartTNT_method_attackEntityFrom_2.set("returnType", "boolean");
        reflect_EntityMinecartTNT_method_attackEntityFrom_2.set("static", false);
        reflect_EntityMinecartTNT_method_attackEntityFrom_2.set("argnames", new String[]{"damagesource", "f"});
        reflect_EntityMinecartTNT_method_attackEntityFrom_2.set("argtypes", new String[]{"DamageSource", "float"});
        reflect_EntityMinecartTNT_method_attackEntityFrom_2.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityMinecartTNT) params.getReflective("_self")).attackEntityFrom((DamageSource) params.getReflective("damagesource"), (float) params.getFloat("f"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityMinecartTNT_methods.add(reflect_EntityMinecartTNT_method_attackEntityFrom_2);


        BaseData reflect_EntityMinecartTNT_method_killMinecart_3 = new ModData();
        reflect_EntityMinecartTNT_method_killMinecart_3.set("methodName", "killMinecart");
        reflect_EntityMinecartTNT_method_killMinecart_3.set("returnType", "void");
        reflect_EntityMinecartTNT_method_killMinecart_3.set("static", false);
        reflect_EntityMinecartTNT_method_killMinecart_3.set("argnames", new String[]{"damagesource"});
        reflect_EntityMinecartTNT_method_killMinecart_3.set("argtypes", new String[]{"DamageSource"});
        reflect_EntityMinecartTNT_method_killMinecart_3.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityMinecartTNT) params.getReflective("_self")).killMinecart((DamageSource) params.getReflective("damagesource"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityMinecartTNT_methods.add(reflect_EntityMinecartTNT_method_killMinecart_3);


        BaseData reflect_EntityMinecartTNT_method_fall_4 = new ModData();
        reflect_EntityMinecartTNT_method_fall_4.set("methodName", "fall");
        reflect_EntityMinecartTNT_method_fall_4.set("returnType", "void");
        reflect_EntityMinecartTNT_method_fall_4.set("static", false);
        reflect_EntityMinecartTNT_method_fall_4.set("argnames", new String[]{"f", "f1"});
        reflect_EntityMinecartTNT_method_fall_4.set("argtypes", new String[]{"float", "float"});
        reflect_EntityMinecartTNT_method_fall_4.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityMinecartTNT) params.getReflective("_self")).fall((float) params.getFloat("f"), (float) params.getFloat("f1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityMinecartTNT_methods.add(reflect_EntityMinecartTNT_method_fall_4);


        BaseData reflect_EntityMinecartTNT_method_onActivatorRailPass_5 = new ModData();
        reflect_EntityMinecartTNT_method_onActivatorRailPass_5.set("methodName", "onActivatorRailPass");
        reflect_EntityMinecartTNT_method_onActivatorRailPass_5.set("returnType", "void");
        reflect_EntityMinecartTNT_method_onActivatorRailPass_5.set("static", false);
        reflect_EntityMinecartTNT_method_onActivatorRailPass_5.set("argnames", new String[]{"var1", "var2", "var3", "flag"});
        reflect_EntityMinecartTNT_method_onActivatorRailPass_5.set("argtypes", new String[]{"int", "int", "int", "boolean"});
        reflect_EntityMinecartTNT_method_onActivatorRailPass_5.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityMinecartTNT) params.getReflective("_self")).onActivatorRailPass((int) params.getInt("var1"), (int) params.getInt("var2"), (int) params.getInt("var3"), (boolean) params.getBoolean("flag"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityMinecartTNT_methods.add(reflect_EntityMinecartTNT_method_onActivatorRailPass_5);


        BaseData reflect_EntityMinecartTNT_method_handleStatusUpdate_6 = new ModData();
        reflect_EntityMinecartTNT_method_handleStatusUpdate_6.set("methodName", "handleStatusUpdate");
        reflect_EntityMinecartTNT_method_handleStatusUpdate_6.set("returnType", "void");
        reflect_EntityMinecartTNT_method_handleStatusUpdate_6.set("static", false);
        reflect_EntityMinecartTNT_method_handleStatusUpdate_6.set("argnames", new String[]{"b0"});
        reflect_EntityMinecartTNT_method_handleStatusUpdate_6.set("argtypes", new String[]{"byte"});
        reflect_EntityMinecartTNT_method_handleStatusUpdate_6.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityMinecartTNT) params.getReflective("_self")).handleStatusUpdate((byte) params.getByte("b0"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityMinecartTNT_methods.add(reflect_EntityMinecartTNT_method_handleStatusUpdate_6);


        BaseData reflect_EntityMinecartTNT_method_ignite_7 = new ModData();
        reflect_EntityMinecartTNT_method_ignite_7.set("methodName", "ignite");
        reflect_EntityMinecartTNT_method_ignite_7.set("returnType", "void");
        reflect_EntityMinecartTNT_method_ignite_7.set("static", false);
        reflect_EntityMinecartTNT_method_ignite_7.set("argnames", new String[]{});
        reflect_EntityMinecartTNT_method_ignite_7.set("argtypes", new String[]{});
        reflect_EntityMinecartTNT_method_ignite_7.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityMinecartTNT) params.getReflective("_self")).ignite();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityMinecartTNT_methods.add(reflect_EntityMinecartTNT_method_ignite_7);


        BaseData reflect_EntityMinecartTNT_method_getFuseTicks_8 = new ModData();
        reflect_EntityMinecartTNT_method_getFuseTicks_8.set("methodName", "getFuseTicks");
        reflect_EntityMinecartTNT_method_getFuseTicks_8.set("returnType", "int");
        reflect_EntityMinecartTNT_method_getFuseTicks_8.set("static", false);
        reflect_EntityMinecartTNT_method_getFuseTicks_8.set("argnames", new String[]{});
        reflect_EntityMinecartTNT_method_getFuseTicks_8.set("argtypes", new String[]{});
        reflect_EntityMinecartTNT_method_getFuseTicks_8.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityMinecartTNT) params.getReflective("_self")).getFuseTicks();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityMinecartTNT_methods.add(reflect_EntityMinecartTNT_method_getFuseTicks_8);


        BaseData reflect_EntityMinecartTNT_method_isIgnited_9 = new ModData();
        reflect_EntityMinecartTNT_method_isIgnited_9.set("methodName", "isIgnited");
        reflect_EntityMinecartTNT_method_isIgnited_9.set("returnType", "boolean");
        reflect_EntityMinecartTNT_method_isIgnited_9.set("static", false);
        reflect_EntityMinecartTNT_method_isIgnited_9.set("argnames", new String[]{});
        reflect_EntityMinecartTNT_method_isIgnited_9.set("argtypes", new String[]{});
        reflect_EntityMinecartTNT_method_isIgnited_9.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityMinecartTNT) params.getReflective("_self")).isIgnited();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityMinecartTNT_methods.add(reflect_EntityMinecartTNT_method_isIgnited_9);


        BaseData reflect_EntityMinecartTNT_method_getExplosionResistance_10 = new ModData();
        reflect_EntityMinecartTNT_method_getExplosionResistance_10.set("methodName", "getExplosionResistance");
        reflect_EntityMinecartTNT_method_getExplosionResistance_10.set("returnType", "float");
        reflect_EntityMinecartTNT_method_getExplosionResistance_10.set("static", false);
        reflect_EntityMinecartTNT_method_getExplosionResistance_10.set("argnames", new String[]{"explosion", "world", "blockpos", "iblockstate"});
        reflect_EntityMinecartTNT_method_getExplosionResistance_10.set("argtypes", new String[]{"Explosion", "World", "BlockPos", "IBlockState"});
        reflect_EntityMinecartTNT_method_getExplosionResistance_10.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityMinecartTNT) params.getReflective("_self")).getExplosionResistance((Explosion) params.getReflective("explosion"), (World) params.getReflective("world"), (BlockPos) params.getReflective("blockpos"), (IBlockState) params.getReflective("iblockstate"));
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityMinecartTNT_methods.add(reflect_EntityMinecartTNT_method_getExplosionResistance_10);


        BaseData[] reflect_EntityMinecartTNT_methods_arr = new BaseData[reflect_EntityMinecartTNT_methods.size()];
        for (int i = 0; i < reflect_EntityMinecartTNT_methods_arr.length; i++) {
            reflect_EntityMinecartTNT_methods_arr[i] = reflect_EntityMinecartTNT_methods.get(i);
        }

        reflect_EntityMinecartTNT.set("constructors", reflect_EntityMinecartTNT_constructors_arr);
        reflect_EntityMinecartTNT.set("methods", reflect_EntityMinecartTNT_methods_arr);
        reflect_EntityMinecartTNT.set("className", "EntityMinecartTNT");
        reflect_EntityMinecartTNT.set("classId", "net.minecraft.entity.item.EntityMinecartTNT");
        reflect_EntityMinecartTNT.set("class", EntityMinecartTNT.class);
        reflect_EntityMinecartTNT.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityMinecartTNT;
        });
        reflectProfiles.add(reflect_EntityMinecartTNT);
    }


    //classdef for EntityPainting
    public static void reflect_EntityPainting_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityPainting = new ModData();

        ArrayList<BaseData> reflect_EntityPainting_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_EntityPainting_constructor_EntityPainting_0 = new ModData();
        reflect_EntityPainting_constructor_EntityPainting_0.set("returnType", "EntityPainting");
        reflect_EntityPainting_constructor_EntityPainting_0.set("argnames", new String[]{"worldIn"});
        reflect_EntityPainting_constructor_EntityPainting_0.set("argtypes", new String[]{"World"});
        reflect_EntityPainting_constructor_EntityPainting_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityPainting((World) params.getReflective("worldIn"));
        });
        
        reflect_EntityPainting_constructors.add(reflect_EntityPainting_constructor_EntityPainting_0);


        BaseData reflect_EntityPainting_constructor_EntityPainting_1 = new ModData();
        reflect_EntityPainting_constructor_EntityPainting_1.set("returnType", "EntityPainting");
        reflect_EntityPainting_constructor_EntityPainting_1.set("argnames", new String[]{"worldIn", "pos", "facing"});
        reflect_EntityPainting_constructor_EntityPainting_1.set("argtypes", new String[]{"World", "BlockPos", "EnumFacing"});
        reflect_EntityPainting_constructor_EntityPainting_1.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityPainting((World) params.getReflective("worldIn"), (BlockPos) params.getReflective("pos"), (EnumFacing) params.getReflective("facing"));
        });
        
        reflect_EntityPainting_constructors.add(reflect_EntityPainting_constructor_EntityPainting_1);


        BaseData reflect_EntityPainting_constructor_EntityPainting_2 = new ModData();
        reflect_EntityPainting_constructor_EntityPainting_2.set("returnType", "EntityPainting");
        reflect_EntityPainting_constructor_EntityPainting_2.set("argnames", new String[]{"worldIn", "pos", "facing", "title"});
        reflect_EntityPainting_constructor_EntityPainting_2.set("argtypes", new String[]{"World", "BlockPos", "EnumFacing", "String"});
        reflect_EntityPainting_constructor_EntityPainting_2.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityPainting((World) params.getReflective("worldIn"), (BlockPos) params.getReflective("pos"), (EnumFacing) params.getReflective("facing"), (String) params.getString("title"));
        });
        
        reflect_EntityPainting_constructors.add(reflect_EntityPainting_constructor_EntityPainting_2);


        BaseData[] reflect_EntityPainting_constructors_arr = new BaseData[reflect_EntityPainting_constructors.size()];
        for (int i = 0; i < reflect_EntityPainting_constructors_arr.length; i++) {
            reflect_EntityPainting_constructors_arr[i] = reflect_EntityPainting_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityPainting_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityPainting_method_writeEntityToNBT_0 = new ModData();
        reflect_EntityPainting_method_writeEntityToNBT_0.set("methodName", "writeEntityToNBT");
        reflect_EntityPainting_method_writeEntityToNBT_0.set("returnType", "void");
        reflect_EntityPainting_method_writeEntityToNBT_0.set("static", false);
        reflect_EntityPainting_method_writeEntityToNBT_0.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityPainting_method_writeEntityToNBT_0.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityPainting_method_writeEntityToNBT_0.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPainting) params.getReflective("_self")).writeEntityToNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPainting_methods.add(reflect_EntityPainting_method_writeEntityToNBT_0);


        BaseData reflect_EntityPainting_method_readEntityFromNBT_1 = new ModData();
        reflect_EntityPainting_method_readEntityFromNBT_1.set("methodName", "readEntityFromNBT");
        reflect_EntityPainting_method_readEntityFromNBT_1.set("returnType", "void");
        reflect_EntityPainting_method_readEntityFromNBT_1.set("static", false);
        reflect_EntityPainting_method_readEntityFromNBT_1.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityPainting_method_readEntityFromNBT_1.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityPainting_method_readEntityFromNBT_1.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPainting) params.getReflective("_self")).readEntityFromNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPainting_methods.add(reflect_EntityPainting_method_readEntityFromNBT_1);


        BaseData reflect_EntityPainting_method_getWidthPixels_2 = new ModData();
        reflect_EntityPainting_method_getWidthPixels_2.set("methodName", "getWidthPixels");
        reflect_EntityPainting_method_getWidthPixels_2.set("returnType", "int");
        reflect_EntityPainting_method_getWidthPixels_2.set("static", false);
        reflect_EntityPainting_method_getWidthPixels_2.set("argnames", new String[]{});
        reflect_EntityPainting_method_getWidthPixels_2.set("argtypes", new String[]{});
        reflect_EntityPainting_method_getWidthPixels_2.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityPainting) params.getReflective("_self")).getWidthPixels();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityPainting_methods.add(reflect_EntityPainting_method_getWidthPixels_2);


        BaseData reflect_EntityPainting_method_getHeightPixels_3 = new ModData();
        reflect_EntityPainting_method_getHeightPixels_3.set("methodName", "getHeightPixels");
        reflect_EntityPainting_method_getHeightPixels_3.set("returnType", "int");
        reflect_EntityPainting_method_getHeightPixels_3.set("static", false);
        reflect_EntityPainting_method_getHeightPixels_3.set("argnames", new String[]{});
        reflect_EntityPainting_method_getHeightPixels_3.set("argtypes", new String[]{});
        reflect_EntityPainting_method_getHeightPixels_3.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityPainting) params.getReflective("_self")).getHeightPixels();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityPainting_methods.add(reflect_EntityPainting_method_getHeightPixels_3);


        BaseData reflect_EntityPainting_method_onBroken_4 = new ModData();
        reflect_EntityPainting_method_onBroken_4.set("methodName", "onBroken");
        reflect_EntityPainting_method_onBroken_4.set("returnType", "void");
        reflect_EntityPainting_method_onBroken_4.set("static", false);
        reflect_EntityPainting_method_onBroken_4.set("argnames", new String[]{"entity"});
        reflect_EntityPainting_method_onBroken_4.set("argtypes", new String[]{"Entity"});
        reflect_EntityPainting_method_onBroken_4.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPainting) params.getReflective("_self")).onBroken((Entity) params.getReflective("entity"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPainting_methods.add(reflect_EntityPainting_method_onBroken_4);


        BaseData reflect_EntityPainting_method_setLocationAndAngles_5 = new ModData();
        reflect_EntityPainting_method_setLocationAndAngles_5.set("methodName", "setLocationAndAngles");
        reflect_EntityPainting_method_setLocationAndAngles_5.set("returnType", "void");
        reflect_EntityPainting_method_setLocationAndAngles_5.set("static", false);
        reflect_EntityPainting_method_setLocationAndAngles_5.set("argnames", new String[]{"d0", "d1", "d2", "var7", "var8"});
        reflect_EntityPainting_method_setLocationAndAngles_5.set("argtypes", new String[]{"double", "double", "double", "float", "float"});
        reflect_EntityPainting_method_setLocationAndAngles_5.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPainting) params.getReflective("_self")).setLocationAndAngles((double) params.getDouble("d0"), (double) params.getDouble("d1"), (double) params.getDouble("d2"), (float) params.getFloat("var7"), (float) params.getFloat("var8"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPainting_methods.add(reflect_EntityPainting_method_setLocationAndAngles_5);


        BaseData[] reflect_EntityPainting_methods_arr = new BaseData[reflect_EntityPainting_methods.size()];
        for (int i = 0; i < reflect_EntityPainting_methods_arr.length; i++) {
            reflect_EntityPainting_methods_arr[i] = reflect_EntityPainting_methods.get(i);
        }

        reflect_EntityPainting.set("constructors", reflect_EntityPainting_constructors_arr);
        reflect_EntityPainting.set("methods", reflect_EntityPainting_methods_arr);
        reflect_EntityPainting.set("className", "EntityPainting");
        reflect_EntityPainting.set("classId", "net.minecraft.entity.item.EntityPainting");
        reflect_EntityPainting.set("class", EntityPainting.class);
        reflect_EntityPainting.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityPainting;
        });
        reflectProfiles.add(reflect_EntityPainting);
    }


    //classdef for EntityTNTPrimed
    public static void reflect_EntityTNTPrimed_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityTNTPrimed = new ModData();

        ArrayList<BaseData> reflect_EntityTNTPrimed_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_EntityTNTPrimed_constructor_EntityTNTPrimed_0 = new ModData();
        reflect_EntityTNTPrimed_constructor_EntityTNTPrimed_0.set("returnType", "EntityTNTPrimed");
        reflect_EntityTNTPrimed_constructor_EntityTNTPrimed_0.set("argnames", new String[]{"worldIn"});
        reflect_EntityTNTPrimed_constructor_EntityTNTPrimed_0.set("argtypes", new String[]{"World"});
        reflect_EntityTNTPrimed_constructor_EntityTNTPrimed_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityTNTPrimed((World) params.getReflective("worldIn"));
        });
        
        reflect_EntityTNTPrimed_constructors.add(reflect_EntityTNTPrimed_constructor_EntityTNTPrimed_0);


        BaseData[] reflect_EntityTNTPrimed_constructors_arr = new BaseData[reflect_EntityTNTPrimed_constructors.size()];
        for (int i = 0; i < reflect_EntityTNTPrimed_constructors_arr.length; i++) {
            reflect_EntityTNTPrimed_constructors_arr[i] = reflect_EntityTNTPrimed_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityTNTPrimed_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityTNTPrimed_method_canBeCollidedWith_0 = new ModData();
        reflect_EntityTNTPrimed_method_canBeCollidedWith_0.set("methodName", "canBeCollidedWith");
        reflect_EntityTNTPrimed_method_canBeCollidedWith_0.set("returnType", "boolean");
        reflect_EntityTNTPrimed_method_canBeCollidedWith_0.set("static", false);
        reflect_EntityTNTPrimed_method_canBeCollidedWith_0.set("argnames", new String[]{});
        reflect_EntityTNTPrimed_method_canBeCollidedWith_0.set("argtypes", new String[]{});
        reflect_EntityTNTPrimed_method_canBeCollidedWith_0.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityTNTPrimed) params.getReflective("_self")).canBeCollidedWith();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityTNTPrimed_methods.add(reflect_EntityTNTPrimed_method_canBeCollidedWith_0);


        BaseData reflect_EntityTNTPrimed_method_onUpdate_1 = new ModData();
        reflect_EntityTNTPrimed_method_onUpdate_1.set("methodName", "onUpdate");
        reflect_EntityTNTPrimed_method_onUpdate_1.set("returnType", "void");
        reflect_EntityTNTPrimed_method_onUpdate_1.set("static", false);
        reflect_EntityTNTPrimed_method_onUpdate_1.set("argnames", new String[]{});
        reflect_EntityTNTPrimed_method_onUpdate_1.set("argtypes", new String[]{});
        reflect_EntityTNTPrimed_method_onUpdate_1.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityTNTPrimed) params.getReflective("_self")).onUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityTNTPrimed_methods.add(reflect_EntityTNTPrimed_method_onUpdate_1);


        BaseData reflect_EntityTNTPrimed_method_getTntPlacedBy_2 = new ModData();
        reflect_EntityTNTPrimed_method_getTntPlacedBy_2.set("methodName", "getTntPlacedBy");
        reflect_EntityTNTPrimed_method_getTntPlacedBy_2.set("returnType", "EntityLivingBase");
        reflect_EntityTNTPrimed_method_getTntPlacedBy_2.set("static", false);
        reflect_EntityTNTPrimed_method_getTntPlacedBy_2.set("argnames", new String[]{});
        reflect_EntityTNTPrimed_method_getTntPlacedBy_2.set("argtypes", new String[]{});
        reflect_EntityTNTPrimed_method_getTntPlacedBy_2.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EntityLivingBase) ((EntityTNTPrimed) params.getReflective("_self")).getTntPlacedBy();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityTNTPrimed_methods.add(reflect_EntityTNTPrimed_method_getTntPlacedBy_2);


        BaseData reflect_EntityTNTPrimed_method_getEyeHeight_3 = new ModData();
        reflect_EntityTNTPrimed_method_getEyeHeight_3.set("methodName", "getEyeHeight");
        reflect_EntityTNTPrimed_method_getEyeHeight_3.set("returnType", "float");
        reflect_EntityTNTPrimed_method_getEyeHeight_3.set("static", false);
        reflect_EntityTNTPrimed_method_getEyeHeight_3.set("argnames", new String[]{});
        reflect_EntityTNTPrimed_method_getEyeHeight_3.set("argtypes", new String[]{});
        reflect_EntityTNTPrimed_method_getEyeHeight_3.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityTNTPrimed) params.getReflective("_self")).getEyeHeight();
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityTNTPrimed_methods.add(reflect_EntityTNTPrimed_method_getEyeHeight_3);


        BaseData[] reflect_EntityTNTPrimed_methods_arr = new BaseData[reflect_EntityTNTPrimed_methods.size()];
        for (int i = 0; i < reflect_EntityTNTPrimed_methods_arr.length; i++) {
            reflect_EntityTNTPrimed_methods_arr[i] = reflect_EntityTNTPrimed_methods.get(i);
        }

        reflect_EntityTNTPrimed.set("constructors", reflect_EntityTNTPrimed_constructors_arr);
        reflect_EntityTNTPrimed.set("methods", reflect_EntityTNTPrimed_methods_arr);
        reflect_EntityTNTPrimed.set("className", "EntityTNTPrimed");
        reflect_EntityTNTPrimed.set("classId", "net.minecraft.entity.item.EntityTNTPrimed");
        reflect_EntityTNTPrimed.set("class", EntityTNTPrimed.class);
        reflect_EntityTNTPrimed.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityTNTPrimed;
        });
        reflectProfiles.add(reflect_EntityTNTPrimed);
    }


    //classdef for EntityXPOrb
    public static void reflect_EntityXPOrb_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityXPOrb = new ModData();

        ArrayList<BaseData> reflect_EntityXPOrb_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_EntityXPOrb_constructor_EntityXPOrb_0 = new ModData();
        reflect_EntityXPOrb_constructor_EntityXPOrb_0.set("returnType", "EntityXPOrb");
        reflect_EntityXPOrb_constructor_EntityXPOrb_0.set("argnames", new String[]{"worldIn", "x", "y", "z", "expValue"});
        reflect_EntityXPOrb_constructor_EntityXPOrb_0.set("argtypes", new String[]{"World", "double", "double", "double", "int"});
        reflect_EntityXPOrb_constructor_EntityXPOrb_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityXPOrb((World) params.getReflective("worldIn"), (double) params.getDouble("x"), (double) params.getDouble("y"), (double) params.getDouble("z"), (int) params.getInt("expValue"));
        });
        
        reflect_EntityXPOrb_constructors.add(reflect_EntityXPOrb_constructor_EntityXPOrb_0);


        BaseData reflect_EntityXPOrb_constructor_EntityXPOrb_1 = new ModData();
        reflect_EntityXPOrb_constructor_EntityXPOrb_1.set("returnType", "EntityXPOrb");
        reflect_EntityXPOrb_constructor_EntityXPOrb_1.set("argnames", new String[]{"worldIn"});
        reflect_EntityXPOrb_constructor_EntityXPOrb_1.set("argtypes", new String[]{"World"});
        reflect_EntityXPOrb_constructor_EntityXPOrb_1.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityXPOrb((World) params.getReflective("worldIn"));
        });
        
        reflect_EntityXPOrb_constructors.add(reflect_EntityXPOrb_constructor_EntityXPOrb_1);


        BaseData[] reflect_EntityXPOrb_constructors_arr = new BaseData[reflect_EntityXPOrb_constructors.size()];
        for (int i = 0; i < reflect_EntityXPOrb_constructors_arr.length; i++) {
            reflect_EntityXPOrb_constructors_arr[i] = reflect_EntityXPOrb_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityXPOrb_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityXPOrb_method_getBrightnessForRender_0 = new ModData();
        reflect_EntityXPOrb_method_getBrightnessForRender_0.set("methodName", "getBrightnessForRender");
        reflect_EntityXPOrb_method_getBrightnessForRender_0.set("returnType", "int");
        reflect_EntityXPOrb_method_getBrightnessForRender_0.set("static", false);
        reflect_EntityXPOrb_method_getBrightnessForRender_0.set("argnames", new String[]{"f"});
        reflect_EntityXPOrb_method_getBrightnessForRender_0.set("argtypes", new String[]{"float"});
        reflect_EntityXPOrb_method_getBrightnessForRender_0.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityXPOrb) params.getReflective("_self")).getBrightnessForRender((float) params.getFloat("f"));
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityXPOrb_methods.add(reflect_EntityXPOrb_method_getBrightnessForRender_0);


        BaseData reflect_EntityXPOrb_method_onUpdate_1 = new ModData();
        reflect_EntityXPOrb_method_onUpdate_1.set("methodName", "onUpdate");
        reflect_EntityXPOrb_method_onUpdate_1.set("returnType", "void");
        reflect_EntityXPOrb_method_onUpdate_1.set("static", false);
        reflect_EntityXPOrb_method_onUpdate_1.set("argnames", new String[]{});
        reflect_EntityXPOrb_method_onUpdate_1.set("argtypes", new String[]{});
        reflect_EntityXPOrb_method_onUpdate_1.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityXPOrb) params.getReflective("_self")).onUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityXPOrb_methods.add(reflect_EntityXPOrb_method_onUpdate_1);


        BaseData reflect_EntityXPOrb_method_handleWaterMovement_2 = new ModData();
        reflect_EntityXPOrb_method_handleWaterMovement_2.set("methodName", "handleWaterMovement");
        reflect_EntityXPOrb_method_handleWaterMovement_2.set("returnType", "boolean");
        reflect_EntityXPOrb_method_handleWaterMovement_2.set("static", false);
        reflect_EntityXPOrb_method_handleWaterMovement_2.set("argnames", new String[]{});
        reflect_EntityXPOrb_method_handleWaterMovement_2.set("argtypes", new String[]{});
        reflect_EntityXPOrb_method_handleWaterMovement_2.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityXPOrb) params.getReflective("_self")).handleWaterMovement();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityXPOrb_methods.add(reflect_EntityXPOrb_method_handleWaterMovement_2);


        BaseData reflect_EntityXPOrb_method_attackEntityFrom_3 = new ModData();
        reflect_EntityXPOrb_method_attackEntityFrom_3.set("methodName", "attackEntityFrom");
        reflect_EntityXPOrb_method_attackEntityFrom_3.set("returnType", "boolean");
        reflect_EntityXPOrb_method_attackEntityFrom_3.set("static", false);
        reflect_EntityXPOrb_method_attackEntityFrom_3.set("argnames", new String[]{"damagesource", "f"});
        reflect_EntityXPOrb_method_attackEntityFrom_3.set("argtypes", new String[]{"DamageSource", "float"});
        reflect_EntityXPOrb_method_attackEntityFrom_3.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityXPOrb) params.getReflective("_self")).attackEntityFrom((DamageSource) params.getReflective("damagesource"), (float) params.getFloat("f"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityXPOrb_methods.add(reflect_EntityXPOrb_method_attackEntityFrom_3);


        BaseData reflect_EntityXPOrb_method_writeEntityToNBT_4 = new ModData();
        reflect_EntityXPOrb_method_writeEntityToNBT_4.set("methodName", "writeEntityToNBT");
        reflect_EntityXPOrb_method_writeEntityToNBT_4.set("returnType", "void");
        reflect_EntityXPOrb_method_writeEntityToNBT_4.set("static", false);
        reflect_EntityXPOrb_method_writeEntityToNBT_4.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityXPOrb_method_writeEntityToNBT_4.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityXPOrb_method_writeEntityToNBT_4.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityXPOrb) params.getReflective("_self")).writeEntityToNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityXPOrb_methods.add(reflect_EntityXPOrb_method_writeEntityToNBT_4);


        BaseData reflect_EntityXPOrb_method_readEntityFromNBT_5 = new ModData();
        reflect_EntityXPOrb_method_readEntityFromNBT_5.set("methodName", "readEntityFromNBT");
        reflect_EntityXPOrb_method_readEntityFromNBT_5.set("returnType", "void");
        reflect_EntityXPOrb_method_readEntityFromNBT_5.set("static", false);
        reflect_EntityXPOrb_method_readEntityFromNBT_5.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityXPOrb_method_readEntityFromNBT_5.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityXPOrb_method_readEntityFromNBT_5.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityXPOrb) params.getReflective("_self")).readEntityFromNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityXPOrb_methods.add(reflect_EntityXPOrb_method_readEntityFromNBT_5);


        BaseData reflect_EntityXPOrb_method_onCollideWithPlayer_6 = new ModData();
        reflect_EntityXPOrb_method_onCollideWithPlayer_6.set("methodName", "onCollideWithPlayer");
        reflect_EntityXPOrb_method_onCollideWithPlayer_6.set("returnType", "void");
        reflect_EntityXPOrb_method_onCollideWithPlayer_6.set("static", false);
        reflect_EntityXPOrb_method_onCollideWithPlayer_6.set("argnames", new String[]{"entityplayer"});
        reflect_EntityXPOrb_method_onCollideWithPlayer_6.set("argtypes", new String[]{"EntityPlayer"});
        reflect_EntityXPOrb_method_onCollideWithPlayer_6.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityXPOrb) params.getReflective("_self")).onCollideWithPlayer((EntityPlayer) params.getReflective("entityplayer"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityXPOrb_methods.add(reflect_EntityXPOrb_method_onCollideWithPlayer_6);


        BaseData reflect_EntityXPOrb_method_getXpValue_7 = new ModData();
        reflect_EntityXPOrb_method_getXpValue_7.set("methodName", "getXpValue");
        reflect_EntityXPOrb_method_getXpValue_7.set("returnType", "int");
        reflect_EntityXPOrb_method_getXpValue_7.set("static", false);
        reflect_EntityXPOrb_method_getXpValue_7.set("argnames", new String[]{});
        reflect_EntityXPOrb_method_getXpValue_7.set("argtypes", new String[]{});
        reflect_EntityXPOrb_method_getXpValue_7.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityXPOrb) params.getReflective("_self")).getXpValue();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityXPOrb_methods.add(reflect_EntityXPOrb_method_getXpValue_7);


        BaseData reflect_EntityXPOrb_method_getTextureByXP_8 = new ModData();
        reflect_EntityXPOrb_method_getTextureByXP_8.set("methodName", "getTextureByXP");
        reflect_EntityXPOrb_method_getTextureByXP_8.set("returnType", "int");
        reflect_EntityXPOrb_method_getTextureByXP_8.set("static", false);
        reflect_EntityXPOrb_method_getTextureByXP_8.set("argnames", new String[]{});
        reflect_EntityXPOrb_method_getTextureByXP_8.set("argtypes", new String[]{});
        reflect_EntityXPOrb_method_getTextureByXP_8.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityXPOrb) params.getReflective("_self")).getTextureByXP();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityXPOrb_methods.add(reflect_EntityXPOrb_method_getTextureByXP_8);


        BaseData reflect_EntityXPOrb_method_getXPSplit_9 = new ModData();
        reflect_EntityXPOrb_method_getXPSplit_9.set("methodName", "getXPSplit");
        reflect_EntityXPOrb_method_getXPSplit_9.set("returnType", "int");
        reflect_EntityXPOrb_method_getXPSplit_9.set("static", true);
        reflect_EntityXPOrb_method_getXPSplit_9.set("argnames", new String[]{"expValue"});
        reflect_EntityXPOrb_method_getXPSplit_9.set("argtypes", new String[]{"int"});
        reflect_EntityXPOrb_method_getXPSplit_9.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) EntityXPOrb.getXPSplit((int) params.getInt("expValue"));
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityXPOrb_methods.add(reflect_EntityXPOrb_method_getXPSplit_9);


        BaseData reflect_EntityXPOrb_method_canAttackWithItem_10 = new ModData();
        reflect_EntityXPOrb_method_canAttackWithItem_10.set("methodName", "canAttackWithItem");
        reflect_EntityXPOrb_method_canAttackWithItem_10.set("returnType", "boolean");
        reflect_EntityXPOrb_method_canAttackWithItem_10.set("static", false);
        reflect_EntityXPOrb_method_canAttackWithItem_10.set("argnames", new String[]{});
        reflect_EntityXPOrb_method_canAttackWithItem_10.set("argtypes", new String[]{});
        reflect_EntityXPOrb_method_canAttackWithItem_10.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityXPOrb) params.getReflective("_self")).canAttackWithItem();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityXPOrb_methods.add(reflect_EntityXPOrb_method_canAttackWithItem_10);


        BaseData[] reflect_EntityXPOrb_methods_arr = new BaseData[reflect_EntityXPOrb_methods.size()];
        for (int i = 0; i < reflect_EntityXPOrb_methods_arr.length; i++) {
            reflect_EntityXPOrb_methods_arr[i] = reflect_EntityXPOrb_methods.get(i);
        }

        reflect_EntityXPOrb.set("constructors", reflect_EntityXPOrb_constructors_arr);
        reflect_EntityXPOrb.set("methods", reflect_EntityXPOrb_methods_arr);
        reflect_EntityXPOrb.set("className", "EntityXPOrb");
        reflect_EntityXPOrb.set("classId", "net.minecraft.entity.item.EntityXPOrb");
        reflect_EntityXPOrb.set("class", EntityXPOrb.class);
        reflect_EntityXPOrb.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityXPOrb;
        });
        reflectProfiles.add(reflect_EntityXPOrb);
    }


    //classdef for EntityLightningBolt
    public static void reflect_EntityLightningBolt_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityLightningBolt = new ModData();

        ArrayList<BaseData> reflect_EntityLightningBolt_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_EntityLightningBolt_constructor_EntityLightningBolt_0 = new ModData();
        reflect_EntityLightningBolt_constructor_EntityLightningBolt_0.set("returnType", "EntityLightningBolt");
        reflect_EntityLightningBolt_constructor_EntityLightningBolt_0.set("argnames", new String[]{"worldIn", "posX", "posY", "posZ"});
        reflect_EntityLightningBolt_constructor_EntityLightningBolt_0.set("argtypes", new String[]{"World", "double", "double", "double"});
        reflect_EntityLightningBolt_constructor_EntityLightningBolt_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityLightningBolt((World) params.getReflective("worldIn"), (double) params.getDouble("posX"), (double) params.getDouble("posY"), (double) params.getDouble("posZ"));
        });
        
        reflect_EntityLightningBolt_constructors.add(reflect_EntityLightningBolt_constructor_EntityLightningBolt_0);


        BaseData[] reflect_EntityLightningBolt_constructors_arr = new BaseData[reflect_EntityLightningBolt_constructors.size()];
        for (int i = 0; i < reflect_EntityLightningBolt_constructors_arr.length; i++) {
            reflect_EntityLightningBolt_constructors_arr[i] = reflect_EntityLightningBolt_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityLightningBolt_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityLightningBolt_method_onUpdate_0 = new ModData();
        reflect_EntityLightningBolt_method_onUpdate_0.set("methodName", "onUpdate");
        reflect_EntityLightningBolt_method_onUpdate_0.set("returnType", "void");
        reflect_EntityLightningBolt_method_onUpdate_0.set("static", false);
        reflect_EntityLightningBolt_method_onUpdate_0.set("argnames", new String[]{});
        reflect_EntityLightningBolt_method_onUpdate_0.set("argtypes", new String[]{});
        reflect_EntityLightningBolt_method_onUpdate_0.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityLightningBolt) params.getReflective("_self")).onUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityLightningBolt_methods.add(reflect_EntityLightningBolt_method_onUpdate_0);


        BaseData[] reflect_EntityLightningBolt_methods_arr = new BaseData[reflect_EntityLightningBolt_methods.size()];
        for (int i = 0; i < reflect_EntityLightningBolt_methods_arr.length; i++) {
            reflect_EntityLightningBolt_methods_arr[i] = reflect_EntityLightningBolt_methods.get(i);
        }

        reflect_EntityLightningBolt.set("constructors", reflect_EntityLightningBolt_constructors_arr);
        reflect_EntityLightningBolt.set("methods", reflect_EntityLightningBolt_methods_arr);
        reflect_EntityLightningBolt.set("className", "EntityLightningBolt");
        reflect_EntityLightningBolt.set("classId", "net.minecraft.entity.effect.EntityLightningBolt");
        reflect_EntityLightningBolt.set("class", EntityLightningBolt.class);
        reflect_EntityLightningBolt.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityLightningBolt;
        });
        reflectProfiles.add(reflect_EntityLightningBolt);
    }


    //classdef for EntityDragon
    public static void reflect_EntityDragon_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityDragon = new ModData();

        ArrayList<BaseData> reflect_EntityDragon_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_EntityDragon_constructor_EntityDragon_0 = new ModData();
        reflect_EntityDragon_constructor_EntityDragon_0.set("returnType", "EntityDragon");
        reflect_EntityDragon_constructor_EntityDragon_0.set("argnames", new String[]{"worldIn"});
        reflect_EntityDragon_constructor_EntityDragon_0.set("argtypes", new String[]{"World"});
        reflect_EntityDragon_constructor_EntityDragon_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityDragon((World) params.getReflective("worldIn"));
        });
        
        reflect_EntityDragon_constructors.add(reflect_EntityDragon_constructor_EntityDragon_0);


        BaseData[] reflect_EntityDragon_constructors_arr = new BaseData[reflect_EntityDragon_constructors.size()];
        for (int i = 0; i < reflect_EntityDragon_constructors_arr.length; i++) {
            reflect_EntityDragon_constructors_arr[i] = reflect_EntityDragon_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityDragon_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityDragon_method_getMovementOffsets_0 = new ModData();
        reflect_EntityDragon_method_getMovementOffsets_0.set("methodName", "getMovementOffsets");
        reflect_EntityDragon_method_getMovementOffsets_0.set("returnType", "double[]");
        reflect_EntityDragon_method_getMovementOffsets_0.set("static", false);
        reflect_EntityDragon_method_getMovementOffsets_0.set("argnames", new String[]{"parInt1", "parFloat1"});
        reflect_EntityDragon_method_getMovementOffsets_0.set("argtypes", new String[]{"int", "float"});
        reflect_EntityDragon_method_getMovementOffsets_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (double[]) ((EntityDragon) params.getReflective("_self")).getMovementOffsets((int) params.getInt("parInt1"), (float) params.getFloat("parFloat1"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityDragon_methods.add(reflect_EntityDragon_method_getMovementOffsets_0);


        BaseData reflect_EntityDragon_method_onLivingUpdate_1 = new ModData();
        reflect_EntityDragon_method_onLivingUpdate_1.set("methodName", "onLivingUpdate");
        reflect_EntityDragon_method_onLivingUpdate_1.set("returnType", "void");
        reflect_EntityDragon_method_onLivingUpdate_1.set("static", false);
        reflect_EntityDragon_method_onLivingUpdate_1.set("argnames", new String[]{});
        reflect_EntityDragon_method_onLivingUpdate_1.set("argtypes", new String[]{});
        reflect_EntityDragon_method_onLivingUpdate_1.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityDragon) params.getReflective("_self")).onLivingUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityDragon_methods.add(reflect_EntityDragon_method_onLivingUpdate_1);


        BaseData reflect_EntityDragon_method_attackEntityFromPart_2 = new ModData();
        reflect_EntityDragon_method_attackEntityFromPart_2.set("methodName", "attackEntityFromPart");
        reflect_EntityDragon_method_attackEntityFromPart_2.set("returnType", "boolean");
        reflect_EntityDragon_method_attackEntityFromPart_2.set("static", false);
        reflect_EntityDragon_method_attackEntityFromPart_2.set("argnames", new String[]{"entitydragonpart", "damagesource", "f"});
        reflect_EntityDragon_method_attackEntityFromPart_2.set("argtypes", new String[]{"EntityDragonPart", "DamageSource", "float"});
        reflect_EntityDragon_method_attackEntityFromPart_2.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityDragon) params.getReflective("_self")).attackEntityFromPart((EntityDragonPart) params.getReflective("entitydragonpart"), (DamageSource) params.getReflective("damagesource"), (float) params.getFloat("f"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityDragon_methods.add(reflect_EntityDragon_method_attackEntityFromPart_2);


        BaseData reflect_EntityDragon_method_attackEntityFrom_3 = new ModData();
        reflect_EntityDragon_method_attackEntityFrom_3.set("methodName", "attackEntityFrom");
        reflect_EntityDragon_method_attackEntityFrom_3.set("returnType", "boolean");
        reflect_EntityDragon_method_attackEntityFrom_3.set("static", false);
        reflect_EntityDragon_method_attackEntityFrom_3.set("argnames", new String[]{"damagesource", "f"});
        reflect_EntityDragon_method_attackEntityFrom_3.set("argtypes", new String[]{"DamageSource", "float"});
        reflect_EntityDragon_method_attackEntityFrom_3.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityDragon) params.getReflective("_self")).attackEntityFrom((DamageSource) params.getReflective("damagesource"), (float) params.getFloat("f"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityDragon_methods.add(reflect_EntityDragon_method_attackEntityFrom_3);


        BaseData reflect_EntityDragon_method_onKillCommand_4 = new ModData();
        reflect_EntityDragon_method_onKillCommand_4.set("methodName", "onKillCommand");
        reflect_EntityDragon_method_onKillCommand_4.set("returnType", "void");
        reflect_EntityDragon_method_onKillCommand_4.set("static", false);
        reflect_EntityDragon_method_onKillCommand_4.set("argnames", new String[]{});
        reflect_EntityDragon_method_onKillCommand_4.set("argtypes", new String[]{});
        reflect_EntityDragon_method_onKillCommand_4.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityDragon) params.getReflective("_self")).onKillCommand();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityDragon_methods.add(reflect_EntityDragon_method_onKillCommand_4);


        BaseData reflect_EntityDragon_method_getParts_5 = new ModData();
        reflect_EntityDragon_method_getParts_5.set("methodName", "getParts");
        reflect_EntityDragon_method_getParts_5.set("returnType", "Entity[]");
        reflect_EntityDragon_method_getParts_5.set("static", false);
        reflect_EntityDragon_method_getParts_5.set("argnames", new String[]{});
        reflect_EntityDragon_method_getParts_5.set("argtypes", new String[]{});
        reflect_EntityDragon_method_getParts_5.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Entity[]) ((EntityDragon) params.getReflective("_self")).getParts();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityDragon_methods.add(reflect_EntityDragon_method_getParts_5);


        BaseData reflect_EntityDragon_method_canBeCollidedWith_6 = new ModData();
        reflect_EntityDragon_method_canBeCollidedWith_6.set("methodName", "canBeCollidedWith");
        reflect_EntityDragon_method_canBeCollidedWith_6.set("returnType", "boolean");
        reflect_EntityDragon_method_canBeCollidedWith_6.set("static", false);
        reflect_EntityDragon_method_canBeCollidedWith_6.set("argnames", new String[]{});
        reflect_EntityDragon_method_canBeCollidedWith_6.set("argtypes", new String[]{});
        reflect_EntityDragon_method_canBeCollidedWith_6.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityDragon) params.getReflective("_self")).canBeCollidedWith();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityDragon_methods.add(reflect_EntityDragon_method_canBeCollidedWith_6);


        BaseData reflect_EntityDragon_method_getWorld_7 = new ModData();
        reflect_EntityDragon_method_getWorld_7.set("methodName", "getWorld");
        reflect_EntityDragon_method_getWorld_7.set("returnType", "World");
        reflect_EntityDragon_method_getWorld_7.set("static", false);
        reflect_EntityDragon_method_getWorld_7.set("argnames", new String[]{});
        reflect_EntityDragon_method_getWorld_7.set("argtypes", new String[]{});
        reflect_EntityDragon_method_getWorld_7.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (World) ((EntityDragon) params.getReflective("_self")).getWorld();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityDragon_methods.add(reflect_EntityDragon_method_getWorld_7);


        BaseData[] reflect_EntityDragon_methods_arr = new BaseData[reflect_EntityDragon_methods.size()];
        for (int i = 0; i < reflect_EntityDragon_methods_arr.length; i++) {
            reflect_EntityDragon_methods_arr[i] = reflect_EntityDragon_methods.get(i);
        }

        reflect_EntityDragon.set("constructors", reflect_EntityDragon_constructors_arr);
        reflect_EntityDragon.set("methods", reflect_EntityDragon_methods_arr);
        reflect_EntityDragon.set("className", "EntityDragon");
        reflect_EntityDragon.set("classId", "net.minecraft.entity.boss.EntityDragon");
        reflect_EntityDragon.set("class", EntityDragon.class);
        reflect_EntityDragon.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityDragon;
        });
        reflectProfiles.add(reflect_EntityDragon);
    }


    //classdef for EntityWither
    public static void reflect_EntityWither_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityWither = new ModData();

        ArrayList<BaseData> reflect_EntityWither_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_EntityWither_constructor_EntityWither_0 = new ModData();
        reflect_EntityWither_constructor_EntityWither_0.set("returnType", "EntityWither");
        reflect_EntityWither_constructor_EntityWither_0.set("argnames", new String[]{"worldIn"});
        reflect_EntityWither_constructor_EntityWither_0.set("argtypes", new String[]{"World"});
        reflect_EntityWither_constructor_EntityWither_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityWither((World) params.getReflective("worldIn"));
        });
        
        reflect_EntityWither_constructors.add(reflect_EntityWither_constructor_EntityWither_0);


        BaseData[] reflect_EntityWither_constructors_arr = new BaseData[reflect_EntityWither_constructors.size()];
        for (int i = 0; i < reflect_EntityWither_constructors_arr.length; i++) {
            reflect_EntityWither_constructors_arr[i] = reflect_EntityWither_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityWither_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityWither_method_writeEntityToNBT_0 = new ModData();
        reflect_EntityWither_method_writeEntityToNBT_0.set("methodName", "writeEntityToNBT");
        reflect_EntityWither_method_writeEntityToNBT_0.set("returnType", "void");
        reflect_EntityWither_method_writeEntityToNBT_0.set("static", false);
        reflect_EntityWither_method_writeEntityToNBT_0.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityWither_method_writeEntityToNBT_0.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityWither_method_writeEntityToNBT_0.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityWither) params.getReflective("_self")).writeEntityToNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityWither_methods.add(reflect_EntityWither_method_writeEntityToNBT_0);


        BaseData reflect_EntityWither_method_readEntityFromNBT_1 = new ModData();
        reflect_EntityWither_method_readEntityFromNBT_1.set("methodName", "readEntityFromNBT");
        reflect_EntityWither_method_readEntityFromNBT_1.set("returnType", "void");
        reflect_EntityWither_method_readEntityFromNBT_1.set("static", false);
        reflect_EntityWither_method_readEntityFromNBT_1.set("argnames", new String[]{"nbttagcompound"});
        reflect_EntityWither_method_readEntityFromNBT_1.set("argtypes", new String[]{"NBTTagCompound"});
        reflect_EntityWither_method_readEntityFromNBT_1.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityWither) params.getReflective("_self")).readEntityFromNBT((NBTTagCompound) params.getReflective("nbttagcompound"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityWither_methods.add(reflect_EntityWither_method_readEntityFromNBT_1);


        BaseData reflect_EntityWither_method_onLivingUpdate_2 = new ModData();
        reflect_EntityWither_method_onLivingUpdate_2.set("methodName", "onLivingUpdate");
        reflect_EntityWither_method_onLivingUpdate_2.set("returnType", "void");
        reflect_EntityWither_method_onLivingUpdate_2.set("static", false);
        reflect_EntityWither_method_onLivingUpdate_2.set("argnames", new String[]{});
        reflect_EntityWither_method_onLivingUpdate_2.set("argtypes", new String[]{});
        reflect_EntityWither_method_onLivingUpdate_2.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityWither) params.getReflective("_self")).onLivingUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityWither_methods.add(reflect_EntityWither_method_onLivingUpdate_2);


        BaseData reflect_EntityWither_method_func_181033_a_3 = new ModData();
        reflect_EntityWither_method_func_181033_a_3.set("methodName", "func_181033_a");
        reflect_EntityWither_method_func_181033_a_3.set("returnType", "boolean");
        reflect_EntityWither_method_func_181033_a_3.set("static", true);
        reflect_EntityWither_method_func_181033_a_3.set("argnames", new String[]{"parBlock"});
        reflect_EntityWither_method_func_181033_a_3.set("argtypes", new String[]{"Block"});
        reflect_EntityWither_method_func_181033_a_3.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) EntityWither.func_181033_a((Block) params.getReflective("parBlock"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityWither_methods.add(reflect_EntityWither_method_func_181033_a_3);


        BaseData reflect_EntityWither_method_func_82206_m_4 = new ModData();
        reflect_EntityWither_method_func_82206_m_4.set("methodName", "func_82206_m");
        reflect_EntityWither_method_func_82206_m_4.set("returnType", "void");
        reflect_EntityWither_method_func_82206_m_4.set("static", false);
        reflect_EntityWither_method_func_82206_m_4.set("argnames", new String[]{});
        reflect_EntityWither_method_func_82206_m_4.set("argtypes", new String[]{});
        reflect_EntityWither_method_func_82206_m_4.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityWither) params.getReflective("_self")).func_82206_m();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityWither_methods.add(reflect_EntityWither_method_func_82206_m_4);


        BaseData reflect_EntityWither_method_setInWeb_5 = new ModData();
        reflect_EntityWither_method_setInWeb_5.set("methodName", "setInWeb");
        reflect_EntityWither_method_setInWeb_5.set("returnType", "void");
        reflect_EntityWither_method_setInWeb_5.set("static", false);
        reflect_EntityWither_method_setInWeb_5.set("argnames", new String[]{});
        reflect_EntityWither_method_setInWeb_5.set("argtypes", new String[]{});
        reflect_EntityWither_method_setInWeb_5.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityWither) params.getReflective("_self")).setInWeb();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityWither_methods.add(reflect_EntityWither_method_setInWeb_5);


        BaseData reflect_EntityWither_method_getTotalArmorValue_6 = new ModData();
        reflect_EntityWither_method_getTotalArmorValue_6.set("methodName", "getTotalArmorValue");
        reflect_EntityWither_method_getTotalArmorValue_6.set("returnType", "int");
        reflect_EntityWither_method_getTotalArmorValue_6.set("static", false);
        reflect_EntityWither_method_getTotalArmorValue_6.set("argnames", new String[]{});
        reflect_EntityWither_method_getTotalArmorValue_6.set("argtypes", new String[]{});
        reflect_EntityWither_method_getTotalArmorValue_6.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityWither) params.getReflective("_self")).getTotalArmorValue();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityWither_methods.add(reflect_EntityWither_method_getTotalArmorValue_6);


        BaseData reflect_EntityWither_method_attackEntityWithRangedAttack_7 = new ModData();
        reflect_EntityWither_method_attackEntityWithRangedAttack_7.set("methodName", "attackEntityWithRangedAttack");
        reflect_EntityWither_method_attackEntityWithRangedAttack_7.set("returnType", "void");
        reflect_EntityWither_method_attackEntityWithRangedAttack_7.set("static", false);
        reflect_EntityWither_method_attackEntityWithRangedAttack_7.set("argnames", new String[]{"entitylivingbase", "var2"});
        reflect_EntityWither_method_attackEntityWithRangedAttack_7.set("argtypes", new String[]{"EntityLivingBase", "float"});
        reflect_EntityWither_method_attackEntityWithRangedAttack_7.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityWither) params.getReflective("_self")).attackEntityWithRangedAttack((EntityLivingBase) params.getReflective("entitylivingbase"), (float) params.getFloat("var2"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityWither_methods.add(reflect_EntityWither_method_attackEntityWithRangedAttack_7);


        BaseData reflect_EntityWither_method_attackEntityFrom_8 = new ModData();
        reflect_EntityWither_method_attackEntityFrom_8.set("methodName", "attackEntityFrom");
        reflect_EntityWither_method_attackEntityFrom_8.set("returnType", "boolean");
        reflect_EntityWither_method_attackEntityFrom_8.set("static", false);
        reflect_EntityWither_method_attackEntityFrom_8.set("argnames", new String[]{"damagesource", "f"});
        reflect_EntityWither_method_attackEntityFrom_8.set("argtypes", new String[]{"DamageSource", "float"});
        reflect_EntityWither_method_attackEntityFrom_8.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityWither) params.getReflective("_self")).attackEntityFrom((DamageSource) params.getReflective("damagesource"), (float) params.getFloat("f"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityWither_methods.add(reflect_EntityWither_method_attackEntityFrom_8);


        BaseData reflect_EntityWither_method_getBrightnessForRender_9 = new ModData();
        reflect_EntityWither_method_getBrightnessForRender_9.set("methodName", "getBrightnessForRender");
        reflect_EntityWither_method_getBrightnessForRender_9.set("returnType", "int");
        reflect_EntityWither_method_getBrightnessForRender_9.set("static", false);
        reflect_EntityWither_method_getBrightnessForRender_9.set("argnames", new String[]{"var1"});
        reflect_EntityWither_method_getBrightnessForRender_9.set("argtypes", new String[]{"float"});
        reflect_EntityWither_method_getBrightnessForRender_9.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityWither) params.getReflective("_self")).getBrightnessForRender((float) params.getFloat("var1"));
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityWither_methods.add(reflect_EntityWither_method_getBrightnessForRender_9);


        BaseData reflect_EntityWither_method_fall_10 = new ModData();
        reflect_EntityWither_method_fall_10.set("methodName", "fall");
        reflect_EntityWither_method_fall_10.set("returnType", "void");
        reflect_EntityWither_method_fall_10.set("static", false);
        reflect_EntityWither_method_fall_10.set("argnames", new String[]{"var1", "var2"});
        reflect_EntityWither_method_fall_10.set("argtypes", new String[]{"float", "float"});
        reflect_EntityWither_method_fall_10.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityWither) params.getReflective("_self")).fall((float) params.getFloat("var1"), (float) params.getFloat("var2"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityWither_methods.add(reflect_EntityWither_method_fall_10);


        BaseData reflect_EntityWither_method_addPotionEffect_11 = new ModData();
        reflect_EntityWither_method_addPotionEffect_11.set("methodName", "addPotionEffect");
        reflect_EntityWither_method_addPotionEffect_11.set("returnType", "void");
        reflect_EntityWither_method_addPotionEffect_11.set("static", false);
        reflect_EntityWither_method_addPotionEffect_11.set("argnames", new String[]{"var1"});
        reflect_EntityWither_method_addPotionEffect_11.set("argtypes", new String[]{"PotionEffect"});
        reflect_EntityWither_method_addPotionEffect_11.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityWither) params.getReflective("_self")).addPotionEffect((PotionEffect) params.getReflective("var1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityWither_methods.add(reflect_EntityWither_method_addPotionEffect_11);


        BaseData reflect_EntityWither_method_func_82207_a_12 = new ModData();
        reflect_EntityWither_method_func_82207_a_12.set("methodName", "func_82207_a");
        reflect_EntityWither_method_func_82207_a_12.set("returnType", "float");
        reflect_EntityWither_method_func_82207_a_12.set("static", false);
        reflect_EntityWither_method_func_82207_a_12.set("argnames", new String[]{"parInt1"});
        reflect_EntityWither_method_func_82207_a_12.set("argtypes", new String[]{"int"});
        reflect_EntityWither_method_func_82207_a_12.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityWither) params.getReflective("_self")).func_82207_a((int) params.getInt("parInt1"));
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityWither_methods.add(reflect_EntityWither_method_func_82207_a_12);


        BaseData reflect_EntityWither_method_func_82210_r_13 = new ModData();
        reflect_EntityWither_method_func_82210_r_13.set("methodName", "func_82210_r");
        reflect_EntityWither_method_func_82210_r_13.set("returnType", "float");
        reflect_EntityWither_method_func_82210_r_13.set("static", false);
        reflect_EntityWither_method_func_82210_r_13.set("argnames", new String[]{"parInt1"});
        reflect_EntityWither_method_func_82210_r_13.set("argtypes", new String[]{"int"});
        reflect_EntityWither_method_func_82210_r_13.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityWither) params.getReflective("_self")).func_82210_r((int) params.getInt("parInt1"));
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityWither_methods.add(reflect_EntityWither_method_func_82210_r_13);


        BaseData reflect_EntityWither_method_getInvulTime_14 = new ModData();
        reflect_EntityWither_method_getInvulTime_14.set("methodName", "getInvulTime");
        reflect_EntityWither_method_getInvulTime_14.set("returnType", "int");
        reflect_EntityWither_method_getInvulTime_14.set("static", false);
        reflect_EntityWither_method_getInvulTime_14.set("argnames", new String[]{});
        reflect_EntityWither_method_getInvulTime_14.set("argtypes", new String[]{});
        reflect_EntityWither_method_getInvulTime_14.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityWither) params.getReflective("_self")).getInvulTime();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityWither_methods.add(reflect_EntityWither_method_getInvulTime_14);


        BaseData reflect_EntityWither_method_setInvulTime_15 = new ModData();
        reflect_EntityWither_method_setInvulTime_15.set("methodName", "setInvulTime");
        reflect_EntityWither_method_setInvulTime_15.set("returnType", "void");
        reflect_EntityWither_method_setInvulTime_15.set("static", false);
        reflect_EntityWither_method_setInvulTime_15.set("argnames", new String[]{"parInt1"});
        reflect_EntityWither_method_setInvulTime_15.set("argtypes", new String[]{"int"});
        reflect_EntityWither_method_setInvulTime_15.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityWither) params.getReflective("_self")).setInvulTime((int) params.getInt("parInt1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityWither_methods.add(reflect_EntityWither_method_setInvulTime_15);


        BaseData reflect_EntityWither_method_getWatchedTargetId_16 = new ModData();
        reflect_EntityWither_method_getWatchedTargetId_16.set("methodName", "getWatchedTargetId");
        reflect_EntityWither_method_getWatchedTargetId_16.set("returnType", "int");
        reflect_EntityWither_method_getWatchedTargetId_16.set("static", false);
        reflect_EntityWither_method_getWatchedTargetId_16.set("argnames", new String[]{"parInt1"});
        reflect_EntityWither_method_getWatchedTargetId_16.set("argtypes", new String[]{"int"});
        reflect_EntityWither_method_getWatchedTargetId_16.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EntityWither) params.getReflective("_self")).getWatchedTargetId((int) params.getInt("parInt1"));
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EntityWither_methods.add(reflect_EntityWither_method_getWatchedTargetId_16);


        BaseData reflect_EntityWither_method_updateWatchedTargetId_17 = new ModData();
        reflect_EntityWither_method_updateWatchedTargetId_17.set("methodName", "updateWatchedTargetId");
        reflect_EntityWither_method_updateWatchedTargetId_17.set("returnType", "void");
        reflect_EntityWither_method_updateWatchedTargetId_17.set("static", false);
        reflect_EntityWither_method_updateWatchedTargetId_17.set("argnames", new String[]{"targetOffset", "newId"});
        reflect_EntityWither_method_updateWatchedTargetId_17.set("argtypes", new String[]{"int", "int"});
        reflect_EntityWither_method_updateWatchedTargetId_17.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityWither) params.getReflective("_self")).updateWatchedTargetId((int) params.getInt("targetOffset"), (int) params.getInt("newId"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityWither_methods.add(reflect_EntityWither_method_updateWatchedTargetId_17);


        BaseData reflect_EntityWither_method_isArmored_18 = new ModData();
        reflect_EntityWither_method_isArmored_18.set("methodName", "isArmored");
        reflect_EntityWither_method_isArmored_18.set("returnType", "boolean");
        reflect_EntityWither_method_isArmored_18.set("static", false);
        reflect_EntityWither_method_isArmored_18.set("argnames", new String[]{});
        reflect_EntityWither_method_isArmored_18.set("argtypes", new String[]{});
        reflect_EntityWither_method_isArmored_18.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityWither) params.getReflective("_self")).isArmored();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityWither_methods.add(reflect_EntityWither_method_isArmored_18);


        BaseData reflect_EntityWither_method_getCreatureAttribute_19 = new ModData();
        reflect_EntityWither_method_getCreatureAttribute_19.set("methodName", "getCreatureAttribute");
        reflect_EntityWither_method_getCreatureAttribute_19.set("returnType", "EnumCreatureAttribute");
        reflect_EntityWither_method_getCreatureAttribute_19.set("static", false);
        reflect_EntityWither_method_getCreatureAttribute_19.set("argnames", new String[]{});
        reflect_EntityWither_method_getCreatureAttribute_19.set("argtypes", new String[]{});
        reflect_EntityWither_method_getCreatureAttribute_19.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EnumCreatureAttribute) ((EntityWither) params.getReflective("_self")).getCreatureAttribute();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityWither_methods.add(reflect_EntityWither_method_getCreatureAttribute_19);


        BaseData reflect_EntityWither_method_mountEntity_20 = new ModData();
        reflect_EntityWither_method_mountEntity_20.set("methodName", "mountEntity");
        reflect_EntityWither_method_mountEntity_20.set("returnType", "void");
        reflect_EntityWither_method_mountEntity_20.set("static", false);
        reflect_EntityWither_method_mountEntity_20.set("argnames", new String[]{"var1"});
        reflect_EntityWither_method_mountEntity_20.set("argtypes", new String[]{"Entity"});
        reflect_EntityWither_method_mountEntity_20.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityWither) params.getReflective("_self")).mountEntity((Entity) params.getReflective("var1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityWither_methods.add(reflect_EntityWither_method_mountEntity_20);


        BaseData[] reflect_EntityWither_methods_arr = new BaseData[reflect_EntityWither_methods.size()];
        for (int i = 0; i < reflect_EntityWither_methods_arr.length; i++) {
            reflect_EntityWither_methods_arr[i] = reflect_EntityWither_methods.get(i);
        }

        reflect_EntityWither.set("constructors", reflect_EntityWither_constructors_arr);
        reflect_EntityWither.set("methods", reflect_EntityWither_methods_arr);
        reflect_EntityWither.set("className", "EntityWither");
        reflect_EntityWither.set("classId", "net.minecraft.entity.boss.EntityWither");
        reflect_EntityWither.set("class", EntityWither.class);
        reflect_EntityWither.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityWither;
        });
        reflectProfiles.add(reflect_EntityWither);
    }


    //classdef for Minecraft
    public static void reflect_Minecraft_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_Minecraft = new ModData();

        ArrayList<BaseData> reflect_Minecraft_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_Minecraft_constructor_Minecraft_0 = new ModData();
        reflect_Minecraft_constructor_Minecraft_0.set("returnType", "Minecraft");
        reflect_Minecraft_constructor_Minecraft_0.set("argnames", new String[]{"gameConfig"});
        reflect_Minecraft_constructor_Minecraft_0.set("argtypes", new String[]{"GameConfiguration"});
        reflect_Minecraft_constructor_Minecraft_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new Minecraft((GameConfiguration) params.getReflective("gameConfig"));
        });
        
        reflect_Minecraft_constructors.add(reflect_Minecraft_constructor_Minecraft_0);


        BaseData[] reflect_Minecraft_constructors_arr = new BaseData[reflect_Minecraft_constructors.size()];
        for (int i = 0; i < reflect_Minecraft_constructors_arr.length; i++) {
            reflect_Minecraft_constructors_arr[i] = reflect_Minecraft_constructors.get(i);
        }

        ArrayList<BaseData> reflect_Minecraft_methods = new ArrayList<BaseData>();
        
        BaseData reflect_Minecraft_method_run_0 = new ModData();
        reflect_Minecraft_method_run_0.set("methodName", "run");
        reflect_Minecraft_method_run_0.set("returnType", "void");
        reflect_Minecraft_method_run_0.set("static", false);
        reflect_Minecraft_method_run_0.set("argnames", new String[]{});
        reflect_Minecraft_method_run_0.set("argtypes", new String[]{});
        reflect_Minecraft_method_run_0.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Minecraft) params.getReflective("_self")).run();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_run_0);


        BaseData reflect_Minecraft_method_getVersion_1 = new ModData();
        reflect_Minecraft_method_getVersion_1.set("methodName", "getVersion");
        reflect_Minecraft_method_getVersion_1.set("returnType", "String");
        reflect_Minecraft_method_getVersion_1.set("static", false);
        reflect_Minecraft_method_getVersion_1.set("argnames", new String[]{});
        reflect_Minecraft_method_getVersion_1.set("argtypes", new String[]{});
        reflect_Minecraft_method_getVersion_1.setCallbackStringWithDataArg("exec", (BaseData params) -> {
                try {
                    return (String) ((Minecraft) params.getReflective("_self")).getVersion();
                } catch (Exception _exception_reflect_) {
                    return "";
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_getVersion_1);


        BaseData reflect_Minecraft_method_crashed_2 = new ModData();
        reflect_Minecraft_method_crashed_2.set("methodName", "crashed");
        reflect_Minecraft_method_crashed_2.set("returnType", "void");
        reflect_Minecraft_method_crashed_2.set("static", false);
        reflect_Minecraft_method_crashed_2.set("argnames", new String[]{"crash"});
        reflect_Minecraft_method_crashed_2.set("argtypes", new String[]{"CrashReport"});
        reflect_Minecraft_method_crashed_2.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Minecraft) params.getReflective("_self")).crashed((CrashReport) params.getReflective("crash"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_crashed_2);


        BaseData reflect_Minecraft_method_displayCrashReport_3 = new ModData();
        reflect_Minecraft_method_displayCrashReport_3.set("methodName", "displayCrashReport");
        reflect_Minecraft_method_displayCrashReport_3.set("returnType", "void");
        reflect_Minecraft_method_displayCrashReport_3.set("static", false);
        reflect_Minecraft_method_displayCrashReport_3.set("argnames", new String[]{"crashReportIn"});
        reflect_Minecraft_method_displayCrashReport_3.set("argtypes", new String[]{"CrashReport"});
        reflect_Minecraft_method_displayCrashReport_3.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Minecraft) params.getReflective("_self")).displayCrashReport((CrashReport) params.getReflective("crashReportIn"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_displayCrashReport_3);


        BaseData reflect_Minecraft_method_isUnicode_4 = new ModData();
        reflect_Minecraft_method_isUnicode_4.set("methodName", "isUnicode");
        reflect_Minecraft_method_isUnicode_4.set("returnType", "boolean");
        reflect_Minecraft_method_isUnicode_4.set("static", false);
        reflect_Minecraft_method_isUnicode_4.set("argnames", new String[]{});
        reflect_Minecraft_method_isUnicode_4.set("argtypes", new String[]{});
        reflect_Minecraft_method_isUnicode_4.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((Minecraft) params.getReflective("_self")).isUnicode();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_isUnicode_4);


        BaseData reflect_Minecraft_method_refreshResources_5 = new ModData();
        reflect_Minecraft_method_refreshResources_5.set("methodName", "refreshResources");
        reflect_Minecraft_method_refreshResources_5.set("returnType", "void");
        reflect_Minecraft_method_refreshResources_5.set("static", false);
        reflect_Minecraft_method_refreshResources_5.set("argnames", new String[]{});
        reflect_Minecraft_method_refreshResources_5.set("argtypes", new String[]{});
        reflect_Minecraft_method_refreshResources_5.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Minecraft) params.getReflective("_self")).refreshResources();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_refreshResources_5);


        BaseData reflect_Minecraft_method_displayGuiScreen_6 = new ModData();
        reflect_Minecraft_method_displayGuiScreen_6.set("methodName", "displayGuiScreen");
        reflect_Minecraft_method_displayGuiScreen_6.set("returnType", "void");
        reflect_Minecraft_method_displayGuiScreen_6.set("static", false);
        reflect_Minecraft_method_displayGuiScreen_6.set("argnames", new String[]{"guiScreenIn"});
        reflect_Minecraft_method_displayGuiScreen_6.set("argtypes", new String[]{"GuiScreen"});
        reflect_Minecraft_method_displayGuiScreen_6.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Minecraft) params.getReflective("_self")).displayGuiScreen((GuiScreen) params.getReflective("guiScreenIn"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_displayGuiScreen_6);


        BaseData reflect_Minecraft_method_shutdownIntegratedServer_7 = new ModData();
        reflect_Minecraft_method_shutdownIntegratedServer_7.set("methodName", "shutdownIntegratedServer");
        reflect_Minecraft_method_shutdownIntegratedServer_7.set("returnType", "void");
        reflect_Minecraft_method_shutdownIntegratedServer_7.set("static", false);
        reflect_Minecraft_method_shutdownIntegratedServer_7.set("argnames", new String[]{"cont"});
        reflect_Minecraft_method_shutdownIntegratedServer_7.set("argtypes", new String[]{"GuiScreen"});
        reflect_Minecraft_method_shutdownIntegratedServer_7.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Minecraft) params.getReflective("_self")).shutdownIntegratedServer((GuiScreen) params.getReflective("cont"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_shutdownIntegratedServer_7);


        BaseData reflect_Minecraft_method_checkGLError_8 = new ModData();
        reflect_Minecraft_method_checkGLError_8.set("methodName", "checkGLError");
        reflect_Minecraft_method_checkGLError_8.set("returnType", "void");
        reflect_Minecraft_method_checkGLError_8.set("static", false);
        reflect_Minecraft_method_checkGLError_8.set("argnames", new String[]{"message"});
        reflect_Minecraft_method_checkGLError_8.set("argtypes", new String[]{"String"});
        reflect_Minecraft_method_checkGLError_8.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Minecraft) params.getReflective("_self")).checkGLError((String) params.getString("message"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_checkGLError_8);


        BaseData reflect_Minecraft_method_shutdownMinecraftApplet_9 = new ModData();
        reflect_Minecraft_method_shutdownMinecraftApplet_9.set("methodName", "shutdownMinecraftApplet");
        reflect_Minecraft_method_shutdownMinecraftApplet_9.set("returnType", "void");
        reflect_Minecraft_method_shutdownMinecraftApplet_9.set("static", false);
        reflect_Minecraft_method_shutdownMinecraftApplet_9.set("argnames", new String[]{});
        reflect_Minecraft_method_shutdownMinecraftApplet_9.set("argtypes", new String[]{});
        reflect_Minecraft_method_shutdownMinecraftApplet_9.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Minecraft) params.getReflective("_self")).shutdownMinecraftApplet();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_shutdownMinecraftApplet_9);


        BaseData reflect_Minecraft_method_updateDisplay_10 = new ModData();
        reflect_Minecraft_method_updateDisplay_10.set("methodName", "updateDisplay");
        reflect_Minecraft_method_updateDisplay_10.set("returnType", "void");
        reflect_Minecraft_method_updateDisplay_10.set("static", false);
        reflect_Minecraft_method_updateDisplay_10.set("argnames", new String[]{});
        reflect_Minecraft_method_updateDisplay_10.set("argtypes", new String[]{});
        reflect_Minecraft_method_updateDisplay_10.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Minecraft) params.getReflective("_self")).updateDisplay();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_updateDisplay_10);


        BaseData reflect_Minecraft_method_getLimitFramerate_11 = new ModData();
        reflect_Minecraft_method_getLimitFramerate_11.set("methodName", "getLimitFramerate");
        reflect_Minecraft_method_getLimitFramerate_11.set("returnType", "int");
        reflect_Minecraft_method_getLimitFramerate_11.set("static", false);
        reflect_Minecraft_method_getLimitFramerate_11.set("argnames", new String[]{});
        reflect_Minecraft_method_getLimitFramerate_11.set("argtypes", new String[]{});
        reflect_Minecraft_method_getLimitFramerate_11.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((Minecraft) params.getReflective("_self")).getLimitFramerate();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_getLimitFramerate_11);


        BaseData reflect_Minecraft_method_isFramerateLimitBelowMax_12 = new ModData();
        reflect_Minecraft_method_isFramerateLimitBelowMax_12.set("methodName", "isFramerateLimitBelowMax");
        reflect_Minecraft_method_isFramerateLimitBelowMax_12.set("returnType", "boolean");
        reflect_Minecraft_method_isFramerateLimitBelowMax_12.set("static", false);
        reflect_Minecraft_method_isFramerateLimitBelowMax_12.set("argnames", new String[]{});
        reflect_Minecraft_method_isFramerateLimitBelowMax_12.set("argtypes", new String[]{});
        reflect_Minecraft_method_isFramerateLimitBelowMax_12.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((Minecraft) params.getReflective("_self")).isFramerateLimitBelowMax();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_isFramerateLimitBelowMax_12);


        BaseData reflect_Minecraft_method_shutdown_13 = new ModData();
        reflect_Minecraft_method_shutdown_13.set("methodName", "shutdown");
        reflect_Minecraft_method_shutdown_13.set("returnType", "void");
        reflect_Minecraft_method_shutdown_13.set("static", false);
        reflect_Minecraft_method_shutdown_13.set("argnames", new String[]{});
        reflect_Minecraft_method_shutdown_13.set("argtypes", new String[]{});
        reflect_Minecraft_method_shutdown_13.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Minecraft) params.getReflective("_self")).shutdown();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_shutdown_13);


        BaseData reflect_Minecraft_method_setIngameFocus_14 = new ModData();
        reflect_Minecraft_method_setIngameFocus_14.set("methodName", "setIngameFocus");
        reflect_Minecraft_method_setIngameFocus_14.set("returnType", "void");
        reflect_Minecraft_method_setIngameFocus_14.set("static", false);
        reflect_Minecraft_method_setIngameFocus_14.set("argnames", new String[]{});
        reflect_Minecraft_method_setIngameFocus_14.set("argtypes", new String[]{});
        reflect_Minecraft_method_setIngameFocus_14.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Minecraft) params.getReflective("_self")).setIngameFocus();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_setIngameFocus_14);


        BaseData reflect_Minecraft_method_setIngameNotInFocus_15 = new ModData();
        reflect_Minecraft_method_setIngameNotInFocus_15.set("methodName", "setIngameNotInFocus");
        reflect_Minecraft_method_setIngameNotInFocus_15.set("returnType", "void");
        reflect_Minecraft_method_setIngameNotInFocus_15.set("static", false);
        reflect_Minecraft_method_setIngameNotInFocus_15.set("argnames", new String[]{});
        reflect_Minecraft_method_setIngameNotInFocus_15.set("argtypes", new String[]{});
        reflect_Minecraft_method_setIngameNotInFocus_15.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Minecraft) params.getReflective("_self")).setIngameNotInFocus();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_setIngameNotInFocus_15);


        BaseData reflect_Minecraft_method_displayInGameMenu_16 = new ModData();
        reflect_Minecraft_method_displayInGameMenu_16.set("methodName", "displayInGameMenu");
        reflect_Minecraft_method_displayInGameMenu_16.set("returnType", "void");
        reflect_Minecraft_method_displayInGameMenu_16.set("static", false);
        reflect_Minecraft_method_displayInGameMenu_16.set("argnames", new String[]{});
        reflect_Minecraft_method_displayInGameMenu_16.set("argtypes", new String[]{});
        reflect_Minecraft_method_displayInGameMenu_16.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Minecraft) params.getReflective("_self")).displayInGameMenu();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_displayInGameMenu_16);


        BaseData reflect_Minecraft_method_clickMouse_17 = new ModData();
        reflect_Minecraft_method_clickMouse_17.set("methodName", "clickMouse");
        reflect_Minecraft_method_clickMouse_17.set("returnType", "void");
        reflect_Minecraft_method_clickMouse_17.set("static", false);
        reflect_Minecraft_method_clickMouse_17.set("argnames", new String[]{});
        reflect_Minecraft_method_clickMouse_17.set("argtypes", new String[]{});
        reflect_Minecraft_method_clickMouse_17.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Minecraft) params.getReflective("_self")).clickMouse();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_clickMouse_17);


        BaseData reflect_Minecraft_method_rightClickMouse_18 = new ModData();
        reflect_Minecraft_method_rightClickMouse_18.set("methodName", "rightClickMouse");
        reflect_Minecraft_method_rightClickMouse_18.set("returnType", "void");
        reflect_Minecraft_method_rightClickMouse_18.set("static", false);
        reflect_Minecraft_method_rightClickMouse_18.set("argnames", new String[]{});
        reflect_Minecraft_method_rightClickMouse_18.set("argtypes", new String[]{});
        reflect_Minecraft_method_rightClickMouse_18.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Minecraft) params.getReflective("_self")).rightClickMouse();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_rightClickMouse_18);


        BaseData reflect_Minecraft_method_toggleFullscreen_19 = new ModData();
        reflect_Minecraft_method_toggleFullscreen_19.set("methodName", "toggleFullscreen");
        reflect_Minecraft_method_toggleFullscreen_19.set("returnType", "void");
        reflect_Minecraft_method_toggleFullscreen_19.set("static", false);
        reflect_Minecraft_method_toggleFullscreen_19.set("argnames", new String[]{});
        reflect_Minecraft_method_toggleFullscreen_19.set("argtypes", new String[]{});
        reflect_Minecraft_method_toggleFullscreen_19.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Minecraft) params.getReflective("_self")).toggleFullscreen();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_toggleFullscreen_19);


        BaseData reflect_Minecraft_method_func_181535_r_20 = new ModData();
        reflect_Minecraft_method_func_181535_r_20.set("methodName", "func_181535_r");
        reflect_Minecraft_method_func_181535_r_20.set("returnType", "MusicTicker");
        reflect_Minecraft_method_func_181535_r_20.set("static", false);
        reflect_Minecraft_method_func_181535_r_20.set("argnames", new String[]{});
        reflect_Minecraft_method_func_181535_r_20.set("argtypes", new String[]{});
        reflect_Minecraft_method_func_181535_r_20.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (MusicTicker) ((Minecraft) params.getReflective("_self")).func_181535_r();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_func_181535_r_20);


        BaseData reflect_Minecraft_method_runTick_21 = new ModData();
        reflect_Minecraft_method_runTick_21.set("methodName", "runTick");
        reflect_Minecraft_method_runTick_21.set("returnType", "void");
        reflect_Minecraft_method_runTick_21.set("static", false);
        reflect_Minecraft_method_runTick_21.set("argnames", new String[]{});
        reflect_Minecraft_method_runTick_21.set("argtypes", new String[]{});
        reflect_Minecraft_method_runTick_21.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Minecraft) params.getReflective("_self")).runTick();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_runTick_21);


        BaseData reflect_Minecraft_method_launchIntegratedServer_22 = new ModData();
        reflect_Minecraft_method_launchIntegratedServer_22.set("methodName", "launchIntegratedServer");
        reflect_Minecraft_method_launchIntegratedServer_22.set("returnType", "void");
        reflect_Minecraft_method_launchIntegratedServer_22.set("static", false);
        reflect_Minecraft_method_launchIntegratedServer_22.set("argnames", new String[]{"folderName", "worldName", "worldSettingsIn"});
        reflect_Minecraft_method_launchIntegratedServer_22.set("argtypes", new String[]{"String", "String", "WorldSettings"});
        reflect_Minecraft_method_launchIntegratedServer_22.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Minecraft) params.getReflective("_self")).launchIntegratedServer((String) params.getString("folderName"), (String) params.getString("worldName"), (WorldSettings) params.getReflective("worldSettingsIn"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_launchIntegratedServer_22);


        BaseData reflect_Minecraft_method_loadWorld_23 = new ModData();
        reflect_Minecraft_method_loadWorld_23.set("methodName", "loadWorld");
        reflect_Minecraft_method_loadWorld_23.set("returnType", "void");
        reflect_Minecraft_method_loadWorld_23.set("static", false);
        reflect_Minecraft_method_loadWorld_23.set("argnames", new String[]{"worldClientIn"});
        reflect_Minecraft_method_loadWorld_23.set("argtypes", new String[]{"WorldClient"});
        reflect_Minecraft_method_loadWorld_23.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Minecraft) params.getReflective("_self")).loadWorld((WorldClient) params.getReflective("worldClientIn"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_loadWorld_23);


        BaseData reflect_Minecraft_method_loadWorld_24 = new ModData();
        reflect_Minecraft_method_loadWorld_24.set("methodName", "loadWorld");
        reflect_Minecraft_method_loadWorld_24.set("returnType", "void");
        reflect_Minecraft_method_loadWorld_24.set("static", false);
        reflect_Minecraft_method_loadWorld_24.set("argnames", new String[]{"worldClientIn", "loadingMessage"});
        reflect_Minecraft_method_loadWorld_24.set("argtypes", new String[]{"WorldClient", "String"});
        reflect_Minecraft_method_loadWorld_24.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Minecraft) params.getReflective("_self")).loadWorld((WorldClient) params.getReflective("worldClientIn"), (String) params.getString("loadingMessage"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_loadWorld_24);


        BaseData reflect_Minecraft_method_setDimensionAndSpawnPlayer_25 = new ModData();
        reflect_Minecraft_method_setDimensionAndSpawnPlayer_25.set("methodName", "setDimensionAndSpawnPlayer");
        reflect_Minecraft_method_setDimensionAndSpawnPlayer_25.set("returnType", "void");
        reflect_Minecraft_method_setDimensionAndSpawnPlayer_25.set("static", false);
        reflect_Minecraft_method_setDimensionAndSpawnPlayer_25.set("argnames", new String[]{"dimension"});
        reflect_Minecraft_method_setDimensionAndSpawnPlayer_25.set("argtypes", new String[]{"int"});
        reflect_Minecraft_method_setDimensionAndSpawnPlayer_25.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Minecraft) params.getReflective("_self")).setDimensionAndSpawnPlayer((int) params.getInt("dimension"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_setDimensionAndSpawnPlayer_25);


        BaseData reflect_Minecraft_method_isDemo_26 = new ModData();
        reflect_Minecraft_method_isDemo_26.set("methodName", "isDemo");
        reflect_Minecraft_method_isDemo_26.set("returnType", "boolean");
        reflect_Minecraft_method_isDemo_26.set("static", false);
        reflect_Minecraft_method_isDemo_26.set("argnames", new String[]{});
        reflect_Minecraft_method_isDemo_26.set("argtypes", new String[]{});
        reflect_Minecraft_method_isDemo_26.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((Minecraft) params.getReflective("_self")).isDemo();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_isDemo_26);


        BaseData reflect_Minecraft_method_getNetHandler_27 = new ModData();
        reflect_Minecraft_method_getNetHandler_27.set("methodName", "getNetHandler");
        reflect_Minecraft_method_getNetHandler_27.set("returnType", "NetHandlerPlayClient");
        reflect_Minecraft_method_getNetHandler_27.set("static", false);
        reflect_Minecraft_method_getNetHandler_27.set("argnames", new String[]{});
        reflect_Minecraft_method_getNetHandler_27.set("argtypes", new String[]{});
        reflect_Minecraft_method_getNetHandler_27.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (NetHandlerPlayClient) ((Minecraft) params.getReflective("_self")).getNetHandler();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_getNetHandler_27);


        BaseData reflect_Minecraft_method_isGuiEnabled_28 = new ModData();
        reflect_Minecraft_method_isGuiEnabled_28.set("methodName", "isGuiEnabled");
        reflect_Minecraft_method_isGuiEnabled_28.set("returnType", "boolean");
        reflect_Minecraft_method_isGuiEnabled_28.set("static", true);
        reflect_Minecraft_method_isGuiEnabled_28.set("argnames", new String[]{});
        reflect_Minecraft_method_isGuiEnabled_28.set("argtypes", new String[]{});
        reflect_Minecraft_method_isGuiEnabled_28.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) Minecraft.isGuiEnabled();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_isGuiEnabled_28);


        BaseData reflect_Minecraft_method_isFancyGraphicsEnabled_29 = new ModData();
        reflect_Minecraft_method_isFancyGraphicsEnabled_29.set("methodName", "isFancyGraphicsEnabled");
        reflect_Minecraft_method_isFancyGraphicsEnabled_29.set("returnType", "boolean");
        reflect_Minecraft_method_isFancyGraphicsEnabled_29.set("static", true);
        reflect_Minecraft_method_isFancyGraphicsEnabled_29.set("argnames", new String[]{});
        reflect_Minecraft_method_isFancyGraphicsEnabled_29.set("argtypes", new String[]{});
        reflect_Minecraft_method_isFancyGraphicsEnabled_29.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) Minecraft.isFancyGraphicsEnabled();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_isFancyGraphicsEnabled_29);


        BaseData reflect_Minecraft_method_isAmbientOcclusionEnabled_30 = new ModData();
        reflect_Minecraft_method_isAmbientOcclusionEnabled_30.set("methodName", "isAmbientOcclusionEnabled");
        reflect_Minecraft_method_isAmbientOcclusionEnabled_30.set("returnType", "boolean");
        reflect_Minecraft_method_isAmbientOcclusionEnabled_30.set("static", true);
        reflect_Minecraft_method_isAmbientOcclusionEnabled_30.set("argnames", new String[]{});
        reflect_Minecraft_method_isAmbientOcclusionEnabled_30.set("argtypes", new String[]{});
        reflect_Minecraft_method_isAmbientOcclusionEnabled_30.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) Minecraft.isAmbientOcclusionEnabled();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_isAmbientOcclusionEnabled_30);


        BaseData reflect_Minecraft_method_middleClickMouse_31 = new ModData();
        reflect_Minecraft_method_middleClickMouse_31.set("methodName", "middleClickMouse");
        reflect_Minecraft_method_middleClickMouse_31.set("returnType", "void");
        reflect_Minecraft_method_middleClickMouse_31.set("static", false);
        reflect_Minecraft_method_middleClickMouse_31.set("argnames", new String[]{});
        reflect_Minecraft_method_middleClickMouse_31.set("argtypes", new String[]{});
        reflect_Minecraft_method_middleClickMouse_31.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Minecraft) params.getReflective("_self")).middleClickMouse();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_middleClickMouse_31);


        BaseData reflect_Minecraft_method_addGraphicsAndWorldToCrashReport_32 = new ModData();
        reflect_Minecraft_method_addGraphicsAndWorldToCrashReport_32.set("methodName", "addGraphicsAndWorldToCrashReport");
        reflect_Minecraft_method_addGraphicsAndWorldToCrashReport_32.set("returnType", "CrashReport");
        reflect_Minecraft_method_addGraphicsAndWorldToCrashReport_32.set("static", false);
        reflect_Minecraft_method_addGraphicsAndWorldToCrashReport_32.set("argnames", new String[]{"theCrash"});
        reflect_Minecraft_method_addGraphicsAndWorldToCrashReport_32.set("argtypes", new String[]{"CrashReport"});
        reflect_Minecraft_method_addGraphicsAndWorldToCrashReport_32.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (CrashReport) ((Minecraft) params.getReflective("_self")).addGraphicsAndWorldToCrashReport((CrashReport) params.getReflective("theCrash"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_addGraphicsAndWorldToCrashReport_32);


        BaseData reflect_Minecraft_method_getMinecraft_33 = new ModData();
        reflect_Minecraft_method_getMinecraft_33.set("methodName", "getMinecraft");
        reflect_Minecraft_method_getMinecraft_33.set("returnType", "Minecraft");
        reflect_Minecraft_method_getMinecraft_33.set("static", true);
        reflect_Minecraft_method_getMinecraft_33.set("argnames", new String[]{});
        reflect_Minecraft_method_getMinecraft_33.set("argtypes", new String[]{});
        reflect_Minecraft_method_getMinecraft_33.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Minecraft) Minecraft.getMinecraft();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_getMinecraft_33);


        BaseData reflect_Minecraft_method_isSnooperEnabled_34 = new ModData();
        reflect_Minecraft_method_isSnooperEnabled_34.set("methodName", "isSnooperEnabled");
        reflect_Minecraft_method_isSnooperEnabled_34.set("returnType", "boolean");
        reflect_Minecraft_method_isSnooperEnabled_34.set("static", false);
        reflect_Minecraft_method_isSnooperEnabled_34.set("argnames", new String[]{});
        reflect_Minecraft_method_isSnooperEnabled_34.set("argtypes", new String[]{});
        reflect_Minecraft_method_isSnooperEnabled_34.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((Minecraft) params.getReflective("_self")).isSnooperEnabled();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_isSnooperEnabled_34);


        BaseData reflect_Minecraft_method_setServerData_35 = new ModData();
        reflect_Minecraft_method_setServerData_35.set("methodName", "setServerData");
        reflect_Minecraft_method_setServerData_35.set("returnType", "void");
        reflect_Minecraft_method_setServerData_35.set("static", false);
        reflect_Minecraft_method_setServerData_35.set("argnames", new String[]{"serverDataIn"});
        reflect_Minecraft_method_setServerData_35.set("argtypes", new String[]{"ServerData"});
        reflect_Minecraft_method_setServerData_35.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Minecraft) params.getReflective("_self")).setServerData((ServerData) params.getReflective("serverDataIn"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_setServerData_35);


        BaseData reflect_Minecraft_method_getCurrentServerData_36 = new ModData();
        reflect_Minecraft_method_getCurrentServerData_36.set("methodName", "getCurrentServerData");
        reflect_Minecraft_method_getCurrentServerData_36.set("returnType", "ServerData");
        reflect_Minecraft_method_getCurrentServerData_36.set("static", false);
        reflect_Minecraft_method_getCurrentServerData_36.set("argnames", new String[]{});
        reflect_Minecraft_method_getCurrentServerData_36.set("argtypes", new String[]{});
        reflect_Minecraft_method_getCurrentServerData_36.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (ServerData) ((Minecraft) params.getReflective("_self")).getCurrentServerData();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_getCurrentServerData_36);


        BaseData reflect_Minecraft_method_isIntegratedServerRunning_37 = new ModData();
        reflect_Minecraft_method_isIntegratedServerRunning_37.set("methodName", "isIntegratedServerRunning");
        reflect_Minecraft_method_isIntegratedServerRunning_37.set("returnType", "boolean");
        reflect_Minecraft_method_isIntegratedServerRunning_37.set("static", false);
        reflect_Minecraft_method_isIntegratedServerRunning_37.set("argnames", new String[]{});
        reflect_Minecraft_method_isIntegratedServerRunning_37.set("argtypes", new String[]{});
        reflect_Minecraft_method_isIntegratedServerRunning_37.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((Minecraft) params.getReflective("_self")).isIntegratedServerRunning();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_isIntegratedServerRunning_37);


        BaseData reflect_Minecraft_method_isSingleplayer_38 = new ModData();
        reflect_Minecraft_method_isSingleplayer_38.set("methodName", "isSingleplayer");
        reflect_Minecraft_method_isSingleplayer_38.set("returnType", "boolean");
        reflect_Minecraft_method_isSingleplayer_38.set("static", false);
        reflect_Minecraft_method_isSingleplayer_38.set("argnames", new String[]{});
        reflect_Minecraft_method_isSingleplayer_38.set("argtypes", new String[]{});
        reflect_Minecraft_method_isSingleplayer_38.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((Minecraft) params.getReflective("_self")).isSingleplayer();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_isSingleplayer_38);


        BaseData reflect_Minecraft_method_stopIntegratedServer_39 = new ModData();
        reflect_Minecraft_method_stopIntegratedServer_39.set("methodName", "stopIntegratedServer");
        reflect_Minecraft_method_stopIntegratedServer_39.set("returnType", "void");
        reflect_Minecraft_method_stopIntegratedServer_39.set("static", true);
        reflect_Minecraft_method_stopIntegratedServer_39.set("argnames", new String[]{});
        reflect_Minecraft_method_stopIntegratedServer_39.set("argtypes", new String[]{});
        reflect_Minecraft_method_stopIntegratedServer_39.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    Minecraft.stopIntegratedServer();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_stopIntegratedServer_39);


        BaseData reflect_Minecraft_method_getSystemTime_40 = new ModData();
        reflect_Minecraft_method_getSystemTime_40.set("methodName", "getSystemTime");
        reflect_Minecraft_method_getSystemTime_40.set("returnType", "long");
        reflect_Minecraft_method_getSystemTime_40.set("static", true);
        reflect_Minecraft_method_getSystemTime_40.set("argnames", new String[]{});
        reflect_Minecraft_method_getSystemTime_40.set("argtypes", new String[]{});
        reflect_Minecraft_method_getSystemTime_40.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (long) Minecraft.getSystemTime();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_getSystemTime_40);


        BaseData reflect_Minecraft_method_isFullScreen_41 = new ModData();
        reflect_Minecraft_method_isFullScreen_41.set("methodName", "isFullScreen");
        reflect_Minecraft_method_isFullScreen_41.set("returnType", "boolean");
        reflect_Minecraft_method_isFullScreen_41.set("static", false);
        reflect_Minecraft_method_isFullScreen_41.set("argnames", new String[]{});
        reflect_Minecraft_method_isFullScreen_41.set("argtypes", new String[]{});
        reflect_Minecraft_method_isFullScreen_41.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((Minecraft) params.getReflective("_self")).isFullScreen();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_isFullScreen_41);


        BaseData reflect_Minecraft_method_getSession_42 = new ModData();
        reflect_Minecraft_method_getSession_42.set("methodName", "getSession");
        reflect_Minecraft_method_getSession_42.set("returnType", "Session");
        reflect_Minecraft_method_getSession_42.set("static", false);
        reflect_Minecraft_method_getSession_42.set("argnames", new String[]{});
        reflect_Minecraft_method_getSession_42.set("argtypes", new String[]{});
        reflect_Minecraft_method_getSession_42.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Session) ((Minecraft) params.getReflective("_self")).getSession();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_getSession_42);


        BaseData reflect_Minecraft_method_getTextureManager_43 = new ModData();
        reflect_Minecraft_method_getTextureManager_43.set("methodName", "getTextureManager");
        reflect_Minecraft_method_getTextureManager_43.set("returnType", "TextureManager");
        reflect_Minecraft_method_getTextureManager_43.set("static", false);
        reflect_Minecraft_method_getTextureManager_43.set("argnames", new String[]{});
        reflect_Minecraft_method_getTextureManager_43.set("argtypes", new String[]{});
        reflect_Minecraft_method_getTextureManager_43.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (TextureManager) ((Minecraft) params.getReflective("_self")).getTextureManager();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_getTextureManager_43);


        BaseData reflect_Minecraft_method_getResourceManager_44 = new ModData();
        reflect_Minecraft_method_getResourceManager_44.set("methodName", "getResourceManager");
        reflect_Minecraft_method_getResourceManager_44.set("returnType", "IResourceManager");
        reflect_Minecraft_method_getResourceManager_44.set("static", false);
        reflect_Minecraft_method_getResourceManager_44.set("argnames", new String[]{});
        reflect_Minecraft_method_getResourceManager_44.set("argtypes", new String[]{});
        reflect_Minecraft_method_getResourceManager_44.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (IResourceManager) ((Minecraft) params.getReflective("_self")).getResourceManager();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_getResourceManager_44);


        BaseData reflect_Minecraft_method_getResourcePackRepository_45 = new ModData();
        reflect_Minecraft_method_getResourcePackRepository_45.set("methodName", "getResourcePackRepository");
        reflect_Minecraft_method_getResourcePackRepository_45.set("returnType", "ResourcePackRepository");
        reflect_Minecraft_method_getResourcePackRepository_45.set("static", false);
        reflect_Minecraft_method_getResourcePackRepository_45.set("argnames", new String[]{});
        reflect_Minecraft_method_getResourcePackRepository_45.set("argtypes", new String[]{});
        reflect_Minecraft_method_getResourcePackRepository_45.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (ResourcePackRepository) ((Minecraft) params.getReflective("_self")).getResourcePackRepository();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_getResourcePackRepository_45);


        BaseData reflect_Minecraft_method_getLanguageManager_46 = new ModData();
        reflect_Minecraft_method_getLanguageManager_46.set("methodName", "getLanguageManager");
        reflect_Minecraft_method_getLanguageManager_46.set("returnType", "LanguageManager");
        reflect_Minecraft_method_getLanguageManager_46.set("static", false);
        reflect_Minecraft_method_getLanguageManager_46.set("argnames", new String[]{});
        reflect_Minecraft_method_getLanguageManager_46.set("argtypes", new String[]{});
        reflect_Minecraft_method_getLanguageManager_46.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (LanguageManager) ((Minecraft) params.getReflective("_self")).getLanguageManager();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_getLanguageManager_46);


        BaseData reflect_Minecraft_method_getTextureMapBlocks_47 = new ModData();
        reflect_Minecraft_method_getTextureMapBlocks_47.set("methodName", "getTextureMapBlocks");
        reflect_Minecraft_method_getTextureMapBlocks_47.set("returnType", "TextureMap");
        reflect_Minecraft_method_getTextureMapBlocks_47.set("static", false);
        reflect_Minecraft_method_getTextureMapBlocks_47.set("argnames", new String[]{});
        reflect_Minecraft_method_getTextureMapBlocks_47.set("argtypes", new String[]{});
        reflect_Minecraft_method_getTextureMapBlocks_47.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (TextureMap) ((Minecraft) params.getReflective("_self")).getTextureMapBlocks();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_getTextureMapBlocks_47);


        BaseData reflect_Minecraft_method_isJava64bit_48 = new ModData();
        reflect_Minecraft_method_isJava64bit_48.set("methodName", "isJava64bit");
        reflect_Minecraft_method_isJava64bit_48.set("returnType", "boolean");
        reflect_Minecraft_method_isJava64bit_48.set("static", false);
        reflect_Minecraft_method_isJava64bit_48.set("argnames", new String[]{});
        reflect_Minecraft_method_isJava64bit_48.set("argtypes", new String[]{});
        reflect_Minecraft_method_isJava64bit_48.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((Minecraft) params.getReflective("_self")).isJava64bit();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_isJava64bit_48);


        BaseData reflect_Minecraft_method_isGamePaused_49 = new ModData();
        reflect_Minecraft_method_isGamePaused_49.set("methodName", "isGamePaused");
        reflect_Minecraft_method_isGamePaused_49.set("returnType", "boolean");
        reflect_Minecraft_method_isGamePaused_49.set("static", false);
        reflect_Minecraft_method_isGamePaused_49.set("argnames", new String[]{});
        reflect_Minecraft_method_isGamePaused_49.set("argtypes", new String[]{});
        reflect_Minecraft_method_isGamePaused_49.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((Minecraft) params.getReflective("_self")).isGamePaused();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_isGamePaused_49);


        BaseData reflect_Minecraft_method_getSoundHandler_50 = new ModData();
        reflect_Minecraft_method_getSoundHandler_50.set("methodName", "getSoundHandler");
        reflect_Minecraft_method_getSoundHandler_50.set("returnType", "SoundHandler");
        reflect_Minecraft_method_getSoundHandler_50.set("static", false);
        reflect_Minecraft_method_getSoundHandler_50.set("argnames", new String[]{});
        reflect_Minecraft_method_getSoundHandler_50.set("argtypes", new String[]{});
        reflect_Minecraft_method_getSoundHandler_50.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (SoundHandler) ((Minecraft) params.getReflective("_self")).getSoundHandler();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_getSoundHandler_50);


        BaseData reflect_Minecraft_method_dispatchKeypresses_51 = new ModData();
        reflect_Minecraft_method_dispatchKeypresses_51.set("methodName", "dispatchKeypresses");
        reflect_Minecraft_method_dispatchKeypresses_51.set("returnType", "void");
        reflect_Minecraft_method_dispatchKeypresses_51.set("static", false);
        reflect_Minecraft_method_dispatchKeypresses_51.set("argnames", new String[]{});
        reflect_Minecraft_method_dispatchKeypresses_51.set("argtypes", new String[]{});
        reflect_Minecraft_method_dispatchKeypresses_51.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Minecraft) params.getReflective("_self")).dispatchKeypresses();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_dispatchKeypresses_51);


        BaseData reflect_Minecraft_method_getRenderViewEntity_52 = new ModData();
        reflect_Minecraft_method_getRenderViewEntity_52.set("methodName", "getRenderViewEntity");
        reflect_Minecraft_method_getRenderViewEntity_52.set("returnType", "Entity");
        reflect_Minecraft_method_getRenderViewEntity_52.set("static", false);
        reflect_Minecraft_method_getRenderViewEntity_52.set("argnames", new String[]{});
        reflect_Minecraft_method_getRenderViewEntity_52.set("argtypes", new String[]{});
        reflect_Minecraft_method_getRenderViewEntity_52.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Entity) ((Minecraft) params.getReflective("_self")).getRenderViewEntity();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_getRenderViewEntity_52);


        BaseData reflect_Minecraft_method_setRenderViewEntity_53 = new ModData();
        reflect_Minecraft_method_setRenderViewEntity_53.set("methodName", "setRenderViewEntity");
        reflect_Minecraft_method_setRenderViewEntity_53.set("returnType", "void");
        reflect_Minecraft_method_setRenderViewEntity_53.set("static", false);
        reflect_Minecraft_method_setRenderViewEntity_53.set("argnames", new String[]{"viewingEntity"});
        reflect_Minecraft_method_setRenderViewEntity_53.set("argtypes", new String[]{"Entity"});
        reflect_Minecraft_method_setRenderViewEntity_53.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Minecraft) params.getReflective("_self")).setRenderViewEntity((Entity) params.getReflective("viewingEntity"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_setRenderViewEntity_53);


        BaseData reflect_Minecraft_method_addScheduledTask_54 = new ModData();
        reflect_Minecraft_method_addScheduledTask_54.set("methodName", "addScheduledTask");
        reflect_Minecraft_method_addScheduledTask_54.set("returnType", "void");
        reflect_Minecraft_method_addScheduledTask_54.set("static", false);
        reflect_Minecraft_method_addScheduledTask_54.set("argnames", new String[]{"runnableToSchedule"});
        reflect_Minecraft_method_addScheduledTask_54.set("argtypes", new String[]{"Runnable"});
        reflect_Minecraft_method_addScheduledTask_54.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Minecraft) params.getReflective("_self")).addScheduledTask((Runnable) params.getReflective("runnableToSchedule"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_addScheduledTask_54);


        BaseData reflect_Minecraft_method_getBlockRendererDispatcher_55 = new ModData();
        reflect_Minecraft_method_getBlockRendererDispatcher_55.set("methodName", "getBlockRendererDispatcher");
        reflect_Minecraft_method_getBlockRendererDispatcher_55.set("returnType", "BlockRendererDispatcher");
        reflect_Minecraft_method_getBlockRendererDispatcher_55.set("static", false);
        reflect_Minecraft_method_getBlockRendererDispatcher_55.set("argnames", new String[]{});
        reflect_Minecraft_method_getBlockRendererDispatcher_55.set("argtypes", new String[]{});
        reflect_Minecraft_method_getBlockRendererDispatcher_55.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (BlockRendererDispatcher) ((Minecraft) params.getReflective("_self")).getBlockRendererDispatcher();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_getBlockRendererDispatcher_55);


        BaseData reflect_Minecraft_method_getRenderManager_56 = new ModData();
        reflect_Minecraft_method_getRenderManager_56.set("methodName", "getRenderManager");
        reflect_Minecraft_method_getRenderManager_56.set("returnType", "RenderManager");
        reflect_Minecraft_method_getRenderManager_56.set("static", false);
        reflect_Minecraft_method_getRenderManager_56.set("argnames", new String[]{});
        reflect_Minecraft_method_getRenderManager_56.set("argtypes", new String[]{});
        reflect_Minecraft_method_getRenderManager_56.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (RenderManager) ((Minecraft) params.getReflective("_self")).getRenderManager();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_getRenderManager_56);


        BaseData reflect_Minecraft_method_getRenderItem_57 = new ModData();
        reflect_Minecraft_method_getRenderItem_57.set("methodName", "getRenderItem");
        reflect_Minecraft_method_getRenderItem_57.set("returnType", "RenderItem");
        reflect_Minecraft_method_getRenderItem_57.set("static", false);
        reflect_Minecraft_method_getRenderItem_57.set("argnames", new String[]{});
        reflect_Minecraft_method_getRenderItem_57.set("argtypes", new String[]{});
        reflect_Minecraft_method_getRenderItem_57.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (RenderItem) ((Minecraft) params.getReflective("_self")).getRenderItem();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_getRenderItem_57);


        BaseData reflect_Minecraft_method_getItemRenderer_58 = new ModData();
        reflect_Minecraft_method_getItemRenderer_58.set("methodName", "getItemRenderer");
        reflect_Minecraft_method_getItemRenderer_58.set("returnType", "ItemRenderer");
        reflect_Minecraft_method_getItemRenderer_58.set("static", false);
        reflect_Minecraft_method_getItemRenderer_58.set("argnames", new String[]{});
        reflect_Minecraft_method_getItemRenderer_58.set("argtypes", new String[]{});
        reflect_Minecraft_method_getItemRenderer_58.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (ItemRenderer) ((Minecraft) params.getReflective("_self")).getItemRenderer();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_getItemRenderer_58);


        BaseData reflect_Minecraft_method_getDebugFPS_59 = new ModData();
        reflect_Minecraft_method_getDebugFPS_59.set("methodName", "getDebugFPS");
        reflect_Minecraft_method_getDebugFPS_59.set("returnType", "int");
        reflect_Minecraft_method_getDebugFPS_59.set("static", true);
        reflect_Minecraft_method_getDebugFPS_59.set("argnames", new String[]{});
        reflect_Minecraft_method_getDebugFPS_59.set("argtypes", new String[]{});
        reflect_Minecraft_method_getDebugFPS_59.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) Minecraft.getDebugFPS();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_getDebugFPS_59);


        BaseData reflect_Minecraft_method_func_181539_aj_60 = new ModData();
        reflect_Minecraft_method_func_181539_aj_60.set("methodName", "func_181539_aj");
        reflect_Minecraft_method_func_181539_aj_60.set("returnType", "FrameTimer");
        reflect_Minecraft_method_func_181539_aj_60.set("static", false);
        reflect_Minecraft_method_func_181539_aj_60.set("argnames", new String[]{});
        reflect_Minecraft_method_func_181539_aj_60.set("argtypes", new String[]{});
        reflect_Minecraft_method_func_181539_aj_60.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (FrameTimer) ((Minecraft) params.getReflective("_self")).func_181539_aj();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_func_181539_aj_60);


        BaseData reflect_Minecraft_method_func_181540_al_61 = new ModData();
        reflect_Minecraft_method_func_181540_al_61.set("methodName", "func_181540_al");
        reflect_Minecraft_method_func_181540_al_61.set("returnType", "boolean");
        reflect_Minecraft_method_func_181540_al_61.set("static", false);
        reflect_Minecraft_method_func_181540_al_61.set("argnames", new String[]{});
        reflect_Minecraft_method_func_181540_al_61.set("argtypes", new String[]{});
        reflect_Minecraft_method_func_181540_al_61.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((Minecraft) params.getReflective("_self")).func_181540_al();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_func_181540_al_61);


        BaseData reflect_Minecraft_method_func_181537_a_62 = new ModData();
        reflect_Minecraft_method_func_181537_a_62.set("methodName", "func_181537_a");
        reflect_Minecraft_method_func_181537_a_62.set("returnType", "void");
        reflect_Minecraft_method_func_181537_a_62.set("static", false);
        reflect_Minecraft_method_func_181537_a_62.set("argnames", new String[]{"parFlag"});
        reflect_Minecraft_method_func_181537_a_62.set("argtypes", new String[]{"boolean"});
        reflect_Minecraft_method_func_181537_a_62.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Minecraft) params.getReflective("_self")).func_181537_a((boolean) params.getBoolean("parFlag"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_func_181537_a_62);


        BaseData reflect_Minecraft_method_getGLMaximumTextureSize_63 = new ModData();
        reflect_Minecraft_method_getGLMaximumTextureSize_63.set("methodName", "getGLMaximumTextureSize");
        reflect_Minecraft_method_getGLMaximumTextureSize_63.set("returnType", "int");
        reflect_Minecraft_method_getGLMaximumTextureSize_63.set("static", true);
        reflect_Minecraft_method_getGLMaximumTextureSize_63.set("argnames", new String[]{});
        reflect_Minecraft_method_getGLMaximumTextureSize_63.set("argtypes", new String[]{});
        reflect_Minecraft_method_getGLMaximumTextureSize_63.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) Minecraft.getGLMaximumTextureSize();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_getGLMaximumTextureSize_63);


        BaseData reflect_Minecraft_method_areKeysLocked_64 = new ModData();
        reflect_Minecraft_method_areKeysLocked_64.set("methodName", "areKeysLocked");
        reflect_Minecraft_method_areKeysLocked_64.set("returnType", "boolean");
        reflect_Minecraft_method_areKeysLocked_64.set("static", false);
        reflect_Minecraft_method_areKeysLocked_64.set("argnames", new String[]{});
        reflect_Minecraft_method_areKeysLocked_64.set("argtypes", new String[]{});
        reflect_Minecraft_method_areKeysLocked_64.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((Minecraft) params.getReflective("_self")).areKeysLocked();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_areKeysLocked_64);


        BaseData reflect_Minecraft_method_getModelManager_65 = new ModData();
        reflect_Minecraft_method_getModelManager_65.set("methodName", "getModelManager");
        reflect_Minecraft_method_getModelManager_65.set("returnType", "ModelManager");
        reflect_Minecraft_method_getModelManager_65.set("static", false);
        reflect_Minecraft_method_getModelManager_65.set("argnames", new String[]{});
        reflect_Minecraft_method_getModelManager_65.set("argtypes", new String[]{});
        reflect_Minecraft_method_getModelManager_65.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (ModelManager) ((Minecraft) params.getReflective("_self")).getModelManager();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_getModelManager_65);


        BaseData reflect_Minecraft_method_getSaveLoader_66 = new ModData();
        reflect_Minecraft_method_getSaveLoader_66.set("methodName", "getSaveLoader");
        reflect_Minecraft_method_getSaveLoader_66.set("returnType", "ISaveFormat");
        reflect_Minecraft_method_getSaveLoader_66.set("static", false);
        reflect_Minecraft_method_getSaveLoader_66.set("argnames", new String[]{});
        reflect_Minecraft_method_getSaveLoader_66.set("argtypes", new String[]{});
        reflect_Minecraft_method_getSaveLoader_66.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (ISaveFormat) ((Minecraft) params.getReflective("_self")).getSaveLoader();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_getSaveLoader_66);


        BaseData reflect_Minecraft_method_clearTitles_67 = new ModData();
        reflect_Minecraft_method_clearTitles_67.set("methodName", "clearTitles");
        reflect_Minecraft_method_clearTitles_67.set("returnType", "void");
        reflect_Minecraft_method_clearTitles_67.set("static", false);
        reflect_Minecraft_method_clearTitles_67.set("argnames", new String[]{});
        reflect_Minecraft_method_clearTitles_67.set("argtypes", new String[]{});
        reflect_Minecraft_method_clearTitles_67.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Minecraft) params.getReflective("_self")).clearTitles();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_clearTitles_67);


        BaseData reflect_Minecraft_method_getEnableFNAWSkins_68 = new ModData();
        reflect_Minecraft_method_getEnableFNAWSkins_68.set("methodName", "getEnableFNAWSkins");
        reflect_Minecraft_method_getEnableFNAWSkins_68.set("returnType", "boolean");
        reflect_Minecraft_method_getEnableFNAWSkins_68.set("static", false);
        reflect_Minecraft_method_getEnableFNAWSkins_68.set("argnames", new String[]{});
        reflect_Minecraft_method_getEnableFNAWSkins_68.set("argtypes", new String[]{});
        reflect_Minecraft_method_getEnableFNAWSkins_68.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((Minecraft) params.getReflective("_self")).getEnableFNAWSkins();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_Minecraft_methods.add(reflect_Minecraft_method_getEnableFNAWSkins_68);


        BaseData[] reflect_Minecraft_methods_arr = new BaseData[reflect_Minecraft_methods.size()];
        for (int i = 0; i < reflect_Minecraft_methods_arr.length; i++) {
            reflect_Minecraft_methods_arr[i] = reflect_Minecraft_methods.get(i);
        }

        reflect_Minecraft.set("constructors", reflect_Minecraft_constructors_arr);
        reflect_Minecraft.set("methods", reflect_Minecraft_methods_arr);
        reflect_Minecraft.set("className", "Minecraft");
        reflect_Minecraft.set("classId", "net.minecraft.client.Minecraft");
        reflect_Minecraft.set("class", Minecraft.class);
        reflect_Minecraft.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof Minecraft;
        });
        reflectProfiles.add(reflect_Minecraft);
    }


    //classdef for EntityRenderer
    public static void reflect_EntityRenderer_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityRenderer = new ModData();

        ArrayList<BaseData> reflect_EntityRenderer_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_EntityRenderer_constructor_EntityRenderer_0 = new ModData();
        reflect_EntityRenderer_constructor_EntityRenderer_0.set("returnType", "EntityRenderer");
        reflect_EntityRenderer_constructor_EntityRenderer_0.set("argnames", new String[]{"mcIn", "resourceManagerIn"});
        reflect_EntityRenderer_constructor_EntityRenderer_0.set("argtypes", new String[]{"Minecraft", "IResourceManager"});
        reflect_EntityRenderer_constructor_EntityRenderer_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityRenderer((Minecraft) params.getReflective("mcIn"), (IResourceManager) params.getReflective("resourceManagerIn"));
        });
        
        reflect_EntityRenderer_constructors.add(reflect_EntityRenderer_constructor_EntityRenderer_0);


        BaseData[] reflect_EntityRenderer_constructors_arr = new BaseData[reflect_EntityRenderer_constructors.size()];
        for (int i = 0; i < reflect_EntityRenderer_constructors_arr.length; i++) {
            reflect_EntityRenderer_constructors_arr[i] = reflect_EntityRenderer_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityRenderer_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityRenderer_method_isShaderActive_0 = new ModData();
        reflect_EntityRenderer_method_isShaderActive_0.set("methodName", "isShaderActive");
        reflect_EntityRenderer_method_isShaderActive_0.set("returnType", "boolean");
        reflect_EntityRenderer_method_isShaderActive_0.set("static", false);
        reflect_EntityRenderer_method_isShaderActive_0.set("argnames", new String[]{});
        reflect_EntityRenderer_method_isShaderActive_0.set("argtypes", new String[]{});
        reflect_EntityRenderer_method_isShaderActive_0.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityRenderer) params.getReflective("_self")).isShaderActive();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityRenderer_methods.add(reflect_EntityRenderer_method_isShaderActive_0);


        BaseData reflect_EntityRenderer_method_func_181022_b_1 = new ModData();
        reflect_EntityRenderer_method_func_181022_b_1.set("methodName", "func_181022_b");
        reflect_EntityRenderer_method_func_181022_b_1.set("returnType", "void");
        reflect_EntityRenderer_method_func_181022_b_1.set("static", false);
        reflect_EntityRenderer_method_func_181022_b_1.set("argnames", new String[]{});
        reflect_EntityRenderer_method_func_181022_b_1.set("argtypes", new String[]{});
        reflect_EntityRenderer_method_func_181022_b_1.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityRenderer) params.getReflective("_self")).func_181022_b();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityRenderer_methods.add(reflect_EntityRenderer_method_func_181022_b_1);


        BaseData reflect_EntityRenderer_method_switchUseShader_2 = new ModData();
        reflect_EntityRenderer_method_switchUseShader_2.set("methodName", "switchUseShader");
        reflect_EntityRenderer_method_switchUseShader_2.set("returnType", "void");
        reflect_EntityRenderer_method_switchUseShader_2.set("static", false);
        reflect_EntityRenderer_method_switchUseShader_2.set("argnames", new String[]{});
        reflect_EntityRenderer_method_switchUseShader_2.set("argtypes", new String[]{});
        reflect_EntityRenderer_method_switchUseShader_2.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityRenderer) params.getReflective("_self")).switchUseShader();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityRenderer_methods.add(reflect_EntityRenderer_method_switchUseShader_2);


        BaseData reflect_EntityRenderer_method_loadEntityShader_3 = new ModData();
        reflect_EntityRenderer_method_loadEntityShader_3.set("methodName", "loadEntityShader");
        reflect_EntityRenderer_method_loadEntityShader_3.set("returnType", "void");
        reflect_EntityRenderer_method_loadEntityShader_3.set("static", false);
        reflect_EntityRenderer_method_loadEntityShader_3.set("argnames", new String[]{"entityIn"});
        reflect_EntityRenderer_method_loadEntityShader_3.set("argtypes", new String[]{"Entity"});
        reflect_EntityRenderer_method_loadEntityShader_3.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityRenderer) params.getReflective("_self")).loadEntityShader((Entity) params.getReflective("entityIn"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityRenderer_methods.add(reflect_EntityRenderer_method_loadEntityShader_3);


        BaseData reflect_EntityRenderer_method_activateNextShader_4 = new ModData();
        reflect_EntityRenderer_method_activateNextShader_4.set("methodName", "activateNextShader");
        reflect_EntityRenderer_method_activateNextShader_4.set("returnType", "void");
        reflect_EntityRenderer_method_activateNextShader_4.set("static", false);
        reflect_EntityRenderer_method_activateNextShader_4.set("argnames", new String[]{});
        reflect_EntityRenderer_method_activateNextShader_4.set("argtypes", new String[]{});
        reflect_EntityRenderer_method_activateNextShader_4.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityRenderer) params.getReflective("_self")).activateNextShader();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityRenderer_methods.add(reflect_EntityRenderer_method_activateNextShader_4);


        BaseData reflect_EntityRenderer_method_onResourceManagerReload_5 = new ModData();
        reflect_EntityRenderer_method_onResourceManagerReload_5.set("methodName", "onResourceManagerReload");
        reflect_EntityRenderer_method_onResourceManagerReload_5.set("returnType", "void");
        reflect_EntityRenderer_method_onResourceManagerReload_5.set("static", false);
        reflect_EntityRenderer_method_onResourceManagerReload_5.set("argnames", new String[]{"var1"});
        reflect_EntityRenderer_method_onResourceManagerReload_5.set("argtypes", new String[]{"IResourceManager"});
        reflect_EntityRenderer_method_onResourceManagerReload_5.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityRenderer) params.getReflective("_self")).onResourceManagerReload((IResourceManager) params.getReflective("var1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityRenderer_methods.add(reflect_EntityRenderer_method_onResourceManagerReload_5);


        BaseData reflect_EntityRenderer_method_updateRenderer_6 = new ModData();
        reflect_EntityRenderer_method_updateRenderer_6.set("methodName", "updateRenderer");
        reflect_EntityRenderer_method_updateRenderer_6.set("returnType", "void");
        reflect_EntityRenderer_method_updateRenderer_6.set("static", false);
        reflect_EntityRenderer_method_updateRenderer_6.set("argnames", new String[]{});
        reflect_EntityRenderer_method_updateRenderer_6.set("argtypes", new String[]{});
        reflect_EntityRenderer_method_updateRenderer_6.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityRenderer) params.getReflective("_self")).updateRenderer();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityRenderer_methods.add(reflect_EntityRenderer_method_updateRenderer_6);


        BaseData reflect_EntityRenderer_method_updateShaderGroupSize_7 = new ModData();
        reflect_EntityRenderer_method_updateShaderGroupSize_7.set("methodName", "updateShaderGroupSize");
        reflect_EntityRenderer_method_updateShaderGroupSize_7.set("returnType", "void");
        reflect_EntityRenderer_method_updateShaderGroupSize_7.set("static", false);
        reflect_EntityRenderer_method_updateShaderGroupSize_7.set("argnames", new String[]{"width", "height"});
        reflect_EntityRenderer_method_updateShaderGroupSize_7.set("argtypes", new String[]{"int", "int"});
        reflect_EntityRenderer_method_updateShaderGroupSize_7.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityRenderer) params.getReflective("_self")).updateShaderGroupSize((int) params.getInt("width"), (int) params.getInt("height"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityRenderer_methods.add(reflect_EntityRenderer_method_updateShaderGroupSize_7);


        BaseData reflect_EntityRenderer_method_getMouseOver_8 = new ModData();
        reflect_EntityRenderer_method_getMouseOver_8.set("methodName", "getMouseOver");
        reflect_EntityRenderer_method_getMouseOver_8.set("returnType", "void");
        reflect_EntityRenderer_method_getMouseOver_8.set("static", false);
        reflect_EntityRenderer_method_getMouseOver_8.set("argnames", new String[]{"partialTicks"});
        reflect_EntityRenderer_method_getMouseOver_8.set("argtypes", new String[]{"float"});
        reflect_EntityRenderer_method_getMouseOver_8.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityRenderer) params.getReflective("_self")).getMouseOver((float) params.getFloat("partialTicks"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityRenderer_methods.add(reflect_EntityRenderer_method_getMouseOver_8);


        BaseData reflect_EntityRenderer_method_getFOVModifier_9 = new ModData();
        reflect_EntityRenderer_method_getFOVModifier_9.set("methodName", "getFOVModifier");
        reflect_EntityRenderer_method_getFOVModifier_9.set("returnType", "float");
        reflect_EntityRenderer_method_getFOVModifier_9.set("static", false);
        reflect_EntityRenderer_method_getFOVModifier_9.set("argnames", new String[]{"partialTicks", "parFlag"});
        reflect_EntityRenderer_method_getFOVModifier_9.set("argtypes", new String[]{"float", "boolean"});
        reflect_EntityRenderer_method_getFOVModifier_9.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityRenderer) params.getReflective("_self")).getFOVModifier((float) params.getFloat("partialTicks"), (boolean) params.getBoolean("parFlag"));
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityRenderer_methods.add(reflect_EntityRenderer_method_getFOVModifier_9);


        BaseData reflect_EntityRenderer_method_setupCameraTransform_10 = new ModData();
        reflect_EntityRenderer_method_setupCameraTransform_10.set("methodName", "setupCameraTransform");
        reflect_EntityRenderer_method_setupCameraTransform_10.set("returnType", "void");
        reflect_EntityRenderer_method_setupCameraTransform_10.set("static", false);
        reflect_EntityRenderer_method_setupCameraTransform_10.set("argnames", new String[]{"partialTicks", "pass"});
        reflect_EntityRenderer_method_setupCameraTransform_10.set("argtypes", new String[]{"float", "int"});
        reflect_EntityRenderer_method_setupCameraTransform_10.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityRenderer) params.getReflective("_self")).setupCameraTransform((float) params.getFloat("partialTicks"), (int) params.getInt("pass"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityRenderer_methods.add(reflect_EntityRenderer_method_setupCameraTransform_10);


        BaseData reflect_EntityRenderer_method_disableLightmap_11 = new ModData();
        reflect_EntityRenderer_method_disableLightmap_11.set("methodName", "disableLightmap");
        reflect_EntityRenderer_method_disableLightmap_11.set("returnType", "void");
        reflect_EntityRenderer_method_disableLightmap_11.set("static", false);
        reflect_EntityRenderer_method_disableLightmap_11.set("argnames", new String[]{});
        reflect_EntityRenderer_method_disableLightmap_11.set("argtypes", new String[]{});
        reflect_EntityRenderer_method_disableLightmap_11.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityRenderer) params.getReflective("_self")).disableLightmap();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityRenderer_methods.add(reflect_EntityRenderer_method_disableLightmap_11);


        BaseData reflect_EntityRenderer_method_enableLightmap_12 = new ModData();
        reflect_EntityRenderer_method_enableLightmap_12.set("methodName", "enableLightmap");
        reflect_EntityRenderer_method_enableLightmap_12.set("returnType", "void");
        reflect_EntityRenderer_method_enableLightmap_12.set("static", false);
        reflect_EntityRenderer_method_enableLightmap_12.set("argnames", new String[]{});
        reflect_EntityRenderer_method_enableLightmap_12.set("argtypes", new String[]{});
        reflect_EntityRenderer_method_enableLightmap_12.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityRenderer) params.getReflective("_self")).enableLightmap();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityRenderer_methods.add(reflect_EntityRenderer_method_enableLightmap_12);


        BaseData reflect_EntityRenderer_method_disableLightmapStatic_13 = new ModData();
        reflect_EntityRenderer_method_disableLightmapStatic_13.set("methodName", "disableLightmapStatic");
        reflect_EntityRenderer_method_disableLightmapStatic_13.set("returnType", "void");
        reflect_EntityRenderer_method_disableLightmapStatic_13.set("static", true);
        reflect_EntityRenderer_method_disableLightmapStatic_13.set("argnames", new String[]{});
        reflect_EntityRenderer_method_disableLightmapStatic_13.set("argtypes", new String[]{});
        reflect_EntityRenderer_method_disableLightmapStatic_13.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    EntityRenderer.disableLightmapStatic();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityRenderer_methods.add(reflect_EntityRenderer_method_disableLightmapStatic_13);


        BaseData reflect_EntityRenderer_method_enableLightmapStatic_14 = new ModData();
        reflect_EntityRenderer_method_enableLightmapStatic_14.set("methodName", "enableLightmapStatic");
        reflect_EntityRenderer_method_enableLightmapStatic_14.set("returnType", "void");
        reflect_EntityRenderer_method_enableLightmapStatic_14.set("static", true);
        reflect_EntityRenderer_method_enableLightmapStatic_14.set("argnames", new String[]{});
        reflect_EntityRenderer_method_enableLightmapStatic_14.set("argtypes", new String[]{});
        reflect_EntityRenderer_method_enableLightmapStatic_14.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    EntityRenderer.enableLightmapStatic();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityRenderer_methods.add(reflect_EntityRenderer_method_enableLightmapStatic_14);


        BaseData reflect_EntityRenderer_method_func_181560_a_15 = new ModData();
        reflect_EntityRenderer_method_func_181560_a_15.set("methodName", "func_181560_a");
        reflect_EntityRenderer_method_func_181560_a_15.set("returnType", "void");
        reflect_EntityRenderer_method_func_181560_a_15.set("static", false);
        reflect_EntityRenderer_method_func_181560_a_15.set("argnames", new String[]{"parFloat1", "parLong1"});
        reflect_EntityRenderer_method_func_181560_a_15.set("argtypes", new String[]{"float", "long"});
        reflect_EntityRenderer_method_func_181560_a_15.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityRenderer) params.getReflective("_self")).func_181560_a((float) params.getFloat("parFloat1"), (long) params.getReflective("parLong1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityRenderer_methods.add(reflect_EntityRenderer_method_func_181560_a_15);


        BaseData reflect_EntityRenderer_method_renderStreamIndicator_16 = new ModData();
        reflect_EntityRenderer_method_renderStreamIndicator_16.set("methodName", "renderStreamIndicator");
        reflect_EntityRenderer_method_renderStreamIndicator_16.set("returnType", "void");
        reflect_EntityRenderer_method_renderStreamIndicator_16.set("static", false);
        reflect_EntityRenderer_method_renderStreamIndicator_16.set("argnames", new String[]{"partialTicks"});
        reflect_EntityRenderer_method_renderStreamIndicator_16.set("argtypes", new String[]{"float"});
        reflect_EntityRenderer_method_renderStreamIndicator_16.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityRenderer) params.getReflective("_self")).renderStreamIndicator((float) params.getFloat("partialTicks"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityRenderer_methods.add(reflect_EntityRenderer_method_renderStreamIndicator_16);


        BaseData reflect_EntityRenderer_method_renderWorld_17 = new ModData();
        reflect_EntityRenderer_method_renderWorld_17.set("methodName", "renderWorld");
        reflect_EntityRenderer_method_renderWorld_17.set("returnType", "void");
        reflect_EntityRenderer_method_renderWorld_17.set("static", false);
        reflect_EntityRenderer_method_renderWorld_17.set("argnames", new String[]{"partialTicks", "finishTimeNano"});
        reflect_EntityRenderer_method_renderWorld_17.set("argtypes", new String[]{"float", "long"});
        reflect_EntityRenderer_method_renderWorld_17.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityRenderer) params.getReflective("_self")).renderWorld((float) params.getFloat("partialTicks"), (long) params.getReflective("finishTimeNano"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityRenderer_methods.add(reflect_EntityRenderer_method_renderWorld_17);


        BaseData reflect_EntityRenderer_method_setupOverlayRendering_18 = new ModData();
        reflect_EntityRenderer_method_setupOverlayRendering_18.set("methodName", "setupOverlayRendering");
        reflect_EntityRenderer_method_setupOverlayRendering_18.set("returnType", "void");
        reflect_EntityRenderer_method_setupOverlayRendering_18.set("static", false);
        reflect_EntityRenderer_method_setupOverlayRendering_18.set("argnames", new String[]{});
        reflect_EntityRenderer_method_setupOverlayRendering_18.set("argtypes", new String[]{});
        reflect_EntityRenderer_method_setupOverlayRendering_18.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityRenderer) params.getReflective("_self")).setupOverlayRendering();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityRenderer_methods.add(reflect_EntityRenderer_method_setupOverlayRendering_18);


        BaseData reflect_EntityRenderer_method_getMapItemRenderer_19 = new ModData();
        reflect_EntityRenderer_method_getMapItemRenderer_19.set("methodName", "getMapItemRenderer");
        reflect_EntityRenderer_method_getMapItemRenderer_19.set("returnType", "MapItemRenderer");
        reflect_EntityRenderer_method_getMapItemRenderer_19.set("static", false);
        reflect_EntityRenderer_method_getMapItemRenderer_19.set("argnames", new String[]{});
        reflect_EntityRenderer_method_getMapItemRenderer_19.set("argtypes", new String[]{});
        reflect_EntityRenderer_method_getMapItemRenderer_19.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (MapItemRenderer) ((EntityRenderer) params.getReflective("_self")).getMapItemRenderer();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityRenderer_methods.add(reflect_EntityRenderer_method_getMapItemRenderer_19);


        BaseData reflect_EntityRenderer_method_renderHeldItemLight_20 = new ModData();
        reflect_EntityRenderer_method_renderHeldItemLight_20.set("methodName", "renderHeldItemLight");
        reflect_EntityRenderer_method_renderHeldItemLight_20.set("returnType", "boolean");
        reflect_EntityRenderer_method_renderHeldItemLight_20.set("static", false);
        reflect_EntityRenderer_method_renderHeldItemLight_20.set("argnames", new String[]{"entityLiving", "mag"});
        reflect_EntityRenderer_method_renderHeldItemLight_20.set("argtypes", new String[]{"EntityLivingBase", "float"});
        reflect_EntityRenderer_method_renderHeldItemLight_20.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityRenderer) params.getReflective("_self")).renderHeldItemLight((EntityLivingBase) params.getReflective("entityLiving"), (float) params.getFloat("mag"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityRenderer_methods.add(reflect_EntityRenderer_method_renderHeldItemLight_20);


        BaseData reflect_EntityRenderer_method_renderItemEntityLight_21 = new ModData();
        reflect_EntityRenderer_method_renderItemEntityLight_21.set("methodName", "renderItemEntityLight");
        reflect_EntityRenderer_method_renderItemEntityLight_21.set("returnType", "boolean");
        reflect_EntityRenderer_method_renderItemEntityLight_21.set("static", false);
        reflect_EntityRenderer_method_renderItemEntityLight_21.set("argnames", new String[]{"entity", "mag"});
        reflect_EntityRenderer_method_renderItemEntityLight_21.set("argtypes", new String[]{"Entity", "float"});
        reflect_EntityRenderer_method_renderItemEntityLight_21.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityRenderer) params.getReflective("_self")).renderItemEntityLight((Entity) params.getReflective("entity"), (float) params.getFloat("mag"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityRenderer_methods.add(reflect_EntityRenderer_method_renderItemEntityLight_21);


        BaseData reflect_EntityRenderer_method_setupSunCameraTransform_22 = new ModData();
        reflect_EntityRenderer_method_setupSunCameraTransform_22.set("methodName", "setupSunCameraTransform");
        reflect_EntityRenderer_method_setupSunCameraTransform_22.set("returnType", "void");
        reflect_EntityRenderer_method_setupSunCameraTransform_22.set("static", true);
        reflect_EntityRenderer_method_setupSunCameraTransform_22.set("argnames", new String[]{"celestialAngle"});
        reflect_EntityRenderer_method_setupSunCameraTransform_22.set("argtypes", new String[]{"float"});
        reflect_EntityRenderer_method_setupSunCameraTransform_22.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    EntityRenderer.setupSunCameraTransform((float) params.getFloat("celestialAngle"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityRenderer_methods.add(reflect_EntityRenderer_method_setupSunCameraTransform_22);


        BaseData[] reflect_EntityRenderer_methods_arr = new BaseData[reflect_EntityRenderer_methods.size()];
        for (int i = 0; i < reflect_EntityRenderer_methods_arr.length; i++) {
            reflect_EntityRenderer_methods_arr[i] = reflect_EntityRenderer_methods.get(i);
        }

        reflect_EntityRenderer.set("constructors", reflect_EntityRenderer_constructors_arr);
        reflect_EntityRenderer.set("methods", reflect_EntityRenderer_methods_arr);
        reflect_EntityRenderer.set("className", "EntityRenderer");
        reflect_EntityRenderer.set("classId", "net.minecraft.client.renderer.EntityRenderer");
        reflect_EntityRenderer.set("class", EntityRenderer.class);
        reflect_EntityRenderer.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityRenderer;
        });
        reflectProfiles.add(reflect_EntityRenderer);
    }


    //classdef for RenderGlobal
    public static void reflect_RenderGlobal_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_RenderGlobal = new ModData();

        ArrayList<BaseData> reflect_RenderGlobal_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_RenderGlobal_constructor_RenderGlobal_0 = new ModData();
        reflect_RenderGlobal_constructor_RenderGlobal_0.set("returnType", "RenderGlobal");
        reflect_RenderGlobal_constructor_RenderGlobal_0.set("argnames", new String[]{"mcIn"});
        reflect_RenderGlobal_constructor_RenderGlobal_0.set("argtypes", new String[]{"Minecraft"});
        reflect_RenderGlobal_constructor_RenderGlobal_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new RenderGlobal((Minecraft) params.getReflective("mcIn"));
        });
        
        reflect_RenderGlobal_constructors.add(reflect_RenderGlobal_constructor_RenderGlobal_0);


        BaseData[] reflect_RenderGlobal_constructors_arr = new BaseData[reflect_RenderGlobal_constructors.size()];
        for (int i = 0; i < reflect_RenderGlobal_constructors_arr.length; i++) {
            reflect_RenderGlobal_constructors_arr[i] = reflect_RenderGlobal_constructors.get(i);
        }

        ArrayList<BaseData> reflect_RenderGlobal_methods = new ArrayList<BaseData>();
        
        BaseData reflect_RenderGlobal_method_onResourceManagerReload_0 = new ModData();
        reflect_RenderGlobal_method_onResourceManagerReload_0.set("methodName", "onResourceManagerReload");
        reflect_RenderGlobal_method_onResourceManagerReload_0.set("returnType", "void");
        reflect_RenderGlobal_method_onResourceManagerReload_0.set("static", false);
        reflect_RenderGlobal_method_onResourceManagerReload_0.set("argnames", new String[]{"var1"});
        reflect_RenderGlobal_method_onResourceManagerReload_0.set("argtypes", new String[]{"IResourceManager"});
        reflect_RenderGlobal_method_onResourceManagerReload_0.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((RenderGlobal) params.getReflective("_self")).onResourceManagerReload((IResourceManager) params.getReflective("var1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_RenderGlobal_methods.add(reflect_RenderGlobal_method_onResourceManagerReload_0);


        BaseData reflect_RenderGlobal_method_makeEntityOutlineShader_1 = new ModData();
        reflect_RenderGlobal_method_makeEntityOutlineShader_1.set("methodName", "makeEntityOutlineShader");
        reflect_RenderGlobal_method_makeEntityOutlineShader_1.set("returnType", "void");
        reflect_RenderGlobal_method_makeEntityOutlineShader_1.set("static", false);
        reflect_RenderGlobal_method_makeEntityOutlineShader_1.set("argnames", new String[]{});
        reflect_RenderGlobal_method_makeEntityOutlineShader_1.set("argtypes", new String[]{});
        reflect_RenderGlobal_method_makeEntityOutlineShader_1.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((RenderGlobal) params.getReflective("_self")).makeEntityOutlineShader();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_RenderGlobal_methods.add(reflect_RenderGlobal_method_makeEntityOutlineShader_1);


        BaseData reflect_RenderGlobal_method_renderEntityOutlineFramebuffer_2 = new ModData();
        reflect_RenderGlobal_method_renderEntityOutlineFramebuffer_2.set("methodName", "renderEntityOutlineFramebuffer");
        reflect_RenderGlobal_method_renderEntityOutlineFramebuffer_2.set("returnType", "void");
        reflect_RenderGlobal_method_renderEntityOutlineFramebuffer_2.set("static", false);
        reflect_RenderGlobal_method_renderEntityOutlineFramebuffer_2.set("argnames", new String[]{});
        reflect_RenderGlobal_method_renderEntityOutlineFramebuffer_2.set("argtypes", new String[]{});
        reflect_RenderGlobal_method_renderEntityOutlineFramebuffer_2.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((RenderGlobal) params.getReflective("_self")).renderEntityOutlineFramebuffer();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_RenderGlobal_methods.add(reflect_RenderGlobal_method_renderEntityOutlineFramebuffer_2);


        BaseData reflect_RenderGlobal_method_setWorldAndLoadRenderers_3 = new ModData();
        reflect_RenderGlobal_method_setWorldAndLoadRenderers_3.set("methodName", "setWorldAndLoadRenderers");
        reflect_RenderGlobal_method_setWorldAndLoadRenderers_3.set("returnType", "void");
        reflect_RenderGlobal_method_setWorldAndLoadRenderers_3.set("static", false);
        reflect_RenderGlobal_method_setWorldAndLoadRenderers_3.set("argnames", new String[]{"worldClientIn"});
        reflect_RenderGlobal_method_setWorldAndLoadRenderers_3.set("argtypes", new String[]{"WorldClient"});
        reflect_RenderGlobal_method_setWorldAndLoadRenderers_3.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((RenderGlobal) params.getReflective("_self")).setWorldAndLoadRenderers((WorldClient) params.getReflective("worldClientIn"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_RenderGlobal_methods.add(reflect_RenderGlobal_method_setWorldAndLoadRenderers_3);


        BaseData reflect_RenderGlobal_method_loadRenderers_4 = new ModData();
        reflect_RenderGlobal_method_loadRenderers_4.set("methodName", "loadRenderers");
        reflect_RenderGlobal_method_loadRenderers_4.set("returnType", "void");
        reflect_RenderGlobal_method_loadRenderers_4.set("static", false);
        reflect_RenderGlobal_method_loadRenderers_4.set("argnames", new String[]{});
        reflect_RenderGlobal_method_loadRenderers_4.set("argtypes", new String[]{});
        reflect_RenderGlobal_method_loadRenderers_4.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((RenderGlobal) params.getReflective("_self")).loadRenderers();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_RenderGlobal_methods.add(reflect_RenderGlobal_method_loadRenderers_4);


        BaseData reflect_RenderGlobal_method_createBindEntityOutlineFbs_5 = new ModData();
        reflect_RenderGlobal_method_createBindEntityOutlineFbs_5.set("methodName", "createBindEntityOutlineFbs");
        reflect_RenderGlobal_method_createBindEntityOutlineFbs_5.set("returnType", "void");
        reflect_RenderGlobal_method_createBindEntityOutlineFbs_5.set("static", false);
        reflect_RenderGlobal_method_createBindEntityOutlineFbs_5.set("argnames", new String[]{"parInt1", "parInt2"});
        reflect_RenderGlobal_method_createBindEntityOutlineFbs_5.set("argtypes", new String[]{"int", "int"});
        reflect_RenderGlobal_method_createBindEntityOutlineFbs_5.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((RenderGlobal) params.getReflective("_self")).createBindEntityOutlineFbs((int) params.getInt("parInt1"), (int) params.getInt("parInt2"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_RenderGlobal_methods.add(reflect_RenderGlobal_method_createBindEntityOutlineFbs_5);


        BaseData reflect_RenderGlobal_method_renderEntities_6 = new ModData();
        reflect_RenderGlobal_method_renderEntities_6.set("methodName", "renderEntities");
        reflect_RenderGlobal_method_renderEntities_6.set("returnType", "void");
        reflect_RenderGlobal_method_renderEntities_6.set("static", false);
        reflect_RenderGlobal_method_renderEntities_6.set("argnames", new String[]{"renderViewEntity", "camera", "partialTicks"});
        reflect_RenderGlobal_method_renderEntities_6.set("argtypes", new String[]{"Entity", "ICamera", "float"});
        reflect_RenderGlobal_method_renderEntities_6.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((RenderGlobal) params.getReflective("_self")).renderEntities((Entity) params.getReflective("renderViewEntity"), (ICamera) params.getReflective("camera"), (float) params.getFloat("partialTicks"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_RenderGlobal_methods.add(reflect_RenderGlobal_method_renderEntities_6);


        BaseData reflect_RenderGlobal_method_renderParaboloidTileEntities_7 = new ModData();
        reflect_RenderGlobal_method_renderParaboloidTileEntities_7.set("methodName", "renderParaboloidTileEntities");
        reflect_RenderGlobal_method_renderParaboloidTileEntities_7.set("returnType", "void");
        reflect_RenderGlobal_method_renderParaboloidTileEntities_7.set("static", false);
        reflect_RenderGlobal_method_renderParaboloidTileEntities_7.set("argnames", new String[]{"renderViewEntity", "partialTicks", "up"});
        reflect_RenderGlobal_method_renderParaboloidTileEntities_7.set("argtypes", new String[]{"Entity", "float", "int"});
        reflect_RenderGlobal_method_renderParaboloidTileEntities_7.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((RenderGlobal) params.getReflective("_self")).renderParaboloidTileEntities((Entity) params.getReflective("renderViewEntity"), (float) params.getFloat("partialTicks"), (int) params.getInt("up"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_RenderGlobal_methods.add(reflect_RenderGlobal_method_renderParaboloidTileEntities_7);


        BaseData reflect_RenderGlobal_method_getDebugInfoRenders_8 = new ModData();
        reflect_RenderGlobal_method_getDebugInfoRenders_8.set("methodName", "getDebugInfoRenders");
        reflect_RenderGlobal_method_getDebugInfoRenders_8.set("returnType", "String");
        reflect_RenderGlobal_method_getDebugInfoRenders_8.set("static", false);
        reflect_RenderGlobal_method_getDebugInfoRenders_8.set("argnames", new String[]{});
        reflect_RenderGlobal_method_getDebugInfoRenders_8.set("argtypes", new String[]{});
        reflect_RenderGlobal_method_getDebugInfoRenders_8.setCallbackStringWithDataArg("exec", (BaseData params) -> {
                try {
                    return (String) ((RenderGlobal) params.getReflective("_self")).getDebugInfoRenders();
                } catch (Exception _exception_reflect_) {
                    return "";
                }
            });
            
        reflect_RenderGlobal_methods.add(reflect_RenderGlobal_method_getDebugInfoRenders_8);


        BaseData reflect_RenderGlobal_method_getDebugInfoEntities_9 = new ModData();
        reflect_RenderGlobal_method_getDebugInfoEntities_9.set("methodName", "getDebugInfoEntities");
        reflect_RenderGlobal_method_getDebugInfoEntities_9.set("returnType", "String");
        reflect_RenderGlobal_method_getDebugInfoEntities_9.set("static", false);
        reflect_RenderGlobal_method_getDebugInfoEntities_9.set("argnames", new String[]{});
        reflect_RenderGlobal_method_getDebugInfoEntities_9.set("argtypes", new String[]{});
        reflect_RenderGlobal_method_getDebugInfoEntities_9.setCallbackStringWithDataArg("exec", (BaseData params) -> {
                try {
                    return (String) ((RenderGlobal) params.getReflective("_self")).getDebugInfoEntities();
                } catch (Exception _exception_reflect_) {
                    return "";
                }
            });
            
        reflect_RenderGlobal_methods.add(reflect_RenderGlobal_method_getDebugInfoEntities_9);


        BaseData reflect_RenderGlobal_method_renderBlockLayer_10 = new ModData();
        reflect_RenderGlobal_method_renderBlockLayer_10.set("methodName", "renderBlockLayer");
        reflect_RenderGlobal_method_renderBlockLayer_10.set("returnType", "int");
        reflect_RenderGlobal_method_renderBlockLayer_10.set("static", false);
        reflect_RenderGlobal_method_renderBlockLayer_10.set("argnames", new String[]{"blockLayerIn", "partialTicks", "pass", "entityIn"});
        reflect_RenderGlobal_method_renderBlockLayer_10.set("argtypes", new String[]{"EnumWorldBlockLayer", "double", "int", "Entity"});
        reflect_RenderGlobal_method_renderBlockLayer_10.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((RenderGlobal) params.getReflective("_self")).renderBlockLayer((EnumWorldBlockLayer) params.getReflective("blockLayerIn"), (double) params.getDouble("partialTicks"), (int) params.getInt("pass"), (Entity) params.getReflective("entityIn"));
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_RenderGlobal_methods.add(reflect_RenderGlobal_method_renderBlockLayer_10);


        BaseData reflect_RenderGlobal_method_updateClouds_11 = new ModData();
        reflect_RenderGlobal_method_updateClouds_11.set("methodName", "updateClouds");
        reflect_RenderGlobal_method_updateClouds_11.set("returnType", "void");
        reflect_RenderGlobal_method_updateClouds_11.set("static", false);
        reflect_RenderGlobal_method_updateClouds_11.set("argnames", new String[]{});
        reflect_RenderGlobal_method_updateClouds_11.set("argtypes", new String[]{});
        reflect_RenderGlobal_method_updateClouds_11.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((RenderGlobal) params.getReflective("_self")).updateClouds();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_RenderGlobal_methods.add(reflect_RenderGlobal_method_updateClouds_11);


        BaseData reflect_RenderGlobal_method_renderSky_12 = new ModData();
        reflect_RenderGlobal_method_renderSky_12.set("methodName", "renderSky");
        reflect_RenderGlobal_method_renderSky_12.set("returnType", "void");
        reflect_RenderGlobal_method_renderSky_12.set("static", false);
        reflect_RenderGlobal_method_renderSky_12.set("argnames", new String[]{"partialTicks", "pass"});
        reflect_RenderGlobal_method_renderSky_12.set("argtypes", new String[]{"float", "int"});
        reflect_RenderGlobal_method_renderSky_12.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((RenderGlobal) params.getReflective("_self")).renderSky((float) params.getFloat("partialTicks"), (int) params.getInt("pass"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_RenderGlobal_methods.add(reflect_RenderGlobal_method_renderSky_12);


        BaseData reflect_RenderGlobal_method_renderClouds_13 = new ModData();
        reflect_RenderGlobal_method_renderClouds_13.set("methodName", "renderClouds");
        reflect_RenderGlobal_method_renderClouds_13.set("returnType", "void");
        reflect_RenderGlobal_method_renderClouds_13.set("static", false);
        reflect_RenderGlobal_method_renderClouds_13.set("argnames", new String[]{"partialTicks", "pass"});
        reflect_RenderGlobal_method_renderClouds_13.set("argtypes", new String[]{"float", "int"});
        reflect_RenderGlobal_method_renderClouds_13.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((RenderGlobal) params.getReflective("_self")).renderClouds((float) params.getFloat("partialTicks"), (int) params.getInt("pass"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_RenderGlobal_methods.add(reflect_RenderGlobal_method_renderClouds_13);


        BaseData reflect_RenderGlobal_method_hasCloudFog_14 = new ModData();
        reflect_RenderGlobal_method_hasCloudFog_14.set("methodName", "hasCloudFog");
        reflect_RenderGlobal_method_hasCloudFog_14.set("returnType", "boolean");
        reflect_RenderGlobal_method_hasCloudFog_14.set("static", false);
        reflect_RenderGlobal_method_hasCloudFog_14.set("argnames", new String[]{"x", "y", "z", "partialTicks"});
        reflect_RenderGlobal_method_hasCloudFog_14.set("argtypes", new String[]{"double", "double", "double", "float"});
        reflect_RenderGlobal_method_hasCloudFog_14.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((RenderGlobal) params.getReflective("_self")).hasCloudFog((double) params.getDouble("x"), (double) params.getDouble("y"), (double) params.getDouble("z"), (float) params.getFloat("partialTicks"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_RenderGlobal_methods.add(reflect_RenderGlobal_method_hasCloudFog_14);


        BaseData reflect_RenderGlobal_method_updateChunks_15 = new ModData();
        reflect_RenderGlobal_method_updateChunks_15.set("methodName", "updateChunks");
        reflect_RenderGlobal_method_updateChunks_15.set("returnType", "void");
        reflect_RenderGlobal_method_updateChunks_15.set("static", false);
        reflect_RenderGlobal_method_updateChunks_15.set("argnames", new String[]{"finishTimeNano"});
        reflect_RenderGlobal_method_updateChunks_15.set("argtypes", new String[]{"long"});
        reflect_RenderGlobal_method_updateChunks_15.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((RenderGlobal) params.getReflective("_self")).updateChunks((long) params.getReflective("finishTimeNano"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_RenderGlobal_methods.add(reflect_RenderGlobal_method_updateChunks_15);


        BaseData reflect_RenderGlobal_method_renderWorldBorder_16 = new ModData();
        reflect_RenderGlobal_method_renderWorldBorder_16.set("methodName", "renderWorldBorder");
        reflect_RenderGlobal_method_renderWorldBorder_16.set("returnType", "void");
        reflect_RenderGlobal_method_renderWorldBorder_16.set("static", false);
        reflect_RenderGlobal_method_renderWorldBorder_16.set("argnames", new String[]{"partialTicks", "parFloat1"});
        reflect_RenderGlobal_method_renderWorldBorder_16.set("argtypes", new String[]{"Entity", "float"});
        reflect_RenderGlobal_method_renderWorldBorder_16.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((RenderGlobal) params.getReflective("_self")).renderWorldBorder((Entity) params.getReflective("partialTicks"), (float) params.getFloat("parFloat1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_RenderGlobal_methods.add(reflect_RenderGlobal_method_renderWorldBorder_16);


        BaseData reflect_RenderGlobal_method_func_181561_a_17 = new ModData();
        reflect_RenderGlobal_method_func_181561_a_17.set("methodName", "func_181561_a");
        reflect_RenderGlobal_method_func_181561_a_17.set("returnType", "void");
        reflect_RenderGlobal_method_func_181561_a_17.set("static", true);
        reflect_RenderGlobal_method_func_181561_a_17.set("argnames", new String[]{"parAxisAlignedBB"});
        reflect_RenderGlobal_method_func_181561_a_17.set("argtypes", new String[]{"AxisAlignedBB"});
        reflect_RenderGlobal_method_func_181561_a_17.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    RenderGlobal.func_181561_a((AxisAlignedBB) params.getReflective("parAxisAlignedBB"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_RenderGlobal_methods.add(reflect_RenderGlobal_method_func_181561_a_17);


        BaseData reflect_RenderGlobal_method_markBlockForUpdate_18 = new ModData();
        reflect_RenderGlobal_method_markBlockForUpdate_18.set("methodName", "markBlockForUpdate");
        reflect_RenderGlobal_method_markBlockForUpdate_18.set("returnType", "void");
        reflect_RenderGlobal_method_markBlockForUpdate_18.set("static", false);
        reflect_RenderGlobal_method_markBlockForUpdate_18.set("argnames", new String[]{"blockpos"});
        reflect_RenderGlobal_method_markBlockForUpdate_18.set("argtypes", new String[]{"BlockPos"});
        reflect_RenderGlobal_method_markBlockForUpdate_18.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((RenderGlobal) params.getReflective("_self")).markBlockForUpdate((BlockPos) params.getReflective("blockpos"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_RenderGlobal_methods.add(reflect_RenderGlobal_method_markBlockForUpdate_18);


        BaseData reflect_RenderGlobal_method_notifyLightSet_19 = new ModData();
        reflect_RenderGlobal_method_notifyLightSet_19.set("methodName", "notifyLightSet");
        reflect_RenderGlobal_method_notifyLightSet_19.set("returnType", "void");
        reflect_RenderGlobal_method_notifyLightSet_19.set("static", false);
        reflect_RenderGlobal_method_notifyLightSet_19.set("argnames", new String[]{"blockpos"});
        reflect_RenderGlobal_method_notifyLightSet_19.set("argtypes", new String[]{"BlockPos"});
        reflect_RenderGlobal_method_notifyLightSet_19.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((RenderGlobal) params.getReflective("_self")).notifyLightSet((BlockPos) params.getReflective("blockpos"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_RenderGlobal_methods.add(reflect_RenderGlobal_method_notifyLightSet_19);


        BaseData reflect_RenderGlobal_method_markBlockRangeForRenderUpdate_20 = new ModData();
        reflect_RenderGlobal_method_markBlockRangeForRenderUpdate_20.set("methodName", "markBlockRangeForRenderUpdate");
        reflect_RenderGlobal_method_markBlockRangeForRenderUpdate_20.set("returnType", "void");
        reflect_RenderGlobal_method_markBlockRangeForRenderUpdate_20.set("static", false);
        reflect_RenderGlobal_method_markBlockRangeForRenderUpdate_20.set("argnames", new String[]{"i", "j", "k", "l", "i1", "j1"});
        reflect_RenderGlobal_method_markBlockRangeForRenderUpdate_20.set("argtypes", new String[]{"int", "int", "int", "int", "int", "int"});
        reflect_RenderGlobal_method_markBlockRangeForRenderUpdate_20.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((RenderGlobal) params.getReflective("_self")).markBlockRangeForRenderUpdate((int) params.getInt("i"), (int) params.getInt("j"), (int) params.getInt("k"), (int) params.getInt("l"), (int) params.getInt("i1"), (int) params.getInt("j1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_RenderGlobal_methods.add(reflect_RenderGlobal_method_markBlockRangeForRenderUpdate_20);


        BaseData reflect_RenderGlobal_method_playRecord_21 = new ModData();
        reflect_RenderGlobal_method_playRecord_21.set("methodName", "playRecord");
        reflect_RenderGlobal_method_playRecord_21.set("returnType", "void");
        reflect_RenderGlobal_method_playRecord_21.set("static", false);
        reflect_RenderGlobal_method_playRecord_21.set("argnames", new String[]{"s", "blockpos"});
        reflect_RenderGlobal_method_playRecord_21.set("argtypes", new String[]{"String", "BlockPos"});
        reflect_RenderGlobal_method_playRecord_21.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((RenderGlobal) params.getReflective("_self")).playRecord((String) params.getString("s"), (BlockPos) params.getReflective("blockpos"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_RenderGlobal_methods.add(reflect_RenderGlobal_method_playRecord_21);


        BaseData reflect_RenderGlobal_method_playSound_22 = new ModData();
        reflect_RenderGlobal_method_playSound_22.set("methodName", "playSound");
        reflect_RenderGlobal_method_playSound_22.set("returnType", "void");
        reflect_RenderGlobal_method_playSound_22.set("static", false);
        reflect_RenderGlobal_method_playSound_22.set("argnames", new String[]{"var1", "var2", "var4", "var6", "var8", "var9"});
        reflect_RenderGlobal_method_playSound_22.set("argtypes", new String[]{"String", "double", "double", "double", "float", "float"});
        reflect_RenderGlobal_method_playSound_22.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((RenderGlobal) params.getReflective("_self")).playSound((String) params.getString("var1"), (double) params.getDouble("var2"), (double) params.getDouble("var4"), (double) params.getDouble("var6"), (float) params.getFloat("var8"), (float) params.getFloat("var9"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_RenderGlobal_methods.add(reflect_RenderGlobal_method_playSound_22);


        BaseData reflect_RenderGlobal_method_onEntityAdded_23 = new ModData();
        reflect_RenderGlobal_method_onEntityAdded_23.set("methodName", "onEntityAdded");
        reflect_RenderGlobal_method_onEntityAdded_23.set("returnType", "void");
        reflect_RenderGlobal_method_onEntityAdded_23.set("static", false);
        reflect_RenderGlobal_method_onEntityAdded_23.set("argnames", new String[]{"var1"});
        reflect_RenderGlobal_method_onEntityAdded_23.set("argtypes", new String[]{"Entity"});
        reflect_RenderGlobal_method_onEntityAdded_23.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((RenderGlobal) params.getReflective("_self")).onEntityAdded((Entity) params.getReflective("var1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_RenderGlobal_methods.add(reflect_RenderGlobal_method_onEntityAdded_23);


        BaseData reflect_RenderGlobal_method_onEntityRemoved_24 = new ModData();
        reflect_RenderGlobal_method_onEntityRemoved_24.set("methodName", "onEntityRemoved");
        reflect_RenderGlobal_method_onEntityRemoved_24.set("returnType", "void");
        reflect_RenderGlobal_method_onEntityRemoved_24.set("static", false);
        reflect_RenderGlobal_method_onEntityRemoved_24.set("argnames", new String[]{"var1"});
        reflect_RenderGlobal_method_onEntityRemoved_24.set("argtypes", new String[]{"Entity"});
        reflect_RenderGlobal_method_onEntityRemoved_24.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((RenderGlobal) params.getReflective("_self")).onEntityRemoved((Entity) params.getReflective("var1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_RenderGlobal_methods.add(reflect_RenderGlobal_method_onEntityRemoved_24);


        BaseData reflect_RenderGlobal_method_deleteAllDisplayLists_25 = new ModData();
        reflect_RenderGlobal_method_deleteAllDisplayLists_25.set("methodName", "deleteAllDisplayLists");
        reflect_RenderGlobal_method_deleteAllDisplayLists_25.set("returnType", "void");
        reflect_RenderGlobal_method_deleteAllDisplayLists_25.set("static", false);
        reflect_RenderGlobal_method_deleteAllDisplayLists_25.set("argnames", new String[]{});
        reflect_RenderGlobal_method_deleteAllDisplayLists_25.set("argtypes", new String[]{});
        reflect_RenderGlobal_method_deleteAllDisplayLists_25.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((RenderGlobal) params.getReflective("_self")).deleteAllDisplayLists();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_RenderGlobal_methods.add(reflect_RenderGlobal_method_deleteAllDisplayLists_25);


        BaseData reflect_RenderGlobal_method_broadcastSound_26 = new ModData();
        reflect_RenderGlobal_method_broadcastSound_26.set("methodName", "broadcastSound");
        reflect_RenderGlobal_method_broadcastSound_26.set("returnType", "void");
        reflect_RenderGlobal_method_broadcastSound_26.set("static", false);
        reflect_RenderGlobal_method_broadcastSound_26.set("argnames", new String[]{"i", "blockpos", "var3"});
        reflect_RenderGlobal_method_broadcastSound_26.set("argtypes", new String[]{"int", "BlockPos", "int"});
        reflect_RenderGlobal_method_broadcastSound_26.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((RenderGlobal) params.getReflective("_self")).broadcastSound((int) params.getInt("i"), (BlockPos) params.getReflective("blockpos"), (int) params.getInt("var3"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_RenderGlobal_methods.add(reflect_RenderGlobal_method_broadcastSound_26);


        BaseData reflect_RenderGlobal_method_playAuxSFX_27 = new ModData();
        reflect_RenderGlobal_method_playAuxSFX_27.set("methodName", "playAuxSFX");
        reflect_RenderGlobal_method_playAuxSFX_27.set("returnType", "void");
        reflect_RenderGlobal_method_playAuxSFX_27.set("static", false);
        reflect_RenderGlobal_method_playAuxSFX_27.set("argnames", new String[]{"var1", "i", "blockpos", "j"});
        reflect_RenderGlobal_method_playAuxSFX_27.set("argtypes", new String[]{"EntityPlayer", "int", "BlockPos", "int"});
        reflect_RenderGlobal_method_playAuxSFX_27.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((RenderGlobal) params.getReflective("_self")).playAuxSFX((EntityPlayer) params.getReflective("var1"), (int) params.getInt("i"), (BlockPos) params.getReflective("blockpos"), (int) params.getInt("j"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_RenderGlobal_methods.add(reflect_RenderGlobal_method_playAuxSFX_27);


        BaseData reflect_RenderGlobal_method_sendBlockBreakProgress_28 = new ModData();
        reflect_RenderGlobal_method_sendBlockBreakProgress_28.set("methodName", "sendBlockBreakProgress");
        reflect_RenderGlobal_method_sendBlockBreakProgress_28.set("returnType", "void");
        reflect_RenderGlobal_method_sendBlockBreakProgress_28.set("static", false);
        reflect_RenderGlobal_method_sendBlockBreakProgress_28.set("argnames", new String[]{"i", "blockpos", "j"});
        reflect_RenderGlobal_method_sendBlockBreakProgress_28.set("argtypes", new String[]{"int", "BlockPos", "int"});
        reflect_RenderGlobal_method_sendBlockBreakProgress_28.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((RenderGlobal) params.getReflective("_self")).sendBlockBreakProgress((int) params.getInt("i"), (BlockPos) params.getReflective("blockpos"), (int) params.getInt("j"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_RenderGlobal_methods.add(reflect_RenderGlobal_method_sendBlockBreakProgress_28);


        BaseData reflect_RenderGlobal_method_setDisplayListEntitiesDirty_29 = new ModData();
        reflect_RenderGlobal_method_setDisplayListEntitiesDirty_29.set("methodName", "setDisplayListEntitiesDirty");
        reflect_RenderGlobal_method_setDisplayListEntitiesDirty_29.set("returnType", "void");
        reflect_RenderGlobal_method_setDisplayListEntitiesDirty_29.set("static", false);
        reflect_RenderGlobal_method_setDisplayListEntitiesDirty_29.set("argnames", new String[]{});
        reflect_RenderGlobal_method_setDisplayListEntitiesDirty_29.set("argtypes", new String[]{});
        reflect_RenderGlobal_method_setDisplayListEntitiesDirty_29.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((RenderGlobal) params.getReflective("_self")).setDisplayListEntitiesDirty();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_RenderGlobal_methods.add(reflect_RenderGlobal_method_setDisplayListEntitiesDirty_29);


        BaseData reflect_RenderGlobal_method_getDebugInfoShort_30 = new ModData();
        reflect_RenderGlobal_method_getDebugInfoShort_30.set("methodName", "getDebugInfoShort");
        reflect_RenderGlobal_method_getDebugInfoShort_30.set("returnType", "String");
        reflect_RenderGlobal_method_getDebugInfoShort_30.set("static", false);
        reflect_RenderGlobal_method_getDebugInfoShort_30.set("argnames", new String[]{});
        reflect_RenderGlobal_method_getDebugInfoShort_30.set("argtypes", new String[]{});
        reflect_RenderGlobal_method_getDebugInfoShort_30.setCallbackStringWithDataArg("exec", (BaseData params) -> {
                try {
                    return (String) ((RenderGlobal) params.getReflective("_self")).getDebugInfoShort();
                } catch (Exception _exception_reflect_) {
                    return "";
                }
            });
            
        reflect_RenderGlobal_methods.add(reflect_RenderGlobal_method_getDebugInfoShort_30);


        BaseData[] reflect_RenderGlobal_methods_arr = new BaseData[reflect_RenderGlobal_methods.size()];
        for (int i = 0; i < reflect_RenderGlobal_methods_arr.length; i++) {
            reflect_RenderGlobal_methods_arr[i] = reflect_RenderGlobal_methods.get(i);
        }

        reflect_RenderGlobal.set("constructors", reflect_RenderGlobal_constructors_arr);
        reflect_RenderGlobal.set("methods", reflect_RenderGlobal_methods_arr);
        reflect_RenderGlobal.set("className", "RenderGlobal");
        reflect_RenderGlobal.set("classId", "net.minecraft.client.renderer.RenderGlobal");
        reflect_RenderGlobal.set("class", RenderGlobal.class);
        reflect_RenderGlobal.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof RenderGlobal;
        });
        reflectProfiles.add(reflect_RenderGlobal);
    }


    //classdef for Tessellator
    public static void reflect_Tessellator_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_Tessellator = new ModData();

        ArrayList<BaseData> reflect_Tessellator_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_Tessellator_constructor_Tessellator_0 = new ModData();
        reflect_Tessellator_constructor_Tessellator_0.set("returnType", "Tessellator");
        reflect_Tessellator_constructor_Tessellator_0.set("argnames", new String[]{"bufferSize"});
        reflect_Tessellator_constructor_Tessellator_0.set("argtypes", new String[]{"int"});
        reflect_Tessellator_constructor_Tessellator_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new Tessellator((int) params.getInt("bufferSize"));
        });
        
        reflect_Tessellator_constructors.add(reflect_Tessellator_constructor_Tessellator_0);


        BaseData[] reflect_Tessellator_constructors_arr = new BaseData[reflect_Tessellator_constructors.size()];
        for (int i = 0; i < reflect_Tessellator_constructors_arr.length; i++) {
            reflect_Tessellator_constructors_arr[i] = reflect_Tessellator_constructors.get(i);
        }

        ArrayList<BaseData> reflect_Tessellator_methods = new ArrayList<BaseData>();
        
        BaseData reflect_Tessellator_method_getInstance_0 = new ModData();
        reflect_Tessellator_method_getInstance_0.set("methodName", "getInstance");
        reflect_Tessellator_method_getInstance_0.set("returnType", "Tessellator");
        reflect_Tessellator_method_getInstance_0.set("static", true);
        reflect_Tessellator_method_getInstance_0.set("argnames", new String[]{});
        reflect_Tessellator_method_getInstance_0.set("argtypes", new String[]{});
        reflect_Tessellator_method_getInstance_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Tessellator) Tessellator.getInstance();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Tessellator_methods.add(reflect_Tessellator_method_getInstance_0);


        BaseData reflect_Tessellator_method_draw_1 = new ModData();
        reflect_Tessellator_method_draw_1.set("methodName", "draw");
        reflect_Tessellator_method_draw_1.set("returnType", "void");
        reflect_Tessellator_method_draw_1.set("static", false);
        reflect_Tessellator_method_draw_1.set("argnames", new String[]{});
        reflect_Tessellator_method_draw_1.set("argtypes", new String[]{});
        reflect_Tessellator_method_draw_1.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((Tessellator) params.getReflective("_self")).draw();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_Tessellator_methods.add(reflect_Tessellator_method_draw_1);


        BaseData reflect_Tessellator_method_getWorldRenderer_2 = new ModData();
        reflect_Tessellator_method_getWorldRenderer_2.set("methodName", "getWorldRenderer");
        reflect_Tessellator_method_getWorldRenderer_2.set("returnType", "WorldRenderer");
        reflect_Tessellator_method_getWorldRenderer_2.set("static", false);
        reflect_Tessellator_method_getWorldRenderer_2.set("argnames", new String[]{});
        reflect_Tessellator_method_getWorldRenderer_2.set("argtypes", new String[]{});
        reflect_Tessellator_method_getWorldRenderer_2.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (WorldRenderer) ((Tessellator) params.getReflective("_self")).getWorldRenderer();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_Tessellator_methods.add(reflect_Tessellator_method_getWorldRenderer_2);


        BaseData[] reflect_Tessellator_methods_arr = new BaseData[reflect_Tessellator_methods.size()];
        for (int i = 0; i < reflect_Tessellator_methods_arr.length; i++) {
            reflect_Tessellator_methods_arr[i] = reflect_Tessellator_methods.get(i);
        }

        reflect_Tessellator.set("constructors", reflect_Tessellator_constructors_arr);
        reflect_Tessellator.set("methods", reflect_Tessellator_methods_arr);
        reflect_Tessellator.set("className", "Tessellator");
        reflect_Tessellator.set("classId", "net.minecraft.client.renderer.Tessellator");
        reflect_Tessellator.set("class", Tessellator.class);
        reflect_Tessellator.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof Tessellator;
        });
        reflectProfiles.add(reflect_Tessellator);
    }


    //classdef for RenderManager
    public static void reflect_RenderManager_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_RenderManager = new ModData();

        ArrayList<BaseData> reflect_RenderManager_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_RenderManager_constructor_RenderManager_0 = new ModData();
        reflect_RenderManager_constructor_RenderManager_0.set("returnType", "RenderManager");
        reflect_RenderManager_constructor_RenderManager_0.set("argnames", new String[]{"renderEngineIn", "itemRendererIn"});
        reflect_RenderManager_constructor_RenderManager_0.set("argtypes", new String[]{"TextureManager", "RenderItem"});
        reflect_RenderManager_constructor_RenderManager_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new RenderManager((TextureManager) params.getReflective("renderEngineIn"), (RenderItem) params.getReflective("itemRendererIn"));
        });
        
        reflect_RenderManager_constructors.add(reflect_RenderManager_constructor_RenderManager_0);


        BaseData[] reflect_RenderManager_constructors_arr = new BaseData[reflect_RenderManager_constructors.size()];
        for (int i = 0; i < reflect_RenderManager_constructors_arr.length; i++) {
            reflect_RenderManager_constructors_arr[i] = reflect_RenderManager_constructors.get(i);
        }

        ArrayList<BaseData> reflect_RenderManager_methods = new ArrayList<BaseData>();
        
        BaseData reflect_RenderManager_method_setEnableFNAWSkins_0 = new ModData();
        reflect_RenderManager_method_setEnableFNAWSkins_0.set("methodName", "setEnableFNAWSkins");
        reflect_RenderManager_method_setEnableFNAWSkins_0.set("returnType", "void");
        reflect_RenderManager_method_setEnableFNAWSkins_0.set("static", false);
        reflect_RenderManager_method_setEnableFNAWSkins_0.set("argnames", new String[]{"en"});
        reflect_RenderManager_method_setEnableFNAWSkins_0.set("argtypes", new String[]{"boolean"});
        reflect_RenderManager_method_setEnableFNAWSkins_0.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((RenderManager) params.getReflective("_self")).setEnableFNAWSkins((boolean) params.getBoolean("en"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_RenderManager_methods.add(reflect_RenderManager_method_setEnableFNAWSkins_0);


        BaseData reflect_RenderManager_method_setRenderPosition_1 = new ModData();
        reflect_RenderManager_method_setRenderPosition_1.set("methodName", "setRenderPosition");
        reflect_RenderManager_method_setRenderPosition_1.set("returnType", "void");
        reflect_RenderManager_method_setRenderPosition_1.set("static", false);
        reflect_RenderManager_method_setRenderPosition_1.set("argnames", new String[]{"renderPosXIn", "renderPosYIn", "renderPosZIn"});
        reflect_RenderManager_method_setRenderPosition_1.set("argtypes", new String[]{"double", "double", "double"});
        reflect_RenderManager_method_setRenderPosition_1.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((RenderManager) params.getReflective("_self")).setRenderPosition((double) params.getDouble("renderPosXIn"), (double) params.getDouble("renderPosYIn"), (double) params.getDouble("renderPosZIn"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_RenderManager_methods.add(reflect_RenderManager_method_setRenderPosition_1);


        BaseData reflect_RenderManager_method_setPlayerViewY_2 = new ModData();
        reflect_RenderManager_method_setPlayerViewY_2.set("methodName", "setPlayerViewY");
        reflect_RenderManager_method_setPlayerViewY_2.set("returnType", "void");
        reflect_RenderManager_method_setPlayerViewY_2.set("static", false);
        reflect_RenderManager_method_setPlayerViewY_2.set("argnames", new String[]{"playerViewYIn"});
        reflect_RenderManager_method_setPlayerViewY_2.set("argtypes", new String[]{"float"});
        reflect_RenderManager_method_setPlayerViewY_2.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((RenderManager) params.getReflective("_self")).setPlayerViewY((float) params.getFloat("playerViewYIn"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_RenderManager_methods.add(reflect_RenderManager_method_setPlayerViewY_2);


        BaseData reflect_RenderManager_method_isRenderShadow_3 = new ModData();
        reflect_RenderManager_method_isRenderShadow_3.set("methodName", "isRenderShadow");
        reflect_RenderManager_method_isRenderShadow_3.set("returnType", "boolean");
        reflect_RenderManager_method_isRenderShadow_3.set("static", false);
        reflect_RenderManager_method_isRenderShadow_3.set("argnames", new String[]{});
        reflect_RenderManager_method_isRenderShadow_3.set("argtypes", new String[]{});
        reflect_RenderManager_method_isRenderShadow_3.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((RenderManager) params.getReflective("_self")).isRenderShadow();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_RenderManager_methods.add(reflect_RenderManager_method_isRenderShadow_3);


        BaseData reflect_RenderManager_method_setRenderShadow_4 = new ModData();
        reflect_RenderManager_method_setRenderShadow_4.set("methodName", "setRenderShadow");
        reflect_RenderManager_method_setRenderShadow_4.set("returnType", "void");
        reflect_RenderManager_method_setRenderShadow_4.set("static", false);
        reflect_RenderManager_method_setRenderShadow_4.set("argnames", new String[]{"renderShadowIn"});
        reflect_RenderManager_method_setRenderShadow_4.set("argtypes", new String[]{"boolean"});
        reflect_RenderManager_method_setRenderShadow_4.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((RenderManager) params.getReflective("_self")).setRenderShadow((boolean) params.getBoolean("renderShadowIn"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_RenderManager_methods.add(reflect_RenderManager_method_setRenderShadow_4);


        BaseData reflect_RenderManager_method_setDebugBoundingBox_5 = new ModData();
        reflect_RenderManager_method_setDebugBoundingBox_5.set("methodName", "setDebugBoundingBox");
        reflect_RenderManager_method_setDebugBoundingBox_5.set("returnType", "void");
        reflect_RenderManager_method_setDebugBoundingBox_5.set("static", false);
        reflect_RenderManager_method_setDebugBoundingBox_5.set("argnames", new String[]{"debugBoundingBoxIn"});
        reflect_RenderManager_method_setDebugBoundingBox_5.set("argtypes", new String[]{"boolean"});
        reflect_RenderManager_method_setDebugBoundingBox_5.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((RenderManager) params.getReflective("_self")).setDebugBoundingBox((boolean) params.getBoolean("debugBoundingBoxIn"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_RenderManager_methods.add(reflect_RenderManager_method_setDebugBoundingBox_5);


        BaseData reflect_RenderManager_method_isDebugBoundingBox_6 = new ModData();
        reflect_RenderManager_method_isDebugBoundingBox_6.set("methodName", "isDebugBoundingBox");
        reflect_RenderManager_method_isDebugBoundingBox_6.set("returnType", "boolean");
        reflect_RenderManager_method_isDebugBoundingBox_6.set("static", false);
        reflect_RenderManager_method_isDebugBoundingBox_6.set("argnames", new String[]{});
        reflect_RenderManager_method_isDebugBoundingBox_6.set("argtypes", new String[]{});
        reflect_RenderManager_method_isDebugBoundingBox_6.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((RenderManager) params.getReflective("_self")).isDebugBoundingBox();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_RenderManager_methods.add(reflect_RenderManager_method_isDebugBoundingBox_6);


        BaseData reflect_RenderManager_method_renderEntitySimple_7 = new ModData();
        reflect_RenderManager_method_renderEntitySimple_7.set("methodName", "renderEntitySimple");
        reflect_RenderManager_method_renderEntitySimple_7.set("returnType", "boolean");
        reflect_RenderManager_method_renderEntitySimple_7.set("static", false);
        reflect_RenderManager_method_renderEntitySimple_7.set("argnames", new String[]{"entityIn", "partialTicks"});
        reflect_RenderManager_method_renderEntitySimple_7.set("argtypes", new String[]{"Entity", "float"});
        reflect_RenderManager_method_renderEntitySimple_7.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((RenderManager) params.getReflective("_self")).renderEntitySimple((Entity) params.getReflective("entityIn"), (float) params.getFloat("partialTicks"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_RenderManager_methods.add(reflect_RenderManager_method_renderEntitySimple_7);


        BaseData reflect_RenderManager_method_shouldRender_8 = new ModData();
        reflect_RenderManager_method_shouldRender_8.set("methodName", "shouldRender");
        reflect_RenderManager_method_shouldRender_8.set("returnType", "boolean");
        reflect_RenderManager_method_shouldRender_8.set("static", false);
        reflect_RenderManager_method_shouldRender_8.set("argnames", new String[]{"entityIn", "camera", "camX", "camY", "camZ"});
        reflect_RenderManager_method_shouldRender_8.set("argtypes", new String[]{"Entity", "ICamera", "double", "double", "double"});
        reflect_RenderManager_method_shouldRender_8.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((RenderManager) params.getReflective("_self")).shouldRender((Entity) params.getReflective("entityIn"), (ICamera) params.getReflective("camera"), (double) params.getDouble("camX"), (double) params.getDouble("camY"), (double) params.getDouble("camZ"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_RenderManager_methods.add(reflect_RenderManager_method_shouldRender_8);


        BaseData reflect_RenderManager_method_renderEntityStatic_9 = new ModData();
        reflect_RenderManager_method_renderEntityStatic_9.set("methodName", "renderEntityStatic");
        reflect_RenderManager_method_renderEntityStatic_9.set("returnType", "boolean");
        reflect_RenderManager_method_renderEntityStatic_9.set("static", false);
        reflect_RenderManager_method_renderEntityStatic_9.set("argnames", new String[]{"entity", "partialTicks", "parFlag"});
        reflect_RenderManager_method_renderEntityStatic_9.set("argtypes", new String[]{"Entity", "float", "boolean"});
        reflect_RenderManager_method_renderEntityStatic_9.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((RenderManager) params.getReflective("_self")).renderEntityStatic((Entity) params.getReflective("entity"), (float) params.getFloat("partialTicks"), (boolean) params.getBoolean("parFlag"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_RenderManager_methods.add(reflect_RenderManager_method_renderEntityStatic_9);


        BaseData reflect_RenderManager_method_setupLightmapCoords_10 = new ModData();
        reflect_RenderManager_method_setupLightmapCoords_10.set("methodName", "setupLightmapCoords");
        reflect_RenderManager_method_setupLightmapCoords_10.set("returnType", "void");
        reflect_RenderManager_method_setupLightmapCoords_10.set("static", true);
        reflect_RenderManager_method_setupLightmapCoords_10.set("argnames", new String[]{"entity", "partialTicks"});
        reflect_RenderManager_method_setupLightmapCoords_10.set("argtypes", new String[]{"Entity", "float"});
        reflect_RenderManager_method_setupLightmapCoords_10.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    RenderManager.setupLightmapCoords((Entity) params.getReflective("entity"), (float) params.getFloat("partialTicks"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_RenderManager_methods.add(reflect_RenderManager_method_setupLightmapCoords_10);


        BaseData reflect_RenderManager_method_renderWitherSkull_11 = new ModData();
        reflect_RenderManager_method_renderWitherSkull_11.set("methodName", "renderWitherSkull");
        reflect_RenderManager_method_renderWitherSkull_11.set("returnType", "void");
        reflect_RenderManager_method_renderWitherSkull_11.set("static", false);
        reflect_RenderManager_method_renderWitherSkull_11.set("argnames", new String[]{"entityIn", "partialTicks"});
        reflect_RenderManager_method_renderWitherSkull_11.set("argtypes", new String[]{"Entity", "float"});
        reflect_RenderManager_method_renderWitherSkull_11.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((RenderManager) params.getReflective("_self")).renderWitherSkull((Entity) params.getReflective("entityIn"), (float) params.getFloat("partialTicks"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_RenderManager_methods.add(reflect_RenderManager_method_renderWitherSkull_11);


        BaseData reflect_RenderManager_method_set_12 = new ModData();
        reflect_RenderManager_method_set_12.set("methodName", "set");
        reflect_RenderManager_method_set_12.set("returnType", "void");
        reflect_RenderManager_method_set_12.set("static", false);
        reflect_RenderManager_method_set_12.set("argnames", new String[]{"worldIn"});
        reflect_RenderManager_method_set_12.set("argtypes", new String[]{"World"});
        reflect_RenderManager_method_set_12.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((RenderManager) params.getReflective("_self")).set((World) params.getReflective("worldIn"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_RenderManager_methods.add(reflect_RenderManager_method_set_12);


        BaseData reflect_RenderManager_method_getDistanceToCamera_13 = new ModData();
        reflect_RenderManager_method_getDistanceToCamera_13.set("methodName", "getDistanceToCamera");
        reflect_RenderManager_method_getDistanceToCamera_13.set("returnType", "double");
        reflect_RenderManager_method_getDistanceToCamera_13.set("static", false);
        reflect_RenderManager_method_getDistanceToCamera_13.set("argnames", new String[]{"parDouble1", "parDouble2", "parDouble3"});
        reflect_RenderManager_method_getDistanceToCamera_13.set("argtypes", new String[]{"double", "double", "double"});
        reflect_RenderManager_method_getDistanceToCamera_13.setCallbackDoubleWithDataArg("exec", (BaseData params) -> {
                try {
                    return (double) ((RenderManager) params.getReflective("_self")).getDistanceToCamera((double) params.getDouble("parDouble1"), (double) params.getDouble("parDouble2"), (double) params.getDouble("parDouble3"));
                } catch (Exception _exception_reflect_) {
                    return 0.0d;
                }
            });
            
        reflect_RenderManager_methods.add(reflect_RenderManager_method_getDistanceToCamera_13);


        BaseData reflect_RenderManager_method_getFontRenderer_14 = new ModData();
        reflect_RenderManager_method_getFontRenderer_14.set("methodName", "getFontRenderer");
        reflect_RenderManager_method_getFontRenderer_14.set("returnType", "FontRenderer");
        reflect_RenderManager_method_getFontRenderer_14.set("static", false);
        reflect_RenderManager_method_getFontRenderer_14.set("argnames", new String[]{});
        reflect_RenderManager_method_getFontRenderer_14.set("argtypes", new String[]{});
        reflect_RenderManager_method_getFontRenderer_14.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (FontRenderer) ((RenderManager) params.getReflective("_self")).getFontRenderer();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_RenderManager_methods.add(reflect_RenderManager_method_getFontRenderer_14);


        BaseData reflect_RenderManager_method_setRenderOutlines_15 = new ModData();
        reflect_RenderManager_method_setRenderOutlines_15.set("methodName", "setRenderOutlines");
        reflect_RenderManager_method_setRenderOutlines_15.set("returnType", "void");
        reflect_RenderManager_method_setRenderOutlines_15.set("static", false);
        reflect_RenderManager_method_setRenderOutlines_15.set("argnames", new String[]{"renderOutlinesIn"});
        reflect_RenderManager_method_setRenderOutlines_15.set("argtypes", new String[]{"boolean"});
        reflect_RenderManager_method_setRenderOutlines_15.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((RenderManager) params.getReflective("_self")).setRenderOutlines((boolean) params.getBoolean("renderOutlinesIn"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_RenderManager_methods.add(reflect_RenderManager_method_setRenderOutlines_15);


        BaseData[] reflect_RenderManager_methods_arr = new BaseData[reflect_RenderManager_methods.size()];
        for (int i = 0; i < reflect_RenderManager_methods_arr.length; i++) {
            reflect_RenderManager_methods_arr[i] = reflect_RenderManager_methods.get(i);
        }

        reflect_RenderManager.set("constructors", reflect_RenderManager_constructors_arr);
        reflect_RenderManager.set("methods", reflect_RenderManager_methods_arr);
        reflect_RenderManager.set("className", "RenderManager");
        reflect_RenderManager.set("classId", "net.minecraft.client.renderer.entity.RenderManager");
        reflect_RenderManager.set("class", RenderManager.class);
        reflect_RenderManager.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof RenderManager;
        });
        reflectProfiles.add(reflect_RenderManager);
    }


    //classdef for WorldClient
    public static void reflect_WorldClient_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_WorldClient = new ModData();

        ArrayList<BaseData> reflect_WorldClient_constructors = new ArrayList<BaseData>();
        
        BaseData[] reflect_WorldClient_constructors_arr = new BaseData[reflect_WorldClient_constructors.size()];
        for (int i = 0; i < reflect_WorldClient_constructors_arr.length; i++) {
            reflect_WorldClient_constructors_arr[i] = reflect_WorldClient_constructors.get(i);
        }

        ArrayList<BaseData> reflect_WorldClient_methods = new ArrayList<BaseData>();
        
        BaseData reflect_WorldClient_method_tick_0 = new ModData();
        reflect_WorldClient_method_tick_0.set("methodName", "tick");
        reflect_WorldClient_method_tick_0.set("returnType", "void");
        reflect_WorldClient_method_tick_0.set("static", false);
        reflect_WorldClient_method_tick_0.set("argnames", new String[]{});
        reflect_WorldClient_method_tick_0.set("argtypes", new String[]{});
        reflect_WorldClient_method_tick_0.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((WorldClient) params.getReflective("_self")).tick();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_WorldClient_methods.add(reflect_WorldClient_method_tick_0);


        BaseData reflect_WorldClient_method_doPreChunk_1 = new ModData();
        reflect_WorldClient_method_doPreChunk_1.set("methodName", "doPreChunk");
        reflect_WorldClient_method_doPreChunk_1.set("returnType", "void");
        reflect_WorldClient_method_doPreChunk_1.set("static", false);
        reflect_WorldClient_method_doPreChunk_1.set("argnames", new String[]{"parInt1", "parInt2", "parFlag"});
        reflect_WorldClient_method_doPreChunk_1.set("argtypes", new String[]{"int", "int", "boolean"});
        reflect_WorldClient_method_doPreChunk_1.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((WorldClient) params.getReflective("_self")).doPreChunk((int) params.getInt("parInt1"), (int) params.getInt("parInt2"), (boolean) params.getBoolean("parFlag"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_WorldClient_methods.add(reflect_WorldClient_method_doPreChunk_1);


        BaseData reflect_WorldClient_method_spawnEntityInWorld_2 = new ModData();
        reflect_WorldClient_method_spawnEntityInWorld_2.set("methodName", "spawnEntityInWorld");
        reflect_WorldClient_method_spawnEntityInWorld_2.set("returnType", "boolean");
        reflect_WorldClient_method_spawnEntityInWorld_2.set("static", false);
        reflect_WorldClient_method_spawnEntityInWorld_2.set("argnames", new String[]{"entity"});
        reflect_WorldClient_method_spawnEntityInWorld_2.set("argtypes", new String[]{"Entity"});
        reflect_WorldClient_method_spawnEntityInWorld_2.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((WorldClient) params.getReflective("_self")).spawnEntityInWorld((Entity) params.getReflective("entity"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_WorldClient_methods.add(reflect_WorldClient_method_spawnEntityInWorld_2);


        BaseData reflect_WorldClient_method_removeEntity_3 = new ModData();
        reflect_WorldClient_method_removeEntity_3.set("methodName", "removeEntity");
        reflect_WorldClient_method_removeEntity_3.set("returnType", "void");
        reflect_WorldClient_method_removeEntity_3.set("static", false);
        reflect_WorldClient_method_removeEntity_3.set("argnames", new String[]{"entity"});
        reflect_WorldClient_method_removeEntity_3.set("argtypes", new String[]{"Entity"});
        reflect_WorldClient_method_removeEntity_3.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((WorldClient) params.getReflective("_self")).removeEntity((Entity) params.getReflective("entity"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_WorldClient_methods.add(reflect_WorldClient_method_removeEntity_3);


        BaseData reflect_WorldClient_method_addEntityToWorld_4 = new ModData();
        reflect_WorldClient_method_addEntityToWorld_4.set("methodName", "addEntityToWorld");
        reflect_WorldClient_method_addEntityToWorld_4.set("returnType", "void");
        reflect_WorldClient_method_addEntityToWorld_4.set("static", false);
        reflect_WorldClient_method_addEntityToWorld_4.set("argnames", new String[]{"parInt1", "parEntity"});
        reflect_WorldClient_method_addEntityToWorld_4.set("argtypes", new String[]{"int", "Entity"});
        reflect_WorldClient_method_addEntityToWorld_4.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((WorldClient) params.getReflective("_self")).addEntityToWorld((int) params.getInt("parInt1"), (Entity) params.getReflective("parEntity"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_WorldClient_methods.add(reflect_WorldClient_method_addEntityToWorld_4);


        BaseData reflect_WorldClient_method_getEntityByID_5 = new ModData();
        reflect_WorldClient_method_getEntityByID_5.set("methodName", "getEntityByID");
        reflect_WorldClient_method_getEntityByID_5.set("returnType", "Entity");
        reflect_WorldClient_method_getEntityByID_5.set("static", false);
        reflect_WorldClient_method_getEntityByID_5.set("argnames", new String[]{"i"});
        reflect_WorldClient_method_getEntityByID_5.set("argtypes", new String[]{"int"});
        reflect_WorldClient_method_getEntityByID_5.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Entity) ((WorldClient) params.getReflective("_self")).getEntityByID((int) params.getInt("i"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_WorldClient_methods.add(reflect_WorldClient_method_getEntityByID_5);


        BaseData reflect_WorldClient_method_removeEntityFromWorld_6 = new ModData();
        reflect_WorldClient_method_removeEntityFromWorld_6.set("methodName", "removeEntityFromWorld");
        reflect_WorldClient_method_removeEntityFromWorld_6.set("returnType", "Entity");
        reflect_WorldClient_method_removeEntityFromWorld_6.set("static", false);
        reflect_WorldClient_method_removeEntityFromWorld_6.set("argnames", new String[]{"parInt1"});
        reflect_WorldClient_method_removeEntityFromWorld_6.set("argtypes", new String[]{"int"});
        reflect_WorldClient_method_removeEntityFromWorld_6.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Entity) ((WorldClient) params.getReflective("_self")).removeEntityFromWorld((int) params.getInt("parInt1"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_WorldClient_methods.add(reflect_WorldClient_method_removeEntityFromWorld_6);


        BaseData reflect_WorldClient_method_invalidateRegionAndSetBlock_7 = new ModData();
        reflect_WorldClient_method_invalidateRegionAndSetBlock_7.set("methodName", "invalidateRegionAndSetBlock");
        reflect_WorldClient_method_invalidateRegionAndSetBlock_7.set("returnType", "boolean");
        reflect_WorldClient_method_invalidateRegionAndSetBlock_7.set("static", false);
        reflect_WorldClient_method_invalidateRegionAndSetBlock_7.set("argnames", new String[]{"parBlockPos", "parIBlockState"});
        reflect_WorldClient_method_invalidateRegionAndSetBlock_7.set("argtypes", new String[]{"BlockPos", "IBlockState"});
        reflect_WorldClient_method_invalidateRegionAndSetBlock_7.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((WorldClient) params.getReflective("_self")).invalidateRegionAndSetBlock((BlockPos) params.getReflective("parBlockPos"), (IBlockState) params.getReflective("parIBlockState"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_WorldClient_methods.add(reflect_WorldClient_method_invalidateRegionAndSetBlock_7);


        BaseData reflect_WorldClient_method_sendQuittingDisconnectingPacket_8 = new ModData();
        reflect_WorldClient_method_sendQuittingDisconnectingPacket_8.set("methodName", "sendQuittingDisconnectingPacket");
        reflect_WorldClient_method_sendQuittingDisconnectingPacket_8.set("returnType", "void");
        reflect_WorldClient_method_sendQuittingDisconnectingPacket_8.set("static", false);
        reflect_WorldClient_method_sendQuittingDisconnectingPacket_8.set("argnames", new String[]{});
        reflect_WorldClient_method_sendQuittingDisconnectingPacket_8.set("argtypes", new String[]{});
        reflect_WorldClient_method_sendQuittingDisconnectingPacket_8.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((WorldClient) params.getReflective("_self")).sendQuittingDisconnectingPacket();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_WorldClient_methods.add(reflect_WorldClient_method_sendQuittingDisconnectingPacket_8);


        BaseData reflect_WorldClient_method_doVoidFogParticles_9 = new ModData();
        reflect_WorldClient_method_doVoidFogParticles_9.set("methodName", "doVoidFogParticles");
        reflect_WorldClient_method_doVoidFogParticles_9.set("returnType", "void");
        reflect_WorldClient_method_doVoidFogParticles_9.set("static", false);
        reflect_WorldClient_method_doVoidFogParticles_9.set("argnames", new String[]{"parInt1", "parInt2", "parInt3"});
        reflect_WorldClient_method_doVoidFogParticles_9.set("argtypes", new String[]{"int", "int", "int"});
        reflect_WorldClient_method_doVoidFogParticles_9.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((WorldClient) params.getReflective("_self")).doVoidFogParticles((int) params.getInt("parInt1"), (int) params.getInt("parInt2"), (int) params.getInt("parInt3"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_WorldClient_methods.add(reflect_WorldClient_method_doVoidFogParticles_9);


        BaseData reflect_WorldClient_method_removeAllEntities_10 = new ModData();
        reflect_WorldClient_method_removeAllEntities_10.set("methodName", "removeAllEntities");
        reflect_WorldClient_method_removeAllEntities_10.set("returnType", "void");
        reflect_WorldClient_method_removeAllEntities_10.set("static", false);
        reflect_WorldClient_method_removeAllEntities_10.set("argnames", new String[]{});
        reflect_WorldClient_method_removeAllEntities_10.set("argtypes", new String[]{});
        reflect_WorldClient_method_removeAllEntities_10.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((WorldClient) params.getReflective("_self")).removeAllEntities();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_WorldClient_methods.add(reflect_WorldClient_method_removeAllEntities_10);


        BaseData reflect_WorldClient_method_addWorldInfoToCrashReport_11 = new ModData();
        reflect_WorldClient_method_addWorldInfoToCrashReport_11.set("methodName", "addWorldInfoToCrashReport");
        reflect_WorldClient_method_addWorldInfoToCrashReport_11.set("returnType", "CrashReportCategory");
        reflect_WorldClient_method_addWorldInfoToCrashReport_11.set("static", false);
        reflect_WorldClient_method_addWorldInfoToCrashReport_11.set("argnames", new String[]{"crashreport"});
        reflect_WorldClient_method_addWorldInfoToCrashReport_11.set("argtypes", new String[]{"CrashReport"});
        reflect_WorldClient_method_addWorldInfoToCrashReport_11.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (CrashReportCategory) ((WorldClient) params.getReflective("_self")).addWorldInfoToCrashReport((CrashReport) params.getReflective("crashreport"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_WorldClient_methods.add(reflect_WorldClient_method_addWorldInfoToCrashReport_11);


        BaseData reflect_WorldClient_method_playSound_12 = new ModData();
        reflect_WorldClient_method_playSound_12.set("methodName", "playSound");
        reflect_WorldClient_method_playSound_12.set("returnType", "void");
        reflect_WorldClient_method_playSound_12.set("static", false);
        reflect_WorldClient_method_playSound_12.set("argnames", new String[]{"d0", "d1", "d2", "s", "f", "f1", "flag"});
        reflect_WorldClient_method_playSound_12.set("argtypes", new String[]{"double", "double", "double", "String", "float", "float", "boolean"});
        reflect_WorldClient_method_playSound_12.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((WorldClient) params.getReflective("_self")).playSound((double) params.getDouble("d0"), (double) params.getDouble("d1"), (double) params.getDouble("d2"), (String) params.getString("s"), (float) params.getFloat("f"), (float) params.getFloat("f1"), (boolean) params.getBoolean("flag"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_WorldClient_methods.add(reflect_WorldClient_method_playSound_12);


        BaseData reflect_WorldClient_method_setWorldScoreboard_13 = new ModData();
        reflect_WorldClient_method_setWorldScoreboard_13.set("methodName", "setWorldScoreboard");
        reflect_WorldClient_method_setWorldScoreboard_13.set("returnType", "void");
        reflect_WorldClient_method_setWorldScoreboard_13.set("static", false);
        reflect_WorldClient_method_setWorldScoreboard_13.set("argnames", new String[]{"parScoreboard"});
        reflect_WorldClient_method_setWorldScoreboard_13.set("argtypes", new String[]{"Scoreboard"});
        reflect_WorldClient_method_setWorldScoreboard_13.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((WorldClient) params.getReflective("_self")).setWorldScoreboard((Scoreboard) params.getReflective("parScoreboard"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_WorldClient_methods.add(reflect_WorldClient_method_setWorldScoreboard_13);


        BaseData reflect_WorldClient_method_setWorldTime_14 = new ModData();
        reflect_WorldClient_method_setWorldTime_14.set("methodName", "setWorldTime");
        reflect_WorldClient_method_setWorldTime_14.set("returnType", "void");
        reflect_WorldClient_method_setWorldTime_14.set("static", false);
        reflect_WorldClient_method_setWorldTime_14.set("argnames", new String[]{"i"});
        reflect_WorldClient_method_setWorldTime_14.set("argtypes", new String[]{"long"});
        reflect_WorldClient_method_setWorldTime_14.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((WorldClient) params.getReflective("_self")).setWorldTime((long) params.getReflective("i"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_WorldClient_methods.add(reflect_WorldClient_method_setWorldTime_14);


        BaseData[] reflect_WorldClient_methods_arr = new BaseData[reflect_WorldClient_methods.size()];
        for (int i = 0; i < reflect_WorldClient_methods_arr.length; i++) {
            reflect_WorldClient_methods_arr[i] = reflect_WorldClient_methods.get(i);
        }

        reflect_WorldClient.set("constructors", reflect_WorldClient_constructors_arr);
        reflect_WorldClient.set("methods", reflect_WorldClient_methods_arr);
        reflect_WorldClient.set("className", "WorldClient");
        reflect_WorldClient.set("classId", "net.minecraft.client.multiplayer.WorldClient");
        reflect_WorldClient.set("class", WorldClient.class);
        reflect_WorldClient.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof WorldClient;
        });
        reflectProfiles.add(reflect_WorldClient);
    }


    //classdef for AbstractClientPlayer
    public static void reflect_AbstractClientPlayer_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_AbstractClientPlayer = new ModData();

        ArrayList<BaseData> reflect_AbstractClientPlayer_constructors = new ArrayList<BaseData>();
        
        BaseData[] reflect_AbstractClientPlayer_constructors_arr = new BaseData[reflect_AbstractClientPlayer_constructors.size()];
        for (int i = 0; i < reflect_AbstractClientPlayer_constructors_arr.length; i++) {
            reflect_AbstractClientPlayer_constructors_arr[i] = reflect_AbstractClientPlayer_constructors.get(i);
        }

        ArrayList<BaseData> reflect_AbstractClientPlayer_methods = new ArrayList<BaseData>();
        
        BaseData reflect_AbstractClientPlayer_method_isSpectator_0 = new ModData();
        reflect_AbstractClientPlayer_method_isSpectator_0.set("methodName", "isSpectator");
        reflect_AbstractClientPlayer_method_isSpectator_0.set("returnType", "boolean");
        reflect_AbstractClientPlayer_method_isSpectator_0.set("static", false);
        reflect_AbstractClientPlayer_method_isSpectator_0.set("argnames", new String[]{});
        reflect_AbstractClientPlayer_method_isSpectator_0.set("argtypes", new String[]{});
        reflect_AbstractClientPlayer_method_isSpectator_0.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((AbstractClientPlayer) params.getReflective("_self")).isSpectator();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_AbstractClientPlayer_methods.add(reflect_AbstractClientPlayer_method_isSpectator_0);


        BaseData reflect_AbstractClientPlayer_method_hasPlayerInfo_1 = new ModData();
        reflect_AbstractClientPlayer_method_hasPlayerInfo_1.set("methodName", "hasPlayerInfo");
        reflect_AbstractClientPlayer_method_hasPlayerInfo_1.set("returnType", "boolean");
        reflect_AbstractClientPlayer_method_hasPlayerInfo_1.set("static", false);
        reflect_AbstractClientPlayer_method_hasPlayerInfo_1.set("argnames", new String[]{});
        reflect_AbstractClientPlayer_method_hasPlayerInfo_1.set("argtypes", new String[]{});
        reflect_AbstractClientPlayer_method_hasPlayerInfo_1.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((AbstractClientPlayer) params.getReflective("_self")).hasPlayerInfo();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_AbstractClientPlayer_methods.add(reflect_AbstractClientPlayer_method_hasPlayerInfo_1);


        BaseData reflect_AbstractClientPlayer_method_hasSkin_2 = new ModData();
        reflect_AbstractClientPlayer_method_hasSkin_2.set("methodName", "hasSkin");
        reflect_AbstractClientPlayer_method_hasSkin_2.set("returnType", "boolean");
        reflect_AbstractClientPlayer_method_hasSkin_2.set("static", false);
        reflect_AbstractClientPlayer_method_hasSkin_2.set("argnames", new String[]{});
        reflect_AbstractClientPlayer_method_hasSkin_2.set("argtypes", new String[]{});
        reflect_AbstractClientPlayer_method_hasSkin_2.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((AbstractClientPlayer) params.getReflective("_self")).hasSkin();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_AbstractClientPlayer_methods.add(reflect_AbstractClientPlayer_method_hasSkin_2);


        BaseData reflect_AbstractClientPlayer_method_getLocationSkin_3 = new ModData();
        reflect_AbstractClientPlayer_method_getLocationSkin_3.set("methodName", "getLocationSkin");
        reflect_AbstractClientPlayer_method_getLocationSkin_3.set("returnType", "ResourceLocation");
        reflect_AbstractClientPlayer_method_getLocationSkin_3.set("static", false);
        reflect_AbstractClientPlayer_method_getLocationSkin_3.set("argnames", new String[]{});
        reflect_AbstractClientPlayer_method_getLocationSkin_3.set("argtypes", new String[]{});
        reflect_AbstractClientPlayer_method_getLocationSkin_3.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (ResourceLocation) ((AbstractClientPlayer) params.getReflective("_self")).getLocationSkin();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_AbstractClientPlayer_methods.add(reflect_AbstractClientPlayer_method_getLocationSkin_3);


        BaseData reflect_AbstractClientPlayer_method_getLocationCape_4 = new ModData();
        reflect_AbstractClientPlayer_method_getLocationCape_4.set("methodName", "getLocationCape");
        reflect_AbstractClientPlayer_method_getLocationCape_4.set("returnType", "ResourceLocation");
        reflect_AbstractClientPlayer_method_getLocationCape_4.set("static", false);
        reflect_AbstractClientPlayer_method_getLocationCape_4.set("argnames", new String[]{});
        reflect_AbstractClientPlayer_method_getLocationCape_4.set("argtypes", new String[]{});
        reflect_AbstractClientPlayer_method_getLocationCape_4.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (ResourceLocation) ((AbstractClientPlayer) params.getReflective("_self")).getLocationCape();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_AbstractClientPlayer_methods.add(reflect_AbstractClientPlayer_method_getLocationCape_4);


        BaseData reflect_AbstractClientPlayer_method_getSkinType_5 = new ModData();
        reflect_AbstractClientPlayer_method_getSkinType_5.set("methodName", "getSkinType");
        reflect_AbstractClientPlayer_method_getSkinType_5.set("returnType", "String");
        reflect_AbstractClientPlayer_method_getSkinType_5.set("static", false);
        reflect_AbstractClientPlayer_method_getSkinType_5.set("argnames", new String[]{});
        reflect_AbstractClientPlayer_method_getSkinType_5.set("argtypes", new String[]{});
        reflect_AbstractClientPlayer_method_getSkinType_5.setCallbackStringWithDataArg("exec", (BaseData params) -> {
                try {
                    return (String) ((AbstractClientPlayer) params.getReflective("_self")).getSkinType();
                } catch (Exception _exception_reflect_) {
                    return "";
                }
            });
            
        reflect_AbstractClientPlayer_methods.add(reflect_AbstractClientPlayer_method_getSkinType_5);


        BaseData reflect_AbstractClientPlayer_method_getEaglerSkinModel_6 = new ModData();
        reflect_AbstractClientPlayer_method_getEaglerSkinModel_6.set("methodName", "getEaglerSkinModel");
        reflect_AbstractClientPlayer_method_getEaglerSkinModel_6.set("returnType", "SkinModel");
        reflect_AbstractClientPlayer_method_getEaglerSkinModel_6.set("static", false);
        reflect_AbstractClientPlayer_method_getEaglerSkinModel_6.set("argnames", new String[]{});
        reflect_AbstractClientPlayer_method_getEaglerSkinModel_6.set("argtypes", new String[]{});
        reflect_AbstractClientPlayer_method_getEaglerSkinModel_6.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (SkinModel) ((AbstractClientPlayer) params.getReflective("_self")).getEaglerSkinModel();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_AbstractClientPlayer_methods.add(reflect_AbstractClientPlayer_method_getEaglerSkinModel_6);


        BaseData reflect_AbstractClientPlayer_method_getFovModifier_7 = new ModData();
        reflect_AbstractClientPlayer_method_getFovModifier_7.set("methodName", "getFovModifier");
        reflect_AbstractClientPlayer_method_getFovModifier_7.set("returnType", "float");
        reflect_AbstractClientPlayer_method_getFovModifier_7.set("static", false);
        reflect_AbstractClientPlayer_method_getFovModifier_7.set("argnames", new String[]{});
        reflect_AbstractClientPlayer_method_getFovModifier_7.set("argtypes", new String[]{});
        reflect_AbstractClientPlayer_method_getFovModifier_7.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((AbstractClientPlayer) params.getReflective("_self")).getFovModifier();
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_AbstractClientPlayer_methods.add(reflect_AbstractClientPlayer_method_getFovModifier_7);


        BaseData[] reflect_AbstractClientPlayer_methods_arr = new BaseData[reflect_AbstractClientPlayer_methods.size()];
        for (int i = 0; i < reflect_AbstractClientPlayer_methods_arr.length; i++) {
            reflect_AbstractClientPlayer_methods_arr[i] = reflect_AbstractClientPlayer_methods.get(i);
        }

        reflect_AbstractClientPlayer.set("constructors", reflect_AbstractClientPlayer_constructors_arr);
        reflect_AbstractClientPlayer.set("methods", reflect_AbstractClientPlayer_methods_arr);
        reflect_AbstractClientPlayer.set("className", "AbstractClientPlayer");
        reflect_AbstractClientPlayer.set("classId", "net.minecraft.client.entity.AbstractClientPlayer");
        reflect_AbstractClientPlayer.set("class", AbstractClientPlayer.class);
        reflect_AbstractClientPlayer.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof AbstractClientPlayer;
        });
        reflectProfiles.add(reflect_AbstractClientPlayer);
    }


    //classdef for EntityOtherPlayerMP
    public static void reflect_EntityOtherPlayerMP_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityOtherPlayerMP = new ModData();

        ArrayList<BaseData> reflect_EntityOtherPlayerMP_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_EntityOtherPlayerMP_constructor_EntityOtherPlayerMP_0 = new ModData();
        reflect_EntityOtherPlayerMP_constructor_EntityOtherPlayerMP_0.set("returnType", "EntityOtherPlayerMP");
        reflect_EntityOtherPlayerMP_constructor_EntityOtherPlayerMP_0.set("argnames", new String[]{"worldIn", "gameProfileIn"});
        reflect_EntityOtherPlayerMP_constructor_EntityOtherPlayerMP_0.set("argtypes", new String[]{"World", "GameProfile"});
        reflect_EntityOtherPlayerMP_constructor_EntityOtherPlayerMP_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityOtherPlayerMP((World) params.getReflective("worldIn"), (GameProfile) params.getReflective("gameProfileIn"));
        });
        
        reflect_EntityOtherPlayerMP_constructors.add(reflect_EntityOtherPlayerMP_constructor_EntityOtherPlayerMP_0);


        BaseData[] reflect_EntityOtherPlayerMP_constructors_arr = new BaseData[reflect_EntityOtherPlayerMP_constructors.size()];
        for (int i = 0; i < reflect_EntityOtherPlayerMP_constructors_arr.length; i++) {
            reflect_EntityOtherPlayerMP_constructors_arr[i] = reflect_EntityOtherPlayerMP_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityOtherPlayerMP_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityOtherPlayerMP_method_makeModData_0 = new ModData();
        reflect_EntityOtherPlayerMP_method_makeModData_0.set("methodName", "makeModData");
        reflect_EntityOtherPlayerMP_method_makeModData_0.set("returnType", "ModData");
        reflect_EntityOtherPlayerMP_method_makeModData_0.set("static", false);
        reflect_EntityOtherPlayerMP_method_makeModData_0.set("argnames", new String[]{});
        reflect_EntityOtherPlayerMP_method_makeModData_0.set("argtypes", new String[]{});
        reflect_EntityOtherPlayerMP_method_makeModData_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (ModData) ((EntityOtherPlayerMP) params.getReflective("_self")).makeModData();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityOtherPlayerMP_methods.add(reflect_EntityOtherPlayerMP_method_makeModData_0);


        BaseData reflect_EntityOtherPlayerMP_method_loadModData_1 = new ModData();
        reflect_EntityOtherPlayerMP_method_loadModData_1.set("methodName", "loadModData");
        reflect_EntityOtherPlayerMP_method_loadModData_1.set("returnType", "void");
        reflect_EntityOtherPlayerMP_method_loadModData_1.set("static", false);
        reflect_EntityOtherPlayerMP_method_loadModData_1.set("argnames", new String[]{"data"});
        reflect_EntityOtherPlayerMP_method_loadModData_1.set("argtypes", new String[]{"BaseData"});
        reflect_EntityOtherPlayerMP_method_loadModData_1.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityOtherPlayerMP) params.getReflective("_self")).loadModData((BaseData) params.getReflective("data"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityOtherPlayerMP_methods.add(reflect_EntityOtherPlayerMP_method_loadModData_1);


        BaseData reflect_EntityOtherPlayerMP_method_attackEntityFrom_2 = new ModData();
        reflect_EntityOtherPlayerMP_method_attackEntityFrom_2.set("methodName", "attackEntityFrom");
        reflect_EntityOtherPlayerMP_method_attackEntityFrom_2.set("returnType", "boolean");
        reflect_EntityOtherPlayerMP_method_attackEntityFrom_2.set("static", false);
        reflect_EntityOtherPlayerMP_method_attackEntityFrom_2.set("argnames", new String[]{"var1", "var2"});
        reflect_EntityOtherPlayerMP_method_attackEntityFrom_2.set("argtypes", new String[]{"DamageSource", "float"});
        reflect_EntityOtherPlayerMP_method_attackEntityFrom_2.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityOtherPlayerMP) params.getReflective("_self")).attackEntityFrom((DamageSource) params.getReflective("var1"), (float) params.getFloat("var2"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityOtherPlayerMP_methods.add(reflect_EntityOtherPlayerMP_method_attackEntityFrom_2);


        BaseData reflect_EntityOtherPlayerMP_method_onUpdate_3 = new ModData();
        reflect_EntityOtherPlayerMP_method_onUpdate_3.set("methodName", "onUpdate");
        reflect_EntityOtherPlayerMP_method_onUpdate_3.set("returnType", "void");
        reflect_EntityOtherPlayerMP_method_onUpdate_3.set("static", false);
        reflect_EntityOtherPlayerMP_method_onUpdate_3.set("argnames", new String[]{});
        reflect_EntityOtherPlayerMP_method_onUpdate_3.set("argtypes", new String[]{});
        reflect_EntityOtherPlayerMP_method_onUpdate_3.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityOtherPlayerMP) params.getReflective("_self")).onUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityOtherPlayerMP_methods.add(reflect_EntityOtherPlayerMP_method_onUpdate_3);


        BaseData reflect_EntityOtherPlayerMP_method_onLivingUpdate_4 = new ModData();
        reflect_EntityOtherPlayerMP_method_onLivingUpdate_4.set("methodName", "onLivingUpdate");
        reflect_EntityOtherPlayerMP_method_onLivingUpdate_4.set("returnType", "void");
        reflect_EntityOtherPlayerMP_method_onLivingUpdate_4.set("static", false);
        reflect_EntityOtherPlayerMP_method_onLivingUpdate_4.set("argnames", new String[]{});
        reflect_EntityOtherPlayerMP_method_onLivingUpdate_4.set("argtypes", new String[]{});
        reflect_EntityOtherPlayerMP_method_onLivingUpdate_4.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityOtherPlayerMP) params.getReflective("_self")).onLivingUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityOtherPlayerMP_methods.add(reflect_EntityOtherPlayerMP_method_onLivingUpdate_4);


        BaseData reflect_EntityOtherPlayerMP_method_setCurrentItemOrArmor_5 = new ModData();
        reflect_EntityOtherPlayerMP_method_setCurrentItemOrArmor_5.set("methodName", "setCurrentItemOrArmor");
        reflect_EntityOtherPlayerMP_method_setCurrentItemOrArmor_5.set("returnType", "void");
        reflect_EntityOtherPlayerMP_method_setCurrentItemOrArmor_5.set("static", false);
        reflect_EntityOtherPlayerMP_method_setCurrentItemOrArmor_5.set("argnames", new String[]{"slotIn", "stack"});
        reflect_EntityOtherPlayerMP_method_setCurrentItemOrArmor_5.set("argtypes", new String[]{"int", "ItemStack"});
        reflect_EntityOtherPlayerMP_method_setCurrentItemOrArmor_5.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityOtherPlayerMP) params.getReflective("_self")).setCurrentItemOrArmor((int) params.getInt("slotIn"), (ItemStack) params.getReflective("stack"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityOtherPlayerMP_methods.add(reflect_EntityOtherPlayerMP_method_setCurrentItemOrArmor_5);


        BaseData reflect_EntityOtherPlayerMP_method_addChatMessage_6 = new ModData();
        reflect_EntityOtherPlayerMP_method_addChatMessage_6.set("methodName", "addChatMessage");
        reflect_EntityOtherPlayerMP_method_addChatMessage_6.set("returnType", "void");
        reflect_EntityOtherPlayerMP_method_addChatMessage_6.set("static", false);
        reflect_EntityOtherPlayerMP_method_addChatMessage_6.set("argnames", new String[]{"ichatcomponent"});
        reflect_EntityOtherPlayerMP_method_addChatMessage_6.set("argtypes", new String[]{"IChatComponent"});
        reflect_EntityOtherPlayerMP_method_addChatMessage_6.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityOtherPlayerMP) params.getReflective("_self")).addChatMessage((IChatComponent) params.getReflective("ichatcomponent"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityOtherPlayerMP_methods.add(reflect_EntityOtherPlayerMP_method_addChatMessage_6);


        BaseData reflect_EntityOtherPlayerMP_method_canCommandSenderUseCommand_7 = new ModData();
        reflect_EntityOtherPlayerMP_method_canCommandSenderUseCommand_7.set("methodName", "canCommandSenderUseCommand");
        reflect_EntityOtherPlayerMP_method_canCommandSenderUseCommand_7.set("returnType", "boolean");
        reflect_EntityOtherPlayerMP_method_canCommandSenderUseCommand_7.set("static", false);
        reflect_EntityOtherPlayerMP_method_canCommandSenderUseCommand_7.set("argnames", new String[]{"var1", "var2"});
        reflect_EntityOtherPlayerMP_method_canCommandSenderUseCommand_7.set("argtypes", new String[]{"int", "String"});
        reflect_EntityOtherPlayerMP_method_canCommandSenderUseCommand_7.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityOtherPlayerMP) params.getReflective("_self")).canCommandSenderUseCommand((int) params.getInt("var1"), (String) params.getString("var2"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityOtherPlayerMP_methods.add(reflect_EntityOtherPlayerMP_method_canCommandSenderUseCommand_7);


        BaseData reflect_EntityOtherPlayerMP_method_getPosition_8 = new ModData();
        reflect_EntityOtherPlayerMP_method_getPosition_8.set("methodName", "getPosition");
        reflect_EntityOtherPlayerMP_method_getPosition_8.set("returnType", "BlockPos");
        reflect_EntityOtherPlayerMP_method_getPosition_8.set("static", false);
        reflect_EntityOtherPlayerMP_method_getPosition_8.set("argnames", new String[]{});
        reflect_EntityOtherPlayerMP_method_getPosition_8.set("argtypes", new String[]{});
        reflect_EntityOtherPlayerMP_method_getPosition_8.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (BlockPos) ((EntityOtherPlayerMP) params.getReflective("_self")).getPosition();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityOtherPlayerMP_methods.add(reflect_EntityOtherPlayerMP_method_getPosition_8);


        BaseData[] reflect_EntityOtherPlayerMP_methods_arr = new BaseData[reflect_EntityOtherPlayerMP_methods.size()];
        for (int i = 0; i < reflect_EntityOtherPlayerMP_methods_arr.length; i++) {
            reflect_EntityOtherPlayerMP_methods_arr[i] = reflect_EntityOtherPlayerMP_methods.get(i);
        }

        reflect_EntityOtherPlayerMP.set("constructors", reflect_EntityOtherPlayerMP_constructors_arr);
        reflect_EntityOtherPlayerMP.set("methods", reflect_EntityOtherPlayerMP_methods_arr);
        reflect_EntityOtherPlayerMP.set("className", "EntityOtherPlayerMP");
        reflect_EntityOtherPlayerMP.set("classId", "net.minecraft.client.entity.EntityOtherPlayerMP");
        reflect_EntityOtherPlayerMP.set("class", EntityOtherPlayerMP.class);
        reflect_EntityOtherPlayerMP.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityOtherPlayerMP;
        });
        reflectProfiles.add(reflect_EntityOtherPlayerMP);
    }


    //classdef for EntityPlayerSP
    public static void reflect_EntityPlayerSP_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EntityPlayerSP = new ModData();

        ArrayList<BaseData> reflect_EntityPlayerSP_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_EntityPlayerSP_constructor_EntityPlayerSP_0 = new ModData();
        reflect_EntityPlayerSP_constructor_EntityPlayerSP_0.set("returnType", "EntityPlayerSP");
        reflect_EntityPlayerSP_constructor_EntityPlayerSP_0.set("argnames", new String[]{"mcIn", "worldIn", "netHandler", "statWriter"});
        reflect_EntityPlayerSP_constructor_EntityPlayerSP_0.set("argtypes", new String[]{"Minecraft", "World", "NetHandlerPlayClient", "StatFileWriter"});
        reflect_EntityPlayerSP_constructor_EntityPlayerSP_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new EntityPlayerSP((Minecraft) params.getReflective("mcIn"), (World) params.getReflective("worldIn"), (NetHandlerPlayClient) params.getReflective("netHandler"), (StatFileWriter) params.getReflective("statWriter"));
        });
        
        reflect_EntityPlayerSP_constructors.add(reflect_EntityPlayerSP_constructor_EntityPlayerSP_0);


        BaseData[] reflect_EntityPlayerSP_constructors_arr = new BaseData[reflect_EntityPlayerSP_constructors.size()];
        for (int i = 0; i < reflect_EntityPlayerSP_constructors_arr.length; i++) {
            reflect_EntityPlayerSP_constructors_arr[i] = reflect_EntityPlayerSP_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EntityPlayerSP_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EntityPlayerSP_method_makeModData_0 = new ModData();
        reflect_EntityPlayerSP_method_makeModData_0.set("methodName", "makeModData");
        reflect_EntityPlayerSP_method_makeModData_0.set("returnType", "ModData");
        reflect_EntityPlayerSP_method_makeModData_0.set("static", false);
        reflect_EntityPlayerSP_method_makeModData_0.set("argnames", new String[]{});
        reflect_EntityPlayerSP_method_makeModData_0.set("argtypes", new String[]{});
        reflect_EntityPlayerSP_method_makeModData_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (ModData) ((EntityPlayerSP) params.getReflective("_self")).makeModData();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityPlayerSP_methods.add(reflect_EntityPlayerSP_method_makeModData_0);


        BaseData reflect_EntityPlayerSP_method_loadModData_1 = new ModData();
        reflect_EntityPlayerSP_method_loadModData_1.set("methodName", "loadModData");
        reflect_EntityPlayerSP_method_loadModData_1.set("returnType", "void");
        reflect_EntityPlayerSP_method_loadModData_1.set("static", false);
        reflect_EntityPlayerSP_method_loadModData_1.set("argnames", new String[]{"data"});
        reflect_EntityPlayerSP_method_loadModData_1.set("argtypes", new String[]{"BaseData"});
        reflect_EntityPlayerSP_method_loadModData_1.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerSP) params.getReflective("_self")).loadModData((BaseData) params.getReflective("data"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerSP_methods.add(reflect_EntityPlayerSP_method_loadModData_1);


        BaseData reflect_EntityPlayerSP_method_attackEntityFrom_2 = new ModData();
        reflect_EntityPlayerSP_method_attackEntityFrom_2.set("methodName", "attackEntityFrom");
        reflect_EntityPlayerSP_method_attackEntityFrom_2.set("returnType", "boolean");
        reflect_EntityPlayerSP_method_attackEntityFrom_2.set("static", false);
        reflect_EntityPlayerSP_method_attackEntityFrom_2.set("argnames", new String[]{"source", "amount"});
        reflect_EntityPlayerSP_method_attackEntityFrom_2.set("argtypes", new String[]{"DamageSource", "float"});
        reflect_EntityPlayerSP_method_attackEntityFrom_2.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityPlayerSP) params.getReflective("_self")).attackEntityFrom((DamageSource) params.getReflective("source"), (float) params.getFloat("amount"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityPlayerSP_methods.add(reflect_EntityPlayerSP_method_attackEntityFrom_2);


        BaseData reflect_EntityPlayerSP_method_heal_3 = new ModData();
        reflect_EntityPlayerSP_method_heal_3.set("methodName", "heal");
        reflect_EntityPlayerSP_method_heal_3.set("returnType", "void");
        reflect_EntityPlayerSP_method_heal_3.set("static", false);
        reflect_EntityPlayerSP_method_heal_3.set("argnames", new String[]{"healAmount"});
        reflect_EntityPlayerSP_method_heal_3.set("argtypes", new String[]{"float"});
        reflect_EntityPlayerSP_method_heal_3.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerSP) params.getReflective("_self")).heal((float) params.getFloat("healAmount"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerSP_methods.add(reflect_EntityPlayerSP_method_heal_3);


        BaseData reflect_EntityPlayerSP_method_mountEntity_4 = new ModData();
        reflect_EntityPlayerSP_method_mountEntity_4.set("methodName", "mountEntity");
        reflect_EntityPlayerSP_method_mountEntity_4.set("returnType", "void");
        reflect_EntityPlayerSP_method_mountEntity_4.set("static", false);
        reflect_EntityPlayerSP_method_mountEntity_4.set("argnames", new String[]{"entityIn"});
        reflect_EntityPlayerSP_method_mountEntity_4.set("argtypes", new String[]{"Entity"});
        reflect_EntityPlayerSP_method_mountEntity_4.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerSP) params.getReflective("_self")).mountEntity((Entity) params.getReflective("entityIn"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerSP_methods.add(reflect_EntityPlayerSP_method_mountEntity_4);


        BaseData reflect_EntityPlayerSP_method_onUpdate_5 = new ModData();
        reflect_EntityPlayerSP_method_onUpdate_5.set("methodName", "onUpdate");
        reflect_EntityPlayerSP_method_onUpdate_5.set("returnType", "void");
        reflect_EntityPlayerSP_method_onUpdate_5.set("static", false);
        reflect_EntityPlayerSP_method_onUpdate_5.set("argnames", new String[]{});
        reflect_EntityPlayerSP_method_onUpdate_5.set("argtypes", new String[]{});
        reflect_EntityPlayerSP_method_onUpdate_5.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerSP) params.getReflective("_self")).onUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerSP_methods.add(reflect_EntityPlayerSP_method_onUpdate_5);


        BaseData reflect_EntityPlayerSP_method_onUpdateWalkingPlayer_6 = new ModData();
        reflect_EntityPlayerSP_method_onUpdateWalkingPlayer_6.set("methodName", "onUpdateWalkingPlayer");
        reflect_EntityPlayerSP_method_onUpdateWalkingPlayer_6.set("returnType", "void");
        reflect_EntityPlayerSP_method_onUpdateWalkingPlayer_6.set("static", false);
        reflect_EntityPlayerSP_method_onUpdateWalkingPlayer_6.set("argnames", new String[]{});
        reflect_EntityPlayerSP_method_onUpdateWalkingPlayer_6.set("argtypes", new String[]{});
        reflect_EntityPlayerSP_method_onUpdateWalkingPlayer_6.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerSP) params.getReflective("_self")).onUpdateWalkingPlayer();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerSP_methods.add(reflect_EntityPlayerSP_method_onUpdateWalkingPlayer_6);


        BaseData reflect_EntityPlayerSP_method_dropOneItem_7 = new ModData();
        reflect_EntityPlayerSP_method_dropOneItem_7.set("methodName", "dropOneItem");
        reflect_EntityPlayerSP_method_dropOneItem_7.set("returnType", "EntityItem");
        reflect_EntityPlayerSP_method_dropOneItem_7.set("static", false);
        reflect_EntityPlayerSP_method_dropOneItem_7.set("argnames", new String[]{"dropAll"});
        reflect_EntityPlayerSP_method_dropOneItem_7.set("argtypes", new String[]{"boolean"});
        reflect_EntityPlayerSP_method_dropOneItem_7.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (EntityItem) ((EntityPlayerSP) params.getReflective("_self")).dropOneItem((boolean) params.getBoolean("dropAll"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityPlayerSP_methods.add(reflect_EntityPlayerSP_method_dropOneItem_7);


        BaseData reflect_EntityPlayerSP_method_sendChatMessage_8 = new ModData();
        reflect_EntityPlayerSP_method_sendChatMessage_8.set("methodName", "sendChatMessage");
        reflect_EntityPlayerSP_method_sendChatMessage_8.set("returnType", "void");
        reflect_EntityPlayerSP_method_sendChatMessage_8.set("static", false);
        reflect_EntityPlayerSP_method_sendChatMessage_8.set("argnames", new String[]{"message"});
        reflect_EntityPlayerSP_method_sendChatMessage_8.set("argtypes", new String[]{"String"});
        reflect_EntityPlayerSP_method_sendChatMessage_8.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerSP) params.getReflective("_self")).sendChatMessage((String) params.getString("message"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerSP_methods.add(reflect_EntityPlayerSP_method_sendChatMessage_8);


        BaseData reflect_EntityPlayerSP_method_swingItem_9 = new ModData();
        reflect_EntityPlayerSP_method_swingItem_9.set("methodName", "swingItem");
        reflect_EntityPlayerSP_method_swingItem_9.set("returnType", "void");
        reflect_EntityPlayerSP_method_swingItem_9.set("static", false);
        reflect_EntityPlayerSP_method_swingItem_9.set("argnames", new String[]{});
        reflect_EntityPlayerSP_method_swingItem_9.set("argtypes", new String[]{});
        reflect_EntityPlayerSP_method_swingItem_9.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerSP) params.getReflective("_self")).swingItem();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerSP_methods.add(reflect_EntityPlayerSP_method_swingItem_9);


        BaseData reflect_EntityPlayerSP_method_respawnPlayer_10 = new ModData();
        reflect_EntityPlayerSP_method_respawnPlayer_10.set("methodName", "respawnPlayer");
        reflect_EntityPlayerSP_method_respawnPlayer_10.set("returnType", "void");
        reflect_EntityPlayerSP_method_respawnPlayer_10.set("static", false);
        reflect_EntityPlayerSP_method_respawnPlayer_10.set("argnames", new String[]{});
        reflect_EntityPlayerSP_method_respawnPlayer_10.set("argtypes", new String[]{});
        reflect_EntityPlayerSP_method_respawnPlayer_10.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerSP) params.getReflective("_self")).respawnPlayer();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerSP_methods.add(reflect_EntityPlayerSP_method_respawnPlayer_10);


        BaseData reflect_EntityPlayerSP_method_closeScreen_11 = new ModData();
        reflect_EntityPlayerSP_method_closeScreen_11.set("methodName", "closeScreen");
        reflect_EntityPlayerSP_method_closeScreen_11.set("returnType", "void");
        reflect_EntityPlayerSP_method_closeScreen_11.set("static", false);
        reflect_EntityPlayerSP_method_closeScreen_11.set("argnames", new String[]{});
        reflect_EntityPlayerSP_method_closeScreen_11.set("argtypes", new String[]{});
        reflect_EntityPlayerSP_method_closeScreen_11.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerSP) params.getReflective("_self")).closeScreen();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerSP_methods.add(reflect_EntityPlayerSP_method_closeScreen_11);


        BaseData reflect_EntityPlayerSP_method_closeScreenAndDropStack_12 = new ModData();
        reflect_EntityPlayerSP_method_closeScreenAndDropStack_12.set("methodName", "closeScreenAndDropStack");
        reflect_EntityPlayerSP_method_closeScreenAndDropStack_12.set("returnType", "void");
        reflect_EntityPlayerSP_method_closeScreenAndDropStack_12.set("static", false);
        reflect_EntityPlayerSP_method_closeScreenAndDropStack_12.set("argnames", new String[]{});
        reflect_EntityPlayerSP_method_closeScreenAndDropStack_12.set("argtypes", new String[]{});
        reflect_EntityPlayerSP_method_closeScreenAndDropStack_12.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerSP) params.getReflective("_self")).closeScreenAndDropStack();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerSP_methods.add(reflect_EntityPlayerSP_method_closeScreenAndDropStack_12);


        BaseData reflect_EntityPlayerSP_method_setPlayerSPHealth_13 = new ModData();
        reflect_EntityPlayerSP_method_setPlayerSPHealth_13.set("methodName", "setPlayerSPHealth");
        reflect_EntityPlayerSP_method_setPlayerSPHealth_13.set("returnType", "void");
        reflect_EntityPlayerSP_method_setPlayerSPHealth_13.set("static", false);
        reflect_EntityPlayerSP_method_setPlayerSPHealth_13.set("argnames", new String[]{"health"});
        reflect_EntityPlayerSP_method_setPlayerSPHealth_13.set("argtypes", new String[]{"float"});
        reflect_EntityPlayerSP_method_setPlayerSPHealth_13.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerSP) params.getReflective("_self")).setPlayerSPHealth((float) params.getFloat("health"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerSP_methods.add(reflect_EntityPlayerSP_method_setPlayerSPHealth_13);


        BaseData reflect_EntityPlayerSP_method_addStat_14 = new ModData();
        reflect_EntityPlayerSP_method_addStat_14.set("methodName", "addStat");
        reflect_EntityPlayerSP_method_addStat_14.set("returnType", "void");
        reflect_EntityPlayerSP_method_addStat_14.set("static", false);
        reflect_EntityPlayerSP_method_addStat_14.set("argnames", new String[]{"stat", "amount"});
        reflect_EntityPlayerSP_method_addStat_14.set("argtypes", new String[]{"StatBase", "int"});
        reflect_EntityPlayerSP_method_addStat_14.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerSP) params.getReflective("_self")).addStat((StatBase) params.getReflective("stat"), (int) params.getInt("amount"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerSP_methods.add(reflect_EntityPlayerSP_method_addStat_14);


        BaseData reflect_EntityPlayerSP_method_sendPlayerAbilities_15 = new ModData();
        reflect_EntityPlayerSP_method_sendPlayerAbilities_15.set("methodName", "sendPlayerAbilities");
        reflect_EntityPlayerSP_method_sendPlayerAbilities_15.set("returnType", "void");
        reflect_EntityPlayerSP_method_sendPlayerAbilities_15.set("static", false);
        reflect_EntityPlayerSP_method_sendPlayerAbilities_15.set("argnames", new String[]{});
        reflect_EntityPlayerSP_method_sendPlayerAbilities_15.set("argtypes", new String[]{});
        reflect_EntityPlayerSP_method_sendPlayerAbilities_15.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerSP) params.getReflective("_self")).sendPlayerAbilities();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerSP_methods.add(reflect_EntityPlayerSP_method_sendPlayerAbilities_15);


        BaseData reflect_EntityPlayerSP_method_isUser_16 = new ModData();
        reflect_EntityPlayerSP_method_isUser_16.set("methodName", "isUser");
        reflect_EntityPlayerSP_method_isUser_16.set("returnType", "boolean");
        reflect_EntityPlayerSP_method_isUser_16.set("static", false);
        reflect_EntityPlayerSP_method_isUser_16.set("argnames", new String[]{});
        reflect_EntityPlayerSP_method_isUser_16.set("argtypes", new String[]{});
        reflect_EntityPlayerSP_method_isUser_16.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityPlayerSP) params.getReflective("_self")).isUser();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityPlayerSP_methods.add(reflect_EntityPlayerSP_method_isUser_16);


        BaseData reflect_EntityPlayerSP_method_sendHorseInventory_17 = new ModData();
        reflect_EntityPlayerSP_method_sendHorseInventory_17.set("methodName", "sendHorseInventory");
        reflect_EntityPlayerSP_method_sendHorseInventory_17.set("returnType", "void");
        reflect_EntityPlayerSP_method_sendHorseInventory_17.set("static", false);
        reflect_EntityPlayerSP_method_sendHorseInventory_17.set("argnames", new String[]{});
        reflect_EntityPlayerSP_method_sendHorseInventory_17.set("argtypes", new String[]{});
        reflect_EntityPlayerSP_method_sendHorseInventory_17.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerSP) params.getReflective("_self")).sendHorseInventory();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerSP_methods.add(reflect_EntityPlayerSP_method_sendHorseInventory_17);


        BaseData reflect_EntityPlayerSP_method_setClientBrand_18 = new ModData();
        reflect_EntityPlayerSP_method_setClientBrand_18.set("methodName", "setClientBrand");
        reflect_EntityPlayerSP_method_setClientBrand_18.set("returnType", "void");
        reflect_EntityPlayerSP_method_setClientBrand_18.set("static", false);
        reflect_EntityPlayerSP_method_setClientBrand_18.set("argnames", new String[]{"brand"});
        reflect_EntityPlayerSP_method_setClientBrand_18.set("argtypes", new String[]{"String"});
        reflect_EntityPlayerSP_method_setClientBrand_18.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerSP) params.getReflective("_self")).setClientBrand((String) params.getString("brand"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerSP_methods.add(reflect_EntityPlayerSP_method_setClientBrand_18);


        BaseData reflect_EntityPlayerSP_method_getClientBrand_19 = new ModData();
        reflect_EntityPlayerSP_method_getClientBrand_19.set("methodName", "getClientBrand");
        reflect_EntityPlayerSP_method_getClientBrand_19.set("returnType", "String");
        reflect_EntityPlayerSP_method_getClientBrand_19.set("static", false);
        reflect_EntityPlayerSP_method_getClientBrand_19.set("argnames", new String[]{});
        reflect_EntityPlayerSP_method_getClientBrand_19.set("argtypes", new String[]{});
        reflect_EntityPlayerSP_method_getClientBrand_19.setCallbackStringWithDataArg("exec", (BaseData params) -> {
                try {
                    return (String) ((EntityPlayerSP) params.getReflective("_self")).getClientBrand();
                } catch (Exception _exception_reflect_) {
                    return "";
                }
            });
            
        reflect_EntityPlayerSP_methods.add(reflect_EntityPlayerSP_method_getClientBrand_19);


        BaseData reflect_EntityPlayerSP_method_getStatFileWriter_20 = new ModData();
        reflect_EntityPlayerSP_method_getStatFileWriter_20.set("methodName", "getStatFileWriter");
        reflect_EntityPlayerSP_method_getStatFileWriter_20.set("returnType", "StatFileWriter");
        reflect_EntityPlayerSP_method_getStatFileWriter_20.set("static", false);
        reflect_EntityPlayerSP_method_getStatFileWriter_20.set("argnames", new String[]{});
        reflect_EntityPlayerSP_method_getStatFileWriter_20.set("argtypes", new String[]{});
        reflect_EntityPlayerSP_method_getStatFileWriter_20.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (StatFileWriter) ((EntityPlayerSP) params.getReflective("_self")).getStatFileWriter();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityPlayerSP_methods.add(reflect_EntityPlayerSP_method_getStatFileWriter_20);


        BaseData reflect_EntityPlayerSP_method_addChatComponentMessage_21 = new ModData();
        reflect_EntityPlayerSP_method_addChatComponentMessage_21.set("methodName", "addChatComponentMessage");
        reflect_EntityPlayerSP_method_addChatComponentMessage_21.set("returnType", "void");
        reflect_EntityPlayerSP_method_addChatComponentMessage_21.set("static", false);
        reflect_EntityPlayerSP_method_addChatComponentMessage_21.set("argnames", new String[]{"chatComponent"});
        reflect_EntityPlayerSP_method_addChatComponentMessage_21.set("argtypes", new String[]{"IChatComponent"});
        reflect_EntityPlayerSP_method_addChatComponentMessage_21.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerSP) params.getReflective("_self")).addChatComponentMessage((IChatComponent) params.getReflective("chatComponent"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerSP_methods.add(reflect_EntityPlayerSP_method_addChatComponentMessage_21);


        BaseData reflect_EntityPlayerSP_method_setSprinting_22 = new ModData();
        reflect_EntityPlayerSP_method_setSprinting_22.set("methodName", "setSprinting");
        reflect_EntityPlayerSP_method_setSprinting_22.set("returnType", "void");
        reflect_EntityPlayerSP_method_setSprinting_22.set("static", false);
        reflect_EntityPlayerSP_method_setSprinting_22.set("argnames", new String[]{"sprinting"});
        reflect_EntityPlayerSP_method_setSprinting_22.set("argtypes", new String[]{"boolean"});
        reflect_EntityPlayerSP_method_setSprinting_22.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerSP) params.getReflective("_self")).setSprinting((boolean) params.getBoolean("sprinting"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerSP_methods.add(reflect_EntityPlayerSP_method_setSprinting_22);


        BaseData reflect_EntityPlayerSP_method_setXPStats_23 = new ModData();
        reflect_EntityPlayerSP_method_setXPStats_23.set("methodName", "setXPStats");
        reflect_EntityPlayerSP_method_setXPStats_23.set("returnType", "void");
        reflect_EntityPlayerSP_method_setXPStats_23.set("static", false);
        reflect_EntityPlayerSP_method_setXPStats_23.set("argnames", new String[]{"currentXP", "maxXP", "level"});
        reflect_EntityPlayerSP_method_setXPStats_23.set("argtypes", new String[]{"float", "int", "int"});
        reflect_EntityPlayerSP_method_setXPStats_23.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerSP) params.getReflective("_self")).setXPStats((float) params.getFloat("currentXP"), (int) params.getInt("maxXP"), (int) params.getInt("level"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerSP_methods.add(reflect_EntityPlayerSP_method_setXPStats_23);


        BaseData reflect_EntityPlayerSP_method_addChatMessage_24 = new ModData();
        reflect_EntityPlayerSP_method_addChatMessage_24.set("methodName", "addChatMessage");
        reflect_EntityPlayerSP_method_addChatMessage_24.set("returnType", "void");
        reflect_EntityPlayerSP_method_addChatMessage_24.set("static", false);
        reflect_EntityPlayerSP_method_addChatMessage_24.set("argnames", new String[]{"ichatcomponent"});
        reflect_EntityPlayerSP_method_addChatMessage_24.set("argtypes", new String[]{"IChatComponent"});
        reflect_EntityPlayerSP_method_addChatMessage_24.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerSP) params.getReflective("_self")).addChatMessage((IChatComponent) params.getReflective("ichatcomponent"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerSP_methods.add(reflect_EntityPlayerSP_method_addChatMessage_24);


        BaseData reflect_EntityPlayerSP_method_canCommandSenderUseCommand_25 = new ModData();
        reflect_EntityPlayerSP_method_canCommandSenderUseCommand_25.set("methodName", "canCommandSenderUseCommand");
        reflect_EntityPlayerSP_method_canCommandSenderUseCommand_25.set("returnType", "boolean");
        reflect_EntityPlayerSP_method_canCommandSenderUseCommand_25.set("static", false);
        reflect_EntityPlayerSP_method_canCommandSenderUseCommand_25.set("argnames", new String[]{"i", "var2"});
        reflect_EntityPlayerSP_method_canCommandSenderUseCommand_25.set("argtypes", new String[]{"int", "String"});
        reflect_EntityPlayerSP_method_canCommandSenderUseCommand_25.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityPlayerSP) params.getReflective("_self")).canCommandSenderUseCommand((int) params.getInt("i"), (String) params.getString("var2"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityPlayerSP_methods.add(reflect_EntityPlayerSP_method_canCommandSenderUseCommand_25);


        BaseData reflect_EntityPlayerSP_method_getPosition_26 = new ModData();
        reflect_EntityPlayerSP_method_getPosition_26.set("methodName", "getPosition");
        reflect_EntityPlayerSP_method_getPosition_26.set("returnType", "BlockPos");
        reflect_EntityPlayerSP_method_getPosition_26.set("static", false);
        reflect_EntityPlayerSP_method_getPosition_26.set("argnames", new String[]{});
        reflect_EntityPlayerSP_method_getPosition_26.set("argtypes", new String[]{});
        reflect_EntityPlayerSP_method_getPosition_26.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (BlockPos) ((EntityPlayerSP) params.getReflective("_self")).getPosition();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EntityPlayerSP_methods.add(reflect_EntityPlayerSP_method_getPosition_26);


        BaseData reflect_EntityPlayerSP_method_playSound_27 = new ModData();
        reflect_EntityPlayerSP_method_playSound_27.set("methodName", "playSound");
        reflect_EntityPlayerSP_method_playSound_27.set("returnType", "void");
        reflect_EntityPlayerSP_method_playSound_27.set("static", false);
        reflect_EntityPlayerSP_method_playSound_27.set("argnames", new String[]{"name", "volume", "pitch"});
        reflect_EntityPlayerSP_method_playSound_27.set("argtypes", new String[]{"String", "float", "float"});
        reflect_EntityPlayerSP_method_playSound_27.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerSP) params.getReflective("_self")).playSound((String) params.getString("name"), (float) params.getFloat("volume"), (float) params.getFloat("pitch"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerSP_methods.add(reflect_EntityPlayerSP_method_playSound_27);


        BaseData reflect_EntityPlayerSP_method_isServerWorld_28 = new ModData();
        reflect_EntityPlayerSP_method_isServerWorld_28.set("methodName", "isServerWorld");
        reflect_EntityPlayerSP_method_isServerWorld_28.set("returnType", "boolean");
        reflect_EntityPlayerSP_method_isServerWorld_28.set("static", false);
        reflect_EntityPlayerSP_method_isServerWorld_28.set("argnames", new String[]{});
        reflect_EntityPlayerSP_method_isServerWorld_28.set("argtypes", new String[]{});
        reflect_EntityPlayerSP_method_isServerWorld_28.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityPlayerSP) params.getReflective("_self")).isServerWorld();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityPlayerSP_methods.add(reflect_EntityPlayerSP_method_isServerWorld_28);


        BaseData reflect_EntityPlayerSP_method_isRidingHorse_29 = new ModData();
        reflect_EntityPlayerSP_method_isRidingHorse_29.set("methodName", "isRidingHorse");
        reflect_EntityPlayerSP_method_isRidingHorse_29.set("returnType", "boolean");
        reflect_EntityPlayerSP_method_isRidingHorse_29.set("static", false);
        reflect_EntityPlayerSP_method_isRidingHorse_29.set("argnames", new String[]{});
        reflect_EntityPlayerSP_method_isRidingHorse_29.set("argtypes", new String[]{});
        reflect_EntityPlayerSP_method_isRidingHorse_29.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityPlayerSP) params.getReflective("_self")).isRidingHorse();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityPlayerSP_methods.add(reflect_EntityPlayerSP_method_isRidingHorse_29);


        BaseData reflect_EntityPlayerSP_method_getHorseJumpPower_30 = new ModData();
        reflect_EntityPlayerSP_method_getHorseJumpPower_30.set("methodName", "getHorseJumpPower");
        reflect_EntityPlayerSP_method_getHorseJumpPower_30.set("returnType", "float");
        reflect_EntityPlayerSP_method_getHorseJumpPower_30.set("static", false);
        reflect_EntityPlayerSP_method_getHorseJumpPower_30.set("argnames", new String[]{});
        reflect_EntityPlayerSP_method_getHorseJumpPower_30.set("argtypes", new String[]{});
        reflect_EntityPlayerSP_method_getHorseJumpPower_30.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityPlayerSP) params.getReflective("_self")).getHorseJumpPower();
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityPlayerSP_methods.add(reflect_EntityPlayerSP_method_getHorseJumpPower_30);


        BaseData reflect_EntityPlayerSP_method_openEditSign_31 = new ModData();
        reflect_EntityPlayerSP_method_openEditSign_31.set("methodName", "openEditSign");
        reflect_EntityPlayerSP_method_openEditSign_31.set("returnType", "void");
        reflect_EntityPlayerSP_method_openEditSign_31.set("static", false);
        reflect_EntityPlayerSP_method_openEditSign_31.set("argnames", new String[]{"signTile"});
        reflect_EntityPlayerSP_method_openEditSign_31.set("argtypes", new String[]{"TileEntitySign"});
        reflect_EntityPlayerSP_method_openEditSign_31.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerSP) params.getReflective("_self")).openEditSign((TileEntitySign) params.getReflective("signTile"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerSP_methods.add(reflect_EntityPlayerSP_method_openEditSign_31);


        BaseData reflect_EntityPlayerSP_method_openEditCommandBlock_32 = new ModData();
        reflect_EntityPlayerSP_method_openEditCommandBlock_32.set("methodName", "openEditCommandBlock");
        reflect_EntityPlayerSP_method_openEditCommandBlock_32.set("returnType", "void");
        reflect_EntityPlayerSP_method_openEditCommandBlock_32.set("static", false);
        reflect_EntityPlayerSP_method_openEditCommandBlock_32.set("argnames", new String[]{"cmdBlockLogic"});
        reflect_EntityPlayerSP_method_openEditCommandBlock_32.set("argtypes", new String[]{"CommandBlockLogic"});
        reflect_EntityPlayerSP_method_openEditCommandBlock_32.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerSP) params.getReflective("_self")).openEditCommandBlock((CommandBlockLogic) params.getReflective("cmdBlockLogic"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerSP_methods.add(reflect_EntityPlayerSP_method_openEditCommandBlock_32);


        BaseData reflect_EntityPlayerSP_method_displayGUIBook_33 = new ModData();
        reflect_EntityPlayerSP_method_displayGUIBook_33.set("methodName", "displayGUIBook");
        reflect_EntityPlayerSP_method_displayGUIBook_33.set("returnType", "void");
        reflect_EntityPlayerSP_method_displayGUIBook_33.set("static", false);
        reflect_EntityPlayerSP_method_displayGUIBook_33.set("argnames", new String[]{"bookStack"});
        reflect_EntityPlayerSP_method_displayGUIBook_33.set("argtypes", new String[]{"ItemStack"});
        reflect_EntityPlayerSP_method_displayGUIBook_33.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerSP) params.getReflective("_self")).displayGUIBook((ItemStack) params.getReflective("bookStack"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerSP_methods.add(reflect_EntityPlayerSP_method_displayGUIBook_33);


        BaseData reflect_EntityPlayerSP_method_displayGUIChest_34 = new ModData();
        reflect_EntityPlayerSP_method_displayGUIChest_34.set("methodName", "displayGUIChest");
        reflect_EntityPlayerSP_method_displayGUIChest_34.set("returnType", "void");
        reflect_EntityPlayerSP_method_displayGUIChest_34.set("static", false);
        reflect_EntityPlayerSP_method_displayGUIChest_34.set("argnames", new String[]{"chestInventory"});
        reflect_EntityPlayerSP_method_displayGUIChest_34.set("argtypes", new String[]{"IInventory"});
        reflect_EntityPlayerSP_method_displayGUIChest_34.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerSP) params.getReflective("_self")).displayGUIChest((IInventory) params.getReflective("chestInventory"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerSP_methods.add(reflect_EntityPlayerSP_method_displayGUIChest_34);


        BaseData reflect_EntityPlayerSP_method_displayGUIHorse_35 = new ModData();
        reflect_EntityPlayerSP_method_displayGUIHorse_35.set("methodName", "displayGUIHorse");
        reflect_EntityPlayerSP_method_displayGUIHorse_35.set("returnType", "void");
        reflect_EntityPlayerSP_method_displayGUIHorse_35.set("static", false);
        reflect_EntityPlayerSP_method_displayGUIHorse_35.set("argnames", new String[]{"horse", "horseInventory"});
        reflect_EntityPlayerSP_method_displayGUIHorse_35.set("argtypes", new String[]{"EntityHorse", "IInventory"});
        reflect_EntityPlayerSP_method_displayGUIHorse_35.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerSP) params.getReflective("_self")).displayGUIHorse((EntityHorse) params.getReflective("horse"), (IInventory) params.getReflective("horseInventory"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerSP_methods.add(reflect_EntityPlayerSP_method_displayGUIHorse_35);


        BaseData reflect_EntityPlayerSP_method_displayGui_36 = new ModData();
        reflect_EntityPlayerSP_method_displayGui_36.set("methodName", "displayGui");
        reflect_EntityPlayerSP_method_displayGui_36.set("returnType", "void");
        reflect_EntityPlayerSP_method_displayGui_36.set("static", false);
        reflect_EntityPlayerSP_method_displayGui_36.set("argnames", new String[]{"guiOwner"});
        reflect_EntityPlayerSP_method_displayGui_36.set("argtypes", new String[]{"IInteractionObject"});
        reflect_EntityPlayerSP_method_displayGui_36.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerSP) params.getReflective("_self")).displayGui((IInteractionObject) params.getReflective("guiOwner"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerSP_methods.add(reflect_EntityPlayerSP_method_displayGui_36);


        BaseData reflect_EntityPlayerSP_method_displayVillagerTradeGui_37 = new ModData();
        reflect_EntityPlayerSP_method_displayVillagerTradeGui_37.set("methodName", "displayVillagerTradeGui");
        reflect_EntityPlayerSP_method_displayVillagerTradeGui_37.set("returnType", "void");
        reflect_EntityPlayerSP_method_displayVillagerTradeGui_37.set("static", false);
        reflect_EntityPlayerSP_method_displayVillagerTradeGui_37.set("argnames", new String[]{"villager"});
        reflect_EntityPlayerSP_method_displayVillagerTradeGui_37.set("argtypes", new String[]{"IMerchant"});
        reflect_EntityPlayerSP_method_displayVillagerTradeGui_37.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerSP) params.getReflective("_self")).displayVillagerTradeGui((IMerchant) params.getReflective("villager"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerSP_methods.add(reflect_EntityPlayerSP_method_displayVillagerTradeGui_37);


        BaseData reflect_EntityPlayerSP_method_onCriticalHit_38 = new ModData();
        reflect_EntityPlayerSP_method_onCriticalHit_38.set("methodName", "onCriticalHit");
        reflect_EntityPlayerSP_method_onCriticalHit_38.set("returnType", "void");
        reflect_EntityPlayerSP_method_onCriticalHit_38.set("static", false);
        reflect_EntityPlayerSP_method_onCriticalHit_38.set("argnames", new String[]{"entityHit"});
        reflect_EntityPlayerSP_method_onCriticalHit_38.set("argtypes", new String[]{"Entity"});
        reflect_EntityPlayerSP_method_onCriticalHit_38.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerSP) params.getReflective("_self")).onCriticalHit((Entity) params.getReflective("entityHit"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerSP_methods.add(reflect_EntityPlayerSP_method_onCriticalHit_38);


        BaseData reflect_EntityPlayerSP_method_onEnchantmentCritical_39 = new ModData();
        reflect_EntityPlayerSP_method_onEnchantmentCritical_39.set("methodName", "onEnchantmentCritical");
        reflect_EntityPlayerSP_method_onEnchantmentCritical_39.set("returnType", "void");
        reflect_EntityPlayerSP_method_onEnchantmentCritical_39.set("static", false);
        reflect_EntityPlayerSP_method_onEnchantmentCritical_39.set("argnames", new String[]{"entityHit"});
        reflect_EntityPlayerSP_method_onEnchantmentCritical_39.set("argtypes", new String[]{"Entity"});
        reflect_EntityPlayerSP_method_onEnchantmentCritical_39.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerSP) params.getReflective("_self")).onEnchantmentCritical((Entity) params.getReflective("entityHit"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerSP_methods.add(reflect_EntityPlayerSP_method_onEnchantmentCritical_39);


        BaseData reflect_EntityPlayerSP_method_isSneaking_40 = new ModData();
        reflect_EntityPlayerSP_method_isSneaking_40.set("methodName", "isSneaking");
        reflect_EntityPlayerSP_method_isSneaking_40.set("returnType", "boolean");
        reflect_EntityPlayerSP_method_isSneaking_40.set("static", false);
        reflect_EntityPlayerSP_method_isSneaking_40.set("argnames", new String[]{});
        reflect_EntityPlayerSP_method_isSneaking_40.set("argtypes", new String[]{});
        reflect_EntityPlayerSP_method_isSneaking_40.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityPlayerSP) params.getReflective("_self")).isSneaking();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityPlayerSP_methods.add(reflect_EntityPlayerSP_method_isSneaking_40);


        BaseData reflect_EntityPlayerSP_method_updateEntityActionState_41 = new ModData();
        reflect_EntityPlayerSP_method_updateEntityActionState_41.set("methodName", "updateEntityActionState");
        reflect_EntityPlayerSP_method_updateEntityActionState_41.set("returnType", "void");
        reflect_EntityPlayerSP_method_updateEntityActionState_41.set("static", false);
        reflect_EntityPlayerSP_method_updateEntityActionState_41.set("argnames", new String[]{});
        reflect_EntityPlayerSP_method_updateEntityActionState_41.set("argtypes", new String[]{});
        reflect_EntityPlayerSP_method_updateEntityActionState_41.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerSP) params.getReflective("_self")).updateEntityActionState();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerSP_methods.add(reflect_EntityPlayerSP_method_updateEntityActionState_41);


        BaseData reflect_EntityPlayerSP_method_onLivingUpdate_42 = new ModData();
        reflect_EntityPlayerSP_method_onLivingUpdate_42.set("methodName", "onLivingUpdate");
        reflect_EntityPlayerSP_method_onLivingUpdate_42.set("returnType", "void");
        reflect_EntityPlayerSP_method_onLivingUpdate_42.set("static", false);
        reflect_EntityPlayerSP_method_onLivingUpdate_42.set("argnames", new String[]{});
        reflect_EntityPlayerSP_method_onLivingUpdate_42.set("argtypes", new String[]{});
        reflect_EntityPlayerSP_method_onLivingUpdate_42.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerSP) params.getReflective("_self")).onLivingUpdate();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerSP_methods.add(reflect_EntityPlayerSP_method_onLivingUpdate_42);


        BaseData reflect_EntityPlayerSP_method_getSpeed_43 = new ModData();
        reflect_EntityPlayerSP_method_getSpeed_43.set("methodName", "getSpeed");
        reflect_EntityPlayerSP_method_getSpeed_43.set("returnType", "float");
        reflect_EntityPlayerSP_method_getSpeed_43.set("static", false);
        reflect_EntityPlayerSP_method_getSpeed_43.set("argnames", new String[]{});
        reflect_EntityPlayerSP_method_getSpeed_43.set("argtypes", new String[]{});
        reflect_EntityPlayerSP_method_getSpeed_43.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((EntityPlayerSP) params.getReflective("_self")).getSpeed();
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_EntityPlayerSP_methods.add(reflect_EntityPlayerSP_method_getSpeed_43);


        BaseData reflect_EntityPlayerSP_method_strafe_44 = new ModData();
        reflect_EntityPlayerSP_method_strafe_44.set("methodName", "strafe");
        reflect_EntityPlayerSP_method_strafe_44.set("returnType", "void");
        reflect_EntityPlayerSP_method_strafe_44.set("static", false);
        reflect_EntityPlayerSP_method_strafe_44.set("argnames", new String[]{});
        reflect_EntityPlayerSP_method_strafe_44.set("argtypes", new String[]{});
        reflect_EntityPlayerSP_method_strafe_44.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerSP) params.getReflective("_self")).strafe();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerSP_methods.add(reflect_EntityPlayerSP_method_strafe_44);


        BaseData reflect_EntityPlayerSP_method_isMoving_45 = new ModData();
        reflect_EntityPlayerSP_method_isMoving_45.set("methodName", "isMoving");
        reflect_EntityPlayerSP_method_isMoving_45.set("returnType", "boolean");
        reflect_EntityPlayerSP_method_isMoving_45.set("static", false);
        reflect_EntityPlayerSP_method_isMoving_45.set("argnames", new String[]{});
        reflect_EntityPlayerSP_method_isMoving_45.set("argtypes", new String[]{});
        reflect_EntityPlayerSP_method_isMoving_45.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityPlayerSP) params.getReflective("_self")).isMoving();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityPlayerSP_methods.add(reflect_EntityPlayerSP_method_isMoving_45);


        BaseData reflect_EntityPlayerSP_method_hasMotion_46 = new ModData();
        reflect_EntityPlayerSP_method_hasMotion_46.set("methodName", "hasMotion");
        reflect_EntityPlayerSP_method_hasMotion_46.set("returnType", "boolean");
        reflect_EntityPlayerSP_method_hasMotion_46.set("static", false);
        reflect_EntityPlayerSP_method_hasMotion_46.set("argnames", new String[]{});
        reflect_EntityPlayerSP_method_hasMotion_46.set("argtypes", new String[]{});
        reflect_EntityPlayerSP_method_hasMotion_46.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EntityPlayerSP) params.getReflective("_self")).hasMotion();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EntityPlayerSP_methods.add(reflect_EntityPlayerSP_method_hasMotion_46);


        BaseData reflect_EntityPlayerSP_method_strafe_47 = new ModData();
        reflect_EntityPlayerSP_method_strafe_47.set("methodName", "strafe");
        reflect_EntityPlayerSP_method_strafe_47.set("returnType", "void");
        reflect_EntityPlayerSP_method_strafe_47.set("static", false);
        reflect_EntityPlayerSP_method_strafe_47.set("argnames", new String[]{"speed"});
        reflect_EntityPlayerSP_method_strafe_47.set("argtypes", new String[]{"float"});
        reflect_EntityPlayerSP_method_strafe_47.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerSP) params.getReflective("_self")).strafe((float) params.getFloat("speed"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerSP_methods.add(reflect_EntityPlayerSP_method_strafe_47);


        BaseData reflect_EntityPlayerSP_method_getDirection_48 = new ModData();
        reflect_EntityPlayerSP_method_getDirection_48.set("methodName", "getDirection");
        reflect_EntityPlayerSP_method_getDirection_48.set("returnType", "double");
        reflect_EntityPlayerSP_method_getDirection_48.set("static", false);
        reflect_EntityPlayerSP_method_getDirection_48.set("argnames", new String[]{});
        reflect_EntityPlayerSP_method_getDirection_48.set("argtypes", new String[]{});
        reflect_EntityPlayerSP_method_getDirection_48.setCallbackDoubleWithDataArg("exec", (BaseData params) -> {
                try {
                    return (double) ((EntityPlayerSP) params.getReflective("_self")).getDirection();
                } catch (Exception _exception_reflect_) {
                    return 0.0d;
                }
            });
            
        reflect_EntityPlayerSP_methods.add(reflect_EntityPlayerSP_method_getDirection_48);


        BaseData reflect_EntityPlayerSP_method_setSpeed_49 = new ModData();
        reflect_EntityPlayerSP_method_setSpeed_49.set("methodName", "setSpeed");
        reflect_EntityPlayerSP_method_setSpeed_49.set("returnType", "void");
        reflect_EntityPlayerSP_method_setSpeed_49.set("static", false);
        reflect_EntityPlayerSP_method_setSpeed_49.set("argnames", new String[]{"speed"});
        reflect_EntityPlayerSP_method_setSpeed_49.set("argtypes", new String[]{"float"});
        reflect_EntityPlayerSP_method_setSpeed_49.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EntityPlayerSP) params.getReflective("_self")).setSpeed((float) params.getFloat("speed"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EntityPlayerSP_methods.add(reflect_EntityPlayerSP_method_setSpeed_49);


        BaseData[] reflect_EntityPlayerSP_methods_arr = new BaseData[reflect_EntityPlayerSP_methods.size()];
        for (int i = 0; i < reflect_EntityPlayerSP_methods_arr.length; i++) {
            reflect_EntityPlayerSP_methods_arr[i] = reflect_EntityPlayerSP_methods.get(i);
        }

        reflect_EntityPlayerSP.set("constructors", reflect_EntityPlayerSP_constructors_arr);
        reflect_EntityPlayerSP.set("methods", reflect_EntityPlayerSP_methods_arr);
        reflect_EntityPlayerSP.set("className", "EntityPlayerSP");
        reflect_EntityPlayerSP.set("classId", "net.minecraft.client.entity.EntityPlayerSP");
        reflect_EntityPlayerSP.set("class", EntityPlayerSP.class);
        reflect_EntityPlayerSP.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EntityPlayerSP;
        });
        reflectProfiles.add(reflect_EntityPlayerSP);
    }


    //classdef for EaglercraftGPU
    public static void reflect_EaglercraftGPU_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_EaglercraftGPU = new ModData();

        ArrayList<BaseData> reflect_EaglercraftGPU_constructors = new ArrayList<BaseData>();
        
        BaseData[] reflect_EaglercraftGPU_constructors_arr = new BaseData[reflect_EaglercraftGPU_constructors.size()];
        for (int i = 0; i < reflect_EaglercraftGPU_constructors_arr.length; i++) {
            reflect_EaglercraftGPU_constructors_arr[i] = reflect_EaglercraftGPU_constructors.get(i);
        }

        ArrayList<BaseData> reflect_EaglercraftGPU_methods = new ArrayList<BaseData>();
        
        BaseData reflect_EaglercraftGPU_method_gluErrorString_0 = new ModData();
        reflect_EaglercraftGPU_method_gluErrorString_0.set("methodName", "gluErrorString");
        reflect_EaglercraftGPU_method_gluErrorString_0.set("returnType", "String");
        reflect_EaglercraftGPU_method_gluErrorString_0.set("static", false);
        reflect_EaglercraftGPU_method_gluErrorString_0.set("argnames", new String[]{"i"});
        reflect_EaglercraftGPU_method_gluErrorString_0.set("argtypes", new String[]{"int"});
        reflect_EaglercraftGPU_method_gluErrorString_0.setCallbackStringWithDataArg("exec", (BaseData params) -> {
                try {
                    return (String) ((EaglercraftGPU) params.getReflective("_self")).gluErrorString((int) params.getInt("i"));
                } catch (Exception _exception_reflect_) {
                    return "";
                }
            });
            
        reflect_EaglercraftGPU_methods.add(reflect_EaglercraftGPU_method_gluErrorString_0);


        BaseData reflect_EaglercraftGPU_method_glTexParameteri_1 = new ModData();
        reflect_EaglercraftGPU_method_glTexParameteri_1.set("methodName", "glTexParameteri");
        reflect_EaglercraftGPU_method_glTexParameteri_1.set("returnType", "void");
        reflect_EaglercraftGPU_method_glTexParameteri_1.set("static", false);
        reflect_EaglercraftGPU_method_glTexParameteri_1.set("argnames", new String[]{"target", "param", "value"});
        reflect_EaglercraftGPU_method_glTexParameteri_1.set("argtypes", new String[]{"int", "int", "int"});
        reflect_EaglercraftGPU_method_glTexParameteri_1.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EaglercraftGPU) params.getReflective("_self")).glTexParameteri((int) params.getInt("target"), (int) params.getInt("param"), (int) params.getInt("value"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EaglercraftGPU_methods.add(reflect_EaglercraftGPU_method_glTexParameteri_1);


        BaseData reflect_EaglercraftGPU_method_glTexParameterf_2 = new ModData();
        reflect_EaglercraftGPU_method_glTexParameterf_2.set("methodName", "glTexParameterf");
        reflect_EaglercraftGPU_method_glTexParameterf_2.set("returnType", "void");
        reflect_EaglercraftGPU_method_glTexParameterf_2.set("static", false);
        reflect_EaglercraftGPU_method_glTexParameterf_2.set("argnames", new String[]{"target", "param", "value"});
        reflect_EaglercraftGPU_method_glTexParameterf_2.set("argtypes", new String[]{"int", "int", "float"});
        reflect_EaglercraftGPU_method_glTexParameterf_2.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EaglercraftGPU) params.getReflective("_self")).glTexParameterf((int) params.getInt("target"), (int) params.getInt("param"), (float) params.getFloat("value"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EaglercraftGPU_methods.add(reflect_EaglercraftGPU_method_glTexParameterf_2);


        BaseData reflect_EaglercraftGPU_method_glCopyTexSubImage2D_3 = new ModData();
        reflect_EaglercraftGPU_method_glCopyTexSubImage2D_3.set("methodName", "glCopyTexSubImage2D");
        reflect_EaglercraftGPU_method_glCopyTexSubImage2D_3.set("returnType", "void");
        reflect_EaglercraftGPU_method_glCopyTexSubImage2D_3.set("static", false);
        reflect_EaglercraftGPU_method_glCopyTexSubImage2D_3.set("argnames", new String[]{"target", "level", "sx", "sy", "dx", "dy", "w", "h"});
        reflect_EaglercraftGPU_method_glCopyTexSubImage2D_3.set("argtypes", new String[]{"int", "int", "int", "int", "int", "int", "int", "int"});
        reflect_EaglercraftGPU_method_glCopyTexSubImage2D_3.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EaglercraftGPU) params.getReflective("_self")).glCopyTexSubImage2D((int) params.getInt("target"), (int) params.getInt("level"), (int) params.getInt("sx"), (int) params.getInt("sy"), (int) params.getInt("dx"), (int) params.getInt("dy"), (int) params.getInt("w"), (int) params.getInt("h"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EaglercraftGPU_methods.add(reflect_EaglercraftGPU_method_glCopyTexSubImage2D_3);


        BaseData reflect_EaglercraftGPU_method_glNewList_4 = new ModData();
        reflect_EaglercraftGPU_method_glNewList_4.set("methodName", "glNewList");
        reflect_EaglercraftGPU_method_glNewList_4.set("returnType", "void");
        reflect_EaglercraftGPU_method_glNewList_4.set("static", false);
        reflect_EaglercraftGPU_method_glNewList_4.set("argnames", new String[]{"target", "op"});
        reflect_EaglercraftGPU_method_glNewList_4.set("argtypes", new String[]{"int", "int"});
        reflect_EaglercraftGPU_method_glNewList_4.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EaglercraftGPU) params.getReflective("_self")).glNewList((int) params.getInt("target"), (int) params.getInt("op"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EaglercraftGPU_methods.add(reflect_EaglercraftGPU_method_glNewList_4);


        BaseData reflect_EaglercraftGPU_method_glEndList_5 = new ModData();
        reflect_EaglercraftGPU_method_glEndList_5.set("methodName", "glEndList");
        reflect_EaglercraftGPU_method_glEndList_5.set("returnType", "void");
        reflect_EaglercraftGPU_method_glEndList_5.set("static", false);
        reflect_EaglercraftGPU_method_glEndList_5.set("argnames", new String[]{});
        reflect_EaglercraftGPU_method_glEndList_5.set("argtypes", new String[]{});
        reflect_EaglercraftGPU_method_glEndList_5.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EaglercraftGPU) params.getReflective("_self")).glEndList();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EaglercraftGPU_methods.add(reflect_EaglercraftGPU_method_glEndList_5);


        BaseData reflect_EaglercraftGPU_method_glCallList_6 = new ModData();
        reflect_EaglercraftGPU_method_glCallList_6.set("methodName", "glCallList");
        reflect_EaglercraftGPU_method_glCallList_6.set("returnType", "void");
        reflect_EaglercraftGPU_method_glCallList_6.set("static", false);
        reflect_EaglercraftGPU_method_glCallList_6.set("argnames", new String[]{"displayList"});
        reflect_EaglercraftGPU_method_glCallList_6.set("argtypes", new String[]{"int"});
        reflect_EaglercraftGPU_method_glCallList_6.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EaglercraftGPU) params.getReflective("_self")).glCallList((int) params.getInt("displayList"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EaglercraftGPU_methods.add(reflect_EaglercraftGPU_method_glCallList_6);


        BaseData reflect_EaglercraftGPU_method_flushDisplayList_7 = new ModData();
        reflect_EaglercraftGPU_method_flushDisplayList_7.set("methodName", "flushDisplayList");
        reflect_EaglercraftGPU_method_flushDisplayList_7.set("returnType", "void");
        reflect_EaglercraftGPU_method_flushDisplayList_7.set("static", false);
        reflect_EaglercraftGPU_method_flushDisplayList_7.set("argnames", new String[]{"displayList"});
        reflect_EaglercraftGPU_method_flushDisplayList_7.set("argtypes", new String[]{"int"});
        reflect_EaglercraftGPU_method_flushDisplayList_7.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EaglercraftGPU) params.getReflective("_self")).flushDisplayList((int) params.getInt("displayList"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EaglercraftGPU_methods.add(reflect_EaglercraftGPU_method_flushDisplayList_7);


        BaseData reflect_EaglercraftGPU_method_glNormal3f_8 = new ModData();
        reflect_EaglercraftGPU_method_glNormal3f_8.set("methodName", "glNormal3f");
        reflect_EaglercraftGPU_method_glNormal3f_8.set("returnType", "void");
        reflect_EaglercraftGPU_method_glNormal3f_8.set("static", false);
        reflect_EaglercraftGPU_method_glNormal3f_8.set("argnames", new String[]{"x", "y", "z"});
        reflect_EaglercraftGPU_method_glNormal3f_8.set("argtypes", new String[]{"float", "float", "float"});
        reflect_EaglercraftGPU_method_glNormal3f_8.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EaglercraftGPU) params.getReflective("_self")).glNormal3f((float) params.getFloat("x"), (float) params.getFloat("y"), (float) params.getFloat("z"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EaglercraftGPU_methods.add(reflect_EaglercraftGPU_method_glNormal3f_8);


        BaseData reflect_EaglercraftGPU_method_glGetString_9 = new ModData();
        reflect_EaglercraftGPU_method_glGetString_9.set("methodName", "glGetString");
        reflect_EaglercraftGPU_method_glGetString_9.set("returnType", "String");
        reflect_EaglercraftGPU_method_glGetString_9.set("static", false);
        reflect_EaglercraftGPU_method_glGetString_9.set("argnames", new String[]{"param"});
        reflect_EaglercraftGPU_method_glGetString_9.set("argtypes", new String[]{"int"});
        reflect_EaglercraftGPU_method_glGetString_9.setCallbackStringWithDataArg("exec", (BaseData params) -> {
                try {
                    return (String) ((EaglercraftGPU) params.getReflective("_self")).glGetString((int) params.getInt("param"));
                } catch (Exception _exception_reflect_) {
                    return "";
                }
            });
            
        reflect_EaglercraftGPU_methods.add(reflect_EaglercraftGPU_method_glGetString_9);


        BaseData reflect_EaglercraftGPU_method_glGetInteger_10 = new ModData();
        reflect_EaglercraftGPU_method_glGetInteger_10.set("methodName", "glGetInteger");
        reflect_EaglercraftGPU_method_glGetInteger_10.set("returnType", "void");
        reflect_EaglercraftGPU_method_glGetInteger_10.set("static", false);
        reflect_EaglercraftGPU_method_glGetInteger_10.set("argnames", new String[]{"param", "values"});
        reflect_EaglercraftGPU_method_glGetInteger_10.set("argtypes", new String[]{"int", "int[]"});
        reflect_EaglercraftGPU_method_glGetInteger_10.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EaglercraftGPU) params.getReflective("_self")).glGetInteger((int) params.getInt("param"), (int[]) params.getReflective("values"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EaglercraftGPU_methods.add(reflect_EaglercraftGPU_method_glGetInteger_10);


        BaseData reflect_EaglercraftGPU_method_glGetInteger_11 = new ModData();
        reflect_EaglercraftGPU_method_glGetInteger_11.set("methodName", "glGetInteger");
        reflect_EaglercraftGPU_method_glGetInteger_11.set("returnType", "int");
        reflect_EaglercraftGPU_method_glGetInteger_11.set("static", false);
        reflect_EaglercraftGPU_method_glGetInteger_11.set("argnames", new String[]{"param"});
        reflect_EaglercraftGPU_method_glGetInteger_11.set("argtypes", new String[]{"int"});
        reflect_EaglercraftGPU_method_glGetInteger_11.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EaglercraftGPU) params.getReflective("_self")).glGetInteger((int) params.getInt("param"));
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EaglercraftGPU_methods.add(reflect_EaglercraftGPU_method_glGetInteger_11);


        BaseData reflect_EaglercraftGPU_method_glTexStorage2D_12 = new ModData();
        reflect_EaglercraftGPU_method_glTexStorage2D_12.set("methodName", "glTexStorage2D");
        reflect_EaglercraftGPU_method_glTexStorage2D_12.set("returnType", "void");
        reflect_EaglercraftGPU_method_glTexStorage2D_12.set("static", false);
        reflect_EaglercraftGPU_method_glTexStorage2D_12.set("argnames", new String[]{"target", "levels", "internalFormat", "w", "h"});
        reflect_EaglercraftGPU_method_glTexStorage2D_12.set("argtypes", new String[]{"int", "int", "int", "int", "int"});
        reflect_EaglercraftGPU_method_glTexStorage2D_12.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EaglercraftGPU) params.getReflective("_self")).glTexStorage2D((int) params.getInt("target"), (int) params.getInt("levels"), (int) params.getInt("internalFormat"), (int) params.getInt("w"), (int) params.getInt("h"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EaglercraftGPU_methods.add(reflect_EaglercraftGPU_method_glTexStorage2D_12);


        BaseData reflect_EaglercraftGPU_method_glLineWidth_13 = new ModData();
        reflect_EaglercraftGPU_method_glLineWidth_13.set("methodName", "glLineWidth");
        reflect_EaglercraftGPU_method_glLineWidth_13.set("returnType", "void");
        reflect_EaglercraftGPU_method_glLineWidth_13.set("static", false);
        reflect_EaglercraftGPU_method_glLineWidth_13.set("argnames", new String[]{"f"});
        reflect_EaglercraftGPU_method_glLineWidth_13.set("argtypes", new String[]{"float"});
        reflect_EaglercraftGPU_method_glLineWidth_13.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EaglercraftGPU) params.getReflective("_self")).glLineWidth((float) params.getFloat("f"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EaglercraftGPU_methods.add(reflect_EaglercraftGPU_method_glLineWidth_13);


        BaseData reflect_EaglercraftGPU_method_glFog_14 = new ModData();
        reflect_EaglercraftGPU_method_glFog_14.set("methodName", "glFog");
        reflect_EaglercraftGPU_method_glFog_14.set("returnType", "void");
        reflect_EaglercraftGPU_method_glFog_14.set("static", false);
        reflect_EaglercraftGPU_method_glFog_14.set("argnames", new String[]{"param", "valueBuffer"});
        reflect_EaglercraftGPU_method_glFog_14.set("argtypes", new String[]{"int", "FloatBuffer"});
        reflect_EaglercraftGPU_method_glFog_14.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EaglercraftGPU) params.getReflective("_self")).glFog((int) params.getInt("param"), (FloatBuffer) params.getReflective("valueBuffer"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EaglercraftGPU_methods.add(reflect_EaglercraftGPU_method_glFog_14);


        BaseData reflect_EaglercraftGPU_method_glFogi_15 = new ModData();
        reflect_EaglercraftGPU_method_glFogi_15.set("methodName", "glFogi");
        reflect_EaglercraftGPU_method_glFogi_15.set("returnType", "void");
        reflect_EaglercraftGPU_method_glFogi_15.set("static", false);
        reflect_EaglercraftGPU_method_glFogi_15.set("argnames", new String[]{"param", "value"});
        reflect_EaglercraftGPU_method_glFogi_15.set("argtypes", new String[]{"int", "int"});
        reflect_EaglercraftGPU_method_glFogi_15.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EaglercraftGPU) params.getReflective("_self")).glFogi((int) params.getInt("param"), (int) params.getInt("value"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EaglercraftGPU_methods.add(reflect_EaglercraftGPU_method_glFogi_15);


        BaseData reflect_EaglercraftGPU_method_glGenLists_16 = new ModData();
        reflect_EaglercraftGPU_method_glGenLists_16.set("methodName", "glGenLists");
        reflect_EaglercraftGPU_method_glGenLists_16.set("returnType", "int");
        reflect_EaglercraftGPU_method_glGenLists_16.set("static", false);
        reflect_EaglercraftGPU_method_glGenLists_16.set("argnames", new String[]{});
        reflect_EaglercraftGPU_method_glGenLists_16.set("argtypes", new String[]{});
        reflect_EaglercraftGPU_method_glGenLists_16.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EaglercraftGPU) params.getReflective("_self")).glGenLists();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EaglercraftGPU_methods.add(reflect_EaglercraftGPU_method_glGenLists_16);


        BaseData reflect_EaglercraftGPU_method_glDeleteLists_17 = new ModData();
        reflect_EaglercraftGPU_method_glDeleteLists_17.set("methodName", "glDeleteLists");
        reflect_EaglercraftGPU_method_glDeleteLists_17.set("returnType", "void");
        reflect_EaglercraftGPU_method_glDeleteLists_17.set("static", false);
        reflect_EaglercraftGPU_method_glDeleteLists_17.set("argnames", new String[]{"id"});
        reflect_EaglercraftGPU_method_glDeleteLists_17.set("argtypes", new String[]{"int"});
        reflect_EaglercraftGPU_method_glDeleteLists_17.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EaglercraftGPU) params.getReflective("_self")).glDeleteLists((int) params.getInt("id"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EaglercraftGPU_methods.add(reflect_EaglercraftGPU_method_glDeleteLists_17);


        BaseData reflect_EaglercraftGPU_method_glGetError_18 = new ModData();
        reflect_EaglercraftGPU_method_glGetError_18.set("methodName", "glGetError");
        reflect_EaglercraftGPU_method_glGetError_18.set("returnType", "int");
        reflect_EaglercraftGPU_method_glGetError_18.set("static", false);
        reflect_EaglercraftGPU_method_glGetError_18.set("argnames", new String[]{});
        reflect_EaglercraftGPU_method_glGetError_18.set("argtypes", new String[]{});
        reflect_EaglercraftGPU_method_glGetError_18.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((EaglercraftGPU) params.getReflective("_self")).glGetError();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_EaglercraftGPU_methods.add(reflect_EaglercraftGPU_method_glGetError_18);


        BaseData reflect_EaglercraftGPU_method_glBlendEquation_19 = new ModData();
        reflect_EaglercraftGPU_method_glBlendEquation_19.set("methodName", "glBlendEquation");
        reflect_EaglercraftGPU_method_glBlendEquation_19.set("returnType", "void");
        reflect_EaglercraftGPU_method_glBlendEquation_19.set("static", false);
        reflect_EaglercraftGPU_method_glBlendEquation_19.set("argnames", new String[]{"equation"});
        reflect_EaglercraftGPU_method_glBlendEquation_19.set("argtypes", new String[]{"int"});
        reflect_EaglercraftGPU_method_glBlendEquation_19.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EaglercraftGPU) params.getReflective("_self")).glBlendEquation((int) params.getInt("equation"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EaglercraftGPU_methods.add(reflect_EaglercraftGPU_method_glBlendEquation_19);


        BaseData reflect_EaglercraftGPU_method_bindGLBufferArray_20 = new ModData();
        reflect_EaglercraftGPU_method_bindGLBufferArray_20.set("methodName", "bindGLBufferArray");
        reflect_EaglercraftGPU_method_bindGLBufferArray_20.set("returnType", "void");
        reflect_EaglercraftGPU_method_bindGLBufferArray_20.set("static", false);
        reflect_EaglercraftGPU_method_bindGLBufferArray_20.set("argnames", new String[]{"buffer"});
        reflect_EaglercraftGPU_method_bindGLBufferArray_20.set("argtypes", new String[]{"IBufferArrayGL"});
        reflect_EaglercraftGPU_method_bindGLBufferArray_20.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EaglercraftGPU) params.getReflective("_self")).bindGLBufferArray((IBufferArrayGL) params.getReflective("buffer"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EaglercraftGPU_methods.add(reflect_EaglercraftGPU_method_bindGLBufferArray_20);


        BaseData reflect_EaglercraftGPU_method_bindGLArrayBuffer_21 = new ModData();
        reflect_EaglercraftGPU_method_bindGLArrayBuffer_21.set("methodName", "bindGLArrayBuffer");
        reflect_EaglercraftGPU_method_bindGLArrayBuffer_21.set("returnType", "void");
        reflect_EaglercraftGPU_method_bindGLArrayBuffer_21.set("static", false);
        reflect_EaglercraftGPU_method_bindGLArrayBuffer_21.set("argnames", new String[]{"buffer"});
        reflect_EaglercraftGPU_method_bindGLArrayBuffer_21.set("argtypes", new String[]{"IBufferGL"});
        reflect_EaglercraftGPU_method_bindGLArrayBuffer_21.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EaglercraftGPU) params.getReflective("_self")).bindGLArrayBuffer((IBufferGL) params.getReflective("buffer"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EaglercraftGPU_methods.add(reflect_EaglercraftGPU_method_bindGLArrayBuffer_21);


        BaseData reflect_EaglercraftGPU_method_bindGLUniformBuffer_22 = new ModData();
        reflect_EaglercraftGPU_method_bindGLUniformBuffer_22.set("methodName", "bindGLUniformBuffer");
        reflect_EaglercraftGPU_method_bindGLUniformBuffer_22.set("returnType", "void");
        reflect_EaglercraftGPU_method_bindGLUniformBuffer_22.set("static", false);
        reflect_EaglercraftGPU_method_bindGLUniformBuffer_22.set("argnames", new String[]{"buffer"});
        reflect_EaglercraftGPU_method_bindGLUniformBuffer_22.set("argtypes", new String[]{"IBufferGL"});
        reflect_EaglercraftGPU_method_bindGLUniformBuffer_22.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EaglercraftGPU) params.getReflective("_self")).bindGLUniformBuffer((IBufferGL) params.getReflective("buffer"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EaglercraftGPU_methods.add(reflect_EaglercraftGPU_method_bindGLUniformBuffer_22);


        BaseData reflect_EaglercraftGPU_method_bindGLShaderProgram_23 = new ModData();
        reflect_EaglercraftGPU_method_bindGLShaderProgram_23.set("methodName", "bindGLShaderProgram");
        reflect_EaglercraftGPU_method_bindGLShaderProgram_23.set("returnType", "void");
        reflect_EaglercraftGPU_method_bindGLShaderProgram_23.set("static", false);
        reflect_EaglercraftGPU_method_bindGLShaderProgram_23.set("argnames", new String[]{"prog"});
        reflect_EaglercraftGPU_method_bindGLShaderProgram_23.set("argtypes", new String[]{"IProgramGL"});
        reflect_EaglercraftGPU_method_bindGLShaderProgram_23.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EaglercraftGPU) params.getReflective("_self")).bindGLShaderProgram((IProgramGL) params.getReflective("prog"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EaglercraftGPU_methods.add(reflect_EaglercraftGPU_method_bindGLShaderProgram_23);


        BaseData reflect_EaglercraftGPU_method_bindUniformBufferRange_24 = new ModData();
        reflect_EaglercraftGPU_method_bindUniformBufferRange_24.set("methodName", "bindUniformBufferRange");
        reflect_EaglercraftGPU_method_bindUniformBufferRange_24.set("returnType", "void");
        reflect_EaglercraftGPU_method_bindUniformBufferRange_24.set("static", false);
        reflect_EaglercraftGPU_method_bindUniformBufferRange_24.set("argnames", new String[]{"index", "buffer", "offset", "size"});
        reflect_EaglercraftGPU_method_bindUniformBufferRange_24.set("argtypes", new String[]{"int", "IBufferGL", "int", "int"});
        reflect_EaglercraftGPU_method_bindUniformBufferRange_24.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EaglercraftGPU) params.getReflective("_self")).bindUniformBufferRange((int) params.getInt("index"), (IBufferGL) params.getReflective("buffer"), (int) params.getInt("offset"), (int) params.getInt("size"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EaglercraftGPU_methods.add(reflect_EaglercraftGPU_method_bindUniformBufferRange_24);


        BaseData reflect_EaglercraftGPU_method_renderBuffer_25 = new ModData();
        reflect_EaglercraftGPU_method_renderBuffer_25.set("methodName", "renderBuffer");
        reflect_EaglercraftGPU_method_renderBuffer_25.set("returnType", "void");
        reflect_EaglercraftGPU_method_renderBuffer_25.set("static", false);
        reflect_EaglercraftGPU_method_renderBuffer_25.set("argnames", new String[]{"buffer", "attrib", "mode", "count"});
        reflect_EaglercraftGPU_method_renderBuffer_25.set("argtypes", new String[]{"ByteBuffer", "int", "int", "int"});
        reflect_EaglercraftGPU_method_renderBuffer_25.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EaglercraftGPU) params.getReflective("_self")).renderBuffer((ByteBuffer) params.getReflective("buffer"), (int) params.getInt("attrib"), (int) params.getInt("mode"), (int) params.getInt("count"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EaglercraftGPU_methods.add(reflect_EaglercraftGPU_method_renderBuffer_25);


        BaseData reflect_EaglercraftGPU_method_optimize_26 = new ModData();
        reflect_EaglercraftGPU_method_optimize_26.set("methodName", "optimize");
        reflect_EaglercraftGPU_method_optimize_26.set("returnType", "void");
        reflect_EaglercraftGPU_method_optimize_26.set("static", false);
        reflect_EaglercraftGPU_method_optimize_26.set("argnames", new String[]{});
        reflect_EaglercraftGPU_method_optimize_26.set("argtypes", new String[]{});
        reflect_EaglercraftGPU_method_optimize_26.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EaglercraftGPU) params.getReflective("_self")).optimize();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EaglercraftGPU_methods.add(reflect_EaglercraftGPU_method_optimize_26);


        BaseData reflect_EaglercraftGPU_method_renderAgain_27 = new ModData();
        reflect_EaglercraftGPU_method_renderAgain_27.set("methodName", "renderAgain");
        reflect_EaglercraftGPU_method_renderAgain_27.set("returnType", "void");
        reflect_EaglercraftGPU_method_renderAgain_27.set("static", false);
        reflect_EaglercraftGPU_method_renderAgain_27.set("argnames", new String[]{});
        reflect_EaglercraftGPU_method_renderAgain_27.set("argtypes", new String[]{});
        reflect_EaglercraftGPU_method_renderAgain_27.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EaglercraftGPU) params.getReflective("_self")).renderAgain();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EaglercraftGPU_methods.add(reflect_EaglercraftGPU_method_renderAgain_27);


        BaseData reflect_EaglercraftGPU_method_attachQuad16EmulationBuffer_28 = new ModData();
        reflect_EaglercraftGPU_method_attachQuad16EmulationBuffer_28.set("methodName", "attachQuad16EmulationBuffer");
        reflect_EaglercraftGPU_method_attachQuad16EmulationBuffer_28.set("returnType", "void");
        reflect_EaglercraftGPU_method_attachQuad16EmulationBuffer_28.set("static", false);
        reflect_EaglercraftGPU_method_attachQuad16EmulationBuffer_28.set("argnames", new String[]{"vertexCount", "bind"});
        reflect_EaglercraftGPU_method_attachQuad16EmulationBuffer_28.set("argtypes", new String[]{"int", "boolean"});
        reflect_EaglercraftGPU_method_attachQuad16EmulationBuffer_28.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EaglercraftGPU) params.getReflective("_self")).attachQuad16EmulationBuffer((int) params.getInt("vertexCount"), (boolean) params.getBoolean("bind"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EaglercraftGPU_methods.add(reflect_EaglercraftGPU_method_attachQuad16EmulationBuffer_28);


        BaseData reflect_EaglercraftGPU_method_attachQuad32EmulationBuffer_29 = new ModData();
        reflect_EaglercraftGPU_method_attachQuad32EmulationBuffer_29.set("methodName", "attachQuad32EmulationBuffer");
        reflect_EaglercraftGPU_method_attachQuad32EmulationBuffer_29.set("returnType", "void");
        reflect_EaglercraftGPU_method_attachQuad32EmulationBuffer_29.set("static", false);
        reflect_EaglercraftGPU_method_attachQuad32EmulationBuffer_29.set("argnames", new String[]{"vertexCount", "bind"});
        reflect_EaglercraftGPU_method_attachQuad32EmulationBuffer_29.set("argtypes", new String[]{"int", "boolean"});
        reflect_EaglercraftGPU_method_attachQuad32EmulationBuffer_29.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EaglercraftGPU) params.getReflective("_self")).attachQuad32EmulationBuffer((int) params.getInt("vertexCount"), (boolean) params.getBoolean("bind"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EaglercraftGPU_methods.add(reflect_EaglercraftGPU_method_attachQuad32EmulationBuffer_29);


        BaseData reflect_EaglercraftGPU_method_getNativeTexture_30 = new ModData();
        reflect_EaglercraftGPU_method_getNativeTexture_30.set("methodName", "getNativeTexture");
        reflect_EaglercraftGPU_method_getNativeTexture_30.set("returnType", "ITextureGL");
        reflect_EaglercraftGPU_method_getNativeTexture_30.set("static", false);
        reflect_EaglercraftGPU_method_getNativeTexture_30.set("argnames", new String[]{"tex"});
        reflect_EaglercraftGPU_method_getNativeTexture_30.set("argtypes", new String[]{"int"});
        reflect_EaglercraftGPU_method_getNativeTexture_30.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (ITextureGL) ((EaglercraftGPU) params.getReflective("_self")).getNativeTexture((int) params.getInt("tex"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_EaglercraftGPU_methods.add(reflect_EaglercraftGPU_method_getNativeTexture_30);


        BaseData reflect_EaglercraftGPU_method_regenerateTexture_31 = new ModData();
        reflect_EaglercraftGPU_method_regenerateTexture_31.set("methodName", "regenerateTexture");
        reflect_EaglercraftGPU_method_regenerateTexture_31.set("returnType", "void");
        reflect_EaglercraftGPU_method_regenerateTexture_31.set("static", false);
        reflect_EaglercraftGPU_method_regenerateTexture_31.set("argnames", new String[]{"tex"});
        reflect_EaglercraftGPU_method_regenerateTexture_31.set("argtypes", new String[]{"int"});
        reflect_EaglercraftGPU_method_regenerateTexture_31.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EaglercraftGPU) params.getReflective("_self")).regenerateTexture((int) params.getInt("tex"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EaglercraftGPU_methods.add(reflect_EaglercraftGPU_method_regenerateTexture_31);


        BaseData reflect_EaglercraftGPU_method_drawHighPoly_32 = new ModData();
        reflect_EaglercraftGPU_method_drawHighPoly_32.set("methodName", "drawHighPoly");
        reflect_EaglercraftGPU_method_drawHighPoly_32.set("returnType", "void");
        reflect_EaglercraftGPU_method_drawHighPoly_32.set("static", false);
        reflect_EaglercraftGPU_method_drawHighPoly_32.set("argnames", new String[]{"mesh"});
        reflect_EaglercraftGPU_method_drawHighPoly_32.set("argtypes", new String[]{"HighPolyMesh"});
        reflect_EaglercraftGPU_method_drawHighPoly_32.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EaglercraftGPU) params.getReflective("_self")).drawHighPoly((HighPolyMesh) params.getReflective("mesh"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EaglercraftGPU_methods.add(reflect_EaglercraftGPU_method_drawHighPoly_32);


        BaseData reflect_EaglercraftGPU_method_createFramebufferHDR16FTexture_33 = new ModData();
        reflect_EaglercraftGPU_method_createFramebufferHDR16FTexture_33.set("methodName", "createFramebufferHDR16FTexture");
        reflect_EaglercraftGPU_method_createFramebufferHDR16FTexture_33.set("returnType", "void");
        reflect_EaglercraftGPU_method_createFramebufferHDR16FTexture_33.set("static", false);
        reflect_EaglercraftGPU_method_createFramebufferHDR16FTexture_33.set("argnames", new String[]{"target", "level", "w", "h", "format", "allow32bitFallback"});
        reflect_EaglercraftGPU_method_createFramebufferHDR16FTexture_33.set("argtypes", new String[]{"int", "int", "int", "int", "int", "boolean"});
        reflect_EaglercraftGPU_method_createFramebufferHDR16FTexture_33.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EaglercraftGPU) params.getReflective("_self")).createFramebufferHDR16FTexture((int) params.getInt("target"), (int) params.getInt("level"), (int) params.getInt("w"), (int) params.getInt("h"), (int) params.getInt("format"), (boolean) params.getBoolean("allow32bitFallback"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EaglercraftGPU_methods.add(reflect_EaglercraftGPU_method_createFramebufferHDR16FTexture_33);


        BaseData reflect_EaglercraftGPU_method_createFramebufferHDR16FTexture_34 = new ModData();
        reflect_EaglercraftGPU_method_createFramebufferHDR16FTexture_34.set("methodName", "createFramebufferHDR16FTexture");
        reflect_EaglercraftGPU_method_createFramebufferHDR16FTexture_34.set("returnType", "void");
        reflect_EaglercraftGPU_method_createFramebufferHDR16FTexture_34.set("static", false);
        reflect_EaglercraftGPU_method_createFramebufferHDR16FTexture_34.set("argnames", new String[]{"target", "level", "w", "h", "format", "pixelData"});
        reflect_EaglercraftGPU_method_createFramebufferHDR16FTexture_34.set("argtypes", new String[]{"int", "int", "int", "int", "int", "ByteBuffer"});
        reflect_EaglercraftGPU_method_createFramebufferHDR16FTexture_34.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EaglercraftGPU) params.getReflective("_self")).createFramebufferHDR16FTexture((int) params.getInt("target"), (int) params.getInt("level"), (int) params.getInt("w"), (int) params.getInt("h"), (int) params.getInt("format"), (ByteBuffer) params.getReflective("pixelData"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EaglercraftGPU_methods.add(reflect_EaglercraftGPU_method_createFramebufferHDR16FTexture_34);


        BaseData reflect_EaglercraftGPU_method_createFramebufferHDR32FTexture_35 = new ModData();
        reflect_EaglercraftGPU_method_createFramebufferHDR32FTexture_35.set("methodName", "createFramebufferHDR32FTexture");
        reflect_EaglercraftGPU_method_createFramebufferHDR32FTexture_35.set("returnType", "void");
        reflect_EaglercraftGPU_method_createFramebufferHDR32FTexture_35.set("static", false);
        reflect_EaglercraftGPU_method_createFramebufferHDR32FTexture_35.set("argnames", new String[]{"target", "level", "w", "h", "format", "allow16bitFallback"});
        reflect_EaglercraftGPU_method_createFramebufferHDR32FTexture_35.set("argtypes", new String[]{"int", "int", "int", "int", "int", "boolean"});
        reflect_EaglercraftGPU_method_createFramebufferHDR32FTexture_35.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EaglercraftGPU) params.getReflective("_self")).createFramebufferHDR32FTexture((int) params.getInt("target"), (int) params.getInt("level"), (int) params.getInt("w"), (int) params.getInt("h"), (int) params.getInt("format"), (boolean) params.getBoolean("allow16bitFallback"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EaglercraftGPU_methods.add(reflect_EaglercraftGPU_method_createFramebufferHDR32FTexture_35);


        BaseData reflect_EaglercraftGPU_method_createFramebufferHDR32FTexture_36 = new ModData();
        reflect_EaglercraftGPU_method_createFramebufferHDR32FTexture_36.set("methodName", "createFramebufferHDR32FTexture");
        reflect_EaglercraftGPU_method_createFramebufferHDR32FTexture_36.set("returnType", "void");
        reflect_EaglercraftGPU_method_createFramebufferHDR32FTexture_36.set("static", false);
        reflect_EaglercraftGPU_method_createFramebufferHDR32FTexture_36.set("argnames", new String[]{"target", "level", "w", "h", "format", "pixelData"});
        reflect_EaglercraftGPU_method_createFramebufferHDR32FTexture_36.set("argtypes", new String[]{"int", "int", "int", "int", "int", "ByteBuffer"});
        reflect_EaglercraftGPU_method_createFramebufferHDR32FTexture_36.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EaglercraftGPU) params.getReflective("_self")).createFramebufferHDR32FTexture((int) params.getInt("target"), (int) params.getInt("level"), (int) params.getInt("w"), (int) params.getInt("h"), (int) params.getInt("format"), (ByteBuffer) params.getReflective("pixelData"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EaglercraftGPU_methods.add(reflect_EaglercraftGPU_method_createFramebufferHDR32FTexture_36);


        BaseData reflect_EaglercraftGPU_method_warmUpCache_37 = new ModData();
        reflect_EaglercraftGPU_method_warmUpCache_37.set("methodName", "warmUpCache");
        reflect_EaglercraftGPU_method_warmUpCache_37.set("returnType", "void");
        reflect_EaglercraftGPU_method_warmUpCache_37.set("static", false);
        reflect_EaglercraftGPU_method_warmUpCache_37.set("argnames", new String[]{});
        reflect_EaglercraftGPU_method_warmUpCache_37.set("argtypes", new String[]{});
        reflect_EaglercraftGPU_method_warmUpCache_37.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((EaglercraftGPU) params.getReflective("_self")).warmUpCache();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_EaglercraftGPU_methods.add(reflect_EaglercraftGPU_method_warmUpCache_37);


        BaseData reflect_EaglercraftGPU_method_checkHDRFramebufferSupport_38 = new ModData();
        reflect_EaglercraftGPU_method_checkHDRFramebufferSupport_38.set("methodName", "checkHDRFramebufferSupport");
        reflect_EaglercraftGPU_method_checkHDRFramebufferSupport_38.set("returnType", "boolean");
        reflect_EaglercraftGPU_method_checkHDRFramebufferSupport_38.set("static", false);
        reflect_EaglercraftGPU_method_checkHDRFramebufferSupport_38.set("argnames", new String[]{"bits"});
        reflect_EaglercraftGPU_method_checkHDRFramebufferSupport_38.set("argtypes", new String[]{"int"});
        reflect_EaglercraftGPU_method_checkHDRFramebufferSupport_38.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EaglercraftGPU) params.getReflective("_self")).checkHDRFramebufferSupport((int) params.getInt("bits"));
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EaglercraftGPU_methods.add(reflect_EaglercraftGPU_method_checkHDRFramebufferSupport_38);


        BaseData reflect_EaglercraftGPU_method_checkHasHDRFramebufferSupport_39 = new ModData();
        reflect_EaglercraftGPU_method_checkHasHDRFramebufferSupport_39.set("methodName", "checkHasHDRFramebufferSupport");
        reflect_EaglercraftGPU_method_checkHasHDRFramebufferSupport_39.set("returnType", "boolean");
        reflect_EaglercraftGPU_method_checkHasHDRFramebufferSupport_39.set("static", false);
        reflect_EaglercraftGPU_method_checkHasHDRFramebufferSupport_39.set("argnames", new String[]{});
        reflect_EaglercraftGPU_method_checkHasHDRFramebufferSupport_39.set("argtypes", new String[]{});
        reflect_EaglercraftGPU_method_checkHasHDRFramebufferSupport_39.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EaglercraftGPU) params.getReflective("_self")).checkHasHDRFramebufferSupport();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EaglercraftGPU_methods.add(reflect_EaglercraftGPU_method_checkHasHDRFramebufferSupport_39);


        BaseData reflect_EaglercraftGPU_method_checkHasHDRFramebufferSupportWithFilter_40 = new ModData();
        reflect_EaglercraftGPU_method_checkHasHDRFramebufferSupportWithFilter_40.set("methodName", "checkHasHDRFramebufferSupportWithFilter");
        reflect_EaglercraftGPU_method_checkHasHDRFramebufferSupportWithFilter_40.set("returnType", "boolean");
        reflect_EaglercraftGPU_method_checkHasHDRFramebufferSupportWithFilter_40.set("static", false);
        reflect_EaglercraftGPU_method_checkHasHDRFramebufferSupportWithFilter_40.set("argnames", new String[]{});
        reflect_EaglercraftGPU_method_checkHasHDRFramebufferSupportWithFilter_40.set("argtypes", new String[]{});
        reflect_EaglercraftGPU_method_checkHasHDRFramebufferSupportWithFilter_40.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EaglercraftGPU) params.getReflective("_self")).checkHasHDRFramebufferSupportWithFilter();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EaglercraftGPU_methods.add(reflect_EaglercraftGPU_method_checkHasHDRFramebufferSupportWithFilter_40);


        BaseData reflect_EaglercraftGPU_method_checkLinearHDR32FSupport_41 = new ModData();
        reflect_EaglercraftGPU_method_checkLinearHDR32FSupport_41.set("methodName", "checkLinearHDR32FSupport");
        reflect_EaglercraftGPU_method_checkLinearHDR32FSupport_41.set("returnType", "boolean");
        reflect_EaglercraftGPU_method_checkLinearHDR32FSupport_41.set("static", false);
        reflect_EaglercraftGPU_method_checkLinearHDR32FSupport_41.set("argnames", new String[]{});
        reflect_EaglercraftGPU_method_checkLinearHDR32FSupport_41.set("argtypes", new String[]{});
        reflect_EaglercraftGPU_method_checkLinearHDR32FSupport_41.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((EaglercraftGPU) params.getReflective("_self")).checkLinearHDR32FSupport();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_EaglercraftGPU_methods.add(reflect_EaglercraftGPU_method_checkLinearHDR32FSupport_41);


        BaseData[] reflect_EaglercraftGPU_methods_arr = new BaseData[reflect_EaglercraftGPU_methods.size()];
        for (int i = 0; i < reflect_EaglercraftGPU_methods_arr.length; i++) {
            reflect_EaglercraftGPU_methods_arr[i] = reflect_EaglercraftGPU_methods.get(i);
        }

        reflect_EaglercraftGPU.set("constructors", reflect_EaglercraftGPU_constructors_arr);
        reflect_EaglercraftGPU.set("methods", reflect_EaglercraftGPU_methods_arr);
        reflect_EaglercraftGPU.set("className", "EaglercraftGPU");
        reflect_EaglercraftGPU.set("classId", "net.lax1dude.eaglercraft.v1_8.opengl.EaglercraftGPU");
        reflect_EaglercraftGPU.set("class", EaglercraftGPU.class);
        reflect_EaglercraftGPU.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof EaglercraftGPU;
        });
        reflectProfiles.add(reflect_EaglercraftGPU);
    }


    //classdef for GlStateManager
    public static void reflect_GlStateManager_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_GlStateManager = new ModData();

        ArrayList<BaseData> reflect_GlStateManager_constructors = new ArrayList<BaseData>();
        
        BaseData[] reflect_GlStateManager_constructors_arr = new BaseData[reflect_GlStateManager_constructors.size()];
        for (int i = 0; i < reflect_GlStateManager_constructors_arr.length; i++) {
            reflect_GlStateManager_constructors_arr[i] = reflect_GlStateManager_constructors.get(i);
        }

        ArrayList<BaseData> reflect_GlStateManager_methods = new ArrayList<BaseData>();
        
        BaseData reflect_GlStateManager_method_pushLightCoords_0 = new ModData();
        reflect_GlStateManager_method_pushLightCoords_0.set("methodName", "pushLightCoords");
        reflect_GlStateManager_method_pushLightCoords_0.set("returnType", "void");
        reflect_GlStateManager_method_pushLightCoords_0.set("static", false);
        reflect_GlStateManager_method_pushLightCoords_0.set("argnames", new String[]{});
        reflect_GlStateManager_method_pushLightCoords_0.set("argtypes", new String[]{});
        reflect_GlStateManager_method_pushLightCoords_0.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).pushLightCoords();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_pushLightCoords_0);


        BaseData reflect_GlStateManager_method_popLightCoords_1 = new ModData();
        reflect_GlStateManager_method_popLightCoords_1.set("methodName", "popLightCoords");
        reflect_GlStateManager_method_popLightCoords_1.set("returnType", "void");
        reflect_GlStateManager_method_popLightCoords_1.set("static", false);
        reflect_GlStateManager_method_popLightCoords_1.set("argnames", new String[]{});
        reflect_GlStateManager_method_popLightCoords_1.set("argtypes", new String[]{});
        reflect_GlStateManager_method_popLightCoords_1.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).popLightCoords();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_popLightCoords_1);


        BaseData reflect_GlStateManager_method_disableAlpha_2 = new ModData();
        reflect_GlStateManager_method_disableAlpha_2.set("methodName", "disableAlpha");
        reflect_GlStateManager_method_disableAlpha_2.set("returnType", "void");
        reflect_GlStateManager_method_disableAlpha_2.set("static", false);
        reflect_GlStateManager_method_disableAlpha_2.set("argnames", new String[]{});
        reflect_GlStateManager_method_disableAlpha_2.set("argtypes", new String[]{});
        reflect_GlStateManager_method_disableAlpha_2.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).disableAlpha();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_disableAlpha_2);


        BaseData reflect_GlStateManager_method_enableAlpha_3 = new ModData();
        reflect_GlStateManager_method_enableAlpha_3.set("methodName", "enableAlpha");
        reflect_GlStateManager_method_enableAlpha_3.set("returnType", "void");
        reflect_GlStateManager_method_enableAlpha_3.set("static", false);
        reflect_GlStateManager_method_enableAlpha_3.set("argnames", new String[]{});
        reflect_GlStateManager_method_enableAlpha_3.set("argtypes", new String[]{});
        reflect_GlStateManager_method_enableAlpha_3.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).enableAlpha();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_enableAlpha_3);


        BaseData reflect_GlStateManager_method_alphaFunc_4 = new ModData();
        reflect_GlStateManager_method_alphaFunc_4.set("methodName", "alphaFunc");
        reflect_GlStateManager_method_alphaFunc_4.set("returnType", "void");
        reflect_GlStateManager_method_alphaFunc_4.set("static", false);
        reflect_GlStateManager_method_alphaFunc_4.set("argnames", new String[]{"func", "ref"});
        reflect_GlStateManager_method_alphaFunc_4.set("argtypes", new String[]{"int", "float"});
        reflect_GlStateManager_method_alphaFunc_4.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).alphaFunc((int) params.getInt("func"), (float) params.getFloat("ref"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_alphaFunc_4);


        BaseData reflect_GlStateManager_method_enableLighting_5 = new ModData();
        reflect_GlStateManager_method_enableLighting_5.set("methodName", "enableLighting");
        reflect_GlStateManager_method_enableLighting_5.set("returnType", "void");
        reflect_GlStateManager_method_enableLighting_5.set("static", false);
        reflect_GlStateManager_method_enableLighting_5.set("argnames", new String[]{});
        reflect_GlStateManager_method_enableLighting_5.set("argtypes", new String[]{});
        reflect_GlStateManager_method_enableLighting_5.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).enableLighting();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_enableLighting_5);


        BaseData reflect_GlStateManager_method_disableLighting_6 = new ModData();
        reflect_GlStateManager_method_disableLighting_6.set("methodName", "disableLighting");
        reflect_GlStateManager_method_disableLighting_6.set("returnType", "void");
        reflect_GlStateManager_method_disableLighting_6.set("static", false);
        reflect_GlStateManager_method_disableLighting_6.set("argnames", new String[]{});
        reflect_GlStateManager_method_disableLighting_6.set("argtypes", new String[]{});
        reflect_GlStateManager_method_disableLighting_6.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).disableLighting();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_disableLighting_6);


        BaseData reflect_GlStateManager_method_enableExtensionPipeline_7 = new ModData();
        reflect_GlStateManager_method_enableExtensionPipeline_7.set("methodName", "enableExtensionPipeline");
        reflect_GlStateManager_method_enableExtensionPipeline_7.set("returnType", "void");
        reflect_GlStateManager_method_enableExtensionPipeline_7.set("static", false);
        reflect_GlStateManager_method_enableExtensionPipeline_7.set("argnames", new String[]{});
        reflect_GlStateManager_method_enableExtensionPipeline_7.set("argtypes", new String[]{});
        reflect_GlStateManager_method_enableExtensionPipeline_7.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).enableExtensionPipeline();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_enableExtensionPipeline_7);


        BaseData reflect_GlStateManager_method_disableExtensionPipeline_8 = new ModData();
        reflect_GlStateManager_method_disableExtensionPipeline_8.set("methodName", "disableExtensionPipeline");
        reflect_GlStateManager_method_disableExtensionPipeline_8.set("returnType", "void");
        reflect_GlStateManager_method_disableExtensionPipeline_8.set("static", false);
        reflect_GlStateManager_method_disableExtensionPipeline_8.set("argnames", new String[]{});
        reflect_GlStateManager_method_disableExtensionPipeline_8.set("argtypes", new String[]{});
        reflect_GlStateManager_method_disableExtensionPipeline_8.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).disableExtensionPipeline();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_disableExtensionPipeline_8);


        BaseData reflect_GlStateManager_method_isExtensionPipeline_9 = new ModData();
        reflect_GlStateManager_method_isExtensionPipeline_9.set("methodName", "isExtensionPipeline");
        reflect_GlStateManager_method_isExtensionPipeline_9.set("returnType", "boolean");
        reflect_GlStateManager_method_isExtensionPipeline_9.set("static", false);
        reflect_GlStateManager_method_isExtensionPipeline_9.set("argnames", new String[]{});
        reflect_GlStateManager_method_isExtensionPipeline_9.set("argtypes", new String[]{});
        reflect_GlStateManager_method_isExtensionPipeline_9.setCallbackBooleanWithDataArg("exec", (BaseData params) -> {
                try {
                    return (boolean) ((GlStateManager) params.getReflective("_self")).isExtensionPipeline();
                } catch (Exception _exception_reflect_) {
                    return false;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_isExtensionPipeline_9);


        BaseData reflect_GlStateManager_method_disableMCLight_10 = new ModData();
        reflect_GlStateManager_method_disableMCLight_10.set("methodName", "disableMCLight");
        reflect_GlStateManager_method_disableMCLight_10.set("returnType", "void");
        reflect_GlStateManager_method_disableMCLight_10.set("static", false);
        reflect_GlStateManager_method_disableMCLight_10.set("argnames", new String[]{"light"});
        reflect_GlStateManager_method_disableMCLight_10.set("argtypes", new String[]{"int"});
        reflect_GlStateManager_method_disableMCLight_10.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).disableMCLight((int) params.getInt("light"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_disableMCLight_10);


        BaseData reflect_GlStateManager_method_setMCLightAmbient_11 = new ModData();
        reflect_GlStateManager_method_setMCLightAmbient_11.set("methodName", "setMCLightAmbient");
        reflect_GlStateManager_method_setMCLightAmbient_11.set("returnType", "void");
        reflect_GlStateManager_method_setMCLightAmbient_11.set("static", false);
        reflect_GlStateManager_method_setMCLightAmbient_11.set("argnames", new String[]{"r", "g", "b"});
        reflect_GlStateManager_method_setMCLightAmbient_11.set("argtypes", new String[]{"float", "float", "float"});
        reflect_GlStateManager_method_setMCLightAmbient_11.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).setMCLightAmbient((float) params.getFloat("r"), (float) params.getFloat("g"), (float) params.getFloat("b"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_setMCLightAmbient_11);


        BaseData reflect_GlStateManager_method_enableColorMaterial_12 = new ModData();
        reflect_GlStateManager_method_enableColorMaterial_12.set("methodName", "enableColorMaterial");
        reflect_GlStateManager_method_enableColorMaterial_12.set("returnType", "void");
        reflect_GlStateManager_method_enableColorMaterial_12.set("static", false);
        reflect_GlStateManager_method_enableColorMaterial_12.set("argnames", new String[]{});
        reflect_GlStateManager_method_enableColorMaterial_12.set("argtypes", new String[]{});
        reflect_GlStateManager_method_enableColorMaterial_12.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).enableColorMaterial();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_enableColorMaterial_12);


        BaseData reflect_GlStateManager_method_disableColorMaterial_13 = new ModData();
        reflect_GlStateManager_method_disableColorMaterial_13.set("methodName", "disableColorMaterial");
        reflect_GlStateManager_method_disableColorMaterial_13.set("returnType", "void");
        reflect_GlStateManager_method_disableColorMaterial_13.set("static", false);
        reflect_GlStateManager_method_disableColorMaterial_13.set("argnames", new String[]{});
        reflect_GlStateManager_method_disableColorMaterial_13.set("argtypes", new String[]{});
        reflect_GlStateManager_method_disableColorMaterial_13.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).disableColorMaterial();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_disableColorMaterial_13);


        BaseData reflect_GlStateManager_method_disableDepth_14 = new ModData();
        reflect_GlStateManager_method_disableDepth_14.set("methodName", "disableDepth");
        reflect_GlStateManager_method_disableDepth_14.set("returnType", "void");
        reflect_GlStateManager_method_disableDepth_14.set("static", false);
        reflect_GlStateManager_method_disableDepth_14.set("argnames", new String[]{});
        reflect_GlStateManager_method_disableDepth_14.set("argtypes", new String[]{});
        reflect_GlStateManager_method_disableDepth_14.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).disableDepth();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_disableDepth_14);


        BaseData reflect_GlStateManager_method_enableDepth_15 = new ModData();
        reflect_GlStateManager_method_enableDepth_15.set("methodName", "enableDepth");
        reflect_GlStateManager_method_enableDepth_15.set("returnType", "void");
        reflect_GlStateManager_method_enableDepth_15.set("static", false);
        reflect_GlStateManager_method_enableDepth_15.set("argnames", new String[]{});
        reflect_GlStateManager_method_enableDepth_15.set("argtypes", new String[]{});
        reflect_GlStateManager_method_enableDepth_15.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).enableDepth();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_enableDepth_15);


        BaseData reflect_GlStateManager_method_depthFunc_16 = new ModData();
        reflect_GlStateManager_method_depthFunc_16.set("methodName", "depthFunc");
        reflect_GlStateManager_method_depthFunc_16.set("returnType", "void");
        reflect_GlStateManager_method_depthFunc_16.set("static", false);
        reflect_GlStateManager_method_depthFunc_16.set("argnames", new String[]{"depthFunc"});
        reflect_GlStateManager_method_depthFunc_16.set("argtypes", new String[]{"int"});
        reflect_GlStateManager_method_depthFunc_16.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).depthFunc((int) params.getInt("depthFunc"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_depthFunc_16);


        BaseData reflect_GlStateManager_method_depthMask_17 = new ModData();
        reflect_GlStateManager_method_depthMask_17.set("methodName", "depthMask");
        reflect_GlStateManager_method_depthMask_17.set("returnType", "void");
        reflect_GlStateManager_method_depthMask_17.set("static", false);
        reflect_GlStateManager_method_depthMask_17.set("argnames", new String[]{"flagIn"});
        reflect_GlStateManager_method_depthMask_17.set("argtypes", new String[]{"boolean"});
        reflect_GlStateManager_method_depthMask_17.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).depthMask((boolean) params.getBoolean("flagIn"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_depthMask_17);


        BaseData reflect_GlStateManager_method_disableBlend_18 = new ModData();
        reflect_GlStateManager_method_disableBlend_18.set("methodName", "disableBlend");
        reflect_GlStateManager_method_disableBlend_18.set("returnType", "void");
        reflect_GlStateManager_method_disableBlend_18.set("static", false);
        reflect_GlStateManager_method_disableBlend_18.set("argnames", new String[]{});
        reflect_GlStateManager_method_disableBlend_18.set("argtypes", new String[]{});
        reflect_GlStateManager_method_disableBlend_18.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).disableBlend();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_disableBlend_18);


        BaseData reflect_GlStateManager_method_enableBlend_19 = new ModData();
        reflect_GlStateManager_method_enableBlend_19.set("methodName", "enableBlend");
        reflect_GlStateManager_method_enableBlend_19.set("returnType", "void");
        reflect_GlStateManager_method_enableBlend_19.set("static", false);
        reflect_GlStateManager_method_enableBlend_19.set("argnames", new String[]{});
        reflect_GlStateManager_method_enableBlend_19.set("argtypes", new String[]{});
        reflect_GlStateManager_method_enableBlend_19.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).enableBlend();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_enableBlend_19);


        BaseData reflect_GlStateManager_method_globalDisableBlend_20 = new ModData();
        reflect_GlStateManager_method_globalDisableBlend_20.set("methodName", "globalDisableBlend");
        reflect_GlStateManager_method_globalDisableBlend_20.set("returnType", "void");
        reflect_GlStateManager_method_globalDisableBlend_20.set("static", false);
        reflect_GlStateManager_method_globalDisableBlend_20.set("argnames", new String[]{});
        reflect_GlStateManager_method_globalDisableBlend_20.set("argtypes", new String[]{});
        reflect_GlStateManager_method_globalDisableBlend_20.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).globalDisableBlend();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_globalDisableBlend_20);


        BaseData reflect_GlStateManager_method_globalEnableBlend_21 = new ModData();
        reflect_GlStateManager_method_globalEnableBlend_21.set("methodName", "globalEnableBlend");
        reflect_GlStateManager_method_globalEnableBlend_21.set("returnType", "void");
        reflect_GlStateManager_method_globalEnableBlend_21.set("static", false);
        reflect_GlStateManager_method_globalEnableBlend_21.set("argnames", new String[]{});
        reflect_GlStateManager_method_globalEnableBlend_21.set("argtypes", new String[]{});
        reflect_GlStateManager_method_globalEnableBlend_21.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).globalEnableBlend();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_globalEnableBlend_21);


        BaseData reflect_GlStateManager_method_blendFunc_22 = new ModData();
        reflect_GlStateManager_method_blendFunc_22.set("methodName", "blendFunc");
        reflect_GlStateManager_method_blendFunc_22.set("returnType", "void");
        reflect_GlStateManager_method_blendFunc_22.set("static", false);
        reflect_GlStateManager_method_blendFunc_22.set("argnames", new String[]{"srcFactor", "dstFactor"});
        reflect_GlStateManager_method_blendFunc_22.set("argtypes", new String[]{"int", "int"});
        reflect_GlStateManager_method_blendFunc_22.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).blendFunc((int) params.getInt("srcFactor"), (int) params.getInt("dstFactor"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_blendFunc_22);


        BaseData reflect_GlStateManager_method_tryBlendFuncSeparate_23 = new ModData();
        reflect_GlStateManager_method_tryBlendFuncSeparate_23.set("methodName", "tryBlendFuncSeparate");
        reflect_GlStateManager_method_tryBlendFuncSeparate_23.set("returnType", "void");
        reflect_GlStateManager_method_tryBlendFuncSeparate_23.set("static", false);
        reflect_GlStateManager_method_tryBlendFuncSeparate_23.set("argnames", new String[]{"srcFactor", "dstFactor", "srcFactorAlpha", "dstFactorAlpha"});
        reflect_GlStateManager_method_tryBlendFuncSeparate_23.set("argtypes", new String[]{"int", "int", "int", "int"});
        reflect_GlStateManager_method_tryBlendFuncSeparate_23.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).tryBlendFuncSeparate((int) params.getInt("srcFactor"), (int) params.getInt("dstFactor"), (int) params.getInt("srcFactorAlpha"), (int) params.getInt("dstFactorAlpha"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_tryBlendFuncSeparate_23);


        BaseData reflect_GlStateManager_method_enableOverlayFramebufferBlending_24 = new ModData();
        reflect_GlStateManager_method_enableOverlayFramebufferBlending_24.set("methodName", "enableOverlayFramebufferBlending");
        reflect_GlStateManager_method_enableOverlayFramebufferBlending_24.set("returnType", "void");
        reflect_GlStateManager_method_enableOverlayFramebufferBlending_24.set("static", false);
        reflect_GlStateManager_method_enableOverlayFramebufferBlending_24.set("argnames", new String[]{});
        reflect_GlStateManager_method_enableOverlayFramebufferBlending_24.set("argtypes", new String[]{});
        reflect_GlStateManager_method_enableOverlayFramebufferBlending_24.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).enableOverlayFramebufferBlending();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_enableOverlayFramebufferBlending_24);


        BaseData reflect_GlStateManager_method_disableOverlayFramebufferBlending_25 = new ModData();
        reflect_GlStateManager_method_disableOverlayFramebufferBlending_25.set("methodName", "disableOverlayFramebufferBlending");
        reflect_GlStateManager_method_disableOverlayFramebufferBlending_25.set("returnType", "void");
        reflect_GlStateManager_method_disableOverlayFramebufferBlending_25.set("static", false);
        reflect_GlStateManager_method_disableOverlayFramebufferBlending_25.set("argnames", new String[]{});
        reflect_GlStateManager_method_disableOverlayFramebufferBlending_25.set("argtypes", new String[]{});
        reflect_GlStateManager_method_disableOverlayFramebufferBlending_25.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).disableOverlayFramebufferBlending();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_disableOverlayFramebufferBlending_25);


        BaseData reflect_GlStateManager_method_setShaderBlendSrc_26 = new ModData();
        reflect_GlStateManager_method_setShaderBlendSrc_26.set("methodName", "setShaderBlendSrc");
        reflect_GlStateManager_method_setShaderBlendSrc_26.set("returnType", "void");
        reflect_GlStateManager_method_setShaderBlendSrc_26.set("static", false);
        reflect_GlStateManager_method_setShaderBlendSrc_26.set("argnames", new String[]{"r", "g", "b", "a"});
        reflect_GlStateManager_method_setShaderBlendSrc_26.set("argtypes", new String[]{"float", "float", "float", "float"});
        reflect_GlStateManager_method_setShaderBlendSrc_26.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).setShaderBlendSrc((float) params.getFloat("r"), (float) params.getFloat("g"), (float) params.getFloat("b"), (float) params.getFloat("a"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_setShaderBlendSrc_26);


        BaseData reflect_GlStateManager_method_setShaderBlendAdd_27 = new ModData();
        reflect_GlStateManager_method_setShaderBlendAdd_27.set("methodName", "setShaderBlendAdd");
        reflect_GlStateManager_method_setShaderBlendAdd_27.set("returnType", "void");
        reflect_GlStateManager_method_setShaderBlendAdd_27.set("static", false);
        reflect_GlStateManager_method_setShaderBlendAdd_27.set("argnames", new String[]{"r", "g", "b", "a"});
        reflect_GlStateManager_method_setShaderBlendAdd_27.set("argtypes", new String[]{"float", "float", "float", "float"});
        reflect_GlStateManager_method_setShaderBlendAdd_27.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).setShaderBlendAdd((float) params.getFloat("r"), (float) params.getFloat("g"), (float) params.getFloat("b"), (float) params.getFloat("a"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_setShaderBlendAdd_27);


        BaseData reflect_GlStateManager_method_enableShaderBlendAdd_28 = new ModData();
        reflect_GlStateManager_method_enableShaderBlendAdd_28.set("methodName", "enableShaderBlendAdd");
        reflect_GlStateManager_method_enableShaderBlendAdd_28.set("returnType", "void");
        reflect_GlStateManager_method_enableShaderBlendAdd_28.set("static", false);
        reflect_GlStateManager_method_enableShaderBlendAdd_28.set("argnames", new String[]{});
        reflect_GlStateManager_method_enableShaderBlendAdd_28.set("argtypes", new String[]{});
        reflect_GlStateManager_method_enableShaderBlendAdd_28.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).enableShaderBlendAdd();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_enableShaderBlendAdd_28);


        BaseData reflect_GlStateManager_method_disableShaderBlendAdd_29 = new ModData();
        reflect_GlStateManager_method_disableShaderBlendAdd_29.set("methodName", "disableShaderBlendAdd");
        reflect_GlStateManager_method_disableShaderBlendAdd_29.set("returnType", "void");
        reflect_GlStateManager_method_disableShaderBlendAdd_29.set("static", false);
        reflect_GlStateManager_method_disableShaderBlendAdd_29.set("argnames", new String[]{});
        reflect_GlStateManager_method_disableShaderBlendAdd_29.set("argtypes", new String[]{});
        reflect_GlStateManager_method_disableShaderBlendAdd_29.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).disableShaderBlendAdd();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_disableShaderBlendAdd_29);


        BaseData reflect_GlStateManager_method_setBlendConstants_30 = new ModData();
        reflect_GlStateManager_method_setBlendConstants_30.set("methodName", "setBlendConstants");
        reflect_GlStateManager_method_setBlendConstants_30.set("returnType", "void");
        reflect_GlStateManager_method_setBlendConstants_30.set("static", false);
        reflect_GlStateManager_method_setBlendConstants_30.set("argnames", new String[]{"r", "g", "b", "a"});
        reflect_GlStateManager_method_setBlendConstants_30.set("argtypes", new String[]{"float", "float", "float", "float"});
        reflect_GlStateManager_method_setBlendConstants_30.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).setBlendConstants((float) params.getFloat("r"), (float) params.getFloat("g"), (float) params.getFloat("b"), (float) params.getFloat("a"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_setBlendConstants_30);


        BaseData reflect_GlStateManager_method_enableFog_31 = new ModData();
        reflect_GlStateManager_method_enableFog_31.set("methodName", "enableFog");
        reflect_GlStateManager_method_enableFog_31.set("returnType", "void");
        reflect_GlStateManager_method_enableFog_31.set("static", false);
        reflect_GlStateManager_method_enableFog_31.set("argnames", new String[]{});
        reflect_GlStateManager_method_enableFog_31.set("argtypes", new String[]{});
        reflect_GlStateManager_method_enableFog_31.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).enableFog();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_enableFog_31);


        BaseData reflect_GlStateManager_method_disableFog_32 = new ModData();
        reflect_GlStateManager_method_disableFog_32.set("methodName", "disableFog");
        reflect_GlStateManager_method_disableFog_32.set("returnType", "void");
        reflect_GlStateManager_method_disableFog_32.set("static", false);
        reflect_GlStateManager_method_disableFog_32.set("argnames", new String[]{});
        reflect_GlStateManager_method_disableFog_32.set("argtypes", new String[]{});
        reflect_GlStateManager_method_disableFog_32.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).disableFog();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_disableFog_32);


        BaseData reflect_GlStateManager_method_setFog_33 = new ModData();
        reflect_GlStateManager_method_setFog_33.set("methodName", "setFog");
        reflect_GlStateManager_method_setFog_33.set("returnType", "void");
        reflect_GlStateManager_method_setFog_33.set("static", false);
        reflect_GlStateManager_method_setFog_33.set("argnames", new String[]{"param"});
        reflect_GlStateManager_method_setFog_33.set("argtypes", new String[]{"int"});
        reflect_GlStateManager_method_setFog_33.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).setFog((int) params.getInt("param"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_setFog_33);


        BaseData reflect_GlStateManager_method_setFogDensity_34 = new ModData();
        reflect_GlStateManager_method_setFogDensity_34.set("methodName", "setFogDensity");
        reflect_GlStateManager_method_setFogDensity_34.set("returnType", "void");
        reflect_GlStateManager_method_setFogDensity_34.set("static", false);
        reflect_GlStateManager_method_setFogDensity_34.set("argnames", new String[]{"param"});
        reflect_GlStateManager_method_setFogDensity_34.set("argtypes", new String[]{"float"});
        reflect_GlStateManager_method_setFogDensity_34.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).setFogDensity((float) params.getFloat("param"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_setFogDensity_34);


        BaseData reflect_GlStateManager_method_setFogStart_35 = new ModData();
        reflect_GlStateManager_method_setFogStart_35.set("methodName", "setFogStart");
        reflect_GlStateManager_method_setFogStart_35.set("returnType", "void");
        reflect_GlStateManager_method_setFogStart_35.set("static", false);
        reflect_GlStateManager_method_setFogStart_35.set("argnames", new String[]{"param"});
        reflect_GlStateManager_method_setFogStart_35.set("argtypes", new String[]{"float"});
        reflect_GlStateManager_method_setFogStart_35.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).setFogStart((float) params.getFloat("param"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_setFogStart_35);


        BaseData reflect_GlStateManager_method_setFogEnd_36 = new ModData();
        reflect_GlStateManager_method_setFogEnd_36.set("methodName", "setFogEnd");
        reflect_GlStateManager_method_setFogEnd_36.set("returnType", "void");
        reflect_GlStateManager_method_setFogEnd_36.set("static", false);
        reflect_GlStateManager_method_setFogEnd_36.set("argnames", new String[]{"param"});
        reflect_GlStateManager_method_setFogEnd_36.set("argtypes", new String[]{"float"});
        reflect_GlStateManager_method_setFogEnd_36.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).setFogEnd((float) params.getFloat("param"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_setFogEnd_36);


        BaseData reflect_GlStateManager_method_enableCull_37 = new ModData();
        reflect_GlStateManager_method_enableCull_37.set("methodName", "enableCull");
        reflect_GlStateManager_method_enableCull_37.set("returnType", "void");
        reflect_GlStateManager_method_enableCull_37.set("static", false);
        reflect_GlStateManager_method_enableCull_37.set("argnames", new String[]{});
        reflect_GlStateManager_method_enableCull_37.set("argtypes", new String[]{});
        reflect_GlStateManager_method_enableCull_37.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).enableCull();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_enableCull_37);


        BaseData reflect_GlStateManager_method_disableCull_38 = new ModData();
        reflect_GlStateManager_method_disableCull_38.set("methodName", "disableCull");
        reflect_GlStateManager_method_disableCull_38.set("returnType", "void");
        reflect_GlStateManager_method_disableCull_38.set("static", false);
        reflect_GlStateManager_method_disableCull_38.set("argnames", new String[]{});
        reflect_GlStateManager_method_disableCull_38.set("argtypes", new String[]{});
        reflect_GlStateManager_method_disableCull_38.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).disableCull();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_disableCull_38);


        BaseData reflect_GlStateManager_method_cullFace_39 = new ModData();
        reflect_GlStateManager_method_cullFace_39.set("methodName", "cullFace");
        reflect_GlStateManager_method_cullFace_39.set("returnType", "void");
        reflect_GlStateManager_method_cullFace_39.set("static", false);
        reflect_GlStateManager_method_cullFace_39.set("argnames", new String[]{"mode"});
        reflect_GlStateManager_method_cullFace_39.set("argtypes", new String[]{"int"});
        reflect_GlStateManager_method_cullFace_39.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).cullFace((int) params.getInt("mode"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_cullFace_39);


        BaseData reflect_GlStateManager_method_enablePolygonOffset_40 = new ModData();
        reflect_GlStateManager_method_enablePolygonOffset_40.set("methodName", "enablePolygonOffset");
        reflect_GlStateManager_method_enablePolygonOffset_40.set("returnType", "void");
        reflect_GlStateManager_method_enablePolygonOffset_40.set("static", false);
        reflect_GlStateManager_method_enablePolygonOffset_40.set("argnames", new String[]{});
        reflect_GlStateManager_method_enablePolygonOffset_40.set("argtypes", new String[]{});
        reflect_GlStateManager_method_enablePolygonOffset_40.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).enablePolygonOffset();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_enablePolygonOffset_40);


        BaseData reflect_GlStateManager_method_disablePolygonOffset_41 = new ModData();
        reflect_GlStateManager_method_disablePolygonOffset_41.set("methodName", "disablePolygonOffset");
        reflect_GlStateManager_method_disablePolygonOffset_41.set("returnType", "void");
        reflect_GlStateManager_method_disablePolygonOffset_41.set("static", false);
        reflect_GlStateManager_method_disablePolygonOffset_41.set("argnames", new String[]{});
        reflect_GlStateManager_method_disablePolygonOffset_41.set("argtypes", new String[]{});
        reflect_GlStateManager_method_disablePolygonOffset_41.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).disablePolygonOffset();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_disablePolygonOffset_41);


        BaseData reflect_GlStateManager_method_doPolygonOffset_42 = new ModData();
        reflect_GlStateManager_method_doPolygonOffset_42.set("methodName", "doPolygonOffset");
        reflect_GlStateManager_method_doPolygonOffset_42.set("returnType", "void");
        reflect_GlStateManager_method_doPolygonOffset_42.set("static", false);
        reflect_GlStateManager_method_doPolygonOffset_42.set("argnames", new String[]{"factor", "units"});
        reflect_GlStateManager_method_doPolygonOffset_42.set("argtypes", new String[]{"float", "float"});
        reflect_GlStateManager_method_doPolygonOffset_42.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).doPolygonOffset((float) params.getFloat("factor"), (float) params.getFloat("units"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_doPolygonOffset_42);


        BaseData reflect_GlStateManager_method_enableColorLogic_43 = new ModData();
        reflect_GlStateManager_method_enableColorLogic_43.set("methodName", "enableColorLogic");
        reflect_GlStateManager_method_enableColorLogic_43.set("returnType", "void");
        reflect_GlStateManager_method_enableColorLogic_43.set("static", false);
        reflect_GlStateManager_method_enableColorLogic_43.set("argnames", new String[]{});
        reflect_GlStateManager_method_enableColorLogic_43.set("argtypes", new String[]{});
        reflect_GlStateManager_method_enableColorLogic_43.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).enableColorLogic();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_enableColorLogic_43);


        BaseData reflect_GlStateManager_method_disableColorLogic_44 = new ModData();
        reflect_GlStateManager_method_disableColorLogic_44.set("methodName", "disableColorLogic");
        reflect_GlStateManager_method_disableColorLogic_44.set("returnType", "void");
        reflect_GlStateManager_method_disableColorLogic_44.set("static", false);
        reflect_GlStateManager_method_disableColorLogic_44.set("argnames", new String[]{});
        reflect_GlStateManager_method_disableColorLogic_44.set("argtypes", new String[]{});
        reflect_GlStateManager_method_disableColorLogic_44.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).disableColorLogic();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_disableColorLogic_44);


        BaseData reflect_GlStateManager_method_colorLogicOp_45 = new ModData();
        reflect_GlStateManager_method_colorLogicOp_45.set("methodName", "colorLogicOp");
        reflect_GlStateManager_method_colorLogicOp_45.set("returnType", "void");
        reflect_GlStateManager_method_colorLogicOp_45.set("static", false);
        reflect_GlStateManager_method_colorLogicOp_45.set("argnames", new String[]{"opcode"});
        reflect_GlStateManager_method_colorLogicOp_45.set("argtypes", new String[]{"int"});
        reflect_GlStateManager_method_colorLogicOp_45.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).colorLogicOp((int) params.getInt("opcode"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_colorLogicOp_45);


        BaseData reflect_GlStateManager_method_enableTexGen_46 = new ModData();
        reflect_GlStateManager_method_enableTexGen_46.set("methodName", "enableTexGen");
        reflect_GlStateManager_method_enableTexGen_46.set("returnType", "void");
        reflect_GlStateManager_method_enableTexGen_46.set("static", false);
        reflect_GlStateManager_method_enableTexGen_46.set("argnames", new String[]{});
        reflect_GlStateManager_method_enableTexGen_46.set("argtypes", new String[]{});
        reflect_GlStateManager_method_enableTexGen_46.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).enableTexGen();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_enableTexGen_46);


        BaseData reflect_GlStateManager_method_disableTexGen_47 = new ModData();
        reflect_GlStateManager_method_disableTexGen_47.set("methodName", "disableTexGen");
        reflect_GlStateManager_method_disableTexGen_47.set("returnType", "void");
        reflect_GlStateManager_method_disableTexGen_47.set("static", false);
        reflect_GlStateManager_method_disableTexGen_47.set("argnames", new String[]{});
        reflect_GlStateManager_method_disableTexGen_47.set("argtypes", new String[]{});
        reflect_GlStateManager_method_disableTexGen_47.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).disableTexGen();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_disableTexGen_47);


        BaseData reflect_GlStateManager_method_setActiveTexture_50 = new ModData();
        reflect_GlStateManager_method_setActiveTexture_50.set("methodName", "setActiveTexture");
        reflect_GlStateManager_method_setActiveTexture_50.set("returnType", "void");
        reflect_GlStateManager_method_setActiveTexture_50.set("static", false);
        reflect_GlStateManager_method_setActiveTexture_50.set("argnames", new String[]{"texture"});
        reflect_GlStateManager_method_setActiveTexture_50.set("argtypes", new String[]{"int"});
        reflect_GlStateManager_method_setActiveTexture_50.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).setActiveTexture((int) params.getInt("texture"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_setActiveTexture_50);


        BaseData reflect_GlStateManager_method_enableTexture2D_51 = new ModData();
        reflect_GlStateManager_method_enableTexture2D_51.set("methodName", "enableTexture2D");
        reflect_GlStateManager_method_enableTexture2D_51.set("returnType", "void");
        reflect_GlStateManager_method_enableTexture2D_51.set("static", false);
        reflect_GlStateManager_method_enableTexture2D_51.set("argnames", new String[]{});
        reflect_GlStateManager_method_enableTexture2D_51.set("argtypes", new String[]{});
        reflect_GlStateManager_method_enableTexture2D_51.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).enableTexture2D();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_enableTexture2D_51);


        BaseData reflect_GlStateManager_method_disableTexture2D_52 = new ModData();
        reflect_GlStateManager_method_disableTexture2D_52.set("methodName", "disableTexture2D");
        reflect_GlStateManager_method_disableTexture2D_52.set("returnType", "void");
        reflect_GlStateManager_method_disableTexture2D_52.set("static", false);
        reflect_GlStateManager_method_disableTexture2D_52.set("argnames", new String[]{});
        reflect_GlStateManager_method_disableTexture2D_52.set("argtypes", new String[]{});
        reflect_GlStateManager_method_disableTexture2D_52.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).disableTexture2D();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_disableTexture2D_52);


        BaseData reflect_GlStateManager_method_texCoords2D_53 = new ModData();
        reflect_GlStateManager_method_texCoords2D_53.set("methodName", "texCoords2D");
        reflect_GlStateManager_method_texCoords2D_53.set("returnType", "void");
        reflect_GlStateManager_method_texCoords2D_53.set("static", false);
        reflect_GlStateManager_method_texCoords2D_53.set("argnames", new String[]{"x", "y"});
        reflect_GlStateManager_method_texCoords2D_53.set("argtypes", new String[]{"float", "float"});
        reflect_GlStateManager_method_texCoords2D_53.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).texCoords2D((float) params.getFloat("x"), (float) params.getFloat("y"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_texCoords2D_53);


        BaseData reflect_GlStateManager_method_texCoords2DDirect_54 = new ModData();
        reflect_GlStateManager_method_texCoords2DDirect_54.set("methodName", "texCoords2DDirect");
        reflect_GlStateManager_method_texCoords2DDirect_54.set("returnType", "void");
        reflect_GlStateManager_method_texCoords2DDirect_54.set("static", false);
        reflect_GlStateManager_method_texCoords2DDirect_54.set("argnames", new String[]{"tex", "x", "y"});
        reflect_GlStateManager_method_texCoords2DDirect_54.set("argtypes", new String[]{"int", "float", "float"});
        reflect_GlStateManager_method_texCoords2DDirect_54.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).texCoords2DDirect((int) params.getInt("tex"), (float) params.getFloat("x"), (float) params.getFloat("y"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_texCoords2DDirect_54);


        BaseData reflect_GlStateManager_method_getTexCoordX_55 = new ModData();
        reflect_GlStateManager_method_getTexCoordX_55.set("methodName", "getTexCoordX");
        reflect_GlStateManager_method_getTexCoordX_55.set("returnType", "float");
        reflect_GlStateManager_method_getTexCoordX_55.set("static", false);
        reflect_GlStateManager_method_getTexCoordX_55.set("argnames", new String[]{"tex"});
        reflect_GlStateManager_method_getTexCoordX_55.set("argtypes", new String[]{"int"});
        reflect_GlStateManager_method_getTexCoordX_55.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((GlStateManager) params.getReflective("_self")).getTexCoordX((int) params.getInt("tex"));
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_getTexCoordX_55);


        BaseData reflect_GlStateManager_method_getTexCoordY_56 = new ModData();
        reflect_GlStateManager_method_getTexCoordY_56.set("methodName", "getTexCoordY");
        reflect_GlStateManager_method_getTexCoordY_56.set("returnType", "float");
        reflect_GlStateManager_method_getTexCoordY_56.set("static", false);
        reflect_GlStateManager_method_getTexCoordY_56.set("argnames", new String[]{"tex"});
        reflect_GlStateManager_method_getTexCoordY_56.set("argtypes", new String[]{"int"});
        reflect_GlStateManager_method_getTexCoordY_56.setCallbackFloatWithDataArg("exec", (BaseData params) -> {
                try {
                    return (float) ((GlStateManager) params.getReflective("_self")).getTexCoordY((int) params.getInt("tex"));
                } catch (Exception _exception_reflect_) {
                    return 0.0f;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_getTexCoordY_56);


        BaseData reflect_GlStateManager_method_generateTexture_57 = new ModData();
        reflect_GlStateManager_method_generateTexture_57.set("methodName", "generateTexture");
        reflect_GlStateManager_method_generateTexture_57.set("returnType", "int");
        reflect_GlStateManager_method_generateTexture_57.set("static", false);
        reflect_GlStateManager_method_generateTexture_57.set("argnames", new String[]{});
        reflect_GlStateManager_method_generateTexture_57.set("argtypes", new String[]{});
        reflect_GlStateManager_method_generateTexture_57.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((GlStateManager) params.getReflective("_self")).generateTexture();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_generateTexture_57);


        BaseData reflect_GlStateManager_method_deleteTexture_58 = new ModData();
        reflect_GlStateManager_method_deleteTexture_58.set("methodName", "deleteTexture");
        reflect_GlStateManager_method_deleteTexture_58.set("returnType", "void");
        reflect_GlStateManager_method_deleteTexture_58.set("static", false);
        reflect_GlStateManager_method_deleteTexture_58.set("argnames", new String[]{"texture"});
        reflect_GlStateManager_method_deleteTexture_58.set("argtypes", new String[]{"int"});
        reflect_GlStateManager_method_deleteTexture_58.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).deleteTexture((int) params.getInt("texture"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_deleteTexture_58);


        BaseData reflect_GlStateManager_method_bindTexture_59 = new ModData();
        reflect_GlStateManager_method_bindTexture_59.set("methodName", "bindTexture");
        reflect_GlStateManager_method_bindTexture_59.set("returnType", "void");
        reflect_GlStateManager_method_bindTexture_59.set("static", false);
        reflect_GlStateManager_method_bindTexture_59.set("argnames", new String[]{"texture"});
        reflect_GlStateManager_method_bindTexture_59.set("argtypes", new String[]{"int"});
        reflect_GlStateManager_method_bindTexture_59.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).bindTexture((int) params.getInt("texture"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_bindTexture_59);


        BaseData reflect_GlStateManager_method_bindTexture3D_60 = new ModData();
        reflect_GlStateManager_method_bindTexture3D_60.set("methodName", "bindTexture3D");
        reflect_GlStateManager_method_bindTexture3D_60.set("returnType", "void");
        reflect_GlStateManager_method_bindTexture3D_60.set("static", false);
        reflect_GlStateManager_method_bindTexture3D_60.set("argnames", new String[]{"texture"});
        reflect_GlStateManager_method_bindTexture3D_60.set("argtypes", new String[]{"int"});
        reflect_GlStateManager_method_bindTexture3D_60.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).bindTexture3D((int) params.getInt("texture"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_bindTexture3D_60);


        BaseData reflect_GlStateManager_method_quickBindTexture_61 = new ModData();
        reflect_GlStateManager_method_quickBindTexture_61.set("methodName", "quickBindTexture");
        reflect_GlStateManager_method_quickBindTexture_61.set("returnType", "void");
        reflect_GlStateManager_method_quickBindTexture_61.set("static", false);
        reflect_GlStateManager_method_quickBindTexture_61.set("argnames", new String[]{"unit", "texture"});
        reflect_GlStateManager_method_quickBindTexture_61.set("argtypes", new String[]{"int", "int"});
        reflect_GlStateManager_method_quickBindTexture_61.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).quickBindTexture((int) params.getInt("unit"), (int) params.getInt("texture"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_quickBindTexture_61);


        BaseData reflect_GlStateManager_method_shadeModel_62 = new ModData();
        reflect_GlStateManager_method_shadeModel_62.set("methodName", "shadeModel");
        reflect_GlStateManager_method_shadeModel_62.set("returnType", "void");
        reflect_GlStateManager_method_shadeModel_62.set("static", false);
        reflect_GlStateManager_method_shadeModel_62.set("argnames", new String[]{"mode"});
        reflect_GlStateManager_method_shadeModel_62.set("argtypes", new String[]{"int"});
        reflect_GlStateManager_method_shadeModel_62.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).shadeModel((int) params.getInt("mode"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_shadeModel_62);


        BaseData reflect_GlStateManager_method_enableRescaleNormal_63 = new ModData();
        reflect_GlStateManager_method_enableRescaleNormal_63.set("methodName", "enableRescaleNormal");
        reflect_GlStateManager_method_enableRescaleNormal_63.set("returnType", "void");
        reflect_GlStateManager_method_enableRescaleNormal_63.set("static", false);
        reflect_GlStateManager_method_enableRescaleNormal_63.set("argnames", new String[]{});
        reflect_GlStateManager_method_enableRescaleNormal_63.set("argtypes", new String[]{});
        reflect_GlStateManager_method_enableRescaleNormal_63.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).enableRescaleNormal();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_enableRescaleNormal_63);


        BaseData reflect_GlStateManager_method_disableRescaleNormal_64 = new ModData();
        reflect_GlStateManager_method_disableRescaleNormal_64.set("methodName", "disableRescaleNormal");
        reflect_GlStateManager_method_disableRescaleNormal_64.set("returnType", "void");
        reflect_GlStateManager_method_disableRescaleNormal_64.set("static", false);
        reflect_GlStateManager_method_disableRescaleNormal_64.set("argnames", new String[]{});
        reflect_GlStateManager_method_disableRescaleNormal_64.set("argtypes", new String[]{});
        reflect_GlStateManager_method_disableRescaleNormal_64.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).disableRescaleNormal();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_disableRescaleNormal_64);


        BaseData reflect_GlStateManager_method_viewport_65 = new ModData();
        reflect_GlStateManager_method_viewport_65.set("methodName", "viewport");
        reflect_GlStateManager_method_viewport_65.set("returnType", "void");
        reflect_GlStateManager_method_viewport_65.set("static", false);
        reflect_GlStateManager_method_viewport_65.set("argnames", new String[]{"x", "y", "w", "h"});
        reflect_GlStateManager_method_viewport_65.set("argtypes", new String[]{"int", "int", "int", "int"});
        reflect_GlStateManager_method_viewport_65.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).viewport((int) params.getInt("x"), (int) params.getInt("y"), (int) params.getInt("w"), (int) params.getInt("h"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_viewport_65);


        BaseData reflect_GlStateManager_method_colorMask_66 = new ModData();
        reflect_GlStateManager_method_colorMask_66.set("methodName", "colorMask");
        reflect_GlStateManager_method_colorMask_66.set("returnType", "void");
        reflect_GlStateManager_method_colorMask_66.set("static", false);
        reflect_GlStateManager_method_colorMask_66.set("argnames", new String[]{"red", "green", "blue", "alpha"});
        reflect_GlStateManager_method_colorMask_66.set("argtypes", new String[]{"boolean", "boolean", "boolean", "boolean"});
        reflect_GlStateManager_method_colorMask_66.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).colorMask((boolean) params.getBoolean("red"), (boolean) params.getBoolean("green"), (boolean) params.getBoolean("blue"), (boolean) params.getBoolean("alpha"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_colorMask_66);


        BaseData reflect_GlStateManager_method_clearDepth_67 = new ModData();
        reflect_GlStateManager_method_clearDepth_67.set("methodName", "clearDepth");
        reflect_GlStateManager_method_clearDepth_67.set("returnType", "void");
        reflect_GlStateManager_method_clearDepth_67.set("static", false);
        reflect_GlStateManager_method_clearDepth_67.set("argnames", new String[]{"depth"});
        reflect_GlStateManager_method_clearDepth_67.set("argtypes", new String[]{"float"});
        reflect_GlStateManager_method_clearDepth_67.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).clearDepth((float) params.getFloat("depth"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_clearDepth_67);


        BaseData reflect_GlStateManager_method_clearColor_68 = new ModData();
        reflect_GlStateManager_method_clearColor_68.set("methodName", "clearColor");
        reflect_GlStateManager_method_clearColor_68.set("returnType", "void");
        reflect_GlStateManager_method_clearColor_68.set("static", false);
        reflect_GlStateManager_method_clearColor_68.set("argnames", new String[]{"red", "green", "blue", "alpha"});
        reflect_GlStateManager_method_clearColor_68.set("argtypes", new String[]{"float", "float", "float", "float"});
        reflect_GlStateManager_method_clearColor_68.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).clearColor((float) params.getFloat("red"), (float) params.getFloat("green"), (float) params.getFloat("blue"), (float) params.getFloat("alpha"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_clearColor_68);


        BaseData reflect_GlStateManager_method_clear_69 = new ModData();
        reflect_GlStateManager_method_clear_69.set("methodName", "clear");
        reflect_GlStateManager_method_clear_69.set("returnType", "void");
        reflect_GlStateManager_method_clear_69.set("static", false);
        reflect_GlStateManager_method_clear_69.set("argnames", new String[]{"mask"});
        reflect_GlStateManager_method_clear_69.set("argtypes", new String[]{"int"});
        reflect_GlStateManager_method_clear_69.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).clear((int) params.getInt("mask"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_clear_69);


        BaseData reflect_GlStateManager_method_matrixMode_70 = new ModData();
        reflect_GlStateManager_method_matrixMode_70.set("methodName", "matrixMode");
        reflect_GlStateManager_method_matrixMode_70.set("returnType", "void");
        reflect_GlStateManager_method_matrixMode_70.set("static", false);
        reflect_GlStateManager_method_matrixMode_70.set("argnames", new String[]{"mode"});
        reflect_GlStateManager_method_matrixMode_70.set("argtypes", new String[]{"int"});
        reflect_GlStateManager_method_matrixMode_70.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).matrixMode((int) params.getInt("mode"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_matrixMode_70);


        BaseData reflect_GlStateManager_method_loadIdentity_71 = new ModData();
        reflect_GlStateManager_method_loadIdentity_71.set("methodName", "loadIdentity");
        reflect_GlStateManager_method_loadIdentity_71.set("returnType", "void");
        reflect_GlStateManager_method_loadIdentity_71.set("static", false);
        reflect_GlStateManager_method_loadIdentity_71.set("argnames", new String[]{});
        reflect_GlStateManager_method_loadIdentity_71.set("argtypes", new String[]{});
        reflect_GlStateManager_method_loadIdentity_71.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).loadIdentity();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_loadIdentity_71);


        BaseData reflect_GlStateManager_method_pushMatrix_72 = new ModData();
        reflect_GlStateManager_method_pushMatrix_72.set("methodName", "pushMatrix");
        reflect_GlStateManager_method_pushMatrix_72.set("returnType", "void");
        reflect_GlStateManager_method_pushMatrix_72.set("static", false);
        reflect_GlStateManager_method_pushMatrix_72.set("argnames", new String[]{});
        reflect_GlStateManager_method_pushMatrix_72.set("argtypes", new String[]{});
        reflect_GlStateManager_method_pushMatrix_72.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).pushMatrix();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_pushMatrix_72);


        BaseData reflect_GlStateManager_method_popMatrix_73 = new ModData();
        reflect_GlStateManager_method_popMatrix_73.set("methodName", "popMatrix");
        reflect_GlStateManager_method_popMatrix_73.set("returnType", "void");
        reflect_GlStateManager_method_popMatrix_73.set("static", false);
        reflect_GlStateManager_method_popMatrix_73.set("argnames", new String[]{});
        reflect_GlStateManager_method_popMatrix_73.set("argtypes", new String[]{});
        reflect_GlStateManager_method_popMatrix_73.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).popMatrix();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_popMatrix_73);


        BaseData reflect_GlStateManager_method_getFloat_74 = new ModData();
        reflect_GlStateManager_method_getFloat_74.set("methodName", "getFloat");
        reflect_GlStateManager_method_getFloat_74.set("returnType", "void");
        reflect_GlStateManager_method_getFloat_74.set("static", false);
        reflect_GlStateManager_method_getFloat_74.set("argnames", new String[]{"pname", "params"});
        reflect_GlStateManager_method_getFloat_74.set("argtypes", new String[]{"int", "float[]"});
        reflect_GlStateManager_method_getFloat_74.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).getFloat((int) params.getInt("pname"), (float[]) params.getReflective("params"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_getFloat_74);


        BaseData reflect_GlStateManager_method_ortho_75 = new ModData();
        reflect_GlStateManager_method_ortho_75.set("methodName", "ortho");
        reflect_GlStateManager_method_ortho_75.set("returnType", "void");
        reflect_GlStateManager_method_ortho_75.set("static", false);
        reflect_GlStateManager_method_ortho_75.set("argnames", new String[]{"left", "right", "bottom", "top", "zNear", "zFar"});
        reflect_GlStateManager_method_ortho_75.set("argtypes", new String[]{"double", "double", "double", "double", "double", "double"});
        reflect_GlStateManager_method_ortho_75.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).ortho((double) params.getDouble("left"), (double) params.getDouble("right"), (double) params.getDouble("bottom"), (double) params.getDouble("top"), (double) params.getDouble("zNear"), (double) params.getDouble("zFar"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_ortho_75);


        BaseData reflect_GlStateManager_method_rotate_76 = new ModData();
        reflect_GlStateManager_method_rotate_76.set("methodName", "rotate");
        reflect_GlStateManager_method_rotate_76.set("returnType", "void");
        reflect_GlStateManager_method_rotate_76.set("static", false);
        reflect_GlStateManager_method_rotate_76.set("argnames", new String[]{"angle", "x", "y", "z"});
        reflect_GlStateManager_method_rotate_76.set("argtypes", new String[]{"float", "float", "float", "float"});
        reflect_GlStateManager_method_rotate_76.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).rotate((float) params.getFloat("angle"), (float) params.getFloat("x"), (float) params.getFloat("y"), (float) params.getFloat("z"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_rotate_76);


        BaseData reflect_GlStateManager_method_scale_77 = new ModData();
        reflect_GlStateManager_method_scale_77.set("methodName", "scale");
        reflect_GlStateManager_method_scale_77.set("returnType", "void");
        reflect_GlStateManager_method_scale_77.set("static", false);
        reflect_GlStateManager_method_scale_77.set("argnames", new String[]{"x", "y", "z"});
        reflect_GlStateManager_method_scale_77.set("argtypes", new String[]{"float", "float", "float"});
        reflect_GlStateManager_method_scale_77.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).scale((float) params.getFloat("x"), (float) params.getFloat("y"), (float) params.getFloat("z"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_scale_77);


        BaseData reflect_GlStateManager_method_scale_78 = new ModData();
        reflect_GlStateManager_method_scale_78.set("methodName", "scale");
        reflect_GlStateManager_method_scale_78.set("returnType", "void");
        reflect_GlStateManager_method_scale_78.set("static", false);
        reflect_GlStateManager_method_scale_78.set("argnames", new String[]{"x", "y", "z"});
        reflect_GlStateManager_method_scale_78.set("argtypes", new String[]{"double", "double", "double"});
        reflect_GlStateManager_method_scale_78.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).scale((double) params.getDouble("x"), (double) params.getDouble("y"), (double) params.getDouble("z"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_scale_78);


        BaseData reflect_GlStateManager_method_translate_79 = new ModData();
        reflect_GlStateManager_method_translate_79.set("methodName", "translate");
        reflect_GlStateManager_method_translate_79.set("returnType", "void");
        reflect_GlStateManager_method_translate_79.set("static", false);
        reflect_GlStateManager_method_translate_79.set("argnames", new String[]{"x", "y", "z"});
        reflect_GlStateManager_method_translate_79.set("argtypes", new String[]{"float", "float", "float"});
        reflect_GlStateManager_method_translate_79.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).translate((float) params.getFloat("x"), (float) params.getFloat("y"), (float) params.getFloat("z"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_translate_79);


        BaseData reflect_GlStateManager_method_translate_80 = new ModData();
        reflect_GlStateManager_method_translate_80.set("methodName", "translate");
        reflect_GlStateManager_method_translate_80.set("returnType", "void");
        reflect_GlStateManager_method_translate_80.set("static", false);
        reflect_GlStateManager_method_translate_80.set("argnames", new String[]{"x", "y", "z"});
        reflect_GlStateManager_method_translate_80.set("argtypes", new String[]{"double", "double", "double"});
        reflect_GlStateManager_method_translate_80.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).translate((double) params.getDouble("x"), (double) params.getDouble("y"), (double) params.getDouble("z"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_translate_80);


        BaseData reflect_GlStateManager_method_multMatrix_81 = new ModData();
        reflect_GlStateManager_method_multMatrix_81.set("methodName", "multMatrix");
        reflect_GlStateManager_method_multMatrix_81.set("returnType", "void");
        reflect_GlStateManager_method_multMatrix_81.set("static", false);
        reflect_GlStateManager_method_multMatrix_81.set("argnames", new String[]{"matrix"});
        reflect_GlStateManager_method_multMatrix_81.set("argtypes", new String[]{"float[]"});
        reflect_GlStateManager_method_multMatrix_81.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).multMatrix((float[]) params.getReflective("matrix"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_multMatrix_81);


        BaseData reflect_GlStateManager_method_multMatrix_82 = new ModData();
        reflect_GlStateManager_method_multMatrix_82.set("methodName", "multMatrix");
        reflect_GlStateManager_method_multMatrix_82.set("returnType", "void");
        reflect_GlStateManager_method_multMatrix_82.set("static", false);
        reflect_GlStateManager_method_multMatrix_82.set("argnames", new String[]{"matrix"});
        reflect_GlStateManager_method_multMatrix_82.set("argtypes", new String[]{"Matrix4f"});
        reflect_GlStateManager_method_multMatrix_82.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).multMatrix((Matrix4f) params.getReflective("matrix"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_multMatrix_82);


        BaseData reflect_GlStateManager_method_color_83 = new ModData();
        reflect_GlStateManager_method_color_83.set("methodName", "color");
        reflect_GlStateManager_method_color_83.set("returnType", "void");
        reflect_GlStateManager_method_color_83.set("static", false);
        reflect_GlStateManager_method_color_83.set("argnames", new String[]{"colorRed", "colorGreen", "colorBlue", "colorAlpha"});
        reflect_GlStateManager_method_color_83.set("argtypes", new String[]{"float", "float", "float", "float"});
        reflect_GlStateManager_method_color_83.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).color((float) params.getFloat("colorRed"), (float) params.getFloat("colorGreen"), (float) params.getFloat("colorBlue"), (float) params.getFloat("colorAlpha"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_color_83);


        BaseData reflect_GlStateManager_method_color_84 = new ModData();
        reflect_GlStateManager_method_color_84.set("methodName", "color");
        reflect_GlStateManager_method_color_84.set("returnType", "void");
        reflect_GlStateManager_method_color_84.set("static", false);
        reflect_GlStateManager_method_color_84.set("argnames", new String[]{"colorRed", "colorGreen", "colorBlue"});
        reflect_GlStateManager_method_color_84.set("argtypes", new String[]{"float", "float", "float"});
        reflect_GlStateManager_method_color_84.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).color((float) params.getFloat("colorRed"), (float) params.getFloat("colorGreen"), (float) params.getFloat("colorBlue"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_color_84);


        BaseData reflect_GlStateManager_method_resetColor_85 = new ModData();
        reflect_GlStateManager_method_resetColor_85.set("methodName", "resetColor");
        reflect_GlStateManager_method_resetColor_85.set("returnType", "void");
        reflect_GlStateManager_method_resetColor_85.set("static", false);
        reflect_GlStateManager_method_resetColor_85.set("argnames", new String[]{});
        reflect_GlStateManager_method_resetColor_85.set("argtypes", new String[]{});
        reflect_GlStateManager_method_resetColor_85.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).resetColor();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_resetColor_85);


        BaseData reflect_GlStateManager_method_callList_86 = new ModData();
        reflect_GlStateManager_method_callList_86.set("methodName", "callList");
        reflect_GlStateManager_method_callList_86.set("returnType", "void");
        reflect_GlStateManager_method_callList_86.set("static", false);
        reflect_GlStateManager_method_callList_86.set("argnames", new String[]{"list"});
        reflect_GlStateManager_method_callList_86.set("argtypes", new String[]{"int"});
        reflect_GlStateManager_method_callList_86.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).callList((int) params.getInt("list"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_callList_86);


        BaseData reflect_GlStateManager_method_gluPerspective_87 = new ModData();
        reflect_GlStateManager_method_gluPerspective_87.set("methodName", "gluPerspective");
        reflect_GlStateManager_method_gluPerspective_87.set("returnType", "void");
        reflect_GlStateManager_method_gluPerspective_87.set("static", false);
        reflect_GlStateManager_method_gluPerspective_87.set("argnames", new String[]{"fovy", "aspect", "zNear", "zFar"});
        reflect_GlStateManager_method_gluPerspective_87.set("argtypes", new String[]{"float", "float", "float", "float"});
        reflect_GlStateManager_method_gluPerspective_87.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).gluPerspective((float) params.getFloat("fovy"), (float) params.getFloat("aspect"), (float) params.getFloat("zNear"), (float) params.getFloat("zFar"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_gluPerspective_87);


        BaseData reflect_GlStateManager_method_gluLookAt_88 = new ModData();
        reflect_GlStateManager_method_gluLookAt_88.set("methodName", "gluLookAt");
        reflect_GlStateManager_method_gluLookAt_88.set("returnType", "void");
        reflect_GlStateManager_method_gluLookAt_88.set("static", false);
        reflect_GlStateManager_method_gluLookAt_88.set("argnames", new String[]{"eye", "center", "up"});
        reflect_GlStateManager_method_gluLookAt_88.set("argtypes", new String[]{"Vector3f", "Vector3f", "Vector3f"});
        reflect_GlStateManager_method_gluLookAt_88.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).gluLookAt((Vector3f) params.getReflective("eye"), (Vector3f) params.getReflective("center"), (Vector3f) params.getReflective("up"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_gluLookAt_88);


        BaseData reflect_GlStateManager_method_transform_89 = new ModData();
        reflect_GlStateManager_method_transform_89.set("methodName", "transform");
        reflect_GlStateManager_method_transform_89.set("returnType", "void");
        reflect_GlStateManager_method_transform_89.set("static", false);
        reflect_GlStateManager_method_transform_89.set("argnames", new String[]{"vecIn", "vecOut"});
        reflect_GlStateManager_method_transform_89.set("argtypes", new String[]{"Vector4f", "Vector4f"});
        reflect_GlStateManager_method_transform_89.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).transform((Vector4f) params.getReflective("vecIn"), (Vector4f) params.getReflective("vecOut"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_transform_89);


        BaseData reflect_GlStateManager_method_getMatrix_90 = new ModData();
        reflect_GlStateManager_method_getMatrix_90.set("methodName", "getMatrix");
        reflect_GlStateManager_method_getMatrix_90.set("returnType", "void");
        reflect_GlStateManager_method_getMatrix_90.set("static", false);
        reflect_GlStateManager_method_getMatrix_90.set("argnames", new String[]{"mat"});
        reflect_GlStateManager_method_getMatrix_90.set("argtypes", new String[]{"Matrix4f"});
        reflect_GlStateManager_method_getMatrix_90.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).getMatrix((Matrix4f) params.getReflective("mat"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_getMatrix_90);


        BaseData reflect_GlStateManager_method_loadMatrix_91 = new ModData();
        reflect_GlStateManager_method_loadMatrix_91.set("methodName", "loadMatrix");
        reflect_GlStateManager_method_loadMatrix_91.set("returnType", "void");
        reflect_GlStateManager_method_loadMatrix_91.set("static", false);
        reflect_GlStateManager_method_loadMatrix_91.set("argnames", new String[]{"mat"});
        reflect_GlStateManager_method_loadMatrix_91.set("argtypes", new String[]{"Matrix4f"});
        reflect_GlStateManager_method_loadMatrix_91.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((GlStateManager) params.getReflective("_self")).loadMatrix((Matrix4f) params.getReflective("mat"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_loadMatrix_91);


        BaseData reflect_GlStateManager_method_getModelViewSerial_92 = new ModData();
        reflect_GlStateManager_method_getModelViewSerial_92.set("methodName", "getModelViewSerial");
        reflect_GlStateManager_method_getModelViewSerial_92.set("returnType", "int");
        reflect_GlStateManager_method_getModelViewSerial_92.set("static", false);
        reflect_GlStateManager_method_getModelViewSerial_92.set("argnames", new String[]{});
        reflect_GlStateManager_method_getModelViewSerial_92.set("argtypes", new String[]{});
        reflect_GlStateManager_method_getModelViewSerial_92.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((GlStateManager) params.getReflective("_self")).getModelViewSerial();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_getModelViewSerial_92);


        BaseData reflect_GlStateManager_method_getModelViewReference_93 = new ModData();
        reflect_GlStateManager_method_getModelViewReference_93.set("methodName", "getModelViewReference");
        reflect_GlStateManager_method_getModelViewReference_93.set("returnType", "Matrix4f");
        reflect_GlStateManager_method_getModelViewReference_93.set("static", false);
        reflect_GlStateManager_method_getModelViewReference_93.set("argnames", new String[]{});
        reflect_GlStateManager_method_getModelViewReference_93.set("argtypes", new String[]{});
        reflect_GlStateManager_method_getModelViewReference_93.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (Matrix4f) ((GlStateManager) params.getReflective("_self")).getModelViewReference();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_getModelViewReference_93);


        BaseData reflect_GlStateManager_method_recompileShaders_94 = new ModData();
        reflect_GlStateManager_method_recompileShaders_94.set("methodName", "recompileShaders");
        reflect_GlStateManager_method_recompileShaders_94.set("returnType", "void");
        reflect_GlStateManager_method_recompileShaders_94.set("static", true);
        reflect_GlStateManager_method_recompileShaders_94.set("argnames", new String[]{});
        reflect_GlStateManager_method_recompileShaders_94.set("argtypes", new String[]{});
        reflect_GlStateManager_method_recompileShaders_94.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    GlStateManager.recompileShaders();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_recompileShaders_94);


        BaseData reflect_GlStateManager_method_makeModData_95 = new ModData();
        reflect_GlStateManager_method_makeModData_95.set("methodName", "makeModData");
        reflect_GlStateManager_method_makeModData_95.set("returnType", "ModData");
        reflect_GlStateManager_method_makeModData_95.set("static", true);
        reflect_GlStateManager_method_makeModData_95.set("argnames", new String[]{});
        reflect_GlStateManager_method_makeModData_95.set("argtypes", new String[]{});
        reflect_GlStateManager_method_makeModData_95.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (ModData) GlStateManager.makeModData();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_makeModData_95);


        BaseData reflect_GlStateManager_method_loadModData_96 = new ModData();
        reflect_GlStateManager_method_loadModData_96.set("methodName", "loadModData");
        reflect_GlStateManager_method_loadModData_96.set("returnType", "void");
        reflect_GlStateManager_method_loadModData_96.set("static", true);
        reflect_GlStateManager_method_loadModData_96.set("argnames", new String[]{"data"});
        reflect_GlStateManager_method_loadModData_96.set("argtypes", new String[]{"BaseData"});
        reflect_GlStateManager_method_loadModData_96.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    GlStateManager.loadModData((BaseData) params.getReflective("data"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_GlStateManager_methods.add(reflect_GlStateManager_method_loadModData_96);


        BaseData[] reflect_GlStateManager_methods_arr = new BaseData[reflect_GlStateManager_methods.size()];
        for (int i = 0; i < reflect_GlStateManager_methods_arr.length; i++) {
            reflect_GlStateManager_methods_arr[i] = reflect_GlStateManager_methods.get(i);
        }

        reflect_GlStateManager.set("constructors", reflect_GlStateManager_constructors_arr);
        reflect_GlStateManager.set("methods", reflect_GlStateManager_methods_arr);
        reflect_GlStateManager.set("className", "GlStateManager");
        reflect_GlStateManager.set("classId", "net.lax1dude.eaglercraft.v1_8.opengl.GlStateManager");
        reflect_GlStateManager.set("class", GlStateManager.class);
        reflect_GlStateManager.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof GlStateManager;
        });
        reflectProfiles.add(reflect_GlStateManager);
    }


    //classdef for VertexFormat
    public static void reflect_VertexFormat_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_VertexFormat = new ModData();

        ArrayList<BaseData> reflect_VertexFormat_constructors = new ArrayList<BaseData>();
        
        BaseData[] reflect_VertexFormat_constructors_arr = new BaseData[reflect_VertexFormat_constructors.size()];
        for (int i = 0; i < reflect_VertexFormat_constructors_arr.length; i++) {
            reflect_VertexFormat_constructors_arr[i] = reflect_VertexFormat_constructors.get(i);
        }

        ArrayList<BaseData> reflect_VertexFormat_methods = new ArrayList<BaseData>();
        
        BaseData[] reflect_VertexFormat_methods_arr = new BaseData[reflect_VertexFormat_methods.size()];
        for (int i = 0; i < reflect_VertexFormat_methods_arr.length; i++) {
            reflect_VertexFormat_methods_arr[i] = reflect_VertexFormat_methods.get(i);
        }

        reflect_VertexFormat.set("constructors", reflect_VertexFormat_constructors_arr);
        reflect_VertexFormat.set("methods", reflect_VertexFormat_methods_arr);
        reflect_VertexFormat.set("className", "VertexFormat");
        reflect_VertexFormat.set("classId", "net.lax1dude.eaglercraft.v1_8.opengl.VertexFormat");
        reflect_VertexFormat.set("class", VertexFormat.class);
        reflect_VertexFormat.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof VertexFormat;
        });
        reflectProfiles.add(reflect_VertexFormat);
    }


    //classdef for WorldRenderer
    public static void reflect_WorldRenderer_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_WorldRenderer = new ModData();

        ArrayList<BaseData> reflect_WorldRenderer_constructors = new ArrayList<BaseData>();
        
        BaseData reflect_WorldRenderer_constructor_WorldRenderer_0 = new ModData();
        reflect_WorldRenderer_constructor_WorldRenderer_0.set("returnType", "WorldRenderer");
        reflect_WorldRenderer_constructor_WorldRenderer_0.set("argnames", new String[]{"bufferSizeIn"});
        reflect_WorldRenderer_constructor_WorldRenderer_0.set("argtypes", new String[]{"int"});
        reflect_WorldRenderer_constructor_WorldRenderer_0.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
            return new WorldRenderer((int) params.getInt("bufferSizeIn"));
        });
        
        reflect_WorldRenderer_constructors.add(reflect_WorldRenderer_constructor_WorldRenderer_0);


        BaseData[] reflect_WorldRenderer_constructors_arr = new BaseData[reflect_WorldRenderer_constructors.size()];
        for (int i = 0; i < reflect_WorldRenderer_constructors_arr.length; i++) {
            reflect_WorldRenderer_constructors_arr[i] = reflect_WorldRenderer_constructors.get(i);
        }

        ArrayList<BaseData> reflect_WorldRenderer_methods = new ArrayList<BaseData>();
        
        BaseData reflect_WorldRenderer_method_free_0 = new ModData();
        reflect_WorldRenderer_method_free_0.set("methodName", "free");
        reflect_WorldRenderer_method_free_0.set("returnType", "void");
        reflect_WorldRenderer_method_free_0.set("static", false);
        reflect_WorldRenderer_method_free_0.set("argnames", new String[]{});
        reflect_WorldRenderer_method_free_0.set("argtypes", new String[]{});
        reflect_WorldRenderer_method_free_0.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((WorldRenderer) params.getReflective("_self")).free();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_WorldRenderer_methods.add(reflect_WorldRenderer_method_free_0);


        BaseData reflect_WorldRenderer_method_finalize_1 = new ModData();
        reflect_WorldRenderer_method_finalize_1.set("methodName", "finalize");
        reflect_WorldRenderer_method_finalize_1.set("returnType", "void");
        reflect_WorldRenderer_method_finalize_1.set("static", false);
        reflect_WorldRenderer_method_finalize_1.set("argnames", new String[]{});
        reflect_WorldRenderer_method_finalize_1.set("argtypes", new String[]{});
        reflect_WorldRenderer_method_finalize_1.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((WorldRenderer) params.getReflective("_self")).finalize();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_WorldRenderer_methods.add(reflect_WorldRenderer_method_finalize_1);


        BaseData reflect_WorldRenderer_method_func_181674_a_2 = new ModData();
        reflect_WorldRenderer_method_func_181674_a_2.set("methodName", "func_181674_a");
        reflect_WorldRenderer_method_func_181674_a_2.set("returnType", "void");
        reflect_WorldRenderer_method_func_181674_a_2.set("static", false);
        reflect_WorldRenderer_method_func_181674_a_2.set("argnames", new String[]{"parFloat1", "parFloat2", "parFloat3"});
        reflect_WorldRenderer_method_func_181674_a_2.set("argtypes", new String[]{"float", "float", "float"});
        reflect_WorldRenderer_method_func_181674_a_2.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((WorldRenderer) params.getReflective("_self")).func_181674_a((float) params.getFloat("parFloat1"), (float) params.getFloat("parFloat2"), (float) params.getFloat("parFloat3"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_WorldRenderer_methods.add(reflect_WorldRenderer_method_func_181674_a_2);


        BaseData reflect_WorldRenderer_method_reset_4 = new ModData();
        reflect_WorldRenderer_method_reset_4.set("methodName", "reset");
        reflect_WorldRenderer_method_reset_4.set("returnType", "void");
        reflect_WorldRenderer_method_reset_4.set("static", false);
        reflect_WorldRenderer_method_reset_4.set("argnames", new String[]{});
        reflect_WorldRenderer_method_reset_4.set("argtypes", new String[]{});
        reflect_WorldRenderer_method_reset_4.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((WorldRenderer) params.getReflective("_self")).reset();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_WorldRenderer_methods.add(reflect_WorldRenderer_method_reset_4);


        BaseData reflect_WorldRenderer_method_begin_5 = new ModData();
        reflect_WorldRenderer_method_begin_5.set("methodName", "begin");
        reflect_WorldRenderer_method_begin_5.set("returnType", "void");
        reflect_WorldRenderer_method_begin_5.set("static", false);
        reflect_WorldRenderer_method_begin_5.set("argnames", new String[]{"parInt1", "parVertexFormat"});
        reflect_WorldRenderer_method_begin_5.set("argtypes", new String[]{"int", "VertexFormat"});
        reflect_WorldRenderer_method_begin_5.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((WorldRenderer) params.getReflective("_self")).begin((int) params.getInt("parInt1"), (VertexFormat) params.getReflective("parVertexFormat"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_WorldRenderer_methods.add(reflect_WorldRenderer_method_begin_5);


        BaseData reflect_WorldRenderer_method_tex_6 = new ModData();
        reflect_WorldRenderer_method_tex_6.set("methodName", "tex");
        reflect_WorldRenderer_method_tex_6.set("returnType", "WorldRenderer");
        reflect_WorldRenderer_method_tex_6.set("static", false);
        reflect_WorldRenderer_method_tex_6.set("argnames", new String[]{"parDouble1", "parDouble2"});
        reflect_WorldRenderer_method_tex_6.set("argtypes", new String[]{"double", "double"});
        reflect_WorldRenderer_method_tex_6.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (WorldRenderer) ((WorldRenderer) params.getReflective("_self")).tex((double) params.getDouble("parDouble1"), (double) params.getDouble("parDouble2"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_WorldRenderer_methods.add(reflect_WorldRenderer_method_tex_6);


        BaseData reflect_WorldRenderer_method_lightmap_7 = new ModData();
        reflect_WorldRenderer_method_lightmap_7.set("methodName", "lightmap");
        reflect_WorldRenderer_method_lightmap_7.set("returnType", "WorldRenderer");
        reflect_WorldRenderer_method_lightmap_7.set("static", false);
        reflect_WorldRenderer_method_lightmap_7.set("argnames", new String[]{"parInt1", "parInt2"});
        reflect_WorldRenderer_method_lightmap_7.set("argtypes", new String[]{"int", "int"});
        reflect_WorldRenderer_method_lightmap_7.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (WorldRenderer) ((WorldRenderer) params.getReflective("_self")).lightmap((int) params.getInt("parInt1"), (int) params.getInt("parInt2"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_WorldRenderer_methods.add(reflect_WorldRenderer_method_lightmap_7);


        BaseData reflect_WorldRenderer_method_putBrightness4_8 = new ModData();
        reflect_WorldRenderer_method_putBrightness4_8.set("methodName", "putBrightness4");
        reflect_WorldRenderer_method_putBrightness4_8.set("returnType", "void");
        reflect_WorldRenderer_method_putBrightness4_8.set("static", false);
        reflect_WorldRenderer_method_putBrightness4_8.set("argnames", new String[]{"parInt1", "parInt2", "parInt3", "parInt4"});
        reflect_WorldRenderer_method_putBrightness4_8.set("argtypes", new String[]{"int", "int", "int", "int"});
        reflect_WorldRenderer_method_putBrightness4_8.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((WorldRenderer) params.getReflective("_self")).putBrightness4((int) params.getInt("parInt1"), (int) params.getInt("parInt2"), (int) params.getInt("parInt3"), (int) params.getInt("parInt4"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_WorldRenderer_methods.add(reflect_WorldRenderer_method_putBrightness4_8);


        BaseData reflect_WorldRenderer_method_putPosition_9 = new ModData();
        reflect_WorldRenderer_method_putPosition_9.set("methodName", "putPosition");
        reflect_WorldRenderer_method_putPosition_9.set("returnType", "void");
        reflect_WorldRenderer_method_putPosition_9.set("static", false);
        reflect_WorldRenderer_method_putPosition_9.set("argnames", new String[]{"x", "y", "z"});
        reflect_WorldRenderer_method_putPosition_9.set("argtypes", new String[]{"double", "double", "double"});
        reflect_WorldRenderer_method_putPosition_9.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((WorldRenderer) params.getReflective("_self")).putPosition((double) params.getDouble("x"), (double) params.getDouble("y"), (double) params.getDouble("z"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_WorldRenderer_methods.add(reflect_WorldRenderer_method_putPosition_9);


        BaseData reflect_WorldRenderer_method_putColorMultiplier_10 = new ModData();
        reflect_WorldRenderer_method_putColorMultiplier_10.set("methodName", "putColorMultiplier");
        reflect_WorldRenderer_method_putColorMultiplier_10.set("returnType", "void");
        reflect_WorldRenderer_method_putColorMultiplier_10.set("static", false);
        reflect_WorldRenderer_method_putColorMultiplier_10.set("argnames", new String[]{"red", "green", "blue", "parInt1"});
        reflect_WorldRenderer_method_putColorMultiplier_10.set("argtypes", new String[]{"float", "float", "float", "int"});
        reflect_WorldRenderer_method_putColorMultiplier_10.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((WorldRenderer) params.getReflective("_self")).putColorMultiplier((float) params.getFloat("red"), (float) params.getFloat("green"), (float) params.getFloat("blue"), (int) params.getInt("parInt1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_WorldRenderer_methods.add(reflect_WorldRenderer_method_putColorMultiplier_10);


        BaseData reflect_WorldRenderer_method_putColorRGB_F_11 = new ModData();
        reflect_WorldRenderer_method_putColorRGB_F_11.set("methodName", "putColorRGB_F");
        reflect_WorldRenderer_method_putColorRGB_F_11.set("returnType", "void");
        reflect_WorldRenderer_method_putColorRGB_F_11.set("static", false);
        reflect_WorldRenderer_method_putColorRGB_F_11.set("argnames", new String[]{"red", "green", "blue", "parInt1"});
        reflect_WorldRenderer_method_putColorRGB_F_11.set("argtypes", new String[]{"float", "float", "float", "int"});
        reflect_WorldRenderer_method_putColorRGB_F_11.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((WorldRenderer) params.getReflective("_self")).putColorRGB_F((float) params.getFloat("red"), (float) params.getFloat("green"), (float) params.getFloat("blue"), (int) params.getInt("parInt1"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_WorldRenderer_methods.add(reflect_WorldRenderer_method_putColorRGB_F_11);


        BaseData reflect_WorldRenderer_method_markDirty_12 = new ModData();
        reflect_WorldRenderer_method_markDirty_12.set("methodName", "markDirty");
        reflect_WorldRenderer_method_markDirty_12.set("returnType", "void");
        reflect_WorldRenderer_method_markDirty_12.set("static", false);
        reflect_WorldRenderer_method_markDirty_12.set("argnames", new String[]{});
        reflect_WorldRenderer_method_markDirty_12.set("argtypes", new String[]{});
        reflect_WorldRenderer_method_markDirty_12.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((WorldRenderer) params.getReflective("_self")).markDirty();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_WorldRenderer_methods.add(reflect_WorldRenderer_method_markDirty_12);


        BaseData reflect_WorldRenderer_method_color_13 = new ModData();
        reflect_WorldRenderer_method_color_13.set("methodName", "color");
        reflect_WorldRenderer_method_color_13.set("returnType", "WorldRenderer");
        reflect_WorldRenderer_method_color_13.set("static", false);
        reflect_WorldRenderer_method_color_13.set("argnames", new String[]{"parFloat1", "parFloat2", "parFloat3", "parFloat4"});
        reflect_WorldRenderer_method_color_13.set("argtypes", new String[]{"float", "float", "float", "float"});
        reflect_WorldRenderer_method_color_13.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (WorldRenderer) ((WorldRenderer) params.getReflective("_self")).color((float) params.getFloat("parFloat1"), (float) params.getFloat("parFloat2"), (float) params.getFloat("parFloat3"), (float) params.getFloat("parFloat4"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_WorldRenderer_methods.add(reflect_WorldRenderer_method_color_13);


        BaseData reflect_WorldRenderer_method_color_14 = new ModData();
        reflect_WorldRenderer_method_color_14.set("methodName", "color");
        reflect_WorldRenderer_method_color_14.set("returnType", "WorldRenderer");
        reflect_WorldRenderer_method_color_14.set("static", false);
        reflect_WorldRenderer_method_color_14.set("argnames", new String[]{"parInt1", "parInt2", "parInt3", "parInt4"});
        reflect_WorldRenderer_method_color_14.set("argtypes", new String[]{"int", "int", "int", "int"});
        reflect_WorldRenderer_method_color_14.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (WorldRenderer) ((WorldRenderer) params.getReflective("_self")).color((int) params.getInt("parInt1"), (int) params.getInt("parInt2"), (int) params.getInt("parInt3"), (int) params.getInt("parInt4"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_WorldRenderer_methods.add(reflect_WorldRenderer_method_color_14);


        BaseData reflect_WorldRenderer_method_addVertexData_15 = new ModData();
        reflect_WorldRenderer_method_addVertexData_15.set("methodName", "addVertexData");
        reflect_WorldRenderer_method_addVertexData_15.set("returnType", "void");
        reflect_WorldRenderer_method_addVertexData_15.set("static", false);
        reflect_WorldRenderer_method_addVertexData_15.set("argnames", new String[]{"vertexData"});
        reflect_WorldRenderer_method_addVertexData_15.set("argtypes", new String[]{"int[]"});
        reflect_WorldRenderer_method_addVertexData_15.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((WorldRenderer) params.getReflective("_self")).addVertexData((int[]) params.getReflective("vertexData"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_WorldRenderer_methods.add(reflect_WorldRenderer_method_addVertexData_15);


        BaseData reflect_WorldRenderer_method_endVertex_16 = new ModData();
        reflect_WorldRenderer_method_endVertex_16.set("methodName", "endVertex");
        reflect_WorldRenderer_method_endVertex_16.set("returnType", "void");
        reflect_WorldRenderer_method_endVertex_16.set("static", false);
        reflect_WorldRenderer_method_endVertex_16.set("argnames", new String[]{});
        reflect_WorldRenderer_method_endVertex_16.set("argtypes", new String[]{});
        reflect_WorldRenderer_method_endVertex_16.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((WorldRenderer) params.getReflective("_self")).endVertex();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_WorldRenderer_methods.add(reflect_WorldRenderer_method_endVertex_16);


        BaseData reflect_WorldRenderer_method_pos_17 = new ModData();
        reflect_WorldRenderer_method_pos_17.set("methodName", "pos");
        reflect_WorldRenderer_method_pos_17.set("returnType", "WorldRenderer");
        reflect_WorldRenderer_method_pos_17.set("static", false);
        reflect_WorldRenderer_method_pos_17.set("argnames", new String[]{"parDouble1", "parDouble2", "parDouble3"});
        reflect_WorldRenderer_method_pos_17.set("argtypes", new String[]{"double", "double", "double"});
        reflect_WorldRenderer_method_pos_17.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (WorldRenderer) ((WorldRenderer) params.getReflective("_self")).pos((double) params.getDouble("parDouble1"), (double) params.getDouble("parDouble2"), (double) params.getDouble("parDouble3"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_WorldRenderer_methods.add(reflect_WorldRenderer_method_pos_17);


        BaseData reflect_WorldRenderer_method_putNormal_18 = new ModData();
        reflect_WorldRenderer_method_putNormal_18.set("methodName", "putNormal");
        reflect_WorldRenderer_method_putNormal_18.set("returnType", "void");
        reflect_WorldRenderer_method_putNormal_18.set("static", false);
        reflect_WorldRenderer_method_putNormal_18.set("argnames", new String[]{"x", "y", "z"});
        reflect_WorldRenderer_method_putNormal_18.set("argtypes", new String[]{"float", "float", "float"});
        reflect_WorldRenderer_method_putNormal_18.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((WorldRenderer) params.getReflective("_self")).putNormal((float) params.getFloat("x"), (float) params.getFloat("y"), (float) params.getFloat("z"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_WorldRenderer_methods.add(reflect_WorldRenderer_method_putNormal_18);


        BaseData reflect_WorldRenderer_method_putNormal_19 = new ModData();
        reflect_WorldRenderer_method_putNormal_19.set("methodName", "putNormal");
        reflect_WorldRenderer_method_putNormal_19.set("returnType", "void");
        reflect_WorldRenderer_method_putNormal_19.set("static", false);
        reflect_WorldRenderer_method_putNormal_19.set("argnames", new String[]{"x", "y", "z", "id"});
        reflect_WorldRenderer_method_putNormal_19.set("argtypes", new String[]{"float", "float", "float", "int"});
        reflect_WorldRenderer_method_putNormal_19.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((WorldRenderer) params.getReflective("_self")).putNormal((float) params.getFloat("x"), (float) params.getFloat("y"), (float) params.getFloat("z"), (int) params.getInt("id"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_WorldRenderer_methods.add(reflect_WorldRenderer_method_putNormal_19);


        BaseData reflect_WorldRenderer_method_normal_20 = new ModData();
        reflect_WorldRenderer_method_normal_20.set("methodName", "normal");
        reflect_WorldRenderer_method_normal_20.set("returnType", "WorldRenderer");
        reflect_WorldRenderer_method_normal_20.set("static", false);
        reflect_WorldRenderer_method_normal_20.set("argnames", new String[]{"parFloat1", "parFloat2", "parFloat3"});
        reflect_WorldRenderer_method_normal_20.set("argtypes", new String[]{"float", "float", "float"});
        reflect_WorldRenderer_method_normal_20.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (WorldRenderer) ((WorldRenderer) params.getReflective("_self")).normal((float) params.getFloat("parFloat1"), (float) params.getFloat("parFloat2"), (float) params.getFloat("parFloat3"));
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_WorldRenderer_methods.add(reflect_WorldRenderer_method_normal_20);


        BaseData reflect_WorldRenderer_method_genNormals_21 = new ModData();
        reflect_WorldRenderer_method_genNormals_21.set("methodName", "genNormals");
        reflect_WorldRenderer_method_genNormals_21.set("returnType", "void");
        reflect_WorldRenderer_method_genNormals_21.set("static", false);
        reflect_WorldRenderer_method_genNormals_21.set("argnames", new String[]{"b", "vertId"});
        reflect_WorldRenderer_method_genNormals_21.set("argtypes", new String[]{"boolean", "int"});
        reflect_WorldRenderer_method_genNormals_21.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((WorldRenderer) params.getReflective("_self")).genNormals((boolean) params.getBoolean("b"), (int) params.getInt("vertId"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_WorldRenderer_methods.add(reflect_WorldRenderer_method_genNormals_21);


        BaseData reflect_WorldRenderer_method_setTranslation_22 = new ModData();
        reflect_WorldRenderer_method_setTranslation_22.set("methodName", "setTranslation");
        reflect_WorldRenderer_method_setTranslation_22.set("returnType", "void");
        reflect_WorldRenderer_method_setTranslation_22.set("static", false);
        reflect_WorldRenderer_method_setTranslation_22.set("argnames", new String[]{"x", "y", "z"});
        reflect_WorldRenderer_method_setTranslation_22.set("argtypes", new String[]{"double", "double", "double"});
        reflect_WorldRenderer_method_setTranslation_22.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((WorldRenderer) params.getReflective("_self")).setTranslation((double) params.getDouble("x"), (double) params.getDouble("y"), (double) params.getDouble("z"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_WorldRenderer_methods.add(reflect_WorldRenderer_method_setTranslation_22);


        BaseData reflect_WorldRenderer_method_finishDrawing_23 = new ModData();
        reflect_WorldRenderer_method_finishDrawing_23.set("methodName", "finishDrawing");
        reflect_WorldRenderer_method_finishDrawing_23.set("returnType", "void");
        reflect_WorldRenderer_method_finishDrawing_23.set("static", false);
        reflect_WorldRenderer_method_finishDrawing_23.set("argnames", new String[]{});
        reflect_WorldRenderer_method_finishDrawing_23.set("argtypes", new String[]{});
        reflect_WorldRenderer_method_finishDrawing_23.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((WorldRenderer) params.getReflective("_self")).finishDrawing();
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_WorldRenderer_methods.add(reflect_WorldRenderer_method_finishDrawing_23);


        BaseData reflect_WorldRenderer_method_getByteBuffer_24 = new ModData();
        reflect_WorldRenderer_method_getByteBuffer_24.set("methodName", "getByteBuffer");
        reflect_WorldRenderer_method_getByteBuffer_24.set("returnType", "ByteBuffer");
        reflect_WorldRenderer_method_getByteBuffer_24.set("static", false);
        reflect_WorldRenderer_method_getByteBuffer_24.set("argnames", new String[]{});
        reflect_WorldRenderer_method_getByteBuffer_24.set("argtypes", new String[]{});
        reflect_WorldRenderer_method_getByteBuffer_24.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (ByteBuffer) ((WorldRenderer) params.getReflective("_self")).getByteBuffer();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_WorldRenderer_methods.add(reflect_WorldRenderer_method_getByteBuffer_24);


        BaseData reflect_WorldRenderer_method_getVertexFormat_25 = new ModData();
        reflect_WorldRenderer_method_getVertexFormat_25.set("methodName", "getVertexFormat");
        reflect_WorldRenderer_method_getVertexFormat_25.set("returnType", "VertexFormat");
        reflect_WorldRenderer_method_getVertexFormat_25.set("static", false);
        reflect_WorldRenderer_method_getVertexFormat_25.set("argnames", new String[]{});
        reflect_WorldRenderer_method_getVertexFormat_25.set("argtypes", new String[]{});
        reflect_WorldRenderer_method_getVertexFormat_25.setCallbackReflectiveWithDataArg("exec", (BaseData params) -> {
                try {
                    return (VertexFormat) ((WorldRenderer) params.getReflective("_self")).getVertexFormat();
                } catch (Exception _exception_reflect_) {
                    return null;
                }
            });
            
        reflect_WorldRenderer_methods.add(reflect_WorldRenderer_method_getVertexFormat_25);


        BaseData reflect_WorldRenderer_method_getVertexCount_26 = new ModData();
        reflect_WorldRenderer_method_getVertexCount_26.set("methodName", "getVertexCount");
        reflect_WorldRenderer_method_getVertexCount_26.set("returnType", "int");
        reflect_WorldRenderer_method_getVertexCount_26.set("static", false);
        reflect_WorldRenderer_method_getVertexCount_26.set("argnames", new String[]{});
        reflect_WorldRenderer_method_getVertexCount_26.set("argtypes", new String[]{});
        reflect_WorldRenderer_method_getVertexCount_26.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((WorldRenderer) params.getReflective("_self")).getVertexCount();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_WorldRenderer_methods.add(reflect_WorldRenderer_method_getVertexCount_26);


        BaseData reflect_WorldRenderer_method_getDrawMode_27 = new ModData();
        reflect_WorldRenderer_method_getDrawMode_27.set("methodName", "getDrawMode");
        reflect_WorldRenderer_method_getDrawMode_27.set("returnType", "int");
        reflect_WorldRenderer_method_getDrawMode_27.set("static", false);
        reflect_WorldRenderer_method_getDrawMode_27.set("argnames", new String[]{});
        reflect_WorldRenderer_method_getDrawMode_27.set("argtypes", new String[]{});
        reflect_WorldRenderer_method_getDrawMode_27.setCallbackIntWithDataArg("exec", (BaseData params) -> {
                try {
                    return (int) ((WorldRenderer) params.getReflective("_self")).getDrawMode();
                } catch (Exception _exception_reflect_) {
                    return 0;
                }
            });
            
        reflect_WorldRenderer_methods.add(reflect_WorldRenderer_method_getDrawMode_27);


        BaseData reflect_WorldRenderer_method_putColor4_28 = new ModData();
        reflect_WorldRenderer_method_putColor4_28.set("methodName", "putColor4");
        reflect_WorldRenderer_method_putColor4_28.set("returnType", "void");
        reflect_WorldRenderer_method_putColor4_28.set("static", false);
        reflect_WorldRenderer_method_putColor4_28.set("argnames", new String[]{"argb"});
        reflect_WorldRenderer_method_putColor4_28.set("argtypes", new String[]{"int"});
        reflect_WorldRenderer_method_putColor4_28.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((WorldRenderer) params.getReflective("_self")).putColor4((int) params.getInt("argb"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_WorldRenderer_methods.add(reflect_WorldRenderer_method_putColor4_28);


        BaseData reflect_WorldRenderer_method_putColorRGB_F4_29 = new ModData();
        reflect_WorldRenderer_method_putColorRGB_F4_29.set("methodName", "putColorRGB_F4");
        reflect_WorldRenderer_method_putColorRGB_F4_29.set("returnType", "void");
        reflect_WorldRenderer_method_putColorRGB_F4_29.set("static", false);
        reflect_WorldRenderer_method_putColorRGB_F4_29.set("argnames", new String[]{"red", "green", "blue"});
        reflect_WorldRenderer_method_putColorRGB_F4_29.set("argtypes", new String[]{"float", "float", "float"});
        reflect_WorldRenderer_method_putColorRGB_F4_29.setCallbackVoidWithDataArg("exec", (BaseData params) -> {
                try {
                    ((WorldRenderer) params.getReflective("_self")).putColorRGB_F4((float) params.getFloat("red"), (float) params.getFloat("green"), (float) params.getFloat("blue"));
                } catch (Exception _exception_reflect_) {
                    return;
                }
            });
            
        reflect_WorldRenderer_methods.add(reflect_WorldRenderer_method_putColorRGB_F4_29);


        BaseData[] reflect_WorldRenderer_methods_arr = new BaseData[reflect_WorldRenderer_methods.size()];
        for (int i = 0; i < reflect_WorldRenderer_methods_arr.length; i++) {
            reflect_WorldRenderer_methods_arr[i] = reflect_WorldRenderer_methods.get(i);
        }

        reflect_WorldRenderer.set("constructors", reflect_WorldRenderer_constructors_arr);
        reflect_WorldRenderer.set("methods", reflect_WorldRenderer_methods_arr);
        reflect_WorldRenderer.set("className", "WorldRenderer");
        reflect_WorldRenderer.set("classId", "net.lax1dude.eaglercraft.v1_8.opengl.WorldRenderer");
        reflect_WorldRenderer.set("class", WorldRenderer.class);
        reflect_WorldRenderer.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof WorldRenderer;
        });
        reflectProfiles.add(reflect_WorldRenderer);
    }


    //classdef for UwUAPI
    public static void reflect_UwUAPI_generator(ArrayList<BaseData> reflectProfiles) {
        BaseData reflect_UwUAPI = new ModData();

        ArrayList<BaseData> reflect_UwUAPI_constructors = new ArrayList<BaseData>();
        
        BaseData[] reflect_UwUAPI_constructors_arr = new BaseData[reflect_UwUAPI_constructors.size()];
        for (int i = 0; i < reflect_UwUAPI_constructors_arr.length; i++) {
            reflect_UwUAPI_constructors_arr[i] = reflect_UwUAPI_constructors.get(i);
        }

        ArrayList<BaseData> reflect_UwUAPI_methods = new ArrayList<BaseData>();
        
        BaseData reflect_UwUAPI_method_uwuify_0 = new ModData();
        reflect_UwUAPI_method_uwuify_0.set("methodName", "uwuify");
        reflect_UwUAPI_method_uwuify_0.set("returnType", "String");
        reflect_UwUAPI_method_uwuify_0.set("static", true);
        reflect_UwUAPI_method_uwuify_0.set("argnames", new String[]{"stringToUwuify"});
        reflect_UwUAPI_method_uwuify_0.set("argtypes", new String[]{"String"});
        reflect_UwUAPI_method_uwuify_0.setCallbackStringWithDataArg("exec", (BaseData params) -> {
                try {
                    return (String) UwUAPI.uwuify((String) params.getString("stringToUwuify"));
                } catch (Exception _exception_reflect_) {
                    return "";
                }
            });
            
        reflect_UwUAPI_methods.add(reflect_UwUAPI_method_uwuify_0);


        BaseData[] reflect_UwUAPI_methods_arr = new BaseData[reflect_UwUAPI_methods.size()];
        for (int i = 0; i < reflect_UwUAPI_methods_arr.length; i++) {
            reflect_UwUAPI_methods_arr[i] = reflect_UwUAPI_methods.get(i);
        }

        reflect_UwUAPI.set("constructors", reflect_UwUAPI_constructors_arr);
        reflect_UwUAPI.set("methods", reflect_UwUAPI_methods_arr);
        reflect_UwUAPI.set("className", "UwUAPI");
        reflect_UwUAPI.set("classId", "me.otterdev.UwUAPI");
        reflect_UwUAPI.set("class", UwUAPI.class);
        reflect_UwUAPI.setCallbackBooleanWithDataArg("isObjInstanceOf", (args)->{
            return args.getReflective("obj") instanceof UwUAPI;
        });
        reflectProfiles.add(reflect_UwUAPI);
    }



    public static PLReflect makeModData() {
        PLReflect plReflectGlobal = new PLReflect();
        setMethodMapFn(plReflectGlobal);
        ArrayList<BaseData> reflectProfiles = new ArrayList<BaseData>();
        
        PLReflect.reflect_World_generator(reflectProfiles);
        PLReflect.reflect_WorldServer_generator(reflectProfiles);
        PLReflect.reflect_AxisAlignedBB_generator(reflectProfiles);
        PLReflect.reflect_MathHelper_generator(reflectProfiles);
        PLReflect.reflect_Vec3_generator(reflectProfiles);
        PLReflect.reflect_MinecraftServer_generator(reflectProfiles);
        PLReflect.reflect_ItemStack_generator(reflectProfiles);
        PLReflect.reflect_Blocks_generator(reflectProfiles);
        PLReflect.reflect_Items_generator(reflectProfiles);
        PLReflect.reflect_Entity_generator(reflectProfiles);
        PLReflect.reflect_EntityCreature_generator(reflectProfiles);
        PLReflect.reflect_EntityLiving_generator(reflectProfiles);
        PLReflect.reflect_EntityLivingBase_generator(reflectProfiles);
        PLReflect.reflect_EntityMinecartCommandBlock_generator(reflectProfiles);
        PLReflect.reflect_EntityPlayer_generator(reflectProfiles);
        PLReflect.reflect_EntityPlayerMP_generator(reflectProfiles);
        PLReflect.reflect_EntityAmbientCreature_generator(reflectProfiles);
        PLReflect.reflect_EntityAnimal_generator(reflectProfiles);
        PLReflect.reflect_EntityBat_generator(reflectProfiles);
        PLReflect.reflect_EntityChicken_generator(reflectProfiles);
        PLReflect.reflect_EntityCow_generator(reflectProfiles);
        PLReflect.reflect_EntityHorse_generator(reflectProfiles);
        PLReflect.reflect_EntityMooshroom_generator(reflectProfiles);
        PLReflect.reflect_EntityOcelot_generator(reflectProfiles);
        PLReflect.reflect_EntityPig_generator(reflectProfiles);
        PLReflect.reflect_EntityRabbit_generator(reflectProfiles);
        PLReflect.reflect_EntitySheep_generator(reflectProfiles);
        PLReflect.reflect_EntitySquid_generator(reflectProfiles);
        PLReflect.reflect_EntityTameable_generator(reflectProfiles);
        PLReflect.reflect_EntityVillager_generator(reflectProfiles);
        PLReflect.reflect_EntityWaterMob_generator(reflectProfiles);
        PLReflect.reflect_EntityWolf_generator(reflectProfiles);
        PLReflect.reflect_EntityBlaze_generator(reflectProfiles);
        PLReflect.reflect_EntityCaveSpider_generator(reflectProfiles);
        PLReflect.reflect_EntityCreeper_generator(reflectProfiles);
        PLReflect.reflect_EntityEnderman_generator(reflectProfiles);
        PLReflect.reflect_EntityEndermite_generator(reflectProfiles);
        PLReflect.reflect_EntityGhast_generator(reflectProfiles);
        PLReflect.reflect_EntityGiantZombie_generator(reflectProfiles);
        PLReflect.reflect_EntityGolem_generator(reflectProfiles);
        PLReflect.reflect_EntityGuardian_generator(reflectProfiles);
        PLReflect.reflect_EntityIronGolem_generator(reflectProfiles);
        PLReflect.reflect_EntityMagmaCube_generator(reflectProfiles);
        PLReflect.reflect_EntityMob_generator(reflectProfiles);
        PLReflect.reflect_EntityPigZombie_generator(reflectProfiles);
        PLReflect.reflect_EntitySilverfish_generator(reflectProfiles);
        PLReflect.reflect_EntitySkeleton_generator(reflectProfiles);
        PLReflect.reflect_EntitySlime_generator(reflectProfiles);
        PLReflect.reflect_EntitySnowman_generator(reflectProfiles);
        PLReflect.reflect_EntitySpider_generator(reflectProfiles);
        PLReflect.reflect_EntityWitch_generator(reflectProfiles);
        PLReflect.reflect_EntityZombie_generator(reflectProfiles);
        PLReflect.reflect_EntityArmorStand_generator(reflectProfiles);
        PLReflect.reflect_EntityBoat_generator(reflectProfiles);
        PLReflect.reflect_EntityEnderCrystal_generator(reflectProfiles);
        PLReflect.reflect_EntityEnderEye_generator(reflectProfiles);
        PLReflect.reflect_EntityEnderPearl_generator(reflectProfiles);
        PLReflect.reflect_EntityExpBottle_generator(reflectProfiles);
        PLReflect.reflect_EntityFallingBlock_generator(reflectProfiles);
        PLReflect.reflect_EntityFireworkRocket_generator(reflectProfiles);
        PLReflect.reflect_EntityItem_generator(reflectProfiles);
        PLReflect.reflect_EntityItemFrame_generator(reflectProfiles);
        PLReflect.reflect_EntityMinecart_generator(reflectProfiles);
        PLReflect.reflect_EntityMinecartChest_generator(reflectProfiles);
        PLReflect.reflect_EntityMinecartContainer_generator(reflectProfiles);
        PLReflect.reflect_EntityMinecartEmpty_generator(reflectProfiles);
        PLReflect.reflect_EntityMinecartFurnace_generator(reflectProfiles);
        PLReflect.reflect_EntityMinecartHopper_generator(reflectProfiles);
        PLReflect.reflect_EntityMinecartTNT_generator(reflectProfiles);
        PLReflect.reflect_EntityPainting_generator(reflectProfiles);
        PLReflect.reflect_EntityTNTPrimed_generator(reflectProfiles);
        PLReflect.reflect_EntityXPOrb_generator(reflectProfiles);
        PLReflect.reflect_EntityLightningBolt_generator(reflectProfiles);
        PLReflect.reflect_EntityDragon_generator(reflectProfiles);
        PLReflect.reflect_EntityWither_generator(reflectProfiles);
        PLReflect.reflect_Minecraft_generator(reflectProfiles);
        PLReflect.reflect_EntityRenderer_generator(reflectProfiles);
        PLReflect.reflect_RenderGlobal_generator(reflectProfiles);
        PLReflect.reflect_Tessellator_generator(reflectProfiles);
        PLReflect.reflect_RenderManager_generator(reflectProfiles);
        PLReflect.reflect_WorldClient_generator(reflectProfiles);
        PLReflect.reflect_AbstractClientPlayer_generator(reflectProfiles);
        PLReflect.reflect_EntityOtherPlayerMP_generator(reflectProfiles);
        PLReflect.reflect_EntityPlayerSP_generator(reflectProfiles);
        PLReflect.reflect_EaglercraftGPU_generator(reflectProfiles);
        PLReflect.reflect_GlStateManager_generator(reflectProfiles);
        PLReflect.reflect_VertexFormat_generator(reflectProfiles);
        PLReflect.reflect_WorldRenderer_generator(reflectProfiles);
        PLReflect.reflect_UwUAPI_generator(reflectProfiles);

        BaseData[] reflectProfilesArr = new BaseData[reflectProfiles.size()];
        for (int i = 0; i < reflectProfilesArr.length; i++) {
            reflectProfilesArr[i] = reflectProfiles.get(i);
        }
        plReflectGlobal.set("classes", reflectProfilesArr);

        plReflectGlobal.setCallbackClassFinder("getClassByName", (String className)->{
            for (int i = 0; i < reflectProfilesArr.length; i++) {
                if (reflectProfilesArr[i].getString("className").equals(className)) {
                    return reflectProfilesArr[i];
                }
            }
            return null;
        });

        plReflectGlobal.setCallbackClassFinder("getClassById", (String classId)->{
            for (int i = 0; i < reflectProfilesArr.length; i++) {
                if (reflectProfilesArr[i].getString("classId").equals(classId)) {
                    return reflectProfilesArr[i];
                }
            }
            return null;
        });

        return plReflectGlobal;
    }
}